--

ALTER TABLE `users` ADD `openweathermap_city_id` int(11) NOT NULL DEFAULT 0;

CREATE TABLE `all_cities` (
  `id` int NOT NULL,
  `name` varchar(64) NOT NULL DEFAULT '',
  `name_ru` varchar(64) NOT NULL DEFAULT '',
  `country` varchar(64) NOT NULL DEFAULT '',
  `country_id` int NOT NULL DEFAULT 0,
  `admin1_code` varchar(64) NOT NULL DEFAULT '',
  `admin2_code` varchar(64) NOT NULL DEFAULT '',
  `admin3_code` varchar(64) NOT NULL DEFAULT '',
  `admin4_code` varchar(64) NOT NULL DEFAULT '',
  `lat` varchar(32) NOT NULL DEFAULT '',
  `lon` varchar(32) NOT NULL DEFAULT '',
  `timezone` varchar(64) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `country_id` (`country_id`),
  KEY `timezone` (`timezone`)
) DEFAULT CHARSET=utf8;

CREATE TABLE `openweathermap_cache` (
  `id` int NOT NULL AUTO_INCREMENT,
  `current` text,
  `forecast` text,
  `updated_current` timestamp DEFAULT 0,
  `updated_forecast` timestamp DEFAULT 0,
  `city_id` int NOT NULL DEFAULT 0,
  `last_request` timestamp DEFAULT 0,
  PRIMARY KEY (`id`),
  UNIQUE KEY `city_id` (`city_id`)
) DEFAULT CHARSET=utf8;

ALTER TABLE `weatherco_cache` ADD `updated_current` timestamp DEFAULT 0;
ALTER TABLE `weatherco_cache` ADD `updated_forecast` timestamp DEFAULT 0;
UPDATE weatherco_cache SET updated_current = updated, updated_forecast=updated;

SET NAMES utf8;

INSERT INTO all_cities (id, name, name_ru, country, country_id, admin1_code, admin2_code, admin3_code, admin4_code, lat, lon, timezone) VALUES
("290594", "Umm al Qaywayn", "Умм-эль-Кайвайн", "AE", "784", "07", "", "", "", "25.56473", "55.55517", "Asia/Dubai"),
("291074", "Ras al-Khaimah", "Рас-эль-Хайма", "AE", "784", "05", "", "", "", "25.78953", "55.9432", "Asia/Dubai"),
("291696", "Khawr Fakkan", "Хор-Факкан", "AE", "784", "06", "", "", "", "25.33132", "56.34199", "Asia/Dubai"),
("292223", "Dubai", "Дубай", "AE", "784", "03", "", "", "", "25.25817", "55.30472", "Asia/Dubai"),
("292239", "Dibba Al-Hisn", "Дибба Аль-Хисн", "AE", "784", "04", "", "", "", "25.61955", "56.27291", "Asia/Dubai"),
("292672", "Sharjah", "Шарджа", "AE", "784", "06", "", "", "", "25.33737", "55.41206", "Asia/Dubai"),
("292688", "Ar Ruways", "Ар-Руваис", "AE", "784", "01", "", "", "", "24.11028", "52.73056", "Asia/Dubai"),
("292878", "Al Fujayrah", "Фуджейра", "AE", "784", "04", "", "", "", "25.11641", "56.34141", "Asia/Dubai"),
("292913", "Al Ain", "Аль-Айн", "AE", "784", "01", "", "", "", "24.19167", "55.76056", "Asia/Dubai"),
("292932", "Ajman", "", "AE", "784", "02", "", "", "", "25.41111", "55.43504", "Asia/Dubai"),
("292953", "Adh Dhayd", "", "AE", "784", "06", "", "", "", "25.28812", "55.88157", "Asia/Dubai"),
("292968", "Abu Dhabi", "Абу-Даби", "AE", "784", "01", "", "", "", "24.46667", "54.36667", "Asia/Dubai"),
("1120985", "Zaranj", "Зарани", "AF", "4", "19", "7053297", "", "", "30.95962", "61.86037", "Asia/Kabul"),
("1123004", "Taloqan", "Таликан", "AF", "4", "26", "", "", "", "36.73605", "69.53451", "Asia/Kabul"),
("1125155", "Shindand", "Шинданд", "AF", "4", "11", "", "", "", "33.30294", "62.1474", "Asia/Kabul"),
("1125444", "Shibirghan", "Шеберган", "AF", "4", "31", "", "", "", "36.66757", "65.7529", "Asia/Kabul"),
("1125896", "Shahrak", "", "AF", "4", "09", "", "", "", "34.10738", "64.3052", "Asia/Kabul"),
("1127110", "Sar-e Pul", "Сари-Пуль", "AF", "4", "33", "", "", "", "36.21544", "65.93249", "Asia/Kabul"),
("1127628", "Sang-e Charak", "", "AF", "4", "33", "", "", "", "35.84972", "66.43694", "Asia/Kabul"),
("1127768", "Aibak", "Саманган", "AF", "4", "32", "", "", "", "36.26468", "68.01551", "Asia/Kabul"),
("1128265", "Rustaq", "", "AF", "4", "26", "", "", "", "37.12604", "69.83045", "Asia/Kabul"),
("1129516", "Qarqin", "Кханика", "AF", "4", "31", "", "", "", "37.41853", "66.04358", "Asia/Kabul"),
("1129648", "Qarawul", "", "AF", "4", "24", "", "", "", "37.21959", "68.7802", "Asia/Kabul"),
("1130490", "Pul-e Khumri", "Пули-Хумри", "AF", "4", "03", "", "", "", "35.94458", "68.71512", "Asia/Kabul"),
("1131316", "Paghman", "Пагман", "AF", "4", "13", "", "", "", "34.58787", "68.95091", "Asia/Kabul"),
("1132495", "Nahrin", "Нахрин", "AF", "4", "03", "", "", "", "36.0649", "69.13343", "Asia/Kabul"),
("1133453", "Maymana", "Меймене", "AF", "4", "07", "", "", "", "35.92139", "64.78361", "Asia/Kabul"),
("1133574", "Mehtar Lam", "Митарлам", "AF", "4", "35", "", "", "", "34.67139", "70.20944", "Asia/Kabul"),
("1133616", "Mazar-e Sharif", "Мазари-Шариф", "AF", "4", "30", "", "", "", "36.70904", "67.11087", "Asia/Kabul"),
("1134720", "Lashkar Gah", "Лашкаргах", "AF", "4", "10", "", "", "", "31.59382", "64.37161", "Asia/Kabul"),
("1135158", "Kushk", "Кушк", "AF", "4", "11", "", "", "", "33.29565", "61.95221", "Asia/Kabul"),
("1135689", "Kunduz", "Кундуз", "AF", "4", "24", "", "", "", "36.72896", "68.857", "Asia/Kabul"),
("1136469", "Khost", "Хост", "AF", "4", "37", "", "", "", "33.33951", "69.92041", "Asia/Kabul"),
("1136575", "Khulm", "Ташкурган", "AF", "4", "30", "", "", "", "36.69736", "67.69826", "Asia/Kabul"),
("1136863", "Khash", "", "AF", "4", "19", "", "", "", "31.52919", "62.79055", "Asia/Kabul"),
("1137168", "Khanabad", "Ханабад", "AF", "4", "24", "", "", "", "36.6825", "69.11556", "Asia/Kabul"),
("1137807", "Karukh", "", "AF", "4", "11", "", "", "", "34.48108", "62.5863", "Asia/Kabul"),
("1138336", "Kandahar", "Кандагар", "AF", "4", "23", "", "", "", "31.61332", "65.71013", "Asia/Kabul"),
("1138958", "Kabul", "Кабул", "AF", "4", "13", "", "", "", "34.52813", "69.17233", "Asia/Kabul"),
("1139715", "Jalalabad", "Джалалабад", "AF", "4", "18", "", "", "", "34.42647", "70.45153", "Asia/Kabul"),
("1139807", "Jabal os Saraj", "Dzhabal’-Ussaradzh", "AF", "4", "40", "", "", "", "35.11833", "69.23778", "Asia/Kabul"),
("1140026", "Herat", "Герат", "AF", "4", "11", "", "", "", "34.34817", "62.19967", "Asia/Kabul"),
("1141089", "Ghormach", "", "AF", "4", "02", "7052787", "", "", "35.73062", "63.78264", "Asia/Kabul"),
("1141269", "Ghazni", "Газни", "AF", "4", "08", "", "", "", "33.55391", "68.42096", "Asia/Kabul"),
("1141540", "Gereshk", "Герешк", "AF", "4", "10", "", "", "", "31.82089", "64.57005", "Asia/Kabul"),
("1141857", "Gardez", "Гардез", "AF", "4", "36", "", "", "", "33.59744", "69.22592", "Asia/Kabul"),
("1142170", "Fayzabad", "Файзабад", "AF", "4", "01", "", "", "", "37.11664", "70.58002", "Asia/Kabul"),
("1142264", "Farah", "", "AF", "4", "06", "", "", "", "32.37451", "62.11638", "Asia/Kabul"),
("1142404", "Kafir Qala", "", "AF", "4", "11", "", "", "", "34.66667", "61.06667", "Asia/Kabul"),
("1145352", "Charikar", "Чарикар", "AF", "4", "40", "", "", "", "35.01361", "69.17139", "Asia/Kabul"),
("1147066", "Baraki Barak", "", "AF", "4", "17", "", "", "", "33.96744", "68.9492", "Asia/Kabul"),
("1147242", "Bamyan", "", "AF", "4", "05", "", "", "", "34.82156", "67.82734", "Asia/Kabul"),
("1147290", "Balkh", "Балх", "AF", "4", "30", "", "", "", "36.75635", "66.8972", "Asia/Kabul"),
("1147540", "Baghlan", "Баглан", "AF", "4", "03", "", "", "", "36.13068", "68.70829", "Asia/Kabul"),
("1148106", "Art Khwajah", "", "AF", "4", "26", "", "", "", "37.08571", "69.47958", "Asia/Kabul"),
("1148205", "Asmar", "", "AF", "4", "34", "", "", "", "35.03333", "71.35809", "Asia/Kabul"),
("1148311", "Asadabad", "Асадабад", "AF", "4", "34", "", "", "", "34.87311", "71.14697", "Asia/Kabul"),
("1148658", "Andkhoy", "", "AF", "4", "07", "", "", "", "36.95293", "65.12376", "Asia/Kabul"),
("1429434", "Bazarak", "Базарак", "AF", "4", "42", "", "", "", "35.31292", "69.51519", "Asia/Kabul"),
("1469706", "Markaz-e Woluswali-ye Achin", "", "AF", "4", "18", "", "", "", "34.12583", "70.70778", "Asia/Kabul"),
("6692413", "Cool urhajo", "", "AF", "4", "05", "", "", "", "34.26545", "67.34516", "Asia/Kabul"),
("363243", "Sarande", "Саранда", "AL", "8", "51", "20", "", "", "39.87556", "20.00528", "Europe/Tirane"),
("782661", "Kukes", "Кукес", "AL", "8", "47", "", "", "", "42.07694", "20.42194", "Europe/Tirane"),
("782756", "Korce", "Корча", "AL", "8", "46", "09", "", "", "40.61861", "20.78083", "Europe/Tirane"),
("783148", "Gjirokaster", "Гирокастра", "AL", "8", "45", "", "", "", "40.07583", "20.13889", "Europe/Tirane"),
("783263", "Elbasan", "Эльбасан", "AL", "8", "43", "", "", "", "41.1125", "20.08222", "Europe/Tirane"),
("783493", "Burrel", "Буррель", "AL", "8", "41", "15", "", "", "41.61028", "20.00889", "Europe/Tirane"),
("3183719", "Vlore", "Влёра", "AL", "8", "51", "", "", "", "40.46667", "19.48972", "Europe/Tirane"),
("3183875", "Tirana", "Тирана", "AL", "8", "50", "", "", "", "41.3275", "19.81889", "Europe/Tirane"),
("3184081", "Shkoder", "Шкодер", "AL", "8", "49", "21", "", "", "42.06828", "19.51258", "Europe/Tirane"),
("3184517", "Patos Fshat", "", "AL", "8", "44", "", "", "", "40.64278", "19.65083", "Europe/Tirane"),
("3184862", "Lushnje", "Люшня", "AL", "8", "44", "14", "", "", "40.94194", "19.705", "Europe/Tirane"),
("3184935", "Lezhe", "Лежа", "AL", "8", "48", "", "", "", "41.78361", "19.64361", "Europe/Tirane"),
("3185012", "Lac", "Лак", "AL", "8", "48", "35", "", "", "41.63556", "19.71306", "Europe/Tirane"),
("3185060", "Kucove", "Кучова", "AL", "8", "40", "34", "", "", "40.80028", "19.91667", "Europe/Tirane"),
("3185082", "Kruje", "Круе", "AL", "8", "42", "10", "", "", "41.50917", "19.79278", "Europe/Tirane"),
("3185211", "Kavaje", "Кавайе", "AL", "8", "50", "33", "", "", "41.18556", "19.55694", "Europe/Tirane"),
("3185670", "Fier-Cifci", "", "AL", "8", "44", "", "", "", "40.71667", "19.56667", "Europe/Tirane"),
("3185672", "Fier", "Фиери", "AL", "8", "44", "", "", "", "40.72389", "19.55611", "Europe/Tirane"),
("3185728", "Durres", "Дуррес", "AL", "8", "42", "", "", "", "41.32306", "19.44139", "Europe/Tirane"),
("3186084", "Berat", "Берат", "AL", "8", "40", "01", "", "", "40.70583", "19.95222", "Europe/Tirane"),
("174875", "Kapan", "Капан", "AM", "51", "08", "", "", "", "39.20754", "46.40576", "Asia/Yerevan"),
("174895", "Goris", "Горис", "AM", "51", "08", "", "", "", "39.51288", "46.33816", "Asia/Yerevan"),
("174972", "Hats'avan", "Ацаван", "AM", "51", "08", "", "", "", "39.46405", "45.97047", "Asia/Yerevan"),
("174979", "Artashat", "Арташат", "AM", "51", "02", "", "", "", "39.96144", "44.54447", "Asia/Yerevan"),
("174991", "Ararat", "Арарат", "AM", "51", "02", "", "", "", "39.83166", "44.70489", "Asia/Yerevan"),
("616052", "Yerevan", "Ереван", "AM", "51", "11", "", "", "", "40.18111", "44.51361", "Asia/Yerevan"),
("616062", "Ejmiatsin", "Вагаршапат", "AM", "51", "03", "", "", "", "40.16557", "44.29462", "Asia/Yerevan"),
("616199", "Spitak", "Спитак", "AM", "51", "06", "", "", "", "40.8322", "44.2673", "Asia/Yerevan"),
("616250", "Sevan", "Севан", "AM", "51", "04", "", "", "", "40.5484", "44.94868", "Asia/Yerevan"),
("616435", "Masis", "Масис", "AM", "51", "02", "", "", "", "40.06762", "44.43591", "Asia/Yerevan"),
("616530", "Vanadzor", "Кировакан", "AM", "51", "06", "", "", "", "40.80456", "44.4939", "Asia/Yerevan"),
("616599", "Gavarr", "Гавар", "AM", "51", "04", "", "", "", "40.35398", "45.12386", "Asia/Yerevan"),
("616629", "Hrazdan", "Раздан", "AM", "51", "05", "", "", "", "40.49748", "44.7662", "Asia/Yerevan"),
("616631", "Armavir", "Армавир", "AM", "51", "03", "", "", "", "40.15446", "44.03815", "Asia/Yerevan"),
("616635", "Gyumri", "Гюмри", "AM", "51", "07", "", "", "", "40.7942", "43.84528", "Asia/Yerevan"),
("616877", "Ashtarak", "Аштарак", "AM", "51", "01", "", "", "", "40.2991", "44.36204", "Asia/Yerevan"),
("617026", "Abovyan", "Абовян", "AM", "51", "05", "", "", "", "40.26741", "44.62656", "Asia/Yerevan"),
("145531", "Saurimo", "Сауримо", "AO", "24", "18", "", "", "", "-9.66078", "20.39155", "Africa/Luanda"),
("145724", "Lucapa", "Лукапа", "AO", "24", "17", "", "", "", "-8.41915", "20.74466", "Africa/Luanda"),
("876177", "Luau", "Луау", "AO", "24", "14", "", "", "", "-10.70727", "22.22466", "Africa/Luanda"),
("2236568", "Uige", "Уиже", "AO", "24", "15", "", "", "", "-7.60874", "15.06131", "Africa/Luanda"),
("2236967", "Soio", "Сойу", "AO", "24", "16", "", "", "", "-6.1349", "12.36894", "Africa/Luanda"),
("2239001", "Nzeto", "Нзето", "AO", "24", "16", "", "", "", "-7.23116", "12.8666", "Africa/Luanda"),
("2239076", "N'dalatando", "", "AO", "24", "05", "", "", "", "-9.29782", "14.91162", "Africa/Luanda"),
("2239520", "Mbanza Congo", "", "AO", "24", "16", "", "", "", "-6.26703", "14.2401", "Africa/Luanda"),
("2239862", "Malanje", "Маланже", "AO", "24", "12", "2239859", "", "", "-9.54015", "16.34096", "Africa/Luanda"),
("2240449", "Luanda", "Луанда", "AO", "24", "20", "", "", "", "-8.83682", "13.23432", "Africa/Luanda"),
("2242001", "Caxito", "Кашито", "AO", "24", "19", "", "", "", "-8.57848", "13.66425", "Africa/Luanda"),
("2243271", "Cabinda", "Кабинда", "AO", "24", "03", "", "", "", "-5.55", "12.2", "Africa/Luanda"),
("3346015", "Sumbe", "Сумбе", "AO", "24", "06", "", "", "", "-11.20605", "13.84371", "Africa/Luanda"),
("3347019", "Namibe", "Намибе", "AO", "24", "13", "", "", "", "-15.19611", "12.15222", "Africa/Luanda"),
("3347353", "Menongue", "Менонге", "AO", "24", "04", "", "", "", "-14.6585", "17.69099", "Africa/Luanda"),
("3347719", "Luena", "Луэна", "AO", "24", "14", "", "", "", "-11.78333", "19.91667", "Africa/Luanda"),
("3347762", "Lubango", "Лубанго", "AO", "24", "09", "", "", "", "-14.91717", "13.4925", "Africa/Luanda"),
("3347853", "Longonjo", "Логонжу", "AO", "24", "08", "", "", "", "-12.90667", "15.25333", "Africa/Luanda"),
("3347939", "Lobito", "Лобиту", "AO", "24", "01", "", "", "", "-12.3644", "13.53601", "Africa/Luanda"),
("3348078", "Cuito", "Куито", "AO", "24", "02", "", "", "", "-12.38333", "16.93333", "Africa/Luanda"),
("3348313", "Huambo", "Уамбо", "AO", "24", "08", "", "", "", "-12.77611", "15.73917", "Africa/Luanda"),
("3350246", "Catumbela", "Катумбела", "AO", "24", "01", "", "", "", "-12.43002", "13.54677", "Africa/Luanda"),
("3350372", "Catabola", "Катабола", "AO", "24", "02", "", "", "", "-12.15", "17.28333", "Africa/Luanda"),
("3351014", "Camacupa", "Камакупа", "AO", "24", "02", "", "", "", "-12.01667", "17.48333", "Africa/Luanda"),
("3351024", "Caluquembe", "Калукембе", "AO", "24", "09", "", "", "", "-13.78333", "14.68333", "Africa/Luanda"),
("3351500", "Caala", "Каале", "AO", "24", "08", "", "", "", "-12.8525", "15.56056", "Africa/Luanda"),
("3351663", "Benguela", "Бенгела", "AO", "24", "01", "", "", "", "-12.57626", "13.40547", "Africa/Luanda"),
("3427213", "Zarate", "Зарате", "AR", "32", "01", "3427212", "", "", "-34.09814", "-59.02858", "America/Argentina/Buenos_Aires"),
("3427388", "Villa Ocampo", "", "AR", "32", "21", "", "", "", "-28.48752", "-59.35515", "America/Argentina/Cordoba"),
("3427408", "Villa Lugano", "", "AR", "32", "07", "", "", "", "-34.67907", "-58.47262", "America/Argentina/Buenos_Aires"),
("3427428", "Villaguay", "", "AR", "32", "08", "3427426", "", "", "-31.8653", "-59.02689", "America/Argentina/Cordoba"),
("3427431", "Villa Gesell", "Вилья-Хесель", "AR", "32", "01", "", "", "", "-37.26394", "-56.97304", "America/Argentina/Buenos_Aires"),
("3427761", "Tigre", "Тигре", "AR", "32", "01", "3427753", "", "", "-34.42603", "-58.57962", "America/Argentina/Buenos_Aires"),
("3427833", "Tandil", "Тандиль", "AR", "32", "01", "3427832", "", "", "-37.32167", "-59.13316", "America/Argentina/Buenos_Aires"),
("3428068", "San Vicente", "", "AR", "32", "14", "", "", "", "-26.61667", "-54.13333", "America/Argentina/Cordoba"),
("3428071", "Santo Tome", "", "AR", "32", "06", "", "", "", "-28.54939", "-56.04077", "America/Argentina/Cordoba"),
("3428359", "Santa Elena", "", "AR", "32", "08", "", "", "", "-30.94768", "-59.78696", "America/Argentina/Cordoba"),
("3428577", "San Pedro", "", "AR", "32", "14", "3428569", "", "", "-26.62207", "-54.10842", "America/Argentina/Cordoba"),
("3428708", "San Luis del Palmar", "", "AR", "32", "06", "", "", "", "-27.5079", "-58.55454", "America/Argentina/Cordoba"),
("3428759", "San Lorenzo", "", "AR", "32", "06", "", "", "", "-28.13306", "-58.76733", "America/Argentina/Cordoba"),
("3428975", "San Javier", "", "AR", "32", "21", "3428973", "", "", "-30.57781", "-59.9317", "America/Argentina/Cordoba"),
("3428992", "San Isidro", "", "AR", "32", "01", "3428983", "", "", "-34.47145", "-58.50776", "America/Argentina/Buenos_Aires"),
("3429403", "Saladas", "", "AR", "32", "06", "3429402", "", "", "-28.25384", "-58.62591", "America/Argentina/Cordoba"),
("3429576", "Retiro", "Ретиро", "AR", "32", "07", "", "", "", "-34.58333", "-58.38333", "America/Argentina/Buenos_Aires"),
("3429577", "Resistencia", "Ресистенсия", "AR", "32", "03", "", "", "", "-27.46056", "-58.98389", "America/Argentina/Cordoba"),
("3429594", "Reconquista", "Реконкиста", "AR", "32", "21", "", "", "", "-29.15", "-59.65", "America/Argentina/Cordoba"),
("3429652", "Quilmes", "Кильмес", "AR", "32", "01", "3429651", "", "", "-34.72418", "-58.25265", "America/Argentina/Buenos_Aires"),
("3429732", "Puerto Rico", "", "AR", "32", "14", "", "", "", "-26.79598", "-55.02402", "America/Argentina/Cordoba"),
("3429777", "Puerto Iguazu", "Пуэрто-Игуасу", "AR", "32", "14", "3433487", "", "", "-25.59912", "-54.57355", "America/Argentina/Cordoba"),
("3429786", "Puerto Esperanza", "", "AR", "32", "14", "", "", "", "-26.01517", "-54.67306", "America/Argentina/Cordoba"),
("3429790", "Puerto Eldorado", "", "AR", "32", "14", "", "", "", "-26.40842", "-54.69463", "America/Argentina/Cordoba"),
("3429886", "Posadas", "Посадас", "AR", "32", "14", "", "", "", "-27.36708", "-55.89608", "America/Argentina/Cordoba"),
("3429902", "Pontevedra", "", "AR", "32", "01", "", "", "", "-34.74974", "-58.68696", "America/Argentina/Buenos_Aires"),
("3429949", "Pirane", "", "AR", "32", "09", "3429948", "", "", "-25.73239", "-59.10879", "America/Argentina/Cordoba"),
("3430104", "Paso de los Libres", "", "AR", "32", "06", "3430103", "", "", "-29.71311", "-57.08991", "America/Argentina/Cordoba"),
("3430340", "Obera", "Обера", "AR", "32", "14", "3430339", "", "", "-27.48706", "-55.11994", "America/Argentina/Cordoba"),
("3430443", "Necochea", "", "AR", "32", "01", "", "", "", "-38.54726", "-58.73675", "America/Argentina/Buenos_Aires"),
("3430545", "Moron", "", "AR", "32", "01", "3430544", "", "", "-34.65344", "-58.61975", "America/Argentina/Buenos_Aires"),
("3430598", "Monte Caseros", "", "AR", "32", "06", "3430597", "", "", "-30.25359", "-57.63626", "America/Argentina/Cordoba"),
("3430601", "Montecarlo", "", "AR", "32", "14", "3430599", "", "", "-26.5662", "-54.757", "America/Argentina/Cordoba"),
("3430708", "Mercedes", "", "AR", "32", "01", "3430705", "", "", "-34.65146", "-59.43068", "America/Argentina/Buenos_Aires"),
("3430709", "Mercedes", "Мерседес", "AR", "32", "06", "", "", "", "-29.18186", "-58.07895", "America/Argentina/Cordoba"),
("3430863", "Mar del Plata", "Мар-дель-Плата", "AR", "32", "01", "", "", "", "-38.00228", "-57.55754", "America/Argentina/Buenos_Aires"),
("3430988", "Lujan", "Лухан", "AR", "32", "01", "3430982", "", "", "-34.57028", "-59.105", "America/Argentina/Buenos_Aires"),
("3432043", "La Plata", "Ла-Плата", "AR", "32", "01", "3432039", "", "", "-34.92145", "-57.95453", "America/Argentina/Buenos_Aires"),
("3432079", "La Paz", "", "AR", "32", "08", "3432077", "", "", "-30.74485", "-59.64566", "America/Argentina/Cordoba"),
("3433349", "Jardin America", "", "AR", "32", "14", "", "", "", "-27.04346", "-55.22698", "America/Argentina/Cordoba"),
("3433658", "Gualeguaychu", "Гуалегуайчу", "AR", "32", "08", "", "", "", "-33.00938", "-58.51722", "America/Argentina/Cordoba"),
("3433663", "Gualeguay", "", "AR", "32", "08", "3433661", "", "", "-33.14156", "-59.30966", "America/Argentina/Cordoba"),
("3433715", "Goya", "Гойя", "AR", "32", "06", "", "", "", "-29.14003", "-59.26256", "America/Argentina/Cordoba"),
("3433753", "Gobernador Ingeniero Valentin Virasoro", "", "AR", "32", "06", "", "", "", "-28.05", "-56.03333", "America/Argentina/Cordoba"),
("3433803", "General Jose de San Martin", "", "AR", "32", "03", "", "", "", "-26.53743", "-59.34158", "America/Argentina/Cordoba"),
("3433836", "Garupa", "", "AR", "32", "14", "", "", "", "-27.48171", "-55.82921", "America/Argentina/Cordoba"),
("3433899", "Formosa", "Формоза", "AR", "32", "09", "", "", "", "-26.17753", "-58.17814", "America/Argentina/Cordoba"),
("3433901", "Fontana", "", "AR", "32", "03", "", "", "", "-27.41813", "-59.02392", "America/Argentina/Cordoba"),
("3433956", "Federal", "", "AR", "32", "08", "", "", "", "-30.95465", "-58.78326", "America/Argentina/Cordoba"),
("3434095", "Esquina", "", "AR", "32", "06", "3434094", "", "", "-30.01444", "-59.52719", "America/Argentina/Cordoba"),
("3434291", "El Soberbio", "", "AR", "32", "14", "", "", "", "-27.29846", "-54.19877", "America/Argentina/Cordoba"),
("3435038", "Dolores", "", "AR", "32", "01", "3435032", "", "", "-36.31322", "-57.67918", "America/Argentina/Buenos_Aires"),
("3435103", "Curuzu Cuatia", "", "AR", "32", "06", "", "", "", "-29.79171", "-58.0546", "America/Argentina/Cordoba"),
("3435217", "Corrientes", "Корриентес", "AR", "32", "06", "", "", "", "-27.4806", "-58.8341", "America/Argentina/Cordoba"),
("3435261", "Concordia", "Конкордия", "AR", "32", "08", "", "", "", "-31.39296", "-58.02089", "America/Argentina/Cordoba"),
("3435264", "Concepcion del Uruguay", "Консепсьон-дель-Уругвай", "AR", "32", "08", "", "", "", "-32.48249", "-58.23722", "America/Argentina/Cordoba"),
("3435356", "Colegiales", "", "AR", "32", "07", "", "", "", "-34.57365", "-58.44924", "America/Argentina/Buenos_Aires"),
("3435486", "Chajari", "", "AR", "32", "08", "", "", "", "-30.75048", "-57.97962", "America/Argentina/Cordoba"),
("3435810", "Campana", "Кампана", "AR", "32", "01", "3435809", "", "", "-34.16874", "-58.95914", "America/Argentina/Buenos_Aires"),
("3435910", "Buenos Aires", "Буэнос-Айрес", "AR", "32", "07", "", "", "", "-34.61315", "-58.37723", "America/Argentina/Buenos_Aires"),
("3436124", "Barranqueras", "", "AR", "32", "03", "", "", "", "-27.48299", "-58.93579", "America/Argentina/Cordoba"),
("3436199", "Azul", "Азул", "AR", "32", "01", "3436197", "", "", "-36.77698", "-59.85854", "America/Argentina/Buenos_Aires"),
("3436230", "Avellaneda", "", "AR", "32", "21", "", "", "", "-29.11761", "-59.65834", "America/Argentina/Cordoba"),
("3436287", "Aristobulo del Valle", "", "AR", "32", "14", "", "", "", "-27.09625", "-54.89626", "America/Argentina/Cordoba"),
("3832132", "Zapala", "Сапала", "AR", "32", "15", "3832131", "", "", "-38.89916", "-70.05442", "America/Argentina/Salta"),
("3832260", "Yerba Buena", "", "AR", "32", "24", "", "", "", "-26.81667", "-65.31667", "America/Argentina/Tucuman"),
("3832647", "Villa Regina", "", "AR", "32", "16", "", "", "", "-39.1", "-67.06667", "America/Argentina/Salta"),
("3832653", "Villa Paula de Sarmiento", "", "AR", "32", "18", "", "", "", "-31.4933", "-68.53838", "America/Argentina/San_Juan"),
("3832662", "Villa Nueva", "", "AR", "32", "05", "", "", "", "-32.43293", "-63.24763", "America/Argentina/Cordoba"),
("3832694", "Villa Maria", "", "AR", "32", "05", "", "", "", "-32.40751", "-63.24016", "America/Argentina/Cordoba"),
("3832756", "Villa Dolores", "", "AR", "32", "05", "", "", "", "-31.94585", "-65.18958", "America/Argentina/Cordoba"),
("3832778", "Villa Constitucion", "", "AR", "32", "21", "", "", "", "-33.22778", "-60.3297", "America/Argentina/Cordoba"),
("3832791", "Villa Carlos Paz", "Карлос-Паз", "AR", "32", "05", "", "", "", "-31.42414", "-64.49778", "America/Argentina/Cordoba"),
("3832811", "Villa Angela", "", "AR", "32", "03", "", "", "", "-27.57383", "-60.71526", "America/Argentina/Cordoba"),
("3832815", "Villa Allende", "", "AR", "32", "05", "", "", "", "-31.29458", "-64.29538", "America/Argentina/Cordoba"),
("3832899", "Viedma", "Вьедма", "AR", "32", "16", "", "", "", "-40.81345", "-62.99668", "America/Argentina/Salta"),
("3832934", "Victoria", "Виктория", "AR", "32", "08", "3832932", "", "", "-32.61841", "-60.15478", "America/Argentina/Cordoba"),
("3833027", "Vera", "", "AR", "32", "21", "", "", "", "-29.4593", "-60.21261", "America/Argentina/Cordoba"),
("3833062", "Venado Tuerto", "Неукен", "AR", "32", "21", "", "", "", "-33.74556", "-61.96884", "America/Argentina/Cordoba"),
("3833112", "Veinticinco de Mayo", "", "AR", "32", "01", "3833100", "", "", "-35.4323", "-60.17271", "America/Argentina/Buenos_Aires"),
("3833367", "Ushuaia", "Ушуая", "AR", "32", "23", "", "", "", "-54.8", "-68.3", "America/Argentina/Ushuaia"),
("3833412", "Unquillo", "", "AR", "32", "05", "", "", "", "-31.23073", "-64.31615", "America/Argentina/Cordoba"),
("3833794", "Tres Isletas", "", "AR", "32", "03", "", "", "", "-26.34066", "-60.43207", "America/Argentina/Cordoba"),
("3833859", "Tres Arroyos", "", "AR", "32", "01", "3833857", "", "", "-38.37394", "-60.27978", "America/Argentina/Buenos_Aires"),
("3833883", "Trelew", "", "AR", "32", "04", "", "", "", "-43.24895", "-65.30505", "America/Argentina/Catamarca"),
("3834502", "Termas de Rio Hondo", "", "AR", "32", "22", "", "", "", "-27.49983", "-64.86042", "America/Argentina/Cordoba"),
("3834601", "Tartagal", "Тартагал", "AR", "32", "17", "", "", "", "-22.51636", "-63.80131", "America/Argentina/Salta"),
("3834813", "Tafi Viejo", "", "AR", "32", "24", "", "", "", "-26.73201", "-65.25921", "America/Argentina/Tucuman"),
("3834971", "Sunchales", "", "AR", "32", "21", "", "", "", "-30.94404", "-61.56148", "America/Argentina/Cordoba"),
("3835793", "Santo Tome", "", "AR", "32", "21", "", "", "", "-31.66274", "-60.7653", "America/Argentina/Cordoba"),
("3835869", "Santiago del Estero", "Сантьяго-дель-Эстеро", "AR", "32", "22", "", "", "", "-27.79511", "-64.26149", "America/Argentina/Cordoba"),
("3835994", "Santa Rosa", "Санта-Роса", "AR", "32", "11", "", "", "", "-36.61667", "-64.28333", "America/Argentina/Salta"),
("3836194", "Santa Lucia", "", "AR", "32", "18", "3836188", "", "", "-31.53987", "-68.49503", "America/Argentina/San_Juan"),
("3836277", "Santa Fe de la Vera Cruz", "Санта-Фе", "AR", "32", "21", "", "", "", "-31.63333", "-60.7", "America/Argentina/Cordoba"),
("3836564", "San Salvador de Jujuy", "Сан Сальвадор де Жужуй", "AR", "32", "10", "", "", "", "-24.19456", "-65.29712", "America/Argentina/Jujuy"),
("3836620", "San Ramon de la Nueva Oran", "", "AR", "32", "17", "", "", "", "-23.13705", "-64.32426", "America/Argentina/Salta"),
("3836669", "San Rafael", "Сан-Рафаэль", "AR", "32", "13", "", "", "", "-34.61772", "-68.33007", "America/Argentina/Mendoza"),
("3836772", "San Pedro", "", "AR", "32", "10", "3836752", "", "", "-24.23127", "-64.86614", "America/Argentina/Jujuy"),
("3836846", "San Nicolas de los Arroyos", "", "AR", "32", "01", "", "", "", "-33.33578", "-60.22523", "America/Argentina/Buenos_Aires"),
("3836873", "San Miguel de Tucuman", "Сан-Мигель-де-Тукуман", "AR", "32", "24", "", "", "", "-26.82414", "-65.2226", "America/Argentina/Tucuman"),
("3836951", "San Martin de los Andes", "Сан-Мартин-Де-Лос-Андес", "AR", "32", "15", "3852288", "", "", "-40.15789", "-71.35337", "America/Argentina/Salta"),
("3836992", "San Martin", "", "AR", "32", "13", "", "", "", "-33.08103", "-68.46814", "America/Argentina/Mendoza"),
("3837056", "San Luis", "Сан-Луис", "AR", "32", "19", "", "", "", "-33.29501", "-66.33563", "America/Argentina/San_Luis"),
("3837124", "San Justo", "", "AR", "32", "21", "3837122", "", "", "-30.78913", "-60.59189", "America/Argentina/Cordoba"),
("3837213", "San Juan", "Сан-Хуан", "AR", "32", "18", "", "", "", "-31.5375", "-68.53639", "America/Argentina/San_Juan"),
("3837240", "San Jose de Jachal", "", "AR", "32", "18", "", "", "", "-30.24057", "-68.74693", "America/Argentina/San_Juan"),
("3837441", "San Jorge", "", "AR", "32", "21", "", "", "", "-31.89618", "-61.85984", "America/Argentina/Cordoba"),
("3837675", "San Francisco", "", "AR", "32", "05", "", "", "", "-31.42797", "-62.08266", "America/Argentina/Cordoba"),
("3837702", "San Fernando del Valle de Catamarca", "Сан-Фернандо-дель-Валье-де-Катамарка", "AR", "32", "02", "", "", "", "-28.46957", "-65.78524", "America/Argentina/Catamarca"),
("3837980", "San Antonio Oeste", "", "AR", "32", "16", "", "", "", "-40.73193", "-64.94769", "America/Argentina/Salta"),
("3838233", "Salta", "Сальта", "AR", "32", "17", "", "", "", "-24.7859", "-65.41166", "America/Argentina/Salta"),
("3838506", "Rufino", "", "AR", "32", "21", "", "", "", "-34.26827", "-62.71262", "America/Argentina/Cordoba"),
("3838583", "Rosario", "Росарио", "AR", "32", "21", "3838574", "", "", "-32.94682", "-60.63932", "America/Argentina/Cordoba"),
("3838793", "Rio Tercero", "", "AR", "32", "05", "", "", "", "-32.17301", "-64.11406", "America/Argentina/Cordoba"),
("3838797", "Rio Segundo", "", "AR", "32", "05", "3838796", "", "", "-31.6526", "-63.9099", "America/Argentina/Cordoba"),
("3838859", "Rio Gallegos", "Рио-Гальегос", "AR", "32", "20", "", "", "", "-51.62261", "-69.21813", "America/Argentina/Rio_Gallegos"),
("3838874", "Rio Cuarto", "Рио-Куарто", "AR", "32", "05", "3838873", "", "", "-33.13067", "-64.34992", "America/Argentina/Cordoba"),
("3838902", "Rio Ceballos", "", "AR", "32", "05", "", "", "", "-31.16486", "-64.32241", "America/Argentina/Cordoba"),
("3839307", "Rawson", "Роусон", "AR", "32", "04", "3839303", "", "", "-43.30016", "-65.10228", "America/Argentina/Catamarca"),
("3839479", "Rafaela", "Рафаэла", "AR", "32", "21", "", "", "", "-31.25033", "-61.4867", "America/Argentina/Cordoba"),
("3839490", "Quitilipi", "", "AR", "32", "03", "3839489", "", "", "-26.86913", "-60.21683", "America/Argentina/Cordoba"),
("3839982", "Punta Alta", "Пунта-Альта", "AR", "32", "01", "", "", "", "-38.87588", "-62.07359", "America/Argentina/Buenos_Aires"),
("3840092", "Puerto Madryn", "Пуэрто-Мадрин", "AR", "32", "04", "", "", "", "-42.7692", "-65.03851", "America/Argentina/Catamarca"),
("3840300", "Presidencia Roque Saenz Pena", "", "AR", "32", "03", "", "", "", "-26.78522", "-60.43876", "America/Argentina/Cordoba"),
("3840860", "Pocito", "", "AR", "32", "18", "3840858", "", "", "-31.68333", "-68.58333", "America/Argentina/San_Juan"),
("3840885", "Plottier", "", "AR", "32", "15", "", "", "", "-38.96667", "-68.23333", "America/Argentina/Salta"),
("3841490", "Pergamino", "Пергамино", "AR", "32", "01", "3841488", "", "", "-33.88995", "-60.57357", "America/Argentina/Buenos_Aires"),
("3841500", "Perez", "", "AR", "32", "21", "", "", "", "-32.99835", "-60.76791", "America/Argentina/Cordoba"),
("3841956", "Parana", "Парана", "AR", "32", "08", "", "", "", "-31.73197", "-60.5238", "America/Argentina/Cordoba"),
("3842190", "Palpala", "", "AR", "32", "10", "", "", "", "-24.25648", "-65.21163", "America/Argentina/Jujuy"),
("3842670", "Olavarria", "Олаваррия", "AR", "32", "01", "", "", "", "-36.89272", "-60.32254", "America/Argentina/Buenos_Aires"),
("3842881", "Nueve de Julio", "Нев-де-Хулио", "AR", "32", "01", "3842871", "", "", "-35.44437", "-60.88313", "America/Argentina/Buenos_Aires"),
("3843123", "Neuquen", "Неукен", "AR", "32", "15", "", "", "", "-38.95161", "-68.0591", "America/Argentina/Salta"),
("3843619", "Morteros", "", "AR", "32", "05", "", "", "", "-30.71164", "-61.99862", "America/Argentina/Cordoba"),
("3843803", "Monteros", "", "AR", "32", "24", "3843802", "", "", "-27.16742", "-65.49832", "America/Argentina/Tucuman"),
("3844421", "Mendoza", "Мендоса", "AR", "32", "13", "", "", "", "-32.89084", "-68.82717", "America/Argentina/Mendoza"),
("3844899", "Marcos Juarez", "", "AR", "32", "05", "", "", "", "-32.6978", "-62.10672", "America/Argentina/Cordoba"),
("3845330", "Machagai", "", "AR", "32", "03", "", "", "", "-26.92614", "-60.04956", "America/Argentina/Cordoba"),
("3846864", "Lincoln", "", "AR", "32", "01", "3846861", "", "", "-34.86649", "-61.5302", "America/Argentina/Buenos_Aires"),
("3846915", "Libertador General San Martin", "", "AR", "32", "10", "", "", "", "-23.80644", "-64.78757", "America/Argentina/Jujuy"),
("3848687", "Las Brenas", "", "AR", "32", "03", "", "", "", "-27.08966", "-61.08161", "America/Argentina/Cordoba"),
("3848950", "La Rioja", "Ла-Риоха", "AR", "32", "12", "", "", "", "-29.41105", "-66.85067", "America/Argentina/La_Rioja"),
("3851331", "La Falda", "", "AR", "32", "05", "", "", "", "-31.08841", "-64.48987", "America/Argentina/Cordoba"),
("3852374", "La Calera", "", "AR", "32", "05", "", "", "", "-31.34377", "-64.33529", "America/Argentina/Cordoba"),
("3852468", "Laboulaye", "", "AR", "32", "05", "", "", "", "-34.12662", "-63.39119", "America/Argentina/Cordoba"),
("3853354", "Junin", "", "AR", "32", "01", "3853351", "", "", "-34.58382", "-60.94332", "America/Argentina/Buenos_Aires"),
("3853491", "Joaquin V. Gonzalez", "", "AR", "32", "17", "", "", "", "-25.08333", "-64.18333", "America/Argentina/Salta"),
("3853510", "Jesus Maria", "", "AR", "32", "05", "", "", "", "-30.98153", "-64.09424", "America/Argentina/Cordoba"),
("3854895", "Granadero Baigorria", "", "AR", "32", "21", "", "", "", "-32.85683", "-60.71754", "America/Argentina/Cordoba"),
("3854985", "Gobernador Galvez", "", "AR", "32", "21", "", "", "", "-33.03016", "-60.64045", "America/Argentina/Cordoba"),
("3855065", "General Roca", "Хенераль", "AR", "32", "16", "3855061", "", "", "-39.03333", "-67.58333", "America/Argentina/Salta"),
("3855074", "General Pinedo", "", "AR", "32", "03", "", "", "", "-27.31667", "-61.28333", "America/Argentina/Cordoba"),
("3855075", "General Pico", "", "AR", "32", "11", "", "", "", "-35.65662", "-63.75682", "America/Argentina/Salta"),
("3855116", "General Enrique Mosconi", "", "AR", "32", "17", "", "", "", "-22.59588", "-63.81255", "America/Argentina/Salta"),
("3855244", "Galvez", "", "AR", "32", "21", "", "", "", "-32.02927", "-61.22103", "America/Argentina/Cordoba"),
("3855554", "Firmat", "", "AR", "32", "21", "", "", "", "-33.45937", "-61.4832", "America/Argentina/Cordoba"),
("3855666", "Famailla", "", "AR", "32", "24", "3855665", "", "", "-27.05413", "-65.40329", "America/Argentina/Tucuman"),
("3855974", "Esquel", "Эскель", "AR", "32", "04", "3855298", "", "", "-42.91147", "-71.31947", "America/Argentina/Catamarca"),
("3856022", "Esperanza", "", "AR", "32", "21", "", "", "", "-31.4488", "-60.93173", "America/Argentina/Cordoba"),
("3856231", "Embarcacion", "", "AR", "32", "17", "", "", "", "-23.20898", "-64.09605", "America/Argentina/Salta"),
("3856235", "Embalse", "", "AR", "32", "05", "3863430", "", "", "-32.18", "-64.41809", "America/Argentina/Cordoba"),
("3858765", "El Bolson", "", "AR", "32", "16", "", "", "", "-41.96051", "-71.53336", "America/Argentina/Salta"),
("3859384", "Diamante", "", "AR", "32", "08", "", "", "", "-32.06641", "-60.63836", "America/Argentina/Cordoba"),
("3859512", "Dean Funes", "", "AR", "32", "05", "", "", "", "-30.42036", "-64.34984", "America/Argentina/Cordoba"),
("3859552", "Cutral-Co", "", "AR", "32", "15", "", "", "", "-38.93424", "-69.23052", "America/Argentina/Salta"),
("3859828", "Cruz del Eje", "", "AR", "32", "05", "3859827", "", "", "-30.72644", "-64.80387", "America/Argentina/Cordoba"),
("3859904", "Crespo", "", "AR", "32", "08", "", "", "", "-32.02873", "-60.30658", "America/Argentina/Cordoba"),
("3859965", "Cosquin", "", "AR", "32", "05", "", "", "", "-31.24508", "-64.46563", "America/Argentina/Cordoba"),
("3860164", "Coronel Suarez", "Коронель-Суарез", "AR", "32", "01", "3860163", "", "", "-37.45467", "-61.93343", "America/Argentina/Buenos_Aires"),
("3860217", "Coronda", "", "AR", "32", "21", "", "", "", "-31.97263", "-60.91982", "America/Argentina/Cordoba"),
("3860259", "Cordoba", "Кордова", "AR", "32", "05", "3862744", "", "", "-31.4135", "-64.18105", "America/Argentina/Cordoba"),
("3860443", "Comodoro Rivadavia", "Комодоро-Ривадавия", "AR", "32", "04", "", "", "", "-45.86414", "-67.49656", "America/Argentina/Catamarca"),
("3861056", "Cipolletti", "Чиполлетти", "AR", "32", "16", "", "", "", "-38.93392", "-67.99032", "America/Argentina/Salta"),
("3861061", "Cinco Saltos", "", "AR", "32", "16", "", "", "", "-38.82224", "-68.06293", "America/Argentina/Salta"),
("3861344", "Chivilcoy", "", "AR", "32", "01", "3435406", "", "", "-34.89566", "-60.01667", "America/Argentina/Buenos_Aires"),
("3861416", "Chimbas", "", "AR", "32", "18", "3861415", "", "", "-31.48333", "-68.53333", "America/Argentina/San_Juan"),
("3861445", "Chilecito", "", "AR", "32", "12", "3861443", "", "", "-29.16195", "-67.4974", "America/Argentina/La_Rioja"),
("3861678", "Charata", "", "AR", "32", "03", "", "", "", "-27.21438", "-61.18795", "America/Argentina/Cordoba"),
("3861953", "Chacabuco", "Чакабуко", "AR", "32", "01", "3861944", "", "", "-34.64167", "-60.47389", "America/Argentina/Buenos_Aires"),
("3862144", "Centenario", "", "AR", "32", "15", "", "", "", "-38.82955", "-68.1318", "America/Argentina/Salta"),
("3862240", "Caucete", "", "AR", "32", "18", "", "", "", "-31.65179", "-68.28105", "America/Argentina/San_Juan"),
("3862254", "Catriel", "", "AR", "32", "16", "", "", "", "-37.87907", "-67.7956", "America/Argentina/Salta"),
("3862320", "Castelli", "", "AR", "32", "03", "", "", "", "-25.94679", "-60.61947", "America/Argentina/Cordoba"),
("3862351", "Casilda", "", "AR", "32", "21", "", "", "", "-33.04417", "-61.16806", "America/Argentina/Cordoba"),
("3862655", "Carcarana", "", "AR", "32", "21", "", "", "", "-32.85679", "-61.15331", "America/Argentina/Cordoba"),
("3862738", "Capitan Bermudez", "", "AR", "32", "21", "", "", "", "-32.82262", "-60.71852", "America/Argentina/Cordoba"),
("3862981", "Canada de Gomez", "Канада-де-Гомес", "AR", "32", "21", "", "", "", "-32.81636", "-61.39493", "America/Argentina/Cordoba"),
("3863379", "Caleta Olivia", "Калета-Оливия", "AR", "32", "20", "", "", "", "-46.43929", "-67.52814", "America/Argentina/Rio_Gallegos"),
("3864331", "Bell Ville", "", "AR", "32", "05", "", "", "", "-32.62591", "-62.68873", "America/Argentina/Cordoba"),
("3864375", "Bella Vista", "", "AR", "32", "24", "", "", "", "-27.03084", "-65.30315", "America/Argentina/Tucuman"),
("3865086", "Bahia Blanca", "Байя-Бланка", "AR", "32", "01", "3865084", "", "", "-38.7196", "-62.27243", "America/Argentina/Buenos_Aires"),
("3865385", "Arroyo Seco", "", "AR", "32", "21", "", "", "", "-33.15489", "-60.50863", "America/Argentina/Cordoba"),
("3865424", "Arroyito", "", "AR", "32", "05", "", "", "", "-31.42022", "-63.05002", "America/Argentina/Cordoba"),
("3865840", "Anatuya", "", "AR", "32", "22", "", "", "", "-28.46064", "-62.83472", "America/Argentina/Cordoba"),
("3866163", "Alta Gracia", "Альта-Грация", "AR", "32", "05", "", "", "", "-31.65292", "-64.42826", "America/Argentina/Cordoba"),
("3866242", "Allen", "", "AR", "32", "16", "", "", "", "-38.97736", "-67.82714", "America/Argentina/Salta"),
("3866367", "Alderetes", "", "AR", "32", "24", "", "", "", "-26.81667", "-65.13333", "America/Argentina/Tucuman"),
("3866425", "Albardon", "", "AR", "32", "18", "3866424", "", "", "-31.43722", "-68.52556", "America/Argentina/San_Juan"),
("3866496", "Aguilares", "", "AR", "32", "24", "", "", "", "-27.4338", "-65.61427", "America/Argentina/Tucuman"),
("6693230", "Villa Santa Rita", "", "AR", "32", "07", "", "", "", "-34.61082", "-58.481", "America/Argentina/Buenos_Aires"),
("7116866", "Villa Mercedes", "", "AR", "32", "19", "", "", "", "-33.67571", "-65.45783", "America/Argentina/San_Luis"),
("7647007", "San Carlos de Bariloche", "Сан Карлос де Барилоче", "AR", "32", "16", "3864759", "3837856", "", "-41.14557", "-71.30822", "America/Argentina/Salta"),
("2760910", "Wolfsberg", "", "AT", "40", "02", "209", "20923", "", "46.84056", "14.84417", "Europe/Vienna"),
("2761353", "Wiener Neustadt", "Винер-Нойштадт", "AT", "40", "03", "304", "30401", "", "47.8", "16.25", "Europe/Vienna"),
("2761369", "Vienna", "Вена", "AT", "40", "09", "900", "901", "", "48.20849", "16.37208", "Europe/Vienna"),
("2761524", "Wels", "Вельс", "AT", "40", "04", "403", "40301", "", "48.16667", "14.03333", "Europe/Vienna"),
("2761669", "Weinzierl bei Krems", "", "AT", "40", "03", "313", "31327", "", "48.4", "15.6", "Europe/Vienna"),
("2762372", "Villach", "Филлах", "AT", "40", "02", "202", "20201", "", "46.61028", "13.85583", "Europe/Vienna"),
("2763423", "Traun", "", "AT", "40", "04", "410", "41021", "", "48.22656", "14.23459", "Europe/Vienna"),
("2763460", "Traiskirchen", "", "AT", "40", "03", "306", "30639", "", "48.01485", "16.29324", "Europe/Vienna"),
("2763795", "Ternitz", "Терниц", "AT", "40", "03", "318", "31839", "", "47.71565", "16.03575", "Europe/Vienna"),
("2764359", "Steyr", "Штайр", "AT", "40", "04", "402", "40201", "", "48.04274", "14.42127", "Europe/Vienna"),
("2764786", "Spittal an der Drau", "Шпитталь-ан-дер-Драу", "AT", "40", "02", "206", "20635", "", "46.8", "13.5", "Europe/Vienna"),
("2765388", "Schwechat", "Швехат", "AT", "40", "03", "324", "32419", "", "48.13333", "16.46667", "Europe/Vienna"),
("2766429", "Sankt Poelten", "Санкт-Пёльтен", "AT", "40", "03", "302", "30201", "", "48.2", "15.63333", "Europe/Vienna"),
("2766824", "Salzburg", "Зальцбург", "AT", "40", "05", "501", "50101", "", "47.79941", "13.04399", "Europe/Vienna"),
("2766922", "Saalfelden am Steinernen Meer", "Зальфельден-ам-Штайнернен-Меер", "AT", "40", "05", "506", "50619", "", "47.42681", "12.848", "Europe/Vienna"),
("2771335", "Modling", "Мёдлинг", "AT", "40", "03", "317", "31717", "", "48.08605", "16.28921", "Europe/Vienna"),
("2772173", "Lustenau", "Лустенау", "AT", "40", "08", "803", "80303", "", "47.42642", "9.65851", "Europe/Vienna"),
("2772400", "Linz", "Линц", "AT", "40", "04", "401", "40101", "", "48.30639", "14.28611", "Europe/Vienna"),
("2772635", "Leonding", "Леондинг", "AT", "40", "04", "410", "41012", "", "48.27965", "14.2533", "Europe/Vienna"),
("2772649", "Leoben", "Леобен", "AT", "40", "06", "611", "61108", "", "47.3765", "15.09144", "Europe/Vienna"),
("2773300", "Kufstein", "Куфштайн", "AT", "40", "07", "705", "70513", "", "47.58333", "12.16667", "Europe/Vienna"),
("2773549", "Krems an der Donau", "Кремс-на-Дунае", "AT", "40", "03", "301", "30101", "", "48.40921", "15.61415", "Europe/Vienna"),
("2773913", "Klosterneuburg", "Клостернойбург", "AT", "40", "03", "324", "32408", "", "48.30521", "16.32522", "Europe/Vienna"),
("2774326", "Klagenfurt am Woerthersee", "Клагенфурт", "AT", "40", "02", "201", "20101", "", "46.62472", "14.30528", "Europe/Vienna"),
("2774773", "Kapfenberg", "Капфенберг", "AT", "40", "06", "621", "62113", "", "47.44458", "15.29331", "Europe/Vienna"),
("2775220", "Innsbruck", "Инсбрук", "AT", "40", "07", "701", "70101", "", "47.26266", "11.39454", "Europe/Vienna"),
("2776951", "Hallein", "Халлайн", "AT", "40", "05", "502", "50205", "", "47.68333", "13.1", "Europe/Vienna"),
("2778067", "Graz", "Грац", "AT", "40", "06", "601", "60101", "", "47.06667", "15.45", "Europe/Vienna"),
("2779674", "Feldkirch", "Фельдкирх", "AT", "40", "08", "804", "80404", "", "47.23306", "9.6", "Europe/Vienna"),
("2780741", "Dornbirn", "Дорнбирн", "AT", "40", "08", "803", "80301", "", "47.41427", "9.74195", "Europe/Vienna"),
("2781503", "Bregenz", "Брегенц", "AT", "40", "08", "802", "80207", "", "47.50311", "9.7471", "Europe/Vienna"),
("2781520", "Braunau am Inn", "Браунау-ам-Инн", "AT", "40", "04", "404", "40404", "", "48.25628", "13.04343", "Europe/Vienna"),
("2782067", "Baden", "Баден", "AT", "40", "03", "306", "30604", "", "48.00543", "16.23264", "Europe/Vienna"),
("2782555", "Amstetten", "Амштеттен", "AT", "40", "03", "305", "30502", "", "48.1229", "14.87206", "Europe/Vienna"),
("3323063", "Ansfelden", "", "AT", "40", "05", "503", "50332", "", "47.965", "13.04944", "Europe/Vienna"),
("2058430", "Whyalla", "Уайалла", "AU", "36", "05", "48540", "", "", "-33.03268", "137.56484", "Australia/Adelaide"),
("2062338", "Rockingham", "", "AU", "36", "08", "57490", "", "", "-32.27682", "115.72978", "Australia/Perth"),
("2062944", "Prospect", "", "AU", "36", "05", "46510", "", "", "-34.88241", "138.5933", "Australia/Adelaide"),
("2063042", "Port Hedland", "Порт-Хедленд", "AU", "36", "08", "57280", "", "", "-20.31215", "118.61059", "Australia/Perth"),
("2063523", "Perth", "Перт", "AU", "36", "08", "51310", "", "", "-31.95224", "115.8614", "Australia/Perth"),
("2065176", "Murray Bridge", "Марри-Бридж", "AU", "36", "05", "45040", "", "", "-35.11986", "139.27345", "Australia/Adelaide"),
("2065594", "Mount Isa", "Маунт-Айза", "AU", "36", "04", "35300", "", "", "-20.72523", "139.49727", "Australia/Brisbane"),
("2065740", "Morphett Vale", "", "AU", "36", "05", "45340", "", "", "-35.13333", "138.51667", "Australia/Adelaide"),
("2067119", "Mandurah", "Мандъюра", "AU", "36", "08", "55110", "", "", "-32.5269", "115.7217", "Australia/Perth"),
("2068079", "Kwinana", "", "AU", "36", "08", "54830", "", "", "-32.23013", "115.78128", "Australia/Perth"),
("2068823", "Kalgoorlie", "Калгурли", "AU", "36", "08", "54280", "", "", "-30.74614", "121.4742", "Australia/Perth"),
("2070571", "Gosnells", "", "AU", "36", "08", "53780", "", "", "-32.081", "116.0054", "Australia/Perth"),
("2070998", "Geraldton", "Джералдтон", "AU", "36", "08", "53520", "", "", "-28.77897", "114.61459", "Australia/Perth"),
("2071059", "Gawler", "Голер", "AU", "36", "05", "42030", "", "", "-34.60251", "138.74902", "Australia/Adelaide"),
("2071223", "Fremantle", "Фримантл", "AU", "36", "08", "53430", "", "", "-32.05", "115.76667", "Australia/Perth"),
("2073124", "Darwin", "Дарвин", "AU", "36", "03", "71000", "", "", "-12.46113", "130.84185", "Australia/Darwin"),
("2075265", "Busselton", "", "AU", "36", "08", "51260", "", "", "-33.65249", "115.3455", "Australia/Perth"),
("2075432", "Bunbury", "Банбери", "AU", "36", "08", "51190", "", "", "-33.32711", "115.64137", "Australia/Perth"),
("2077579", "Armadale", "", "AU", "36", "08", "50210", "", "", "-32.14607", "116.0093", "Australia/Perth"),
("2077895", "Alice Springs", "Алис-Спрингс", "AU", "36", "03", "70200", "", "", "-23.69748", "133.88362", "Australia/Darwin"),
("2077963", "Albany", "Олбани", "AU", "36", "08", "50080", "", "", "-35.0031", "117.86595", "Australia/Perth"),
("2078025", "Adelaide", "Аделаида", "AU", "36", "05", "40070", "", "", "-34.92866", "138.59863", "Australia/Adelaide"),
("2143069", "Woodridge", "", "AU", "36", "04", "34590", "", "", "-27.63333", "153.1", "Australia/Brisbane"),
("2143285", "Wodonga", "Уодонга", "AU", "36", "07", "27170", "", "", "-36.12179", "146.88809", "Australia/Melbourne"),
("2144528", "Warrnambool", "Уорнамбул", "AU", "36", "07", "26730", "", "", "-38.38176", "142.48799", "Australia/Melbourne"),
("2144764", "Wangaratta", "Уангаратта", "AU", "36", "07", "26700", "", "", "-36.35846", "146.32056", "Australia/Melbourne"),
("2145110", "Wagga Wagga", "Уогга Уогга", "AU", "36", "02", "17750", "", "", "-35.12577", "147.35374", "Australia/Sydney"),
("2146108", "Traralgon", "Траралгон", "AU", "36", "07", "23810", "", "", "-38.19528", "146.5415", "Australia/Melbourne"),
("2146142", "Townsville", "Таунсвилл", "AU", "36", "04", "37010", "", "", "-19.26639", "146.8057", "Australia/Brisbane"),
("2146268", "Toowoomba", "Тувумба", "AU", "36", "04", "36910", "", "", "-27.56056", "151.95386", "Australia/Brisbane"),
("2147381", "Taree", "Тари", "AU", "36", "02", "13350", "", "", "-31.91099", "152.45387", "Australia/Sydney"),
("2147497", "Tamworth", "Тамуорт", "AU", "36", "02", "17310", "", "", "-31.09048", "150.92905", "Australia/Sydney"),
("2147714", "Sydney", "Сидней", "AU", "36", "02", "17200", "", "", "-33.86785", "151.20732", "Australia/Sydney"),
("2147849", "Surfers Paradise", "Сёрферс Парадайз", "AU", "36", "04", "33430", "", "", "-28.00274", "153.42999", "Australia/Brisbane"),
("2147892", "Sunnybank", "", "AU", "36", "04", "31000", "", "", "-27.58333", "153.05", "Australia/Brisbane"),
("2147914", "Sunbury", "Санбери", "AU", "36", "07", "23270", "", "", "-37.57742", "144.72607", "Australia/Melbourne"),
("2148398", "Port Stephens", "", "AU", "36", "02", "16400", "", "", "-32.71314", "152.06623", "Australia/Sydney"),
("2148928", "Southport", "", "AU", "36", "04", "33430", "", "", "-27.96724", "153.39796", "Australia/Brisbane"),
("2148997", "South Grafton", "", "AU", "36", "02", "11730", "", "", "-29.7076", "152.92627", "Australia/Sydney"),
("2149645", "Shepparton", "Шеппартон", "AU", "36", "07", "22830", "", "", "-36.38047", "145.39867", "Australia/Melbourne"),
("2150660", "Saint Kilda", "", "AU", "36", "07", "25900", "", "", "-37.8676", "144.98099", "Australia/Melbourne"),
("2151437", "Rockhampton", "Рокхемптон", "AU", "36", "04", "36360", "", "", "-23.38032", "150.50595", "Australia/Brisbane"),
("2151649", "Richmond", "", "AU", "36", "07", "27350", "", "", "-37.81819", "145.00176", "Australia/Melbourne"),
("2152286", "Queanbeyan", "Куинбеян", "AU", "36", "02", "16470", "", "", "-35.35493", "149.232", "Australia/Sydney"),
("2152329", "Quakers Hill", "", "AU", "36", "02", "10750", "", "", "-33.73333", "150.88333", "Australia/Sydney"),
("2152659", "Port Macquarie", "Порт Маккуори", "AU", "36", "02", "16380", "", "", "-31.43084", "152.90894", "Australia/Sydney"),
("2154219", "Orange", "Орандж", "AU", "36", "02", "16150", "", "", "-33.28397", "149.10018", "Australia/Sydney"),
("2154787", "Nowra", "Новра", "AU", "36", "02", "16950", "", "", "-34.88422", "150.60036", "Australia/Sydney"),
("2155472", "Newcastle", "Ньюкасл", "AU", "36", "02", "15900", "", "", "-32.92715", "151.77647", "Australia/Sydney"),
("2155542", "Nerang", "", "AU", "36", "04", "33430", "", "", "-27.98941", "153.33633", "Australia/Brisbane"),
("2156340", "Mulgrave", "", "AU", "36", "07", "24970", "", "", "-37.91667", "145.2", "Australia/Melbourne"),
("2156643", "Mount Gambier", "Маунт-Гамбиер", "AU", "36", "05", "44620", "", "", "-37.8318", "140.77919", "Australia/Adelaide"),
("2156813", "Mosman", "Мосман", "AU", "36", "02", "15350", "", "", "-33.83902", "151.23956", "Australia/Sydney"),
("2156878", "Mornington", "Морнингтон", "AU", "36", "07", "25340", "", "", "-38.21792", "145.03876", "Australia/Melbourne"),
("2156934", "Morayfield", "", "AU", "36", "04", "35010", "", "", "-27.10876", "152.94907", "Australia/Brisbane"),
("2157343", "Moe", "Мои", "AU", "36", "07", "23810", "", "", "-38.17828", "146.26099", "Australia/Melbourne"),
("2157698", "Mildura", "Милдьюра", "AU", "36", "07", "24780", "", "", "-34.18551", "142.16251", "Australia/Melbourne"),
("2158151", "Melton", "Мелтон", "AU", "36", "07", "24650", "", "", "-37.68339", "144.58543", "Australia/Melbourne"),
("2158177", "Melbourne", "Мельбурн", "AU", "36", "07", "24600", "", "", "-37.814", "144.96332", "Australia/Melbourne"),
("2158562", "Maryborough", "Мэриборо", "AU", "36", "04", "33220", "", "", "-25.54073", "152.70493", "Australia/Brisbane"),
("2158626", "Marrickville", "", "AU", "36", "02", "15200", "", "", "-33.90318", "151.15176", "Australia/Sydney"),
("2158651", "Maroubra", "", "AU", "36", "02", "16550", "", "", "-33.95", "151.23333", "Australia/Sydney"),
("2159045", "Maitland", "Мейтленд", "AU", "36", "02", "15050", "", "", "-32.73308", "151.5574", "Australia/Sydney"),
("2159220", "Mackay", "Макей", "AU", "36", "04", "34770", "", "", "-21.15345", "149.16554", "Australia/Brisbane"),
("2159851", "Liverpool", "", "AU", "36", "02", "12850", "", "", "-33.9", "150.93333", "Australia/Sydney"),
("2160063", "Lismore", "Лизмор", "AU", "36", "02", "14850", "", "", "-28.81354", "153.2773", "Australia/Sydney"),
("2160517", "Launceston", "Лонсестон", "AU", "36", "06", "64010", "", "", "-41.43876", "147.13467", "Australia/Hobart"),
("2161776", "Katoomba", "Катумба", "AU", "36", "02", "10900", "", "", "-33.71977", "150.30739", "Australia/Sydney"),
("2163137", "Hornsby", "", "AU", "36", "02", "14000", "", "", "-33.70244", "151.09931", "Australia/Sydney"),
("2163355", "Hobart", "Хобарт", "AU", "36", "06", "62810", "", "", "-42.87936", "147.32941", "Australia/Hobart"),
("2164422", "Griffith", "Гриффит", "AU", "36", "02", "13450", "", "", "-34.28853", "146.05093", "Australia/Sydney"),
("2164515", "Greensborough", "", "AU", "36", "07", "20660", "", "", "-37.70462", "145.10302", "Australia/Melbourne"),
("2164691", "Granville", "", "AU", "36", "02", "16250", "", "", "-33.83333", "151.01667", "Australia/Sydney"),
("2164837", "Goulburn", "Гулберн", "AU", "36", "02", "13310", "", "", "-34.75155", "149.72086", "Australia/Sydney"),
("2165087", "Gold Coast", "Голд Коуст", "AU", "36", "04", "33430", "", "", "-28.00029", "153.43088", "Australia/Brisbane"),
("2165478", "Gladstone", "Глэдстон", "AU", "36", "04", "33360", "", "", "-23.84761", "151.25635", "Australia/Brisbane"),
("2165798", "Geelong", "Джилонг", "AU", "36", "07", "22750", "", "", "-38.14711", "144.36069", "Australia/Melbourne"),
("2166143", "Frankston East", "Френкстон", "AU", "36", "07", "22170", "", "", "-38.13333", "145.13333", "Australia/Melbourne"),
("2166309", "Forster", "", "AU", "36", "02", "13400", "", "", "-32.18136", "152.51715", "Australia/Sydney"),
("2167280", "Epping", "", "AU", "36", "02", "16250", "", "", "-33.77271", "151.08184", "Australia/Sydney"),
("2167312", "Engadine", "", "AU", "36", "02", "17150", "", "", "-34.06564", "151.01266", "Australia/Sydney"),
("2167817", "Echuca", "Ичука", "AU", "36", "07", "21370", "", "", "-36.14057", "144.75185", "Australia/Melbourne"),
("2167949", "Earlwood", "", "AU", "36", "02", "14150", "", "", "-33.95", "151.1", "Australia/Sydney"),
("2168305", "Dubbo", "Даббо", "AU", "36", "02", "12600", "", "", "-32.24295", "148.60484", "Australia/Sydney"),
("2168943", "Devonport", "Девонпорт", "AU", "36", "06", "61610", "", "", "-41.17695", "146.35152", "Australia/Hobart"),
("2169220", "Deception Bay", "", "AU", "36", "04", "35010", "", "", "-27.19354", "153.02631", "Australia/Brisbane"),
("2169956", "Cronulla", "", "AU", "36", "02", "17150", "", "", "-34.06251", "151.14961", "Australia/Sydney"),
("2170078", "Cranbourne", "", "AU", "36", "07", "21610", "", "", "-38.1", "145.28333", "Australia/Melbourne"),
("2170089", "Craigieburn", "", "AU", "36", "07", "23270", "", "", "-37.6", "144.95", "Australia/Melbourne"),
("2171085", "Coffs Harbour", "Кофс-Харбор", "AU", "36", "02", "11800", "", "", "-30.29626", "153.11351", "Australia/Sydney"),
("2171507", "Wollongong", "Вуллонгонг", "AU", "36", "02", "18450", "", "", "-34.424", "150.89345", "Australia/Sydney"),
("2171845", "Cessnock", "Сеснок", "AU", "36", "02", "11720", "", "", "-32.83211", "151.35623", "Australia/Sydney"),
("2172111", "Castle Hill", "", "AU", "36", "02", "10500", "", "", "-33.73333", "151", "Australia/Sydney"),
("2172303", "Carlingford", "", "AU", "36", "02", "16250", "", "", "-33.78269", "151.04888", "Australia/Sydney"),
("2172311", "Caringbah", "", "AU", "36", "02", "17150", "", "", "-34.04726", "151.12051", "Australia/Sydney"),
("2172517", "Canberra", "Канберра", "AU", "36", "01", "", "", "", "-35.28346", "149.12807", "Australia/Sydney"),
("2172686", "Camberwell", "", "AU", "36", "07", "21110", "", "", "-37.84205", "145.0694", "Australia/Melbourne"),
("2172710", "Caloundra", "Калундра", "AU", "36", "04", "36710", "", "", "-26.79709", "153.13771", "Australia/Brisbane"),
("2172797", "Cairns", "Кернс", "AU", "36", "04", "32070", "", "", "-16.92304", "145.76625", "Australia/Brisbane"),
("2172832", "Caboolture", "", "AU", "36", "04", "35010", "", "", "-27.08465", "152.9511", "Australia/Brisbane"),
("2173125", "Burnie", "Берни", "AU", "36", "06", "60610", "", "", "-41.05584", "145.90375", "Australia/Hobart"),
("2173323", "Bundaberg", "Бандаберг", "AU", "36", "04", "31820", "", "", "-24.86621", "152.3479", "Australia/Brisbane"),
("2173605", "Buderim", "", "AU", "36", "04", "36710", "", "", "-26.68443", "153.05705", "Australia/Brisbane"),
("2173741", "Brunswick", "", "AU", "36", "07", "25250", "", "", "-37.76667", "144.96667", "Australia/Melbourne"),
("2173911", "Broken Hill", "Брокен-Хилл", "AU", "36", "02", "11250", "", "", "-31.96173", "141.45998", "Australia/Broken_Hill"),
("2174003", "Brisbane", "Брисбен", "AU", "36", "04", "31000", "", "", "-27.46794", "153.02809", "Australia/Brisbane"),
("2175411", "Blacktown", "", "AU", "36", "02", "10750", "", "", "-33.76667", "150.91667", "Australia/Sydney"),
("2176187", "Bendigo", "Бендиго", "AU", "36", "07", "22620", "", "", "-36.75818", "144.28024", "Australia/Melbourne"),
("2176632", "Bathurst", "Бэтхерст", "AU", "36", "02", "10470", "", "", "-33.41665", "149.5806", "Australia/Sydney"),
("2176934", "Banora Point", "", "AU", "36", "02", "17550", "", "", "-28.21298", "153.53634", "Australia/Sydney"),
("2177091", "Ballarat", "Балларат", "AU", "36", "07", "20570", "", "", "-37.56622", "143.84957", "Australia/Melbourne"),
("2177671", "Armidale", "Армидейл", "AU", "36", "02", "10110", "", "", "-30.50828", "151.67123", "Australia/Sydney"),
("2178174", "Albury", "Олбери", "AU", "36", "02", "10050", "", "", "-36.07494", "146.92394", "Australia/Sydney"),
("2207259", "South Brisbane", "", "AU", "36", "04", "31000", "", "", "-27.48034", "153.02049", "Australia/Brisbane"),
("2208285", "Randwick", "", "AU", "36", "02", "16550", "", "", "-33.91439", "151.24895", "Australia/Sydney"),
("2208305", "Dee Why", "", "AU", "36", "02", "18000", "", "", "-33.75", "151.3", "Australia/Sydney"),
("6301965", "Palmerston", "Палмерстон", "AU", "36", "03", "72800", "", "", "-12.48602", "130.9833", "Australia/Darwin"),
("6943558", "Bracken Ridge", "", "AU", "36", "04", "31000", "", "", "-27.3171", "153.03097", "Australia/Brisbane"),
("7281782", "North Ryde", "", "AU", "36", "02", "16700", "", "", "-33.79677", "151.12436", "Australia/Sydney"),
("7281807", "Hoppers Crossing", "", "AU", "36", "07", "27260", "", "", "-37.88264", "144.7003", "Australia/Melbourne"),
("7281838", "Logan City", "", "AU", "36", "04", "34590", "", "", "-27.63917", "153.10944", "Australia/Brisbane"),
("7281839", "Carindale", "", "AU", "36", "04", "31000", "", "", "-27.50578", "153.10236", "Australia/Brisbane"),
("7281840", "Paramatta", "", "AU", "36", "02", "16250", "", "", "-33.8178", "151.00348", "Australia/Sydney"),
("7281850", "Ferntree Gully", "", "AU", "36", "07", "23670", "", "", "-37.88461", "145.29539", "Australia/Melbourne"),
("7302259", "City of Parramatta", "", "AU", "36", "02", "16250", "", "", "-33.81667", "151", "Australia/Sydney"),
("7302628", "Adelaide Hills", "", "AU", "36", "05", "40120", "", "", "-34.91118", "138.70735", "Australia/Adelaide"),
("7302631", "Canning Vale", "", "AU", "36", "08", "51330", "", "", "-32.05798", "115.91814", "Australia/Perth"),
("7302642", "Glenmore Park", "", "AU", "36", "02", "16350", "", "", "-33.79068", "150.6693", "Australia/Sydney"),
("7932612", "Glen Iris", "", "AU", "36", "07", "26350", "", "", "-37.85995", "145.05489", "Australia/Melbourne"),
("7932629", "Balwyn North", "", "AU", "36", "07", "21110", "", "", "-37.79086", "145.09386", "Australia/Melbourne"),
("7932636", "Carnegie", "", "AU", "36", "07", "22310", "", "", "-37.88867", "145.05713", "Australia/Melbourne"),
("7932638", "Malvern East", "", "AU", "36", "07", "26350", "", "", "-37.87397", "145.04253", "Australia/Melbourne"),
("7932646", "Brighton East", "", "AU", "36", "07", "20910", "", "", "-37.90141", "145.01884", "Australia/Melbourne"),
("7932654", "Booval", "", "AU", "36", "04", "33960", "", "", "-27.61328", "152.78944", "Australia/Brisbane"),
("8015209", "St Albans", "", "AU", "36", "07", "21180", "", "", "-37.74496", "144.80049", "Australia/Melbourne"),
("8347325", "Endeavour Hills", "", "AU", "36", "07", "21610", "", "", "-37.97695", "145.25866", "Australia/Melbourne"),
("8347717", "Clayton", "", "AU", "36", "07", "24970", "", "", "-37.91731", "145.13041", "Australia/Melbourne"),
("146970", "Xankǝndi", "Степанакерт", "AZ", "31", "61", "", "", "", "39.8177", "46.7528", "Asia/Baku"),
("147059", "Ahmadbayli", "Tel’mankend", "AZ", "31", "45", "", "", "", "39.87867", "48.39902", "Asia/Baku"),
("147105", "Shushi", "Шуша", "AZ", "31", "55", "", "", "", "39.76006", "46.74989", "Asia/Baku"),
("147271", "Salyan", "Сальян", "AZ", "31", "49", "", "", "", "39.59621", "48.98479", "Asia/Baku"),
("147288", "Saatli", "Саатлы", "AZ", "31", "45", "", "", "", "39.93214", "48.36892", "Asia/Baku"),
("147425", "Neftcala", "Нефтечала", "AZ", "31", "36", "", "", "", "39.3768", "49.247", "Asia/Baku"),
("147429", "Nakhchivan", "Нахичевань", "AZ", "31", "35", "", "", "", "39.20889", "45.41222", "Asia/Baku"),
("147622", "Lǝnkǝran", "Ленкорань", "AZ", "31", "29", "", "", "", "38.75428", "48.85062", "Asia/Baku"),
("147982", "Imishli", "Имишли", "AZ", "31", "24", "", "", "", "39.87095", "48.05995", "Asia/Baku"),
("148106", "Fizuli", "Физули", "AZ", "31", "18", "", "", "", "39.60094", "47.14529", "Asia/Baku"),
("148290", "Dzhalilabad", "", "AZ", "31", "15", "", "", "", "39.20963", "48.49186", "Asia/Baku"),
("148340", "Pushkino", "", "AZ", "31", "13", "", "", "", "39.45833", "48.545", "Asia/Baku"),
("148354", "Beyləqan", "", "AZ", "31", "12", "", "", "", "39.77556", "47.61861", "Asia/Baku"),
("148445", "Astara", "Астара", "AZ", "31", "08", "", "", "", "38.45598", "48.87498", "Asia/Baku"),
("148565", "Sirvan", "Ширван", "AZ", "31", "07", "", "", "", "39.93778", "48.929", "Asia/Baku"),
("148619", "Agdam", "Агдам", "AZ", "31", "03", "", "", "", "39.99096", "46.92736", "Asia/Baku"),
("584596", "Zaqatala", "Закаталы", "AZ", "31", "70", "", "", "", "41.6316", "46.64479", "Asia/Baku"),
("584614", "Zabrat", "Забрат", "AZ", "31", "09", "", "", "", "40.47746", "49.94174", "Asia/Baku"),
("584649", "Yevlakh", "Евлах", "AZ", "31", "68", "", "", "", "40.61832", "47.15014", "Asia/Baku"),
("584716", "Yelenendorf", "Гёйгёль", "AZ", "31", "62", "", "", "", "40.58584", "46.3189", "Asia/Baku"),
("584717", "Xacmaz", "Хачмас", "AZ", "31", "60", "", "", "", "41.46426", "48.80565", "Asia/Baku"),
("584791", "Ujar", "Уджары", "AZ", "31", "59", "", "", "", "40.51902", "47.65423", "Asia/Baku"),
("584871", "Terter", "Тертер", "AZ", "31", "57", "", "", "", "40.34179", "46.93242", "Asia/Baku"),
("584923", "Sumqayit", "Сумгаит", "AZ", "31", "54", "", "", "", "40.58972", "49.66861", "Asia/Baku"),
("585103", "Qaracuxur", "Гарачухур", "AZ", "31", "09", "", "", "", "40.39667", "49.97361", "Asia/Baku"),
("585152", "Shamkhor", "Шамкир", "AZ", "31", "51", "", "", "", "40.82975", "46.0178", "Asia/Baku"),
("585156", "Shamakhi", "Шемаха", "AZ", "31", "50", "", "", "", "40.63141", "48.64137", "Asia/Baku"),
("585170", "Sheki", "Шеки", "AZ", "31", "48", "", "", "", "41.19194", "47.17056", "Asia/Baku"),
("585184", "Sabuncu", "Сабунчи", "AZ", "31", "09", "", "", "", "40.4425", "49.94806", "Asia/Baku"),
("585187", "Sabirabad", "Сабирабад", "AZ", "31", "46", "", "", "", "40.00869", "48.47701", "Asia/Baku"),
("585220", "Qusar", "Кусары", "AZ", "31", "44", "", "", "", "41.4275", "48.4302", "Asia/Baku"),
("585221", "Quba", "Куба", "AZ", "31", "42", "", "", "", "41.36108", "48.51341", "Asia/Baku"),
("585225", "Haciqabul", "Кази-Магомед", "AZ", "31", "23", "", "", "", "40.03874", "48.94286", "Asia/Baku"),
("585226", "Qazax", "Казах", "AZ", "31", "40", "", "", "", "41.09246", "45.36561", "Asia/Baku"),
("585379", "Haci Zeynalabdin", "", "AZ", "31", "54", "", "", "", "40.62333", "49.55861", "Asia/Baku"),
("585514", "Mingelchaur", "Мингечаур", "AZ", "31", "33", "", "", "", "40.76395", "47.05953", "Asia/Baku"),
("585557", "Mastaga", "Маштага", "AZ", "31", "09", "", "", "", "40.52982", "50.00616", "Asia/Baku"),
("585568", "Mardakyany", "Мардакян", "AZ", "31", "09", "", "", "", "40.49182", "50.14292", "Asia/Baku"),
("585630", "Lokbatan", "Локбатан", "AZ", "31", "09", "", "", "", "40.3256", "49.73376", "Asia/Baku"),
("585763", "Kyurdarmir", "Кюрдамир", "AZ", "31", "27", "", "", "", "40.34532", "48.15085", "Asia/Baku"),
("585915", "Khirdalan", "Хырдалан", "AZ", "31", "01", "", "", "", "40.44808", "49.75502", "Asia/Baku"),
("586340", "Yeni Suraxani", "", "AZ", "31", "09", "", "", "", "40.43026", "50.03598", "Asia/Baku"),
("586427", "Geoktschai", "Геокчай", "AZ", "31", "22", "", "", "", "40.65056", "47.74219", "Asia/Baku"),
("586429", "Hovsan", "Говсан", "AZ", "31", "09", "", "", "", "40.37444", "50.08528", "Asia/Baku"),
("586523", "Ganja", "Гянджа", "AZ", "31", "20", "", "", "", "40.68278", "46.36056", "Asia/Baku"),
("586763", "Divichibazar", "Дивичи", "AZ", "31", "17", "", "", "", "41.20117", "48.98712", "Asia/Baku"),
("586925", "Buzovna", "Бузовна", "AZ", "31", "09", "", "", "", "40.51903", "50.11438", "Asia/Baku"),
("586968", "Biny Selo", "Бина", "AZ", "31", "09", "", "", "", "40.45076", "50.08686", "Asia/Baku"),
("587057", "Barda", "Барда", "AZ", "31", "11", "", "", "", "40.37577", "47.12619", "Asia/Baku"),
("587078", "Bilajari", "", "AZ", "31", "09", "", "", "", "40.4444", "49.80566", "Asia/Baku"),
("587084", "Baku", "Баку", "AZ", "31", "09", "", "", "", "40.37767", "49.89201", "Asia/Baku"),
("587261", "Amirdzhan", "", "AZ", "31", "09", "", "", "", "40.42639", "49.98361", "Asia/Baku"),
("587361", "Aghsu", "Ахсу", "AZ", "31", "06", "", "", "", "40.57028", "48.40087", "Asia/Baku"),
("587378", "Agdas", "Агдаш", "AZ", "31", "04", "", "", "", "40.64699", "47.4738", "Asia/Baku"),
("587384", "Agdzhabedy", "Агджабеди", "AZ", "31", "02", "", "", "", "40.05015", "47.45937", "Asia/Baku"),
("824003", "Bakixanov", "Бакиханова", "AZ", "31", "09", "", "", "", "40.41894", "49.96693", "Asia/Baku"),
("3186573", "Zenica", "Зеница", "BA", "70", "01", "", "", "", "44.20169", "17.90397", "Europe/Sarajevo"),
("3187609", "Visoko", "Високо", "BA", "70", "01", "", "", "", "43.98889", "18.17806", "Europe/Sarajevo"),
("3188225", "Velika Kladusa", "Велика-Кладуша", "BA", "70", "01", "", "", "", "45.18497", "15.80579", "Europe/Sarajevo"),
("3188582", "Tuzla", "Тузла", "BA", "70", "01", "", "", "", "44.53842", "18.66709", "Europe/Sarajevo"),
("3188893", "Trebinje", "Требинье", "BA", "70", "02", "", "", "", "42.71197", "18.34362", "Europe/Sarajevo"),
("3188924", "Travnik", "Травник", "BA", "70", "01", "", "", "", "44.22637", "17.66582", "Europe/Sarajevo"),
("3191281", "Sarajevo", "Сараево", "BA", "70", "01", "3343737", "", "", "43.84864", "18.35644", "Europe/Sarajevo"),
("3192409", "Prijedor", "Приедора", "BA", "70", "02", "", "", "", "44.97991", "16.71401", "Europe/Sarajevo"),
("3194828", "Mostar", "Мостар", "BA", "70", "01", "3343740", "", "", "43.34333", "17.80806", "Europe/Sarajevo"),
("3199744", "Gradacac", "", "BA", "70", "01", "", "", "", "44.87851", "18.42764", "Europe/Sarajevo"),
("3199779", "Gracanica", "", "BA", "70", "01", "", "", "", "44.70307", "18.3101", "Europe/Sarajevo"),
("3200396", "Gorazde", "Горажде", "BA", "70", "01", "", "", "", "43.66795", "18.97564", "Europe/Sarajevo"),
("3201984", "Doboj", "Добой", "BA", "70", "02", "", "", "", "44.73179", "18.08698", "Europe/Sarajevo"),
("3202822", "Cazin", "", "BA", "70", "01", "", "", "", "44.96694", "15.94306", "Europe/Sarajevo"),
("3203099", "Bugojno", "Бугойно", "BA", "70", "01", "", "", "", "44.05722", "17.45083", "Europe/Sarajevo"),
("3203521", "Brcko", "Брчко", "BA", "70", "BRC", "", "", "", "44.87278", "18.80833", "Europe/Sarajevo"),
("3203653", "Bosanska Krupa", "Босанска Крупа", "BA", "70", "01", "", "", "", "44.8825", "16.15139", "Europe/Sarajevo"),
("3204186", "Bijeljina", "Биелине", "BA", "70", "02", "", "", "", "44.75874", "19.21437", "Europe/Sarajevo"),
("3204222", "Bihac", "Бихач", "BA", "70", "01", "", "", "", "44.81694", "15.87083", "Europe/Sarajevo"),
("3204541", "Banja Luka", "Баня-Лука", "BA", "70", "02", "", "", "", "44.77583", "17.18556", "Europe/Sarajevo"),
("3337476", "Konjic", "", "BA", "70", "01", "", "", "", "43.65126", "17.96082", "Europe/Sarajevo"),
("3374036", "Bridgetown", "Бриджтаун", "BB", "52", "08", "", "", "", "13.1", "-59.61667", "America/Barbados"),
("1185092", "Thakurgaon", "", "BD", "50", "87", "", "", "", "26.03097", "88.46989", "Asia/Dhaka"),
("1185095", "Teknaf", "", "BD", "50", "84", "", "", "", "20.86382", "92.30153", "Asia/Dhaka"),
("1185098", "Tungi", "", "BD", "50", "81", "", "", "", "23.89154", "90.40232", "Asia/Dhaka"),
("1185099", "Sylhet", "Силхет", "BD", "50", "86", "", "", "", "24.89904", "91.87198", "Asia/Dhaka"),
("1185100", "Dohar", "", "BD", "50", "81", "", "", "", "23.59311", "90.14251", "Asia/Dhaka"),
("1185106", "Jamalpur", "", "BD", "50", "81", "", "", "", "24.91965", "89.94812", "Asia/Dhaka"),
("1185108", "Shibganj", "", "BD", "50", "83", "", "", "", "24.68501", "88.15638", "Asia/Dhaka"),
("1185111", "Satkhira", "", "BD", "50", "82", "", "", "", "22.70817", "89.07185", "Asia/Dhaka"),
("1185115", "Sirajganj", "Сираджгандж", "BD", "50", "83", "", "", "", "24.45771", "89.70802", "Asia/Dhaka"),
("1185116", "Netrakona", "", "BD", "50", "81", "", "", "", "24.88352", "90.72898", "Asia/Dhaka"),
("1185117", "Narsingdi", "", "BD", "50", "81", "", "", "", "23.92298", "90.71768", "Asia/Dhaka"),
("1185120", "Sandwip", "Сандвип", "BD", "50", "84", "", "", "", "22.51409", "91.45491", "Asia/Dhaka"),
("1185121", "Shahzadpur", "", "BD", "50", "83", "", "", "", "24.17687", "89.5988", "Asia/Dhaka"),
("1185127", "Ramganj", "", "BD", "50", "84", "", "", "", "23.1006", "90.84989", "Asia/Dhaka"),
("1185128", "Rajshahi", "Раджшахи", "BD", "50", "83", "", "", "", "24.374", "88.60114", "Asia/Dhaka"),
("1185138", "Pirojpur", "", "BD", "50", "85", "", "", "", "22.57965", "89.97521", "Asia/Dhaka"),
("1185141", "Panchagarh", "", "BD", "50", "87", "", "", "", "26.33338", "88.55777", "Asia/Dhaka"),
("1185148", "Patiya", "", "BD", "50", "84", "", "", "", "22.29543", "91.979", "Asia/Dhaka"),
("1185149", "Parbatipur", "", "BD", "50", "87", "", "", "", "25.66369", "88.93093", "Asia/Dhaka"),
("1185155", "Narayanganj", "", "BD", "50", "81", "", "", "", "23.61352", "90.50298", "Asia/Dhaka"),
("1185156", "Nalchiti", "", "BD", "50", "85", "", "", "", "22.63696", "90.27195", "Asia/Dhaka"),
("1185159", "Nagarpur", "", "BD", "50", "81", "", "", "", "24.05783", "89.87696", "Asia/Dhaka"),
("1185160", "Nageswari", "", "BD", "50", "87", "", "", "", "25.96817", "89.69153", "Asia/Dhaka"),
("1185162", "Mymensingh", "Майменсингх", "BD", "50", "81", "", "", "", "24.75636", "90.40646", "Asia/Dhaka"),
("1185164", "Muktagacha", "", "BD", "50", "81", "", "", "", "24.76484", "90.25698", "Asia/Dhaka"),
("1185165", "Mirzapur", "Мирзапур", "BD", "50", "81", "", "", "", "24.10287", "90.09841", "Asia/Dhaka"),
("1185166", "Maulavi Bazar", "", "BD", "50", "86", "", "", "", "24.48888", "91.77075", "Asia/Dhaka"),
("1185167", "Morrelgonj", "", "BD", "50", "82", "", "", "", "22.45566", "89.85584", "Asia/Dhaka"),
("1185171", "Mehendiganj", "", "BD", "50", "85", "", "", "", "22.82257", "90.52859", "Asia/Dhaka"),
("1185173", "Mathba", "", "BD", "50", "85", "", "", "", "22.28616", "89.95882", "Asia/Dhaka"),
("1185181", "Lalmanirhat", "", "BD", "50", "87", "", "", "", "25.91719", "89.44595", "Asia/Dhaka"),
("1185183", "Laksham", "", "BD", "50", "84", "", "", "", "23.24018", "91.12143", "Asia/Dhaka"),
("1185186", "Comilla", "Комилле", "BD", "50", "84", "", "", "", "23.46186", "91.18504", "Asia/Dhaka"),
("1185188", "Rangpur", "Рангпур", "BD", "50", "87", "", "", "", "25.74664", "89.25166", "Asia/Dhaka"),
("1185191", "Kushtia", "", "BD", "50", "82", "", "", "", "23.9028", "89.11943", "Asia/Dhaka"),
("1185199", "Kaliganj", "", "BD", "50", "82", "", "", "", "23.40964", "89.13801", "Asia/Dhaka"),
("1185204", "Jhingergacha", "", "BD", "50", "82", "", "", "", "23.11134", "89.09061", "Asia/Dhaka"),
("1185206", "Joypur Hat", "", "BD", "50", "83", "", "", "", "25.10147", "89.02734", "Asia/Dhaka"),
("1185207", "Ishurdi", "", "BD", "50", "83", "", "", "", "24.12858", "89.06573", "Asia/Dhaka"),
("1185209", "Habiganj", "", "BD", "50", "86", "", "", "", "24.38044", "91.413", "Asia/Dhaka"),
("1185210", "Gaurnadi", "", "BD", "50", "85", "", "", "", "22.97372", "90.22376", "Asia/Dhaka"),
("1185218", "Gafargaon", "", "BD", "50", "81", "", "", "", "24.432", "90.5585", "Asia/Dhaka"),
("1185224", "Feni", "", "BD", "50", "84", "", "", "", "23.01134", "91.4013", "Asia/Dhaka"),
("1185236", "Raipur", "Райпур", "BD", "50", "84", "", "", "", "23.0391", "90.76808", "Asia/Dhaka"),
("1185239", "Sarankhola", "", "BD", "50", "82", "", "", "", "22.31006", "89.79113", "Asia/Dhaka"),
("1185241", "Dhaka", "Дакка", "BD", "50", "81", "13", "", "", "23.7104", "90.40744", "Asia/Dhaka"),
("1185247", "Chilmari", "", "BD", "50", "87", "", "", "", "25.55613", "89.67097", "Asia/Dhaka"),
("1185249", "Chhagalnaiya", "", "BD", "50", "84", "", "", "", "23.02475", "91.51092", "Asia/Dhaka"),
("1185251", "Lalmohan", "", "BD", "50", "85", "", "", "", "22.33774", "90.73708", "Asia/Dhaka"),
("1185252", "Khagrachhari", "Кхаграчари", "BD", "50", "84", "", "", "", "23.10787", "91.97006", "Asia/Dhaka"),
("1185254", "Chhatak", "", "BD", "50", "86", "", "", "", "25.03858", "91.6815", "Asia/Dhaka"),
("1185260", "Bhatpara Abhaynagar", "", "BD", "50", "82", "", "", "", "23.01472", "89.43936", "Asia/Dhaka"),
("1185262", "Bheramara", "", "BD", "50", "82", "", "", "", "24.02452", "88.99234", "Asia/Dhaka"),
("1185263", "Bhairab Bazar", "", "BD", "50", "81", "", "", "", "24.0524", "90.9764", "Asia/Dhaka"),
("1185270", "Bandarban", "Бандарбан", "BD", "50", "84", "", "", "", "22.19534", "92.21946", "Asia/Dhaka"),
("1185272", "Kalia", "Калия", "BD", "50", "82", "", "", "", "23.043", "89.63094", "Asia/Dhaka"),
("1185274", "Baniachang", "", "BD", "50", "86", "", "", "", "24.51863", "91.35787", "Asia/Dhaka"),
("1185276", "Bajitpur", "", "BD", "50", "81", "", "", "", "24.21623", "90.95002", "Asia/Dhaka"),
("1185283", "Badarganj", "", "BD", "50", "87", "", "", "", "25.67419", "89.05377", "Asia/Dhaka"),
("1185293", "Narail", "", "BD", "50", "82", "", "", "", "23.15509", "89.49515", "Asia/Dhaka"),
("1185920", "Tungipara", "", "BD", "50", "81", "", "", "", "22.89983", "89.90326", "Asia/Dhaka"),
("1188569", "Sarishabari", "", "BD", "50", "81", "", "", "", "24.75127", "89.83126", "Asia/Dhaka"),
("1189056", "Sakhipur", "", "BD", "50", "81", "", "", "", "24.31988", "90.16943", "Asia/Dhaka"),
("1189638", "Raojan", "", "BD", "50", "84", "", "", "", "22.53511", "91.91919", "Asia/Dhaka"),
("1191139", "Phultala", "", "BD", "50", "82", "", "", "", "22.71673", "89.51194", "Asia/Dhaka"),
("1191368", "Palang", "", "BD", "50", "81", "", "", "", "23.21824", "90.35076", "Asia/Dhaka"),
("1192366", "Par Naogaon", "", "BD", "50", "83", "", "", "", "24.80418", "88.94875", "Asia/Dhaka"),
("1193823", "Nabinagar", "", "BD", "50", "84", "", "", "", "23.88791", "90.96792", "Asia/Dhaka"),
("1196292", "Lakshmipur", "", "BD", "50", "84", "", "", "", "22.9443", "90.83005", "Asia/Dhaka"),
("1197895", "Kesabpur", "", "BD", "50", "82", "", "", "", "22.90725", "89.21954", "Asia/Dhaka"),
("1201753", "Hajiganj", "", "BD", "50", "84", "", "", "", "23.25191", "90.85508", "Asia/Dhaka"),
("1203344", "Faridpur", "", "BD", "50", "81", "", "", "", "23.60612", "89.84064", "Asia/Dhaka"),
("1203891", "Dinajpur", "", "BD", "50", "87", "", "", "", "25.62745", "88.63779", "Asia/Dhaka"),
("1205481", "Uttar Char Fasson", "", "BD", "50", "82", "", "", "", "22.22647", "90.71275", "Asia/Dhaka"),
("1205733", "Chittagong", "Читтагонг", "BD", "50", "84", "Chittagong", "", "", "22.3384", "91.83168", "Asia/Dhaka"),
("1207047", "Char Bhadrasan", "", "BD", "50", "81", "", "", "", "23.30916", "90.22698", "Asia/Dhaka"),
("1209562", "Bera", "Беру", "BD", "50", "83", "", "", "", "24.07821", "89.63262", "Asia/Dhaka"),
("1210565", "Burhanuddin", "", "BD", "50", "85", "", "", "", "22.49518", "90.7239", "Asia/Dhaka"),
("1336133", "Satkania", "", "BD", "50", "84", "", "", "", "22.07639", "92.04955", "Asia/Dhaka"),
("1336134", "Cox's Bazar", "Кокс-Базар", "BD", "50", "84", "", "", "", "21.45388", "91.96765", "Asia/Dhaka"),
("1336135", "Khulna", "Кхулна", "BD", "50", "82", "", "", "", "22.80978", "89.56439", "Asia/Dhaka"),
("1336136", "Bhola", "Бхола", "BD", "50", "85", "", "", "", "22.68759", "90.64403", "Asia/Dhaka"),
("1336137", "Barisal", "Барисал", "BD", "50", "85", "", "", "", "22.70497", "90.37013", "Asia/Dhaka"),
("1336140", "Jessore", "", "BD", "50", "82", "", "", "", "23.16971", "89.21371", "Asia/Dhaka"),
("1336143", "Pabna", "Пабне", "BD", "50", "83", "", "", "", "24.00644", "89.2372", "Asia/Dhaka"),
("1336144", "Tangail", "", "BD", "50", "81", "", "", "", "24.24984", "89.91655", "Asia/Dhaka"),
("1337233", "Bogra", "Богра", "BD", "50", "83", "", "", "", "24.85098", "89.37108", "Asia/Dhaka"),
("1337239", "Pirgaaj", "", "BD", "50", "87", "", "", "", "25.85587", "88.35943", "Asia/Dhaka"),
("1337240", "Nawabganj", "", "BD", "50", "83", "", "", "", "24.59025", "88.27444", "Asia/Dhaka"),
("1337245", "Madaripur", "", "BD", "50", "81", "", "", "", "23.17097", "90.20935", "Asia/Dhaka"),
("1337248", "Sherpur", "", "BD", "50", "81", "", "", "", "25.01881", "90.01751", "Asia/Dhaka"),
("1337249", "Kishorganj", "", "BD", "50", "81", "", "", "", "24.43944", "90.78291", "Asia/Dhaka"),
("1462681", "Manikchari", "", "BD", "50", "84", "", "", "", "22.83957", "91.84128", "Asia/Dhaka"),
("1477498", "Bhandaria", "", "BD", "50", "85", "", "", "", "22.48898", "90.06273", "Asia/Dhaka"),
("6414184", "Fatikchari", "", "BD", "50", "84", "", "", "", "22.68768", "91.78123", "Asia/Dhaka"),
("6545349", "Saidpur", "", "BD", "50", "83", "", "", "", "25.77769", "88.89169", "Asia/Dhaka"),
("2783081", "Zwijndrecht", "", "BE", "56", "VLG", "VAN", "11", "11056", "51.21979", "4.32664", "Europe/Brussels"),
("2783089", "Zwevegem", "", "BE", "56", "VLG", "VWV", "34", "34042", "50.81268", "3.33848", "Europe/Brussels"),
("2783175", "Zottegem", "Зоттегем", "BE", "56", "VLG", "VOV", "41", "41081", "50.86956", "3.81052", "Europe/Brussels"),
("2783188", "Zonhoven", "", "BE", "56", "VLG", "VLI", "71", "71066", "50.99064", "5.36819", "Europe/Brussels"),
("2783204", "Zoersel", "", "BE", "56", "VLG", "VAN", "11", "11055", "51.26825", "4.71296", "Europe/Brussels"),
("2783274", "Zemst", "Земст", "BE", "56", "VLG", "VBR", "23", "23096", "50.98318", "4.46079", "Europe/Brussels"),
("2783293", "Zele", "Зеле", "BE", "56", "VLG", "VOV", "42", "42028", "51.06566", "4.0403", "Europe/Brussels"),
("2783308", "Zedelgem", "Зедельгем", "BE", "56", "VLG", "VWV", "31", "31040", "51.14236", "3.1368", "Europe/Brussels"),
("2783310", "Zaventem", "", "BE", "56", "VLG", "VBR", "23", "23094", "50.88365", "4.47298", "Europe/Brussels"),
("2783416", "Wuustwezel", "", "BE", "56", "VLG", "VAN", "11", "11053", "51.39214", "4.59546", "Europe/Brussels"),
("2783632", "Willebroek", "Виллебрук", "BE", "56", "VLG", "VAN", "12", "12040", "51.06041", "4.36019", "Europe/Brussels"),
("2783759", "Wevelgem", "Вевельгеме", "BE", "56", "VLG", "VWV", "34", "34041", "50.8", "3.16667", "Europe/Brussels"),
("2783763", "Wetteren", "Веттерен", "BE", "56", "VLG", "VOV", "42", "42025", "51.00526", "3.88341", "Europe/Brussels"),
("2783801", "Westerlo", "Вестерло", "BE", "56", "VLG", "VAN", "13", "13049", "51.09049", "4.91544", "Europe/Brussels"),
("2783820", "Wervik", "", "BE", "56", "VLG", "VWV", "33", "33029", "50.78069", "3.03854", "Europe/Brussels"),
("2783941", "Wavre", "Вавр", "BE", "56", "WAL", "WBR", "25", "25112", "50.71717", "4.60138", "Europe/Brussels"),
("2783985", "Waterloo", "Ватерлоо", "BE", "56", "WAL", "WBR", "25", "25110", "50.71469", "4.3991", "Europe/Brussels"),
("2784068", "Waregem", "Варегем", "BE", "56", "VLG", "VWV", "34", "34040", "50.88898", "3.42756", "Europe/Brussels"),
("2784189", "Walcourt", "Валькур", "BE", "56", "WAL", "WNA", "93", "93088", "50.25401", "4.43796", "Europe/Brussels"),
("2784548", "Vise", "", "BE", "56", "WAL", "WLG", "62", "62108", "50.7376", "5.69907", "Europe/Brussels"),
("2784604", "Vilvoorde", "Вилворде", "BE", "56", "VLG", "VBR", "23", "23088", "50.92814", "4.42938", "Europe/Brussels"),
("2784821", "Verviers", "Вервье", "BE", "56", "WAL", "WLG", "63", "63079", "50.58907", "5.86241", "Europe/Brussels"),
("2785141", "Turnhout", "Турнхоут", "BE", "56", "VLG", "VAN", "13", "13040", "51.32254", "4.94471", "Europe/Brussels"),
("2785169", "Tubize", "Тюбиз", "BE", "56", "WAL", "WBR", "25", "25105", "50.69059", "4.2009", "Europe/Brussels"),
("2785341", "Tournai", "Турне", "BE", "56", "WAL", "WHT", "57", "57081", "50.60715", "3.38932", "Europe/Brussels"),
("2785364", "Torhout", "Торхоут", "BE", "56", "VLG", "VWV", "31", "31033", "51.0656", "3.10085", "Europe/Brussels"),
("2785389", "Tongeren", "Тонгерен", "BE", "56", "VLG", "VLI", "73", "73083", "50.78054", "5.46484", "Europe/Brussels"),
("2785470", "Tienen", "Тинен", "BE", "56", "VLG", "VBR", "24", "24107", "50.80744", "4.9378", "Europe/Brussels"),
("2785476", "Tielt", "", "BE", "56", "VLG", "VWV", "37", "37015", "50.99931", "3.32707", "Europe/Brussels"),
("2785612", "Tessenderlo", "", "BE", "56", "VLG", "VLI", "71", "71057", "51.06513", "5.08856", "Europe/Brussels"),
("2785622", "Tervuren", "Тервюрен", "BE", "56", "VLG", "VBR", "24", "24104", "50.82372", "4.51418", "Europe/Brussels"),
("2785778", "Temse", "Темсе", "BE", "56", "VLG", "VOV", "46", "46025", "51.12794", "4.21372", "Europe/Brussels"),
("2786087", "Stekene", "", "BE", "56", "VLG", "VOV", "46", "46024", "51.2099", "4.0365", "Europe/Brussels"),
("2786229", "Stabroek", "", "BE", "56", "VLG", "VAN", "11", "11044", "51.33189", "4.37127", "Europe/Brussels"),
("2786344", "Soumagne", "Сумань", "BE", "56", "WAL", "WLG", "62", "62099", "50.61385", "5.74679", "Europe/Brussels"),
("2786420", "Soignies", "Суанье", "BE", "56", "WAL", "WHT", "55", "55040", "50.57904", "4.07129", "Europe/Brussels"),
("2786545", "Sint-Truiden", "Синт-Трюйден", "BE", "56", "VLG", "VLI", "71", "71053", "50.81679", "5.18647", "Europe/Brussels"),
("2786559", "Sint-Pieters-Leeuw", "", "BE", "56", "VLG", "VBR", "23", "23077", "50.77926", "4.24355", "Europe/Brussels"),
("2786578", "Sint-Niklaas", "Синт-Никлас", "BE", "56", "VLG", "VOV", "46", "46021", "51.16509", "4.1437", "Europe/Brussels"),
("2786634", "Sint-Kruis", "", "BE", "56", "VLG", "VWV", "", "", "51.21399", "3.24949", "Europe/Brussels"),
("2786641", "Sint-Katelijne-Waver", "", "BE", "56", "VLG", "VAN", "12", "12035", "51.06691", "4.53469", "Europe/Brussels"),
("2786694", "Sint-Gillis-Waas", "", "BE", "56", "VLG", "VOV", "46", "46020", "51.21914", "4.12374", "Europe/Brussels"),
("2786700", "Sint-Genesius-Rode", "", "BE", "56", "VLG", "VBR", "23", "23101", "50.74645", "4.35754", "Europe/Brussels"),
("2786824", "Seraing", "Серен", "BE", "56", "WAL", "WLG", "62", "62096", "50.58362", "5.50115", "Europe/Brussels"),
("2786963", "Schoten", "", "BE", "56", "VLG", "VAN", "11", "11040", "51.25251", "4.50268", "Europe/Brussels"),
("2787048", "Schilde", "Шильде", "BE", "56", "VLG", "VAN", "11", "11039", "51.24107", "4.58336", "Europe/Brussels"),
("2787356", "Saint-Nicolas", "Санкт-Никола", "BE", "56", "WAL", "WLG", "62", "62093", "50.62837", "5.53243", "Europe/Brussels"),
("2787416", "Saint-Ghislain", "Санкт-Гилене", "BE", "56", "WAL", "WHT", "53", "53070", "50.44816", "3.81886", "Europe/Brussels"),
("2787662", "Rotselaar", "", "BE", "56", "VLG", "VBR", "24", "24094", "50.95302", "4.71665", "Europe/Brussels"),
("2787769", "Ronse", "Ронсе", "BE", "56", "VLG", "VOV", "45", "45041", "50.74574", "3.6005", "Europe/Brussels"),
("2787889", "Roeselare", "Руселаре", "BE", "56", "VLG", "VWV", "36", "36015", "50.94653", "3.12269", "Europe/Brussels"),
("2787989", "Rixensart", "Риксенсарт", "BE", "56", "WAL", "WBR", "25", "25091", "50.71229", "4.52529", "Europe/Brussels"),
("2788088", "Riemst", "", "BE", "56", "VLG", "VLI", "73", "73066", "50.80995", "5.60131", "Europe/Brussels"),
("2788348", "Ranst", "", "BE", "56", "VLG", "VAN", "11", "11035", "51.18983", "4.56533", "Europe/Brussels"),
("2788499", "Quaregnon", "", "BE", "56", "WAL", "WHT", "53", "53065", "50.44067", "3.8653", "Europe/Brussels"),
("2788506", "Puurs", "", "BE", "56", "VLG", "VAN", "12", "12030", "51.07409", "4.28844", "Europe/Brussels"),
("2788521", "Putte", "", "BE", "56", "VLG", "VAN", "12", "12029", "51.05337", "4.63263", "Europe/Brussels"),
("2788726", "Poperinge", "Поперинге", "BE", "56", "VLG", "VWV", "33", "33021", "50.85386", "2.72659", "Europe/Brussels"),
("2788765", "Pont-a-Celles", "", "BE", "56", "WAL", "WHT", "52", "52055", "50.50518", "4.36887", "Europe/Brussels"),
("2789162", "Peruwelz", "Перювельз", "BE", "56", "WAL", "WHT", "57", "57064", "50.50819", "3.59373", "Europe/Brussels"),
("2789232", "Peer", "", "BE", "56", "VLG", "VLI", "72", "72030", "51.1303", "5.45952", "Europe/Brussels"),
("2789413", "Overijse", "Оверийсе", "BE", "56", "VLG", "VBR", "23", "23062", "50.77436", "4.53461", "Europe/Brussels"),
("2789471", "Oupeye", "Упе", "BE", "56", "WAL", "WLG", "62", "62079", "50.71184", "5.6468", "Europe/Brussels"),
("2789529", "Oudenaarde", "Оуденаарде", "BE", "56", "VLG", "VOV", "45", "45035", "50.85168", "3.60891", "Europe/Brussels"),
("2789751", "Oostkamp", "Осткамп", "BE", "56", "VLG", "VWV", "31", "31022", "51.15432", "3.23128", "Europe/Brussels"),
("2789786", "Oostende", "Остенде", "BE", "56", "VLG", "VWV", "35", "35013", "51.22339", "2.91185", "Europe/Brussels"),
("2790101", "Nivelles", "Нивель", "BE", "56", "WAL", "WBR", "25", "25072", "50.59833", "4.32848", "Europe/Brussels"),
("2790114", "Ninove", "Нинове", "BE", "56", "VLG", "VOV", "41", "41048", "50.82776", "4.02657", "Europe/Brussels"),
("2790135", "Nijlen", "", "BE", "56", "VLG", "VAN", "12", "12026", "51.16096", "4.67008", "Europe/Brussels"),
("2790357", "Neerpelt", "", "BE", "56", "VLG", "VLI", "72", "72025", "51.22807", "5.4427", "Europe/Brussels"),
("2790471", "Namur", "Намюр", "BE", "56", "WAL", "WNA", "92", "92094", "50.4669", "4.86746", "Europe/Brussels"),
("2790595", "Mouscron", "Мускрон", "BE", "56", "WAL", "WHT", "54", "54007", "50.74497", "3.20639", "Europe/Brussels"),
("2790676", "Mortsel", "Мортсел", "BE", "56", "VLG", "VAN", "11", "11029", "51.16697", "4.45127", "Europe/Brussels"),
("2790697", "Morlanwelz-Mariemont", "", "BE", "56", "WAL", "WHT", "56", "56087", "50.45502", "4.24519", "Europe/Brussels"),
("2790869", "Mons", "Монс", "BE", "56", "WAL", "WHT", "53", "53053", "50.45413", "3.95229", "Europe/Brussels"),
("2791067", "Mol", "Мол", "BE", "56", "VLG", "VAN", "13", "13025", "51.19188", "5.11662", "Europe/Brussels"),
("2791194", "Middelkerke", "", "BE", "56", "VLG", "VWV", "35", "35011", "51.18532", "2.82077", "Europe/Brussels"),
("2791315", "Merelbeke", "Мерелбеке", "BE", "56", "VLG", "VOV", "44", "44043", "50.99447", "3.74621", "Europe/Brussels"),
("2791343", "Menen", "Менен", "BE", "56", "VLG", "VWV", "34", "34027", "50.79722", "3.12245", "Europe/Brussels"),
("2791424", "Meise", "", "BE", "56", "VLG", "VBR", "23", "23050", "50.93934", "4.32655", "Europe/Brussels"),
("2791537", "Mechelen", "Мехелен", "BE", "56", "VLG", "VAN", "12", "12025", "51.02574", "4.47762", "Europe/Brussels"),
("2791744", "Marche-en-Famenne", "Марш-ан-Фамен", "BE", "56", "WAL", "WLX", "83", "83034", "50.22678", "5.34416", "Europe/Brussels"),
("2791814", "Manage", "", "BE", "56", "WAL", "WHT", "52", "52043", "50.50312", "4.23589", "Europe/Brussels"),
("2791857", "Maldegem", "Мальдегем", "BE", "56", "VLG", "VOV", "43", "43010", "51.20737", "3.44511", "Europe/Brussels"),
("2791961", "Maasmechelen", "Маасмехелене", "BE", "56", "VLG", "VLI", "73", "73107", "50.96545", "5.69452", "Europe/Brussels"),
("2791964", "Maaseik", "Маасейк", "BE", "56", "VLG", "VLI", "72", "72021", "51.09802", "5.78379", "Europe/Brussels"),
("2792073", "Louvain-la-Neuve", "Лувен-ла-Нев", "BE", "56", "WAL", "WBR", "25", "25121", "50.66829", "4.61443", "Europe/Brussels"),
("2792165", "Londerzeel", "", "BE", "56", "VLG", "VBR", "23", "23045", "51.00468", "4.30304", "Europe/Brussels"),
("2792179", "Lommel", "Ломмел", "BE", "56", "VLG", "VLI", "72", "72020", "51.23074", "5.31349", "Europe/Brussels"),
("2792196", "Lokeren", "Локерен", "BE", "56", "VLG", "VOV", "46", "46014", "51.10364", "3.99339", "Europe/Brussels"),
("2792235", "Lochristi", "", "BE", "56", "VLG", "VOV", "44", "44034", "51.09644", "3.83194", "Europe/Brussels"),
("2792360", "Lille", "", "BE", "56", "VLG", "VAN", "13", "13019", "51.24197", "4.82312", "Europe/Brussels"),
("2792397", "Lier", "Льер", "BE", "56", "VLG", "VAN", "12", "12021", "51.13128", "4.57042", "Europe/Brussels"),
("2792413", "Liege", "Льеж", "BE", "56", "WAL", "WLG", "62", "62063", "50.63373", "5.56749", "Europe/Brussels"),
("2792482", "Leuven", "Лёвен", "BE", "56", "VLG", "VBR", "24", "24062", "50.87959", "4.70093", "Europe/Brussels"),
("2792567", "Lessines", "Лессин", "BE", "56", "WAL", "WHT", "55", "55023", "50.71104", "3.83579", "Europe/Brussels"),
("2793077", "Lede", "", "BE", "56", "VLG", "VOV", "41", "41034", "50.96626", "3.98594", "Europe/Brussels"),
("2793144", "Lebbeke", "", "BE", "56", "VLG", "VOV", "42", "42011", "51.00464", "4.13457", "Europe/Brussels"),
("2793446", "Lanaken", "", "BE", "56", "VLG", "VLI", "73", "73042", "50.89318", "5.6468", "Europe/Brussels"),
("2793508", "La Louviere", "Ла-Лувьер", "BE", "56", "WAL", "WHT", "55", "55022", "50.48657", "4.18785", "Europe/Brussels"),
("2794055", "Kortrijk", "Кортрейк", "BE", "56", "VLG", "VWV", "34", "34022", "50.82803", "3.26487", "Europe/Brussels"),
("2794070", "Kortenberg", "", "BE", "56", "VLG", "VBR", "24", "24055", "50.88982", "4.54353", "Europe/Brussels"),
("2794117", "Kontich", "Контич", "BE", "56", "VLG", "VAN", "11", "11024", "51.13213", "4.44706", "Europe/Brussels"),
("2794166", "Koksijde", "Коксийде", "BE", "56", "VLG", "VWV", "38", "38014", "51.11642", "2.63772", "Europe/Brussels"),
("2794210", "Knokke-Heist", "Кнокке-Хейст", "BE", "56", "VLG", "VWV", "31", "31043", "51.35", "3.26667", "Europe/Brussels"),
("2794663", "Kasterlee", "", "BE", "56", "VLG", "VAN", "13", "13017", "51.24118", "4.96651", "Europe/Brussels"),
("2794730", "Kapellen", "Капеллене", "BE", "56", "VLG", "VAN", "11", "11023", "51.31377", "4.43539", "Europe/Brussels"),
("2794788", "Kalmthout", "", "BE", "56", "VLG", "VAN", "11", "11022", "51.38442", "4.47556", "Europe/Brussels"),
("2795009", "Izegem", "Изегем", "BE", "56", "VLG", "VWV", "36", "36008", "50.91396", "3.21378", "Europe/Brussels"),
("2795100", "Ieper", "Ипр", "BE", "56", "VLG", "VWV", "33", "33011", "50.85114", "2.88569", "Europe/Brussels"),
("2795113", "Huy", "Юи", "BE", "56", "WAL", "WLG", "61", "61031", "50.51894", "5.23284", "Europe/Brussels"),
("2795261", "Houthalen", "", "BE", "56", "VLG", "VLI", "72", "72039", "51.03427", "5.37429", "Europe/Brussels"),
("2795398", "Hoogstraten", "Хогстратен", "BE", "56", "VLG", "VAN", "13", "13014", "51.40029", "4.76034", "Europe/Brussels"),
("2795730", "Hoboken", "", "BE", "56", "VLG", "VAN", "11", "11002", "51.17611", "4.34844", "Europe/Brussels"),
("2795800", "Heusden", "", "BE", "56", "VLG", "VLI", "71", "71070", "51.03664", "5.28013", "Europe/Brussels"),
("2795908", "Herzele", "", "BE", "56", "VLG", "VOV", "41", "41027", "50.88681", "3.89014", "Europe/Brussels"),
("2795912", "Herve", "Эрв", "BE", "56", "WAL", "WLG", "63", "63035", "50.64083", "5.79353", "Europe/Brussels"),
("2795930", "Herstal", "Эрсталь", "BE", "56", "WAL", "WLG", "62", "62051", "50.66415", "5.62346", "Europe/Brussels"),
("2796009", "Herentals", "Херенталс", "BE", "56", "VLG", "VAN", "13", "13011", "51.17655", "4.83248", "Europe/Brussels"),
("2796012", "Herent", "", "BE", "56", "VLG", "VBR", "24", "24038", "50.90861", "4.67056", "Europe/Brussels"),
("2796132", "Helchteren", "", "BE", "56", "VLG", "VLI", "72", "72039", "51.05591", "5.38244", "Europe/Brussels"),
("2796153", "Heist-op-den-Berg", "", "BE", "56", "VLG", "VAN", "12", "12014", "51.07537", "4.72827", "Europe/Brussels"),
("2796491", "Hasselt", "Хасселт", "BE", "56", "VLG", "VLI", "71", "71022", "50.93106", "5.33781", "Europe/Brussels"),
("2796542", "Harelbeke", "Харелбеке", "BE", "56", "VLG", "VWV", "34", "34013", "50.85343", "3.30935", "Europe/Brussels"),
("2796637", "Hamme", "Хамме", "BE", "56", "VLG", "VOV", "42", "42008", "51.09822", "4.13705", "Europe/Brussels"),
("2796696", "Halle", "Галле", "BE", "56", "VLG", "VBR", "23", "23027", "50.73385", "4.23454", "Europe/Brussels"),
("2796833", "Haaltert", "", "BE", "56", "VLG", "VOV", "41", "41024", "50.90634", "4.00093", "Europe/Brussels"),
("2797114", "Grimbergen", "Гримберген", "BE", "56", "VLG", "VBR", "23", "23025", "50.93409", "4.37213", "Europe/Brussels"),
("2797638", "Geraardsbergen", "Герардсберген", "BE", "56", "VLG", "VOV", "41", "41018", "50.77343", "3.88223", "Europe/Brussels"),
("2797656", "Gent", "Гент", "BE", "56", "VLG", "VOV", "44", "44021", "51.05", "3.71667", "Europe/Brussels"),
("2797670", "Genk", "Генк", "BE", "56", "VLG", "VLI", "71", "71016", "50.965", "5.50082", "Europe/Brussels"),
("2797713", "Gembloux", "Гемблуа", "BE", "56", "WAL", "WNA", "92", "92142", "50.56149", "4.69889", "Europe/Brussels"),
("2797779", "Geel", "Геел", "BE", "56", "VLG", "VAN", "13", "13008", "51.16557", "4.98917", "Europe/Brussels"),
("2798023", "Frameries", "Фрамерис", "BE", "56", "WAL", "WHT", "53", "53028", "50.40578", "3.89603", "Europe/Brussels"),
("2798297", "Fleurus", "Флерус", "BE", "56", "WAL", "WHT", "52", "52021", "50.48351", "4.55006", "Europe/Brussels"),
("2798301", "Fleron", "Флерон", "BE", "56", "WAL", "WLG", "62", "62038", "50.61516", "5.68062", "Europe/Brussels"),
("2798307", "Flemalle-Haute", "", "BE", "56", "WAL", "WLG", "62", "62120", "50.59994", "5.44471", "Europe/Brussels"),
("2798551", "Evergem", "Эвергем", "BE", "56", "VLG", "VOV", "44", "44019", "51.1053", "3.704", "Europe/Brussels"),
("2798573", "Eupen", "Эйпен", "BE", "56", "WAL", "WLG", "63", "63023", "50.6279", "6.03647", "Europe/Brussels"),
("2798615", "Essen", "", "BE", "56", "VLG", "VAN", "11", "11016", "51.46272", "4.45393", "Europe/Brussels"),
("2798987", "Eeklo", "Экло", "BE", "56", "VLG", "VOV", "43", "43005", "51.18703", "3.55654", "Europe/Brussels"),
("2799007", "Edegem", "", "BE", "56", "VLG", "VAN", "11", "11013", "51.15662", "4.44504", "Europe/Brussels"),
("2799090", "Duffel", "", "BE", "56", "VLG", "VAN", "12", "12009", "51.09554", "4.50903", "Europe/Brussels"),
("2799226", "Dour", "", "BE", "56", "WAL", "WHT", "53", "53020", "50.39583", "3.77792", "Europe/Brussels"),
("2799365", "Dilbeek", "Дилбек", "BE", "56", "VLG", "VBR", "23", "23016", "50.84799", "4.25972", "Europe/Brussels"),
("2799369", "Diksmuide", "", "BE", "56", "VLG", "VWV", "32", "32003", "51.03248", "2.86384", "Europe/Brussels"),
("2799397", "Diest", "", "BE", "56", "VLG", "VBR", "24", "24020", "50.98923", "5.05062", "Europe/Brussels"),
("2799412", "Diepenbeek", "", "BE", "56", "VLG", "VLI", "71", "71011", "50.90769", "5.41875", "Europe/Brussels"),
("2799496", "Destelbergen", "", "BE", "56", "VLG", "VOV", "44", "44013", "51.05952", "3.79899", "Europe/Brussels"),
("2799645", "Dendermonde", "Дендермонде", "BE", "56", "VLG", "VOV", "42", "42006", "51.02869", "4.10106", "Europe/Brussels"),
("2799647", "Denderleeuw", "", "BE", "56", "VLG", "VOV", "41", "41011", "50.88506", "4.07601", "Europe/Brussels"),
("2799746", "Deinze", "Дейнзе", "BE", "56", "VLG", "VOV", "44", "44011", "50.98175", "3.53096", "Europe/Brussels"),
("2800063", "Courcelles", "Курсель", "BE", "56", "WAL", "WHT", "52", "52015", "50.46379", "4.3747", "Europe/Brussels"),
("2800220", "Colfontaine", "", "BE", "56", "WAL", "WHT", "53", "53082", "50.4141", "3.85569", "Europe/Brussels"),
("2800438", "Chaudfontaine", "", "BE", "56", "WAL", "WLG", "62", "62022", "50.5828", "5.6341", "Europe/Brussels"),
("2800448", "Chatelet", "Шатле", "BE", "56", "WAL", "WHT", "52", "52012", "50.40338", "4.52826", "Europe/Brussels"),
("2800461", "Chasse Royale", "", "BE", "56", "WAL", "WHT", "", "", "50.42842", "3.95001", "Europe/Brussels"),
("2800481", "Charleroi", "Шарлеруа", "BE", "56", "WAL", "WHT", "52", "52011", "50.41136", "4.44448", "Europe/Brussels"),
("2800866", "Brussels", "Брюссель", "BE", "56", "BRU", "BRU", "21", "21004", "50.85045", "4.34878", "Europe/Brussels"),
("2800931", "Brugge", "Брюгге", "BE", "56", "VLG", "VWV", "31", "31005", "51.20892", "3.22424", "Europe/Brussels"),
("2801106", "Brecht", "Брехт", "BE", "56", "VLG", "VAN", "11", "11009", "51.35024", "4.63829", "Europe/Brussels"),
("2801117", "Brasschaat", "Брасхат", "BE", "56", "VLG", "VAN", "11", "11008", "51.2912", "4.49182", "Europe/Brussels"),
("2801150", "Braine-le-Comte", "Брем-ле-Конт", "BE", "56", "WAL", "WHT", "55", "55004", "50.60979", "4.14658", "Europe/Brussels"),
("2801154", "Braine-l'Alleud", "Брен-л'Аллё", "BE", "56", "WAL", "WBR", "25", "25014", "50.68363", "4.36784", "Europe/Brussels"),
("2801226", "Boussu", "Боуссу", "BE", "56", "WAL", "WHT", "53", "53014", "50.43417", "3.7944", "Europe/Brussels"),
("2801447", "Bornem", "", "BE", "56", "VLG", "VAN", "12", "12007", "51.09716", "4.24364", "Europe/Brussels"),
("2801494", "Boom", "", "BE", "56", "VLG", "VAN", "11", "11005", "51.09242", "4.3717", "Europe/Brussels"),
("2801858", "Blankenberge", "Бланкенберге", "BE", "56", "VLG", "VWV", "31", "31004", "51.31306", "3.13227", "Europe/Brussels"),
("2801922", "Binche", "Бенш", "BE", "56", "WAL", "WHT", "56", "56011", "50.41155", "4.16469", "Europe/Brussels"),
("2801924", "Bilzen", "Билзен", "BE", "56", "VLG", "VLI", "73", "73006", "50.87325", "5.5184", "Europe/Brussels"),
("2802031", "Beveren", "Беверен", "BE", "56", "VLG", "VOV", "46", "46003", "51.21187", "4.25633", "Europe/Brussels"),
("2802170", "Beringen", "Берингене", "BE", "56", "VLG", "VLI", "71", "71004", "51.04954", "5.22606", "Europe/Brussels"),
("2802433", "Beersel", "Берсел", "BE", "56", "VLG", "VBR", "23", "23003", "50.76589", "4.3002", "Europe/Brussels"),
("2802435", "Beerse", "", "BE", "56", "VLG", "VAN", "13", "13004", "51.31927", "4.85304", "Europe/Brussels"),
("2802743", "Balen", "", "BE", "56", "VLG", "VAN", "13", "13003", "51.16837", "5.17027", "Europe/Brussels"),
("2803010", "Ath", "Ат", "BE", "56", "WAL", "WHT", "51", "51004", "50.62937", "3.77801", "Europe/Brussels"),
("2803033", "Asse", "Ассо", "BE", "56", "VLG", "VBR", "23", "23002", "50.91011", "4.19836", "Europe/Brussels"),
("2803073", "Arlon", "Арлон", "BE", "56", "WAL", "WLX", "81", "81001", "49.68333", "5.81667", "Europe/Brussels"),
("2803138", "Antwerpen", "Антверпен", "BE", "56", "VLG", "VAN", "11", "11002", "51.21989", "4.40346", "Europe/Brussels"),
("2803160", "Ans", "Анс", "BE", "56", "WAL", "WLG", "62", "62003", "50.6623", "5.52029", "Europe/Brussels"),
("2803204", "Andenne", "Анден", "BE", "56", "WAL", "WNA", "92", "92003", "50.48941", "5.09513", "Europe/Brussels"),
("2803429", "Aarschot", "Ааршот", "BE", "56", "VLG", "VBR", "24", "24001", "50.98715", "4.83695", "Europe/Brussels"),
("2803443", "Aalter", "Алтер", "BE", "56", "VLG", "VOV", "44", "44001", "51.09017", "3.44693", "Europe/Brussels"),
("2803448", "Aalst", "", "BE", "56", "VLG", "VOV", "41", "41002", "50.93604", "4.0355", "Europe/Brussels"),
("2353197", "Zorgo", "", "BF", "854", "11", "20", "", "", "12.24922", "-0.61527", "Africa/Ouagadougou"),
("2353688", "Yako", "Яко", "BF", "854", "10", "34", "", "", "12.9591", "-2.26075", "Africa/Ouagadougou"),
("2354176", "Tougan", "", "BF", "854", "01", "73", "", "", "13.0725", "-3.0694", "Africa/Ouagadougou"),
("2354349", "Titao", "", "BF", "854", "10", "62", "", "", "13.76667", "-2.06667", "Africa/Ouagadougou"),
("2354675", "Tenkodogo", "", "BF", "854", "04", "49", "", "", "11.78", "-0.36972", "Africa/Ouagadougou"),
("2356228", "Reo", "Рео", "BF", "854", "06", "36", "", "", "12.31963", "-2.47094", "Africa/Ouagadougou"),
("2356454", "Po", "", "BF", "854", "07", "65", "", "", "11.16972", "-1.145", "Africa/Ouagadougou"),
("2357043", "Ouahigouya", "", "BF", "854", "10", "76", "", "", "13.58278", "-2.42158", "Africa/Ouagadougou"),
("2357048", "Ouagadougou", "Уагадугу", "BF", "854", "03", "53", "", "", "12.36566", "-1.53388", "Africa/Ouagadougou"),
("2357163", "Nouna", "", "BF", "854", "01", "58", "", "", "12.72938", "-3.86305", "Africa/Ouagadougou"),
("2358100", "Manga", "", "BF", "854", "07", "44", "", "", "11.66361", "-1.07306", "Africa/Ouagadougou"),
("2358382", "Leo", "Лев", "BF", "854", "06", "72", "", "", "11.10033", "-2.10654", "Africa/Ouagadougou"),
("2358738", "Koupela", "", "BF", "854", "04", "28", "", "", "12.17864", "-0.35103", "Africa/Ouagadougou"),
("2358946", "Koudougou", "Кудугу", "BF", "854", "06", "19", "", "", "12.25263", "-2.36272", "Africa/Ouagadougou"),
("2359142", "Kongoussi", "", "BF", "854", "05", "15", "", "", "13.32583", "-1.53472", "Africa/Ouagadougou"),
("2359227", "Kombissiri", "", "BF", "854", "07", "47", "", "", "12.06095", "-1.33355", "Africa/Ouagadougou"),
("2359317", "Kokologo", "", "BF", "854", "06", "19", "", "", "12.18972", "-1.88556", "Africa/Ouagadougou"),
("2359608", "Kaya", "Кая", "BF", "854", "05", "70", "", "", "13.09167", "-1.08444", "Africa/Ouagadougou"),
("2360073", "Hounde", "", "BF", "854", "09", "74", "", "", "11.5", "-3.51667", "Africa/Ouagadougou"),
("2360238", "Gourcy", "", "BF", "854", "10", "78", "", "", "13.20776", "-2.35893", "Africa/Ouagadougou"),
("2360615", "Garango", "", "BF", "854", "04", "49", "", "", "11.8", "-0.55056", "Africa/Ouagadougou"),
("2360886", "Fada N'gourma", "", "BF", "854", "08", "50", "", "", "12.06157", "0.35843", "Africa/Ouagadougou"),
("2361082", "Dori", "Дори", "BF", "854", "12", "71", "", "", "14.0354", "-0.0345", "Africa/Ouagadougou"),
("2361177", "Djibo", "Джибо", "BF", "854", "12", "40", "", "", "14.0994", "-1.62554", "Africa/Ouagadougou"),
("2361373", "Diapaga", "Диапага", "BF", "854", "08", "42", "", "", "12.07305", "1.78838", "Africa/Ouagadougou"),
("2361477", "Dedougou", "", "BF", "854", "01", "63", "", "", "12.46338", "-3.46075", "Africa/Ouagadougou"),
("2361845", "Bousse", "", "BF", "854", "11", "60", "", "", "12.6576", "-1.89288", "Africa/Ouagadougou"),
("2361946", "Boulsa", "", "BF", "854", "05", "64", "", "", "12.66664", "-0.57468", "Africa/Ouagadougou"),
("2362344", "Bobo-Dioulasso", "Бобо-Диуласо", "BF", "854", "09", "51", "", "", "11.17715", "-4.2979", "Africa/Ouagadougou"),
("2362909", "Banfora", "Банфору", "BF", "854", "02", "55", "", "", "10.63333", "-4.76667", "Africa/Ouagadougou"),
("2577162", "Gaoua", "", "BF", "854", "13", "69", "", "", "10.29917", "-3.25083", "Africa/Ouagadougou"),
("2577164", "Orodara", "", "BF", "854", "09", "54", "", "", "10.94917", "-4.93417", "Africa/Ouagadougou"),
("725578", "Yambol", "", "BG", "100", "65", "JAM26", "", "", "42.48333", "26.5", "Europe/Sofia"),
("725712", "Vratsa", "Враца", "BG", "100", "64", "VRC10", "", "", "43.21", "23.5625", "Europe/Sofia"),
("725905", "Vidin", "Видин", "BG", "100", "63", "VID09", "", "", "43.99", "22.8725", "Europe/Sofia"),
("725988", "Velingrad", "Велинград", "BG", "100", "48", "PAZ08", "", "", "42.02754", "23.99155", "Europe/Sofia"),
("725993", "Veliko Turnovo", "", "BG", "100", "62", "VTR04", "", "", "43.08124", "25.62904", "Europe/Sofia"),
("726050", "Varna", "Варна", "BG", "100", "61", "VAR06", "", "", "43.21667", "27.91667", "Europe/Sofia"),
("726174", "Targovishte", "", "BG", "100", "60", "TGV35", "", "", "43.2512", "26.57215", "Europe/Sofia"),
("726320", "Troyan", "", "BG", "100", "46", "LOV34", "", "", "42.89427", "24.71589", "Europe/Sofia"),
("726418", "Dobrich", "Добрич", "BG", "100", "40", "DOB28", "", "", "43.56667", "27.83333", "Europe/Sofia"),
("726534", "Svishtov", "", "BG", "100", "62", "VTR28", "", "", "43.61959", "25.35044", "Europe/Sofia"),
("726546", "Svilengrad", "Свиленград", "BG", "100", "43", "HKV28", "", "", "41.76667", "26.2", "Europe/Sofia"),
("726848", "Stara Zagora", "Стара-Загора", "BG", "100", "59", "SZR31", "", "", "42.43278", "25.64194", "Europe/Sofia"),
("726872", "Dupnitsa", "", "BG", "100", "45", "KNL48", "", "", "42.26667", "23.11667", "Europe/Sofia"),
("727011", "Sofia", "София", "BG", "100", "42", "SOF46", "", "", "42.69751", "23.32415", "Europe/Sofia"),
("727030", "Smolyan", "", "BG", "100", "57", "SML31", "", "", "41.58528", "24.69194", "Europe/Sofia"),
("727079", "Sliven", "Сливен", "BG", "100", "56", "SLV20", "", "", "42.68583", "26.32917", "Europe/Sofia"),
("727221", "Silistra", "Силистра", "BG", "100", "55", "SLS31", "", "", "44.11667", "27.26667", "Europe/Sofia"),
("727233", "Shumen", "", "BG", "100", "54", "SHU30", "", "", "43.27064", "26.92286", "Europe/Sofia"),
("727337", "Sevlievo", "", "BG", "100", "41", "GAB29", "", "", "43.02583", "25.11361", "Europe/Sofia"),
("727447", "Sandanski", "", "BG", "100", "38", "BLG40", "", "", "41.56667", "23.28333", "Europe/Sofia"),
("727462", "Samokov", "", "BG", "100", "58", "SFO39", "", "", "42.337", "23.5528", "Europe/Sofia"),
("727523", "Ruse", "Русе", "BG", "100", "53", "RSE27", "", "", "43.85639", "25.97083", "Europe/Sofia"),
("727696", "Razgrad", "Разград", "BG", "100", "52", "RAZ26", "", "", "43.53333", "26.51667", "Europe/Sofia"),
("727791", "Rakovski", "", "BG", "100", "51", "PDV25", "", "", "42.3", "24.96667", "Europe/Sofia"),
("728075", "Popovo", "", "BG", "100", "60", "TGV24", "", "", "43.35", "26.23333", "Europe/Sofia"),
("728193", "Plovdiv", "Пловдив", "BG", "100", "51", "PDV22", "", "", "42.15", "24.75", "Europe/Sofia"),
("728203", "Pleven", "Плевен", "BG", "100", "50", "PVN24", "", "", "43.41667", "24.61667", "Europe/Sofia"),
("728288", "Petrich", "Петрич", "BG", "100", "38", "BLG33", "", "", "41.4", "23.21667", "Europe/Sofia"),
("728317", "Peshtera", "", "BG", "100", "48", "PAZ21", "", "", "42.03333", "24.3", "Europe/Sofia"),
("728330", "Pernik", "Перник", "BG", "100", "49", "PER32", "", "", "42.6", "23.03333", "Europe/Sofia"),
("728378", "Pazardzhik", "Пазарджик", "BG", "100", "48", "PAZ19", "", "", "42.2", "24.33333", "Europe/Sofia"),
("728448", "Panagyurishte", "", "BG", "100", "48", "PAZ20", "", "", "42.5", "24.18333", "Europe/Sofia"),
("728742", "Nova Zagora", "", "BG", "100", "56", "SLV16", "", "", "42.48333", "26.01667", "Europe/Sofia"),
("729114", "Montana", "Монтана", "BG", "100", "47", "MON29", "", "", "43.4125", "23.225", "Europe/Sofia"),
("729559", "Lovech", "Ловеч", "BG", "100", "46", "LOV18", "", "", "43.13333", "24.71667", "Europe/Sofia"),
("729581", "Lom", "", "BG", "100", "47", "MON24", "", "", "43.81389", "23.23611", "Europe/Sofia"),
("729730", "Kyustendil", "", "BG", "100", "45", "KNL29", "", "", "42.28389", "22.69111", "Europe/Sofia"),
("729794", "Kurdzhali", "Кырджали", "BG", "100", "44", "KRZ16", "", "", "41.65", "25.36667", "Europe/Sofia"),
("730435", "Haskovo", "Хасково", "BG", "100", "43", "HKV34", "", "", "41.93415", "25.55557", "Europe/Sofia"),
("730442", "Kharmanli", "", "BG", "100", "43", "HKV33", "", "", "41.93333", "25.9", "Europe/Sofia"),
("730496", "Kazanluk", "Казанлык", "BG", "100", "59", "SZR12", "", "", "42.61667", "25.4", "Europe/Sofia"),
("730559", "Karnobat", "", "BG", "100", "39", "BGS09", "", "", "42.65", "26.98333", "Europe/Sofia"),
("730565", "Karlovo", "Карлово", "BG", "100", "51", "PDV13", "", "", "42.63333", "24.8", "Europe/Sofia"),
("731108", "Gotse Delchev", "Гоце-Делчев", "BG", "100", "38", "BLG11", "", "", "41.56667", "23.73333", "Europe/Sofia"),
("731233", "Gorna Oryakhovitsa", "Горна Оряховица", "BG", "100", "62", "VTR06", "", "", "43.12778", "25.70167", "Europe/Sofia"),
("731549", "Gabrovo", "Габрово", "BG", "100", "41", "GAB05", "", "", "42.87472", "25.33417", "Europe/Sofia"),
("732263", "Dimitrovgrad", "Димитровград", "BG", "100", "43", "HKV09", "", "", "42.05", "25.6", "Europe/Sofia"),
("732452", "Chirpan", "", "BG", "100", "59", "SZR36", "", "", "42.2", "25.33333", "Europe/Sofia"),
("732491", "Cherven Bryag", "", "BG", "100", "50", "PVN37", "", "", "43.26667", "24.1", "Europe/Sofia"),
("732770", "Burgas", "Бургас", "BG", "100", "39", "BGS04", "", "", "42.50606", "27.46781", "Europe/Sofia"),
("733014", "Botevgrad", "", "BG", "100", "58", "SFO07", "", "", "42.9", "23.78333", "Europe/Sofia"),
("733191", "Blagoevgrad", "Благоевград", "BG", "100", "38", "BLG03", "", "", "42.01667", "23.1", "Europe/Sofia"),
("733264", "Berkovitsa", "", "BG", "100", "47", "MON02", "", "", "43.23611", "23.12583", "Europe/Sofia"),
("733579", "Aytos", "", "BG", "100", "39", "BGS01", "", "", "42.7", "27.25", "Europe/Sofia"),
("733618", "Asenovgrad", "", "BG", "100", "51", "PDV01", "", "", "42.01667", "24.86667", "Europe/Sofia"),
("422232", "Makamba", "Макамба", "BI", "108", "17", "", "", "", "-4.1348", "29.804", "Africa/Bujumbura"),
("423328", "Bururi", "Бурури", "BI", "108", "10", "", "", "", "-3.94877", "29.62438", "Africa/Bujumbura"),
("425378", "Bujumbura", "Бужумбура", "BI", "108", "24", "", "", "", "-3.3822", "29.3644", "Africa/Bujumbura"),
("425551", "Muramvya", "", "BI", "108", "22", "", "", "", "-3.2682", "29.6079", "Africa/Bujumbura"),
("426272", "Gitega", "Гитеге", "BI", "108", "13", "", "", "", "-3.4264", "29.9308", "Africa/Bujumbura"),
("426700", "Ruyigi", "Руйиги", "BI", "108", "21", "", "", "", "-3.47639", "30.24861", "Africa/Bujumbura"),
("430569", "Ngozi", "Нгози", "BI", "108", "19", "", "", "", "-2.9075", "29.8306", "Africa/Bujumbura"),
("430952", "Kayanza", "", "BI", "108", "15", "", "", "", "-2.9221", "29.6293", "Africa/Bujumbura"),
("431748", "Muyinga", "Муйинга", "BI", "108", "18", "", "", "", "-2.8451", "30.3414", "Africa/Bujumbura"),
("433635", "Rutana", "Рутана", "BI", "108", "20", "", "", "", "-3.9279", "29.992", "Africa/Bujumbura"),
("2391377", "Tchaourou", "", "BJ", "204", "10", "", "", "", "8.88649", "2.59752", "Africa/Porto-Novo"),
("2391455", "Tanguieta", "", "BJ", "204", "08", "", "", "", "10.62118", "1.26651", "Africa/Porto-Novo"),
("2391893", "Save", "", "BJ", "204", "11", "", "", "", "8.03424", "2.4866", "Africa/Porto-Novo"),
("2391895", "Savalou", "", "BJ", "204", "11", "", "", "", "7.92807", "1.97558", "Africa/Porto-Novo"),
("2392009", "Sakete", "", "BJ", "204", "17", "", "", "", "6.73618", "2.65866", "Africa/Porto-Novo"),
("2392087", "Porto-Novo", "Порто-Ново", "BJ", "204", "16", "", "", "", "6.49646", "2.60359", "Africa/Porto-Novo"),
("2392108", "Pobe", "", "BJ", "204", "17", "", "", "", "6.98008", "2.6649", "Africa/Porto-Novo"),
("2392204", "Parakou", "Параку", "BJ", "204", "10", "", "", "", "9.33716", "2.63031", "Africa/Porto-Novo"),
("2392308", "Ouidah", "Виды", "BJ", "204", "09", "", "", "", "6.36307", "2.08506", "Africa/Porto-Novo"),
("2392505", "Nikki", "Никки", "BJ", "204", "10", "", "", "", "9.94009", "3.21075", "Africa/Porto-Novo"),
("2392601", "Natitingou", "Натитингу", "BJ", "204", "08", "", "", "", "10.30416", "1.37962", "Africa/Porto-Novo"),
("2392837", "Malanville", "Маланвилем", "BJ", "204", "08", "", "", "", "11.86819", "3.38327", "Africa/Porto-Novo"),
("2392897", "Lokossa", "", "BJ", "204", "15", "", "", "", "6.63869", "1.71674", "Africa/Porto-Novo"),
("2393551", "Ketou", "", "BJ", "204", "17", "", "", "", "7.36332", "2.59978", "Africa/Porto-Novo"),
("2393693", "Kandi", "Канди", "BJ", "204", "07", "", "", "", "11.13417", "2.93861", "Africa/Porto-Novo"),
("2394545", "Dogbo", "", "BJ", "204", "12", "", "", "", "6.81667", "1.78333", "Africa/Porto-Novo"),
("2394560", "Djougou", "", "BJ", "204", "13", "", "", "", "9.70853", "1.66598", "Africa/Porto-Novo"),
("2394711", "Dassa-Zoume", "", "BJ", "204", "11", "", "", "", "7.75", "2.18333", "Africa/Porto-Novo"),
("2394814", "Cove", "", "BJ", "204", "18", "", "", "", "7.22097", "2.34017", "Africa/Porto-Novo"),
("2394819", "Cotonou", "Котону", "BJ", "204", "14", "", "", "", "6.36536", "2.41833", "Africa/Porto-Novo"),
("2394824", "Come", "", "BJ", "204", "15", "", "", "", "6.40764", "1.88198", "Africa/Porto-Novo"),
("2395049", "Bohicon", "", "BJ", "204", "18", "", "", "", "7.17826", "2.0667", "Africa/Porto-Novo"),
("2395182", "Bembereke", "", "BJ", "204", "10", "", "", "", "10.22827", "2.66335", "Africa/Porto-Novo"),
("2395261", "Bassila", "", "BJ", "204", "13", "", "", "", "9.00814", "1.6654", "Africa/Porto-Novo"),
("2395317", "Banikoara", "", "BJ", "204", "07", "", "", "", "11.29845", "2.43856", "Africa/Porto-Novo"),
("2395568", "Aplahoue", "", "BJ", "204", "12", "", "", "", "6.93333", "1.68333", "Africa/Porto-Novo"),
("2395635", "Allada", "", "BJ", "204", "09", "", "", "", "6.66547", "2.15138", "Africa/Porto-Novo"),
("2395914", "Abomey-Calavi", "Абомей-Калави", "BJ", "204", "09", "", "", "", "6.44852", "2.35566", "Africa/Porto-Novo"),
("2395915", "Abomey", "Абомей", "BJ", "204", "18", "", "", "", "7.18286", "1.99119", "Africa/Porto-Novo"),
("3901178", "Yacuiba", "Якуиба", "BO", "68", "09", "", "", "", "-22.03799", "-63.67968", "America/La_Paz"),
("3901301", "Warnes", "", "BO", "68", "08", "", "", "", "-17.5", "-63.16667", "America/La_Paz"),
("3901501", "Villazon", "Вильясон", "BO", "68", "07", "", "", "", "-22.08659", "-65.59422", "America/La_Paz"),
("3901504", "Villa Yapacani", "", "BO", "68", "08", "", "", "", "-17.4", "-63.83333", "America/La_Paz"),
("3901547", "Villamontes", "Вилья-Монтес", "BO", "68", "09", "", "", "", "-21.26236", "-63.46903", "America/La_Paz"),
("3902202", "Tupiza", "", "BO", "68", "07", "", "", "", "-21.44344", "-65.71875", "America/La_Paz"),
("3902377", "Trinidad", "Тринидад", "BO", "68", "03", "", "", "", "-14.83333", "-64.9", "America/La_Paz"),
("3903320", "Tarija", "Тариха", "BO", "68", "09", "", "", "", "-21.53549", "-64.72956", "America/La_Paz"),
("3903987", "Sucre", "Сукре", "BO", "68", "01", "", "", "", "-19.03332", "-65.26274", "America/La_Paz"),
("3904666", "Santiago del Torno", "", "BO", "68", "08", "", "", "", "-17.98674", "-63.38118", "America/La_Paz"),
("3904906", "Santa Cruz de la Sierra", "Санта-Крус-де-ла-Сиерра", "BO", "68", "08", "", "", "", "-17.78629", "-63.18117", "America/La_Paz"),
("3905658", "San Ignacio de Velasco", "", "BO", "68", "08", "", "", "", "-16.36667", "-60.95", "America/La_Paz"),
("3905792", "San Borja", "", "BO", "68", "03", "", "", "", "-14.81667", "-66.85", "America/La_Paz"),
("3906466", "Riberalta", "", "BO", "68", "03", "", "", "", "-11.00654", "-66.06312", "America/La_Paz"),
("3907080", "Punata", "", "BO", "68", "02", "", "", "", "-17.54234", "-65.83472", "America/La_Paz"),
("3907584", "Potosi", "Потоси", "BO", "68", "07", "", "", "", "-19.58361", "-65.75306", "America/La_Paz"),
("3909234", "Oruro", "Оруро", "BO", "68", "05", "", "", "", "-17.98333", "-67.15", "America/La_Paz"),
("3910027", "Montero", "Монтеро", "BO", "68", "08", "", "", "", "-17.33866", "-63.2505", "America/La_Paz"),
("3910291", "Mizque", "", "BO", "68", "02", "", "", "", "-17.94101", "-65.34016", "America/La_Paz"),
("3911409", "Llallagua", "", "BO", "68", "07", "", "", "", "-18.42426", "-66.58388", "America/La_Paz"),
("3911925", "La Paz", "Ла-Пас", "BO", "68", "04", "", "", "", "-16.5", "-68.15", "America/La_Paz"),
("3914839", "Huanuni", "", "BO", "68", "05", "", "", "", "-18.289", "-66.83583", "America/La_Paz"),
("3915350", "Guayaramerin", "", "BO", "68", "03", "", "", "", "-10.83676", "-65.36136", "America/La_Paz"),
("3918937", "Cotoca", "", "BO", "68", "08", "", "", "", "-17.81667", "-63.05", "America/La_Paz"),
("3919968", "Cochabamba", "Кочабамба", "BO", "68", "02", "", "", "", "-17.3895", "-66.1568", "America/La_Paz"),
("3919998", "Cobija", "Кобиха", "BO", "68", "06", "", "", "", "-11.02671", "-68.76918", "America/La_Paz"),
("3922414", "Camiri", "Камири", "BO", "68", "08", "", "", "", "-20.03849", "-63.51833", "America/La_Paz"),
("3384986", "Vitoria do Mearim", "", "BR", "76", "13", "2112902", "", "", "-3.46222", "-44.87056", "America/Fortaleza"),
("3384987", "Vitoria de Santo Antao", "Витория-де-Санту-Антан", "BR", "76", "30", "2616407", "", "", "-8.11806", "-35.29139", "America/Recife"),
("3385022", "Viseu", "", "BR", "76", "16", "1508308", "", "", "-1.19667", "-46.14", "America/Belem"),
("3385077", "Conde", "", "BR", "76", "17", "2504603", "", "", "-7.25972", "-34.9075", "America/Fortaleza"),
("3385088", "Vigia", "", "BR", "76", "16", "1508209", "", "", "-0.85833", "-48.14167", "America/Belem"),
("3385106", "Vicosa do Ceara", "", "BR", "76", "06", "2314102", "", "", "-3.56222", "-41.09222", "America/Fortaleza"),
("3385109", "Vicosa", "", "BR", "76", "02", "2709400", "", "", "-9.37139", "-36.24083", "America/Maceio"),
("3385122", "Viana", "Виана", "BR", "76", "13", "2112803", "", "", "-3.22028", "-45.00361", "America/Fortaleza"),
("3385467", "Varzea Alegre", "", "BR", "76", "06", "2305605", "", "", "-5.35", "-40.38333", "America/Fortaleza"),
("3385504", "Varjota", "", "BR", "76", "06", "2313955", "", "", "-4.19444", "-40.47667", "America/Fortaleza"),
("3385538", "Vargem Grande", "", "BR", "76", "13", "2112704", "", "", "-3.54306", "-43.91583", "America/Fortaleza"),
("3385592", "Valenca do Piaui", "", "BR", "76", "20", "2211308", "", "", "-6.4075", "-41.74556", "America/Fortaleza"),
("3385742", "Uniao dos Palmares", "", "BR", "76", "02", "2709301", "", "", "-9.16278", "-36.03194", "America/Maceio"),
("3385745", "Uniao", "", "BR", "76", "20", "2211100", "", "", "-4.58583", "-42.86417", "America/Fortaleza"),
("3385922", "Tuntum", "", "BR", "76", "13", "2112308", "", "", "-5.25806", "-44.64889", "America/Fortaleza"),
("3385935", "Tucurui", "", "BR", "76", "16", "1508100", "", "", "-3.76611", "-49.6725", "America/Belem"),
("3385980", "Tucuma", "", "BR", "76", "16", "1502509", "", "", "-0.18333", "-50.05", "America/Belem"),
("3386042", "Trindade", "", "BR", "76", "30", "2615607", "", "", "-7.76194", "-40.26778", "America/Recife"),
("3386177", "Trairi", "", "BR", "76", "06", "2313500", "", "", "-3.27778", "-39.26889", "America/Fortaleza"),
("3386264", "Toritama", "Торитама", "BR", "76", "30", "2615409", "", "", "-8.00667", "-36.05667", "America/Recife"),
("3386279", "Tome Acu", "", "BR", "76", "16", "1508001", "", "", "-2.41889", "-48.15222", "America/Belem"),
("3386361", "Timon", "Тимон", "BR", "76", "13", "2112209", "", "", "-5.09417", "-42.83667", "America/Fortaleza"),
("3386372", "Timbiras", "", "BR", "76", "13", "2112100", "", "", "-4.25528", "-43.94056", "America/Fortaleza"),
("3386396", "Timbauba", "", "BR", "76", "30", "2615300", "", "", "-7.50528", "-35.31833", "America/Recife"),
("3386449", "Tiangua", "", "BR", "76", "06", "2313401", "", "", "-3.73222", "-40.99167", "America/Fortaleza"),
("3386496", "Teresina", "Терезина", "BR", "76", "20", "2211001", "", "", "-5.08917", "-42.80194", "America/Fortaleza"),
("3386567", "Sao Joao dos Inhamuns", "", "BR", "76", "06", "2313302", "", "", "-6", "-40.28333", "America/Fortaleza"),
("3386931", "Tamandare", "", "BR", "76", "30", "2614857", "", "", "-8.75632", "-35.09995", "America/Recife"),
("3387082", "Tabira", "", "BR", "76", "30", "2614600", "", "", "-7.59083", "-37.53944", "America/Recife"),
("3387115", "Surubim", "", "BR", "76", "30", "2614501", "", "", "-7.83306", "-35.75472", "America/Recife"),
("3387202", "Sousa", "", "BR", "76", "17", "2516201", "", "", "-6.75917", "-38.22806", "America/Fortaleza"),
("3387204", "Soure", "", "BR", "76", "16", "1507904", "", "", "-0.71667", "-48.52333", "America/Belem"),
("3387266", "Solanea", "", "BR", "76", "17", "2501500", "", "", "-6.755", "-35.54", "America/Fortaleza"),
("3387296", "Sobral", "Собрал", "BR", "76", "06", "2312908", "", "", "-3.68611", "-40.34972", "America/Fortaleza"),
("3387604", "Sirinhaem", "", "BR", "76", "30", "2614204", "", "", "-8.59083", "-35.11611", "America/Recife"),
("3387663", "Sertania", "", "BR", "76", "30", "2614105", "", "", "-8.07361", "-37.26444", "America/Recife"),
("3387786", "Serra Talhada", "", "BR", "76", "30", "2613909", "", "", "-7.99194", "-38.29833", "America/Recife"),
("3387926", "Senador Pompeu", "", "BR", "76", "06", "2312700", "", "", "-5.58806", "-39.37167", "America/Fortaleza"),
("3387987", "Satuba", "", "BR", "76", "02", "2708907", "", "", "-9.56333", "-35.82444", "America/Maceio"),
("3388145", "Sao Raimundo Nonato", "", "BR", "76", "20", "2210607", "", "", "-9.01528", "-42.69944", "America/Fortaleza"),
("3388269", "Sao Miguel dos Campos", "Сан-Мигель-дус-Кампус", "BR", "76", "02", "2708600", "", "", "-9.78111", "-36.09361", "America/Maceio"),
("3388270", "Sao Miguel do Guama", "", "BR", "76", "16", "1507607", "", "", "-1.62667", "-47.48333", "America/Belem"),
("3388318", "Sao Mateus do Maranhao", "", "BR", "76", "13", "2111508", "", "", "-4.04167", "-44.475", "America/Fortaleza"),
("3388341", "Sao Luis do Quitunde", "", "BR", "76", "02", "2708501", "", "", "-9.31833", "-35.56111", "America/Maceio"),
("3388368", "Sao Luis", "Сан-Луис", "BR", "76", "13", "2111300", "", "", "-2.52972", "-44.30278", "America/Fortaleza"),
("3388376", "Sao Lourenco da Mata", "Сан-Лоренсу-да-Мата", "BR", "76", "30", "2613701", "", "", "-8.00222", "-35.01833", "America/Recife"),
("3388435", "Sao Jose do Egito", "", "BR", "76", "30", "2613602", "", "", "-7.47889", "-37.27444", "America/Recife"),
("3388441", "Sao Jose de Ribamar", "", "BR", "76", "13", "2111201", "", "", "-2.56194", "-44.05417", "America/Fortaleza"),
("3388443", "Sao Jose de Mipibu", "", "BR", "76", "22", "2412203", "", "", "-6.07472", "-35.23778", "America/Fortaleza"),
("3388615", "Sao Joao dos Patos", "", "BR", "76", "13", "2111102", "", "", "-6.495", "-43.70222", "America/Fortaleza"),
("3388714", "Sao Goncalo do Amarante", "", "BR", "76", "06", "2312403", "", "", "-3.60722", "-38.96833", "America/Fortaleza"),
("3388847", "Sao Felix do Xingu", "", "BR", "76", "16", "1507300", "", "", "-6.64472", "-51.995", "America/Belem"),
("3388868", "Sao Domingos do Maranhao", "", "BR", "76", "13", "2110708", "", "", "-5.57583", "-44.38528", "America/Fortaleza"),
("3388991", "Sao Bento", "", "BR", "76", "17", "2504306", "", "", "-6.28333", "-37.75", "America/Fortaleza"),
("3389006", "Sao Bento", "Сан-Бенту", "BR", "76", "13", "2110500", "", "", "-2.69583", "-44.82139", "America/Fortaleza"),
("3389321", "Santa Rita", "", "BR", "76", "17", "2513703", "", "", "-7.11389", "-34.97806", "America/Fortaleza"),
("3389353", "Santarem", "Сантарен", "BR", "76", "16", "1506807", "", "", "-2.44306", "-54.70833", "America/Santarem"),
("3389358", "Santa Quiteria do Maranhao", "", "BR", "76", "13", "2110104", "", "", "-3.51556", "-42.54667", "America/Fortaleza"),
("3389361", "Santa Quiteria", "", "BR", "76", "06", "2312205", "", "", "-4.33194", "-40.15667", "America/Fortaleza"),
("3389384", "Santana do Ipanema", "Сантана-ду-Ипанема", "BR", "76", "02", "2708006", "", "", "-9.37833", "-37.24528", "America/Maceio"),
("3389557", "Santa Luzia", "", "BR", "76", "13", "2109502", "", "", "-7.64265", "-47.21738", "America/Fortaleza"),
("3389609", "Santa Ines", "Санта-Инес", "BR", "76", "13", "2109908", "", "", "-3.66667", "-45.38", "America/Fortaleza"),
("3389622", "Santa Helena", "", "BR", "76", "13", "2109809", "", "", "-2.23111", "-45.3", "America/Fortaleza"),
("3389652", "Santa Cruz do Capibaribe", "", "BR", "76", "30", "2612505", "", "", "-7.9575", "-36.20472", "America/Recife"),
("3389673", "Santa Cruz", "", "BR", "76", "22", "2411205", "", "", "-6.22944", "-36.02278", "America/Fortaleza"),
("3389822", "Salinopolis", "", "BR", "76", "16", "1506203", "", "", "-0.61361", "-47.35611", "America/Belem"),
("3389860", "Salgueiro", "Салгейру", "BR", "76", "30", "2612208", "", "", "-8.07417", "-39.11917", "America/Recife"),
("3390160", "Russas", "", "BR", "76", "06", "2311801", "", "", "-4.94028", "-37.97583", "America/Fortaleza"),
("3390288", "Rio Largo", "", "BR", "76", "02", "2707701", "", "", "-9.47833", "-35.85333", "America/Maceio"),
("3390295", "Rio Formoso", "", "BR", "76", "30", "2611903", "", "", "-8.66877", "-35.16277", "America/Recife"),
("3390326", "Ribeirao", "", "BR", "76", "30", "2611804", "", "", "-8.51444", "-35.37778", "America/Recife"),
("3390760", "Recife", "Ресифи", "BR", "76", "30", "2611606", "", "", "-8.05389", "-34.88111", "America/Recife"),
("3390901", "Quixeramobim", "", "BR", "76", "06", "2311405", "", "", "-5.19917", "-39.29278", "America/Fortaleza"),
("3390907", "Quixada", "", "BR", "76", "06", "2311306", "", "", "-4.97139", "-39.01528", "America/Fortaleza"),
("3391220", "Presidente Dutra", "", "BR", "76", "13", "2109106", "", "", "-5.29", "-44.49", "America/Fortaleza"),
("3391360", "Santana", "Сантана", "BR", "76", "03", "1600600", "", "", "-0.05833", "-51.18167", "America/Belem"),
("3391397", "Porto Calvo", "", "BR", "76", "02", "2707305", "", "", "-9.045", "-35.39833", "America/Maceio"),
("3391412", "Portel", "", "BR", "76", "16", "1505809", "", "", "-1.93556", "-50.82111", "America/Belem"),
("3391556", "Pombos", "", "BR", "76", "30", "2611309", "", "", "-8.14139", "-35.39583", "America/Recife"),
("3391571", "Pombal", "", "BR", "76", "17", "2512101", "", "", "-6.77028", "-37.80167", "America/Fortaleza"),
("3391908", "Piripiri", "", "BR", "76", "20", "2208403", "", "", "-4.27333", "-41.77694", "America/Fortaleza"),
("3391991", "Piracuruca", "", "BR", "76", "20", "2208304", "", "", "-3.92806", "-41.70917", "America/Fortaleza"),
("3392054", "Pinheiro", "Пиньейру", "BR", "76", "13", "2108603", "", "", "-2.52139", "-45.0825", "America/Fortaleza"),
("3392088", "Pindare Mirim", "", "BR", "76", "13", "2108504", "", "", "-3.60833", "-45.34333", "America/Fortaleza"),
("3392126", "Pilar", "Пилар", "BR", "76", "02", "2706901", "", "", "-9.59722", "-35.95667", "America/Maceio"),
("3392167", "Picos", "Пикус", "BR", "76", "20", "2208007", "", "", "-7.07694", "-41.46694", "America/Fortaleza"),
("3392242", "Petrolina", "Петролина", "BR", "76", "30", "2611101", "", "", "-9.39861", "-40.50083", "America/Recife"),
("3392243", "Jatoba", "Ятоба", "BR", "76", "30", "2608057", "", "", "-9.18306", "-38.26889", "America/Recife"),
("3392251", "Pesqueira", "", "BR", "76", "30", "2610905", "", "", "-8.35778", "-36.69639", "America/Recife"),
("3392345", "Pentecoste", "", "BR", "76", "06", "2310704", "", "", "-3.79278", "-39.27028", "America/Fortaleza"),
("3392368", "Penalva", "", "BR", "76", "13", "2108306", "", "", "-3.29417", "-45.17361", "America/Fortaleza"),
("3392431", "Pedro II", "", "BR", "76", "20", "2207900", "", "", "-4.42472", "-41.45861", "America/Fortaleza"),
("3392629", "Pedra Branca", "Педра-Бранка", "BR", "76", "06", "2310506", "", "", "-5.45417", "-39.71722", "America/Fortaleza"),
("3392734", "Paulo Afonso", "", "BR", "76", "05", "2924009", "", "", "-9.40611", "-38.21472", "America/Bahia"),
("3392740", "Paulista", "", "BR", "76", "30", "2610707", "", "", "-7.94083", "-34.87306", "America/Recife"),
("3392887", "Patos", "Патус", "BR", "76", "17", "2510808", "", "", "-7.02444", "-37.28", "America/Fortaleza"),
("3392998", "Parnamirim", "Парнамирин", "BR", "76", "22", "2403251", "", "", "-5.91556", "-35.26278", "America/Fortaleza"),
("3393001", "Parnaiba", "Парнаиба", "BR", "76", "20", "2207702", "", "", "-2.90472", "-41.77667", "America/Fortaleza"),
("3393008", "Parintins", "Паринтинса", "BR", "76", "04", "1303403", "", "", "-2.62833", "-56.73583", "America/Manaus"),
("3393017", "Parelhas", "", "BR", "76", "22", "2408904", "", "", "-6.68778", "-36.6575", "America/Fortaleza"),
("3393091", "Paraipaba", "", "BR", "76", "06", "2310258", "", "", "-3.43944", "-39.14833", "America/Fortaleza"),
("3393106", "Paragominas", "", "BR", "76", "16", "1505502", "", "", "-2.96667", "-47.48333", "America/Belem"),
("3393115", "Paracuru", "", "BR", "76", "06", "2310209", "", "", "-3.41", "-39.03056", "America/Fortaleza"),
("3393264", "Palmares", "", "BR", "76", "30", "2610004", "", "", "-8.68333", "-35.59167", "America/Recife"),
("3393400", "Pacatuba", "", "BR", "76", "06", "2309706", "", "", "-3.98417", "-38.62028", "America/Fortaleza"),
("3393409", "Pacajus", "", "BR", "76", "06", "2309607", "", "", "-4.1725", "-38.46056", "America/Fortaleza"),
("3393452", "Ouricuri", "", "BR", "76", "30", "2609907", "", "", "-7.8825", "-40.08167", "America/Recife"),
("3393465", "Oros", "", "BR", "76", "06", "2309508", "", "", "-6.24444", "-38.91361", "America/Fortaleza"),
("3393471", "Oriximina", "", "BR", "76", "16", "1505304", "", "", "-1.76556", "-55.86611", "America/Santarem"),
("3393536", "Olinda", "Олинда", "BR", "76", "30", "2609600", "", "", "-8.00889", "-34.85528", "America/Recife"),
("3393764", "Oeiras", "", "BR", "76", "20", "2207009", "", "", "-7.02528", "-42.13111", "America/Fortaleza"),
("3393768", "Abidos", "", "BR", "76", "16", "1505106", "", "", "-1.9175", "-55.51806", "America/Santarem"),
("3393832", "Nova Russas", "", "BR", "76", "06", "2309300", "", "", "-4.70667", "-40.56306", "America/Fortaleza"),
("3393876", "Nova Cruz", "", "BR", "76", "22", "2408300", "", "", "-6.47806", "-35.43389", "America/Fortaleza"),
("3393972", "Nazare da Mata", "Назар-да-Мата", "BR", "76", "30", "2609501", "", "", "-7.74167", "-35.22778", "America/Recife"),
("3394023", "Natal", "Натал", "BR", "76", "22", "2408102", "", "", "-5.795", "-35.20944", "America/Fortaleza"),
("3394116", "Murici", "", "BR", "76", "02", "2705507", "", "", "-9.30667", "-35.94333", "America/Maceio"),
("3394453", "Moreno", "", "BR", "76", "30", "2609402", "", "", "-8.11861", "-35.09222", "America/Recife"),
("3394500", "Morada Nova", "", "BR", "76", "06", "2308708", "", "", "-5.10667", "-38.3725", "America/Fortaleza"),
("3394549", "Monteiro", "", "BR", "76", "17", "2509701", "", "", "-7.88944", "-37.12", "America/Fortaleza"),
("3394605", "Monte Alegre", "Монти-Алегри", "BR", "76", "16", "1504802", "", "", "-2.00082", "-54.08102", "America/Santarem"),
("3394649", "Mombaca", "", "BR", "76", "06", "2308500", "", "", "-5.74306", "-39.6275", "America/Fortaleza"),
("3394661", "Moju", "", "BR", "76", "16", "1504703", "", "", "-1.88389", "-48.76889", "America/Belem"),
("3394682", "Mossoro", "Мосоро", "BR", "76", "22", "2408003", "", "", "-5.1875", "-37.34417", "America/Fortaleza"),
("3394745", "Mocajuba", "", "BR", "76", "16", "1504604", "", "", "-2.58417", "-49.50722", "America/Belem"),
("3395062", "Maues", "", "BR", "76", "04", "1302900", "", "", "-3.38361", "-57.71861", "America/Manaus"),
("3395077", "Matriz de Camaragibe", "", "BR", "76", "02", "2705101", "", "", "-9.15167", "-35.53333", "America/Maceio"),
("3395380", "Mari", "", "BR", "76", "17", "2509107", "", "", "-7.06", "-35.31944", "America/Fortaleza"),
("3395395", "Marechal Deodoro", "", "BR", "76", "02", "2704708", "", "", "-9.71028", "-35.895", "America/Maceio"),
("3395458", "Maragogi", "", "BR", "76", "02", "2704500", "", "", "-9.01222", "-35.2225", "America/Maceio"),
("3395473", "Maracanau", "", "BR", "76", "06", "2307650", "", "", "-3.87667", "-38.62556", "America/Fortaleza"),
("3395503", "Maraba", "Мараба", "BR", "76", "16", "1504208", "", "", "-5.36861", "-49.11778", "America/Belem"),
("3395717", "Mamanguape", "", "BR", "76", "17", "2508901", "", "", "-6.83861", "-35.12611", "America/Fortaleza"),
("3395981", "Maceio", "Масейо", "BR", "76", "02", "2704302", "", "", "-9.66583", "-35.73528", "America/Maceio"),
("3395998", "Macau", "", "BR", "76", "22", "2407203", "", "", "-5.115", "-36.63444", "America/Fortaleza"),
("3396016", "Macapa", "Макапа", "BR", "76", "03", "1600303", "", "", "0.03889", "-51.06639", "America/Belem"),
("3396048", "Macaiba", "", "BR", "76", "22", "2407104", "", "", "-5.85833", "-35.35389", "America/Fortaleza"),
("3396266", "Limoeiro do Norte", "", "BR", "76", "06", "2307601", "", "", "-5.14556", "-38.09806", "America/Fortaleza"),
("3396277", "Limoeiro", "", "BR", "76", "30", "2608909", "", "", "-7.87472", "-35.45028", "America/Recife"),
("3396364", "Lavras da Mangabeira", "", "BR", "76", "06", "2307502", "", "", "-6.75333", "-38.96444", "America/Fortaleza"),
("3396496", "Lajedo", "Лажеду", "BR", "76", "30", "2608800", "", "", "-8.66361", "-36.32", "America/Recife"),
("3396601", "Lago da Pedra", "Лаго-да-Педра", "BR", "76", "13", "2113009", "", "", "-4.28674", "-45.23824", "America/Fortaleza"),
("3396769", "Lagoa do Itaenga", "", "BR", "76", "30", "2608503", "", "", "-7.93611", "-35.29028", "America/Recife"),
("3397147", "Juazeiro do Norte", "Жуазейру-ду-Норти", "BR", "76", "06", "2307304", "", "", "-7.21306", "-39.31528", "America/Fortaleza"),
("3397230", "Jose de Freitas", "", "BR", "76", "20", "2205508", "", "", "-4.75639", "-42.57556", "America/Fortaleza"),
("3397277", "Joao Pessoa", "Жуан-Песоа", "BR", "76", "17", "2507507", "", "", "-7.115", "-34.86306", "America/Fortaleza"),
("3397315", "Joao Camara", "", "BR", "76", "22", "2405801", "", "", "-5.5375", "-35.81972", "America/Fortaleza"),
("3397665", "Jaguaruana", "", "BR", "76", "06", "2307007", "", "", "-4.83389", "-37.78111", "America/Fortaleza"),
("3397675", "Jaguaribe", "Жагуариби", "BR", "76", "06", "2306900", "", "", "-5.89056", "-38.62194", "America/Fortaleza"),
("3397838", "Jaboatao", "", "BR", "76", "30", "2607901", "", "", "-8.18028", "-35.00139", "America/Recife"),
("3397851", "Itupiranga", "", "BR", "76", "16", "1503705", "", "", "-5.13472", "-49.32667", "America/Belem"),
("3397893", "Itacoatiara", "", "BR", "76", "04", "1301902", "", "", "-3.14306", "-58.44417", "America/Manaus"),
("3397898", "Itaporanga", "", "BR", "76", "17", "2507002", "", "", "-7.30444", "-38.15028", "America/Fortaleza"),
("3397904", "Itapissuma", "", "BR", "76", "30", "2607752", "", "", "-7.77639", "-34.89222", "America/Recife"),
("3397909", "Itapipoca", "Итапипока", "BR", "76", "06", "2306405", "", "", "-3.49444", "-39.57861", "America/Fortaleza"),
("3397936", "Itapecuru Mirim", "", "BR", "76", "13", "2105401", "", "", "-3.3925", "-44.35861", "America/Fortaleza"),
("3397941", "Itapage", "", "BR", "76", "06", "2306306", "", "", "-3.68667", "-39.58611", "America/Fortaleza"),
("3397967", "Itaituba", "", "BR", "76", "16", "1503606", "", "", "-4.27611", "-55.98361", "America/Santarem"),
("3397969", "Itaitinga", "", "BR", "76", "06", "2306256", "", "", "-3.96944", "-38.52806", "America/Fortaleza"),
("3398003", "Itabaiana", "", "BR", "76", "17", "2506905", "", "", "-7.32861", "-35.3325", "America/Fortaleza"),
("3398076", "Ipueiras", "", "BR", "76", "06", "", "", "", "-7.03333", "-40.45", "America/Fortaleza"),
("3398105", "Ipubi", "", "BR", "76", "30", "2607307", "", "", "-7.65194", "-40.14889", "America/Recife"),
("3398112", "Ipu", "", "BR", "76", "06", "2305803", "", "", "-4.32222", "-40.71083", "America/Fortaleza"),
("3398115", "Ipojuca", "Ипожука", "BR", "76", "30", "2607208", "", "", "-8.39889", "-35.06389", "America/Recife"),
("3398269", "Imperatriz", "Императрис", "BR", "76", "13", "2105302", "", "", "-5.52639", "-47.49167", "America/Fortaleza"),
("3398331", "Iguatu", "", "BR", "76", "06", "2305506", "", "", "-6.35944", "-39.29861", "America/Fortaleza"),
("3398343", "Igarape Miri", "", "BR", "76", "16", "1503309", "", "", "-1.975", "-48.95972", "America/Belem"),
("3398350", "Igarape Acu", "", "BR", "76", "16", "1503200", "", "", "-1.12889", "-47.62", "America/Belem"),
("3398352", "Igarassu", "", "BR", "76", "30", "2606804", "", "", "-7.83417", "-34.90639", "America/Recife"),
("3398379", "Ico", "", "BR", "76", "06", "2305407", "", "", "-6.40111", "-38.86222", "America/Fortaleza"),
("3398450", "Horizonte", "", "BR", "76", "06", "2305233", "", "", "-4.1", "-38.48333", "America/Fortaleza"),
("3398569", "Guaraciaba do Norte", "", "BR", "76", "06", "2305001", "", "", "-4.16694", "-40.7475", "America/Fortaleza"),
("3398570", "Guarabira", "", "BR", "76", "17", "2506301", "", "", "-6.85472", "-35.49", "America/Fortaleza"),
("3398614", "Guaiuba", "", "BR", "76", "06", "2304954", "", "", "-4.03972", "-38.63722", "America/Fortaleza"),
("3398691", "Gravata", "", "BR", "76", "30", "2606408", "", "", "-8.20111", "-35.56472", "America/Recife"),
("3398706", "Granja", "", "BR", "76", "06", "2304707", "", "", "-3.12028", "-40.82611", "America/Fortaleza"),
("3398856", "Grajau", "", "BR", "76", "13", "2104800", "", "", "-5.81944", "-46.13861", "America/Fortaleza"),
("3398904", "Goiana", "Гояна", "BR", "76", "30", "2606200", "", "", "-7.56056", "-35.0025", "America/Recife"),
("3398920", "Gloria do Goita", "", "BR", "76", "30", "2606101", "", "", "-8.00167", "-35.29278", "America/Recife"),
("3399058", "Garanhuns", "Гараньюнс", "BR", "76", "30", "", "", "", "-8.88202", "-36.50216", "America/Recife"),
("3399132", "Gameleira", "", "BR", "76", "30", "2605905", "", "", "-8.58444", "-35.38667", "America/Recife"),
("3399415", "Fortaleza", "Форталеза", "BR", "76", "06", "2304400", "", "", "-3.71722", "-38.54306", "America/Fortaleza"),
("3399506", "Floriano", "Флориан", "BR", "76", "20", "2203909", "", "", "-6.76694", "-43.0225", "America/Fortaleza"),
("3399518", "Floresta", "", "BR", "76", "30", "2605707", "", "", "-8.60111", "-38.56861", "America/Recife"),
("3400558", "Eusebio", "Эусебио", "BR", "76", "06", "2304285", "", "", "-3.89", "-38.45056", "America/Fortaleza"),
("3400567", "Extremoz", "Эстремос", "BR", "76", "22", "2403608", "", "", "-5.70556", "-35.30722", "America/Fortaleza"),
("3400617", "Estreito", "", "BR", "76", "13", "2107803", "", "", "-5.78333", "-43.25", "America/Fortaleza"),
("3400740", "Esperantina", "", "BR", "76", "20", "2203701", "", "", "-3.90167", "-42.23361", "America/Fortaleza"),
("3400752", "Esperanca", "", "BR", "76", "17", "2506004", "", "", "-7.03306", "-35.85722", "America/Fortaleza"),
("3400804", "Escada", "", "BR", "76", "30", "2605202", "", "", "-8.35917", "-35.22361", "America/Recife"),
("3400969", "Dom Pedro", "", "BR", "76", "13", "2106003", "", "", "-5.0375", "-44.43857", "America/Fortaleza"),
("3401106", "Demerval Lobao", "", "BR", "76", "20", "2203305", "", "", "-5.35833", "-42.67639", "America/Fortaleza"),
("3401109", "Delmiro Gouveia", "", "BR", "76", "02", "2702405", "", "", "-9.38861", "-37.99917", "America/Maceio"),
("3401138", "Custodia", "", "BR", "76", "30", "2605103", "", "", "-8.0875", "-37.64306", "America/Recife"),
("3401148", "Cururupu", "", "BR", "76", "13", "2103703", "", "", "-1.82833", "-44.86833", "America/Fortaleza"),
("3401283", "Currais Novos", "Куррайс-Новус", "BR", "76", "22", "2403103", "", "", "-6.26083", "-36.51778", "America/Fortaleza"),
("3401340", "Cupira", "", "BR", "76", "30", "2605004", "", "", "-8.61667", "-35.95", "America/Recife"),
("3401545", "Crato", "Крату", "BR", "76", "06", "2304202", "", "", "-7.23417", "-39.40944", "America/Fortaleza"),
("3401548", "Crateus", "", "BR", "76", "06", "2304103", "", "", "-5.17833", "-40.6775", "America/Fortaleza"),
("3401703", "Coroata", "", "BR", "76", "13", "2103604", "", "", "-4.13", "-44.12417", "America/Fortaleza"),
("3401830", "Condado", "", "BR", "76", "30", "2604601", "", "", "-7.58583", "-35.10583", "America/Recife"),
("3401845", "Conceicao do Araguaia", "", "BR", "76", "16", "1502707", "", "", "-8.25778", "-49.26472", "America/Araguaina"),
("3401963", "Colinas", "Колинас", "BR", "76", "13", "2103505", "", "", "-6.02583", "-44.24917", "America/Fortaleza"),
("3401992", "Coelho Neto", "", "BR", "76", "13", "2103406", "", "", "-4.25667", "-43.01278", "America/Fortaleza"),
("3402000", "Codo", "", "BR", "76", "13", "2103307", "", "", "-4.45528", "-43.88556", "America/Fortaleza"),
("3402229", "Chapadinha", "", "BR", "76", "13", "2103208", "", "", "-3.74167", "-43.36028", "America/Fortaleza"),
("3402271", "Cha Grande", "", "BR", "76", "30", "2604502", "", "", "-8.23833", "-35.46167", "America/Recife"),
("3402360", "Ceara Mirim", "", "BR", "76", "22", "2402600", "", "", "-5.63444", "-35.42556", "America/Fortaleza"),
("3402383", "Caxias", "", "BR", "76", "13", "2103000", "", "", "-4.85889", "-43.35611", "America/Fortaleza"),
("3402429", "Caucaia", "", "BR", "76", "06", "2303709", "", "", "-3.73611", "-38.65306", "America/Fortaleza"),
("3402465", "Catole do Rocha", "", "BR", "76", "17", "2504306", "", "", "-6.34389", "-37.74667", "America/Fortaleza"),
("3402528", "Catende", "", "BR", "76", "30", "2604205", "", "", "-8.66667", "-35.71667", "America/Recife"),
("3402591", "Castanhal", "", "BR", "76", "16", "1502400", "", "", "-1.29389", "-47.92639", "America/Belem"),
("3402613", "Cascavel", "", "BR", "76", "06", "2303501", "", "", "-4.13306", "-38.24194", "America/Fortaleza"),
("3402655", "Caruaru", "Каруару", "BR", "76", "30", "2604106", "", "", "-8.28333", "-35.97611", "America/Recife"),
("3402721", "Carpina", "Карпина", "BR", "76", "30", "2604007", "", "", "-7.85083", "-35.25472", "America/Recife"),
("3402724", "Carolina", "Каролина", "BR", "76", "13", "2102804", "", "", "-7.33561", "-47.46218", "America/Fortaleza"),
("3403127", "Capitao Poco", "", "BR", "76", "16", "1502301", "", "", "-1.74639", "-47.05944", "America/Belem"),
("3403208", "Capanema", "", "BR", "76", "16", "1502202", "", "", "-1.19583", "-47.18083", "America/Belem"),
("3403353", "Caninde", "", "BR", "76", "06", "2302800", "", "", "-4.35889", "-39.31167", "America/Fortaleza"),
("3403362", "Canguaretama", "Кангуаретама", "BR", "76", "22", "2402204", "", "", "-6.38", "-35.12889", "America/Fortaleza"),
("3403534", "Campos Sales", "", "BR", "76", "06", "2302701", "", "", "-7.07444", "-40.37611", "America/Fortaleza"),
("3403566", "Campo Maior", "", "BR", "76", "20", "2202208", "", "", "-4.82778", "-42.16861", "America/Fortaleza"),
("3403611", "Campo Alegre", "", "BR", "76", "02", "2701407", "", "", "-9.78194", "-36.35083", "America/Maceio"),
("3403642", "Campina Grande", "Кампина-Гранде", "BR", "76", "17", "2504009", "", "", "-7.23056", "-35.88111", "America/Fortaleza"),
("3403687", "Camocim", "", "BR", "76", "06", "2302602", "", "", "-2.90222", "-40.84111", "America/Fortaleza"),
("3403697", "Cameta", "", "BR", "76", "16", "1502103", "", "", "-2.24444", "-49.49583", "America/Belem"),
("3403941", "Cajueiro", "", "BR", "76", "02", "2704203", "", "", "-9.71667", "-36.45", "America/Maceio"),
("3404020", "Cajazeiras", "Кажазейрас", "BR", "76", "17", "2503704", "", "", "-6.89028", "-38.55528", "America/Fortaleza"),
("3404117", "Caico", "Кайко", "BR", "76", "22", "2402006", "", "", "-6.45833", "-37.09778", "America/Fortaleza"),
("3404513", "Cabrobo", "", "BR", "76", "30", "2603009", "", "", "-8.51417", "-39.31", "America/Recife"),
("3404545", "Cabo", "", "BR", "76", "30", "2602902", "", "", "-8.28333", "-35.03333", "America/Recife"),
("3404558", "Cabedelo", "", "BR", "76", "17", "2503209", "", "", "-6.98111", "-34.83389", "America/Fortaleza"),
("3404722", "Buriti Bravo", "", "BR", "76", "13", "2102309", "", "", "-5.83722", "-43.83361", "America/Fortaleza"),
("3404766", "Buique", "Буики", "BR", "76", "30", "2602803", "", "", "-8.62306", "-37.15583", "America/Recife"),
("3404817", "Breves", "", "BR", "76", "16", "1501808", "", "", "-1.68222", "-50.48028", "America/Belem"),
("3404833", "Brejo Santo", "", "BR", "76", "06", "2302503", "", "", "-7.49333", "-38.98722", "America/Fortaleza"),
("3404862", "Brejo da Madre de Deus", "", "BR", "76", "30", "2602605", "", "", "-8.14583", "-36.37111", "America/Recife"),
("3405006", "Braganca", "", "BR", "76", "16", "1501709", "", "", "-1.05361", "-46.76556", "America/Belem"),
("3405380", "Bom Conselho", "", "BR", "76", "30", "2602100", "", "", "-9.16972", "-36.67972", "America/Recife"),
("3405616", "Boa Viagem", "", "BR", "76", "06", "2302404", "", "", "-5.1275", "-39.73222", "America/Fortaleza"),
("3405738", "Bezerros", "Безеррус", "BR", "76", "30", "2601904", "", "", "-8.23333", "-35.79694", "America/Recife"),
("3405792", "Benevides", "", "BR", "76", "16", "1501501", "", "", "-1.36139", "-48.24472", "America/Belem"),
("3405812", "Belo Jardim", "", "BR", "76", "30", "2601706", "", "", "-8.33556", "-36.42417", "America/Recife"),
("3405863", "Belem", "Белем", "BR", "76", "17", "2501906", "", "", "-6.69167", "-35.53333", "America/Fortaleza"),
("3405870", "Belem", "Белен", "BR", "76", "16", "1501402", "", "", "-1.45583", "-48.50444", "America/Belem"),
("3405924", "Beberibe", "Беберибе", "BR", "76", "06", "2302206", "", "", "-4.17972", "-38.13056", "America/Fortaleza"),
("3405940", "Bayeux", "", "BR", "76", "17", "2501807", "", "", "-7.125", "-34.93222", "America/Fortaleza"),
("3405954", "Baturite", "", "BR", "76", "06", "2302107", "", "", "-4.32861", "-38.88472", "America/Fortaleza"),
("3406160", "Barreiros", "", "BR", "76", "30", "2601409", "", "", "-8.81833", "-35.18639", "America/Recife"),
("3406196", "Barreirinhas", "", "BR", "76", "13", "2101707", "", "", "-2.75556", "-42.82591", "America/Fortaleza"),
("3406263", "Barras", "Баррас", "BR", "76", "20", "2201200", "", "", "-4.24444", "-42.29444", "America/Fortaleza"),
("3406318", "Barra do Corda", "", "BR", "76", "13", "2101608", "", "", "-5.50308", "-45.23693", "America/Fortaleza"),
("3406429", "Barcarena", "", "BR", "76", "16", "1501303", "", "", "-1.50583", "-48.62583", "America/Belem"),
("3406442", "Barbalha", "", "BR", "76", "06", "2301901", "", "", "-7.31111", "-39.30417", "America/Fortaleza"),
("3406545", "Balsas", "Альтбальсас", "BR", "76", "13", "2101400", "", "", "-7.5325", "-46.03556", "America/Fortaleza"),
("3406910", "Bacabal", "Бакабал", "BR", "76", "13", "2101202", "", "", "-4.29167", "-44.79167", "America/Fortaleza"),
("3406961", "Augusto Correa", "", "BR", "76", "16", "1500909", "", "", "-1.02167", "-46.635", "America/Belem"),
("3406996", "Atalaia", "", "BR", "76", "02", "2700409", "", "", "-9.50194", "-36.02278", "America/Maceio"),
("3407194", "Areia Branca", "", "BR", "76", "22", "2401107", "", "", "-4.95611", "-37.13694", "America/Fortaleza"),
("3407216", "Arcoverde", "Арковерди", "BR", "76", "30", "2601201", "", "", "-8.41889", "-37.05389", "America/Recife"),
("3407243", "Araripina", "Арарипина", "BR", "76", "30", "2601102", "", "", "-7.57611", "-40.49833", "America/Recife"),
("3407258", "Arari", "", "BR", "76", "13", "2101004", "", "", "-3.45361", "-44.78", "America/Fortaleza"),
("3407327", "Arapiraca", "", "BR", "76", "02", "2700300", "", "", "-9.7525", "-36.66111", "America/Maceio"),
("3407357", "Araguaina", "Арагуаина", "BR", "76", "31", "1702109", "", "", "-7.19111", "-48.20722", "America/Araguaina"),
("3407378", "Aracati", "Аракати", "BR", "76", "06", "2301109", "", "", "-4.56167", "-37.76972", "America/Fortaleza"),
("3407407", "Aquiraz", "", "BR", "76", "06", "2301000", "", "", "-3.90139", "-38.39111", "America/Fortaleza"),
("3407440", "Apodi", "", "BR", "76", "22", "2401008", "", "", "-5.66417", "-37.79889", "America/Fortaleza"),
("3407669", "Ananindeua", "Ананиндеуа", "BR", "76", "16", "1500800", "", "", "-1.36556", "-48.37222", "America/Belem"),
("3407758", "Amaraji", "", "BR", "76", "30", "2600906", "", "", "-8.38306", "-35.4525", "America/Recife"),
("3407797", "Altos", "", "BR", "76", "20", "2200400", "", "", "-5.03806", "-42.46", "America/Fortaleza"),
("3407882", "Altamira", "Альтамира", "BR", "76", "16", "1500602", "", "", "-3.20333", "-52.20639", "America/Santarem"),
("3407903", "Almeirim", "Алмейрин", "BR", "76", "16", "1500503", "", "", "-1.52333", "-52.58167", "America/Santarem"),
("3407980", "Alenquer", "", "BR", "76", "16", "1500404", "", "", "-1.94167", "-54.73833", "America/Santarem"),
("3408100", "Alagoa Grande", "", "BR", "76", "17", "2515807", "", "", "-7.15833", "-35.63", "America/Fortaleza"),
("3408166", "Aguas Belas", "", "BR", "76", "30", "2600500", "", "", "-9.11139", "-37.12306", "America/Recife"),
("3408175", "Agua Preta", "", "BR", "76", "30", "2600401", "", "", "-8.7075", "-35.53056", "America/Recife"),
("3408274", "Afogados da Ingazeira", "", "BR", "76", "30", "2600104", "", "", "-7.75083", "-37.63917", "America/Recife"),
("3408337", "Acu", "", "BR", "76", "22", "2400208", "", "", "-5.57667", "-36.90861", "America/Fortaleza"),
("3408343", "Acopiara", "", "BR", "76", "06", "2300309", "", "", "-6.09528", "-39.4525", "America/Fortaleza"),
("3408368", "Acarau", "Акарау", "BR", "76", "06", "2300200", "", "", "-2.88556", "-40.12", "America/Fortaleza"),
("3408404", "Abreu e Lima", "", "BR", "76", "30", "2600054", "", "", "-7.91167", "-34.90278", "America/Recife"),
("3408424", "Abaetetuba", "", "BR", "76", "16", "1500107", "", "", "-1.71806", "-48.8825", "America/Belem"),
("3444823", "Xique Xique", "", "BR", "76", "05", "2933604", "", "", "-10.82167", "-42.73111", "America/Bahia"),
("3444848", "Xanxere", "", "BR", "76", "26", "4219507", "", "", "-26.87694", "-52.40417", "America/Sao_Paulo"),
("3444864", "Votuporanga", "", "BR", "76", "27", "3557105", "", "", "-20.42278", "-49.97278", "America/Sao_Paulo"),
("3444866", "Votorantim", "", "BR", "76", "27", "3557006", "", "", "-23.54667", "-47.43778", "America/Sao_Paulo"),
("3444876", "Volta Redonda", "Волта-Редонда", "BR", "76", "21", "3306305", "", "", "-22.52306", "-44.10417", "America/Sao_Paulo"),
("3444914", "Vitoria da Conquista", "Витория-да-Конкиста", "BR", "76", "05", "2933307", "", "", "-14.86611", "-40.83944", "America/Bahia"),
("3444924", "Vitoria", "Витория", "BR", "76", "08", "3205309", "", "", "-20.31944", "-40.33778", "America/Sao_Paulo"),
("3444969", "Visconde do Rio Branco", "", "BR", "76", "15", "3172004", "", "", "-21.01028", "-42.84056", "America/Sao_Paulo"),
("3444997", "Viradouro", "", "BR", "76", "27", "3556800", "", "", "-20.87306", "-48.29694", "America/Sao_Paulo"),
("3445014", "Vinhedo", "", "BR", "76", "27", "3556701", "", "", "-23.02972", "-46.97528", "America/Sao_Paulo"),
("3445026", "Vila Velha", "Вила-Велья", "BR", "76", "08", "3205200", "", "", "-20.32972", "-40.2925", "America/Sao_Paulo"),
("3445126", "Videira", "Видейра", "BR", "76", "26", "4219309", "", "", "-27.00833", "-51.15167", "America/Sao_Paulo"),
("3445133", "Vicosa", "Висоза", "BR", "76", "15", "3171303", "", "", "-20.75389", "-42.88194", "America/Sao_Paulo"),
("3445153", "Viana", "Виана", "BR", "76", "08", "3205101", "", "", "-20.39028", "-40.49611", "America/Sao_Paulo"),
("3445156", "Viamao", "Виаман", "BR", "76", "23", "4323002", "", "", "-30.08111", "-51.02333", "America/Sao_Paulo"),
("3445162", "Vespasiano", "", "BR", "76", "15", "3171204", "", "", "-19.69194", "-43.92333", "America/Sao_Paulo"),
("3445299", "Veranopolis", "", "BR", "76", "23", "4322806", "", "", "-28.93611", "-51.54944", "America/Sao_Paulo"),
("3445307", "Vera Cruz", "", "BR", "76", "05", "2901304", "", "", "-12.63333", "-41.03333", "America/Bahia"),
("3445348", "Wenceslau Braz", "", "BR", "76", "18", "4128500", "", "", "-23.87389", "-49.80278", "America/Sao_Paulo"),
("3445350", "Venancio Aires", "", "BR", "76", "23", "4322608", "", "", "-29.60639", "-52.19194", "America/Sao_Paulo"),
("3445418", "Vazante", "", "BR", "76", "15", "3171006", "", "", "-17.98694", "-46.90778", "America/Sao_Paulo"),
("3445433", "Vassouras", "", "BR", "76", "21", "3306206", "", "", "-22.40389", "-43.6625", "America/Sao_Paulo"),
("3445446", "Varzea Paulista", "", "BR", "76", "27", "3556503", "", "", "-23.21139", "-46.82833", "America/Sao_Paulo"),
("3445451", "Varzea Grande", "", "BR", "76", "14", "5108402", "", "", "-15.64667", "-56.1325", "America/Cuiaba"),
("3445459", "Varzea da Palma", "", "BR", "76", "15", "3170800", "", "", "-17.59806", "-44.73083", "America/Sao_Paulo"),
("3445487", "Varginha", "Варжинья", "BR", "76", "15", "3170701", "", "", "-21.55139", "-45.43028", "America/Sao_Paulo"),
("3445500", "Vargem Grande do Sul", "Варжен-Гранди-ду-Сул", "BR", "76", "27", "3556404", "", "", "-21.83222", "-46.89361", "America/Sao_Paulo"),
("3445575", "Valparaiso", "", "BR", "76", "27", "3556305", "", "", "-21.22778", "-50.86833", "America/Sao_Paulo"),
("3445578", "Valinhos", "", "BR", "76", "27", "3556206", "", "", "-22.97056", "-46.99583", "America/Sao_Paulo"),
("3445596", "Valenca", "Валенса", "BR", "76", "21", "3306107", "", "", "-22.24556", "-43.70028", "America/Sao_Paulo"),
("3445597", "Valenca", "", "BR", "76", "05", "2932903", "", "", "-13.37028", "-39.07306", "America/Bahia"),
("3445630", "Vacaria", "Вакария", "BR", "76", "23", "4322509", "", "", "-28.51222", "-50.93389", "America/Sao_Paulo"),
("3445679", "Uruguaiana", "Уругуаяна", "BR", "76", "23", "4322400", "", "", "-29.75472", "-57.08833", "America/Sao_Paulo"),
("3445690", "Urucuca", "", "BR", "76", "05", "2932705", "", "", "-14.59306", "-39.28444", "America/Bahia"),
("3445713", "Uruacu", "Уруасу", "BR", "76", "29", "5221601", "", "", "-14.52472", "-49.14083", "America/Sao_Paulo"),
("3445746", "Uniao da Vitoria", "Униан-да-Витория", "BR", "76", "18", "4128203", "", "", "-26.23", "-51.08639", "America/Sao_Paulo"),
("3445764", "Unai", "Унай", "BR", "76", "15", "3170404", "", "", "-16.3575", "-46.90611", "America/Sao_Paulo"),
("3445781", "Una", "", "BR", "76", "05", "2932507", "", "", "-15.29333", "-39.07528", "America/Bahia"),
("3445782", "Umuarama", "", "BR", "76", "18", "4128104", "", "", "-23.76639", "-53.325", "America/Sao_Paulo"),
("3445831", "Uberlandia", "Уберландия", "BR", "76", "15", "3170206", "", "", "-18.91861", "-48.27722", "America/Sao_Paulo"),
("3445839", "Uberaba", "Убераба", "BR", "76", "15", "3170107", "", "", "-19.74833", "-47.93194", "America/Sao_Paulo"),
("3445847", "Ubatuba", "Убатуба", "BR", "76", "27", "3555406", "", "", "-23.43389", "-45.07111", "America/Sao_Paulo"),
("3445849", "Ubata", "", "BR", "76", "05", "2932309", "", "", "-14.21389", "-39.52278", "America/Bahia"),
("3445853", "Ubaitaba", "", "BR", "76", "05", "2932200", "", "", "-14.3125", "-39.32333", "America/Bahia"),
("3445859", "Uba", "Уба", "BR", "76", "15", "3169901", "", "", "-21.12", "-42.94278", "America/Sao_Paulo"),
("3445939", "Tupancireta", "", "BR", "76", "23", "4322202", "", "", "-29.08056", "-53.83583", "America/Sao_Paulo"),
("3445941", "Tupaciguara", "Тупасигуара", "BR", "76", "15", "3169604", "", "", "-18.59222", "-48.705", "America/Sao_Paulo"),
("3445942", "Tupa", "Тупа", "BR", "76", "27", "3555000", "", "", "-21.93472", "-50.51361", "America/Sao_Paulo"),
("3445983", "Tucano", "", "BR", "76", "05", "2931905", "", "", "-10.96306", "-38.78667", "America/Bahia"),
("3445993", "Tubarao", "Тубаран", "BR", "76", "26", "4218707", "", "", "-28.46667", "-49.00694", "America/Sao_Paulo"),
("3446038", "Trindade", "Триндади", "BR", "76", "29", "5221403", "", "", "-16.64944", "-49.48889", "America/Sao_Paulo"),
("3446065", "Tres Rios", "", "BR", "76", "21", "3306008", "", "", "-22.11667", "-43.20917", "America/Sao_Paulo"),
("3446077", "Tres Pontas", "Трес-Понтас", "BR", "76", "15", "3169406", "", "", "-21.36667", "-45.5125", "America/Sao_Paulo"),
("3446087", "Tres Passos", "", "BR", "76", "23", "4321907", "", "", "-27.45556", "-53.93194", "America/Sao_Paulo"),
("3446098", "Tres Lagoas", "Трес-Лагоас", "BR", "76", "11", "5008305", "", "", "-20.78741", "-51.70406", "America/Campo_Grande"),
("3446130", "Tres de Maio", "", "BR", "76", "23", "4321808", "", "", "-27.77333", "-54.24", "America/Sao_Paulo"),
("3446137", "Tres Coroas", "", "BR", "76", "23", "4321709", "", "", "-29.51694", "-50.77778", "America/Sao_Paulo"),
("3446138", "Tres Coracoes", "", "BR", "76", "15", "3169307", "", "", "-21.69694", "-45.25333", "America/Sao_Paulo"),
("3446194", "Tremembe", "", "BR", "76", "27", "3554805", "", "", "-22.95833", "-45.54944", "America/Sao_Paulo"),
("3446232", "Tramandai", "", "BR", "76", "23", "4321600", "", "", "-29.98472", "-50.13361", "America/Sao_Paulo"),
("3446295", "Torres", "Торрес", "BR", "76", "23", "4321501", "", "", "-29.33528", "-49.72694", "America/Sao_Paulo"),
("3446370", "Toledo", "Толедо", "BR", "76", "18", "4127700", "", "", "-24.71361", "-53.74306", "America/Sao_Paulo"),
("3446400", "Tobias Barreto", "", "BR", "76", "28", "2807402", "", "", "-11.18389", "-37.99833", "America/Maceio"),
("3446445", "Timoteo", "Тимофей", "BR", "76", "15", "3168705", "", "", "-19.5825", "-42.64444", "America/Sao_Paulo"),
("3446465", "Timbo", "", "BR", "76", "26", "4218202", "", "", "-26.82333", "-49.27167", "America/Sao_Paulo"),
("3446500", "Tijucas", "Тижукас", "BR", "76", "26", "4218004", "", "", "-27.24139", "-48.63361", "America/Sao_Paulo"),
("3446539", "Tiete", "", "BR", "76", "27", "3554508", "", "", "-23.10194", "-47.71472", "America/Sao_Paulo"),
("3446556", "Teutonia", "", "BR", "76", "23", "4321451", "", "", "-29.44806", "-51.80639", "America/Sao_Paulo"),
("3446606", "Teresopolis", "Терезополис", "BR", "76", "21", "3305802", "", "", "-22.41222", "-42.96556", "America/Sao_Paulo"),
("3446621", "Teofilo Otoni", "Теофилу-Отони", "BR", "76", "15", "3168606", "", "", "-17.8575", "-41.50528", "America/Sao_Paulo"),
("3446625", "Teodoro Sampaio", "", "BR", "76", "27", "3554300", "", "", "-22.5325", "-52.1675", "America/Sao_Paulo"),
("3446652", "Telemaco Borba", "", "BR", "76", "18", "4127106", "", "", "-24.32389", "-50.61556", "America/Sao_Paulo"),
("3446682", "Taubate", "Таубате", "BR", "76", "27", "3554102", "", "", "-23.02639", "-45.55528", "America/Sao_Paulo"),
("3446692", "Tatui", "", "BR", "76", "27", "3554003", "", "", "-23.35556", "-47.85694", "America/Sao_Paulo"),
("3446752", "Taquarituba", "", "BR", "76", "27", "3553807", "", "", "-23.53306", "-49.24444", "America/Sao_Paulo"),
("3446753", "Taquaritinga", "", "BR", "76", "27", "3553708", "", "", "-21.40611", "-48.50472", "America/Sao_Paulo"),
("3446783", "Taquari", "Такуари", "BR", "76", "23", "4321303", "", "", "-29.79972", "-51.86444", "America/Sao_Paulo"),
("3446847", "Taquara", "", "BR", "76", "23", "4321204", "", "", "-29.65056", "-50.78056", "America/Sao_Paulo"),
("3446866", "Tapiramuta", "", "BR", "76", "05", "2931301", "", "", "-11.84722", "-40.79139", "America/Bahia"),
("3446880", "Tapes", "", "BR", "76", "23", "4321105", "", "", "-30.67333", "-51.39583", "America/Sao_Paulo"),
("3446974", "Tangua", "", "BR", "76", "21", "3305752", "", "", "-22.73028", "-42.71417", "America/Sao_Paulo"),
("3446979", "Tanabi", "", "BR", "76", "27", "3553401", "", "", "-20.62639", "-49.64917", "America/Sao_Paulo"),
("3447005", "Tambau", "", "BR", "76", "27", "3553302", "", "", "-21.705", "-47.27444", "America/Sao_Paulo"),
("3447059", "Taiobeiras", "Тайобейрас", "BR", "76", "15", "3168002", "", "", "-15.80778", "-42.23306", "America/Sao_Paulo"),
("3447186", "Taboao da Serra", "", "BR", "76", "27", "3552809", "", "", "-23.62611", "-46.79167", "America/Sao_Paulo"),
("3447212", "Suzano", "Сузано", "BR", "76", "27", "3552502", "", "", "-23.5425", "-46.31083", "America/Sao_Paulo"),
("3447259", "Sumare", "Сумаре", "BR", "76", "27", "3552403", "", "", "-22.82194", "-47.26694", "America/Sao_Paulo"),
("3447399", "Sorocaba", "Сорокаба", "BR", "76", "27", "3552205", "", "", "-23.50167", "-47.45806", "America/Sao_Paulo"),
("3447423", "Soledade", "", "BR", "76", "23", "4320800", "", "", "-28.81833", "-52.51028", "America/Sao_Paulo"),
("3447437", "Socorro", "Сокорро", "BR", "76", "27", "3552106", "", "", "-22.59139", "-46.52889", "America/Sao_Paulo"),
("3447473", "Sobradinho", "", "BR", "76", "05", "2929107", "", "", "-12.83333", "-39.1", "America/Bahia"),
("3447562", "Simao Dias", "", "BR", "76", "28", "2807105", "", "", "-10.73833", "-37.81111", "America/Maceio"),
("3447591", "Silva Jardim", "", "BR", "76", "21", "3305604", "", "", "-22.65083", "-42.39167", "America/Sao_Paulo"),
("3447597", "Sidrolandia", "", "BR", "76", "11", "5007901", "", "", "-20.93194", "-54.96139", "America/Campo_Grande"),
("3447624", "Sete Lagoas", "Сети-Лагоас", "BR", "76", "15", "3167202", "", "", "-19.46583", "-44.24667", "America/Sao_Paulo"),
("3447651", "Sertaozinho", "", "BR", "76", "27", "3551702", "", "", "-21.13778", "-47.99028", "America/Sao_Paulo"),
("3447690", "Serrinha", "", "BR", "76", "05", "2930501", "", "", "-11.66417", "-39.0075", "America/Bahia"),
("3447718", "Serra Negra", "", "BR", "76", "27", "3551603", "", "", "-22.61222", "-46.70056", "America/Sao_Paulo"),
("3447720", "Serrana", "", "BR", "76", "27", "3551504", "", "", "-21.21139", "-47.59556", "America/Sao_Paulo"),
("3447779", "Serra", "Серра", "BR", "76", "08", "3205002", "", "", "-20.12861", "-40.30778", "America/Sao_Paulo"),
("3447785", "Seropedica", "", "BR", "76", "21", "3305554", "", "", "-22.74389", "-43.7075", "America/Sao_Paulo"),
("3447839", "Senhor do Bonfim", "", "BR", "76", "05", "2930105", "", "", "-10.46139", "-40.18944", "America/Bahia"),
("3447854", "Senador Canedo", "", "BR", "76", "29", "5220454", "", "", "-16.70806", "-49.09306", "America/Sao_Paulo"),
("3447928", "Seabra", "", "BR", "76", "05", "2929909", "", "", "-12.41861", "-41.77028", "America/Bahia"),
("3447929", "Schroeder", "", "BR", "76", "26", "4217402", "", "", "-26.4125", "-49.07306", "America/Sao_Paulo"),
("3447961", "Saubara", "", "BR", "76", "05", "2929750", "", "", "-12.7375", "-38.76861", "America/Bahia"),
("3447969", "Sarzedo", "", "BR", "76", "15", "3165537", "", "", "-20.03528", "-44.14472", "America/Sao_Paulo"),
("3447997", "Sarandi", "Саранди", "BR", "76", "23", "4320107", "", "", "-27.94389", "-52.92306", "America/Sao_Paulo"),
("3447998", "Sarandi", "", "BR", "76", "18", "4126256", "", "", "-23.44361", "-51.87389", "America/Sao_Paulo"),
("3448011", "Saquarema", "", "BR", "76", "21", "3305505", "", "", "-22.92", "-42.51028", "America/Sao_Paulo"),
("3448031", "Sapucaia", "Сапукая", "BR", "76", "23", "4320008", "", "", "-29.83333", "-51.15", "America/Sao_Paulo"),
("3448063", "Sapiranga", "", "BR", "76", "23", "4319901", "", "", "-29.63806", "-51.00694", "America/Sao_Paulo"),
("3448136", "Sao Vicente", "Сан-Висенти", "BR", "76", "27", "3551009", "", "", "-23.96306", "-46.39194", "America/Sao_Paulo"),
("3448207", "Sao Sepe", "", "BR", "76", "23", "4319604", "", "", "-30.16056", "-53.56528", "America/Sao_Paulo"),
("3448219", "Sao Sebastiao do Passe", "", "BR", "76", "05", "2929503", "", "", "-12.5125", "-38.49528", "America/Bahia"),
("3448221", "Sao Sebastiao do Paraiso", "Сан-Себастьян-ду-Параисо", "BR", "76", "15", "3164704", "", "", "-20.91694", "-46.99139", "America/Sao_Paulo"),
("3448227", "Sao Sebastiao do Cai", "", "BR", "76", "23", "4319505", "", "", "-29.58667", "-51.37556", "America/Sao_Paulo"),
("3448257", "Sao Sebastiao", "", "BR", "76", "27", "3550704", "", "", "-23.76", "-45.40972", "America/Sao_Paulo"),
("3448300", "Sao Roque", "", "BR", "76", "27", "3550605", "", "", "-23.52917", "-47.13528", "America/Sao_Paulo"),
("3448351", "Sao Pedro da Aldeia", "", "BR", "76", "21", "3305208", "", "", "-22.83917", "-42.10278", "America/Sao_Paulo"),
("3448403", "Sao Pedro", "", "BR", "76", "27", "3550407", "", "", "-22.54861", "-47.91389", "America/Sao_Paulo"),
("3448439", "Sao Paulo", "Сан-Паулу", "BR", "76", "27", "3550308", "", "", "-23.5475", "-46.63611", "America/Sao_Paulo"),
("3448453", "Sao Miguel do Iguacu", "", "BR", "76", "18", "4125704", "", "", "-25.34806", "-54.23778", "America/Sao_Paulo"),
("3448455", "Sao Miguel do Araguaia", "", "BR", "76", "29", "5220207", "", "", "-13.275", "-50.16278", "America/Sao_Paulo"),
("3448502", "Sao Mateus do Sul", "Сан-Матеус-ду-Сул", "BR", "76", "18", "4125605", "", "", "-25.87417", "-50.38278", "America/Sao_Paulo"),
("3448519", "Sao Mateus", "Сан-Матеус", "BR", "76", "08", "3204906", "", "", "-18.72011", "-39.85891", "America/Sao_Paulo"),
("3448533", "Sao Marcos", "", "BR", "76", "23", "4319000", "", "", "-28.97111", "-51.06806", "America/Sao_Paulo"),
("3448545", "Sao Manuel", "Сан-Мануэль", "BR", "76", "27", "3550100", "", "", "-22.73111", "-48.57056", "America/Sao_Paulo"),
("3448552", "Sao Luiz Gonzaga", "", "BR", "76", "23", "4318903", "", "", "-28.40833", "-54.96083", "America/Sao_Paulo"),
("3448558", "Sao Luis de Montes Belos", "", "BR", "76", "29", "5220108", "", "", "-16.525", "-50.37222", "America/Sao_Paulo"),
("3448596", "Sao Lourenco do Sul", "Сан-Лоренсу-ду-Сул", "BR", "76", "23", "4318804", "", "", "-31.36528", "-51.97833", "America/Sao_Paulo"),
("3448616", "Sao Lourenco", "Сан-Лоренсу", "BR", "76", "15", "3163706", "", "", "-22.11639", "-45.05444", "America/Sao_Paulo"),
("3448622", "Sao Leopoldo", "Сан-Леополду", "BR", "76", "23", "4318705", "", "", "-29.76028", "-51.14722", "America/Sao_Paulo"),
("3448632", "Sao Jose dos Pinhais", "Сан-Жозе-дус-Пиньяйс", "BR", "76", "18", "4125506", "", "", "-25.53472", "-49.20639", "America/Sao_Paulo"),
("3448636", "Sao Jose dos Campos", "Сан-Жозе-дус-Кампус", "BR", "76", "27", "3549904", "", "", "-23.17944", "-45.88694", "America/Sao_Paulo"),
("3448639", "Sao Jose do Rio Preto", "Сан-Жозе-ду-Риу-Прету", "BR", "76", "27", "3549805", "", "", "-20.81972", "-49.37944", "America/Sao_Paulo"),
("3448640", "Sao Jose do Rio Pardo", "", "BR", "76", "27", "3549706", "", "", "-21.59556", "-46.88861", "America/Sao_Paulo"),
("3448742", "Sao Jose", "", "BR", "76", "26", "4202800", "", "", "-28.21171", "-49.1632", "America/Sao_Paulo"),
("3448825", "Sao Joaquim da Barra", "", "BR", "76", "27", "3549409", "", "", "-20.58139", "-47.85472", "America/Sao_Paulo"),
("3448828", "Sao Joaquim", "", "BR", "76", "26", "4216503", "", "", "-28.29389", "-49.93167", "America/Sao_Paulo"),
("3448846", "Sao Joao Nepomuceno", "Сан-Жуан-Непомусено", "BR", "76", "15", "3162906", "", "", "-21.54", "-43.01056", "America/Sao_Paulo"),
("3448877", "Sao Joao de Meriti", "Сан-Жуан-ди-Мерити", "BR", "76", "21", "3305109", "", "", "-22.80389", "-43.37222", "America/Sao_Paulo"),
("3448879", "Sao Joao del Rei", "Сан-Жуан-дел-Рей", "BR", "76", "15", "3162500", "", "", "-21.13556", "-44.26167", "America/Sao_Paulo"),
("3448902", "Sao Joao da Boa Vista", "", "BR", "76", "27", "3549102", "", "", "-21.96917", "-46.79806", "America/Sao_Paulo"),
("3448903", "Sao Joao da Barra", "Сан-Жуан-да-Барра", "BR", "76", "21", "3305000", "", "", "-21.64028", "-41.05111", "America/Sao_Paulo"),
("3449045", "Sao Jeronimo", "", "BR", "76", "23", "4318408", "", "", "-29.95917", "-51.72222", "America/Sao_Paulo"),
("3449053", "Sao Gotardo", "", "BR", "76", "15", "3162104", "", "", "-19.31111", "-46.04889", "America/Sao_Paulo"),
("3449056", "Sao Goncalo do Sapucai", "", "BR", "76", "15", "3162005", "", "", "-21.89222", "-45.59528", "America/Sao_Paulo"),
("3449099", "Sao Gabriel", "", "BR", "76", "23", "4318309", "", "", "-30.33639", "-54.32", "America/Sao_Paulo"),
("3449112", "Sao Francisco do Sul", "Сан-Франсиску-ду-Сул", "BR", "76", "26", "4216206", "", "", "-26.24333", "-48.63806", "America/Sao_Paulo"),
("3449116", "Sao Francisco do Conde", "Сан-Франсиску-ду-Конде", "BR", "76", "05", "2929206", "", "", "-12.6275", "-38.68", "America/Bahia"),
("3449176", "Sao Francisco", "", "BR", "76", "15", "3161106", "", "", "-15.94861", "-44.86444", "America/Sao_Paulo"),
("3449195", "Sao Fidelis", "", "BR", "76", "21", "3304805", "", "", "-21.64611", "-41.74694", "America/Sao_Paulo"),
("3449310", "Sao Cristovao", "Сан-Кристован", "BR", "76", "28", "2806701", "", "", "-11.01472", "-37.20639", "America/Maceio"),
("3449319", "Sao Carlos", "Сан-Карлос", "BR", "76", "27", "3548906", "", "", "-22.0175", "-47.89083", "America/Sao_Paulo"),
("3449324", "Sao Caetano do Sul", "Сан-Каэтано-ду-Сул", "BR", "76", "27", "3548807", "", "", "-23.62306", "-46.55111", "America/Sao_Paulo"),
("3449340", "Sao Borja", "Сан-Борха", "BR", "76", "23", "4318002", "", "", "-28.66056", "-56.00444", "America/Sao_Paulo"),
("3449344", "Sao Bernardo do Campo", "Сан-Бернардо-ду-Кампу", "BR", "76", "27", "3548708", "", "", "-23.69389", "-46.565", "America/Sao_Paulo"),
("3449350", "Sao Bento do Sul", "Сан-Бенту-ду-Сул", "BR", "76", "26", "4215802", "", "", "-26.25028", "-49.37861", "America/Sao_Paulo"),
("3449427", "Santos Dumont", "", "BR", "76", "15", "3160702", "", "", "-21.45667", "-43.5525", "America/Sao_Paulo"),
("3449433", "Santos", "Сантос", "BR", "76", "27", "3548500", "", "", "-23.96083", "-46.33361", "America/Sao_Paulo"),
("3449467", "Santo Estevao", "", "BR", "76", "05", "2928802", "", "", "-12.43028", "-39.25139", "America/Bahia"),
("3449500", "Santo Antonio do Monte", "", "BR", "76", "15", "3160405", "", "", "-20.08722", "-45.29361", "America/Sao_Paulo"),
("3449516", "Santo Antonio do Amparo", "", "BR", "76", "15", "3159902", "", "", "-20.94639", "-44.91889", "America/Sao_Paulo"),
("3449518", "Santo Antonio de Posse", "", "BR", "76", "27", "3548005", "", "", "-22.60611", "-46.91944", "America/Sao_Paulo"),
("3449519", "Santo Antonio de Padua", "", "BR", "76", "21", "3304706", "", "", "-21.53944", "-42.18028", "America/Sao_Paulo"),
("3449521", "Santo Antonio de Jesus", "", "BR", "76", "05", "2928703", "", "", "-12.96889", "-39.26139", "America/Bahia"),
("3449529", "Santo Antonio da Platina", "Санту-Антониу-да-Платина", "BR", "76", "18", "4124103", "", "", "-23.295", "-50.07722", "America/Sao_Paulo"),
("3449696", "Santo Angelo", "Санту-Анджело", "BR", "76", "23", "4317509", "", "", "-28.29917", "-54.26306", "America/Sao_Paulo"),
("3449701", "Santo Andre", "Санту-Андре", "BR", "76", "27", "3547809", "", "", "-23.66389", "-46.53833", "America/Sao_Paulo"),
("3449707", "Santo Anastacio", "", "BR", "76", "27", "3543238", "", "", "-21.83833", "-51.61028", "America/Sao_Paulo"),
("3449711", "Santo Amaro da Imperatriz", "", "BR", "76", "26", "4215703", "", "", "-27.68806", "-48.77861", "America/Sao_Paulo"),
("3449720", "Santo Amaro", "", "BR", "76", "05", "2928604", "", "", "-12.54667", "-38.71194", "America/Bahia"),
("3449741", "Santiago", "Сантьяго", "BR", "76", "23", "4317400", "", "", "-29.19167", "-54.86722", "America/Sao_Paulo"),
("3449747", "Santa Vitoria do Palmar", "", "BR", "76", "23", "4317301", "", "", "-33.51889", "-53.36806", "America/Sao_Paulo"),
("3449793", "Santa Rosa de Viterbo", "", "BR", "76", "27", "3547601", "", "", "-21.47278", "-47.36306", "America/Sao_Paulo"),
("3449822", "Santa Rosa", "", "BR", "76", "23", "4317202", "", "", "-27.87083", "-54.48139", "America/Sao_Paulo"),
("3449847", "Santa Rita do Sapucai", "Санта-Рита-ду-Сапукайя", "BR", "76", "15", "3159605", "", "", "-22.25222", "-45.70333", "America/Sao_Paulo"),
("3449851", "Santa Rita do Passa Quatro", "", "BR", "76", "27", "3547502", "", "", "-21.71028", "-47.47806", "America/Sao_Paulo"),
("3449933", "Santana do Paraiso", "Сантана-ду-Параисо", "BR", "76", "15", "3158953", "", "", "-19.36361", "-42.56861", "America/Sao_Paulo"),
("3449936", "Santana do Livramento", "Сантана-ду-Ливраменту", "BR", "76", "23", "4317103", "", "", "-30.89083", "-55.53278", "America/Sao_Paulo"),
("3449948", "Santana de Parnaiba", "", "BR", "76", "27", "3547304", "", "", "-23.44417", "-46.91778", "America/Sao_Paulo"),
("3450063", "Santa Maria da Vitoria", "Санта-Мария-да-Витория", "BR", "76", "05", "2929057", "", "", "-13.39472", "-44.18861", "America/Bahia"),
("3450083", "Santa Maria", "Санта-Мария", "BR", "76", "23", "4316907", "", "", "-29.68417", "-53.80694", "America/Sao_Paulo"),
("3450144", "Santa Luzia", "Санта-Лусия", "BR", "76", "15", "3157807", "", "", "-19.76972", "-43.85139", "America/Sao_Paulo"),
("3450157", "Santaluz", "", "BR", "76", "05", "2928000", "", "", "-11.25583", "-39.37472", "America/Bahia"),
("3450188", "Santa Isabel", "", "BR", "76", "27", "3546801", "", "", "-23.31556", "-46.22139", "America/Sao_Paulo"),
("3450206", "Santa Helena de Goias", "Санта-Элена-ди-Гояс", "BR", "76", "29", "5219308", "", "", "-17.81361", "-50.59694", "America/Sao_Paulo"),
("3450225", "Santa Gertrudes", "", "BR", "76", "27", "3546702", "", "", "-22.45667", "-47.53028", "America/Sao_Paulo"),
("3450232", "Santa Fe do Sul", "", "BR", "76", "27", "3546603", "", "", "-20.21111", "-50.92583", "America/Sao_Paulo"),
("3450269", "Santa Cruz do Sul", "Санта-Крус-ду-Сул", "BR", "76", "23", "4316808", "", "", "-29.7175", "-52.42583", "America/Sao_Paulo"),
("3450272", "Santa Cruz do Rio Pardo", "", "BR", "76", "27", "3546405", "", "", "-22.89889", "-49.6325", "America/Sao_Paulo"),
("3450283", "Santa Cruz das Palmeiras", "", "BR", "76", "27", "3546306", "", "", "-21.82694", "-47.24861", "America/Sao_Paulo"),
("3450288", "Santa Cruz Cabralia", "", "BR", "76", "05", "2927705", "", "", "-16.27806", "-39.02472", "America/Bahia"),
("3450376", "Santa Cecilia", "", "BR", "76", "26", "4215505", "", "", "-26.96083", "-50.42694", "America/Sao_Paulo"),
("3450404", "Santa Barbara d'Oeste", "", "BR", "76", "27", "3545803", "", "", "-22.75361", "-47.41361", "America/Sao_Paulo"),
("3450554", "Salvador", "Салвадор", "BR", "76", "05", "2927408", "", "", "-12.97111", "-38.51083", "America/Bahia"),
("3450563", "Salto de Pirapora", "", "BR", "76", "27", "3545308", "", "", "-23.64889", "-47.57333", "America/Sao_Paulo"),
("3450594", "Salto", "Сальто", "BR", "76", "27", "3545209", "", "", "-23.20083", "-47.28694", "America/Sao_Paulo"),
("3450671", "Salinas", "", "BR", "76", "15", "3157005", "", "", "-16.17028", "-42.29028", "America/Sao_Paulo"),
("3450759", "Sacramento", "", "BR", "76", "15", "3156908", "", "", "-19.86528", "-47.44", "America/Sao_Paulo"),
("3450832", "Ruy Barbosa", "", "BR", "76", "05", "2927200", "", "", "-12.28389", "-40.49389", "America/Bahia"),
("3450843", "Rubiataba", "", "BR", "76", "29", "5218904", "", "", "-15.16444", "-49.80333", "America/Sao_Paulo"),
("3450873", "Rosario do Sul", "Росарио-ду-Сул", "BR", "76", "23", "4316402", "", "", "-30.25833", "-54.91417", "America/Sao_Paulo"),
("3450909", "Rondonopolis", "", "BR", "76", "14", "5107602", "", "", "-16.47083", "-54.63556", "America/Cuiaba"),
("3450963", "Rolante", "", "BR", "76", "23", "4316006", "", "", "-29.65056", "-50.57583", "America/Sao_Paulo"),
("3450964", "Rolandia", "", "BR", "76", "18", "4122404", "", "", "-23.30972", "-51.36917", "America/Sao_Paulo"),
("3451051", "Rio Verde de Mato Grosso", "", "BR", "76", "11", "5007406", "", "", "-18.91806", "-54.84417", "America/Campo_Grande"),
("3451071", "Rio Real", "", "BR", "76", "05", "2927002", "", "", "-11.48472", "-37.93278", "America/Bahia"),
("3451102", "Rio Pardo", "Рио-Пардо", "BR", "76", "23", "4315701", "", "", "-29.98972", "-52.37806", "America/Sao_Paulo"),
("3451121", "Rio Negro", "", "BR", "76", "18", "4122305", "", "", "-26.10583", "-49.7975", "America/Sao_Paulo"),
("3451124", "Rio Negrinho", "", "BR", "76", "26", "4215000", "", "", "-26.25444", "-49.51833", "America/Sao_Paulo"),
("3451134", "Rio Grande da Serra", "", "BR", "76", "27", "3544103", "", "", "-23.74417", "-46.39833", "America/Sao_Paulo"),
("3451138", "Rio Grande", "Рио-Гранде", "BR", "76", "23", "4315602", "", "", "-32.035", "-52.09861", "America/Sao_Paulo"),
("3451152", "Rio do Sul", "Риу-ду-Сул", "BR", "76", "26", "4214805", "", "", "-27.21417", "-49.64306", "America/Sao_Paulo"),
("3451190", "Rio de Janeiro", "Рио-де-Жанейро", "BR", "76", "21", "3304557", "", "", "-22.90278", "-43.2075", "America/Sao_Paulo"),
("3451202", "Rio das Pedras", "", "BR", "76", "27", "3544004", "", "", "-22.84333", "-47.60611", "America/Sao_Paulo"),
("3451205", "Rio das Ostras", "", "BR", "76", "21", "3304524", "", "", "-22.52694", "-41.945", "America/Sao_Paulo"),
("3451234", "Rio Claro", "", "BR", "76", "27", "3543907", "", "", "-22.41139", "-47.56139", "America/Sao_Paulo"),
("3451241", "Rio Brilhante", "", "BR", "76", "11", "5007208", "", "", "-21.80194", "-54.54639", "America/Campo_Grande"),
("3451242", "Rio Branco do Sul", "Риу-Бранку-ду-Сул", "BR", "76", "18", "4122206", "", "", "-25.19", "-49.31417", "America/Sao_Paulo"),
("3451261", "Rio Bonito", "", "BR", "76", "21", "3304300", "", "", "-22.70861", "-42.60972", "America/Sao_Paulo"),
("3451328", "Ribeirao Preto", "Рибейран-Прету", "BR", "76", "27", "3543402", "", "", "-21.1775", "-47.81028", "America/Sao_Paulo"),
("3451329", "Ribeirao Pires", "", "BR", "76", "27", "3543303", "", "", "-23.71056", "-46.41333", "America/Sao_Paulo"),
("3451353", "Ribeirao das Neves", "", "BR", "76", "15", "3154606", "", "", "-19.76694", "-44.08667", "America/Sao_Paulo"),
("3451357", "Ribeirao da Ilha", "", "BR", "76", "26", "4205407", "", "", "-27.69934", "-48.53219", "America/Sao_Paulo"),
("3451383", "Ribeira do Pombal", "", "BR", "76", "05", "2926608", "", "", "-10.83444", "-38.53583", "America/Bahia"),
("3451474", "Riachao do Jacuipe", "", "BR", "76", "05", "2926301", "", "", "-11.80694", "-39.38556", "America/Bahia"),
("3451650", "Resplendor", "", "BR", "76", "15", "3154309", "", "", "-19.32556", "-41.25528", "America/Sao_Paulo"),
("3451668", "Resende", "Резенди", "BR", "76", "21", "3304201", "", "", "-22.46889", "-44.44667", "America/Sao_Paulo"),
("3451704", "Registro", "", "BR", "76", "27", "3542602", "", "", "-24.4875", "-47.84361", "America/Sao_Paulo"),
("3451709", "Regente Feijo", "", "BR", "76", "27", "3542404", "", "", "-22.22139", "-51.30278", "America/Sao_Paulo"),
("3451856", "Rancharia", "", "BR", "76", "27", "3542206", "", "", "-22.22917", "-50.89306", "America/Sao_Paulo"),
("3451931", "Quirinopolis", "", "BR", "76", "29", "5218508", "", "", "-18.44833", "-50.45167", "America/Sao_Paulo"),
("3452073", "Queimados", "", "BR", "76", "21", "3304144", "", "", "-22.71611", "-43.55528", "America/Sao_Paulo"),
("3452141", "Quatro Barras", "", "BR", "76", "18", "4120804", "", "", "-25.36556", "-49.07694", "America/Sao_Paulo"),
("3452179", "Quarai", "Куараи", "BR", "76", "23", "4315305", "", "", "-30.3875", "-56.45139", "America/Sao_Paulo"),
("3452216", "Prudentopolis", "", "BR", "76", "18", "4120606", "", "", "-25.21306", "-50.97778", "America/Sao_Paulo"),
("3452233", "Propria", "", "BR", "76", "28", "2805703", "", "", "-10.21111", "-36.84028", "America/Maceio"),
("3452237", "Promissao", "", "BR", "76", "27", "3541604", "", "", "-21.53667", "-49.85806", "America/Sao_Paulo"),
("3452320", "Presidente Venceslau", "", "BR", "76", "27", "3541505", "", "", "-21.87611", "-51.84389", "America/Sao_Paulo"),
("3452324", "Presidente Prudente", "Президенти-Пруденти", "BR", "76", "27", "3541406", "", "", "-22.12556", "-51.38889", "America/Sao_Paulo"),
("3452331", "Presidente Epitacio", "", "BR", "76", "27", "3541307", "", "", "-21.76333", "-52.11556", "America/Sao_Paulo"),
("3452440", "Prata", "", "BR", "76", "15", "3152808", "", "", "-19.30722", "-48.92417", "America/Sao_Paulo"),
("3452465", "Praia Grande", "Прайя-Гранди", "BR", "76", "27", "3541000", "", "", "-24.00583", "-46.40278", "America/Sao_Paulo"),
("3452483", "Prado", "", "BR", "76", "05", "2925501", "", "", "-17.34111", "-39.22083", "America/Bahia"),
("3452525", "Pouso Alegre", "Позу-Алегри", "BR", "76", "15", "3152501", "", "", "-22.23", "-45.93639", "America/Sao_Paulo"),
("3452599", "Posse", "", "BR", "76", "29", "5218300", "", "", "-14.09306", "-46.36944", "America/Sao_Paulo"),
("3452623", "Porto Uniao", "", "BR", "76", "26", "4213609", "", "", "-26.23806", "-51.07833", "America/Sao_Paulo"),
("3452640", "Porto Seguro", "Порту-Сегуру", "BR", "76", "05", "2925303", "", "", "-16.44972", "-39.06472", "America/Bahia"),
("3452775", "Porto Ferreira", "Порту-Феррейра", "BR", "76", "27", "3540705", "", "", "-21.85389", "-47.47917", "America/Sao_Paulo"),
("3452779", "Porto Feliz", "Порту-Фелис", "BR", "76", "27", "3540606", "", "", "-23.21472", "-47.52389", "America/Sao_Paulo"),
("3452925", "Porto Alegre", "Порту-Алегри", "BR", "76", "23", "4314902", "", "", "-30.03306", "-51.23", "America/Sao_Paulo"),
("3452982", "Portao", "", "BR", "76", "23", "4314803", "", "", "-29.70167", "-51.24194", "America/Sao_Paulo"),
("3453014", "Porangatu", "Порангату", "BR", "76", "29", "5218003", "", "", "-13.44083", "-49.14861", "America/Sao_Paulo"),
("3453060", "Pontes e Lacerda", "", "BR", "76", "14", "5106752", "", "", "-15.22611", "-59.33528", "America/Cuiaba"),
("3453078", "Ponte Nova", "", "BR", "76", "15", "3152105", "", "", "-20.41639", "-42.90861", "America/Sao_Paulo"),
("3453150", "Ponta Pora", "Понта-Поран", "BR", "76", "11", "5006606", "", "", "-22.53611", "-55.72556", "America/Campo_Grande"),
("3453171", "Pontal", "", "BR", "76", "27", "3540200", "", "", "-21.0225", "-48.03722", "America/Sao_Paulo"),
("3453186", "Ponta Grossa", "Понта-Гроса", "BR", "76", "18", "4119905", "", "", "-25.095", "-50.16194", "America/Sao_Paulo"),
("3453240", "Pompeu", "", "BR", "76", "15", "3152006", "", "", "-19.22444", "-44.93528", "America/Sao_Paulo"),
("3453242", "Pompeia", "", "BR", "76", "27", "3540002", "", "", "-22.10861", "-50.17167", "America/Sao_Paulo"),
("3453245", "Pomerode", "", "BR", "76", "26", "4213203", "", "", "-26.74056", "-49.17694", "America/Sao_Paulo"),
("3453303", "Pocos de Caldas", "Посус-ди-Калдас", "BR", "76", "15", "3151800", "", "", "-21.78778", "-46.56139", "America/Sao_Paulo"),
("3453315", "Pocone", "", "BR", "76", "14", "5106505", "", "", "-16.25667", "-56.62278", "America/Cuiaba"),
("3453337", "Pocoes", "", "BR", "76", "05", "2925105", "", "", "-14.52972", "-40.36528", "America/Bahia"),
("3453406", "Poa", "", "BR", "76", "27", "3539806", "", "", "-23.52806", "-46.34472", "America/Sao_Paulo"),
("3453420", "Planaltina", "", "BR", "76", "29", "5217609", "", "", "-15.45278", "-47.61417", "America/Sao_Paulo"),
("3453435", "Piuma", "", "BR", "76", "08", "3204203", "", "", "-20.83778", "-40.72194", "America/Sao_Paulo"),
("3453439", "Piui", "", "BR", "76", "15", "3151503", "", "", "-20.46528", "-45.95806", "America/Sao_Paulo"),
("3453457", "Pitangui", "", "BR", "76", "15", "3151404", "", "", "-19.68278", "-44.89028", "America/Sao_Paulo"),
("3453467", "Pitangueiras", "", "BR", "76", "27", "3539509", "", "", "-21.00944", "-48.22167", "America/Sao_Paulo"),
("3453478", "Pitanga", "", "BR", "76", "18", "4119608", "", "", "-24.75722", "-51.76139", "America/Sao_Paulo"),
("3453494", "Piritiba", "", "BR", "76", "05", "2924801", "", "", "-11.73028", "-40.55528", "America/Bahia"),
("3453503", "Pires do Rio", "Пирес-ду-Риу", "BR", "76", "29", "5217401", "", "", "-17.29972", "-48.27944", "America/Sao_Paulo"),
("3453535", "Piraquara", "", "BR", "76", "18", "4119509", "", "", "-25.44167", "-49.06333", "America/Sao_Paulo"),
("3453542", "Pirapozinho", "", "BR", "76", "27", "3539202", "", "", "-22.27528", "-51.5", "America/Sao_Paulo"),
("3453546", "Pirapora", "", "BR", "76", "15", "3151206", "", "", "-17.345", "-44.94194", "America/Sao_Paulo"),
("3453605", "Pirajui", "", "BR", "76", "27", "3538907", "", "", "-21.99861", "-49.45722", "America/Sao_Paulo"),
("3453610", "Piraju", "", "BR", "76", "27", "3538808", "", "", "-23.19361", "-49.38389", "America/Sao_Paulo"),
("3453622", "Pirai do Sul", "", "BR", "76", "18", "4119400", "", "", "-24.52611", "-49.94861", "America/Sao_Paulo"),
("3453635", "Pirai", "", "BR", "76", "21", "3304003", "", "", "-22.62917", "-43.89806", "America/Sao_Paulo"),
("3453639", "Pirassununga", "Пирасунунга", "BR", "76", "27", "3539301", "", "", "-21.99611", "-47.42583", "America/Sao_Paulo"),
("3453643", "Piracicaba", "Пирасикаба", "BR", "76", "27", "3538709", "", "", "-22.72528", "-47.64917", "America/Sao_Paulo"),
("3453659", "Piracanjuba", "", "BR", "76", "29", "5217104", "", "", "-17.30278", "-49.01667", "America/Sao_Paulo"),
("3453661", "Piracaia", "", "BR", "76", "27", "3538600", "", "", "-23.05389", "-46.35806", "America/Sao_Paulo"),
("3453767", "Pinheiral", "", "BR", "76", "21", "3303955", "", "", "-22.51278", "-44.00056", "America/Sao_Paulo"),
("3453777", "Pinhao", "", "BR", "76", "18", "4119301", "", "", "-25.69556", "-51.65972", "America/Sao_Paulo"),
("3453807", "Espirito Santo do Pinhal", "", "BR", "76", "27", "3548104", "", "", "-22.11583", "-46.68278", "America/Sao_Paulo"),
("3453827", "Pindobacu", "", "BR", "76", "05", "2924603", "", "", "-10.74167", "-40.36083", "America/Bahia"),
("3453837", "Pindamonhangaba", "Пиндамоньянгаба", "BR", "76", "27", "3538006", "", "", "-22.92389", "-45.46167", "America/Sao_Paulo"),
("3453896", "Pilar do Sul", "", "BR", "76", "27", "3537909", "", "", "-23.81306", "-47.71639", "America/Sao_Paulo"),
("3453926", "Piedade", "", "BR", "76", "27", "3537800", "", "", "-23.71194", "-47.42778", "America/Sao_Paulo"),
("3454031", "Petropolis", "Петрополис", "BR", "76", "21", "3303906", "", "", "-22.505", "-43.17861", "America/Sao_Paulo"),
("3454061", "Peruibe", "Перуиби", "BR", "76", "27", "3537602", "", "", "-24.32", "-46.99833", "America/Sao_Paulo"),
("3454131", "Pereira Barreto", "", "BR", "76", "27", "3537404", "", "", "-20.63833", "-51.10917", "America/Sao_Paulo"),
("3454139", "Perdoes", "", "BR", "76", "15", "3149903", "", "", "-21.09083", "-45.09139", "America/Sao_Paulo"),
("3454213", "Penha", "Пенья", "BR", "76", "26", "4212502", "", "", "-26.76944", "-48.64583", "America/Sao_Paulo"),
("3454231", "Penedo", "", "BR", "76", "02", "2706703", "", "", "-10.29028", "-36.58639", "America/Maceio"),
("3454235", "Penapolis", "Пенаполис", "BR", "76", "27", "3537305", "", "", "-21.41972", "-50.0775", "America/Sao_Paulo"),
("3454244", "Pelotas", "Пелотас", "BR", "76", "23", "4314407", "", "", "-31.77194", "-52.3425", "America/Sao_Paulo"),
("3454358", "Pedro Leopoldo", "", "BR", "76", "15", "3149309", "", "", "-19.61806", "-44.04306", "America/Sao_Paulo"),
("3454407", "Pedreira", "Педрейра", "BR", "76", "27", "3537107", "", "", "-22.74194", "-46.90139", "America/Sao_Paulo"),
("3454578", "Pedra Azul", "", "BR", "76", "15", "3148707", "", "", "-16.00528", "-41.29722", "America/Sao_Paulo"),
("3454620", "Pederneiras", "", "BR", "76", "27", "3536703", "", "", "-22.35167", "-48.775", "America/Sao_Paulo"),
("3454690", "Paulinia", "Паулиния", "BR", "76", "27", "3536505", "", "", "-22.76111", "-47.15417", "America/Sao_Paulo"),
("3454763", "Patrocinio", "Патросиниу", "BR", "76", "15", "3148103", "", "", "-18.94389", "-46.9925", "America/Sao_Paulo"),
("3454783", "Patos de Minas", "Патус-ди-Минас", "BR", "76", "15", "3148004", "", "", "-18.57889", "-46.51806", "America/Sao_Paulo"),
("3454818", "Pato Branco", "Пату-Бранку", "BR", "76", "18", "4118501", "", "", "-26.22861", "-52.67056", "America/Sao_Paulo"),
("3454827", "Paty do Alferes", "Пати-ду-Алферис", "BR", "76", "21", "3303856", "", "", "-22.42861", "-43.41861", "America/Sao_Paulo"),
("3454847", "Passos", "Пассос", "BR", "76", "15", "3147907", "", "", "-20.71889", "-46.60972", "America/Sao_Paulo"),
("3454857", "Passo Fundo", "Пасу-Фунду", "BR", "76", "23", "4314100", "", "", "-28.26278", "-52.40667", "America/Sao_Paulo"),
("3454954", "Parobe", "", "BR", "76", "23", "4314050", "", "", "-29.62861", "-50.83472", "America/Sao_Paulo"),
("3455036", "Paraty", "", "BR", "76", "21", "3303807", "", "", "-23.21778", "-44.71306", "America/Sao_Paulo"),
("3455051", "Paranavai", "", "BR", "76", "18", "4118402", "", "", "-23.07306", "-52.46528", "America/Sao_Paulo"),
("3455061", "Paranapanema", "", "BR", "76", "27", "3535804", "", "", "-23.3863", "-48.72441", "America/Sao_Paulo"),
("3455065", "Paranaiba", "Паранаиба", "BR", "76", "11", "5006309", "", "", "-19.67722", "-51.19083", "America/Campo_Grande"),
("3455070", "Paranagua", "Паранагуа", "BR", "76", "18", "4118204", "", "", "-25.51944", "-48.51992", "America/Sao_Paulo"),
("3455141", "Paraiba do Sul", "Параиба-ду-Сул", "BR", "76", "21", "3303708", "", "", "-22.16194", "-43.29278", "America/Sao_Paulo"),
("3455152", "Paraguacu Paulista", "", "BR", "76", "27", "3535507", "", "", "-22.41278", "-50.57583", "America/Sao_Paulo"),
("3455155", "Paraguacu", "", "BR", "76", "15", "3147204", "", "", "-21.54722", "-45.7375", "America/Sao_Paulo"),
("3455161", "Para de Minas", "Пара-ди-Минас", "BR", "76", "15", "3147105", "", "", "-19.86028", "-44.60833", "America/Sao_Paulo"),
("3455168", "Paracatu", "Паракату", "BR", "76", "15", "3147006", "", "", "-17.22222", "-46.87472", "America/Sao_Paulo"),
("3455170", "Paracambi", "", "BR", "76", "21", "3303609", "", "", "-22.60829", "-43.7084", "America/Sao_Paulo"),
("3455281", "Panambi", "", "BR", "76", "23", "4313904", "", "", "-28.2925", "-53.50167", "America/Sao_Paulo"),
("3455298", "Palotina", "", "BR", "76", "18", "4117909", "", "", "-24.28389", "-53.84", "America/Sao_Paulo"),
("3455342", "Palmital", "", "BR", "76", "27", "3535309", "", "", "-22.78889", "-50.2175", "America/Sao_Paulo"),
("3455416", "Palmeira das Missoes", "", "BR", "76", "23", "4313706", "", "", "-27.89944", "-53.31361", "America/Sao_Paulo"),
("3455425", "Palmeira", "", "BR", "76", "18", "4117701", "", "", "-25.42944", "-50.00639", "America/Sao_Paulo"),
("3455459", "Palmas", "Пальмас", "BR", "76", "18", "4117602", "", "", "-26.48417", "-51.99056", "America/Sao_Paulo"),
("3455478", "Palhoca", "Пальоса", "BR", "76", "26", "4211900", "", "", "-27.64528", "-48.66778", "America/Sao_Paulo"),
("3455553", "Paicandu", "", "BR", "76", "18", "4117503", "", "", "-23.4575", "-52.04861", "America/Sao_Paulo"),
("3455580", "Padre Bernardo", "", "BR", "76", "29", "5215603", "", "", "-15.16595", "-48.28281", "America/Sao_Paulo"),
("3455671", "Ouro Preto", "Ору-Прету", "BR", "76", "15", "3146107", "", "", "-20.39484", "-43.50517", "America/Sao_Paulo"),
("3455689", "Ouro Branco", "", "BR", "76", "15", "3145901", "", "", "-20.52083", "-43.69194", "America/Sao_Paulo"),
("3455729", "Ourinhos", "Ориньюс", "BR", "76", "27", "3534708", "", "", "-22.97889", "-49.87056", "America/Sao_Paulo"),
("3455756", "Osvaldo Cruz", "", "BR", "76", "27", "3534609", "", "", "-21.79667", "-50.87861", "America/Sao_Paulo"),
("3455769", "Osorio", "Осорио", "BR", "76", "23", "4313508", "", "", "-29.88667", "-50.26972", "America/Sao_Paulo"),
("3455775", "Osasco", "Осаску", "BR", "76", "27", "3534401", "", "", "-23.5325", "-46.79167", "America/Sao_Paulo"),
("3455784", "Orleans", "", "BR", "76", "26", "4211702", "", "", "-28.35889", "-49.29139", "America/Sao_Paulo"),
("3455785", "Orlandia", "", "BR", "76", "27", "3534302", "", "", "-20.72028", "-47.88667", "America/Sao_Paulo"),
("3455908", "Oliveira", "Оливейра", "BR", "76", "15", "3145604", "", "", "-20.69639", "-44.82722", "America/Sao_Paulo"),
("3455923", "Olimpia", "Олимпия", "BR", "76", "27", "3533908", "", "", "-20.73722", "-48.91472", "America/Sao_Paulo"),
("3456060", "Novo Horizonte", "", "BR", "76", "27", "3533502", "", "", "-21.46806", "-49.22083", "America/Sao_Paulo"),
("3456068", "Novo Hamburgo", "Нову-Амбургу", "BR", "76", "23", "4313409", "", "", "-29.67833", "-51.13056", "America/Sao_Paulo"),
("3456102", "Nova Vicosa", "", "BR", "76", "05", "2923001", "", "", "-17.89194", "-39.37194", "America/Bahia"),
("3456110", "Nova Venecia", "", "BR", "76", "08", "3203908", "", "", "-18.71056", "-40.40056", "America/Sao_Paulo"),
("3456125", "Nova Prata", "", "BR", "76", "23", "4313300", "", "", "-28.78389", "-51.61", "America/Sao_Paulo"),
("3456127", "Nova Petropolis", "", "BR", "76", "23", "4313201", "", "", "-29.37639", "-51.11444", "America/Sao_Paulo"),
("3456137", "Nova Olimpia", "", "BR", "76", "14", "5106232", "", "", "-14.79722", "-57.28806", "America/Cuiaba"),
("3456138", "Nova Odessa", "", "BR", "76", "27", "3533403", "", "", "-22.7775", "-47.29583", "America/Sao_Paulo"),
("3456147", "Nova Lima", "Нова-Лима", "BR", "76", "15", "3144805", "", "", "-19.98556", "-43.84667", "America/Sao_Paulo"),
("3456160", "Nova Iguacu", "Нова-Игуасу", "BR", "76", "21", "3303500", "", "", "-22.75917", "-43.45111", "America/Sao_Paulo"),
("3456164", "Nova Granada", "", "BR", "76", "27", "3533007", "", "", "-20.53389", "-49.31417", "America/Sao_Paulo"),
("3456166", "Nova Friburgo", "Нова-Фрибургу", "BR", "76", "21", "3303401", "", "", "-22.28194", "-42.53111", "America/Sao_Paulo"),
("3456176", "Nova Era", "", "BR", "76", "15", "3144706", "", "", "-19.75", "-43.0375", "America/Sao_Paulo"),
("3456223", "Nossa Senhora do Socorro", "", "BR", "76", "28", "2804805", "", "", "-10.855", "-37.12611", "America/Maceio"),
("3456240", "Nossa Senhora da Gloria", "", "BR", "76", "28", "2804508", "", "", "-10.21833", "-37.42028", "America/Maceio"),
("3456283", "Niteroi", "Нитерой", "BR", "76", "21", "3303302", "", "", "-22.88333", "-43.10361", "America/Sao_Paulo"),
("3456285", "Niquelandia", "Никеландия", "BR", "76", "29", "5214606", "", "", "-14.47389", "-48.45972", "America/Sao_Paulo"),
("3456290", "Nilopolis", "", "BR", "76", "21", "3303203", "", "", "-22.8075", "-43.41389", "America/Sao_Paulo"),
("3456322", "Neropolis", "Нерополис", "BR", "76", "29", "5214507", "", "", "-16.40639", "-49.21861", "America/Sao_Paulo"),
("3456324", "Nepomuceno", "", "BR", "76", "15", "3144607", "", "", "-21.23583", "-45.23583", "America/Sao_Paulo"),
("3456366", "Nazare", "Назар", "BR", "76", "05", "2922508", "", "", "-13.035", "-39.01444", "America/Bahia"),
("3456368", "Navirai", "Навираи", "BR", "76", "11", "5005707", "", "", "-23.065", "-54.19056", "America/Campo_Grande"),
("3456370", "Navegantes", "Навегантис", "BR", "76", "26", "4211306", "", "", "-26.89889", "-48.65417", "America/Sao_Paulo"),
("3456398", "Nanuque", "", "BR", "76", "15", "3144300", "", "", "-17.83917", "-40.35389", "America/Sao_Paulo"),
("3456412", "Muzambinho", "", "BR", "76", "15", "3144102", "", "", "-21.37583", "-46.52556", "America/Sao_Paulo"),
("3456483", "Muritiba", "", "BR", "76", "05", "2908309", "", "", "-12.91667", "-39.25", "America/Bahia"),
("3456500", "Muriae", "Муриаэ", "BR", "76", "15", "3143906", "", "", "-21.13056", "-42.36639", "America/Sao_Paulo"),
("3456593", "Mucuri", "Мукури", "BR", "76", "05", "2922003", "", "", "-18.08639", "-39.55083", "America/Bahia"),
("3456696", "Morro do Chapeu", "", "BR", "76", "05", "2921708", "", "", "-11.54852", "-41.15804", "America/Bahia"),
("3456724", "Morro Agudo", "", "BR", "76", "27", "3531902", "", "", "-20.73139", "-48.05778", "America/Sao_Paulo"),
("3456735", "Morrinhos", "", "BR", "76", "29", "5213806", "", "", "-17.73111", "-49.09944", "America/Sao_Paulo"),
("3456814", "Montes Claros", "Монтис-Кларус", "BR", "76", "15", "3143302", "", "", "-16.735", "-43.86167", "America/Sao_Paulo"),
("3456816", "Monte Santo de Minas", "", "BR", "76", "15", "3143203", "", "", "-21.18972", "-46.98028", "America/Sao_Paulo"),
("3456826", "Montenegro", "Черногория", "BR", "76", "23", "4312401", "", "", "-29.68861", "-51.46111", "America/Sao_Paulo"),
("3456827", "Monte Mor", "", "BR", "76", "27", "3531803", "", "", "-22.94667", "-47.31583", "America/Sao_Paulo"),
("3456848", "Monte Carmelo", "", "BR", "76", "15", "3143104", "", "", "-18.72472", "-47.49861", "America/Sao_Paulo"),
("3456863", "Monte Azul Paulista", "", "BR", "76", "27", "3531506", "", "", "-20.90722", "-48.64139", "America/Sao_Paulo"),
("3456866", "Monte Aprazivel", "", "BR", "76", "27", "3531407", "", "", "-20.7725", "-49.71417", "America/Sao_Paulo"),
("3456873", "Monte Alto", "", "BR", "76", "27", "3531308", "", "", "-21.26111", "-48.49639", "America/Sao_Paulo"),
("3456944", "Mongagua", "", "BR", "76", "27", "3531100", "", "", "-24.09306", "-46.62083", "America/Sao_Paulo"),
("3456998", "Mogi Mirim", "Можи-Мирин", "BR", "76", "27", "3530805", "", "", "-22.43194", "-46.95778", "America/Sao_Paulo"),
("3457000", "Mogi Guacu", "Можи-Гуасу", "BR", "76", "27", "3530706", "", "", "-22.36742", "-46.94389", "America/Sao_Paulo"),
("3457001", "Mogi das Cruzes", "", "BR", "76", "27", "3530607", "", "", "-23.52278", "-46.18833", "America/Sao_Paulo"),
("3457025", "Mococa", "", "BR", "76", "27", "3530508", "", "", "-21.46778", "-47.00472", "America/Sao_Paulo"),
("3457107", "Mirandopolis", "Мирандополис", "BR", "76", "27", "3530102", "", "", "-21.13361", "-51.10167", "America/Sao_Paulo"),
("3457133", "Miracema", "Мирасема", "BR", "76", "21", "3303005", "", "", "-21.41222", "-42.19667", "America/Sao_Paulo"),
("3457147", "Mineiros", "", "BR", "76", "29", "5213103", "", "", "-17.56944", "-52.55111", "America/Sao_Paulo"),
("3457191", "Miguel Pereira", "", "BR", "76", "21", "3302908", "", "", "-22.45389", "-43.46889", "America/Sao_Paulo"),
("3457192", "Miguelopolis", "", "BR", "76", "27", "3529708", "", "", "-20.17944", "-48.03194", "America/Sao_Paulo"),
("3457247", "Mendes", "", "BR", "76", "21", "3302809", "", "", "-22.52667", "-43.73278", "America/Sao_Paulo"),
("3457359", "Medianeira", "Медианейра", "BR", "76", "18", "4115804", "", "", "-25.29528", "-54.09389", "America/Sao_Paulo"),
("3457360", "Medeiros Neto", "", "BR", "76", "05", "2921104", "", "", "-17.37389", "-40.22056", "America/Bahia"),
("3457381", "Maua", "", "BR", "76", "27", "3529401", "", "", "-23.66778", "-46.46139", "America/Sao_Paulo"),
("3457393", "Matozinhos", "", "BR", "76", "15", "3141108", "", "", "-19.55778", "-44.08139", "America/Sao_Paulo"),
("3457484", "Mateus Leme", "", "BR", "76", "15", "3140704", "", "", "-19.98639", "-44.42778", "America/Sao_Paulo"),
("3457509", "Matao", "", "BR", "76", "27", "3529302", "", "", "-21.60333", "-48.36583", "America/Sao_Paulo"),
("3457528", "Mata de Sao Joao", "Мата-де-Сан-Жуан", "BR", "76", "05", "2921005", "", "", "-12.53028", "-38.29917", "America/Bahia"),
("3457566", "Mascote", "", "BR", "76", "05", "2920908", "", "", "-15.56306", "-39.3025", "America/Bahia"),
("3457595", "Martinopolis", "", "BR", "76", "27", "3529203", "", "", "-22.14583", "-51.17083", "America/Sao_Paulo"),
("3457671", "Maringa", "Маринга", "BR", "76", "18", "4115200", "", "", "-23.42528", "-51.93861", "America/Sao_Paulo"),
("3457692", "Marilia", "Марилья", "BR", "76", "27", "3529005", "", "", "-22.21389", "-49.94583", "America/Sao_Paulo"),
("3457708", "Marica", "", "BR", "76", "21", "3302700", "", "", "-22.91944", "-42.81861", "America/Sao_Paulo"),
("3457736", "Mariana", "Мариана", "BR", "76", "15", "3140001", "", "", "-20.37778", "-43.41611", "America/Sao_Paulo"),
("3457741", "Marialva", "", "BR", "76", "18", "4114807", "", "", "-23.485", "-51.79167", "America/Sao_Paulo"),
("3457772", "Marechal Candido Rondon", "", "BR", "76", "18", "4114609", "", "", "-24.55611", "-54.05667", "America/Sao_Paulo"),
("3457817", "Marau", "", "BR", "76", "23", "4311809", "", "", "-28.44917", "-52.2", "America/Sao_Paulo"),
("3457819", "Marataizes", "", "BR", "76", "08", "3203320", "", "", "-21.04333", "-40.82444", "America/Sao_Paulo"),
("3457850", "Maragogipe", "", "BR", "76", "05", "2920601", "", "", "-12.77778", "-38.91944", "America/Bahia"),
("3457854", "Maracas", "", "BR", "76", "05", "2920502", "", "", "-13.44111", "-40.43083", "America/Bahia"),
("3457859", "Maracaju", "", "BR", "76", "11", "5005400", "", "", "-21.61444", "-55.16833", "America/Campo_Grande"),
("3457950", "Manhumirim", "", "BR", "76", "15", "3139508", "", "", "-20.35778", "-41.95806", "America/Sao_Paulo"),
("3457952", "Manhuacu", "Маньюасу", "BR", "76", "15", "3139409", "", "", "-20.25806", "-42.03361", "America/Sao_Paulo"),
("3457991", "Mangaratiba", "", "BR", "76", "21", "3302601", "", "", "-22.95972", "-44.04056", "America/Sao_Paulo"),
("3458049", "Mandaguari", "", "BR", "76", "18", "4114203", "", "", "-23.5475", "-51.67083", "America/Sao_Paulo"),
("3458131", "Mairipora", "Майрипоран", "BR", "76", "27", "3528502", "", "", "-23.31861", "-46.58667", "America/Sao_Paulo"),
("3458132", "Mairinque", "Майринки", "BR", "76", "27", "3528403", "", "", "-23.54583", "-47.18333", "America/Sao_Paulo"),
("3458147", "Mafra", "Мафре", "BR", "76", "26", "4210100", "", "", "-26.11139", "-49.80528", "America/Sao_Paulo"),
("3458211", "Machado", "", "BR", "76", "15", "3139003", "", "", "-21.67472", "-45.91972", "America/Sao_Paulo"),
("3458245", "Macatuba", "", "BR", "76", "27", "3528007", "", "", "-22.50222", "-48.71139", "America/Sao_Paulo"),
("3458266", "Macae", "Макаэ", "BR", "76", "21", "3302403", "", "", "-22.37083", "-41.78694", "America/Sao_Paulo"),
("3458329", "Luziania", "", "BR", "76", "29", "5212501", "", "", "-16.2525", "-47.95028", "America/Sao_Paulo"),
("3458397", "Lucas", "Лукас", "BR", "76", "14", "5101605", "", "", "-16.33333", "-55.93333", "America/Cuiaba"),
("3458406", "Louveira", "", "BR", "76", "27", "3527306", "", "", "-23.08639", "-46.95056", "America/Sao_Paulo"),
("3458425", "Lorena", "", "BR", "76", "27", "3527207", "", "", "-22.73083", "-45.12472", "America/Sao_Paulo"),
("3458449", "Londrina", "Лондрина", "BR", "76", "18", "4113700", "", "", "-23.31028", "-51.16278", "America/Sao_Paulo"),
("3458479", "Loanda", "", "BR", "76", "18", "4113502", "", "", "-22.92306", "-53.13722", "America/Sao_Paulo"),
("3458481", "Livramento do Brumado", "", "BR", "76", "05", "2919504", "", "", "-13.64306", "-41.84056", "America/Bahia"),
("3458494", "Lins", "Линс", "BR", "76", "27", "3527108", "", "", "-21.67861", "-49.7425", "America/Sao_Paulo"),
("3458498", "Linhares", "", "BR", "76", "08", "3203205", "", "", "-19.39111", "-40.07222", "America/Sao_Paulo"),
("3458575", "Limeira", "Лимейра", "BR", "76", "27", "3526902", "", "", "-22.56472", "-47.40167", "America/Sao_Paulo"),
("3458632", "Leopoldina", "", "BR", "76", "15", "3138401", "", "", "-21.53194", "-42.64306", "America/Sao_Paulo"),
("3458645", "Lencois Paulista", "", "BR", "76", "27", "3526803", "", "", "-22.59861", "-48.80028", "America/Sao_Paulo"),
("3458662", "Leme", "Лем", "BR", "76", "27", "3526704", "", "", "-22.18556", "-47.39028", "America/Sao_Paulo"),
("3458696", "Lavras", "Лаврас", "BR", "76", "15", "3138203", "", "", "-21.24528", "-44.99972", "America/Sao_Paulo"),
("3458746", "Laranjeiras do Sul", "", "BR", "76", "18", "4113304", "", "", "-25.40778", "-52.41611", "America/Sao_Paulo"),
("3458778", "Laranjeiras", "", "BR", "76", "28", "2803609", "", "", "-10.80639", "-37.17", "America/Maceio"),
("3458786", "Laranjal Paulista", "", "BR", "76", "27", "3526407", "", "", "-23.04972", "-47.83667", "America/Sao_Paulo"),
("3458826", "Lapa", "", "BR", "76", "18", "4113205", "", "", "-25.76972", "-49.71583", "America/Sao_Paulo"),
("3458902", "Lajinha", "", "BR", "76", "15", "3137700", "", "", "-20.15139", "-41.62278", "America/Sao_Paulo"),
("3458930", "Lages", "Лажис", "BR", "76", "26", "4209300", "", "", "-27.81611", "-50.32611", "America/Sao_Paulo"),
("3459035", "Lajeado", "", "BR", "76", "23", "4311403", "", "", "-29.46694", "-51.96139", "America/Sao_Paulo"),
("3459094", "Laguna", "Лагуна", "BR", "76", "26", "4209409", "", "", "-28.4825", "-48.78083", "America/Sao_Paulo"),
("3459126", "Lagoa Vermelha", "", "BR", "76", "23", "4311304", "", "", "-28.20861", "-51.52583", "America/Sao_Paulo"),
("3459138", "Lagoa Santa", "", "BR", "76", "15", "3137601", "", "", "-19.62722", "-43.88972", "America/Sao_Paulo"),
("3459251", "Lagoa da Prata", "", "BR", "76", "15", "3137205", "", "", "-20.0225", "-45.54361", "America/Sao_Paulo"),
("3459342", "Lagarto", "", "BR", "76", "28", "2803500", "", "", "-10.91722", "-37.65", "America/Maceio"),
("3459352", "Ladario", "", "BR", "76", "11", "5005202", "", "", "-19.00472", "-57.60167", "America/Campo_Grande"),
("3459462", "Jundiai", "Жундиаи", "BR", "76", "27", "3525904", "", "", "-23.18639", "-46.88417", "America/Sao_Paulo"),
("3459495", "Julio de Castilhos", "", "BR", "76", "23", "4311205", "", "", "-29.22694", "-53.68167", "America/Sao_Paulo"),
("3459505", "Juiz de Fora", "Жуис-ди-Фора", "BR", "76", "15", "3136702", "", "", "-21.76417", "-43.35028", "America/Sao_Paulo"),
("3459550", "Juatuba", "", "BR", "76", "15", "3136652", "", "", "-19.95194", "-44.34278", "America/Sao_Paulo"),
("3459667", "Jose Bonifacio", "", "BR", "76", "27", "3525706", "", "", "-21.05278", "-49.68833", "America/Sao_Paulo"),
("3459712", "Joinville", "Жоинвили", "BR", "76", "26", "4209102", "", "", "-26.30444", "-48.84556", "America/Sao_Paulo"),
("3459785", "Joao Pinheiro", "", "BR", "76", "15", "3136306", "", "", "-17.7425", "-46.1725", "America/Sao_Paulo"),
("3459796", "Joao Monlevade", "Жуан-Монлевади", "BR", "76", "15", "3136207", "", "", "-19.81", "-43.17361", "America/Sao_Paulo"),
("3459869", "Joacaba", "Жоасаба", "BR", "76", "26", "4209003", "", "", "-27.17806", "-51.50472", "America/Sao_Paulo"),
("3459922", "Jeremoabo", "", "BR", "76", "05", "2918100", "", "", "-10.075", "-38.48083", "America/Bahia"),
("3459925", "Jequitinhonha", "", "BR", "76", "15", "3135803", "", "", "-16.43389", "-41.00333", "America/Sao_Paulo"),
("3459943", "Jequie", "Жекие", "BR", "76", "05", "2918001", "", "", "-13.8575", "-40.08361", "America/Bahia"),
("3460005", "Jau", "Жау", "BR", "76", "27", "3525300", "", "", "-22.29639", "-48.55778", "America/Sao_Paulo"),
("3460064", "Jatai", "", "BR", "76", "29", "5211909", "", "", "-17.88139", "-51.71444", "America/Sao_Paulo"),
("3460068", "Jarinu", "", "BR", "76", "27", "3525201", "", "", "-23.10139", "-46.72833", "America/Sao_Paulo"),
("3460071", "Jardinopolis", "", "BR", "76", "27", "3525102", "", "", "-21.01778", "-47.76389", "America/Sao_Paulo"),
("3460087", "Jardim", "", "BR", "76", "11", "5005004", "", "", "-21.48028", "-56.13806", "America/Campo_Grande"),
("3460102", "Jaragua do Sul", "Жарагуа-ду-Сул", "BR", "76", "26", "4208906", "", "", "-26.48611", "-49.06667", "America/Sao_Paulo"),
("3460107", "Jaragua", "", "BR", "76", "29", "5211800", "", "", "-15.75694", "-49.33444", "America/Sao_Paulo"),
("3460132", "Japeri", "", "BR", "76", "21", "3302270", "", "", "-22.64306", "-43.65333", "America/Sao_Paulo"),
("3460148", "Januaria", "", "BR", "76", "15", "3135209", "", "", "-15.48866", "-44.35988", "America/Sao_Paulo"),
("3460170", "Jandira", "", "BR", "76", "27", "3525003", "", "", "-23.5275", "-46.9025", "America/Sao_Paulo"),
("3460172", "Jandaia do Sul", "", "BR", "76", "18", "4112108", "", "", "-23.60306", "-51.64333", "America/Sao_Paulo"),
("3460174", "Janauba", "", "BR", "76", "15", "3135100", "", "", "-15.8025", "-43.30889", "America/Sao_Paulo"),
("3460186", "Jales", "", "BR", "76", "27", "3524808", "", "", "-20.26889", "-50.54583", "America/Sao_Paulo"),
("3460200", "Jaguariuna", "", "BR", "76", "27", "3524709", "", "", "-22.70556", "-46.98583", "America/Sao_Paulo"),
("3460214", "Jaguariaiva", "", "BR", "76", "18", "4112009", "", "", "-24.25111", "-49.70583", "America/Sao_Paulo"),
("3460225", "Jaguarari", "", "BR", "76", "05", "2917706", "", "", "-10.26389", "-40.19583", "America/Bahia"),
("3460232", "Jaguarao", "", "BR", "76", "23", "4311007", "", "", "-32.56611", "-53.37583", "America/Sao_Paulo"),
("3460242", "Jaguaquara", "", "BR", "76", "05", "2917607", "", "", "-13.53056", "-39.97083", "America/Bahia"),
("3460267", "Jacutinga", "", "BR", "76", "15", "3134905", "", "", "-22.28556", "-46.61222", "America/Sao_Paulo"),
("3460344", "Jacobina", "", "BR", "76", "05", "2917508", "", "", "-11.18056", "-40.51833", "America/Bahia"),
("3460355", "Jaciara", "", "BR", "76", "14", "5104807", "", "", "-15.96528", "-54.96833", "America/Cuiaba"),
("3460362", "Jacarezinho", "Жакарезинью", "BR", "76", "18", "4111803", "", "", "-23.16056", "-49.96944", "America/Sao_Paulo"),
("3460370", "Jacarei", "Жакареи", "BR", "76", "27", "3524402", "", "", "-23.30528", "-45.96583", "America/Sao_Paulo"),
("3460441", "Jaboticabal", "Жаботикабал", "BR", "76", "27", "3524303", "", "", "-21.25472", "-48.32222", "America/Sao_Paulo"),
("3460484", "Ivoti", "", "BR", "76", "23", "4310801", "", "", "-29.59111", "-51.16056", "America/Sao_Paulo"),
("3460511", "Ituverava", "", "BR", "76", "27", "3524105", "", "", "-20.33944", "-47.78056", "America/Sao_Paulo"),
("3460513", "Iturama", "Итурама", "BR", "76", "15", "3134400", "", "", "-19.72806", "-50.19556", "America/Sao_Paulo"),
("3460516", "Itupeva", "", "BR", "76", "27", "3524006", "", "", "-23.15306", "-47.05778", "America/Sao_Paulo"),
("3460522", "Itumbiara", "Итумбиара", "BR", "76", "29", "5211503", "", "", "-18.41917", "-49.21528", "America/Sao_Paulo"),
("3460523", "Ituiutaba", "Итиютаба", "BR", "76", "15", "3134202", "", "", "-18.96889", "-49.465", "America/Sao_Paulo"),
("3460530", "Itubera", "", "BR", "76", "05", "2917300", "", "", "-13.73222", "-39.14917", "America/Bahia"),
("3460535", "Itu", "Иту", "BR", "76", "27", "3523909", "", "", "-23.26417", "-47.29917", "America/Sao_Paulo"),
("3460542", "Itororo", "", "BR", "76", "05", "2917102", "", "", "-15.11694", "-40.07028", "America/Bahia"),
("3460584", "Itauna", "", "BR", "76", "15", "3133808", "", "", "-20.07528", "-44.57639", "America/Sao_Paulo"),
("3460594", "Itatinga", "", "BR", "76", "27", "3523503", "", "", "-23.10167", "-48.61583", "America/Sao_Paulo"),
("3460598", "Itatiba", "", "BR", "76", "27", "3523404", "", "", "-23.00583", "-46.83889", "America/Sao_Paulo"),
("3460620", "Itarare", "Итараре", "BR", "76", "27", "3523206", "", "", "-24.1125", "-49.33167", "America/Sao_Paulo"),
("3460629", "Itaqui", "Итака", "BR", "76", "23", "4310603", "", "", "-29.12528", "-56.55306", "America/Sao_Paulo"),
("3460644", "Itaquaquecetuba", "", "BR", "76", "27", "3523107", "", "", "-23.48611", "-46.34833", "America/Sao_Paulo"),
("3460648", "Itapuranga", "", "BR", "76", "29", "5211206", "", "", "-15.56222", "-49.94861", "America/Sao_Paulo"),
("3460671", "Itapolis", "", "BR", "76", "27", "3522703", "", "", "-21.59556", "-48.81278", "America/Sao_Paulo"),
("3460699", "Itapira", "", "BR", "76", "27", "3522604", "", "", "-22.43611", "-46.82167", "America/Sao_Paulo"),
("3460718", "Itapevi", "", "BR", "76", "27", "3522505", "", "", "-23.54889", "-46.93417", "America/Sao_Paulo"),
("3460723", "Itapeva", "", "BR", "76", "27", "3522406", "", "", "-23.98222", "-48.87556", "America/Sao_Paulo"),
("3460728", "Itapetininga", "Итапетининга", "BR", "76", "27", "3522307", "", "", "-23.59167", "-48.05306", "America/Sao_Paulo"),
("3460730", "Itapetinga", "", "BR", "76", "05", "2916401", "", "", "-15.24889", "-40.24778", "America/Bahia"),
("3460733", "Itaperuna", "", "BR", "76", "21", "3302205", "", "", "-21.205", "-41.88778", "America/Sao_Paulo"),
("3460734", "Itaperucu", "", "BR", "76", "18", "4111258", "", "", "-25.22", "-49.34778", "America/Sao_Paulo"),
("3460738", "Itapemirim", "", "BR", "76", "08", "3202801", "", "", "-21.01111", "-40.83389", "America/Sao_Paulo"),
("3460740", "Itapema", "Итапема", "BR", "76", "26", "4208302", "", "", "-27.09028", "-48.61139", "America/Sao_Paulo"),
("3460748", "Itapecerica da Serra", "Итапесерика-да-Серра", "BR", "76", "27", "3522208", "", "", "-23.71694", "-46.84917", "America/Sao_Paulo"),
("3460752", "Itapecerica", "", "BR", "76", "15", "3133501", "", "", "-20.4725", "-45.12556", "America/Sao_Paulo"),
("3460764", "Itaparica", "", "BR", "76", "05", "2916104", "", "", "-12.88833", "-38.67861", "America/Bahia"),
("3460773", "Itapaci", "", "BR", "76", "29", "5210901", "", "", "-14.95083", "-49.54944", "America/Sao_Paulo"),
("3460774", "Itaocara", "", "BR", "76", "21", "3302106", "", "", "-21.66917", "-42.07611", "America/Sao_Paulo"),
("3460791", "Itanhaem", "", "BR", "76", "27", "3522109", "", "", "-24.18306", "-46.78889", "America/Sao_Paulo"),
("3460813", "Itambe", "", "BR", "76", "05", "2915809", "", "", "-15.245", "-40.62444", "America/Bahia"),
("3460825", "Itamarandiba", "", "BR", "76", "15", "3132503", "", "", "-17.85722", "-42.85889", "America/Sao_Paulo"),
("3460826", "Itamaraju", "", "BR", "76", "05", "2915601", "", "", "-17.03917", "-39.53111", "America/Bahia"),
("3460831", "Itajuipe", "", "BR", "76", "05", "2915502", "", "", "-14.67806", "-39.375", "America/Bahia"),
("3460834", "Itajuba", "Итажуба", "BR", "76", "15", "3132404", "", "", "-22.42556", "-45.45278", "America/Sao_Paulo"),
("3460845", "Itajai", "Итажаи", "BR", "76", "26", "4208203", "", "", "-26.90778", "-48.66194", "America/Sao_Paulo"),
("3460887", "Itai", "", "BR", "76", "27", "3521804", "", "", "-23.41778", "-49.09056", "America/Sao_Paulo"),
("3460899", "Itaguai", "Итагуаи", "BR", "76", "21", "3302007", "", "", "-22.85222", "-43.77528", "America/Sao_Paulo"),
("3460949", "Itabuna", "Итабуна", "BR", "76", "05", "2914802", "", "", "-14.78556", "-39.28028", "America/Bahia"),
("3460950", "Itaborai", "", "BR", "76", "21", "3301900", "", "", "-22.74444", "-42.85944", "America/Sao_Paulo"),
("3460954", "Itabirito", "", "BR", "76", "15", "3131901", "", "", "-20.25333", "-43.80139", "America/Sao_Paulo"),
("3460960", "Itabira", "Итабира", "BR", "76", "15", "3131703", "", "", "-19.61917", "-43.22694", "America/Sao_Paulo"),
("3460963", "Itaberai", "Итабераи", "BR", "76", "29", "5210406", "", "", "-16.02028", "-49.81028", "America/Sao_Paulo"),
("3460966", "Itaberaba", "", "BR", "76", "05", "2914703", "", "", "-12.5275", "-40.30694", "America/Bahia"),
("3460971", "Itabaianinha", "", "BR", "76", "28", "2803005", "", "", "-11.27389", "-37.79", "America/Maceio"),
("3460974", "Itabaiana", "", "BR", "76", "28", "2802908", "", "", "-10.685", "-37.42528", "America/Maceio"),
("3461013", "Irece", "", "BR", "76", "05", "2914604", "", "", "-11.30417", "-41.85583", "America/Bahia"),
("3461017", "Irati", "", "BR", "76", "18", "4110706", "", "", "-25.46722", "-50.65111", "America/Sao_Paulo"),
("3461055", "Iracemapolis", "", "BR", "76", "27", "3521408", "", "", "-22.58056", "-47.51861", "America/Sao_Paulo"),
("3461090", "Ipora", "Ипора", "BR", "76", "29", "5210208", "", "", "-16.44194", "-51.11778", "America/Sao_Paulo"),
("3461124", "Ipira", "", "BR", "76", "05", "2914000", "", "", "-12.15833", "-39.73722", "America/Bahia"),
("3461129", "Ipiau", "Ипиау", "BR", "76", "05", "2913903", "", "", "-14.13341", "-39.73708", "America/Bahia"),
("3461134", "Ipero", "", "BR", "76", "27", "3521002", "", "", "-23.35028", "-47.68861", "America/Sao_Paulo"),
("3461144", "Ipatinga", "Ипатинга", "BR", "76", "15", "3131307", "", "", "-19.46833", "-42.53667", "America/Sao_Paulo"),
("3461151", "Ipameri", "", "BR", "76", "29", "5210109", "", "", "-17.72194", "-48.15972", "America/Sao_Paulo"),
("3461153", "Ipaba", "", "BR", "76", "15", "3131158", "", "", "-19.41361", "-42.41944", "America/Sao_Paulo"),
("3461194", "Inhumas", "", "BR", "76", "29", "5210000", "", "", "-16.35778", "-49.49611", "America/Sao_Paulo"),
("3461311", "Indaiatuba", "Индаятуба", "BR", "76", "27", "3520509", "", "", "-23.08842", "-47.2119", "America/Sao_Paulo"),
("3461316", "Indaial", "", "BR", "76", "26", "4207502", "", "", "-26.89778", "-49.23167", "America/Sao_Paulo"),
("3461368", "Imbituva", "", "BR", "76", "18", "4110102", "", "", "-25.23", "-50.60444", "America/Sao_Paulo"),
("3461370", "Imbituba", "", "BR", "76", "26", "4207304", "", "", "-28.24", "-48.67028", "America/Sao_Paulo"),
("3461408", "Ilheus", "Ильеус", "BR", "76", "05", "2913606", "", "", "-14.79364", "-39.03949", "America/Bahia"),
("3461411", "Ilha Solteira", "Илья-Солтейра", "BR", "76", "27", "3520442", "", "", "-20.43278", "-51.3425", "America/Sao_Paulo"),
("3461425", "Ilhabela", "", "BR", "76", "27", "3520400", "", "", "-23.77806", "-45.35806", "America/Sao_Paulo"),
("3461444", "Ijui", "Ижуи", "BR", "76", "23", "4310207", "", "", "-28.38778", "-53.91472", "America/Sao_Paulo"),
("3461465", "Iguape", "Игуапи", "BR", "76", "27", "3520301", "", "", "-24.70806", "-47.55528", "America/Sao_Paulo"),
("3461481", "Igrejinha", "Игрежинья", "BR", "76", "23", "4310108", "", "", "-29.57444", "-50.79028", "America/Sao_Paulo"),
("3461498", "Igarape", "", "BR", "76", "15", "3130101", "", "", "-20.07028", "-44.30167", "America/Sao_Paulo"),
("3461499", "Igarapava", "", "BR", "76", "27", "3520103", "", "", "-20.03833", "-47.74694", "America/Sao_Paulo"),
("3461501", "Igaracu do Tiete", "", "BR", "76", "27", "3520004", "", "", "-22.50917", "-48.55778", "America/Sao_Paulo"),
("3461519", "Icara", "Исара", "BR", "76", "26", "4207007", "", "", "-28.71333", "-49.3", "America/Sao_Paulo"),
("3461525", "Ibotirama", "", "BR", "76", "05", "2913200", "", "", "-12.18528", "-43.22056", "America/Bahia"),
("3461528", "Ibiuna", "", "BR", "76", "27", "3519709", "", "", "-23.65639", "-47.2225", "America/Sao_Paulo"),
("3461550", "Ibitinga", "", "BR", "76", "27", "3519600", "", "", "-21.75778", "-48.82889", "America/Sao_Paulo"),
("3461563", "Ibirite", "Ибирите", "BR", "76", "15", "3129806", "", "", "-20.02194", "-44.05889", "America/Sao_Paulo"),
("3461565", "Ibirataia", "", "BR", "76", "05", "2912905", "", "", "-14.06694", "-39.64056", "America/Bahia"),
("3461576", "Ibirama", "", "BR", "76", "26", "4206900", "", "", "-27.05694", "-49.51778", "America/Sao_Paulo"),
("3461588", "Ibipora", "", "BR", "76", "18", "4109807", "", "", "-23.26917", "-51.04806", "America/Sao_Paulo"),
("3461606", "Ibicarai", "", "BR", "76", "05", "2912103", "", "", "-14.865", "-39.5875", "America/Bahia"),
("3461620", "Ibia", "", "BR", "76", "15", "3129509", "", "", "-19.47833", "-46.53889", "America/Sao_Paulo"),
("3461625", "Ibate", "", "BR", "76", "27", "3519303", "", "", "-21.95472", "-47.99667", "America/Sao_Paulo"),
("3461628", "Ibaiti", "", "BR", "76", "18", "4109708", "", "", "-23.84861", "-50.18778", "America/Sao_Paulo"),
("3461638", "Iacu", "", "BR", "76", "05", "2911907", "", "", "-12.76722", "-40.21167", "America/Bahia"),
("3461655", "Hortolandia", "Ортоландия", "BR", "76", "27", "3519071", "", "", "-22.85833", "-47.22", "America/Sao_Paulo"),
("3461680", "Herval", "", "BR", "76", "23", "4307104", "", "", "-32.02361", "-53.39556", "America/Sao_Paulo"),
("3461724", "Gurupi", "Гурупи", "BR", "76", "31", "1709500", "", "", "-11.72917", "-49.06861", "America/Araguaina"),
("3461763", "Guaxupe", "", "BR", "76", "15", "3128709", "", "", "-21.30528", "-46.71278", "America/Sao_Paulo"),
("3461786", "Guarulhos", "", "BR", "76", "27", "3518800", "", "", "-23.46278", "-46.53333", "America/Sao_Paulo"),
("3461789", "Guaruja", "Гуаружа", "BR", "76", "27", "3518701", "", "", "-23.99306", "-46.25639", "America/Sao_Paulo"),
("3461824", "Guariba", "", "BR", "76", "27", "3518602", "", "", "-21.36", "-48.22833", "America/Sao_Paulo"),
("3461857", "Guaratuba", "", "BR", "76", "18", "4109609", "", "", "-25.88278", "-48.57472", "America/Sao_Paulo"),
("3461859", "Guaratingueta", "Гуаратингета", "BR", "76", "27", "3518404", "", "", "-22.81639", "-45.1925", "America/Sao_Paulo"),
("3461871", "Guararema", "", "BR", "76", "27", "3518305", "", "", "-23.415", "-46.035", "America/Sao_Paulo"),
("3461874", "Guararapes", "", "BR", "76", "27", "3518206", "", "", "-21.26083", "-50.64278", "America/Sao_Paulo"),
("3461879", "Guarapuava", "Гуарапуава", "BR", "76", "18", "4109401", "", "", "-25.39528", "-51.45806", "America/Sao_Paulo"),
("3461888", "Guarapari", "Гуарапари", "BR", "76", "08", "3202405", "", "", "-20.65367", "-40.50204", "America/Sao_Paulo"),
("3461910", "Guaranesia", "", "BR", "76", "15", "3128303", "", "", "-21.29917", "-46.8025", "America/Sao_Paulo"),
("3461914", "Guaramirim", "", "BR", "76", "26", "4206504", "", "", "-26.47306", "-49.00278", "America/Sao_Paulo"),
("3461935", "Guara", "", "BR", "76", "27", "3517703", "", "", "-20.42833", "-47.82417", "America/Sao_Paulo"),
("3461941", "Guapore", "", "BR", "76", "23", "4309407", "", "", "-28.84556", "-51.89028", "America/Sao_Paulo"),
("3461949", "Guapimirim", "Гуапимирин", "BR", "76", "21", "3301850", "", "", "-22.53722", "-42.98194", "America/Sao_Paulo"),
("3461958", "Guanhaes", "", "BR", "76", "15", "3128006", "", "", "-18.775", "-42.9325", "America/Sao_Paulo"),
("3461973", "Guanambi", "", "BR", "76", "05", "2911709", "", "", "-14.22333", "-42.78139", "America/Bahia"),
("3461995", "Guaira", "Гуайра", "BR", "76", "27", "3517406", "", "", "-20.31833", "-48.31056", "America/Sao_Paulo"),
("3462022", "Guacui", "", "BR", "76", "08", "3202306", "", "", "-20.77556", "-41.67944", "America/Sao_Paulo"),
("3462089", "Gravatai", "Граватаи", "BR", "76", "23", "4309209", "", "", "-29.94444", "-50.99194", "America/Sao_Paulo"),
("3462315", "Governador Valadares", "Говернадор-Валадарес", "BR", "76", "15", "3127701", "", "", "-18.85111", "-41.94944", "America/Sao_Paulo"),
("3462371", "Goiatuba", "Гоятуба", "BR", "76", "29", "5209101", "", "", "-18.0125", "-49.35472", "America/Sao_Paulo"),
("3462374", "Goias", "", "BR", "76", "29", "5208905", "", "", "-15.93444", "-50.14028", "America/Sao_Paulo"),
("3462376", "Goianira", "Гоянира", "BR", "76", "29", "5208806", "", "", "-16.49611", "-49.42639", "America/Sao_Paulo"),
("3462377", "Goiania", "Гояния", "BR", "76", "29", "5208707", "", "", "-16.67861", "-49.25389", "America/Sao_Paulo"),
("3462378", "Goianesia", "", "BR", "76", "29", "5208608", "", "", "-15.3175", "-49.1175", "America/Sao_Paulo"),
("3462535", "Gaspar", "", "BR", "76", "26", "4205902", "", "", "-26.93139", "-48.95889", "America/Sao_Paulo"),
("3462557", "Garibaldi", "", "BR", "76", "23", "4308607", "", "", "-29.25611", "-51.53361", "America/Sao_Paulo"),
("3462580", "Garca", "", "BR", "76", "27", "3516705", "", "", "-22.21056", "-49.65611", "America/Sao_Paulo"),
("3462601", "Gandu", "", "BR", "76", "05", "2911204", "", "", "-13.74389", "-39.48667", "America/Bahia"),
("3462916", "Frutal", "Фрутал", "BR", "76", "15", "3127107", "", "", "-20.02472", "-48.94056", "America/Sao_Paulo"),
("3462956", "Frederico Westphalen", "", "BR", "76", "23", "4308508", "", "", "-27.35917", "-53.39444", "America/Sao_Paulo"),
("3462964", "Franco da Rocha", "", "BR", "76", "27", "3516408", "", "", "-23.32167", "-46.72694", "America/Sao_Paulo"),
("3462980", "Francisco Morato", "", "BR", "76", "27", "3516309", "", "", "-23.28167", "-46.74528", "America/Sao_Paulo"),
("3462996", "Francisco Beltrao", "Белтран-Франциско", "BR", "76", "18", "4108403", "", "", "-26.08111", "-53.055", "America/Sao_Paulo"),
("3463011", "Franca", "Франко", "BR", "76", "27", "3516200", "", "", "-20.53861", "-47.40083", "America/Sao_Paulo"),
("3463030", "Foz do Iguacu", "Фос-ду-Игуасу", "BR", "76", "18", "4108304", "", "", "-25.54778", "-54.58806", "America/Sao_Paulo"),
("3463066", "Forquilhinha", "Форкильинья", "BR", "76", "26", "4205456", "", "", "-28.7475", "-49.47222", "America/Sao_Paulo"),
("3463140", "Formosa", "", "BR", "76", "29", "5208004", "", "", "-15.53722", "-47.33444", "America/Sao_Paulo"),
("3463174", "Formiga", "Формига", "BR", "76", "15", "3126109", "", "", "-20.46444", "-45.42639", "America/Sao_Paulo"),
("3463237", "Florianopolis", "Флорианополис", "BR", "76", "26", "4205407", "", "", "-27.59667", "-48.54917", "America/Sao_Paulo"),
("3463271", "Flores da Cunha", "", "BR", "76", "23", "4308201", "", "", "-29.02889", "-51.18167", "America/Sao_Paulo"),
("3463422", "Ferraz de Vasconcelos", "", "BR", "76", "27", "3515707", "", "", "-23.54083", "-46.36861", "America/Sao_Paulo"),
("3463432", "Fernandopolis", "", "BR", "76", "27", "3515509", "", "", "-20.28389", "-50.24639", "America/Sao_Paulo"),
("3463478", "Feira de Santana", "Фейра-де-Сантана", "BR", "76", "05", "2910800", "", "", "-12.26667", "-38.96667", "America/Bahia"),
("3463605", "Farroupilha", "", "BR", "76", "23", "4307906", "", "", "-29.225", "-51.34778", "America/Sao_Paulo"),
("3463698", "Euclides da Cunha", "Евклид-да-Кунья", "BR", "76", "05", "2910701", "", "", "-10.5075", "-39.01583", "America/Bahia"),
("3463762", "Estrela", "", "BR", "76", "23", "4322509", "", "", "-28.06111", "-50.93833", "America/Sao_Paulo"),
("3463859", "Esteio", "", "BR", "76", "23", "4307708", "", "", "-29.86139", "-51.17917", "America/Sao_Paulo"),
("3463865", "Estancia Velha", "", "BR", "76", "23", "4307609", "", "", "-29.64833", "-51.17389", "America/Sao_Paulo"),
("3463900", "Estancia", "", "BR", "76", "28", "2802106", "", "", "-11.26833", "-37.43833", "America/Maceio"),
("3463920", "Esplanada", "", "BR", "76", "05", "2910602", "", "", "-11.79611", "-37.945", "America/Bahia"),
("3463939", "Espinosa", "", "BR", "76", "15", "3124302", "", "", "-14.92611", "-42.81917", "America/Sao_Paulo"),
("3464008", "Esmeraldas", "Эсмеральдас", "BR", "76", "15", "3124104", "", "", "-19.7625", "-44.31389", "America/Sao_Paulo"),
("3464073", "Erechim", "Эрешин", "BR", "76", "23", "4307005", "", "", "-27.63417", "-52.27389", "America/Sao_Paulo"),
("3464100", "Entre Rios", "", "BR", "76", "05", "2910503", "", "", "-11.94194", "-38.08444", "America/Bahia"),
("3464255", "Encruzilhada do Sul", "", "BR", "76", "23", "4306908", "", "", "-30.54389", "-52.52194", "America/Sao_Paulo"),
("3464274", "Encantado", "", "BR", "76", "23", "4306809", "", "", "-29.23611", "-51.86972", "America/Sao_Paulo"),
("3464304", "Embu Guacu", "", "BR", "76", "27", "3515103", "", "", "-23.83222", "-46.81139", "America/Sao_Paulo"),
("3464305", "Embu", "Эмба", "BR", "76", "27", "3515004", "", "", "-23.64889", "-46.85222", "America/Sao_Paulo"),
("3464329", "Eloi Mendes", "", "BR", "76", "15", "3123601", "", "", "-21.61", "-45.56528", "America/Sao_Paulo"),
("3464374", "Duque de Caxias", "Дуки-ди-Кашиас", "BR", "76", "21", "3301702", "", "", "-22.78556", "-43.31167", "America/Sao_Paulo"),
("3464460", "Dourados", "Дорадус", "BR", "76", "11", "5003702", "", "", "-22.22111", "-54.80556", "America/Campo_Grande"),
("3464547", "Dom Pedrito", "", "BR", "76", "23", "4306601", "", "", "-30.98278", "-54.67306", "America/Sao_Paulo"),
("3464579", "Dois Vizinhos", "", "BR", "76", "18", "4107207", "", "", "-25.73361", "-53.05722", "America/Sao_Paulo"),
("3464618", "Dois Corregos", "", "BR", "76", "27", "3514106", "", "", "-22.36611", "-48.38028", "America/Sao_Paulo"),
("3464688", "Divinopolis", "Дивинополис", "BR", "76", "15", "3122306", "", "", "-20.13889", "-44.88389", "America/Sao_Paulo"),
("3464724", "Diamantino", "", "BR", "76", "14", "5103502", "", "", "-14.40861", "-56.44611", "America/Cuiaba"),
("3464728", "Diamantina", "Диамантина", "BR", "76", "15", "3121605", "", "", "-18.24142", "-43.60568", "America/Sao_Paulo"),
("3464739", "Diadema", "Диадема", "BR", "76", "27", "3513801", "", "", "-23.68611", "-46.62278", "America/Sao_Paulo"),
("3464809", "Descalvado", "", "BR", "76", "27", "3513702", "", "", "-21.90389", "-47.61944", "America/Sao_Paulo"),
("3464891", "Curvelo", "Курвелу", "BR", "76", "15", "3120904", "", "", "-18.75639", "-44.43083", "America/Sao_Paulo"),
("3464974", "Curitibanos", "Куритибанус", "BR", "76", "26", "4204806", "", "", "-27.28278", "-50.58444", "America/Sao_Paulo"),
("3464975", "Curitiba", "Куритиба", "BR", "76", "18", "4106902", "", "", "-25.42778", "-49.27306", "America/Sao_Paulo"),
("3465038", "Cuiaba", "Куяба", "BR", "76", "14", "5103403", "", "", "-15.59611", "-56.09667", "America/Cuiaba"),
("3465059", "Cubatao", "", "BR", "76", "27", "3513504", "", "", "-23.895", "-46.42528", "America/Sao_Paulo"),
("3465083", "Cruzeiro do Oeste", "", "BR", "76", "18", "4106605", "", "", "-23.785", "-53.07333", "America/Sao_Paulo"),
("3465090", "Cruzeiro", "", "BR", "76", "27", "3513405", "", "", "-22.57611", "-44.96278", "America/Sao_Paulo"),
("3465105", "Cruz das Almas", "", "BR", "76", "05", "2909802", "", "", "-12.67", "-39.10194", "America/Bahia"),
("3465108", "Cruz Alta", "Крус-Алта", "BR", "76", "23", "4306106", "", "", "-28.63861", "-53.60639", "America/Sao_Paulo"),
("3465164", "Cristalina", "Кристалина", "BR", "76", "29", "5206206", "", "", "-16.76861", "-47.61361", "America/Sao_Paulo"),
("3465196", "Criciuma", "Крисиума", "BR", "76", "26", "4204608", "", "", "-28.6775", "-49.36972", "America/Sao_Paulo"),
("3465209", "Cravinhos", "", "BR", "76", "27", "3513108", "", "", "-21.34028", "-47.72944", "America/Sao_Paulo"),
("3465228", "Coxim", "Кошин", "BR", "76", "11", "5003306", "", "", "-18.50667", "-54.76", "America/Campo_Grande"),
("3465284", "Cotia", "", "BR", "76", "27", "3513009", "", "", "-23.60389", "-46.91917", "America/Sao_Paulo"),
("3465320", "Cosmopolis", "", "BR", "76", "27", "3512803", "", "", "-22.64583", "-47.19611", "America/Sao_Paulo"),
("3465329", "Coruripe", "", "BR", "76", "02", "2702306", "", "", "-10.12556", "-36.17556", "America/Maceio"),
("3465342", "Corumba", "Корумба", "BR", "76", "11", "5003207", "", "", "-19.00917", "-57.65333", "America/Campo_Grande"),
("3465459", "Coronel Vivida", "", "BR", "76", "18", "4106506", "", "", "-25.97972", "-52.56778", "America/Sao_Paulo"),
("3465476", "Coronel Fabriciano", "Коронел-Фабрисиану", "BR", "76", "15", "3119401", "", "", "-19.51861", "-42.62889", "America/Sao_Paulo"),
("3465487", "Coromandel", "", "BR", "76", "15", "3119302", "", "", "-18.47333", "-47.20028", "America/Sao_Paulo"),
("3465512", "Corinto", "Коринто", "BR", "76", "15", "3119104", "", "", "-18.38083", "-44.45639", "America/Sao_Paulo"),
("3465524", "Cordeiropolis", "", "BR", "76", "27", "3512407", "", "", "-22.48194", "-47.45667", "America/Sao_Paulo"),
("3465527", "Cordeiro", "", "BR", "76", "21", "3301504", "", "", "-22.02861", "-42.36083", "America/Sao_Paulo"),
("3465624", "Contagem", "Контажен", "BR", "76", "15", "3118601", "", "", "-19.93167", "-44.05361", "America/Sao_Paulo"),
("3465644", "Conselheiro Lafaiete", "Консельейру-Лафаети", "BR", "76", "15", "3118304", "", "", "-20.66028", "-43.78611", "America/Sao_Paulo"),
("3465671", "Congonhas", "Конгоньяс", "BR", "76", "15", "3118007", "", "", "-20.49972", "-43.85778", "America/Sao_Paulo"),
("3465713", "Conde", "", "BR", "76", "05", "2908606", "", "", "-11.81361", "-37.61056", "America/Bahia"),
("3465721", "Concordia", "Конкордия", "BR", "76", "26", "4204301", "", "", "-27.23417", "-52.02778", "America/Sao_Paulo"),
("3465731", "Conchal", "", "BR", "76", "27", "3512209", "", "", "-22.33028", "-47.1725", "America/Sao_Paulo"),
("3465748", "Conceicao do Coite", "", "BR", "76", "05", "2908408", "", "", "-11.56389", "-39.28278", "America/Bahia"),
("3465758", "Conceicao do Jacuipe", "", "BR", "76", "05", "2908507", "", "", "-12.31667", "-38.76667", "America/Bahia"),
("3465764", "Conceicao das Alagoas", "", "BR", "76", "15", "3117306", "", "", "-19.91472", "-48.38833", "America/Sao_Paulo"),
("3465767", "Conceicao da Feira", "", "BR", "76", "05", "2908200", "", "", "-12.50583", "-38.99861", "America/Bahia"),
("3465769", "Conceicao da Barra", "", "BR", "76", "08", "3201605", "", "", "-18.59333", "-39.73222", "America/Sao_Paulo"),
("3465881", "Colorado", "", "BR", "76", "18", "4105904", "", "", "-22.8375", "-51.97306", "America/Sao_Paulo"),
("3465927", "Colombo", "Коломбо", "BR", "76", "18", "4105805", "", "", "-25.29167", "-49.22417", "America/Sao_Paulo"),
("3465944", "Colatina", "Колатина", "BR", "76", "08", "3201506", "", "", "-19.53944", "-40.63056", "America/Sao_Paulo"),
("3466041", "Coaraci", "", "BR", "76", "05", "2908002", "", "", "-14.64083", "-39.55111", "America/Bahia"),
("3466062", "Claudio", "", "BR", "76", "15", "3116605", "", "", "-20.44333", "-44.76583", "America/Sao_Paulo"),
("3466171", "Cicero Dantas", "", "BR", "76", "05", "2907806", "", "", "-10.6", "-38.38333", "America/Bahia"),
("3466174", "Cianorte", "Сианорте", "BR", "76", "18", "4105508", "", "", "-23.66333", "-52.605", "America/Sao_Paulo"),
("3466261", "Charqueadas", "", "BR", "76", "23", "4305355", "", "", "-29.95472", "-51.62528", "America/Sao_Paulo"),
("3466296", "Chapeco", "Шапеко", "BR", "76", "26", "4204202", "", "", "-27.09639", "-52.61833", "America/Sao_Paulo"),
("3466429", "Cerquilho", "", "BR", "76", "27", "3511508", "", "", "-23.165", "-47.74361", "America/Sao_Paulo"),
("3466436", "Ceres", "", "BR", "76", "29", "5205406", "", "", "-15.30833", "-49.59833", "America/Sao_Paulo"),
("3466481", "Celso Ramos", "", "BR", "76", "26", "4204152", "", "", "-27.63444", "-51.33639", "America/Sao_Paulo"),
("3466537", "Caxias do Sul", "Кашиас-ду-Сул", "BR", "76", "23", "4305108", "", "", "-29.16806", "-51.17944", "America/Sao_Paulo"),
("3466547", "Caxambu", "", "BR", "76", "15", "3115508", "", "", "-21.97722", "-44.9325", "America/Sao_Paulo"),
("3466641", "Catu", "", "BR", "76", "05", "2907509", "", "", "-12.35306", "-38.37889", "America/Bahia"),
("3466692", "Catanduva", "Катандува", "BR", "76", "27", "3511102", "", "", "-21.13778", "-48.97278", "America/Sao_Paulo"),
("3466696", "Catalao", "", "BR", "76", "29", "5205109", "", "", "-18.16583", "-47.94639", "America/Sao_Paulo"),
("3466698", "Cataguases", "Катагуазис", "BR", "76", "15", "3115300", "", "", "-21.38917", "-42.69667", "America/Sao_Paulo"),
("3466704", "Castro", "", "BR", "76", "18", "4104907", "", "", "-24.79111", "-50.01194", "America/Sao_Paulo"),
("3466723", "Castelo", "Каштелу", "BR", "76", "08", "3201407", "", "", "-20.60361", "-41.18472", "America/Sao_Paulo"),
("3466750", "Cassilandia", "", "BR", "76", "11", "5002902", "", "", "-19.11333", "-51.73417", "America/Campo_Grande"),
("3466763", "Casimiro de Abreu", "", "BR", "76", "21", "3301306", "", "", "-22.48056", "-42.20417", "America/Sao_Paulo"),
("3466779", "Cascavel", "Каскавел", "BR", "76", "18", "4104808", "", "", "-24.95583", "-53.45528", "America/Sao_Paulo"),
("3466824", "Casa Branca", "", "BR", "76", "27", "3510807", "", "", "-21.77389", "-47.08639", "America/Sao_Paulo"),
("3466902", "Carmo do Paranaiba", "", "BR", "76", "15", "3114303", "", "", "-19.00083", "-46.31611", "America/Sao_Paulo"),
("3466903", "Carmo do Cajuru", "", "BR", "76", "15", "3114204", "", "", "-20.18417", "-44.77111", "America/Sao_Paulo"),
("3466933", "Carlos Barbosa", "", "BR", "76", "23", "4304804", "", "", "-29.2975", "-51.50361", "America/Sao_Paulo"),
("3466978", "Carazinho", "Каразинью", "BR", "76", "23", "4304705", "", "", "-28.28389", "-52.78639", "America/Sao_Paulo"),
("3466988", "Caratinga", "Каратинга", "BR", "76", "15", "3113404", "", "", "-19.78972", "-42.13917", "America/Sao_Paulo"),
("3466998", "Carapicuiba", "", "BR", "76", "27", "3510609", "", "", "-23.52272", "-46.835", "America/Sao_Paulo"),
("3467012", "Carangola", "Карангола", "BR", "76", "15", "3113305", "", "", "-20.73306", "-42.02944", "America/Sao_Paulo"),
("3467026", "Carandai", "", "BR", "76", "15", "3113206", "", "", "-20.95361", "-43.80639", "America/Sao_Paulo"),
("3467081", "Caraguatatuba", "Карагуататуба", "BR", "76", "27", "3510500", "", "", "-23.62028", "-45.41306", "America/Sao_Paulo"),
("3467197", "Capivari", "Капивари", "BR", "76", "27", "3510401", "", "", "-22.995", "-47.50778", "America/Sao_Paulo"),
("3467261", "Capinzal", "", "BR", "76", "26", "4203907", "", "", "-27.34361", "-51.61194", "America/Sao_Paulo"),
("3467272", "Capim Grosso", "", "BR", "76", "05", "2906873", "", "", "-11.38111", "-40.01278", "America/Bahia"),
("3467305", "Capelinha", "Капелинья", "BR", "76", "15", "3112307", "", "", "-17.69139", "-42.51583", "America/Sao_Paulo"),
("3467319", "Capela", "", "BR", "76", "28", "2801306", "", "", "-10.50333", "-37.05278", "America/Maceio"),
("3467362", "Capao da Canoa", "", "BR", "76", "23", "4304630", "", "", "-29.74556", "-50.00972", "America/Sao_Paulo"),
("3467371", "Capao Bonito", "", "BR", "76", "27", "3510203", "", "", "-24.00583", "-48.34944", "America/Sao_Paulo"),
("3467452", "Canoinhas", "", "BR", "76", "26", "4203808", "", "", "-26.17722", "-50.39", "America/Sao_Paulo"),
("3467467", "Canoas", "Каноас", "BR", "76", "23", "4304606", "", "", "-29.91778", "-51.18361", "America/Sao_Paulo"),
("3467512", "Cangucu", "", "BR", "76", "23", "4304507", "", "", "-31.395", "-52.67556", "America/Sao_Paulo"),
("3467530", "Canela", "Канела", "BR", "76", "23", "4304408", "", "", "-29.36556", "-50.81556", "America/Sao_Paulo"),
("3467542", "Candido Mota", "", "BR", "76", "27", "3510005", "", "", "-22.74639", "-50.38694", "America/Sao_Paulo"),
("3467550", "Candelaria", "", "BR", "76", "23", "4304200", "", "", "-29.66917", "-52.78889", "America/Sao_Paulo"),
("3467577", "Canavieiras", "", "BR", "76", "05", "2906303", "", "", "-15.675", "-38.94722", "America/Bahia"),
("3467673", "Campo Verde", "", "BR", "76", "11", "5004908", "", "", "-20.41667", "-54.06667", "America/Campo_Grande"),
("3467677", "Campos Novos", "Кампус-Новус", "BR", "76", "26", "4203600", "", "", "-27.40167", "-51.225", "America/Sao_Paulo"),
("3467680", "Campos Gerais", "Кампус-Жерайс", "BR", "76", "15", "3111606", "", "", "-21.235", "-45.75861", "America/Sao_Paulo"),
("3467684", "Campos do Jordao", "Кампус-ду-Жордау", "BR", "76", "27", "3509700", "", "", "-22.73944", "-45.59139", "America/Sao_Paulo"),
("3467687", "Campos Belos", "", "BR", "76", "29", "5204904", "", "", "-13.03667", "-46.77167", "America/Sao_Paulo"),
("3467693", "Campos", "Кампос", "BR", "76", "21", "3301009", "", "", "-21.75227", "-41.33044", "America/Sao_Paulo"),
("3467717", "Campo Mourao", "", "BR", "76", "18", "4104303", "", "", "-24.04556", "-52.38306", "America/Sao_Paulo"),
("3467736", "Campo Largo", "", "BR", "76", "18", "4104204", "", "", "-25.45861", "-49.52833", "America/Sao_Paulo"),
("3467747", "Campo Grande", "Кампу-Гранди", "BR", "76", "11", "5002704", "", "", "-20.44278", "-54.64639", "America/Campo_Grande"),
("3467760", "Campo Formoso", "", "BR", "76", "05", "2906006", "", "", "-10.5075", "-40.32139", "America/Bahia"),
("3467796", "Campo Belo", "Кампу-Белу", "BR", "76", "15", "3111200", "", "", "-20.89722", "-45.27722", "America/Sao_Paulo"),
("3467865", "Campinas", "Кампинас", "BR", "76", "27", "3509502", "", "", "-22.90556", "-47.06083", "America/Sao_Paulo"),
("3467877", "Campina Grande do Sul", "Кампина-Гранде-ду-Сул", "BR", "76", "18", "4104006", "", "", "-25.30556", "-49.05528", "America/Sao_Paulo"),
("3467956", "Cambui", "", "BR", "76", "15", "3110608", "", "", "-22.61222", "-46.0575", "America/Sao_Paulo"),
("3467978", "Cambe", "", "BR", "76", "18", "4103701", "", "", "-23.27583", "-51.27833", "America/Sao_Paulo"),
("3467985", "Cambara", "", "BR", "76", "18", "4103602", "", "", "-23.04639", "-50.07361", "America/Sao_Paulo"),
("3468014", "Camaqua", "", "BR", "76", "23", "4303509", "", "", "-30.85111", "-51.81222", "America/Sao_Paulo"),
("3468023", "Camanducaia", "", "BR", "76", "15", "3110509", "", "", "-22.75528", "-46.14472", "America/Sao_Paulo"),
("3468031", "Camacari", "", "BR", "76", "05", "2905701", "", "", "-12.6975", "-38.32417", "America/Bahia"),
("3468100", "Caldas Novas", "", "BR", "76", "29", "5204508", "", "", "-17.74167", "-48.625", "America/Sao_Paulo"),
("3468121", "Cajuru", "", "BR", "76", "27", "3509403", "", "", "-21.27528", "-47.30417", "America/Sao_Paulo"),
("3468157", "Cajati", "", "BR", "76", "27", "3509254", "", "", "-24.73611", "-48.12278", "America/Sao_Paulo"),
("3468158", "Cajamar", "", "BR", "76", "27", "3509205", "", "", "-23.35611", "-46.87694", "America/Sao_Paulo"),
("3468215", "Caieiras", "", "BR", "76", "27", "3509007", "", "", "-23.36417", "-46.74056", "America/Sao_Paulo"),
("3468317", "Caetite", "Каэтите", "BR", "76", "05", "2905206", "", "", "-14.06944", "-42.475", "America/Bahia"),
("3468327", "Caete", "Каэте", "BR", "76", "15", "3110004", "", "", "-19.88", "-43.66972", "America/Sao_Paulo"),
("3468376", "Cachoeiro de Itapemirim", "Кашуэйру-ди-Итапемирин", "BR", "76", "08", "3201209", "", "", "-20.84889", "-41.11278", "America/Sao_Paulo"),
("3468403", "Cachoeirinha", "", "BR", "76", "23", "4303103", "", "", "-29.95111", "-51.09389", "America/Sao_Paulo"),
("3468425", "Cachoeiras de Macacu", "", "BR", "76", "21", "3300803", "", "", "-22.4625", "-42.65306", "America/Sao_Paulo"),
("3468436", "Cachoeira do Sul", "Кашуэйра-ду-Сул", "BR", "76", "23", "4303004", "", "", "-30.03917", "-52.89389", "America/Sao_Paulo"),
("3468535", "Cachoeira", "", "BR", "76", "05", "2904902", "", "", "-12.61833", "-38.95583", "America/Bahia"),
("3468560", "Cacapava do Sul", "", "BR", "76", "23", "4302808", "", "", "-30.51222", "-53.49139", "America/Sao_Paulo"),
("3468562", "Cacapava", "", "BR", "76", "27", "3508504", "", "", "-23.10083", "-45.70694", "America/Sao_Paulo"),
("3468570", "Cacador", "Касадор", "BR", "76", "26", "4203006", "", "", "-26.77528", "-51.015", "America/Sao_Paulo"),
("3468592", "Cabreuva", "Кабреува", "BR", "76", "27", "3508405", "", "", "-23.3075", "-47.13278", "America/Sao_Paulo"),
("3468615", "Cabo Frio", "Кабу-Фриу", "BR", "76", "21", "3300704", "", "", "-22.88717", "-42.02622", "America/Sao_Paulo"),
("3468704", "Butia", "", "BR", "76", "23", "4302709", "", "", "-30.11972", "-51.96222", "America/Sao_Paulo"),
("3468720", "Buritizeiro", "", "BR", "76", "15", "3109402", "", "", "-17.35111", "-44.96222", "America/Sao_Paulo"),
("3468732", "Buritis", "", "BR", "76", "15", "3109303", "", "", "-15.61778", "-46.42333", "America/Sao_Paulo"),
("3468802", "Buri", "", "BR", "76", "27", "3508009", "", "", "-23.7975", "-48.59278", "America/Sao_Paulo"),
("3468858", "Buerarema", "", "BR", "76", "05", "2904704", "", "", "-14.95944", "-39.29972", "America/Bahia"),
("3468879", "Brusque", "", "BR", "76", "26", "4202909", "", "", "-27.09806", "-48.9175", "America/Sao_Paulo"),
("3468893", "Brumado", "Брумаду", "BR", "76", "05", "2904605", "", "", "-14.20361", "-41.66528", "America/Bahia"),
("3468894", "Brumadinho", "", "BR", "76", "15", "3109006", "", "", "-20.14333", "-44.19972", "America/Sao_Paulo"),
("3468899", "Brotas", "", "BR", "76", "27", "3507902", "", "", "-22.28417", "-48.12667", "America/Sao_Paulo"),
("3468902", "Brodosqui", "", "BR", "76", "27", "3507803", "", "", "-20.99139", "-47.65861", "America/Sao_Paulo"),
("3469058", "Brasilia", "Бразилия", "BR", "76", "07", "5300108", "", "", "-15.77972", "-47.92972", "America/Sao_Paulo"),
("3469092", "Braganca Paulista", "Браганса-Паулиста", "BR", "76", "27", "3507605", "", "", "-22.95194", "-46.54194", "America/Sao_Paulo"),
("3469115", "Braco do Norte", "", "BR", "76", "26", "4202800", "", "", "-28.275", "-49.16556", "America/Sao_Paulo"),
("3469136", "Botucatu", "Ботукату", "BR", "76", "27", "3507506", "", "", "-22.88583", "-48.445", "America/Sao_Paulo"),
("3469425", "Bom Jesus do Itabapoana", "Бон-Жезус-ду-Итабапоана", "BR", "76", "21", "3300605", "", "", "-21.13389", "-41.67972", "America/Sao_Paulo"),
("3469437", "Bom Jesus da Lapa", "Бон-Жезус-да-Лапа", "BR", "76", "05", "2903904", "", "", "-13.255", "-43.41806", "America/Bahia"),
("3469516", "Bom Despacho", "", "BR", "76", "15", "3107406", "", "", "-19.73639", "-45.25222", "America/Sao_Paulo"),
("3469540", "Boituva", "", "BR", "76", "27", "3507001", "", "", "-23.28333", "-47.67222", "America/Sao_Paulo"),
("3469601", "Bocaiuva", "", "BR", "76", "15", "3107307", "", "", "-17.10778", "-43.815", "America/Sao_Paulo"),
("3469932", "Boa Esperanca", "Боа-Эсперанса", "BR", "76", "15", "3107109", "", "", "-21.09", "-45.56583", "America/Sao_Paulo"),
("3469968", "Blumenau", "Блуменау", "BR", "76", "26", "4202404", "", "", "-26.91944", "-49.06611", "America/Sao_Paulo"),
("3469984", "Biritiba Mirim", "", "BR", "76", "27", "3506607", "", "", "-23.5725", "-46.03861", "America/Sao_Paulo"),
("3469989", "Birigui", "", "BR", "76", "27", "3506508", "", "", "-21.28861", "-50.34", "America/Sao_Paulo"),
("3470003", "Biguacu", "", "BR", "76", "26", "4202305", "", "", "-27.49417", "-48.65556", "America/Sao_Paulo"),
("3470044", "Betim", "Бетин", "BR", "76", "15", "3106705", "", "", "-19.96778", "-44.19833", "America/Sao_Paulo"),
("3470052", "Bertioga", "", "BR", "76", "27", "3506359", "", "", "-23.85444", "-46.13861", "America/Sao_Paulo"),
("3470073", "Bento Goncalves", "", "BR", "76", "23", "4302105", "", "", "-29.17139", "-51.51917", "America/Sao_Paulo"),
("3470117", "Belo Oriente", "", "BR", "76", "15", "3106309", "", "", "-19.22", "-42.48361", "America/Sao_Paulo"),
("3470127", "Belo Horizonte", "Белу-Оризонти", "BR", "76", "15", "3106200", "", "", "-19.92083", "-43.93778", "America/Sao_Paulo"),
("3470142", "Belford Roxo", "Белфорд-Рошу", "BR", "76", "21", "3300456", "", "", "-22.76417", "-43.39944", "America/Sao_Paulo"),
("3470177", "Bela Vista", "", "BR", "76", "11", "5002100", "", "", "-22.10889", "-56.52111", "America/Campo_Grande"),
("3470264", "Bebedouro", "", "BR", "76", "27", "3506102", "", "", "-20.94944", "-48.47917", "America/Sao_Paulo"),
("3470279", "Bauru", "Бауру", "BR", "76", "27", "3506003", "", "", "-22.31472", "-49.06056", "America/Sao_Paulo"),
("3470324", "Batatais", "Бататайс", "BR", "76", "27", "3505906", "", "", "-20.89111", "-47.585", "America/Sao_Paulo"),
("3470341", "Bastos", "", "BR", "76", "27", "3505807", "", "", "-21.92194", "-50.73389", "America/Sao_Paulo"),
("3470353", "Barueri", "Баруэри", "BR", "76", "27", "3505708", "", "", "-23.51056", "-46.87611", "America/Sao_Paulo"),
("3470369", "Barroso", "", "BR", "76", "15", "3105905", "", "", "-21.18694", "-43.97583", "America/Sao_Paulo"),
("3470428", "Barrinha", "", "BR", "76", "27", "3505609", "", "", "-21.19361", "-48.16389", "America/Sao_Paulo"),
("3470451", "Barretos", "Барретус", "BR", "76", "27", "3505500", "", "", "-20.55722", "-48.56778", "America/Sao_Paulo"),
("3470470", "Barreiro do Jaiba", "", "BR", "76", "15", "3171030", "", "", "-15.61532", "-43.59187", "America/Sao_Paulo"),
("3470583", "Barreiras", "Баррейрас", "BR", "76", "05", "2903201", "", "", "-12.15278", "-44.99", "America/Bahia"),
("3470597", "Barra Velha", "", "BR", "76", "26", "4202107", "", "", "-26.63222", "-48.68472", "America/Sao_Paulo"),
("3470636", "Barra Mansa", "Барра-Манса", "BR", "76", "21", "3300407", "", "", "-22.54417", "-44.17139", "America/Sao_Paulo"),
("3470674", "Barra dos Coqueiros", "", "BR", "76", "28", "2800605", "", "", "-10.90889", "-37.03861", "America/Maceio"),
("3470691", "Barra do Pirai", "", "BR", "76", "21", "3300308", "", "", "-22.47", "-43.82556", "America/Sao_Paulo"),
("3470709", "Barra do Garcas", "Барра-ду-Гарсас", "BR", "76", "14", "5101803", "", "", "-15.89", "-52.25667", "America/Cuiaba"),
("3470718", "Barra do Bugres", "", "BR", "76", "14", "5101704", "", "", "-15.0725", "-57.18111", "America/Cuiaba"),
("3470730", "Barra de Sao Francisco", "Барра-де-Сан-Франциско", "BR", "76", "08", "3200904", "", "", "-18.755", "-40.89083", "America/Sao_Paulo"),
("3470776", "Barra Bonita", "", "BR", "76", "27", "3505302", "", "", "-22.49472", "-48.55806", "America/Sao_Paulo"),
("3470821", "Barra", "Барра", "BR", "76", "05", "2902708", "", "", "-11.08944", "-43.14167", "America/Bahia"),
("3470825", "Bariri", "", "BR", "76", "27", "3505203", "", "", "-22.07444", "-48.74028", "America/Sao_Paulo"),
("3470858", "Barbacena", "", "BR", "76", "15", "3105608", "", "", "-21.22583", "-43.77361", "America/Sao_Paulo"),
("3470878", "Barao de Cocais", "", "BR", "76", "15", "3105400", "", "", "-19.94583", "-43.48722", "America/Sao_Paulo"),
("3470912", "Bandeirantes", "", "BR", "76", "18", "4102406", "", "", "-23.11", "-50.3675", "America/Sao_Paulo"),
("3471005", "Bambui", "", "BR", "76", "15", "3105103", "", "", "-20.00639", "-45.97694", "America/Sao_Paulo"),
("3471039", "Balneario Camboriu", "Балнеариу-Камбориу", "BR", "76", "26", "4202008", "", "", "-26.99056", "-48.63472", "America/Sao_Paulo"),
("3471061", "Baixo Guandu", "", "BR", "76", "08", "3200805", "", "", "-19.51889", "-41.01583", "America/Sao_Paulo"),
("3471196", "Bage", "Баг", "BR", "76", "23", "4301602", "", "", "-31.33139", "-54.10694", "America/Sao_Paulo"),
("3471291", "Avare", "", "BR", "76", "27", "3504503", "", "", "-23.09861", "-48.92583", "America/Sao_Paulo"),
("3471335", "Atibaia", "Атибая", "BR", "76", "27", "3504107", "", "", "-23.11694", "-46.55028", "America/Sao_Paulo"),
("3471368", "Astorga", "", "BR", "76", "18", "4102109", "", "", "-23.2325", "-51.66556", "America/Sao_Paulo"),
("3471374", "Assis", "Ассис", "BR", "76", "27", "3504008", "", "", "-22.66167", "-50.41222", "America/Sao_Paulo"),
("3471393", "Aruja", "", "BR", "76", "27", "3503901", "", "", "-23.39611", "-46.32083", "America/Sao_Paulo"),
("3471395", "Artur Nogueira", "", "BR", "76", "27", "3503802", "", "", "-22.57306", "-47.1725", "America/Sao_Paulo"),
("3471422", "Arroio Grande", "", "BR", "76", "23", "4301305", "", "", "-32.2375", "-53.08694", "America/Sao_Paulo"),
("3471428", "Arroio do Meio", "", "BR", "76", "23", "4301008", "", "", "-29.40111", "-51.945", "America/Sao_Paulo"),
("3471451", "Arraial do Cabo", "", "BR", "76", "21", "3300258", "", "", "-22.96611", "-42.02778", "America/Sao_Paulo"),
("3471487", "Armacao de Buzios", "", "BR", "76", "21", "3300233", "", "", "-22.74694", "-41.88167", "America/Sao_Paulo"),
("3471683", "Arcos", "Аркос", "BR", "76", "15", "3104205", "", "", "-20.28194", "-45.53944", "America/Sao_Paulo"),
("3471691", "Araxa", "Араша", "BR", "76", "15", "3104007", "", "", "-19.59333", "-46.94056", "America/Sao_Paulo"),
("3471697", "Araucaria", "Араукария", "BR", "76", "18", "4101804", "", "", "-25.59306", "-49.41028", "America/Sao_Paulo"),
("3471715", "Araruama", "Араруама", "BR", "76", "21", "3300209", "", "", "-22.87278", "-42.34306", "America/Sao_Paulo"),
("3471758", "Araras", "", "BR", "76", "27", "3503307", "", "", "-22.35694", "-47.38417", "America/Sao_Paulo"),
("3471766", "Araraquara", "Араракуара", "BR", "76", "27", "3503208", "", "", "-21.79444", "-48.17556", "America/Sao_Paulo"),
("3471772", "Ararangua", "Арарангуа", "BR", "76", "26", "4201406", "", "", "-28.93472", "-49.48583", "America/Sao_Paulo"),
("3471798", "Arapongas", "Арапонгас", "BR", "76", "18", "4101507", "", "", "-23.41944", "-51.42444", "America/Sao_Paulo"),
("3471830", "Araguari", "Арагуари", "BR", "76", "15", "3103504", "", "", "-18.64722", "-48.18722", "America/Sao_Paulo"),
("3471840", "Aragarcas", "", "BR", "76", "29", "5201702", "", "", "-15.8975", "-52.25083", "America/Sao_Paulo"),
("3471846", "Aracuai", "Арасуаи", "BR", "76", "15", "3103405", "", "", "-16.84972", "-42.07028", "America/Sao_Paulo"),
("3471848", "Aracruz", "Аракрус", "BR", "76", "08", "3200607", "", "", "-19.82028", "-40.27333", "America/Sao_Paulo"),
("3471849", "Aracoiaba da Serra", "", "BR", "76", "27", "3502903", "", "", "-23.50528", "-47.61417", "America/Sao_Paulo"),
("3471854", "Araci", "", "BR", "76", "05", "2902104", "", "", "-11.33333", "-38.96667", "America/Bahia"),
("3471859", "Aracatuba", "Арасатуба", "BR", "76", "27", "3502804", "", "", "-21.20889", "-50.43278", "America/Sao_Paulo"),
("3471872", "Aracaju", "Аракажу", "BR", "76", "28", "2800308", "", "", "-10.91111", "-37.07167", "America/Maceio"),
("3471896", "Aquidauana", "", "BR", "76", "11", "5001102", "", "", "-20.47111", "-55.78722", "America/Campo_Grande"),
("3471910", "Apucarana", "", "BR", "76", "18", "4101408", "", "", "-23.55083", "-51.46083", "America/Sao_Paulo"),
("3471927", "Apiai", "", "BR", "76", "27", "3502705", "", "", "-24.50944", "-48.8425", "America/Sao_Paulo"),
("3471940", "Aparecida do Taboado", "", "BR", "76", "11", "5001003", "", "", "-20.08667", "-51.09361", "America/Campo_Grande"),
("3471949", "Aparecida", "Апаресида", "BR", "76", "27", "3502507", "", "", "-22.84694", "-45.22972", "America/Sao_Paulo"),
("3472048", "Antonina", "", "BR", "76", "18", "4101200", "", "", "-25.42861", "-48.71194", "America/Sao_Paulo"),
("3472138", "Anicuns", "", "BR", "76", "29", "5201306", "", "", "-16.46111", "-49.96167", "America/Sao_Paulo"),
("3472177", "Angra dos Reis", "Ангра-дус-Рейс", "BR", "76", "21", "3300100", "", "", "-23.00667", "-44.31806", "America/Sao_Paulo"),
("3472248", "Andradina", "", "BR", "76", "27", "3502101", "", "", "-20.89611", "-51.37944", "America/Sao_Paulo"),
("3472254", "Andradas", "Андрадас", "BR", "76", "15", "3102605", "", "", "-22.06806", "-46.56917", "America/Sao_Paulo"),
("3472284", "Anastacio", "", "BR", "76", "11", "5000708", "", "", "-20.48361", "-55.80694", "America/Campo_Grande"),
("3472287", "Anapolis", "Анаполис", "BR", "76", "29", "5201108", "", "", "-16.32667", "-48.95278", "America/Sao_Paulo"),
("3472311", "Amparo", "", "BR", "76", "27", "3501905", "", "", "-22.70111", "-46.76444", "America/Sao_Paulo"),
("3472338", "Americo Brasiliense", "", "BR", "76", "27", "3501707", "", "", "-21.72444", "-48.10167", "America/Sao_Paulo"),
("3472343", "Americana", "Американа", "BR", "76", "27", "3501608", "", "", "-22.73917", "-47.33139", "America/Sao_Paulo"),
("3472370", "Amargosa", "", "BR", "76", "05", "2901007", "", "", "-13.03028", "-39.60472", "America/Bahia"),
("3472417", "Alvares Machado", "", "BR", "76", "27", "3501301", "", "", "-22.07944", "-51.47194", "America/Sao_Paulo"),
("3472518", "Almirante Tamandare", "", "BR", "76", "18", "4100400", "", "", "-25.32472", "-49.31", "America/Sao_Paulo"),
("3472520", "Almenara", "Альменара", "BR", "76", "15", "3101706", "", "", "-16.18361", "-40.69444", "America/Sao_Paulo"),
("3472603", "Alfenas", "", "BR", "76", "15", "3101607", "", "", "-21.42917", "-45.94722", "America/Sao_Paulo"),
("3472609", "Alem Paraiba", "", "BR", "76", "15", "3101508", "", "", "-21.88778", "-42.70444", "America/Sao_Paulo"),
("3472638", "Alegrete", "Алегрети", "BR", "76", "23", "4300406", "", "", "-29.78306", "-55.79194", "America/Sao_Paulo"),
("3472666", "Alegre", "", "BR", "76", "08", "3200201", "", "", "-20.76361", "-41.53306", "America/Sao_Paulo"),
("3472766", "Alagoinhas", "Алагоиньяс", "BR", "76", "05", "2900702", "", "", "-12.13556", "-38.41917", "America/Bahia"),
("3472808", "Aimores", "", "BR", "76", "15", "3101102", "", "", "-19.49583", "-41.06389", "America/Sao_Paulo"),
("3472825", "Agudos", "", "BR", "76", "27", "3500709", "", "", "-22.46917", "-48.9875", "America/Sao_Paulo"),
("3472848", "Aguas Vermelhas", "", "BR", "76", "15", "3101003", "", "", "-15.74722", "-41.46", "America/Sao_Paulo"),
("3472869", "Aguas de Lindoia", "", "BR", "76", "27", "3500501", "", "", "-22.47639", "-46.63278", "America/Sao_Paulo"),
("3472969", "Aguai", "", "BR", "76", "27", "3500303", "", "", "-22.05944", "-46.97861", "America/Sao_Paulo"),
("3473157", "Adamantina", "", "BR", "76", "27", "3500105", "", "", "-21.68528", "-51.0725", "America/Sao_Paulo"),
("3473267", "Abaete", "Абаэте", "BR", "76", "15", "3100203", "", "", "-19.16", "-45.44583", "America/Sao_Paulo"),
("3473964", "Guaiba", "", "BR", "76", "23", "4309308", "", "", "-30.11389", "-51.325", "America/Sao_Paulo"),
("3474574", "Palmas", "Палмас", "BR", "76", "31", "1721000", "", "", "-10.16745", "-48.32766", "America/Araguaina"),
("3661944", "Tefe", "", "BR", "76", "04", "1304203", "", "", "-3.35021", "-64.70879", "America/Manaus"),
("3661980", "Tarauaca", "", "BR", "76", "01", "1200609", "", "", "-8.16139", "-70.76556", "America/Rio_Branco"),
("3662075", "Tabatinga", "", "BR", "76", "04", "1304062", "", "", "-4.23095", "-69.93858", "America/Manaus"),
("3662155", "Sena Madureira", "", "BR", "76", "01", "1200500", "", "", "-9.06556", "-68.65694", "America/Eirunepe"),
("3662342", "Sao Gabriel da Cachoeira", "", "BR", "76", "04", "1303809", "", "", "-0.13028", "-67.08917", "America/Manaus"),
("3662574", "Rio Branco", "Риу-Бранку", "BR", "76", "01", "1200401", "", "", "-9.97472", "-67.81", "America/Rio_Branco"),
("3662762", "Porto Velho", "Порту-Велью", "BR", "76", "24", "1100205", "", "", "-8.76194", "-63.90389", "America/Porto_Velho"),
("3663517", "Manaus", "Манаус", "BR", "76", "04", "1302603", "", "", "-3.10194", "-60.025", "America/Manaus"),
("3663529", "Manacapuru", "Манакапуру", "BR", "76", "04", "1302504", "", "", "-3.29972", "-60.62056", "America/Manaus"),
("3664078", "Humaita", "", "BR", "76", "04", "1301704", "", "", "-7.51651", "-63.03105", "America/Manaus"),
("3664207", "Fonte Boa", "", "BR", "76", "04", "1301605", "", "", "-2.51389", "-66.09167", "America/Manaus"),
("3664321", "Eirunepe", "", "BR", "76", "04", "1301407", "", "", "-6.66028", "-69.87361", "America/Eirunepe"),
("3664464", "Cruzeiro do Sul", "", "BR", "76", "01", "1200203", "", "", "-7.63111", "-72.67", "America/Rio_Branco"),
("3664539", "Coari", "Коари", "BR", "76", "04", "1301209", "", "", "-4.085", "-63.14139", "America/Manaus"),
("3664659", "Carauari", "", "BR", "76", "04", "1301001", "", "", "-4.88278", "-66.89583", "America/Manaus"),
("3664980", "Boa Vista", "Боа-Виста", "BR", "76", "25", "1400100", "", "", "2.81972", "-60.67333", "America/Boa_Vista"),
("3665199", "Ariquemes", "", "BR", "76", "24", "1100023", "", "", "-9.91333", "-63.04083", "America/Porto_Velho"),
("3665202", "Aripuana", "Арипуанан", "BR", "76", "14", "5103254", "", "", "-9.16667", "-60.63333", "America/Cuiaba"),
("3924679", "Vilhena", "Вилена", "BR", "76", "24", "1100304", "", "", "-12.74056", "-60.14583", "America/Porto_Velho"),
("3924877", "Posto Fiscal Rolim de Moura", "", "BR", "76", "24", "1100015", "", "", "-13.08271", "-62.27726", "America/Porto_Velho"),
("3924908", "Pimenta Bueno", "", "BR", "76", "24", "1100189", "", "", "-11.6725", "-61.19361", "America/Porto_Velho"),
("3924948", "Ouro Preto do Oeste", "Ору-Прету-ду-Уэсти", "BR", "76", "24", "1100155", "", "", "-10.74806", "-62.21583", "America/Porto_Velho"),
("3925033", "Ji Parana", "", "BR", "76", "24", "1100122", "", "", "-10.88528", "-61.95167", "America/Porto_Velho"),
("3925040", "Jaru", "Жара", "BR", "76", "24", "1100114", "", "", "-10.43889", "-62.46639", "America/Porto_Velho"),
("3925075", "Guajara Mirim", "", "BR", "76", "24", "1100106", "", "", "-10.78278", "-65.33944", "America/Porto_Velho"),
("3925212", "Cacoal", "Какоал", "BR", "76", "24", "1100049", "", "", "-11.43861", "-61.44722", "America/Porto_Velho"),
("6316406", "Aparecida de Goiania", "Апаресида-ди-Гояния", "BR", "76", "29", "5201405", "", "", "-16.82333", "-49.24389", "America/Sao_Paulo"),
("6316729", "Campinas", "", "BR", "76", "26", "4216602", "", "", "-27.59444", "-48.60694", "America/Sao_Paulo"),
("6317344", "Jaboatao dos Guararapes", "Жабоатан-дус-Гуарарапис", "BR", "76", "30", "2607901", "", "", "-8.11278", "-35.01472", "America/Recife"),
("6317464", "Lauro de Freitas", "", "BR", "76", "05", "2919207", "", "", "-12.89444", "-38.32722", "America/Bahia"),
("6317953", "Pinhais", "", "BR", "76", "18", "4119152", "", "", "-25.44472", "-49.1925", "America/Sao_Paulo"),
("6318165", "Rio Preto da Eva", "", "BR", "76", "04", "1303569", "", "", "-2.69795", "-59.70172", "America/Manaus"),
("6318694", "Simoes Filho", "", "BR", "76", "05", "2930709", "", "", "-12.78444", "-38.40389", "America/Bahia"),
("6318696", "Sinop", "", "BR", "76", "14", "5107909", "", "", "-11.86417", "-55.5025", "America/Cuiaba"),
("6693804", "Cambebba", "", "BR", "76", "06", "2303709", "", "", "-3.62092", "-38.82913", "America/Fortaleza"),
("7874479", "Trindade", "", "BR", "76", "26", "4205407", "", "", "-27.58612", "-48.52335", "America/Sao_Paulo"),
("7874492", "Freguesia do Ribeirao da Ilha", "", "BR", "76", "26", "4205407", "", "", "-27.71773", "-48.56266", "America/Sao_Paulo"),
("933000", "Tonota", "", "BW", "72", "01", "", "", "", "-21.44236", "27.46153", "Africa/Gaborone"),
("933018", "Thamaga", "", "BW", "72", "06", "", "", "", "-24.67014", "25.53975", "Africa/Gaborone"),
("933088", "Serowe", "Серова", "BW", "72", "01", "", "", "", "-22.38754", "26.71077", "Africa/Gaborone"),
("933099", "Selebi-Phikwe", "", "BW", "72", "01", "", "", "", "-21.97895", "27.84296", "Africa/Gaborone"),
("933141", "Ramotswa", "", "BW", "72", "09", "", "", "", "-24.87158", "25.86989", "Africa/Gaborone"),
("933182", "Palapye", "Палапье", "BW", "72", "01", "", "", "", "-22.54605", "27.12507", "Africa/Gaborone"),
("933271", "Mosopa", "", "BW", "72", "10", "", "", "", "-24.7718", "25.42156", "Africa/Gaborone"),
("933305", "Molepolole", "Молепололе", "BW", "72", "06", "", "", "", "-24.40659", "25.49508", "Africa/Gaborone"),
("933331", "Mogoditshane", "", "BW", "72", "06", "", "", "", "-24.62694", "25.86556", "Africa/Gaborone"),
("933340", "Mochudi", "Мочуди", "BW", "72", "05", "", "", "", "-24.41667", "26.15", "Africa/Gaborone"),
("933366", "Maun", "Маун", "BW", "72", "11", "", "", "", "-19.98333", "23.41667", "Africa/Gaborone"),
("933471", "Mahalapye", "", "BW", "72", "01", "", "", "", "-23.10407", "26.81421", "Africa/Gaborone"),
("933521", "Lobatse", "Лобаце", "BW", "72", "09", "", "", "", "-25.22435", "25.67728", "Africa/Gaborone"),
("933535", "Letlhakane", "", "BW", "72", "01", "", "", "", "-21.41494", "25.59263", "Africa/Gaborone"),
("933685", "Kanye", "Канье", "BW", "72", "10", "", "", "", "-24.96675", "25.33274", "Africa/Gaborone"),
("933719", "Janeng", "", "BW", "72", "09", "", "", "", "-25.41667", "25.55", "Africa/Gaborone"),
("933773", "Gaborone", "Габороне", "BW", "72", "09", "", "", "", "-24.65451", "25.90859", "Africa/Gaborone"),
("933778", "Francistown", "Франсистаун", "BW", "72", "08", "", "", "", "-21.16995", "27.50788", "Africa/Gaborone"),
("618800", "Horad Zhodzina", "Жодино", "BY", "112", "05", "", "", "", "54.0985", "28.3331", "Europe/Minsk"),
("618806", "Zhlobin", "Жлобин", "BY", "112", "02", "", "", "", "52.8926", "30.024", "Europe/Minsk"),
("620127", "Vitebsk", "Витебск", "BY", "112", "07", "", "", "", "55.1904", "30.2049", "Europe/Minsk"),
("620181", "Vilyeyka", "Вилейка", "BY", "112", "05", "", "", "", "54.4914", "26.9111", "Europe/Minsk"),
("620391", "Vawkavysk", "Волковыск", "BY", "112", "03", "", "", "", "53.1561", "24.4513", "Europe/Minsk"),
("621074", "Svyetlahorsk", "Светлогорск", "BY", "112", "02", "", "", "", "52.6329", "29.7389", "Europe/Minsk"),
("621266", "Stowbtsy", "Столбцы", "BY", "112", "05", "", "", "", "53.4785", "26.7434", "Europe/Minsk"),
("621713", "Smarhon'", "Сморгонь", "BY", "112", "03", "", "", "", "54.4798", "26.3957", "Europe/Minsk"),
("621741", "Slutsk", "Слуцк", "BY", "112", "05", "", "", "", "53.0274", "27.5597", "Europe/Minsk"),
("621754", "Slonim", "Слоним", "BY", "112", "03", "", "", "", "53.0869", "25.3163", "Europe/Minsk"),
("622113", "Shchuchin", "Щучин", "BY", "112", "03", "", "", "", "53.6014", "24.7465", "Europe/Minsk"),
("622428", "Salihorsk", "Солигорск", "BY", "112", "05", "", "", "", "52.7876", "27.5415", "Europe/Minsk"),
("622739", "Rahachow", "Рогачев", "BY", "112", "02", "", "", "", "53.0934", "30.0495", "Europe/Minsk"),
("622794", "Rechytsa", "Речица", "BY", "112", "02", "", "", "", "52.3617", "30.3916", "Europe/Minsk"),
("622997", "Pruzhany", "Пружаны", "BY", "112", "01", "", "", "", "52.556", "24.4573", "Europe/Minsk"),
("623317", "Polatsk", "Полоцк", "BY", "112", "07", "", "", "", "55.4879", "28.7856", "Europe/Minsk"),
("623549", "Pinsk", "Пинск", "BY", "112", "01", "", "", "", "52.1229", "26.0951", "Europe/Minsk"),
("623760", "Pastavy", "Поставы", "BY", "112", "07", "", "", "", "55.11676", "26.83263", "Europe/Minsk"),
("624034", "Asipovichy", "Осиповичи", "BY", "112", "06", "", "", "", "53.3011", "28.6386", "Europe/Minsk"),
("624079", "Orsha", "Орша", "BY", "112", "07", "", "", "", "54.5081", "30.4172", "Europe/Minsk"),
("624400", "Novoye Medvezhino", "Медвежино", "BY", "112", "04", "", "", "", "53.88333", "27.45", "Europe/Minsk"),
("624784", "Navapolatsk", "Новополоцк", "BY", "112", "07", "", "", "", "55.5318", "28.5987", "Europe/Minsk"),
("624785", "Navahrudak", "Новогрудок", "BY", "112", "03", "", "", "", "53.5942", "25.8191", "Europe/Minsk"),
("625144", "Minsk", "Минск", "BY", "112", "04", "", "", "", "53.9", "27.56667", "Europe/Minsk"),
("625324", "Mazyr", "Мозырь", "BY", "112", "02", "", "", "", "52.0495", "29.2456", "Europe/Minsk"),
("625367", "Masty", "Мосты", "BY", "112", "03", "", "", "", "53.4122", "24.5387", "Europe/Minsk"),
("625409", "Mar''ina Horka", "Марьина Горка", "BY", "112", "05", "", "", "", "53.509", "28.147", "Europe/Minsk"),
("625625", "Maladzyechna", "Молодечно", "BY", "112", "05", "", "", "", "54.3167", "26.854", "Europe/Minsk"),
("625665", "Mahilyow", "Могилёв", "BY", "112", "06", "", "", "", "53.9168", "30.3449", "Europe/Minsk"),
("625743", "Lyepyel'", "Лепель", "BY", "112", "07", "", "", "", "54.8814", "28.699", "Europe/Minsk"),
("625818", "Luninyets", "Лунинец", "BY", "112", "01", "", "", "", "52.2472", "26.8047", "Europe/Minsk"),
("626081", "Lida", "Лида", "BY", "112", "03", "", "", "", "53.88333", "25.29972", "Europe/Minsk"),
("626450", "Krychaw", "Кричев", "BY", "112", "06", "", "", "", "53.7125", "31.717", "Europe/Minsk"),
("627083", "Kalodzishchy", "Колодищи", "BY", "112", "05", "", "", "", "53.944", "27.7823", "Europe/Minsk"),
("627145", "Kobryn", "Кобрин", "BY", "112", "01", "", "", "", "52.2138", "24.3564", "Europe/Minsk"),
("627751", "Kalinkavichy", "Калинковичи", "BY", "112", "02", "", "", "", "52.1323", "29.3257", "Europe/Minsk"),
("627800", "Ivatsevichy", "Ивацевичи", "BY", "112", "01", "", "", "", "52.709", "25.3401", "Europe/Minsk"),
("627904", "Hrodna", "Гродно", "BY", "112", "03", "", "", "", "53.6884", "23.8258", "Europe/Minsk"),
("627905", "Horki", "Горки", "BY", "112", "06", "", "", "", "54.2862", "30.9863", "Europe/Minsk"),
("627907", "Gomel", "Гомель", "BY", "112", "02", "", "", "", "52.4345", "30.9754", "Europe/Minsk"),
("627908", "Hlybokaye", "Глубокое", "BY", "112", "07", "", "", "", "55.1384", "27.6905", "Europe/Minsk"),
("628634", "Dzyarzhynsk", "Дзержинск", "BY", "112", "05", "", "", "", "53.6832", "27.138", "Europe/Minsk"),
("629018", "Dobrush", "Добруш", "BY", "112", "02", "", "", "", "52.4089", "31.3237", "Europe/Minsk"),
("629447", "Bykhaw", "Быхов", "BY", "112", "06", "", "", "", "53.521", "30.2454", "Europe/Minsk"),
("629454", "Byaroza", "Берёза", "BY", "112", "01", "", "", "", "52.5314", "24.9786", "Europe/Minsk"),
("629634", "Brest", "Брест", "BY", "112", "01", "", "", "", "52.09755", "23.68775", "Europe/Minsk"),
("630376", "Horad Barysaw", "Город Борисов", "BY", "112", "05", "", "", "", "54.2279", "28.505", "Europe/Minsk"),
("630429", "Baranovichi", "Барановичи", "BY", "112", "01", "", "", "", "53.1327", "26.0139", "Europe/Minsk"),
("630468", "Babruysk", "Бобруйск", "BY", "112", "06", "", "", "", "53.1384", "29.2214", "Europe/Minsk"),
("8020218", "Malinovka", "Малиновка", "BY", "112", "04", "", "", "", "53.8579", "27.4374", "Europe/Minsk"),
("3581194", "San Ignacio", "", "BZ", "84", "02", "", "", "", "17.15297", "-89.08058", "America/Belize"),
("3581514", "Orange Walk", "", "BZ", "84", "04", "", "", "", "18.08124", "-88.56328", "America/Belize"),
("3582672", "Belmopan", "Бельмопан", "BZ", "84", "02", "", "", "", "17.25", "-88.76667", "America/Belize"),
("3582677", "Belize City", "Белиз", "BZ", "84", "01", "", "", "", "17.49952", "-88.19756", "America/Belize"),
("5881791", "Abbotsford", "Абботсфорд", "CA", "124", "02", "5957659", "", "", "49.05798", "-122.25257", "America/Vancouver"),
("5882799", "Airdrie", "", "CA", "124", "01", "", "", "", "51.30011", "-114.03528", "America/Edmonton"),
("5882873", "Ajax", "Эйджакс", "CA", "124", "08", "", "", "", "43.85012", "-79.03288", "America/Toronto"),
("5884083", "Alma", "Алма", "CA", "124", "10", "02", "", "", "48.55009", "-71.6491", "America/Montreal"),
("5884588", "Amos", "", "CA", "124", "10", "08", "", "", "48.56688", "-78.11624", "America/Montreal"),
("5885383", "Anmore", "", "CA", "124", "02", "5915", "", "", "49.31637", "-122.85263", "America/Vancouver"),
("5889745", "Baie-Comeau", "", "CA", "124", "10", "09", "", "", "49.21679", "-68.14894", "America/Montreal"),
("5894171", "Barrie", "Барри", "CA", "124", "08", "", "", "", "44.40011", "-79.66634", "America/Toronto"),
("5895650", "Beaconsfield", "", "CA", "124", "10", "", "", "", "45.43341", "-73.86586", "America/Montreal"),
("5897884", "Belleville", "Бельвиль", "CA", "124", "08", "", "", "", "44.16682", "-77.38277", "America/Toronto"),
("5898138", "Beloeil", "", "CA", "124", "10", "16", "", "", "45.56678", "-73.19915", "America/Montreal"),
("5903510", "Blainville", "", "CA", "124", "10", "15", "", "", "45.66678", "-73.88249", "America/Montreal"),
("5905132", "Boisbriand", "", "CA", "124", "10", "15", "", "", "45.61678", "-73.83249", "America/Montreal"),
("5906267", "Boucherville", "Бушервиль", "CA", "124", "10", "16", "", "", "45.59104", "-73.43605", "America/Montreal"),
("5907180", "Bradford West Gwillimbury", "", "CA", "124", "08", "", "", "", "44.11681", "-79.61633", "America/Toronto"),
("5907364", "Brampton", "Брамптон", "CA", "124", "08", "", "", "", "43.68341", "-79.76633", "America/Toronto"),
("5907896", "Brandon", "Брэндон", "CA", "124", "03", "", "", "", "49.84692", "-99.95306", "America/Winnipeg"),
("5907983", "Brant", "", "CA", "124", "08", "", "", "", "43.1334", "-80.34967", "America/Toronto"),
("5907990", "Brantford", "Брантфорд", "CA", "124", "08", "", "", "", "43.1334", "-80.26636", "America/Toronto"),
("5909294", "Brockville", "Броквилл", "CA", "124", "08", "", "", "", "44.59132", "-75.68705", "America/Toronto"),
("5909629", "Brossard", "", "CA", "124", "10", "16", "", "", "45.45008", "-73.46583", "America/Montreal"),
("5911592", "Burlington", "Берлингтон", "CA", "124", "08", "", "", "", "43.38621", "-79.83713", "America/Toronto"),
("5911606", "Burnaby", "Бернаби", "CA", "124", "02", "", "", "", "49.26636", "-122.95263", "America/Vancouver"),
("5913490", "Calgary", "Калгари", "CA", "124", "01", "", "", "", "51.05011", "-114.08529", "America/Edmonton"),
("5913695", "Cambridge", "Кеймбридж", "CA", "124", "08", "", "", "", "43.3601", "-80.31269", "America/Toronto"),
("5914132", "Campbell River", "Кэмпбелл-Ривер", "CA", "124", "02", "", "", "", "50.01634", "-125.24459", "America/Vancouver"),
("5914653", "Camrose", "", "CA", "124", "01", "", "", "", "53.01684", "-112.83525", "America/Edmonton"),
("5914826", "Candiac", "", "CA", "124", "10", "16", "", "", "45.38338", "-73.51587", "America/Montreal"),
("5919566", "Chambly", "Шамбли", "CA", "124", "10", "16", "", "", "45.45008", "-73.28246", "America/Montreal"),
("5920288", "Charlottetown", "Шарлоттаун", "CA", "124", "09", "", "", "", "46.23525", "-63.12671", "America/Halifax"),
("5920433", "Chateauguay", "", "CA", "124", "10", "16", "", "", "45.38338", "-73.74919", "America/Montreal"),
("5921356", "Chilliwack", "", "CA", "124", "02", "5909", "", "", "49.16638", "-121.95257", "America/Vancouver"),
("5923101", "Clarence-Rockland", "", "CA", "124", "08", "", "", "", "45.5501", "-75.29101", "America/Toronto"),
("5924579", "Cobourg", "", "CA", "124", "08", "", "", "", "43.95977", "-78.16515", "America/Toronto"),
("5924618", "Cochrane", "", "CA", "124", "01", "", "", "", "51.18341", "-114.46871", "America/Edmonton"),
("5925975", "Collingwood", "", "CA", "124", "08", "", "", "", "44.4834", "-80.21638", "America/Toronto"),
("5926511", "Conception Bay South", "", "CA", "124", "05", "", "", "", "47.49989", "-52.99806", "America/St_Johns"),
("5927689", "Coquitlam", "", "CA", "124", "02", "", "", "", "49.28297", "-122.75262", "America/Vancouver"),
("5927969", "Corner Brook", "Корнер-Брук", "CA", "124", "05", "", "", "", "48.95001", "-57.95202", "America/St_Johns"),
("5928065", "Cornwall", "", "CA", "124", "08", "", "", "", "45.01809", "-74.72815", "America/Toronto"),
("5928488", "Cote-Saint-Luc", "", "CA", "124", "10", "", "", "", "45.46536", "-73.66585", "America/Montreal"),
("5930890", "Courtenay", "Куртенэ", "CA", "124", "02", "", "", "", "49.68657", "-124.9936", "America/Vancouver"),
("5931800", "Cranbrook", "Кранбрук", "CA", "124", "02", "", "", "", "49.49991", "-115.76879", "America/Edmonton"),
("5935277", "Dartmouth", "", "CA", "124", "07", "", "", "", "44.67134", "-63.57719", "America/Halifax"),
("5937615", "Delta", "Дельта", "CA", "124", "02", "", "", "", "49.14399", "-122.9068", "America/Vancouver"),
("5938513", "Deux-Montagnes", "", "CA", "124", "10", "15", "", "", "45.53455", "-73.90168", "America/Montreal"),
("5939219", "Dieppe", "Дьеп", "CA", "124", "04", "", "", "", "46.07844", "-64.68735", "America/Moncton"),
("5940956", "Dollard-Des Ormeaux", "", "CA", "124", "10", "", "", "", "45.49452", "-73.82419", "America/Montreal"),
("5941925", "Dorval", "Дорваль", "CA", "124", "10", "", "", "", "45.4473", "-73.75335", "America/Montreal"),
("5942845", "Drummondville", "Драммондвилл", "CA", "124", "10", "17", "", "", "45.88336", "-72.48241", "America/Montreal"),
("5943865", "Duncan", "Дункан", "CA", "124", "02", "", "", "", "48.78293", "-123.70266", "America/Vancouver"),
("5946768", "Edmonton", "Эдмонтон", "CA", "124", "01", "", "", "", "53.55014", "-113.46871", "America/Edmonton"),
("5950267", "Etobicoke", "Этобико", "CA", "124", "08", "", "", "", "43.65421", "-79.56711", "America/Toronto"),
("5955815", "Fort Erie", "", "CA", "124", "08", "", "", "", "42.90012", "-78.93286", "America/Toronto"),
("5955895", "Fort McMurray", "", "CA", "124", "01", "", "", "", "56.72676", "-111.38103", "America/Edmonton"),
("5955960", "Fort St. John", "Форт-Сент-Джон", "CA", "124", "02", "", "", "", "56.24988", "-120.85292", "America/Dawson_Creek"),
("5957776", "Fredericton", "Фредериктон", "CA", "124", "04", "", "", "", "45.94541", "-66.66558", "America/Moncton"),
("5959974", "Gatineau", "Гатино", "CA", "124", "10", "07", "", "", "45.47723", "-75.70164", "America/Montreal"),
("5961564", "Glace Bay", "", "CA", "124", "07", "", "", "", "46.19695", "-59.95698", "America/Glace_Bay"),
("5964215", "Granby", "Гранби", "CA", "124", "10", "16", "", "", "45.40008", "-72.73243", "America/Montreal"),
("5964347", "Grande Prairie", "Гранд-Прери", "CA", "124", "01", "", "", "", "55.16667", "-118.80271", "America/Edmonton"),
("5964700", "Greater Sudbury", "Большой Садбери", "CA", "124", "08", "", "", "", "46.49", "-80.99001", "America/Toronto"),
("5965812", "Greater Napanee", "", "CA", "124", "08", "", "", "", "44.25012", "-76.94944", "America/Toronto"),
("5967629", "Guelph", "Гелф", "CA", "124", "08", "6177913", "", "", "43.54594", "-80.25599", "America/Toronto"),
("5969782", "Hamilton", "Гамильтон", "CA", "124", "08", "", "", "", "43.25011", "-79.84963", "America/Toronto"),
("5978765", "Huntsville", "Хантсвилл", "CA", "124", "08", "", "", "", "45.33341", "-79.21632", "America/Toronto"),
("5987650", "Joliette", "", "CA", "124", "10", "14", "", "", "46.01677", "-73.44915", "America/Montreal"),
("5989045", "Kamloops", "Камлупс", "CA", "124", "02", "", "", "", "50.66648", "-120.3192", "America/Vancouver"),
("5990579", "Kelowna", "Келоуна", "CA", "124", "02", "", "", "", "49.88307", "-119.48568", "America/Vancouver"),
("5991370", "Keswick", "", "CA", "124", "08", "", "", "", "44.25011", "-79.46632", "America/Toronto"),
("5992500", "Kingston", "Кингстон", "CA", "124", "08", "", "", "", "44.22976", "-76.48098", "America/Toronto"),
("5992830", "Kirkland", "", "CA", "124", "10", "", "", "", "45.45008", "-73.86586", "America/Montreal"),
("5992996", "Kitchener", "Китченер", "CA", "124", "08", "", "", "", "43.42537", "-80.5112", "America/Toronto"),
("6049388", "Langford", "", "CA", "124", "02", "", "", "", "48.44963", "-123.50261", "America/Vancouver"),
("6049429", "Langley", "", "CA", "124", "02", "", "", "", "49.10107", "-122.65883", "America/Vancouver"),
("6049430", "Langley", "", "CA", "124", "02", "", "", "", "49.08297", "-122.58589", "America/Vancouver"),
("6049863", "La Prairie", "", "CA", "124", "10", "16", "", "", "45.41678", "-73.49917", "America/Montreal"),
("6050263", "L'Assomption", "", "CA", "124", "10", "14", "", "", "45.82318", "-73.4294", "America/Montreal"),
("6050610", "Laval", "Лаваль", "CA", "124", "10", "13", "", "", "45.56995", "-73.692", "America/Montreal"),
("6051562", "Leduc", "", "CA", "124", "01", "", "", "", "53.26682", "-113.55201", "America/Edmonton"),
("6053154", "Lethbridge", "Летбридж", "CA", "124", "01", "", "", "", "49.69999", "-112.81856", "America/Edmonton"),
("6058024", "Lloydminster", "Ллойдминстер", "CA", "124", "11", "", "", "", "53.28346", "-110.00157", "America/Edmonton"),
("6058560", "London", "Лондон", "CA", "124", "08", "", "", "", "42.98339", "-81.23304", "America/Toronto"),
("6059891", "Longueuil", "Лонгёй", "CA", "124", "10", "16", "", "", "45.53121", "-73.51806", "America/Montreal"),
("6064180", "Magog", "Мейгог", "CA", "124", "10", "05", "", "", "45.26678", "-72.14909", "America/Montreal"),
("6065686", "Maple Ridge", "Мэпл-Ридж", "CA", "124", "02", "", "", "", "49.21939", "-122.60193", "America/Vancouver"),
("6066513", "Markham", "Маркем", "CA", "124", "08", "", "", "", "43.86682", "-79.2663", "America/Toronto"),
("6067494", "Mascouche", "", "CA", "124", "10", "14", "", "", "45.74965", "-73.59956", "America/Montreal"),
("6071618", "Medicine Hat", "Медисин-Хат", "CA", "124", "01", "", "", "", "50.05006", "-110.66834", "America/Edmonton"),
("6073363", "Midland", "", "CA", "124", "08", "", "", "", "44.7501", "-79.88296", "America/Toronto"),
("6074377", "Milton", "Милтон", "CA", "124", "08", "5969719", "", "", "43.51681", "-79.88294", "America/Toronto"),
("6075061", "Mirabel", "Мирабель", "CA", "124", "10", "15", "", "", "45.65008", "-74.08251", "America/Montreal"),
("6075081", "Miramichi", "Мирамиши", "CA", "124", "04", "1309", "", "", "47.02895", "-65.50186", "America/Moncton"),
("6075357", "Mississauga", "Миссиссога", "CA", "124", "08", "", "", "", "43.5789", "-79.6583", "America/Toronto"),
("6076211", "Moncton", "Монктон", "CA", "124", "04", "", "", "", "46.11594", "-64.80186", "America/Moncton"),
("6077243", "Montreal", "Монреаль", "CA", "124", "10", "06", "", "", "45.50884", "-73.58781", "America/Montreal"),
("6077315", "Mont-Royal", "", "CA", "124", "10", "", "", "", "45.51675", "-73.64918", "America/Montreal"),
("6077340", "Mont-Saint-Hilaire", "", "CA", "124", "10", "16", "", "", "45.56678", "-73.19915", "America/Montreal"),
("6078112", "Moose Jaw", "Мус-Джо", "CA", "124", "11", "", "", "", "50.40005", "-105.53445", "America/Regina"),
("6082231", "Mount Pearl", "", "CA", "124", "05", "", "", "", "47.51659", "-52.78135", "America/St_Johns"),
("6085772", "Nanaimo", "Нанаймо", "CA", "124", "02", "", "", "", "49.16638", "-123.94003", "America/Vancouver"),
("6087579", "New Glasgow", "", "CA", "124", "07", "", "", "", "45.58344", "-62.64863", "America/Halifax"),
("6087701", "Newmarket", "Ньюмаркет", "CA", "124", "08", "", "", "", "44.05011", "-79.46631", "America/Toronto"),
("6087844", "New Westminster", "Нью-Уэстминстер", "CA", "124", "02", "", "", "", "49.20678", "-122.91092", "America/Vancouver"),
("6087892", "Niagara Falls", "Ниагара-Фолс", "CA", "124", "08", "", "", "", "43.10012", "-79.06627", "America/Toronto"),
("6089125", "Norfolk County", "", "CA", "124", "08", "", "", "", "42.8334", "-80.38297", "America/Toronto"),
("6089404", "North Battleford", "", "CA", "124", "11", "", "", "", "52.77972", "-108.2967", "America/Regina"),
("6089426", "North Bay", "Норт-Бей", "CA", "124", "08", "", "", "", "46.3168", "-79.46633", "America/Toronto"),
("6089661", "North Cowichan", "", "CA", "124", "02", "", "", "", "48.84133", "-123.68596", "America/Vancouver"),
("6090785", "North Vancouver", "", "CA", "124", "02", "5909", "", "", "49.31636", "-123.06934", "America/Vancouver"),
("6091104", "North York", "Норт-Йорк", "CA", "124", "08", "", "", "", "43.76681", "-79.4163", "America/Toronto"),
("6091919", "Oak Bay", "", "CA", "124", "02", "", "", "", "48.44964", "-123.3026", "America/Vancouver"),
("6092122", "Oakville", "Оквилл", "CA", "124", "08", "", "", "", "43.45011", "-79.68292", "America/Toronto"),
("6094201", "Orangeville", "", "CA", "124", "08", "", "", "", "43.9168", "-80.09967", "America/Toronto"),
("6094325", "Orillia", "Ориллия", "CA", "124", "08", "", "", "", "44.60868", "-79.42068", "America/Toronto"),
("6094578", "Oshawa", "Ошава", "CA", "124", "08", "", "", "", "43.90012", "-78.84957", "America/Toronto"),
("6094817", "Ottawa", "Оттава", "CA", "124", "08", "", "", "", "45.41117", "-75.69812", "America/Toronto"),
("6095645", "Owen Sound", "Оуэн-Саунд", "CA", "124", "08", "", "", "", "44.56717", "-80.94349", "America/Toronto"),
("6098642", "Parksville", "", "CA", "124", "02", "5921", "", "", "49.31835", "-124.31494", "America/Vancouver"),
("6100832", "Pembroke", "", "CA", "124", "08", "", "", "", "45.81681", "-77.11616", "America/Toronto"),
("6101141", "Penticton", "", "CA", "124", "02", "", "", "", "49.48062", "-119.58584", "America/Vancouver"),
("6101606", "Petawawa", "", "CA", "124", "08", "", "", "", "45.89452", "-77.28007", "America/Toronto"),
("6101645", "Peterborough", "Питерборо", "CA", "124", "08", "", "", "", "44.30012", "-78.31623", "America/Toronto"),
("6104111", "Pickering", "Пикеринг", "CA", "124", "08", "", "", "", "43.90012", "-79.13289", "America/Toronto"),
("6105815", "Pitt Meadows", "Питт-Медоус", "CA", "124", "02", "", "", "", "49.22119", "-122.68965", "America/Vancouver"),
("6107325", "Pointe-Claire", "", "CA", "124", "10", "06", "", "", "45.44868", "-73.81669", "America/Montreal"),
("6111632", "Port Alberni", "", "CA", "124", "02", "", "", "", "49.24133", "-124.8028", "America/Vancouver"),
("6111704", "Port Colborne", "", "CA", "124", "08", "", "", "", "42.90012", "-79.23288", "America/Toronto"),
("6111962", "Port Moody", "", "CA", "124", "02", "", "", "", "49.28297", "-122.85263", "America/Vancouver"),
("6113335", "Prince Albert", "Принс-Альберт", "CA", "124", "11", "", "", "", "53.20008", "-105.76772", "America/Regina"),
("6113355", "Prince Edward", "", "CA", "124", "08", "", "", "", "44.00012", "-77.24946", "America/Toronto"),
("6113365", "Prince George", "Принс-Джордж", "CA", "124", "02", "", "", "", "53.9166", "-122.75301", "America/Vancouver"),
("6115355", "Quinte West", "", "CA", "124", "08", "", "", "", "44.18342", "-77.56618", "America/Toronto"),
("6117731", "Rayside-Balfour", "", "CA", "124", "08", "", "", "", "46.60873", "-81.20763", "America/Toronto"),
("6118158", "Red Deer", "Ред-Дир", "CA", "124", "01", "", "", "", "52.26682", "-113.802", "America/Edmonton"),
("6119109", "Regina", "Реджайна", "CA", "124", "11", "", "", "", "50.45008", "-104.6178", "America/Regina"),
("6119518", "Repentigny", "Репантиньи", "CA", "124", "10", "14", "", "", "45.74222", "-73.45008", "America/Montreal"),
("6122085", "Richmond", "Ричмонд", "CA", "124", "02", "", "", "", "49.17003", "-123.13683", "America/Vancouver"),
("6122091", "Richmond Hill", "", "CA", "124", "08", "", "", "", "43.87111", "-79.43725", "America/Toronto"),
("6128577", "Rouyn-Noranda", "Руэн-Норанда", "CA", "124", "10", "08", "", "", "48.23656", "-79.02311", "America/Montreal"),
("6137270", "Saguenay", "Сагеней", "CA", "124", "10", "02", "", "", "48.41675", "-71.06573", "America/Montreal"),
("6137489", "Saint-Basile-le-Grand", "", "CA", "124", "10", "16", "", "", "45.53338", "-73.28246", "America/Montreal"),
("6137540", "Saint-Bruno-de-Montarville", "", "CA", "124", "10", "", "", "", "45.53341", "-73.34916", "America/Montreal"),
("6137633", "Saint-Constant", "", "CA", "124", "10", "16", "", "", "45.36678", "-73.56588", "America/Montreal"),
("6137781", "Sainte-Catherine", "", "CA", "124", "10", "", "", "", "46.31836", "-72.56632", "America/Montreal"),
("6137941", "Sainte-Julie", "", "CA", "124", "10", "16", "", "", "45.58338", "-73.33246", "America/Montreal"),
("6138121", "Sainte-Therese", "", "CA", "124", "10", "15", "", "", "45.63922", "-73.82757", "America/Montreal"),
("6138175", "Saint-Eustache", "", "CA", "124", "10", "15", "", "", "45.565", "-73.90554", "America/Montreal"),
("6138374", "Saint-Hyacinthe", "Санкт-Гиацинт", "CA", "124", "10", "16", "", "", "45.63076", "-72.95699", "America/Montreal"),
("6138495", "Saint-Jean-sur-Richelieu", "Сен-Жан-сюр-Ришелье", "CA", "124", "10", "16", "", "", "45.30713", "-73.26259", "America/Montreal"),
("6138501", "Saint-Jerome", "Сен-Жером", "CA", "124", "10", "15", "", "", "45.78036", "-74.00365", "America/Montreal"),
("6138517", "Saint John", "Сент-Джон", "CA", "124", "04", "", "", "", "45.27271", "-66.06766", "America/Moncton"),
("6138610", "Saint-Laurent", "Сен-Лоран", "CA", "124", "10", "", "", "", "45.50008", "-73.66585", "America/Montreal"),
("6138617", "Saint-Lazare", "", "CA", "124", "10", "16", "", "", "45.40008", "-74.13256", "America/Montreal"),
("6138625", "Saint-Leonard", "", "CA", "124", "10", "06", "", "", "45.58773", "-73.59501", "America/Montreal"),
("6139289", "Salaberry-de-Valleyfield", "Салаберри-де-Валлифилд", "CA", "124", "10", "16", "", "", "45.25008", "-74.13253", "America/Montreal"),
("6139416", "Salmon Arm", "Сэлмон-Арм", "CA", "124", "02", "", "", "", "50.6998", "-119.30237", "America/Vancouver"),
("6141190", "Sarnia", "Сарния", "CA", "124", "08", "", "", "", "42.97866", "-82.40407", "America/Toronto"),
("6141256", "Saskatoon", "Саскатун", "CA", "124", "11", "", "", "", "52.11679", "-106.63452", "America/Regina"),
("6141439", "Sault Ste. Marie", "", "CA", "124", "08", "5883638", "", "", "46.51677", "-84.33325", "America/Toronto"),
("6144312", "Sept-Iles", "Сет-Иль", "CA", "124", "10", "09", "", "", "50.20011", "-66.38208", "America/Montreal"),
("6145489", "Shawinigan", "Шавиниган", "CA", "124", "10", "04", "", "", "46.56675", "-72.74913", "America/Montreal"),
("6146143", "Sherbrooke", "Шербрук", "CA", "124", "10", "05", "", "", "45.40008", "-71.89908", "America/Montreal"),
("6146279", "Sherwood Park", "", "CA", "124", "01", "", "", "", "53.51684", "-113.3187", "America/Edmonton"),
("6151352", "Sorel-Tracy", "Сорель-Трейси", "CA", "124", "10", "16", "", "", "46.03336", "-73.11585", "America/Montreal"),
("6154383", "Spruce Grove", "", "CA", "124", "01", "", "", "", "53.53344", "-113.91874", "America/Edmonton"),
("6155033", "St. Albert", "", "CA", "124", "01", "", "", "", "53.63344", "-113.63533", "America/Edmonton"),
("6155721", "St. Catharines", "Сент-Катаринс", "CA", "124", "08", "6087883", "", "", "43.17126", "-79.24267", "America/Toronto"),
("6157977", "Stratford", "Стратфорд", "CA", "124", "08", "", "", "", "43.36679", "-80.94972", "America/Toronto"),
("6158357", "St. Thomas", "", "CA", "124", "08", "", "", "", "42.77361", "-81.18038", "America/Toronto"),
("6159905", "Surrey", "Суррей", "CA", "124", "02", "", "", "", "49.10635", "-122.82509", "America/Vancouver"),
("6162949", "Terrace", "", "CA", "124", "02", "", "", "", "54.51634", "-128.60345", "America/Vancouver"),
("6163012", "Terrebonne", "Тербон", "CA", "124", "10", "14", "", "", "45.70004", "-73.64732", "America/Montreal"),
("6165719", "Thorold", "", "CA", "124", "08", "", "", "", "43.11682", "-79.19958", "America/Toronto"),
("6166142", "Thunder Bay", "Тандер-Бей", "CA", "124", "08", "6166139", "", "", "48.38202", "-89.25018", "America/Thunder_Bay"),
("6166739", "Timmins", "", "CA", "124", "08", "", "", "", "48.46686", "-81.33312", "America/Toronto"),
("6167865", "Toronto", "Торонто", "CA", "124", "08", "", "", "", "43.70011", "-79.4163", "America/Toronto"),
("6169141", "Trois-Rivieres", "Труа-Ривьер", "CA", "124", "10", "04", "", "", "46.34515", "-72.5477", "America/Montreal"),
("6169587", "Truro", "Труро", "CA", "124", "07", "", "", "", "45.36685", "-63.26538", "America/Halifax"),
("6173017", "Val-d'Or", "Валь-д'Ор", "CA", "124", "10", "08", "", "", "48.10018", "-77.7828", "America/Montreal"),
("6173331", "Vancouver", "Ванкувер", "CA", "124", "02", "", "", "", "49.24966", "-123.11934", "America/Vancouver"),
("6173508", "Varennes", "", "CA", "124", "10", "16", "", "", "45.68338", "-73.43246", "America/Montreal"),
("6173570", "Vaudreuil-Dorion", "", "CA", "124", "10", "16", "", "", "45.40008", "-74.03251", "America/Montreal"),
("6173577", "Vaughan", "Вон", "CA", "124", "08", "", "", "", "43.8361", "-79.49827", "America/Toronto"),
("6173864", "Vernon", "Вернон", "CA", "124", "02", "", "", "", "50.25809", "-119.26905", "America/Vancouver"),
("6174041", "Victoria", "Виктория", "CA", "124", "02", "", "", "", "48.43294", "-123.3693", "America/Vancouver"),
("6174151", "Victoriaville", "Викториавилл", "CA", "124", "10", "04", "", "", "46.05007", "-71.96579", "America/Montreal"),
("6176823", "Waterloo", "Ватерлоо", "CA", "124", "08", "", "", "", "43.4668", "-80.51639", "America/Toronto"),
("6177869", "Welland", "", "CA", "124", "08", "", "", "", "42.98342", "-79.24958", "America/Toronto"),
("6178582", "West End", "", "CA", "124", "02", "", "", "", "49.28333", "-123.13333", "America/Vancouver"),
("6179226", "Westmount", "Уэстмаунт", "CA", "124", "10", "", "", "", "45.48341", "-73.59918", "America/Montreal"),
("6180550", "Whitehorse", "Уайтхорс", "CA", "124", "12", "", "", "", "60.71611", "-135.05375", "America/Whitehorse"),
("6180961", "White Rock", "", "CA", "124", "02", "5915", "", "", "49.01636", "-122.8026", "America/Vancouver"),
("6182962", "Windsor", "Уинсор", "CA", "124", "08", "", "", "", "42.30008", "-83.01654", "America/Toronto"),
("6183235", "Winnipeg", "Виннипег", "CA", "124", "03", "", "", "", "49.8844", "-97.14704", "America/Winnipeg"),
("6184365", "Woodstock", "Вудсток", "CA", "124", "08", "", "", "", "43.13339", "-80.7497", "America/Toronto"),
("6185377", "Yellowknife", "Йеллоунайф", "CA", "124", "13", "", "", "", "62.456", "-114.35255", "America/Yellowknife"),
("6185607", "Yorkton", "", "CA", "124", "11", "", "", "", "51.2167", "-102.46766", "America/Regina"),
("6324729", "Halifax", "Галифакс", "CA", "124", "07", "", "", "", "44.64533", "-63.57239", "America/Halifax"),
("6324733", "St. John's", "Сент-Джонс", "CA", "124", "05", "", "", "", "47.56494", "-52.70931", "America/St_Johns"),
("6325494", "Quebec", "Квебек", "CA", "124", "10", "", "", "", "46.81228", "-71.21454", "America/Montreal"),
("6325521", "Levis", "Леви", "CA", "124", "10", "12", "", "", "46.80326", "-71.17793", "America/Montreal"),
("6354895", "Rimouski", "Римуски", "CA", "124", "10", "01", "", "", "48.44879", "-68.52396", "America/Montreal"),
("6354897", "Riviere-du-Loup", "Ривьер-дю-Лу", "CA", "124", "10", "01", "", "", "47.82699", "-69.54243", "America/Montreal"),
("6354908", "Sydney", "", "CA", "124", "07", "", "", "", "46.1351", "-60.1831", "America/Glace_Bay"),
("6534203", "L'Ancienne-Lorette", "", "CA", "124", "10", "", "", "", "46.79392", "-71.35191", "America/Montreal"),
("6545023", "Edmundston", "Эдмундстон", "CA", "124", "04", "", "", "", "47.3737", "-68.32512", "America/Moncton"),
("6943827", "Thetford-Mines", "", "CA", "124", "10", "12", "", "", "46.09371", "-71.30539", "America/Montreal"),
("7280414", "Cole Harbour", "", "CA", "124", "07", "", "", "", "44.67244", "-63.47506", "America/Halifax"),
("7281931", "Okanagan", "", "CA", "124", "02", "", "", "", "50.36386", "-119.34997", "America/Vancouver"),
("7281936", "West Kelowna", "", "CA", "124", "02", "", "", "", "49.8625", "-119.58333", "America/Vancouver"),
("7302647", "Bellechasse Regional County Municipality", "", "CA", "124", "10", "12", "", "", "46.66667", "-70.71667", "America/Montreal"),
("7303786", "Jonquiere", "Жонкьер", "CA", "124", "10", "02", "", "", "48.41648", "-71.24884", "America/Montreal"),
("7535681", "Saint-Augustin-de-Desmaures", "", "CA", "124", "10", "03", "", "", "46.74064", "-71.45131", "America/Montreal"),
("7602078", "Ladner", "", "CA", "124", "02", "", "", "", "49.08938", "-123.08241", "America/Vancouver"),
("7669012", "Walnut Grove", "", "CA", "124", "02", "", "", "", "49.16473", "-122.64042", "America/Vancouver"),
("8285452", "Ancaster", "Анкастер", "CA", "124", "08", "", "", "", "43.21806", "-79.98716", "America/Toronto"),
("8533869", "West Vancouver", "", "CA", "124", "02", "", "", "", "49.36672", "-123.16652", "America/Vancouver"),
("8558534", "Willowdale", "", "CA", "124", "08", "", "", "", "43.76672", "-79.39909", "America/Toronto"),
("7304591", "West Island", "", "CC", "166", "", "", "", "", "-12.15681", "96.82251", "Indian/Cocos"),
("237478", "Mobaye", "", "CF", "140", "02", "", "", "", "4.31902", "21.17861", "Africa/Bangui"),
("238566", "Ippy", "", "CF", "140", "11", "", "", "", "6.26793", "21.22468", "Africa/Bangui"),
("239899", "Bria", "Бриа", "CF", "140", "03", "", "", "", "6.54233", "21.98633", "Africa/Bangui"),
("240498", "Bangassou", "Бангасу", "CF", "140", "08", "", "", "", "4.74132", "22.81838", "Africa/Bangui"),
("240604", "Bambari", "Бамбари", "CF", "140", "11", "", "", "", "5.76795", "20.67565", "Africa/Bangui"),
("2383119", "Sibut", "Сибут", "CF", "140", "06", "", "", "", "5.71801", "19.07389", "Africa/Bangui"),
("2383523", "Paoua", "", "CF", "140", "13", "", "", "", "7.24269", "16.44059", "Africa/Bangui"),
("2383827", "Nola", "", "CF", "140", "16", "", "", "", "3.52716", "16.04", "Africa/Bangui"),
("2384770", "Mbaiki", "", "CF", "140", "07", "", "", "", "3.86781", "17.98923", "Africa/Bangui"),
("2386012", "Kaga Bandoro", "", "CF", "140", "15", "", "", "", "6.98961", "19.18744", "Africa/Bangui"),
("2387435", "Damara", "Дамара", "CF", "140", "17", "", "", "", "4.96075", "18.7035", "Africa/Bangui"),
("2387495", "Carnot", "", "CF", "140", "04", "", "", "", "4.94273", "15.87735", "Africa/Bangui"),
("2387546", "Bozoum", "Бозуме", "CF", "140", "13", "", "", "", "6.31933", "16.37992", "Africa/Bangui"),
("2387926", "Bouar", "Буаре", "CF", "140", "09", "", "", "", "5.93404", "15.59599", "Africa/Bangui"),
("2388036", "Bossangoa", "Босангоа", "CF", "140", "12", "", "", "", "6.49263", "17.45518", "Africa/Bangui"),
("2388614", "Boda", "", "CF", "140", "07", "", "", "", "4.31887", "17.46953", "Africa/Bangui"),
("2388873", "Bimbo", "", "CF", "140", "17", "", "", "", "4.25671", "18.41583", "Africa/Bangui"),
("2389086", "Berberati", "Берберати", "CF", "140", "04", "", "", "", "4.26116", "15.79216", "Africa/Bangui"),
("2389691", "Batangafo", "", "CF", "140", "12", "", "", "", "7.30082", "18.2833", "Africa/Bangui"),
("2389853", "Bangui", "Банги", "CF", "140", "18", "", "", "", "4.36122", "18.55496", "Africa/Bangui"),
("2657896", "Zurich", "Цюрих", "CH", "756", "ZH", "112", "261", "", "47.36667", "8.55", "Europe/Zurich"),
("2657908", "Zug", "Цуг", "CH", "756", "ZG", "900", "1711", "", "47.17242", "8.51744", "Europe/Zurich"),
("2657941", "Yverdon-les-Bains", "Ивердон-ле-Бен", "CH", "756", "VD", "2224", "5938", "", "46.77852", "6.64115", "Europe/Zurich"),
("2657970", "Winterthur", "Винтертур", "CH", "756", "ZH", "110", "230", "", "47.50004", "8.7251", "Europe/Zurich"),
("2657996", "Wil", "Виль", "CH", "756", "SG", "1728", "3427", "", "47.46152", "9.04552", "Europe/Zurich"),
("2658011", "Wettingen", "Веттинген", "CH", "756", "AG", "1902", "4045", "", "47.4705", "8.31636", "Europe/Zurich"),
("2658145", "Vevey", "Веве", "CH", "756", "VD", "2230", "5890", "", "46.46299", "6.84345", "Europe/Zurich"),
("2658154", "Vernier", "", "CH", "756", "GE", "2500", "6643", "", "46.21702", "6.08497", "Europe/Zurich"),
("2658216", "Uster", "Устер", "CH", "756", "ZH", "109", "198", "", "47.34713", "8.72091", "Europe/Zurich"),
("2658377", "Thun", "Тун", "CH", "756", "BE", "247", "942", "", "46.75118", "7.62166", "Europe/Zurich"),
("2658494", "Steffisburg", "", "CH", "756", "BE", "247", "939", "", "46.77807", "7.63249", "Europe/Zurich"),
("2658576", "Sitten", "Сьон", "CH", "756", "VS", "2312", "6266", "", "46.22908", "7.35942", "Europe/Zurich"),
("2658606", "Sierre", "", "CH", "756", "VS", "2311", "6248", "", "46.29192", "7.53559", "Europe/Zurich"),
("2658656", "Zuerich (Kreis 11) / Seebach", "", "CH", "756", "ZH", "112", "261", "", "47.42181", "8.54779", "Europe/Zurich"),
("2658761", "Schaffhausen", "Шаффхаузен", "CH", "756", "SH", "1403", "2939", "", "47.69732", "8.63493", "Europe/Zurich"),
("2658822", "Sankt Gallen", "Санкт-Галлен", "CH", "756", "SG", "1721", "3203", "", "47.42391", "9.37477", "Europe/Zurich"),
("2659070", "Renens", "Ренан", "CH", "756", "VD", "2229", "5591", "", "46.53989", "6.5881", "Europe/Zurich"),
("2659099", "Rapperswil", "Рапперсвиль", "CH", "756", "SG", "1726", "3340", "", "47.22557", "8.82228", "Europe/Zurich"),
("2659127", "Pully", "", "CH", "756", "VD", "2226", "5590", "", "46.51027", "6.66183", "Europe/Zurich"),
("2659296", "Onex", "", "CH", "756", "GE", "2500", "6631", "", "46.18391", "6.10181", "Europe/Zurich"),
("2659297", "Olten", "Ольтен", "CH", "756", "SO", "1108", "2581", "", "47.34999", "7.90329", "Europe/Zurich"),
("2659310", "Zuerich (Kreis 11) / Oerlikon", "", "CH", "756", "ZH", "112", "261", "", "47.40823", "8.54258", "Europe/Zurich"),
("2659422", "Nyon", "Ньон", "CH", "756", "VD", "2228", "5724", "", "46.38318", "6.23955", "Europe/Zurich"),
("2659496", "Neuchatel", "Невшатель", "CH", "756", "NE", "2404", "6458", "", "46.99179", "6.931", "Europe/Zurich"),
("2659522", "Muttenz", "Муттенц", "CH", "756", "BL", "1301", "2770", "", "47.52271", "7.64511", "Europe/Zurich"),
("2659601", "Montreux", "Монтрё", "CH", "756", "VD", "2230", "5886", "", "46.43301", "6.91143", "Europe/Zurich"),
("2659613", "Monthey", "Монте", "CH", "756", "VS", "2308", "6153", "", "46.25546", "6.96066", "Europe/Zurich"),
("2659667", "Meyrin", "Мерен", "CH", "756", "GE", "2500", "6630", "", "46.23424", "6.08025", "Europe/Zurich"),
("2659811", "Luzern", "Люцерн", "CH", "756", "LU", "311", "1061", "", "47.05048", "8.30635", "Europe/Zurich"),
("2659836", "Lugano", "Лугано", "CH", "756", "TI", "2105", "5192", "", "46.01008", "8.96004", "Europe/Zurich"),
("2659873", "Littau", "", "CH", "756", "LU", "311", "1061", "", "47.05", "8.26274", "Europe/Zurich"),
("2659977", "Le Chatelard", "Шатлар", "CH", "756", "VD", "2230", "5886", "", "46.44527", "6.89908", "Europe/Zurich"),
("2659994", "Lausanne", "Лозанна", "CH", "756", "VD", "2225", "5586", "", "46.516", "6.63282", "Europe/Zurich"),
("2660076", "La Chaux-de-Fonds", "Ла-Шо-де-Фон", "CH", "756", "NE", "2402", "6421", "", "47.09993", "6.82586", "Europe/Zurich"),
("2660104", "Kriens", "Кринс", "CH", "756", "LU", "312", "1059", "", "47.03537", "8.27631", "Europe/Zurich"),
("2660108", "Kreuzlingen", "Кройцлинген", "CH", "756", "TG", "2013", "4671", "", "47.65", "9.18333", "Europe/Zurich"),
("2660119", "Koniz", "Кёниц", "CH", "756", "BE", "246", "355", "", "46.92436", "7.41457", "Europe/Zurich"),
("2660127", "Kloten", "Клотен", "CH", "756", "ZH", "103", "62", "", "47.45152", "8.58491", "Europe/Zurich"),
("2660221", "Jona", "", "CH", "756", "SG", "1726", "3340", "", "47.22983", "8.83884", "Europe/Zurich"),
("2660305", "Horgen", "Хорген", "CH", "756", "ZH", "106", "133", "", "47.25579", "8.60027", "Europe/Zurich"),
("2660306", "Zuerich (Kreis 10) / Hoengg", "", "CH", "756", "ZH", "112", "261", "", "47.40313", "8.4971", "Europe/Zurich"),
("2660365", "Herisau", "Херизау", "CH", "756", "AR", "1501", "3001", "", "47.38615", "9.27916", "Europe/Zurich"),
("2660512", "Grenchen", "Гренхен", "CH", "756", "SO", "1107", "2546", "", "47.1921", "7.39586", "Europe/Zurich"),
("2660549", "Gossau", "Госсау", "CH", "756", "SG", "1721", "3443", "", "47.41694", "9.25125", "Europe/Zurich"),
("2660646", "Geneve", "Женева", "CH", "756", "GE", "2500", "6621", "", "46.20222", "6.14569", "Europe/Zurich"),
("2660718", "Fribourg", "Фрибур", "CH", "756", "FR", "1004", "2196", "", "46.80237", "7.15128", "Europe/Zurich"),
("2660727", "Frauenfeld", "Фрауэнфельд", "CH", "756", "TG", "2012", "4566", "", "47.55816", "8.89854", "Europe/Zurich"),
("2660911", "Emmen", "Эммен", "CH", "756", "LU", "313", "1024", "", "47.07772", "8.27888", "Europe/Zurich"),
("2660971", "Dubendorf", "", "CH", "756", "ZH", "109", "191", "", "47.39724", "8.61872", "Europe/Zurich"),
("2661015", "Dietikon", "", "CH", "756", "ZH", "111", "243", "", "47.40165", "8.40015", "Europe/Zurich"),
("2661169", "Chur", "Кур", "CH", "756", "GR", "1829", "3901", "", "46.84986", "9.53287", "Europe/Zurich"),
("2661265", "Carouge", "Каруж", "CH", "756", "GE", "2500", "6608", "", "46.18096", "6.13921", "Europe/Zurich"),
("2661513", "Biel/Bienne", "Биль", "CH", "756", "BE", "242", "371", "", "47.13713", "7.24608", "Europe/Zurich"),
("2661552", "Bern", "Берн", "CH", "756", "BE", "246", "351", "", "46.94809", "7.44744", "Europe/Zurich"),
("2661567", "Bellinzona", "Беллинцона", "CH", "756", "TI", "2101", "5002", "", "46.19278", "9.01703", "Europe/Zurich"),
("2661604", "Basel", "Базель", "CH", "756", "BS", "1200", "2701", "", "47.5584", "7.57327", "Europe/Zurich"),
("2661646", "Baden", "Баден", "CH", "756", "AG", "1902", "4021", "", "47.47333", "8.30592", "Europe/Zurich"),
("2661653", "Baar", "Бар", "CH", "756", "ZG", "900", "1701", "", "47.19625", "8.52954", "Europe/Zurich"),
("2661666", "Aussersihl", "", "CH", "756", "ZH", "112", "261", "", "47.37752", "8.52127", "Europe/Zurich"),
("2661810", "Allschwil", "Альшвиль", "CH", "756", "BL", "1301", "2762", "", "47.55074", "7.53599", "Europe/Zurich"),
("2661861", "Adliswil", "", "CH", "756", "ZH", "106", "131", "", "47.30997", "8.52462", "Europe/Zurich"),
("2661881", "Aarau", "Арау", "CH", "756", "AG", "1901", "4001", "", "47.39254", "8.04422", "Europe/Zurich"),
("3206590", "Riehen", "Риен", "CH", "756", "BS", "1200", "2703", "", "47.57884", "7.64683", "Europe/Zurich"),
("6295475", "Zuerich (Kreis 10) / Wipkingen", "", "CH", "756", "ZH", "112", "261", "", "47.39503", "8.52529", "Europe/Zurich"),
("6295484", "Zuerich (Kreis 11) / Affoltern", "", "CH", "756", "ZH", "112", "261", "", "47.41814", "8.5122", "Europe/Zurich"),
("6295495", "Zuerich (Kreis 2) / Wollishofen", "", "CH", "756", "ZH", "112", "261", "", "47.3401", "8.53134", "Europe/Zurich"),
("6295498", "Zuerich (Kreis 3) / Sihlfeld", "", "CH", "756", "ZH", "112", "261", "", "47.37382", "8.51164", "Europe/Zurich"),
("6295504", "Zuerich (Kreis 6) / Unterstrass", "", "CH", "756", "ZH", "112", "261", "", "47.3953", "8.53721", "Europe/Zurich"),
("6295512", "Zuerich (Kreis 9) / Albisrieden", "", "CH", "756", "ZH", "112", "261", "", "47.37398", "8.49007", "Europe/Zurich"),
("6295513", "Zuerich (Kreis 9) / Altstetten", "", "CH", "756", "ZH", "112", "261", "", "47.38946", "8.48533", "Europe/Zurich"),
("6295520", "Stadt Winterthur (Kreis 1)", "", "CH", "756", "ZH", "110", "230", "", "47.49494", "8.71954", "Europe/Zurich"),
("6295523", "Zuerich (Kreis 12)", "", "CH", "756", "ZH", "112", "261", "", "47.40372", "8.57608", "Europe/Zurich"),
("6295531", "Seen (Kreis 3)", "", "CH", "756", "ZH", "110", "230", "", "47.47646", "8.76996", "Europe/Zurich"),
("6295532", "Zuerich (Kreis 3)", "", "CH", "756", "ZH", "112", "261", "", "47.35785", "8.50296", "Europe/Zurich"),
("6295533", "Zuerich (Kreis 11)", "", "CH", "756", "ZH", "112", "261", "", "47.42326", "8.52166", "Europe/Zurich"),
("6295534", "Zuerich (Kreis 9)", "", "CH", "756", "ZH", "112", "261", "", "47.38245", "8.47993", "Europe/Zurich"),
("6295536", "Oberwinterthur (Kreis 2)", "", "CH", "756", "ZH", "110", "230", "", "47.51692", "8.76863", "Europe/Zurich"),
("6295539", "Zuerich (Kreis 10)", "", "CH", "756", "ZH", "112", "261", "", "47.40773", "8.5005", "Europe/Zurich"),
("6295540", "Zuerich (Kreis 2)", "", "CH", "756", "ZH", "112", "261", "", "47.33756", "8.5211", "Europe/Zurich"),
("6295542", "Zuerich (Kreis 8)", "", "CH", "756", "ZH", "112", "261", "", "47.3548", "8.56097", "Europe/Zurich"),
("6295548", "Zuerich (Kreis 7)", "", "CH", "756", "ZH", "112", "261", "", "47.37328", "8.58038", "Europe/Zurich"),
("6295550", "Zuerich (Kreis 6)", "", "CH", "756", "ZH", "112", "261", "", "47.39223", "8.54381", "Europe/Zurich"),
("6691640", "Lancy", "Ланси", "CH", "756", "GE", "2500", "6628", "", "46.18981", "6.11441", "Europe/Zurich"),
("2279172", "Zuenoula", "", "CI", "385", "83", "", "", "", "7.43027", "-6.05054", "Africa/Abidjan"),
("2279755", "Yamoussoukro", "Ямусукро", "CI", "385", "81", "", "", "", "6.82055", "-5.27674", "Africa/Abidjan"),
("2280045", "Vavoua", "Вавуа", "CI", "385", "80", "", "", "", "7.38194", "-6.47778", "Africa/Abidjan"),
("2280316", "Toumodi", "", "CI", "385", "81", "", "", "", "6.55799", "-5.01769", "Africa/Abidjan"),
("2280376", "Touba", "", "CI", "385", "75", "", "", "", "8.28333", "-7.68333", "Africa/Abidjan"),
("2280589", "Tengrela", "", "CI", "385", "87", "", "", "", "10.48115", "-6.40694", "Africa/Abidjan"),
("2280761", "Tiassale", "", "CI", "385", "82", "", "", "", "5.89839", "-4.82293", "Africa/Abidjan"),
("2280995", "Tanda", "", "CI", "385", "92", "", "", "", "7.80336", "-3.16832", "Africa/Abidjan"),
("2281120", "Tabou", "", "CI", "385", "76", "", "", "", "4.42295", "-7.3528", "Africa/Abidjan"),
("2281606", "Sinfra", "", "CI", "385", "92", "", "", "", "6.62103", "-5.91144", "Africa/Abidjan"),
("2281951", "Sassandra", "Сассандра", "CI", "385", "76", "", "", "", "4.95384", "-6.08531", "Africa/Abidjan"),
("2282006", "San-Pedro", "", "CI", "385", "76", "", "", "", "4.74851", "-6.6363", "Africa/Abidjan"),
("2282178", "Sakassou", "", "CI", "385", "90", "", "", "", "7.45462", "-5.29263", "Africa/Abidjan"),
("2282827", "Oume", "", "CI", "385", "79", "", "", "", "6.38309", "-5.41759", "Africa/Abidjan"),
("2283016", "Odienne", "Одиенне", "CI", "385", "77", "", "", "", "9.50511", "-7.56433", "Africa/Abidjan"),
("2284589", "Mankono", "", "CI", "385", "91", "", "", "", "8.05861", "-6.18972", "Africa/Abidjan"),
("2284647", "Man", "", "CI", "385", "78", "", "", "", "7.41251", "-7.55383", "Africa/Abidjan"),
("2285449", "Lakota", "Лакота", "CI", "385", "88", "", "", "", "5.84752", "-5.682", "Africa/Abidjan"),
("2286304", "Korhogo", "Корого", "CI", "385", "87", "", "", "", "9.45803", "-5.62961", "Africa/Abidjan"),
("2287298", "Katiola", "", "CI", "385", "90", "", "", "", "8.13728", "-5.10095", "Africa/Abidjan"),
("2287790", "Issia", "", "CI", "385", "80", "", "", "", "6.49224", "-6.58558", "Africa/Abidjan"),
("2287958", "Guiglo", "", "CI", "385", "78", "", "", "", "6.54368", "-7.4935", "Africa/Abidjan"),
("2288115", "Grand-Bassam", "Гран-Бассам", "CI", "385", "89", "", "", "", "5.2118", "-3.73884", "Africa/Abidjan"),
("2288118", "Affery", "", "CI", "385", "82", "", "", "", "6.32035", "-3.95235", "Africa/Abidjan"),
("2288829", "Gagnoa", "", "CI", "385", "79", "", "", "", "6.13193", "-5.9506", "Africa/Abidjan"),
("2289049", "Ferkessedougou", "Феркеседугу", "CI", "385", "87", "", "", "", "9.5928", "-5.19449", "Africa/Abidjan"),
("2289549", "Duekoue", "", "CI", "385", "78", "", "", "", "6.74202", "-7.34918", "Africa/Abidjan"),
("2289887", "Divo", "", "CI", "385", "88", "", "", "", "5.83739", "-5.35723", "Africa/Abidjan"),
("2289983", "Dimbokro", "", "CI", "385", "81", "", "", "", "6.64678", "-4.70519", "Africa/Abidjan"),
("2290412", "Daoukro", "Даукро", "CI", "385", "86", "", "", "", "7.0591", "-3.9631", "Africa/Abidjan"),
("2290462", "Danane", "Данане", "CI", "385", "78", "", "", "", "7.25957", "-8.15498", "Africa/Abidjan"),
("2290486", "Daloa", "Далоа", "CI", "385", "80", "", "", "", "6.87736", "-6.45022", "Africa/Abidjan"),
("2290582", "Dabou", "Даб", "CI", "385", "82", "", "", "", "5.32556", "-4.37685", "Africa/Abidjan"),
("2290836", "Boundiali", "Бундиали", "CI", "385", "87", "", "", "", "9.52167", "-6.48694", "Africa/Abidjan"),
("2290849", "Bouna", "Буна", "CI", "385", "92", "", "", "", "9.26926", "-2.9951", "Africa/Abidjan"),
("2290956", "Bouake", "Буаке", "CI", "385", "90", "", "", "", "7.69385", "-5.03031", "Africa/Abidjan"),
("2290964", "Bouafle", "", "CI", "385", "83", "", "", "", "6.99041", "-5.7442", "Africa/Abidjan"),
("2291087", "Bonoua", "", "CI", "385", "89", "", "", "", "5.27247", "-3.59625", "Africa/Abidjan"),
("2291113", "Bongouanou", "", "CI", "385", "81", "", "", "", "6.65175", "-4.20406", "Africa/Abidjan"),
("2291136", "Bondoukou", "Бондуку", "CI", "385", "92", "", "", "", "8.0402", "-2.80003", "Africa/Abidjan"),
("2291580", "Bingerville", "", "CI", "385", "82", "", "", "", "5.35581", "-3.88537", "Africa/Abidjan"),
("2291666", "Biankouma", "", "CI", "385", "78", "", "", "", "7.73909", "-7.61377", "Africa/Abidjan"),
("2291779", "Beoumi", "", "CI", "385", "90", "", "", "", "7.67395", "-5.58086", "Africa/Abidjan"),
("2292179", "Bangolo", "", "CI", "385", "78", "", "", "", "7.01232", "-7.4864", "Africa/Abidjan"),
("2292755", "Arrah", "", "CI", "385", "81", "", "", "", "6.67342", "-3.96938", "Africa/Abidjan"),
("2292852", "Anyama", "Аньяме", "CI", "385", "82", "", "", "", "5.49462", "-4.05183", "Africa/Abidjan"),
("2293107", "Akoupe", "", "CI", "385", "82", "", "", "", "6.38423", "-3.88759", "Africa/Abidjan"),
("2293260", "Agnibilekrou", "", "CI", "385", "85", "", "", "", "7.13113", "-3.20415", "Africa/Abidjan"),
("2293268", "Agboville", "Агбовиле", "CI", "385", "74", "", "", "", "5.92801", "-4.21319", "Africa/Abidjan"),
("2293342", "Adzope", "Адзопе", "CI", "385", "82", "", "", "", "6.10694", "-3.86194", "Africa/Abidjan"),
("2293428", "Adiake", "", "CI", "385", "89", "", "", "", "5.28634", "-3.30402", "Africa/Abidjan"),
("2293507", "Aboisso", "Абуассо", "CI", "385", "89", "", "", "", "5.46779", "-3.20711", "Africa/Abidjan"),
("2293521", "Abobo", "", "CI", "385", "82", "", "", "", "5.41613", "-4.0159", "Africa/Abidjan"),
("2293538", "Abidjan", "Абиджан", "CI", "385", "82", "", "", "", "5.30966", "-4.01266", "Africa/Abidjan"),
("2293549", "Abengourou", "Абенгуру", "CI", "385", "85", "", "", "", "6.72972", "-3.49639", "Africa/Abidjan"),
("2596934", "Seguela", "Сегеле", "CI", "385", "91", "", "", "", "7.96111", "-6.67306", "Africa/Abidjan"),
("2598243", "Soubre", "", "CI", "385", "76", "", "", "", "5.78556", "-6.60833", "Africa/Abidjan"),
("2220957", "Yaounde", "Яунде", "CM", "120", "11", "", "", "", "3.86667", "11.51667", "Africa/Douala"),
("2221030", "Yagoua", "", "CM", "120", "12", "", "", "", "10.34107", "15.23288", "Africa/Douala"),
("2221053", "Wum", "", "CM", "120", "07", "", "", "", "6.38333", "10.06667", "Africa/Douala"),
("2221394", "Tonga", "", "CM", "120", "08", "", "", "", "4.96667", "10.7", "Africa/Douala"),
("2221504", "Tiko", "", "CM", "120", "09", "", "", "", "4.0745", "9.3699", "Africa/Douala"),
("2221530", "Tibati", "", "CM", "120", "10", "", "", "", "6.46504", "12.62843", "Africa/Douala"),
("2221607", "Tchollire", "", "CM", "120", "13", "", "", "", "8.4022", "14.1698", "Africa/Douala"),
("2222230", "Sangmelima", "Сангмелима", "CM", "120", "14", "", "", "", "2.93333", "11.98333", "Africa/Douala"),
("2222623", "Penja", "", "CM", "120", "05", "", "", "", "4.63911", "9.67987", "Africa/Douala"),
("2223293", "Obala", "", "CM", "120", "11", "", "", "", "4.16667", "11.53333", "Africa/Douala"),
("2223734", "Nkoteng", "", "CM", "120", "11", "", "", "", "4.51667", "12.03333", "Africa/Douala"),
("2223763", "Nkongsamba", "Нконгсамба", "CM", "120", "05", "", "", "", "4.9547", "9.9404", "Africa/Douala"),
("2224827", "Ngaoundere", "", "CM", "120", "10", "", "", "", "7.32765", "13.58472", "Africa/Douala"),
("2225457", "Nanga Eboko", "", "CM", "120", "11", "", "", "", "4.68333", "12.36667", "Africa/Douala"),
("2225726", "Muyuka", "", "CM", "120", "09", "", "", "", "4.2898", "9.4103", "Africa/Douala"),
("2225728", "Mutengene", "", "CM", "120", "09", "", "", "", "4.0913", "9.3144", "Africa/Douala"),
("2225991", "Mora", "Море", "CM", "120", "12", "", "", "", "11.04611", "14.14011", "Africa/Douala"),
("2226275", "Mokolo", "", "CM", "120", "12", "", "", "", "10.74244", "13.80227", "Africa/Douala"),
("2227230", "Melong", "", "CM", "120", "05", "", "", "", "5.1218", "9.96143", "Africa/Douala"),
("2227402", "Meiganga", "Мейганге", "CM", "120", "10", "", "", "", "6.51667", "14.3", "Africa/Douala"),
("2227613", "Mbouda", "", "CM", "120", "08", "", "", "", "5.62611", "10.2542", "Africa/Douala"),
("2228005", "Mbanga", "", "CM", "120", "05", "", "", "", "4.5016", "9.5671", "Africa/Douala"),
("2228028", "Mbandjok", "", "CM", "120", "11", "", "", "", "4.45", "11.9", "Africa/Douala"),
("2228079", "Mbalmayo", "Мбальмайо", "CM", "120", "11", "", "", "", "3.51667", "11.5", "Africa/Douala"),
("2228373", "Maroua", "Маруа", "CM", "120", "12", "", "", "", "10.59095", "14.31592", "Africa/Douala"),
("2228499", "Manjo", "", "CM", "120", "05", "", "", "", "4.8428", "9.8217", "Africa/Douala"),
("2228675", "Mamfe", "", "CM", "120", "09", "", "", "", "5.754", "9.3123", "Africa/Douala"),
("2229152", "Loum", "Лум", "CM", "120", "05", "", "", "", "4.7182", "9.7351", "Africa/Douala"),
("2229267", "Lolodorf", "", "CM", "120", "14", "", "", "", "3.23333", "10.73333", "Africa/Douala"),
("2229411", "Limbe", "Лимбе", "CM", "120", "09", "", "", "", "4.0242", "9.2149", "Africa/Douala"),
("2229681", "Lagdo", "", "CM", "120", "13", "", "", "", "9.0263", "13.6919", "Africa/Douala"),
("2229748", "Kumbo", "", "CM", "120", "07", "", "", "", "6.2", "10.66667", "Africa/Douala"),
("2229752", "Kumba", "Кумбой", "CM", "120", "09", "", "", "", "4.6363", "9.4469", "Africa/Douala"),
("2229761", "Kribi", "Криби", "CM", "120", "14", "", "", "", "2.95", "9.91667", "Africa/Douala"),
("2229798", "Kousseri", "", "CM", "120", "12", "", "", "", "12.07689", "15.03063", "Africa/Douala"),
("2230599", "Kaele", "", "CM", "120", "12", "", "", "", "10.10917", "14.45083", "Africa/Douala"),
("2230876", "Guider", "", "CM", "120", "13", "", "", "", "9.9333", "13.94672", "Africa/Douala"),
("2231319", "Garoua Boulai", "", "CM", "120", "04", "", "", "", "5.88333", "14.55", "Africa/Douala"),
("2231320", "Garoua", "Гаруа", "CM", "120", "13", "", "", "", "9.30142", "13.39771", "Africa/Douala"),
("2231482", "Fundong", "", "CM", "120", "07", "", "", "", "6.25", "10.26667", "Africa/Douala"),
("2231504", "Foumbot", "", "CM", "120", "08", "", "", "", "5.50803", "10.6325", "Africa/Douala"),
("2231506", "Foumban", "", "CM", "120", "08", "", "", "", "5.72662", "10.89865", "Africa/Douala"),
("2231564", "Fontem", "", "CM", "120", "09", "", "", "", "5.4685", "9.8818", "Africa/Douala"),
("2231881", "Eseka", "", "CM", "120", "11", "", "", "", "3.65", "10.76667", "Africa/Douala"),
("2232239", "Edea", "Эдеа", "CM", "120", "05", "", "", "", "3.8", "10.13333", "Africa/Douala"),
("2232283", "Ebolowa", "", "CM", "120", "14", "", "", "", "2.9", "11.15", "Africa/Douala"),
("2232444", "Dschang", "", "CM", "120", "08", "", "", "", "5.44397", "10.05332", "Africa/Douala"),
("2232593", "Douala", "Дуала", "CM", "120", "05", "", "", "", "4.04827", "9.70428", "Africa/Douala"),
("2232997", "Dizangue", "", "CM", "120", "05", "", "", "", "3.76667", "9.98333", "Africa/Douala"),
("2233410", "Buea", "", "CM", "120", "09", "", "", "", "4.1527", "9.241", "Africa/Douala"),
("2233805", "Bogo", "", "CM", "120", "12", "", "", "", "10.7336", "14.60928", "Africa/Douala"),
("2234359", "Bertoua", "Бертуа", "CM", "120", "04", "", "", "", "4.57728", "13.68459", "Africa/Douala"),
("2234536", "Belabo", "Белабо", "CM", "120", "04", "", "", "", "4.93333", "13.3", "Africa/Douala"),
("2234663", "Batouri", "", "CM", "120", "04", "", "", "", "4.43333", "14.36667", "Africa/Douala"),
("2234794", "Banyo", "", "CM", "120", "10", "", "", "", "6.75", "11.81667", "Africa/Douala"),
("2234865", "Bangangte", "", "CM", "120", "08", "", "", "", "5.14079", "10.52535", "Africa/Douala"),
("2234941", "Bamusso", "", "CM", "120", "09", "", "", "", "4.4591", "8.9027", "Africa/Douala"),
("2234974", "Bamenda", "Баменды", "CM", "120", "07", "", "", "", "5.9597", "10.14597", "Africa/Douala"),
("2235029", "Bali", "Бали", "CM", "120", "07", "", "", "", "5.88737", "10.01176", "Africa/Douala"),
("2235189", "Bafoussam", "Бафуссама", "CM", "120", "08", "", "", "", "5.47775", "10.41759", "Africa/Douala"),
("2235194", "Bafia", "", "CM", "120", "11", "", "", "", "4.75", "11.23333", "Africa/Douala"),
("2235196", "Bafang", "", "CM", "120", "08", "", "", "", "5.15705", "10.1771", "Africa/Douala"),
("2235776", "Akonolinga", "", "CM", "120", "11", "", "", "", "3.76667", "12.25", "Africa/Douala"),
("2594800", "Idenao", "", "CM", "120", "09", "", "", "", "4.2475", "9.00472", "Africa/Douala"),
("1279715", "Rikaze", "Шигадзе", "CN", "156", "14", "", "", "", "29.25", "88.88333", "Asia/Urumqi"),
("1279945", "Jiuquan", "Сучжоу", "CN", "156", "15", "", "", "", "39.74318", "98.51736", "Asia/Chongqing"),
("1280037", "Shache", "", "CN", "156", "13", "", "", "", "38.41667", "77.24056", "Asia/Kashgar"),
("1280281", "Qamdo", "", "CN", "156", "14", "", "", "", "31.1304", "97.17982", "Asia/Urumqi"),
("1280517", "Nagqu", "Нагчу", "CN", "156", "14", "", "", "", "31.47678", "92.05729", "Asia/Urumqi"),
("1280737", "Lhasa", "Лхаса", "CN", "156", "14", "", "", "", "29.65", "91.1", "Asia/Urumqi"),
("1280757", "Laojunmiao", "", "CN", "156", "15", "", "", "", "39.83333", "97.73333", "Asia/Chongqing"),
("1280849", "Kashi", "Кашгар", "CN", "156", "13", "", "", "", "39.47066", "75.98951", "Asia/Kashgar"),
("1280957", "Jiayuguan", "Цзяюйгуань", "CN", "156", "15", "", "", "", "39.81121", "98.28618", "Asia/Chongqing"),
("1281019", "Hotan", "Хотан", "CN", "156", "13", "", "", "", "37.1075", "79.93548", "Asia/Kashgar"),
("1281368", "Deqen", "Дечен", "CN", "156", "14", "", "", "", "29.96178", "90.71875", "Asia/Urumqi"),
("1529102", "UEruemqi", "Урумчи", "CN", "156", "13", "", "", "", "43.80096", "87.60046", "Asia/Urumqi"),
("1529114", "Laochenglu", "Турфан", "CN", "156", "13", "", "", "", "42.9251", "89.16831", "Asia/Urumqi"),
("1529195", "Shihezi", "Шихэцзы", "CN", "156", "13", "", "", "", "44.3023", "86.03694", "Asia/Urumqi"),
("1529363", "Kuche", "Куча", "CN", "156", "13", "", "", "", "41.72778", "82.93639", "Asia/Urumqi"),
("1529376", "Sayibage", "Корла", "CN", "156", "13", "", "", "", "41.76055", "86.15231", "Asia/Urumqi"),
("1529452", "Hoxtolgay", "", "CN", "156", "13", "", "", "", "46.51872", "86.00214", "Asia/Urumqi"),
("1529484", "Hami", "Хами", "CN", "156", "13", "", "", "", "42.83393", "93.50601", "Asia/Urumqi"),
("1529569", "Yan'an Beilu", "Чанцзи", "CN", "156", "13", "", "", "", "44.00782", "87.30461", "Asia/Urumqi"),
("1529626", "Baijiantan", "", "CN", "156", "13", "", "", "", "45.68928", "85.12441", "Asia/Urumqi"),
("1529641", "Aral", "Аральское", "CN", "156", "13", "", "", "", "40.51556", "81.26361", "Asia/Kashgar"),
("1529651", "Altay", "Алтайская", "CN", "156", "13", "", "", "", "47.84864", "88.13361", "Asia/Urumqi"),
("1529660", "Yingbazha", "Аксу", "CN", "156", "13", "", "", "", "41.11312", "80.26918", "Asia/Kashgar"),
("1783621", "Zunyi", "Цзуньи", "CN", "156", "18", "", "", "", "27.68667", "106.90722", "Asia/Chongqing"),
("1783633", "Zoucheng", "", "CN", "156", "25", "", "", "", "35.40056", "116.96556", "Asia/Shanghai"),
("1783683", "Yanjiang", "Цзыян", "CN", "156", "32", "", "", "", "30.12108", "104.64811", "Asia/Chongqing"),
("1783745", "Zigong", "Цзыгун", "CN", "156", "32", "", "", "", "29.34162", "104.77689", "Asia/Chongqing"),
("1783763", "Zhuzhou", "Чжучжоу", "CN", "156", "11", "1783761", "", "", "27.83333", "113.15", "Asia/Shanghai"),
("1783873", "Zhumadian", "Чжумадянь", "CN", "156", "09", "", "", "", "32.97944", "114.02944", "Asia/Shanghai"),
("1783934", "Shangqiu", "Шанцю", "CN", "156", "09", "", "", "", "34.45", "115.65", "Asia/Shanghai"),
("1783940", "Zhuji", "", "CN", "156", "02", "", "", "", "29.71876", "120.24233", "Asia/Shanghai"),
("1783988", "Mizhou", "", "CN", "156", "25", "", "", "", "35.99472", "119.3975", "Asia/Shanghai"),
("1784055", "Zhuanghe", "", "CN", "156", "19", "", "", "", "39.70083", "122.99111", "Asia/Shanghai"),
("1784074", "Zhouzhuang", "Чжоучжуан", "CN", "156", "04", "", "", "", "31.11788", "120.84427", "Asia/Shanghai"),
("1784130", "Zhoukou", "Чжоуко", "CN", "156", "09", "", "", "", "33.63333", "114.63333", "Asia/Shanghai"),
("1784178", "Zhoucun", "", "CN", "156", "25", "", "", "", "36.81667", "117.81667", "Asia/Shanghai"),
("1784185", "Yuxi", "Юйси", "CN", "156", "29", "", "", "", "24.355", "102.54222", "Asia/Chongqing"),
("1784253", "Zhongxing", "", "CN", "156", "04", "", "", "", "33.70389", "118.67917", "Asia/Shanghai"),
("1784310", "Zhongshu", "Чжуншу", "CN", "156", "29", "", "", "", "24.51667", "103.76667", "Asia/Chongqing"),
("1784553", "Zhicheng", "", "CN", "156", "02", "", "", "", "31.0054", "119.90488", "Asia/Shanghai"),
("1784554", "Zhicheng", "", "CN", "156", "12", "", "", "", "30.29556", "111.50472", "Asia/Shanghai"),
("1784580", "Zhenzhou", "", "CN", "156", "04", "", "", "", "32.28034", "119.16999", "Asia/Shanghai"),
("1784642", "Zhenjiang", "", "CN", "156", "04", "", "", "", "32.21086", "119.45508", "Asia/Shanghai"),
("1784647", "Zhaobaoshan", "", "CN", "156", "02", "", "", "", "29.9695", "121.68753", "Asia/Shanghai"),
("1784658", "Zhengzhou", "Чжэнчжоу", "CN", "156", "09", "", "", "", "34.75778", "113.64861", "Asia/Shanghai"),
("1784820", "Xinghua", "Синхуа", "CN", "156", "04", "", "", "", "32.93917", "119.83417", "Asia/Shanghai"),
("1784841", "Zhaotong", "Чжаотун", "CN", "156", "29", "", "", "", "27.31667", "103.71667", "Asia/Chongqing"),
("1784853", "Zhaoqing", "Чжаоцин", "CN", "156", "30", "", "", "", "23.05116", "112.45972", "Asia/Shanghai"),
("1784929", "Zhaogezhuang", "", "CN", "156", "10", "", "", "", "39.76667", "118.4", "Asia/Shanghai"),
("1784953", "Luofeng", "", "CN", "156", "25", "", "", "", "37.36497", "120.40997", "Asia/Shanghai"),
("1784990", "Zhanjiang", "Чжаньцзян", "CN", "156", "30", "", "", "", "21.28145", "110.34271", "Asia/Urumqi"),
("1785018", "Zhangzhou", "Чжанчжоу", "CN", "156", "07", "", "", "", "24.51333", "117.65556", "Asia/Shanghai"),
("1785036", "Zhangye", "", "CN", "156", "15", "", "", "", "38.93417", "100.45167", "Asia/Chongqing"),
("1785286", "Zibo", "Цзыбо", "CN", "156", "25", "", "", "", "36.79056", "118.06333", "Asia/Shanghai"),
("1785294", "Anyang", "Аньянг", "CN", "156", "09", "", "", "", "36.09944", "114.32889", "Asia/Shanghai"),
("1785453", "Zaozhuang", "Цзаочжуан", "CN", "156", "25", "", "", "", "34.86472", "117.55417", "Asia/Shanghai"),
("1785462", "Zaoyang", "", "CN", "156", "12", "", "", "", "32.12722", "112.75417", "Asia/Shanghai"),
("1785545", "Yuyao", "Юяо", "CN", "156", "02", "1799395", "1785543", "", "30.05", "121.14944", "Asia/Shanghai"),
("1785566", "Yuzhou", "", "CN", "156", "09", "", "", "", "34.16278", "113.46389", "Asia/Shanghai"),
("1785572", "Yuxia", "", "CN", "156", "26", "", "", "", "34.06154", "108.62905", "Asia/Chongqing"),
("1785623", "Kunshan", "Куньшань", "CN", "156", "04", "", "", "", "31.37762", "120.9543", "Asia/Shanghai"),
("1785655", "Yunyang", "", "CN", "156", "09", "", "", "", "33.44743", "112.71422", "Asia/Shanghai"),
("1785698", "Yunmeng Chengguanzhen", "", "CN", "156", "12", "", "", "", "31.06251", "113.76545", "Asia/Shanghai"),
("1785710", "Jinghong", "", "CN", "156", "29", "", "", "", "21.99102", "100.73409", "Asia/Chongqing"),
("1785716", "Pizhou", "", "CN", "156", "04", "", "", "", "34.31139", "117.95028", "Asia/Shanghai"),
("1785725", "Yunfu", "Юньфу", "CN", "156", "30", "", "", "", "22.92832", "112.03954", "Asia/Chongqing"),
("1785738", "Yuncheng", "Юньчэн", "CN", "156", "24", "", "", "", "35.02306", "110.99278", "Asia/Shanghai"),
("1785777", "Yulin", "Юйлинь", "CN", "156", "26", "", "", "", "38.29056", "109.74944", "Asia/Chongqing"),
("1785781", "Yulin", "", "CN", "156", "16", "", "", "", "22.63333", "110.15", "Asia/Chongqing"),
("1785964", "Yudong", "Юйдун", "CN", "156", "33", "", "", "", "29.385", "106.51944", "Asia/Chongqing"),
("1785974", "Yuci", "", "CN", "156", "24", "", "", "", "37.68028", "112.73194", "Asia/Shanghai"),
("1785980", "Yucheng", "Юйчэн", "CN", "156", "25", "", "", "", "34.92889", "116.46528", "Asia/Shanghai"),
("1786060", "Yuanping", "", "CN", "156", "24", "", "", "", "38.71528", "112.7575", "Asia/Shanghai"),
("1786067", "Qianjiang", "Юаньлинь", "CN", "156", "12", "", "", "", "30.421", "112.8919", "Asia/Shanghai"),
("1786112", "Heyuan", "Хэюань", "CN", "156", "30", "", "", "", "23.73333", "114.68333", "Asia/Shanghai"),
("1786357", "Yongfeng", "", "CN", "156", "11", "", "", "", "27.42829", "112.18338", "Asia/Shanghai"),
("1786378", "Yongchuan", "", "CN", "156", "33", "", "", "", "29.35376", "105.89392", "Asia/Chongqing"),
("1786455", "Yishui", "", "CN", "156", "25", "", "", "", "35.78472", "118.62806", "Asia/Shanghai"),
("1786546", "Zhongxiang", "", "CN", "156", "12", "", "", "", "31.16611", "112.58306", "Asia/Shanghai"),
("1786587", "Yingshang Chengguanzhen", "", "CN", "156", "01", "", "", "", "32.62945", "116.27014", "Asia/Shanghai"),
("1786640", "Chengzhong", "", "CN", "156", "12", "", "", "", "30.94454", "113.55284", "Asia/Shanghai"),
("1786657", "Yinchuan", "Иньчуань", "CN", "156", "21", "", "", "", "38.46806", "106.27306", "Asia/Chongqing"),
("1786676", "Yima", "Йимы", "CN", "156", "09", "", "", "", "34.73806", "111.88389", "Asia/Shanghai"),
("1786720", "Yigou", "", "CN", "156", "09", "", "", "", "35.81139", "114.31667", "Asia/Shanghai"),
("1786731", "Qingzhou", "Цинчжоу", "CN", "156", "25", "", "", "", "36.69667", "118.47972", "Asia/Shanghai"),
("1786746", "Yichun", "Ичунь", "CN", "156", "03", "", "", "", "27.83333", "114.4", "Asia/Shanghai"),
("1786759", "Yicheng", "", "CN", "156", "12", "", "", "", "31.70472", "112.25611", "Asia/Shanghai"),
("1786760", "Yicheng", "", "CN", "156", "04", "", "", "", "31.36059", "119.82016", "Asia/Shanghai"),
("1786764", "Yichang", "Ичан", "CN", "156", "12", "", "", "", "30.71444", "111.28472", "Asia/Shanghai"),
("1786770", "Yibin", "Ибинь", "CN", "156", "32", "", "", "", "28.76667", "104.62383", "Asia/Chongqing"),
("1786855", "Yatou", "Жунчэн", "CN", "156", "25", "", "", "", "37.1566", "122.43762", "Asia/Shanghai"),
("1786867", "Yashan", "", "CN", "156", "16", "", "", "", "22.1975", "109.94194", "Asia/Chongqing"),
("1787031", "Yanzhou", "", "CN", "156", "25", "", "", "", "35.55278", "116.82861", "Asia/Shanghai"),
("1787093", "Yantai", "Яньтай", "CN", "156", "25", "", "", "", "37.47649", "121.44081", "Asia/Shanghai"),
("1787144", "Yanliang", "", "CN", "156", "26", "", "", "", "34.65918", "109.22921", "Asia/Chongqing"),
("1787227", "Yangzhou", "Янчжоу", "CN", "156", "04", "", "", "", "32.39722", "119.43583", "Asia/Shanghai"),
("1787323", "Yangshuo", "Яншо", "CN", "156", "16", "", "", "", "24.78081", "110.48967", "Asia/Chongqing"),
("1787331", "Zhangjiagang", "", "CN", "156", "04", "", "", "", "31.865", "120.53889", "Asia/Shanghai"),
("1787351", "Yangquan", "", "CN", "156", "24", "", "", "", "37.8575", "113.56333", "Asia/Shanghai"),
("1787437", "Yangliuqing", "", "CN", "156", "28", "", "", "", "39.1375", "116.99972", "Asia/Shanghai"),
("1787601", "Yanggu", "Янг", "CN", "156", "25", "", "", "", "36.11056", "115.77528", "Asia/Shanghai"),
("1787646", "Yangcun", "", "CN", "156", "28", "", "", "", "39.36389", "117.06028", "Asia/Shanghai"),
("1787746", "Yancheng", "Яньчэн", "CN", "156", "04", "", "", "", "33.3575", "120.1573", "Asia/Shanghai"),
("1787824", "Tongshan", "Сюйчжоу", "CN", "156", "04", "", "", "", "34.18045", "117.15707", "Asia/Shanghai"),
("1787837", "Xucheng", "", "CN", "156", "30", "", "", "", "20.32917", "110.16712", "Asia/Urumqi"),
("1787858", "Shangrao", "Шанжао", "CN", "156", "03", "", "", "", "28.45322", "117.9686", "Asia/Shanghai"),
("1787901", "Xunchang", "", "CN", "156", "32", "", "", "", "28.45433", "104.71498", "Asia/Chongqing"),
("1788046", "Xuchang", "", "CN", "156", "09", "", "", "", "34.01667", "113.81667", "Asia/Shanghai"),
("1788081", "Xuanzhou", "", "CN", "156", "01", "", "", "", "30.9525", "118.75528", "Asia/Shanghai"),
("1788206", "Xixiang", "", "CN", "156", "09", "", "", "", "35.16278", "112.865", "Asia/Shanghai"),
("1788245", "Xiuying", "", "CN", "156", "31", "", "", "", "20.00073", "110.29359", "Asia/Chongqing"),
("1788268", "Xiulin", "", "CN", "156", "12", "", "", "", "29.71667", "112.4", "Asia/Shanghai"),
("1788402", "Xiongzhou", "", "CN", "156", "30", "", "", "", "25.11667", "114.3", "Asia/Shanghai"),
("1788406", "Guixi", "", "CN", "156", "03", "", "", "", "28.28857", "117.21329", "Asia/Shanghai"),
("1788450", "Xinzhou", "Синьчжоу", "CN", "156", "24", "", "", "", "38.40917", "112.73333", "Asia/Shanghai"),
("1788452", "Xinzhou", "", "CN", "156", "12", "", "", "", "30.86667", "114.8", "Asia/Shanghai"),
("1788462", "Xinzhi", "", "CN", "156", "24", "", "", "", "36.49889", "111.70472", "Asia/Shanghai"),
("1788508", "Xinyu", "", "CN", "156", "03", "", "", "", "27.80429", "114.93335", "Asia/Shanghai"),
("1788522", "Xinye", "", "CN", "156", "09", "", "", "", "32.51861", "112.35222", "Asia/Shanghai"),
("1788534", "Xinyang", "Цзинань", "CN", "156", "09", "", "", "", "32.12278", "114.06556", "Asia/Shanghai"),
("1788572", "Xinxiang", "Синьсян", "CN", "156", "09", "", "", "", "35.30889", "113.86722", "Asia/Shanghai"),
("1788618", "Xintai", "", "CN", "156", "25", "", "", "", "35.90056", "117.75194", "Asia/Shanghai"),
("1788638", "Xinshi", "", "CN", "156", "12", "", "", "", "31.04704", "113.14098", "Asia/Shanghai"),
("1788694", "Xinpu", "", "CN", "156", "04", "", "", "", "34.59972", "119.15944", "Asia/Shanghai"),
("1788816", "Xinji", "", "CN", "156", "10", "", "", "", "37.90278", "115.20361", "Asia/Shanghai"),
("1788852", "Xining", "Синин", "CN", "156", "06", "", "", "", "36.62554", "101.75739", "Asia/Chongqing"),
("1788869", "Shangmei", "", "CN", "156", "11", "", "", "", "27.74278", "111.29556", "Asia/Shanghai"),
("1788927", "Xingtai", "Синтай", "CN", "156", "10", "", "", "", "37.06306", "114.49417", "Asia/Shanghai"),
("1789065", "Ankang", "Анкан", "CN", "156", "26", "", "", "", "32.68", "109.01722", "Asia/Chongqing"),
("1789118", "Xindian", "", "CN", "156", "25", "", "", "", "36.7975", "118.29444", "Asia/Shanghai"),
("1789137", "Xindi", "", "CN", "156", "12", "", "", "", "29.81667", "113.46667", "Asia/Shanghai"),
("1789176", "Feicheng", "", "CN", "156", "25", "", "", "", "36.24861", "116.76583", "Asia/Shanghai"),
("1789273", "Sanshui", "", "CN", "156", "30", "", "", "", "23.15486", "112.89161", "Asia/Shanghai"),
("1789289", "Ximei", "", "CN", "156", "07", "", "", "", "24.98773", "118.3858", "Asia/Shanghai"),
("1789427", "Xihua", "", "CN", "156", "09", "", "", "", "33.78333", "114.51667", "Asia/Shanghai"),
("1789462", "Xihe", "", "CN", "156", "12", "", "", "", "31.68636", "113.46585", "Asia/Shanghai"),
("1789647", "Xichang", "Сичан", "CN", "156", "32", "", "", "", "27.89642", "102.26342", "Asia/Chongqing"),
("1789693", "Xiazhuang", "", "CN", "156", "25", "", "", "", "34.91611", "118.63889", "Asia/Shanghai"),
("1789703", "Xiazhen", "", "CN", "156", "25", "", "", "", "34.80222", "117.11167", "Asia/Shanghai"),
("1789799", "Xiashi", "", "CN", "156", "02", "", "", "", "30.53629", "120.68638", "Asia/Shanghai"),
("1789897", "Gongyi", "", "CN", "156", "09", "", "", "", "34.76", "112.97139", "Asia/Shanghai"),
("1789945", "Xiaoweizhai", "", "CN", "156", "18", "", "", "", "26.19028", "107.5125", "Asia/Chongqing"),
("1789998", "Xiaoshan", "Сяошань", "CN", "156", "02", "", "", "", "30.16746", "120.25883", "Asia/Shanghai"),
("1790100", "Xiaolingwei", "", "CN", "156", "04", "", "", "", "32.03244", "118.854", "Asia/Shanghai"),
("1790254", "Xiaogan", "", "CN", "156", "12", "", "", "", "30.92689", "113.92221", "Asia/Shanghai"),
("1790353", "Xianyang", "Саньян", "CN", "156", "26", "", "", "", "34.33778", "108.70261", "Asia/Chongqing"),
("1790371", "Xiantao", "", "CN", "156", "12", "", "", "", "30.3708", "113.44294", "Asia/Shanghai"),
("1790379", "Xianshuigu", "", "CN", "156", "28", "", "", "", "38.985", "117.38278", "Asia/Shanghai"),
("1790392", "Xiannu", "", "CN", "156", "04", "", "", "", "32.42806", "119.56048", "Asia/Shanghai"),
("1790396", "Xianning", "Сяньнин", "CN", "156", "12", "", "", "", "29.88333", "114.21667", "Asia/Shanghai"),
("1790413", "Xianju", "", "CN", "156", "02", "", "", "", "28.8547", "120.73168", "Asia/Shanghai"),
("1790437", "Zhuhai", "Чжухай", "CN", "156", "30", "", "", "", "22.27694", "113.56778", "Asia/Shanghai"),
("1790451", "Wenxing", "", "CN", "156", "11", "", "", "", "28.66667", "112.88333", "Asia/Shanghai"),
("1790471", "Xiangxiang", "", "CN", "156", "11", "", "", "", "27.73333", "112.53333", "Asia/Shanghai"),
("1790492", "Xiangtan", "Сянтань", "CN", "156", "11", "", "", "", "27.85", "112.9", "Asia/Shanghai"),
("1790587", "Xiangyang", "Сянфань", "CN", "156", "12", "", "", "", "32.0422", "112.14479", "Asia/Shanghai"),
("1790601", "Xiangcheng", "", "CN", "156", "09", "", "", "", "33.84703", "113.4778", "Asia/Shanghai"),
("1790630", "Xi'an", "Сиань", "CN", "156", "26", "", "", "", "34.25833", "108.92861", "Asia/Chongqing"),
("1790645", "Xiamen", "Сямэнь", "CN", "156", "07", "", "", "", "24.47979", "118.08187", "Asia/Shanghai"),
("1790840", "Wuzhou", "", "CN", "156", "16", "", "", "", "23.48333", "111.31667", "Asia/Chongqing"),
("1790885", "Wuyang", "", "CN", "156", "01", "", "", "", "31.9925", "116.24722", "Asia/Shanghai"),
("1790894", "Wuxue", "", "CN", "156", "12", "", "", "", "29.85058", "115.5525", "Asia/Shanghai"),
("1790923", "Wuxi", "Уси", "CN", "156", "04", "", "", "", "31.56887", "120.28857", "Asia/Shanghai"),
("1791056", "Dongyang", "", "CN", "156", "02", "", "", "", "29.26778", "120.22528", "Asia/Shanghai"),
("1791121", "Changde", "Чандэ", "CN", "156", "11", "", "", "", "29.04638", "111.6783", "Asia/Shanghai"),
("1791236", "Wuhu", "Уху", "CN", "156", "01", "", "", "", "31.33728", "118.37351", "Asia/Shanghai"),
("1791247", "Wuhan", "Ухань", "CN", "156", "12", "", "", "", "30.58333", "114.26667", "Asia/Shanghai"),
("1791249", "Wuhai", "", "CN", "156", "20", "", "", "", "39.68442", "106.81582", "Asia/Chongqing"),
("1791325", "Wuda", "", "CN", "156", "20", "", "", "", "39.49944", "106.71167", "Asia/Chongqing"),
("1791347", "Wucheng", "", "CN", "156", "01", "", "", "", "29.60077", "118.17495", "Asia/Shanghai"),
("1791388", "Wenzhou", "Вэньчжоу", "CN", "156", "02", "", "", "", "27.99942", "120.66682", "Asia/Shanghai"),
("1791428", "Wenshang", "", "CN", "156", "25", "", "", "", "35.7275", "116.49611", "Asia/Shanghai"),
("1791464", "Wenling", "", "CN", "156", "02", "", "", "", "28.37161", "121.36974", "Asia/Shanghai"),
("1791536", "Tianfu", "", "CN", "156", "25", "", "", "", "37.19723", "122.05228", "Asia/Shanghai"),
("1791636", "Weinan", "Вэйнань", "CN", "156", "26", "", "", "", "34.50355", "109.50891", "Asia/Chongqing"),
("1791673", "Weihai", "Вэйхай", "CN", "156", "25", "", "", "", "37.50914", "122.11356", "Asia/Shanghai"),
("1791681", "Weifang", "Вэйфан", "CN", "156", "25", "", "", "", "36.71", "119.10194", "Asia/Shanghai"),
("1791748", "Wanxian", "", "CN", "156", "33", "", "", "", "30.81544", "108.37089", "Asia/Chongqing"),
("1791779", "Wancheng", "", "CN", "156", "31", "", "", "", "18.80454", "110.39512", "Asia/Chongqing"),
("1792087", "Yinzhu", "", "CN", "156", "25", "", "", "", "35.87861", "119.97528", "Asia/Shanghai"),
("1792260", "Wafangdian", "", "CN", "156", "19", "", "", "", "39.61833", "122.00806", "Asia/Shanghai"),
("1792359", "Huangshan", "Туньси", "CN", "156", "01", "", "", "", "29.71139", "118.3125", "Asia/Shanghai"),
("1792516", "Loushanguan", "", "CN", "156", "18", "", "", "", "28.1368", "106.822", "Asia/Chongqing"),
("1792520", "Tongzhou", "Тунчжоу", "CN", "156", "22", "", "", "", "39.90395", "116.66183", "Asia/Shanghai"),
("1792585", "Fuding", "", "CN", "156", "07", "", "", "", "27.32734", "120.214", "Asia/Shanghai"),
("1792592", "Tongren", "", "CN", "156", "18", "", "", "", "27.71722", "109.18528", "Asia/Chongqing"),
("1792621", "Wusong", "", "CN", "156", "01", "", "", "", "30.95", "117.78333", "Asia/Shanghai"),
("1792692", "Tongchuan", "", "CN", "156", "32", "", "", "", "31.09407", "105.08731", "Asia/Chongqing"),
("1792892", "Tianshui", "", "CN", "156", "15", "", "", "", "34.57952", "105.74238", "Asia/Chongqing"),
("1792916", "Tianpeng", "", "CN", "156", "32", "", "", "", "30.98664", "103.93933", "Asia/Chongqing"),
("1792947", "Tianjin", "Тяньцзинь", "CN", "156", "28", "", "", "", "39.14222", "117.17667", "Asia/Shanghai"),
("1793036", "Tengzhou", "Тэнчжоу", "CN", "156", "25", "", "", "", "35.07706", "117.15176", "Asia/Shanghai"),
("1793089", "Taozhuang", "", "CN", "156", "25", "", "", "", "34.85", "117.33333", "Asia/Shanghai"),
("1793230", "Tantou", "", "CN", "156", "07", "", "", "", "26.03033", "119.59739", "Asia/Shanghai"),
("1793286", "Tangzhai", "", "CN", "156", "01", "", "", "", "34.43278", "116.59111", "Asia/Shanghai"),
("1793346", "Tangshan", "Таншань", "CN", "156", "10", "", "", "", "39.63333", "118.18333", "Asia/Shanghai"),
("1793364", "Tangping", "", "CN", "156", "30", "", "", "", "22.03177", "111.93537", "Asia/Chongqing"),
("1793385", "Tangjiazhuang", "", "CN", "156", "10", "", "", "", "39.73333", "118.45", "Asia/Shanghai"),
("1793419", "Tanghe", "", "CN", "156", "09", "", "", "", "32.68833", "112.8275", "Asia/Shanghai"),
("1793424", "Tanggu", "Танго", "CN", "156", "28", "", "", "", "39.02111", "117.64694", "Asia/Shanghai"),
("1793505", "Taizhou", "Тайчжоу", "CN", "156", "04", "", "", "", "32.49069", "119.90812", "Asia/Shanghai"),
("1793511", "Taiyuan", "Тайюань", "CN", "156", "24", "", "", "", "37.86944", "112.56028", "Asia/Shanghai"),
("1793533", "Taixing", "", "CN", "156", "04", "", "", "", "32.16667", "120.01361", "Asia/Shanghai"),
("1793700", "Taishan", "Тайшань", "CN", "156", "30", "", "", "", "22.25135", "112.7799", "Asia/Chongqing"),
("1793724", "Tai'an", "Тайань", "CN", "156", "25", "", "", "", "36.18528", "117.12", "Asia/Shanghai"),
("1793743", "Suzhou", "Сучжоу", "CN", "156", "01", "", "", "", "33.63611", "116.97889", "Asia/Shanghai"),
("1793774", "Suozhen", "", "CN", "156", "25", "", "", "", "36.95389", "118.10472", "Asia/Shanghai"),
("1793879", "Suizhou", "", "CN", "156", "12", "", "", "", "31.71111", "113.36306", "Asia/Shanghai"),
("1793889", "Suixi", "", "CN", "156", "01", "", "", "", "33.89067", "116.77472", "Asia/Shanghai"),
("1793899", "Suicheng", "", "CN", "156", "04", "", "", "", "33.8963", "117.93307", "Asia/Shanghai"),
("1793900", "Suining", "Суйнин", "CN", "156", "32", "", "", "", "30.50802", "105.57332", "Asia/Chongqing"),
("1794035", "Songjiang", "", "CN", "156", "23", "", "", "", "31.03595", "121.2146", "Asia/Shanghai"),
("1794140", "Sishui", "", "CN", "156", "25", "", "", "", "35.64889", "117.27583", "Asia/Shanghai"),
("1794479", "Laixi", "", "CN", "156", "25", "", "", "", "36.85917", "120.52694", "Asia/Shanghai"),
("1794794", "Shouguang", "Шоугуан", "CN", "156", "25", "", "", "", "36.88", "118.7375", "Asia/Shanghai"),
("1794806", "Shizuishan", "", "CN", "156", "21", "", "", "", "39.23333", "106.76944", "Asia/Chongqing"),
("1794825", "Shizilu", "", "CN", "156", "25", "", "", "", "35.17111", "118.82889", "Asia/Shanghai"),
("1794903", "Shiyan", "Шиянь", "CN", "156", "12", "", "", "", "32.6475", "110.77806", "Asia/Shanghai"),
("1794904", "Shiyan", "Шиян", "CN", "156", "12", "", "", "", "32.56667", "110.78333", "Asia/Shanghai"),
("1794947", "Shiwan", "", "CN", "156", "30", "", "", "", "23.00107", "113.077", "Asia/Shanghai"),
("1794971", "Shitanjing", "", "CN", "156", "21", "", "", "", "39.23417", "106.34389", "Asia/Chongqing"),
("1795055", "Shiqiao", "", "CN", "156", "30", "", "", "", "22.9464", "113.35769", "Asia/Shanghai"),
("1795060", "Shiqi", "", "CN", "156", "30", "", "", "", "22.51682", "113.38521", "Asia/Shanghai"),
("1795166", "Shima", "Шима", "CN", "156", "07", "", "", "", "24.44647", "117.81216", "Asia/Shanghai"),
("1795184", "Shilong", "", "CN", "156", "30", "", "", "", "23.11444", "113.84722", "Asia/Shanghai"),
("1795196", "Tongchuan", "", "CN", "156", "26", "", "", "", "35.08056", "109.08972", "Asia/Chongqing"),
("1795270", "Shijiazhuang", "Шицзячжуан", "CN", "156", "10", "", "", "", "38.04139", "114.47861", "Asia/Shanghai"),
("1795565", "Shenzhen", "Шэньчжэнь", "CN", "156", "30", "1795563", "", "", "22.54554", "114.0683", "Asia/Shanghai"),
("1795579", "Yanta", "", "CN", "156", "25", "", "", "", "36.24111", "115.66722", "Asia/Shanghai"),
("1795632", "Shenjiamen", "", "CN", "156", "02", "", "", "", "29.95762", "122.29802", "Asia/Shanghai"),
("1795816", "Shashi", "Шаши", "CN", "156", "12", "", "", "", "30.30722", "112.24472", "Asia/Shanghai"),
("1795842", "Shaping", "", "CN", "156", "30", "", "", "", "22.77019", "112.95776", "Asia/Shanghai"),
("1795855", "Shaoxing", "Шаосин", "CN", "156", "02", "", "", "", "30.00237", "120.57864", "Asia/Shanghai"),
("1795857", "Shaowu", "", "CN", "156", "07", "", "", "", "27.34089", "117.4831", "Asia/Shanghai"),
("1795874", "Shaoguan", "Шаогуань", "CN", "156", "30", "", "", "", "24.8", "113.58333", "Asia/Shanghai"),
("1795919", "Shancheng", "", "CN", "156", "25", "", "", "", "34.79528", "116.08167", "Asia/Shanghai"),
("1795928", "Shanwei", "Шаньвэй", "CN", "156", "30", "", "", "", "22.78199", "115.3475", "Asia/Shanghai"),
("1795940", "Shantou", "Шаньтоу", "CN", "156", "30", "", "", "", "23.36814", "116.71479", "Asia/Shanghai"),
("1795941", "Shanting", "", "CN", "156", "25", "", "", "", "35.07528", "117.45778", "Asia/Shanghai"),
("1796236", "Shanghai", "Шанхай", "CN", "156", "23", "", "", "", "31.22222", "121.45806", "Asia/Shanghai"),
("1796421", "Shahecheng", "", "CN", "156", "10", "", "", "", "36.93833", "114.50583", "Asia/Shanghai"),
("1796556", "Sanya", "Санья", "CN", "156", "31", "", "", "", "18.24306", "109.505", "Asia/Chongqing"),
("1796663", "Sanming", "Саньмин", "CN", "156", "07", "", "", "", "26.24861", "117.61861", "Asia/Shanghai"),
("1797038", "Runan", "", "CN", "156", "09", "", "", "", "33.00111", "114.35417", "Asia/Shanghai"),
("1797120", "Fuqing", "Фуцинь", "CN", "156", "07", "", "", "", "25.725", "119.37944", "Asia/Shanghai"),
("1797121", "Jieyang", "Цзеян", "CN", "156", "30", "", "", "", "23.5418", "116.36581", "Asia/Shanghai"),
("1797132", "Rizhao", "", "CN", "156", "25", "", "", "", "35.4275", "119.45528", "Asia/Shanghai"),
("1797181", "Renqiu", "", "CN", "156", "10", "", "", "", "38.69889", "116.09361", "Asia/Shanghai"),
("1797264", "Quzhou", "Цюйчжоу", "CN", "156", "02", "", "", "", "28.95944", "118.86861", "Asia/Shanghai"),
("1797318", "Qujing", "", "CN", "156", "29", "", "", "", "25.48333", "103.78333", "Asia/Chongqing"),
("1797333", "Qufu", "Цюйфу", "CN", "156", "25", "", "", "", "35.59667", "116.99111", "Asia/Shanghai"),
("1797353", "Quanzhou", "Цюаньчжоу", "CN", "156", "07", "", "", "", "24.91389", "118.58583", "Asia/Shanghai"),
("1797417", "Wuxi", "", "CN", "156", "11", "", "", "", "26.5844", "111.859", "Asia/Shanghai"),
("1797438", "Zhuangyuan", "", "CN", "156", "25", "", "", "", "37.30553", "120.82747", "Asia/Shanghai"),
("1797535", "Qiongshan", "", "CN", "156", "31", "", "", "", "20.00583", "110.35417", "Asia/Chongqing"),
("1797543", "Qionghu", "", "CN", "156", "11", "", "", "", "28.84061", "112.37399", "Asia/Shanghai"),
("1797551", "Qinzhou", "", "CN", "156", "16", "", "", "", "21.97296", "108.62612", "Asia/Chongqing"),
("1797575", "Qinnan", "", "CN", "156", "04", "", "", "", "33.25306", "119.91333", "Asia/Shanghai"),
("1797595", "Qinhuangdao", "Циньхуандао", "CN", "156", "10", "", "", "", "39.93167", "119.58833", "Asia/Shanghai"),
("1797658", "Jinjiang", "", "CN", "156", "07", "", "", "", "24.81978", "118.57414", "Asia/Shanghai"),
("1797793", "Qingquan", "Цинцюань", "CN", "156", "12", "", "", "", "30.45113", "115.25593", "Asia/Shanghai"),
("1797873", "Huai'an", "", "CN", "156", "04", "", "", "", "33.58861", "119.01917", "Asia/Shanghai"),
("1797929", "Qingdao", "Циндао", "CN", "156", "25", "", "", "", "36.06605", "120.36939", "Asia/Shanghai"),
("1797945", "Qingyuan", "", "CN", "156", "30", "", "", "", "23.7", "113.03333", "Asia/Shanghai"),
("1798082", "Hongqiao", "Хунцяо", "CN", "156", "11", "", "", "", "26.76837", "112.10814", "Asia/Shanghai"),
("1798422", "Puyang Chengguanzhen", "", "CN", "156", "09", "", "", "", "35.70506", "115.01409", "Asia/Shanghai"),
("1798425", "Puyang", "", "CN", "156", "02", "", "", "", "29.45679", "119.88872", "Asia/Shanghai"),
("1798449", "Putian", "Путянь", "CN", "156", "07", "", "", "", "25.43944", "119.01028", "Asia/Shanghai"),
("1798473", "Puqi", "", "CN", "156", "12", "", "", "", "29.71667", "113.88333", "Asia/Shanghai"),
("1798480", "Pumiao", "", "CN", "156", "16", "", "", "", "22.75867", "108.48111", "Asia/Chongqing"),
("1798490", "Pulandian", "", "CN", "156", "19", "", "", "", "39.39528", "121.96694", "Asia/Shanghai"),
("1798548", "Poyang", "Поянху", "CN", "156", "03", "", "", "", "28.99242", "116.66754", "Asia/Shanghai"),
("1798632", "Pingyin", "", "CN", "156", "25", "", "", "", "36.28306", "116.44528", "Asia/Shanghai"),
("1798634", "Pingyi", "", "CN", "156", "25", "", "", "", "35.50056", "117.63083", "Asia/Shanghai"),
("1798636", "Gutao", "Пинъяо", "CN", "156", "24", "", "", "", "37.2025", "112.17806", "Asia/Shanghai"),
("1798654", "Pingxiang", "", "CN", "156", "03", "", "", "", "27.61672", "113.85353", "Asia/Shanghai"),
("1798713", "Pingshan", "", "CN", "156", "30", "", "", "", "22.99376", "114.71311", "Asia/Shanghai"),
("1798733", "Pingnan", "", "CN", "156", "16", "", "", "", "23.54218", "110.38946", "Asia/Chongqing"),
("1798760", "Pingliang", "Пинлян", "CN", "156", "15", "", "", "", "35.53917", "106.68611", "Asia/Chongqing"),
("1798821", "Pingdu", "Пинду", "CN", "156", "25", "", "", "", "36.78444", "119.94639", "Asia/Shanghai"),
("1798827", "Pingdingshan", "Пиндиншань", "CN", "156", "09", "", "", "", "33.73847", "113.30119", "Asia/Shanghai"),
("1798946", "Pengcheng", "", "CN", "156", "10", "", "", "", "36.43111", "114.17", "Asia/Shanghai"),
("1798998", "Dadukou", "Паньчжихуа", "CN", "156", "32", "", "", "", "26.5479", "101.70539", "Asia/Chongqing"),
("1799348", "Ningyang", "", "CN", "156", "25", "", "", "", "35.76417", "116.79139", "Asia/Shanghai"),
("1799352", "Yutan", "", "CN", "156", "11", "", "", "", "28.25831", "112.56048", "Asia/Shanghai"),
("1799383", "Ninghai", "", "CN", "156", "25", "", "", "", "37.38422", "121.60859", "Asia/Shanghai"),
("1799384", "Ninghai", "", "CN", "156", "02", "", "", "", "29.28917", "121.42472", "Asia/Shanghai"),
("1799397", "Ningbo", "Нинбо", "CN", "156", "02", "", "", "", "29.87819", "121.54945", "Asia/Shanghai"),
("1799491", "Neijiang", "", "CN", "156", "32", "", "", "", "29.58354", "105.06216", "Asia/Chongqing"),
("1799552", "Nanzhou", "", "CN", "156", "11", "", "", "", "29.35955", "112.40243", "Asia/Shanghai"),
("1799574", "Nanzhang Chengguanzhen", "", "CN", "156", "12", "", "", "", "31.78394", "111.82752", "Asia/Shanghai"),
("1799629", "Nanyang", "Наньян", "CN", "156", "09", "", "", "", "32.99472", "112.53278", "Asia/Shanghai"),
("1799722", "Nantong", "Наньтун", "CN", "156", "04", "", "", "", "32.03028", "120.87472", "Asia/Shanghai"),
("1799832", "Pucheng", "", "CN", "156", "07", "", "", "", "27.92333", "118.53333", "Asia/Shanghai"),
("1799846", "Nanping", "Наньпин", "CN", "156", "07", "", "", "", "26.645", "118.17361", "Asia/Shanghai"),
("1799869", "Nanning", "Наньнин", "CN", "156", "16", "", "", "", "22.81667", "108.31667", "Asia/Chongqing"),
("1799897", "Nanma", "", "CN", "156", "25", "", "", "", "36.18167", "118.15833", "Asia/Shanghai"),
("1799908", "Nanlong", "", "CN", "156", "32", "", "", "", "31.35333", "106.06309", "Asia/Chongqing"),
("1799962", "Nanjing", "Нанкин", "CN", "156", "04", "", "", "", "32.06167", "118.77778", "Asia/Shanghai"),
("1800065", "Nangong", "", "CN", "156", "10", "", "", "", "37.35806", "115.37444", "Asia/Shanghai"),
("1800088", "Nanfeng", "", "CN", "156", "30", "", "", "", "23.72695", "111.79723", "Asia/Shanghai"),
("1800101", "Nandu", "", "CN", "156", "16", "", "", "", "22.8525", "110.82333", "Asia/Chongqing"),
("1800107", "Nanding", "", "CN", "156", "25", "", "", "", "36.74833", "118.05583", "Asia/Shanghai"),
("1800146", "Nanchong", "Наньчун", "CN", "156", "32", "", "", "", "30.79508", "106.08474", "Asia/Chongqing"),
("1800163", "Nanchang", "Наньчан", "CN", "156", "03", "", "", "", "28.68333", "115.88333", "Asia/Shanghai"),
("1800430", "Miyang", "", "CN", "156", "29", "", "", "", "24.40417", "103.44278", "Asia/Chongqing"),
("1800498", "Mingshui", "", "CN", "156", "25", "", "", "", "36.71667", "117.5", "Asia/Shanghai"),
("1800519", "Mingguang", "", "CN", "156", "01", "", "", "", "32.78017", "117.96378", "Asia/Shanghai"),
("1800521", "Minggang", "", "CN", "156", "09", "", "", "", "32.45861", "114.04861", "Asia/Shanghai"),
("1800627", "Mianyang", "Мяньян", "CN", "156", "32", "", "", "", "31.45934", "104.75424", "Asia/Chongqing"),
("1800657", "Mentougou", "", "CN", "156", "22", "", "", "", "39.93819", "116.09307", "Asia/Shanghai"),
("1800675", "Mengyin", "", "CN", "156", "25", "", "", "", "35.70694", "117.92639", "Asia/Shanghai"),
("1800764", "Mengcheng Chengguanzhen", "", "CN", "156", "01", "", "", "", "33.26611", "116.56605", "Asia/Shanghai"),
("1800779", "Meizhou", "Мэйчжоу", "CN", "156", "30", "", "", "", "24.29769", "116.10724", "Asia/Shanghai"),
("1800829", "Wuchuan", "", "CN", "156", "30", "", "", "", "21.45713", "110.76591", "Asia/Urumqi"),
("1801401", "Majie", "", "CN", "156", "29", "", "", "", "25.03333", "102.63611", "Asia/Chongqing"),
("1801455", "Zhijiang", "", "CN", "156", "12", "", "", "", "30.42139", "111.75333", "Asia/Shanghai"),
("1801582", "Macheng", "", "CN", "156", "12", "", "", "", "31.18013", "115.02213", "Asia/Shanghai"),
("1801615", "Maba", "", "CN", "156", "30", "", "", "", "24.68412", "113.59839", "Asia/Shanghai"),
("1801722", "Lushun", "Порт-Артур", "CN", "156", "19", "", "", "", "38.8", "121.26667", "Asia/Shanghai"),
("1801757", "Luqiao", "", "CN", "156", "02", "", "", "", "28.58023", "121.37491", "Asia/Shanghai"),
("1801792", "Luoyang", "Лоян", "CN", "156", "09", "1801785", "", "", "34.68361", "112.45361", "Asia/Shanghai"),
("1801797", "Luoyang", "Лоян", "CN", "156", "07", "", "", "", "24.95938", "118.683", "Asia/Shanghai"),
("1801799", "Luoyang", "Лоян", "CN", "156", "30", "", "", "", "23.16244", "114.27342", "Asia/Shanghai"),
("1801850", "Luorong", "", "CN", "156", "16", "", "", "", "24.40583", "109.60861", "Asia/Chongqing"),
("1801934", "Luohe", "", "CN", "156", "09", "", "", "", "33.57167", "114.03528", "Asia/Shanghai"),
("1801983", "Luocheng", "", "CN", "156", "32", "", "", "", "29.38481", "104.02862", "Asia/Chongqing"),
("1802068", "Lucheng", "", "CN", "156", "01", "", "", "", "31.23357", "117.28057", "Asia/Shanghai"),
("1802171", "Kangding", "Кандин", "CN", "156", "32", "", "", "", "30.05127", "101.96033", "Asia/Chongqing"),
("1802177", "Lubu", "", "CN", "156", "30", "", "", "", "23.17233", "112.28298", "Asia/Shanghai"),
("1802204", "Luancheng", "", "CN", "156", "10", "", "", "", "37.87917", "114.65167", "Asia/Shanghai"),
("1802238", "Loudi", "Лоуди", "CN", "156", "11", "", "", "", "27.73444", "111.99444", "Asia/Shanghai"),
("1802476", "Longquan", "Лунцюань", "CN", "156", "29", "", "", "", "24.67192", "102.1613", "Asia/Chongqing"),
("1802550", "Longgang", "", "CN", "156", "25", "", "", "", "37.65182", "120.33063", "Asia/Shanghai"),
("1802788", "Licheng", "", "CN", "156", "04", "", "", "", "31.42813", "119.48353", "Asia/Shanghai"),
("1802875", "Guankou", "Лиуянг", "CN", "156", "11", "", "", "", "28.15861", "113.62709", "Asia/Shanghai"),
("1802940", "Puning", "", "CN", "156", "30", "", "", "", "23.31072", "116.16869", "Asia/Shanghai"),
("1803245", "Lishui", "Лишуй", "CN", "156", "02", "", "", "", "28.46042", "119.91029", "Asia/Shanghai"),
("1803266", "Lintong", "", "CN", "156", "26", "", "", "", "34.37803", "109.20892", "Asia/Chongqing"),
("1803318", "Linyi", "Линьи", "CN", "156", "25", "", "", "", "35.06306", "118.34278", "Asia/Shanghai"),
("1803331", "Linxia Chengguanzhen", "Линься", "CN", "156", "15", "", "", "", "35.60028", "103.20639", "Asia/Chongqing"),
("1803334", "Linxi", "", "CN", "156", "10", "", "", "", "39.7", "118.43333", "Asia/Shanghai"),
("1803352", "Linshui", "", "CN", "156", "10", "", "", "", "36.42472", "114.20472", "Asia/Shanghai"),
("1803364", "Linqu", "", "CN", "156", "25", "", "", "", "36.51556", "118.53972", "Asia/Shanghai"),
("1803365", "Linqiong", "", "CN", "156", "32", "", "", "", "30.41587", "103.46088", "Asia/Chongqing"),
("1803367", "Qingnian", "", "CN", "156", "25", "", "", "", "36.84032", "115.71183", "Asia/Shanghai"),
("1803374", "Linping", "", "CN", "156", "02", "", "", "", "30.4225", "120.29722", "Asia/Shanghai"),
("1803422", "Linhai", "", "CN", "156", "02", "", "", "", "28.84815", "121.12807", "Asia/Shanghai"),
("1803551", "Lingcheng", "", "CN", "156", "16", "", "", "", "22.70722", "110.34917", "Asia/Chongqing"),
("1803560", "Lincheng", "Линьчэн", "CN", "156", "31", "", "", "", "19.90778", "109.68583", "Asia/Chongqing"),
("1803567", "Linfen", "Линьфынь", "CN", "156", "24", "", "", "", "36.08889", "111.51889", "Asia/Shanghai"),
("1803616", "Xishan", "Лилин", "CN", "156", "11", "", "", "", "27.66667", "113.5", "Asia/Shanghai"),
("1803782", "Lichuan", "Личуань", "CN", "156", "12", "", "", "", "30.3", "108.85", "Asia/Shanghai"),
("1803791", "Licheng", "", "CN", "156", "30", "", "", "", "23.29549", "113.82465", "Asia/Shanghai"),
("1803834", "Liaocheng", "Ляочэн", "CN", "156", "25", "", "", "", "36.45596", "115.97766", "Asia/Shanghai"),
("1803841", "Lianzhou", "", "CN", "156", "30", "", "", "", "24.78186", "112.3712", "Asia/Shanghai"),
("1803842", "Lianzhou", "", "CN", "156", "16", "", "", "", "21.66621", "109.20116", "Asia/Chongqing"),
("1803886", "Lianran", "", "CN", "156", "29", "", "", "", "24.92271", "102.48496", "Asia/Chongqing"),
("1803936", "Wuwei", "", "CN", "156", "15", "", "", "", "37.92672", "102.63202", "Asia/Chongqing"),
("1803948", "Liangxiang", "", "CN", "156", "22", "", "", "", "39.73598", "116.13295", "Asia/Shanghai"),
("1804120", "Lianjiang", "", "CN", "156", "30", "", "", "", "21.64673", "110.28172", "Asia/Urumqi"),
("1804153", "Leshan", "Лэшань", "CN", "156", "32", "", "", "", "29.56228", "103.76386", "Asia/Chongqing"),
("1804162", "Lengshuitan", "", "CN", "156", "11", "", "", "", "26.4111", "111.59559", "Asia/Shanghai"),
("1804169", "Lengshuijiang", "", "CN", "156", "11", "", "", "", "27.68806", "111.42944", "Asia/Shanghai"),
("1804208", "Leiyang", "", "CN", "156", "11", "", "", "", "26.40238", "112.85908", "Asia/Shanghai"),
("1804252", "Lecheng", "", "CN", "156", "30", "", "", "", "25.128", "113.35041", "Asia/Shanghai"),
("1804386", "Laohekou", "", "CN", "156", "12", "", "", "", "32.38583", "111.66778", "Asia/Shanghai"),
("1804430", "Lanzhou", "Ланьчжоу", "CN", "156", "15", "", "", "", "36.05701", "103.83987", "Asia/Chongqing"),
("1804442", "Lanxi", "", "CN", "156", "02", "", "", "", "29.21588", "119.47156", "Asia/Shanghai"),
("1804451", "Lianyuan", "", "CN", "156", "11", "", "", "", "27.68833", "111.66417", "Asia/Shanghai"),
("1804540", "Langfang", "Ланфан", "CN", "156", "10", "", "", "", "39.50972", "116.69472", "Asia/Shanghai"),
("1804578", "Weichanglu", "", "CN", "156", "25", "", "", "", "37.18072", "119.94217", "Asia/Shanghai"),
("1804586", "Laiyang", "", "CN", "156", "25", "", "", "", "36.97583", "120.71361", "Asia/Shanghai"),
("1804591", "Laiwu", "", "CN", "156", "25", "", "", "", "36.19278", "117.65694", "Asia/Shanghai"),
("1804609", "Laibin", "", "CN", "156", "16", "", "", "", "23.7", "109.26667", "Asia/Chongqing"),
("1804645", "Kunyang", "", "CN", "156", "02", "", "", "", "27.66583", "120.56583", "Asia/Shanghai"),
("1804651", "Kunming", "Куньмин", "CN", "156", "29", "", "", "", "25.03889", "102.71833", "Asia/Chongqing"),
("1804850", "Kaiyuan", "Кайюань", "CN", "156", "29", "", "", "", "23.69767", "103.30372", "Asia/Chongqing"),
("1804874", "Kaihua", "", "CN", "156", "29", "", "", "", "23.3695", "104.27721", "Asia/Chongqing"),
("1804879", "Kaifeng", "Кайфэн", "CN", "156", "09", "", "", "", "34.7986", "114.30742", "Asia/Shanghai"),
("1804892", "Juye", "", "CN", "156", "25", "", "", "", "35.39472", "116.08833", "Asia/Shanghai"),
("1804979", "Juegang", "", "CN", "156", "04", "", "", "", "32.31737", "121.18552", "Asia/Shanghai"),
("1805179", "Jiujiang", "Цзюцзян", "CN", "156", "03", "", "", "", "29.73333", "115.98333", "Asia/Shanghai"),
("1805267", "Jishui", "", "CN", "156", "09", "", "", "", "33.73333", "115.4", "Asia/Shanghai"),
("1805270", "Qianzhou", "", "CN", "156", "11", "", "", "", "28.31926", "109.73346", "Asia/Shanghai"),
("1805298", "Jinzhou", "Цзиньчжоу", "CN", "156", "19", "", "", "", "39.1", "121.71667", "Asia/Shanghai"),
("1805334", "Jinxiangzhen", "", "CN", "156", "02", "", "", "", "27.43265", "120.60625", "Asia/Shanghai"),
("1805379", "Jinshi", "", "CN", "156", "11", "", "", "", "29.60487", "111.87012", "Asia/Shanghai"),
("1805408", "Jinsha", "Цзиньша", "CN", "156", "04", "", "", "", "32.08982", "121.07355", "Asia/Shanghai"),
("1805505", "Jinjiang", "", "CN", "156", "31", "", "", "", "19.72878", "110.00851", "Asia/Chongqing"),
("1805515", "Jinji", "", "CN", "156", "16", "", "", "", "23.22806", "110.82611", "Asia/Chongqing"),
("1805518", "Jining", "Цзинин", "CN", "156", "25", "", "", "", "35.405", "116.58139", "Asia/Shanghai"),
("1805528", "Jinhua", "Цзиньхуа", "CN", "156", "02", "", "", "", "29.10678", "119.64421", "Asia/Shanghai"),
("1805540", "Jingzhou", "Цзинчжоу", "CN", "156", "12", "", "", "", "30.35028", "112.19028", "Asia/Shanghai"),
("1805563", "Tianchang", "", "CN", "156", "10", "", "", "", "37.99806", "114.01556", "Asia/Shanghai"),
("1805611", "Jingmen", "Цзинмэнь", "CN", "156", "12", "", "", "", "31.03361", "112.20472", "Asia/Shanghai"),
("1805618", "Jingling", "", "CN", "156", "12", "", "", "", "30.65", "113.1", "Asia/Shanghai"),
("1805680", "Jingdezhen", "Цзиндэчжэнь", "CN", "156", "03", "", "", "", "29.2947", "117.20789", "Asia/Shanghai"),
("1805733", "Jinchang", "Цзиньчан", "CN", "156", "15", "1805747", "", "", "38.50062", "102.19379", "Asia/Chongqing"),
("1805741", "Jincheng", "Цзиньчэн", "CN", "156", "24", "", "", "", "35.50222", "112.83278", "Asia/Shanghai"),
("1805753", "Jinan", "Цзинань", "CN", "156", "25", "", "", "", "36.66833", "116.99722", "Asia/Shanghai"),
("1805757", "Jimo", "", "CN", "156", "25", "", "", "", "36.38972", "120.46222", "Asia/Shanghai"),
("1805798", "Jijiang", "", "CN", "156", "33", "", "", "", "29.28993", "106.25001", "Asia/Chongqing"),
("1805833", "Jiexiu", "", "CN", "156", "24", "", "", "", "37.02444", "111.9125", "Asia/Shanghai"),
("1805844", "Jieshou", "", "CN", "156", "01", "1810843", "", "", "33.26338", "115.36108", "Asia/Shanghai"),
("1805857", "Jieshi", "", "CN", "156", "30", "", "", "", "22.81027", "115.83058", "Asia/Shanghai"),
("1805884", "Jiehu", "", "CN", "156", "25", "", "", "", "35.54278", "118.455", "Asia/Shanghai"),
("1805935", "Jiazi", "", "CN", "156", "30", "", "", "", "22.87932", "116.07318", "Asia/Shanghai"),
("1805953", "Jiaxing", "Цзясин", "CN", "156", "02", "", "", "", "30.7522", "120.75", "Asia/Shanghai"),
("1805987", "Jiaozuo", "Цзяоцзо", "CN", "156", "09", "", "", "", "35.23972", "113.23306", "Asia/Shanghai"),
("1806096", "Jiaozhou", "", "CN", "156", "25", "", "", "", "36.28389", "120.00333", "Asia/Shanghai"),
("1806097", "Ningde", "", "CN", "156", "07", "", "", "", "26.66167", "119.52278", "Asia/Shanghai"),
("1806167", "Jian'ou", "", "CN", "156", "07", "", "", "", "27.04694", "118.32528", "Asia/Shanghai"),
("1806218", "Jiangyan", "", "CN", "156", "04", "", "", "", "32.50611", "120.14278", "Asia/Shanghai"),
("1806248", "Jianguang", "", "CN", "156", "03", "", "", "", "28.19377", "115.7836", "Asia/Shanghai"),
("1806299", "Jiangmen", "Цзянмэнь", "CN", "156", "30", "", "", "", "22.58333", "113.08333", "Asia/Shanghai"),
("1806327", "Jiangkou", "", "CN", "156", "07", "", "", "", "25.48694", "119.19834", "Asia/Shanghai"),
("1806408", "Yangjiang", "Янцзян", "CN", "156", "30", "", "", "", "21.85564", "111.96272", "Asia/Chongqing"),
("1806445", "Ji'an", "Цзиань", "CN", "156", "03", "", "", "", "27.11716", "114.97927", "Asia/Shanghai"),
("1806466", "Guangyuan", "", "CN", "156", "32", "", "", "", "32.44202", "105.823", "Asia/Chongqing"),
("1806535", "Huzhou", "", "CN", "156", "02", "", "", "", "30.8703", "120.0933", "Asia/Shanghai"),
("1806591", "Hutang", "", "CN", "156", "04", "", "", "", "31.53429", "119.49", "Asia/Shanghai"),
("1806651", "Huoqiu Chengguanzhen", "", "CN", "156", "01", "", "", "", "32.35473", "116.2939", "Asia/Shanghai"),
("1806696", "Humen", "Хумэнь", "CN", "156", "30", "", "", "", "22.81898", "113.67306", "Asia/Shanghai"),
("1806776", "Huizhou", "Хуэйчжоу", "CN", "156", "30", "", "", "", "23.08333", "114.4", "Asia/Shanghai"),
("1806840", "Huilong", "Квидонга", "CN", "156", "04", "", "", "", "31.81111", "121.655", "Asia/Shanghai"),
("1806881", "Huicheng", "", "CN", "156", "30", "", "", "", "23.03845", "116.28988", "Asia/Shanghai"),
("1806882", "Xinhui", "", "CN", "156", "30", "", "", "", "22.456", "113.0482", "Asia/Shanghai"),
("1806960", "Huazhou", "", "CN", "156", "30", "", "", "", "21.63333", "110.58333", "Asia/Urumqi"),
("1807112", "Huangzhou", "Хуанчжоу", "CN", "156", "12", "", "", "", "30.45", "114.8", "Asia/Shanghai"),
("1807143", "Huangyan", "", "CN", "156", "02", "", "", "", "28.6501", "121.26591", "Asia/Shanghai"),
("1807234", "Huangshi", "Хуанши", "CN", "156", "12", "", "", "", "30.24706", "115.04814", "Asia/Shanghai"),
("1807301", "Dasha", "Даша", "CN", "156", "30", "", "", "", "23.11037", "113.4418", "Asia/Shanghai"),
("1807308", "Huangpi", "", "CN", "156", "12", "", "", "", "30.88453", "114.37789", "Asia/Shanghai"),
("1807339", "Huangmei", "", "CN", "156", "12", "", "", "", "30.19235", "116.02496", "Asia/Shanghai"),
("1807508", "Huanggang", "Хуанган", "CN", "156", "30", "", "", "", "23.67704", "116.99961", "Asia/Shanghai"),
("1807544", "Daxing", "Дасин", "CN", "156", "22", "", "", "", "39.74025", "116.32693", "Asia/Shanghai"),
("1807553", "Huangchuan", "", "CN", "156", "09", "", "", "", "32.12722", "115.03944", "Asia/Shanghai"),
("1807645", "Huaiyuan Chengguanzhen", "", "CN", "156", "01", "", "", "", "32.95893", "117.16566", "Asia/Shanghai"),
("1807681", "Huainan", "", "CN", "156", "01", "", "", "", "32.62639", "116.99694", "Asia/Shanghai"),
("1807687", "Huaicheng", "", "CN", "156", "30", "", "", "", "23.91952", "112.17629", "Asia/Shanghai"),
("1807689", "Huaihua", "Хуайхуа", "CN", "156", "11", "", "", "", "27.54944", "109.95917", "Asia/Shanghai"),
("1807695", "Huaidian", "", "CN", "156", "09", "", "", "", "33.43333", "115.03333", "Asia/Shanghai"),
("1807700", "Huaibei", "Хуайбэй", "CN", "156", "01", "", "", "", "33.97444", "116.79167", "Asia/Shanghai"),
("1808106", "Hongjiang", "", "CN", "156", "11", "", "", "", "27.11", "109.99556", "Asia/Shanghai"),
("1808198", "Heze", "Хэцзэ", "CN", "156", "25", "", "", "", "35.23929", "115.47358", "Asia/Shanghai"),
("1808212", "Hechuan", "", "CN", "156", "33", "", "", "", "29.99228", "106.26461", "Asia/Chongqing"),
("1808316", "Yiyang", "Иян", "CN", "156", "11", "", "", "", "28.58917", "112.32833", "Asia/Shanghai"),
("1808336", "Hepo", "Хэпо", "CN", "156", "30", "", "", "", "23.43077", "115.82991", "Asia/Shanghai"),
("1808370", "Hengyang", "Хэнъян", "CN", "156", "11", "1808369", "", "", "26.88946", "112.61888", "Asia/Shanghai"),
("1808392", "Hengshui", "Хэншуй", "CN", "156", "10", "", "", "", "37.73222", "115.70111", "Asia/Shanghai"),
("1808722", "Hefei", "Хэфэй", "CN", "156", "01", "", "", "", "31.86389", "117.28083", "Asia/Shanghai"),
("1808744", "Hede", "Хеде", "CN", "156", "04", "", "", "", "33.7722", "120.26176", "Asia/Shanghai"),
("1808747", "Hecun", "", "CN", "156", "10", "", "", "", "36.53333", "114.11111", "Asia/Shanghai"),
("1808770", "Hebi", "", "CN", "156", "09", "", "", "", "35.89917", "114.1925", "Asia/Shanghai"),
("1808857", "Hanzhong", "Ханьчжун", "CN", "156", "26", "", "", "", "33.07278", "107.03028", "Asia/Chongqing"),
("1808872", "Chengyang", "Фуаня", "CN", "156", "07", "", "", "", "27.08917", "119.64528", "Asia/Shanghai"),
("1808879", "Hanting", "", "CN", "156", "25", "", "", "", "36.77083", "119.21083", "Asia/Shanghai"),
("1808926", "Hangzhou", "Ханчжоу", "CN", "156", "02", "", "", "", "30.29365", "120.16142", "Asia/Shanghai"),
("1808931", "Hangu", "Ханга", "CN", "156", "28", "", "", "", "39.24889", "117.78917", "Asia/Shanghai"),
("1808963", "Handan", "Ханьдань", "CN", "156", "10", "", "", "", "36.60056", "114.46778", "Asia/Shanghai"),
("1808977", "Hanchuan", "", "CN", "156", "12", "", "", "", "30.65", "113.76667", "Asia/Shanghai"),
("1808981", "Hancheng", "", "CN", "156", "26", "", "", "", "35.46028", "110.42917", "Asia/Chongqing"),
("1809003", "Haizhou", "", "CN", "156", "04", "", "", "", "34.58167", "119.12889", "Asia/Shanghai"),
("1809061", "Jiaojiang", "", "CN", "156", "02", "", "", "", "28.68028", "121.44278", "Asia/Shanghai"),
("1809062", "Haimen", "", "CN", "156", "30", "", "", "", "23.19346", "116.61219", "Asia/Shanghai"),
("1809077", "Haikou", "", "CN", "156", "29", "", "", "", "24.77985", "102.57548", "Asia/Chongqing"),
("1809078", "Haikou", "Хайкоу", "CN", "156", "31", "", "", "", "20.04583", "110.34167", "Asia/Chongqing"),
("1809159", "Guye", "", "CN", "156", "10", "", "", "", "39.73333", "118.41667", "Asia/Shanghai"),
("1809263", "Guozhen", "", "CN", "156", "26", "", "", "", "34.36591", "107.35904", "Asia/Chongqing"),
("1809412", "Guli", "Гули", "CN", "156", "02", "", "", "", "28.88162", "120.03308", "Asia/Shanghai"),
("1809461", "Guiyang", "Гуйян", "CN", "156", "18", "", "", "", "26.58333", "106.71667", "Asia/Chongqing"),
("1809483", "Guiren", "", "CN", "156", "04", "", "", "", "33.66972", "118.18889", "Asia/Shanghai"),
("1809486", "Guiping", "", "CN", "156", "16", "", "", "", "23.39336", "110.07437", "Asia/Chongqing"),
("1809498", "Guilin", "Гуйлинь", "CN", "156", "16", "", "", "", "25.28194", "110.28639", "Asia/Chongqing"),
("1809532", "Guigang", "", "CN", "156", "16", "", "", "", "23.09639", "109.60917", "Asia/Chongqing"),
("1809610", "Gucheng Chengguanzhen", "", "CN", "156", "12", "", "", "", "32.26604", "111.63476", "Asia/Shanghai"),
("1809858", "Guangzhou", "Гуанчжоу", "CN", "156", "30", "", "", "", "23.11667", "113.25", "Asia/Shanghai"),
("1809879", "Guangshui", "", "CN", "156", "12", "", "", "", "31.6199", "113.9978", "Asia/Shanghai"),
("1810240", "Gejiu", "", "CN", "156", "29", "", "", "", "23.36085", "103.15372", "Asia/Chongqing"),
("1810295", "Gaozhou", "", "CN", "156", "30", "", "", "", "21.93924", "110.84607", "Asia/Urumqi"),
("1810309", "Gaoyou", "", "CN", "156", "04", "", "", "", "32.78933", "119.44182", "Asia/Shanghai"),
("1810437", "Gaoping", "", "CN", "156", "32", "", "", "", "30.77576", "106.10294", "Asia/Chongqing"),
("1810458", "Gaomi", "", "CN", "156", "25", "", "", "", "36.38333", "119.75278", "Asia/Shanghai"),
("1810553", "Gaogou", "", "CN", "156", "04", "", "", "", "34.0175", "119.18861", "Asia/Shanghai"),
("1810821", "Fuzhou", "Фучжоу", "CN", "156", "07", "", "", "", "26.06139", "119.30611", "Asia/Shanghai"),
("1810845", "Fuyang", "Фуян", "CN", "156", "01", "", "", "", "32.9", "115.81667", "Asia/Shanghai"),
("1810846", "Fuyang", "Фуянь", "CN", "156", "02", "", "", "", "30.05333", "119.95194", "Asia/Shanghai"),
("1810920", "Qingyang", "", "CN", "156", "25", "", "", "", "37.49583", "121.25806", "Asia/Shanghai"),
("1810979", "Fuling", "Фулин", "CN", "156", "33", "", "", "", "29.706", "107.39575", "Asia/Chongqing"),
("1811103", "Foshan", "Фошань", "CN", "156", "30", "", "", "", "23.02677", "113.13148", "Asia/Shanghai"),
("1811114", "Fenyi", "", "CN", "156", "03", "", "", "", "27.81117", "114.66805", "Asia/Shanghai"),
("1811200", "Fengxian", "", "CN", "156", "04", "", "", "", "34.70388", "116.58717", "Asia/Shanghai"),
("1811260", "Fengrun", "", "CN", "156", "10", "", "", "", "39.83333", "118.11667", "Asia/Shanghai"),
("1811305", "Fengkou", "", "CN", "156", "12", "", "", "", "30.08268", "113.33346", "Asia/Shanghai"),
("1811440", "Feicheng", "", "CN", "156", "25", "", "", "", "35.26056", "117.9675", "Asia/Shanghai"),
("1811542", "Fangshan", "", "CN", "156", "22", "", "", "", "39.69833", "115.9925", "Asia/Shanghai"),
("1811619", "Ezhou", "", "CN", "156", "12", "", "", "", "30.4", "114.83333", "Asia/Shanghai"),
("1811720", "Enshi", "Эньши", "CN", "156", "12", "", "", "", "30.3", "109.48333", "Asia/Shanghai"),
("1811729", "Encheng", "Эньпин", "CN", "156", "30", "", "", "", "22.18659", "112.30424", "Asia/Chongqing"),
("1811764", "Duyun", "Дуюн", "CN", "156", "18", "", "", "", "26.26667", "107.51667", "Asia/Chongqing"),
("1811829", "Duobao", "", "CN", "156", "12", "", "", "", "30.67", "112.68952", "Asia/Shanghai"),
("1811929", "Ducheng", "", "CN", "156", "30", "", "", "", "23.24212", "111.5284", "Asia/Chongqing"),
("1812057", "Xinyi", "", "CN", "156", "30", "", "", "", "22.37303", "110.94746", "Asia/Urumqi"),
("1812101", "Dongying", "Дуньин", "CN", "156", "25", "", "", "", "37.45639", "118.48556", "Asia/Shanghai"),
("1812228", "Dongtai", "", "CN", "156", "04", "", "", "", "32.85231", "120.30947", "Asia/Shanghai"),
("1812256", "Dongsheng", "", "CN", "156", "20", "", "", "", "39.81608", "109.97763", "Asia/Chongqing"),
("1812427", "Dongkan", "", "CN", "156", "04", "", "", "", "33.99972", "119.83083", "Asia/Shanghai"),
("1812521", "Donghai", "", "CN", "156", "30", "", "", "", "22.94594", "115.64204", "Asia/Shanghai"),
("1812545", "Dongguan", "Дунгуань", "CN", "156", "30", "", "", "", "23.04889", "113.74472", "Asia/Shanghai"),
("1812597", "Dongdu", "", "CN", "156", "25", "", "", "", "35.85", "117.7", "Asia/Shanghai"),
("1812621", "Dongcun", "", "CN", "156", "25", "", "", "", "36.77667", "121.15972", "Asia/Shanghai"),
("1812728", "Dingzhou", "", "CN", "156", "10", "", "", "", "38.51306", "114.99556", "Asia/Shanghai"),
("1812754", "Dingtao", "", "CN", "156", "25", "", "", "", "35.07436", "115.56582", "Asia/Shanghai"),
("1812955", "Dezhou", "Дэчжоу", "CN", "156", "25", "", "", "", "37.44861", "116.2925", "Asia/Shanghai"),
("1812961", "Deyang", "Дэян", "CN", "156", "32", "", "", "", "31.13019", "104.38198", "Asia/Chongqing"),
("1812981", "Deqing", "", "CN", "156", "02", "", "", "", "30.54485", "119.9599", "Asia/Shanghai"),
("1812988", "Dengzhou", "Пэнлай", "CN", "156", "25", "", "", "", "37.80822", "120.75908", "Asia/Shanghai"),
("1812990", "Dengzhou", "", "CN", "156", "09", "", "", "", "32.68222", "112.08194", "Asia/Shanghai"),
("1813016", "Dengfeng", "", "CN", "156", "09", "", "", "", "34.45528", "113.02806", "Asia/Shanghai"),
("1813088", "Dazhong", "", "CN", "156", "04", "", "", "", "33.19973", "120.4578", "Asia/Shanghai"),
("1813171", "Zhangjiajie", "Чжанцзяцзе", "CN", "156", "11", "", "", "", "29.12944", "110.47833", "Asia/Shanghai"),
("1813206", "Daye", "", "CN", "156", "12", "", "", "", "30.08333", "114.95", "Asia/Shanghai"),
("1813253", "Lijiang", "Лицзян", "CN", "156", "29", "", "", "", "26.86879", "100.22072", "Asia/Chongqing"),
("1813325", "Dazhou", "", "CN", "156", "32", "", "", "", "31.21592", "107.50092", "Asia/Chongqing"),
("1813344", "Dawukou", "", "CN", "156", "21", "", "", "", "39.04194", "106.39583", "Asia/Chongqing"),
("1813451", "Datong", "Датун", "CN", "156", "01", "", "", "", "32.62082", "117.06318", "Asia/Shanghai"),
("1813658", "Fenghua", "", "CN", "156", "02", "", "", "", "29.65628", "121.4064", "Asia/Shanghai"),
("1813775", "Huaxian", "", "CN", "156", "09", "", "", "", "35.56389", "114.50583", "Asia/Shanghai"),
("1813812", "Danshui", "Даньшуем", "CN", "156", "30", "", "", "", "22.7984", "114.46716", "Asia/Shanghai"),
("1813828", "Danjiangkou", "Даньцзянкоу", "CN", "156", "12", "", "", "", "32.54278", "111.50861", "Asia/Shanghai"),
("1813851", "Gushu", "", "CN", "156", "01", "", "", "", "31.56055", "118.48147", "Asia/Shanghai"),
("1813892", "Dancheng", "", "CN", "156", "09", "", "", "", "33.63333", "115.18333", "Asia/Shanghai"),
("1814082", "Daliang", "Далян", "CN", "156", "30", "", "", "", "22.84067", "113.2503", "Asia/Shanghai"),
("1814087", "Dalian", "Далянь", "CN", "156", "19", "1814068", "", "", "38.91222", "121.60222", "Asia/Shanghai"),
("1814093", "Dali", "Дали", "CN", "156", "29", "", "", "", "25.58474", "100.21229", "Asia/Chongqing"),
("1814757", "Chuzhou", "Чучжоу", "CN", "156", "01", "", "", "", "32.32194", "118.29778", "Asia/Shanghai"),
("1814786", "Yangchun", "", "CN", "156", "30", "", "", "", "22.16667", "111.78333", "Asia/Chongqing"),
("1814870", "Yiwu", "", "CN", "156", "02", "", "", "", "29.31506", "120.07676", "Asia/Shanghai"),
("1814906", "Chongqing", "Чунцин", "CN", "156", "33", "", "", "", "29.56278", "106.55278", "Asia/Chongqing"),
("1814919", "Chonglong", "", "CN", "156", "32", "", "", "", "29.78062", "104.85224", "Asia/Chongqing"),
("1814934", "Chizhou", "", "CN", "156", "01", "", "", "", "30.66134", "117.47783", "Asia/Shanghai"),
("1815059", "Chenzhou", "Чэньчжоу", "CN", "156", "11", "1815056", "", "", "25.8", "113.03333", "Asia/Shanghai"),
("1815184", "Chengyang", "", "CN", "156", "25", "", "", "", "35.57944", "118.83278", "Asia/Shanghai"),
("1815251", "Chengjiang", "", "CN", "156", "04", "", "", "", "31.91102", "120.26302", "Asia/Shanghai"),
("1815286", "Chengdu", "Чэнду", "CN", "156", "32", "", "", "", "30.66667", "104.06667", "Asia/Chongqing"),
("1815302", "Chenghua", "", "CN", "156", "30", "", "", "", "23.46132", "116.77007", "Asia/Shanghai"),
("1815395", "Chaozhou", "Чаочжоу", "CN", "156", "30", "", "", "", "23.65396", "116.62262", "Asia/Shanghai"),
("1815427", "Chaohu", "", "CN", "156", "01", "", "", "", "31.6", "117.86667", "Asia/Shanghai"),
("1815456", "Changzhou", "Чанчжоу", "CN", "156", "04", "", "", "", "31.77358", "119.95401", "Asia/Shanghai"),
("1815463", "Changzhi", "Чанчжи", "CN", "156", "24", "", "", "", "35.20889", "111.73861", "Asia/Shanghai"),
("1815577", "Changsha", "Чанша", "CN", "156", "11", "1815551", "", "", "28.19874", "112.97087", "Asia/Shanghai"),
("1815585", "Changqing", "Чанцин", "CN", "156", "25", "", "", "", "36.5575", "116.72722", "Asia/Shanghai"),
("1815656", "Changli", "Чанли", "CN", "156", "10", "", "", "", "39.70417", "119.15056", "Asia/Shanghai"),
("1815667", "Changleng", "", "CN", "156", "03", "", "", "", "28.7", "115.81667", "Asia/Shanghai"),
("1816026", "Caohe", "", "CN", "156", "12", "", "", "", "30.2297", "115.43346", "Asia/Shanghai"),
("1816028", "Weining", "Вэйнин", "CN", "156", "18", "", "", "", "26.85", "104.23333", "Asia/Chongqing"),
("1816080", "Cangzhou", "Цанчжоу", "CN", "156", "10", "", "", "", "38.31667", "116.86667", "Asia/Shanghai"),
("1816176", "Caidian", "", "CN", "156", "12", "", "", "", "30.58333", "114.03333", "Asia/Shanghai"),
("1816221", "Buhe", "Бухэ", "CN", "156", "12", "", "", "", "30.28757", "112.22979", "Asia/Shanghai"),
("1816234", "Bozhou", "Бочжоу", "CN", "156", "01", "", "", "", "33.87722", "115.77028", "Asia/Shanghai"),
("1816256", "Botou", "Бота", "CN", "156", "10", "", "", "", "38.06667", "116.56667", "Asia/Shanghai"),
("1816265", "Boshan", "", "CN", "156", "25", "", "", "", "36.48333", "117.83333", "Asia/Shanghai"),
("1816269", "Baise City", "Бозе", "CN", "156", "16", "", "", "", "23.89972", "106.61333", "Asia/Chongqing"),
("1816336", "Binzhou", "", "CN", "156", "25", "", "", "", "37.36667", "118.01667", "Asia/Shanghai"),
("1816338", "Luxu", "", "CN", "156", "16", "", "", "", "23.22378", "108.80216", "Asia/Chongqing"),
("1816373", "Bijie", "Бицзе", "CN", "156", "18", "", "", "", "27.30193", "105.28627", "Asia/Chongqing"),
("1816406", "Bianzhuang", "", "CN", "156", "25", "", "", "", "34.84861", "118.04472", "Asia/Shanghai"),
("1816440", "Bengbu", "Бэнбу", "CN", "156", "01", "", "", "", "32.94083", "117.36083", "Asia/Shanghai"),
("1816670", "Beijing", "Пекин", "CN", "156", "22", "", "", "", "39.9075", "116.39723", "Asia/Shanghai"),
("1816705", "Beihai", "Бэйхай", "CN", "156", "16", "", "", "", "21.48333", "109.1", "Asia/Chongqing"),
("1816751", "Beidao", "", "CN", "156", "15", "", "", "", "34.56861", "105.89333", "Asia/Chongqing"),
("1816753", "Beidaihehaibin", "Бейдайхэ", "CN", "156", "10", "", "", "", "39.82222", "119.51806", "Asia/Shanghai"),
("1816790", "Beibei", "Бэй", "CN", "156", "33", "", "", "", "29.82739", "106.43645", "Asia/Chongqing"),
("1816890", "Baoying", "", "CN", "156", "04", "", "", "", "33.22917", "119.30917", "Asia/Shanghai"),
("1816924", "Langzhong", "", "CN", "156", "32", "", "", "", "31.55037", "105.99381", "Asia/Chongqing"),
("1816971", "Baoding", "Баодин", "CN", "156", "10", "", "", "", "38.85111", "115.49028", "Asia/Shanghai"),
("1817240", "Baiyin", "", "CN", "156", "15", "", "", "", "36.54696", "104.17023", "Asia/Chongqing"),
("1817701", "Baihe", "", "CN", "156", "16", "", "", "", "22.15", "107.23333", "Asia/Chongqing"),
("1817720", "Shangyu", "", "CN", "156", "02", "", "", "", "30.01556", "120.87111", "Asia/Shanghai"),
("1817858", "Babu", "Бабу", "CN", "156", "16", "", "", "", "24.41667", "111.51667", "Asia/Chongqing"),
("1817952", "Anxiang", "", "CN", "156", "11", "", "", "", "29.4", "112.15", "Asia/Shanghai"),
("1817968", "Anshun", "Аньшунь", "CN", "156", "18", "", "", "", "26.25", "105.93333", "Asia/Chongqing"),
("1817990", "Anqiu", "", "CN", "156", "25", "", "", "", "36.43417", "119.1925", "Asia/Shanghai"),
("1817993", "Anqing", "Аньцин", "CN", "156", "01", "", "", "", "30.51365", "117.04723", "Asia/Shanghai"),
("1818004", "Mabai", "", "CN", "156", "29", "", "", "", "23.01279", "104.45081", "Asia/Chongqing"),
("1818016", "Anlu", "", "CN", "156", "12", "", "", "", "31.2575", "113.67833", "Asia/Shanghai"),
("1818051", "Anjiang", "", "CN", "156", "11", "", "", "", "27.31944", "110.10306", "Asia/Shanghai"),
("1818116", "Anbu", "", "CN", "156", "30", "", "", "", "23.44895", "116.68092", "Asia/Shanghai"),
("1885823", "Jiangyou", "", "CN", "156", "32", "", "", "", "31.76667", "104.71667", "Asia/Chongqing"),
("1886760", "Suzhou", "Сучжоу", "CN", "156", "04", "", "", "", "31.30408", "120.59538", "Asia/Shanghai"),
("1886762", "Zhoushan", "Чжоушань", "CN", "156", "02", "", "", "", "30.01075", "122.20465", "Asia/Shanghai"),
("1898359", "Mudu", "Муду", "CN", "156", "04", "", "", "", "31.25597", "120.51857", "Asia/Shanghai"),
("1898494", "Songling", "Сунлин", "CN", "156", "04", "", "", "", "31.1933", "120.71758", "Asia/Shanghai"),
("1915223", "Zhongshan", "", "CN", "156", "30", "", "", "", "21.31992", "110.5723", "Asia/Urumqi"),
("1919014", "Lianghu", "", "CN", "156", "02", "", "", "", "29.99152", "120.89845", "Asia/Shanghai"),
("1920772", "Zhoucheng", "", "CN", "156", "25", "", "", "", "35.91222", "116.31167", "Asia/Shanghai"),
("1921372", "Dalianwan", "", "CN", "156", "19", "", "", "", "39.02861", "121.695", "Asia/Shanghai"),
("1927639", "Yueyang", "Юэян", "CN", "156", "11", "", "", "", "29.37455", "113.09481", "Asia/Shanghai"),
("1929434", "Bojia", "", "CN", "156", "11", "", "", "", "26.46722", "111.96806", "Asia/Shanghai"),
("2033128", "Zhenlai", "", "CN", "156", "05", "", "", "", "45.84955", "123.2973", "Asia/Harbin"),
("2033135", "Zhengjiatun", "", "CN", "156", "05", "", "", "", "43.50639", "123.50639", "Asia/Harbin"),
("2033147", "Zhaozhou", "Чжаочжоу", "CN", "156", "08", "", "", "", "45.68333", "125.31667", "Asia/Harbin"),
("2033149", "Zhaoyuan", "", "CN", "156", "08", "", "", "", "45.5", "125.13333", "Asia/Harbin"),
("2033168", "Zhaodong", "", "CN", "156", "08", "", "", "", "46.06771", "125.98263", "Asia/Harbin"),
("2033196", "Zhangjiakou", "Чжанцзякоу", "CN", "156", "10", "", "", "", "40.81", "114.87944", "Asia/Shanghai"),
("2033225", "Zalantun", "Чжаланьтунь", "CN", "156", "20", "", "", "", "48", "122.71667", "Asia/Shanghai"),
("2033242", "Yushu", "Юйшу", "CN", "156", "05", "", "", "", "44.8", "126.53333", "Asia/Harbin"),
("2033301", "Youhao", "", "CN", "156", "08", "", "", "", "47.85306", "128.83565", "Asia/Harbin"),
("2033370", "Yingkou", "Инкоу", "CN", "156", "19", "2033369", "", "", "40.66482", "122.22833", "Asia/Shanghai"),
("2033403", "Yilan", "", "CN", "156", "08", "", "", "", "46.31618", "129.55455", "Asia/Harbin"),
("2033413", "Yichun", "Ичунь", "CN", "156", "08", "", "", "", "47.72143", "128.87529", "Asia/Harbin"),
("2033423", "Yebaishou", "", "CN", "156", "19", "", "", "", "41.3975", "119.64083", "Asia/Shanghai"),
("2033449", "Yantongshan", "", "CN", "156", "05", "", "", "", "43.29194", "126.00944", "Asia/Harbin"),
("2033467", "Yanji", "Яньцзи", "CN", "156", "05", "", "", "", "42.9075", "129.50778", "Asia/Harbin"),
("2033536", "Yakeshi", "Якэши", "CN", "156", "20", "", "", "", "49.28333", "120.73333", "Asia/Shanghai"),
("2033574", "Xuanhua", "", "CN", "156", "10", "", "", "", "40.61028", "115.04472", "Asia/Shanghai"),
("2033602", "Xiuyan", "", "CN", "156", "19", "", "", "", "40.29278", "123.27444", "Asia/Shanghai"),
("2033667", "Xinqing", "", "CN", "156", "08", "", "", "", "48.28701", "129.52337", "Asia/Harbin"),
("2033675", "Xinmin", "Синьминь", "CN", "156", "19", "", "", "", "41.99083", "122.82528", "Asia/Shanghai"),
("2033739", "Xinglongshan", "", "CN", "156", "05", "", "", "", "43.95611", "125.46611", "Asia/Harbin"),
("2033766", "Xingcheng", "Синчэн", "CN", "156", "19", "", "", "", "40.61667", "120.71667", "Asia/Shanghai"),
("2033824", "Xilin Hot", "", "CN", "156", "20", "", "", "", "43.96667", "116.03333", "Asia/Shanghai"),
("2033866", "Xifeng", "", "CN", "156", "19", "", "", "", "42.73722", "124.72222", "Asia/Shanghai"),
("2033934", "Xiaoshi", "", "CN", "156", "19", "", "", "", "41.29711", "124.12092", "Asia/Shanghai"),
("2034141", "Wuchang", "Учан", "CN", "156", "08", "", "", "", "44.91428", "127.15001", "Asia/Harbin"),
("2034221", "Wangqing", "Ванцине", "CN", "156", "05", "", "", "", "43.32179", "129.76342", "Asia/Harbin"),
("2034226", "Hepingjie", "", "CN", "156", "05", "", "", "", "42.05972", "126.91583", "Asia/Harbin"),
("2034228", "Wangkui", "", "CN", "156", "08", "", "", "", "46.83283", "126.47768", "Asia/Harbin"),
("2034312", "Ulanhot", "", "CN", "156", "20", "", "", "", "46.08333", "122.08333", "Asia/Shanghai"),
("2034340", "Tumen", "Тюменский", "CN", "156", "05", "", "", "", "42.96611", "129.8425", "Asia/Harbin"),
("2034400", "Tongliao", "", "CN", "156", "20", "", "", "", "43.6125", "122.26528", "Asia/Shanghai"),
("2034439", "Tieling", "Телин", "CN", "156", "19", "2034437", "", "", "42.29306", "123.84139", "Asia/Shanghai"),
("2034440", "Tieli", "", "CN", "156", "08", "", "", "", "46.98043", "128.04498", "Asia/Harbin"),
("2034497", "Guangming", "Таонань", "CN", "156", "05", "", "", "", "45.33333", "122.78333", "Asia/Harbin"),
("2034599", "Tailai", "", "CN", "156", "08", "", "", "", "46.38909", "123.41372", "Asia/Harbin"),
("2034600", "Taikang", "", "CN", "156", "08", "", "", "", "46.86135", "124.442", "Asia/Harbin"),
("2034615", "Tahe", "", "CN", "156", "08", "", "", "", "52.33333", "124.73333", "Asia/Harbin"),
("2034638", "Sujiatun", "Суцзятунь", "CN", "156", "19", "", "", "", "41.65917", "123.33917", "Asia/Shanghai"),
("2034651", "Suileng", "", "CN", "156", "08", "", "", "", "47.24805", "127.09535", "Asia/Harbin"),
("2034655", "Suihua", "", "CN", "156", "08", "", "", "", "46.63954", "126.99508", "Asia/Harbin"),
("2034657", "Suifenhe", "", "CN", "156", "08", "", "", "", "44.4", "131.16667", "Asia/Harbin"),
("2034691", "Songjianghe", "", "CN", "156", "05", "", "", "", "42.1859", "127.47895", "Asia/Harbin"),
("2034714", "Siping", "", "CN", "156", "05", "", "", "", "43.16143", "124.37785", "Asia/Harbin"),
("2034754", "Shunyi", "Шуньи", "CN", "156", "22", "", "", "", "40.12175", "116.64783", "Asia/Shanghai"),
("2034761", "Shulan", "Шулань", "CN", "156", "05", "", "", "", "44.41667", "126.95", "Asia/Harbin"),
("2034786", "Shuangyashan", "", "CN", "156", "08", "", "", "", "46.63611", "131.15389", "Asia/Harbin"),
("2034791", "Shuangyang", "", "CN", "156", "05", "", "", "", "43.52417", "125.67361", "Asia/Harbin"),
("2034834", "Shuangcheng", "", "CN", "156", "08", "", "", "", "45.35", "126.28333", "Asia/Harbin"),
("2034918", "Shiguai", "", "CN", "156", "20", "", "", "", "40.70583", "110.28556", "Asia/Chongqing"),
("2034937", "Shenyang", "Шэньян", "CN", "156", "19", "2034935", "", "", "41.79222", "123.43278", "Asia/Shanghai"),
("2034995", "Shanhetun", "", "CN", "156", "08", "", "", "", "44.7", "127.2", "Asia/Harbin"),
("2035002", "Shangzhi", "", "CN", "156", "08", "", "", "", "45.21406", "127.97426", "Asia/Harbin"),
("2035182", "Sanchazi", "", "CN", "156", "05", "", "", "", "42.08167", "126.60028", "Asia/Harbin"),
("2035196", "Salaqi", "", "CN", "156", "20", "", "", "", "40.54139", "110.51083", "Asia/Chongqing"),
("2035225", "Fendou", "", "CN", "156", "08", "", "", "", "46.64142", "124.86283", "Asia/Harbin"),
("2035261", "Taihe", "", "CN", "156", "08", "", "", "", "45.76195", "130.85131", "Asia/Harbin"),
("2035265", "Qiqihar", "Цицикар", "CN", "156", "08", "", "", "", "47.34088", "123.96045", "Asia/Harbin"),
("2035325", "Qinggang", "", "CN", "156", "08", "", "", "", "46.68469", "126.10595", "Asia/Harbin"),
("2035399", "Qianguo", "", "CN", "156", "05", "", "", "", "45.11712", "124.85676", "Asia/Harbin"),
("2035453", "Pingzhuang", "", "CN", "156", "20", "", "", "", "42.03722", "119.28889", "Asia/Shanghai"),
("2035511", "Panshi", "Паньши", "CN", "156", "05", "", "", "", "42.94222", "126.05611", "Asia/Harbin"),
("2035513", "Panshan", "", "CN", "156", "19", "", "", "", "41.18806", "122.04944", "Asia/Shanghai"),
("2035593", "Nianzishan", "", "CN", "156", "08", "", "", "", "47.51667", "122.88333", "Asia/Harbin"),
("2035601", "Nenjiang", "", "CN", "156", "08", "", "", "", "49.17414", "125.21774", "Asia/Harbin"),
("2035610", "Nehe", "Нэхэ", "CN", "156", "08", "", "", "", "48.48333", "124.83333", "Asia/Harbin"),
("2035635", "Nantai", "", "CN", "156", "19", "", "", "", "40.9241", "122.80437", "Asia/Shanghai"),
("2035644", "Nanpiao", "", "CN", "156", "19", "", "", "", "41.09822", "120.74792", "Asia/Shanghai"),
("2035669", "Lianhe", "", "CN", "156", "08", "", "", "", "47.13333", "129.27426", "Asia/Harbin"),
("2035707", "Mujiayingzi", "", "CN", "156", "20", "", "", "", "42.11667", "118.78333", "Asia/Shanghai"),
("2035715", "Mudanjiang", "Муданьцзян", "CN", "156", "08", "", "", "", "44.58333", "129.6", "Asia/Harbin"),
("2035746", "Mishan", "Мишань", "CN", "156", "08", "", "", "", "45.55", "131.88333", "Asia/Harbin"),
("2035754", "Mingyue", "", "CN", "156", "05", "", "", "", "43.10694", "128.92167", "Asia/Harbin"),
("2035758", "Mingshui", "", "CN", "156", "08", "", "", "", "47.1815", "125.90027", "Asia/Harbin"),
("2035801", "Meihekou", "", "CN", "156", "05", "", "", "", "42.52722", "125.67528", "Asia/Harbin"),
("2035836", "Manzhouli", "Маньчжурия", "CN", "156", "20", "", "", "", "49.6", "117.43333", "Asia/Shanghai"),
("2035966", "Longjing", "", "CN", "156", "05", "", "", "", "42.77139", "129.42333", "Asia/Harbin"),
("2035970", "Longjiang", "Лонцзян", "CN", "156", "08", "", "", "", "47.33072", "123.17816", "Asia/Harbin"),
("2035980", "Longfeng", "", "CN", "156", "08", "", "", "", "46.53168", "125.1038", "Asia/Harbin"),
("2036033", "Liuhe", "Люхэ", "CN", "156", "05", "", "", "", "42.24007", "125.71717", "Asia/Harbin"),
("2036055", "Lishu", "Лишать", "CN", "156", "05", "", "", "", "43.30472", "124.32778", "Asia/Harbin"),
("2036066", "Linkou", "", "CN", "156", "08", "", "", "", "45.28606", "130.26151", "Asia/Harbin"),
("2036069", "Linjiang", "Линьцзяне", "CN", "156", "05", "", "", "", "41.80694", "126.90778", "Asia/Harbin"),
("2036075", "Lingyuan", "", "CN", "156", "19", "", "", "", "41.24", "119.40111", "Asia/Shanghai"),
("2036081", "Lingdong", "", "CN", "156", "08", "", "", "", "46.56694", "131.14528", "Asia/Harbin"),
("2036106", "Liaozhong", "", "CN", "156", "19", "", "", "", "41.50611", "122.72417", "Asia/Shanghai"),
("2036109", "Liaoyuan", "", "CN", "156", "05", "", "", "", "42.90361", "125.13583", "Asia/Harbin"),
("2036113", "Liaoyang", "Ляоян", "CN", "156", "19", "", "", "", "41.27194", "123.17306", "Asia/Shanghai"),
("2036226", "Lanxi", "", "CN", "156", "08", "", "", "", "46.25785", "126.28269", "Asia/Harbin"),
("2036237", "Langxiang", "", "CN", "156", "08", "", "", "", "46.94985", "128.86849", "Asia/Harbin"),
("2036241", "Langtou", "", "CN", "156", "19", "", "", "", "40.02611", "124.32861", "Asia/Shanghai"),
("2036283", "Kuandian", "", "CN", "156", "19", "", "", "", "40.72861", "124.78472", "Asia/Shanghai"),
("2036337", "Kaiyuan", "Кайюань", "CN", "156", "19", "", "", "", "42.53306", "124.04028", "Asia/Shanghai"),
("2036338", "Kaitong", "", "CN", "156", "05", "", "", "", "44.81351", "123.15", "Asia/Harbin"),
("2036389", "Jixi", "Цзиси", "CN", "156", "08", "", "", "", "45.3011", "130.95718", "Asia/Harbin"),
("2036401", "Jiutai", "", "CN", "156", "05", "", "", "", "44.1525", "125.83278", "Asia/Harbin"),
("2036403", "Jiupu", "", "CN", "156", "19", "2038630", "", "", "41.06667", "122.95", "Asia/Shanghai"),
("2036418", "Jishu", "", "CN", "156", "05", "", "", "", "44.31667", "126.8", "Asia/Harbin"),
("2036427", "Jinzhou", "Цзиньчжоу", "CN", "156", "19", "", "", "", "41.10778", "121.14167", "Asia/Shanghai"),
("2036434", "Lianshan", "", "CN", "156", "19", "", "", "", "40.76432", "120.85327", "Asia/Shanghai"),
("2036458", "Jining", "Цзинин", "CN", "156", "20", "", "", "", "41.0275", "113.10583", "Asia/Chongqing"),
("2036502", "Jilin", "Цзилинь", "CN", "156", "05", "", "", "", "43.85083", "126.56028", "Asia/Harbin"),
("2036519", "Jidong", "", "CN", "156", "08", "", "", "", "45.21667", "131.08333", "Asia/Harbin"),
("2036536", "Minzhu", "Цзяохэ", "CN", "156", "05", "", "", "", "43.72144", "127.33402", "Asia/Harbin"),
("2036581", "Jiamusi", "Цзямусы", "CN", "156", "08", "", "", "", "46.79927", "130.31633", "Asia/Harbin"),
("2036595", "Jalai Nur", "Чжалайнор", "CN", "156", "20", "", "", "", "49.45", "117.7", "Asia/Shanghai"),
("2036597", "Jagdaqi", "", "CN", "156", "20", "", "", "", "50.41667", "124.11667", "Asia/Shanghai"),
("2036619", "Hushitai", "", "CN", "156", "19", "", "", "", "41.93222", "123.51139", "Asia/Shanghai"),
("2036653", "Hunchun", "Хуньчунь", "CN", "156", "05", "", "", "", "42.8675", "130.35806", "Asia/Harbin"),
("2036670", "Hulan Ergi", "", "CN", "156", "08", "", "", "", "47.20417", "123.63333", "Asia/Harbin"),
("2036671", "Hulan", "Хулан", "CN", "156", "08", "", "", "", "45.98333", "126.6", "Asia/Harbin"),
("2036685", "Huinan", "", "CN", "156", "05", "", "", "", "42.6225", "126.26139", "Asia/Harbin"),
("2036713", "Huanren", "", "CN", "156", "19", "", "", "", "41.26472", "125.36667", "Asia/Shanghai"),
("2036734", "Huangnihe", "", "CN", "156", "05", "", "", "", "43.55833", "128.02389", "Asia/Harbin"),
("2036753", "Huanan", "", "CN", "156", "08", "", "", "", "46.2207", "130.525", "Asia/Harbin"),
("2036776", "Huadian", "", "CN", "156", "05", "", "", "", "42.96333", "126.74778", "Asia/Harbin"),
("2036876", "Honggang", "", "CN", "156", "08", "", "", "", "46.40124", "124.88322", "Asia/Harbin"),
("2036892", "Hohhot", "Хух-Хото", "CN", "156", "20", "", "", "", "40.81056", "111.65222", "Asia/Chongqing"),
("2036920", "Fendou", "", "CN", "156", "08", "", "", "", "45.21235", "130.90254", "Asia/Harbin"),
("2036933", "Helong", "Хэлуне", "CN", "156", "05", "", "", "", "42.53974", "128.99722", "Asia/Harbin"),
("2036959", "Heishan", "", "CN", "156", "19", "", "", "", "41.68917", "122.11278", "Asia/Shanghai"),
("2036973", "Heihe", "Хэйхэ", "CN", "156", "08", "", "", "", "50.24413", "127.49016", "Asia/Harbin"),
("2036986", "Hegang", "Хэган", "CN", "156", "08", "", "", "", "47.35118", "130.30012", "Asia/Harbin"),
("2037013", "Harbin", "Харбин", "CN", "156", "08", "", "", "", "45.75", "126.65", "Asia/Harbin"),
("2037069", "Hailun", "", "CN", "156", "08", "", "", "", "47.4565", "126.95368", "Asia/Harbin"),
("2037075", "Hailin", "Хайлин", "CN", "156", "08", "", "", "", "44.57149", "129.38539", "Asia/Harbin"),
("2037078", "Hailar", "Хайлар", "CN", "156", "20", "", "", "", "49.2", "119.7", "Asia/Shanghai"),
("2037086", "Haicheng", "", "CN", "156", "19", "", "", "", "40.85158", "122.74754", "Asia/Shanghai"),
("2037222", "Gongzhuling", "Гунчжулина", "CN", "156", "05", "", "", "", "43.50075", "124.81979", "Asia/Harbin"),
("2037240", "Gongchangling", "", "CN", "156", "19", "", "", "", "41.11667", "123.45", "Asia/Shanghai"),
("2037252", "Genhe", "", "CN", "156", "20", "", "", "", "50.78333", "121.51667", "Asia/Shanghai"),
("2037311", "Gannan", "", "CN", "156", "08", "", "", "", "47.91472", "123.50306", "Asia/Harbin"),
("2037330", "Fuyuan", "Фуюань", "CN", "156", "08", "", "", "", "48.36306", "134.28917", "Asia/Harbin"),
("2037334", "Fuyu", "", "CN", "156", "08", "", "", "", "47.79756", "124.45731", "Asia/Harbin"),
("2037335", "Fuyu", "", "CN", "156", "05", "", "", "", "45.18333", "124.81667", "Asia/Harbin"),
("2037345", "Fuxin", "Фусинь", "CN", "156", "19", "", "", "", "42.05889", "121.745", "Asia/Shanghai"),
("2037346", "Fuxin", "Фусинь", "CN", "156", "19", "", "", "", "42.01556", "121.65889", "Asia/Shanghai"),
("2037355", "Fushun", "Фушунь", "CN", "156", "19", "", "", "", "41.85583", "123.92333", "Asia/Shanghai"),
("2037370", "Fuli", "Фули", "CN", "156", "08", "", "", "", "46.72167", "131.13944", "Asia/Harbin"),
("2037375", "Fujin", "Фуцзинь", "CN", "156", "08", "", "", "", "47.26", "132.03222", "Asia/Harbin"),
("2037391", "Beichengqu", "", "CN", "156", "20", "", "", "", "40.43944", "113.15361", "Asia/Chongqing"),
("2037393", "Fengxiang", "Фенгсианг", "CN", "156", "08", "", "", "", "47.57549", "130.82306", "Asia/Harbin"),
("2037411", "Fengcheng", "", "CN", "156", "19", "", "", "", "40.45361", "124.07167", "Asia/Shanghai"),
("2037485", "Erenhot", "", "CN", "156", "20", "", "", "", "43.6475", "111.97667", "Asia/Shanghai"),
("2037494", "Erdaojiang", "", "CN", "156", "05", "", "", "", "41.77639", "126.03194", "Asia/Harbin"),
("2037534", "Dunhua", "Дуньхуа", "CN", "156", "05", "", "", "", "43.3725", "128.2425", "Asia/Harbin"),
("2037611", "Dongning", "", "CN", "156", "08", "", "", "", "44.06219", "131.12075", "Asia/Harbin"),
("2037620", "Dongling", "Донлин", "CN", "156", "19", "", "", "", "41.81444", "123.57583", "Asia/Shanghai"),
("2037658", "Dongfeng", "", "CN", "156", "05", "", "", "", "42.64031", "125.51176", "Asia/Harbin"),
("2037685", "Dongxing", "", "CN", "156", "08", "", "", "", "45.36088", "130.78679", "Asia/Harbin"),
("2037712", "Dehui", "", "CN", "156", "05", "", "", "", "44.53333", "125.7", "Asia/Harbin"),
("2037799", "Datong", "Датун", "CN", "156", "24", "", "", "", "40.09361", "113.29139", "Asia/Shanghai"),
("2037820", "Dashitou", "", "CN", "156", "05", "", "", "", "43.30667", "128.51139", "Asia/Harbin"),
("2037823", "Dashiqiao", "", "CN", "156", "19", "", "", "", "40.63732", "122.50251", "Asia/Shanghai"),
("2037860", "Daqing", "Дацин", "CN", "156", "08", "", "", "", "46.58333", "125", "Asia/Harbin"),
("2037886", "Dandong", "Даньдун", "CN", "156", "19", "", "", "", "40.12917", "124.39472", "Asia/Shanghai"),
("2037913", "Linghai", "", "CN", "156", "19", "", "", "", "41.16528", "121.36667", "Asia/Shanghai"),
("2037930", "Dalai", "", "CN", "156", "05", "", "", "", "45.5", "124.3", "Asia/Harbin"),
("2038067", "Chifeng", "Чифэн", "CN", "156", "20", "", "", "", "42.26833", "118.96361", "Asia/Shanghai"),
("2038080", "Chengzihe", "", "CN", "156", "08", "", "", "", "45.33333", "131.06667", "Asia/Harbin"),
("2038087", "Chengde", "Чэндэ", "CN", "156", "10", "", "", "", "40.9725", "117.93611", "Asia/Shanghai"),
("2038118", "Chaoyang", "Чаоян", "CN", "156", "05", "", "", "", "42.66223", "126.0263", "Asia/Harbin"),
("2038120", "Chaoyang", "Чаоян", "CN", "156", "19", "", "", "", "41.57028", "120.45861", "Asia/Shanghai"),
("2038139", "Changtu", "Чанту", "CN", "156", "19", "", "", "", "42.77884", "124.09545", "Asia/Shanghai"),
("2038154", "Changping", "Чанпин", "CN", "156", "22", "", "", "", "40.21612", "116.23471", "Asia/Shanghai"),
("2038158", "Changling", "", "CN", "156", "05", "", "", "", "44.26532", "124.00045", "Asia/Harbin"),
("2038180", "Changchun", "Чанчунь", "CN", "156", "05", "2038176", "", "", "43.88", "125.32278", "Asia/Harbin"),
("2038198", "Chaihe", "", "CN", "156", "08", "", "", "", "44.7598", "129.67826", "Asia/Harbin"),
("2038274", "Boli", "Боли", "CN", "156", "08", "", "", "", "45.75279", "130.57211", "Asia/Harbin"),
("2038283", "Binzhou", "", "CN", "156", "08", "", "", "", "45.75281", "127.47986", "Asia/Harbin"),
("2038300", "Benxi", "Бэньси", "CN", "156", "19", "", "", "", "41.28861", "123.765", "Asia/Shanghai"),
("2038342", "Beipiao", "", "CN", "156", "19", "", "", "", "41.79194", "120.77917", "Asia/Shanghai"),
("2038365", "Bei'an", "", "CN", "156", "08", "", "", "", "48.26667", "126.6", "Asia/Harbin"),
("2038421", "Bayan", "Баян", "CN", "156", "08", "", "", "", "46.07556", "127.3984", "Asia/Harbin"),
("2038432", "Baotou", "Баотоу", "CN", "156", "20", "", "", "", "40.65222", "109.82222", "Asia/Chongqing"),
("2038438", "Baoshan", "Баошань", "CN", "156", "08", "", "", "", "46.55861", "131.42444", "Asia/Harbin"),
("2038446", "Baoqing", "Баоцин", "CN", "156", "08", "", "", "", "46.33167", "132.21111", "Asia/Harbin"),
("2038482", "Bamiantong", "", "CN", "156", "08", "", "", "", "44.91738", "130.52", "Asia/Harbin"),
("2038529", "Baishishan", "", "CN", "156", "05", "", "", "", "43.58333", "127.56667", "Asia/Harbin"),
("2038541", "Baiquan", "", "CN", "156", "08", "", "", "", "47.60605", "126.08481", "Asia/Harbin"),
("2038569", "Baicheng", "Байчен", "CN", "156", "05", "", "", "", "45.60746", "122.82076", "Asia/Harbin"),
("2038584", "Baishan", "Байшань", "CN", "156", "05", "", "", "", "41.93853", "126.41965", "Asia/Harbin"),
("2038632", "Anshan", "Аньшань", "CN", "156", "19", "2038630", "", "", "41.12361", "122.99", "Asia/Shanghai"),
("2038650", "Anda", "Анда", "CN", "156", "08", "", "", "", "46.40202", "125.31454", "Asia/Harbin"),
("2038665", "Oroqen Zizhiqi", "Алихэ", "CN", "156", "20", "", "", "", "50.56667", "123.71667", "Asia/Shanghai"),
("2038679", "Acheng", "Ахенг", "CN", "156", "08", "", "", "", "45.54545", "126.97703", "Asia/Harbin"),
("2047837", "Songling", "", "CN", "156", "10", "", "", "", "40.30806", "118.27056", "Asia/Shanghai"),
("6825277", "Shilin", "Шилин", "CN", "156", "29", "", "", "", "24.81878", "103.33237", "Asia/Chongqing"),
("7283386", "Changshu City", "", "CN", "156", "04", "", "", "", "31.64615", "120.74221", "Asia/Shanghai"),
("7290013", "Shixing", "", "CN", "156", "30", "", "", "", "24.94824", "114.06572", "Asia/Shanghai"),
("7303248", "Jiashan", "", "CN", "156", "02", "", "", "", "30.84918", "120.92583", "Asia/Shanghai"),
("7304020", "Fenghuang", "Фенхуань", "CN", "156", "11", "", "", "", "27.93557", "109.59961", "Asia/Shanghai"),
("7602670", "Zhu Cheng City", "", "CN", "156", "25", "", "", "", "35.99502", "119.40259", "Asia/Shanghai"),
("7910932", "Shangri-La", "Шангри-Ла", "CN", "156", "29", "1281365", "", "", "27.82511", "99.70779", "Asia/Chongqing"),
("8347664", "Ordos", "Ордос", "CN", "156", "20", "", "", "", "39.6086", "109.78157", "Asia/Chongqing"),
("8505006", "Wenshan City", "", "CN", "156", "29", "1791424", "", "", "23.36306", "104.25047", "Asia/Chongqing"),
("8533133", "Liupanshui", "", "CN", "156", "18", "", "", "", "26.59444", "104.83333", "Asia/Chongqing"),
("3533753", "Yara", "", "CU", "192", "09", "", "", "", "20.2733", "-76.95399", "America/Havana"),
("3533826", "Yaguajay", "", "CU", "192", "14", "", "", "", "22.32722", "-79.23778", "America/Havana"),
("3534094", "Vinales", "Виньялес", "CU", "192", "01", "", "", "", "22.61243", "-83.71136", "America/Havana"),
("3534363", "Vertientes", "", "CU", "192", "05", "", "", "", "21.25528", "-78.15338", "America/Havana"),
("3534432", "Venezuela", "", "CU", "192", "07", "", "", "", "21.73528", "-78.79639", "America/Havana"),
("3534632", "Varadero", "Варадеро", "CU", "192", "03", "", "", "", "23.15678", "-81.24441", "America/Havana"),
("3534749", "Urbano Noris", "", "CU", "192", "12", "", "", "", "20.60101", "-76.13188", "America/Havana"),
("3534761", "Union de Reyes", "", "CU", "192", "03", "", "", "", "22.79528", "-81.5375", "America/Havana"),
("3534915", "Trinidad", "Тринидад", "CU", "192", "14", "", "", "", "21.80194", "-79.98417", "America/Havana"),
("3536259", "Sibanicu", "", "CU", "192", "05", "", "", "", "21.235", "-77.52639", "America/Havana"),
("3536640", "Santo Domingo", "", "CU", "192", "16", "", "", "", "22.58667", "-80.24361", "America/Havana"),
("3536724", "Santiago de las Vegas", "Сантьяго-де-лас-Вегас", "CU", "192", "02", "", "", "", "22.97", "-82.38694", "America/Havana"),
("3536729", "Santiago de Cuba", "Сантьяго-де-Куба", "CU", "192", "15", "3536726", "", "", "20.02472", "-75.82194", "America/Havana"),
("3537840", "Santa Cruz del Sur", "", "CU", "192", "05", "", "", "", "20.71176", "-77.9986", "America/Havana"),
("3537845", "Santa Cruz del Norte", "", "CU", "192", "MA", "", "", "", "23.15374", "-81.92611", "America/Havana"),
("3537906", "Santa Clara", "Санта Клара", "CU", "192", "16", "", "", "", "22.4", "-79.96667", "America/Havana"),
("3538803", "San Miguel del Padron", "", "CU", "192", "02", "", "", "", "23.06639", "-82.29472", "America/Havana"),
("3539093", "San Luis", "", "CU", "192", "15", "", "", "", "20.1875", "-75.85083", "America/Havana"),
("3539560", "San Jose de las Lajas", "", "CU", "192", "MA", "", "", "", "22.96139", "-82.15111", "America/Havana"),
("3540667", "Sancti Spiritus", "Санкти-Спиритус", "CU", "192", "14", "", "", "", "21.92972", "-79.4425", "America/Havana"),
("3540680", "San Cristobal", "", "CU", "192", "AR", "", "", "", "22.71417", "-83.04806", "America/Havana"),
("3540885", "San Antonio de los Banos", "", "CU", "192", "AR", "", "", "", "22.89111", "-82.49917", "America/Havana"),
("3541440", "Sagua la Grande", "", "CU", "192", "16", "", "", "", "22.80667", "-80.07556", "America/Havana"),
("3541446", "Sagua de Tanamo", "", "CU", "192", "12", "", "", "", "20.58194", "-75.24139", "America/Havana"),
("3541999", "Rodas", "Родас", "CU", "192", "08", "", "", "", "22.33794", "-80.55538", "America/Havana"),
("3542137", "Rio Guayabal de Yateras", "", "CU", "192", "10", "", "", "", "20.36667", "-75.01667", "America/Havana"),
("3542167", "Rio Cauto", "", "CU", "192", "09", "", "", "", "20.56284", "-76.92122", "America/Havana"),
("3542455", "Remedios", "Ремедиос", "CU", "192", "16", "", "", "", "22.49303", "-79.54488", "America/Havana"),
("3542502", "Regla", "", "CU", "192", "02", "", "", "", "23.125", "-82.33194", "America/Havana"),
("3542744", "Ranchuelo", "", "CU", "192", "16", "", "", "", "22.37485", "-80.14983", "America/Havana"),
("3543299", "Puerto Padre", "Пуэрто-Падре", "CU", "192", "13", "", "", "", "21.19449", "-76.60355", "America/Havana"),
("3543498", "Primero de Enero", "", "CU", "192", "07", "", "", "", "21.94694", "-78.42833", "America/Havana"),
("3543961", "Placetas", "", "CU", "192", "16", "", "", "", "22.31194", "-79.65333", "America/Havana"),
("3544091", "Pinar del Rio", "Пинар-дель-Рио", "CU", "192", "01", "3544089", "", "", "22.4175", "-83.69806", "America/Havana"),
("3544393", "Perico", "", "CU", "192", "03", "", "", "", "22.76917", "-81.01889", "America/Havana"),
("3544607", "Pedro Betancourt", "", "CU", "192", "03", "", "", "", "22.72467", "-81.28852", "America/Havana"),
("3545040", "Palmira", "", "CU", "192", "08", "", "", "", "22.24167", "-80.39028", "America/Havana"),
("3545064", "Palma Soriano", "", "CU", "192", "15", "", "", "", "20.21238", "-75.99843", "America/Havana"),
("3545841", "Nuevitas", "", "CU", "192", "05", "", "", "", "21.54528", "-77.26444", "America/Havana"),
("3545867", "Nueva Gerona", "Нуэва-Херона", "CU", "192", "04", "", "", "", "21.88333", "-82.8", "America/Havana"),
("3545981", "Niquero", "", "CU", "192", "09", "", "", "", "20.04478", "-77.5851", "America/Havana"),
("3546434", "Moron", "Морон", "CU", "192", "07", "", "", "", "22.10944", "-78.6275", "America/Havana"),
("3546791", "Moa", "Моа", "CU", "192", "12", "", "", "", "20.65694", "-74.94028", "America/Havana"),
("3546882", "Minas de Matahambre", "", "CU", "192", "01", "", "", "", "22.5875", "-83.945", "America/Havana"),
("3546894", "Minas", "Минас", "CU", "192", "05", "", "", "", "21.48833", "-77.61832", "America/Havana"),
("3547260", "Media Luna", "", "CU", "192", "09", "", "", "", "20.14001", "-77.43658", "America/Havana"),
("3547398", "Matanzas", "Матанзас", "CU", "192", "03", "", "", "", "23.04111", "-81.5775", "America/Havana"),
("3547600", "Mariel", "", "CU", "192", "AR", "", "", "", "22.9875", "-82.75361", "America/Havana"),
("3547867", "Manzanillo", "Мансанильо", "CU", "192", "09", "", "", "", "20.34333", "-77.11667", "America/Havana"),
("3547976", "Manicaragua", "", "CU", "192", "16", "", "", "", "22.14944", "-79.97361", "America/Havana"),
("3548441", "Maisi", "", "CU", "192", "10", "", "", "", "20.24673", "-74.15181", "America/Havana"),
("3548529", "Madruga", "", "CU", "192", "MA", "", "", "", "22.91139", "-81.85611", "America/Havana"),
("3548993", "Los Palacios", "", "CU", "192", "01", "", "", "", "22.58722", "-83.24861", "America/Havana"),
("3550598", "Las Tunas", "Лас-Тунас", "CU", "192", "13", "", "", "", "20.96167", "-76.95111", "America/Havana"),
("3551184", "La Sierpe", "", "CU", "192", "14", "", "", "", "21.75722", "-79.24306", "America/Havana"),
("3551608", "La Salud", "Ла Салюд", "CU", "192", "MA", "", "", "", "22.86991", "-82.42193", "America/Havana"),
("3553478", "Havana", "Гавана", "CU", "192", "02", "", "", "", "23.13302", "-82.38304", "America/Havana"),
("3555907", "Jovellanos", "", "CU", "192", "03", "", "", "", "22.80444", "-81.19444", "America/Havana"),
("3556077", "Jobabo", "", "CU", "192", "12", "", "", "", "20.96917", "-76.29944", "America/Havana"),
("3556078", "Jobabo", "", "CU", "192", "13", "", "", "", "20.90508", "-77.28819", "America/Havana"),
("3556168", "Jiguani", "", "CU", "192", "09", "", "", "", "20.36667", "-76.42722", "America/Havana"),
("3556268", "Jesus Menendez", "", "CU", "192", "13", "", "", "", "21.16", "-76.47889", "America/Havana"),
("3556334", "Jatibonico", "", "CU", "192", "14", "", "", "", "21.941", "-79.17484", "America/Havana"),
("3556351", "Jaruco", "", "CU", "192", "MA", "", "", "", "23.04306", "-82.01083", "America/Havana"),
("3556437", "Jaguey Grande", "", "CU", "192", "03", "", "", "", "22.52694", "-81.12861", "America/Havana"),
("3556969", "Holguin", "Ольгин", "CU", "192", "12", "3556966", "", "", "20.88722", "-76.26306", "America/Havana"),
("3557332", "Guisa", "", "CU", "192", "09", "", "", "", "20.25101", "-76.54152", "America/Havana"),
("3557347", "Guira de Melena", "", "CU", "192", "AR", "", "", "", "22.79274", "-82.50823", "America/Havana"),
("3557378", "Gueines", "Гуинес", "CU", "192", "11", "", "", "", "22.83611", "-82.02806", "America/Havana"),
("3557689", "Guantanamo", "Гуантанамо", "CU", "192", "10", "3557686", "", "", "20.14444", "-75.20917", "America/Havana"),
("3557758", "Guane", "", "CU", "192", "01", "", "", "", "22.2025", "-84.0875", "America/Havana"),
("3557801", "Guanajay", "", "CU", "192", "AR", "", "", "", "22.92639", "-82.6875", "America/Havana"),
("3557846", "Guanabacoa", "", "CU", "192", "02", "", "", "", "23.12389", "-82.30028", "America/Havana"),
("3557923", "Guaimaro", "", "CU", "192", "05", "", "", "", "21.05176", "-77.35021", "America/Havana"),
("3558315", "Gibara", "", "CU", "192", "12", "", "", "", "21.10972", "-76.13167", "America/Havana"),
("3558744", "Fomento", "", "CU", "192", "14", "", "", "", "22.1001", "-79.71913", "America/Havana"),
("3558771", "Florida", "Флорида", "CU", "192", "05", "", "", "", "21.52472", "-78.22583", "America/Havana"),
("3558792", "Florencia", "", "CU", "192", "07", "", "", "", "22.14518", "-78.97764", "America/Havana"),
("3559318", "Esmeralda", "Эсмеральда", "CU", "192", "05", "", "", "", "21.85155", "-78.12005", "America/Havana"),
("3559416", "Encrucijada", "", "CU", "192", "16", "", "", "", "22.61611", "-79.86458", "America/Havana"),
("3562827", "Cumanayagua", "", "CU", "192", "08", "", "", "", "22.14944", "-80.20222", "America/Havana"),
("3562895", "Cueto", "", "CU", "192", "12", "", "", "", "20.64511", "-75.9402", "America/Havana"),
("3563145", "Cruces", "Крусес", "CU", "192", "08", "", "", "", "22.34175", "-80.27028", "America/Havana"),
("3563317", "Corralillo", "", "CU", "192", "16", "", "", "", "22.98194", "-80.58556", "America/Havana"),
("3563504", "Contramaestre", "", "CU", "192", "15", "", "", "", "20.29778", "-76.24139", "America/Havana"),
("3563559", "Consolacion del Sur", "", "CU", "192", "01", "", "", "", "22.50528", "-83.51095", "America/Havana"),
("3563609", "Condado", "Кондадо", "CU", "192", "14", "", "", "", "21.87667", "-79.84028", "America/Havana"),
("3563843", "Colon", "", "CU", "192", "03", "", "", "", "22.71917", "-80.90583", "America/Havana"),
("3563856", "Colombia", "", "CU", "192", "13", "", "", "", "20.98806", "-77.42972", "America/Havana"),
("3564084", "Ciro Redondo", "", "CU", "192", "07", "", "", "", "22.01222", "-78.705", "America/Havana"),
("3564114", "Cifuentes", "", "CU", "192", "16", "", "", "", "22.645", "-80.04611", "America/Havana"),
("3564124", "Cienfuegos", "Сьенфуэгос", "CU", "192", "08", "3564121", "", "", "22.14957", "-80.44662", "America/Havana"),
("3564178", "Ciego de Avila", "", "CU", "192", "07", "", "", "", "21.84", "-78.76194", "America/Havana"),
("3564394", "Chambas", "", "CU", "192", "07", "", "", "", "22.18736", "-78.91569", "America/Havana"),
("3564436", "Cerro", "", "CU", "192", "02", "", "", "", "23.10861", "-82.37778", "America/Havana"),
("3564885", "Cauto Cristo", "", "CU", "192", "09", "", "", "", "20.55639", "-76.47444", "America/Havana"),
("3565432", "Cardenas", "Карденас", "CU", "192", "03", "", "", "", "23.0375", "-81.20472", "America/Havana"),
("3565951", "Campechuela", "", "CU", "192", "09", "", "", "", "20.23417", "-77.27889", "America/Havana"),
("3566054", "Camajuani", "", "CU", "192", "16", "", "", "", "22.48333", "-79.75", "America/Havana"),
("3566067", "Camaguey", "Камагуэй", "CU", "192", "05", "", "", "", "21.38083", "-77.91694", "America/Havana"),
("3566134", "Calimete", "", "CU", "192", "03", "", "", "", "22.53166", "-80.9045", "America/Havana"),
("3566356", "Caibarien", "", "CU", "192", "16", "", "", "", "22.52056", "-79.46694", "America/Havana"),
("3566429", "Cacocum", "", "CU", "192", "12", "", "", "", "20.73668", "-76.32646", "America/Havana"),
("3566603", "Cabaiguan", "", "CU", "192", "14", "", "", "", "22.07889", "-79.49917", "America/Havana"),
("3567546", "Bejucal", "", "CU", "192", "MA", "", "", "", "22.92861", "-82.38861", "America/Havana"),
("3567597", "Bayamo", "Баямо", "CU", "192", "09", "", "", "", "20.37917", "-76.64333", "America/Havana"),
("3567612", "Bauta", "", "CU", "192", "AR", "", "", "", "22.98278", "-82.54639", "America/Havana"),
("3567669", "Bartolome Maso", "", "CU", "192", "09", "", "", "", "20.16303", "-76.94443", "America/Havana"),
("3567823", "Baragua", "", "CU", "192", "07", "", "", "", "21.6883", "-78.63606", "America/Havana"),
("3567834", "Baracoa", "", "CU", "192", "10", "", "", "", "20.34659", "-74.49675", "America/Havana"),
("3567869", "Banes", "", "CU", "192", "12", "", "", "", "20.9625", "-75.71861", "America/Havana"),
("3567995", "Bahia Honda", "", "CU", "192", "AR", "", "", "", "22.90361", "-83.15917", "America/Havana"),
("3568312", "Artemisa", "Артемиса", "CU", "192", "AR", "", "", "", "22.81306", "-82.76194", "America/Havana"),
("3568342", "Arroyo Naranjo", "", "CU", "192", "02", "", "", "", "23.03611", "-82.37167", "America/Havana"),
("3569024", "Amancio", "", "CU", "192", "13", "", "", "", "20.8225", "-77.57861", "America/Havana"),
("3569136", "Alquizar", "", "CU", "192", "AR", "", "", "", "22.80583", "-82.58417", "America/Havana"),
("3569370", "Alamar", "Аламар", "CU", "192", "02", "", "", "", "23.15833", "-82.27694", "America/Havana"),
("3569546", "Aguada de Pasajeros", "", "CU", "192", "08", "", "", "", "22.37925", "-80.84898", "America/Havana"),
("3569741", "Abreus", "", "CU", "192", "08", "", "", "", "22.2775", "-80.5675", "America/Havana"),
("3746181", "Habana del Este", "", "CU", "192", "02", "", "", "", "23.15917", "-82.33056", "America/Havana"),
("3746183", "Centro Habana", "", "CU", "192", "02", "3746183", "", "", "23.13833", "-82.36417", "America/Havana"),
("3746184", "La Habana Vieja", "", "CU", "192", "02", "", "", "", "23.13028", "-82.35306", "America/Havana"),
("3746938", "Baguanos", "", "CU", "192", "12", "", "", "", "20.75167", "-76.02694", "America/Havana"),
("3754915", "Jimaguayu", "", "CU", "192", "05", "", "", "", "21.24278", "-77.82778", "America/Havana"),
("6956646", "Arroyo Naranjo", "", "CU", "192", "02", "", "", "", "23.0144", "-82.3031", "America/Havana"),
("6956647", "Boyeros", "", "CU", "192", "02", "", "", "", "23.0072", "-82.4017", "America/Havana"),
("6956648", "Diez de Octubre", "", "CU", "192", "02", "", "", "", "23.0881", "-82.3597", "America/Havana"),
("3374218", "Santa Maria", "", "CV", "132", "08", "", "", "", "16.6", "-22.9", "Atlantic/Cape_Verde"),
("3374333", "Praia", "Прая", "CV", "132", "14", "", "", "", "14.93152", "-23.51254", "Atlantic/Cape_Verde"),
("3374462", "Mindelo", "Минделу", "CV", "132", "11", "", "", "", "16.89014", "-24.98042", "Atlantic/Cape_Verde"),
("3374707", "Cova Figueira", "", "CV", "132", "24", "", "", "", "14.89054", "-24.29343", "Atlantic/Cape_Verde"),
("18918", "Protaras", "Протарас", "CY", "196", "01", "", "", "", "35.0125", "34.05833", "Asia/Nicosia"),
("146214", "Paphos", "Пафос", "CY", "196", "06", "", "", "", "34.77679", "32.42451", "Asia/Nicosia"),
("146268", "Nicosia", "Никосия", "CY", "196", "04", "", "", "", "35.16667", "33.36667", "Asia/Nicosia"),
("146384", "Limassol", "Лимасол", "CY", "196", "05", "", "", "", "34.68406", "33.03794", "Asia/Nicosia"),
("146400", "Larnaca", "Ларнака", "CY", "196", "03", "", "", "", "34.92291", "33.6233", "Asia/Nicosia"),
("146412", "Kyrenia", "Кирения", "CY", "196", "02", "", "", "", "35.34167", "33.31667", "Asia/Nicosia"),
("146617", "Famagusta", "Фамагуста", "CY", "196", "01", "", "", "", "35.125", "33.95", "Asia/Nicosia"),
("3061284", "Dvur Kralove nad Labem", "Двур-Кралове-над-Лабем", "CZ", "203", "82", "", "", "", "50.43172", "15.81402", "Europe/Prague"),
("3061344", "Znojmo", "Зноймо", "CZ", "203", "78", "0627", "", "", "48.8555", "16.0488", "Europe/Prague"),
("3061370", "Zlin", "Злин", "CZ", "203", "90", "0724", "", "", "49.22645", "17.67065", "Europe/Prague"),
("3061692", "Zd'ar nad Sazavou Druhy", "", "CZ", "203", "80", "", "", "", "49.58726", "15.93216", "Europe/Prague"),
("3061695", "Zd'ar nad Sazavou", "Ждяр-над-Сазавоу", "CZ", "203", "80", "0615", "", "", "49.56263", "15.93924", "Europe/Prague"),
("3061822", "Zatec", "Жатец", "CZ", "203", "89", "", "", "", "50.32717", "13.54577", "Europe/Prague"),
("3062283", "Vyskov", "Вышков", "CZ", "203", "78", "0626", "", "", "49.27747", "16.99897", "Europe/Prague"),
("3062339", "Vsetin", "Всетин", "CZ", "203", "90", "0723", "", "", "49.33871", "17.99619", "Europe/Prague"),
("3063375", "Varnsdorf", "Варнсдорф", "CZ", "203", "89", "", "", "", "50.91154", "14.61824", "Europe/Prague"),
("3063447", "Valasske Mezirici", "Мезиржичи", "CZ", "203", "90", "", "", "", "49.47181", "17.97113", "Europe/Prague"),
("3063546", "Usti nad Orlici", "Усти-над-Орлици", "CZ", "203", "86", "0534", "", "", "49.97387", "16.39361", "Europe/Prague"),
("3063548", "Usti nad Labem", "Усти-над-Лабем", "CZ", "203", "89", "0427", "", "", "50.6607", "14.03227", "Europe/Prague"),
("3063736", "Uhersky Brod", "Угерски-Брод", "CZ", "203", "90", "", "", "", "49.02513", "17.64715", "Europe/Prague"),
("3063739", "Uherske Hradiste", "Градиште", "CZ", "203", "90", "0722", "", "", "49.06975", "17.45969", "Europe/Prague"),
("3063907", "Trutnov", "Трутнов", "CZ", "203", "82", "0525", "", "", "50.56101", "15.9127", "Europe/Prague"),
("3064000", "Trinec", "Тршинец", "CZ", "203", "85", "", "", "", "49.67763", "18.67078", "Europe/Prague"),
("3064104", "Trebic", "Тршебич", "CZ", "203", "80", "0614", "", "", "49.21492", "15.88166", "Europe/Prague"),
("3064288", "Teplice", "Теплице", "CZ", "203", "89", "0426", "", "", "50.6404", "13.82451", "Europe/Prague"),
("3064379", "Tabor", "Табор", "CZ", "203", "79", "0317", "", "", "49.41441", "14.6578", "Europe/Prague"),
("3064454", "Svitavy", "Свитави", "CZ", "203", "86", "0533", "", "", "49.75594", "16.46829", "Europe/Prague"),
("3064673", "Sumperk", "Шумперк", "CZ", "203", "84", "0715", "", "", "49.96528", "16.97061", "Europe/Prague"),
("3065067", "Strakonice", "Страконице", "CZ", "203", "79", "", "", "", "49.26141", "13.90237", "Europe/Prague"),
("3065281", "Stary Bohumin", "", "CZ", "203", "85", "", "", "", "49.9169", "18.33619", "Europe/Prague"),
("3065617", "Sokolov", "Соколов", "CZ", "203", "81", "0413", "", "", "50.1813", "12.6401", "Europe/Prague"),
("3065903", "Slany", "", "CZ", "203", "88", "0203", "", "", "50.23046", "14.08693", "Europe/Prague"),
("3066651", "Roznov pod Radhostem", "", "CZ", "203", "90", "0723", "", "", "49.45853", "18.14302", "Europe/Prague"),
("3067051", "Rakovnik", "", "CZ", "203", "88", "", "", "", "50.1037", "13.7334", "Europe/Prague"),
("3067421", "Prostejov", "Простейов", "CZ", "203", "84", "0713", "", "", "49.47188", "17.11184", "Europe/Prague"),
("3067433", "Prosek", "", "CZ", "203", "52", "8378777", "", "", "50.11525", "14.50685", "Europe/Prague"),
("3067542", "Pribram", "Пршибрам", "CZ", "203", "88", "020B", "", "", "49.68988", "14.01043", "Europe/Prague"),
("3067580", "Prerov", "Преров", "CZ", "203", "84", "", "", "", "49.45511", "17.4509", "Europe/Prague"),
("3067696", "Prague", "Прага", "CZ", "203", "52", "", "", "", "50.08804", "14.42076", "Europe/Prague"),
("3068160", "Pilsen", "Пльзень", "CZ", "203", "87", "0323", "", "", "49.74747", "13.37759", "Europe/Prague"),
("3068293", "Pisek", "Писек", "CZ", "203", "79", "0314", "", "", "49.3088", "14.1475", "Europe/Prague"),
("3068445", "Pelhrimov", "", "CZ", "203", "80", "0613", "", "", "49.43134", "15.22336", "Europe/Prague"),
("3068582", "Pardubice", "Пардубице", "CZ", "203", "86", "0532", "", "", "50.04075", "15.77659", "Europe/Prague"),
("3068689", "Otrokovice", "", "CZ", "203", "90", "", "", "", "49.21667", "17.51667", "Europe/Prague"),
("3068690", "Otrokovice", "", "CZ", "203", "90", "0724", "", "", "49.20934", "17.53944", "Europe/Prague"),
("3068766", "Ostrov", "Остров", "CZ", "203", "81", "", "", "", "50.30592", "12.93907", "Europe/Prague"),
("3068799", "Ostrava", "Острава", "CZ", "203", "85", "0806", "", "", "49.83465", "18.28204", "Europe/Prague"),
("3068873", "Orlova", "Орлова", "CZ", "203", "85", "", "", "", "49.84527", "18.43011", "Europe/Prague"),
("3068927", "Opava", "Опава", "CZ", "203", "85", "0805", "", "", "49.93866", "17.90257", "Europe/Prague"),
("3069011", "Olomouc", "Оломоуц", "CZ", "203", "84", "0712", "", "", "49.59552", "17.25175", "Europe/Prague"),
("3069305", "Novy Jicin", "", "CZ", "203", "85", "0804", "", "", "49.59438", "18.01028", "Europe/Prague"),
("3069844", "Neratovice", "", "CZ", "203", "88", "", "", "", "50.25926", "14.51759", "Europe/Prague"),
("3070122", "Nachod", "", "CZ", "203", "82", "0523", "", "", "50.4167", "16.16289", "Europe/Prague"),
("3070291", "Most", "Мост", "CZ", "203", "89", "0425", "", "", "50.50301", "13.63617", "Europe/Prague"),
("3070420", "Modrany", "Модржаны", "CZ", "203", "52", "8378780", "", "", "50.01116", "14.4096", "Europe/Prague"),
("3070544", "Mlada Boleslav", "Млада-Болеслав", "CZ", "203", "88", "0207", "", "", "50.41135", "14.90318", "Europe/Prague"),
("3070862", "Melnik", "Мельник", "CZ", "203", "88", "0206", "", "", "50.3505", "14.47411", "Europe/Prague"),
("3071507", "Louny", "Лоуни", "CZ", "203", "89", "0424", "", "", "50.35699", "13.79667", "Europe/Prague"),
("3071665", "Litvinov", "Литвинов", "CZ", "203", "89", "0425", "", "", "50.6042", "13.61812", "Europe/Prague"),
("3071677", "Litomerice", "Литомержице", "CZ", "203", "89", "0423", "", "", "50.53348", "14.1318", "Europe/Prague"),
("3071961", "Liberec", "Либерец", "CZ", "203", "83", "0513", "", "", "50.76711", "15.05619", "Europe/Prague"),
("3071966", "Liben", "", "CZ", "203", "52", "8378776", "", "", "50.10819", "14.47457", "Europe/Prague"),
("3072137", "Letnany", "", "CZ", "203", "52", "8378788", "", "", "50.13333", "14.51667", "Europe/Prague"),
("3072463", "Kutna Hora", "Кутна-Гора", "CZ", "203", "88", "0205", "", "", "49.94839", "15.26816", "Europe/Prague"),
("3072649", "Kromeriz", "Кромнержиж", "CZ", "203", "90", "0721", "", "", "49.29785", "17.39312", "Europe/Prague"),
("3072656", "Krnov", "Крнов", "CZ", "203", "85", "", "", "", "50.08967", "17.70385", "Europe/Prague"),
("3072929", "Kralupy nad Vltavou", "Кралупи-над-Влтавой", "CZ", "203", "88", "", "", "", "50.24107", "14.31149", "Europe/Prague"),
("3073254", "Koprivnice", "Копршивницах", "CZ", "203", "85", "", "", "", "49.59947", "18.1448", "Europe/Prague"),
("3073371", "Kolin", "Колин", "CZ", "203", "88", "0204", "", "", "50.02814", "15.20057", "Europe/Prague"),
("3073660", "Klatovy", "Клатовы", "CZ", "203", "87", "", "", "", "49.39552", "13.29505", "Europe/Prague"),
("3073668", "Klasterec nad Ohri", "", "CZ", "203", "89", "", "", "", "50.38445", "13.17128", "Europe/Prague"),
("3073699", "Kladno", "Кладно", "CZ", "203", "88", "", "", "", "50.14734", "14.10285", "Europe/Prague"),
("3073789", "Karvina", "Карвина", "CZ", "203", "85", "0803", "", "", "49.854", "18.54169", "Europe/Prague"),
("3073803", "Karlovy Vary", "Карловы Вары", "CZ", "203", "81", "0412", "", "", "50.23271", "12.87117", "Europe/Prague"),
("3074020", "Kadan", "", "CZ", "203", "89", "", "", "", "50.38333", "13.26667", "Europe/Prague"),
("3074039", "Kadan", "Кадань", "CZ", "203", "89", "0422", "", "", "50.37598", "13.27131", "Europe/Prague"),
("3074110", "Jirkov", "Йирков", "CZ", "203", "89", "", "", "", "50.49979", "13.44769", "Europe/Prague"),
("3074149", "Jindrichuv Hradec", "Йиндржихув-Градец", "CZ", "203", "79", "0313", "", "", "49.14404", "15.00301", "Europe/Prague"),
("3074199", "Jihlava", "Йиглава", "CZ", "203", "80", "0612", "", "", "49.3961", "15.59124", "Europe/Prague"),
("3074204", "Jicin", "Йичин", "CZ", "203", "82", "0522", "", "", "50.43723", "15.35162", "Europe/Prague"),
("3074603", "Jablonec nad Nisou", "Яблонец", "CZ", "203", "83", "0512", "", "", "50.72431", "15.17108", "Europe/Prague"),
("3074893", "Hranice", "Границе", "CZ", "203", "84", "0714", "", "", "49.54796", "17.73469", "Europe/Prague"),
("3074967", "Hradec Kralove", "Градец Кралове", "CZ", "203", "82", "0521", "", "", "50.20923", "15.83277", "Europe/Prague"),
("3075654", "Hodonin", "Годонин", "CZ", "203", "78", "", "", "", "48.84893", "17.13244", "Europe/Prague"),
("3075919", "Havlickuv Brod", "Гавличкув-Брод", "CZ", "203", "80", "0611", "", "", "49.60785", "15.58069", "Europe/Prague"),
("3075921", "Havirov", "Гавиржов", "CZ", "203", "85", "", "", "", "49.77984", "18.43688", "Europe/Prague"),
("3076127", "Frydek-Mistek", "Мистек", "CZ", "203", "85", "0802", "", "", "49.68333", "18.35", "Europe/Prague"),
("3077244", "Decin", "Дечин", "CZ", "203", "89", "0421", "", "", "50.78215", "14.21478", "Europe/Prague"),
("3077539", "Chrudim", "Хрудим", "CZ", "203", "86", "0531", "", "", "49.95109", "15.79558", "Europe/Prague"),
("3077685", "Chomutov", "Хомутов", "CZ", "203", "89", "0422", "", "", "50.46048", "13.41779", "Europe/Prague"),
("3077835", "Cheb", "Хеб", "CZ", "203", "81", "0411", "", "", "50.07963", "12.37392", "Europe/Prague"),
("3077882", "Cesky Tesin", "Чески-Тешин", "CZ", "203", "85", "", "", "", "49.74613", "18.62613", "Europe/Prague"),
("3077916", "Ceske Budejovice", "Ческе-Будеёвице", "CZ", "203", "79", "0311", "", "", "48.97447", "14.47434", "Europe/Prague"),
("3077920", "Ceska Trebova", "Ческа-Тршебова", "CZ", "203", "86", "", "", "", "49.90436", "16.44413", "Europe/Prague"),
("3077929", "Ceska Lipa", "Ческа-Липа", "CZ", "203", "83", "0511", "", "", "50.68551", "14.53764", "Europe/Prague"),
("3078545", "Bruntal", "", "CZ", "203", "85", "0801", "", "", "49.98844", "17.4647", "Europe/Prague"),
("3078610", "Brno", "Брно", "CZ", "203", "78", "0622", "", "", "49.19522", "16.60796", "Europe/Prague"),
("3078773", "Breclav", "Бржецлав", "CZ", "203", "78", "0624", "", "", "48.75897", "16.88203", "Europe/Prague"),
("3078833", "Branik", "", "CZ", "203", "52", "", "", "", "50.03597", "14.41235", "Europe/Prague"),
("3078837", "Brandys nad Labem-Stara Boleslav", "", "CZ", "203", "88", "", "", "", "50.18709", "14.66326", "Europe/Prague"),
("3079129", "Bohumin", "Богумин", "CZ", "203", "85", "", "", "", "49.90411", "18.35755", "Europe/Prague"),
("3079273", "Blansko", "Бланско", "CZ", "203", "78", "0621", "", "", "49.36304", "16.64446", "Europe/Prague"),
("3079346", "Bilina Kyselka", "", "CZ", "203", "89", "", "", "", "50.55", "13.76667", "Europe/Prague"),
("3079348", "Bilina", "Билина", "CZ", "203", "89", "", "", "", "50.54854", "13.77535", "Europe/Prague"),
("3079467", "Beroun", "Бероун", "CZ", "203", "88", "0202", "", "", "49.96382", "14.072", "Europe/Prague"),
("3079508", "Benesov", "Бенешов", "CZ", "203", "88", "0201", "", "", "49.78162", "14.68697", "Europe/Prague"),
("6269470", "Cerny Most", "", "CZ", "203", "52", "", "", "", "50.10475", "14.57974", "Europe/Prague"),
("2803560", "Zwickau", "Цвиккау", "DE", "276", "13", "00", "14524", "", "50.72724", "12.48839", "Europe/Berlin"),
("2803620", "Zweibrucken", "Цвайбрюккен", "DE", "276", "08", "00", "07320", "", "49.24686", "7.36977", "Europe/Berlin"),
("2803723", "Zulpich", "Цюльпих", "DE", "276", "07", "", "", "", "50.69447", "6.65414", "Europe/Berlin"),
("2803870", "Zossen", "Цоссен", "DE", "276", "11", "", "", "", "52.216", "13.44909", "Europe/Berlin"),
("2804008", "Zittau", "Циттау", "DE", "276", "13", "00", "", "", "50.89772", "14.80764", "Europe/Berlin"),
("2804034", "Zirndorf", "Цирндорф", "DE", "276", "02", "095", "09573", "09573134", "49.4424", "10.95414", "Europe/Berlin"),
("2804748", "Zerbst", "Цербст", "DE", "276", "14", "", "", "", "51.9662", "12.08517", "Europe/Berlin"),
("2804922", "Zeitz", "Цайц", "DE", "276", "14", "", "", "", "51.04962", "12.1369", "Europe/Berlin"),
("2805059", "Zehlendorf Bezirk", "Целендорф", "DE", "276", "16", "00", "11000", "11000000", "52.43333", "13.25", "Europe/Berlin"),
("2805385", "Xanten", "Ксантен", "DE", "276", "07", "051", "", "", "51.65877", "6.45297", "Europe/Berlin"),
("2805597", "Wurzen", "Вурцен", "DE", "276", "13", "00", "", "", "51.3707", "12.73938", "Europe/Berlin"),
("2805615", "Wuerzburg", "Вюрцбург", "DE", "276", "02", "096", "09663", "09663000", "49.79391", "9.95121", "Europe/Berlin"),
("2805644", "Wurselen", "Вюрзелен", "DE", "276", "07", "053", "", "", "50.81809", "6.1347", "Europe/Berlin"),
("2805753", "Wuppertal", "Вупперталь", "DE", "276", "07", "051", "05124", "", "51.27027", "7.16755", "Europe/Berlin"),
("2805761", "Wunstorf", "Вунсторф", "DE", "276", "06", "", "", "", "52.42376", "9.43585", "Europe/Berlin"),
("2805910", "Wulfrath", "Вюльфрат", "DE", "276", "07", "", "", "", "51.28195", "7.03821", "Europe/Berlin"),
("2806081", "Worth am Rhein", "Вёрт-на-Рейне", "DE", "276", "08", "", "", "", "49.04888", "8.25959", "Europe/Berlin"),
("2806142", "Worms", "Вормс", "DE", "276", "08", "00", "07319", "", "49.63278", "8.35916", "Europe/Berlin"),
("2806654", "Wolfsburg", "Вольфсбург", "DE", "276", "06", "00", "03103", "", "52.42452", "10.7815", "Europe/Berlin"),
("2806768", "Wolfratshausen", "Вольфратсхаузен", "DE", "276", "02", "091", "09173", "09173147", "47.91289", "11.42166", "Europe/Berlin"),
("2806914", "Wolfenbuettel", "Вольфенбюттель", "DE", "276", "06", "00", "03158", "", "52.16442", "10.54095", "Europe/Berlin"),
("2806919", "Wolfen", "Вольфен", "DE", "276", "14", "", "", "", "51.66122", "12.26873", "Europe/Berlin"),
("2807184", "Witzenhausen", "Витценхаузен", "DE", "276", "05", "", "", "", "51.34103", "9.8554", "Europe/Berlin"),
("2807201", "Wittstock", "", "DE", "276", "11", "", "", "", "53.16118", "12.48287", "Europe/Berlin"),
("2807218", "Wittmund", "Витмунд", "DE", "276", "06", "00", "03462", "", "53.57674", "7.77839", "Europe/Berlin"),
("2807240", "Wittlich", "Виттлих", "DE", "276", "08", "00", "07231", "", "49.98596", "6.89308", "Europe/Berlin"),
("2807344", "Wittenberge", "Виттенберге", "DE", "276", "11", "", "", "", "53.00543", "11.75032", "Europe/Berlin"),
("2807360", "Wittenau", "", "DE", "276", "16", "00", "11000", "11000000", "52.59319", "13.32127", "Europe/Berlin"),
("2807363", "Witten", "Виттен", "DE", "276", "07", "", "", "", "51.44362", "7.35258", "Europe/Berlin"),
("2807465", "Wismar", "Висмар", "DE", "276", "12", "00", "13074", "", "53.89314", "11.45286", "Europe/Berlin"),
("2807594", "Wipperfurth", "Випперфюрт", "DE", "276", "07", "", "", "", "51.1161", "7.39865", "Europe/Berlin"),
("2807748", "Winterhude", "", "DE", "276", "04", "", "", "", "53.6", "10", "Europe/Berlin"),
("2807845", "Winsen", "", "DE", "276", "06", "00", "03353", "", "53.35753", "10.21282", "Europe/Berlin"),
("2807872", "Winnenden", "Винненден", "DE", "276", "01", "081", "08119", "08119085", "48.87563", "9.39819", "Europe/Berlin"),
("2808461", "Wilnsdorf", "Вильнсдорф", "DE", "276", "07", "059", "05970", "05970044", "50.81667", "8.1", "Europe/Berlin"),
("2808473", "Wilmersdorf Bezirk", "Вильмерсдорф", "DE", "276", "16", "00", "11000", "11000000", "52.48333", "13.31667", "Europe/Berlin"),
("2808559", "Willich", "Виллих", "DE", "276", "07", "051", "", "", "51.26371", "6.54734", "Europe/Berlin"),
("2808662", "Wilhelmstadt", "", "DE", "276", "16", "00", "11000", "11000000", "52.52462", "13.17707", "Europe/Berlin"),
("2808720", "Wilhelmshaven", "Вильгельмсхафен", "DE", "276", "06", "00", "03405", "", "53.52998", "8.11253", "Europe/Berlin"),
("2808893", "Wildeshausen", "Вильдесхаузен", "DE", "276", "06", "00", "03458", "", "52.89446", "8.43375", "Europe/Berlin"),
("2809138", "Wiesloch", "Вислох", "DE", "276", "01", "082", "08226", "08226098", "49.29504", "8.69846", "Europe/Berlin"),
("2809346", "Wiesbaden", "Висбаден", "DE", "276", "05", "064", "", "", "50.08258", "8.24932", "Europe/Berlin"),
("2809517", "Wiehl", "Виль", "DE", "276", "07", "", "", "", "50.9495", "7.55062", "Europe/Berlin"),
("2809889", "Wetzlar", "Вецлар", "DE", "276", "05", "065", "06532", "", "50.56109", "8.50495", "Europe/Berlin"),
("2809984", "Wetter (Ruhr)", "", "DE", "276", "07", "", "", "", "51.38747", "7.39277", "Europe/Berlin"),
("2810188", "Westerstede", "Вестерстеде", "DE", "276", "06", "00", "03451", "", "53.25682", "7.92737", "Europe/Berlin"),
("2810538", "Westend", "", "DE", "276", "16", "00", "11000", "11000000", "52.51708", "13.27636", "Europe/Berlin"),
("2810612", "Wesseling", "Весселинг", "DE", "276", "07", "", "", "", "50.82709", "6.9747", "Europe/Berlin"),
("2810678", "Wesel", "Везель", "DE", "276", "07", "051", "05170", "", "51.6669", "6.62037", "Europe/Berlin"),
("2810716", "Wertheim", "", "DE", "276", "01", "081", "08128", "08128131", "49.759", "9.50852", "Europe/Berlin"),
("2810808", "Wernigerode", "Вернигероде", "DE", "276", "14", "", "", "", "51.83652", "10.78216", "Europe/Berlin"),
("2810833", "Werne", "Верне", "DE", "276", "07", "", "", "", "51.66446", "7.63421", "Europe/Berlin"),
("2810855", "Wermelskirchen", "Вермельскирхен", "DE", "276", "07", "", "", "", "51.1397", "7.21583", "Europe/Berlin"),
("2810878", "Werl", "Верль", "DE", "276", "07", "059", "05974", "", "51.55493", "7.91403", "Europe/Berlin"),
("2810919", "Werdohl", "Вердоль", "DE", "276", "07", "", "", "", "51.26011", "7.76608", "Europe/Berlin"),
("2810945", "Werder", "Вердер", "DE", "276", "11", "00", "", "", "52.37874", "12.934", "Europe/Berlin"),
("2810969", "Werdau", "Вердау", "DE", "276", "13", "", "", "", "50.73604", "12.37534", "Europe/Berlin"),
("2811204", "Wendlingen am Neckar", "Вендлинген-на-Неккаре", "DE", "276", "01", "081", "08116", "08116071", "48.67124", "9.37632", "Europe/Berlin"),
("2811278", "Wenden", "Венден", "DE", "276", "07", "059", "05966", "05966028", "50.96667", "7.86667", "Europe/Berlin"),
("2811292", "Wendelstein", "", "DE", "276", "02", "095", "09576", "09576151", "49.3523", "11.15069", "Europe/Berlin"),
("2811644", "Weiterstadt", "Вайтерштадт", "DE", "276", "05", "", "", "", "49.9039", "8.58874", "Europe/Berlin"),
("2811698", "Weisswasser", "Вайсвассер", "DE", "276", "13", "", "", "", "51.50403", "14.64017", "Europe/Berlin"),
("2811899", "Weissenfels", "Вайсенфельс", "DE", "276", "14", "", "", "", "51.20148", "11.96843", "Europe/Berlin"),
("2811909", "Weissenburg in Bayern", "Вайсенбург", "DE", "276", "02", "095", "09577", "09577177", "49.03095", "10.97221", "Europe/Berlin"),
("2812145", "Weinstadt-Endersbach", "", "DE", "276", "01", "081", "08119", "08119091", "48.81311", "9.36387", "Europe/Berlin"),
("2812174", "Weinheim", "Вайнхайм", "DE", "276", "01", "082", "08226", "08226096", "49.54887", "8.66697", "Europe/Berlin"),
("2812204", "Weingarten", "Вайнгартен", "DE", "276", "01", "084", "08436", "08436082", "47.81009", "9.63863", "Europe/Berlin"),
("2812482", "Weimar", "Веймар", "DE", "276", "15", "00", "16055", "", "50.9803", "11.32903", "Europe/Berlin"),
("2812515", "Weilheim", "Вайльхайм", "DE", "276", "02", "091", "09190", "09190157", "47.84147", "11.15484", "Europe/Berlin"),
("2812522", "Weilerswist", "Вайлерсвист", "DE", "276", "07", "053", "05366", "05366040", "50.76667", "6.83333", "Europe/Berlin"),
("2812625", "Weil der Stadt", "Вайль-дер-Штадт", "DE", "276", "01", "081", "08115", "08115050", "48.74953", "8.87176", "Europe/Berlin"),
("2812636", "Weil am Rhein", "Вайль-на-Рейне", "DE", "276", "01", "083", "08336", "08336091", "47.59331", "7.62082", "Europe/Berlin"),
("2813040", "Weiden", "Вайден", "DE", "276", "02", "093", "09363", "09363000", "49.67682", "12.15613", "Europe/Berlin"),
("2813187", "Weissensee", "Вайсензее", "DE", "276", "16", "00", "11000", "11000000", "52.55632", "13.46649", "Europe/Berlin"),
("2813390", "Wegberg", "Вегберг", "DE", "276", "07", "", "", "", "51.14221", "6.28436", "Europe/Berlin"),
("2813433", "Weener", "Венер", "DE", "276", "06", "", "", "", "53.16332", "7.35052", "Europe/Berlin"),
("2813464", "Wedel", "Ведель", "DE", "276", "10", "", "", "", "53.58374", "9.69835", "Europe/Berlin"),
("2813472", "Wedding Bezirk", "", "DE", "276", "16", "00", "11000", "11000000", "52.54734", "13.35594", "Europe/Berlin"),
("2813786", "Wassenberg", "Вассенберг", "DE", "276", "07", "053", "", "", "51.10009", "6.15484", "Europe/Berlin"),
("2814005", "Warstein", "Варштайн", "DE", "276", "07", "", "", "", "51.44488", "8.34851", "Europe/Berlin"),
("2814127", "Warendorf", "Варендорф", "DE", "276", "07", "055", "05570", "", "51.95109", "7.98756", "Europe/Berlin"),
("2814131", "Waren", "Варен", "DE", "276", "12", "", "", "", "53.5204", "12.67985", "Europe/Berlin"),
("2814146", "Wardenburg", "Варденбург", "DE", "276", "06", "00", "03458", "03458013", "53.06667", "8.2", "Europe/Berlin"),
("2814153", "Warburg", "Варбург", "DE", "276", "07", "", "", "", "51.49011", "9.14641", "Europe/Berlin"),
("2814270", "Wangen im Allgau", "Ванген-им-Алльгой", "DE", "276", "01", "084", "08436", "08436081", "47.6895", "9.83247", "Europe/Berlin"),
("2814305", "Wandlitz", "Вандлиц", "DE", "276", "11", "00", "12060", "12060269", "52.74196", "13.45799", "Europe/Berlin"),
("2814362", "Waltrop", "Вальтроп", "DE", "276", "07", "", "", "", "51.62125", "7.40238", "Europe/Berlin"),
("2814462", "Walsrode", "Вальсроде", "DE", "276", "06", "", "", "", "52.86147", "9.5926", "Europe/Berlin"),
("2814632", "Wallenhorst", "Валленхорст", "DE", "276", "06", "00", "03459", "03459033", "52.35", "8.01667", "Europe/Berlin"),
("2814791", "Waldshut-Tiengen", "Вальдсхут-Тинген", "DE", "276", "01", "083", "08337", "08337126", "47.62323", "8.21717", "Europe/Berlin"),
("2814874", "Waldkraiburg", "Вальдкрайбург", "DE", "276", "02", "091", "09183", "09183148", "48.20854", "12.39893", "Europe/Berlin"),
("2814883", "Waldkirch", "Вальдкирх", "DE", "276", "01", "083", "08316", "08316056", "48.09585", "7.96371", "Europe/Berlin"),
("2815137", "Waldbrol", "Вальдбрёль", "DE", "276", "07", "", "", "", "50.87576", "7.61688", "Europe/Berlin"),
("2815330", "Waiblingen", "Вайблинген", "DE", "276", "01", "081", "08119", "08119079", "48.83241", "9.31641", "Europe/Berlin"),
("2815487", "Waghausel", "Вагхойзель", "DE", "276", "01", "082", "08215", "08215106", "49.24991", "8.51257", "Europe/Berlin"),
("2815559", "Wadgassen", "", "DE", "276", "09", "00", "10044", "10044120", "49.26667", "6.78333", "Europe/Berlin"),
("2815565", "Wadern", "Вадерн", "DE", "276", "09", "", "", "", "49.54122", "6.88774", "Europe/Berlin"),
("2815678", "Wachtberg", "Вахтберг", "DE", "276", "07", "053", "05382", "05382072", "50.63333", "7.1", "Europe/Berlin"),
("2815824", "Vreden", "Фреден", "DE", "276", "07", "055", "", "", "52.03792", "6.828", "Europe/Berlin"),
("2816630", "Volklingen", "Фёльклинген", "DE", "276", "09", "", "", "", "49.25162", "6.85873", "Europe/Berlin"),
("2817065", "Voerde", "Ферде", "DE", "276", "07", "051", "", "", "51.59703", "6.6863", "Europe/Berlin"),
("2817105", "Vlotho", "Флото", "DE", "276", "07", "057", "", "", "52.1653", "8.85996", "Europe/Berlin"),
("2817202", "Vilshofen", "", "DE", "276", "02", "092", "09275", "09275154", "48.62695", "13.19222", "Europe/Berlin"),
("2817220", "Villingen-Schwenningen", "Виллинген-Швеннинген", "DE", "276", "01", "083", "08326", "08326074", "48.06226", "8.49358", "Europe/Berlin"),
("2817311", "Viersen", "Фирзен", "DE", "276", "07", "051", "05166", "", "51.25435", "6.39441", "Europe/Berlin"),
("2817324", "Viernheim", "Фирнхайм", "DE", "276", "05", "", "", "", "49.54033", "8.5782", "Europe/Berlin"),
("2817537", "Versmold", "Ферсмольд", "DE", "276", "07", "", "", "", "52.04009", "8.15272", "Europe/Berlin"),
("2817576", "Verl", "Ферль", "DE", "276", "07", "057", "05754", "05754044", "51.88333", "8.51667", "Europe/Berlin"),
("2817599", "Verden", "Ферден", "DE", "276", "06", "00", "03361", "", "52.92342", "9.23491", "Europe/Berlin"),
("2817724", "Velbert", "Фельберт", "DE", "276", "07", "051", "", "", "51.33536", "7.04348", "Europe/Berlin"),
("2817812", "Vechta", "Фехта", "DE", "276", "06", "00", "03460", "", "52.72632", "8.28598", "Europe/Berlin"),
("2817813", "Vechelde", "Фехельде", "DE", "276", "06", "00", "03157", "03157007", "52.26038", "10.36491", "Europe/Berlin"),
("2817818", "Vaterstetten", "Фатерштеттен", "DE", "276", "02", "091", "09175", "09175132", "48.10537", "11.76825", "Europe/Berlin"),
("2817873", "Varel", "", "DE", "276", "06", "00", "03455", "03455026", "53.39693", "8.13621", "Europe/Berlin"),
("2817927", "Vaihingen an der Enz", "Файхинген-на-Энце", "DE", "276", "01", "081", "08118", "08118073", "48.93563", "8.96045", "Europe/Berlin"),
("2818067", "Uetersen", "Итерзен", "DE", "276", "10", "", "", "", "53.68769", "9.66394", "Europe/Berlin"),
("2818094", "Uslar", "Услар", "DE", "276", "06", "", "", "", "51.6569", "9.63501", "Europe/Berlin"),
("2818766", "Unterschleissheim", "Унтершлайсхайм", "DE", "276", "02", "091", "09184", "09184149", "48.28038", "11.57684", "Europe/Berlin"),
("2819465", "Unterhaching", "Унтерхахинг", "DE", "276", "02", "091", "09184", "09184148", "48.06598", "11.61564", "Europe/Berlin"),
("2819974", "Unterkrozingen", "", "DE", "276", "01", "083", "08315", "08315006", "47.91933", "7.69045", "Europe/Berlin"),
("2820087", "Unna", "Унна", "DE", "276", "07", "059", "05978", "", "51.53794", "7.68969", "Europe/Berlin"),
("2820256", "Ulm", "Ульм", "DE", "276", "01", "084", "08425", "", "48.39841", "9.99155", "Europe/Berlin"),
("2820456", "Uelzen", "Ильцен", "DE", "276", "06", "00", "03360", "", "52.96572", "10.56111", "Europe/Berlin"),
("2820577", "Uberlingen", "Иберлинген", "DE", "276", "01", "084", "08435", "08435059", "47.76977", "9.17136", "Europe/Berlin"),
("2820621", "Ubach-Palenberg", "Ибах-Паленберг", "DE", "276", "07", "053", "05370", "05370028", "50.93333", "6.11667", "Europe/Berlin"),
("2820693", "Tuttlingen", "Тутлинген", "DE", "276", "01", "083", "08327", "08327050", "47.98464", "8.8177", "Europe/Berlin"),
("2820860", "Tuebingen", "Тюбинген", "DE", "276", "01", "084", "08416", "08416041", "48.52266", "9.05222", "Europe/Berlin"),
("2820973", "Trossingen", "Троссинген", "DE", "276", "01", "083", "08327", "08327049", "48.07667", "8.64409", "Europe/Berlin"),
("2821029", "Troisdorf", "Тройсдорф", "DE", "276", "07", "053", "", "", "50.80901", "7.14968", "Europe/Berlin"),
("2821164", "Trier", "Трир", "DE", "276", "08", "00", "07211", "07211000", "49.75565", "6.63935", "Europe/Berlin"),
("2821515", "Traunstein", "Траунштайн", "DE", "276", "02", "091", "09189", "09189155", "47.86825", "12.64335", "Europe/Berlin"),
("2821517", "Traunreut", "Траунройт", "DE", "276", "02", "091", "09189", "09189154", "47.96269", "12.59231", "Europe/Berlin"),
("2821807", "Torgau", "Торгау", "DE", "276", "13", "00", "14730", "", "51.56016", "12.99617", "Europe/Berlin"),
("2821899", "Tonisvorst", "Тёнисфорст", "DE", "276", "07", "", "", "", "51.32092", "6.49412", "Europe/Berlin"),
("2823368", "Tettnang", "", "DE", "276", "01", "084", "08435", "08435057", "47.66857", "9.59132", "Europe/Berlin"),
("2823533", "Templin", "Темплин", "DE", "276", "11", "", "", "", "53.11865", "13.5022", "Europe/Berlin"),
("2823538", "Tempelhof Bezirk", "Темпельхоф", "DE", "276", "16", "00", "11000", "11000000", "52.46667", "13.4", "Europe/Berlin"),
("2823567", "Teltow", "Тельтов", "DE", "276", "11", "", "", "", "52.4031", "13.26014", "Europe/Berlin"),
("2823590", "Telgte", "Тельгте", "DE", "276", "07", "055", "", "", "51.97995", "7.78293", "Europe/Berlin"),
("2823708", "Tegel", "Тегель", "DE", "276", "16", "00", "11000", "11000000", "52.57601", "13.29389", "Europe/Berlin"),
("2823799", "Taunusstein", "Таунусштайн", "DE", "276", "05", "", "", "", "50.14993", "8.15206", "Europe/Berlin"),
("2823812", "Taufkirchen", "", "DE", "276", "02", "091", "09184", "09184145", "48.0486", "11.61701", "Europe/Berlin"),
("2824461", "Syke", "Зике", "DE", "276", "06", "", "", "", "52.91345", "8.82209", "Europe/Berlin"),
("2824655", "Sundern", "Зундерн", "DE", "276", "07", "059", "", "", "51.3281", "8.00369", "Europe/Berlin"),
("2824801", "Sulzbach-Rosenberg", "Зульцбах-Розенберг", "DE", "276", "02", "093", "09371", "09371151", "49.50126", "11.74598", "Europe/Berlin"),
("2824841", "Sulzbach", "Зульцбах", "DE", "276", "09", "", "", "", "49.29882", "7.05696", "Europe/Berlin"),
("2824948", "Suhl", "Зуль", "DE", "276", "15", "00", "16054", "", "50.60911", "10.69401", "Europe/Berlin"),
("2825297", "Stuttgart", "Штутгарт", "DE", "276", "01", "081", "08111", "08111000", "48.78232", "9.17702", "Europe/Berlin"),
("2825422", "Stuhr", "", "DE", "276", "06", "00", "03251", "03251037", "53.03333", "8.75", "Europe/Berlin"),
("2826082", "Strausberg", "Штраусберг", "DE", "276", "11", "", "", "", "52.57859", "13.88741", "Europe/Berlin"),
("2826099", "Straubing", "Штраубинг", "DE", "276", "02", "092", "09263", "09263000", "48.88126", "12.57385", "Europe/Berlin"),
("2826287", "Stralsund", "Штральзунд", "DE", "276", "12", "00", "13073", "", "54.30911", "13.0818", "Europe/Berlin"),
("2826304", "Straelen", "Штрален", "DE", "276", "07", "", "", "", "51.4419", "6.26639", "Europe/Berlin"),
("2826595", "Stolberg", "Штольберг", "DE", "276", "07", "", "", "", "50.77368", "6.22595", "Europe/Berlin"),
("2826861", "Stockelsdorf", "", "DE", "276", "10", "00", "01055", "01055040", "53.8922", "10.64713", "Europe/Berlin"),
("2826909", "Stockach", "Штоках", "DE", "276", "01", "083", "08335", "08335079", "47.85105", "9.0091", "Europe/Berlin"),
("2827479", "Stendal", "Стендаль", "DE", "276", "14", "00", "15090", "", "52.6069", "11.85867", "Europe/Berlin"),
("2827552", "Stellingen", "", "DE", "276", "04", "", "", "", "53.5922", "9.9287", "Europe/Berlin"),
("2828050", "Steinhagen", "", "DE", "276", "07", "057", "05754", "05754040", "52", "8.4", "Europe/Berlin"),
("2828105", "Steinfurt", "Штайнфурт", "DE", "276", "07", "055", "05566", "", "52.15045", "7.33664", "Europe/Berlin"),
("2828994", "Steilshoop", "", "DE", "276", "04", "", "", "", "53.61028", "10.05917", "Europe/Berlin"),
("2829109", "Steglitz Bezirk", "Штеглиц", "DE", "276", "16", "00", "11000", "11000000", "52.45606", "13.332", "Europe/Berlin"),
("2829422", "Stassfurt", "Штасфурт", "DE", "276", "14", "", "", "", "51.85186", "11.58508", "Europe/Berlin"),
("2829457", "Starnberg", "Штарнберг", "DE", "276", "02", "091", "09188", "09188139", "48.00193", "11.34416", "Europe/Berlin"),
("2829758", "Stadtlohn", "Штадтлон", "DE", "276", "07", "", "", "", "51.99399", "6.91918", "Europe/Berlin"),
("2829777", "Stadthagen", "Штадтхаген", "DE", "276", "06", "00", "03257", "", "52.32333", "9.20311", "Europe/Berlin"),
("2829804", "Stadtallendorf", "Штадталлендорф", "DE", "276", "05", "", "", "", "50.82261", "9.01294", "Europe/Berlin"),
("2829901", "Stade", "Штаде", "DE", "276", "06", "00", "03359", "", "53.59337", "9.47629", "Europe/Berlin"),
("2829962", "Staaken", "", "DE", "276", "16", "00", "11000", "11000000", "52.53661", "13.15056", "Europe/Berlin"),
("2829998", "Sprockhovel", "Шпрокхёфель", "DE", "276", "07", "", "", "", "51.34669", "7.24343", "Europe/Berlin"),
("2830035", "Springe", "Шпринге", "DE", "276", "06", "", "", "", "52.20845", "9.55416", "Europe/Berlin"),
("2830582", "Speyer", "Шпайер", "DE", "276", "08", "00", "07318", "", "49.32083", "8.43111", "Europe/Berlin"),
("2830637", "Spenge", "", "DE", "276", "07", "", "", "", "52.14021", "8.48475", "Europe/Berlin"),
("2831088", "Sonthofen", "Зонтхофен", "DE", "276", "02", "097", "09780", "09780139", "47.51821", "10.28262", "Europe/Berlin"),
("2831250", "Sonneberg", "Зоннеберг", "DE", "276", "15", "00", "16072", "", "50.3592", "11.17463", "Europe/Berlin"),
("2831276", "Sondershausen", "Зондерсхаузен", "DE", "276", "15", "00", "16065", "", "51.36973", "10.87011", "Europe/Berlin"),
("2831403", "Soemmerda", "Зёммерда", "DE", "276", "15", "00", "16068", "", "51.15914", "11.11524", "Europe/Berlin"),
("2831486", "Soltau", "Зольтау", "DE", "276", "06", "", "", "", "52.98638", "9.84338", "Europe/Berlin"),
("2831580", "Solingen", "Золинген", "DE", "276", "07", "051", "05122", "", "51.17343", "7.0845", "Europe/Berlin"),
("2831708", "Soest", "Зоест", "DE", "276", "07", "059", "05974", "", "51.57558", "8.10619", "Europe/Berlin"),
("2831852", "Sinzig", "Зинциг", "DE", "276", "08", "", "", "", "50.54384", "7.24639", "Europe/Berlin"),
("2831872", "Sinsheim", "Зинсхайм", "DE", "276", "01", "082", "08226", "08226085", "49.2529", "8.87867", "Europe/Berlin"),
("2831924", "Singen", "Зинген", "DE", "276", "01", "083", "08335", "08335075", "47.75935", "8.8403", "Europe/Berlin"),
("2831948", "Sindelfingen", "Зиндельфинген", "DE", "276", "01", "081", "08115", "08115045", "48.7", "9.01667", "Europe/Berlin"),
("2832023", "Simmerath", "Зиммерат", "DE", "276", "07", "053", "05334", "05334028", "50.6", "6.3", "Europe/Berlin"),
("2832232", "Sigmaringen", "Зигмаринген", "DE", "276", "01", "084", "08437", "08437104", "48.08829", "9.23033", "Europe/Berlin"),
("2832495", "Siegen", "Зиген", "DE", "276", "07", "059", "05970", "", "50.87482", "8.02431", "Europe/Berlin"),
("2832521", "Siegburg", "Зигбург", "DE", "276", "07", "053", "05382", "", "50.80019", "7.20769", "Europe/Berlin"),
("2833073", "Senftenberg", "Зенфтенберг", "DE", "276", "11", "00", "12066", "", "51.52517", "14.00164", "Europe/Berlin"),
("2833079", "Senden", "", "DE", "276", "07", "055", "05558", "05558044", "51.85", "7.5", "Europe/Berlin"),
("2833080", "Senden", "", "DE", "276", "02", "097", "09775", "09775152", "48.32441", "10.04442", "Europe/Berlin"),
("2833170", "Selm", "Зельм", "DE", "276", "07", "", "", "", "51.69689", "7.46809", "Europe/Berlin"),
("2833242", "Seligenstadt", "Зелигенштадт", "DE", "276", "05", "064", "", "", "50.0432", "8.97394", "Europe/Berlin"),
("2833296", "Selb", "Зельб", "DE", "276", "02", "094", "09479", "09479152", "50.17058", "12.13054", "Europe/Berlin"),
("2833475", "Sehnde", "Зенде", "DE", "276", "06", "00", "", "", "52.31394", "9.9682", "Europe/Berlin"),
("2833564", "Seevetal", "Зеветаль", "DE", "276", "06", "00", "03353", "03353031", "53.4", "9.96667", "Europe/Berlin"),
("2833592", "Seesen", "Зезен", "DE", "276", "06", "", "", "", "51.89096", "10.17847", "Europe/Berlin"),
("2833641", "Seelze", "Зельце", "DE", "276", "06", "", "", "", "52.39635", "9.59727", "Europe/Berlin"),
("2834240", "Schwetzingen", "Шветцинген", "DE", "276", "01", "082", "08226", "08226084", "49.38217", "8.5823", "Europe/Berlin"),
("2834265", "Schwerte", "Шверте", "DE", "276", "07", "", "", "", "51.44387", "7.5675", "Europe/Berlin"),
("2834282", "Schwerin", "Шверин", "DE", "276", "12", "", "", "", "53.62937", "11.41316", "Europe/Berlin"),
("2834372", "Schwelm", "Швельм", "DE", "276", "07", "059", "05954", "", "51.28635", "7.29388", "Europe/Berlin"),
("2834498", "Schweinfurt", "Швайнфурт", "DE", "276", "02", "096", "09662", "09662000", "50.04937", "10.22175", "Europe/Berlin"),
("2834629", "Schwedt (Oder)", "", "DE", "276", "11", "", "", "", "53.05963", "14.28154", "Europe/Berlin"),
("2834978", "Schwarzenberg", "Шварценберг", "DE", "276", "13", "00", "", "", "50.53791", "12.78522", "Europe/Berlin"),
("2835260", "Schwanewede", "Шваневеде", "DE", "276", "06", "00", "03356", "03356009", "53.23333", "8.6", "Europe/Berlin"),
("2835297", "Schwandorf in Bayern", "", "DE", "276", "02", "093", "09376", "09376161", "49.32534", "12.1098", "Europe/Berlin"),
("2835342", "Schwalmtal", "", "DE", "276", "07", "051", "05166", "05166024", "51.21667", "6.26667", "Europe/Berlin"),
("2835345", "Schwalmstadt", "Швальмштадт", "DE", "276", "05", "", "", "", "50.93333", "9.21667", "Europe/Berlin"),
("2835382", "Schwalbach", "", "DE", "276", "09", "00", "10044", "10044118", "49.3", "6.81667", "Europe/Berlin"),
("2835481", "Schwaebisch Hall", "", "DE", "276", "01", "081", "08127", "08127076", "49.11127", "9.73908", "Europe/Berlin"),
("2835482", "Schwabisch Gmund", "Швебиш-Гмюнд", "DE", "276", "01", "081", "08136", "08136065", "48.79947", "9.79809", "Europe/Berlin"),
("2835537", "Schwabach", "Швабах", "DE", "276", "02", "095", "09565", "09565000", "49.33047", "11.02346", "Europe/Berlin"),
("2836084", "Schrobenhausen", "Шробенхаузен", "DE", "276", "02", "091", "09185", "09185158", "48.56067", "11.26071", "Europe/Berlin"),
("2836203", "Schramberg", "Шрамберг", "DE", "276", "01", "083", "08325", "08325053", "48.22399", "8.38583", "Europe/Berlin"),
("2836282", "Schortens", "", "DE", "276", "06", "00", "03455", "03455015", "53.53333", "7.95", "Europe/Berlin"),
("2836320", "Schorndorf", "Шорндорф", "DE", "276", "01", "081", "08119", "08119067", "48.80537", "9.52721", "Europe/Berlin"),
("2836413", "Schopfheim", "Шопфхайм", "DE", "276", "01", "083", "08336", "08336081", "47.65105", "7.82089", "Europe/Berlin"),
("2836788", "Schoneberg Bezirk", "", "DE", "276", "16", "00", "11000", "11000000", "52.46667", "13.35", "Europe/Berlin"),
("2836809", "Schonebeck", "Шёнебек", "DE", "276", "14", "", "", "", "52.01682", "11.7307", "Europe/Berlin"),
("2837291", "Schneverdingen", "Шнефердинген", "DE", "276", "06", "", "", "", "53.11685", "9.79524", "Europe/Berlin"),
("2837470", "Schneeberg", "Шнеберг", "DE", "276", "13", "", "", "", "50.59465", "12.64139", "Europe/Berlin"),
("2837954", "Schmelz", "", "DE", "276", "09", "00", "10044", "10044117", "49.43333", "6.85", "Europe/Berlin"),
("2838009", "Schmargendorf", "", "DE", "276", "16", "00", "11000", "11000000", "52.47517", "13.29071", "Europe/Berlin"),
("2838053", "Schmallenberg", "Шмалленберг", "DE", "276", "07", "059", "", "", "51.15473", "8.28505", "Europe/Berlin"),
("2838059", "Schmalkalden", "Шмалькальден", "DE", "276", "15", "", "", "", "50.72136", "10.44386", "Europe/Berlin"),
("2838201", "Schluchtern", "Шлюхтерн", "DE", "276", "05", "064", "", "", "50.34891", "9.52532", "Europe/Berlin"),
("2838634", "Schleswig", "Шлезвиг", "DE", "276", "10", "00", "01059", "", "54.52156", "9.5586", "Europe/Berlin"),
("2839050", "Schkeuditz", "Шкойдиц", "DE", "276", "13", "", "", "", "51.39678", "12.22141", "Europe/Berlin"),
("2839316", "Schiffweiler", "Шифвайлер", "DE", "276", "09", "00", "10043", "10043116", "49.36667", "7.13333", "Europe/Berlin"),
("2839335", "Schifferstadt", "Шифферштадт", "DE", "276", "08", "", "", "", "49.38417", "8.3775", "Europe/Berlin"),
("2841125", "Saulgau", "", "DE", "276", "01", "084", "08437", "08437100", "48.01676", "9.50064", "Europe/Berlin"),
("2841374", "Sasel", "", "DE", "276", "04", "", "", "", "53.65385", "10.11184", "Europe/Berlin"),
("2841386", "Sarstedt", "Зарштедт", "DE", "276", "06", "", "", "", "52.23495", "9.85411", "Europe/Berlin"),
("2841463", "Sankt Wendel", "Санкт-Вендель", "DE", "276", "09", "00", "10046", "", "49.46633", "7.16814", "Europe/Berlin"),
("2841590", "Sankt Ingbert", "", "DE", "276", "09", "", "", "", "49.27697", "7.11672", "Europe/Berlin"),
("2841648", "Sankt Augustin", "Санкт-Августин", "DE", "276", "07", "", "", "", "50.77538", "7.197", "Europe/Berlin"),
("2841693", "Sangerhausen", "Зангерхаузен", "DE", "276", "14", "00", "15087", "", "51.47221", "11.29533", "Europe/Berlin"),
("2842112", "Salzwedel", "Зальцведель", "DE", "276", "14", "00", "15081", "", "52.85435", "11.1525", "Europe/Berlin"),
("2842131", "Salzkotten", "Зальцкоттен", "DE", "276", "07", "057", "", "", "51.6717", "8.60092", "Europe/Berlin"),
("2842632", "Saarlouis", "Саарлуисе", "DE", "276", "09", "00", "10044", "", "49.31366", "6.75154", "Europe/Berlin"),
("2842647", "Saarbrucken", "Саарбрюккен", "DE", "276", "09", "", "", "", "49.2354", "6.98165", "Europe/Berlin"),
("2842688", "Saalfeld", "Заальфельд", "DE", "276", "15", "00", "16073", "", "50.64826", "11.36536", "Europe/Berlin"),
("2842884", "Russelsheim", "Рюссельсхайм", "DE", "276", "05", "064", "", "", "49.98955", "8.42251", "Europe/Berlin"),
("2843106", "Rummelsburg", "", "DE", "276", "16", "00", "11000", "11000000", "52.50146", "13.4934", "Europe/Berlin"),
("2843350", "Rudow", "", "DE", "276", "16", "00", "11000", "11000000", "52.42407", "13.48529", "Europe/Berlin"),
("2843355", "Rudolstadt", "Рудольштадт", "DE", "276", "15", "", "", "", "50.72043", "11.34046", "Europe/Berlin"),
("2843636", "Rottweil", "Ротвайль", "DE", "276", "01", "083", "08325", "08325049", "48.16783", "8.62719", "Europe/Berlin"),
("2843729", "Rottenburg", "", "DE", "276", "01", "084", "08416", "08416036", "48.47629", "8.93528", "Europe/Berlin"),
("2844265", "Roth", "Рота", "DE", "276", "02", "095", "09576", "09576143", "49.24762", "11.09111", "Europe/Berlin"),
("2844437", "Rotenburg", "Ротенбург", "DE", "276", "06", "00", "03357", "", "53.11125", "9.41082", "Europe/Berlin"),
("2844588", "Rostock", "Росток", "DE", "276", "12", "00", "", "", "54.0887", "12.14049", "Europe/Berlin"),
("2844862", "Rosrath", "Рёсрат", "DE", "276", "07", "053", "", "", "50.89559", "7.18175", "Europe/Berlin"),
("2844988", "Rosenheim", "Розенхайм", "DE", "276", "02", "091", "09163", "09163000", "47.85637", "12.12247", "Europe/Berlin"),
("2845222", "Ronnenberg", "", "DE", "276", "06", "", "", "", "52.31939", "9.65544", "Europe/Berlin"),
("2846523", "Rinteln", "Ринтельн", "DE", "276", "06", "00", "03257", "03257031", "52.18604", "9.07917", "Europe/Berlin"),
("2846843", "Rietberg", "Ритберг", "DE", "276", "07", "", "", "", "51.80924", "8.42841", "Europe/Berlin"),
("2846939", "Riesa", "Риза", "DE", "276", "13", "", "", "", "51.30776", "13.29168", "Europe/Berlin"),
("2847033", "Riegelsberg", "", "DE", "276", "09", "00", "10041", "10041517", "49.3", "6.93333", "Europe/Berlin"),
("2847524", "Ribnitz-Damgarten", "Рибниц-Дамгартен", "DE", "276", "12", "", "", "", "54.2422", "12.45666", "Europe/Berlin"),
("2847639", "Rheinfelden (Baden)", "Райнфельден", "DE", "276", "01", "083", "08336", "08336069", "47.56013", "7.78715", "Europe/Berlin"),
("2847645", "Rheine", "Райн", "DE", "276", "07", "055", "", "", "52.28509", "7.44055", "Europe/Berlin"),
("2847662", "Rheinberg", "", "DE", "276", "07", "", "", "", "51.54649", "6.59524", "Europe/Berlin"),
("2847666", "Rheinbach", "Райнбах", "DE", "276", "07", "053", "", "", "50.62562", "6.94911", "Europe/Berlin"),
("2847689", "Rhede", "Реде", "DE", "276", "07", "055", "", "", "51.83537", "6.69602", "Europe/Berlin"),
("2847690", "Rheda-Wiedenbruck", "Ред-Виденбрюк", "DE", "276", "07", "057", "", "", "51.84967", "8.30017", "Europe/Berlin"),
("2847736", "Reutlingen", "Ройтлинген", "DE", "276", "01", "084", "08415", "08415061", "48.49144", "9.20427", "Europe/Berlin"),
("2848175", "Renningen", "Реннинген", "DE", "276", "01", "081", "08115", "08115041", "48.76974", "8.93871", "Europe/Berlin"),
("2848245", "Rendsburg", "Рендсбург", "DE", "276", "10", "00", "01058", "", "54.30663", "9.66313", "Europe/Berlin"),
("2848273", "Remscheid", "Ремшайд", "DE", "276", "07", "051", "05120", "", "51.17983", "7.1925", "Europe/Berlin"),
("2848335", "Remagen", "Ремаген", "DE", "276", "08", "", "", "", "50.57879", "7.22703", "Europe/Berlin"),
("2848756", "Reinickendorf", "", "DE", "276", "16", "00", "11000", "11000000", "52.56667", "13.33333", "Europe/Berlin"),
("2848762", "Reinheim", "Райнхайм", "DE", "276", "05", "", "", "", "49.82923", "8.83572", "Europe/Berlin"),
("2848845", "Reinbek", "Райнбек", "DE", "276", "10", "", "", "", "53.51703", "10.2488", "Europe/Berlin"),
("2849156", "Reichenbach/Vogtland", "", "DE", "276", "13", "00", "", "", "50.62279", "12.30344", "Europe/Berlin"),
("2849483", "Regensburg", "Регенсбург", "DE", "276", "02", "093", "09362", "09362000", "49.03451", "12.11923", "Europe/Berlin"),
("2849548", "Rees", "Рес", "DE", "276", "07", "", "", "", "51.76263", "6.39778", "Europe/Berlin"),
("2849647", "Recklinghausen", "Реклингхаузен", "DE", "276", "07", "055", "05562", "", "51.61379", "7.19738", "Europe/Berlin"),
("2849802", "Ravensburg", "Равенсбург", "DE", "276", "01", "084", "08436", "08436064", "47.78198", "9.61062", "Europe/Berlin"),
("2850174", "Ratingen", "Ратинген", "DE", "276", "07", "051", "", "", "51.29724", "6.84929", "Europe/Berlin"),
("2850213", "Rathenow", "Ратенов", "DE", "276", "11", "00", "12063", "", "52.60659", "12.33696", "Europe/Berlin"),
("2850235", "Ratekau", "Ратекау", "DE", "276", "10", "00", "01055", "01055035", "53.95", "10.73333", "Europe/Berlin"),
("2850253", "Rastede", "Растеде", "DE", "276", "06", "00", "03451", "03451005", "53.25", "8.2", "Europe/Berlin"),
("2850257", "Rastatt", "Раштатт", "DE", "276", "01", "082", "08216", "08216043", "48.85851", "8.20964", "Europe/Berlin"),
("2850887", "Rahden", "Раден", "DE", "276", "07", "", "", "", "52.43367", "8.61263", "Europe/Berlin"),
("2850954", "Radolfzell am Bodensee", "Радольфцелль", "DE", "276", "01", "083", "08335", "08335063", "47.74194", "8.97098", "Europe/Berlin"),
("2850995", "Radevormwald", "Радеформвальд", "DE", "276", "07", "", "", "", "51.20218", "7.36027", "Europe/Berlin"),
("2851077", "Radebeul", "Радебойль", "DE", "276", "13", "00", "", "", "51.10654", "13.66047", "Europe/Berlin"),
("2851079", "Radeberg", "Радеберг", "DE", "276", "13", "", "", "", "51.11112", "13.91199", "Europe/Berlin"),
("2851343", "Quickborn", "Квикборн", "DE", "276", "10", "", "", "", "53.72831", "9.90934", "Europe/Berlin"),
("2851465", "Quedlinburg", "Кведлинбург", "DE", "276", "14", "", "", "", "51.78843", "11.15006", "Europe/Berlin"),
("2851584", "Puttlingen", "Пютлинген", "DE", "276", "09", "", "", "", "49.2855", "6.88723", "Europe/Berlin"),
("2851746", "Pulheim", "Пульхайм", "DE", "276", "07", "053", "", "", "50.99965", "6.80632", "Europe/Berlin"),
("2851782", "Puchheim", "", "DE", "276", "02", "091", "09179", "09179145", "48.15", "11.35", "Europe/Berlin"),
("2852217", "Prenzlauer Berg Bezirk", "Пренцлауэр-Берг", "DE", "276", "16", "00", "11000", "11000000", "52.53878", "13.42443", "Europe/Berlin"),
("2852218", "Prenzlau", "Пренцлау", "DE", "276", "11", "00", "12073", "", "53.31625", "13.86261", "Europe/Berlin"),
("2852280", "Preetz", "Прец", "DE", "276", "10", "", "", "", "54.2354", "10.27795", "Europe/Berlin"),
("2852458", "Potsdam", "Потсдам", "DE", "276", "11", "", "", "", "52.39886", "13.06566", "Europe/Berlin"),
("2852577", "Porta Westfalica", "", "DE", "276", "07", "", "", "", "52.23779", "8.91901", "Europe/Berlin"),
("2852673", "Poppenbuettel", "", "DE", "276", "04", "", "", "", "53.65917", "10.08472", "Europe/Berlin"),
("2853209", "Plettenberg", "Плеттенберг", "DE", "276", "07", "", "", "", "51.20949", "7.8726", "Europe/Berlin"),
("2853292", "Plauen", "Плауэн", "DE", "276", "13", "00", "14523", "", "50.4973", "12.13782", "Europe/Berlin"),
("2853572", "Pirna", "Пирна", "DE", "276", "13", "00", "14628", "", "50.95843", "13.93702", "Europe/Berlin"),
("2853574", "Pirmasens", "Пирмазенс", "DE", "276", "08", "00", "07340", "", "49.20145", "7.60529", "Europe/Berlin"),
("2853658", "Pinneberg", "Пиннеберг", "DE", "276", "10", "00", "01056", "", "53.66732", "9.78936", "Europe/Berlin"),
("2853924", "Pfungstadt", "Пфунгштадт", "DE", "276", "05", "", "", "", "49.80557", "8.60306", "Europe/Berlin"),
("2853928", "Pfullingen", "Пфуллинген", "DE", "276", "01", "084", "08415", "08415059", "48.46458", "9.22796", "Europe/Berlin"),
("2853969", "Pforzheim", "Пфорцхайм", "DE", "276", "01", "082", "08231", "08231000", "48.88436", "8.69892", "Europe/Berlin"),
("2854386", "Pfaffenhofen an der Ilm", "Пфаффенхофен-ан-дер-Ильм", "DE", "276", "02", "091", "09186", "09186143", "48.53053", "11.505", "Europe/Berlin"),
("2854655", "Petershagen", "Петерсхаген", "DE", "276", "07", "057", "", "", "52.37513", "8.96538", "Europe/Berlin"),
("2854923", "Penzberg", "Пенцберг", "DE", "276", "02", "091", "09190", "09190141", "47.75293", "11.377", "Europe/Berlin"),
("2855047", "Peine", "Пайне", "DE", "276", "06", "00", "03157", "03157006", "52.31928", "10.2352", "Europe/Berlin"),
("2855328", "Passau", "Пассау", "DE", "276", "02", "092", "09262", "09262000", "48.5665", "13.43122", "Europe/Berlin"),
("2855441", "Parchim", "Пархим", "DE", "276", "12", "00", "13076", "", "53.42631", "11.84875", "Europe/Berlin"),
("2855525", "Papenburg", "Папенбург", "DE", "276", "06", "", "", "", "53.07738", "7.40444", "Europe/Berlin"),
("2855598", "Pankow", "Панков", "DE", "276", "16", "00", "11000", "11000000", "52.56926", "13.40186", "Europe/Berlin"),
("2855745", "Paderborn", "Падерборн", "DE", "276", "07", "057", "05774", "", "51.71905", "8.75439", "Europe/Berlin"),
("2855794", "Oyten", "", "DE", "276", "06", "00", "03361", "03361009", "53.05", "9.01667", "Europe/Berlin"),
("2855859", "Overath", "Оверат", "DE", "276", "07", "053", "", "", "50.93275", "7.28389", "Europe/Berlin"),
("2855917", "Ottweiler", "Отвайлер", "DE", "276", "09", "00", "10043", "", "49.40133", "7.16424", "Europe/Berlin"),
("2855935", "Ottobrunn", "Оттобрунн", "DE", "276", "02", "091", "09184", "09184136", "48.06489", "11.66327", "Europe/Berlin"),
("2856500", "Osterholz-Scharmbeck", "Остерхольц-Шармбек", "DE", "276", "06", "00", "03356", "", "53.22698", "8.79528", "Europe/Berlin"),
("2856883", "Osnabrueck", "Оснабрюк", "DE", "276", "06", "00", "03459", "", "52.27264", "8.0498", "Europe/Berlin"),
("2856930", "Oschersleben", "Ошерслебен", "DE", "276", "14", "", "", "", "52.0304", "11.22898", "Europe/Berlin"),
("2856944", "Oschatz", "Ошац", "DE", "276", "13", "", "", "", "51.30001", "13.10984", "Europe/Berlin"),
("2857129", "Oranienburg", "Ораниенбург", "DE", "276", "11", "00", "12065", "", "52.75577", "13.24197", "Europe/Berlin"),
("2857185", "Opladen", "Опладен", "DE", "276", "07", "", "", "", "51.05521", "7.01931", "Europe/Berlin"),
("2857291", "Olsberg", "Ольсберг", "DE", "276", "07", "059", "", "", "51.35613", "8.48899", "Europe/Berlin"),
("2857306", "Olpe", "Ольпе", "DE", "276", "07", "059", "05966", "", "51.02899", "7.85139", "Europe/Berlin"),
("2857458", "Oldenburg", "Ольденбург", "DE", "276", "06", "00", "03403", "", "53.14118", "8.21467", "Europe/Berlin"),
("2857472", "Olching", "Ольхинг", "DE", "276", "02", "091", "09179", "09179142", "48.2", "11.33333", "Europe/Berlin"),
("2857565", "Ohringen", "Эринген", "DE", "276", "01", "081", "08126", "08126066", "49.19884", "9.5072", "Europe/Berlin"),
("2857798", "Offenburg", "Оффенбург", "DE", "276", "01", "083", "08317", "08317096", "48.47377", "7.94495", "Europe/Berlin"),
("2857807", "Offenbach", "", "DE", "276", "05", "064", "06438", "", "50.1006", "8.76647", "Europe/Berlin"),
("2857900", "Oerlinghausen", "Эрлингхаузен", "DE", "276", "07", "057", "", "", "51.95453", "8.6622", "Europe/Berlin"),
("2857904", "Oer-Erkenschwick", "Ор-Эркеншвик", "DE", "276", "07", "", "", "", "51.64198", "7.26451", "Europe/Berlin"),
("2857943", "Oelde", "Ольде", "DE", "276", "07", "", "", "", "51.8289", "8.14724", "Europe/Berlin"),
("2858103", "Odenthal", "Оденталь", "DE", "276", "07", "053", "05378", "05378020", "51.03333", "7.11667", "Europe/Berlin"),
("2858245", "Ochtrup", "Охтруп", "DE", "276", "07", "055", "", "", "52.20802", "7.18988", "Europe/Berlin"),
("2858738", "Oberursel", "", "DE", "276", "05", "064", "", "", "50.20731", "8.57747", "Europe/Berlin"),
("2858763", "Obertshausen", "Обертсхаузен", "DE", "276", "05", "", "", "", "50.07139", "8.85123", "Europe/Berlin"),
("2859103", "Oberschoneweide", "", "DE", "276", "16", "00", "11000", "11000000", "52.46106", "13.52108", "Europe/Berlin"),
("2859380", "Ober-Ramstadt", "Обер-Рамштадт", "DE", "276", "05", "", "", "", "49.83078", "8.74887", "Europe/Berlin"),
("2860080", "Oberkirch", "Оберкирх", "DE", "276", "01", "083", "08317", "08317089", "48.53241", "8.07864", "Europe/Berlin"),
("2860410", "Oberhausen", "Оберхаузен", "DE", "276", "07", "051", "05119", "", "51.47311", "6.88074", "Europe/Berlin"),
("2861402", "Oberasbach", "", "DE", "276", "02", "095", "09573", "09573122", "49.42275", "10.95766", "Europe/Berlin"),
("2861632", "Nurtingen", "Нюртинген", "DE", "276", "01", "081", "08116", "08116049", "48.62565", "9.34203", "Europe/Berlin"),
("2861650", "Nuernberg", "Нюрнберг", "DE", "276", "02", "095", "09564", "09564000", "49.45421", "11.07752", "Europe/Berlin"),
("2861677", "Numbrecht", "Нюмбрехт", "DE", "276", "07", "053", "05374", "05374032", "50.9", "7.55", "Europe/Berlin"),
("2861733", "Nottuln", "Ноттульн", "DE", "276", "07", "055", "05558", "05558032", "51.93333", "7.35", "Europe/Berlin"),
("2861814", "Northeim", "Нортхайм", "DE", "276", "06", "00", "03155", "", "51.70662", "9.99998", "Europe/Berlin"),
("2861914", "Noerdlingen", "Нёрдлинген", "DE", "276", "02", "097", "09779", "09779194", "48.85122", "10.48868", "Europe/Berlin"),
("2861934", "Nordhorn", "Нордхорн", "DE", "276", "06", "00", "03456", "", "52.43081", "7.06833", "Europe/Berlin"),
("2861982", "Nordhausen", "Нордхаузен", "DE", "276", "15", "00", "16062", "", "51.5018", "10.7957", "Europe/Berlin"),
("2862026", "Norderstedt", "Нордерштедт", "DE", "276", "10", "", "", "", "53.6859", "9.98041", "Europe/Berlin"),
("2862104", "Nordenham", "Норденхаме", "DE", "276", "06", "", "", "", "53.4861", "8.48093", "Europe/Berlin"),
("2862118", "Norden", "Норден", "DE", "276", "06", "", "", "", "53.59552", "7.20639", "Europe/Berlin"),
("2862423", "Nikolassee", "", "DE", "276", "16", "00", "11000", "11000000", "52.4344", "13.20095", "Europe/Berlin"),
("2862620", "Nienburg", "Нинбург", "DE", "276", "06", "00", "03256", "", "52.6461", "9.22086", "Europe/Berlin"),
("2862888", "Niederschonhausen", "Нидершёнхаузен", "DE", "276", "16", "00", "11000", "11000000", "52.58483", "13.40272", "Europe/Berlin"),
("2863199", "Niederkruchten", "", "DE", "276", "07", "051", "05166", "05166020", "51.2", "6.21667", "Europe/Berlin"),
("2863223", "Niederkassel", "Нидеркассель", "DE", "276", "07", "", "", "", "50.81503", "7.03777", "Europe/Berlin"),
("2863240", "Nieder-Ingelheim", "", "DE", "276", "08", "", "", "", "49.97756", "8.07246", "Europe/Berlin"),
("2863712", "Nidderau", "Ниддерау", "DE", "276", "05", "", "", "", "50.23805", "8.86704", "Europe/Berlin"),
("2863716", "Nidda", "Нидда", "DE", "276", "05", "064", "", "", "50.4133", "9.00638", "Europe/Berlin"),
("2863795", "Neu Wulmstorf", "", "DE", "276", "06", "00", "03353", "03353026", "53.46667", "9.8", "Europe/Berlin"),
("2863840", "Neuwied", "Нойвид", "DE", "276", "08", "00", "07138", "", "50.4336", "7.47057", "Europe/Berlin"),
("2863941", "Neu-Ulm", "Ной-Ульм", "DE", "276", "02", "097", "09775", "09775135", "48.39279", "10.01112", "Europe/Berlin"),
("2864005", "Neustrelitz", "Нойштрелице", "DE", "276", "12", "", "", "", "53.3613", "13.07292", "Europe/Berlin"),
("2864034", "Neustadt in Holstein", "Нойштадт", "DE", "276", "10", "", "", "", "54.10707", "10.8145", "Europe/Berlin"),
("2864053", "Neustadt bei Coburg", "Нойштадт-Кобург", "DE", "276", "02", "094", "09473", "09473151", "50.32975", "11.12058", "Europe/Berlin"),
("2864054", "Neustadt", "Нойштадт-ан-дер-Вайнштрассе", "DE", "276", "08", "00", "07316", "", "49.35009", "8.13886", "Europe/Berlin"),
("2864058", "Neustadt am Rubenberge", "Нойштадт-ам-Рюбенберге", "DE", "276", "06", "", "", "", "52.50462", "9.45871", "Europe/Berlin"),
("2864072", "Neue Neustadt", "Нойштадт", "DE", "276", "14", "", "", "", "52.15", "11.63333", "Europe/Berlin"),
("2864118", "Neuss", "Нойс", "DE", "276", "07", "051", "05162", "", "51.19807", "6.68504", "Europe/Berlin"),
("2864276", "Neuruppin", "Нойруппин", "DE", "276", "11", "00", "12068", "", "52.92815", "12.80311", "Europe/Berlin"),
("2864435", "Neunkirchen", "Нойнкирхен", "DE", "276", "09", "00", "10043", "", "49.34449", "7.18045", "Europe/Berlin"),
("2864475", "Neumunster", "Ноймюнстер", "DE", "276", "10", "00", "01004", "", "54.07477", "9.98195", "Europe/Berlin"),
("2864549", "Neumarkt in der Oberpfalz", "Ноймаркт", "DE", "276", "02", "093", "09373", "09373113", "49.28028", "11.46278", "Europe/Berlin"),
("2864820", "Neu Isenburg", "Ной-Изенбург", "DE", "276", "05", "064", "", "", "50.04832", "8.69406", "Europe/Berlin"),
("2865376", "Neufahrn bei Freising", "", "DE", "276", "02", "091", "09178", "09178145", "48.31588", "11.66316", "Europe/Berlin"),
("2865716", "Neuenhagen", "", "DE", "276", "11", "", "", "", "52.52985", "13.68914", "Europe/Berlin"),
("2866070", "Neuburg an der Donau", "Нойбург-ан-дер-Донау", "DE", "276", "02", "091", "09185", "09185149", "48.73218", "11.18709", "Europe/Berlin"),
("2866110", "Neubrueck", "", "DE", "276", "07", "051", "", "", "51.13434", "6.63857", "Europe/Berlin"),
("2866135", "Neubrandenburg", "Нойбранденбурге", "DE", "276", "12", "00", "13071", "", "53.56414", "13.27532", "Europe/Berlin"),
("2866280", "Neu-Anspach", "Ной-Анспах", "DE", "276", "05", "064", "06434", "06434007", "50.31667", "8.5", "Europe/Berlin"),
("2866333", "Nettetal", "Неттеталь", "DE", "276", "07", "051", "05166", "05166016", "51.31667", "6.28333", "Europe/Berlin"),
("2866375", "Netphen", "Нетфен", "DE", "276", "07", "", "", "", "50.91667", "8.1", "Europe/Berlin"),
("2866758", "Neckarsulm", "Неккарзульм", "DE", "276", "01", "081", "08125", "08125065", "49.18912", "9.22528", "Europe/Berlin"),
("2866906", "Naumburg", "Наумбург", "DE", "276", "14", "00", "15084", "", "51.14987", "11.80979", "Europe/Berlin"),
("2866930", "Nauen", "Науэн", "DE", "276", "11", "", "", "", "52.60701", "12.87374", "Europe/Berlin"),
("2867164", "Nagold", "Нагольд", "DE", "276", "01", "082", "08235", "08235046", "48.5498", "8.72366", "Europe/Berlin"),
("2867542", "Munster", "Мунстер", "DE", "276", "06", "", "", "", "52.98569", "10.08756", "Europe/Berlin"),
("2867543", "Muenster", "Мюнстер", "DE", "276", "07", "055", "", "", "51.96236", "7.62571", "Europe/Berlin"),
("2867613", "Hannoversch Munden", "", "DE", "276", "06", "", "", "", "51.41505", "9.65046", "Europe/Berlin"),
("2867714", "Munich", "Мюнхен", "DE", "276", "02", "091", "09162", "09162000", "48.13743", "11.57549", "Europe/Berlin"),
("2867770", "Mullheim", "Мюльхайм", "DE", "276", "01", "083", "08315", "08315074", "47.8082", "7.63035", "Europe/Berlin"),
("2867838", "Muelheim (Ruhr)", "Мюльхайм-на-Руре", "DE", "276", "07", "051", "", "", "51.43333", "6.88333", "Europe/Berlin"),
("2867985", "Muehlheim am Main", "Мюльхайм-на-Майне", "DE", "276", "05", "064", "", "", "50.11667", "8.83333", "Europe/Berlin"),
("2867993", "Stuttgart Muehlhausen", "", "DE", "276", "01", "081", "08111", "08111000", "48.84232", "9.23028", "Europe/Berlin"),
("2867996", "Muehlhausen", "Мюльхаузен", "DE", "276", "15", "00", "16064", "", "51.20896", "10.45275", "Europe/Berlin"),
("2868506", "Muehldorf", "", "DE", "276", "02", "091", "09183", "09183128", "48.2467", "12.52155", "Europe/Berlin"),
("2868788", "Muhlacker", "Мюлакер", "DE", "276", "01", "082", "08236", "08236040", "48.94754", "8.83675", "Europe/Berlin"),
("2868936", "Much", "", "DE", "276", "07", "053", "05382", "05382036", "50.91667", "7.4", "Europe/Berlin"),
("2869019", "Mossingen", "Мёссинген", "DE", "276", "01", "084", "08416", "08416025", "48.40567", "9.05419", "Europe/Berlin"),
("2869120", "Mosbach", "", "DE", "276", "01", "082", "08225", "08225058", "49.35357", "9.15106", "Europe/Berlin"),
("2869449", "Moosburg", "", "DE", "276", "02", "091", "09178", "09178143", "48.47089", "11.93811", "Europe/Berlin"),
("2869791", "Monheim am Rhein", "", "DE", "276", "07", "", "", "", "51.09162", "6.89218", "Europe/Berlin"),
("2869894", "Monchengladbach", "Мёнхенгладбах", "DE", "276", "07", "051", "05116", "", "51.18539", "6.44172", "Europe/Berlin"),
("2869994", "Molln", "Мёльн", "DE", "276", "10", "", "", "", "53.61702", "10.68742", "Europe/Berlin"),
("2870221", "Moers", "Мерс", "DE", "276", "07", "051", "", "", "51.45342", "6.6326", "Europe/Berlin"),
("2870310", "Moabit", "Моабит", "DE", "276", "16", "00", "11000", "11000000", "52.52635", "13.33903", "Europe/Berlin"),
("2870318", "Mittweida", "Митвайда", "DE", "276", "13", "", "", "", "50.98622", "12.97538", "Europe/Berlin"),
("2871039", "Minden", "Минден", "DE", "276", "07", "057", "05770", "", "52.28953", "8.91455", "Europe/Berlin"),
("2871284", "Michelstadt", "Михельштадт", "DE", "276", "05", "", "", "", "49.67569", "9.00373", "Europe/Berlin"),
("2871486", "Metzingen", "Метцинген", "DE", "276", "01", "084", "08415", "08415050", "48.53695", "9.2833", "Europe/Berlin"),
("2871535", "Mettmann", "Меттман", "DE", "276", "07", "051", "05158", "", "51.2504", "6.97536", "Europe/Berlin"),
("2871668", "Meschede", "Мешеде", "DE", "276", "07", "059", "05958", "", "51.3502", "8.28332", "Europe/Berlin"),
("2871675", "Merzig", "Мерциге", "DE", "276", "09", "00", "10042", "", "49.44331", "6.63874", "Europe/Berlin"),
("2871736", "Merseburg", "Мерзебург", "DE", "276", "14", "00", "15088", "", "51.35478", "11.98923", "Europe/Berlin"),
("2871845", "Meppen", "Меппен", "DE", "276", "06", "00", "03454", "", "52.69064", "7.29097", "Europe/Berlin"),
("2871983", "Menden", "Менден", "DE", "276", "07", "059", "", "", "51.44337", "7.77824", "Europe/Berlin"),
("2871992", "Memmingen", "Мемминген", "DE", "276", "02", "097", "09764", "09764000", "47.98372", "10.18527", "Europe/Berlin"),
("2872079", "Melle", "Мелле", "DE", "276", "06", "", "", "", "52.20197", "8.33826", "Europe/Berlin"),
("2872155", "Meissen", "Мейсен", "DE", "276", "13", "00", "14627", "", "51.16158", "13.4737", "Europe/Berlin"),
("2872225", "Meiningen", "Майнинген", "DE", "276", "15", "00", "16066", "", "50.56787", "10.41521", "Europe/Berlin"),
("2872237", "Meinerzhagen", "Майнерцхаген", "DE", "276", "07", "", "", "", "51.1074", "7.64838", "Europe/Berlin"),
("2872347", "Meiderich", "", "DE", "276", "07", "", "", "", "51.46667", "6.76667", "Europe/Berlin"),
("2872504", "Meerbusch", "Мербуш", "DE", "276", "07", "051", "", "", "51.26118", "6.6717", "Europe/Berlin"),
("2872519", "Meerane", "Меране", "DE", "276", "13", "00", "", "", "50.84688", "12.46473", "Europe/Berlin"),
("2872582", "Meckenheim", "Меккенхайм", "DE", "276", "07", "", "", "", "50.62388", "7.02942", "Europe/Berlin"),
("2872611", "Mechernich", "Мехерних", "DE", "276", "07", "053", "", "", "50.59304", "6.65224", "Europe/Berlin"),
("2872649", "Mayen", "Майен", "DE", "276", "08", "", "", "", "50.32797", "7.22277", "Europe/Berlin"),
("2873074", "Marzahn", "", "DE", "276", "16", "00", "11000", "11000000", "52.54525", "13.56983", "Europe/Berlin"),
("2873211", "Marsberg", "Марсберг", "DE", "276", "07", "", "", "", "51.46171", "8.84949", "Europe/Berlin"),
("2873263", "Marl", "Марль", "DE", "276", "07", "", "", "", "51.65671", "7.09038", "Europe/Berlin"),
("2873289", "Marktredwitz", "Марктредвиц", "DE", "276", "02", "094", "09479", "09479136", "50.00443", "12.08593", "Europe/Berlin"),
("2873291", "Marktoberdorf", "Марктобердорф", "DE", "276", "02", "097", "09777", "09777151", "47.77964", "10.61713", "Europe/Berlin"),
("2873351", "Markkleeberg West", "", "DE", "276", "13", "", "", "", "51.28333", "12.36667", "Europe/Berlin"),
("2873356", "Markisches Viertel", "", "DE", "276", "16", "00", "11000", "11000000", "52.59841", "13.35766", "Europe/Berlin"),
("2873589", "Marienfelde", "", "DE", "276", "16", "00", "11000", "11000000", "52.41868", "13.36723", "Europe/Berlin"),
("2873606", "Mariendorf", "Мариендорф", "DE", "276", "16", "00", "11000", "11000000", "52.4378", "13.38109", "Europe/Berlin"),
("2873759", "Marburg an der Lahn", "Марбург", "DE", "276", "05", "065", "06534", "", "50.80904", "8.77069", "Europe/Berlin"),
("2873776", "Marbach am Neckar", "Марбах-на-Неккаре", "DE", "276", "01", "081", "08118", "08118049", "48.93964", "9.25995", "Europe/Berlin"),
("2873891", "Mannheim", "Мангейм", "DE", "276", "01", "082", "08222", "08222000", "49.49671", "8.47955", "Europe/Berlin"),
("2874225", "Mainz", "Майнц", "DE", "276", "08", "", "", "", "49.98419", "8.2791", "Europe/Berlin"),
("2874230", "Maintal", "Майнталь", "DE", "276", "05", "064", "", "", "50.15", "8.83333", "Europe/Berlin"),
("2874455", "Mahlsdorf", "", "DE", "276", "16", "00", "11000", "11000000", "52.50935", "13.61373", "Europe/Berlin"),
("2874545", "Magdeburg", "Магдебург", "DE", "276", "14", "00", "15003", "15003000", "52.12773", "11.62916", "Europe/Berlin"),
("2875107", "Lunen", "Люнен", "DE", "276", "07", "", "", "", "51.61634", "7.52872", "Europe/Berlin"),
("2875115", "Lueneburg", "Люнебург", "DE", "276", "06", "00", "03355", "", "53.2509", "10.41409", "Europe/Berlin"),
("2875376", "Ludwigshafen am Rhein", "Людвигсхафен-на-Рейне", "DE", "276", "08", "00", "07338", "", "49.48121", "8.44641", "Europe/Berlin"),
("2875379", "Ludwigsfelde", "Людвигсфельде", "DE", "276", "11", "", "", "", "52.30322", "13.25405", "Europe/Berlin"),
("2875392", "Ludwigsburg", "Людвигсбург", "DE", "276", "01", "081", "08118", "08118048", "48.89731", "9.19161", "Europe/Berlin"),
("2875417", "Ludinghausen", "Людингхаузен", "DE", "276", "07", "", "", "", "51.7683", "7.44379", "Europe/Berlin"),
("2875457", "Luedenscheid", "Люденшайд", "DE", "276", "07", "059", "05962", "", "51.21977", "7.6273", "Europe/Berlin"),
("2875484", "Luckenwalde", "Луккенвальде", "DE", "276", "11", "00", "12072", "", "52.09029", "13.16772", "Europe/Berlin"),
("2875601", "Luebeck", "Любек", "DE", "276", "10", "00", "01003", "", "53.86893", "10.68729", "Europe/Berlin"),
("2875623", "Lubbenau", "Люббенау", "DE", "276", "11", "", "", "", "51.86217", "13.95168", "Europe/Berlin"),
("2875626", "Lubbecke", "Люббекке", "DE", "276", "07", "", "", "", "52.30699", "8.61423", "Europe/Berlin"),
("2875645", "Loxstedt", "Локсштедт", "DE", "276", "06", "00", "03352", "03352032", "53.46667", "8.65", "Europe/Berlin"),
("2875831", "Losheim", "", "DE", "276", "09", "", "", "", "49.5099", "6.74549", "Europe/Berlin"),
("2875881", "Loerrach", "Лёррах", "DE", "276", "01", "083", "08336", "08336050", "47.61497", "7.66457", "Europe/Berlin"),
("2876147", "Lohr am Main", "Лор-на-Майне", "DE", "276", "02", "096", "09677", "09677155", "49.98922", "9.57223", "Europe/Berlin"),
("2876185", "Lohne", "", "DE", "276", "06", "", "", "", "52.66625", "8.2375", "Europe/Berlin"),
("2876218", "Lohmar", "Ломар", "DE", "276", "07", "", "", "", "50.83868", "7.21399", "Europe/Berlin"),
("2876755", "Lobau", "Лёбау", "DE", "276", "13", "", "", "", "51.09954", "14.66738", "Europe/Berlin"),
("2876865", "Lippstadt", "Липпштадте", "DE", "276", "07", "059", "", "", "51.67369", "8.34482", "Europe/Berlin"),
("2877088", "Lingen", "Линген", "DE", "276", "06", "", "", "", "52.52143", "7.31845", "Europe/Berlin"),
("2877142", "Lindlar", "Линдлар", "DE", "276", "07", "053", "05374", "05374020", "51.01959", "7.37758", "Europe/Berlin"),
("2877550", "Lindau", "Линдау", "DE", "276", "02", "097", "09776", "09776116", "47.54612", "9.68431", "Europe/Berlin"),
("2877648", "Limburg an der Lahn", "Лимбург-на-Лане", "DE", "276", "05", "065", "06533", "", "50.3836", "8.0503", "Europe/Berlin"),
("2877673", "Limbach-Oberfrohna", "Лимбах-Оберфрона", "DE", "276", "13", "00", "", "", "50.85882", "12.76165", "Europe/Berlin"),
("2877709", "Lilienthal", "Лилиенталь", "DE", "276", "06", "00", "03356", "03356005", "53.13333", "8.91667", "Europe/Berlin"),
("2878018", "Lichterfelde", "", "DE", "276", "16", "00", "11000", "11000000", "52.4333", "13.30762", "Europe/Berlin"),
("2878044", "Lichtenrade", "", "DE", "276", "16", "00", "11000", "11000000", "52.39844", "13.40637", "Europe/Berlin"),
("2878074", "Lichtenfels", "Лихтенфельс", "DE", "276", "02", "094", "09478", "09478139", "50.14567", "11.05928", "Europe/Berlin"),
("2878102", "Lichtenberg", "", "DE", "276", "16", "00", "11000", "11000000", "52.51395", "13.49975", "Europe/Berlin"),
("2878234", "Leverkusen", "Леверкузен", "DE", "276", "07", "053", "05316", "", "51.0303", "6.98432", "Europe/Berlin"),
("2878270", "Leutkirch im Allgau", "Лойткирх", "DE", "276", "01", "084", "08436", "08436055", "47.82672", "10.0205", "Europe/Berlin"),
("2878673", "Leopoldshohe", "Леопольдсхёэ", "DE", "276", "07", "057", "05766", "05766048", "52.01246", "8.69834", "Europe/Berlin"),
("2878695", "Leonberg", "Леонберг", "DE", "276", "01", "081", "08115", "08115028", "48.8", "9.01667", "Europe/Berlin"),
("2878784", "Lennestadt", "Леннештадт", "DE", "276", "07", "059", "", "", "51.11721", "8.06707", "Europe/Berlin"),
("2878840", "Lengerich", "", "DE", "276", "07", "", "", "", "52.18661", "7.86043", "Europe/Berlin"),
("2878943", "Lemgo", "Лемго", "DE", "276", "07", "057", "05766", "", "52.02786", "8.89901", "Europe/Berlin"),
("2879139", "Leipzig", "Лейпциг", "DE", "276", "13", "00", "14713", "14713000", "51.33962", "12.37129", "Europe/Berlin"),
("2879185", "Leinfelden-Echterdingen", "Лайнфельден-Эхтердинген", "DE", "276", "01", "081", "08116", "08116078", "48.69406", "9.16809", "Europe/Berlin"),
("2879241", "Leimen", "Лаймен", "DE", "276", "01", "082", "08226", "08226041", "49.34737", "8.68733", "Europe/Berlin"),
("2879315", "Leichlingen", "Лайхлинген", "DE", "276", "07", "", "", "", "51.10628", "7.01873", "Europe/Berlin"),
("2879367", "Lehrte", "Лерте", "DE", "276", "06", "", "", "", "52.37539", "9.97155", "Europe/Berlin"),
("2879697", "Leer", "Лер", "DE", "276", "06", "00", "03457", "", "53.23157", "7.461", "Europe/Berlin"),
("2879832", "Lebach", "Лебах", "DE", "276", "09", "", "", "", "49.41122", "6.90988", "Europe/Berlin"),
("2880077", "Laupheim", "Лаупхайм", "DE", "276", "01", "084", "08426", "08426070", "48.22786", "9.87874", "Europe/Berlin"),
("2880144", "Lauf an der Pegnitz", "Лауф-ан-дер-Пегниц", "DE", "276", "02", "095", "09574", "09574138", "49.51386", "11.28247", "Europe/Berlin"),
("2880221", "Lauchhammer", "Лауххаммер", "DE", "276", "11", "", "", "", "51.48813", "13.76623", "Europe/Berlin"),
("2880498", "Lankwitz", "Ланквиц", "DE", "276", "16", "00", "11000", "11000000", "52.43623", "13.3459", "Europe/Berlin"),
("2881018", "Langenhorn", "", "DE", "276", "04", "", "", "", "53.66556", "10.00137", "Europe/Berlin"),
("2881062", "Langenhagen", "Лангенхаген", "DE", "276", "06", "", "", "", "52.44758", "9.73741", "Europe/Berlin"),
("2881085", "Langenfeld", "Лангенфельд", "DE", "276", "07", "051", "", "", "51.10821", "6.94831", "Europe/Berlin"),
("2881276", "Langen", "", "DE", "276", "06", "", "", "", "53.60554", "8.59509", "Europe/Berlin"),
("2881279", "Langen", "Ланген", "DE", "276", "05", "", "", "", "49.98955", "8.66852", "Europe/Berlin"),
("2881485", "Landshut", "Ландсхут", "DE", "276", "02", "092", "09261", "09261000", "48.52961", "12.16179", "Europe/Berlin"),
("2881509", "Landsberg am Lech", "Ландсберг-на-Лехе", "DE", "276", "02", "091", "09181", "09181130", "48.04819", "10.88282", "Europe/Berlin"),
("2881646", "Landau in der Pfalz", "Ландау", "DE", "276", "08", "00", "07337", "", "49.19844", "8.11692", "Europe/Berlin"),
("2881695", "Lampertheim", "Лампертхайм", "DE", "276", "05", "", "", "", "49.59786", "8.4725", "Europe/Berlin"),
("2881885", "Lahr", "Лар", "DE", "276", "01", "083", "08317", "08317065", "48.34042", "7.86886", "Europe/Berlin"),
("2881889", "Lahnstein", "Ланштайн", "DE", "276", "08", "", "", "", "50.3", "7.61667", "Europe/Berlin"),
("2881956", "Lage", "Лаге", "DE", "276", "07", "057", "", "", "51.99223", "8.79301", "Europe/Berlin"),
("2882087", "Laatzen", "Латцен", "DE", "276", "06", "", "", "", "52.31506", "9.79739", "Europe/Berlin"),
("2882091", "Bad Laasphe", "Бад-Ласфе", "DE", "276", "07", "059", "", "", "50.93139", "8.42502", "Europe/Berlin"),
("2882318", "Kurten", "Кюртен", "DE", "276", "07", "053", "05378", "05378012", "51.05", "7.26667", "Europe/Berlin"),
("2882439", "Kuenzelsau", "Кюнцельзау", "DE", "276", "01", "081", "08126", "08126046", "49.2818", "9.68352", "Europe/Berlin"),
("2882440", "Kunzell", "", "DE", "276", "05", "066", "06631", "06631017", "50.5442", "9.71792", "Europe/Berlin"),
("2882588", "Kulmbach", "Кульмбах", "DE", "276", "02", "094", "09477", "09477128", "50.10068", "11.45032", "Europe/Berlin"),
("2883754", "Kronberg", "", "DE", "276", "05", "064", "", "", "50.18424", "8.5232", "Europe/Berlin"),
("2883784", "Kronach", "Кронах", "DE", "276", "02", "094", "09476", "09476145", "50.23963", "11.33308", "Europe/Berlin"),
("2884050", "Kreuztal", "Кройцталь", "DE", "276", "07", "", "", "", "50.96775", "7.98848", "Europe/Berlin"),
("2884161", "Bezirk Kreuzberg", "", "DE", "276", "16", "00", "11000", "11000000", "52.49973", "13.40338", "Europe/Berlin"),
("2884245", "Kreuzau", "Кройцау", "DE", "276", "07", "053", "05358", "05358028", "50.74699", "6.49069", "Europe/Berlin"),
("2884509", "Krefeld", "Крефельд", "DE", "276", "07", "051", "05114", "", "51.33921", "6.58615", "Europe/Berlin"),
("2885237", "Koethen", "Кётен", "DE", "276", "14", "00", "15082", "", "51.75186", "11.97093", "Europe/Berlin"),
("2885397", "Korschenbroich", "Коршенбройх", "DE", "276", "07", "051", "", "", "51.19139", "6.51352", "Europe/Berlin"),
("2885408", "Kornwestheim", "Корнвестхайм", "DE", "276", "01", "081", "08118", "08118046", "48.86158", "9.18569", "Europe/Berlin"),
("2885412", "Korntal", "", "DE", "276", "01", "081", "08118", "08118080", "48.83218", "9.1214", "Europe/Berlin"),
("2885536", "Korbach", "Корбах", "DE", "276", "05", "066", "06635", "", "51.27561", "8.873", "Europe/Berlin"),
("2885656", "Kopenick Bezirk", "Кёпеник", "DE", "276", "16", "00", "11000", "11000000", "52.4455", "13.57455", "Europe/Berlin"),
("2885657", "Berlin Koepenick", "", "DE", "276", "16", "00", "11000", "11000000", "52.44254", "13.58228", "Europe/Berlin"),
("2885672", "Konz", "Конц", "DE", "276", "08", "", "", "", "49.70045", "6.57652", "Europe/Berlin"),
("2885679", "Konstanz", "Констанц", "DE", "276", "01", "083", "08335", "08335043", "47.66033", "9.17582", "Europe/Berlin"),
("2885732", "Konigs Wusterhausen", "Кёнигс-Вустерхаузен", "DE", "276", "11", "", "", "", "52.30141", "13.633", "Europe/Berlin"),
("2885734", "Konigswinter", "Кёнигсвинтер", "DE", "276", "07", "053", "", "", "50.68376", "7.18675", "Europe/Berlin"),
("2885760", "Konigstein im Taunus", "Кёнигштайн", "DE", "276", "05", "064", "06434", "06434005", "50.17943", "8.47132", "Europe/Berlin"),
("2885800", "Konigslutter am Elm", "Кёнигслуттер-ам-Эльм", "DE", "276", "06", "", "", "", "52.25116", "10.81683", "Europe/Berlin"),
("2885908", "Konigsbrunn", "", "DE", "276", "02", "097", "09772", "09772163", "48.27506", "10.89178", "Europe/Berlin"),
("2886242", "Koeln", "Кёльн", "DE", "276", "07", "053", "05315", "05315000", "50.93333", "6.95", "Europe/Berlin"),
("2886446", "Kolbermoor", "Кольбермор", "DE", "276", "02", "091", "09187", "09187150", "47.84965", "12.06696", "Europe/Berlin"),
("2886946", "Koblenz", "Кобленц", "DE", "276", "08", "00", "07137", "", "50.35357", "7.57884", "Europe/Berlin"),
("2887835", "Kleve", "Клеве", "DE", "276", "07", "051", "05154", "", "51.78826", "6.13865", "Europe/Berlin"),
("2888523", "Kleinmachnow", "Клайнмахнов", "DE", "276", "11", "00", "12069", "12069304", "52.40786", "13.22514", "Europe/Berlin"),
("2890158", "Kitzingen", "Китцинген", "DE", "276", "02", "096", "09675", "09675141", "49.73973", "10.15072", "Europe/Berlin"),
("2890425", "Kirchlengern", "Кирхленгерн", "DE", "276", "07", "057", "05758", "05758020", "52.2", "8.63333", "Europe/Berlin"),
("2890473", "Kirchheim unter Teck", "Кирхгайм-унтер-Тек", "DE", "276", "01", "081", "08116", "08116033", "48.64683", "9.45378", "Europe/Berlin"),
("2890504", "Kirchhain", "Кирхгайн", "DE", "276", "05", "065", "", "", "50.8272", "8.92806", "Europe/Berlin"),
("2891014", "Kierspe", "Кирспе", "DE", "276", "07", "", "", "", "51.13402", "7.59075", "Europe/Berlin"),
("2891122", "Kiel", "Киль", "DE", "276", "10", "", "", "", "54.32133", "10.13489", "Europe/Berlin"),
("2891258", "Kevelaer", "Кевелар", "DE", "276", "07", "051", "", "", "51.58243", "6.24603", "Europe/Berlin"),
("2891524", "Kerpen", "Керпен", "DE", "276", "07", "053", "", "", "50.86991", "6.69691", "Europe/Berlin"),
("2891621", "Kempten (Allgaeu)", "", "DE", "276", "02", "097", "09763", "09763000", "47.72674", "10.31389", "Europe/Berlin"),
("2891643", "Kempen", "Кемпен", "DE", "276", "07", "", "", "", "51.36432", "6.41858", "Europe/Berlin"),
("2891832", "Kelkheim (Taunus)", "", "DE", "276", "05", "", "", "", "50.13703", "8.4502", "Europe/Berlin"),
("2891834", "Kelheim", "Кельхайм", "DE", "276", "02", "092", "09273", "09273137", "48.91725", "11.88618", "Europe/Berlin"),
("2891951", "Kehl", "Кель", "DE", "276", "01", "083", "08317", "08317057", "48.57297", "7.81523", "Europe/Berlin"),
("2892051", "Kaulsdorf", "", "DE", "276", "16", "00", "11000", "11000000", "52.51732", "13.58871", "Europe/Berlin"),
("2892080", "Kaufbeuren", "Кауфбойрен", "DE", "276", "02", "097", "09762", "09762000", "47.88238", "10.62192", "Europe/Berlin"),
("2892518", "Kassel", "Кассель", "DE", "276", "05", "066", "06611", "", "51.31667", "9.5", "Europe/Berlin"),
("2892705", "Karow", "", "DE", "276", "16", "00", "11000", "11000000", "52.60904", "13.48117", "Europe/Berlin"),
("2892786", "Karlstadt", "Карлштадт", "DE", "276", "02", "096", "09677", "09677148", "49.96034", "9.77239", "Europe/Berlin"),
("2892794", "Karlsruhe", "Карлсруэ", "DE", "276", "01", "082", "08212", "08212000", "49.00936", "8.40444", "Europe/Berlin"),
("2892811", "Karlshorst", "Карлсхорст", "DE", "276", "16", "00", "11000", "11000000", "52.48419", "13.53185", "Europe/Berlin"),
("2892874", "Karlsfeld", "", "DE", "276", "02", "091", "09174", "09174126", "48.21667", "11.46667", "Europe/Berlin"),
("2892980", "Karben", "Карбен", "DE", "276", "05", "064", "", "", "50.23019", "8.77155", "Europe/Berlin"),
("2893264", "Kamp-Lintfort", "Камп-Линтфорт", "DE", "276", "07", "051", "", "", "51.50467", "6.54588", "Europe/Berlin"),
("2893437", "Kamenz", "Каменц", "DE", "276", "13", "", "", "", "51.26798", "14.09374", "Europe/Berlin"),
("2893438", "Kamen", "Камен", "DE", "276", "07", "", "", "", "51.59231", "7.6638", "Europe/Berlin"),
("2893544", "Kaltenkirchen", "Кальтенкирхен", "DE", "276", "10", "", "", "", "53.83292", "9.9581", "Europe/Berlin"),
("2894003", "Kaiserslautern", "Кайзерслаутерн", "DE", "276", "08", "00", "07312", "", "49.443", "7.77161", "Europe/Berlin"),
("2894375", "Kaarst", "Карст", "DE", "276", "07", "051", "", "", "51.22929", "6.61882", "Europe/Berlin"),
("2894553", "Julich", "Юлих", "DE", "276", "07", "", "", "", "50.92149", "6.36267", "Europe/Berlin"),
("2894637", "Juchen", "Йюхен", "DE", "276", "07", "051", "05162", "05162012", "51.1", "6.5", "Europe/Berlin"),
("2894755", "Johannisthal", "", "DE", "276", "16", "00", "11000", "11000000", "52.44653", "13.5066", "Europe/Berlin"),
("2895044", "Jena", "Йена", "DE", "276", "15", "00", "16053", "", "50.92878", "11.5899", "Europe/Berlin"),
("2895569", "Itzehoe", "Итцехо", "DE", "276", "10", "00", "01061", "", "53.92099", "9.51529", "Europe/Berlin"),
("2895664", "Isernhagen Farster Bauerschaft", "", "DE", "276", "06", "", "", "", "52.47093", "9.84179", "Europe/Berlin"),
("2895669", "Iserlohn", "Изерлон", "DE", "276", "07", "", "", "", "51.37547", "7.70281", "Europe/Berlin"),
("2895992", "Ingolstadt", "Ингольштадт", "DE", "276", "02", "091", "09161", "09161000", "48.76508", "11.42372", "Europe/Berlin"),
("2896514", "Ilmenau", "Ильменау", "DE", "276", "15", "", "", "", "50.68322", "10.91858", "Europe/Berlin"),
("2896538", "Illingen", "", "DE", "276", "09", "", "", "", "49.37362", "7.04758", "Europe/Berlin"),
("2896546", "Illertissen", "Иллертиссен", "DE", "276", "02", "097", "09775", "09775129", "48.22336", "10.10347", "Europe/Berlin"),
("2896736", "Idstein", "Идштайн", "DE", "276", "05", "064", "", "", "50.21774", "8.26679", "Europe/Berlin"),
("2896753", "Idar-Oberstein", "Идар-Оберштайн", "DE", "276", "08", "", "", "", "49.71443", "7.30776", "Europe/Berlin"),
("2896817", "Ibbenburen", "Иббенбюрен", "DE", "276", "07", "", "", "", "52.27964", "7.71457", "Europe/Berlin"),
("2897132", "Husum", "Хузум", "DE", "276", "10", "00", "01054", "", "54.4858", "9.05239", "Europe/Berlin"),
("2897216", "Hurth", "Хюрт", "DE", "276", "07", "053", "", "", "50.87079", "6.86761", "Europe/Berlin"),
("2897436", "Hunfeld", "Хюнфельд", "DE", "276", "05", "066", "", "", "50.67966", "9.76727", "Europe/Berlin"),
("2897674", "Hummelsbuettel", "", "DE", "276", "04", "", "", "", "53.64773", "10.04149", "Europe/Berlin"),
("2898079", "Hude", "", "DE", "276", "06", "", "", "", "53.10766", "8.46322", "Europe/Berlin"),
("2898098", "Huckeswagen", "Хюккесваген", "DE", "276", "07", "", "", "", "51.1498", "7.34471", "Europe/Berlin"),
("2898111", "Huckelhoven", "Хюккельхофен", "DE", "276", "07", "", "", "", "51.0555", "6.22658", "Europe/Berlin"),
("2898304", "Hoyerswerda", "Хойерсверда", "DE", "276", "13", "", "", "", "51.43787", "14.23549", "Europe/Berlin"),
("2898321", "Hoexter", "Хёкстер", "DE", "276", "07", "057", "05762", "05762020", "51.77501", "9.38155", "Europe/Berlin"),
("2898364", "Hovelhof", "Хёфельхоф", "DE", "276", "07", "057", "05774", "05774024", "51.81667", "8.65", "Europe/Berlin"),
("2898603", "Horstel", "Хёрстель", "DE", "276", "07", "055", "", "", "52.29763", "7.58382", "Europe/Berlin"),
("2899101", "Horb am Neckar", "Хорб-на-Неккаре", "DE", "276", "01", "082", "08237", "08237040", "48.44423", "8.6913", "Europe/Berlin"),
("2899449", "Homburg", "", "DE", "276", "09", "00", "10045", "", "49.32637", "7.33867", "Europe/Berlin"),
("2899538", "Holzwickede", "Хольцвиккеде", "DE", "276", "07", "059", "05978", "05978016", "51.5", "7.63333", "Europe/Berlin"),
("2899601", "Holzminden", "Хольцминден", "DE", "276", "06", "00", "03255", "", "51.82798", "9.4455", "Europe/Berlin"),
("2899676", "Holzkirchen", "Хольцкирхен", "DE", "276", "02", "091", "09182", "09182120", "47.87663", "11.70181", "Europe/Berlin"),
("2901420", "Hohenstein-Ernstthal", "Хоэнштайн-Эрнстталь", "DE", "276", "13", "00", "", "", "50.80064", "12.71287", "Europe/Berlin"),
("2901588", "Hohen Neuendorf", "Хоэн-Нойендорф", "DE", "276", "11", "", "", "", "52.67631", "13.27775", "Europe/Berlin"),
("2902533", "Hofheim am Taunus", "Хофхайм-ам-Таунус", "DE", "276", "05", "064", "06436", "", "50.09019", "8.4493", "Europe/Berlin"),
("2902559", "Hofgeismar", "Хофгайсмар", "DE", "276", "05", "066", "", "", "51.49607", "9.385", "Europe/Berlin"),
("2902768", "Hof", "Хоф", "DE", "276", "02", "094", "09464", "09464000", "50.31622", "11.91833", "Europe/Berlin"),
("2902852", "Hockenheim", "Хоккенхайм", "DE", "276", "01", "082", "08226", "08226032", "49.32334", "8.55194", "Europe/Berlin"),
("2903175", "Hochheim am Main", "Хохгайм-на-Майне", "DE", "276", "05", "064", "", "", "50.01436", "8.35218", "Europe/Berlin"),
("2903237", "Hochfeld", "", "DE", "276", "07", "051", "05112", "05112000", "51.41943", "6.75462", "Europe/Berlin"),
("2904725", "Hille", "", "DE", "276", "07", "057", "05770", "05770012", "52.33333", "8.75", "Europe/Berlin"),
("2904789", "Hildesheim", "Хильдесхайм", "DE", "276", "06", "00", "03254", "", "52.15077", "9.95112", "Europe/Berlin"),
("2904795", "Hilden", "Хильден", "DE", "276", "07", "051", "", "", "51.16818", "6.93093", "Europe/Berlin"),
("2904808", "Hilchenbach", "Хильхенбах", "DE", "276", "07", "", "", "", "50.99687", "8.11062", "Europe/Berlin"),
("2904886", "Hiddenhausen", "Хидденхаузен", "DE", "276", "07", "057", "05758", "05758016", "52.16667", "8.61667", "Europe/Berlin"),
("2904985", "Heusweiler", "Хойсвайлер", "DE", "276", "09", "00", "10041", "10041513", "49.35", "6.93333", "Europe/Berlin"),
("2904992", "Heusenstamm", "Хойзенштамм", "DE", "276", "05", "", "", "", "50.05553", "8.80076", "Europe/Berlin"),
("2905206", "Hettstedt", "Хетштедт", "DE", "276", "14", "", "", "", "51.6503", "11.51146", "Europe/Berlin"),
("2905290", "Hessisch Oldendorf", "Хессиш-Ольдендорф", "DE", "276", "06", "", "", "", "52.17269", "9.24913", "Europe/Berlin"),
("2905455", "Herzogenrath", "Херцогенрат", "DE", "276", "07", "053", "05334", "", "50.87067", "6.10136", "Europe/Berlin"),
("2905457", "Herzogenaurach", "Херцогенаурах", "DE", "276", "02", "095", "09572", "09572132", "49.56798", "10.88565", "Europe/Berlin"),
("2905560", "Herten", "Хертен", "DE", "276", "07", "", "", "", "51.59638", "7.14387", "Europe/Berlin"),
("2905826", "Herrenberg", "Херренберг", "DE", "276", "01", "081", "08115", "08115021", "48.59523", "8.86648", "Europe/Berlin"),
("2905891", "Herne", "Херне", "DE", "276", "07", "059", "05916", "", "51.5388", "7.22572", "Europe/Berlin"),
("2905904", "Hermsdorf", "", "DE", "276", "16", "00", "11000", "11000000", "52.61131", "13.31783", "Europe/Berlin"),
("2906121", "Herford", "Херфорд", "DE", "276", "07", "057", "05758", "", "52.11457", "8.67343", "Europe/Berlin"),
("2906152", "Herdecke", "Хердекке", "DE", "276", "07", "", "", "", "51.39999", "7.43584", "Europe/Berlin"),
("2906199", "Herborn", "Херборн", "DE", "276", "05", "", "", "", "50.68135", "8.30369", "Europe/Berlin"),
("2906268", "Heppenheim an der Bergstrasse", "", "DE", "276", "05", "064", "06431", "", "49.64145", "8.63206", "Europe/Berlin"),
("2906331", "Hennigsdorf", "Хеннигсдорф", "DE", "276", "11", "00", "", "", "52.63598", "13.20419", "Europe/Berlin"),
("2906376", "Hennef", "Хеннеф", "DE", "276", "07", "053", "05382", "05382020", "50.77555", "7.28308", "Europe/Berlin"),
("2906530", "Hemmingen", "", "DE", "276", "06", "00", "", "", "52.31425", "9.72359", "Europe/Berlin"),
("2906595", "Hemer", "Хемер", "DE", "276", "07", "", "", "", "51.38707", "7.77019", "Europe/Berlin"),
("2906676", "Helmstedt", "Хельмштедт", "DE", "276", "06", "00", "03154", "03154010", "52.2279", "11.00985", "Europe/Berlin"),
("2906809", "Hellersdorf", "", "DE", "276", "16", "00", "11000", "11000000", "52.53319", "13.6088", "Europe/Berlin"),
("2907201", "Heinsberg", "Хайнсберг", "DE", "276", "07", "053", "05370", "", "51.06358", "6.0998", "Europe/Berlin"),
("2907545", "Heilbad Heiligenstadt", "Хайльбад-Хайлигенштадт", "DE", "276", "15", "00", "16061", "", "51.37819", "10.13744", "Europe/Berlin"),
("2907551", "Heiligensee", "", "DE", "276", "16", "00", "11000", "11000000", "52.61449", "13.24501", "Europe/Berlin"),
("2907585", "Heiligenhaus", "Хайлигенхаус", "DE", "276", "07", "051", "05158", "", "51.32662", "6.97106", "Europe/Berlin"),
("2907669", "Heilbronn", "Хайльбронн", "DE", "276", "01", "081", "08121", "08121000", "49.13995", "9.22054", "Europe/Berlin"),
("2907851", "Heidenheim an der Brenz", "Хайденхайм-на-Бренце", "DE", "276", "01", "081", "08135", "08135019", "48.67798", "10.15162", "Europe/Berlin"),
("2907887", "Heidenau", "Хайденау", "DE", "276", "13", "00", "14628", "", "50.97221", "13.86741", "Europe/Berlin"),
("2907911", "Heidelberg", "Хайдельберг", "DE", "276", "01", "082", "08221", "08221000", "49.40768", "8.69079", "Europe/Berlin"),
("2908032", "Heide", "Хайде", "DE", "276", "10", "00", "01051", "", "54.19579", "9.0988", "Europe/Berlin"),
("2908495", "Hechingen", "Хехинген", "DE", "276", "01", "084", "08417", "08417031", "48.35149", "8.96317", "Europe/Berlin"),
("2909230", "Hattingen", "Хаттинген", "DE", "276", "07", "", "", "", "51.39894", "7.18557", "Europe/Berlin"),
("2909240", "Hattersheim", "", "DE", "276", "05", "064", "", "", "50.07854", "8.47552", "Europe/Berlin"),
("2909313", "Hassloch", "", "DE", "276", "08", "00", "07332", "07332025", "49.36278", "8.25806", "Europe/Berlin"),
("2910278", "Harsewinkel", "Харзевинкель", "DE", "276", "07", "057", "", "", "51.96224", "8.22766", "Europe/Berlin"),
("2910514", "Haren", "", "DE", "276", "06", "", "", "", "52.79262", "7.24142", "Europe/Berlin"),
("2910685", "Harburg", "Харбург", "DE", "276", "04", "", "", "", "53.46057", "9.98388", "Europe/Berlin"),
("2910831", "Hannover", "Ганновер", "DE", "276", "06", "00", "", "", "52.37052", "9.73322", "Europe/Berlin"),
("2911007", "Hanau am Main", "", "DE", "276", "05", "064", "06413", "", "50.13423", "8.91418", "Europe/Berlin"),
("2911051", "Hamminkeln", "Хамминкельн", "DE", "276", "07", "051", "", "", "51.73262", "6.59031", "Europe/Berlin"),
("2911240", "Hamm", "Хамм", "DE", "276", "07", "059", "05915", "05915000", "51.68033", "7.82089", "Europe/Berlin"),
("2911271", "Hameln", "Хамельн", "DE", "276", "06", "00", "03252", "", "52.10397", "9.35623", "Europe/Berlin"),
("2911285", "Wandsbek", "", "DE", "276", "04", "", "", "", "53.56667", "10.1", "Europe/Berlin"),
("2911287", "Marienthal", "", "DE", "276", "04", "", "", "", "53.56667", "10.08333", "Europe/Berlin"),
("2911288", "Hamburg-Mitte", "", "DE", "276", "04", "", "", "", "53.55", "10.01667", "Europe/Berlin"),
("2911293", "Eimsbuettel", "Аймсбюттель", "DE", "276", "04", "", "", "", "53.56667", "9.98333", "Europe/Berlin"),
("2911296", "Altona", "Альтона", "DE", "276", "04", "", "", "", "53.55", "9.93333", "Europe/Berlin"),
("2911298", "Hamburg", "Гамбург", "DE", "276", "04", "", "", "", "53.57532", "10.01534", "Europe/Berlin"),
("2911384", "Halver", "Хальфер", "DE", "276", "07", "", "", "", "51.18612", "7.49817", "Europe/Berlin"),
("2911395", "Haltern", "Хальтерне", "DE", "276", "07", "055", "", "", "51.74297", "7.18163", "Europe/Berlin"),
("2911408", "Halstenbek", "", "DE", "276", "10", "00", "01056", "01056018", "53.63333", "9.85", "Europe/Berlin"),
("2911520", "Halle", "Галле", "DE", "276", "07", "", "", "", "52.06008", "8.36083", "Europe/Berlin"),
("2911522", "Halle (Saale)", "Галле", "DE", "276", "14", "", "", "", "51.5", "12", "Europe/Berlin"),
("2911584", "Haldensleben I", "Хальденслебен", "DE", "276", "14", "00", "15083", "", "52.28906", "11.40982", "Europe/Berlin"),
("2911665", "Halberstadt", "Хальберштадт", "DE", "276", "14", "00", "15085", "", "51.89562", "11.05622", "Europe/Berlin"),
("2911710", "Hakenfelde", "", "DE", "276", "16", "00", "11000", "11000000", "52.55877", "13.20831", "Europe/Berlin"),
("2911964", "Haiger", "Хайгер", "DE", "276", "05", "065", "", "", "50.74162", "8.20778", "Europe/Berlin"),
("2912621", "Hagen", "Хаген", "DE", "276", "07", "059", "05914", "", "51.36081", "7.47168", "Europe/Berlin"),
("2913192", "Haar", "Хар", "DE", "276", "02", "091", "09184", "09184123", "48.10881", "11.72653", "Europe/Berlin"),
("2913195", "Haan", "Хаан", "DE", "276", "07", "", "", "", "51.19382", "7.0133", "Europe/Berlin"),
("2913366", "Guetersloh", "Гютерсло", "DE", "276", "07", "057", "05754", "", "51.90693", "8.37854", "Europe/Berlin"),
("2913433", "Guestrow", "Гюстров", "DE", "276", "12", "00", "13072", "", "53.7972", "12.17337", "Europe/Berlin"),
("2913537", "Gunzenhausen", "Гунценхаузен", "DE", "276", "02", "095", "09577", "09577136", "49.11663", "10.75971", "Europe/Berlin"),
("2913555", "Guenzburg", "Гюнцбург", "DE", "276", "02", "097", "09774", "09774135", "48.45599", "10.27695", "Europe/Berlin"),
("2913761", "Gummersbach", "Гуммерсбах", "DE", "276", "07", "053", "05374", "", "51.02608", "7.56473", "Europe/Berlin"),
("2913922", "Guben", "Губен", "DE", "276", "11", "", "", "", "51.94987", "14.71447", "Europe/Berlin"),
("2914929", "Gross-Umstadt", "Грос-Умштадт", "DE", "276", "05", "", "", "", "49.86899", "8.9321", "Europe/Berlin"),
("2915196", "Grossostheim", "", "DE", "276", "02", "096", "09671", "09671122", "49.91986", "9.07596", "Europe/Berlin"),
("2915613", "Gross-Gerau", "Грос-Герау", "DE", "276", "05", "064", "06433", "", "49.92139", "8.48255", "Europe/Berlin"),
("2916630", "Grossenhain", "Гросенхайн", "DE", "276", "13", "", "", "", "51.28951", "13.5335", "Europe/Berlin"),
("2917138", "Gronau", "Гронау", "DE", "276", "07", "055", "", "", "52.21099", "7.02238", "Europe/Berlin"),
("2917221", "Grobenzell", "", "DE", "276", "02", "091", "09179", "09179126", "48.2", "11.36667", "Europe/Berlin"),
("2917325", "Grimma", "Гримма", "DE", "276", "13", "00", "", "", "51.23367", "12.71959", "Europe/Berlin"),
("2917412", "Griesheim", "", "DE", "276", "05", "", "", "", "49.86085", "8.5725", "Europe/Berlin"),
("2917540", "Grevenbroich", "Гревенброх", "DE", "276", "07", "051", "05162", "", "51.09102", "6.5827", "Europe/Berlin"),
("2917544", "Greven", "Гревен", "DE", "276", "07", "055", "", "", "52.09364", "7.59396", "Europe/Berlin"),
("2917737", "Greiz", "Грайц", "DE", "276", "15", "00", "16076", "", "50.65778", "12.19918", "Europe/Berlin"),
("2917788", "Greifswald", "Грайфсвальд", "DE", "276", "12", "00", "13075", "", "54.09311", "13.38786", "Europe/Berlin"),
("2917816", "Grefrath", "Грефрат", "DE", "276", "07", "051", "05166", "05166008", "51.3363", "6.34072", "Europe/Berlin"),
("2918632", "Goettingen", "Гёттинген", "DE", "276", "06", "00", "03152", "", "51.53443", "9.93228", "Europe/Berlin"),
("2918752", "Gotha", "Гота", "DE", "276", "15", "00", "16067", "", "50.94823", "10.70193", "Europe/Berlin"),
("2918840", "Goslar", "Гослар", "DE", "276", "06", "00", "03153", "", "51.90425", "10.42766", "Europe/Berlin"),
("2918987", "Goerlitz", "Гёрлиц", "DE", "276", "13", "00", "14626", "", "51.15518", "14.98853", "Europe/Berlin"),
("2919054", "Goeppingen", "Гёппинген", "DE", "276", "01", "081", "08117", "08117026", "48.70354", "9.65209", "Europe/Berlin"),
("2919625", "Goch", "Гох", "DE", "276", "07", "051", "", "", "51.67873", "6.15895", "Europe/Berlin"),
("2919880", "Glinde", "", "DE", "276", "10", "", "", "", "53.5441", "10.20048", "Europe/Berlin"),
("2920020", "Glauchau", "Глаухау", "DE", "276", "13", "", "", "", "50.81987", "12.54493", "Europe/Berlin"),
("2920236", "Gladbeck", "Гладбек", "DE", "276", "07", "055", "", "", "51.57077", "6.98593", "Europe/Berlin"),
("2920329", "Ginsheim-Gustavsburg", "Гинсхайм-Густавсбург", "DE", "276", "05", "064", "06433", "06433005", "49.9711", "8.34532", "Europe/Berlin"),
("2920433", "Gilching", "", "DE", "276", "02", "091", "09188", "09188121", "48.10755", "11.2936", "Europe/Berlin"),
("2920478", "Gifhorn", "Гифхорн", "DE", "276", "06", "00", "03151", "", "52.47774", "10.5511", "Europe/Berlin"),
("2920512", "Giessen", "Гиссен", "DE", "276", "05", "065", "", "", "50.58727", "8.67554", "Europe/Berlin"),
("2920620", "Giengen an der Brenz", "Гинген-на-Бренце", "DE", "276", "01", "081", "08135", "08135016", "48.62219", "10.24312", "Europe/Berlin"),
("2920757", "Gevelsberg", "Гефельсберг", "DE", "276", "07", "", "", "", "51.31971", "7.3392", "Europe/Berlin"),
("2920789", "Gesundbrunnen", "", "DE", "276", "16", "00", "11000", "11000000", "52.55035", "13.39139", "Europe/Berlin"),
("2920834", "Geseke", "Гезеке", "DE", "276", "07", "", "", "", "51.64091", "8.5109", "Europe/Berlin"),
("2920842", "Gescher", "Гешер", "DE", "276", "07", "055", "", "", "51.954", "7.00481", "Europe/Berlin"),
("2920891", "Gersthofen", "Герстхофен", "DE", "276", "02", "097", "09772", "09772147", "48.42432", "10.87273", "Europe/Berlin"),
("2921034", "Germersheim", "Гермерсхайм", "DE", "276", "08", "00", "07334", "", "49.22306", "8.36389", "Europe/Berlin"),
("2921039", "Germering", "Гермеринг", "DE", "276", "02", "091", "09179", "09179123", "48.13392", "11.3765", "Europe/Berlin"),
("2921061", "Gerlingen", "Герлинген", "DE", "276", "01", "081", "08118", "08118019", "48.79954", "9.06316", "Europe/Berlin"),
("2921139", "Geretsried", "", "DE", "276", "02", "091", "09173", "09173126", "47.85775", "11.48054", "Europe/Berlin"),
("2921232", "Gera", "Гера", "DE", "276", "15", "", "", "", "50.88029", "12.08187", "Europe/Berlin"),
("2921242", "Georgsmarienhutte", "Георгсмариенхютте", "DE", "276", "06", "", "", "", "52.20296", "8.0448", "Europe/Berlin"),
("2921466", "Gelsenkirchen", "Гельзенкирхен", "DE", "276", "07", "055", "05513", "", "51.5075", "7.12283", "Europe/Berlin"),
("2921473", "Gelnhausen", "Гельнхаузен", "DE", "276", "05", "064", "06435", "", "50.20164", "9.18742", "Europe/Berlin"),
("2921528", "Geldern", "Гельдерн", "DE", "276", "07", "", "", "", "51.51908", "6.32363", "Europe/Berlin"),
("2921653", "Geislingen an der Steige", "Гайслинген-ан-дер-Штайге", "DE", "276", "01", "081", "08117", "08117024", "48.62423", "9.82736", "Europe/Berlin"),
("2921837", "Geilenkirchen", "Гейленкирхен", "DE", "276", "07", "", "", "", "50.96745", "6.11763", "Europe/Berlin"),
("2922102", "Geesthacht", "Гестахт", "DE", "276", "10", "", "", "", "53.43575", "10.3779", "Europe/Berlin"),
("2922230", "Gauting", "", "DE", "276", "02", "091", "09188", "09188120", "48.06919", "11.37703", "Europe/Berlin"),
("2922530", "Garmisch-Partenkirchen", "Гармиш-Партенкирхен", "DE", "276", "02", "091", "09180", "09180117", "47.49209", "11.09576", "Europe/Berlin"),
("2922582", "Garching bei Munchen", "Гархинг", "DE", "276", "02", "091", "09184", "09184119", "48.24896", "11.65101", "Europe/Berlin"),
("2922586", "Garbsen", "Гарбсен", "DE", "276", "06", "", "", "", "52.41371", "9.5899", "Europe/Berlin"),
("2922731", "Ganderkesee", "Гандеркезе", "DE", "276", "06", "00", "03458", "03458005", "53.03333", "8.53333", "Europe/Berlin"),
("2923362", "Gaggenau", "Гаггенау", "DE", "276", "01", "082", "08216", "08216015", "48.8", "8.33333", "Europe/Berlin"),
("2923544", "Furth", "Фюрт", "DE", "276", "02", "095", "09563", "09563000", "49.47593", "10.98856", "Europe/Berlin"),
("2923588", "Furstenwalde", "Фюрстенвальде", "DE", "276", "11", "", "", "", "52.36067", "14.06185", "Europe/Berlin"),
("2923625", "Fuerstenfeldbruck", "Фюрстенфельдбрук", "DE", "276", "02", "091", "09179", "09179121", "48.17904", "11.2547", "Europe/Berlin"),
("2923822", "Fulda", "Фульда", "DE", "276", "05", "066", "06631", "", "50.55162", "9.67518", "Europe/Berlin"),
("2924206", "Frondenberg", "Фрёнденберг-на-Руре", "DE", "276", "07", "059", "", "", "51.47563", "7.76946", "Europe/Berlin"),
("2924302", "Frohnau", "", "DE", "276", "16", "00", "11000", "11000000", "52.63336", "13.29024", "Europe/Berlin"),
("2924360", "Friesoythe", "Фризойте", "DE", "276", "06", "", "", "", "53.0226", "7.85764", "Europe/Berlin"),
("2924573", "Friedrichshain Bezirk", "", "DE", "276", "16", "00", "11000", "11000000", "52.51559", "13.45482", "Europe/Berlin"),
("2924577", "Friedrichshagen", "", "DE", "276", "16", "00", "11000", "11000000", "52.45052", "13.62463", "Europe/Berlin"),
("2924585", "Friedrichshafen", "Фридрихсхафен", "DE", "276", "01", "084", "08435", "08435016", "47.65689", "9.47554", "Europe/Berlin"),
("2924599", "Friedrichsfelde", "", "DE", "276", "16", "00", "11000", "11000000", "52.50575", "13.50812", "Europe/Berlin"),
("2924625", "Friedrichsdorf", "Фридрихсдорф", "DE", "276", "05", "064", "", "", "50.24962", "8.64281", "Europe/Berlin"),
("2924770", "Friedenau", "Фриденау", "DE", "276", "16", "00", "11000", "11000000", "52.47133", "13.32813", "Europe/Berlin"),
("2924802", "Friedberg", "Фридберг", "DE", "276", "05", "064", "06440", "", "50.33739", "8.75591", "Europe/Berlin"),
("2924803", "Friedberg", "Фридберг", "DE", "276", "02", "097", "09771", "09771130", "48.35693", "10.98461", "Europe/Berlin"),
("2924894", "Freudenstadt", "Фройденштадт", "DE", "276", "01", "082", "08237", "08237028", "48.46695", "8.41371", "Europe/Berlin"),
("2924915", "Freudenberg", "", "DE", "276", "07", "", "", "", "50.89741", "7.87414", "Europe/Berlin"),
("2925017", "Freital", "Фрайталь", "DE", "276", "13", "00", "", "", "51.00166", "13.6488", "Europe/Berlin"),
("2925034", "Freising", "Фрайзинг", "DE", "276", "02", "091", "09178", "09178124", "48.40351", "11.74876", "Europe/Berlin"),
("2925080", "Freilassing", "Фрайлассинг", "DE", "276", "02", "091", "09172", "09172118", "47.84085", "12.98114", "Europe/Berlin"),
("2925177", "Freiburg", "Фрайбург", "DE", "276", "01", "083", "08311", "08311000", "47.9959", "7.85222", "Europe/Berlin"),
("2925189", "Freiberg am Neckar", "Фрайберг-на-Неккаре", "DE", "276", "01", "081", "08118", "08118078", "48.93196", "9.2024", "Europe/Berlin"),
("2925192", "Freiberg", "Фрайберг", "DE", "276", "13", "00", "14522", "", "50.91089", "13.33881", "Europe/Berlin"),
("2925259", "Frechen", "Фрехен", "DE", "276", "07", "053", "05362", "", "50.91485", "6.8118", "Europe/Berlin"),
("2925533", "Frankfurt am Main", "Франкфурт-на-Майне", "DE", "276", "05", "064", "06412", "", "50.11552", "8.68417", "Europe/Berlin"),
("2925535", "Frankfurt (Oder)", "Франкфурт-на-Одере", "DE", "276", "11", "", "", "", "52.34714", "14.55062", "Europe/Berlin"),
("2925550", "Frankenthal", "Франкенталь", "DE", "276", "08", "00", "07311", "", "49.53414", "8.35357", "Europe/Berlin"),
("2925629", "Frankenberg", "Франкенберг", "DE", "276", "05", "", "", "", "51.0589", "8.80077", "Europe/Berlin"),
("2925630", "Frankenberg", "Франкенберг", "DE", "276", "13", "", "", "", "50.91297", "13.04011", "Europe/Berlin"),
("2925832", "Forst", "Форст", "DE", "276", "11", "00", "12071", "", "51.73544", "14.63971", "Europe/Berlin"),
("2925910", "Forchheim", "Форххайм", "DE", "276", "02", "094", "09474", "09474126", "49.71754", "11.05877", "Europe/Berlin"),
("2926120", "Florsheim", "", "DE", "276", "05", "064", "", "", "50.01312", "8.42779", "Europe/Berlin"),
("2926271", "Flensburg", "Фленсбург", "DE", "276", "10", "00", "01001", "", "54.78431", "9.43961", "Europe/Berlin"),
("2926670", "Finsterwalde", "Финстервальде", "DE", "276", "11", "", "", "", "51.63388", "13.70662", "Europe/Berlin"),
("2926716", "Finnentrop", "Финнентроп", "DE", "276", "07", "059", "05966", "05966012", "51.16667", "7.96667", "Europe/Berlin"),
("2927043", "Stuttgart Feuerbach", "", "DE", "276", "01", "081", "08111", "08111000", "48.80867", "9.15719", "Europe/Berlin"),
("2927268", "Fellbach", "Фелльбах", "DE", "276", "01", "081", "08119", "08119020", "48.80912", "9.27697", "Europe/Berlin"),
("2927930", "Falkensee", "Фалькензе", "DE", "276", "11", "", "", "", "52.56014", "13.0927", "Europe/Berlin"),
("2928381", "Eutin", "Ойтин", "DE", "276", "10", "00", "01055", "", "54.14054", "10.60751", "Europe/Berlin"),
("2928396", "Euskirchen", "Ойскирхен", "DE", "276", "07", "053", "05366", "", "50.66057", "6.78722", "Europe/Berlin"),
("2928615", "Ettlingen", "Эттлинген", "DE", "276", "01", "082", "08215", "08215017", "48.94094", "8.40763", "Europe/Berlin"),
("2928751", "Esslingen", "Эсслинген-на-Неккаре", "DE", "276", "01", "081", "08116", "08116019", "48.73961", "9.30473", "Europe/Berlin"),
("2928810", "Essen", "Эссен", "DE", "276", "07", "051", "05113", "", "51.45657", "7.01228", "Europe/Berlin"),
("2928874", "Espelkamp", "Эспелькамп", "DE", "276", "07", "", "", "", "52.3825", "8.62127", "Europe/Berlin"),
("2928963", "Eschweiler", "Эшвайлер", "DE", "276", "07", "053", "", "", "50.81854", "6.27184", "Europe/Berlin"),
("2928967", "Eschwege", "Эшвеге", "DE", "276", "05", "066", "06636", "", "51.18386", "10.05329", "Europe/Berlin"),
("2929134", "Eschborn", "Эшборн", "DE", "276", "05", "064", "", "", "50.14328", "8.57111", "Europe/Berlin"),
("2929247", "Erwitte", "Эрвитте", "DE", "276", "07", "", "", "", "51.6127", "8.3384", "Europe/Berlin"),
("2929567", "Erlangen", "Эрланген", "DE", "276", "02", "095", "09562", "09562000", "49.59099", "11.00783", "Europe/Berlin"),
("2929600", "Erkrath", "Эркрат", "DE", "276", "07", "051", "", "", "51.22235", "6.9083", "Europe/Berlin"),
("2929622", "Erkelenz", "Эркеленц", "DE", "276", "07", "", "", "", "51.07947", "6.31531", "Europe/Berlin"),
("2929670", "Erfurt", "Эрфурт", "DE", "276", "15", "", "", "", "50.9787", "11.03283", "Europe/Berlin"),
("2929671", "Erftstadt", "Эрфтштадт", "DE", "276", "07", "", "", "", "50.81481", "6.79386", "Europe/Berlin"),
("2929715", "Erding", "Эрдинг", "DE", "276", "02", "091", "09177", "09177117", "48.30603", "11.90686", "Europe/Berlin"),
("2929831", "Eppingen", "Эппинген", "DE", "276", "01", "081", "08125", "08125026", "49.13644", "8.91229", "Europe/Berlin"),
("2929865", "Eppelborn", "", "DE", "276", "09", "00", "10043", "10043111", "49.4", "6.96667", "Europe/Berlin"),
("2930030", "Ennigerloh", "Эннигерло", "DE", "276", "07", "055", "", "", "51.83843", "8.03093", "Europe/Berlin"),
("2930043", "Ennepetal", "Эннепеталь", "DE", "276", "07", "", "", "", "51.29848", "7.3629", "Europe/Berlin"),
("2930182", "Enger", "Энгер", "DE", "276", "07", "", "", "", "52.14063", "8.55772", "Europe/Berlin"),
("2930216", "Engelskirchen", "Энгельскирхен", "DE", "276", "07", "053", "05374", "05374008", "50.98333", "7.4", "Europe/Berlin"),
("2930449", "Emsdetten", "Эмсдеттен", "DE", "276", "07", "", "", "", "52.1734", "7.52781", "Europe/Berlin"),
("2930509", "Emmerich", "Эммерих", "DE", "276", "07", "051", "", "", "51.83933", "6.24792", "Europe/Berlin"),
("2930523", "Emmendingen", "", "DE", "276", "01", "083", "08316", "08316011", "48.12096", "7.85359", "Europe/Berlin"),
("2930596", "Emden", "Эмден", "DE", "276", "06", "00", "03402", "", "53.36745", "7.20778", "Europe/Berlin"),
("2930646", "Eltville", "", "DE", "276", "05", "064", "", "", "50.02858", "8.11754", "Europe/Berlin"),
("2930778", "Elsdorf", "", "DE", "276", "07", "053", "05362", "05362016", "50.93739", "6.56828", "Europe/Berlin"),
("2930821", "Elmshorn", "Эльмсхорн", "DE", "276", "10", "", "", "", "53.75396", "9.65339", "Europe/Berlin"),
("2930889", "Ellwangen", "Эльванген", "DE", "276", "01", "081", "08136", "08136019", "48.96164", "10.13173", "Europe/Berlin"),
("2931361", "Eitorf", "Айторф", "DE", "276", "07", "053", "05382", "05382016", "50.76667", "7.45", "Europe/Berlin"),
("2931414", "Eislingen", "Айзлинген", "DE", "276", "01", "081", "08117", "08117019", "48.69515", "9.70676", "Europe/Berlin"),
("2931481", "Eisenhuettenstadt", "Айзенхюттенштадт", "DE", "276", "11", "00", "12067", "12067120", "52.15", "14.65", "Europe/Berlin"),
("2931574", "Eisenach", "Айзенах", "DE", "276", "15", "00", "16063", "", "50.9807", "10.31522", "Europe/Berlin"),
("2931804", "Einbeck", "Айнбек", "DE", "276", "06", "", "", "", "51.82018", "9.86961", "Europe/Berlin"),
("2931871", "Eilenburg", "Айленбург", "DE", "276", "13", "00", "14730", "14730110", "51.45984", "12.63338", "Europe/Berlin"),
("2932924", "Ehingen", "Эхинген", "DE", "276", "01", "084", "08425", "08425033", "48.28259", "9.72749", "Europe/Berlin"),
("2933101", "Eggenstein-Leopoldshafen", "", "DE", "276", "01", "082", "08215", "08215102", "49.09006", "8.39879", "Europe/Berlin"),
("2933364", "Edewecht", "Эдевехт", "DE", "276", "06", "", "", "", "53.12699", "7.98406", "Europe/Berlin"),
("2933627", "Eckernforde", "Эккернфёрде", "DE", "276", "10", "", "", "", "54.46854", "9.83824", "Europe/Berlin"),
("2933882", "Eberswalde", "Эберсвальде", "DE", "276", "11", "00", "12060", "", "52.83492", "13.81951", "Europe/Berlin"),
("2933959", "Ebersbach an der Fils", "", "DE", "276", "01", "081", "08117", "08117018", "48.716", "9.5236", "Europe/Berlin"),
("2934020", "Eberbach", "Эбербах", "DE", "276", "01", "082", "08226", "08226013", "49.4668", "8.99016", "Europe/Berlin"),
("2934246", "Dusseldorf", "Дюссельдорф", "DE", "276", "07", "051", "", "", "51.22172", "6.77616", "Europe/Berlin"),
("2934486", "Dueren", "Дюрен", "DE", "276", "07", "053", "05358", "", "50.80434", "6.49299", "Europe/Berlin"),
("2934662", "Dulmen", "Дюльмен", "DE", "276", "07", "055", "", "", "51.83149", "7.28075", "Europe/Berlin"),
("2934691", "Duisburg", "Дуйсбург", "DE", "276", "07", "051", "05112", "", "51.43247", "6.76516", "Europe/Berlin"),
("2934728", "Duderstadt", "Дудерштадт", "DE", "276", "06", "00", "", "", "51.51312", "10.25951", "Europe/Berlin"),
("2935022", "Dresden", "Дрезден", "DE", "276", "13", "00", "", "", "51.05089", "13.73832", "Europe/Berlin"),
("2935042", "Drensteinfurt", "Дренштайнфурт", "DE", "276", "07", "055", "", "", "51.79535", "7.73815", "Europe/Berlin"),
("2935220", "Dreieich", "Драйайх", "DE", "276", "05", "", "", "", "50.01997", "8.69611", "Europe/Berlin"),
("2935517", "Dortmund", "Дортмунд", "DE", "276", "07", "059", "05913", "", "51.51494", "7.466", "Europe/Berlin"),
("2935530", "Dorsten", "Дорстен", "DE", "276", "07", "", "", "", "51.66166", "6.96514", "Europe/Berlin"),
("2935825", "Dormagen", "Дормаген", "DE", "276", "07", "051", "", "", "51.09683", "6.83167", "Europe/Berlin"),
("2936253", "Donauwoerth", "Донаувёрт", "DE", "276", "02", "097", "09779", "09779131", "48.71804", "10.7793", "Europe/Berlin"),
("2936267", "Donaueschingen", "Донауэшинген", "DE", "276", "01", "083", "08326", "08326012", "47.95514", "8.49707", "Europe/Berlin"),
("2936658", "Dobeln", "Дебельн", "DE", "276", "13", "00", "", "", "51.1221", "13.11027", "Europe/Berlin"),
("2936705", "Ditzingen", "Дитцинген", "DE", "276", "01", "081", "08118", "08118011", "48.82672", "9.06703", "Europe/Berlin"),
("2936871", "Dinslaken", "Динслакена", "DE", "276", "07", "051", "", "", "51.56227", "6.7434", "Europe/Berlin"),
("2936909", "Dingolfing", "Дингольфинг", "DE", "276", "02", "092", "09279", "09279112", "48.64244", "12.49283", "Europe/Berlin"),
("2936974", "Dillingen an der Donau", "Диллинген-на-Дунае", "DE", "276", "02", "097", "09773", "09773125", "48.58153", "10.49528", "Europe/Berlin"),
("2936977", "Dillingen", "", "DE", "276", "09", "", "", "", "49.35557", "6.72781", "Europe/Berlin"),
("2936985", "Dillenburg", "Дилленбург", "DE", "276", "05", "", "", "", "50.74114", "8.28699", "Europe/Berlin"),
("2937040", "Dietzenbach", "Дитценбах", "DE", "276", "05", "064", "06413", "", "50.00976", "8.77784", "Europe/Berlin"),
("2937317", "Diepholz", "Дипхольц", "DE", "276", "06", "00", "03251", "", "52.60783", "8.37005", "Europe/Berlin"),
("2937591", "Dieburg", "Дибург", "DE", "276", "05", "", "", "", "49.89738", "8.84613", "Europe/Berlin"),
("2937936", "Detmold", "Детмольд", "DE", "276", "07", "057", "", "", "51.93855", "8.87318", "Europe/Berlin"),
("2937959", "Dessau", "Дессау", "DE", "276", "14", "", "", "", "51.83864", "12.24555", "Europe/Berlin"),
("2938323", "Delmenhorst", "Дельменхорст", "DE", "276", "06", "00", "03401", "", "53.0511", "8.63091", "Europe/Berlin"),
("2938376", "Delitzsch", "Делич", "DE", "276", "13", "00", "", "", "51.52546", "12.34284", "Europe/Berlin"),
("2938389", "Delbruck", "Дельбрюк", "DE", "276", "07", "057", "", "", "51.76502", "8.56223", "Europe/Berlin"),
("2938540", "Deggendorf", "Деггендорф", "DE", "276", "02", "092", "09271", "09271119", "48.84086", "12.96068", "Europe/Berlin"),
("2938784", "Datteln", "Даттельн", "DE", "276", "07", "", "", "", "51.66667", "7.38333", "Europe/Berlin"),
("2938913", "Darmstadt", "Дармштадт", "DE", "276", "05", "064", "", "", "49.87167", "8.65027", "Europe/Berlin"),
("2939167", "Damme", "Дамме", "DE", "276", "06", "", "", "", "52.52157", "8.19793", "Europe/Berlin"),
("2939440", "Dahlem", "Далем", "DE", "276", "16", "00", "11000", "11000000", "52.4581", "13.28702", "Europe/Berlin"),
("2939623", "Dachau", "Дахау", "DE", "276", "02", "091", "09174", "09174115", "48.26", "11.43402", "Europe/Berlin"),
("2939658", "Cuxhaven", "Куксхафен", "DE", "276", "06", "00", "03352", "", "53.87176", "8.69087", "Europe/Berlin"),
("2939747", "Crimmitschau", "Криммичау", "DE", "276", "13", "00", "", "", "50.81644", "12.39045", "Europe/Berlin"),
("2939797", "Crailsheim", "Крайльсхайм", "DE", "276", "01", "081", "08127", "08127014", "49.13444", "10.07193", "Europe/Berlin"),
("2939811", "Cottbus", "Котбус", "DE", "276", "11", "00", "12052", "", "51.75769", "14.32888", "Europe/Berlin"),
("2939820", "Coswig", "Косвиг", "DE", "276", "13", "00", "", "", "51.13204", "13.58312", "Europe/Berlin"),
("2939945", "Coesfeld", "Косфельд", "DE", "276", "07", "055", "05558", "", "51.94349", "7.16809", "Europe/Berlin"),
("2939951", "Coburg", "Кобург", "DE", "276", "02", "094", "09463", "09463000", "50.25937", "10.96384", "Europe/Berlin"),
("2939969", "Cloppenburg", "Клоппенбург", "DE", "276", "06", "00", "03453", "", "52.84754", "8.045", "Europe/Berlin"),
("2939995", "Clausthal-Zellerfeld", "Клаусталь-Целлерфельд", "DE", "276", "06", "", "", "", "51.80949", "10.33821", "Europe/Berlin"),
("2940132", "Chemnitz", "Хемниц", "DE", "276", "13", "00", "14511", "14511000", "50.8357", "12.92922", "Europe/Berlin"),
("2940187", "Charlottenburg Bezirk", "Шарлоттенбург", "DE", "276", "16", "00", "11000", "11000000", "52.51667", "13.28333", "Europe/Berlin"),
("2940204", "Cham", "", "DE", "276", "02", "093", "09372", "09372116", "49.22565", "12.65501", "Europe/Berlin"),
("2940213", "Celle", "Целле", "DE", "276", "06", "00", "03351", "", "52.62264", "10.08047", "Europe/Berlin"),
("2940231", "Castrop-Rauxel", "Кастроп-Рауксель", "DE", "276", "07", "", "", "", "51.55657", "7.31155", "Europe/Berlin"),
("2940383", "Calw", "Кальв", "DE", "276", "01", "082", "08235", "08235085", "48.71419", "8.74031", "Europe/Berlin"),
("2940451", "Buxtehude", "Букстехуде", "DE", "276", "06", "", "", "", "53.46716", "9.68636", "Europe/Berlin"),
("2940512", "Butzbach", "Буцбах", "DE", "276", "05", "064", "", "", "50.43395", "8.67122", "Europe/Berlin"),
("2940938", "Burstadt", "Бюрштадт", "DE", "276", "05", "064", "", "", "49.64266", "8.45936", "Europe/Berlin"),
("2940942", "Burscheid", "Буршайд", "DE", "276", "07", "", "", "", "51.1", "7.11667", "Europe/Berlin"),
("2941279", "Burghausen", "", "DE", "276", "02", "091", "09171", "09171112", "48.16925", "12.83139", "Europe/Berlin"),
("2941405", "Burgdorf", "Бургдорф", "DE", "276", "06", "00", "03241", "03241003", "52.44628", "10.0064", "Europe/Berlin"),
("2941501", "Burg bei Magdeburg", "", "DE", "276", "14", "00", "15086", "", "52.27152", "11.85493", "Europe/Berlin"),
("2941570", "Buren", "Бюрен", "DE", "276", "07", "057", "", "", "51.55109", "8.55956", "Europe/Berlin"),
("2941694", "Buende", "Бюнде", "DE", "276", "07", "", "", "", "52.19837", "8.58644", "Europe/Berlin"),
("2941976", "Buhl", "Бюль", "DE", "276", "01", "082", "08216", "08216007", "48.69676", "8.13523", "Europe/Berlin"),
("2942073", "Budingen", "Бюдинген", "DE", "276", "05", "", "", "", "50.29013", "9.1114", "Europe/Berlin"),
("2942122", "Buckow", "", "DE", "276", "16", "00", "11000", "11000000", "52.432", "13.46018", "Europe/Berlin"),
("2942159", "Buckeburg", "Бюккебург", "DE", "276", "06", "00", "03257", "03257009", "52.26065", "9.04939", "Europe/Berlin"),
("2942323", "Buchholz in der Nordheide", "Бухгольц-ин-дер-Нордхайде", "DE", "276", "06", "", "", "", "53.32641", "9.86812", "Europe/Berlin"),
("2942341", "Buchholz", "", "DE", "276", "16", "00", "11000", "11000000", "52.60242", "13.43019", "Europe/Berlin"),
("2942634", "Buchen", "Бухен", "DE", "276", "01", "082", "08225", "08225014", "49.52416", "9.32293", "Europe/Berlin"),
("2943320", "Bruhl", "Брюль", "DE", "276", "07", "", "", "", "50.82928", "6.90499", "Europe/Berlin"),
("2943336", "Bruggen", "", "DE", "276", "07", "051", "05166", "05166004", "51.24053", "6.18376", "Europe/Berlin"),
("2943408", "Bruckmuhl", "", "DE", "276", "02", "091", "09187", "09187122", "47.87859", "11.91098", "Europe/Berlin"),
("2943560", "Bruchsal", "Брухзаль", "DE", "276", "01", "082", "08215", "08215009", "49.12426", "8.59804", "Europe/Berlin"),
("2943573", "Bruchkobel", "Брухкёбель", "DE", "276", "05", "", "", "", "50.17853", "8.92316", "Europe/Berlin"),
("2944027", "Britz", "", "DE", "276", "16", "00", "11000", "11000000", "52.44293", "13.43388", "Europe/Berlin"),
("2944079", "Brilon", "Брилон", "DE", "276", "07", "059", "", "", "51.39462", "8.57146", "Europe/Berlin"),
("2944200", "Bretten", "Бреттен", "DE", "276", "01", "082", "08215", "08215007", "49.03685", "8.70745", "Europe/Berlin"),
("2944354", "Bremervorde", "Бремерфёрде", "DE", "276", "06", "", "", "", "53.48458", "9.14306", "Europe/Berlin"),
("2944368", "Bremerhaven", "Бремерхафен", "DE", "276", "03", "00", "04012", "", "53.55021", "8.57674", "Europe/Berlin"),
("2944388", "Bremen", "Бремен", "DE", "276", "03", "00", "", "", "53.07516", "8.80777", "Europe/Berlin"),
("2945024", "Braunschweig", "Брауншвейг", "DE", "276", "06", "00", "03101", "", "52.26594", "10.52673", "Europe/Berlin"),
("2945358", "Brandenburg an der Havel", "Бранденбург", "DE", "276", "11", "", "", "", "52.41667", "12.55", "Europe/Berlin"),
("2945474", "Bramsche", "Брамше", "DE", "276", "06", "", "", "", "52.40881", "7.97288", "Europe/Berlin"),
("2945542", "Brakel", "Бракель", "DE", "276", "07", "", "", "", "51.7175", "9.18596", "Europe/Berlin"),
("2945545", "Brake (Unterweser)", "", "DE", "276", "06", "00", "03461", "", "53.33333", "8.48333", "Europe/Berlin"),
("2945591", "Brackenheim", "Бракенхайм", "DE", "276", "01", "081", "08125", "08125013", "49.07787", "9.06601", "Europe/Berlin"),
("2945756", "Bottrop", "Ботроп", "DE", "276", "07", "055", "05512", "", "51.52392", "6.9285", "Europe/Berlin"),
("2946111", "Bornheim", "Борнхайм", "DE", "276", "07", "", "", "", "50.76313", "6.99089", "Europe/Berlin"),
("2946172", "Borna", "Борна", "DE", "276", "13", "00", "14729", "", "51.12416", "12.49638", "Europe/Berlin"),
("2946228", "Borken", "Боркен", "DE", "276", "07", "055", "05554", "", "51.84382", "6.85774", "Europe/Berlin"),
("2946366", "Boppard", "Боппард", "DE", "276", "08", "", "", "", "50.23085", "7.58992", "Europe/Berlin"),
("2946447", "Bonn", "Бонн", "DE", "276", "07", "053", "05314", "", "50.73438", "7.09548", "Europe/Berlin"),
("2946478", "Bonen", "Бёнен", "DE", "276", "07", "059", "05978", "05978008", "51.6", "7.76667", "Europe/Berlin"),
("2947022", "Bogenhausen", "", "DE", "276", "02", "091", "09162", "09162000", "48.15221", "11.61585", "Europe/Berlin"),
("2947416", "Bochum", "Бохум", "DE", "276", "07", "059", "05911", "", "51.48165", "7.21648", "Europe/Berlin"),
("2947421", "Bocholt", "Бохольт", "DE", "276", "07", "051", "", "", "51.83879", "6.61531", "Europe/Berlin"),
("2947444", "Boeblingen", "Бёблинген", "DE", "276", "01", "081", "08115", "08115003", "48.68212", "9.01171", "Europe/Berlin"),
("2947449", "Bobingen", "Бобинген", "DE", "276", "02", "097", "09772", "09772125", "48.27091", "10.8339", "Europe/Berlin"),
("2947641", "Blomberg", "Бломберг", "DE", "276", "07", "057", "", "", "51.94331", "9.09067", "Europe/Berlin"),
("2947739", "Blieskastel", "Блискастель", "DE", "276", "09", "00", "", "", "49.23724", "7.25617", "Europe/Berlin"),
("2948071", "Blankenburg", "Бланкенбург", "DE", "276", "14", "", "", "", "51.79025", "10.95509", "Europe/Berlin"),
("2948164", "Bitterfeld-Wolfen", "Биттерфельд", "DE", "276", "13", "", "", "", "51.62355", "12.32396", "Europe/Berlin"),
("2948825", "Bingen am Rhein", "Бинген-на-Рейне", "DE", "276", "08", "", "", "", "49.96675", "7.8992", "Europe/Berlin"),
("2949012", "Bietigheim-Bissingen", "Битигхайм-Биссинген", "DE", "276", "01", "081", "08118", "08118079", "48.94407", "9.11755", "Europe/Berlin"),
("2949073", "Biesdorf", "", "DE", "276", "16", "00", "11000", "11000000", "52.50906", "13.5534", "Europe/Berlin"),
("2949186", "Bielefeld", "Билефельд", "DE", "276", "07", "057", "05711", "05711000", "52.03333", "8.53333", "Europe/Berlin"),
("2949423", "Biberach an der Riss", "Биберах-на-Рисе", "DE", "276", "01", "084", "08426", "08426021", "48.09345", "9.79053", "Europe/Berlin"),
("2949470", "Bexbach", "Бексбах", "DE", "276", "09", "00", "", "", "49.34615", "7.25527", "Europe/Berlin"),
("2949475", "Beverungen", "Беверунген", "DE", "276", "07", "", "", "", "51.66801", "9.37417", "Europe/Berlin"),
("2950073", "Bernburg", "Бернбург", "DE", "276", "14", "00", "15089", "", "51.79464", "11.7401", "Europe/Berlin"),
("2950096", "Bernau bei Berlin", "Бернау", "DE", "276", "11", "", "", "", "52.67982", "13.58708", "Europe/Berlin"),
("2950159", "Berlin", "Берлин", "DE", "276", "16", "00", "11000", "11000000", "52.52437", "13.41053", "Europe/Berlin"),
("2950294", "Bergneustadt", "Бергнойштадт", "DE", "276", "07", "", "", "", "51.02496", "7.65599", "Europe/Berlin"),
("2950344", "Bergkamen", "Бергкамен", "DE", "276", "07", "", "", "", "51.61633", "7.64451", "Europe/Berlin"),
("2950349", "Bergisch Gladbach", "Бергиш Гладбах", "DE", "276", "07", "053", "05378", "", "50.9856", "7.13298", "Europe/Berlin"),
("2950438", "Bergheim", "Бергем", "DE", "276", "07", "053", "05362", "", "50.95572", "6.63986", "Europe/Berlin"),
("2950978", "Bensheim", "Бенсхайм", "DE", "276", "05", "064", "", "", "49.68369", "8.61839", "Europe/Berlin"),
("2951111", "Bendorf", "Бендорф", "DE", "276", "08", "", "", "", "50.42289", "7.57924", "Europe/Berlin"),
("2951648", "Bedburg", "Бедбург", "DE", "276", "07", "053", "", "", "50.99258", "6.57128", "Europe/Berlin"),
("2951654", "Beckum", "Беккум", "DE", "276", "07", "055", "", "", "51.75571", "8.04075", "Europe/Berlin"),
("2951679", "Beckingen", "", "DE", "276", "09", "00", "10042", "10042111", "49.4", "6.7", "Europe/Berlin"),
("2951825", "Bayreuth", "Байройт", "DE", "276", "02", "094", "09462", "09462000", "49.94782", "11.57894", "Europe/Berlin"),
("2951881", "Bautzen", "Баутцен", "DE", "276", "13", "00", "14625", "", "51.18035", "14.43494", "Europe/Berlin"),
("2951923", "Baunatal", "Баунаталь", "DE", "276", "05", "066", "", "", "51.25182", "9.40747", "Europe/Berlin"),
("2951935", "Baumschulenweg", "", "DE", "276", "16", "00", "11000", "11000000", "52.46582", "13.48524", "Europe/Berlin"),
("2952252", "Bassum", "Бассум", "DE", "276", "06", "", "", "", "52.85059", "8.72791", "Europe/Berlin"),
("2952984", "Bamberg", "Бамберг", "DE", "276", "02", "094", "09461", "09461000", "49.89873", "10.90067", "Europe/Berlin"),
("2953089", "Balingen", "Балинген", "DE", "276", "01", "084", "08417", "08417002", "48.27525", "8.85464", "Europe/Berlin"),
("2953197", "Baiersbronn", "Байрсброн", "DE", "276", "01", "082", "08237", "08237004", "48.50318", "8.37699", "Europe/Berlin"),
("2953269", "Bahnhof Lohne", "", "DE", "276", "07", "", "", "", "52.20737", "8.7149", "Europe/Berlin"),
("2953302", "Baesweiler", "Бесвайлер", "DE", "276", "07", "", "", "", "50.90964", "6.18874", "Europe/Berlin"),
("2953310", "Bad Zwischenahn", "Бад-Цвишенан", "DE", "276", "06", "00", "03451", "03451002", "53.18333", "8", "Europe/Berlin"),
("2953317", "Bad Wildungen", "Бад-Вильдунген", "DE", "276", "05", "066", "", "", "51.11963", "9.12475", "Europe/Berlin"),
("2953320", "Bad Waldsee", "Бад-Вальдзе", "DE", "276", "01", "084", "08436", "08436009", "47.92027", "9.7549", "Europe/Berlin"),
("2953321", "Bad Vilbel", "Бад-Фильбель", "DE", "276", "05", "064", "", "", "50.17866", "8.73756", "Europe/Berlin"),
("2953324", "Bad Toelz", "Бад-Тёльц", "DE", "276", "02", "091", "09173", "09173112", "47.76111", "11.5589", "Europe/Berlin"),
("2953339", "Bad Soden am Taunus", "Бад-Зоден", "DE", "276", "05", "064", "", "", "50.1408", "8.50449", "Europe/Berlin"),
("2953341", "Bad Segeberg", "Бад-Зегеберг", "DE", "276", "10", "00", "01060", "", "53.94313", "10.30215", "Europe/Berlin"),
("2953347", "Bad Schwartau", "Бад-Швартау", "DE", "276", "10", "", "", "", "53.91887", "10.69691", "Europe/Berlin"),
("2953357", "Bad Salzungen", "Бад-Зальцунген", "DE", "276", "15", "00", "16063", "", "50.81342", "10.2361", "Europe/Berlin"),
("2953358", "Bad Salzuflen", "Бад-Зальцуфлен", "DE", "276", "07", "057", "", "", "52.0862", "8.74434", "Europe/Berlin"),
("2953363", "Bad Sackingen", "Бад-Зекинген", "DE", "276", "01", "083", "08337", "08337096", "47.55371", "7.94612", "Europe/Berlin"),
("2953371", "Bad Reichenhall", "Бад-Райхенхалль", "DE", "276", "02", "091", "09172", "09172114", "47.72947", "12.87819", "Europe/Berlin"),
("2953374", "Bad Rappenau", "Бад-Раппенау", "DE", "276", "01", "081", "08125", "08125006", "49.23848", "9.1018", "Europe/Berlin"),
("2953379", "Bad Pyrmont", "Бад-Пирмонт", "DE", "276", "06", "", "", "", "51.9859", "9.25246", "Europe/Berlin"),
("2953385", "Bad Oldesloe", "Бад-Ольдесло", "DE", "276", "10", "00", "01062", "", "53.81167", "10.37417", "Europe/Berlin"),
("2953386", "Bad Oeynhausen", "Бад-Эйнхаузен", "DE", "276", "07", "", "", "", "52.20699", "8.80365", "Europe/Berlin"),
("2953389", "Bad Neustadt an der Saale", "Бад-Нойштадт-ан-дер-Зале", "DE", "276", "02", "096", "09673", "09673114", "50.32174", "10.20673", "Europe/Berlin"),
("2953391", "Bad Neuenahr-Ahrweiler", "Бад-Нойенар-Арвайлер", "DE", "276", "08", "00", "07131", "", "50.54322", "7.1113", "Europe/Berlin"),
("2953395", "Bad Nauheim", "Бад-Наухайм", "DE", "276", "05", "064", "", "", "50.36463", "8.73859", "Europe/Berlin"),
("2953398", "Bad Munstereifel", "Бад-Мюнстерайфель", "DE", "276", "07", "053", "", "", "50.55666", "6.76424", "Europe/Berlin"),
("2953400", "Bad Munder am Deister", "Бад-Мюндер-ам-Дайстер", "DE", "276", "06", "", "", "", "52.19551", "9.46421", "Europe/Berlin"),
("2953402", "Bad Mergentheim", "", "DE", "276", "01", "081", "08128", "08128007", "49.4925", "9.77361", "Europe/Berlin"),
("2953405", "Bad Lippspringe", "Бад-Липшпринге", "DE", "276", "07", "", "", "", "51.78333", "8.81683", "Europe/Berlin"),
("2953413", "Bad Langensalza", "Бад-Лангензальца", "DE", "276", "15", "", "", "", "51.10771", "10.646", "Europe/Berlin"),
("2953416", "Bad Kreuznach", "Бад-Кройцнах", "DE", "276", "08", "00", "07133", "", "49.8414", "7.86713", "Europe/Berlin"),
("2953424", "Bad Kissingen", "Бад-Киссинген", "DE", "276", "02", "096", "09672", "09672114", "50.20228", "10.07784", "Europe/Berlin"),
("2953435", "Bad Honnef", "Бад-Хоннеф", "DE", "276", "07", "053", "05382", "05382008", "50.64336", "7.2278", "Europe/Berlin"),
("2953436", "Bad Homburg vor der Hoehe", "Бад-Хомбург", "DE", "276", "05", "064", "06434", "06434001", "50.22683", "8.61816", "Europe/Berlin"),
("2953439", "Bad Hersfeld", "Бад-Херсфельд", "DE", "276", "05", "066", "06632", "", "50.87197", "9.70891", "Europe/Berlin"),
("2953449", "Bad Harzburg", "Бад-Харцбурге", "DE", "276", "06", "", "", "", "51.88268", "10.56157", "Europe/Berlin"),
("2953464", "Bad Essen", "Бад-Эссен", "DE", "276", "06", "00", "03459", "03459003", "52.31667", "8.33333", "Europe/Berlin"),
("2953504", "Baden-Baden", "Баден-Баден", "DE", "276", "01", "082", "08211", "08211000", "48.7606", "8.23975", "Europe/Berlin"),
("2953522", "Bad Duerkheim", "Бад-Дюркхайм", "DE", "276", "08", "00", "07332", "", "49.4618", "8.17236", "Europe/Berlin"),
("2953525", "Bad Driburg", "Бад-Дрибург", "DE", "276", "07", "057", "", "", "51.73297", "9.01969", "Europe/Berlin"),
("2953545", "Bad Berleburg", "Бад-Берлебург", "DE", "276", "07", "059", "", "", "51.05224", "8.39228", "Europe/Berlin"),
("2953552", "Bad Bentheim", "Бад-Бентхайм", "DE", "276", "06", "", "", "", "52.31814", "7.16343", "Europe/Berlin"),
("2953558", "Bad Aibling", "Бад-Айблинг", "DE", "276", "02", "091", "09187", "09187117", "47.8638", "12.01055", "Europe/Berlin"),
("2953568", "Backnang", "Бакнанг", "DE", "276", "01", "081", "08119", "08119008", "48.94744", "9.43718", "Europe/Berlin"),
("2953770", "Babenhausen", "Бабенхаузен", "DE", "276", "05", "064", "", "", "49.96519", "8.95129", "Europe/Berlin"),
("2954006", "Aurich", "Аурих", "DE", "276", "06", "00", "03452", "", "53.46919", "7.48232", "Europe/Berlin"),
("2954172", "Augsburg", "Аугсбург", "DE", "276", "02", "097", "09761", "09761000", "48.37154", "10.89851", "Europe/Berlin"),
("2954602", "Auerbach", "", "DE", "276", "13", "", "", "", "50.51155", "12.40083", "Europe/Berlin"),
("2954695", "Aue", "Ауэ", "DE", "276", "13", "", "", "", "50.59034", "12.70657", "Europe/Berlin"),
("2954932", "Attendorn", "Аттендорн", "DE", "276", "07", "059", "", "", "51.12645", "7.90333", "Europe/Berlin"),
("2955168", "Aschersleben", "Ашерслебен", "DE", "276", "14", "", "", "", "51.75742", "11.46084", "Europe/Berlin"),
("2955224", "Ascheberg", "Ашеберг", "DE", "276", "07", "055", "05558", "05558004", "51.78333", "7.61667", "Europe/Berlin"),
("2955272", "Aschaffenburg", "Ашаффенбург", "DE", "276", "02", "096", "09661", "09661000", "49.97704", "9.15214", "Europe/Berlin"),
("2955421", "Bad Arolsen", "Бад-Арользен", "DE", "276", "05", "066", "", "", "51.37982", "9.01445", "Europe/Berlin"),
("2955439", "Arnstadt", "Арнштадте", "DE", "276", "15", "00", "16070", "", "50.84048", "10.95198", "Europe/Berlin"),
("2955471", "Arnsberg", "Арнсберге", "DE", "276", "07", "059", "", "", "51.38333", "8.08333", "Europe/Berlin"),
("2955770", "Apolda", "Апольде", "DE", "276", "15", "00", "16071", "", "51.02624", "11.51638", "Europe/Berlin"),
("2955936", "Ansbach", "Ансбах", "DE", "276", "02", "095", "09561", "09561000", "49.30481", "10.5931", "Europe/Berlin"),
("2956005", "Annaberg-Buchholz", "Аннаберг-Буххольц", "DE", "276", "13", "00", "14521", "", "50.57953", "13.00627", "Europe/Berlin"),
("2956093", "Angermunde", "Ангермюнде", "DE", "276", "11", "", "", "", "53.01499", "13.99924", "Europe/Berlin"),
("2956206", "Andernach", "Андернах", "DE", "276", "08", "", "", "", "50.43109", "7.40425", "Europe/Berlin"),
("2956656", "Amberg", "Амберг", "DE", "276", "02", "093", "09361", "09361000", "49.44287", "11.86267", "Europe/Berlin"),
("2956710", "Alzey", "", "DE", "276", "08", "00", "07331", "", "49.74657", "8.11513", "Europe/Berlin"),
("2956715", "Alzenau in Unterfranken", "", "DE", "276", "02", "096", "09671", "09671111", "50.0888", "9.06455", "Europe/Berlin"),
("2957185", "Altglienicke", "", "DE", "276", "16", "00", "11000", "11000000", "52.41116", "13.5355", "Europe/Berlin"),
("2957773", "Altenburg", "Альтенбург", "DE", "276", "15", "00", "16077", "", "50.98763", "12.43684", "Europe/Berlin"),
("2957886", "Altena", "Альтена", "DE", "276", "07", "", "", "", "51.29472", "7.67336", "Europe/Berlin"),
("2958024", "Altdorf", "", "DE", "276", "02", "095", "09574", "09574112", "49.3856", "11.3573", "Europe/Berlin"),
("2958128", "Alsfeld", "Альсфельд", "DE", "276", "05", "065", "", "", "50.75185", "9.27082", "Europe/Berlin"),
("2958141", "Alsdorf", "Альсдорф", "DE", "276", "07", "053", "", "", "50.87672", "6.16399", "Europe/Berlin"),
("2958516", "Alfter", "Альфтер", "DE", "276", "07", "053", "05382", "05382004", "50.73333", "7.01667", "Europe/Berlin"),
("2958533", "Alfeld", "Альфельд", "DE", "276", "06", "", "", "", "51.98382", "9.81989", "Europe/Berlin"),
("2958595", "Albstadt", "Альбштадт", "DE", "276", "01", "084", "08417", "08417079", "48.21644", "9.02596", "Europe/Berlin"),
("2958975", "Aichach", "Айхах", "DE", "276", "02", "097", "09771", "09771113", "48.45755", "11.13413", "Europe/Berlin"),
("2959083", "Ahrensburg", "Аренсбург", "DE", "276", "10", "", "", "", "53.67515", "10.22593", "Europe/Berlin"),
("2959223", "Ahlen", "Ален", "DE", "276", "07", "", "", "", "51.76338", "7.8887", "Europe/Berlin"),
("2959279", "Ahaus", "Ахаус", "DE", "276", "07", "055", "", "", "52.07936", "7.01344", "Europe/Berlin"),
("2959441", "Adlershof", "Адлерсхоф", "DE", "276", "16", "00", "11000", "11000000", "52.43548", "13.54825", "Europe/Berlin"),
("2959681", "Achim", "Ахим", "DE", "276", "06", "00", "03361", "03361001", "53.01416", "9.0263", "Europe/Berlin"),
("2959686", "Achern", "Ахерн", "DE", "276", "01", "083", "08317", "08317001", "48.63115", "8.07607", "Europe/Berlin"),
("2959927", "Aalen", "Ален", "DE", "276", "01", "081", "08136", "08136088", "48.83777", "10.0933", "Europe/Berlin"),
("3207197", "Vellmar", "Фельмар", "DE", "276", "05", "066", "", "", "51.35806", "9.47974", "Europe/Berlin"),
("3207567", "Rehlingen-Siersburg", "", "DE", "276", "09", "00", "10044", "10044114", "49.36667", "6.68333", "Europe/Berlin"),
("3209083", "Henstedt-Ulzburg", "Хенштедт-Ульцбург", "DE", "276", "10", "00", "01060", "01060039", "53.79132", "9.97979", "Europe/Berlin"),
("3247449", "Aachen", "Ахен", "DE", "276", "07", "053", "05334", "05334002", "50.77664", "6.08342", "Europe/Berlin"),
("3272460", "Morfelden-Walldorf", "", "DE", "276", "05", "", "", "", "49.99472", "8.58361", "Europe/Berlin"),
("3272941", "Riedstadt", "Ридштадт", "DE", "276", "05", "064", "", "", "49.83411", "8.49621", "Europe/Berlin"),
("3274966", "Lauda-Konigshofen", "Лауда-Кёнигсхофен", "DE", "276", "01", "081", "08128", "08128139", "49.56526", "9.70816", "Europe/Berlin"),
("3336891", "Filderstadt", "Фильдерштадт", "DE", "276", "01", "081", "08116", "08116077", "48.65698", "9.22049", "Europe/Berlin"),
("3336892", "Ostfildern", "", "DE", "276", "01", "081", "08116", "08116080", "48.72704", "9.24954", "Europe/Berlin"),
("3336893", "Rodgau", "Родгау", "DE", "276", "05", "064", "06438", "06438011", "50.02627", "8.88588", "Europe/Berlin"),
("3337408", "Gropiusstadt", "", "DE", "276", "16", "00", "11000", "11000000", "52.425", "13.46667", "Europe/Berlin"),
("3337504", "Seeheim-Jugenheim", "Зехайм-Югенхайм", "DE", "276", "05", "064", "06432", "06432022", "49.765", "8.65194", "Europe/Berlin"),
("6545288", "Charlottenburg-Nord", "", "DE", "276", "16", "00", "11000", "11000000", "52.53048", "13.29371", "Europe/Berlin"),
("6545310", "Mitte", "", "DE", "276", "16", "00", "11000", "11000000", "52.52003", "13.40489", "Europe/Berlin"),
("6550659", "Spremberg", "Шпремберг", "DE", "276", "11", "00", "12071", "12071372", "51.56971", "14.37355", "Europe/Berlin"),
("6558039", "Rheinstetten", "", "DE", "276", "01", "082", "08215", "08215108", "48.9685", "8.30704", "Europe/Berlin"),
("6691072", "Altstadt Sud", "", "DE", "276", "07", "053", "05315", "05315000", "50.93331", "6.95954", "Europe/Berlin"),
("6691073", "Altstadt Nord", "", "DE", "276", "07", "053", "05315", "05315000", "50.93893", "6.95752", "Europe/Berlin"),
("6691078", "Bilderstoeckchen", "", "DE", "276", "07", "053", "05315", "05315000", "50.96983", "6.92997", "Europe/Berlin"),
("6930414", "Stuttgart-Ost", "", "DE", "276", "01", "081", "08111", "08111000", "48.78363", "9.21032", "Europe/Berlin"),
("6941055", "Bochum-Hordel", "", "DE", "276", "07", "", "", "", "51.50168", "7.1756", "Europe/Berlin"),
("6944296", "St. Pauli", "", "DE", "276", "04", "", "", "", "53.557", "9.964", "Europe/Berlin"),
("7274677", "Eidelstedt", "", "DE", "276", "04", "00", "02000", "", "53.60697", "9.90538", "Europe/Berlin"),
("7289614", "Halle Neustadt", "", "DE", "276", "14", "", "", "", "51.47924", "11.91605", "Europe/Berlin"),
("7290243", "Bergedorf", "Бергедорф", "DE", "276", "04", "", "", "", "53.48462", "10.22904", "Europe/Berlin"),
("7290252", "Spandau", "", "DE", "276", "16", "00", "11000", "11000000", "52.5511", "13.19921", "Europe/Berlin"),
("7290254", "Berlin Schoeneberg", "", "DE", "276", "16", "00", "11000", "11000000", "52.48388", "13.3477", "Europe/Berlin"),
("7290255", "Berlin Treptow", "", "DE", "276", "16", "00", "11000", "11000000", "52.49376", "13.44469", "Europe/Berlin"),
("7290401", "Niederrad", "", "DE", "276", "05", "", "", "", "50.08309", "8.62852", "Europe/Berlin"),
("7302786", "Haselbachtal", "", "DE", "276", "13", "", "", "", "51.2357", "14.02576", "Europe/Berlin"),
("7932342", "Barmbek-Nord", "", "DE", "276", "04", "", "", "", "53.6052", "10.03988", "Europe/Berlin"),
("7932386", "Farmsen-Berne", "", "DE", "276", "04", "", "", "", "53.60639", "10.11972", "Europe/Berlin"),
("8334621", "Falkenhagener Feld", "", "DE", "276", "16", "00", "11000", "11000000", "52.55191", "13.16802", "Europe/Berlin"),
("8334622", "Neu-Hohenschoenhausen", "", "DE", "276", "16", "00", "11000", "11000000", "52.56681", "13.51255", "Europe/Berlin"),
("8334624", "Alt-Hohenschoenhausen", "", "DE", "276", "16", "00", "11000", "11000000", "52.54608", "13.5013", "Europe/Berlin"),
("8334625", "Fennpfuhl", "", "DE", "276", "16", "00", "11000", "11000000", "52.52921", "13.47267", "Europe/Berlin"),
("8354626", "Hamburg-Nord", "", "DE", "276", "04", "", "", "", "53.58935", "9.984", "Europe/Berlin"),
("8378906", "Burg Unter-Falkenstein", "", "DE", "276", "02", "091", "09187", "09187131", "47.7044", "12.10466", "Europe/Berlin"),
("8642860", "Gartenstadt", "", "DE", "276", "08", "", "", "", "49.45937", "8.40377", "Europe/Berlin"),
("2610319", "Viborg", "Виборг", "DK", "208", "18", "791", "", "", "56.45319", "9.40201", "Europe/Copenhagen"),
("2610613", "Vejle", "Вайле", "DK", "208", "21", "630", "", "", "55.70927", "9.5357", "Europe/Copenhagen"),
("2611828", "Taastrup", "Тааструп", "DK", "208", "17", "169", "", "", "55.65173", "12.29216", "Europe/Copenhagen"),
("2612045", "Svendborg", "Свеннборге", "DK", "208", "21", "479", "", "", "55.05982", "10.60677", "Europe/Copenhagen"),
("2612629", "Stenlose", "", "DK", "208", "17", "240", "", "", "55.76828", "12.19723", "Europe/Copenhagen"),
("2613102", "Sonderborg", "Сённенборг", "DK", "208", "21", "540", "", "", "54.90926", "9.80737", "Europe/Copenhagen"),
("2613460", "Slagelse", "Слагельсе", "DK", "208", "20", "330", "", "", "55.40276", "11.35459", "Europe/Copenhagen"),
("2613731", "Skive", "Скиве", "DK", "208", "18", "779", "", "", "56.56381", "9.04024", "Europe/Copenhagen"),
("2614030", "Silkeborg", "Силькеборг", "DK", "208", "18", "740", "", "", "56.1697", "9.54508", "Europe/Copenhagen"),
("2614481", "Roskilde", "Роскилле", "DK", "208", "20", "265", "", "", "55.64152", "12.08035", "Europe/Copenhagen"),
("2614600", "Rodovre", "", "DK", "208", "17", "175", "", "", "55.68062", "12.45373", "Europe/Copenhagen"),
("2614764", "Ringsted", "Рингстед", "DK", "208", "20", "329", "", "", "55.4426", "11.79011", "Europe/Copenhagen"),
("2615006", "Randers", "Рандерс", "DK", "208", "18", "730", "", "", "56.4607", "10.03639", "Europe/Copenhagen"),
("2615876", "Odense", "Оденсе", "DK", "208", "21", "461", "", "", "55.39594", "10.38831", "Europe/Copenhagen"),
("2615961", "Nykobing Falster", "Нюкёбинг Фальстер", "DK", "208", "20", "376", "", "", "54.76906", "11.87425", "Europe/Copenhagen"),
("2616015", "Nyborg", "", "DK", "208", "21", "450", "", "", "55.31274", "10.78964", "Europe/Copenhagen"),
("2616038", "Naestved", "Нествед", "DK", "208", "20", "370", "", "", "55.22992", "11.76092", "Europe/Copenhagen"),
("2617658", "Lillerod", "", "DK", "208", "17", "201", "", "", "55.87496", "12.34579", "Europe/Copenhagen"),
("2618361", "Korsor", "", "DK", "208", "20", "330", "", "", "55.32993", "11.13857", "Europe/Copenhagen"),
("2618415", "Koge", "Кеге", "DK", "208", "20", "259", "", "", "55.45802", "12.18214", "Europe/Copenhagen"),
("2618425", "Copenhagen", "Копенгаген", "DK", "208", "17", "101", "", "", "55.67594", "12.56553", "Europe/Copenhagen"),
("2618528", "Kolding", "Колдинг", "DK", "208", "21", "621", "", "", "55.4904", "9.47216", "Europe/Copenhagen"),
("2619154", "Kalundborg", "", "DK", "208", "20", "326", "", "", "55.67954", "11.08864", "Europe/Copenhagen"),
("2619377", "Ishoj", "", "DK", "208", "17", "183", "", "", "55.61543", "12.35182", "Europe/Copenhagen"),
("2619528", "Hvidovre", "Хвидовре", "DK", "208", "17", "167", "", "", "55.65719", "12.47364", "Europe/Copenhagen"),
("2619771", "Horsens", "Хорсенс", "DK", "208", "18", "615", "", "", "55.86066", "9.85034", "Europe/Copenhagen"),
("2619856", "Horsholm", "Херсхольм", "DK", "208", "17", "223", "", "", "55.88098", "12.50111", "Europe/Copenhagen"),
("2620046", "Holstebro", "Хольстебро", "DK", "208", "18", "661", "", "", "56.36009", "8.61607", "Europe/Copenhagen"),
("2620147", "Holbaek", "Хольбек", "DK", "208", "20", "316", "", "", "55.71354", "11.7169", "Europe/Copenhagen"),
("2620214", "Hjorring", "", "DK", "208", "19", "860", "", "", "57.46417", "9.98229", "Europe/Copenhagen"),
("2620320", "Hillerod", "Хиллерод", "DK", "208", "17", "219", "", "", "55.92791", "12.30081", "Europe/Copenhagen"),
("2620425", "Herning", "Хернинг", "DK", "208", "18", "657", "", "", "56.13932", "8.97378", "Europe/Copenhagen"),
("2620473", "Helsingor", "Хельсингёр", "DK", "208", "17", "217", "", "", "56.03606", "12.6136", "Europe/Copenhagen"),
("2620964", "Haderslev", "Хадерслев", "DK", "208", "21", "510", "", "", "55.25377", "9.48982", "Europe/Copenhagen"),
("2621215", "Greve", "", "DK", "208", "20", "253", "", "", "55.58333", "12.3", "Europe/Copenhagen"),
("2621356", "Glostrup", "", "DK", "208", "17", "161", "", "", "55.6666", "12.40377", "Europe/Copenhagen"),
("2621927", "Frederikshavn", "Фредериксхавн", "DK", "208", "19", "813", "", "", "57.44073", "10.53661", "Europe/Copenhagen"),
("2621942", "Frederiksberg", "Фредериксберг", "DK", "208", "17", "147", "", "", "55.67938", "12.53463", "Europe/Copenhagen"),
("2621951", "Fredericia", "Фредерисия", "DK", "208", "21", "607", "", "", "55.56568", "9.75257", "Europe/Copenhagen"),
("2622306", "Farum", "Фарум", "DK", "208", "17", "190", "", "", "55.80858", "12.36066", "Europe/Copenhagen"),
("2622447", "Esbjerg", "Эсбьерг", "DK", "208", "21", "561", "", "", "55.47028", "8.45187", "Europe/Copenhagen"),
("2623188", "Charlottenlund", "", "DK", "208", "17", "157", "", "", "55.75367", "12.59181", "Europe/Copenhagen"),
("2624112", "Birkerod", "", "DK", "208", "17", "230", "", "", "55.84759", "12.42791", "Europe/Copenhagen"),
("2624341", "Ballerup", "", "DK", "208", "17", "151", "", "", "55.73165", "12.36328", "Europe/Copenhagen"),
("2624652", "Arhus", "Орхус", "DK", "208", "18", "751", "", "", "56.15674", "10.21076", "Europe/Copenhagen"),
("2624886", "Aalborg", "Ольборг", "DK", "208", "19", "851", "", "", "57.048", "9.9187", "Europe/Copenhagen"),
("2624906", "Albertslund", "Альбертслунн", "DK", "208", "17", "165", "", "", "55.65691", "12.36381", "Europe/Copenhagen"),
("2625070", "Aabenraa", "", "DK", "208", "21", "580", "", "", "55.04434", "9.41741", "Europe/Copenhagen"),
("3491941", "Villa Francisca", "", "DO", "214", "34", "", "", "", "18.46667", "-69.9", "America/Santo_Domingo"),
("3491946", "Villa Consuelo", "", "DO", "214", "34", "", "", "", "18.48333", "-69.9", "America/Santo_Domingo"),
("3491948", "Villa Bisono", "", "DO", "214", "25", "", "", "", "19.56378", "-70.87582", "America/Santo_Domingo"),
("3491952", "Villa Altagracia", "Вилья-Альтаграсия", "DO", "214", "33", "", "", "", "18.67297", "-70.17095", "America/Santo_Domingo"),
("3492517", "Tamboril", "", "DO", "214", "25", "", "", "", "19.48538", "-70.61104", "America/Santo_Domingo"),
("3492908", "Santo Domingo", "Санто-Доминго", "DO", "214", "34", "", "", "", "18.50012", "-69.98857", "America/Santo_Domingo"),
("3492914", "Santiago de los Caballeros", "Сантьяго-де-лос-Кабальерос", "DO", "214", "25", "", "", "", "19.4517", "-70.69703", "America/Santo_Domingo"),
("3492984", "Santa Cruz de El Seibo", "", "DO", "214", "28", "", "", "", "18.76559", "-69.03886", "America/Santo_Domingo"),
("3492985", "Santa Cruz de Barahona", "Санта-Крус-де-Бараона", "DO", "214", "03", "", "", "", "18.20854", "-71.10077", "America/Santo_Domingo"),
("3493032", "San Pedro de Macoris", "", "DO", "214", "24", "", "", "", "18.46156", "-69.29718", "America/Santo_Domingo"),
("3493081", "San Juan de la Maguana", "", "DO", "214", "23", "", "", "", "18.80588", "-71.22991", "America/Santo_Domingo"),
("3493100", "San Jose de Ocoa", "", "DO", "214", "36", "", "", "", "18.54661", "-70.50631", "America/Santo_Domingo"),
("3493146", "San Francisco de Macoris", "", "DO", "214", "06", "", "", "", "19.30099", "-70.25259", "America/Santo_Domingo"),
("3493174", "San Fernando de Monte Cristi", "", "DO", "214", "15", "", "", "", "19.84826", "-71.64597", "America/Santo_Domingo"),
("3493175", "Puerto Plata", "", "DO", "214", "18", "3494269", "", "", "19.79344", "-70.6884", "America/Santo_Domingo"),
("3493240", "Salvaleon de Higuey", "", "DO", "214", "10", "", "", "", "18.61501", "-68.70798", "America/Santo_Domingo"),
("3493283", "Salcedo", "", "DO", "214", "19", "", "", "", "19.37762", "-70.41762", "America/Santo_Domingo"),
("3493383", "Sabaneta", "", "DO", "214", "26", "", "", "", "19.47793", "-71.34125", "America/Santo_Domingo"),
("3493482", "Sabana Grande de Boya", "", "DO", "214", "32", "", "", "", "18.94498", "-69.79331", "America/Santo_Domingo"),
("3493769", "Rio Grande", "", "DO", "214", "18", "", "", "", "19.66667", "-70.76667", "America/Santo_Domingo"),
("3494121", "Quisqueya", "", "DO", "214", "24", "", "", "", "18.55542", "-69.40814", "America/Santo_Domingo"),
("3494242", "Punta Cana", "Пунта Кана", "DO", "214", "23", "", "", "", "18.58182", "-68.40431", "America/Santo_Domingo"),
("3495857", "Neiba", "", "DO", "214", "02", "3495858", "", "", "18.48138", "-71.41965", "America/Santo_Domingo"),
("3496021", "Nagua", "Нагуа", "DO", "214", "14", "", "", "", "19.3832", "-69.8474", "America/Santo_Domingo"),
("3496134", "Monte Plata", "Монте Плата", "DO", "214", "32", "", "", "", "18.807", "-69.78399", "America/Santo_Domingo"),
("3496331", "Moca", "", "DO", "214", "08", "3496332", "", "", "19.39352", "-70.52598", "America/Santo_Domingo"),
("3496831", "Mao", "Мао", "DO", "214", "27", "", "", "", "19.55186", "-71.07813", "America/Santo_Domingo"),
("3500370", "Las Matas de Farfan", "Лас-Матас-де-Фарфан", "DO", "214", "23", "", "", "", "18.87309", "-71.51656", "America/Santo_Domingo"),
("3500957", "La Romana", "Ла-Романа", "DO", "214", "12", "", "", "", "18.42734", "-68.97285", "America/Santo_Domingo"),
("3504158", "Jarabacoa", "Харабакоа", "DO", "214", "30", "", "", "", "19.12178", "-70.64218", "America/Santo_Domingo"),
("3504765", "Hato Mayor del Rey", "", "DO", "214", "29", "", "", "", "18.76278", "-69.25681", "America/Santo_Domingo"),
("3505855", "Esperanza", "", "DO", "214", "27", "", "", "", "19.5847", "-70.98489", "America/Santo_Domingo"),
("3508952", "Dajabon", "", "DO", "214", "04", "", "", "", "19.54878", "-71.70829", "America/Santo_Domingo"),
("3509207", "Cotui", "", "DO", "214", "21", "", "", "", "19.05272", "-70.14939", "America/Santo_Domingo"),
("3509363", "Constanza", "Констанция", "DO", "214", "30", "", "", "", "18.90919", "-70.74499", "America/Santo_Domingo"),
("3509382", "Concepcion de La Vega", "", "DO", "214", "30", "", "", "", "19.22207", "-70.52956", "America/Santo_Domingo"),
("3509578", "Ciudad Nueva", "", "DO", "214", "34", "", "", "", "18.46667", "-69.9", "America/Santo_Domingo"),
("3511233", "Bonao", "Бонао", "DO", "214", "31", "", "", "", "18.93687", "-70.40923", "America/Santo_Domingo"),
("3511336", "Boca Chica", "Бока Чика", "DO", "214", "37", "", "", "", "18.45174", "-69.60914", "America/Santo_Domingo"),
("3511540", "San Cristobal", "", "DO", "214", "33", "", "", "", "18.41667", "-70.1", "America/Santo_Domingo"),
("3511550", "Bella Vista", "", "DO", "214", "34", "", "", "", "18.45", "-69.93333", "America/Santo_Domingo"),
("3511626", "Bayaguana", "", "DO", "214", "32", "", "", "", "18.75639", "-69.63616", "America/Santo_Domingo"),
("3512067", "Bani", "Бан", "DO", "214", "35", "", "", "", "18.27964", "-70.33184", "America/Santo_Domingo"),
("3512128", "Bajos de Haina", "", "DO", "214", "33", "", "", "", "18.41538", "-70.03317", "America/Santo_Domingo"),
("3512208", "Azua", "Асуа-де-Компостела", "DO", "214", "01", "3512211", "", "", "18.45319", "-70.7349", "America/Santo_Domingo"),
("7874116", "Santo Domingo Oeste", "", "DO", "214", "37", "", "", "", "18.5", "-70", "America/Santo_Domingo"),
("2474141", "Boumerdas", "Бумердес", "DZ", "12", "40", "", "", "", "36.76639", "3.47717", "Africa/Algiers"),
("2474506", "Zeribet el Oued", "", "DZ", "12", "19", "", "", "", "34.68284", "6.51109", "Africa/Algiers"),
("2474583", "Zeralda", "", "DZ", "12", "55", "", "", "", "36.71169", "2.84244", "Africa/Algiers"),
("2474638", "Zemoura", "", "DZ", "12", "51", "", "", "", "35.72251", "0.75509", "Africa/Algiers"),
("2475475", "Touggourt", "Туггурт", "DZ", "12", "50", "", "", "", "33.10527", "6.05796", "Africa/Algiers"),
("2475612", "Tolga", "Толга", "DZ", "12", "19", "", "", "", "34.72224", "5.37845", "Africa/Algiers"),
("2475687", "Tlemcen", "Тлемсен", "DZ", "12", "15", "", "", "", "34.87833", "-1.315", "Africa/Algiers"),
("2475740", "Tizi Rached", "", "DZ", "12", "14", "", "", "", "36.67176", "4.19176", "Africa/Algiers"),
("2475744", "Tizi Ouzou", "Тизи-Узу", "DZ", "12", "14", "", "", "", "36.71182", "4.04591", "Africa/Algiers"),
("2475752", "Tizi-n-Tleta", "", "DZ", "12", "14", "", "", "", "36.54569", "4.05712", "Africa/Algiers"),
("2475764", "Tizi Gheniff", "", "DZ", "12", "40", "", "", "", "36.58839", "3.77445", "Africa/Algiers"),
("2475860", "Tissemsilt", "", "DZ", "12", "56", "", "", "", "35.60722", "1.81081", "Africa/Algiers"),
("2475921", "Tirmitine", "", "DZ", "12", "14", "", "", "", "36.65393", "3.98143", "Africa/Algiers"),
("2476028", "Tipasa", "Типаса", "DZ", "12", "55", "", "", "", "36.58972", "2.4475", "Africa/Algiers"),
("2476301", "Tindouf", "Тиндуф", "DZ", "12", "54", "", "", "", "27.67111", "-8.14744", "Africa/Algiers"),
("2476396", "Timizart", "", "DZ", "12", "14", "", "", "", "36.8", "4.26667", "Africa/Algiers"),
("2476403", "Timimoun", "", "DZ", "12", "34", "", "", "", "29.26388", "0.23098", "Africa/Algiers"),
("2476412", "el hed", "", "DZ", "12", "18", "", "", "", "36.65", "4.77361", "Africa/Algiers"),
("2476897", "Tiaret", "Тиарет", "DZ", "12", "13", "", "", "", "35.37103", "1.31699", "Africa/Algiers"),
("2476915", "Theniet el Had", "", "DZ", "12", "35", "", "", "", "35.87111", "2.02806", "Africa/Algiers"),
("2476917", "Thenia", "", "DZ", "12", "40", "", "", "", "36.72544", "3.55665", "Africa/Algiers"),
("2477255", "Telerghma", "", "DZ", "12", "48", "", "", "", "36.11653", "6.35434", "Africa/Algiers"),
("2477461", "Tebessa", "Тебесса", "DZ", "12", "33", "", "", "", "35.40417", "8.12417", "Africa/Algiers"),
("2477462", "Tebesbest", "", "DZ", "12", "50", "", "", "", "33.11667", "6.08333", "Africa/Algiers"),
("2477528", "Tazoult-Lambese", "", "DZ", "12", "03", "", "", "", "35.48171", "6.26074", "Africa/Algiers"),
("2478216", "Tamanrasset", "Таманрассете", "DZ", "12", "53", "", "", "", "22.785", "5.52278", "Africa/Algiers"),
("2478226", "Tamalous", "", "DZ", "12", "31", "", "", "", "36.83763", "6.64018", "Africa/Algiers"),
("2478831", "Tadmait", "", "DZ", "12", "40", "", "", "", "36.74413", "3.90045", "Africa/Algiers"),
("2479161", "Sour el Ghozlane", "", "DZ", "12", "21", "", "", "", "36.14766", "3.69123", "Africa/Algiers"),
("2479183", "Souma", "", "DZ", "12", "20", "", "", "", "36.51833", "2.90528", "Africa/Algiers"),
("2479215", "Souk Ahras", "Сук-Ахрас", "DZ", "12", "52", "", "", "", "36.28639", "7.95111", "Africa/Algiers"),
("2479247", "Sougueur", "", "DZ", "12", "13", "", "", "", "35.18568", "1.49612", "Africa/Algiers"),
("2479536", "Skikda", "Скикда", "DZ", "12", "31", "", "", "", "36.87617", "6.90921", "Africa/Algiers"),
("2479609", "Sig", "", "DZ", "12", "26", "", "", "", "35.52832", "-0.19369", "Africa/Algiers"),
("2479916", "Sidi Okba", "", "DZ", "12", "19", "", "", "", "34.74512", "5.89833", "Africa/Algiers"),
("2479966", "Sidi Moussa", "", "DZ", "12", "20", "", "", "", "36.60637", "3.08783", "Africa/Algiers"),
("2480198", "Sidi Merouane", "", "DZ", "12", "48", "", "", "", "36.52056", "6.26111", "Africa/Algiers"),
("2480368", "Sidi Khaled", "", "DZ", "12", "19", "", "", "", "34.387", "4.98785", "Africa/Algiers"),
("2480618", "Sidi ech Chahmi", "", "DZ", "12", "09", "", "", "", "35.65903", "-0.52168", "Africa/Algiers"),
("2481007", "Sidi Bel Abbes", "Сиди-Бель-Аббес", "DZ", "12", "30", "", "", "", "35.18994", "-0.63085", "Africa/Algiers"),
("2481058", "Sidi Amrane", "", "DZ", "12", "50", "", "", "", "33.49885", "6.00803", "Africa/Algiers"),
("2481207", "Sidi Akkacha", "", "DZ", "12", "41", "", "", "", "36.46472", "1.30258", "Africa/Algiers"),
("2481246", "Sidi Aissa", "Сиди-Аисса", "DZ", "12", "27", "", "", "", "35.88548", "3.77236", "Africa/Algiers"),
("2481389", "Sidi Abdelli", "", "DZ", "12", "15", "", "", "", "35.06937", "-1.13706", "Africa/Algiers"),
("2481639", "Sfizef", "", "DZ", "12", "30", "", "", "", "35.23464", "-0.24435", "Africa/Algiers"),
("2481700", "Setif", "Сетиф", "DZ", "12", "12", "", "", "", "36.19112", "5.41373", "Africa/Algiers"),
("2482090", "Sedrata", "", "DZ", "12", "52", "", "", "", "36.12868", "7.53376", "Africa/Algiers"),
("2482159", "Seddouk", "", "DZ", "12", "18", "", "", "", "36.54722", "4.68611", "Africa/Algiers"),
("2482211", "Sebdou", "", "DZ", "12", "15", "", "", "", "34.63703", "-1.33143", "Africa/Algiers"),
("2482390", "Saoula", "", "DZ", "12", "55", "", "", "", "36.70456", "3.02462", "Africa/Algiers"),
("2482447", "Salah Bey", "", "DZ", "12", "12", "", "", "", "35.8545", "5.29053", "Africa/Algiers"),
("2482572", "Saida", "Сайда", "DZ", "12", "10", "", "", "", "34.83034", "0.15171", "Africa/Algiers"),
("2482886", "Rouissat", "", "DZ", "12", "50", "", "", "", "31.92427", "5.35018", "Africa/Algiers"),
("2482908", "Rouiba", "", "DZ", "12", "01", "", "", "", "36.73829", "3.28079", "Africa/Algiers"),
("2482939", "Rouached", "", "DZ", "12", "48", "", "", "", "36.45774", "6.04267", "Africa/Algiers"),
("2483000", "Robbah", "", "DZ", "12", "43", "", "", "", "33.27966", "6.90984", "Africa/Algiers"),
("2483649", "Remchi", "", "DZ", "12", "15", "", "", "", "35.06196", "-1.43362", "Africa/Algiers"),
("2483668", "Relizane", "", "DZ", "12", "51", "", "", "", "35.73734", "0.55599", "Africa/Algiers"),
("2483746", "Reguiba", "", "DZ", "12", "43", "", "", "", "33.56391", "6.70326", "Africa/Algiers"),
("2483757", "Reghaia", "", "DZ", "12", "40", "", "", "", "36.73587", "3.34018", "Africa/Algiers"),
("2483761", "Reggane", "", "DZ", "12", "34", "", "", "", "26.71576", "0.1714", "Africa/Algiers"),
("2483936", "Ras el Oued", "Рас-эль-Уэд", "DZ", "12", "39", "", "", "", "35.9441", "5.03107", "Africa/Algiers"),
("2483968", "Ras el Aioun", "", "DZ", "12", "03", "", "", "", "35.67384", "5.6453", "Africa/Algiers"),
("2484620", "Oum el Bouaghi", "", "DZ", "12", "29", "", "", "", "35.87541", "7.11353", "Africa/Algiers"),
("2484846", "Ouled Mimoun", "", "DZ", "12", "15", "", "", "", "34.90472", "-1.03394", "Africa/Algiers"),
("2485572", "Oued Sly", "", "DZ", "12", "41", "", "", "", "36.10124", "1.19949", "Africa/Algiers"),
("2485582", "Oued Rhiou", "", "DZ", "12", "51", "", "", "", "35.96124", "0.91896", "Africa/Algiers"),
("2485618", "Oued Fodda", "", "DZ", "12", "41", "", "", "", "36.18503", "1.53299", "Africa/Algiers"),
("2485633", "Oued el Alleug", "", "DZ", "12", "55", "", "", "", "36.55528", "2.79028", "Africa/Algiers"),
("2485636", "Oued el Abtal", "Торки-ле-Дюк", "DZ", "12", "26", "", "", "", "35.45595", "0.68778", "Africa/Algiers"),
("2485801", "Ouargla", "Уаргла", "DZ", "12", "50", "", "", "", "31.94932", "5.32502", "Africa/Algiers"),
("2485926", "Oran", "Оран", "DZ", "12", "09", "", "", "", "35.69111", "-0.64167", "Africa/Algiers"),
("2486284", "Nedroma", "", "DZ", "12", "15", "", "", "", "35.01361", "-1.74799", "Africa/Algiers"),
("2486505", "Naciria", "", "DZ", "12", "40", "", "", "", "36.74625", "3.83163", "Africa/Algiers"),
("2486690", "M'Sila", "", "DZ", "12", "27", "", "", "", "35.70583", "4.54194", "Africa/Algiers"),
("2486825", "Mouzaia", "", "DZ", "12", "55", "", "", "", "36.46695", "2.68991", "Africa/Algiers"),
("2487134", "Mostaganem", "Мостаганем", "DZ", "12", "07", "", "", "", "35.93115", "0.08918", "Africa/Algiers"),
("2487452", "Mila", "", "DZ", "12", "48", "", "", "", "36.45028", "6.26444", "Africa/Algiers"),
("2487620", "Metlili Chaamba", "", "DZ", "12", "45", "", "", "", "32.26667", "3.63333", "Africa/Algiers"),
("2487772", "Messaad", "Мессад", "DZ", "12", "22", "", "", "", "34.15429", "3.50309", "Africa/Algiers"),
("2487805", "Meskiana", "", "DZ", "12", "29", "", "", "", "35.63058", "7.66606", "Africa/Algiers"),
("2487852", "Mers el Kebir", "Мерс-эль-Кебир", "DZ", "12", "09", "", "", "", "35.7279", "-0.7081", "Africa/Algiers"),
("2487882", "Merouana", "", "DZ", "12", "03", "", "", "", "35.63106", "5.91186", "Africa/Algiers"),
("2488202", "Melouza", "", "DZ", "12", "39", "", "", "", "35.97999", "4.18665", "Africa/Algiers"),
("2488500", "Mekla", "", "DZ", "12", "14", "", "", "", "36.68178", "4.26378", "Africa/Algiers"),
("2488616", "Mehdia", "Махдия", "DZ", "12", "13", "", "", "", "35.43058", "1.75714", "Africa/Algiers"),
("2488716", "Megarine", "", "DZ", "12", "50", "", "", "", "33.19195", "6.08695", "Africa/Algiers"),
("2488722", "Meftah", "Мефтах", "DZ", "12", "20", "", "", "", "36.6204", "3.22248", "Africa/Algiers"),
("2488835", "Medea", "Медея", "DZ", "12", "06", "", "", "", "36.26417", "2.75393", "Africa/Algiers"),
("2489987", "Mazouna", "", "DZ", "12", "51", "", "", "", "36.12232", "0.89865", "Africa/Algiers"),
("2490098", "Mascara", "", "DZ", "12", "26", "", "", "", "35.39664", "0.14027", "Africa/Algiers"),
("2490180", "Mansourah", "Мансур", "DZ", "12", "39", "", "", "", "36.08725", "4.45192", "Africa/Algiers"),
("2490183", "Mansoura", "Мансура", "DZ", "12", "15", "", "", "", "34.86158", "-1.33935", "Africa/Algiers"),
("2490297", "Makouda", "", "DZ", "12", "40", "", "", "", "36.78567", "4.06273", "Africa/Algiers"),
("2491042", "L'Arbaa Nait Irathen", "", "DZ", "12", "14", "", "", "", "36.63112", "4.19864", "Africa/Algiers"),
("2491050", "Larbaa", "Ларба", "DZ", "12", "03", "", "", "", "36.56471", "3.15434", "Africa/Algiers"),
("2491134", "Lakhdaria", "", "DZ", "12", "21", "", "", "", "36.56463", "3.5933", "Africa/Algiers"),
("2491191", "Laghouat", "Лагуат", "DZ", "12", "25", "", "", "", "33.8", "2.86514", "Africa/Algiers"),
("2491323", "Ksar el Boukhari", "", "DZ", "12", "06", "", "", "", "35.88889", "2.74905", "Africa/Algiers"),
("2491335", "Ksar Chellala", "", "DZ", "12", "13", "", "", "", "35.21222", "2.31889", "Africa/Algiers"),
("2491578", "Kolea", "", "DZ", "12", "55", "", "", "", "36.63888", "2.76845", "Africa/Algiers"),
("2491889", "Khenchela", "", "DZ", "12", "47", "", "", "", "35.43583", "7.14333", "Africa/Algiers"),
("2491911", "Khemis Miliana", "", "DZ", "12", "35", "", "", "", "36.26104", "2.22015", "Africa/Algiers"),
("2491913", "Khemis el Khechna", "", "DZ", "12", "40", "", "", "", "36.64997", "3.3308", "Africa/Algiers"),
("2492345", "Kerkera", "", "DZ", "12", "31", "", "", "", "36.92917", "6.58556", "Africa/Algiers"),
("2492913", "Jijel", "Джиджель", "DZ", "12", "24", "", "", "", "36.82055", "5.76671", "Africa/Algiers"),
("2492920", "Djidiouia", "", "DZ", "12", "51", "", "", "", "35.92989", "0.82871", "Africa/Algiers"),
("2492991", "Isser", "", "DZ", "12", "40", "", "", "", "36.71859", "3.66924", "Africa/Algiers"),
("2493222", "I-n-Salah", "", "DZ", "12", "53", "", "", "", "27.19351", "2.46069", "Africa/Algiers"),
("2493605", "Ighram", "", "DZ", "12", "14", "", "", "", "36.46295", "4.50532", "Africa/Algiers"),
("2493918", "Hennaya", "", "DZ", "12", "15", "", "", "", "34.95139", "-1.36806", "Africa/Algiers"),
("2493956", "Heliopolis", "", "DZ", "12", "23", "", "", "", "36.50361", "7.44278", "Africa/Algiers"),
("2494029", "Hassi Messaoud", "Хасси-Мессауд", "DZ", "12", "50", "", "", "", "31.68041", "6.07286", "Africa/Algiers"),
("2494548", "Hammamet", "Хаммамет", "DZ", "12", "33", "", "", "", "35.44862", "7.95184", "Africa/Algiers"),
("2494554", "Hammam Bou Hadjar", "", "DZ", "12", "36", "", "", "", "35.37889", "-0.96778", "Africa/Algiers"),
("2494610", "Hamma Bouziane", "", "DZ", "12", "04", "", "", "", "36.41205", "6.59603", "Africa/Algiers"),
("2494962", "Hadjout", "", "DZ", "12", "55", "", "", "", "36.51257", "2.41382", "Africa/Algiers"),
("2495662", "Guelma", "Гельма", "DZ", "12", "23", "", "", "", "36.46214", "7.42608", "Africa/Algiers"),
("2496049", "Ghardaia", "Гардая", "DZ", "12", "45", "", "", "", "32.49094", "3.67347", "Africa/Algiers"),
("2496232", "Frenda", "", "DZ", "12", "13", "", "", "", "35.06544", "1.04945", "Africa/Algiers"),
("2496241", "Freha", "", "DZ", "12", "14", "", "", "", "36.75234", "4.3155", "Africa/Algiers"),
("2496573", "Feraoun", "", "DZ", "12", "18", "", "", "", "36.5604", "4.85454", "Africa/Algiers"),
("2497060", "Es Senia", "", "DZ", "12", "09", "", "", "", "35.64779", "-0.62397", "Africa/Algiers"),
("2497323", "El Tarf", "", "DZ", "12", "44", "", "", "", "36.7672", "8.31377", "Africa/Algiers"),
("2497411", "El Oued", "Эль-Уэд", "DZ", "12", "43", "", "", "", "33.35608", "6.86319", "Africa/Algiers"),
("2497714", "El Malah", "", "DZ", "12", "36", "", "", "", "35.39138", "-1.09238", "Africa/Algiers"),
("2497796", "El Kseur", "", "DZ", "12", "18", "", "", "", "36.67942", "4.8555", "Africa/Algiers"),
("2497849", "El Khroub", "", "DZ", "12", "04", "", "", "", "36.26333", "6.69361", "Africa/Algiers"),
("2497988", "El Kala", "Эль-Калы", "DZ", "12", "44", "", "", "", "36.89556", "8.44333", "Africa/Algiers"),
("2498000", "El Idrissia", "", "DZ", "12", "22", "", "", "", "34.44542", "2.52749", "Africa/Algiers"),
("2498172", "El Hadjira", "", "DZ", "12", "50", "", "", "", "32.61336", "5.51259", "Africa/Algiers"),
("2498183", "El Hadjar", "", "DZ", "12", "37", "", "", "", "36.80377", "7.73684", "Africa/Algiers"),
("2498392", "El Eulma", "", "DZ", "12", "12", "", "", "", "36.15281", "5.69016", "Africa/Algiers"),
("2498543", "El Bayadh", "", "DZ", "12", "42", "", "", "", "33.68318", "1.01927", "Africa/Algiers"),
("2498590", "El Attaf", "Эль-Аттафом", "DZ", "12", "35", "", "", "", "36.22393", "1.67187", "Africa/Algiers"),
("2498611", "Chlef", "Шлеф", "DZ", "12", "41", "", "", "", "36.16525", "1.33452", "Africa/Algiers"),
("2498667", "El Aouinet", "", "DZ", "12", "29", "", "", "", "35.86691", "7.88672", "Africa/Algiers"),
("2498704", "El Amria", "", "DZ", "12", "36", "", "", "", "35.52439", "-1.01577", "Africa/Algiers"),
("2498752", "El Affroun", "", "DZ", "12", "55", "", "", "", "36.4701", "2.62528", "Africa/Algiers"),
("2498766", "El Achir", "", "DZ", "12", "39", "", "", "", "36.06386", "4.62744", "Africa/Algiers"),
("2498775", "El Abiodh Sidi Cheikh", "", "DZ", "12", "42", "", "", "", "32.893", "0.54839", "Africa/Algiers"),
("2498782", "El Abadia", "", "DZ", "12", "35", "", "", "", "36.26951", "1.68609", "Africa/Algiers"),
("2498954", "Ech Chettia", "", "DZ", "12", "41", "", "", "", "36.19591", "1.25538", "Africa/Algiers"),
("2499055", "Drean", "", "DZ", "12", "37", "", "", "", "36.68482", "7.75111", "Africa/Algiers"),
("2499104", "Draa el Mizan", "Дра-эль-Мизан", "DZ", "12", "21", "", "", "", "36.53628", "3.8334", "Africa/Algiers"),
("2499116", "Draa Ben Khedda", "", "DZ", "12", "40", "", "", "", "36.73436", "3.96223", "Africa/Algiers"),
("2499193", "Douera", "", "DZ", "12", "55", "", "", "", "36.67", "2.94444", "Africa/Algiers"),
("2500017", "Djelfa", "", "DZ", "12", "22", "", "", "", "34.67279", "3.263", "Africa/Algiers"),
("2500282", "Djamaa", "", "DZ", "12", "50", "", "", "", "33.53388", "5.99306", "Africa/Algiers"),
("2500401", "Didouche Mourad", "", "DZ", "12", "04", "", "", "", "36.4525", "6.63639", "Africa/Algiers"),
("2500583", "Dellys", "", "DZ", "12", "40", "", "", "", "36.91716", "3.91311", "Africa/Algiers"),
("2500737", "Debila", "", "DZ", "12", "43", "", "", "", "33.51667", "6.95", "Africa/Algiers"),
("2500889", "Dar el Beida", "Дар-эль-Бейда", "DZ", "12", "01", "", "", "", "36.71333", "3.2125", "Africa/Algiers"),
("2500904", "Dar Chioukh", "", "DZ", "12", "22", "", "", "", "34.89638", "3.48543", "Africa/Algiers"),
("2501152", "Constantine", "", "DZ", "12", "04", "", "", "", "36.365", "6.61472", "Africa/Algiers"),
("2501289", "Chorfa", "Чорфа", "DZ", "12", "21", "", "", "", "36.36505", "4.32636", "Africa/Algiers"),
("2501323", "Chiffa", "", "DZ", "12", "20", "", "", "", "36.46293", "2.73873", "Africa/Algiers"),
("2501362", "Chetouane", "", "DZ", "12", "15", "", "", "", "34.92129", "-1.29512", "Africa/Algiers"),
("2501404", "Cheria", "", "DZ", "12", "33", "", "", "", "35.27306", "7.75194", "Africa/Algiers"),
("2501465", "Cheraga", "", "DZ", "12", "55", "", "", "", "36.76775", "2.95924", "Africa/Algiers"),
("2501508", "Chemini", "", "DZ", "12", "14", "", "", "", "36.6", "4.61667", "Africa/Algiers"),
("2501541", "Chelghoum el Aid", "", "DZ", "12", "48", "", "", "", "36.16286", "6.16651", "Africa/Algiers"),
("2501680", "Chebli", "", "DZ", "12", "20", "", "", "", "36.57722", "3.00917", "Africa/Algiers"),
("2501767", "Charef", "", "DZ", "12", "22", "", "", "", "34.62098", "2.79503", "Africa/Algiers"),
("2501873", "Chabet el Ameur", "", "DZ", "12", "40", "", "", "", "36.63709", "3.69474", "Africa/Algiers"),
("2502034", "Brezina", "", "DZ", "12", "42", "", "", "", "33.09892", "1.26082", "Africa/Algiers"),
("2502239", "Bou Tlelis", "", "DZ", "12", "09", "", "", "", "35.57272", "-0.8996", "Africa/Algiers"),
("2502686", "Boumahra Ahmed", "", "DZ", "12", "23", "", "", "", "36.45833", "7.51389", "Africa/Algiers"),
("2502924", "Boukadir", "Бу-Кадир", "DZ", "12", "41", "", "", "", "36.06629", "1.12602", "Africa/Algiers"),
("2502939", "Bou Ismail", "Бу-Исмаил", "DZ", "12", "55", "", "", "", "36.64262", "2.69007", "Africa/Algiers"),
("2502958", "Bouira", "", "DZ", "12", "21", "", "", "", "36.37489", "3.902", "Africa/Algiers"),
("2502962", "Bouinan", "", "DZ", "12", "20", "", "", "", "36.53167", "2.99194", "Africa/Algiers"),
("2503033", "Bou Hanifia el Hamamat", "", "DZ", "12", "26", "", "", "", "35.31473", "-0.05037", "Africa/Algiers"),
("2503147", "Bougara", "", "DZ", "12", "20", "", "", "", "36.54178", "3.081", "Africa/Algiers"),
("2503156", "Bougaa", "", "DZ", "12", "12", "", "", "", "36.33293", "5.08843", "Africa/Algiers"),
("2503181", "Boufarik", "", "DZ", "12", "20", "", "", "", "36.57412", "2.91214", "Africa/Algiers"),
("2503229", "Boudouaou", "", "DZ", "12", "40", "", "", "", "36.72735", "3.40995", "Africa/Algiers"),
("2503237", "Boudjima", "", "DZ", "12", "14", "", "", "", "36.80218", "4.15187", "Africa/Algiers"),
("2503468", "Bou Arfa", "", "DZ", "12", "20", "", "", "", "36.46298", "2.81464", "Africa/Algiers"),
("2503620", "Bordj Zemoura", "", "DZ", "12", "39", "", "", "", "36.27462", "4.85668", "Africa/Algiers"),
("2503654", "Bordj Ghdir", "", "DZ", "12", "39", "", "", "", "35.90111", "4.89806", "Africa/Algiers"),
("2503661", "Bordj el Kiffan", "", "DZ", "12", "01", "", "", "", "36.74871", "3.19248", "Africa/Algiers"),
("2503701", "Bordj Bou Arreridj", "", "DZ", "12", "39", "", "", "", "36.07322", "4.76108", "Africa/Algiers"),
("2503755", "Boghni", "", "DZ", "12", "14", "", "", "", "36.54222", "3.95306", "Africa/Algiers"),
("2503769", "Blida", "Блида", "DZ", "12", "20", "", "", "", "36.47004", "2.8277", "Africa/Algiers"),
("2503826", "Biskra", "Бискра", "DZ", "12", "19", "", "", "", "34.85038", "5.72805", "Africa/Algiers"),
("2503847", "Birkhadem", "", "DZ", "12", "01", "", "", "", "36.71499", "3.05002", "Africa/Algiers"),
("2503852", "Birine", "", "DZ", "12", "22", "", "", "", "35.635", "3.225", "Africa/Algiers"),
("2503874", "Bir el Djir", "", "DZ", "12", "09", "", "", "", "35.72", "-0.545", "Africa/Algiers"),
("2503878", "Bir el Ater", "", "DZ", "12", "33", "", "", "", "34.74488", "8.06024", "Africa/Algiers"),
("2504072", "Besbes", "", "DZ", "12", "44", "", "", "", "36.70222", "7.84722", "Africa/Algiers"),
("2504099", "Berrouaghia", "", "DZ", "12", "06", "", "", "", "36.13516", "2.91085", "Africa/Algiers"),
("2504110", "Berriane", "", "DZ", "12", "45", "", "", "", "32.82648", "3.7669", "Africa/Algiers"),
("2504136", "Berrahal", "", "DZ", "12", "37", "", "", "", "36.83528", "7.45333", "Africa/Algiers"),
("2504385", "Bensekrane", "", "DZ", "12", "15", "", "", "", "35.07465", "-1.22431", "Africa/Algiers"),
("2504486", "Ben Mehidi", "", "DZ", "12", "44", "", "", "", "36.76967", "7.9064", "Africa/Algiers"),
("2504581", "Beni Saf", "", "DZ", "12", "36", "", "", "", "35.30099", "-1.38226", "Africa/Algiers"),
("2504616", "Beni Mester", "", "DZ", "12", "15", "", "", "", "34.87045", "-1.42319", "Africa/Algiers"),
("2504622", "Beni Mered", "", "DZ", "12", "20", "", "", "", "36.52389", "2.86131", "Africa/Algiers"),
("2504703", "Beni Douala", "", "DZ", "12", "14", "", "", "", "36.61954", "4.08282", "Africa/Algiers"),
("2504739", "Beni Amrane", "", "DZ", "12", "40", "", "", "", "36.66774", "3.59115", "Africa/Algiers"),
("2505329", "Bejaia", "", "DZ", "12", "18", "", "", "", "36.75587", "5.08433", "Africa/Algiers"),
("2505530", "Bechar", "Бешаре", "DZ", "12", "38", "", "", "", "31.61667", "-2.21667", "Africa/Algiers"),
("2505572", "Batna", "Батна", "DZ", "12", "03", "", "", "", "35.55597", "6.17414", "Africa/Algiers"),
("2505629", "Barika", "Барика", "DZ", "12", "03", "", "", "", "35.38901", "5.36584", "Africa/Algiers"),
("2505651", "Barbacha", "", "DZ", "12", "18", "", "", "", "36.56667", "4.96667", "Africa/Algiers"),
("2505653", "Baraki", "", "DZ", "12", "55", "", "", "", "36.66655", "3.09606", "Africa/Algiers"),
("2505854", "Bab Ezzouar", "", "DZ", "12", "01", "", "", "", "36.72615", "3.18291", "Africa/Algiers"),
("2505915", "Azzaba", "", "DZ", "12", "31", "", "", "", "36.73944", "7.10528", "Africa/Algiers"),
("2506043", "Azazga", "", "DZ", "12", "14", "", "", "", "36.74472", "4.37222", "Africa/Algiers"),
("2506404", "Arris", "", "DZ", "12", "03", "", "", "", "35.25881", "6.34706", "Africa/Algiers"),
("2506519", "Arhribs", "", "DZ", "12", "14", "", "", "", "36.79361", "4.31158", "Africa/Algiers"),
("2506623", "Arbatache", "", "DZ", "12", "40", "", "", "", "36.63773", "3.37127", "Africa/Algiers"),
("2506795", "Aoulef", "", "DZ", "12", "34", "", "", "", "26.96667", "1.08333", "Africa/Algiers"),
("2506999", "Annaba", "Аннаба", "DZ", "12", "37", "", "", "", "36.9", "7.76667", "Africa/Algiers"),
("2507155", "Ammi Moussa", "", "DZ", "12", "51", "", "", "", "35.86781", "1.11143", "Africa/Algiers"),
("2507169", "Amizour", "", "DZ", "12", "18", "", "", "", "36.64022", "4.90131", "Africa/Algiers"),
("2507480", "Algiers", "Алжир", "DZ", "12", "01", "", "", "", "36.7525", "3.04197", "Africa/Algiers"),
("2507646", "Akbou", "", "DZ", "12", "18", "", "", "", "36.4575", "4.53494", "Africa/Algiers"),
("2507877", "Ain Touta", "", "DZ", "12", "03", "", "", "", "35.37675", "5.90001", "Africa/Algiers"),
("2507901", "'Ain Temouchent", "", "DZ", "12", "36", "", "", "", "35.29749", "-1.14037", "Africa/Algiers"),
("2507912", "Ain Taya", "", "DZ", "12", "01", "", "", "", "36.79333", "3.28694", "Africa/Algiers"),
("2507926", "Ain Smara", "", "DZ", "12", "04", "", "", "", "36.2674", "6.50135", "Africa/Algiers"),
("2507943", "Ain Sefra", "", "DZ", "12", "49", "", "", "", "32.75", "-0.58333", "Africa/Algiers"),
("2507972", "Ain Oussera", "", "DZ", "12", "22", "", "", "", "35.45139", "2.90583", "Africa/Algiers"),
("2508010", "'Ain Merane", "", "DZ", "12", "51", "", "", "", "36.16277", "0.97037", "Africa/Algiers"),
("2508059", "Ain Kercha", "", "DZ", "12", "29", "", "", "", "35.92472", "6.69528", "Africa/Algiers"),
("2508102", "Ain Fakroun", "", "DZ", "12", "29", "", "", "", "35.97108", "6.87374", "Africa/Algiers"),
("2508119", "'Ain el Turk", "Айн-эль-Терк", "DZ", "12", "09", "", "", "", "35.74381", "-0.7693", "Africa/Algiers"),
("2508130", "'Ain el Melh", "Айн-эль-Мельх", "DZ", "12", "27", "", "", "", "34.84146", "4.16383", "Africa/Algiers"),
("2508152", "'Ain el Hammam", "Айн-эль-Хаммам", "DZ", "12", "14", "", "", "", "36.56471", "4.30619", "Africa/Algiers"),
("2508157", "`Ain el Hadjel", "", "DZ", "12", "27", "", "", "", "35.67003", "3.88153", "Africa/Algiers"),
("2508174", "Ain el Bya", "", "DZ", "12", "09", "", "", "", "35.80389", "-0.30178", "Africa/Algiers"),
("2508180", "'Ain el Berd", "", "DZ", "12", "30", "", "", "", "35.36395", "-0.51278", "Africa/Algiers"),
("2508184", "'Ain el Bell", "Айн-эль-Белла", "DZ", "12", "22", "", "", "", "34.3438", "3.22475", "Africa/Algiers"),
("2508225", "'Ain Deheb", "", "DZ", "12", "13", "", "", "", "34.84218", "1.54698", "Africa/Algiers"),
("2508228", "Ain Defla", "", "DZ", "12", "35", "", "", "", "36.26406", "1.9679", "Africa/Algiers"),
("2508268", "Ain Bessem", "", "DZ", "12", "21", "", "", "", "36.29333", "3.67319", "Africa/Algiers"),
("2508275", "'Ain Benian", "", "DZ", "12", "55", "", "", "", "36.80277", "2.92185", "Africa/Algiers"),
("2508287", "Ain Beida", "", "DZ", "12", "29", "", "", "", "35.79639", "7.39278", "Africa/Algiers"),
("2508297", "Ain Arnat", "", "DZ", "12", "12", "", "", "", "36.18683", "5.31347", "Africa/Algiers"),
("2508309", "'Ain Abid", "", "DZ", "12", "04", "", "", "", "36.23194", "6.94333", "Africa/Algiers"),
("2508737", "Aflou", "", "DZ", "12", "25", "", "", "", "34.1128", "2.10228", "Africa/Algiers"),
("2508813", "Adrar", "Адрар", "DZ", "12", "34", "", "", "", "27.87429", "-0.29388", "Africa/Algiers"),
("2509031", "Abou el Hassan", "", "DZ", "12", "41", "", "", "", "36.41657", "1.19616", "Africa/Algiers"),
("6698360", "BABOR - VILLE", "", "DZ", "12", "12", "", "", "", "36.48994", "5.5393", "Africa/Algiers"),
("587577", "Viljandi", "Вильянди", "EE", "233", "20", "0897", "", "", "58.36389", "25.59", "Europe/Tallinn"),
("588335", "Tartu", "Тарту", "EE", "233", "18", "0795", "", "", "58.38062", "26.72509", "Europe/Tallinn"),
("588409", "Tallinn", "Таллин", "EE", "233", "01", "0784", "", "", "59.43696", "24.75353", "Europe/Tallinn"),
("588686", "Sillamae", "Силламяэ", "EE", "233", "03", "0735", "", "", "59.39697", "27.76331", "Europe/Tallinn"),
("589165", "Rakvere", "Раквере", "EE", "233", "08", "0663", "", "", "59.34639", "26.35583", "Europe/Tallinn"),
("589580", "Parnu", "Пярну", "EE", "233", "11", "0625", "", "", "58.38588", "24.49711", "Europe/Tallinn"),
("590031", "Narva", "Нарва", "EE", "233", "03", "0511", "", "", "59.37722", "28.19028", "Europe/Tallinn"),
("590447", "Maardu", "Маарду", "EE", "233", "01", "0446", "", "", "59.47667", "25.025", "Europe/Tallinn"),
("591260", "Kohtla-Jarve", "Кохтла-Ярве", "EE", "233", "03", "0322", "", "", "59.39861", "27.27306", "Europe/Tallinn"),
("346030", "Zifta", "Зифта", "EG", "818", "05", "", "", "", "30.7142", "31.24425", "Africa/Cairo"),
("347236", "Toukh", "Тух", "EG", "818", "12", "", "", "", "30.35394", "31.20071", "Africa/Cairo"),
("347497", "Tanda", "Танта", "EG", "818", "05", "", "", "", "30.78847", "31.00192", "Africa/Cairo"),
("347542", "Tamiyah", "", "EG", "818", "04", "", "", "", "29.47639", "30.96119", "Africa/Cairo"),
("347591", "Talkha", "", "EG", "818", "01", "", "", "", "31.0539", "31.37787", "Africa/Cairo"),
("347612", "Tala", "Тале", "EG", "818", "09", "", "", "", "30.68025", "30.94292", "Africa/Cairo"),
("347634", "Tahta", "Тахта", "EG", "818", "24", "", "", "", "26.7693", "31.50214", "Africa/Cairo"),
("347749", "Sumusta as Sultani", "", "EG", "818", "18", "", "", "", "28.91667", "30.85", "Africa/Cairo"),
("347796", "Sohag", "Сохаг", "EG", "818", "24", "", "", "", "26.55695", "31.69478", "Africa/Cairo"),
("348112", "Sidi Salim", "", "EG", "818", "21", "", "", "", "31.27105", "30.78665", "Africa/Cairo"),
("349114", "Shirbin", "", "EG", "818", "01", "", "", "", "31.19688", "31.5243", "Africa/Cairo"),
("349156", "Shibin al Qanatir", "", "EG", "818", "12", "", "", "", "30.31269", "31.32018", "Africa/Cairo"),
("349158", "Shibin al Kawm", "", "EG", "818", "09", "", "", "", "30.55258", "31.00904", "Africa/Cairo"),
("349715", "Samannud", "", "EG", "818", "05", "", "", "", "30.9616", "31.24069", "Africa/Cairo"),
("349717", "Samalut", "", "EG", "818", "10", "", "", "", "28.31214", "30.71007", "Africa/Cairo"),
("350203", "Rosetta", "", "EG", "818", "03", "", "", "", "31.40444", "30.41639", "Africa/Cairo"),
("350370", "Quwaysina", "", "EG", "818", "09", "", "", "", "30.56482", "31.15777", "Africa/Cairo"),
("350376", "Qutur", "", "EG", "818", "05", "", "", "", "30.97225", "30.95614", "Africa/Cairo"),
("350422", "Kousa", "", "EG", "818", "23", "", "", "", "25.91407", "32.76362", "Africa/Cairo"),
("350550", "Qina", "", "EG", "818", "23", "", "", "", "26.16418", "32.72671", "Africa/Cairo"),
("350789", "Qalyub", "Кальюб", "EG", "818", "12", "", "", "", "30.17922", "31.2056", "Africa/Cairo"),
("351434", "Naj` Hammadi", "", "EG", "818", "23", "", "", "", "26.04949", "32.24142", "Africa/Cairo"),
("352344", "Minyat an Nasr", "", "EG", "818", "01", "", "", "", "31.12624", "31.64313", "Africa/Cairo"),
("352354", "Minuf", "", "EG", "818", "09", "", "", "", "30.46579", "30.93164", "Africa/Cairo"),
("352628", "Matay", "", "EG", "818", "10", "", "", "", "28.41899", "30.77924", "Africa/Cairo"),
("352679", "Mashtul as Suq", "", "EG", "818", "14", "", "", "", "30.36056", "31.3776", "Africa/Cairo"),
("352733", "Mersa Matruh", "Марса-Матрух", "EG", "818", "22", "", "", "", "31.3529", "27.23725", "Africa/Cairo"),
("352913", "Manfalut", "", "EG", "818", "17", "", "", "", "27.3104", "30.97004", "Africa/Cairo"),
("352951", "Mallawi", "Маллави", "EG", "818", "10", "", "", "", "27.7314", "30.84165", "Africa/Cairo"),
("353219", "Madinat Sittah Uktubar", "", "EG", "818", "08", "", "", "", "29.81667", "31.05", "Africa/Cairo"),
("353802", "Kawm Umbu", "Ком-Омбо", "EG", "818", "16", "", "", "", "24.47669", "32.94626", "Africa/Cairo"),
("353828", "Kawm Hamadah", "", "EG", "818", "03", "", "", "", "30.76096", "30.69733", "Africa/Cairo"),
("354105", "Kafr Saqr", "", "EG", "818", "14", "", "", "", "30.79336", "31.62575", "Africa/Cairo"),
("354365", "Kafr az Zayyat", "", "EG", "818", "05", "", "", "", "30.8248", "30.81805", "Africa/Cairo"),
("354502", "Kafr ash Shaykh", "", "EG", "818", "21", "", "", "", "31.1143", "30.94012", "Africa/Cairo"),
("354775", "Kafr ad Dawwar", "", "EG", "818", "03", "", "", "", "31.13385", "30.12843", "Africa/Cairo"),
("354981", "Juhaynah", "", "EG", "818", "24", "", "", "", "26.67319", "31.4976", "Africa/Cairo"),
("355026", "Jirja", "", "EG", "818", "24", "", "", "", "26.33826", "31.89161", "Africa/Cairo"),
("355392", "`Izbat al Burj", "", "EG", "818", "01", "", "", "", "31.5084", "31.84106", "Africa/Cairo"),
("355420", "Itsa", "", "EG", "818", "04", "", "", "", "29.2376", "30.78944", "Africa/Cairo"),
("355449", "Isna", "Эсна", "EG", "818", "23", "", "", "", "25.29336", "32.55402", "Africa/Cairo"),
("355628", "Idku", "Идку", "EG", "818", "03", "", "", "", "31.30782", "30.29901", "Africa/Cairo"),
("355648", "Ibshaway", "", "EG", "818", "04", "", "", "", "29.35804", "30.68142", "Africa/Cairo"),
("355795", "Halwan", "Хелуан", "EG", "818", "11", "", "", "", "29.84144", "31.30084", "Africa/Cairo"),
("355939", "Hihya", "", "EG", "818", "14", "", "", "", "30.6713", "31.58801", "Africa/Cairo"),
("356000", "Hawsh `Isa", "", "EG", "818", "03", "", "", "", "30.9128", "30.29018", "Africa/Cairo"),
("356806", "Fuwah", "", "EG", "818", "21", "", "", "", "31.20291", "30.55018", "Africa/Cairo"),
("356933", "Farshut", "", "EG", "818", "23", "", "", "", "26.05494", "32.16329", "Africa/Cairo"),
("356945", "Faraskur", "", "EG", "818", "20", "", "", "", "31.32977", "31.71507", "Africa/Cairo"),
("356989", "Faqus", "", "EG", "818", "14", "", "", "", "30.73006", "31.80182", "Africa/Cairo"),
("358048", "Damietta", "Думьят", "EG", "818", "20", "", "", "", "31.41648", "31.81332", "Africa/Cairo"),
("358095", "Diyarb Najm", "", "EG", "818", "14", "", "", "", "30.75438", "31.44016", "Africa/Cairo"),
("358108", "Disuq", "Дисук", "EG", "818", "21", "", "", "", "31.13305", "30.64649", "Africa/Cairo"),
("358115", "Dishna", "", "EG", "818", "23", "", "", "", "26.12467", "32.47598", "Africa/Cairo"),
("358172", "Dikirnis", "Дикирнис", "EG", "818", "01", "", "", "", "31.08898", "31.59478", "Africa/Cairo"),
("358269", "Dayrut", "", "EG", "818", "17", "", "", "", "27.55602", "30.80764", "Africa/Cairo"),
("358274", "Dayr Mawas", "", "EG", "818", "10", "", "", "", "27.64176", "30.84662", "Africa/Cairo"),
("358448", "Damanhur", "Даманхур", "EG", "818", "03", "", "", "", "31.03408", "30.46823", "Africa/Cairo"),
("358600", "Bush", "", "EG", "818", "18", "", "", "", "29.14816", "31.12733", "Africa/Cairo"),
("358619", "Port Said", "Порт-Саид", "EG", "818", "19", "", "", "", "31.25654", "32.28412", "Africa/Cairo"),
("358620", "Bur Safajah", "Сафага", "EG", "818", "02", "", "", "", "26.72918", "33.93651", "Africa/Cairo"),
("358821", "Bilqas", "", "EG", "818", "01", "", "", "", "31.21452", "31.35798", "Africa/Cairo"),
("358840", "Bilbays", "", "EG", "818", "14", "", "", "", "30.42039", "31.56223", "Africa/Cairo"),
("358970", "Basyun", "", "EG", "818", "05", "", "", "", "30.93976", "30.81338", "Africa/Cairo"),
("359173", "Bani Suwayf", "", "EG", "818", "18", "", "", "", "29.07441", "31.09785", "Africa/Cairo"),
("359212", "Bani Mazar", "", "EG", "818", "10", "", "", "", "28.5036", "30.8004", "Africa/Cairo"),
("359280", "Banha", "Банха", "EG", "818", "12", "", "", "", "30.45906", "31.17858", "Africa/Cairo"),
("359493", "Zagazig", "Эз-Заказик", "EG", "818", "14", "", "", "", "30.58768", "31.502", "Africa/Cairo"),
("359576", "Awsim", "", "EG", "818", "08", "", "", "", "30.12303", "31.13571", "Africa/Cairo"),
("359710", "At Tall al Kabir", "", "EG", "818", "07", "", "", "", "30.54448", "31.78525", "Africa/Cairo"),
("359783", "Asyut", "Асьют", "EG", "818", "17", "", "", "", "27.18096", "31.18368", "Africa/Cairo"),
("359792", "Aswan", "Асуан", "EG", "818", "16", "", "", "", "24.09082", "32.89942", "Africa/Cairo"),
("359796", "Suez", "Суэц", "EG", "818", "15", "", "", "", "29.97371", "32.52627", "Africa/Cairo"),
("359900", "As Saff", "", "EG", "818", "08", "", "", "", "29.56472", "31.28111", "Africa/Cairo"),
("359953", "Ash Shuhada'", "", "EG", "818", "09", "", "", "", "30.59618", "30.89875", "Africa/Cairo"),
("360048", "Ashmun", "", "EG", "818", "09", "", "", "", "30.29857", "30.97635", "Africa/Cairo"),
("360464", "Al Wasitah", "", "EG", "818", "04", "", "", "", "29.33778", "31.20556", "Africa/Cairo"),
("360502", "Luxor", "Луксор", "EG", "818", "28", "", "", "", "25.69893", "32.6421", "Africa/Cairo"),
("360526", "Al Qusiyah", "", "EG", "818", "17", "", "", "", "27.4402", "30.81841", "Africa/Cairo"),
("360531", "Al Qusayr", "Аль-Кусайра", "EG", "818", "02", "", "", "", "26.10426", "34.27793", "Africa/Cairo"),
("360542", "Al Qurayn", "Аль-Эль-Курайн", "EG", "818", "14", "", "", "", "30.61618", "31.73514", "Africa/Cairo"),
("360612", "Al Qanayat", "", "EG", "818", "14", "", "", "", "30.6188", "31.46099", "Africa/Cairo"),
("360615", "Al Qanatir al Khayriyah", "", "EG", "818", "12", "", "", "", "30.19327", "31.13703", "Africa/Cairo"),
("360630", "Cairo", "Каир", "EG", "818", "11", "", "", "", "30.06263", "31.24967", "Africa/Cairo"),
("360686", "Al Minya", "Эль-Минья", "EG", "818", "10", "", "", "", "28.10988", "30.7503", "Africa/Cairo"),
("360716", "Al Matariyah", "", "EG", "818", "01", "", "", "", "31.18287", "32.03108", "Africa/Cairo"),
("360754", "Al Manzilah", "", "EG", "818", "01", "", "", "", "31.15815", "31.937", "Africa/Cairo"),
("360761", "Al Mansurah", "", "EG", "818", "01", "", "", "", "31.03637", "31.38069", "Africa/Cairo"),
("360773", "Al Manshah", "", "EG", "818", "24", "", "", "", "26.47686", "31.8035", "Africa/Cairo"),
("360829", "Al Mahallah al Kubra", "", "EG", "818", "05", "", "", "", "30.97063", "31.1669", "Africa/Cairo"),
("360923", "Al Kharijah", "", "EG", "818", "13", "", "", "", "25.4514", "30.54635", "Africa/Cairo"),
("360928", "Al Khankah", "", "EG", "818", "12", "", "", "", "30.21035", "31.36812", "Africa/Cairo"),
("360995", "Al Jizah", "Гиза", "EG", "818", "08", "", "", "", "30.00808", "31.21093", "Africa/Cairo"),
("361029", "Al Jamaliyah", "", "EG", "818", "01", "", "", "", "31.18086", "31.86518", "Africa/Cairo"),
("361055", "Ismailia", "Исмаилия", "EG", "818", "07", "", "", "", "30.60427", "32.27225", "Africa/Cairo"),
("361058", "Alexandria", "Александрия", "EG", "818", "06", "", "", "", "31.21564", "29.95527", "Africa/Cairo"),
("361103", "Al Ibrahimiyah", "", "EG", "818", "14", "", "", "", "30.71877", "31.56299", "Africa/Cairo"),
("361179", "Al Hawamidiyah", "", "EG", "818", "08", "", "", "", "29.9", "31.25", "Africa/Cairo"),
("361213", "Al Hamul", "", "EG", "818", "21", "", "", "", "31.31146", "31.14766", "Africa/Cairo"),
("361291", "Hurghada", "Хургада", "EG", "818", "02", "", "", "", "27.25738", "33.81291", "Africa/Cairo"),
("361320", "Al Fayyum", "Аль-Фаюм", "EG", "818", "04", "", "", "", "29.30995", "30.8418", "Africa/Cairo"),
("361329", "Al Fashn", "", "EG", "818", "18", "", "", "", "28.82431", "30.89948", "Africa/Cairo"),
("361394", "Al Bawiti", "Бавити", "EG", "818", "08", "", "", "", "28.34919", "28.86591", "Africa/Cairo"),
("361435", "Al Balyana", "", "EG", "818", "24", "", "", "", "26.23568", "32.00347", "Africa/Cairo"),
("361457", "Al Bajur", "", "EG", "818", "09", "", "", "", "30.43026", "31.03681", "Africa/Cairo"),
("361478", "Al Badari", "", "EG", "818", "17", "", "", "", "26.99257", "31.41554", "Africa/Cairo"),
("361495", "Al `Ayyat", "", "EG", "818", "08", "", "", "", "29.61972", "31.2575", "Africa/Cairo"),
("361546", "Arish", "", "EG", "818", "27", "", "", "", "31.13159", "33.79844", "Africa/Cairo"),
("361661", "Akhmim", "Ахмим", "EG", "818", "24", "", "", "", "26.56217", "31.74503", "Africa/Cairo"),
("361702", "Aja", "Айа", "EG", "818", "01", "", "", "", "30.94162", "31.29039", "Africa/Cairo"),
("361827", "Ad Dilinjat", "", "EG", "818", "03", "", "", "", "30.82791", "30.53633", "Africa/Cairo"),
("362004", "Abu Tij", "", "EG", "818", "17", "", "", "", "27.04411", "31.31897", "Africa/Cairo"),
("362277", "Abu Qurqas", "", "EG", "818", "10", "", "", "", "27.9312", "30.83841", "Africa/Cairo"),
("362485", "Abu Kabir", "", "EG", "818", "14", "", "", "", "30.72508", "31.67148", "Africa/Cairo"),
("362882", "Abu al Matamir", "", "EG", "818", "03", "", "", "", "30.91018", "30.17438", "Africa/Cairo"),
("362973", "Abnub", "", "EG", "818", "17", "", "", "", "27.2696", "31.15105", "Africa/Cairo"),
("411165", "Idfu", "", "EG", "818", "16", "", "", "", "24.98028", "32.87472", "Africa/Cairo"),
("419435", "Az Zarqa", "", "EG", "818", "20", "", "", "", "31.20864", "31.63528", "Africa/Cairo"),
("7521348", "Ain Sukhna", "Айн-Сухна", "EG", "818", "15", "", "", "", "29.60018", "32.31671", "Africa/Cairo"),
("2461874", "Smara", "Смара", "EH", "732", "CE", "", "", "", "26.73841", "-11.67194", "Africa/El_Aaiun"),
("2462881", "Laayoune / El Aaiun", "Эль-Аюн", "EH", "732", "00", "", "", "", "27.16224", "-13.20315", "Africa/El_Aaiun"),
("2463447", "Dakhla", "Дахла", "EH", "732", "CE", "", "", "", "23.68477", "-15.95798", "Africa/El_Aaiun"),
("2509305", "Zubia", "", "ES", "724", "51", "GR", "18084", "", "37.11906", "-3.584", "Europe/Madrid"),
("2509377", "Zafra", "Сафра", "ES", "724", "57", "BA", "06158", "", "38.41667", "-6.41667", "Europe/Madrid"),
("2509402", "Yecla", "Екла", "ES", "724", "31", "MU", "30043", "", "38.61365", "-1.11468", "Europe/Madrid"),
("2509463", "Villena", "Вильена", "ES", "724", "60", "A", "03140", "", "38.6373", "-0.86568", "Europe/Madrid"),
("2509491", "Villarrobledo", "Вильярробледо", "ES", "724", "54", "AB", "02081", "", "39.26992", "-2.60118", "Europe/Madrid"),
("2509509", "Vila-real", "Вила-Реал", "ES", "724", "60", "CS", "12032", "", "39.93333", "-0.1", "Europe/Madrid"),
("2509553", "Villanueva de la Serena", "Вильянуэва-де-ла-Серена", "ES", "724", "57", "BA", "06153", "", "38.97655", "-5.7974", "Europe/Madrid"),
("2509588", "Villajoyosa", "", "ES", "724", "60", "A", "03139", "", "38.50754", "-0.23346", "Europe/Madrid"),
("2509650", "Vicar", "Викар", "ES", "724", "51", "AL", "04102", "", "36.83155", "-2.64273", "Europe/Madrid"),
("2509769", "Velez-Malaga", "Велес-Малага", "ES", "724", "51", "MA", "29094", "", "36.77262", "-4.10045", "Europe/Madrid"),
("2509954", "Valencia", "Валенсия", "ES", "724", "60", "V", "46250", "", "39.46975", "-0.37739", "Europe/Madrid"),
("2509982", "Valdepenas", "Вальдепеньясе", "ES", "724", "54", "CR", "13087", "", "38.76211", "-3.38483", "Europe/Madrid"),
("2510073", "Utrera", "Утрера", "ES", "724", "51", "SE", "41095", "", "37.18516", "-5.78093", "Europe/Madrid"),
("2510112", "Ubrique", "", "ES", "724", "51", "CA", "11038", "", "36.67778", "-5.446", "Europe/Madrid"),
("2510116", "Ubeda", "Убеда", "ES", "724", "51", "J", "23092", "", "38.01328", "-3.3705", "Europe/Madrid"),
("2510224", "Totana", "Тотана", "ES", "724", "31", "MU", "30039", "", "37.7688", "-1.50229", "Europe/Madrid"),
("2510245", "Torrox", "Торрокс", "ES", "724", "51", "MA", "29091", "", "36.75793", "-3.95233", "Europe/Madrid"),
("2510253", "Torrevieja", "Торревьеха", "ES", "724", "60", "A", "03133", "", "37.97872", "-0.68222", "Europe/Madrid"),
("2510271", "Torre-Pacheco", "Торре-Пачеко", "ES", "724", "31", "MU", "30030", "", "37.74293", "-0.95396", "Europe/Madrid"),
("2510279", "Torrent", "", "ES", "724", "60", "V", "46244", "", "39.43705", "-0.46546", "Europe/Madrid"),
("2510281", "Torremolinos", "Торремолинос", "ES", "724", "51", "MA", "29901", "", "36.62035", "-4.49976", "Europe/Madrid"),
("2510392", "Tomelloso", "Томельосо", "ES", "724", "54", "CR", "13019", "", "39.15218", "-3.02431", "Europe/Madrid"),
("2510394", "Tomares", "", "ES", "724", "51", "SE", "41093", "", "37.37281", "-6.04589", "Europe/Madrid"),
("2510409", "Toledo", "Толедо", "ES", "724", "54", "TO", "45168", "", "39.8581", "-4.02263", "Europe/Madrid"),
("2510485", "Tias", "", "ES", "724", "53", "GC", "35028", "", "28.96108", "-13.64502", "Atlantic/Canary"),
("2510542", "Telde", "Тельде", "ES", "724", "53", "GC", "35026", "", "27.99242", "-15.41915", "Atlantic/Canary"),
("2510573", "Teguise", "", "ES", "724", "53", "GC", "35024", "", "29.06049", "-13.56398", "Atlantic/Canary"),
("2510599", "Tarifa", "Тарифа", "ES", "724", "51", "CA", "11035", "", "36.01393", "-5.60695", "Europe/Madrid"),
("2510693", "Talavera de la Reina", "Талавера де ла Рейна", "ES", "724", "54", "TO", "45165", "", "39.96348", "-4.83076", "Europe/Madrid"),
("2510725", "Tacoronte", "", "ES", "724", "53", "TF", "38043", "", "28.47688", "-16.41016", "Atlantic/Canary"),
("2510743", "Tavernes de la Valldigna", "", "ES", "724", "60", "V", "46238", "", "39.06667", "-0.26667", "Europe/Madrid"),
("2510764", "Sueca", "", "ES", "724", "60", "V", "46235", "", "39.2026", "-0.31114", "Europe/Madrid"),
("2510880", "Silla", "", "ES", "724", "60", "V", "46230", "", "39.36667", "-0.41667", "Europe/Madrid"),
("2510911", "Sevilla", "Севилья", "ES", "724", "51", "SE", "41091", "", "37.38283", "-5.97317", "Europe/Madrid"),
("2511032", "San Vicent del Raspeig", "", "ES", "724", "60", "A", "03014", "", "38.3964", "-0.5255", "Europe/Madrid"),
("2511050", "Santomera", "", "ES", "724", "31", "MU", "30901", "", "38.06147", "-1.04877", "Europe/Madrid"),
("2511102", "Santa Pola", "Санта-Пола", "ES", "724", "60", "A", "03121", "", "38.19165", "-0.5658", "Europe/Madrid"),
("2511150", "Santa Lucia", "", "ES", "724", "53", "GC", "35019", "", "27.91174", "-15.54071", "Atlantic/Canary"),
("2511162", "Santa Eularia des Riu", "", "ES", "724", "07", "PM", "07054", "", "38.98457", "1.53409", "Europe/Madrid"),
("2511174", "Santa Cruz de Tenerife", "Санта-Крус-де-Тенерифе", "ES", "724", "53", "TF", "38038", "", "28.46824", "-16.25462", "Atlantic/Canary"),
("2511180", "Santa Cruz de la Palma", "", "ES", "724", "53", "TF", "38037", "", "28.68351", "-17.76421", "Atlantic/Canary"),
("2511202", "Santa Brigida", "", "ES", "724", "53", "GC", "35021", "", "28.03197", "-15.50425", "Atlantic/Canary"),
("2511239", "San Roque", "", "ES", "724", "51", "CA", "11033", "", "36.21067", "-5.38415", "Europe/Madrid"),
("2511247", "San Pedro del Pinatar", "", "ES", "724", "31", "MU", "30036", "", "37.83568", "-0.79102", "Europe/Madrid"),
("2511287", "San Miguel", "", "ES", "724", "53", "TF", "38035", "", "28.09826", "-16.61708", "Atlantic/Canary"),
("2511306", "Sanlucar de Barrameda", "Санлукар-де-Баррамеда", "ES", "724", "51", "CA", "11032", "", "36.77808", "-6.3515", "Europe/Madrid"),
("2511329", "San Juan de Aznalfarache", "Сан-Хуан-де-Аснальфараче", "ES", "724", "51", "SE", "41086", "", "37.35812", "-6.03731", "Europe/Madrid"),
("2511330", "San Juan de Alicante", "", "ES", "724", "60", "A", "03014", "", "38.40148", "-0.43623", "Europe/Madrid"),
("2511352", "Sant Josep de sa Talaia", "", "ES", "724", "07", "PM", "07048", "", "38.91667", "1.28333", "Europe/Madrid"),
("2511366", "San Javier", "", "ES", "724", "31", "MU", "30035", "", "37.80626", "-0.83736", "Europe/Madrid"),
("2511371", "San Isidro", "Сан Исидро", "ES", "724", "53", "TF", "38017", "", "28.07617", "-16.558", "Atlantic/Canary"),
("2511388", "San Fernando", "Сан-Фернандо", "ES", "724", "51", "CA", "11031", "", "36.4759", "-6.19817", "Europe/Madrid"),
("2511401", "La Laguna", "Ла-Лагуна", "ES", "724", "53", "TF", "38023", "", "28.4853", "-16.32014", "Atlantic/Canary"),
("2511440", "San Bartolome", "", "ES", "724", "53", "GC", "35019", "", "27.92481", "-15.57329", "Atlantic/Canary"),
("2511447", "San Bartolome", "Сан - Бартоломе", "ES", "724", "53", "GC", "35018", "", "29.00093", "-13.613", "Atlantic/Canary"),
("2511448", "Sant Antoni de Portmany", "Сан-Антонио-Абад", "ES", "724", "07", "PM", "07046", "", "38.98068", "1.30362", "Europe/Madrid"),
("2511619", "Sagunto", "Сагунто", "ES", "724", "60", "V", "46220", "", "39.68333", "-0.26667", "Europe/Madrid"),
("2511700", "Rota", "Рота", "ES", "724", "51", "CA", "11030", "", "36.62545", "-6.3622", "Europe/Madrid"),
("2511716", "Roquetas de Mar", "Рокетас-де-Мар", "ES", "724", "51", "AL", "04079", "", "36.76419", "-2.61475", "Europe/Madrid"),
("2511730", "Ronda", "Ронда", "ES", "724", "51", "MA", "29084", "", "36.74231", "-5.16709", "Europe/Madrid"),
("2511752", "Rojales", "Рохалес", "ES", "724", "60", "A", "03113", "", "38.08799", "-0.72544", "Europe/Madrid"),
("2511852", "Rincon de la Victoria", "Ринкон-де-ла-Виктория", "ES", "724", "51", "MA", "29082", "", "36.71715", "-4.27583", "Europe/Madrid"),
("2511880", "Ribarroja", "", "ES", "724", "60", "V", "46111", "", "39.55", "-0.56667", "Europe/Madrid"),
("2511930", "Requena", "Рекена", "ES", "724", "60", "V", "46213", "", "39.48834", "-1.10044", "Europe/Madrid"),
("2511994", "Realejo Alto", "", "ES", "724", "53", "TF", "38026", "", "28.37645", "-16.58575", "Atlantic/Canary"),
("2512127", "Pucol", "", "ES", "724", "60", "V", "46205", "", "39.61667", "-0.3", "Europe/Madrid"),
("2512169", "Puerto Real", "Пуэрто-Реаль", "ES", "724", "51", "CA", "11028", "", "36.52819", "-6.19011", "Europe/Madrid"),
("2512177", "Puertollano", "Пуэртольяно", "ES", "724", "54", "CR", "13071", "", "38.68712", "-4.10734", "Europe/Madrid"),
("2512186", "Puerto del Rosario", "Пуэрто-дель-Росарио", "ES", "724", "53", "GC", "35017", "", "28.50038", "-13.86272", "Atlantic/Canary"),
("2512196", "Puerto de la Cruz", "Пуэрто-де-ла-Крус", "ES", "724", "53", "TF", "38028", "", "28.41397", "-16.54867", "Atlantic/Canary"),
("2512232", "Puente-Genil", "", "ES", "724", "51", "CO", "14056", "", "37.38943", "-4.76686", "Europe/Madrid"),
("2512251", "La Pobla de Vallbona", "", "ES", "724", "60", "V", "46202", "", "39.6", "-0.55", "Europe/Madrid"),
("2512282", "Priego de Cordoba", "Прьего-де-Кордоба", "ES", "724", "51", "CO", "14055", "", "37.43807", "-4.19523", "Europe/Madrid"),
("2512340", "Pozoblanco", "", "ES", "724", "51", "CO", "14054", "", "38.37906", "-4.84827", "Europe/Madrid"),
("2512432", "Pollenca", "", "ES", "724", "07", "PM", "07042", "", "39.87678", "3.01626", "Europe/Madrid"),
("2512581", "Pilar de la Horadada", "Пилар-де-ла-Орадада", "ES", "724", "60", "A", "03902", "", "37.86591", "-0.79256", "Europe/Madrid"),
("2512620", "Picassent", "", "ES", "724", "60", "V", "46194", "", "39.36667", "-0.45", "Europe/Madrid"),
("2512862", "Paterna", "Патерна", "ES", "724", "60", "V", "46190", "", "39.5", "-0.43333", "Europe/Madrid"),
("2512989", "Palma", "Пальма", "ES", "724", "07", "PM", "07040", "", "39.56939", "2.65024", "Europe/Madrid"),
("2512990", "Palma del Rio", "Пальма-дель-Рио", "ES", "724", "51", "CO", "14036", "", "37.70024", "-5.28121", "Europe/Madrid"),
("2513026", "Pajara", "", "ES", "724", "53", "GC", "35015", "", "28.35039", "-14.1076", "Atlantic/Canary"),
("2513029", "Paiporta", "Пайпорта", "ES", "724", "60", "V", "46186", "", "39.43333", "-0.41667", "Europe/Madrid"),
("2513052", "Osuna", "Осуна", "ES", "724", "51", "SE", "41068", "", "37.23765", "-5.10746", "Europe/Madrid"),
("2513076", "Orihuela", "Ориуэла", "ES", "724", "60", "A", "03099", "", "38.08483", "-0.94401", "Europe/Madrid"),
("2513106", "Ontinyent", "Онтеньенте", "ES", "724", "60", "V", "46184", "", "38.81667", "-0.61667", "Europe/Madrid"),
("2513115", "Onda", "Онда", "ES", "724", "60", "CS", "12084", "", "39.96667", "-0.25", "Europe/Madrid"),
("2513145", "Oliva", "Олива", "ES", "724", "60", "V", "46181", "", "38.91971", "-0.11935", "Europe/Madrid"),
("2513195", "Novelda", "Новельда", "ES", "724", "60", "A", "03093", "", "38.38479", "-0.76773", "Europe/Madrid"),
("2513222", "Nijar", "Нихар", "ES", "724", "51", "AL", "04066", "", "36.96655", "-2.20595", "Europe/Madrid"),
("2513240", "Nerja", "", "ES", "724", "51", "MA", "29075", "", "36.75278", "-3.8744", "Europe/Madrid"),
("2513324", "Navalmoral de la Mata", "Навальмораль-де-ла-Мата", "ES", "724", "57", "CC", "10131", "", "39.89158", "-5.54064", "Europe/Madrid"),
("2513416", "Murcia", "Мурсия", "ES", "724", "31", "MU", "30030", "", "37.98704", "-1.13004", "Europe/Madrid"),
("2513436", "Mula", "", "ES", "724", "31", "MU", "30029", "", "38.04094", "-1.49014", "Europe/Madrid"),
("2513465", "Muchamiel", "", "ES", "724", "60", "A", "03014", "", "38.4158", "-0.44529", "Europe/Madrid"),
("2513477", "Motril", "Мотриль", "ES", "724", "51", "GR", "18140", "", "36.75066", "-3.5179", "Europe/Madrid"),
("2513509", "Moron de la Frontera", "Морон-де-ла-Фронтера", "ES", "724", "51", "SE", "41065", "", "37.12084", "-5.45403", "Europe/Madrid"),
("2513601", "Montilla", "Монтилья", "ES", "724", "51", "CO", "14042", "", "37.58627", "-4.63805", "Europe/Madrid"),
("2513604", "Montijo", "", "ES", "724", "57", "BA", "06088", "", "38.90839", "-6.61785", "Europe/Madrid"),
("2513703", "Moncada", "Монкада", "ES", "724", "60", "V", "46171", "", "39.54555", "-0.39551", "Europe/Madrid"),
("2513759", "Molina de Segura", "Молина-де-Сегура", "ES", "724", "31", "MU", "30027", "", "38.05456", "-1.20763", "Europe/Madrid"),
("2513791", "Moguer", "Могер", "ES", "724", "51", "H", "21050", "", "37.27559", "-6.83851", "Europe/Madrid"),
("2513798", "Mogan", "", "ES", "724", "53", "GC", "35012", "", "27.88385", "-15.72538", "Atlantic/Canary"),
("2513811", "Mislata", "Мислата", "ES", "724", "60", "V", "46169", "", "39.47523", "-0.41825", "Europe/Madrid"),
("2513882", "Mijas", "Михас", "ES", "724", "51", "MA", "29070", "", "36.59575", "-4.63728", "Europe/Madrid"),
("2513917", "Merida", "Мерида", "ES", "724", "57", "BA", "06083", "", "38.91611", "-6.34366", "Europe/Madrid"),
("2513947", "Melilla", "Мелилья", "ES", "724", "ML", "ME", "52001", "", "35.29369", "-2.93833", "Africa/Ceuta"),
("2513983", "Mazarron", "Масаррон", "ES", "724", "31", "MU", "30026", "", "37.5992", "-1.31493", "Europe/Madrid"),
("2514042", "Maspalomas", "Маспаломас", "ES", "724", "53", "GC", "35019", "", "27.76056", "-15.58602", "Atlantic/Canary"),
("2514066", "Massamagrell", "", "ES", "724", "60", "V", "46164", "", "39.56667", "-0.33333", "Europe/Madrid"),
("2514073", "Martos", "Мартос", "ES", "724", "51", "J", "23060", "", "37.72107", "-3.97264", "Europe/Madrid"),
("2514097", "Marratxi", "Маррачи", "ES", "724", "07", "PM", "07036", "", "39.64208", "2.75388", "Europe/Madrid"),
("2514158", "Marchena", "", "ES", "724", "51", "SE", "41060", "", "37.329", "-5.41682", "Europe/Madrid"),
("2514169", "Marbella", "Марбелья", "ES", "724", "51", "MA", "29069", "", "36.51543", "-4.88583", "Europe/Madrid"),
("2514176", "Maracena", "", "ES", "724", "51", "GR", "18127", "", "37.20764", "-3.63493", "Europe/Madrid"),
("2514190", "Manzanares", "", "ES", "724", "54", "CR", "13053", "", "38.99915", "-3.36991", "Europe/Madrid"),
("2514197", "Manises", "Манисес", "ES", "724", "60", "V", "46159", "", "39.49139", "-0.46349", "Europe/Madrid"),
("2514216", "Manacor", "Манакор", "ES", "724", "07", "PM", "07033", "", "39.56964", "3.20955", "Europe/Madrid"),
("2514256", "Malaga", "Малага", "ES", "724", "51", "MA", "29067", "", "36.72016", "-4.42034", "Europe/Madrid"),
("2514287", "Mairena del Aljarafe", "Майрена-дель-Альхарафе", "ES", "724", "51", "SE", "41059", "", "37.34461", "-6.06391", "Europe/Madrid"),
("2514288", "Mairena del Alcor", "", "ES", "724", "51", "SE", "41058", "", "37.37301", "-5.74952", "Europe/Madrid"),
("2514301", "Mao", "Мао", "ES", "724", "07", "PM", "07032", "", "39.88853", "4.26583", "Europe/Madrid"),
("2514392", "Lucena", "", "ES", "724", "51", "CO", "14038", "", "37.40881", "-4.48522", "Europe/Madrid"),
("2514553", "Los Palacios y Villafranca", "", "ES", "724", "51", "SE", "41069", "", "37.16181", "-5.92433", "Europe/Madrid"),
("2514651", "Los Llanos de Aridane", "Лос-Льянос-де-Аридане", "ES", "724", "53", "TF", "38024", "", "28.65851", "-17.91821", "Atlantic/Canary"),
("2514824", "Los Barrios", "Лос-Барриос", "ES", "724", "51", "CA", "11035", "", "36.18482", "-5.49213", "Europe/Madrid"),
("2514868", "Los Alcazares", "", "ES", "724", "31", "MU", "30902", "", "37.74425", "-0.85041", "Europe/Madrid"),
("2514891", "Lorca", "Лорка", "ES", "724", "31", "MU", "30024", "", "37.67119", "-1.7017", "Europe/Madrid"),
("2514893", "Lora del Rio", "Лора-дель-Рио", "ES", "724", "51", "SE", "41055", "", "37.65896", "-5.52751", "Europe/Madrid"),
("2514946", "Loja", "Лоха", "ES", "724", "51", "GR", "18122", "", "37.16887", "-4.15129", "Europe/Madrid"),
("2514984", "Llucmajor", "", "ES", "724", "07", "PM", "07031", "", "39.49093", "2.89108", "Europe/Madrid"),
("2515036", "Lliria", "", "ES", "724", "60", "V", "46148", "", "39.63333", "-0.6", "Europe/Madrid"),
("2515045", "Linares", "Линарес", "ES", "724", "51", "J", "23055", "", "38.09519", "-3.63602", "Europe/Madrid"),
("2515072", "Lepe", "Лепе", "ES", "724", "51", "H", "21044", "", "37.25482", "-7.20433", "Europe/Madrid"),
("2515096", "Lebrija", "Лебриха", "ES", "724", "51", "SE", "41053", "", "36.92077", "-6.07529", "Europe/Madrid"),
("2515151", "La Union", "", "ES", "724", "31", "MU", "30041", "", "37.61915", "-0.87799", "Europe/Madrid"),
("2515219", "Las Torres de Cotillas", "", "ES", "724", "31", "MU", "30038", "", "38.02822", "-1.24188", "Europe/Madrid"),
("2515270", "Las Palmas de Gran Canaria", "Лас-Пальмас-де-Гран-Канария", "ES", "724", "53", "GC", "35016", "", "28.09973", "-15.41343", "Atlantic/Canary"),
("2515284", "La Solana", "", "ES", "724", "54", "CR", "13079", "", "38.94422", "-3.2381", "Europe/Madrid"),
("2515493", "Las Cabezas de San Juan", "", "ES", "724", "51", "SE", "41020", "", "36.9838", "-5.93933", "Europe/Madrid"),
("2515555", "La Roda", "Ла-Рода", "ES", "724", "54", "AB", "02069", "", "39.21667", "-2.15", "Europe/Madrid"),
("2515562", "La Rinconada", "Ла-Ринконада", "ES", "724", "51", "SE", "41081", "", "37.48613", "-5.98091", "Europe/Madrid"),
("2515692", "La Orotava", "Ла-Оротава", "ES", "724", "53", "TF", "38026", "", "28.39076", "-16.52309", "Atlantic/Canary"),
("2515698", "La Oliva", "", "ES", "724", "53", "GC", "35014", "", "28.61052", "-13.92912", "Atlantic/Canary"),
("2515701", "la Nucia", "Ла-Нусиа", "ES", "724", "60", "A", "03094", "", "38.61372", "-0.1269", "Europe/Madrid"),
("2515812", "La Linea de la Concepcion", "Ла-Линеа-де-ла-Консепсьон", "ES", "724", "51", "CA", "11022", "", "36.16809", "-5.34777", "Europe/Madrid"),
("2516004", "L'Eliana", "", "ES", "724", "60", "V", "46116", "", "39.56667", "-0.53333", "Europe/Madrid"),
("2516088", "La Carolina", "", "ES", "724", "51", "J", "23021", "", "38.27559", "-3.61534", "Europe/Madrid"),
("2516255", "Jumilla", "Хумилье", "ES", "724", "31", "MU", "30022", "", "38.47917", "-1.325", "Europe/Madrid"),
("2516326", "Jerez de la Frontera", "Херес-де-ла-Фронтера", "ES", "724", "51", "CA", "11020", "", "36.68645", "-6.13606", "Europe/Madrid"),
("2516336", "Javea", "", "ES", "724", "60", "A", "03063", "", "38.78333", "0.16667", "Europe/Madrid"),
("2516345", "Xativa", "Хатива", "ES", "724", "60", "V", "46145", "", "38.98333", "-0.51667", "Europe/Madrid"),
("2516395", "Jaen", "Хаэн", "ES", "724", "51", "J", "23050", "", "37.76922", "-3.79028", "Europe/Madrid"),
("2516431", "Isla Cristina", "Исла-Кристина", "ES", "724", "51", "H", "21042", "", "37.2", "-7.31667", "Europe/Madrid"),
("2516443", "Ingenio", "", "ES", "724", "53", "GC", "35011", "", "27.92086", "-15.4406", "Atlantic/Canary"),
("2516452", "Inca", "Инка", "ES", "724", "07", "PM", "07027", "", "39.7211", "2.91093", "Europe/Madrid"),
("2516474", "Icod de los Vinos", "", "ES", "724", "53", "TF", "38022", "", "28.37241", "-16.71188", "Atlantic/Canary"),
("2516479", "Ibiza", "Ибица", "ES", "724", "07", "PM", "07026", "", "38.90883", "1.43296", "Europe/Madrid"),
("2516480", "Ibi", "Иби", "ES", "724", "60", "A", "03079", "", "38.62533", "-0.57225", "Europe/Madrid"),
("2516542", "Huercal-Overa", "Уэркаль-Овера", "ES", "724", "51", "AL", "04053", "", "37.38897", "-1.94536", "Europe/Madrid"),
("2516548", "Huelva", "Уэльва", "ES", "724", "51", "H", "21041", "", "37.26638", "-6.94004", "Europe/Madrid"),
("2516797", "Hellin", "Эльине", "ES", "724", "54", "AB", "02037", "", "38.5106", "-1.70096", "Europe/Madrid"),
("2516852", "Guimar", "", "ES", "724", "53", "TF", "38020", "", "28.3039", "-16.43254", "Atlantic/Canary"),
("2516860", "Guia de Isora", "Гиа-де-Исора", "ES", "724", "53", "TF", "38019", "", "28.21154", "-16.77947", "Atlantic/Canary"),
("2516902", "Guardamar del Segura", "", "ES", "724", "60", "A", "03076", "", "38.09031", "-0.65556", "Europe/Madrid"),
("2516925", "Guadix", "Гвадикс", "ES", "724", "51", "GR", "18089", "", "37.29932", "-3.13922", "Europe/Madrid"),
("2517111", "Granadilla de Abona", "Гранадилья-де-Абона", "ES", "724", "53", "TF", "38017", "", "28.11882", "-16.57599", "Atlantic/Canary"),
("2517117", "Granada", "Гранада", "ES", "724", "51", "GR", "18087", "", "37.18817", "-3.60667", "Europe/Madrid"),
("2517367", "Gandia", "Гандия", "ES", "724", "60", "V", "46131", "", "38.96667", "-0.18333", "Europe/Madrid"),
("2517436", "Galdar", "Гальдар", "ES", "724", "53", "GC", "35009", "", "28.14701", "-15.6502", "Atlantic/Canary"),
("2517595", "Fuengirola", "Фуэнхирола", "ES", "724", "51", "MA", "29054", "", "36.53998", "-4.62473", "Europe/Madrid"),
("2517750", "Felanitx", "", "ES", "724", "07", "PM", "07022", "", "39.4696", "3.14831", "Europe/Madrid"),
("2517816", "Estepona", "Эстепона", "ES", "724", "51", "MA", "29051", "", "36.42764", "-5.14589", "Europe/Madrid"),
("2518040", "El Viso del Alcor", "", "ES", "724", "51", "SE", "41102", "", "37.39106", "-5.71993", "Europe/Madrid"),
("2518207", "El Puerto de Santa Maria", "Эль-Пуэрто-де-Санта-Мария", "ES", "724", "51", "CA", "11027", "", "36.59389", "-6.23298", "Europe/Madrid"),
("2518494", "El Ejido", "Эль-Эхидо", "ES", "724", "51", "AL", "04013", "", "36.77629", "-2.81456", "Europe/Madrid"),
("2518505", "Elda", "Эльда", "ES", "724", "60", "A", "03066", "", "38.47783", "-0.79157", "Europe/Madrid"),
("2518559", "Elche", "Эльч", "ES", "724", "60", "A", "03065", "", "38.26218", "-0.70107", "Europe/Madrid"),
("2518729", "El Arahal", "", "ES", "724", "51", "SE", "41011", "", "37.26273", "-5.5453", "Europe/Madrid"),
("2518770", "Ecija", "Эсиха", "ES", "724", "51", "SE", "41039", "", "37.5422", "-5.0826", "Europe/Madrid"),
("2518794", "Dos Hermanas", "", "ES", "724", "51", "SE", "41038", "", "37.28287", "-5.92088", "Europe/Madrid"),
("2518820", "Don Benito", "Дон-Бенито", "ES", "724", "57", "BA", "06044", "", "38.95627", "-5.86162", "Europe/Madrid"),
("2518878", "Denia", "Дения", "ES", "724", "60", "A", "03063", "", "38.84078", "0.10574", "Europe/Madrid"),
("2518924", "Daimiel", "Даймьель", "ES", "724", "54", "CR", "13039", "", "39.07004", "-3.61498", "Europe/Madrid"),
("2518949", "Cullera", "Кульера", "ES", "724", "60", "V", "46105", "", "39.16667", "-0.25", "Europe/Madrid"),
("2519068", "Quart de Poblet", "Куарт-де-Поблет", "ES", "724", "60", "V", "46102", "", "39.48139", "-0.43937", "Europe/Madrid"),
("2519110", "Crevillente", "Кревильенте", "ES", "724", "60", "A", "03059", "", "38.24994", "-0.80975", "Europe/Madrid"),
("2519233", "Coria del Rio", "Кориа-дель-Рио", "ES", "724", "51", "SE", "41034", "", "37.28766", "-6.0541", "Europe/Madrid"),
("2519240", "Cordoba", "Кордова", "ES", "724", "51", "CO", "14021", "", "37.89155", "-4.77275", "Europe/Madrid"),
("2519289", "Conil de la Frontera", "", "ES", "724", "51", "CA", "11014", "", "36.27719", "-6.0885", "Europe/Madrid"),
("2519367", "Coin", "", "ES", "724", "51", "MA", "29042", "", "36.65947", "-4.75639", "Europe/Madrid"),
("2519402", "Ciudad Real", "Сьюдад-Реаль", "ES", "724", "54", "CR", "13034", "", "38.98626", "-3.92907", "Europe/Madrid"),
("2519425", "Cieza", "Сьеса", "ES", "724", "31", "MU", "30019", "", "38.23998", "-1.41987", "Europe/Madrid"),
("2519466", "Xirivella", "Чиривелья", "ES", "724", "60", "V", "46110", "", "39.46588", "-0.42589", "Europe/Madrid"),
("2519477", "Chipiona", "Чипиона", "ES", "724", "51", "CA", "11016", "", "36.73663", "-6.43703", "Europe/Madrid"),
("2519513", "Chiclana de la Frontera", "Чиклана-де-ла-Фронтера", "ES", "724", "51", "CA", "11015", "", "36.41915", "-6.14941", "Europe/Madrid"),
("2519651", "Cehegin", "", "ES", "724", "31", "MU", "30028", "", "38.09242", "-1.7985", "Europe/Madrid"),
("2519690", "Catarroja", "Катаррох", "ES", "724", "60", "V", "46094", "", "39.4", "-0.4", "Europe/Madrid"),
("2519738", "Castilleja de la Cuesta", "", "ES", "724", "51", "SE", "41029", "", "37.38594", "-6.05258", "Europe/Madrid"),
("2519752", "Castello de la Plana", "Кастельон-де-ла-Плана", "ES", "724", "60", "CS", "12040", "", "39.98333", "-0.03333", "Europe/Madrid"),
("2520052", "Cartaya", "", "ES", "724", "51", "H", "21021", "", "37.28114", "-7.15071", "Europe/Madrid"),
("2520055", "Cartama", "Картама", "ES", "724", "51", "MA", "29038", "", "36.71068", "-4.63297", "Europe/Madrid"),
("2520058", "Cartagena", "Картахена", "ES", "724", "31", "MU", "30016", "", "37.60512", "-0.98623", "Europe/Madrid"),
("2520118", "Carmona", "Кармона", "ES", "724", "51", "SE", "41024", "", "37.47125", "-5.64608", "Europe/Madrid"),
("2520121", "Carlet", "", "ES", "724", "60", "V", "46085", "", "39.23333", "-0.51667", "Europe/Madrid"),
("2520150", "Carcaixent", "Каркахенте", "ES", "724", "60", "V", "46083", "", "39.13333", "-0.45", "Europe/Madrid"),
("2520171", "Caravaca", "", "ES", "724", "31", "MU", "30028", "", "38.10558", "-1.86342", "Europe/Madrid"),
("2520283", "Candelaria", "Канделарии", "ES", "724", "53", "TF", "38011", "", "28.3548", "-16.37268", "Atlantic/Canary"),
("2520413", "Campo de Criptana", "", "ES", "724", "54", "CR", "13028", "", "39.40463", "-3.12492", "Europe/Madrid"),
("2520425", "Campina", "", "ES", "724", "51", "J", "23097", "", "38.21896", "-2.9807", "Europe/Madrid"),
("2520447", "el Campello", "", "ES", "724", "60", "A", "03050", "", "38.42885", "-0.39774", "Europe/Madrid"),
("2520477", "Camas", "Камас", "ES", "724", "51", "SE", "41021", "", "37.40202", "-6.03314", "Europe/Madrid"),
("2520493", "Calvia", "Кальвиа", "ES", "724", "07", "PM", "07011", "", "39.5657", "2.50621", "Europe/Madrid"),
("2520496", "Calp", "Кальп", "ES", "724", "60", "A", "03047", "", "38.6447", "0.0445", "Europe/Madrid"),
("2520502", "Callosa de Segura", "Кальоса-де-Сегура", "ES", "724", "60", "A", "03049", "", "38.12497", "-0.87822", "Europe/Madrid"),
("2520600", "Cadiz", "Кадис", "ES", "724", "51", "CA", "11012", "", "36.52978", "-6.29465", "Europe/Madrid"),
("2520611", "Caceres", "Касерес", "ES", "724", "57", "CC", "10037", "", "39.47649", "-6.37224", "Europe/Madrid"),
("2520645", "Cabra", "Кабра", "ES", "724", "51", "CO", "14013", "", "37.47249", "-4.44206", "Europe/Madrid"),
("2520709", "Burriana", "Бурриана", "ES", "724", "60", "CS", "12032", "", "39.88901", "-0.08499", "Europe/Madrid"),
("2520712", "Burjassot", "Бурхасот", "ES", "724", "60", "V", "46078", "", "39.51667", "-0.41667", "Europe/Madrid"),
("2520833", "Bormujos", "", "ES", "724", "51", "SE", "41017", "", "37.37358", "-6.07232", "Europe/Madrid"),
("2520968", "Betera", "", "ES", "724", "60", "V", "46070", "", "39.58333", "-0.45", "Europe/Madrid"),
("2521016", "Berja", "Берха", "ES", "724", "51", "AL", "04029", "", "36.84693", "-2.94966", "Europe/Madrid"),
("2521088", "Benidorm", "Бенидорм", "ES", "724", "60", "A", "03031", "", "38.53816", "-0.13098", "Europe/Madrid"),
("2521105", "Benetusser", "", "ES", "724", "60", "V", "46054", "", "39.41667", "-0.4", "Europe/Madrid"),
("2521139", "Benalmadena", "Бенальмадена", "ES", "724", "51", "MA", "29025", "", "36.59548", "-4.56937", "Europe/Madrid"),
("2521215", "Baza", "База", "ES", "724", "51", "GR", "18023", "", "37.49073", "-2.77259", "Europe/Madrid"),
("2521335", "Barbate de Franco", "", "ES", "724", "51", "CA", "11007", "", "36.19237", "-5.92186", "Europe/Madrid"),
("2521410", "Bailen", "Байлен", "ES", "724", "51", "J", "23010", "", "38.09639", "-3.77786", "Europe/Madrid"),
("2521413", "Baeza", "", "ES", "724", "51", "J", "23009", "", "37.99384", "-3.47103", "Europe/Madrid"),
("2521415", "Baena", "Баэна", "ES", "724", "51", "CO", "14007", "", "37.6167", "-4.32245", "Europe/Madrid"),
("2521420", "Badajoz", "Бадахос", "ES", "724", "57", "BA", "06015", "", "38.87789", "-6.97061", "Europe/Madrid"),
("2521456", "Ayamonte", "Айямонте", "ES", "724", "51", "H", "21010", "", "37.20994", "-7.40266", "Europe/Madrid"),
("2521485", "Atarfe", "", "ES", "724", "51", "GR", "18022", "", "37.22479", "-3.68686", "Europe/Madrid"),
("2521510", "Aspe", "Аспе", "ES", "724", "60", "A", "03019", "", "38.34511", "-0.76722", "Europe/Madrid"),
("2521519", "Arucas", "Арукас", "ES", "724", "53", "GC", "35006", "", "28.11983", "-15.52325", "Atlantic/Canary"),
("2521570", "Arrecife", "Аресифе", "ES", "724", "53", "GC", "35004", "", "28.96302", "-13.54769", "Atlantic/Canary"),
("2521582", "Arona", "Арон", "ES", "724", "53", "TF", "38006", "", "28.09962", "-16.68102", "Atlantic/Canary"),
("2521590", "Armilla", "", "ES", "724", "51", "GR", "18021", "", "37.14102", "-3.61854", "Europe/Madrid"),
("2521665", "Arcos de la Frontera", "Аркос-де-ла-Фронтера", "ES", "724", "51", "CA", "11006", "", "36.75075", "-5.81056", "Europe/Madrid"),
("2521676", "Archena", "", "ES", "724", "31", "MU", "30009", "", "38.11631", "-1.30043", "Europe/Madrid"),
("2521710", "Antequera", "Антекера", "ES", "724", "51", "MA", "29015", "", "37.01938", "-4.56123", "Europe/Madrid"),
("2521738", "Andujar", "Андухар", "ES", "724", "51", "J", "23005", "", "38.03922", "-4.05078", "Europe/Madrid"),
("2521804", "Altea", "", "ES", "724", "60", "A", "03018", "", "38.59885", "-0.05139", "Europe/Madrid"),
("2521847", "Almunecar", "Альмуньекар", "ES", "724", "51", "GR", "18017", "", "36.73393", "-3.69072", "Europe/Madrid"),
("2521855", "Almoradi", "Альморади", "ES", "724", "60", "A", "03099", "", "38.10879", "-0.79197", "Europe/Madrid"),
("2521857", "Almonte", "", "ES", "724", "51", "H", "21005", "", "37.2647", "-6.51667", "Europe/Madrid"),
("2521886", "Almeria", "Альмерия", "ES", "724", "51", "AL", "04013", "", "36.83814", "-2.45974", "Europe/Madrid"),
("2521893", "Almendralejo", "Альмендралехо", "ES", "724", "57", "BA", "06011", "", "38.68316", "-6.40747", "Europe/Madrid"),
("2521909", "Almassora", "", "ES", "724", "60", "CS", "12040", "", "39.95", "-0.05", "Europe/Madrid"),
("2521923", "Almansa", "Альманса", "ES", "724", "54", "AB", "02009", "", "38.86917", "-1.09713", "Europe/Madrid"),
("2521964", "Aljaraque", "", "ES", "724", "51", "H", "21002", "", "37.2699", "-7.02312", "Europe/Madrid"),
("2521978", "Alicante", "Аликанте", "ES", "724", "60", "A", "03014", "", "38.34517", "-0.48149", "Europe/Madrid"),
("2521985", "Alhaurin el Grande", "Алаурин-эль-Гранде", "ES", "724", "51", "MA", "29008", "", "36.643", "-4.68728", "Europe/Madrid"),
("2521986", "Alhaurin de la Torre", "", "ES", "724", "51", "MA", "29007", "", "36.66401", "-4.56139", "Europe/Madrid"),
("2521992", "Alhama de Murcia", "Альхама-де-Мурсия", "ES", "724", "31", "MU", "30008", "", "37.85103", "-1.42507", "Europe/Madrid"),
("2522012", "Algemesi", "Альхемеси", "ES", "724", "60", "V", "46029", "", "39.18333", "-0.43333", "Europe/Madrid"),
("2522013", "Algeciras", "Альхесирас", "ES", "724", "51", "CA", "11004", "", "36.13326", "-5.45051", "Europe/Madrid"),
("2522057", "Alfafar", "Альфафар", "ES", "724", "60", "V", "46022", "", "39.41667", "-0.38333", "Europe/Madrid"),
("2522077", "Aldaia", "Альдайя", "ES", "724", "60", "V", "46021", "", "39.46569", "-0.46005", "Europe/Madrid"),
("2522091", "Alcudia", "", "ES", "724", "07", "PM", "07003", "", "39.85316", "3.12138", "Europe/Madrid"),
("2522098", "Alcoy", "Алька", "ES", "724", "60", "A", "03009", "", "38.70545", "-0.47432", "Europe/Madrid"),
("2522129", "Alzira", "Альсира", "ES", "724", "60", "V", "46017", "", "39.15", "-0.43333", "Europe/Madrid"),
("2522131", "Alcazar de San Juan", "Алькасар-де-Сан-Хуан", "ES", "724", "54", "CR", "13005", "", "39.39011", "-3.20827", "Europe/Madrid"),
("2522152", "Alcantarilla", "Алькантарилья", "ES", "724", "31", "MU", "30005", "", "37.96939", "-1.21714", "Europe/Madrid"),
("2522160", "Alcala la Real", "Алькала-ла-Реаль", "ES", "724", "51", "J", "23002", "", "37.4614", "-3.92301", "Europe/Madrid"),
("2522165", "Alcala de Guadaira", "Алькала-де-Гвадаира", "ES", "724", "51", "SE", "41004", "", "37.33791", "-5.83951", "Europe/Madrid"),
("2522203", "Alboraya", "Альборайя", "ES", "724", "60", "V", "46013", "", "39.5", "-0.35", "Europe/Madrid"),
("2522208", "Albolote", "", "ES", "724", "51", "GR", "18003", "", "37.23088", "-3.6551", "Europe/Madrid"),
("2522250", "Albal", "", "ES", "724", "60", "V", "46007", "", "39.4", "-0.41667", "Europe/Madrid"),
("2522258", "Albacete", "Альбасете", "ES", "724", "54", "AB", "02003", "", "38.99424", "-1.85643", "Europe/Madrid"),
("2522297", "Alaquas", "Алакуас", "ES", "724", "60", "V", "46005", "", "39.45568", "-0.461", "Europe/Madrid"),
("2522325", "Aguimes", "Агуимес", "ES", "724", "53", "GC", "35002", "", "27.90539", "-15.44609", "Atlantic/Canary"),
("2522333", "Aguilas", "Агилас", "ES", "724", "31", "MU", "30003", "", "37.4063", "-1.58289", "Europe/Madrid"),
("2522430", "Adra", "Адра", "ES", "724", "51", "AL", "04003", "", "36.74961", "-3.02055", "Europe/Madrid"),
("2522437", "Adeje", "Адехе", "ES", "724", "53", "TF", "38001", "", "28.12271", "-16.726", "Atlantic/Canary"),
("2567529", "Groa de Murviedro", "", "ES", "724", "60", "V", "46220", "", "39.64167", "-0.23889", "Europe/Madrid"),
("3104316", "Zarautz", "", "ES", "724", "59", "SS", "20079", "", "43.28444", "-2.16992", "Europe/Madrid"),
("3104324", "Zaragoza", "Сарагоса", "ES", "724", "52", "Z", "50297", "", "41.65606", "-0.87734", "Europe/Madrid"),
("3104342", "Zamora", "Самора", "ES", "724", "55", "ZA", "49275", "", "41.50633", "-5.74456", "Europe/Madrid"),
("3104475", "Viveiro", "", "ES", "724", "58", "LU", "27066", "", "43.66228", "-7.59344", "Europe/Madrid"),
("3104499", "Gasteiz / Vitoria", "", "ES", "724", "59", "VI", "01059", "", "42.84998", "-2.67268", "Europe/Madrid"),
("3104584", "Vinaros", "Винаросе", "ES", "724", "60", "CS", "12138", "", "40.47033", "0.47559", "Europe/Madrid"),
("3104703", "Villaviciosa de Odon", "Вильявисиоса-де-Одон", "ES", "724", "29", "M", "28181", "", "40.35692", "-3.90011", "Europe/Madrid"),
("3104748", "Villaverde", "", "ES", "724", "29", "M", "28079", "", "40.35", "-3.7", "Europe/Madrid"),
("3105148", "Villaquilambre", "Вильякиламбре", "ES", "724", "55", "LE", "24222", "", "42.64685", "-5.55835", "Europe/Madrid"),
("3105184", "Vilanova i la Geltru", "", "ES", "724", "56", "B", "08307", "", "41.22392", "1.72511", "Europe/Madrid"),
("3105214", "Villanueva del Pardillo", "", "ES", "724", "29", "M", "28177", "", "40.48333", "-3.96667", "Europe/Madrid"),
("3105247", "Villanueva de la Canada", "", "ES", "724", "29", "M", "28176", "", "40.4469", "-4.00428", "Europe/Madrid"),
("3105522", "Vilalba", "", "ES", "724", "58", "LU", "27065", "", "43.3", "-7.68333", "Europe/Madrid"),
("3105575", "Vilagarcia de Arousa", "", "ES", "724", "58", "PO", "36060", "", "42.59631", "-8.76426", "Europe/Madrid"),
("3105600", "Vilafranca del Penedes", "Вильяфранка-дель-Пенедес", "ES", "724", "56", "B", "08305", "", "41.35", "1.7", "Europe/Madrid"),
("3105803", "Vila-seca", "", "ES", "724", "56", "T", "43123", "", "41.11667", "1.15", "Europe/Madrid"),
("3105805", "Vilaseca", "Вила-сека", "ES", "724", "56", "B", "08150", "", "42.06174", "2.25528", "Europe/Madrid"),
("3105935", "Viladecans", "Виладеканс", "ES", "724", "56", "B", "08089", "", "41.31405", "2.01427", "Europe/Madrid"),
("3105976", "Vigo", "Виго", "ES", "724", "58", "PO", "36057", "", "42.23282", "-8.72264", "Europe/Madrid"),
("3106050", "Vic", "", "ES", "724", "56", "B", "08298", "", "41.93012", "2.25486", "Europe/Madrid"),
("3106054", "Vicalvaro", "", "ES", "724", "29", "M", "28079", "", "40.4", "-3.6", "Europe/Madrid"),
("3106180", "El Vendrell", "Вендрель", "ES", "724", "56", "T", "43163", "", "41.21667", "1.53333", "Europe/Madrid"),
("3106492", "Valls", "Вальс", "ES", "724", "56", "T", "43161", "", "41.28612", "1.24993", "Europe/Madrid"),
("3106672", "Valladolid", "Вальядолид", "ES", "724", "55", "VA", "47186", "", "41.65518", "-4.72372", "Europe/Madrid"),
("3106868", "Valdemoro", "Вальдеморо", "ES", "724", "29", "M", "28161", "", "40.19081", "-3.67887", "Europe/Madrid"),
("3107112", "Vaciamadrid", "Васиамадрид", "ES", "724", "29", "M", "28123", "", "40.32605", "-3.51088", "Europe/Madrid"),
("3107139", "Utebo", "", "ES", "724", "52", "Z", "50272", "", "41.71394", "-0.99487", "Europe/Madrid"),
("3107364", "Tui", "", "ES", "724", "58", "PO", "36055", "", "42.04713", "-8.64435", "Europe/Madrid"),
("3107418", "Tudela", "Тудела", "ES", "724", "32", "NA", "31232", "", "42.06166", "-1.60452", "Europe/Madrid"),
("3107677", "Tortosa", "Тортоса", "ES", "724", "56", "T", "43155", "", "40.81249", "0.5216", "Europe/Madrid"),
("3107765", "Torrelodones", "", "ES", "724", "29", "M", "28152", "", "40.57654", "-3.92658", "Europe/Madrid"),
("3107775", "Torrelavega", "Торрелавега", "ES", "724", "39", "S", "39087", "", "43.34944", "-4.04785", "Europe/Madrid"),
("3107784", "Torrejon de Ardoz", "Торрехон-де-Ардос", "ES", "724", "29", "M", "28148", "", "40.45535", "-3.46973", "Europe/Madrid"),
("3107807", "Torredembarra", "", "ES", "724", "56", "T", "43153", "", "41.14505", "1.39861", "Europe/Madrid"),
("3107955", "Tordera", "", "ES", "724", "56", "B", "08284", "", "41.69914", "2.71888", "Europe/Madrid"),
("3108008", "Tolosa", "", "ES", "724", "59", "SS", "20071", "", "43.13484", "-2.07801", "Europe/Madrid"),
("3108118", "Tetuan de las Victorias", "", "ES", "724", "29", "M", "28079", "", "40.46667", "-3.71667", "Europe/Madrid"),
("3108126", "Teruel", "Теруэль", "ES", "724", "52", "TE", "44216", "", "40.3456", "-1.10646", "Europe/Madrid"),
("3108165", "Teo", "", "ES", "724", "58", "C", "15082", "", "42.75", "-8.5", "Europe/Madrid"),
("3108285", "Tarrega", "", "ES", "724", "56", "L", "25217", "", "41.64704", "1.13957", "Europe/Madrid"),
("3108286", "Terrassa", "Террасса", "ES", "724", "56", "B", "08279", "", "41.56667", "2.01667", "Europe/Madrid"),
("3108288", "Tarragona", "Таррагона", "ES", "724", "56", "T", "43148", "", "41.11667", "1.25", "Europe/Madrid"),
("3108317", "Tarancon", "Таранкон", "ES", "724", "54", "CU", "16203", "", "40.00851", "-3.00731", "Europe/Madrid"),
("3108681", "Soria", "Сория", "ES", "724", "55", "SO", "42173", "", "41.76401", "-2.46883", "Europe/Madrid"),
("3108877", "Sitges", "Ситжес", "ES", "724", "56", "B", "08270", "", "41.23506", "1.81193", "Europe/Madrid"),
("3109041", "Sestao", "Сестао", "ES", "724", "59", "BI", "48084", "", "43.30975", "-3.00716", "Europe/Madrid"),
("3109050", "Sesena", "", "ES", "724", "54", "TO", "45161", "", "40.10473", "-3.69793", "Europe/Madrid"),
("3109256", "Segovia", "Сеговия", "ES", "724", "55", "SG", "40194", "", "40.94808", "-4.11839", "Europe/Madrid"),
("3109402", "Cerdanyola del Valles", "", "ES", "724", "56", "B", "08266", "", "41.49109", "2.14079", "Europe/Madrid"),
("3109442", "Sant Vicenc dels Horts", "", "ES", "724", "56", "B", "08263", "", "41.39317", "2.00689", "Europe/Madrid"),
("3109453", "Barakaldo", "", "ES", "724", "59", "BI", "48013", "", "43.29564", "-2.99729", "Europe/Madrid"),
("3109481", "Santurtzi", "", "ES", "724", "59", "BI", "48082", "", "43.32842", "-3.03248", "Europe/Madrid"),
("3109546", "Sant Just Desvern", "", "ES", "724", "56", "B", "08019", "", "41.38602", "2.07573", "Europe/Madrid"),
("3109642", "Santiago de Compostela", "Сантьяго-де-Компостела", "ES", "724", "58", "C", "15078", "", "42.88052", "-8.54569", "Europe/Madrid"),
("3109689", "Santa Perpetua de Mogoda", "", "ES", "724", "56", "B", "08260", "", "41.53333", "2.18333", "Europe/Madrid"),
("3109718", "Santander", "Сантандер", "ES", "724", "39", "S", "39075", "", "43.46472", "-3.80444", "Europe/Madrid"),
("3109804", "Barbera del Valles", "", "ES", "724", "56", "B", "08252", "", "41.5159", "2.12457", "Europe/Madrid"),
("3109981", "Santa Coloma de Gramenet", "Санта-Колома-де-Граманет", "ES", "724", "56", "B", "08125", "", "41.45152", "2.2081", "Europe/Madrid"),
("3110040", "San Sebastian de los Reyes", "Сан-Себастиан-де-лос-Рейес", "ES", "724", "29", "M", "28134", "", "40.54433", "-3.61588", "Europe/Madrid"),
("3110044", "San Sebastian", "Сан-Себастьян", "ES", "724", "59", "SS", "20069", "", "43.31283", "-1.97499", "Europe/Madrid"),
("3110101", "Sant Quirze del Valles", "", "ES", "724", "56", "B", "08238", "", "41.53333", "2.08333", "Europe/Madrid"),
("3110143", "Sant Pere de Ribes", "", "ES", "724", "56", "B", "08270", "", "41.26667", "1.76667", "Europe/Madrid"),
("3110360", "San Martin de la Vega", "Сан-Мартин-де-ла-Вега", "ES", "724", "29", "M", "28132", "", "40.20735", "-3.57063", "Europe/Madrid"),
("3110458", "San Lorenzo de El Escorial", "Сан-Лоренсо-де-Эль-Эскориаль", "ES", "724", "29", "M", "28131", "", "40.59144", "-4.14738", "Europe/Madrid"),
("3110516", "Vilassar de Mar", "", "ES", "724", "56", "B", "08219", "", "41.50961", "2.39365", "Europe/Madrid"),
("3110519", "Sant Joan Despi", "Sant Joan Despí", "ES", "724", "56", "B", "08019", "", "41.36667", "2.06667", "Europe/Madrid"),
("3110610", "Sanxenxo", "", "ES", "724", "58", "PO", "36051", "", "42.39996", "-8.80698", "Europe/Madrid"),
("3110627", "San Fernando de Henares", "", "ES", "724", "29", "M", "28130", "", "40.42386", "-3.53261", "Europe/Madrid"),
("3110642", "Sant Feliu de Llobregat", "Фелиу-де-Льобрегат", "ES", "724", "56", "B", "08211", "", "41.38333", "2.05", "Europe/Madrid"),
("3110643", "Sant Feliu de Guixols", "", "ES", "724", "56", "GI", "17160", "", "41.78333", "3.03333", "Europe/Madrid"),
("3110718", "Sant Cugat del Valles", "", "ES", "724", "56", "B", "08205", "", "41.46667", "2.08333", "Europe/Madrid"),
("3110813", "Sant Celoni", "", "ES", "724", "56", "B", "08202", "", "41.68333", "2.48333", "Europe/Madrid"),
("3110821", "Sant Carles de la Rapita", "Сан-Карлос-де-ла-Рапита", "ES", "724", "56", "T", "43136", "", "40.61667", "0.6", "Europe/Madrid"),
("3110834", "Sant Boi de Llobregat", "", "ES", "724", "56", "B", "08200", "", "41.34357", "2.03659", "Europe/Madrid"),
("3110876", "Sant Andreu de Palomar", "", "ES", "724", "56", "B", "08019", "", "41.43541", "2.18982", "Europe/Madrid"),
("3110880", "San Andres del Rabanedo", "Сан-Андрес-дель-Рабанедо", "ES", "724", "55", "LE", "24089", "", "42.61174", "-5.61671", "Europe/Madrid"),
("3110885", "Sant Andreu de la Barca", "", "ES", "724", "56", "B", "08054", "", "41.44659", "1.97187", "Europe/Madrid"),
("3110921", "Sant Adria de Besos", "", "ES", "724", "56", "B", "08019", "", "41.43073", "2.21855", "Europe/Madrid"),
("3110962", "Sama", "Саме", "ES", "724", "34", "O", "33031", "", "43.29568", "-5.68416", "Europe/Madrid"),
("3110983", "Salt", "", "ES", "724", "56", "GI", "17155", "", "41.97489", "2.79281", "Europe/Madrid"),
("3110986", "Salou", "Салоу", "ES", "724", "56", "T", "43171", "", "41.07663", "1.14163", "Europe/Madrid"),
("3111108", "Salamanca", "Саламанка", "ES", "724", "55", "SA", "37274", "", "40.96882", "-5.66388", "Europe/Madrid"),
("3111199", "Sabadell", "", "ES", "724", "56", "B", "08187", "", "41.54329", "2.10942", "Europe/Madrid"),
("3111294", "Rubi", "Руби", "ES", "724", "56", "B", "08184", "", "41.49226", "2.03305", "Europe/Madrid"),
("3111348", "Roses", "Росас", "ES", "724", "56", "GI", "17152", "", "42.26199", "3.17689", "Europe/Madrid"),
("3111605", "Ripollet", "", "ES", "724", "56", "B", "08180", "", "41.49686", "2.15739", "Europe/Madrid"),
("3111807", "Ribeira", "", "ES", "724", "58", "C", "15089", "", "42.7461", "-8.44392", "Europe/Madrid"),
("3111933", "Reus", "Реус", "ES", "724", "56", "T", "43123", "", "41.15612", "1.10687", "Europe/Madrid"),
("3112011", "Errenteria", "", "ES", "724", "59", "SS", "20067", "", "43.31195", "-1.90234", "Europe/Madrid"),
("3112154", "Redondela", "Редондела", "ES", "724", "58", "PO", "36045", "", "42.28337", "-8.6096", "Europe/Madrid"),
("3112737", "Puente de Vallecas", "", "ES", "724", "29", "M", "28079", "", "40.39354", "-3.662", "Europe/Madrid"),
("3112761", "Ponteareas", "", "ES", "724", "58", "PO", "36042", "", "42.18333", "-8.5", "Europe/Madrid"),
("3112866", "Premia de Mar", "Премия-де-Мар", "ES", "724", "56", "B", "08172", "", "41.49206", "2.36524", "Europe/Madrid"),
("3112989", "Pozuelo de Alarcon", "Посуэло-де-Аларкон", "ES", "724", "29", "M", "28115", "", "40.43293", "-3.81338", "Europe/Madrid"),
("3113035", "Poio", "", "ES", "724", "58", "PO", "36038", "", "42.44423", "-8.71482", "Europe/Madrid"),
("3113082", "Portugalete", "Португалете", "ES", "724", "59", "BI", "48078", "", "43.32099", "-3.02064", "Europe/Madrid"),
("3113157", "Porrino", "", "ES", "724", "58", "PO", "36039", "", "42.16156", "-8.6198", "Europe/Madrid"),
("3113209", "Pontevedra", "Понтеведра", "ES", "724", "58", "PO", "36038", "", "42.431", "-8.64435", "Europe/Madrid"),
("3113236", "Ponferrada", "Понферрада", "ES", "724", "55", "LE", "24115", "", "42.54664", "-6.59619", "Europe/Madrid"),
("3113268", "Pola de Siero", "Пола-де-Сьеро", "ES", "724", "34", "O", "33066", "", "43.39228", "-5.66335", "Europe/Madrid"),
("3113331", "Plasencia", "Пласенсиа", "ES", "724", "57", "CC", "10148", "", "40.03116", "-6.08845", "Europe/Madrid"),
("3113415", "Pinto", "Пинто", "ES", "724", "29", "M", "28113", "", "40.24147", "-3.69999", "Europe/Madrid"),
("3113526", "Pineda de Mar", "Пинеда де Мар", "ES", "724", "56", "B", "08163", "", "41.62763", "2.6889", "Europe/Madrid"),
("3114256", "Parla", "Парла", "ES", "724", "29", "M", "28106", "", "40.23604", "-3.76752", "Europe/Madrid"),
("3114267", "Parets del Valles", "", "ES", "724", "56", "B", "08107", "", "41.57481", "2.23306", "Europe/Madrid"),
("3114472", "Pamplona", "Памплона", "ES", "724", "32", "NA", "31201", "", "42.81687", "-1.64323", "Europe/Madrid"),
("3114531", "Palencia", "Паленсия", "ES", "724", "55", "P", "34120", "", "42.00955", "-4.52406", "Europe/Madrid"),
("3114566", "Palamos", "", "ES", "724", "56", "GI", "17118", "", "41.84843", "3.12912", "Europe/Madrid"),
("3114567", "Palafrugell", "Палафружель", "ES", "724", "56", "GI", "17117", "", "41.91738", "3.1631", "Europe/Madrid"),
("3114711", "Oviedo", "Овьедо", "ES", "724", "34", "O", "33044", "", "43.36029", "-5.84476", "Europe/Madrid"),
("3114957", "Oria", "", "ES", "724", "59", "SS", "20902", "", "43.25541", "-2.01873", "Europe/Madrid"),
("3114965", "Ourense", "Оренсе", "ES", "724", "58", "OR", "32054", "", "42.33669", "-7.86407", "Europe/Madrid"),
("3115093", "Olot", "Олот", "ES", "724", "56", "GI", "17114", "", "42.18096", "2.49012", "Europe/Madrid"),
("3115171", "Olesa de Montserrat", "", "ES", "724", "56", "B", "08076", "", "41.54372", "1.89408", "Europe/Madrid"),
("3115177", "Oleiros", "Олейрос", "ES", "724", "58", "C", "15058", "", "43.33333", "-8.31667", "Europe/Madrid"),
("3115463", "Nigran", "Нигран", "ES", "724", "58", "PO", "36035", "", "42.14153", "-8.80656", "Europe/Madrid"),
("3115659", "Navalcarnero", "Навалькарнеро", "ES", "724", "29", "M", "28096", "", "40.28908", "-4.01197", "Europe/Madrid"),
("3115739", "Naron", "Нарон", "ES", "724", "58", "C", "15054", "", "43.51667", "-8.15278", "Europe/Madrid"),
("3115907", "Mungia", "", "ES", "724", "59", "BI", "48069", "", "43.35", "-2.83333", "Europe/Madrid"),
("3116025", "Mostoles", "Мостолес", "ES", "724", "29", "M", "28092", "", "40.32234", "-3.86496", "Europe/Madrid"),
("3116156", "Moratalaz", "", "ES", "724", "29", "M", "28079", "", "40.41667", "-3.65", "Europe/Madrid"),
("3116224", "Monzon", "", "ES", "724", "52", "HU", "22158", "", "41.91084", "0.19406", "Europe/Madrid"),
("3116262", "Montornes del Valles", "", "ES", "724", "56", "B", "08136", "", "41.53333", "2.26667", "Europe/Madrid"),
("3116478", "Monforte de Lemos", "Монфорте-де-Лемос", "ES", "724", "58", "LU", "27031", "", "42.52165", "-7.51422", "Europe/Madrid"),
("3116503", "Arrasate / Mondragon", "", "ES", "724", "59", "SS", "20055", "", "43.06441", "-2.48977", "Europe/Madrid"),
("3116527", "Montcada i Reixac", "", "ES", "724", "56", "B", "08125", "", "41.48333", "2.18333", "Europe/Madrid"),
("3116553", "Mollet del Valles", "", "ES", "724", "56", "B", "08125", "", "41.54026", "2.21306", "Europe/Madrid"),
("3116562", "Molins de Rei", "", "ES", "724", "56", "B", "08205", "", "41.41667", "2.01667", "Europe/Madrid"),
("3116653", "Moana", "Моания", "ES", "724", "58", "PO", "36029", "", "42.28333", "-8.75", "Europe/Madrid"),
("3116689", "Miranda de Ebro", "Миранда-де-Эбро", "ES", "724", "55", "BU", "09219", "", "42.6865", "-2.94695", "Europe/Madrid"),
("3116789", "Mieres", "Мьерес", "ES", "724", "34", "O", "33037", "", "43.25", "-5.76667", "Europe/Madrid"),
("3116963", "Mejorada del Campo", "", "ES", "724", "29", "M", "28084", "", "40.39283", "-3.48194", "Europe/Madrid"),
("3117010", "Medina del Campo", "Медина-дель-Кампо", "ES", "724", "55", "VA", "47085", "", "41.31239", "-4.91413", "Europe/Madrid"),
("3117164", "Mataro", "Матаро", "ES", "724", "56", "B", "08121", "", "41.54211", "2.4445", "Europe/Madrid"),
("3117232", "El Masnou", "", "ES", "724", "56", "B", "08118", "", "41.47978", "2.3188", "Europe/Madrid"),
("3117331", "Martorell", "Марторелле", "ES", "724", "56", "B", "08114", "", "41.47402", "1.93062", "Europe/Madrid"),
("3117409", "Marin", "", "ES", "724", "58", "PO", "36026", "", "42.38333", "-8.7", "Europe/Madrid"),
("3117533", "Manresa", "Манреса", "ES", "724", "56", "B", "08213", "", "41.72498", "1.82656", "Europe/Madrid"),
("3117539", "Manlleu", "Манльеу", "ES", "724", "56", "B", "08112", "", "42.00228", "2.28476", "Europe/Madrid"),
("3117636", "Malgrat de Mar", "", "ES", "724", "56", "B", "08110", "", "41.64662", "2.74135", "Europe/Madrid"),
("3117667", "Majadahonda", "Махадаонда", "ES", "724", "29", "M", "28080", "", "40.47353", "-3.87182", "Europe/Madrid"),
("3117735", "Madrid", "Мадрид", "ES", "724", "29", "M", "28079", "", "40.4165", "-3.70256", "Europe/Madrid"),
("3117814", "Lugo", "Луго", "ES", "724", "58", "LU", "27028", "", "43.00992", "-7.55602", "Europe/Madrid"),
("3118150", "Logrono", "Логроньо", "ES", "724", "27", "LO", "26089", "", "42.46667", "-2.45", "Europe/Madrid"),
("3118212", "Lloret de Mar", "Льорет-де-Мар", "ES", "724", "56", "GI", "17095", "", "41.69993", "2.84565", "Europe/Madrid"),
("3118228", "Llodio", "", "ES", "724", "59", "VI", "01036", "", "43.14322", "-2.96204", "Europe/Madrid"),
("3118514", "Lleida", "Лерида", "ES", "724", "56", "L", "25120", "", "41.61674", "0.62218", "Europe/Madrid"),
("3118532", "Leon", "Леон", "ES", "724", "55", "LE", "24089", "", "42.60003", "-5.57032", "Europe/Madrid"),
("3118554", "Leioa", "", "ES", "724", "59", "BI", "48054", "", "43.33333", "-2.98333", "Europe/Madrid"),
("3118594", "Leganes", "Леганес", "ES", "724", "29", "M", "28074", "", "40.32718", "-3.7635", "Europe/Madrid"),
("3118848", "Las Rozas de Madrid", "Лас-Росас-де-Мадрид", "ES", "724", "29", "M", "28127", "", "40.49292", "-3.87371", "Europe/Madrid"),
("3119027", "Lasarte", "", "ES", "724", "59", "SS", "20902", "", "43.26774", "-2.02169", "Europe/Madrid"),
("3119231", "La Pineda", "Ла Пинеда", "ES", "724", "56", "B", "08056", "", "41.07625", "1.18515", "Europe/Madrid"),
("3119536", "Lalin", "Лалин", "ES", "724", "58", "PO", "36024", "", "42.66085", "-8.11285", "Europe/Madrid"),
("3119631", "Laguna de Duero", "Лагуна-де-Дуэро", "ES", "724", "55", "VA", "47076", "", "41.58151", "-4.72332", "Europe/Madrid"),
("3119746", "A Estrada", "", "ES", "724", "58", "PO", "36017", "", "42.68333", "-8.48333", "Europe/Madrid"),
("3119841", "A Coruna", "Ла-Корунья", "ES", "724", "58", "C", "15030", "", "43.37135", "-8.396", "Europe/Madrid"),
("3120304", "Irun", "Ирун", "ES", "724", "59", "SS", "20045", "", "43.33904", "-1.78938", "Europe/Madrid"),
("3120410", "Illescas", "Ильескас", "ES", "724", "54", "TO", "45081", "", "40.12213", "-3.84704", "Europe/Madrid"),
("3120431", "Igualada", "Игуалада", "ES", "724", "56", "B", "08250", "", "41.58098", "1.6172", "Europe/Madrid"),
("3120501", "Humanes de Madrid", "", "ES", "724", "29", "M", "28073", "", "40.25038", "-3.83062", "Europe/Madrid"),
("3120514", "Huesca", "Уэска", "ES", "724", "52", "HU", "22125", "", "42.13615", "-0.4087", "Europe/Madrid"),
("3120619", "L'Hospitalet de Llobregat", "Оспиталет-де-Льобрегат", "ES", "724", "56", "B", "08019", "", "41.35967", "2.10028", "Europe/Madrid"),
("3120635", "Hortaleza", "", "ES", "724", "29", "M", "28079", "", "40.47444", "-3.6411", "Europe/Madrid"),
("3120811", "Hernani", "Эрнани", "ES", "724", "59", "SS", "20040", "", "43.26615", "-1.97615", "Europe/Madrid"),
("3120989", "Gernika-Lumo", "", "ES", "724", "59", "BI", "48046", "", "43.31667", "-2.68333", "Europe/Madrid"),
("3121007", "Getxo", "", "ES", "724", "59", "BI", "48044", "", "43.35689", "-3.01146", "Europe/Madrid"),
("3121070", "Guadalajara", "Гвадалахара", "ES", "724", "54", "GU", "19130", "", "40.62862", "-3.16185", "Europe/Madrid"),
("3121145", "Granollers", "", "ES", "724", "56", "B", "08181", "", "41.60797", "2.28773", "Europe/Madrid"),
("3121245", "Gracia", "", "ES", "724", "56", "B", "08019", "", "41.40237", "2.15641", "Europe/Madrid"),
("3121424", "Gijon", "Хихон", "ES", "724", "34", "O", "33024", "", "43.53573", "-5.66152", "Europe/Madrid"),
("3121437", "Getafe", "Хетафе", "ES", "724", "29", "M", "28065", "", "40.30571", "-3.73295", "Europe/Madrid"),
("3121456", "Girona", "Жерона", "ES", "724", "56", "GI", "17079", "", "41.98311", "2.82493", "Europe/Madrid"),
("3121519", "Gava", "Гава", "ES", "724", "56", "B", "08089", "", "41.30605", "2.00123", "Europe/Madrid"),
("3121751", "Galdakao", "Гальдакано", "ES", "724", "59", "BI", "48036", "", "43.23333", "-2.83333", "Europe/Madrid"),
("3121766", "Galapagar", "Галапагар", "ES", "724", "29", "M", "28061", "", "40.5783", "-4.00426", "Europe/Madrid"),
("3121881", "Fuenterrabia", "", "ES", "724", "59", "SS", "20036", "", "43.36859", "-1.79622", "Europe/Madrid"),
("3121960", "Fuenlabrada", "Фуэнлабрада", "ES", "724", "29", "M", "28058", "", "40.28419", "-3.79415", "Europe/Madrid"),
("3122452", "Figueras", "Фигейрас", "ES", "724", "34", "O", "33017", "", "43.53943", "-7.02559", "Europe/Madrid"),
("3122453", "Figueres", "Фигерас", "ES", "724", "56", "GI", "17066", "", "42.26645", "2.96163", "Europe/Madrid"),
("3122826", "Esplugues de Llobregat", "", "ES", "724", "56", "B", "08019", "", "41.37732", "2.08809", "Europe/Madrid"),
("3122912", "Esparreguera", "", "ES", "724", "56", "B", "08076", "", "41.53333", "1.86667", "Europe/Madrid"),
("3123063", "Ermua", "Эрмуа", "ES", "724", "59", "BI", "48034", "", "43.18333", "-2.5", "Europe/Madrid"),
("3123104", "Erandio", "Эрандио", "ES", "724", "59", "BI", "48902", "", "43.30788", "-2.94502", "Europe/Madrid"),
("3123329", "El Prat de Llobregat", "Эль Прат", "ES", "724", "56", "B", "08169", "", "41.32784", "2.09472", "Europe/Madrid"),
("3123493", "Ferrol", "", "ES", "724", "58", "C", "15036", "", "43.48321", "-8.23689", "Europe/Madrid"),
("3123667", "El Astillero", "Эль-Астильеро", "ES", "724", "39", "S", "39008", "", "43.40094", "-3.82051", "Europe/Madrid"),
("3123688", "Ejea de los Caballeros", "Эхеа-де-лос-Кабальерос", "ES", "724", "52", "Z", "50095", "", "42.12632", "-1.13716", "Europe/Madrid"),
("3123709", "Eibar", "Эйбар", "ES", "724", "59", "SS", "20030", "", "43.18493", "-2.47158", "Europe/Madrid"),
("3123773", "Durango", "Дуранго", "ES", "724", "59", "BI", "48027", "", "43.17124", "-2.6338", "Europe/Madrid"),
("3124041", "Culleredo", "Кульередо", "ES", "724", "58", "C", "15031", "", "43.28788", "-8.38858", "Europe/Madrid"),
("3124132", "Cuenca", "Куэнка", "ES", "724", "54", "CU", "16078", "", "40.06667", "-2.13333", "Europe/Madrid"),
("3124408", "Coslada", "Кослада", "ES", "724", "29", "M", "28049", "", "40.42378", "-3.56129", "Europe/Madrid"),
("3124432", "Corvera", "", "ES", "724", "39", "S", "39056", "", "43.26697", "-3.9471", "Europe/Madrid"),
("3124569", "Cornella de Llobregat", "", "ES", "724", "56", "B", "08019", "", "41.35", "2.08333", "Europe/Madrid"),
("3124765", "Colmenar Viejo", "Кольменар-Вьехо", "ES", "724", "29", "M", "28045", "", "40.65909", "-3.76762", "Europe/Madrid"),
("3124794", "Collado-Villalba", "Кольядо-Вильяльба", "ES", "724", "29", "M", "28047", "", "40.63506", "-4.00486", "Europe/Madrid"),
("3124964", "Ciudad Lineal", "", "ES", "724", "29", "M", "28079", "", "40.45455", "-3.64808", "Europe/Madrid"),
("3124967", "Ciutadella", "", "ES", "724", "07", "PM", "07015", "", "40.00112", "3.84144", "Europe/Madrid"),
("3125082", "Ciempozuelos", "", "ES", "724", "29", "M", "28040", "", "40.15913", "-3.62103", "Europe/Madrid"),
("3125239", "Chamartin", "", "ES", "724", "29", "M", "28079", "", "40.46206", "-3.6766", "Europe/Madrid"),
("3125621", "Castro-Urdiales", "", "ES", "724", "39", "S", "39020", "", "43.38286", "-3.22043", "Europe/Madrid"),
("3125723", "Castrillon", "", "ES", "724", "34", "O", "33007", "", "43.39788", "-6.79217", "Europe/Madrid"),
("3125897", "Castelldefels", "", "ES", "724", "56", "B", "08056", "", "41.27794", "1.97033", "Europe/Madrid"),
("3125915", "Castellar del Valles", "", "ES", "724", "56", "B", "08051", "", "41.61667", "2.08333", "Europe/Madrid"),
("3126317", "Cardedeu", "", "ES", "724", "56", "B", "08181", "", "41.63976", "2.35739", "Europe/Madrid"),
("3126369", "Carballo", "Карбальо", "ES", "724", "58", "C", "15019", "", "43.213", "-8.69104", "Europe/Madrid"),
("3126534", "Canovelles", "", "ES", "724", "56", "B", "08086", "", "41.61667", "2.28333", "Europe/Madrid"),
("3126577", "Cangas", "", "ES", "724", "58", "PO", "36008", "", "42.26413", "-8.78462", "Europe/Madrid"),
("3126888", "Cambrils", "Камбрилс", "ES", "724", "56", "T", "43038", "", "41.07479", "1.05244", "Europe/Madrid"),
("3126890", "Cambre", "", "ES", "724", "58", "C", "15017", "", "43.29438", "-8.34736", "Europe/Madrid"),
("3126917", "Camargo", "Камарго", "ES", "724", "39", "S", "39052", "", "43.40744", "-3.88498", "Europe/Madrid"),
("3127007", "Calella", "", "ES", "724", "56", "B", "08035", "", "41.61802", "2.66781", "Europe/Madrid"),
("3127035", "Caldes de Montbui", "", "ES", "724", "56", "B", "08033", "", "41.63333", "2.16667", "Europe/Madrid"),
("3127047", "Calatayud", "Калатаюд", "ES", "724", "52", "Z", "50067", "", "41.35353", "-1.64318", "Europe/Madrid"),
("3127065", "Calahorra", "Калаорра", "ES", "724", "27", "LO", "26036", "", "42.30506", "-1.96521", "Europe/Madrid"),
("3127066", "Calafell", "", "ES", "724", "56", "T", "43037", "", "41.19997", "1.5683", "Europe/Madrid"),
("3127451", "Burlata", "", "ES", "724", "32", "NA", "31086", "", "42.82562", "-1.61671", "Europe/Madrid"),
("3127461", "Burgos", "Бургос", "ES", "724", "55", "BU", "09059", "", "42.35022", "-3.67527", "Europe/Madrid"),
("3127889", "Boiro", "", "ES", "724", "58", "C", "15011", "", "42.65", "-8.9", "Europe/Madrid"),
("3127958", "Boadilla del Monte", "", "ES", "724", "29", "M", "28022", "", "40.405", "-3.87835", "Europe/Madrid"),
("3127978", "Blanes", "Бланес", "ES", "724", "56", "GI", "17023", "", "41.67419", "2.79036", "Europe/Madrid"),
("3128026", "Bilbao", "Бильбао", "ES", "724", "59", "BI", "48020", "", "43.26271", "-2.92528", "Europe/Madrid"),
("3128174", "Bermeo", "Бермео", "ES", "724", "59", "BI", "48017", "", "43.42088", "-2.72152", "Europe/Madrid"),
("3128201", "Berga", "", "ES", "724", "56", "B", "08022", "", "42.10429", "1.84628", "Europe/Madrid"),
("3128272", "Benicassim", "", "ES", "724", "60", "CS", "12028", "", "40.05", "0.06667", "Europe/Madrid"),
("3128273", "Benicarlo", "Беникарло", "ES", "724", "60", "CS", "12027", "", "40.4165", "0.42709", "Europe/Madrid"),
("3128291", "Benavente", "", "ES", "724", "55", "ZA", "49021", "", "42.00249", "-5.67826", "Europe/Madrid"),
("3128382", "Bejar", "Бехар", "ES", "724", "55", "SA", "37046", "", "40.38641", "-5.76341", "Europe/Madrid"),
("3128760", "Barcelona", "Барселона", "ES", "724", "56", "B", "08019", "", "41.38879", "2.15899", "Europe/Madrid"),
("3128795", "Barbastro", "Барбастро", "ES", "724", "52", "HU", "22048", "", "42.03565", "0.12686", "Europe/Madrid"),
("3128824", "Baranain", "Бараньяйн", "ES", "724", "32", "NA", "31901", "", "42.80567", "-1.67731", "Europe/Madrid"),
("3128832", "Barajas de Madrid", "", "ES", "724", "29", "M", "28079", "", "40.47366", "-3.57777", "Europe/Madrid"),
("3128885", "Banyoles", "", "ES", "724", "56", "GI", "17015", "", "42.11667", "2.76667", "Europe/Madrid"),
("3128978", "Balaguer", "", "ES", "724", "56", "L", "25040", "", "41.79117", "0.81094", "Europe/Madrid"),
("3129028", "Badalona", "Бадалона", "ES", "724", "56", "B", "08015", "", "41.45004", "2.24741", "Europe/Madrid"),
("3129046", "Azuqueca de Henares", "Асукека-де-Энарес", "ES", "724", "54", "GU", "19046", "", "40.56688", "-3.25992", "Europe/Madrid"),
("3129135", "Aviles", "Авилес", "ES", "724", "34", "O", "33004", "", "43.55473", "-5.92483", "Europe/Madrid"),
("3129136", "Avila", "Авила", "ES", "724", "55", "AV", "05019", "", "40.65724", "-4.69951", "Europe/Madrid"),
("3129329", "Arteixo", "", "ES", "724", "58", "C", "15005", "", "43.30482", "-8.50749", "Europe/Madrid"),
("3129636", "Arganda", "Арганда", "ES", "724", "29", "M", "28014", "", "40.30076", "-3.43722", "Europe/Madrid"),
("3129857", "Aranjuez", "Аранхуэс", "ES", "724", "29", "M", "28013", "", "40.03108", "-3.60246", "Europe/Madrid"),
("3129877", "Aranda de Duero", "Аранда-де-Дуэро", "ES", "724", "55", "BU", "09018", "", "41.67041", "-3.6892", "Europe/Madrid"),
("3130131", "Amposta", "", "ES", "724", "56", "T", "43014", "", "40.71308", "0.58103", "Europe/Madrid"),
("3130137", "Amorebieta", "", "ES", "724", "59", "BI", "48003", "", "43.21667", "-2.73333", "Europe/Madrid"),
("3130155", "Ames", "Эймса", "ES", "724", "58", "C", "15013", "", "42.9", "-8.63333", "Europe/Madrid"),
("3130380", "Algorta", "", "ES", "724", "59", "BI", "48044", "", "43.34927", "-3.0094", "Europe/Madrid"),
("3130383", "Algete", "", "ES", "724", "29", "M", "28009", "", "40.59711", "-3.49743", "Europe/Madrid"),
("3130564", "Alcorcon", "Алькоркон", "ES", "724", "29", "M", "28007", "", "40.34582", "-3.82487", "Europe/Madrid"),
("3130583", "Alcobendas", "Алькобендас", "ES", "724", "29", "M", "28006", "", "40.54746", "-3.64197", "Europe/Madrid"),
("3130606", "Alcaniz", "Альканьис", "ES", "724", "52", "TE", "44013", "", "41.05", "-0.13333", "Europe/Madrid"),
("3130616", "Alcala de Henares", "Алькала-де-Энарес", "ES", "724", "29", "M", "28005", "", "40.48205", "-3.35996", "Europe/Madrid"),
("6252065", "Nou Barris", "", "ES", "724", "56", "B", "08019", "", "41.44163", "2.17727", "Europe/Madrid"),
("6324376", "Pinar de Chamartin", "", "ES", "724", "29", "M", "28079", "", "40.47903", "-3.66836", "Europe/Madrid"),
("6354969", "Playa del Ingles", "Плая дель Инглес", "ES", "724", "53", "GC", "35019", "", "27.7567", "-15.5787", "Atlantic/Canary"),
("6355013", "Puerto del Carmen", "Пуэрто-дель-Кармен", "ES", "724", "53", "GC", "35028", "", "28.92313", "-13.66579", "Atlantic/Canary"),
("6362987", "Ceuta", "Сеута", "ES", "724", "CE", "CE", "51001", "", "35.88933", "-5.31979", "Africa/Ceuta"),
("6544099", "Moncloa-Aravaca", "", "ES", "724", "29", "M", "28079", "", "40.43547", "-3.7317", "Europe/Madrid"),
("6544100", "Eixample", "Эшампле", "ES", "724", "56", "B", "08019", "", "41.38896", "2.16179", "Europe/Madrid"),
("6544101", "les Corts", "", "ES", "724", "56", "B", "08019", "", "41.38712", "2.13007", "Europe/Madrid"),
("6544102", "Sarria-Sant Gervasi", "", "ES", "724", "56", "B", "08019", "", "41.40104", "2.1394", "Europe/Madrid"),
("6544103", "Horta-Guinardo", "", "ES", "724", "56", "B", "08019", "", "41.41849", "2.1677", "Europe/Madrid"),
("6544104", "Sants-Montjuic", "", "ES", "724", "56", "B", "08019", "", "41.37263", "2.1546", "Europe/Madrid"),
("6544105", "Sant Marti", "", "ES", "724", "56", "B", "08019", "", "41.41814", "2.19933", "Europe/Madrid"),
("6544106", "Ciutat Vella", "", "ES", "724", "56", "B", "08019", "", "41.38022", "2.17319", "Europe/Madrid"),
("6544487", "Arganzuela", "", "ES", "724", "29", "M", "28079", "", "40.40021", "-3.69618", "Europe/Madrid"),
("6544488", "San Blas", "", "ES", "724", "29", "M", "28079", "", "40.43893", "-3.61537", "Europe/Madrid"),
("6544489", "Latina", "", "ES", "724", "29", "M", "28079", "", "40.38897", "-3.74569", "Europe/Madrid"),
("6544490", "Usera", "", "ES", "724", "29", "M", "28079", "", "40.38866", "-3.70035", "Europe/Madrid"),
("6544491", "Salamanca", "Саламанка", "ES", "724", "29", "M", "28079", "", "40.42972", "-3.67975", "Europe/Madrid"),
("6544492", "Chamberi", "", "ES", "724", "29", "M", "28079", "", "40.43404", "-3.70379", "Europe/Madrid"),
("6544493", "Carabanchel", "", "ES", "724", "29", "M", "28079", "", "40.39094", "-3.7242", "Europe/Madrid"),
("6544494", "City Center", "", "ES", "724", "29", "M", "28079", "", "40.41831", "-3.70275", "Europe/Madrid"),
("6544495", "Retiro", "", "ES", "724", "29", "M", "28079", "", "40.41317", "-3.68307", "Europe/Madrid"),
("6559503", "l'Alfas del Pi", "", "ES", "724", "60", "A", "03011", "", "38.58055", "-0.10321", "Europe/Madrid"),
("6559641", "Las Gabias", "", "ES", "724", "51", "GR", "18905", "", "37.13296", "-3.69765", "Europe/Madrid"),
("6615440", "Delicias", "", "ES", "724", "52", "Z", "50297", "", "41.64928", "-0.90757", "Europe/Madrid"),
("6615442", "Almozara", "Альмозара", "ES", "724", "52", "Z", "50297", "", "41.66124", "-0.90169", "Europe/Madrid"),
("6615443", "Montecanal", "", "ES", "724", "52", "Z", "50297", "", "41.62965", "-0.93873", "Europe/Madrid"),
("6615444", "Oliver-Valdefierro, Oliver, Valdefierro", "", "ES", "724", "52", "Z", "50297", "", "41.64454", "-0.93349", "Europe/Madrid"),
("6618856", "Santutxu", "", "ES", "724", "59", "BI", "48020", "", "43.25347", "-2.9161", "Europe/Madrid"),
("6692471", "Los Realejos", "", "ES", "724", "53", "TF", "38031", "", "28.36739", "-16.58335", "Atlantic/Canary"),
("6693088", "Pasaia", "Пасахес", "ES", "724", "59", "SS", "20064", "", "43.3253", "-1.92707", "Europe/Madrid"),
("6697039", "Basauri", "Басаури", "ES", "724", "59", "BI", "48015", "", "43.2397", "-2.8858", "Europe/Madrid"),
("6943537", "Llefia", "", "ES", "724", "56", "B", "08015", "", "41.43806", "2.2195", "Europe/Madrid"),
("7115111", "Corvera de Asturias", "Корвера-де-Астуриас", "ES", "724", "34", "O", "33020", "", "43.51062", "-5.8691", "Europe/Madrid"),
("7521822", "Alpujarra Granadina", "", "ES", "724", "51", "GR", "18121", "", "36.93068", "-3.19565", "Europe/Madrid"),
("8050879", "Iturrama", "", "ES", "724", "32", "NA", "31201", "", "42.80847", "-1.65825", "Europe/Madrid"),
("8050880", "Ermitagana", "", "ES", "724", "32", "NA", "31201", "", "42.81084", "-1.66409", "Europe/Madrid"),
("8050888", "Primer Ensanche", "", "ES", "724", "32", "NA", "31201", "", "42.81483", "-1.64898", "Europe/Madrid"),
("8050889", "Segundo Ensanche", "", "ES", "724", "32", "NA", "31201", "", "42.8139", "-1.64295", "Europe/Madrid"),
("8285534", "Fuencarral-El Pardo", "", "ES", "724", "29", "M", "28079", "", "40.4984", "-3.7314", "Europe/Madrid"),
("8285535", "Villa de Vallecas", "", "ES", "724", "29", "M", "28079", "", "40.36695", "-3.60146", "Europe/Madrid"),
("8629192", "Natahoyo", "", "ES", "724", "34", "O", "33024", "", "43.54035", "-5.68233", "Europe/Madrid"),
("8629435", "MeteOlot", "", "ES", "724", "56", "GI", "17114", "", "42.18539", "2.48805", "Europe/Madrid"),
("325579", "Ziway", "", "ET", "231", "51", "", "", "", "7.93333", "38.71667", "Africa/Addis_Ababa"),
("325780", "Yirga `Alem", "", "ET", "231", "54", "", "", "", "6.75", "38.41667", "Africa/Addis_Ababa"),
("326036", "Yabelo", "", "ET", "231", "51", "", "", "", "4.88333", "38.08333", "Africa/Addis_Ababa"),
("326206", "Werota", "", "ET", "231", "46", "", "", "", "11.91667", "37.7", "Africa/Addis_Ababa"),
("326308", "Wenji", "", "ET", "231", "51", "", "", "", "8.45", "39.28333", "Africa/Addis_Ababa"),
("327694", "Tippi", "", "ET", "231", "54", "", "", "", "7.2", "35.45", "Africa/Addis_Ababa"),
("328689", "Shashemene", "", "ET", "231", "51", "", "", "", "7.2", "38.6", "Africa/Addis_Ababa"),
("328709", "Shambu", "", "ET", "231", "51", "", "", "", "9.56667", "37.1", "Africa/Addis_Ababa"),
("328716", "Shakiso", "", "ET", "231", "51", "", "", "", "5.75", "38.91667", "Africa/Addis_Ababa"),
("329114", "Sebeta", "", "ET", "231", "51", "", "", "", "8.91667", "38.61667", "Africa/Addis_Ababa"),
("329586", "Robit", "", "ET", "231", "46", "", "", "", "12.01667", "39.63333", "Africa/Addis_Ababa"),
("330120", "Nejo", "", "ET", "231", "51", "", "", "", "9.5", "35.5", "Africa/Addis_Ababa"),
("330186", "Nazret", "", "ET", "231", "51", "", "", "", "8.55", "39.26667", "Africa/Addis_Ababa"),
("330491", "Mojo", "", "ET", "231", "51", "", "", "", "8.6", "39.11667", "Africa/Addis_Ababa"),
("330764", "Metu", "", "ET", "231", "51", "", "", "", "8.3", "35.58333", "Africa/Addis_Ababa"),
("330811", "Metahara", "", "ET", "231", "51", "", "", "", "8.9", "39.91667", "Africa/Addis_Ababa"),
("331038", "Mendi", "Менди", "ET", "231", "51", "", "", "", "9.8", "35.1", "Africa/Addis_Ababa"),
("331180", "Mekele", "", "ET", "231", "53", "", "", "", "13.49667", "39.47528", "Africa/Addis_Ababa"),
("331416", "Maych'ew", "", "ET", "231", "53", "", "", "", "12.7875", "39.54222", "Africa/Addis_Ababa"),
("332746", "Korem", "", "ET", "231", "53", "", "", "", "12.50583", "39.52278", "Africa/Addis_Ababa"),
("332880", "K'olito", "", "ET", "231", "54", "", "", "", "7.31667", "38.08333", "Africa/Addis_Ababa"),
("333103", "Kibre Mengist", "", "ET", "231", "51", "", "", "", "5.88333", "38.98333", "Africa/Addis_Ababa"),
("333356", "Kemise", "", "ET", "231", "46", "", "", "", "10.71668", "39.86997", "Africa/Addis_Ababa"),
("333373", "Kombolcha", "Комбольча", "ET", "231", "46", "", "", "", "11.08155", "39.74339", "Africa/Addis_Ababa"),
("333750", "Jinka", "", "ET", "231", "54", "", "", "", "5.65", "36.65", "Africa/Addis_Ababa"),
("333772", "Jima", "", "ET", "231", "51", "", "", "", "7.66667", "36.83333", "Africa/Addis_Ababa"),
("333795", "Jijiga", "Джиджига", "ET", "231", "52", "", "", "", "9.35", "42.8", "Africa/Addis_Ababa"),
("334227", "Inda Silase", "", "ET", "231", "53", "", "", "", "14.10307", "38.28289", "Africa/Addis_Ababa"),
("335035", "Harar", "Харэр", "ET", "231", "50", "", "", "", "9.31387", "42.11815", "Africa/Addis_Ababa"),
("335288", "Hagere Hiywet", "", "ET", "231", "51", "", "", "", "8.98333", "37.85", "Africa/Addis_Ababa"),
("336014", "Gondar", "Гондэр", "ET", "231", "46", "", "", "", "12.6", "37.46667", "Africa/Addis_Ababa"),
("336350", "Goba", "Гоба", "ET", "231", "51", "", "", "", "7.01667", "39.98333", "Africa/Addis_Ababa"),
("336372", "Giyon", "", "ET", "231", "51", "", "", "", "8.53333", "37.98333", "Africa/Addis_Ababa"),
("336454", "Ginir", "", "ET", "231", "51", "", "", "", "7.13952", "40.71083", "Africa/Addis_Ababa"),
("336496", "Gimbi", "", "ET", "231", "51", "", "", "", "9.17031", "35.83491", "Africa/Addis_Ababa"),
("336931", "Genet", "Женя", "ET", "231", "51", "", "", "", "9.06667", "38.5", "Africa/Addis_Ababa"),
("337010", "Gelemso", "", "ET", "231", "51", "", "", "", "8.81667", "40.51667", "Africa/Addis_Ababa"),
("337152", "Gebre Guracha", "", "ET", "231", "51", "", "", "", "9.8", "38.4", "Africa/Addis_Ababa"),
("337405", "Gambela", "Гамбеле", "ET", "231", "49", "", "", "", "8.25", "34.58333", "Africa/Addis_Ababa"),
("337712", "Finote Selam", "", "ET", "231", "46", "", "", "", "10.7", "37.26667", "Africa/Addis_Ababa"),
("337771", "Fiche", "", "ET", "231", "51", "", "", "", "9.8", "38.73333", "Africa/Addis_Ababa"),
("337853", "Felege Neway", "", "ET", "231", "54", "", "", "", "6.3", "36.88333", "Africa/Addis_Ababa"),
("338554", "Dubti", "", "ET", "231", "45", "", "", "", "11.73292", "41.082", "Africa/Addis_Ababa"),
("338726", "Dodola", "Додола", "ET", "231", "51", "", "", "", "6.98333", "39.18333", "Africa/Addis_Ababa"),
("338832", "Dire Dawa", "Диредавы", "ET", "231", "48", "", "", "", "9.59306", "41.86611", "Africa/Addis_Ababa"),
("338998", "Dila", "Дила", "ET", "231", "54", "", "", "", "6.41667", "38.31667", "Africa/Addis_Ababa"),
("339219", "Dese", "", "ET", "231", "46", "", "", "", "11.13333", "39.63333", "Africa/Addis_Ababa"),
("339448", "Dembi Dolo", "", "ET", "231", "51", "", "", "", "8.53333", "34.8", "Africa/Addis_Ababa"),
("339666", "Debre Zeyit", "", "ET", "231", "51", "", "", "", "8.75", "38.98333", "Africa/Addis_Ababa"),
("339686", "Debre Tabor", "", "ET", "231", "46", "", "", "", "11.85", "38.01667", "Africa/Addis_Ababa"),
("339708", "Debre Mark'os", "", "ET", "231", "46", "", "", "", "10.35", "37.73333", "Africa/Addis_Ababa"),
("339734", "Debre Birhan", "", "ET", "231", "46", "", "", "", "9.67954", "39.53262", "Africa/Addis_Ababa"),
("339823", "Debark'", "", "ET", "231", "46", "", "", "", "13.15611", "37.89806", "Africa/Addis_Ababa"),
("341297", "Butajira", "", "ET", "231", "54", "", "", "", "8.11667", "38.36667", "Africa/Addis_Ababa"),
("341397", "Bure", "Буря", "ET", "231", "46", "", "", "", "10.7", "37.06667", "Africa/Addis_Ababa"),
("341742", "Bonga", "Бонга", "ET", "231", "54", "", "", "", "7.28333", "36.23333", "Africa/Addis_Ababa"),
("341877", "Boditi", "", "ET", "231", "54", "", "", "", "6.96667", "37.86667", "Africa/Addis_Ababa"),
("342190", "Bichena", "", "ET", "231", "46", "", "", "", "10.45", "38.2", "Africa/Addis_Ababa"),
("342559", "Bedesa", "", "ET", "231", "51", "", "", "", "8.9", "40.78333", "Africa/Addis_Ababa"),
("342567", "Bedele", "", "ET", "231", "51", "", "", "", "8.456", "36.35302", "Africa/Addis_Ababa"),
("342641", "Bati", "", "ET", "231", "46", "", "", "", "11.19152", "40.01675", "Africa/Addis_Ababa"),
("342856", "Bako", "Бако", "ET", "231", "54", "", "", "", "5.78333", "36.56667", "Africa/Addis_Ababa"),
("342884", "Bahir Dar", "Бахр-Дар", "ET", "231", "46", "", "", "", "11.59364", "37.39077", "Africa/Addis_Ababa"),
("343137", "Hawassa", "Авасе", "ET", "231", "54", "", "", "", "7.06205", "38.47635", "Africa/Addis_Ababa"),
("343292", "Asosa", "", "ET", "231", "47", "343291", "", "", "10.06667", "34.53333", "Africa/Addis_Ababa"),
("343402", "Asbe Teferi", "", "ET", "231", "51", "", "", "", "9.08569", "40.86708", "Africa/Addis_Ababa"),
("343409", "Asaita", "Асайита", "ET", "231", "45", "", "", "", "11.56838", "41.43869", "Africa/Addis_Ababa"),
("343413", "Asasa", "", "ET", "231", "51", "", "", "", "7.1", "39.2", "Africa/Addis_Ababa"),
("343593", "Areka", "", "ET", "231", "54", "", "", "", "7.06667", "37.7", "Africa/Addis_Ababa"),
("343663", "Arba Minch'", "", "ET", "231", "54", "", "", "", "6.03333", "37.55", "Africa/Addis_Ababa"),
("344420", "Aksum", "", "ET", "231", "53", "", "", "", "14.12448", "38.72444", "Africa/Addis_Ababa"),
("344620", "Hagere Maryam", "", "ET", "231", "51", "", "", "", "5.63418", "38.23603", "Africa/Addis_Ababa"),
("344661", "Agaro", "", "ET", "231", "51", "", "", "", "7.85", "36.65", "Africa/Addis_Ababa"),
("344923", "Adis Zemen", "", "ET", "231", "46", "", "", "", "12.11667", "37.78333", "Africa/Addis_Ababa"),
("344979", "Addis Ababa", "Аддис-Абеба", "ET", "231", "44", "", "", "", "9.02497", "38.74689", "Africa/Addis_Ababa"),
("345149", "Adigrat", "", "ET", "231", "53", "", "", "", "14.277", "39.462", "Africa/Addis_Ababa"),
("345353", "Addiet Canna", "", "ET", "231", "46", "", "", "", "11.26667", "37.48333", "Africa/Addis_Ababa"),
("345704", "Abomsa", "", "ET", "231", "46", "", "", "", "9.98333", "39.98333", "Africa/Addis_Ababa"),
("630752", "Ylojarvi", "", "FI", "246", "15", "06", "980", "", "61.55632", "23.59606", "Europe/Helsinki"),
("631707", "Vihti", "Вихти", "FI", "246", "13", "01", "927", "", "60.41699", "24.31965", "Europe/Helsinki"),
("632370", "Varkaus", "Варкаус", "FI", "246", "14", "11", "915", "", "62.31533", "27.873", "Europe/Helsinki"),
("632453", "Vantaa", "Вантаа", "FI", "246", "13", "01", "092", "", "60.29414", "25.04099", "Europe/Helsinki"),
("632672", "Valkeakoski", "Валкеакоски", "FI", "246", "15", "06", "908", "", "61.26421", "24.03122", "Europe/Helsinki"),
("632978", "Vaasa", "Вааса", "FI", "246", "15", "15", "905", "", "63.096", "21.61577", "Europe/Helsinki"),
("633221", "Uusikaupunki", "Уусикаупунки", "FI", "246", "15", "02", "895", "", "60.80043", "21.40841", "Europe/Helsinki"),
("633591", "Tuusula", "Туусула", "FI", "246", "13", "01", "858", "", "60.40368", "25.02638", "Europe/Helsinki"),
("633679", "Turku", "Турку", "FI", "246", "15", "02", "853", "", "60.45148", "22.26869", "Europe/Helsinki"),
("634093", "Tornio", "Торнио", "FI", "246", "06", "19", "851", "", "65.84811", "24.14662", "Europe/Helsinki"),
("634963", "Tampere", "Тампере", "FI", "246", "15", "06", "837", "", "61.49911", "23.78712", "Europe/Helsinki"),
("636947", "Siilinjarvi", "Силинъярви", "FI", "246", "14", "11", "749", "", "63.08333", "27.66667", "Europe/Helsinki"),
("637067", "Sibbo", "", "FI", "246", "13", "01", "753", "", "60.37752", "25.26906", "Europe/Helsinki"),
("637219", "Seinaejoki", "", "FI", "246", "15", "14", "743", "", "62.79446", "22.82822", "Europe/Helsinki"),
("637292", "Savonlinna", "Савонлинна", "FI", "246", "14", "10", "740", "", "61.8699", "28.87999", "Europe/Helsinki"),
("637948", "Salo", "Сало", "FI", "246", "15", "02", "734", "", "60.38333", "23.13333", "Europe/Helsinki"),
("638936", "Rovaniemi", "Рованиеми", "FI", "246", "06", "19", "698", "", "66.5", "25.71667", "Europe/Helsinki"),
("639406", "Riihimaki", "Рийхимяки", "FI", "246", "13", "05", "694", "", "60.73769", "24.77726", "Europe/Helsinki"),
("639734", "Rauma", "Раума", "FI", "246", "15", "04", "684", "", "61.12724", "21.51127", "Europe/Helsinki"),
("640124", "Raisio", "", "FI", "246", "15", "02", "680", "", "60.48592", "22.16895", "Europe/Helsinki"),
("640276", "Raahe", "Рахе", "FI", "246", "08", "17", "678", "", "64.68333", "24.48333", "Europe/Helsinki"),
("640999", "Pori", "Пори", "FI", "246", "15", "04", "609", "", "61.48333", "21.78333", "Europe/Helsinki"),
("641489", "Pirkkala", "", "FI", "246", "15", "06", "604", "", "61.46125", "23.63228", "Europe/Helsinki"),
("643492", "Oulu", "Оулу", "FI", "246", "08", "17", "564", "", "65.01236", "25.46816", "Europe/Helsinki"),
("644171", "Nurmijarvi", "Нурмиярви", "FI", "246", "13", "01", "543", "", "60.46407", "24.8073", "Europe/Helsinki"),
("644450", "Nokia", "Нокиа", "FI", "246", "15", "06", "536", "", "61.46667", "23.5", "Europe/Helsinki"),
("646005", "Mikkeli", "Миккели", "FI", "246", "14", "10", "491", "", "61.68857", "27.27227", "Europe/Helsinki"),
("646723", "Mantsala", "Мянтсяля", "FI", "246", "13", "01", "505", "", "60.63333", "25.31667", "Europe/Helsinki"),
("647751", "Lohja", "", "FI", "246", "13", "01", "444", "", "60.24859", "24.06534", "Europe/Helsinki"),
("648056", "Lieto", "", "FI", "246", "15", "02", "423", "", "60.51032", "22.46176", "Europe/Helsinki"),
("648366", "Lempaala", "", "FI", "246", "15", "06", "418", "", "61.31667", "23.75", "Europe/Helsinki"),
("648738", "Laukaa", "Лаука", "FI", "246", "15", "13", "410", "", "62.41407", "25.95194", "Europe/Helsinki"),
("648900", "Lappeenranta", "Лаппенранта", "FI", "246", "13", "09", "405", "", "61.05871", "28.18871", "Europe/Helsinki"),
("649360", "Lahti", "Лахти", "FI", "246", "13", "07", "398", "", "60.98267", "25.66151", "Europe/Helsinki"),
("649630", "Kirkkonummi", "", "FI", "246", "13", "01", "257", "", "60.12381", "24.43853", "Europe/Helsinki"),
("649924", "Kuusamo", "Куусамо", "FI", "246", "08", "17", "305", "", "65.96667", "29.18333", "Europe/Helsinki"),
("650224", "Kuopio", "Куопио", "FI", "246", "14", "11", "297", "", "62.89238", "27.67703", "Europe/Helsinki"),
("650859", "Kouvola", "Коувола", "FI", "246", "13", "08", "286", "", "60.86667", "26.7", "Europe/Helsinki"),
("650946", "Kotka", "Котка", "FI", "246", "13", "08", "285", "", "60.46667", "26.91667", "Europe/Helsinki"),
("651299", "Korsholm", "", "FI", "246", "15", "15", "499", "", "63.11418", "21.68216", "Europe/Helsinki"),
("651943", "Kokkola", "Коккола", "FI", "246", "15", "16", "272", "", "63.83847", "23.13066", "Europe/Helsinki"),
("653185", "Kerava", "Керава", "FI", "246", "13", "01", "245", "", "60.40338", "25.105", "Europe/Helsinki"),
("653281", "Kemi", "Кеми", "FI", "246", "06", "19", "240", "", "65.73641", "24.56371", "Europe/Helsinki"),
("654137", "Karhula", "Кархула", "FI", "246", "13", "08", "285", "", "60.51667", "26.95", "Europe/Helsinki"),
("654440", "Kangasala", "Кангасала", "FI", "246", "15", "06", "211", "", "61.46383", "24.07602", "Europe/Helsinki"),
("654899", "Kajaani", "Каяни", "FI", "246", "08", "18", "205", "", "64.22728", "27.72846", "Europe/Helsinki"),
("655130", "Kaarina", "Каарина", "FI", "246", "15", "02", "202", "", "60.40724", "22.36904", "Europe/Helsinki"),
("655194", "Jyvaeskylae", "Ювяскюля", "FI", "246", "15", "13", "179", "", "62.24147", "25.72088", "Europe/Helsinki"),
("655808", "Joensuu", "Йоэнсуу", "FI", "246", "14", "12", "167", "", "62.60118", "29.76316", "Europe/Helsinki"),
("655958", "Jarvenpaa", "Ярвенпяя", "FI", "246", "13", "01", "186", "", "60.47369", "25.08992", "Europe/Helsinki"),
("656073", "Janakkala", "Янаккала", "FI", "246", "13", "05", "165", "", "60.9", "24.6", "Europe/Helsinki"),
("656083", "Jamsa", "Йямся", "FI", "246", "15", "13", "182", "", "61.8642", "25.19002", "Europe/Helsinki"),
("656130", "Jakobstad", "Якобстад", "FI", "246", "15", "15", "598", "", "63.67486", "22.70256", "Europe/Helsinki"),
("656688", "Imatra", "Иматра", "FI", "246", "13", "09", "153", "", "61.17185", "28.75242", "Europe/Helsinki"),
("656820", "Iisalmi", "Исалми", "FI", "246", "14", "11", "140", "", "63.55915", "27.19067", "Europe/Helsinki"),
("656913", "Hyvinkaa", "Хювинкяя", "FI", "246", "13", "01", "106", "", "60.63333", "24.86667", "Europe/Helsinki"),
("657530", "Hollola", "Холлола", "FI", "246", "13", "07", "098", "", "61.05", "25.43333", "Europe/Helsinki"),
("658225", "Helsinki", "Хельсинки", "FI", "246", "13", "01", "091", "", "60.16952", "24.93545", "Europe/Helsinki"),
("658288", "Heinola", "Хейнола", "FI", "246", "13", "07", "111", "", "61.20564", "26.03811", "Europe/Helsinki"),
("658629", "Haukipudas", "Хаукипудас", "FI", "246", "08", "17", "564", "", "65.17654", "25.35233", "Europe/Helsinki"),
("659169", "Hamina", "Хамина", "FI", "246", "13", "08", "075", "", "60.56974", "27.19794", "Europe/Helsinki"),
("659180", "Hameenlinna", "Хямеэнлинна", "FI", "246", "13", "05", "109", "", "60.99596", "24.46434", "Europe/Helsinki"),
("659935", "Forssa", "Форсса", "FI", "246", "13", "05", "061", "", "60.81462", "23.62146", "Europe/Helsinki"),
("660158", "Espoo", "Эспоо", "FI", "246", "13", "01", "049", "", "60.2052", "24.6522", "Europe/Helsinki"),
("660561", "Porvoo", "Порвоо", "FI", "246", "13", "01", "638", "", "60.39233", "25.66507", "Europe/Helsinki"),
("661164", "Anjala", "Анъяла", "FI", "246", "13", "08", "286", "", "60.68333", "26.83333", "Europe/Helsinki"),
("7911309", "Laensi-Turunmaa", "", "FI", "246", "15", "02", "445", "", "60.29972", "22.3004", "Europe/Helsinki"),
("2967245", "Yerres", "Йер", "FR", "250", "A8", "91", "912", "91691", "48.71785", "2.49338", "Europe/Paris"),
("2967318", "Wittenheim", "", "FR", "250", "C1", "68", "684", "68376", "47.8078", "7.33702", "Europe/Paris"),
("2967421", "Wattrelos", "Ваттрело", "FR", "250", "B4", "59", "595", "59650", "50.70118", "3.21812", "Europe/Paris"),
("2967438", "Wasquehal", "Васкеаль", "FR", "250", "B4", "59", "595", "59646", "50.67043", "3.13382", "Europe/Paris"),
("2967758", "Voiron", "Вуарон", "FR", "250", "B9", "38", "381", "38563", "45.36395", "5.59209", "Europe/Paris"),
("2967849", "Vitry-sur-Seine", "Витри-сюр-Сен", "FR", "250", "A8", "94", "941", "94081", "48.78716", "2.40332", "Europe/Paris"),
("2967856", "Vitry-le-Francois", "Витри-ле-Франсуа", "FR", "250", "A4", "51", "514", "51649", "48.73333", "4.58333", "Europe/Paris"),
("2967870", "Vitrolles", "Витроль", "FR", "250", "B8", "13", "134", "13117", "43.46", "5.24861", "Europe/Paris"),
("2967879", "Vitre", "Витрэ", "FR", "250", "A2", "35", "351", "35360", "48.11776", "-1.20577", "Europe/Paris"),
("2967917", "Viry-Chatillon", "Вири-Шатиллон", "FR", "250", "A8", "91", "912", "91687", "48.67212", "2.39318", "Europe/Paris"),
("2967934", "Viroflay", "Вирофле", "FR", "250", "A8", "78", "784", "78686", "48.80078", "2.16181", "Europe/Paris"),
("2968054", "Vincennes", "Венсен", "FR", "250", "A8", "94", "942", "94080", "48.8486", "2.43769", "Europe/Paris"),
("2968142", "Villiers-sur-Marne", "Вилье-сюр-Марн", "FR", "250", "A8", "94", "942", "94079", "48.831", "2.54844", "Europe/Paris"),
("2968176", "Villiers-le-Bel", "Вилье-ле-Бель", "FR", "250", "A8", "95", "952", "95680", "49.00875", "2.39819", "Europe/Paris"),
("2968254", "Villeurbanne", "Вийёрбан", "FR", "250", "B9", "69", "691", "69266", "45.76667", "4.88333", "Europe/Paris"),
("2968368", "Villers-les-Nancy", "Виллер-ле-Нанси", "FR", "250", "B2", "54", "543", "54578", "48.67103", "6.15083", "Europe/Paris"),
("2968482", "Villepinte", "", "FR", "250", "A8", "93", "932", "93078", "48.96203", "2.53253", "Europe/Paris"),
("2968496", "Villeparisis", "Вильпаризи", "FR", "250", "A8", "77", "775", "77514", "48.94208", "2.61463", "Europe/Paris"),
("2968515", "Villeneuve-sur-Lot", "Вильнев-сюр-Ло", "FR", "250", "97", "47", "473", "47323", "44.40854", "0.70415", "Europe/Paris"),
("2968529", "Villeneuve-Saint-Georges", "Вильнёв-Сен-Жорж", "FR", "250", "A8", "94", "941", "94078", "48.73219", "2.44925", "Europe/Paris"),
("2968546", "Villeneuve-le-Roi", "", "FR", "250", "A8", "94", "941", "94077", "48.73684", "2.40081", "Europe/Paris"),
("2968555", "Villeneuve-la-Garenne", "", "FR", "250", "A8", "92", "922", "92078", "48.93935", "2.31478", "Europe/Paris"),
("2968620", "Villenave-d'Ornon", "", "FR", "250", "97", "33", "332", "33550", "44.77327", "-0.5442", "Europe/Paris"),
("2968653", "Villemomble", "", "FR", "250", "A8", "93", "931", "93077", "48.88333", "2.5", "Europe/Paris"),
("2968705", "Villejuif", "Вильжюиф", "FR", "250", "A8", "94", "943", "94076", "48.7939", "2.35992", "Europe/Paris"),
("2968748", "Villefranche-sur-Saone", "Вильфранш-сюр-Сон", "FR", "250", "B9", "69", "692", "69264", "45.98333", "4.71667", "Europe/Paris"),
("2968771", "Villefontaine", "", "FR", "250", "B9", "38", "382", "38553", "45.6125", "5.14558", "Europe/Paris"),
("2969109", "Vigneux-sur-Seine", "", "FR", "250", "A8", "91", "912", "91657", "48.70291", "2.41357", "Europe/Paris"),
("2969257", "Vierzon", "Вьерзон", "FR", "250", "A3", "18", "183", "18279", "47.21667", "2.08333", "Europe/Paris"),
("2969284", "Vienne", "Вьенн", "FR", "250", "B9", "38", "383", "38544", "45.51667", "4.86667", "Europe/Paris"),
("2969392", "Vichy", "Виши", "FR", "250", "98", "03", "033", "03310", "46.11667", "3.41667", "Europe/Paris"),
("2969562", "Vesoul", "Везуль", "FR", "250", "A6", "70", "702", "70550", "47.63333", "6.16667", "Europe/Paris"),
("2969612", "Vertou", "", "FR", "250", "B5", "44", "442", "44215", "47.16869", "-1.46929", "Europe/Paris"),
("2969679", "Versailles", "Версаль", "FR", "250", "A8", "78", "784", "78646", "48.8", "2.13333", "Europe/Paris"),
("2969692", "Verrieres-le-Buisson", "", "FR", "250", "A8", "91", "913", "91645", "48.74565", "2.26796", "Europe/Paris"),
("2969766", "Vernon", "", "FR", "250", "A7", "27", "273", "27681", "49.09292", "1.46332", "Europe/Paris"),
("2969796", "Verneuil-sur-Seine", "", "FR", "250", "A8", "78", "783", "78642", "48.97388", "1.9648", "Europe/Paris"),
("2969958", "Verdun", "Верден", "FR", "250", "B2", "55", "553", "55545", "49.16667", "5.38333", "Europe/Paris"),
("2970072", "Venissieux", "Венисье", "FR", "250", "B9", "69", "691", "69259", "45.70254", "4.87147", "Europe/Paris"),
("2970110", "Vendome", "Вандом", "FR", "250", "A3", "41", "412", "41269", "47.8", "1.06667", "Europe/Paris"),
("2970148", "Vence", "", "FR", "250", "B8", "06", "061", "06157", "43.72162", "7.11232", "Europe/Paris"),
("2970203", "Velizy-Villacoublay", "", "FR", "250", "A8", "78", "784", "78640", "48.78198", "2.19395", "Europe/Paris"),
("2970432", "Vaureal", "Вореаль", "FR", "250", "A8", "95", "953", "95637", "49.03333", "2.03333", "Europe/Paris"),
("2970456", "Vaulx-en-Velin", "", "FR", "250", "B9", "69", "691", "69256", "45.7818", "4.92085", "Europe/Paris"),
("2970761", "Vanves", "Ванв", "FR", "250", "A8", "92", "921", "92075", "48.82345", "2.29025", "Europe/Paris"),
("2970777", "Vannes", "Ванн", "FR", "250", "A2", "56", "563", "56260", "47.66667", "-2.75", "Europe/Paris"),
("2970797", "Vandoeuvre-les-Nancy", "Вандёвр-ле-Нанси", "FR", "250", "B2", "54", "543", "54547", "48.65", "6.18333", "Europe/Paris"),
("2970962", "Vallauris", "Валлорис", "FR", "250", "B8", "06", "061", "06155", "43.57803", "7.05451", "Europe/Paris"),
("2971041", "Valenciennes", "Валансьен", "FR", "250", "B4", "59", "596", "59606", "50.35", "3.53333", "Europe/Paris"),
("2971053", "Valence", "", "FR", "250", "B9", "26", "263", "26362", "44.93333", "4.9", "Europe/Paris"),
("2971482", "Tulle", "Тюль", "FR", "250", "B1", "19", "192", "19272", "45.26667", "1.76667", "Europe/Paris"),
("2971549", "Troyes", "Труа", "FR", "250", "A4", "10", "103", "10387", "48.3", "4.08333", "Europe/Paris"),
("2971874", "Tremblay-en-France", "Трамбле-ан-Франс", "FR", "250", "A8", "93", "932", "93073", "48.94956", "2.5684", "Europe/Paris"),
("2972049", "Trappes", "", "FR", "250", "A8", "78", "784", "78621", "48.77413", "2.01781", "Europe/Paris"),
("2972191", "Tours", "Тур", "FR", "250", "A3", "37", "372", "37261", "47.38333", "0.68333", "Europe/Paris"),
("2972237", "Tournefeuille", "", "FR", "250", "B3", "31", "313", "31557", "43.58872", "1.31922", "Europe/Paris"),
("2972270", "Tourlaville", "", "FR", "250", "99", "50", "502", "50602", "49.63828", "-1.56639", "Europe/Paris"),
("2972284", "Tourcoing", "Туркуэн", "FR", "250", "B4", "59", "595", "59599", "50.72391", "3.16117", "Europe/Paris"),
("2972315", "Toulouse", "Тулуза", "FR", "250", "B3", "31", "313", "31555", "43.60426", "1.44367", "Europe/Paris"),
("2972328", "Toulon", "Тулон", "FR", "250", "B8", "83", "832", "83137", "43.11667", "5.93333", "Europe/Paris"),
("2972350", "Toul", "Туль", "FR", "250", "B2", "54", "544", "54528", "48.68333", "5.9", "Europe/Paris"),
("2972444", "Torcy", "", "FR", "250", "A8", "77", "775", "77468", "48.85", "2.65", "Europe/Paris"),
("2972742", "Thonon-les-Bains", "Тонон-ле-Бен", "FR", "250", "B9", "74", "744", "74281", "46.36667", "6.48333", "Europe/Paris"),
("2972811", "Thionville", "Тьонвиль", "FR", "250", "B2", "57", "577", "57672", "49.36667", "6.16667", "Europe/Paris"),
("2972893", "Thiais", "Тие", "FR", "250", "A8", "94", "943", "94073", "48.76496", "2.3961", "Europe/Paris"),
("2973146", "Tergnier", "Тернье", "FR", "250", "B6", "02", "022", "02738", "49.65607", "3.30107", "Europe/Paris"),
("2973258", "Taverny", "Таверни", "FR", "250", "A8", "95", "953", "95607", "49.02542", "2.21691", "Europe/Paris"),
("2973317", "Tassin-la-Demi-Lune", "", "FR", "250", "B9", "69", "691", "69123", "45.75499", "4.78812", "Europe/Paris"),
("2973385", "Tarbes", "Тарб", "FR", "250", "B3", "65", "653", "65440", "43.23333", "0.08333", "Europe/Paris"),
("2973495", "Talence", "Таланс", "FR", "250", "97", "33", "332", "33522", "44.80477", "-0.59543", "Europe/Paris"),
("2973675", "Suresnes", "Сюрен", "FR", "250", "A8", "92", "922", "92073", "48.87143", "2.22929", "Europe/Paris"),
("2973745", "Sucy-en-Brie", "", "FR", "250", "A8", "94", "941", "94071", "48.76872", "2.53474", "Europe/Paris"),
("2973783", "Strasbourg", "Страсбург", "FR", "250", "C1", "67", "678", "67482", "48.58392", "7.74553", "Europe/Paris"),
("2973841", "Stains", "", "FR", "250", "A8", "93", "933", "93072", "48.95", "2.38333", "Europe/Paris"),
("2974153", "Sotteville-les-Rouen", "Соттевиль-ле-Руан", "FR", "250", "A7", "76", "763", "76681", "49.40972", "1.09006", "Europe/Paris"),
("2974188", "Sorgues", "", "FR", "250", "B8", "84", "842", "84129", "44.01023", "4.87381", "Europe/Paris"),
("2974385", "Soisy-sous-Montmorency", "Суази-су-Монморанси", "FR", "250", "A8", "95", "952", "95598", "48.98813", "2.30156", "Europe/Paris"),
("2974389", "Soissons", "Суассон", "FR", "250", "B6", "02", "024", "02722", "49.38167", "3.32361", "Europe/Paris"),
("2974427", "Six-Fours-les-Plages", "", "FR", "250", "B8", "83", "832", "83129", "43.1", "5.85", "Europe/Paris"),
("2974494", "Sin-le-Noble", "", "FR", "250", "B4", "59", "593", "59569", "50.36159", "3.13113", "Europe/Paris"),
("2974655", "Seynod", "", "FR", "250", "B9", "74", "741", "74268", "45.88549", "6.08831", "Europe/Paris"),
("2974678", "Sevres", "Севр", "FR", "250", "A8", "92", "923", "92072", "48.82292", "2.21757", "Europe/Paris"),
("2974681", "Sevran", "", "FR", "250", "A8", "93", "932", "93071", "48.94472", "2.52746", "Europe/Paris"),
("2974733", "Sete", "Сет", "FR", "250", "A9", "34", "343", "34301", "43.4028", "3.69278", "Europe/Paris"),
("2975050", "Sens", "", "FR", "250", "A1", "89", "893", "89387", "48.2", "3.28333", "Europe/Paris"),
("2975088", "Senlis", "", "FR", "250", "B6", "60", "604", "60612", "49.2", "2.58333", "Europe/Paris"),
("2975233", "Selestat", "Селеста", "FR", "250", "C1", "67", "675", "67462", "48.26667", "7.45", "Europe/Paris"),
("2975349", "Sedan", "Седан", "FR", "250", "A4", "08", "083", "08409", "49.7", "4.95", "Europe/Paris"),
("2975446", "Schiltigheim", "", "FR", "250", "C1", "67", "676", "67447", "48.60749", "7.74931", "Europe/Paris"),
("2975469", "Sceaux", "", "FR", "250", "A8", "92", "921", "92071", "48.77644", "2.29026", "Europe/Paris"),
("2975525", "Savigny-sur-Orge", "Савиньи-сюр-Орж", "FR", "250", "A8", "91", "913", "91589", "48.67678", "2.34835", "Europe/Paris"),
("2975536", "Savigny-le-Temple", "Савиньи-ле-храм", "FR", "250", "A8", "77", "772", "77445", "48.57409", "2.58287", "Europe/Paris"),
("2975758", "Saumur", "Сомюр", "FR", "250", "B5", "49", "493", "49328", "47.26667", "-0.08333", "Europe/Paris"),
("2975921", "Sartrouville", "", "FR", "250", "A8", "78", "783", "78586", "48.9482", "2.19169", "Europe/Paris"),
("2975964", "Sarreguemines", "Саргемин", "FR", "250", "B2", "57", "576", "57631", "49.10995", "7.06747", "Europe/Paris"),
("2976043", "Sarcelles", "Сарсель", "FR", "250", "A8", "95", "952", "95585", "49", "2.38333", "Europe/Paris"),
("2976050", "Saran", "", "FR", "250", "A3", "45", "452", "45302", "47.95013", "1.87601", "Europe/Paris"),
("2976179", "Sannois", "Саннуа", "FR", "250", "A8", "95", "951", "95582", "48.96667", "2.25", "Europe/Paris"),
("2976258", "Sanary-sur-Mer", "Санари-сюр-Мер", "FR", "250", "B8", "83", "832", "83123", "43.11784", "5.80006", "Europe/Paris"),
("2976341", "Salon-de-Provence", "Салон-де-Прованс", "FR", "250", "B8", "13", "131", "13103", "43.64074", "5.09545", "Europe/Paris"),
("2976406", "Sallanches", "", "FR", "250", "B9", "74", "742", "74256", "45.94423", "6.63162", "Europe/Paris"),
("2976984", "Saint-Sebastien-sur-Loire", "Санкт-Себастьян-сюр-Луар", "FR", "250", "B5", "44", "442", "44190", "47.20768", "-1.50332", "Europe/Paris"),
("2977246", "Saint-Raphael", "Сент-Рафаэль", "FR", "250", "B8", "83", "831", "83118", "43.42332", "6.7735", "Europe/Paris"),
("2977295", "Saint-Quentin", "", "FR", "250", "B6", "02", "023", "02691", "49.84889", "3.28757", "Europe/Paris"),
("2977356", "Saint-Priest", "", "FR", "250", "B9", "69", "691", "69290", "45.69612", "4.93892", "Europe/Paris"),
("2977388", "Saint-Pol-sur-Mer", "Сен-Поль-сюр-Мер", "FR", "250", "B4", "59", "594", "59183", "51.03116", "2.33984", "Europe/Paris"),
("2977491", "Saint-Pierre-des-Corps", "", "FR", "250", "A3", "37", "372", "37233", "47.38623", "0.74849", "Europe/Paris"),
("2977800", "Saint-Ouen-l'Aumone", "Сент-Уан-л'Омон", "FR", "250", "A8", "95", "953", "95572", "49.04353", "2.12134", "Europe/Paris"),
("2977824", "Saint-Ouen", "Санкт-Оуэн", "FR", "250", "A8", "75", "751", "75056", "48.9", "2.33333", "Europe/Paris"),
("2977845", "Saint-Omer", "", "FR", "250", "B4", "62", "625", "62765", "50.75", "2.25", "Europe/Paris"),
("2977921", "Saint-Nazaire", "Сен-Назер", "FR", "250", "B5", "44", "443", "44184", "47.28333", "-2.2", "Europe/Paris"),
("2977952", "Saint-Michel-sur-Orge", "Сен-Мишель-сюр-Орж", "FR", "250", "A8", "91", "913", "91570", "48.63479", "2.30831", "Europe/Paris"),
("2978072", "Saint-Medard-en-Jalles", "Санкт-Медард-ан-Жалль", "FR", "250", "97", "33", "332", "33449", "44.89692", "-0.72136", "Europe/Paris"),
("2978100", "Saint-Maximin-la-Sainte-Baume", "", "FR", "250", "B8", "83", "833", "83116", "43.45214", "5.86219", "Europe/Paris"),
("2978179", "Saint-Maur-des-Fosses", "Сен-Мор-де-Фоссе", "FR", "250", "A8", "94", "941", "94068", "48.79394", "2.49323", "Europe/Paris"),
("2978317", "Saint-Martin-d'Heres", "Сен-Мартен-д'Эр", "FR", "250", "B9", "38", "381", "38421", "45.16528", "5.76337", "Europe/Paris"),
("2978621", "Saint-Mande", "Санкт-Манде", "FR", "250", "A8", "94", "942", "94067", "48.83864", "2.41579", "Europe/Paris"),
("2978640", "Saint-Malo", "Сен-Мало", "FR", "250", "A2", "35", "354", "35288", "48.65", "-2.01667", "Europe/Paris"),
("2978742", "Saint-Louis", "Сен-Луи", "FR", "250", "C1", "68", "684", "68297", "47.58836", "7.56247", "Europe/Paris"),
("2978758", "Saint-Lo", "Сен-Ло", "FR", "250", "99", "50", "504", "50502", "49.11624", "-1.09031", "Europe/Paris"),
("2978768", "Saint-Leu-la-Foret", "Сен-Лё-ла-Форе", "FR", "250", "A8", "95", "953", "95563", "49.01667", "2.25", "Europe/Paris"),
("2978771", "Saint-Leu", "", "FR", "250", "A1", "71", "712", "71436", "46.7306", "4.50083", "Europe/Paris"),
("2978891", "Saint-Laurent-du-Var", "Сен-Лоран-дю-Вар", "FR", "250", "B8", "06", "061", "06123", "43.67097", "7.17606", "Europe/Paris"),
("2979316", "Saint-Jean-de-la-Ruelle", "", "FR", "250", "A3", "45", "452", "45285", "47.91127", "1.86483", "Europe/Paris"),
("2979341", "Saint-Jean-de-Braye", "", "FR", "250", "A3", "45", "452", "45284", "47.91303", "1.97705", "Europe/Paris"),
("2979590", "Saint-Herblain", "", "FR", "250", "B5", "44", "442", "44162", "47.21765", "-1.64841", "Europe/Paris"),
("2979627", "Saint-Gratien", "", "FR", "250", "A8", "95", "952", "95555", "48.9735", "2.28729", "Europe/Paris"),
("2979783", "Saint-Germain-en-Laye", "Сен-Жермен-ан-Ле", "FR", "250", "A8", "78", "783", "78551", "48.9", "2.08333", "Europe/Paris"),
("2979985", "Saint-Genis-Laval", "Сен-Жени-Лаваль", "FR", "250", "B9", "69", "691", "69204", "45.69558", "4.7934", "Europe/Paris"),
("2980097", "Saint-Fons", "", "FR", "250", "B9", "69", "691", "69199", "45.7088", "4.86057", "Europe/Paris"),
("2980236", "Saint-Etienne-du-Rouvray", "Сент-Этьен-дю-Руврэ", "FR", "250", "A7", "76", "763", "76575", "49.37794", "1.10467", "Europe/Paris"),
("2980291", "Saint-Etienne", "Сент-Этьен", "FR", "250", "B9", "42", "423", "42218", "45.43333", "4.4", "Europe/Paris"),
("2980340", "Saintes", "", "FR", "250", "B7", "17", "174", "17415", "45.75", "-0.63333", "Europe/Paris"),
("2980558", "Sainte-Genevieve-des-Bois", "Сент-Женевьев-де-Буа", "FR", "250", "A8", "91", "913", "91549", "48.64682", "2.31965", "Europe/Paris"),
("2980586", "Sainte-Foy-les-Lyon", "Сент-Фуа-ле-Лион", "FR", "250", "B9", "69", "691", "69202", "45.73692", "4.79688", "Europe/Paris"),
("2980636", "Saint-Egreve", "", "FR", "250", "B9", "38", "381", "38382", "45.23333", "5.68333", "Europe/Paris"),
("2980816", "Saint-Dizier", "Санкт-Дизье", "FR", "250", "A4", "52", "523", "52448", "48.63333", "4.95", "Europe/Paris"),
("2980827", "Saint-Die-des-Vosges", "Сен-Дье-де-Вож", "FR", "250", "B2", "88", "883", "88413", "48.28333", "6.95", "Europe/Paris"),
("2980916", "Saint-Denis", "Сен-Дени", "FR", "250", "A8", "93", "933", "93066", "48.93333", "2.36667", "Europe/Paris"),
("2980935", "Saint-Cyr-sur-Loire", "", "FR", "250", "A3", "37", "372", "37214", "47.4", "0.66667", "Europe/Paris"),
("2980942", "Saint-Cyr-l'Ecole", "Сен-Сир-Леколь", "FR", "250", "A8", "78", "784", "78545", "48.79865", "2.06814", "Europe/Paris"),
("2981041", "Saint-Cloud", "Сен-Клу", "FR", "250", "A8", "92", "923", "92064", "48.84598", "2.20289", "Europe/Paris"),
("2981206", "Saint-Chamond", "Сен-Шамон", "FR", "250", "B9", "42", "423", "42207", "45.47365", "4.52541", "Europe/Paris"),
("2981280", "Saint-Brieuc", "Сент-Брие", "FR", "250", "A2", "22", "224", "22278", "48.51513", "-2.76838", "Europe/Paris"),
("2981492", "Saint-Avold", "", "FR", "250", "B2", "57", "573", "57606", "49.1027", "6.70064", "Europe/Paris"),
("2981512", "Saint-Avertin", "", "FR", "250", "A3", "37", "372", "37208", "47.36357", "0.73993", "Europe/Paris"),
("2981839", "Saint-Amand-les-Eaux", "Сент-Аман-лез-О", "FR", "250", "B4", "59", "596", "59526", "50.44718", "3.43076", "Europe/Paris"),
("2982235", "Rueil-Malmaison", "Рюэй-Мальмезон", "FR", "250", "A8", "92", "922", "92063", "48.8765", "2.18967", "Europe/Paris"),
("2982343", "Royan", "Руайян", "FR", "250", "B7", "17", "172", "17306", "45.62846", "-1.0281", "Europe/Paris"),
("2982652", "Rouen", "Руан", "FR", "250", "A7", "76", "763", "76540", "49.44313", "1.09932", "Europe/Paris"),
("2982681", "Roubaix", "Рубе", "FR", "250", "B4", "59", "595", "59512", "50.69421", "3.17456", "Europe/Paris"),
("2982757", "Rosny-sous-Bois", "Рони-су-Буа", "FR", "250", "A8", "93", "931", "93064", "48.87017", "2.4991", "Europe/Paris"),
("2982944", "Ronchin", "", "FR", "250", "B4", "59", "595", "59507", "50.59883", "3.09056", "Europe/Paris"),
("2982967", "Romorantin-Lanthenay", "Роморантен-Лантене", "FR", "250", "A3", "41", "413", "41194", "47.36667", "1.75", "Europe/Paris"),
("2983011", "Romans-sur-Isere", "Роман-сюр-Изер", "FR", "250", "B9", "26", "263", "26281", "45.04639", "5.0562", "Europe/Paris"),
("2983026", "Romainville", "Роменвиль", "FR", "250", "A8", "93", "931", "93063", "48.8854", "2.43482", "Europe/Paris"),
("2983074", "Roissy-en-Brie", "Руасси-ан-Бри", "FR", "250", "A8", "77", "775", "77390", "48.79159", "2.64747", "Europe/Paris"),
("2983154", "Rodez", "Родез", "FR", "250", "B3", "12", "122", "12202", "44.35258", "2.57338", "Europe/Paris"),
("2983276", "Rochefort", "Рошфор", "FR", "250", "B7", "17", "172", "17299", "45.93333", "-0.98333", "Europe/Paris"),
("2983362", "Roanne", "Роанн", "FR", "250", "B9", "42", "422", "42187", "46.03333", "4.06667", "Europe/Paris"),
("2983440", "Ris-Orangis", "", "FR", "250", "A8", "91", "912", "91521", "48.6511", "2.41406", "Europe/Paris"),
("2983489", "Riom", "Рьом", "FR", "250", "98", "63", "634", "63300", "45.9", "3.11667", "Europe/Paris"),
("2983536", "Rillieux-la-Pape", "Риллиэукс-ла-Пап", "FR", "250", "B9", "69", "691", "69286", "45.81667", "4.9", "Europe/Paris"),
("2983770", "Reze", "Реза", "FR", "250", "B5", "44", "442", "44143", "47.18144", "-1.54965", "Europe/Paris"),
("2983990", "Rennes", "Ренн", "FR", "250", "A2", "35", "353", "35238", "48.11198", "-1.67429", "Europe/Paris"),
("2984114", "Reims", "Реймс", "FR", "250", "A4", "51", "513", "51454", "49.25", "4.03333", "Europe/Paris"),
("2984513", "Rambouillet", "Рамбуйе", "FR", "250", "A8", "78", "782", "78517", "48.65", "1.83333", "Europe/Paris"),
("2984701", "Quimper", "Кемпер", "FR", "250", "A2", "29", "294", "29232", "48", "-4.1", "Europe/Paris"),
("2985034", "Puteaux", "Пюто", "FR", "250", "A8", "92", "922", "92062", "48.88341", "2.23894", "Europe/Paris"),
("2986025", "Port-de-Bouc", "", "FR", "250", "B8", "13", "134", "13077", "43.40657", "4.9809", "Europe/Paris"),
("2986140", "Pontoise", "Понтуаз", "FR", "250", "A8", "95", "953", "95500", "49.05", "2.1", "Europe/Paris"),
("2986160", "Pontivy", "Понтиви", "FR", "250", "A2", "56", "562", "56178", "48.06667", "-2.98333", "Europe/Paris"),
("2986302", "Pontarlier", "Понтарлье", "FR", "250", "A6", "25", "253", "25462", "46.90347", "6.35542", "Europe/Paris"),
("2986306", "Pont-a-Mousson", "Понт-а-Муссон", "FR", "250", "B2", "54", "543", "54431", "48.90786", "6.0589", "Europe/Paris"),
("2986495", "Poitiers", "Пуатье", "FR", "250", "B7", "86", "863", "86194", "46.58333", "0.33333", "Europe/Paris"),
("2986501", "Poissy", "Пуасси", "FR", "250", "A8", "78", "783", "78498", "48.92902", "2.04952", "Europe/Paris"),
("2986732", "Ploemeur", "", "FR", "250", "A2", "56", "561", "56162", "47.73333", "-3.43333", "Europe/Paris"),
("2986930", "Plaisir", "", "FR", "250", "A8", "78", "784", "78490", "48.82319", "1.9541", "Europe/Paris"),
("2986933", "Plaisance-du-Touch", "", "FR", "250", "B3", "31", "313", "31424", "43.56566", "1.29749", "Europe/Paris"),
("2987271", "Pierrefitte-sur-Seine", "", "FR", "250", "A8", "93", "933", "93059", "48.96691", "2.36104", "Europe/Paris"),
("2987805", "Pessac", "Пессаке", "FR", "250", "97", "33", "332", "33318", "44.81011", "-0.64129", "Europe/Paris"),
("2987825", "Pertuis", "", "FR", "250", "B8", "84", "841", "84089", "43.69252", "5.50285", "Europe/Paris"),
("2987914", "Perpignan", "Перпиньян", "FR", "250", "A9", "66", "662", "66136", "42.69764", "2.89541", "Europe/Paris"),
("2987967", "Perigueux", "Периге", "FR", "250", "97", "24", "243", "24322", "45.18333", "0.71667", "Europe/Paris"),
("2988358", "Pau", "Пау", "FR", "250", "97", "64", "643", "64445", "43.3", "-0.36667", "Europe/Paris"),
("2988507", "Paris", "Париж", "FR", "250", "A8", "75", "751", "75056", "48.85341", "2.3488", "Europe/Paris"),
("2988621", "Pantin", "Пантин", "FR", "250", "A8", "93", "931", "93055", "48.89437", "2.40935", "Europe/Paris"),
("2988670", "Pamiers", "Памье", "FR", "250", "B3", "09", "092", "09225", "43.11667", "1.6", "Europe/Paris"),
("2988758", "Palaiseau", "Палезо", "FR", "250", "A8", "91", "913", "91477", "48.71667", "2.25", "Europe/Paris"),
("2988867", "Ozoir-la-Ferriere", "", "FR", "250", "A8", "77", "775", "77350", "48.76699", "2.66871", "Europe/Paris"),
("2988888", "Oyonnax", "Ойонна", "FR", "250", "B9", "01", "014", "01283", "46.25917", "5.65727", "Europe/Paris"),
("2988936", "Outreau", "", "FR", "250", "B4", "62", "623", "62643", "50.70535", "1.5897", "Europe/Paris"),
("2988998", "Oullins", "", "FR", "250", "B9", "69", "691", "69149", "45.71774", "4.80382", "Europe/Paris"),
("2989130", "Osny", "Они", "FR", "250", "A8", "95", "953", "95476", "49.05937", "2.06183", "Europe/Paris"),
("2989170", "Orvault", "Орво", "FR", "250", "B5", "44", "442", "44114", "47.27095", "-1.6219", "Europe/Paris"),
("2989204", "Orsay", "Орсе", "FR", "250", "A8", "91", "913", "91471", "48.69572", "2.18727", "Europe/Paris"),
("2989297", "Orly", "", "FR", "250", "A8", "94", "941", "94054", "48.74792", "2.39252", "Europe/Paris"),
("2989317", "Orleans", "Орлеан", "FR", "250", "A3", "45", "452", "45234", "47.90289", "1.90389", "Europe/Paris"),
("2989460", "Orange", "Оранж", "FR", "250", "B8", "84", "842", "84087", "44.1392", "4.80791", "Europe/Paris"),
("2989611", "Olivet", "Олива", "FR", "250", "A3", "45", "452", "45232", "47.86219", "1.8991", "Europe/Paris"),
("2989755", "Octeville", "", "FR", "250", "99", "50", "502", "50129", "49.62612", "-1.64349", "Europe/Paris"),
("2989877", "Noyon", "Нуайон", "FR", "250", "B6", "60", "603", "60471", "49.58333", "3", "Europe/Paris"),
("2990187", "Noisy-le-Sec", "Шумная-ле-Сек", "FR", "250", "A8", "93", "931", "93053", "48.89148", "2.46451", "Europe/Paris"),
("2990189", "Noisy-le-Grand", "Шумная-ле-Гран", "FR", "250", "A8", "93", "932", "93051", "48.84979", "2.56266", "Europe/Paris"),
("2990192", "Noisiel", "", "FR", "250", "A8", "77", "775", "77337", "48.84868", "2.62435", "Europe/Paris"),
("2990264", "Nogent-sur-Oise", "Ножан-сюр-Уаз", "FR", "250", "B6", "60", "604", "60463", "49.27158", "2.47074", "Europe/Paris"),
("2990265", "Nogent-sur-Marne", "Ножан-сюр-Марн", "FR", "250", "A8", "94", "942", "94052", "48.83333", "2.48333", "Europe/Paris"),
("2990355", "Niort", "Ньор", "FR", "250", "B7", "79", "792", "79191", "46.32313", "-0.45877", "Europe/Paris"),
("2990363", "Nimes", "Ним", "FR", "250", "A9", "30", "302", "30189", "43.83333", "4.35", "Europe/Paris"),
("2990440", "Nice", "Ницца", "FR", "250", "B8", "06", "062", "06088", "43.70313", "7.26608", "Europe/Paris"),
("2990474", "Nevers", "Невер", "FR", "250", "A1", "58", "583", "58194", "46.98956", "3.159", "Europe/Paris"),
("2990611", "Neuilly-sur-Seine", "Нёйи-сюр-Сен", "FR", "250", "A8", "92", "922", "92051", "48.8846", "2.26965", "Europe/Paris"),
("2990612", "Neuilly-sur-Marne", "Нейи-сюр-Марн", "FR", "250", "A8", "93", "932", "93050", "48.85373", "2.54903", "Europe/Paris"),
("2990616", "Neuilly-Plaisance", "", "FR", "250", "A8", "93", "932", "93049", "48.86342", "2.506", "Europe/Paris"),
("2990919", "Narbonne", "Нарбонна", "FR", "250", "A9", "11", "113", "11262", "43.18333", "3", "Europe/Paris"),
("2990969", "Nantes", "Нант", "FR", "250", "B5", "44", "442", "44109", "47.21725", "-1.55336", "Europe/Paris"),
("2990970", "Nanterre", "Нантер", "FR", "250", "A8", "92", "922", "92050", "48.89198", "2.20675", "Europe/Paris"),
("2990999", "Nancy", "Нанси", "FR", "250", "B2", "54", "543", "54395", "48.68439", "6.18496", "Europe/Paris"),
("2991153", "Muret", "Мюре", "FR", "250", "B3", "31", "311", "31395", "43.46667", "1.35", "Europe/Paris"),
("2991214", "Mulhouse", "Мюлуз", "FR", "250", "C1", "68", "684", "68224", "47.75", "7.33333", "Europe/Paris"),
("2991481", "Moulins", "Мулин", "FR", "250", "98", "03", "032", "03190", "46.56667", "3.33333", "Europe/Paris"),
("2991551", "Mougins", "Мужен", "FR", "250", "B8", "06", "061", "06085", "43.59873", "7.00434", "Europe/Paris"),
("2991719", "Morsang-sur-Orge", "", "FR", "250", "A8", "91", "912", "91434", "48.6618", "2.35338", "Europe/Paris"),
("2991772", "Morlaix", "Морле", "FR", "250", "A2", "29", "293", "29151", "48.58333", "-3.83333", "Europe/Paris"),
("2992003", "Mont-Saint-Aignan", "", "FR", "250", "A7", "76", "763", "76451", "49.46307", "1.09364", "Europe/Paris"),
("2992017", "Montrouge", "Монруж", "FR", "250", "A8", "92", "921", "92049", "48.8162", "2.31394", "Europe/Paris"),
("2992090", "Montreuil", "Монтрей", "FR", "250", "A8", "93", "931", "93048", "48.86415", "2.44322", "Europe/Paris"),
("2992166", "Montpellier", "Монпелье", "FR", "250", "A9", "34", "343", "34172", "43.61092", "3.87723", "Europe/Paris"),
("2992229", "Montmorency", "Монморанси", "FR", "250", "A8", "95", "952", "95428", "48.98826", "2.3434", "Europe/Paris"),
("2992292", "Montlucon", "Монлюсон", "FR", "250", "98", "03", "031", "03185", "46.33333", "2.6", "Europe/Paris"),
("2992367", "Montivilliers", "", "FR", "250", "A7", "76", "762", "76447", "49.54518", "0.18769", "Europe/Paris"),
("2992402", "Montigny-les-Metz", "", "FR", "250", "B2", "57", "574", "57480", "49.09435", "6.15167", "Europe/Paris"),
("2992404", "Montigny-les-Cormeilles", "", "FR", "250", "A8", "95", "951", "95424", "48.98202", "2.20035", "Europe/Paris"),
("2992415", "Montigny-le-Bretonneux", "Монтиньи-ле-Бретоннё", "FR", "250", "A8", "78", "784", "78423", "48.76636", "2.03405", "Europe/Paris"),
("2992536", "Montgeron", "Монжероне", "FR", "250", "A8", "91", "912", "91421", "48.70543", "2.45039", "Europe/Paris"),
("2992616", "Montfermeil", "Монфермей", "FR", "250", "A8", "93", "932", "93047", "48.8982", "2.57913", "Europe/Paris"),
("2992650", "Montesson", "", "FR", "250", "A8", "78", "783", "78418", "48.90924", "2.13754", "Europe/Paris"),
("2992671", "Montereau-Fault-Yonne", "Монтро-Фо-Йонна", "FR", "250", "A8", "77", "773", "77305", "48.38333", "2.95", "Europe/Paris"),
("2992703", "Montelimar", "Монтелимаре", "FR", "250", "B9", "26", "262", "26198", "44.55838", "4.75094", "Europe/Paris"),
("2992771", "Mont-de-Marsan", "Мон-де-Марсан", "FR", "250", "97", "40", "402", "40192", "43.89022", "-0.49713", "Europe/Paris"),
("2992863", "Montceau-les-Mines", "Монке-ле-Мине", "FR", "250", "A1", "71", "712", "71306", "46.66667", "4.36667", "Europe/Paris"),
("2992890", "Montbrison", "", "FR", "250", "B9", "42", "421", "42147", "45.6", "4.05", "Europe/Paris"),
("2992938", "Montbeliard", "Монбельяр", "FR", "250", "A6", "25", "252", "25388", "47.51667", "6.8", "Europe/Paris"),
("2993002", "Montauban", "Монтобан", "FR", "250", "B3", "82", "822", "82121", "44.01667", "1.35", "Europe/Paris"),
("2993024", "Montargis", "Монтаржи", "FR", "250", "A3", "45", "451", "45208", "48", "2.75", "Europe/Paris"),
("2993207", "Mons-en-Baroeul", "", "FR", "250", "B4", "59", "595", "59410", "50.63333", "3.11667", "Europe/Paris"),
("2993572", "Moissy-Cramayel", "", "FR", "250", "A8", "77", "772", "77296", "48.62605", "2.60125", "Europe/Paris"),
("2993679", "Mitry-Mory", "", "FR", "250", "A8", "77", "771", "77294", "48.98333", "2.61667", "Europe/Paris"),
("2993760", "Miramas", "Мирама", "FR", "250", "B8", "13", "134", "13063", "43.58666", "5.00464", "Europe/Paris"),
("2993875", "Millau", "Мийо", "FR", "250", "B3", "12", "121", "12145", "44.1", "3.08333", "Europe/Paris"),
("2994048", "Meyzieu", "", "FR", "250", "B9", "69", "691", "69282", "45.76667", "5", "Europe/Paris"),
("2994087", "Meylan", "Мелан", "FR", "250", "B9", "38", "381", "38229", "45.21988", "5.79007", "Europe/Paris"),
("2994144", "Meudon", "Мёдон", "FR", "250", "A8", "92", "923", "92048", "48.81381", "2.235", "Europe/Paris"),
("2994160", "Metz", "Мец", "FR", "250", "B2", "57", "579", "57463", "49.11911", "6.17269", "Europe/Paris"),
("2994393", "Merignac", "", "FR", "250", "97", "33", "332", "33281", "44.83248", "-0.63381", "Europe/Paris"),
("2994497", "Menton", "Ментона", "FR", "250", "B8", "06", "062", "06083", "43.77649", "7.50435", "Europe/Paris"),
("2994651", "Melun", "Мелён", "FR", "250", "A8", "77", "772", "77288", "48.53333", "2.66667", "Europe/Paris"),
("2994798", "Meaux", "Мо", "FR", "250", "A8", "77", "771", "77284", "48.96014", "2.87885", "Europe/Paris"),
("2994935", "Mayenne", "", "FR", "250", "B5", "53", "533", "53147", "48.3", "-0.61667", "Europe/Paris"),
("2995041", "Maurepas", "", "FR", "250", "A8", "78", "782", "78383", "48.76486", "1.92923", "Europe/Paris"),
("2995121", "Mauguio", "", "FR", "250", "A9", "34", "343", "34154", "43.6181", "4.00739", "Europe/Paris"),
("2995150", "Maubeuge", "Мобёж", "FR", "250", "B4", "59", "591", "59392", "50.27875", "3.97267", "Europe/Paris"),
("2995206", "Massy", "Масси", "FR", "250", "A8", "91", "913", "91377", "48.72692", "2.28301", "Europe/Paris"),
("2995387", "Martigues", "Мартиг", "FR", "250", "B8", "13", "134", "13056", "43.40735", "5.05526", "Europe/Paris"),
("2995469", "Marseille", "Марсель", "FR", "250", "B8", "13", "133", "13055", "43.29695", "5.38107", "Europe/Paris"),
("2995642", "Marmande", "Марманд", "FR", "250", "97", "47", "472", "47157", "44.5", "0.16667", "Europe/Paris"),
("2995652", "Marly-le-Roi", "Марли-ле-Руа", "FR", "250", "A8", "78", "783", "78372", "48.86667", "2.08333", "Europe/Paris"),
("2995750", "Marignane", "Мариньян", "FR", "250", "B8", "13", "134", "13054", "43.41604", "5.21453", "Europe/Paris"),
("2995908", "Marcq-en-Baroeul", "Марк-ан-Барёль", "FR", "250", "B4", "59", "595", "59378", "50.66667", "3.08333", "Europe/Paris"),
("2996146", "Mantes-la-Ville", "", "FR", "250", "A8", "78", "781", "78362", "48.97374", "1.70253", "Europe/Paris"),
("2996148", "Mantes-la-Jolie", "Мант-ля-Жоли", "FR", "250", "A8", "78", "781", "78361", "48.98333", "1.71667", "Europe/Paris"),
("2996180", "Manosque", "Маноске", "FR", "250", "B8", "04", "044", "04112", "43.82883", "5.78688", "Europe/Paris"),
("2996255", "Mandelieu-la-Napoule", "", "FR", "250", "B8", "06", "061", "06079", "43.55", "6.93333", "Europe/Paris"),
("2996514", "Malakoff", "", "FR", "250", "A8", "92", "921", "92046", "48.81999", "2.29998", "Europe/Paris"),
("2996564", "Maisons-Laffitte", "Мезон-Лафит", "FR", "250", "A8", "78", "783", "78358", "48.95264", "2.14521", "Europe/Paris"),
("2996568", "Maisons-Alfort", "Мезон-Альфор", "FR", "250", "A8", "94", "941", "94046", "48.81171", "2.43945", "Europe/Paris"),
("2996882", "Macon", "Макон", "FR", "250", "A1", "71", "715", "71270", "46.3", "4.83333", "Europe/Paris"),
("2996944", "Lyon", "Лион", "FR", "250", "B9", "69", "691", "69123", "45.74846", "4.84671", "Europe/Paris"),
("2997110", "Luneville", "Люневиль", "FR", "250", "B2", "54", "542", "54329", "48.6", "6.5", "Europe/Paris"),
("2997116", "Lunel", "Люнель", "FR", "250", "A9", "34", "343", "34145", "43.67778", "4.13611", "Europe/Paris"),
("2997246", "Luce", "", "FR", "250", "A3", "28", "281", "28218", "48.4369", "1.46359", "Europe/Paris"),
("2997336", "Louviers", "", "FR", "250", "A7", "27", "271", "27375", "49.21667", "1.16667", "Europe/Paris"),
("2997395", "Lourdes", "Лурд", "FR", "250", "B3", "65", "651", "65286", "43.1", "-0.05", "Europe/Paris"),
("2997556", "Lormont", "Лормон", "FR", "250", "97", "33", "332", "33249", "44.87495", "-0.51782", "Europe/Paris"),
("2997577", "Lorient", "Лорьян", "FR", "250", "A2", "56", "561", "56121", "47.75", "-3.36667", "Europe/Paris"),
("2997620", "Loos", "", "FR", "250", "B4", "59", "595", "59360", "50.60982", "3.01874", "Europe/Paris"),
("2997626", "Lons-le-Saunier", "Лон-ле-Сонье", "FR", "250", "A6", "39", "392", "39300", "46.66667", "5.55", "Europe/Paris"),
("2997712", "Longjumeau", "Лонжюмо", "FR", "250", "A8", "91", "913", "91345", "48.69503", "2.30736", "Europe/Paris"),
("2997803", "Lomme", "Ломм", "FR", "250", "B4", "59", "595", "59350", "50.64358", "2.98715", "Europe/Paris"),
("2997904", "Lognes", "", "FR", "250", "A8", "77", "775", "77258", "48.83541", "2.62998", "Europe/Paris"),
("2998056", "Livry-Gargan", "", "FR", "250", "A8", "93", "932", "93046", "48.9193", "2.54305", "Europe/Paris"),
("2998127", "L'Isle-sur-la-Sorgue", "Л'Иль-сюр-ла-Сорг", "FR", "250", "B8", "84", "842", "84054", "43.91915", "5.05092", "Europe/Paris"),
("2998150", "Lisieux", "Лизьё", "FR", "250", "99", "14", "143", "14366", "49.1466", "0.22925", "Europe/Paris"),
("2998224", "Lingolsheim", "", "FR", "250", "C1", "67", "676", "67267", "48.55752", "7.68253", "Europe/Paris"),
("2998286", "Limoges", "Лимож", "FR", "250", "B1", "87", "872", "87085", "45.83153", "1.2578", "Europe/Paris"),
("2998305", "Limeil-Brevannes", "", "FR", "250", "A8", "94", "941", "94044", "48.7448", "2.48705", "Europe/Paris"),
("2998311", "Limay", "", "FR", "250", "A8", "78", "781", "78335", "48.99553", "1.74081", "Europe/Paris"),
("2998324", "Lille", "Лилль", "FR", "250", "B4", "59", "595", "59350", "50.63297", "3.05858", "Europe/Paris"),
("2998431", "Lievin", "Лиевен", "FR", "250", "B4", "62", "627", "62510", "50.4198", "2.78068", "Europe/Paris"),
("2998517", "Libourne", "Либурн", "FR", "250", "97", "33", "335", "33243", "44.91667", "-0.23333", "Europe/Paris"),
("2998632", "L'Hay-les-Roses", "", "FR", "250", "A8", "94", "943", "94038", "48.78333", "2.33333", "Europe/Paris"),
("2998854", "Le Vesinet", "Ле-Везине", "FR", "250", "A8", "78", "783", "78650", "48.89281", "2.13308", "Europe/Paris"),
("2998975", "Levallois-Perret", "Леваллуа-Перре", "FR", "250", "A8", "92", "922", "92044", "48.89389", "2.28864", "Europe/Paris"),
("2999683", "Les Sables-d'Olonne", "Ле-Сабль-д’Олон", "FR", "250", "B5", "85", "853", "85194", "46.5", "-1.78333", "Europe/Paris"),
("3000047", "Les Pennes-Mirabeau", "", "FR", "250", "B8", "13", "131", "13071", "43.41028", "5.31306", "Europe/Paris"),
("3000060", "Les Pavillons-sous-Bois", "", "FR", "250", "A8", "93", "931", "93057", "48.90683", "2.50648", "Europe/Paris"),
("3000192", "Les Mureaux", "", "FR", "250", "A8", "78", "781", "78440", "48.99173", "1.90972", "Europe/Paris"),
("3000491", "Les Lilas", "", "FR", "250", "A8", "93", "931", "93045", "48.87992", "2.42057", "Europe/Paris"),
("3000648", "Les Herbiers", "", "FR", "250", "B5", "85", "852", "85109", "46.86667", "-1.01667", "Europe/Paris"),
("3001402", "Les Clayes-sous-Bois", "", "FR", "250", "A8", "78", "784", "78165", "48.82206", "1.98677", "Europe/Paris"),
("3002465", "Le Puy-en-Velay", "Пюи-ан-Веле", "FR", "250", "98", "43", "432", "43157", "45.04366", "3.88523", "Europe/Paris"),
("3002499", "Le Pre-Saint-Gervais", "", "FR", "250", "A8", "93", "931", "93061", "48.88549", "2.40422", "Europe/Paris"),
("3002570", "Le Pontet", "", "FR", "250", "B8", "84", "842", "84092", "43.96119", "4.86008", "Europe/Paris"),
("3002647", "Le Plessis-Trevise", "", "FR", "250", "A8", "94", "942", "94059", "48.81074", "2.57363", "Europe/Paris"),
("3002650", "Le Plessis-Robinson", "Ле-Плесси-Робинсон", "FR", "250", "A8", "92", "921", "92060", "48.78889", "2.27078", "Europe/Paris"),
("3002880", "Le Petit-Quevilly", "", "FR", "250", "A7", "76", "763", "76498", "49.41338", "1.06155", "Europe/Paris"),
("3002965", "Le Perreux-sur-Marne", "", "FR", "250", "A8", "94", "942", "94058", "48.85", "2.5", "Europe/Paris"),
("3002984", "Le Pecq", "", "FR", "250", "A8", "78", "783", "78481", "48.89317", "2.10371", "Europe/Paris"),
("3003093", "Lens", "", "FR", "250", "B4", "62", "627", "62498", "50.43302", "2.82791", "Europe/Paris"),
("3003481", "Le Mee-sur-Seine", "", "FR", "250", "A8", "77", "772", "77285", "48.53157", "2.62829", "Europe/Paris"),
("3003603", "Le Mans", "Ле-Ман", "FR", "250", "B5", "72", "723", "72181", "48", "0.2", "Europe/Paris"),
("3003737", "Le Kremlin-Bicetre", "Ле-Кремлен-Бисетр", "FR", "250", "A8", "94", "943", "94043", "48.81471", "2.36073", "Europe/Paris"),
("3003796", "Le Havre", "Гавр", "FR", "250", "A7", "76", "762", "76351", "49.4938", "0.10767", "Europe/Paris"),
("3003952", "Le Grand-Quevilly", "Гран-Кевилли", "FR", "250", "A7", "76", "763", "76322", "49.40076", "1.04582", "Europe/Paris"),
("3004427", "Le Creusot", "Ле-Крёзо", "FR", "250", "A1", "71", "711", "71153", "46.80714", "4.41632", "Europe/Paris"),
("3004630", "Le Chesnay", "Ле-Шене", "FR", "250", "A8", "78", "784", "78158", "48.8222", "2.12213", "Europe/Paris"),
("3004871", "Le Cannet", "Ле-Канне", "FR", "250", "B8", "06", "061", "06030", "43.57662", "7.01912", "Europe/Paris"),
("3005066", "Le Bouscat", "Ле-Буска", "FR", "250", "97", "33", "332", "33069", "44.866", "-0.59411", "Europe/Paris"),
("3005269", "Le Blanc-Mesnil", "Ле-Блан-Мениль", "FR", "250", "A8", "93", "932", "93007", "48.93872", "2.46138", "Europe/Paris"),
("3005417", "Laxou", "Лаксу", "FR", "250", "B2", "54", "543", "54304", "48.68315", "6.148", "Europe/Paris"),
("3005825", "La Valette-du-Var", "", "FR", "250", "B8", "83", "832", "83144", "43.13741", "5.98314", "Europe/Paris"),
("3005866", "Laval", "Лаваль", "FR", "250", "B5", "53", "532", "53130", "48.06667", "-0.76667", "Europe/Paris"),
("3006121", "Lattes", "", "FR", "250", "A9", "34", "343", "34129", "43.56752", "3.9046", "Europe/Paris"),
("3006283", "La Teste-de-Buch", "Ла-Тест-де-Буха", "FR", "250", "97", "33", "336", "33529", "44.62875", "-1.14059", "Europe/Paris"),
("3006414", "La Seyne-sur-Mer", "Ла-Сейн-сюр-Мер", "FR", "250", "B8", "83", "832", "83126", "43.09818", "5.88472", "Europe/Paris"),
("3006767", "La Roche-sur-Yon", "Ла-Рош-сюр-Йон", "FR", "250", "B5", "85", "852", "85191", "46.66667", "-1.43333", "Europe/Paris"),
("3006787", "La Rochelle", "Ла-Рошель", "FR", "250", "B7", "17", "173", "17300", "46.16667", "-1.15", "Europe/Paris"),
("3007477", "Laon", "Лана", "FR", "250", "B6", "02", "022", "02408", "49.56667", "3.61667", "Europe/Paris"),
("3007609", "Lannion", "Ланнион", "FR", "250", "A2", "22", "223", "22113", "48.73333", "-3.46667", "Europe/Paris"),
("3007794", "Lanester", "", "FR", "250", "A2", "56", "561", "56098", "47.76132", "-3.33965", "Europe/Paris"),
("3007874", "Landerneau", "", "FR", "250", "A2", "29", "291", "29103", "48.45252", "-4.25252", "Europe/Paris"),
("3008218", "Lambersart", "Ламберсар", "FR", "250", "B4", "59", "595", "59328", "50.65", "3.03333", "Europe/Paris"),
("3008379", "La Madeleine", "Мадлен", "FR", "250", "B4", "59", "595", "59368", "50.64603", "3.07585", "Europe/Paris"),
("3009071", "Lagny-sur-Marne", "", "FR", "250", "A8", "77", "775", "77243", "48.86667", "2.71667", "Europe/Paris"),
("3009169", "La Garenne-Colombes", "", "FR", "250", "A8", "92", "922", "92035", "48.90472", "2.2469", "Europe/Paris"),
("3009223", "La Garde", "", "FR", "250", "B8", "83", "832", "83062", "43.12277", "6.00745", "Europe/Paris"),
("3009443", "La Fleche", "Ла-Флеш", "FR", "250", "B5", "72", "721", "72154", "47.69815", "-0.07553", "Europe/Paris"),
("3009791", "La Crau", "", "FR", "250", "B8", "83", "832", "83047", "43.14981", "6.07425", "Europe/Paris"),
("3009824", "La Courneuve", "Ла-Курнев", "FR", "250", "A8", "93", "933", "93027", "48.92805", "2.39627", "Europe/Paris"),
("3010025", "La Ciotat", "Ла-Сьота", "FR", "250", "B8", "13", "133", "13028", "43.17476", "5.60449", "Europe/Paris"),
("3010237", "La Chapelle-sur-Erdre", "", "FR", "250", "B5", "44", "442", "44035", "47.29584", "-1.55309", "Europe/Paris"),
("3010529", "La Celle-Saint-Cloud", "", "FR", "250", "A8", "78", "783", "78126", "48.85029", "2.14523", "Europe/Paris"),
("3012162", "Jouy-le-Moutier", "Жуи-ле-Мутье", "FR", "250", "A8", "95", "953", "95323", "49.01068", "2.04028", "Europe/Paris"),
("3012219", "Joue-les-Tours", "Жу-ле-Тур", "FR", "250", "A3", "37", "372", "37122", "47.35223", "0.66906", "Europe/Paris"),
("3012313", "Joinville-le-Pont", "", "FR", "250", "A8", "94", "942", "94042", "48.82538", "2.47458", "Europe/Paris"),
("3012621", "Ivry-sur-Seine", "Иври-сюр-Сен", "FR", "250", "A8", "94", "941", "94041", "48.81568", "2.38487", "Europe/Paris"),
("3012647", "Istres", "Истра", "FR", "250", "B8", "13", "134", "13047", "43.51667", "4.98333", "Europe/Paris"),
("3012649", "Issy-les-Moulineaux", "Исси-ле-Мулино", "FR", "250", "A8", "92", "923", "92040", "48.82104", "2.27718", "Europe/Paris"),
("3012664", "Issoire", "Иссуар", "FR", "250", "98", "63", "633", "63178", "45.55", "3.25", "Europe/Paris"),
("3012829", "Illzach", "", "FR", "250", "C1", "68", "684", "68154", "47.78088", "7.34662", "Europe/Paris"),
("3012834", "Illkirch-Graffenstaden", "Ийкирш-Граффанштадан", "FR", "250", "C1", "67", "676", "67218", "48.52894", "7.71523", "Europe/Paris"),
("3012937", "Hyeres", "Иер", "FR", "250", "B8", "83", "832", "83069", "43.11954", "6.13897", "Europe/Paris"),
("3013097", "Houilles", "", "FR", "250", "A8", "78", "783", "78311", "48.92161", "2.19263", "Europe/Paris"),
("3013403", "Herouville-Saint-Clair", "Эрувиль-Сен-Клер", "FR", "250", "99", "14", "142", "14327", "49.21088", "-0.30653", "Europe/Paris"),
("3013477", "Herblay", "Эрбле", "FR", "250", "A8", "95", "951", "95306", "48.98994", "2.1699", "Europe/Paris"),
("3013525", "Henin-Beaumont", "Энен-Бомон", "FR", "250", "B4", "62", "627", "62427", "50.41359", "2.96485", "Europe/Paris"),
("3013549", "Hem", "", "FR", "250", "B4", "59", "595", "59299", "50.65256", "3.18681", "Europe/Paris"),
("3013619", "Hazebrouck", "Азбрук", "FR", "250", "B4", "59", "594", "59295", "50.72374", "2.53729", "Europe/Paris"),
("3013627", "Hayange", "", "FR", "250", "B2", "57", "578", "57306", "49.33428", "6.05268", "Europe/Paris"),
("3013681", "Hautmont", "Отмон", "FR", "250", "B4", "59", "591", "59291", "50.25077", "3.92143", "Europe/Paris"),
("3013701", "Yutz", "", "FR", "250", "B2", "57", "577", "57757", "49.35571", "6.1926", "Europe/Paris"),
("3013862", "Haubourdin", "Обурден", "FR", "250", "B4", "59", "595", "59286", "50.60826", "2.99143", "Europe/Paris"),
("3014034", "Halluin", "Аллюэн", "FR", "250", "B4", "59", "595", "59279", "50.78628", "3.12611", "Europe/Paris"),
("3014078", "Haguenau", "Агно", "FR", "250", "C1", "67", "672", "67180", "48.81557", "7.79051", "Europe/Paris"),
("3014143", "Guyancourt", "Гвианкур", "FR", "250", "A8", "78", "784", "78297", "48.77334", "2.07393", "Europe/Paris"),
("3014175", "Gujan-Mestras", "", "FR", "250", "97", "33", "336", "33199", "44.63333", "-1.06667", "Europe/Paris"),
("3014383", "Gueret", "Гере", "FR", "250", "B1", "23", "232", "23096", "46.16667", "1.86667", "Europe/Paris"),
("3014392", "Guerande", "", "FR", "250", "B5", "44", "443", "44069", "47.32911", "-2.42829", "Europe/Paris"),
("3014646", "Grigny", "", "FR", "250", "A8", "91", "912", "91286", "48.65412", "2.39343", "Europe/Paris"),
("3014728", "Grenoble", "Грeнобль", "FR", "250", "B9", "38", "381", "38185", "45.16667", "5.71667", "Europe/Paris"),
("3014856", "Grasse", "Грас", "FR", "250", "B8", "06", "061", "06069", "43.66667", "6.91667", "Europe/Paris"),
("3015160", "Grande-Synthe", "Гранд-Сент", "FR", "250", "B4", "59", "594", "59271", "51.0154", "2.29975", "Europe/Paris"),
("3015419", "Gradignan", "Градиньян", "FR", "250", "97", "33", "332", "33192", "44.77262", "-0.61393", "Europe/Paris"),
("3015490", "Goussainville", "", "FR", "250", "A8", "95", "952", "95280", "49.01367", "2.46595", "Europe/Paris"),
("3015689", "Gonesse", "Гонесс", "FR", "250", "A8", "95", "952", "95277", "48.98693", "2.44892", "Europe/Paris"),
("3015902", "Givors", "Живор", "FR", "250", "B9", "69", "691", "69091", "45.58415", "4.77256", "Europe/Paris"),
("3016078", "Gif-sur-Yvette", "Жиф-сюр-Иветт", "FR", "250", "A8", "91", "913", "91272", "48.68333", "2.13333", "Europe/Paris"),
("3016097", "Gien", "", "FR", "250", "A3", "45", "451", "45155", "47.69332", "2.63094", "Europe/Paris"),
("3016292", "Gentilly", "", "FR", "250", "A8", "94", "943", "94037", "48.81294", "2.3417", "Europe/Paris"),
("3016321", "Gennevilliers", "Женвилье", "FR", "250", "A8", "92", "922", "92036", "48.93333", "2.3", "Europe/Paris"),
("3016621", "Garges-les-Gonesse", "Гарж-ле-Гонесс", "FR", "250", "A8", "95", "952", "95268", "48.96791", "2.39781", "Europe/Paris"),
("3016667", "Gardanne", "", "FR", "250", "B8", "13", "131", "13041", "43.45491", "5.46913", "Europe/Paris"),
("3016675", "Garches", "Гарш", "FR", "250", "A8", "92", "922", "92033", "48.84226", "2.18232", "Europe/Paris"),
("3016702", "Gap", "", "FR", "250", "B8", "05", "052", "05061", "44.56667", "6.08333", "Europe/Paris"),
("3016830", "Gagny", "", "FR", "250", "A8", "93", "932", "93032", "48.88333", "2.53333", "Europe/Paris"),
("3016956", "Frontignan", "Фронтиньян", "FR", "250", "A9", "34", "343", "34108", "43.44848", "3.754", "Europe/Paris"),
("3017178", "Fresnes", "Френ", "FR", "250", "A8", "94", "943", "94034", "48.75568", "2.32241", "Europe/Paris"),
("3017253", "Frejus", "Фрежюс", "FR", "250", "B8", "83", "831", "83061", "43.43286", "6.73524", "Europe/Paris"),
("3017341", "Franconville", "", "FR", "250", "A8", "95", "953", "95252", "48.98333", "2.23333", "Europe/Paris"),
("3017609", "Fougeres", "Фужер", "FR", "250", "A2", "35", "351", "35115", "48.35", "-1.2", "Europe/Paris"),
("3017651", "Fos-sur-Mer", "", "FR", "250", "B8", "13", "134", "13039", "43.43774", "4.94457", "Europe/Paris"),
("3017805", "Forbach", "Форбах", "FR", "250", "B2", "57", "573", "57227", "49.18333", "6.9", "Europe/Paris"),
("3017910", "Fontenay-sous-Bois", "Фонтене-су-Буа", "FR", "250", "A8", "94", "942", "94033", "48.85442", "2.48268", "Europe/Paris"),
("3017921", "Fontenay-le-Comte", "Фонтене-ле-Конт", "FR", "250", "B5", "85", "851", "85092", "46.46667", "-0.81667", "Europe/Paris"),
("3017924", "Fontenay-aux-Roses", "Фонтене-о-Роз", "FR", "250", "A8", "92", "921", "92032", "48.79325", "2.29275", "Europe/Paris"),
("3018074", "Fontainebleau", "Фонтенбло", "FR", "250", "A8", "77", "774", "77186", "48.4", "2.7", "Europe/Paris"),
("3018095", "Fontaine", "Фонтейн", "FR", "250", "B9", "38", "381", "38169", "45.19839", "5.68265", "Europe/Paris"),
("3018246", "Floirac", "", "FR", "250", "97", "33", "332", "33167", "44.83238", "-0.51411", "Europe/Paris"),
("3018280", "Fleury-les-Aubrais", "", "FR", "250", "A3", "45", "452", "45147", "47.93328", "1.91811", "Europe/Paris"),
("3018339", "Flers", "", "FR", "250", "99", "61", "612", "61169", "48.73722", "-0.57466", "Europe/Paris"),
("3018455", "Firminy", "", "FR", "250", "B9", "42", "423", "42095", "45.38732", "4.29074", "Europe/Paris"),
("3018794", "Fecamp", "Фекан", "FR", "250", "A7", "76", "762", "76259", "49.75787", "0.37457", "Europe/Paris"),
("3019153", "Faches-Thumesnil", "", "FR", "250", "B4", "59", "595", "59220", "50.58333", "3.06667", "Europe/Paris"),
("3019193", "Eysines", "", "FR", "250", "97", "33", "332", "33162", "44.88352", "-0.64686", "Europe/Paris"),
("3019256", "Evry", "", "FR", "250", "A8", "91", "912", "91228", "48.63333", "2.45", "Europe/Paris"),
("3019265", "Evreux", "Эврё", "FR", "250", "A7", "27", "273", "27229", "49.02414", "1.15082", "Europe/Paris"),
("3019459", "Etampes", "Этамп", "FR", "250", "A8", "91", "911", "91223", "48.43333", "2.15", "Europe/Paris"),
("3019766", "La Baule-Escoublac", "Ла-Боль", "FR", "250", "B5", "44", "443", "44055", "47.29221", "-2.36395", "Europe/Paris"),
("3019897", "Ermont", "Эрмон", "FR", "250", "A8", "95", "953", "95219", "48.99004", "2.25804", "Europe/Paris"),
("3019952", "Eragny", "", "FR", "250", "A8", "95", "953", "95218", "49.01667", "2.1", "Europe/Paris"),
("3019960", "Equeurdreville-Hainneville", "", "FR", "250", "99", "50", "502", "50173", "49.64868", "-1.65306", "Europe/Paris"),
("3020020", "Epinay-sur-Seine", "Эпине-сюр-Сен", "FR", "250", "A8", "93", "933", "93031", "48.9535", "2.31514", "Europe/Paris"),
("3020035", "Epinal", "Эпиналь", "FR", "250", "B2", "88", "881", "88160", "48.18333", "6.45", "Europe/Paris"),
("3020062", "Epernay", "Эперне", "FR", "250", "A4", "51", "512", "51230", "49.05", "3.95", "Europe/Paris"),
("3020307", "Elbeuf", "Эльбёф", "FR", "250", "A7", "76", "763", "76231", "49.28669", "1.00288", "Europe/Paris"),
("3020310", "Elancourt", "", "FR", "250", "A8", "78", "782", "78208", "48.7842", "1.9552", "Europe/Paris"),
("3020392", "Ecully", "", "FR", "250", "B9", "69", "691", "69081", "45.77726", "4.77481", "Europe/Paris"),
("3020495", "Echirolles", "Эшироль", "FR", "250", "B9", "38", "381", "38151", "45.1439", "5.72883", "Europe/Paris"),
("3020601", "Eaubonne", "Обонн", "FR", "250", "A8", "95", "953", "95203", "48.99712", "2.28249", "Europe/Paris"),
("3020686", "Dunkerque", "Дюнкерк", "FR", "250", "B4", "59", "594", "59183", "51.03297", "2.377", "Europe/Paris"),
("3020810", "Dreux", "Дрё", "FR", "250", "A3", "28", "283", "28134", "48.73333", "1.36667", "Europe/Paris"),
("3020832", "Draveil", "", "FR", "250", "A8", "91", "912", "91201", "48.68466", "2.41418", "Europe/Paris"),
("3020839", "Drancy", "Дранси", "FR", "250", "A8", "93", "931", "93029", "48.92578", "2.44533", "Europe/Paris"),
("3020850", "Draguignan", "Драгиньян", "FR", "250", "B8", "83", "831", "83050", "43.53333", "6.46667", "Europe/Paris"),
("3020996", "Douarnenez", "Дуарнене", "FR", "250", "A2", "29", "294", "29046", "48.09542", "-4.32904", "Europe/Paris"),
("3021000", "Douai", "Дуэ", "FR", "250", "B4", "59", "593", "59178", "50.36667", "3.06667", "Europe/Paris"),
("3021150", "Domont", "Домон", "FR", "250", "A8", "95", "952", "95199", "49.02782", "2.32638", "Europe/Paris"),
("3021263", "Dole", "Доля", "FR", "250", "A6", "39", "391", "39198", "47.1", "5.5", "Europe/Paris"),
("3021372", "Dijon", "Дижон", "FR", "250", "A1", "21", "212", "21231", "47.31667", "5.01667", "Europe/Paris"),
("3021382", "Digne-les-Bains", "Динь-ле-Бен", "FR", "250", "B8", "04", "043", "04070", "44.09252", "6.23199", "Europe/Paris"),
("3021411", "Dieppe", "Дьеп", "FR", "250", "A7", "76", "761", "76217", "49.93333", "1.08333", "Europe/Paris"),
("3021516", "Deuil-la-Barre", "Дёй-ла-Барр", "FR", "250", "A8", "95", "952", "95197", "48.97674", "2.32722", "Europe/Paris"),
("3021605", "Denain", "Денен", "FR", "250", "B4", "59", "596", "59172", "50.3293", "3.3943", "Europe/Paris"),
("3021662", "Decines-Charpieu", "", "FR", "250", "B9", "69", "691", "69275", "45.76899", "4.97277", "Europe/Paris"),
("3021670", "Dax", "", "FR", "250", "97", "40", "401", "40088", "43.71032", "-1.05366", "Europe/Paris"),
("3021852", "Dammarie-les-Lys", "", "FR", "250", "A8", "77", "772", "77152", "48.51667", "2.65", "Europe/Paris"),
("3022151", "Cugnaux", "", "FR", "250", "B3", "31", "313", "31157", "43.53635", "1.34428", "Europe/Paris"),
("3022376", "Croix", "", "FR", "250", "B4", "59", "595", "59163", "50.67846", "3.1493", "Europe/Paris"),
("3022530", "Creteil", "Кретей", "FR", "250", "A8", "94", "941", "94028", "48.78333", "2.46667", "Europe/Paris"),
("3022569", "Crepy-en-Valois", "Крепи-ан-Валуа", "FR", "250", "B6", "60", "604", "60176", "49.23359", "2.88807", "Europe/Paris"),
("3022610", "Creil", "Крей", "FR", "250", "B6", "60", "604", "60175", "49.25672", "2.48477", "Europe/Paris"),
("3022700", "Cran-Gevrier", "", "FR", "250", "B9", "74", "741", "74093", "45.9", "6.1", "Europe/Paris"),
("3022988", "Cournon-d'Auvergne", "", "FR", "250", "98", "63", "632", "63124", "45.73543", "3.19608", "Europe/Paris"),
("3023141", "Courbevoie", "Курбевуа", "FR", "250", "A8", "92", "922", "92026", "48.89672", "2.25666", "Europe/Paris"),
("3023240", "Coulommiers", "", "FR", "250", "A8", "77", "771", "77131", "48.81451", "3.08498", "Europe/Paris"),
("3023324", "Coueron", "", "FR", "250", "B5", "44", "442", "44047", "47.21508", "-1.72171", "Europe/Paris"),
("3023356", "Coudekerque-Branche", "Кудкерк-Бранш", "FR", "250", "B4", "59", "594", "59155", "51.02288", "2.39359", "Europe/Paris"),
("3023645", "Cormeilles-en-Parisis", "Кормей-ан-Паризи", "FR", "250", "A8", "95", "951", "95176", "48.97111", "2.20491", "Europe/Paris"),
("3023763", "Corbeil-Essonnes", "Корбей-Эссон", "FR", "250", "A8", "91", "912", "91174", "48.60603", "2.48757", "Europe/Paris"),
("3023924", "Conflans-Sainte-Honorine", "Конфлан-Сент-Онорин", "FR", "250", "A8", "78", "783", "78172", "49.00158", "2.09694", "Europe/Paris"),
("3024035", "Concarneau", "Конкарно", "FR", "250", "A2", "29", "294", "29039", "47.87502", "-3.92245", "Europe/Paris"),
("3024066", "Compiegne", "Компьень", "FR", "250", "B6", "60", "603", "60159", "49.41794", "2.82606", "Europe/Paris"),
("3024107", "Combs-la-Ville", "", "FR", "250", "A8", "77", "772", "77122", "48.66497", "2.56957", "Europe/Paris"),
("3024195", "Pontault-Combault", "", "FR", "250", "A8", "77", "775", "77373", "48.79813", "2.60676", "Europe/Paris"),
("3024223", "Colomiers", "", "FR", "250", "B3", "31", "313", "31149", "43.61247", "1.33278", "Europe/Paris"),
("3024266", "Colombes", "Коломб", "FR", "250", "A8", "92", "922", "92025", "48.91882", "2.25404", "Europe/Paris"),
("3024297", "Colmar", "Кольмар", "FR", "250", "C1", "68", "682", "68066", "48.08333", "7.36667", "Europe/Paris"),
("3024440", "Cognac", "Коньяк", "FR", "250", "B7", "16", "162", "16102", "45.7", "-0.33333", "Europe/Paris"),
("3024532", "Cluses", "", "FR", "250", "B9", "74", "742", "74081", "46.06251", "6.57497", "Europe/Paris"),
("3024596", "Clichy-sous-Bois", "Клиши-су-Буа", "FR", "250", "A8", "93", "932", "93014", "48.9102", "2.55324", "Europe/Paris"),
("3024597", "Clichy", "Клиши", "FR", "250", "A8", "92", "922", "92024", "48.90018", "2.30952", "Europe/Paris"),
("3024635", "Clermont-Ferrand", "Клермон-Ферран", "FR", "250", "98", "63", "632", "63113", "45.77966", "3.08628", "Europe/Paris"),
("3024783", "Clamart", "Кламар", "FR", "250", "A8", "92", "921", "92023", "48.80299", "2.26692", "Europe/Paris"),
("3025053", "Cholet", "Шоле", "FR", "250", "B5", "49", "492", "49099", "47.06667", "-0.88333", "Europe/Paris"),
("3025055", "Choisy-le-Roi", "Шуази-ле-Руа", "FR", "250", "A8", "94", "941", "94022", "48.76846", "2.41874", "Europe/Paris"),
("3025144", "Chilly-Mazarin", "", "FR", "250", "A8", "91", "913", "91161", "48.71489", "2.31638", "Europe/Paris"),
("3025314", "Chevilly-Larue", "Шевильи-Ларю", "FR", "250", "A8", "94", "943", "94021", "48.76476", "2.3503", "Europe/Paris"),
("3025466", "Cherbourg-Octeville", "Шербур-Октевиль", "FR", "250", "99", "50", "502", "50129", "49.63984", "-1.61636", "Europe/Paris"),
("3025496", "Chenove", "", "FR", "250", "A1", "21", "212", "21166", "47.29323", "5.00457", "Europe/Paris"),
("3025509", "Chennevieres-sur-Marne", "", "FR", "250", "A8", "94", "942", "94019", "48.79702", "2.54046", "Europe/Paris"),
("3025622", "Chelles", "", "FR", "250", "A8", "77", "775", "77108", "48.88109", "2.59295", "Europe/Paris"),
("3025715", "Chaville", "Шавиль", "FR", "250", "A8", "92", "923", "92022", "48.80565", "2.18864", "Europe/Paris"),
("3025892", "Chaumont", "Шомон", "FR", "250", "A4", "52", "521", "52121", "48.11121", "5.14134", "Europe/Paris"),
("3026033", "Chatou", "Шату", "FR", "250", "A8", "78", "783", "78146", "48.8898", "2.15863", "Europe/Paris"),
("3026083", "Chatillon", "", "FR", "250", "A8", "92", "921", "92020", "48.8024", "2.29346", "Europe/Paris"),
("3026108", "Chatenay-Malabry", "Шатне-Малабри", "FR", "250", "A8", "92", "921", "92019", "48.76507", "2.26655", "Europe/Paris"),
("3026141", "Chatellerault", "Шательро", "FR", "250", "B7", "86", "861", "86066", "46.8", "0.53333", "Europe/Paris"),
("3026194", "Chateau-Thierry", "Шато-Тьерри", "FR", "250", "B6", "02", "021", "02168", "49.05", "3.4", "Europe/Paris"),
("3026204", "Chateauroux", "Шатору", "FR", "250", "A3", "36", "362", "36044", "46.81667", "1.7", "Europe/Paris"),
("3026285", "Chateaudun", "Шатодён", "FR", "250", "A3", "28", "282", "28088", "48.08333", "1.33333", "Europe/Paris"),
("3026467", "Chartres", "Шартр", "FR", "250", "A3", "28", "281", "28085", "48.44685", "1.48925", "Europe/Paris"),
("3026613", "Charleville-Mezieres", "Шарлевиль-Мезьер", "FR", "250", "A4", "08", "081", "08105", "49.76667", "4.71667", "Europe/Paris"),
("3026637", "Charenton-le-Pont", "Шарантон-ле-Пон", "FR", "250", "A8", "94", "941", "94018", "48.82209", "2.41217", "Europe/Paris"),
("3027014", "Champs-sur-Marne", "Шан-сюр-Марн", "FR", "250", "A8", "77", "775", "77083", "48.85", "2.6", "Europe/Paris"),
("3027105", "Champigny-sur-Marne", "Шампиньи-сюр-Марн", "FR", "250", "A8", "94", "942", "94017", "48.81642", "2.49366", "Europe/Paris"),
("3027422", "Chambery", "Шамбери", "FR", "250", "B9", "73", "732", "73065", "45.56667", "5.93333", "Europe/Paris"),
("3027453", "Chamalieres", "Шамальер", "FR", "250", "98", "63", "632", "63075", "45.77559", "3.0631", "Europe/Paris"),
("3027484", "Chalon-sur-Saone", "Шалон-сюр-Сон", "FR", "250", "A1", "71", "712", "71076", "46.78333", "4.85", "Europe/Paris"),
("3027487", "Chalons-en-Champagne", "Шалон-ан-Шампань", "FR", "250", "A4", "51", "511", "51108", "48.95393", "4.36724", "Europe/Paris"),
("3027513", "Challans", "", "FR", "250", "B5", "85", "853", "85047", "46.84363", "-1.8749", "Europe/Paris"),
("3027763", "Cestas", "", "FR", "250", "97", "33", "332", "33122", "44.74345", "-0.67905", "Europe/Paris"),
("3027767", "Cesson-Sevigne", "", "FR", "250", "A2", "35", "353", "35051", "48.1212", "-1.603", "Europe/Paris"),
("3027883", "Cergy", "Сержи", "FR", "250", "A8", "95", "953", "95127", "49.03645", "2.07613", "Europe/Paris"),
("3027950", "Cenon", "Сенон", "FR", "250", "97", "33", "332", "33119", "44.8559", "-0.51839", "Europe/Paris"),
("3028097", "Cayenne", "", "FR", "250", "A7", "76", "", "", "49.55858", "1.62803", "Europe/Paris"),
("3028134", "Cavaillon", "Кавайон", "FR", "250", "B8", "84", "841", "84035", "43.83125", "5.03586", "Europe/Paris"),
("3028263", "Castres", "Кастр", "FR", "250", "B3", "81", "812", "81065", "43.6", "2.25", "Europe/Paris"),
("3028337", "Castelnau-le-Lez", "", "FR", "250", "A9", "34", "343", "34057", "43.63333", "3.9", "Europe/Paris"),
("3028486", "Carvin", "Карвен", "FR", "250", "B4", "62", "627", "62215", "50.49235", "2.95815", "Europe/Paris"),
("3028521", "Carrieres-sous-Poissy", "", "FR", "250", "A8", "78", "783", "78123", "48.94952", "2.04068", "Europe/Paris"),
("3028535", "Carquefou", "", "FR", "250", "B5", "44", "442", "44026", "47.29822", "-1.49024", "Europe/Paris"),
("3028542", "Carpentras", "Карпантрас", "FR", "250", "B8", "84", "843", "84031", "44.05", "5.05", "Europe/Paris"),
("3028641", "Carcassonne", "Каркасон", "FR", "250", "A9", "11", "111", "11069", "43.21667", "2.35", "Europe/Paris"),
("3028779", "Canteleu", "", "FR", "250", "A7", "76", "763", "76157", "49.44065", "1.02459", "Europe/Paris"),
("3028808", "Cannes", "Канны", "FR", "250", "B8", "06", "061", "06029", "43.55135", "7.01275", "Europe/Paris"),
("3029030", "Cambrai", "Камбре", "FR", "250", "B4", "59", "592", "59122", "50.16667", "3.23333", "Europe/Paris"),
("3029096", "Caluire-et-Cuire", "", "FR", "250", "B9", "69", "691", "69034", "45.79041", "4.84112", "Europe/Paris"),
("3029162", "Calais", "Кале", "FR", "250", "B4", "62", "626", "62193", "50.95194", "1.85635", "Europe/Paris"),
("3029213", "Cahors", "Каор", "FR", "250", "B3", "46", "461", "46042", "44.4491", "1.43663", "Europe/Paris"),
("3029227", "Cagnes-sur-Mer", "Кань-сюр-Мер", "FR", "250", "B8", "06", "061", "06027", "43.6646", "7.15339", "Europe/Paris"),
("3029241", "Caen", "Кан", "FR", "250", "99", "14", "142", "14118", "49.18585", "-0.35912", "Europe/Paris"),
("3029276", "Cachan", "Кашан", "FR", "250", "A8", "94", "943", "94016", "48.79632", "2.33661", "Europe/Paris"),
("3029706", "Bry-sur-Marne", "Бри-сюр-Марн", "FR", "250", "A8", "94", "942", "94015", "48.83811", "2.52488", "Europe/Paris"),
("3029748", "Brunoy", "Брюнуа", "FR", "250", "A8", "91", "912", "91114", "48.6942", "2.49223", "Europe/Paris"),
("3029825", "Bruay-la-Buissiere", "Брюэ-ла-Бюисьер", "FR", "250", "B4", "62", "622", "62178", "50.48333", "2.55", "Europe/Paris"),
("3029931", "Bron", "Брон", "FR", "250", "B9", "69", "691", "69029", "45.73333", "4.91667", "Europe/Paris"),
("3029974", "Brive-la-Gaillarde", "Бриве-ла-Гаилларде", "FR", "250", "B1", "19", "191", "19031", "45.15", "1.53333", "Europe/Paris"),
("3030057", "Brignoles", "Бриньоль", "FR", "250", "B8", "83", "833", "83023", "43.4", "6.06667", "Europe/Paris"),
("3030101", "Brie-Comte-Robert", "", "FR", "250", "A8", "77", "772", "77053", "48.68333", "2.61667", "Europe/Paris"),
("3030257", "Bretigny-sur-Orge", "", "FR", "250", "A8", "91", "913", "91103", "48.61135", "2.30593", "Europe/Paris"),
("3030300", "Brest", "Брест", "FR", "250", "A2", "29", "291", "29019", "48.4", "-4.48333", "Europe/Paris"),
("3030303", "Bressuire", "Брессюир", "FR", "250", "B7", "79", "791", "79049", "46.85", "-0.48333", "Europe/Paris"),
("3030960", "Bourgoin", "", "FR", "250", "B9", "38", "382", "38053", "45.58333", "5.28333", "Europe/Paris"),
("3030985", "Bourg-les-Valence", "", "FR", "250", "B9", "26", "263", "26058", "44.95601", "4.91023", "Europe/Paris"),
("3030990", "Bourg-la-Reine", "", "FR", "250", "A8", "92", "921", "92014", "48.77888", "2.31781", "Europe/Paris"),
("3031005", "Bourges", "Бурж", "FR", "250", "A3", "18", "181", "18033", "47.08333", "2.4", "Europe/Paris"),
("3031009", "Bourg-en-Bresse", "Бурк-ан-Брес", "FR", "250", "B9", "01", "012", "01053", "46.20574", "5.2258", "Europe/Paris"),
("3031133", "Boulogne-sur-Mer", "Булонь-сюр-Мер", "FR", "250", "B4", "62", "623", "62160", "50.71667", "1.61667", "Europe/Paris"),
("3031137", "Boulogne-Billancourt", "Булонь-Бийанкур", "FR", "250", "A8", "92", "923", "92012", "48.83333", "2.25", "Europe/Paris"),
("3031268", "Bouguenais", "", "FR", "250", "B5", "44", "442", "44020", "47.17762", "-1.62143", "Europe/Paris"),
("3031582", "Bordeaux", "Бордо", "FR", "250", "97", "33", "332", "33063", "44.84044", "-0.5805", "Europe/Paris"),
("3031709", "Bonneuil-sur-Marne", "", "FR", "250", "A8", "94", "941", "94011", "48.7695", "2.4793", "Europe/Paris"),
("3031815", "Bondy", "Бонди", "FR", "250", "A8", "93", "931", "93010", "48.9018", "2.48931", "Europe/Paris"),
("3031898", "Boissy-Saint-Leger", "", "FR", "250", "A8", "94", "941", "94004", "48.7515", "2.51163", "Europe/Paris"),
("3032070", "Bois-Colombes", "", "FR", "250", "A8", "92", "922", "92009", "48.91936", "2.27484", "Europe/Paris"),
("3032179", "Bobigny", "Бобиньи", "FR", "250", "A8", "93", "931", "93008", "48.9", "2.45", "Europe/Paris"),
("3032213", "Blois", "Блуа", "FR", "250", "A3", "41", "411", "41018", "47.58333", "1.33333", "Europe/Paris"),
("3032340", "Blanquefort", "", "FR", "250", "97", "33", "332", "33056", "44.91248", "-0.63663", "Europe/Paris"),
("3032469", "Blagnac", "Бланьяк", "FR", "250", "B3", "31", "313", "31069", "43.63276", "1.39399", "Europe/Paris"),
("3032551", "Bischheim", "", "FR", "250", "C1", "67", "676", "67043", "48.61612", "7.75343", "Europe/Paris"),
("3032797", "Biarritz", "Биарриц", "FR", "250", "97", "64", "641", "64122", "43.48012", "-1.55558", "Europe/Paris"),
("3032824", "Bezons", "Безон", "FR", "250", "A8", "95", "951", "95063", "48.92426", "2.2128", "Europe/Paris"),
("3032833", "Beziers", "Безье", "FR", "250", "A9", "34", "341", "34032", "43.34122", "3.21402", "Europe/Paris"),
("3033002", "Bethune", "Бетюн", "FR", "250", "B4", "62", "622", "62119", "50.53333", "2.63333", "Europe/Paris"),
("3033123", "Besancon", "Безансон", "FR", "250", "A6", "25", "251", "25056", "47.24878", "6.01815", "Europe/Paris"),
("3033391", "Bergerac", "", "FR", "250", "97", "24", "241", "24037", "44.85", "0.48333", "Europe/Paris"),
("3033415", "Berck", "", "FR", "250", "B4", "62", "624", "62108", "50.4", "1.6", "Europe/Paris"),
("3033416", "Berck-Plage", "", "FR", "250", "B4", "62", "624", "62108", "50.40704", "1.56446", "Europe/Paris"),
("3033791", "Belfort", "Бельфор", "FR", "250", "A6", "90", "901", "90010", "47.63333", "6.86667", "Europe/Paris"),
("3033881", "Begles", "Беглесе", "FR", "250", "97", "33", "332", "33039", "44.80845", "-0.54809", "Europe/Paris"),
("3034006", "Beauvais", "Бове", "FR", "250", "B6", "60", "601", "60057", "49.43333", "2.08333", "Europe/Paris"),
("3034126", "Beaune", "Бон", "FR", "250", "A1", "21", "211", "21054", "47.03333", "4.83333", "Europe/Paris"),
("3034475", "Bayonne", "Байонна", "FR", "250", "97", "64", "641", "64102", "43.48333", "-1.48333", "Europe/Paris"),
("3034483", "Bayeux", "Байё", "FR", "250", "99", "14", "141", "14047", "49.27732", "-0.7039", "Europe/Paris"),
("3034640", "Bastia", "Бастия", "FR", "250", "A5", "2B", "2B2", "2B033", "42.70278", "9.45", "Europe/Paris"),
("3034911", "Bar-le-Duc", "Бар-ле-Дюк", "FR", "250", "B2", "55", "551", "55029", "48.78333", "5.16667", "Europe/Paris"),
("3035204", "Balma", "", "FR", "250", "B3", "31", "313", "31044", "43.61111", "1.49944", "Europe/Paris"),
("3035396", "Bagnols-sur-Ceze", "Баньоль-сюр-Сез", "FR", "250", "A9", "30", "302", "30028", "44.1599", "4.61776", "Europe/Paris"),
("3035403", "Bagnolet", "Баньоле", "FR", "250", "A8", "93", "931", "93006", "48.86667", "2.41667", "Europe/Paris"),
("3035409", "Bagneux", "", "FR", "250", "A8", "92", "921", "92007", "48.79564", "2.30796", "Europe/Paris"),
("3035654", "Avon", "", "FR", "250", "A8", "77", "774", "77014", "48.4022", "2.72022", "Europe/Paris"),
("3035667", "Avion", "", "FR", "250", "B4", "62", "627", "62065", "50.41038", "2.83053", "Europe/Paris"),
("3035681", "Avignon", "Авиньон", "FR", "250", "B8", "84", "842", "84007", "43.94834", "4.80892", "Europe/Paris"),
("3035843", "Auxerre", "Осер", "FR", "250", "A1", "89", "891", "89024", "47.8", "3.56667", "Europe/Paris"),
("3035883", "Autun", "Отён", "FR", "250", "A1", "71", "711", "71014", "46.95", "4.3", "Europe/Paris"),
("3036016", "Aurillac", "Орийак", "FR", "250", "98", "15", "151", "15014", "44.91667", "2.45", "Europe/Paris"),
("3036145", "Aulnay-sous-Bois", "Оне-су-Буа", "FR", "250", "A8", "93", "932", "93005", "48.93814", "2.49402", "Europe/Paris"),
("3036240", "Audincourt", "", "FR", "250", "A6", "25", "252", "25031", "47.48327", "6.85341", "Europe/Paris"),
("3036281", "Auch", "Ош", "FR", "250", "B3", "32", "321", "32013", "43.65", "0.58333", "Europe/Paris"),
("3036386", "Aubervilliers", "Обервилье", "FR", "250", "A8", "93", "933", "93001", "48.91667", "2.38333", "Europe/Paris"),
("3036433", "Aubagne", "Обань", "FR", "250", "B8", "13", "133", "13005", "43.29276", "5.57067", "Europe/Paris"),
("3036460", "Athis-Mons", "", "FR", "250", "A8", "91", "913", "91027", "48.70522", "2.39147", "Europe/Paris"),
("3036572", "Asnieres-sur-Seine", "Аньер-сюр-Сен", "FR", "250", "A8", "92", "922", "92004", "48.91667", "2.28333", "Europe/Paris"),
("3036784", "Arras", "Аррас", "FR", "250", "B4", "62", "621", "62041", "50.29301", "2.78186", "Europe/Paris"),
("3036903", "Armentieres", "Армантьер", "FR", "250", "B4", "59", "595", "59017", "50.68568", "2.88214", "Europe/Paris"),
("3036938", "Arles", "Арль", "FR", "250", "B8", "13", "132", "13004", "43.67681", "4.63031", "Europe/Paris"),
("3037044", "Argenteuil", "Аржантей", "FR", "250", "A8", "95", "951", "95018", "48.95", "2.25", "Europe/Paris"),
("3037051", "Argentan", "Аржантан", "FR", "250", "99", "61", "612", "61006", "48.75", "-0.01667", "Europe/Paris"),
("3037157", "Arcueil", "", "FR", "250", "A8", "94", "943", "94003", "48.79993", "2.33256", "Europe/Paris"),
("3037423", "Antony", "", "FR", "250", "A8", "92", "921", "92002", "48.75", "2.3", "Europe/Paris"),
("3037456", "Antibes", "Антиб", "FR", "250", "B8", "06", "061", "06004", "43.56241", "7.12777", "Europe/Paris"),
("3037514", "Annonay", "Анноне", "FR", "250", "B9", "07", "073", "07010", "45.2397", "4.67075", "Europe/Paris"),
("3037538", "Annemasse", "", "FR", "250", "B9", "74", "743", "74012", "46.19439", "6.23775", "Europe/Paris"),
("3037540", "Annecy-le-Vieux", "Аннеси-ле-Вье", "FR", "250", "B9", "74", "741", "74011", "45.91972", "6.14393", "Europe/Paris"),
("3037543", "Annecy", "Анси", "FR", "250", "B9", "74", "741", "74010", "45.9", "6.11667", "Europe/Paris"),
("3037598", "Angouleme", "Ангулем", "FR", "250", "B7", "16", "161", "16015", "45.65", "0.15", "Europe/Paris"),
("3037612", "Anglet", "Англет", "FR", "250", "97", "64", "641", "64024", "43.47664", "-1.51346", "Europe/Paris"),
("3037656", "Angers", "Анже", "FR", "250", "B5", "49", "491", "49007", "47.46667", "-0.55", "Europe/Paris"),
("3037854", "Amiens", "Амьен", "FR", "250", "B6", "80", "802", "80021", "49.9", "2.3", "Europe/Paris"),
("3038159", "Allauch", "Аллош", "FR", "250", "B8", "13", "133", "13002", "43.33573", "5.48201", "Europe/Paris"),
("3038213", "Alfortville", "Альфорвилль", "FR", "250", "A8", "94", "941", "94002", "48.80575", "2.4204", "Europe/Paris"),
("3038224", "Ales", "Алес", "FR", "250", "A9", "30", "301", "30007", "44.13333", "4.08333", "Europe/Paris"),
("3038230", "Alencon", "Алансон", "FR", "250", "99", "61", "611", "61001", "48.43333", "0.08333", "Europe/Paris"),
("3038261", "Albi", "Альби", "FR", "250", "B3", "81", "811", "81004", "43.9298", "2.148", "Europe/Paris"),
("3038266", "Albertville", "Альбервиль", "FR", "250", "B9", "73", "731", "73011", "45.67452", "6.39061", "Europe/Paris"),
("3038334", "Ajaccio", "Аяччо", "FR", "250", "A5", "2A", "2A1", "2A004", "41.92723", "8.73462", "Europe/Paris"),
("3038350", "Aix-les-Bains", "Экс-ле-Бен", "FR", "250", "B9", "73", "732", "73008", "45.68338", "5.92241", "Europe/Paris"),
("3038354", "Aix-en-Provence", "Экс-ан-Прованс", "FR", "250", "B8", "13", "131", "13001", "43.5283", "5.44973", "Europe/Paris"),
("3038634", "Agen", "Ажен", "FR", "250", "97", "47", "471", "47001", "44.2", "0.63333", "Europe/Paris"),
("3038638", "Agde", "Агд", "FR", "250", "A9", "34", "341", "34003", "43.31083", "3.47583", "Europe/Paris"),
("3038712", "Acheres", "", "FR", "250", "A8", "78", "783", "78005", "48.96116", "2.06882", "Europe/Paris"),
("3038789", "Abbeville", "Абвиль", "FR", "250", "B6", "80", "801", "80001", "50.1", "1.83333", "Europe/Paris"),
("6543862", "Villeneuve-d'Ascq", "Вильнёв-д’Аск", "FR", "250", "B4", "59", "595", "59009", "50.61669", "3.16664", "Europe/Paris"),
("6615536", "Les Ulis", "Лез-Юлис", "FR", "250", "A8", "91", "913", "91692", "48.68167", "2.16944", "Europe/Paris"),
("6615539", "Bourgoin-Jallieu", "Бургуин-Жалльё", "FR", "250", "B9", "38", "382", "38053", "45.58611", "5.27361", "Europe/Paris"),
("7284882", "Marseille 01", "", "FR", "250", "B8", "13", "133", "13055", "43.29814", "5.38407", "Europe/Paris"),
("7284883", "Marseille 02", "", "FR", "250", "B8", "13", "133", "13055", "43.29664", "5.37034", "Europe/Paris"),
("7284884", "Marseille 03", "", "FR", "250", "B8", "13", "133", "13055", "43.30257", "5.37583", "Europe/Paris"),
("7284885", "Marseille 04", "", "FR", "250", "B8", "13", "133", "13055", "43.30213", "5.40141", "Europe/Paris"),
("7284886", "Marseille 05", "", "FR", "250", "B8", "13", "133", "13055", "43.29551", "5.40055", "Europe/Paris"),
("7284887", "Marseille 06", "", "FR", "250", "B8", "13", "133", "13055", "43.29114", "5.38244", "Europe/Paris"),
("7284888", "Marseille 07", "", "FR", "250", "B8", "13", "133", "13055", "43.28889", "5.36485", "Europe/Paris"),
("7284889", "Marseille 08", "", "FR", "250", "B8", "13", "133", "13055", "43.27083", "5.3821", "Europe/Paris"),
("7284890", "Marseille 10", "", "FR", "250", "B8", "13", "133", "13055", "43.27889", "5.41523", "Europe/Paris"),
("7284891", "Marseille 09", "", "FR", "250", "B8", "13", "133", "13055", "43.25433", "5.4057", "Europe/Paris"),
("7284892", "Marseille 11", "", "FR", "250", "B8", "13", "133", "13055", "43.2907", "5.4384", "Europe/Paris"),
("7284893", "Marseille 12", "", "FR", "250", "B8", "13", "133", "13055", "43.29614", "5.43617", "Europe/Paris"),
("7284894", "Marseille 13", "", "FR", "250", "B8", "13", "133", "13055", "43.31856", "5.40836", "Europe/Paris"),
("7284895", "Marseille 14", "", "FR", "250", "B8", "13", "133", "13055", "43.34447", "5.38004", "Europe/Paris"),
("7284896", "Marseille 15", "", "FR", "250", "B8", "13", "133", "13055", "43.37224", "5.35386", "Europe/Paris"),
("7284897", "Marseille 16", "", "FR", "250", "B8", "13", "133", "13055", "43.35982", "5.33421", "Europe/Paris"),
("8504417", "La Defense", "Ля Дефанс", "FR", "250", "A8", "92", "922", "92062", "48.89198", "2.23881", "Europe/Paris"),
("8533870", "Saint-Quentin-en-Yvelines", "", "FR", "250", "A8", "78", "784", "78423", "48.77186", "2.01891", "Europe/Paris"),
("8555643", "Cergy-Pontoise", "", "FR", "250", "A8", "95", "953", "95127", "49.03894", "2.07805", "Europe/Paris"),
("2396253", "Tchibanga", "", "GA", "266", "05", "", "", "", "-2.85", "11.03333", "Africa/Libreville"),
("2396518", "Port-Gentil", "", "GA", "266", "08", "", "", "", "-0.71933", "8.78151", "Africa/Libreville"),
("2396646", "Oyem", "", "GA", "266", "09", "", "", "", "1.5995", "11.57933", "Africa/Libreville"),
("2398073", "Mouila", "", "GA", "266", "04", "", "", "", "-1.86846", "11.05594", "Africa/Libreville"),
("2398269", "Moanda", "", "GA", "266", "02", "", "", "", "-1.55746", "13.21775", "Africa/Libreville"),
("2399697", "Libreville", "Либревиль", "GA", "266", "01", "", "", "", "0.39241", "9.45356", "Africa/Libreville"),
("2399888", "Lambarene", "Ламбарене", "GA", "266", "03", "", "", "", "-0.7001", "10.24055", "Africa/Libreville"),
("2399959", "Koulamoutou", "", "GA", "266", "07", "", "", "", "-1.13032", "12.47359", "Africa/Libreville"),
("2400555", "Franceville", "Франсвиль", "GA", "266", "02", "", "", "", "-1.63333", "13.58357", "Africa/Libreville"),
("2633352", "York", "Йорк", "GB", "826", "ENG", "Q5", "", "", "53.95763", "-1.08271", "Europe/London"),
("2633373", "Yeovil", "Йеовиль", "GB", "826", "ENG", "M3", "40UD", "", "50.94159", "-2.63211", "Europe/London"),
("2633397", "Yeadon", "", "GB", "826", "ENG", "H3", "", "", "53.86437", "-1.68743", "Europe/London"),
("2633406", "Yate", "", "GB", "826", "ENG", "M6", "00HD044", "", "51.54074", "-2.41839", "Europe/London"),
("2633485", "Wrexham", "Рексем", "GB", "826", "WLS", "Z4", "00NL007", "", "53.04664", "-2.99132", "Europe/London"),
("2633521", "Worthing", "", "GB", "826", "ENG", "P6", "45UH", "", "50.81448", "-0.37126", "Europe/London"),
("2633551", "Worksop", "Уорксоп", "GB", "826", "ENG", "J9", "37UC", "", "53.30182", "-1.12404", "Europe/London"),
("2633553", "Workington", "", "GB", "826", "ENG", "C9", "16UB", "", "54.6425", "-3.54413", "Europe/London"),
("2633563", "Worcester", "Вустер", "GB", "826", "ENG", "Q4", "47UE", "", "52.18935", "-2.22001", "Europe/London"),
("2633655", "Woodford Green", "", "GB", "826", "ENG", "GLA", "K8", "", "51.60938", "0.02329", "Europe/London"),
("2633681", "Wombwell", "", "GB", "826", "ENG", "A3", "", "", "53.52189", "-1.39698", "Europe/London"),
("2633691", "Wolverhampton", "Вулвергемптон", "GB", "826", "ENG", "Q3", "41UF", "", "52.58547", "-2.12296", "Europe/London"),
("2633708", "Wokingham", "Уокингхем", "GB", "826", "ENG", "Q2", "", "", "51.4112", "-0.83565", "Europe/London"),
("2633709", "Woking", "Уокинге", "GB", "826", "ENG", "N7", "43UM", "", "51.31903", "-0.55893", "Europe/London"),
("2633729", "Witney", "Уитни", "GB", "826", "ENG", "K2", "38UF", "", "51.7836", "-1.4854", "Europe/London"),
("2633749", "Witham", "", "GB", "826", "ENG", "E4", "22UC", "", "51.80007", "0.64038", "Europe/London"),
("2633765", "Wishaw", "", "GB", "826", "SCT", "V8", "", "", "55.76667", "-3.91667", "Europe/London"),
("2633771", "Wisbech", "Визбич", "GB", "826", "ENG", "C3", "12UD", "", "52.66622", "0.15938", "Europe/London"),
("2633810", "Winsford", "", "GB", "826", "ENG", "Z8", "00EW163", "", "53.18333", "-2.51667", "Europe/London"),
("2633842", "Windsor", "Виндзор", "GB", "826", "ENG", "P9", "", "", "51.48333", "-0.6", "Europe/London"),
("2633858", "Winchester", "Винчестер", "GB", "826", "ENG", "F2", "24UP", "", "51.06513", "-1.3187", "Europe/London"),
("2633883", "Wilmslow", "", "GB", "826", "ENG", "Z7", "00EQ004", "", "53.32803", "-2.23148", "Europe/London"),
("2633912", "Willenhall", "", "GB", "826", "ENG", "O8", "", "", "52.6", "-2.03333", "Europe/London"),
("2633936", "Wigston Magna", "", "GB", "826", "ENG", "H5", "31UJ", "", "52.58128", "-1.09248", "Europe/London"),
("2633948", "Wigan", "Уиган", "GB", "826", "ENG", "P7", "", "", "53.53333", "-2.61667", "Europe/London"),
("2633954", "Widnes", "", "GB", "826", "ENG", "E9", "00ET005", "", "53.3618", "-2.73406", "Europe/London"),
("2633976", "Wickford", "", "GB", "826", "ENG", "E4", "22UB", "", "51.61101", "0.52331", "Europe/London"),
("2634021", "Whitstable", "Уитстабл", "GB", "826", "ENG", "G5", "6945807", "", "51.3607", "1.0257", "Europe/London"),
("2634032", "Whitley Bay", "", "GB", "826", "ENG", "J5", "00EM167", "", "55.03973", "-1.44713", "Europe/London"),
("2634096", "Whitehaven", "", "GB", "826", "ENG", "C9", "16UE", "", "54.54897", "-3.58412", "Europe/London"),
("2634103", "Whitefield", "", "GB", "826", "ENG", "C1", "", "", "53.55", "-2.3", "Europe/London"),
("2634155", "Whickham", "", "GB", "826", "ENG", "E5", "00CH002", "", "54.94561", "-1.67635", "Europe/London"),
("2634202", "Weymouth", "Уэймут", "GB", "826", "ENG", "D6", "19UJ", "", "50.61136", "-2.45334", "Europe/London"),
("2634204", "Weybridge", "Вейбридж", "GB", "826", "ENG", "N7", "43UB", "", "51.37216", "-0.45297", "Europe/London"),
("2634308", "Weston-super-Mare", "Уэстон-сьюпер-Мэр", "GB", "826", "ENG", "J4", "00HC038", "", "51.34603", "-2.97665", "Europe/London"),
("2634340", "West Molesey", "", "GB", "826", "ENG", "N7", "43UB", "", "51.39985", "-0.37997", "Europe/London"),
("2634387", "Westhoughton", "", "GB", "826", "ENG", "B1", "00BL003", "", "53.54899", "-2.52464", "Europe/London"),
("2634491", "West Bromwich", "Уэст-Бромидж", "GB", "826", "ENG", "L7", "47UB", "", "52.51868", "-1.9945", "Europe/London"),
("2634493", "West Bridgford", "", "GB", "826", "ENG", "J9", "37UJ", "", "52.92979", "-1.12537", "Europe/London"),
("2634552", "Welwyn Garden City", "Уэлин-Гарден-Сити", "GB", "826", "ENG", "F8", "26UL", "", "51.80174", "-0.20691", "Europe/London"),
("2634573", "Wellington", "Веллингтон", "GB", "826", "ENG", "O2", "00GF026", "", "52.7", "-2.51667", "Europe/London"),
("2634578", "Wellingborough", "Веллингборо", "GB", "826", "ENG", "J1", "34UH", "", "52.30273", "-0.69446", "Europe/London"),
("2634579", "Welling", "", "GB", "826", "ENG", "GLA", "A6", "", "51.46246", "0.10759", "Europe/London"),
("2634616", "Wednesfield", "", "GB", "826", "ENG", "Q3", "", "", "52.6", "-2.08333", "Europe/London"),
("2634617", "Wednesbury", "", "GB", "826", "ENG", "L7", "41UF", "", "52.5514", "-2.02355", "Europe/London"),
("2634672", "Wath upon Dearne", "", "GB", "826", "ENG", "L3", "00CF003", "", "53.50291", "-1.3458", "Europe/London"),
("2634677", "Watford", "Уотфорд", "GB", "826", "ENG", "F8", "26UK", "", "51.65531", "-0.39602", "Europe/London"),
("2634686", "Waterlooville", "Уотерлувиль", "GB", "826", "ENG", "F2", "24UH", "", "50.88067", "-1.0304", "Europe/London"),
("2634715", "Washington", "Вашингтон", "GB", "826", "ENG", "N6", "", "", "54.9", "-1.51667", "Europe/London"),
("2634725", "Warwick", "Уорик", "GB", "826", "ENG", "P3", "44UF", "", "52.28333", "-1.58333", "Europe/London"),
("2634739", "Warrington", "Уоррингтон", "GB", "826", "ENG", "P2", "", "", "53.39254", "-2.58024", "Europe/London"),
("2634755", "Warminster", "", "GB", "826", "ENG", "P8", "00HY231", "", "51.20434", "-2.17873", "Europe/London"),
("2634777", "Ware", "", "GB", "826", "ENG", "F8", "26UD", "", "51.81265", "-0.02832", "Europe/London"),
("2634825", "Walton-on-Thames", "", "GB", "826", "ENG", "N7", "43UB", "", "51.38533", "-0.42066", "Europe/London"),
("2634843", "Waltham Abbey", "", "GB", "826", "ENG", "E4", "22UH", "", "51.687", "-0.00421", "Europe/London"),
("2634853", "Walsall", "Уолсолл", "GB", "826", "ENG", "O8", "41UF", "", "52.58528", "-1.98396", "Europe/London"),
("2634864", "Wallsend", "Уолсенд", "GB", "826", "ENG", "J5", "", "", "54.99111", "-1.53397", "Europe/London"),
("2634873", "Wallasey", "Уолласи", "GB", "826", "ENG", "Q1", "00CA009", "", "53.42324", "-3.06497", "Europe/London"),
("2634887", "Walkden", "", "GB", "826", "ENG", "L5", "", "", "53.51667", "-2.4", "Europe/London"),
("2634910", "Wakefield", "", "GB", "826", "ENG", "O7", "", "", "53.68331", "-1.49768", "Europe/London"),
("2635062", "Urmston", "", "GB", "826", "ENG", "O6", "00BU001", "", "53.44852", "-2.35419", "Europe/London"),
("2635243", "Uckfield", "", "GB", "826", "ENG", "E2", "21UH", "", "50.96948", "0.09589", "Europe/London"),
("2635269", "Tynemouth", "", "GB", "826", "ENG", "J5", "00EM167", "", "55.01788", "-1.42559", "Europe/London"),
("2635281", "Tyldesley", "", "GB", "826", "ENG", "P7", "00BL003", "", "53.51393", "-2.46754", "Europe/London"),
("2635412", "Truro", "Труро", "GB", "826", "ENG", "C6", "00HE202", "", "50.26526", "-5.05436", "Europe/London"),
("2635427", "Trowbridge", "Троубридже", "GB", "826", "ENG", "P8", "", "", "51.31889", "-2.20861", "Europe/London"),
("2635603", "Totton", "", "GB", "826", "ENG", "F2", "24UJ", "", "50.91877", "-1.49037", "Europe/London"),
("2635650", "Torquay", "Торки", "GB", "826", "ENG", "O4", "", "", "50.46384", "-3.51434", "Europe/London"),
("2635703", "Tonbridge", "Тонбридж", "GB", "826", "ENG", "G5", "29UP", "", "51.19242", "0.27532", "Europe/London"),
("2635762", "Tiverton", "", "GB", "826", "ENG", "D4", "18UD", "", "50.9", "-3.48333", "Europe/London"),
("2635785", "Tipton", "", "GB", "826", "ENG", "L7", "41UF", "", "52.52956", "-2.06773", "Europe/London"),
("2636005", "Thornaby-on-Tees", "", "GB", "826", "ENG", "K9", "", "", "54.53333", "-1.3", "Europe/London"),
("2636032", "Thetford", "Тетфорд", "GB", "826", "ENG", "I9", "33UB", "", "52.41667", "0.75", "Europe/London"),
("2636049", "Thatcham", "", "GB", "826", "ENG", "P4", "00MB049", "", "51.40366", "-1.26049", "Europe/London"),
("2636132", "Teignmouth", "Тинмут", "GB", "826", "ENG", "D4", "18UH", "", "50.54768", "-3.49637", "Europe/London"),
("2636177", "Taunton", "Тонтон", "GB", "826", "ENG", "M3", "40UE", "", "51.01494", "-3.10293", "Europe/London"),
("2636276", "Tamworth", "", "GB", "826", "ENG", "M9", "41UK", "", "52.63399", "-1.69587", "Europe/London"),
("2636333", "Tadley", "", "GB", "826", "ENG", "F2", "24UB", "", "51.35045", "-1.1285", "Europe/London"),
("2636373", "Swinton", "", "GB", "826", "ENG", "I2", "", "", "53.5", "-2.35", "Europe/London"),
("2636389", "Swindon", "Свиндон", "GB", "826", "ENG", "N9", "00HX015", "", "51.55797", "-1.78116", "Europe/London"),
("2636432", "Swansea", "Суонси", "GB", "826", "WLS", "Z1", "", "", "51.62079", "-3.94323", "Europe/London"),
("2636433", "Swanscombe", "", "GB", "826", "ENG", "G5", "29UD", "", "51.44713", "0.31028", "Europe/London"),
("2636439", "Swanley", "", "GB", "826", "ENG", "G5", "6945814", "", "51.39717", "0.17321", "Europe/London"),
("2636465", "Swadlincote", "", "GB", "826", "ENG", "D3", "17UK", "", "52.774", "-1.55744", "Europe/London"),
("2636484", "Sutton in Ashfield", "", "GB", "826", "ENG", "J9", "37UB", "", "53.12542", "-1.26135", "Europe/London"),
("2636486", "Sutton Coldfield", "", "GB", "826", "ENG", "A7", "", "", "52.56667", "-1.81667", "Europe/London"),
("2636503", "Sutton", "Саттон", "GB", "826", "ENG", "GLA", "N8", "", "51.35", "-0.2", "Europe/London"),
("2636531", "Sunderland", "Сандерленд", "GB", "826", "ENG", "N6", "", "", "54.90465", "-1.38222", "Europe/London"),
("2636534", "Sunbury-on-Thames", "", "GB", "826", "ENG", "N7", "43UB", "", "51.40606", "-0.4137", "Europe/London"),
("2636616", "Stroud", "Страуд", "GB", "826", "ENG", "E6", "23UF", "", "51.75", "-2.2", "Europe/London"),
("2636619", "Strood", "", "GB", "826", "ENG", "G5", "", "", "51.39594", "0.49361", "Europe/London"),
("2636663", "Stretford", "Стретфорд", "GB", "826", "ENG", "O6", "", "", "53.45", "-2.31667", "Europe/London"),
("2636713", "Stratford-upon-Avon", "Стратфорд-на-Эйвоне", "GB", "826", "ENG", "P3", "44UE", "", "52.19166", "-1.70734", "Europe/London"),
("2636749", "Stowmarket", "", "GB", "826", "ENG", "N5", "42UE", "", "52.18893", "0.99774", "Europe/London"),
("2636767", "Stourport-on-Severn", "", "GB", "826", "ENG", "Q4", "47UG", "", "52.35", "-2.26667", "Europe/London"),
("2636769", "Stourbridge", "Стоурбридж", "GB", "826", "ENG", "D7", "47UB", "", "52.45608", "-2.14317", "Europe/London"),
("2636841", "Stoke-on-Trent", "Сток-он-Трент", "GB", "826", "ENG", "N4", "", "", "53.00415", "-2.18538", "Europe/London"),
("2636876", "Stockton-on-Tees", "Стоктон-он-Тис", "GB", "826", "ENG", "N3", "", "", "54.56848", "-1.3187", "Europe/London"),
("2636882", "Stockport", "Стокпорт", "GB", "826", "ENG", "N2", "", "", "53.40979", "-2.15761", "Europe/London"),
("2636910", "Stirling", "Стерлинг", "GB", "826", "SCT", "W6", "", "", "56.11903", "-3.93682", "Europe/London"),
("2636940", "Stevenage", "Стивенедж", "GB", "826", "ENG", "F8", "26UH", "", "51.90224", "-0.20256", "Europe/London"),
("2636995", "Staveley", "", "GB", "826", "ENG", "D3", "17UD", "", "53.26667", "-1.35", "Europe/London"),
("2637104", "Stamford", "Стамфорд", "GB", "826", "ENG", "H7", "32UG", "", "52.65", "-0.48333", "Europe/London"),
("2637106", "Stalybridge", "Сталибридж", "GB", "826", "ENG", "O1", "00BT001", "", "53.48414", "-2.05908", "Europe/London"),
("2637126", "Staines", "", "GB", "826", "ENG", "N7", "43UH", "", "51.43092", "-0.50606", "Europe/London"),
("2637142", "Stafford", "Стаффорд", "GB", "826", "ENG", "M9", "41UG", "", "52.80521", "-2.11636", "Europe/London"),
("2637235", "Spennymoor", "", "GB", "826", "ENG", "D8", "00EJ107", "", "54.6988", "-1.60229", "Europe/London"),
("2637265", "Spalding", "", "GB", "826", "ENG", "H7", "32UF", "", "52.78709", "-0.15141", "Europe/London"),
("2637329", "South Shields", "Саут-Шилдс", "GB", "826", "ENG", "M7", "00EM167", "", "54.99859", "-1.4323", "Europe/London"),
("2637330", "Southsea", "", "GB", "826", "ENG", "K6", "", "", "50.79205", "-1.08593", "Europe/London"),
("2637343", "Southport", "", "GB", "826", "ENG", "L8", "", "", "53.64779", "-3.00648", "Europe/London"),
("2637355", "South Ockendon", "", "GB", "826", "ENG", "E4", "", "", "51.50799", "0.28333", "Europe/London"),
("2637433", "Southend-on-Sea", "Саутенд-он-Си", "GB", "826", "ENG", "M5", "", "", "51.53782", "0.71433", "Europe/London"),
("2637435", "South Elmsall", "", "GB", "826", "ENG", "O7", "00DB020", "", "53.59709", "-1.28034", "Europe/London"),
("2637476", "South Benfleet", "", "GB", "826", "ENG", "E4", "22UE", "", "51.55295", "0.55962", "Europe/London"),
("2637487", "Southampton", "Саутгемптон", "GB", "826", "ENG", "M4", "24UJ", "", "50.90395", "-1.40428", "Europe/London"),
("2637490", "Southall", "", "GB", "826", "ENG", "GLA", "D9", "", "51.50896", "-0.3713", "Europe/London"),
("2637546", "Solihull", "Солихалл", "GB", "826", "ENG", "M2", "00CT008", "", "52.41426", "-1.78094", "Europe/London"),
("2637627", "Slough", "Слау", "GB", "826", "ENG", "M1", "", "", "51.50949", "-0.59541", "Europe/London"),
("2637659", "Sleaford", "", "GB", "826", "ENG", "H7", "32UE", "", "52.99826", "-0.40941", "Europe/London"),
("2637752", "Skelmersdale", "", "GB", "826", "ENG", "H2", "30UP", "", "53.55024", "-2.77348", "Europe/London"),
("2637762", "Skegness", "", "GB", "826", "ENG", "H7", "32UC", "", "53.14362", "0.3363", "Europe/London"),
("2637802", "Sittingbourne", "", "GB", "826", "ENG", "G5", "29UM", "", "51.34128", "0.73282", "Europe/London"),
("2637891", "Shrewsbury", "Шрусбери", "GB", "826", "ENG", "L6", "", "", "52.71009", "-2.75208", "Europe/London"),
("2637916", "Shoreham-by-Sea", "", "GB", "826", "ENG", "P6", "45UB", "45UB002", "50.83413", "-0.27431", "Europe/London"),
("2637917", "Shoreham", "", "GB", "826", "ENG", "G5", "B8", "", "51.3334", "0.17801", "Europe/London"),
("2637958", "Shipley", "", "GB", "826", "ENG", "B4", "", "", "53.83333", "-1.76667", "Europe/London"),
("2638077", "Sheffield", "Шеффилд", "GB", "826", "ENG", "L9", "", "", "53.38297", "-1.4659", "Europe/London"),
("2638187", "Sevenoaks", "Севенокс", "GB", "826", "ENG", "G5", "6945814", "", "51.26997", "0.19278", "Europe/London"),
("2638235", "Selby", "Селби", "GB", "826", "ENG", "J7", "36UH", "", "53.78333", "-1.06667", "Europe/London"),
("2638302", "Seaham", "Сихем", "GB", "826", "ENG", "D8", "00EJ096", "", "54.83903", "-1.34575", "Europe/London"),
("2638311", "Seaford", "", "GB", "826", "ENG", "E2", "21UF", "", "50.77141", "0.10268", "Europe/London"),
("2638324", "Scunthorpe", "Сканторпе", "GB", "826", "ENG", "J3", "", "", "53.57905", "-0.65437", "Europe/London"),
("2638419", "Scarborough", "Скарборо", "GB", "826", "ENG", "J7", "36UG", "", "54.27966", "-0.40443", "Europe/London"),
("2638568", "Sandown", "Сандаун", "GB", "826", "ENG", "G2", "00MW018", "", "50.65158", "-1.16103", "Europe/London"),
("2638600", "Sandbach", "", "GB", "826", "ENG", "Z7", "00EQ113", "", "53.14515", "-2.36251", "Europe/London"),
("2638664", "Salisbury", "Солсбери", "GB", "826", "ENG", "P8", "00HY261", "", "51.06931", "-1.79569", "Europe/London"),
("2638671", "Salford", "Солфорд", "GB", "826", "ENG", "L5", "", "", "53.48771", "-2.29042", "Europe/London"),
("2638678", "Sale", "Сейл", "GB", "826", "ENG", "O6", "00BU001", "", "53.42519", "-2.32443", "Europe/London"),
("2638717", "Saint Neots", "", "GB", "826", "ENG", "C3", "12UE", "", "52.21667", "-0.26667", "Europe/London"),
("2638785", "St Helens", "Сент-Хеленс", "GB", "826", "ENG", "N1", "", "", "53.45", "-2.73333", "Europe/London"),
("2638853", "St Austell", "", "GB", "826", "ENG", "C6", "00HE131", "", "50.3425", "-4.77442", "Europe/London"),
("2638864", "Saint Andrews", "Сент-Андрус", "GB", "826", "SCT", "V1", "", "", "56.33871", "-2.79902", "Europe/London"),
("2638867", "St Albans", "Сент-Олбанс", "GB", "826", "ENG", "F8", "6615330", "", "51.75", "-0.33333", "Europe/London"),
("2638894", "Ryton", "", "GB", "826", "ENG", "L6", "00GG155", "", "52.61667", "-2.35", "Europe/London"),
("2638911", "Ryde", "Райд", "GB", "826", "ENG", "G2", "00MW032", "", "50.72999", "-1.1621", "Europe/London"),
("2638926", "Rutherglen", "", "GB", "826", "SCT", "W5", "", "", "55.82885", "-4.21376", "Europe/London"),
("2638946", "Rushden", "", "GB", "826", "ENG", "J1", "34UD", "", "52.29139", "-0.59923", "Europe/London"),
("2638960", "Runcorn", "", "GB", "826", "ENG", "E9", "00ET005", "", "53.34174", "-2.73124", "Europe/London"),
("2638976", "Ruislip", "", "GB", "826", "ENG", "GLA", "F9", "", "51.57344", "-0.42341", "Europe/London"),
("2638977", "Rugeley", "", "GB", "826", "ENG", "M9", "41UB", "", "52.7593", "-1.93694", "Europe/London"),
("2638978", "Rugby", "Рагби", "GB", "826", "ENG", "P3", "44UD", "", "52.37092", "-1.26417", "Europe/London"),
("2639015", "Royton", "", "GB", "826", "ENG", "K1", "00BP002", "", "53.56507", "-2.12267", "Europe/London"),
("2639022", "Royal Tunbridge Wells", "", "GB", "826", "ENG", "G5", "29UQ", "", "51.13245", "0.26333", "Europe/London"),
("2639069", "Rottingdean", "", "GB", "826", "ENG", "B6", "00ML001", "", "50.80984", "-0.05939", "Europe/London"),
("2639093", "Rotherham", "Ротерем", "GB", "826", "ENG", "L3", "00CF004", "", "53.43012", "-1.35678", "Europe/London"),
("2639189", "Romsey", "", "GB", "826", "ENG", "F2", "24UN", "", "50.98906", "-1.49989", "Europe/London"),
("2639265", "Rochford", "", "GB", "826", "ENG", "E4", "22UL", "", "51.58198", "0.70673", "Europe/London"),
("2639268", "Rochester", "Рочестер", "GB", "826", "ENG", "I3", "", "", "51.38764", "0.50546", "Europe/London"),
("2639272", "Rochdale", "Рочдейл", "GB", "826", "ENG", "L2", "30UM", "", "53.61766", "-2.1552", "Europe/London"),
("2639317", "Risca", "", "GB", "826", "WLS", "X4", "00PK023", "", "51.60799", "-3.10081", "Europe/London"),
("2639323", "Ripon", "Рипон", "GB", "826", "ENG", "J7", "36UD", "", "54.13521", "-1.52122", "Europe/London"),
("2639325", "Ripley", "Рипли", "GB", "826", "ENG", "D3", "17UB", "", "53.03333", "-1.4", "Europe/London"),
("2639409", "Rhyl", "Рил", "GB", "826", "WLS", "X9", "00NG035", "", "53.31955", "-3.48862", "Europe/London"),
("2639447", "Rhondda", "", "GB", "826", "WLS", "Y9", "00PF007", "", "51.65896", "-3.44885", "Europe/London"),
("2639495", "Renfrew", "Ренфру", "GB", "826", "SCT", "W2", "", "", "55.87197", "-4.39253", "Europe/London"),
("2639506", "Reigate", "Райгейт", "GB", "826", "ENG", "N7", "43UF", "", "51.23758", "-0.2078", "Europe/London"),
("2639545", "Redhill", "", "GB", "826", "ENG", "N7", "43UF", "", "51.24048", "-0.17044", "Europe/London"),
("2639557", "Redditch", "Реддитч", "GB", "826", "ENG", "Q4", "47UD", "", "52.3065", "-1.94569", "Europe/London"),
("2639563", "Redcar", "", "GB", "826", "ENG", "K9", "00EE004", "", "54.61657", "-1.05999", "Europe/London"),
("2639577", "Reading", "Рединг", "GB", "826", "ENG", "K7", "", "", "51.45625", "-0.97113", "Europe/London"),
("2639583", "Rayleigh", "", "GB", "826", "ENG", "E4", "22UL", "", "51.58571", "0.60459", "Europe/London"),
("2639586", "Rawtenstall", "", "GB", "826", "ENG", "H2", "30UM", "", "53.70076", "-2.28442", "Europe/London"),
("2639588", "Rawmarsh", "", "GB", "826", "ENG", "L3", "00CF024", "", "53.46062", "-1.34437", "Europe/London"),
("2639660", "Ramsgate", "Рамсгейт", "GB", "826", "ENG", "G5", "2636057", "29UN010", "51.33576", "1.41552", "Europe/London"),
("2639668", "Ramsbottom", "", "GB", "826", "ENG", "C1", "", "", "53.64789", "-2.31683", "Europe/London"),
("2639842", "Purley", "", "GB", "826", "ENG", "GLA", "C8", "", "51.33678", "-0.11201", "Europe/London"),
("2639866", "Pudsey", "", "GB", "826", "ENG", "H3", "", "", "53.79538", "-1.66134", "Europe/London"),
("2639896", "Prestwick", "Престуик", "GB", "826", "SCT", "W4", "", "", "55.48333", "-4.61667", "Europe/London"),
("2639897", "Prestwich", "", "GB", "826", "ENG", "C1", "", "", "53.53333", "-2.28333", "Europe/London"),
("2639912", "Preston", "Престон", "GB", "826", "ENG", "H2", "30UK", "", "53.76667", "-2.71667", "Europe/London"),
("2639926", "Prestatyn", "", "GB", "826", "WLS", "X9", "00NG033", "", "53.33748", "-3.40776", "Europe/London"),
("2639928", "Prescot", "", "GB", "826", "ENG", "G9", "00BX004", "", "53.42948", "-2.80031", "Europe/London"),
("2639958", "Poulton le Fylde", "", "GB", "826", "ENG", "H2", "30UQ", "", "53.83333", "-2.98333", "Europe/London"),
("2639970", "Potters Bar", "", "GB", "826", "ENG", "F8", "26UE", "", "51.69353", "-0.17835", "Europe/London"),
("2639996", "Portsmouth", "Портсмут", "GB", "826", "ENG", "K6", "00MR001", "", "50.79899", "-1.09125", "Europe/London"),
("2639998", "Portslade", "", "GB", "826", "ENG", "E2", "", "", "50.84335", "-0.21544", "Europe/London"),
("2640037", "Portishead", "", "GB", "826", "ENG", "J4", "00HC027", "", "51.48199", "-2.76973", "Europe/London"),
("2640054", "Porthcawl", "", "GB", "826", "WLS", "X3", "00PB017", "", "51.47903", "-3.70362", "Europe/London"),
("2640060", "Port Glasgow", "", "GB", "826", "SCT", "V4", "", "", "55.93464", "-4.6895", "Europe/London"),
("2640101", "Poole", "Пул", "GB", "826", "ENG", "K5", "", "", "50.71667", "-2", "Europe/London"),
("2640104", "Pontypridd", "Понтиприте", "GB", "826", "WLS", "Y9", "00PF023", "", "51.6021", "-3.34211", "Europe/London"),
("2640106", "Pontypool", "", "GB", "826", "WLS", "Z2", "", "", "51.70111", "-3.04444", "Europe/London"),
("2640132", "Pontefract", "", "GB", "826", "ENG", "O7", "", "", "53.69107", "-1.31269", "Europe/London"),
("2640155", "Polmont", "Полмонте", "GB", "826", "SCT", "U9", "", "", "55.9905", "-3.70737", "Europe/London"),
("2640190", "Plymstock", "", "GB", "826", "ENG", "K4", "18UG", "", "50.35999", "-4.09049", "Europe/London"),
("2640194", "Plymouth", "Плимут", "GB", "826", "ENG", "K4", "", "", "50.37153", "-4.14305", "Europe/London"),
("2640246", "Pitsea", "", "GB", "826", "ENG", "E4", "22UB", "", "51.56387", "0.50859", "Europe/London"),
("2640275", "Pinner", "", "GB", "826", "ENG", "GLA", "F4", "", "51.59384", "-0.38216", "Europe/London"),
("2640349", "Peterlee", "Петерли", "GB", "826", "ENG", "D8", "00EJ088", "", "54.76032", "-1.33649", "Europe/London"),
("2640351", "Peterhead", "", "GB", "826", "SCT", "T6", "", "", "57.50584", "-1.79806", "Europe/London"),
("2640354", "Peterborough", "Питерборо", "GB", "826", "ENG", "K3", "00JA016", "", "52.57364", "-0.24777", "Europe/London"),
("2640358", "Perth", "Перт", "GB", "826", "SCT", "W1", "", "", "56.39522", "-3.43139", "Europe/London"),
("2640377", "Penzance", "Пензанс", "GB", "826", "ENG", "C6", "00HE107", "", "50.11861", "-5.53715", "Europe/London"),
("2640465", "Penicuik", "", "GB", "826", "SCT", "V5", "", "", "55.83166", "-3.22423", "Europe/London"),
("2640496", "Penarth", "", "GB", "826", "WLS", "Z3", "00PD014", "", "51.4386", "-3.17342", "Europe/London"),
("2640677", "Paisley", "Пейсли", "GB", "826", "SCT", "W2", "", "", "55.83173", "-4.43254", "Europe/London"),
("2640681", "Paignton", "Пэйнтон", "GB", "826", "ENG", "O4", "18UG", "", "50.43565", "-3.56789", "Europe/London"),
("2640729", "Oxford", "Оксфорд", "GB", "826", "ENG", "K2", "38UC", "", "51.75222", "-1.25596", "Europe/London"),
("2640861", "Oswestry", "Освестри", "GB", "826", "ENG", "L6", "00GG140", "", "52.86195", "-3.05497", "Europe/London"),
("2640869", "Ossett", "Оссетт", "GB", "826", "ENG", "O7", "", "", "53.67978", "-1.58006", "Europe/London"),
("2640894", "Orpington", "", "GB", "826", "ENG", "GLA", "B8", "", "51.37457", "0.09785", "Europe/London"),
("2640908", "Ormskirk", "", "GB", "826", "ENG", "H2", "30UP", "", "53.56685", "-2.88178", "Europe/London"),
("2640967", "Omagh", "Ома", "GB", "826", "NIR", "T3", "", "", "54.6", "-7.3", "Europe/London"),
("2641022", "Oldham", "Олдем", "GB", "826", "ENG", "K1", "", "", "53.54051", "-2.1183", "Europe/London"),
("2641134", "Oadby", "", "GB", "826", "ENG", "H5", "31UJ", "", "52.60621", "-1.08354", "Europe/London"),
("2641157", "Nuneaton", "Нанитон", "GB", "826", "ENG", "P3", "44UC", "", "52.52323", "-1.46523", "Europe/London"),
("2641170", "Nottingham", "Ноттингем", "GB", "826", "ENG", "J8", "", "", "52.9536", "-1.15047", "Europe/London"),
("2641181", "Norwich", "Норидж", "GB", "826", "ENG", "I9", "33UG", "", "52.62783", "1.29834", "Europe/London"),
("2641224", "Northwich", "Нортвич", "GB", "826", "ENG", "Z8", "00EW119", "", "53.26138", "-2.51225", "Europe/London"),
("2641267", "North Shields", "", "GB", "826", "ENG", "J5", "", "", "55.01646", "-1.44925", "Europe/London"),
("2641290", "Northolt", "", "GB", "826", "ENG", "GLA", "D9", "", "51.54855", "-0.36778", "Europe/London"),
("2641319", "Lancing", "", "GB", "826", "ENG", "P6", "45UB", "", "50.82882", "-0.32247", "Europe/London"),
("2641430", "Northampton", "Нортгемптон", "GB", "826", "ENG", "J1", "34UF", "", "52.25", "-0.88333", "Europe/London"),
("2641435", "Northallerton", "", "GB", "826", "ENG", "J7", "36UC", "", "54.33901", "-1.43243", "Europe/London"),
("2641519", "Newtownards", "Ньютаунардс", "GB", "826", "NIR", "Q7", "", "", "54.59236", "-5.69092", "Europe/London"),
("2641520", "Newtownabbey", "Ньютонэббей", "GB", "826", "NIR", "T1", "", "", "54.65983", "-5.90858", "Europe/London"),
("2641544", "Newton Mearns", "", "GB", "826", "SCT", "U7", "", "", "55.77334", "-4.33339", "Europe/London"),
("2641546", "Newton-le-Willows", "", "GB", "826", "ENG", "N1", "", "", "53.45", "-2.6", "Europe/London"),
("2641555", "Newton Aycliffe", "", "GB", "826", "ENG", "D8", "00EJ045", "", "54.61842", "-1.5719", "Europe/London"),
("2641557", "Newton Abbot", "Ньютон-Эббот", "GB", "826", "ENG", "D4", "18UH", "", "50.52858", "-3.61186", "Europe/London"),
("2641581", "Newry", "Ньюри", "GB", "826", "NIR", "S9", "", "", "54.17841", "-6.33739", "Europe/London"),
("2641589", "Newquay", "", "GB", "826", "ENG", "C6", "00HE097", "", "50.41317", "-5.08186", "Europe/London"),
("2641591", "Newport Pagnell", "", "GB", "826", "ENG", "I6", "00MG022", "", "52.08731", "-0.72218", "Europe/London"),
("2641598", "Newport", "Ньюпорт", "GB", "826", "WLS", "Y6", "", "", "51.58774", "-2.99835", "Europe/London"),
("2641599", "Newport", "Ньюпорт", "GB", "826", "ENG", "G2", "", "", "50.70146", "-1.29124", "Europe/London"),
("2641609", "New Milton", "", "GB", "826", "ENG", "F2", "24UJ", "", "50.75601", "-1.6658", "Europe/London"),
("2641616", "Newmarket", "Ньюмаркет", "GB", "826", "ENG", "N5", "42UC", "", "52.24467", "0.40418", "Europe/London"),
("2641617", "New Malden", "", "GB", "826", "ENG", "GLA", "G7", "", "51.39915", "-0.2556", "Europe/London"),
("2641673", "Newcastle upon Tyne", "Ньюкасл", "GB", "826", "ENG", "I7", "", "", "54.97328", "-1.61396", "Europe/London"),
("2641674", "Newcastle under Lyme", "", "GB", "826", "ENG", "M9", "41UE", "", "53", "-2.23333", "Europe/London"),
("2641689", "Newbury", "Ньюбери", "GB", "826", "ENG", "P4", "00MB062", "", "51.40033", "-1.32059", "Europe/London"),
("2641690", "Newburn", "", "GB", "826", "ENG", "I7", "00EM073", "", "54.9876", "-1.74415", "Europe/London"),
("2641731", "Newark on Trent", "", "GB", "826", "ENG", "J9", "37UG", "", "53.06667", "-0.81667", "Europe/London"),
("2641810", "Nelson", "", "GB", "826", "ENG", "H2", "30UJ", "", "53.83333", "-2.2", "Europe/London"),
("2641843", "Neath", "Нит", "GB", "826", "WLS", "Y5", "00NZ020", "", "51.66317", "-3.80443", "Europe/London"),
("2641913", "Nailsea", "", "GB", "826", "ENG", "J4", "00HC025", "", "51.43239", "-2.75847", "Europe/London"),
("2641942", "Musselburgh", "Масселборо", "GB", "826", "SCT", "U6", "", "", "55.9417", "-3.04991", "Europe/London"),
("2642135", "Motherwell", "Мазервелл", "GB", "826", "SCT", "V8", "", "", "55.78924", "-3.99187", "Europe/London"),
("2642189", "Morley", "", "GB", "826", "ENG", "H3", "00DA030", "", "53.74013", "-1.59877", "Europe/London"),
("2642204", "Moreton", "", "GB", "826", "ENG", "Q1", "", "", "53.4", "-3.11667", "Europe/London"),
("2642214", "Morecambe", "Моркам", "GB", "826", "ENG", "H2", "30UH", "", "54.06835", "-2.86108", "Europe/London"),
("2642414", "Mitcham", "", "GB", "826", "ENG", "GLA", "I4", "", "51.40474", "-0.16404", "Europe/London"),
("2642423", "Mirfield", "", "GB", "826", "ENG", "G8", "00CZ005", "", "53.67343", "-1.69636", "Europe/London"),
("2642465", "Milton Keynes", "Милтон-Кинс", "GB", "826", "ENG", "I6", "", "", "52.04172", "-0.75583", "Europe/London"),
("2642593", "Middleton", "", "GB", "826", "ENG", "L2", "", "", "53.55", "-2.2", "Europe/London"),
("2642607", "Middlesbrough", "Мидлсбро", "GB", "826", "ENG", "I5", "00EF019", "", "54.57623", "-1.23483", "Europe/London"),
("2642683", "Mexborough", "", "GB", "826", "ENG", "D5", "00CE017", "", "53.49389", "-1.29243", "Europe/London"),
("2642705", "Merthyr Tydfil", "Мертир-Тидвил", "GB", "826", "WLS", "Y3", "00PH009", "", "51.74794", "-3.37779", "Europe/London"),
("2642763", "Melton Mowbray", "", "GB", "826", "ENG", "H5", "31UG", "", "52.76588", "-0.88693", "Europe/London"),
("2642999", "Marple", "", "GB", "826", "ENG", "N2", "00EQ047", "", "53.39452", "-2.06292", "Europe/London"),
("2643003", "Marlow", "", "GB", "826", "ENG", "B9", "11UF", "", "51.56933", "-0.77415", "Europe/London"),
("2643027", "Market Harborough", "", "GB", "826", "ENG", "H5", "31UD", "", "52.4776", "-0.92053", "Europe/London"),
("2643044", "Margate", "Маргит", "GB", "826", "ENG", "G5", "2636057", "", "51.38132", "1.38617", "Europe/London"),
("2643071", "March", "", "GB", "826", "ENG", "C3", "12UD", "", "52.55131", "0.08828", "Europe/London"),
("2643096", "Mansfield Woodhouse", "", "GB", "826", "ENG", "J9", "37UF", "", "53.16495", "-1.19384", "Europe/London"),
("2643097", "Mansfield", "Мэнсфилд", "GB", "826", "ENG", "J9", "37UF", "", "53.13333", "-1.2", "Europe/London"),
("2643116", "Mangotsfield", "", "GB", "826", "ENG", "M6", "00HD045", "", "51.4878", "-2.50403", "Europe/London"),
("2643123", "Manchester", "Манчестер", "GB", "826", "ENG", "I2", "", "", "53.48095", "-2.23743", "Europe/London"),
("2643144", "Maltby", "", "GB", "826", "ENG", "L3", "00CF029", "", "53.41667", "-1.2", "Europe/London"),
("2643160", "Maldon", "Мелдона", "GB", "826", "ENG", "E4", "22UK", "", "51.7311", "0.67463", "Europe/London"),
("2643179", "Maidstone", "Мейдстон", "GB", "826", "ENG", "G5", "29UH", "", "51.26667", "0.51667", "Europe/London"),
("2643186", "Maidenhead", "Мейденхед", "GB", "826", "ENG", "P9", "", "", "51.52279", "-0.71986", "Europe/London"),
("2643198", "Maghull", "", "GB", "826", "ENG", "L8", "00CA005", "", "53.51619", "-2.94117", "Europe/London"),
("2643218", "Maesteg", "", "GB", "826", "WLS", "X3", "00PB012", "", "51.60926", "-3.65823", "Europe/London"),
("2643266", "Macclesfield", "", "GB", "826", "ENG", "Z7", "00EQ124", "", "53.26023", "-2.12564", "Europe/London"),
("2643339", "Luton", "Лутон", "GB", "826", "ENG", "I1", "00KC039", "", "51.87967", "-0.41748", "Europe/London"),
("2643490", "Lowestoft", "Лоустофт", "GB", "826", "ENG", "N5", "42UH", "", "52.4752", "1.75159", "Europe/London"),
("2643553", "Louth", "Лаут", "GB", "826", "ENG", "H7", "32UC", "", "53.36664", "-0.00438", "Europe/London"),
("2643567", "Loughborough", "Лафборо", "GB", "826", "ENG", "H5", "31UC", "", "52.76667", "-1.2", "Europe/London"),
("2643696", "Longfield", "", "GB", "826", "ENG", "G5", "29UD", "", "51.3969", "0.30212", "Europe/London"),
("2643697", "Long Eaton", "", "GB", "826", "ENG", "D3", "17UG", "", "52.89855", "-1.27136", "Europe/London"),
("2643734", "Londonderry County Borough", "", "GB", "826", "NIR", "", "", "", "54.99721", "-7.30917", "Europe/London"),
("2643736", "Derry", "Дерри", "GB", "826", "NIR", "S6", "", "", "54.9981", "-7.30934", "Europe/London"),
("2643741", "City of London", "Сити", "GB", "826", "ENG", "GLA", "H9", "", "51.51279", "-0.09184", "Europe/London"),
("2643743", "London", "Лондон", "GB", "826", "ENG", "GLA", "", "", "51.50853", "-0.12574", "Europe/London"),
("2643776", "Lofthouse", "", "GB", "826", "ENG", "H3", "", "", "53.72947", "-1.49697", "Europe/London"),
("2644100", "Llanelli", "Лланелли", "GB", "826", "WLS", "X7", "00NU032", "", "51.68195", "-4.16191", "Europe/London"),
("2644120", "Llandudno", "Лландидно", "GB", "826", "WLS", "X8", "00NE018", "", "53.32498", "-3.83148", "Europe/London"),
("2644204", "Livingston", "Ливингстон", "GB", "826", "SCT", "W9", "", "", "55.90288", "-3.52261", "Europe/London"),
("2644210", "Liverpool", "Ливерпуль", "GB", "826", "ENG", "H8", "", "", "53.41058", "-2.97794", "Europe/London"),
("2644319", "Littlehampton", "", "GB", "826", "ENG", "P6", "45UC", "", "50.80691", "-0.53782", "Europe/London"),
("2644386", "Litherland", "", "GB", "826", "ENG", "L8", "00CA007", "", "53.46993", "-2.99809", "Europe/London"),
("2644411", "Lisburn", "Лисберн", "GB", "826", "NIR", "S5", "", "", "54.52337", "-6.03527", "Europe/London"),
("2644487", "Lincoln", "Линкольн", "GB", "826", "ENG", "H7", "32UD", "", "53.22683", "-0.53792", "Europe/London"),
("2644531", "Lichfield", "Личфилд", "GB", "826", "ENG", "M9", "41UD", "", "52.68154", "-1.82549", "Europe/London"),
("2644547", "Leyland", "", "GB", "826", "ENG", "H2", "30UN", "", "53.69786", "-2.68758", "Europe/London"),
("2644559", "Lewes", "Льюис", "GB", "826", "ENG", "E2", "21UF", "", "50.87363", "0.01133", "Europe/London"),
("2644597", "Letchworth", "Лечуорт", "GB", "826", "ENG", "F8", "26UF", "", "51.97944", "-0.2284", "Europe/London"),
("2644652", "Leighton Buzzard", "", "GB", "826", "ENG", "Z6", "00KC042", "", "51.91722", "-0.65802", "Europe/London"),
("2644660", "Leigh", "", "GB", "826", "ENG", "P7", "", "", "53.48333", "-2.51667", "Europe/London"),
("2644668", "Leicester", "Лестер", "GB", "826", "ENG", "H4", "31UC", "", "52.6386", "-1.13169", "Europe/London"),
("2644684", "Leek", "", "GB", "826", "ENG", "M9", "41UH", "", "53.10434", "-2.02207", "Europe/London"),
("2644688", "Leeds", "Лидс", "GB", "826", "ENG", "H3", "", "", "53.79648", "-1.54785", "Europe/London"),
("2644726", "Leatherhead", "", "GB", "826", "ENG", "N7", "43UE", "", "51.29593", "-0.3259", "Europe/London"),
("2644737", "Royal Leamington Spa", "Лемингтон Спа", "GB", "826", "ENG", "P3", "44UF", "", "52.3", "-1.53333", "Europe/London"),
("2644849", "Larne", "Ларн", "GB", "826", "NIR", "S3", "", "", "54.85", "-5.81667", "Europe/London"),
("2644853", "Larkhall", "", "GB", "826", "SCT", "W5", "", "", "55.73333", "-3.96667", "Europe/London"),
("2644972", "Lancaster", "Ланкастер", "GB", "826", "ENG", "H2", "30UH", "", "54.04649", "-2.79988", "Europe/London"),
("2645261", "Kirkintilloch", "Керкинтиллох", "GB", "826", "SCT", "U5", "", "", "55.93933", "-4.15262", "Europe/London"),
("2645298", "Kirkcaldy", "Керколди", "GB", "826", "SCT", "V1", "", "", "56.10982", "-3.16149", "Europe/London"),
("2645309", "Kirkby in Ashfield", "", "GB", "826", "ENG", "J9", "37UB", "", "53.09982", "-1.24379", "Europe/London"),
("2645313", "Kirkby", "Керби", "GB", "826", "ENG", "G9", "", "", "53.48333", "-2.9", "Europe/London"),
("2645418", "Kingswood", "Кингсвуд", "GB", "826", "ENG", "M6", "", "", "51.45278", "-2.50833", "Europe/London"),
("2645420", "Kingswinford", "", "GB", "826", "ENG", "D7", "41UF", "", "52.49755", "-2.16889", "Europe/London"),
("2645425", "Hull", "Кингстон-апон-Халл", "GB", "826", "ENG", "G6", "", "", "53.7446", "-0.33525", "Europe/London"),
("2645456", "King's Lynn", "Кингслинн", "GB", "826", "ENG", "I9", "33UE", "", "52.75172", "0.39516", "Europe/London"),
("2645541", "Kilwinning", "Килуиннинг", "GB", "826", "SCT", "V7", "", "", "55.65333", "-4.70666", "Europe/London"),
("2645605", "Kilmarnock", "Килмарнок", "GB", "826", "SCT", "U4", "", "", "55.61171", "-4.49581", "Europe/London"),
("2645721", "Kidsgrove", "", "GB", "826", "ENG", "M9", "41UE", "", "53.08691", "-2.23777", "Europe/London"),
("2645722", "Kidlington", "", "GB", "826", "ENG", "K2", "38UB", "", "51.82166", "-1.2886", "Europe/London"),
("2645724", "Kidderminster", "", "GB", "826", "ENG", "Q4", "47UG", "", "52.38819", "-2.25", "Europe/London"),
("2645733", "Keynsham", "", "GB", "826", "ENG", "A4", "00HA026", "", "51.41387", "-2.4978", "Europe/London"),
("2645753", "Kettering", "Кеттеринг", "GB", "826", "ENG", "J1", "34UE", "", "52.39836", "-0.72571", "Europe/London"),
("2645822", "Kenilworth", "", "GB", "826", "ENG", "P3", "44UF", "", "52.34286", "-1.58015", "Europe/London"),
("2645826", "Kendal", "Кендал", "GB", "826", "ENG", "C9", "16UG", "", "54.32681", "-2.74757", "Europe/London"),
("2645831", "Kempston", "", "GB", "826", "ENG", "Z5", "00KB018", "", "52.11599", "-0.50044", "Europe/London"),
("2645889", "Keighley", "Кейли", "GB", "826", "ENG", "B4", "00CX009", "", "53.86791", "-1.90664", "Europe/London"),
("2645951", "Johnstone", "", "GB", "826", "SCT", "W2", "", "", "55.82906", "-4.51605", "Europe/London"),
("2645972", "Jarrow", "Джарроу", "GB", "826", "ENG", "M7", "00EM167", "", "54.98036", "-1.48423", "Europe/London"),
("2646003", "Islington", "Ислингтон", "GB", "826", "ENG", "GLA", "G3", "", "51.53622", "-0.10304", "Europe/London"),
("2646004", "Isleworth", "", "GB", "826", "ENG", "GLA", "G1", "", "51.47518", "-0.34246", "Europe/London"),
("2646032", "Irvine", "Эрвин", "GB", "826", "SCT", "V7", "", "", "55.6194", "-4.65508", "Europe/London"),
("2646042", "Irlam", "", "GB", "826", "ENG", "L5", "00BU001", "", "53.44253", "-2.42323", "Europe/London"),
("2646057", "Ipswich", "Ипсуич", "GB", "826", "ENG", "N5", "42UD", "", "52.05917", "1.15545", "Europe/London"),
("2646088", "Inverness", "Инвернесс", "GB", "826", "SCT", "V3", "", "", "57.47908", "-4.22398", "Europe/London"),
("2646274", "Ilkeston", "", "GB", "826", "ENG", "D3", "17UG", "", "52.97055", "-1.30951", "Europe/London"),
("2646317", "Hythe", "", "GB", "826", "ENG", "F2", "24UJ", "", "50.86004", "-1.40162", "Europe/London"),
("2646327", "Hyde", "", "GB", "826", "ENG", "O1", "", "", "53.45131", "-2.07943", "Europe/London"),
("2646329", "Huyton", "Хейтон", "GB", "826", "ENG", "G9", "00BX006", "", "53.4115", "-2.83935", "Europe/London"),
("2646393", "Huntingdon", "The Huntingdon", "GB", "826", "ENG", "C3", "12UE", "12UE046", "52.33049", "-0.18651", "Europe/London"),
("2646458", "Huddersfield", "Хаддерсфилд", "GB", "826", "ENG", "G8", "00CZ003", "", "53.64904", "-1.78416", "Europe/London"),
("2646460", "Hucknall", "", "GB", "826", "ENG", "J9", "37UB", "", "53.03333", "-1.2", "Europe/London"),
("2646471", "Hoyland Nether", "", "GB", "826", "ENG", "A3", "", "", "53.5", "-1.45", "Europe/London"),
("2646504", "Hove", "Хов", "GB", "826", "ENG", "B6", "45UG", "", "50.83088", "-0.1672", "Europe/London"),
("2646525", "Houghton-le-Spring", "", "GB", "826", "ENG", "D8", "", "", "54.84034", "-1.46427", "Europe/London"),
("2646542", "Horwich", "", "GB", "826", "ENG", "B1", "00BL002", "", "53.60126", "-2.54975", "Europe/London"),
("2646557", "Horsham", "Хоршэм", "GB", "826", "ENG", "P6", "45UF", "", "51.06395", "-0.32719", "Europe/London"),
("2646558", "Horsforth", "", "GB", "826", "ENG", "H3", "00DA032", "", "53.83797", "-1.64036", "Europe/London"),
("2646606", "Horley", "", "GB", "826", "ENG", "N7", "43UF", "", "51.17423", "-0.15919", "Europe/London"),
("2646807", "Hoddesdon", "Ходдсдон", "GB", "826", "ENG", "F8", "26UB", "", "51.76148", "-0.01144", "Europe/London"),
("2646826", "Hitchin", "", "GB", "826", "ENG", "F8", "26UF", "", "51.95314", "-0.26519", "Europe/London"),
("2646862", "Hindley", "", "GB", "826", "ENG", "P7", "", "", "53.53333", "-2.58333", "Europe/London"),
("2646867", "Hinckley", "Хинкли", "GB", "826", "ENG", "H5", "31UE", "", "52.5389", "-1.37613", "Europe/London"),
("2646914", "High Wycombe", "Хай-Уиком", "GB", "826", "ENG", "B9", "11UF", "", "51.62907", "-0.74934", "Europe/London"),
("2646979", "High Blantyre", "", "GB", "826", "SCT", "W5", "", "", "55.78438", "-4.10007", "Europe/London"),
("2647026", "Heswall", "", "GB", "826", "ENG", "Q1", "00EW114", "", "53.32733", "-3.09648", "Europe/London"),
("2647044", "Hertford", "Хертфорд", "GB", "826", "ENG", "F8", "26UD", "", "51.79588", "-0.07854", "Europe/London"),
("2647057", "Herne Bay", "", "GB", "826", "ENG", "G5", "6945807", "", "51.373", "1.12857", "Europe/London"),
("2647074", "Hereford", "Херефорде", "GB", "826", "ENG", "F7", "00GA240", "", "52.05684", "-2.71482", "Europe/London"),
("2647138", "Hemel Hempstead", "", "GB", "826", "ENG", "F8", "26UC", "", "51.75369", "-0.47517", "Europe/London"),
("2647209", "Hebburn", "", "GB", "826", "ENG", "M7", "", "", "54.97302", "-1.51546", "Europe/London"),
("2647227", "Heanor", "", "GB", "826", "ENG", "D3", "17UB", "", "53.01372", "-1.35383", "Europe/London"),
("2647246", "Hazel Grove", "", "GB", "826", "ENG", "N2", "", "", "53.38333", "-2.11667", "Europe/London"),
("2647248", "Haywards Heath", "", "GB", "826", "ENG", "P6", "45UG", "", "50.99769", "-0.10313", "Europe/London"),
("2647261", "Hayes", "", "GB", "826", "ENG", "GLA", "F9", "", "51.51579", "-0.4234", "Europe/London"),
("2647265", "Haydock", "", "GB", "826", "ENG", "N1", "00EU003", "", "53.46723", "-2.68166", "Europe/London"),
("2647303", "Hawarden", "Хаварден", "GB", "826", "WLS", "Y1", "00NJ012", "", "53.18478", "-3.02578", "Europe/London"),
("2647310", "Haverhill", "", "GB", "826", "ENG", "N5", "42UF", "", "52.08226", "0.43891", "Europe/London"),
("2647317", "Havant", "Хавант", "GB", "826", "ENG", "F2", "24UH", "", "50.8567", "-0.98559", "Europe/London"),
("2647349", "Hatfield", "", "GB", "826", "ENG", "F8", "26UL", "", "51.76338", "-0.22419", "Europe/London"),
("2647356", "Hastings", "Гастингс", "GB", "826", "ENG", "E2", "21UD", "", "50.85519", "0.57292", "Europe/London"),
("2647363", "Haslingden", "", "GB", "826", "ENG", "H2", "30UM", "", "53.70326", "-2.32382", "Europe/London"),
("2647383", "Harwich", "Харвич", "GB", "826", "ENG", "E4", "22UN", "", "51.94194", "1.28437", "Europe/London"),
("2647400", "Hartlepool", "Хартлпул", "GB", "826", "ENG", "F5", "", "", "54.68611", "-1.2125", "Europe/London"),
("2647428", "Harrogate", "Харрогейт", "GB", "826", "ENG", "J7", "36UD", "", "53.99078", "-1.5373", "Europe/London"),
("2647451", "Harpenden", "", "GB", "826", "ENG", "F8", "6615330", "", "51.81684", "-0.35706", "Europe/London"),
("2647461", "Harlow", "Харлоу", "GB", "826", "ENG", "E4", "22UJ", "", "51.77655", "0.11158", "Europe/London"),
("2647550", "Hampton", "", "GB", "826", "ENG", "GLA", "L1", "", "51.41334", "-0.36701", "Europe/London"),
("2647570", "Hamilton", "Гамильтон", "GB", "826", "SCT", "W5", "", "", "55.76667", "-4.03333", "Europe/London"),
("2647632", "Halifax", "Галифакс", "GB", "826", "ENG", "C2", "", "", "53.71667", "-1.85", "Europe/London"),
("2647639", "Halesowen", "Хейлсовен", "GB", "826", "ENG", "D7", "47UB", "", "52.44859", "-2.04938", "Europe/London"),
("2647644", "Hale", "", "GB", "826", "ENG", "N7", "43UL", "", "51.21667", "-0.78333", "Europe/London"),
("2647655", "Hailsham", "", "GB", "826", "ENG", "E2", "21UH", "", "50.8622", "0.25775", "Europe/London"),
("2647679", "Hadleigh", "", "GB", "826", "ENG", "E4", "22UE", "", "51.55269", "0.60983", "Europe/London"),
("2647784", "Guiseley", "", "GB", "826", "ENG", "H3", "", "", "53.87561", "-1.71232", "Europe/London"),
("2647785", "Guisborough", "", "GB", "826", "ENG", "K9", "00EE001", "", "54.53478", "-1.05606", "Europe/London"),
("2647793", "Guildford", "Гилфорд", "GB", "826", "ENG", "N7", "43UD", "", "51.23536", "-0.57427", "Europe/London"),
("2647837", "Grove", "", "GB", "826", "ENG", "K2", "38UE", "", "51.60954", "-1.42187", "Europe/London"),
("2647948", "Greenock", "Гринок", "GB", "826", "SCT", "V4", "", "", "55.94838", "-4.76121", "Europe/London"),
("2647972", "Greenford", "", "GB", "826", "ENG", "GLA", "D9", "", "51.52866", "-0.35508", "Europe/London"),
("2647984", "Great Yarmouth", "Грейт-Ярмут", "GB", "826", "ENG", "I9", "33UD", "", "52.60831", "1.73052", "Europe/London"),
("2647985", "Great Wyrley", "", "GB", "826", "ENG", "M9", "41UF", "", "52.66277", "-2.01111", "Europe/London"),
("2648026", "Great Sankey", "", "GB", "826", "ENG", "P2", "00EU008", "", "53.39234", "-2.63994", "Europe/London"),
("2648063", "Great Malvern", "", "GB", "826", "ENG", "Q4", "47UC", "", "52.11161", "-2.32515", "Europe/London"),
("2648182", "Grays", "", "GB", "826", "ENG", "O3", "29UG", "", "51.47566", "0.32521", "Europe/London"),
("2648187", "Gravesend", "Грейвзенд", "GB", "826", "ENG", "G5", "29UG", "", "51.44138", "0.37371", "Europe/London"),
("2648208", "Grantham", "Гранты", "GB", "826", "ENG", "H7", "32UG", "", "52.91149", "-0.64184", "Europe/London"),
("2648215", "Grangemouth", "", "GB", "826", "SCT", "U9", "", "", "56.01141", "-3.72183", "Europe/London"),
("2648272", "Gosport", "Госпорт", "GB", "826", "ENG", "F2", "24UF", "", "50.79509", "-1.12902", "Europe/London"),
("2648273", "Gosforth", "", "GB", "826", "ENG", "I7", "", "", "55", "-1.61667", "Europe/London"),
("2648290", "Gorseinon", "", "GB", "826", "WLS", "Z1", "00NX009", "", "51.66931", "-4.04163", "Europe/London"),
("2648319", "Goole", "Гул", "GB", "826", "ENG", "E1", "00FB059", "", "53.71667", "-0.86667", "Europe/London"),
("2648356", "Golborne", "", "GB", "826", "ENG", "P7", "00EU017", "", "53.47693", "-2.59651", "Europe/London"),
("2648372", "Godalming", "Годалминге", "GB", "826", "ENG", "N7", "43UL", "", "51.18462", "-0.61725", "Europe/London"),
("2648404", "Gloucester", "Глостер", "GB", "826", "ENG", "E6", "23UE", "", "51.86568", "-2.2431", "Europe/London"),
("2648405", "Glossop", "", "GB", "826", "ENG", "D3", "17UH", "", "53.44325", "-1.949", "Europe/London"),
("2648438", "Glenrothes", "Гленротес", "GB", "826", "SCT", "V1", "", "", "56.19514", "-3.17316", "Europe/London"),
("2648579", "Glasgow", "Глазго", "GB", "826", "SCT", "V2", "", "", "55.86515", "-4.25763", "Europe/London"),
("2648657", "Gillingham", "Джиллингем", "GB", "826", "ENG", "G5", "", "", "51.38914", "0.54863", "Europe/London"),
("2648683", "Giffnock", "Гиффнок", "GB", "826", "SCT", "U7", "", "", "55.80373", "-4.29488", "Europe/London"),
("2648728", "Gelligaer", "", "GB", "826", "WLS", "X4", "00PK012", "", "51.66444", "-3.25611", "Europe/London"),
("2648773", "Gateshead", "Гейтсхед", "GB", "826", "ENG", "E5", "00CH002", "", "54.96209", "-1.60168", "Europe/London"),
("2648875", "Garforth", "", "GB", "826", "ENG", "H3", "", "", "53.79173", "-1.38067", "Europe/London"),
("2648945", "Gainsborough", "", "GB", "826", "ENG", "H7", "32UH", "", "53.38333", "-0.76667", "Europe/London"),
("2648970", "Fylde", "", "GB", "826", "ENG", "H2", "30UF", "", "53.83333", "-2.91667", "Europe/London"),
("2649024", "Frome", "Фрум", "GB", "826", "ENG", "M3", "40UB", "", "51.22834", "-2.32211", "Europe/London"),
("2649049", "Frinton-on-Sea", "", "GB", "826", "ENG", "E4", "22UN", "", "51.83877", "1.24625", "Europe/London"),
("2649198", "Formby", "", "GB", "826", "ENG", "L8", "00CA010", "", "53.55364", "-3.06816", "Europe/London"),
("2649258", "Folkestone", "Фолкстон", "GB", "826", "ENG", "G5", "6945806", "", "51.08333", "1.18333", "Europe/London"),
("2649312", "Fleetwood", "", "GB", "826", "ENG", "H2", "30UQ", "", "53.92527", "-3.01085", "Europe/London"),
("2649322", "Fleet", "", "GB", "826", "ENG", "F2", "24UG", "", "51.28333", "-0.83333", "Europe/London"),
("2649571", "Feltham", "", "GB", "826", "ENG", "GLA", "G1", "", "51.4462", "-0.41388", "Europe/London"),
("2649578", "Felling", "", "GB", "826", "ENG", "E5", "00CH002", "", "54.95297", "-1.57152", "Europe/London"),
("2649579", "Felixstowe", "Филикстоу", "GB", "826", "ENG", "N5", "42UG", "", "51.96375", "1.3511", "Europe/London"),
("2649622", "Faversham", "", "GB", "826", "ENG", "G5", "29UM", "", "51.3148", "0.88856", "Europe/London"),
("2649650", "Farnworth", "", "GB", "826", "ENG", "B1", "", "", "53.55", "-2.4", "Europe/London"),
("2649660", "Farnham", "", "GB", "826", "ENG", "N7", "43UL", "", "51.21433", "-0.79587", "Europe/London"),
("2649672", "Farnborough", "Фарнборо", "GB", "826", "ENG", "F2", "24UL", "", "51.29424", "-0.75565", "Europe/London"),
("2649692", "Fareham", "", "GB", "826", "ENG", "F2", "24UE", "", "50.85162", "-1.17929", "Europe/London"),
("2649715", "Falmouth", "Фалмут", "GB", "826", "ENG", "C6", "00HE035", "", "50.15441", "-5.07113", "Europe/London"),
("2649723", "Falkirk", "Фалкирк", "GB", "826", "SCT", "U9", "", "", "55.99917", "-3.78713", "Europe/London"),
("2649800", "Exmouth", "Эксмут", "GB", "826", "ENG", "D4", "18UB", "", "50.61723", "-3.40233", "Europe/London"),
("2649808", "Exeter", "Эксетер", "GB", "826", "ENG", "D4", "18UC", "", "50.7236", "-3.52751", "Europe/London"),
("2649833", "Evesham", "", "GB", "826", "ENG", "Q4", "47UF", "", "52.09237", "-1.94887", "Europe/London"),
("2649911", "Esher", "Эшер", "GB", "826", "ENG", "N7", "43UB", "", "51.36926", "-0.36572", "Europe/London"),
("2649957", "Epsom", "Эпсом", "GB", "826", "ENG", "N7", "43UC", "", "51.3305", "-0.27011", "Europe/London"),
("2650004", "Emsworth", "", "GB", "826", "ENG", "F2", "24UH", "", "50.84779", "-0.93697", "Europe/London"),
("2650096", "Ellesmere Port", "", "GB", "826", "ENG", "Z8", "00EW100", "", "53.27875", "-2.90134", "Europe/London"),
("2650122", "Elgin", "Элгин", "GB", "826", "SCT", "V6", "", "", "57.65", "-3.33333", "Europe/London"),
("2650188", "Egham", "Эгхем", "GB", "826", "ENG", "N7", "43UG", "", "51.43158", "-0.55239", "Europe/London"),
("2650225", "Edinburgh", "Эдинбург", "GB", "826", "SCT", "U8", "", "", "55.95206", "-3.19648", "Europe/London"),
("2650278", "Eccles", "", "GB", "826", "ENG", "L5", "", "", "53.48333", "-2.33333", "Europe/London"),
("2650285", "Ebbw Vale", "", "GB", "826", "WLS", "X2", "00PL005", "", "51.77714", "-3.20792", "Europe/London"),
("2650309", "Eastwood", "", "GB", "826", "ENG", "J9", "37UD", "", "53", "-1.3", "Europe/London"),
("2650346", "Retford", "", "GB", "826", "ENG", "J9", "37UC", "", "53.32213", "-0.94315", "Europe/London"),
("2650376", "East Molesey", "", "GB", "826", "ENG", "N7", "43UB", "", "51.39872", "-0.34916", "Europe/London"),
("2650396", "Eastleigh", "", "GB", "826", "ENG", "F2", "24UD", "", "50.96667", "-1.35", "Europe/London"),
("2650405", "East Kilbride", "", "GB", "826", "SCT", "W5", "", "", "55.76412", "-4.17669", "Europe/London"),
("2650435", "East Grinstead", "", "GB", "826", "ENG", "P6", "45UG", "", "51.12382", "-0.0061", "Europe/London"),
("2650470", "East Dereham", "", "GB", "826", "ENG", "I9", "33UB", "", "52.68333", "0.93333", "Europe/London"),
("2650497", "Eastbourne", "Истборн", "GB", "826", "ENG", "E2", "21UC", "", "50.76871", "0.28453", "Europe/London"),
("2650628", "Durham", "Дарем", "GB", "826", "ENG", "D8", "", "", "54.77676", "-1.57566", "Europe/London"),
("2650657", "Dunstable", "", "GB", "826", "ENG", "Z6", "00KC018", "", "51.886", "-0.52099", "Europe/London"),
("2650732", "Dunfermline", "Данфермлин", "GB", "826", "SCT", "V1", "", "", "56.07156", "-3.45887", "Europe/London"),
("2650752", "Dundee", "Данди", "GB", "826", "SCT", "U3", "", "", "56.46913", "-2.97489", "Europe/London"),
("2650802", "Dumbarton", "Дамбартон", "GB", "826", "SCT", "W7", "", "", "55.94433", "-4.57061", "Europe/London"),
("2650815", "Dukinfield", "", "GB", "826", "ENG", "O1", "", "", "53.47497", "-2.08809", "Europe/London"),
("2650839", "Dudley", "Дадли", "GB", "826", "ENG", "D7", "", "", "52.5", "-2.08333", "Europe/London"),
("2650962", "Droylsden", "", "GB", "826", "ENG", "O1", "00BS001", "", "53.48005", "-2.14543", "Europe/London"),
("2650967", "Dronfield", "", "GB", "826", "ENG", "D3", "17UJ", "", "53.30221", "-1.47507", "Europe/London"),
("2650983", "Droitwich", "", "GB", "826", "ENG", "Q4", "47UF", "", "52.26667", "-2.15", "Europe/London"),
("2651048", "Dover", "Дувр", "GB", "826", "ENG", "G5", "29UE", "", "51.13333", "1.3", "Europe/London"),
("2651095", "Dorking", "Доркинг", "GB", "826", "ENG", "N7", "43UE", "", "51.2329", "-0.32942", "Europe/London"),
("2651101", "Dorchester", "Дорчестер", "GB", "826", "ENG", "D6", "19UH", "", "50.71667", "-2.43333", "Europe/London"),
("2651123", "Doncaster", "Донкастер", "GB", "826", "ENG", "D5", "", "", "53.52327", "-1.13691", "Europe/London"),
("2651269", "Didcot", "Дидкот", "GB", "826", "ENG", "K2", "38UD", "", "51.60928", "-1.24214", "Europe/London"),
("2651286", "Dewsbury", "Дьюсбери", "GB", "826", "ENG", "G8", "", "", "53.69076", "-1.62907", "Europe/London"),
("2651347", "Derby", "Дерби", "GB", "826", "ENG", "D2", "", "", "52.92277", "-1.47663", "Europe/London"),
("2651357", "Denton", "", "GB", "826", "ENG", "O1", "", "", "53.45678", "-2.11822", "Europe/London"),
("2651468", "Deal", "", "GB", "826", "ENG", "G5", "29UE", "", "51.22322", "1.40432", "Europe/London"),
("2651485", "Daventry", "Давентри", "GB", "826", "ENG", "J1", "34UC", "", "52.25688", "-1.16066", "Europe/London"),
("2651495", "Darwen", "Дарвен", "GB", "826", "ENG", "A8", "00EX001", "", "53.69803", "-2.46494", "Europe/London"),
("2651497", "Darton", "", "GB", "826", "ENG", "A3", "", "", "53.58705", "-1.52676", "Europe/London"),
("2651500", "Dartford", "Дартфорде", "GB", "826", "ENG", "G5", "29UD", "", "51.44352", "0.21964", "Europe/London"),
("2651513", "Darlington", "Дарлингтон", "GB", "826", "ENG", "D1", "00EH013", "", "54.52429", "-1.55039", "Europe/London"),
("2651558", "Dalserf", "", "GB", "826", "SCT", "W5", "", "", "55.73333", "-3.91667", "Europe/London"),
("2651621", "Dagenham", "", "GB", "826", "ENG", "GLA", "A1", "", "51.55", "0.16667", "Europe/London"),
("2651654", "Cwmbran", "", "GB", "826", "WLS", "Z2", "00PM004", "", "51.65446", "-3.02281", "Europe/London"),
("2651715", "Cumbernauld", "", "GB", "826", "SCT", "V8", "", "", "55.94685", "-3.99051", "Europe/London"),
("2651831", "Crowthorne", "", "GB", "826", "ENG", "B3", "00MA003", "", "51.37027", "-0.79219", "Europe/London"),
("2651852", "Crowborough", "", "GB", "826", "ENG", "E2", "21UH", "", "51.06044", "0.16171", "Europe/London"),
("2652002", "Crewe", "Кру", "GB", "826", "ENG", "Z7", "00EQ114", "", "53.09787", "-2.44161", "Europe/London"),
("2652053", "Crawley", "Кроули", "GB", "826", "ENG", "P6", "45UE", "", "51.11303", "-0.18312", "Europe/London"),
("2652095", "Cramlington", "Крамлингтон", "GB", "826", "ENG", "J6", "00EM166", "", "55.08652", "-1.58598", "Europe/London"),
("2652191", "Cowley", "", "GB", "826", "ENG", "K2", "38UC", "", "51.73139", "-1.20742", "Europe/London"),
("2652204", "Cowes", "Каус", "GB", "826", "ENG", "G2", "00MW007", "", "50.76306", "-1.29772", "Europe/London"),
("2652221", "Coventry", "Ковентри", "GB", "826", "ENG", "C7", "", "", "52.40656", "-1.51217", "Europe/London"),
("2652249", "Coulsdon", "", "GB", "826", "ENG", "GLA", "C8", "", "51.32002", "-0.14088", "Europe/London"),
("2652381", "Corby", "Корби", "GB", "826", "ENG", "J1", "34UB", "", "52.49637", "-0.68939", "Europe/London"),
("2652437", "Consett", "Консетт", "GB", "826", "ENG", "D8", "00EJ053", "", "54.85404", "-1.8316", "Europe/London"),
("2652458", "Conisbrough", "", "GB", "826", "ENG", "D5", "00CE016", "", "53.48188", "-1.23214", "Europe/London"),
("2652464", "Congleton", "Конглтон", "GB", "826", "ENG", "Z7", "00EQ043", "", "53.16314", "-2.21253", "Europe/London"),
("2652513", "Colwyn Bay", "", "GB", "826", "WLS", "X8", "00NE009", "", "53.29483", "-3.72674", "Europe/London"),
("2652544", "Colne", "", "GB", "826", "ENG", "H2", "30UJ", "", "53.85713", "-2.16851", "Europe/London"),
("2652586", "Coleraine", "Колрэйн", "GB", "826", "NIR", "R6", "", "", "55.13333", "-6.66667", "Europe/London"),
("2652618", "Colchester", "Колчестер", "GB", "826", "ENG", "E4", "22UG", "", "51.88921", "0.90421", "Europe/London"),
("2652622", "Coity", "", "GB", "826", "WLS", "X3", "00PB004", "", "51.522", "-3.55531", "Europe/London"),
("2652689", "Cobham", "", "GB", "826", "ENG", "N7", "43UB", "", "51.32997", "-0.4113", "Europe/London"),
("2652696", "Coatbridge", "Котбридж", "GB", "826", "SCT", "V8", "", "", "55.86216", "-4.02469", "Europe/London"),
("2652698", "Coalville", "", "GB", "826", "ENG", "H5", "6896157", "", "52.72247", "-1.3702", "Europe/London"),
("2652730", "Clydebank", "", "GB", "826", "SCT", "W7", "", "", "55.90137", "-4.4057", "Europe/London"),
("2652734", "Clydach", "", "GB", "826", "WLS", "Z1", "00NX005", "", "51.68333", "-3.9", "Europe/London"),
("2652819", "Clitheroe", "", "GB", "826", "ENG", "H2", "30UL", "", "53.86667", "-2.4", "Europe/London"),
("2652861", "Clevedon", "", "GB", "826", "ENG", "J4", "00HC013", "", "51.44057", "-2.85745", "Europe/London"),
("2652885", "Cleethorpes", "Клитхорпс", "GB", "826", "ENG", "J2", "00FC016", "", "53.56047", "-0.03225", "Europe/London"),
("2652890", "Cleckheaton", "", "GB", "826", "ENG", "G8", "00CZ005", "", "53.72405", "-1.71294", "Europe/London"),
("2652974", "Clacton-on-Sea", "Клактон-он-Си", "GB", "826", "ENG", "E4", "22UN", "", "51.78967", "1.15597", "Europe/London"),
("2652995", "Cirencester", "", "GB", "826", "ENG", "E6", "23UC", "", "51.71708", "-1.96825", "Europe/London"),
("2653075", "Christchurch", "Крайстчерч", "GB", "826", "ENG", "D6", "19UC", "", "50.73306", "-1.77567", "Europe/London"),
("2653086", "Chorley", "", "GB", "826", "ENG", "H2", "30UE", "", "53.65", "-2.61667", "Europe/London"),
("2653123", "Chislehurst", "Чизлхёрст", "GB", "826", "ENG", "GLA", "B8", "", "51.41709", "0.06858", "Europe/London"),
("2653137", "Chipping Sodbury", "", "GB", "826", "ENG", "M6", "00HD034", "", "51.53813", "-2.39379", "Europe/London"),
("2653144", "Chippenham", "Чиппенем", "GB", "826", "ENG", "P8", "00HY056", "", "51.46", "-2.12472", "Europe/London"),
("2653192", "Chichester", "Чичестер", "GB", "826", "ENG", "P6", "45UD", "", "50.83673", "-0.78003", "Europe/London"),
("2653224", "Chester-le-Street", "", "GB", "826", "ENG", "D8", "00EJ084", "", "54.85862", "-1.57408", "Europe/London"),
("2653225", "Chesterfield", "Честерфилд", "GB", "826", "ENG", "D3", "17UD", "", "53.25", "-1.41667", "Europe/London"),
("2653228", "Chester", "Честер", "GB", "826", "ENG", "Z8", "", "", "53.1905", "-2.89189", "Europe/London"),
("2653229", "Chessington", "", "GB", "826", "ENG", "GLA", "G7", "", "51.3624", "-0.30427", "Europe/London"),
("2653232", "Cheshunt", "", "GB", "826", "ENG", "F8", "26UB", "", "51.70791", "-0.03739", "Europe/London"),
("2653235", "Chesham", "", "GB", "826", "ENG", "B9", "11UC", "", "51.7", "-0.6", "Europe/London"),
("2653261", "Cheltenham", "Челтнем", "GB", "826", "ENG", "E6", "23UB", "", "51.9", "-2.08333", "Europe/London"),
("2653265", "Chelsea", "Челси", "GB", "826", "ENG", "GLA", "G4", "", "51.48755", "-0.16936", "Europe/London"),
("2653266", "Chelmsford", "Челмсфорд", "GB", "826", "ENG", "E4", "22UF", "", "51.73575", "0.46958", "Europe/London"),
("2653290", "Cheadle Hulme", "", "GB", "826", "ENG", "N2", "", "", "53.3761", "-2.1897", "Europe/London"),
("2653305", "Chatham", "Чатем", "GB", "826", "ENG", "G5", "", "", "51.37891", "0.52786", "Europe/London"),
("2653353", "Chapletown", "", "GB", "826", "ENG", "L9", "", "", "53.46506", "-1.47217", "Europe/London"),
("2653379", "Chandlers Ford", "", "GB", "826", "ENG", "F2", "24UD", "", "51.01219", "-1.38136", "Europe/London"),
("2653393", "Chalfont Saint Peter", "", "GB", "826", "ENG", "B9", "11UC", "", "51.60885", "-0.55618", "Europe/London"),
("2653520", "Caterham", "", "GB", "826", "ENG", "N7", "43UK", "", "51.2823", "-0.07889", "Europe/London"),
("2653558", "Castlereagh", "", "GB", "826", "NIR", "R5", "", "", "54.5735", "-5.88472", "Europe/London"),
("2653584", "Castleford", "", "GB", "826", "ENG", "O7", "", "", "53.72587", "-1.36256", "Europe/London"),
("2653646", "Carshalton", "", "GB", "826", "ENG", "GLA", "N8", "", "51.36829", "-0.16755", "Europe/London"),
("2653680", "Carrickfergus", "Каррикфергус", "GB", "826", "NIR", "R4", "", "", "54.7158", "-5.8058", "Europe/London"),
("2653755", "Carmarthen", "Кармартен", "GB", "826", "WLS", "X7", "00NU006", "", "51.85552", "-4.30535", "Europe/London"),
("2653775", "Carlisle", "Карлайл", "GB", "826", "ENG", "C9", "16UD", "", "54.8951", "-2.9382", "Europe/London"),
("2653822", "Cardiff", "Кардифф", "GB", "826", "WLS", "X5", "", "", "51.48", "-3.18", "Europe/London"),
("2653877", "Canterbury", "Кентербери", "GB", "826", "ENG", "G5", "6945807", "", "51.27904", "1.07992", "Europe/London"),
("2653883", "Cannock", "Каннок", "GB", "826", "ENG", "M9", "41UB", "", "52.69045", "-2.03085", "Europe/London"),
("2653941", "Cambridge", "Кембридж", "GB", "826", "ENG", "C3", "12UB", "", "52.2", "0.11667", "Europe/London"),
("2653945", "Camborne", "", "GB", "826", "ENG", "C6", "00HE015", "", "50.21306", "-5.29731", "Europe/London"),
("2653947", "Camberley", "Кемберли", "GB", "826", "ENG", "N7", "43UJ", "", "51.33705", "-0.74261", "Europe/London"),
("2654089", "Caerphilly", "Керфили", "GB", "826", "WLS", "X4", "00PK007", "", "51.57452", "-3.218", "Europe/London"),
("2654141", "Buxton", "", "GB", "826", "ENG", "D3", "17UH", "", "53.25741", "-1.90982", "Europe/London"),
("2654179", "Bushey", "", "GB", "826", "ENG", "F8", "26UE", "", "51.64316", "-0.36053", "Europe/London"),
("2654186", "Bury St Edmunds", "Бери-Сент-Эдмендс", "GB", "826", "ENG", "N5", "42UF", "", "52.2463", "0.71111", "Europe/London"),
("2654187", "Bury", "Бери", "GB", "826", "ENG", "C1", "", "", "53.6", "-2.3", "Europe/London"),
("2654200", "Burton upon Trent", "Бертон-апон-Трент", "GB", "826", "ENG", "M9", "41UC", "", "52.80728", "-1.64263", "Europe/London"),
("2654252", "Burntwood", "", "GB", "826", "ENG", "M9", "41UD", "", "52.68075", "-1.92759", "Europe/London"),
("2654264", "Burnley", "Бернли", "GB", "826", "ENG", "H2", "30UD", "", "53.8", "-2.23333", "Europe/London"),
("2654269", "Burnham-on-Sea", "", "GB", "826", "ENG", "M3", "40UC", "", "51.23862", "-2.9978", "Europe/London"),
("2654308", "Burgess Hill", "", "GB", "826", "ENG", "P6", "45UG", "", "50.95843", "-0.13287", "Europe/London"),
("2654394", "Buckley", "", "GB", "826", "WLS", "Y1", "00NJ004", "", "53.16667", "-3.08333", "Europe/London"),
("2654415", "Buckhaven", "", "GB", "826", "SCT", "V1", "", "", "56.17149", "-3.03377", "Europe/London"),
("2654450", "Brymbo", "", "GB", "826", "WLS", "Z4", "00NL006", "", "53.06667", "-3.06667", "Europe/London"),
("2654490", "Brownhills", "Браунхиллс", "GB", "826", "ENG", "O8", "", "", "52.63333", "-1.93333", "Europe/London"),
("2654579", "Bromsgrove", "", "GB", "826", "ENG", "Q4", "47UB", "", "52.33574", "-2.05983", "Europe/London"),
("2654635", "Broadstairs", "", "GB", "826", "ENG", "G5", "2636057", "", "51.35908", "1.43938", "Europe/London"),
("2654663", "Brixham", "", "GB", "826", "ENG", "O4", "00HH001", "", "50.39431", "-3.51585", "Europe/London"),
("2654668", "Briton Ferry", "", "GB", "826", "WLS", "Y5", "00NZ006", "", "51.63106", "-3.81898", "Europe/London"),
("2654675", "Bristol", "Бристоль", "GB", "826", "ENG", "B7", "", "", "51.45523", "-2.59665", "Europe/London"),
("2654710", "Brighton", "Брайтон", "GB", "826", "ENG", "B6", "", "", "50.82838", "-0.13947", "Europe/London"),
("2654715", "Brighouse", "", "GB", "826", "ENG", "C2", "00CZ003", "", "53.70322", "-1.78428", "Europe/London"),
("2654724", "Brierley Hill", "", "GB", "826", "ENG", "D7", "", "", "52.48173", "-2.12139", "Europe/London"),
("2654728", "Bridlington", "", "GB", "826", "ENG", "E1", "00FB169", "", "54.08306", "-0.19192", "Europe/London"),
("2654730", "Bridgwater", "Бриджуотер", "GB", "826", "ENG", "M3", "40UC", "", "51.12837", "-3.00356", "Europe/London"),
("2654755", "Bridgend", "Бридженд", "GB", "826", "WLS", "X3", "", "", "51.50583", "-3.57722", "Europe/London"),
("2654782", "Brentwood", "Брентвуд", "GB", "826", "ENG", "E4", "22UD", "", "51.62127", "0.30556", "Europe/London"),
("2654814", "Bredbury", "", "GB", "826", "ENG", "N2", "", "", "53.41667", "-2.11667", "Europe/London"),
("2654927", "Bramhall", "", "GB", "826", "ENG", "N2", "00EQ107", "", "53.35801", "-2.16539", "Europe/London"),
("2654938", "Braintree", "", "GB", "826", "ENG", "E4", "22UC", "", "51.87819", "0.55292", "Europe/London"),
("2654993", "Bradford", "Брадфорд", "GB", "826", "ENG", "B4", "", "", "53.79391", "-1.75206", "Europe/London"),
("2655009", "Bracknell", "", "GB", "826", "ENG", "B3", "00MA002", "", "51.41363", "-0.75054", "Europe/London"),
("2655095", "Bournemouth", "Борнмут", "GB", "826", "ENG", "B2", "19UC", "", "50.72048", "-1.8795", "Europe/London"),
("2655138", "Boston", "Бостон", "GB", "826", "ENG", "H7", "32UB", "", "52.97633", "-0.02664", "Europe/London"),
("2655186", "Borehamwood", "", "GB", "826", "ENG", "F8", "26UE", "", "51.65468", "-0.27762", "Europe/London"),
("2655198", "Bootle", "Бутл", "GB", "826", "ENG", "L8", "", "", "53.46667", "-3.01667", "Europe/London"),
("2655237", "Bolton", "Болтон", "GB", "826", "ENG", "B1", "", "", "53.58333", "-2.43333", "Europe/London"),
("2655262", "Bognor Regis", "", "GB", "826", "ENG", "P6", "45UC", "", "50.78206", "-0.67978", "Europe/London"),
("2655315", "Blyth", "Блит", "GB", "826", "ENG", "J6", "00EM165", "", "55.12708", "-1.50856", "Europe/London"),
("2655329", "Bloxwich", "", "GB", "826", "ENG", "O8", "41UF", "", "52.61806", "-2.00431", "Europe/London"),
("2655351", "Bletchley", "", "GB", "826", "ENG", "B9", "", "", "51.99334", "-0.73471", "Europe/London"),
("2655459", "Blackpool", "Блэкпул", "GB", "826", "ENG", "A9", "", "", "53.81667", "-3.05", "Europe/London"),
("2655524", "Blackburn", "Блэкберн", "GB", "826", "ENG", "A8", "", "", "53.75", "-2.48333", "Europe/London"),
("2655557", "Bishopstoke", "", "GB", "826", "ENG", "F2", "24UD", "", "50.96643", "-1.32832", "Europe/London"),
("2655562", "Bishops Stortford", "", "GB", "826", "ENG", "F8", "26UD", "", "51.87113", "0.15868", "Europe/London"),
("2655582", "Bishopbriggs", "Бишопбриггс", "GB", "826", "SCT", "U5", "", "", "55.90669", "-4.21869", "Europe/London"),
("2655583", "Bishop Auckland", "Бишоп-Окленд", "GB", "826", "ENG", "D8", "00EJ006", "", "54.65554", "-1.67706", "Europe/London"),
("2655603", "Birmingham", "Бирмингем", "GB", "826", "ENG", "A7", "", "", "52.48142", "-1.89983", "Europe/London"),
("2655613", "Birkenhead", "Биркенхед", "GB", "826", "ENG", "Q1", "00EW114", "", "53.39337", "-3.01479", "Europe/London"),
("2655642", "Bingley", "", "GB", "826", "ENG", "B4", "00CX017", "", "53.84861", "-1.83857", "Europe/London"),
("2655664", "Billingham", "Биллингем", "GB", "826", "ENG", "N3", "00EF019", "", "54.58881", "-1.29034", "Europe/London"),
("2655672", "Billericay", "Биллерикей", "GB", "826", "ENG", "E4", "22UB", "", "51.62867", "0.41963", "Europe/London"),
("2655689", "Biggleswade", "", "GB", "826", "ENG", "Z6", "00KC008", "", "52.08652", "-0.26493", "Europe/London"),
("2655707", "Bideford", "", "GB", "826", "ENG", "D4", "18UK", "", "51.01787", "-4.20458", "Europe/London"),
("2655708", "Biddulph", "", "GB", "826", "ENG", "M9", "41UH", "", "53.11724", "-2.17584", "Europe/London"),
("2655729", "Bicester", "", "GB", "826", "ENG", "K2", "38UB", "", "51.89998", "-1.15357", "Europe/London"),
("2655775", "Bexley", "", "GB", "826", "ENG", "GLA", "A6", "", "51.44162", "0.14866", "Europe/London"),
("2655777", "Bexhill-on-Sea", "", "GB", "826", "ENG", "E2", "21UG", "", "50.85023", "0.47095", "Europe/London"),
("2655785", "Beverley", "", "GB", "826", "ENG", "E1", "", "", "53.84587", "-0.42332", "Europe/London"),
("2655819", "Berwick-Upon-Tweed", "Бервик-апон-Твид", "GB", "826", "ENG", "J6", "", "", "55.78333", "-2", "Europe/London"),
("2655858", "Berkhamsted", "", "GB", "826", "ENG", "F8", "26UC", "26UC002", "51.7604", "-0.56528", "Europe/London"),
("2655882", "Bentley", "", "GB", "826", "ENG", "D5", "", "", "53.53333", "-1.15", "Europe/London"),
("2655942", "Belper", "Белпер", "GB", "826", "ENG", "D3", "17UB", "", "53.0233", "-1.48119", "Europe/London"),
("2655952", "Bellshill", "", "GB", "826", "SCT", "V8", "", "", "55.81667", "-4.01667", "Europe/London"),
("2655984", "Belfast", "Белфаст", "GB", "826", "NIR", "R3", "", "", "54.58333", "-5.93333", "Europe/London"),
("2656031", "Bedworth", "Бедворс", "GB", "826", "ENG", "P3", "44UC", "", "52.4791", "-1.46909", "Europe/London"),
("2656039", "Bedlington", "", "GB", "826", "ENG", "J6", "", "", "55.13061", "-1.59319", "Europe/London"),
("2656046", "Bedford", "Бедфорд", "GB", "826", "ENG", "Z5", "", "", "52.13459", "-0.46632", "Europe/London"),
("2656065", "Beckenham", "", "GB", "826", "ENG", "GLA", "B8", "", "51.40878", "-0.02526", "Europe/London"),
("2656070", "Bebington", "", "GB", "826", "ENG", "Q1", "", "", "53.35", "-3.01667", "Europe/London"),
("2656086", "Bearsden", "Берсден", "GB", "826", "SCT", "U5", "", "", "55.91536", "-4.33279", "Europe/London"),
("2656168", "Batley", "", "GB", "826", "ENG", "G8", "", "", "53.70291", "-1.6337", "Europe/London"),
("2656169", "Bathgate", "", "GB", "826", "SCT", "W9", "", "", "55.90204", "-3.64398", "Europe/London"),
("2656173", "Bath", "Бат", "GB", "826", "ENG", "A4", "", "", "51.3751", "-2.36172", "Europe/London"),
("2656192", "Basingstoke", "", "GB", "826", "ENG", "F2", "24UB", "", "51.26249", "-1.08708", "Europe/London"),
("2656194", "Basildon", "Басилдон", "GB", "826", "ENG", "E4", "22UB", "", "51.56844", "0.45782", "Europe/London"),
("2656235", "Barry", "Барри", "GB", "826", "WLS", "Z3", "", "", "51.40667", "-3.26944", "Europe/London"),
("2656241", "Barrow-in-Furness", "", "GB", "826", "ENG", "C9", "16UC", "", "54.11094", "-3.22758", "Europe/London"),
("2656258", "Barrhead", "Баррхед", "GB", "826", "SCT", "U7", "", "", "55.79916", "-4.39285", "Europe/London"),
("2656281", "Barnstaple", "Барнстапл", "GB", "826", "ENG", "D4", "18UE", "", "51.08022", "-4.05808", "Europe/London"),
("2656284", "Barnsley", "Барнсли", "GB", "826", "ENG", "A3", "", "", "53.55", "-1.48333", "Europe/London"),
("2656295", "Barnet", "Барнет", "GB", "826", "ENG", "GLA", "A2", "", "51.65", "-0.2", "Europe/London"),
("2656333", "Barking", "", "GB", "826", "ENG", "GLA", "A1", "", "51.53333", "0.08333", "Europe/London"),
("2656379", "Banstead", "", "GB", "826", "ENG", "N7", "43UF", "", "51.32503", "-0.19569", "Europe/London"),
("2656396", "Bangor", "Бангор", "GB", "826", "NIR", "T2", "", "", "54.65338", "-5.66895", "Europe/London"),
("2656397", "Bangor", "Бангор", "GB", "826", "WLS", "Y2", "00NC006", "", "53.22647", "-4.13459", "Europe/London"),
("2656406", "Banbury", "Банбери", "GB", "826", "ENG", "K2", "38UB", "", "52.0602", "-1.34029", "Europe/London"),
("2656407", "Banbridge", "Банбридж", "GB", "826", "NIR", "R2", "", "", "54.35", "-6.28333", "Europe/London"),
("2656490", "Ballymena", "Бэллимена", "GB", "826", "NIR", "Q9", "", "", "54.86357", "-6.27628", "Europe/London"),
("2656627", "Baildon", "", "GB", "826", "ENG", "B4", "00CX016", "", "53.84711", "-1.78785", "Europe/London"),
("2656708", "Ayr", "Эр", "GB", "826", "SCT", "W4", "", "", "55.46273", "-4.63393", "Europe/London"),
("2656719", "Aylesbury", "Эйлсбери", "GB", "826", "ENG", "B9", "11UB", "", "51.81665", "-0.81458", "Europe/London"),
("2656847", "Atherton", "", "GB", "826", "ENG", "P7", "00BL003", "", "53.52371", "-2.49354", "Europe/London"),
("2656915", "Ashton-under-Lyne", "Эштон-андер-Лайн", "GB", "826", "ENG", "O1", "", "", "53.48876", "-2.0989", "Europe/London"),
("2656918", "Ashton in Makerfield", "", "GB", "826", "ENG", "P7", "", "", "53.48333", "-2.65", "Europe/London"),
("2656955", "Ashford", "Эшфорд", "GB", "826", "ENG", "G5", "29UB", "", "51.14586", "0.87281", "Europe/London"),
("2656992", "Ascot", "Аскот", "GB", "826", "ENG", "P9", "", "", "51.41082", "-0.6748", "Europe/London"),
("2657030", "Arnold", "Арнольд", "GB", "826", "ENG", "J9", "37UE", "", "53", "-1.13333", "Europe/London"),
("2657215", "Arbroath", "Арброт", "GB", "826", "SCT", "T7", "", "", "56.56317", "-2.58736", "Europe/London"),
("2657255", "Antrim", "Антрим", "GB", "826", "NIR", "Q6", "", "", "54.7", "-6.2", "Europe/London"),
("2657324", "Andover", "Андовер", "GB", "826", "ENG", "F2", "24UN", "", "51.20828", "-1.48246", "Europe/London"),
("2657356", "Amersham", "Амершам", "GB", "826", "ENG", "B9", "11UC", "", "51.66667", "-0.61667", "Europe/London"),
("2657402", "Altrincham", "", "GB", "826", "ENG", "O6", "00EQ008", "", "53.38752", "-2.34848", "Europe/London"),
("2657408", "Alton", "", "GB", "826", "ENG", "F2", "24UC", "", "51.14931", "-0.97469", "Europe/London"),
("2657471", "Alloa", "Аллоа", "GB", "826", "SCT", "U1", "", "", "56.11586", "-3.78997", "Europe/London"),
("2657508", "Alfreton", "Алфретон", "GB", "826", "ENG", "D3", "17UB", "", "53.0961", "-1.38832", "Europe/London"),
("2657528", "Aldridge", "", "GB", "826", "ENG", "O8", "41UD", "", "52.60549", "-1.91715", "Europe/London"),
("2657540", "Aldershot", "Олдершот", "GB", "826", "ENG", "F2", "24UL", "", "51.24827", "-0.76389", "Europe/London"),
("2657613", "Airdrie", "", "GB", "826", "SCT", "V8", "", "", "55.86602", "-3.98025", "Europe/London"),
("2657697", "Acton", "", "GB", "826", "ENG", "GLA", "D9", "", "51.50901", "-0.2762", "Europe/London"),
("2657703", "Acocks Green", "", "GB", "826", "ENG", "A7", "", "", "52.45", "-1.81667", "Europe/London"),
("2657770", "Accrington", "Аккрингтон", "GB", "826", "ENG", "H2", "30UG", "", "53.75379", "-2.35863", "Europe/London"),
("2657780", "Abingdon", "Абингдон", "GB", "826", "ENG", "K2", "38UE", "", "51.67109", "-1.28278", "Europe/London"),
("2657782", "Aberystwyth", "Аберистуит", "GB", "826", "WLS", "X6", "00NQ003", "", "52.41548", "-4.08292", "Europe/London"),
("2657812", "Abergele", "Абергеле", "GB", "826", "WLS", "X8", "00NE001", "", "53.28436", "-3.5822", "Europe/London"),
("2657832", "Aberdeen", "Абердин", "GB", "826", "SCT", "T5", "", "", "57.14369", "-2.09814", "Europe/London"),
("2657835", "Aberdare", "Абердэйр", "GB", "826", "WLS", "Y9", "00PF003", "", "51.71438", "-3.44918", "Europe/London"),
("3209584", "Crosby", "", "GB", "826", "ENG", "L8", "", "", "53.47778", "-3.03333", "Europe/London"),
("3345317", "Blackwood", "", "GB", "826", "WLS", "X4", "00PK006", "", "51.66778", "-3.2075", "Europe/London"),
("3345432", "Neston", "", "GB", "826", "ENG", "P8", "", "", "51.41222", "-2.20056", "Europe/London"),
("3345437", "Camden Town", "", "GB", "826", "ENG", "GLA", "C4", "", "51.54057", "-0.14334", "Europe/London"),
("3345439", "Telford", "Телфорд", "GB", "826", "ENG", "O2", "", "", "52.67659", "-2.44926", "Europe/London"),
("3345440", "Craigavon", "Крейгавон", "GB", "826", "NIR", "R8", "", "", "54.44709", "-6.387", "Europe/London"),
("6545243", "Bayswater", "", "GB", "826", "ENG", "GLA", "P5", "", "51.51116", "-0.18426", "Europe/London"),
("6620293", "Yateley", "", "GB", "826", "ENG", "F2", "24UG", "", "51.34305", "-0.82985", "Europe/London"),
("6620355", "Bowthorpe", "", "GB", "826", "ENG", "I9", "33UG", "", "52.63884", "1.21885", "Europe/London"),
("6620360", "Hedge End", "", "GB", "826", "ENG", "F2", "24UD", "", "50.91234", "-1.30076", "Europe/London"),
("6639623", "Erskine", "", "GB", "826", "SCT", "W2", "", "", "55.9005", "-4.45028", "Europe/London"),
("6640028", "Hale", "", "GB", "826", "ENG", "I2", "", "", "53.37831", "-2.33271", "Europe/London"),
("6690592", "Amersham on the Hill", "", "GB", "826", "ENG", "B9", "11UC", "", "51.67468", "-0.60742", "Europe/London"),
("6690602", "Battersea", "", "GB", "826", "ENG", "GLA", "P1", "", "51.47475", "-0.15547", "Europe/London"),
("6690862", "South Croydon", "", "GB", "826", "ENG", "GLA", "C8", "", "51.36217", "-0.09421", "Europe/London"),
("6690863", "Hornchurch", "", "GB", "826", "ENG", "GLA", "F6", "", "51.55685", "0.21664", "Europe/London"),
("6690866", "Surbiton", "Сурбитон", "GB", "826", "ENG", "GLA", "G7", "", "51.39148", "-0.29825", "Europe/London"),
("6690867", "Ewell", "", "GB", "826", "ENG", "N7", "43UC", "", "51.34948", "-0.2494", "Europe/London"),
("6690870", "Becontree", "", "GB", "826", "ENG", "GLA", "A1", "", "51.5529", "0.129", "Europe/London"),
("6690877", "Brixton", "Брикстон", "GB", "826", "ENG", "GLA", "H1", "", "51.46593", "-0.10652", "Europe/London"),
("6690989", "Bethnal Green", "", "GB", "826", "ENG", "GLA", "O5", "", "51.52718", "-0.06109", "Europe/London"),
("6691219", "Failsworth", "Фэйлзуорт", "GB", "826", "ENG", "I2", "", "", "53.50484", "-2.16568", "Europe/London"),
("6691227", "Radcliffe", "", "GB", "826", "ENG", "C1", "", "", "53.56178", "-2.32455", "Europe/London"),
("6691235", "Heywood", "", "GB", "826", "ENG", "I2", "", "", "53.59245", "-2.21941", "Europe/London"),
("6691766", "Longsight", "", "GB", "826", "ENG", "I2", "", "", "53.45801", "-2.20104", "Europe/London"),
("6691884", "Heavitree", "", "GB", "826", "ENG", "D4", "18UC", "", "50.72044", "-3.49646", "Europe/London"),
("6691927", "Ferndown", "", "GB", "826", "ENG", "D6", "19UD", "", "50.80743", "-1.89975", "Europe/London"),
("6693470", "Lytham St Annes", "", "GB", "826", "ENG", "H2", "30UF", "", "53.7426", "-2.997", "Europe/London"),
("6693771", "Hadley Wood", "", "GB", "826", "ENG", "GLA", "E3", "", "51.66669", "-0.16981", "Europe/London"),
("6695247", "Chapel Allerton", "", "GB", "826", "ENG", "H3", "", "", "53.82901", "-1.53834", "Europe/London"),
("6947041", "Blackheath", "", "GB", "826", "ENG", "GLA", "H6", "", "51.4647", "0.0079", "Europe/London"),
("6947168", "Kempston Hardwick", "", "GB", "826", "ENG", "Z5", "00KB038", "", "52.08956", "-0.49908", "Europe/London"),
("6947756", "Mendip", "", "GB", "826", "ENG", "M3", "40UB", "", "51.2372", "-2.6266", "Europe/London"),
("7290015", "Lower Earley", "", "GB", "826", "ENG", "Q2", "00MF004", "", "51.42708", "-0.91979", "Europe/London"),
("7302130", "Bartley Green", "", "GB", "826", "ENG", "A7", "47UB", "", "52.43532", "-1.99707", "Europe/London"),
("8063096", "Earlsfield", "", "GB", "826", "ENG", "GLA", "P1", "", "51.4439", "-0.1854", "Europe/London"),
("8224216", "Letchworth Garden City", "", "GB", "826", "ENG", "F8", "26UF", "26UF035", "51.97938", "-0.22664", "Europe/London"),
("8224782", "Shirley", "", "GB", "826", "ENG", "M2", "", "", "52.41074", "-1.81952", "Europe/London"),
("8224783", "Stanley", "", "GB", "826", "ENG", "D8", "00EJ110", "", "54.86796", "-1.69846", "Europe/London"),
("8299614", "Rossendale", "", "GB", "826", "ENG", "H2", "30UM", "", "53.68456", "-2.2769", "Europe/London"),
("8299615", "Thornton-Cleveleys", "", "GB", "826", "ENG", "L8", "00CA008", "", "53.87389", "-3.02244", "Europe/London"),
("8299616", "Deeside", "", "GB", "826", "WLS", "Y1", "00NJ030", "", "53.20053", "-3.03841", "Europe/London"),
("8299617", "High Peak", "", "GB", "826", "ENG", "D3", "17UH", "17UH010", "53.36797", "-1.84536", "Europe/London"),
("8299619", "Hayling Island", "", "GB", "826", "ENG", "F2", "24UH", "", "50.7838", "-0.96869", "Europe/London"),
("8299620", "Isle of Lewis", "", "GB", "826", "SCT", "W8", "", "", "58.21901", "-6.38803", "Europe/London"),
("8299621", "Shetland", "", "GB", "826", "SCT", "W3", "", "", "60.15456", "-1.14899", "Europe/London"),
("8299623", "Orkney", "Оркнейские острова", "GB", "826", "SCT", "V9", "", "", "58.98465", "-2.95953", "Europe/London"),
("8315400", "Holloway", "", "GB", "826", "ENG", "GLA", "G3", "", "51.55237", "-0.12497", "Europe/London"),
("8581595", "Harringay", "", "GB", "826", "ENG", "GLA", "F3", "", "51.5824", "-0.09956", "Europe/London"),
("610824", "Zugdidi", "Зугдиди", "GE", "268", "71", "610823", "", "", "42.5088", "41.87088", "Asia/Tbilisi"),
("610864", "Zestap'oni", "Зестафони", "GE", "268", "66", "", "", "", "42.11", "43.0525", "Asia/Tbilisi"),
("611403", "Ts'khinvali", "Цхинвали", "GE", "268", "73", "", "", "", "42.22764", "43.96861", "Asia/Tbilisi"),
("611583", "Tqvarch'eli", "Ткуарчал", "GE", "268", "02", "", "", "", "42.84035", "41.68007", "Asia/Tbilisi"),
("611694", "Telavi", "Телави", "GE", "268", "67", "7667581", "", "", "41.91978", "45.47315", "Asia/Tbilisi"),
("611717", "Tbilisi", "Тбилиси", "GE", "268", "51", "", "", "", "41.69411", "44.83368", "Asia/Tbilisi"),
("611847", "Sokhumi", "Сухум", "GE", "268", "02", "", "", "", "43.00697", "40.9893", "Asia/Tbilisi"),
("612053", "Senak'i", "Сенаки", "GE", "268", "71", "", "", "", "42.27042", "42.0675", "Asia/Tbilisi"),
("612126", "Samtredia", "Самтредиа", "GE", "268", "66", "", "", "", "42.1537", "42.33517", "Asia/Tbilisi"),
("612287", "Rust'avi", "Рустави", "GE", "268", "68", "", "", "", "41.54949", "44.99323", "Asia/Tbilisi"),
("612366", "P'ot'i", "Поти", "GE", "268", "71", "", "", "", "42.14616", "41.67197", "Asia/Tbilisi"),
("612536", "Ozurgeti", "Озургети", "GE", "268", "65", "", "", "", "41.92442", "42.00682", "Asia/Tbilisi"),
("612652", "Och'amch'ire", "Очамчира", "GE", "268", "02", "", "", "", "42.71232", "41.46863", "Asia/Tbilisi"),
("613074", "Marneuli", "Марнеули", "GE", "268", "68", "7667578", "", "", "41.47588", "44.80894", "Asia/Tbilisi"),
("613607", "K'ut'aisi", "Кутаиси", "GE", "268", "66", "", "", "", "42.26791", "42.69459", "Asia/Tbilisi"),
("613762", "Kobuleti", "Кобулети", "GE", "268", "04", "", "", "", "41.82", "41.77528", "Asia/Tbilisi"),
("613988", "Khashuri", "Хашури", "GE", "268", "73", "613987", "", "", "41.99414", "43.59994", "Asia/Tbilisi"),
("614455", "Gori", "Гори", "GE", "268", "73", "", "", "", "41.98422", "44.11578", "Asia/Tbilisi"),
("615532", "Batumi", "Батуми", "GE", "268", "04", "", "", "", "41.64228", "41.63392", "Asia/Tbilisi"),
("615860", "Akhaltsikhe", "Ахалцихе", "GE", "268", "72", "", "", "", "41.63901", "42.98262", "Asia/Tbilisi"),
("615912", "Stantsiya Novyy Afon", "Новый Афон", "GE", "268", "02", "", "", "", "43.08056", "40.83833", "Asia/Tbilisi"),
("824288", "Tsqaltubo", "Цхалтубо", "GE", "268", "66", "", "", "", "42.34129", "42.5976", "Asia/Tbilisi"),
("3421319", "Nuuk", "Нуук", "GL", "304", "07", "", "", "", "64.18347", "-51.72157", "America/Godthab"),
("2414545", "Tougue", "", "GN", "324", "L", "28", "", "", "11.45", "-11.68333", "Africa/Conakry"),
("2414926", "Telimele", "", "GN", "324", "D", "27", "", "", "10.9", "-13.03333", "Africa/Conakry"),
("2415703", "Siguiri", "Сигири", "GN", "324", "K", "39", "", "", "11.42282", "-9.16852", "Africa/Conakry"),
("2416443", "Pita", "", "GN", "324", "M", "25", "", "", "11.08333", "-12.4", "Africa/Conakry"),
("2416969", "Nzerekore", "Нзерекоре", "GN", "324", "N", "38", "", "", "7.75624", "-8.8179", "Africa/Conakry"),
("2417833", "Mamou", "", "GN", "324", "M", "23", "", "", "10.37546", "-12.09148", "Africa/Conakry"),
("2417988", "Macenta", "Масента", "GN", "324", "N", "21", "", "", "8.54351", "-9.47099", "Africa/Conakry"),
("2418362", "Labe", "Лаба", "GN", "324", "L", "34", "", "", "11.31823", "-12.28332", "Africa/Conakry"),
("2419472", "Kissidougou", "Кисидугу", "GN", "324", "F", "17", "", "", "9.1848", "-10.09987", "Africa/Conakry"),
("2419533", "Kindia", "Киндиа", "GN", "324", "D", "16", "", "", "10.05692", "-12.86576", "Africa/Conakry"),
("2419992", "Kankan", "", "GN", "324", "K", "32", "", "", "10.38542", "-9.30568", "Africa/Conakry"),
("2420056", "Kamsar", "Комсар", "GN", "324", "B", "03", "", "", "10.66667", "-14.6", "Africa/Conakry"),
("2420562", "Gueckedou", "", "GN", "324", "N", "13", "", "", "8.56744", "-10.1336", "Africa/Conakry"),
("2420884", "Fria", "Фриа", "GN", "324", "B", "11", "", "", "10.45", "-13.53333", "Africa/Conakry"),
("2422457", "Coyah", "", "GN", "324", "D", "30", "", "", "9.70556", "-13.37694", "Africa/Conakry"),
("2422465", "Conakry", "Конакри", "GN", "324", "04", "", "", "", "9.53795", "-13.67729", "Africa/Conakry"),
("2422488", "Camayenne", "", "GN", "324", "04", "", "", "", "9.535", "-13.68778", "Africa/Conakry"),
("2422924", "Boke", "", "GN", "324", "B", "03", "", "", "10.94094", "-14.29665", "Africa/Conakry"),
("2309332", "Ebebiyin", "Эбебьин", "GQ", "226", "07", "", "", "", "2.15106", "11.33528", "Africa/Malabo"),
("2309527", "Malabo", "Малабо", "GQ", "226", "04", "", "", "", "3.75", "8.78333", "Africa/Malabo"),
("2310046", "Bata", "Бата", "GQ", "226", "08", "", "", "", "1.86391", "9.76582", "Africa/Malabo"),
("251780", "Voula", "Вуле", "GR", "300", "ESYE31", "445406", "9216", "", "37.84221", "23.77651", "Europe/Athens"),
("251833", "Volos", "", "GR", "300", "ESYE14", "24", "9105", "", "39.36667", "22.94583", "Europe/Athens"),
("251948", "Vyronas", "", "GR", "300", "ESYE31", "445408", "9186", "", "37.96105", "23.753", "Europe/Athens"),
("252601", "Tripoli", "Триполи", "GR", "300", "ESYE25", "41", "9241", "", "37.50889", "22.37944", "Europe/Athens"),
("252664", "Trikala", "Трикала", "GR", "300", "ESYE14", "22", "9114", "", "39.55528", "21.7675", "Europe/Athens"),
("252910", "Thivai", "", "GR", "300", "ESYE24", "33", "9144", "", "38.325", "23.31889", "Europe/Athens"),
("253394", "Sparti", "", "GR", "300", "ESYE25", "42", "9252", "", "37.07333", "22.42972", "Europe/Athens"),
("254144", "Salamis", "Саламина", "GR", "300", "ESYE31", "406101", "9211", "", "37.96427", "23.49649", "Europe/Athens"),
("254352", "Rethymno", "Ретимнон", "GR", "300", "ESYE43", "44", "9318", "", "35.36687", "24.47487", "Europe/Athens"),
("254698", "Preveza", "", "GR", "300", "ESYE21", "19", "9090", "", "38.95617", "20.7505", "Europe/Athens"),
("255229", "Pyrgos", "Пиргос", "GR", "300", "ESYE23", "39", "9141", "", "37.67513", "21.44102", "Europe/Athens"),
("255274", "Piraeus", "Пирей", "GR", "300", "ESYE31", "35", "", "", "37.94745", "23.63708", "Europe/Athens"),
("255377", "Petroupolis", "Петроуполис", "GR", "300", "ESYE31", "445408", "9184", "", "38.04187", "23.68494", "Europe/Athens"),
("255524", "Peristeri", "Перистерион", "GR", "300", "ESYE31", "445408", "9183", "", "38.01667", "23.7", "Europe/Athens"),
("255588", "Perama", "Перама", "GR", "300", "ESYE31", "406101", "9206", "", "37.96775", "23.5721", "Europe/Athens"),
("255683", "Patra", "", "GR", "300", "ESYE23", "38", "9134", "", "38.24444", "21.73444", "Europe/Athens"),
("256075", "Palaio Faliro", "", "GR", "300", "ESYE31", "445408", "9201", "", "37.92066", "23.70916", "Europe/Athens"),
("256429", "Nikaia", "", "GR", "300", "ESYE31", "406101", "9204", "", "37.96667", "23.65", "Europe/Athens"),
("256575", "Nea Smyrni", "", "GR", "300", "ESYE31", "445408", "9200", "", "37.94504", "23.71416", "Europe/Athens"),
("256598", "Nea Makri", "", "GR", "300", "ESYE31", "445406", "9220", "", "38.08733", "23.97642", "Europe/Athens"),
("256601", "Ilion", "", "GR", "300", "ESYE31", "445408", "9182", "", "38.03333", "23.7", "Europe/Athens"),
("256614", "Nea Ionia", "", "GR", "300", "ESYE31", "445408", "9174", "", "38.03333", "23.75", "Europe/Athens"),
("256621", "Nea Filadelfeia", "", "GR", "300", "ESYE31", "445408", "9193", "", "38.03333", "23.73333", "Europe/Athens"),
("256622", "Nea Erythraia", "", "GR", "300", "ESYE31", "445408", "9171", "", "38.1", "23.81667", "Europe/Athens"),
("256750", "Moskhaton", "", "GR", "300", "ESYE31", "406101", "9205", "", "37.94718", "23.67708", "Europe/Athens"),
("256866", "Mytilini", "Митилини", "GR", "300", "ESYE41", "51", "9261", "", "39.11", "26.55472", "Europe/Athens"),
("257302", "Melissia", "Мелиссия", "GR", "300", "ESYE31", "445408", "9176", "", "38.05", "23.83333", "Europe/Athens"),
("257365", "Megara", "Мегара", "GR", "300", "ESYE31", "445407", "9231", "", "37.99471", "23.34324", "Europe/Athens"),
("258038", "Artemida", "", "GR", "300", "ESYE31", "445406", "9226", "", "37.96667", "24", "Europe/Athens"),
("258463", "Livadeia", "Левадия", "GR", "300", "ESYE24", "33", "9145", "", "38.435", "22.87389", "Europe/Athens"),
("258576", "Larisa", "Лариса", "GR", "300", "ESYE14", "21", "9100", "", "39.63722", "22.42028", "Europe/Athens"),
("258620", "Lamia", "Ламия", "GR", "300", "ESYE24", "29", "9160", "", "38.9", "22.43333", "Europe/Athens"),
("259245", "Kos", "Кос", "GR", "300", "ESYE42", "47", "9284", "", "36.89333", "27.28889", "Europe/Athens"),
("259251", "Koropi", "", "GR", "300", "ESYE31", "445406", "9218", "", "37.89886", "23.87181", "Europe/Athens"),
("259289", "Korinthos", "Коринф", "GR", "300", "ESYE25", "37", "9243", "", "37.94068", "22.95734", "Europe/Athens"),
("259824", "Kifisia", "", "GR", "300", "ESYE31", "445408", "9171", "", "38.07438", "23.81106", "Europe/Athens"),
("259949", "Cholargos", "", "GR", "300", "ESYE31", "445408", "9175", "", "38", "23.8", "Europe/Athens"),
("259973", "Chios", "Хиос", "GR", "300", "ESYE41", "50", "9266", "", "38.36778", "26.13583", "Europe/Athens"),
("260114", "Chania", "Ханья", "GR", "300", "ESYE43", "43", "9325", "", "35.51124", "24.02921", "Europe/Athens"),
("260133", "Chalkida", "Халкида", "GR", "300", "ESYE24", "34", "9155", "", "38.46361", "23.59944", "Europe/Athens"),
("260172", "Khalandrion", "", "GR", "300", "ESYE31", "445408", "9178", "", "38.03058", "23.79793", "Europe/Athens"),
("260204", "Keratsini", "", "GR", "300", "ESYE31", "406101", "9202", "", "37.9625", "23.61972", "Europe/Athens"),
("260989", "Karditsa", "Кардица", "GR", "300", "ESYE14", "23", "9092", "", "39.36556", "21.92167", "Europe/Athens"),
("261414", "Kallithea", "Каллифея", "GR", "300", "ESYE31", "445408", "9198", "", "37.95", "23.7", "Europe/Athens"),
("261604", "Kalamata", "Каламата", "GR", "300", "ESYE25", "40", "9254", "", "37.03889", "22.11417", "Europe/Athens"),
("261614", "Alimos", "", "GR", "300", "ESYE31", "445408", "9195", "", "37.91033", "23.72361", "Europe/Athens"),
("261678", "Kaisariani", "Кесариани", "GR", "300", "ESYE31", "445408", "9190", "", "37.96667", "23.8", "Europe/Athens"),
("261743", "Irakleio", "", "GR", "300", "ESYE31", "445408", "9173", "", "38.05282", "23.76523", "Europe/Athens"),
("261745", "Irakleion", "Ираклион", "GR", "300", "ESYE43", "45", "9305", "", "35.32787", "25.14341", "Europe/Athens"),
("261779", "Ioannina", "", "GR", "300", "ESYE21", "17", "9084", "", "39.66486", "20.85189", "Europe/Athens"),
("262135", "Galatsi", "", "GR", "300", "ESYE31", "445408", "9188", "", "38.01667", "23.75", "Europe/Athens"),
("262719", "Elliniko", "", "GR", "300", "ESYE31", "445408", "9197", "", "37.88333", "23.73333", "Europe/Athens"),
("262752", "Elefsina", "", "GR", "300", "ESYE31", "445407", "9229", "", "38.04135", "23.54295", "Europe/Athens"),
("264111", "Agia Varvara", "", "GR", "300", "ESYE31", "445408", "9179", "", "37.98333", "23.66667", "Europe/Athens"),
("264194", "Agia Paraskevi", "", "GR", "300", "ESYE31", "445408", "9167", "", "38.01667", "23.83333", "Europe/Athens"),
("264371", "Athens", "Афины", "GR", "300", "ESYE31", "445408", "9186", "", "37.97945", "23.71622", "Europe/Athens"),
("264445", "Aspropyrgos", "", "GR", "300", "ESYE31", "445407", "9228", "", "38.06134", "23.58971", "Europe/Athens"),
("264559", "Arta", "", "GR", "300", "ESYE21", "20", "9073", "", "39.16056", "20.98528", "Europe/Athens"),
("264670", "Argos", "Аргос", "GR", "300", "ESYE25", "36", "9233", "", "37.63333", "22.73333", "Europe/Athens"),
("264888", "Ano Liosia", "", "GR", "300", "ESYE31", "445407", "9232", "", "38.08333", "23.7", "Europe/Athens"),
("265243", "Marousi", "", "GR", "300", "ESYE31", "445408", "9168", "", "38.05", "23.8", "Europe/Athens"),
("265252", "Amaliada", "", "GR", "300", "ESYE23", "39", "9139", "", "37.8", "21.35", "Europe/Athens"),
("265488", "Acharnes", "", "GR", "300", "ESYE31", "445406", "9215", "", "38.08333", "23.73333", "Europe/Athens"),
("265500", "Aigio", "Эйо", "GR", "300", "ESYE23", "38", "9130", "", "38.24861", "22.08194", "Europe/Athens"),
("265533", "Aigaleo", "", "GR", "300", "ESYE31", "445408", "9181", "", "37.98333", "23.68333", "Europe/Athens"),
("265560", "Agrinio", "Агринион", "GR", "300", "ESYE23", "31", "9123", "", "38.62139", "21.40778", "Europe/Athens"),
("400666", "Rodos", "Родос", "GR", "300", "ESYE42", "47", "9296", "", "36.44083", "28.2225", "Europe/Athens"),
("733776", "Giannitsa", "Яница", "GR", "300", "ESYE12", "07", "9044", "", "40.79194", "22.4075", "Europe/Athens"),
("733840", "Xanthi", "Ксанти", "GR", "300", "ESYE11", "03", "9017", "", "41.13488", "24.888", "Europe/Athens"),
("733905", "Veroia", "Верия", "GR", "300", "ESYE12", "12", "9024", "", "40.52437", "22.20242", "Europe/Athens"),
("734077", "Thessaloniki", "Салоники", "GR", "300", "ESYE12", "13", "9031", "", "40.64362", "22.93086", "Europe/Athens"),
("734301", "Sykies", "", "GR", "300", "ESYE12", "13", "9035", "", "40.64944", "22.95083", "Europe/Athens"),
("734330", "Serres", "", "GR", "300", "ESYE12", "05", "9054", "", "41.08499", "23.54757", "Europe/Athens"),
("734426", "Ptolemaida", "", "GR", "300", "ESYE13", "11", "9067", "", "40.51472", "21.67861", "Europe/Athens"),
("734538", "Polichni", "Полихни", "GR", "300", "ESYE12", "13", "9036", "", "40.66671", "22.94881", "Europe/Athens"),
("734643", "Pylaia", "Пилеа", "GR", "300", "ESYE12", "13", "9037", "", "40.59918", "22.98613", "Europe/Athens"),
("734712", "Peraia", "", "GR", "300", "ESYE12", "13", "9029", "", "40.49874", "22.92617", "Europe/Athens"),
("734771", "Panorama", "", "GR", "300", "ESYE12", "13", "9037", "", "40.58779", "23.0315", "Europe/Athens"),
("734880", "Orestiada", "", "GR", "300", "ESYE11", "01", "9008", "", "41.50306", "26.52972", "Europe/Athens"),
("734883", "Oraiokastro", "", "GR", "300", "ESYE12", "13", "9039", "", "40.73083", "22.91722", "Europe/Athens"),
("735030", "Naousa", "", "GR", "300", "ESYE12", "12", "9025", "", "40.62944", "22.06806", "Europe/Athens"),
("735215", "Menemeni", "", "GR", "300", "ESYE12", "13", "9026", "", "40.65829", "22.89712", "Europe/Athens"),
("735563", "Kozani", "Козани", "GR", "300", "ESYE13", "11", "9068", "", "40.30068", "21.78896", "Europe/Athens"),
("735640", "Komotini", "Комотини", "GR", "300", "ESYE11", "02", "9021", "", "41.11917", "25.40535", "Europe/Athens"),
("735736", "Kilkis", "", "GR", "300", "ESYE12", "06", "9040", "", "40.99302", "22.87433", "Europe/Athens"),
("735861", "Kavala", "Кавала", "GR", "300", "ESYE11", "14", "9012", "", "40.93959", "24.40687", "Europe/Athens"),
("735914", "Katerini", "", "GR", "300", "ESYE12", "16", "9047", "", "40.26956", "22.50608", "Europe/Athens"),
("736083", "Kalamaria", "Каламария", "GR", "300", "ESYE12", "13", "9032", "", "40.5825", "22.95028", "Europe/Athens"),
("736229", "Florina", "", "GR", "300", "ESYE13", "08", "9072", "", "40.78197", "21.40981", "Europe/Athens"),
("736357", "Edessa", "", "GR", "300", "ESYE12", "07", "9043", "", "40.8026", "22.04751", "Europe/Athens"),
("736364", "Drama", "", "GR", "300", "ESYE11", "04", "9002", "", "41.15283", "24.1473", "Europe/Athens"),
("736928", "Alexandroupoli", "Александруполис", "GR", "300", "ESYE11", "01", "9006", "", "40.84995", "25.87644", "Europe/Athens"),
("2463679", "Kerkyra", "Корфу", "GR", "300", "ESYE22", "25", "9118", "", "39.62", "19.91972", "Europe/Athens"),
("6324534", "Vrilissia", "", "GR", "300", "ESYE31", "445408", "9169", "", "38.03381", "23.82962", "Europe/Athens"),
("7522530", "Marousi", "", "GR", "300", "ESYE31", "445408", "9168", "", "38.05404", "23.806", "Europe/Athens"),
("8201845", "Gerakas", "", "GR", "300", "ESYE31", "", "", "", "38.02277", "23.8576", "Europe/Athens"),
("8310183", "Korydallos", "", "GR", "300", "ESYE31", "", "", "", "37.98468", "23.64711", "Europe/Athens"),
("8358544", "Zografos", "", "GR", "300", "ESYE31", "35", "", "", "37.97332", "23.7909", "Europe/Athens"),
("8478257", "Agios Ioannis Rentis", "", "GR", "300", "ESYE31", "406101", "9204", "", "37.96491", "23.66511", "Europe/Athens"),
("9034728", "Nea Ionia", "", "GR", "300", "ESYE14", "24", "9105", "", "39.37312", "22.93375", "Europe/Athens"),
("3186781", "Zapresic", "Запрешич", "HR", "191", "20", "", "", "", "45.85639", "15.80778", "Europe/Zagreb"),
("3186886", "Zagreb", "Загреб", "HR", "191", "21", "3186885", "", "", "45.81444", "15.97798", "Europe/Zagreb"),
("3186952", "Zadar", "Задар", "HR", "191", "19", "", "", "", "44.11972", "15.24222", "Europe/Zagreb"),
("3187047", "Vukovar", "Вуковар", "HR", "191", "18", "", "", "", "45.34333", "18.99972", "Europe/Zagreb"),
("3187694", "Virovitica", "", "HR", "191", "17", "3187693", "", "", "45.83194", "17.38389", "Europe/Zagreb"),
("3187719", "Vinkovci", "Винковцы", "HR", "191", "18", "", "", "", "45.28833", "18.80472", "Europe/Zagreb"),
("3188244", "Velika Gorica", "Велика-Горица", "HR", "191", "20", "3188243", "", "", "45.7125", "16.07556", "Europe/Zagreb"),
("3188383", "Varazdin", "Вараждин", "HR", "191", "16", "", "", "", "46.30444", "16.33778", "Europe/Zagreb"),
("3190261", "Split", "Сплит", "HR", "191", "15", "3190259", "", "", "43.50891", "16.43915", "Europe/Zagreb"),
("3190359", "Solin", "Солин", "HR", "191", "15", "", "", "", "43.5432", "16.49314", "Europe/Zagreb"),
("3190586", "Slavonski Brod", "Славонски-Брод", "HR", "191", "02", "3190585", "", "", "45.16028", "18.01556", "Europe/Zagreb"),
("3190589", "Pozega", "Пожега", "HR", "191", "11", "", "", "", "45.34028", "17.68528", "Europe/Zagreb"),
("3190813", "Sisak", "Сисак", "HR", "191", "14", "3190812", "", "", "45.46611", "16.37833", "Europe/Zagreb"),
("3190941", "Sibenik", "Шибеник", "HR", "191", "13", "3190938", "", "", "43.72722", "15.90583", "Europe/Zagreb"),
("3190966", "Sesvete", "Сесвете", "HR", "191", "21", "3190965", "", "", "45.83111", "16.11639", "Europe/Zagreb"),
("3191316", "Samobor", "", "HR", "191", "20", "3191315", "", "", "45.80306", "15.71806", "Europe/Zagreb"),
("3191648", "Rijeka", "Риека", "HR", "191", "12", "", "", "", "45.34306", "14.40917", "Europe/Zagreb"),
("3192224", "Pula", "Пула", "HR", "191", "04", "3192222", "", "", "44.86833", "13.84806", "Europe/Zagreb"),
("3193935", "Osijek", "Осиек", "HR", "191", "10", "3193934", "", "", "45.55111", "18.69389", "Europe/Zagreb"),
("3197728", "Koprivnica", "Копривница", "HR", "191", "06", "3197726", "", "", "46.16278", "16.8275", "Europe/Zagreb"),
("3198259", "Karlovac", "Карловац", "HR", "191", "05", "3198257", "", "", "45.48722", "15.54778", "Europe/Zagreb"),
("3201047", "Dubrovnik", "Дубровник", "HR", "191", "03", "7577034", "", "", "42.64807", "18.09216", "Europe/Zagreb"),
("3202888", "Cakovec", "Чаковец", "HR", "191", "09", "", "", "", "46.38444", "16.43389", "Europe/Zagreb"),
("3203982", "Bjelovar", "Беловар", "HR", "191", "01", "", "", "", "45.89861", "16.84889", "Europe/Zagreb"),
("3209380", "Stenjevec", "", "HR", "191", "21", "", "", "", "45.80846", "15.88245", "Europe/Zagreb"),
("6618983", "Zagreb - Centar", "", "HR", "191", "21", "3186885", "", "", "45.81313", "15.97753", "Europe/Zagreb"),
("714581", "Torokszentmiklos", "Тороксентмиклош", "HU", "348", "20", "", "", "", "47.18333", "20.41667", "Europe/Budapest"),
("714697", "Tiszaujvaros", "", "HU", "348", "04", "", "", "", "47.93333", "21.08333", "Europe/Budapest"),
("715126", "Szolnok", "Сольнок", "HU", "348", "20", "", "", "", "47.18333", "20.2", "Europe/Budapest"),
("715338", "Szentes", "", "HU", "348", "06", "", "", "", "46.65627", "20.27201", "Europe/Budapest"),
("715429", "Szeged", "", "HU", "348", "06", "", "", "", "46.253", "20.14824", "Europe/Budapest"),
("715466", "Szarvas", "Сарваш", "HU", "348", "03", "", "", "", "46.86667", "20.55", "Europe/Budapest"),
("715839", "Satoraljaujhely", "Шаторальяуйхей", "HU", "348", "04", "", "", "", "48.39492", "21.65871", "Europe/Budapest"),
("716301", "Puspokladany", "", "HU", "348", "10", "", "", "", "47.31667", "21.11667", "Europe/Budapest"),
("716671", "Ozd", "Озд", "HU", "348", "04", "", "", "", "48.21667", "20.3", "Europe/Budapest"),
("716736", "Oroshaza", "Орошхаза", "HU", "348", "03", "", "", "", "46.56667", "20.66667", "Europe/Budapest"),
("716935", "Nyiregyhaza", "Ньиредьхаза", "HU", "348", "18", "", "", "", "47.95539", "21.71671", "Europe/Budapest"),
("717582", "Miskolc", "Мишкольц", "HU", "348", "04", "", "", "", "48.1", "20.78333", "Europe/Budapest"),
("717635", "Mezotur", "", "HU", "348", "20", "", "", "", "47", "20.63333", "Europe/Budapest"),
("717652", "Mezokovesd", "", "HU", "348", "04", "", "", "", "47.81667", "20.58333", "Europe/Budapest"),
("717771", "Mateszalka", "", "HU", "348", "18", "", "", "", "47.95528", "22.32348", "Europe/Budapest"),
("717902", "Mako", "Мако", "HU", "348", "06", "", "", "", "46.21667", "20.48333", "Europe/Budapest"),
("718739", "Kisvarda", "", "HU", "348", "18", "", "", "", "48.21667", "22.08333", "Europe/Budapest"),
("719311", "Kazincbarcika", "Казинцбарцика", "HU", "348", "04", "", "", "", "48.25", "20.63333", "Europe/Budapest"),
("719404", "Karcag", "Карцаге", "HU", "348", "20", "", "", "", "47.31667", "20.93333", "Europe/Budapest"),
("719965", "Hodmezovasarhely", "Ходмезевашархей", "HU", "348", "06", "", "", "", "46.41667", "20.33333", "Europe/Budapest"),
("720276", "Hajduszoboszlo", "Хайдусобосло", "HU", "348", "10", "", "", "", "47.45", "21.4", "Europe/Budapest"),
("720284", "Hajdunanas", "", "HU", "348", "10", "", "", "", "47.85", "21.43333", "Europe/Budapest"),
("720292", "Hajduboszormeny", "", "HU", "348", "10", "", "", "", "47.66667", "21.51667", "Europe/Budapest"),
("720334", "Gyula", "Дьюла", "HU", "348", "03", "", "", "", "46.65", "21.28333", "Europe/Budapest"),
("720364", "Gyomaendrod", "", "HU", "348", "03", "", "", "", "46.93333", "20.83333", "Europe/Budapest"),
("721239", "Eger", "Эгер", "HU", "348", "11", "", "", "", "47.90265", "20.37329", "Europe/Budapest"),
("721472", "Debrecen", "Дебрецен", "HU", "348", "10", "", "", "", "47.53333", "21.63333", "Europe/Budapest"),
("721592", "Csongrad", "", "HU", "348", "06", "", "", "", "46.71332", "20.14242", "Europe/Budapest"),
("722324", "Berettyoujfalu", "", "HU", "348", "10", "", "", "", "47.21667", "21.55", "Europe/Budapest"),
("722437", "Bekescsaba", "Бекешчаба", "HU", "348", "03", "", "", "", "46.68333", "21.1", "Europe/Budapest"),
("722439", "Bekes", "Бекеш", "HU", "348", "03", "", "", "", "46.76667", "21.13333", "Europe/Budapest"),
("722636", "Balmazujvaros", "", "HU", "348", "10", "", "", "", "47.61667", "21.35", "Europe/Budapest"),
("723030", "Abony", "", "HU", "348", "16", "", "", "", "47.1899", "20.00476", "Europe/Budapest"),
("3042638", "Zalaegerszeg", "Залаэгерсег", "HU", "348", "24", "", "", "", "46.84", "16.84389", "Europe/Budapest"),
("3042929", "Veszprem", "Веспрем", "HU", "348", "23", "", "", "", "47.09327", "17.91149", "Europe/Budapest"),
("3043019", "Vecses", "", "HU", "348", "16", "", "", "", "47.40705", "19.28648", "Europe/Budapest"),
("3043095", "Varpalota", "", "HU", "348", "23", "", "", "", "47.19936", "18.13954", "Europe/Budapest"),
("3043293", "Vac", "Вац", "HU", "348", "16", "", "", "", "47.77591", "19.13612", "Europe/Budapest"),
("3044082", "Tatabanya", "Татабанья", "HU", "348", "12", "", "", "", "47.58494", "18.39325", "Europe/Budapest"),
("3044083", "Tata", "", "HU", "348", "12", "", "", "", "47.65289", "18.31838", "Europe/Budapest"),
("3044141", "Tapolca", "", "HU", "348", "23", "", "", "", "46.88152", "17.44117", "Europe/Budapest"),
("3044310", "Szombathely", "Сомбатхей", "HU", "348", "22", "", "", "", "47.23088", "16.62155", "Europe/Budapest"),
("3044475", "Szigetszentmiklos", "Сигетсентмиклош", "HU", "348", "16", "", "", "", "47.34382", "19.04335", "Europe/Budapest"),
("3044681", "Szentendre", "Сентендре", "HU", "348", "16", "", "", "", "47.66943", "19.07561", "Europe/Budapest"),
("3044760", "Szekszard", "Сексард", "HU", "348", "21", "", "", "", "46.35014", "18.70905", "Europe/Budapest"),
("3044774", "Szekesfehervar", "Секешфехервар", "HU", "348", "08", "", "", "", "47.18995", "18.41034", "Europe/Budapest"),
("3044821", "Szazhalombatta", "", "HU", "348", "16", "", "", "", "47.32579", "18.92142", "Europe/Budapest"),
("3045190", "Sopron", "Шопрон", "HU", "348", "09", "", "", "", "47.68501", "16.59049", "Europe/Budapest"),
("3045332", "Siofok", "Шиофок", "HU", "348", "17", "", "", "", "46.90412", "18.058", "Europe/Budapest"),
("3045487", "Sarvar", "", "HU", "348", "22", "", "", "", "47.25395", "16.93525", "Europe/Budapest"),
("3045643", "Salgotarjan", "Шальготарьян", "HU", "348", "14", "", "", "", "48.09872", "19.80303", "Europe/Budapest"),
("3046526", "Pecs", "Печ", "HU", "348", "02", "", "", "", "46.08333", "18.23333", "Europe/Budapest"),
("3046619", "Paradsasvar", "Парадшашвар", "HU", "348", "11", "", "", "", "47.9126", "19.97709", "Europe/Budapest"),
("3046686", "Papa", "Папы", "HU", "348", "23", "", "", "", "47.33004", "17.4674", "Europe/Budapest"),
("3046768", "Paks", "", "HU", "348", "21", "", "", "", "46.62648", "18.85962", "Europe/Budapest"),
("3046888", "Oroszlany", "Орослане", "HU", "348", "12", "", "", "", "47.48671", "18.31225", "Europe/Budapest"),
("3047651", "Nagykoros", "", "HU", "348", "16", "", "", "", "47.03419", "19.77857", "Europe/Budapest"),
("3047679", "Nagykanizsa", "Надьканижа", "HU", "348", "24", "", "", "", "46.45347", "16.99104", "Europe/Budapest"),
("3047896", "Mosonmagyarovar", "Мошонмадьяровар", "HU", "348", "09", "", "", "", "47.86788", "17.26994", "Europe/Budapest"),
("3047942", "Monor", "", "HU", "348", "16", "", "", "", "47.35133", "19.44734", "Europe/Budapest"),
("3047967", "Mohacs", "Мохач", "HU", "348", "02", "", "", "", "45.99306", "18.68306", "Europe/Budapest"),
("3049512", "Komlo", "", "HU", "348", "02", "", "", "", "46.19278", "18.26494", "Europe/Budapest"),
("3049519", "Komarom", "", "HU", "348", "12", "", "", "", "47.74318", "18.11913", "Europe/Budapest"),
("3049880", "Kiskunhalas", "Кишкунхалаш", "HU", "348", "01", "", "", "", "46.43402", "19.4848", "Europe/Budapest"),
("3049885", "Kiskunfelegyhaza", "", "HU", "348", "01", "", "", "", "46.71213", "19.84458", "Europe/Budapest"),
("3049896", "Kiskoros", "", "HU", "348", "01", "", "", "", "46.62139", "19.28528", "Europe/Budapest"),
("3050212", "Keszthely", "Кестхей", "HU", "348", "24", "", "", "", "46.76812", "17.24317", "Europe/Budapest"),
("3050434", "Kecskemet", "Кечкемет", "HU", "348", "01", "", "", "", "46.90618", "19.69128", "Europe/Budapest"),
("3050616", "Kaposvar", "Капошвар", "HU", "348", "17", "", "", "", "46.36667", "17.8", "Europe/Budapest"),
("3050719", "Kalocsa", "Калоча", "HU", "348", "01", "", "", "", "46.52639", "18.98583", "Europe/Budapest"),
("3050907", "Jaszbereny", "", "HU", "348", "20", "", "", "", "47.5", "19.91667", "Europe/Budapest"),
("3051621", "Hatvan", "", "HU", "348", "11", "", "", "", "47.66667", "19.68333", "Europe/Budapest"),
("3052009", "Gyor", "Дьёр", "HU", "348", "09", "", "", "", "47.68333", "17.63512", "Europe/Budapest"),
("3052040", "Gyongyos", "Дьёндьёш", "HU", "348", "11", "", "", "", "47.78257", "19.928", "Europe/Budapest"),
("3052101", "Gyal", "", "HU", "348", "16", "", "", "", "47.38449", "19.2214", "Europe/Budapest"),
("3052236", "Godollo", "Гёдёллё", "HU", "348", "16", "", "", "", "47.59657", "19.35515", "Europe/Budapest"),
("3052241", "God", "", "HU", "348", "16", "", "", "", "47.68324", "19.13417", "Europe/Budapest"),
("3052542", "Fot", "", "HU", "348", "16", "", "", "", "47.6177", "19.1887", "Europe/Budapest"),
("3053163", "Esztergom", "Эстергом", "HU", "348", "12", "", "", "", "47.7928", "18.74148", "Europe/Budapest"),
("3053281", "Erd", "Эрд", "HU", "348", "16", "", "", "", "47.39489", "18.9136", "Europe/Budapest"),
("3053438", "Dunaujvaros", "Дунауйварош", "HU", "348", "08", "", "", "", "46.98333", "18.93333", "Europe/Budapest"),
("3053476", "Dunakeszi", "", "HU", "348", "16", "", "", "", "47.6364", "19.13864", "Europe/Budapest"),
("3053485", "Dunaharaszti", "", "HU", "348", "16", "", "", "", "47.3545", "19.09822", "Europe/Budapest"),
("3053590", "Dombovar", "", "HU", "348", "21", "", "", "", "46.37657", "18.13696", "Europe/Budapest"),
("3053836", "Dabas", "", "HU", "348", "16", "", "", "", "47.18594", "19.31091", "Europe/Budapest"),
("3054543", "Cegled", "Цеглед", "HU", "348", "16", "", "", "", "47.17266", "19.79952", "Europe/Budapest"),
("3054643", "Budapest", "Будапешт", "HU", "348", "05", "", "", "", "47.49801", "19.03991", "Europe/Budapest"),
("3054646", "Budaors", "", "HU", "348", "16", "", "", "", "47.46181", "18.95845", "Europe/Budapest"),
("3055601", "Balassagyarmat", "", "HU", "348", "14", "", "", "", "48.07296", "19.29614", "Europe/Budapest"),
("3055685", "Baja", "Бая", "HU", "348", "01", "", "", "", "46.17496", "18.95639", "Europe/Budapest"),
("3056357", "Ajka", "Айка", "HU", "348", "23", "", "", "", "47.10196", "17.55892", "Europe/Budapest"),
("7284823", "Budapest XII. keruelet", "", "HU", "348", "05", "", "", "", "47.49192", "19.01493", "Europe/Budapest"),
("7284824", "Budapest XI. keruelet", "", "HU", "348", "05", "", "", "", "47.47603", "19.03605", "Europe/Budapest"),
("7284825", "Budapest IX. keruelet", "", "HU", "348", "05", "", "", "", "47.48299", "19.06591", "Europe/Budapest"),
("7284826", "Budapest VIII. keruelet", "", "HU", "348", "05", "", "", "", "47.48919", "19.07012", "Europe/Budapest"),
("7284827", "Budapest VII. keruelet", "", "HU", "348", "05", "", "", "", "47.50045", "19.06875", "Europe/Budapest"),
("7284828", "Budapest VI. keruelet", "", "HU", "348", "05", "", "", "", "47.50369", "19.06583", "Europe/Budapest"),
("7284829", "Budapest XIV. keruelet", "", "HU", "348", "05", "", "", "", "47.5183", "19.10789", "Europe/Budapest"),
("7284830", "Budapest XIII. keruelet", "", "HU", "348", "05", "", "", "", "47.52978", "19.08068", "Europe/Budapest"),
("7284831", "Budapest IV. keruelet", "", "HU", "348", "05", "", "", "", "47.56182", "19.08909", "Europe/Budapest"),
("7284832", "Budapest XV. keruelet", "", "HU", "348", "05", "", "", "", "47.56263", "19.11681", "Europe/Budapest"),
("7284833", "Budapest XVI. keruelet", "", "HU", "348", "05", "", "", "", "47.51482", "19.17028", "Europe/Budapest"),
("7284834", "Budapest X. keruelet", "", "HU", "348", "05", "", "", "", "47.4791", "19.15835", "Europe/Budapest"),
("7284835", "Budapest XIX. keruelet", "", "HU", "348", "05", "", "", "", "47.45293", "19.14943", "Europe/Budapest"),
("7284836", "Budapest XVIII. keruelet", "", "HU", "348", "05", "", "", "", "47.44417", "19.17595", "Europe/Budapest"),
("7284837", "Budapest XXIII. keruelet", "", "HU", "348", "05", "", "", "", "47.39788", "19.11492", "Europe/Budapest"),
("7284838", "Budapest XXII. keruelet", "", "HU", "348", "05", "", "", "", "47.42698", "19.04016", "Europe/Budapest"),
("7284839", "Budapest XXI. keruelet", "", "HU", "348", "05", "", "", "", "47.43047", "19.07098", "Europe/Budapest"),
("7284840", "Budapest XX. keruelet", "", "HU", "348", "05", "", "", "", "47.43674", "19.10093", "Europe/Budapest"),
("7284841", "Budapest XVII. keruelet", "", "HU", "348", "05", "", "", "", "47.47997", "19.25388", "Europe/Budapest"),
("7284842", "Budapest III. keruelet", "", "HU", "348", "05", "", "", "", "47.54157", "19.04501", "Europe/Budapest"),
("7284843", "Budapest II. keruelet", "", "HU", "348", "05", "", "", "", "47.51291", "19.03184", "Europe/Budapest"),
("7284844", "Budapest I. keruelet", "", "HU", "348", "05", "", "", "", "47.49705", "19.03961", "Europe/Budapest"),
("1213493", "Teluk Nibung", "", "ID", "360", "26", "", "", "", "3.001", "99.8164", "Asia/Jakarta"),
("1213500", "Tebingtinggi", "", "ID", "360", "26", "", "", "", "3.3285", "99.1625", "Asia/Jakarta"),
("1213530", "Tanjungtiram", "", "ID", "360", "26", "", "", "", "4.0613", "98.3699", "Asia/Jakarta"),
("1213547", "Tanjungbalai", "", "ID", "360", "26", "", "", "", "2.96667", "99.8", "Asia/Jakarta"),
("1213614", "Sunggal", "", "ID", "360", "26", "", "", "", "3.5765", "98.6151", "Asia/Jakarta"),
("1213655", "Stabat", "", "ID", "360", "26", "", "", "", "3.761", "98.4513", "Asia/Jakarta"),
("1213821", "Sigli", "", "ID", "360", "01", "", "", "", "5.3848", "95.9609", "Asia/Jakarta"),
("1213855", "Sibolga", "Сиболга", "ID", "360", "26", "", "", "", "1.74016", "98.78117", "Asia/Jakarta"),
("1214026", "Sabang", "", "ID", "360", "01", "", "", "", "5.88969", "95.31644", "Asia/Jakarta"),
("1214055", "Reuleuet", "", "ID", "360", "01", "", "", "", "5.21667", "96.28333", "Asia/Jakarta"),
("1214073", "Rantauprapat", "", "ID", "360", "26", "", "", "", "2.1", "99.83333", "Asia/Jakarta"),
("1214189", "Percut", "", "ID", "360", "26", "", "", "", "3.6253", "98.864", "Asia/Jakarta"),
("1214191", "Perbaungan", "", "ID", "360", "26", "", "", "", "3.5679", "98.956", "Asia/Jakarta"),
("1214204", "Pematangsiantar", "", "ID", "360", "26", "", "", "", "2.9595", "99.0687", "Asia/Jakarta"),
("1214302", "Pangkalan Brandan", "", "ID", "360", "26", "", "", "", "4.0238", "98.2782", "Asia/Jakarta"),
("1214369", "Padangsidempuan", "", "ID", "360", "26", "", "", "", "1.37952", "99.27146", "Asia/Jakarta"),
("1214488", "Meulaboh", "Мелабоха", "ID", "360", "01", "", "", "", "4.1363", "96.1285", "Asia/Jakarta"),
("1214520", "Medan", "Медан", "ID", "360", "26", "", "", "", "3.58333", "98.66667", "Asia/Jakarta"),
("1214658", "Lhokseumawe", "Локсеумаве", "ID", "360", "01", "", "", "", "5.1801", "97.1507", "Asia/Jakarta"),
("1214724", "Langsa", "", "ID", "360", "01", "", "", "", "4.4683", "97.9683", "Asia/Jakarta"),
("1214800", "Labuhan Deli", "", "ID", "360", "26", "", "", "", "3.7278", "98.6738", "Asia/Jakarta"),
("1214882", "Kisaran", "", "ID", "360", "26", "", "", "", "2.9845", "99.6158", "Asia/Jakarta"),
("1214965", "Kabanjahe", "", "ID", "360", "26", "", "", "", "3.1001", "98.4908", "Asia/Jakarta"),
("1215199", "Deli Tua", "", "ID", "360", "26", "", "", "", "3.5078", "98.6839", "Asia/Jakarta"),
("1215350", "Bireun", "", "ID", "360", "01", "", "", "", "5.203", "96.7009", "Asia/Jakarta"),
("1215355", "Binjai", "", "ID", "360", "26", "", "", "", "3.6001", "98.4854", "Asia/Jakarta"),
("1215412", "Belawan", "", "ID", "360", "26", "", "", "", "3.7755", "98.6832", "Asia/Jakarta"),
("1215498", "Bandar", "", "ID", "360", "26", "", "", "", "2.05", "99.75", "Asia/Jakarta"),
("1215502", "Banda Aceh", "Банда-Ачех", "ID", "360", "01", "1171", "", "", "5.5577", "95.3222", "Asia/Jakarta"),
("1621177", "Yogyakarta", "Джокьякарта", "ID", "360", "10", "", "", "", "-7.78278", "110.36083", "Asia/Jakarta"),
("1621395", "Wonosobo", "", "ID", "360", "07", "", "", "", "-7.36", "109.9025", "Asia/Jakarta"),
("1621416", "Wonopringgo", "", "ID", "360", "07", "", "", "", "-6.98333", "109.61667", "Asia/Jakarta"),
("1621439", "Wongsorejo", "", "ID", "360", "08", "", "", "", "-7.9908", "114.4009", "Asia/Jakarta"),
("1621520", "Wiradesa", "", "ID", "360", "07", "", "", "", "-6.8922", "109.619", "Asia/Jakarta"),
("1621613", "Weru", "", "ID", "360", "30", "", "", "", "-6.711", "108.5037", "Asia/Jakarta"),
("1621655", "Weleri", "", "ID", "360", "07", "", "", "", "-6.9713", "110.0666", "Asia/Jakarta"),
("1621659", "Welahan", "", "ID", "360", "07", "", "", "", "-6.8", "110.71667", "Asia/Jakarta"),
("1621678", "Wedi", "", "ID", "360", "07", "", "", "", "-7.74306", "110.57944", "Asia/Jakarta"),
("1621884", "Watampone", "", "ID", "360", "38", "", "", "", "-4.5386", "120.3279", "Asia/Makassar"),
("1622090", "Wangon", "", "ID", "360", "07", "", "", "", "-7.51611", "109.05389", "Asia/Jakarta"),
("1622138", "Wanaraja", "", "ID", "360", "30", "", "", "", "-7.1749", "107.9808", "Asia/Jakarta"),
("1622318", "Waingapu", "", "ID", "360", "18", "", "", "", "-9.6567", "120.2641", "Asia/Makassar"),
("1622636", "Ungaran", "", "ID", "360", "07", "", "", "", "-7.13972", "110.405", "Asia/Jakarta"),
("1622786", "Makassar", "Макассар", "ID", "360", "38", "", "", "", "-5.14", "119.4221", "Asia/Makassar"),
("1622846", "Ubud", "Убуд", "ID", "360", "02", "", "", "", "-8.5098", "115.2654", "Asia/Makassar"),
("1623080", "Tulungagung", "", "ID", "360", "08", "", "", "", "-8.0657", "111.9025", "Asia/Jakarta"),
("1623096", "Tulangan Utara", "", "ID", "360", "08", "", "", "", "-7.4737", "112.6505", "Asia/Jakarta"),
("1623180", "Tuban", "Тубан", "ID", "360", "08", "", "", "", "-6.8976", "112.0649", "Asia/Jakarta"),
("1623197", "Tual", "", "ID", "360", "28", "", "", "", "-5.6193", "132.7886", "Asia/Jayapura"),
("1623223", "Trucuk", "", "ID", "360", "07", "", "", "", "-7.71833", "110.65889", "Asia/Jakarta"),
("1623251", "Trenggalek", "", "ID", "360", "08", "", "", "", "-8.0764", "111.70641", "Asia/Jakarta"),
("1623424", "Tondano", "", "ID", "360", "31", "", "", "", "1.3054", "124.91261", "Asia/Makassar"),
("1623446", "Tomohon", "", "ID", "360", "31", "", "", "", "1.31678", "124.80379", "Asia/Makassar"),
("1624041", "Ternate", "Тернате", "ID", "360", "29", "", "", "", "0.79065", "127.38424", "Asia/Jayapura"),
("1624058", "Terbanggi Besar", "", "ID", "360", "15", "", "", "", "-4.87898", "105.21818", "Asia/Jakarta"),
("1624494", "Tegal", "", "ID", "360", "07", "", "", "", "-6.8694", "109.1402", "Asia/Jakarta"),
("1624545", "Tayu", "", "ID", "360", "07", "", "", "", "-6.5397", "111.0518", "Asia/Jakarta"),
("1624647", "Tasikmalaya", "", "ID", "360", "30", "", "", "", "-7.3274", "108.2207", "Asia/Jakarta"),
("1624668", "Tarub", "", "ID", "360", "07", "", "", "", "-6.93333", "109.16667", "Asia/Jakarta"),
("1624725", "Tarakan", "Таракан", "ID", "360", "42", "", "", "", "3.31332", "117.59152", "Asia/Makassar"),
("1624863", "Tanjungpinang", "", "ID", "360", "40", "", "", "", "0.91667", "104.45", "Asia/Jakarta"),
("1624877", "Tanjung Pandan", "", "ID", "360", "35", "", "", "", "-2.73353", "107.63477", "Asia/Jakarta"),
("1624917", "Bandarlampung", "", "ID", "360", "15", "", "", "", "-5.42544", "105.25803", "Asia/Jakarta"),
("1624987", "Tanjungagung", "", "ID", "360", "32", "", "", "", "-3.93728", "103.80465", "Asia/Jakarta"),
("1625067", "Tanggulangin", "", "ID", "360", "08", "", "", "", "-7.49958", "112.69992", "Asia/Jakarta"),
("1625084", "Tangerang", "Тангеранг", "ID", "360", "33", "", "", "", "-6.17806", "106.63", "Asia/Jakarta"),
("1625708", "Tabanan", "", "ID", "360", "02", "", "", "", "-8.5413", "115.12522", "Asia/Makassar"),
("1625812", "Surakarta", "Суракарте", "ID", "360", "07", "", "", "", "-7.55611", "110.83167", "Asia/Jakarta"),
("1625822", "Surabaya", "Сурабая", "ID", "360", "08", "3578", "", "", "-7.24917", "112.75083", "Asia/Jakarta"),
("1625908", "Sungai Raya", "", "ID", "360", "11", "", "", "", "0.7", "108.9", "Asia/Pontianak"),
("1625929", "Sungai Penuh", "", "ID", "360", "05", "", "", "", "-2.0561", "101.3913", "Asia/Jakarta"),
("1625958", "Sungailiat", "", "ID", "360", "35", "", "", "", "-1.85442", "106.12215", "Asia/Jakarta"),
("1626099", "Sumenep", "", "ID", "360", "08", "", "", "", "-7.01667", "113.86667", "Asia/Jakarta"),
("1626100", "Sumedang Utara", "", "ID", "360", "00", "", "", "", "-6.85", "107.91667", "Asia/Jakarta"),
("1626134", "Sumberpucung", "", "ID", "360", "08", "", "", "", "-8.15856", "112.48292", "Asia/Jakarta"),
("1626183", "Sumber", "", "ID", "360", "30", "", "", "", "-6.76028", "108.48306", "Asia/Jakarta"),
("1626185", "Sumbawa Besar", "", "ID", "360", "17", "Sumbawa (undefined)", "7377422", "", "-8.49317", "117.42024", "Asia/Makassar"),
("1626312", "Sokaraja", "", "ID", "360", "07", "", "", "", "-7.45806", "109.28806", "Asia/Jakarta"),
("1626381", "Sukabumi", "Сукабуми", "ID", "360", "30", "", "", "", "-6.91806", "106.92667", "Asia/Jakarta"),
("1626486", "Srono", "", "ID", "360", "08", "", "", "", "-8.40003", "114.26661", "Asia/Jakarta"),
("1626493", "Srandakan", "", "ID", "360", "10", "", "", "", "-7.93861", "110.25056", "Asia/Jakarta"),
("1626498", "Sragen", "", "ID", "360", "07", "", "", "", "-7.42639", "111.02222", "Asia/Jakarta"),
("1626542", "Sorong", "Соронг", "ID", "360", "39", "", "", "", "-0.87956", "131.26104", "Asia/Jayapura"),
("1626560", "Soreang", "", "ID", "360", "30", "", "", "", "-7.03306", "107.51833", "Asia/Jakarta"),
("1626649", "Solok", "", "ID", "360", "24", "", "", "", "-0.8006", "100.6571", "Asia/Jakarta"),
("1626673", "Soko", "", "ID", "360", "08", "", "", "", "-7.48315", "112.42704", "Asia/Jakarta"),
("1626698", "Sofifi", "", "ID", "360", "29", "", "", "", "0.73333", "127.55", "Asia/Jayapura"),
("1626703", "Soe", "Сое", "ID", "360", "18", "", "", "", "-9.86071", "124.28395", "Asia/Makassar"),
("1626754", "Sleman", "", "ID", "360", "10", "", "", "", "-7.71556", "110.35556", "Asia/Jakarta"),
("1626758", "Slawi", "", "ID", "360", "07", "", "", "", "-6.9816", "109.1407", "Asia/Jakarta"),
("1626801", "Situbondo", "", "ID", "360", "08", "", "", "", "-7.70623", "114.00976", "Asia/Jakarta"),
("1626895", "Sinjai", "", "ID", "360", "38", "", "", "", "-5.1241", "120.253", "Asia/Makassar"),
("1626899", "Singosari", "Сингосари", "ID", "360", "08", "", "", "", "-7.8924", "112.6658", "Asia/Jakarta"),
("1626903", "Singojuruh", "", "ID", "360", "08", "", "", "", "-8.31667", "114.23333", "Asia/Jakarta"),
("1626916", "Singkawang", "", "ID", "360", "11", "", "", "", "0.90925", "108.98463", "Asia/Pontianak"),
("1626921", "Sengkang", "", "ID", "360", "38", "", "", "", "-4.1279", "120.0297", "Asia/Makassar"),
("1626932", "Singaraja", "Сингараджа", "ID", "360", "02", "", "", "", "-8.112", "115.08818", "Asia/Makassar"),
("1626936", "Singaparna", "", "ID", "360", "30", "", "", "", "-7.3515", "108.111", "Asia/Jakarta"),
("1627035", "Simpang", "", "ID", "360", "05", "", "", "", "-1.26424", "104.09701", "Asia/Jakarta"),
("1627185", "Sijunjung", "", "ID", "360", "24", "", "", "", "-0.7005", "100.9774", "Asia/Jakarta"),
("1627253", "Sidoarjo", "", "ID", "360", "08", "", "", "", "-7.4478", "112.7183", "Asia/Jakarta"),
("1627267", "Sidareja", "", "ID", "360", "07", "", "", "", "-7.4846", "108.7923", "Asia/Jakarta"),
("1627357", "Sewon", "", "ID", "360", "10", "", "", "", "-7.87639", "110.35889", "Asia/Jakarta"),
("1627459", "Serpong", "", "ID", "360", "30", "", "", "", "-6.31694", "106.66417", "Asia/Jakarta"),
("1627549", "Serang", "", "ID", "360", "33", "", "", "", "-6.1149", "106.1502", "Asia/Jakarta"),
("1627610", "Sepatan", "", "ID", "360", "30", "", "", "", "-6.11889", "106.575", "Asia/Jakarta"),
("1627896", "Semarang", "Семаранг", "ID", "360", "07", "", "", "", "-6.9932", "110.4203", "Asia/Jakarta"),
("1627969", "Selogiri", "", "ID", "360", "07", "", "", "", "-7.78333", "110.86667", "Asia/Jakarta"),
("1628453", "Sawangan", "", "ID", "360", "30", "", "", "", "-6.40278", "106.77444", "Asia/Jakarta"),
("1628884", "Sampit", "", "ID", "360", "13", "", "", "", "-2.5315", "112.9496", "Asia/Pontianak"),
("1628899", "Sampang", "", "ID", "360", "08", "", "", "", "-7.1872", "113.2394", "Asia/Jakarta"),
("1629001", "Samarinda", "Самаринда", "ID", "360", "14", "", "", "", "-0.48585", "117.1466", "Asia/Makassar"),
("1629131", "Salatiga", "", "ID", "360", "07", "", "", "", "-7.33194", "110.49278", "Asia/Jakarta"),
("1629380", "Ruteng", "", "ID", "360", "18", "", "", "", "-8.6136", "120.4721", "Asia/Makassar"),
("1629710", "Rengasdengklok", "", "ID", "360", "30", "", "", "", "-6.15917", "107.29806", "Asia/Jakarta"),
("1629749", "Rembangan", "", "ID", "360", "07", "", "", "", "-6.7036", "111.3416", "Asia/Jakarta"),
("1629974", "Rantepao", "", "ID", "360", "38", "", "", "", "-2.9701", "119.8978", "Asia/Makassar"),
("1630058", "Rangkasbitung", "", "ID", "360", "33", "", "", "", "-6.3591", "106.2494", "Asia/Jakarta"),
("1630088", "Randudongkal", "", "ID", "360", "07", "", "", "", "-7.0981", "109.3243", "Asia/Jakarta"),
("1630200", "Rajapolah", "", "ID", "360", "30", "", "", "", "-7.221", "108.1896", "Asia/Jakarta"),
("1630328", "Purwokerto", "", "ID", "360", "07", "", "", "", "-7.42139", "109.23444", "Asia/Jakarta"),
("1630333", "Purwodadi", "", "ID", "360", "07", "", "", "", "-7.0868", "110.9158", "Asia/Jakarta"),
("1630341", "Purwakarta", "", "ID", "360", "30", "", "", "", "-6.55694", "107.44333", "Asia/Jakarta"),
("1630366", "Purbalingga", "", "ID", "360", "07", "", "", "", "-7.38806", "109.36389", "Asia/Jakarta"),
("1630416", "Pundong", "", "ID", "360", "10", "", "", "", "-7.95222", "110.34861", "Asia/Jakarta"),
("1630634", "Probolinggo", "", "ID", "360", "08", "", "", "", "-7.7543", "113.2159", "Asia/Jakarta"),
("1630649", "Prigen", "", "ID", "360", "08", "", "", "", "-7.68333", "112.61667", "Asia/Jakarta"),
("1630662", "Praya", "Прая", "ID", "360", "17", "Lombok (undefined)", "", "", "-8.70536", "116.27036", "Asia/Makassar"),
("1630681", "Candi Prambanan", "", "ID", "360", "07", "", "", "", "-7.75", "110.49417", "Asia/Jakarta"),
("1630723", "Poso", "Посо", "ID", "360", "21", "", "", "", "-1.3959", "120.7524", "Asia/Makassar"),
("1630789", "Pontianak", "Понтианак", "ID", "360", "11", "", "", "", "-0.03109", "109.32199", "Asia/Pontianak"),
("1630798", "Ponorogo", "", "ID", "360", "08", "", "", "", "-7.8685", "111.462", "Asia/Jakarta"),
("1630935", "Polewali", "", "ID", "360", "41", "", "", "", "-3.4324", "119.3435", "Asia/Makassar"),
("1630997", "Plumbon", "", "ID", "360", "30", "", "", "", "-6.705", "108.47278", "Asia/Jakarta"),
("1631271", "Petarukan", "", "ID", "360", "07", "", "", "", "-6.88333", "109.43333", "Asia/Jakarta"),
("1631393", "Prabumulih", "", "ID", "360", "32", "", "", "", "-3.43447", "104.23056", "Asia/Jakarta"),
("1631637", "Pemangkat", "", "ID", "360", "11", "", "", "", "1.16667", "108.96667", "Asia/Pontianak"),
("1631648", "Pemalang", "", "ID", "360", "07", "", "", "", "-6.9", "109.36667", "Asia/Jakarta"),
("1631733", "Pelabuhanratu", "", "ID", "360", "30", "", "", "", "-6.9875", "106.55139", "Asia/Jakarta"),
("1631761", "Pekanbaru", "Пеканбару", "ID", "360", "37", "", "", "", "0.53333", "101.45", "Asia/Jakarta"),
("1631766", "Pekalongan", "", "ID", "360", "07", "", "", "", "-6.8886", "109.6753", "Asia/Jakarta"),
("1631851", "Pecangaan", "", "ID", "360", "07", "", "", "", "-6.6978", "110.7107", "Asia/Jakarta"),
("1631905", "Payakumbuh", "", "ID", "360", "24", "", "", "", "-0.2159", "100.6334", "Asia/Jakarta"),
("1631992", "Pati", "Пати", "ID", "360", "07", "", "", "", "-6.7559", "111.038", "Asia/Jakarta"),
("1632033", "Pasuruan", "", "ID", "360", "08", "", "", "", "-7.6453", "112.9075", "Asia/Jakarta"),
("1632197", "Paseh", "", "ID", "360", "30", "", "", "", "-7.1026", "107.7641", "Asia/Jakarta"),
("1632228", "Pasarkemis", "", "ID", "360", "30", "", "", "", "-6.17028", "106.53028", "Asia/Jakarta"),
("1632276", "Parung", "", "ID", "360", "30", "", "", "", "-6.42139", "106.73306", "Asia/Jakarta"),
("1632334", "Pariaman", "", "ID", "360", "24", "", "", "", "-0.61898", "100.11997", "Asia/Jakarta"),
("1632353", "Parepare", "", "ID", "360", "38", "", "", "", "-4.0135", "119.6255", "Asia/Makassar"),
("1632358", "Pare", "", "ID", "360", "08", "", "", "", "-7.7679", "112.198", "Asia/Jakarta"),
("1632566", "Panji", "", "ID", "360", "08", "", "", "", "-7.72528", "114.09954", "Asia/Jakarta"),
("1632654", "Pangkalpinang", "", "ID", "360", "35", "", "", "", "-2.12914", "106.11377", "Asia/Jakarta"),
("1632694", "Pangkalanbuun", "", "ID", "360", "13", "", "", "", "-2.6832", "111.6259", "Asia/Pontianak"),
("1632823", "Pandeglang", "", "ID", "360", "33", "", "", "", "-6.3084", "106.1067", "Asia/Jakarta"),
("1632859", "Pandaan", "", "ID", "360", "08", "", "", "", "-7.65268", "112.6875", "Asia/Jakarta"),
("1632861", "Pandak", "", "ID", "360", "10", "", "", "", "-7.91306", "110.29361", "Asia/Jakarta"),
("1632903", "Panarukan", "", "ID", "360", "08", "", "", "", "-7.70181", "113.91844", "Asia/Jakarta"),
("1632937", "Pamulang", "", "ID", "360", "30", "", "", "", "-6.34278", "106.73833", "Asia/Jakarta"),
("1632974", "Pameungpeuk", "", "ID", "360", "30", "", "", "", "-7.01833", "107.60389", "Asia/Jakarta"),
("1632978", "Pamekasan", "", "ID", "360", "08", "", "", "", "-7.1568", "113.4746", "Asia/Jakarta"),
("1632998", "Pamanukan", "", "ID", "360", "30", "", "", "", "-6.28417", "107.81056", "Asia/Jakarta"),
("1633034", "Palu", "Пал", "ID", "360", "21", "", "", "", "-0.8917", "119.8707", "Asia/Makassar"),
("1633037", "Palopo", "", "ID", "360", "38", "", "", "", "-2.9925", "120.19694", "Asia/Makassar"),
("1633056", "Palimanan", "", "ID", "360", "30", "", "", "", "-6.70694", "108.42417", "Asia/Jakarta"),
("1633070", "Palembang", "Палембанг", "ID", "360", "32", "", "", "", "-2.91673", "104.7458", "Asia/Jakarta"),
("1633118", "Palangkaraya", "", "ID", "360", "13", "", "", "", "-2.2136", "113.9108", "Asia/Pontianak"),
("1633182", "Pakisaji", "", "ID", "360", "08", "", "", "", "-8.0665", "112.5981", "Asia/Jakarta"),
("1633308", "Pageralam", "", "ID", "360", "32", "", "", "", "-4.02177", "103.25093", "Asia/Jakarta"),
("1633419", "Padang", "Паданг", "ID", "360", "24", "", "", "", "-0.94924", "100.35427", "Asia/Jakarta"),
("1633442", "Paciran", "", "ID", "360", "08", "", "", "", "-6.87666", "112.37606", "Asia/Jakarta"),
("1633986", "Ngunut", "", "ID", "360", "08", "", "", "", "-8.1058", "112.01591", "Asia/Jakarta"),
("1634010", "Ngoro", "", "ID", "360", "08", "", "", "", "-7.68386", "112.25804", "Asia/Jakarta"),
("1634098", "Ngawi", "", "ID", "360", "30", "", "", "", "-7.4038", "111.4461", "Asia/Jakarta"),
("1634131", "Nganjuk", "", "ID", "360", "08", "", "", "", "-7.6051", "111.9035", "Asia/Jakarta"),
("1634266", "Negara", "", "ID", "360", "02", "", "", "", "-8.35694", "114.61694", "Asia/Makassar"),
("1634614", "Nabire", "", "ID", "360", "36", "", "", "", "-3.35989", "135.50074", "Asia/Jayapura"),
("1634678", "Muntok", "", "ID", "360", "35", "", "", "", "-2.06719", "105.16228", "Asia/Jakarta"),
("1634680", "Muntilan", "", "ID", "360", "07", "", "", "", "-7.58111", "110.29278", "Asia/Jakarta"),
("1634718", "Muncar", "", "ID", "360", "08", "", "", "", "-8.43333", "114.33333", "Asia/Jakarta"),
("1634954", "Mranggen", "", "ID", "360", "07", "", "", "", "-7.0268", "110.5158", "Asia/Jakarta"),
("1635111", "Mojokerto", "", "ID", "360", "08", "", "", "", "-7.4664", "112.4338", "Asia/Jakarta"),
("1635116", "Mojoagung", "", "ID", "360", "08", "", "", "", "-7.56667", "112.35", "Asia/Jakarta"),
("1635164", "Mlonggo", "", "ID", "360", "07", "", "", "", "-6.53333", "110.7", "Asia/Jakarta"),
("1635283", "Metro", "Метро", "ID", "360", "15", "", "", "", "-5.11306", "105.30667", "Asia/Jakarta"),
("1635342", "Mertoyudan", "", "ID", "360", "07", "", "", "", "-7.52", "110.22639", "Asia/Jakarta"),
("1635660", "Melati", "", "ID", "360", "10", "", "", "", "-7.73333", "110.36667", "Asia/Jakarta"),
("1635815", "Maumere", "", "ID", "360", "18", "", "", "", "-8.6199", "122.2111", "Asia/Makassar"),
("1635882", "Mataram", "Матарам", "ID", "360", "17", "Lombok (undefined)", "", "", "-8.58333", "116.11667", "Asia/Makassar"),
("1636022", "Martapura", "", "ID", "360", "12", "", "", "", "-3.4109", "114.8642", "Asia/Makassar"),
("1636121", "Margasari", "", "ID", "360", "07", "", "", "", "-7.1", "109.01667", "Asia/Jakarta"),
("1636125", "Margahayukencana", "", "ID", "360", "30", "", "", "", "-6.97083", "107.5675", "Asia/Jakarta"),
("1636308", "Manokwari", "Маноквари", "ID", "360", "39", "", "", "", "-0.86667", "134.08333", "Asia/Jayapura"),
("1636322", "Manismata", "", "ID", "360", "11", "", "", "", "-2.46667", "111.03333", "Asia/Pontianak"),
("1636426", "Manggar", "", "ID", "360", "35", "", "", "", "-2.88333", "108.26667", "Asia/Jakarta"),
("1636507", "Mendaha", "", "ID", "360", "05", "", "", "", "-1.0163", "103.59331", "Asia/Jakarta"),
("1636544", "Manado", "Манадо", "ID", "360", "31", "", "", "", "1.48218", "124.84892", "Asia/Makassar"),
("1636722", "Malang", "Маланг", "ID", "360", "08", "", "", "", "-7.9797", "112.6304", "Asia/Jakarta"),
("1636806", "Majene", "", "ID", "360", "41", "", "", "", "-3.5403", "118.9707", "Asia/Makassar"),
("1636808", "Majenang", "", "ID", "360", "07", "", "", "", "-7.2975", "108.7642", "Asia/Jakarta"),
("1636816", "Majalengka", "", "ID", "360", "30", "", "", "", "-6.83611", "108.22778", "Asia/Jakarta"),
("1636884", "Magelang", "Магеланг", "ID", "360", "07", "", "", "", "-7.47056", "110.21778", "Asia/Jakarta"),
("1636930", "Madiun", "", "ID", "360", "08", "", "", "", "-7.6298", "111.5239", "Asia/Jakarta"),
("1637001", "Luwuk", "", "ID", "360", "21", "", "", "", "-0.9516", "122.7875", "Asia/Makassar"),
("1637090", "Lumajang", "", "ID", "360", "08", "", "", "", "-8.1335", "113.2248", "Asia/Jakarta"),
("1637158", "Lubuklinggau", "", "ID", "360", "32", "", "", "", "-3.2945", "102.8614", "Asia/Jakarta"),
("1637510", "Loa Janan", "", "ID", "360", "14", "", "", "", "-0.58295", "117.09503", "Asia/Makassar"),
("1638063", "Lembang", "Лембанге", "ID", "360", "30", "", "", "", "-6.81167", "107.6175", "Asia/Jakarta"),
("1638217", "Lebaksiu", "", "ID", "360", "07", "", "", "", "-7.0496", "109.1441", "Asia/Jakarta"),
("1638284", "Lawang", "", "ID", "360", "08", "", "", "", "-7.8353", "112.6947", "Asia/Jakarta"),
("1638352", "Lasem", "", "ID", "360", "07", "", "", "", "-6.6922", "111.4527", "Asia/Jakarta"),
("1638562", "Lamongan", "", "ID", "360", "08", "", "", "", "-7.11667", "112.41667", "Asia/Jakarta"),
("1638775", "Lahat", "", "ID", "360", "32", "", "", "", "-3.78514", "103.54279", "Asia/Jakarta"),
("1638868", "Labuhanbajo", "Лабуанбаджо", "ID", "360", "18", "", "", "", "-8.4964", "119.8877", "Asia/Makassar"),
("1638870", "Labuan", "", "ID", "360", "33", "", "", "", "-6.3784", "105.83", "Asia/Jakarta"),
("1638981", "Kutoarjo", "", "ID", "360", "07", "", "", "", "-7.71694", "109.91278", "Asia/Jakarta"),
("1639002", "Kuta", "Кута", "ID", "360", "02", "", "", "", "-8.72332", "115.17234", "Asia/Makassar"),
("1639094", "Kuningan", "", "ID", "360", "30", "", "", "", "-6.97583", "108.48306", "Asia/Jakarta"),
("1639215", "Kudus", "", "ID", "360", "07", "", "", "", "-6.8048", "110.8405", "Asia/Jakarta"),
("1639286", "Kualatungkal", "", "ID", "360", "05", "", "", "", "-0.81623", "103.46111", "Asia/Jakarta"),
("1639304", "Kualakapuas", "", "ID", "360", "13", "", "", "", "-3.00913", "114.38759", "Asia/Pontianak"),
("1639337", "Kroya", "", "ID", "360", "07", "", "", "", "-7.63306", "109.24611", "Asia/Jakarta"),
("1639356", "Krian", "", "ID", "360", "08", "", "", "", "-7.4104", "112.5792", "Asia/Jakarta"),
("1639362", "Kresek", "", "ID", "360", "30", "", "", "", "-6.13139", "106.37972", "Asia/Jakarta"),
("1639431", "Kraksaan", "", "ID", "360", "08", "", "", "", "-7.75845", "113.39624", "Asia/Jakarta"),
("1639524", "Kotabumi", "", "ID", "360", "15", "", "", "", "-4.82505", "104.8817", "Asia/Jakarta"),
("1639850", "Klungkung", "", "ID", "360", "02", "", "", "", "-8.53333", "115.4", "Asia/Makassar"),
("1639900", "Klaten", "", "ID", "360", "07", "", "", "", "-7.70583", "110.60639", "Asia/Jakarta"),
("1639925", "Klangenan", "", "ID", "360", "30", "", "", "", "-6.70944", "108.44", "Asia/Jakarta"),
("1640044", "Kijang", "", "ID", "360", "40", "", "", "", "0.9", "104.63333", "Asia/Jakarta"),
("1640138", "Ketanggungan", "", "ID", "360", "07", "", "", "", "-6.9383", "108.891", "Asia/Jakarta"),
("1640185", "Kertosono", "", "ID", "360", "08", "", "", "", "-7.58333", "112.1", "Asia/Jakarta"),
("1640296", "Kepanjen", "", "ID", "360", "08", "", "", "", "-8.1303", "112.5727", "Asia/Jakarta"),
("1640344", "Kendari", "Кендари", "ID", "360", "22", "", "", "", "-3.9778", "122.51507", "Asia/Makassar"),
("1640354", "Kencong", "", "ID", "360", "08", "", "", "", "-8.28333", "113.36667", "Asia/Jakarta"),
("1640576", "Kefamenanu", "", "ID", "360", "18", "", "", "", "-9.44667", "124.47806", "Asia/Makassar"),
("1640581", "Kedungwuni", "", "ID", "360", "07", "", "", "", "-6.97038", "109.64794", "Asia/Jakarta"),
("1640585", "Kedungwaru", "", "ID", "360", "08", "", "", "", "-8.06667", "111.91667", "Asia/Jakarta"),
("1640660", "Kediri", "", "ID", "360", "08", "", "", "", "-7.81667", "112.01667", "Asia/Jakarta"),
("1640755", "Kebonarun", "", "ID", "360", "07", "", "", "", "-7.70028", "110.56306", "Asia/Jakarta"),
("1640765", "Kebomas", "", "ID", "360", "08", "", "", "", "-7.16667", "112.6333", "Asia/Jakarta"),
("1640902", "Kawalu", "", "ID", "360", "30", "", "", "", "-7.3817", "108.2082", "Asia/Jakarta"),
("1640972", "Katabu", "", "ID", "360", "22", "", "", "", "-4.9333", "122.5167", "Asia/Makassar"),
("1641184", "Karangsembung", "", "ID", "360", "30", "", "", "", "-6.8487", "108.6422", "Asia/Jakarta"),
("1641301", "Karangasem", "Денпасар", "ID", "360", "02", "", "", "", "-8.45", "115.61667", "Asia/Makassar"),
("1641333", "Karanganom", "", "ID", "360", "07", "", "", "", "-7.64889", "110.625", "Asia/Jakarta"),
("1641342", "Karangampel", "", "ID", "360", "30", "", "", "", "-6.46222", "108.45194", "Asia/Jakarta"),
("1641792", "Kamal", "Камаль", "ID", "360", "08", "", "", "", "-7.16778", "112.71917", "Asia/Jakarta"),
("1641977", "Kalianget", "", "ID", "360", "08", "", "", "", "-7.0537", "113.94244", "Asia/Jakarta"),
("1642317", "Juwana", "", "ID", "360", "07", "", "", "", "-6.715", "111.1514", "Asia/Jakarta"),
("1642414", "Jombang", "", "ID", "360", "08", "", "", "", "-7.54595", "112.23307", "Asia/Jakarta"),
("1642437", "Jogonalan", "", "ID", "360", "07", "", "", "", "-7.70361", "110.53611", "Asia/Jakarta"),
("1642588", "Jember", "", "ID", "360", "08", "", "", "", "-8.17211", "113.69953", "Asia/Jakarta"),
("1642628", "Jekulo", "", "ID", "360", "07", "", "", "", "-6.8057", "110.9262", "Asia/Jakarta"),
("1642684", "Jatiwangi", "", "ID", "360", "30", "", "", "", "-6.73361", "108.26278", "Asia/Jakarta"),
("1642692", "Jatiroto", "", "ID", "360", "07", "", "", "", "-7.88333", "111.11667", "Asia/Jakarta"),
("1642726", "Jatibarang", "", "ID", "360", "30", "", "", "", "-6.47472", "108.31528", "Asia/Jakarta"),
("1642754", "Jaten", "", "ID", "360", "07", "", "", "", "-7.57722", "110.8975", "Asia/Jakarta"),
("1642858", "Jambi City", "Джамби", "ID", "360", "05", "", "", "", "-1.6", "103.61667", "Asia/Jakarta"),
("1642911", "Jakarta", "Джакарта", "ID", "360", "04", "", "", "", "-6.21462", "106.84513", "Asia/Jakarta"),
("1643078", "Indramayu", "", "ID", "360", "30", "", "", "", "-6.32639", "108.32", "Asia/Jakarta"),
("1643761", "Grogol", "", "ID", "360", "07", "", "", "", "-7.60111", "110.81861", "Asia/Jakarta"),
("1643776", "Gresik", "", "ID", "360", "08", "", "", "", "-7.15389", "112.65611", "Asia/Jakarta"),
("1643837", "Gorontalo", "Горонтало", "ID", "360", "34", "", "", "", "0.5412", "123.0595", "Asia/Makassar"),
("1643898", "Gongdanglegi Kulon", "", "ID", "360", "08", "", "", "", "-8.17529", "112.63594", "Asia/Jakarta"),
("1643920", "Gombong", "", "ID", "360", "07", "", "", "", "-7.60722", "109.51417", "Asia/Jakarta"),
("1643981", "Godean", "", "ID", "360", "10", "", "", "", "-7.76972", "110.29389", "Asia/Jakarta"),
("1644178", "Genteng", "", "ID", "360", "08", "", "", "", "-8.36667", "114.15", "Asia/Jakarta"),
("1644349", "Gedangan", "", "ID", "360", "08", "", "", "", "-7.39083", "112.72667", "Asia/Jakarta"),
("1644360", "Gebog", "", "ID", "360", "07", "", "", "", "-6.735", "110.8444", "Asia/Jakarta"),
("1644522", "Gampengrejo", "", "ID", "360", "08", "", "", "", "-7.76667", "112.01667", "Asia/Jakarta"),
("1644557", "Gambiran Satu", "", "ID", "360", "08", "", "", "", "-8.3939", "114.1464", "Asia/Jakarta"),
("1644605", "Galesong", "", "ID", "360", "38", "", "", "", "-5.3166", "119.3661", "Asia/Makassar"),
("1644932", "Ende", "", "ID", "360", "18", "", "", "", "-8.8432", "121.6623", "Asia/Makassar"),
("1645133", "Dumai", "Думай", "ID", "360", "37", "", "", "", "1.66711", "101.44316", "Asia/Jakarta"),
("1645154", "Dukuhturi", "", "ID", "360", "07", "", "", "", "-6.9", "109.08333", "Asia/Jakarta"),
("1645220", "Driyorejo", "", "ID", "360", "08", "", "", "", "-7.3659", "112.6219", "Asia/Jakarta"),
("1645428", "Diwek", "", "ID", "360", "08", "", "", "", "-7.57897", "112.23109", "Asia/Jakarta"),
("1645518", "Depok", "", "ID", "360", "10", "", "", "", "-7.7625", "110.43167", "Asia/Jakarta"),
("1645524", "Depok", "", "ID", "360", "30", "", "", "", "-6.4", "106.81861", "Asia/Jakarta"),
("1645528", "Denpasar", "Денпасар", "ID", "360", "02", "", "", "", "-8.65", "115.21667", "Asia/Makassar"),
("1645559", "Demak", "Демак", "ID", "360", "07", "", "", "", "-6.8909", "110.6396", "Asia/Jakarta"),
("1645565", "Delanggu", "", "ID", "360", "07", "", "", "", "-7.61667", "110.68333", "Asia/Jakarta"),
("1645749", "Dampit", "", "ID", "360", "08", "", "", "", "-8.21162", "112.74934", "Asia/Jakarta"),
("1645875", "Curup", "", "ID", "360", "03", "", "", "", "-3.4703", "102.5207", "Asia/Jakarta"),
("1645895", "Curug", "", "ID", "360", "33", "", "", "", "-6.26583", "106.55639", "Asia/Jakarta"),
("1645976", "Comal", "", "ID", "360", "07", "", "", "", "-6.9053", "109.5347", "Asia/Jakarta"),
("1645978", "Colomadu", "", "ID", "360", "07", "", "", "", "-7.53333", "110.75", "Asia/Jakarta"),
("1646034", "Citeureup", "", "ID", "360", "30", "", "", "", "-6.48556", "106.88194", "Asia/Jakarta"),
("1646170", "Cirebon", "Чиребон", "ID", "360", "30", "", "", "", "-6.7063", "108.557", "Asia/Jakarta"),
("1646194", "Ciputat", "", "ID", "360", "30", "", "", "", "-6.2375", "106.69556", "Asia/Jakarta"),
("1646448", "Cimahi", "", "ID", "360", "30", "", "", "", "-6.87222", "107.5425", "Asia/Jakarta"),
("1646492", "Cileunyi", "", "ID", "360", "30", "", "", "", "-6.93889", "107.75278", "Asia/Jakarta"),
("1646494", "Cileungsir", "", "ID", "360", "30", "", "", "", "-6.39472", "106.95917", "Asia/Jakarta"),
("1646678", "Cikarang", "", "ID", "360", "30", "", "", "", "-6.26111", "107.15278", "Asia/Jakarta"),
("1646698", "Cikampek", "", "ID", "360", "30", "", "", "", "-6.41972", "107.45583", "Asia/Jakarta"),
("1646893", "Cicurug", "", "ID", "360", "30", "", "", "", "-6.78139", "106.7825", "Asia/Jakarta"),
("1647003", "Cibinong", "Сибинонге", "ID", "360", "30", "", "", "", "-6.48167", "106.85417", "Asia/Jakarta"),
("1647149", "Ciamis", "", "ID", "360", "30", "", "", "", "-7.3257", "108.3534", "Asia/Jakarta"),
("1647179", "Cepu", "", "ID", "360", "07", "", "", "", "-7.1475", "111.5906", "Asia/Jakarta"),
("1647187", "Ceper", "", "ID", "360", "07", "", "", "", "-7.67417", "110.67889", "Asia/Jakarta"),
("1647298", "Caringin", "", "ID", "360", "30", "", "", "", "-6.70611", "106.82139", "Asia/Jakarta"),
("1647383", "Ciampea", "", "ID", "360", "30", "", "", "", "-6.55472", "106.70083", "Asia/Jakarta"),
("1647834", "Bulakamba", "", "ID", "360", "07", "", "", "", "-6.8748", "108.9559", "Asia/Jakarta"),
("1647866", "Bukittinggi", "", "ID", "360", "24", "", "", "", "-0.30907", "100.37055", "Asia/Jakarta"),
("1647936", "Buduran", "", "ID", "360", "08", "", "", "", "-7.4281", "112.7234", "Asia/Jakarta"),
("1647991", "Buaran", "", "ID", "360", "07", "", "", "", "-7.05", "109.55", "Asia/Jakarta"),
("1648082", "Boyolangu", "", "ID", "360", "08", "", "", "", "-8.1181", "111.8935", "Asia/Jakarta"),
("1648084", "Boyolali", "", "ID", "360", "07", "", "", "", "-7.53306", "110.59583", "Asia/Jakarta"),
("1648186", "Bontang", "", "ID", "360", "14", "", "", "", "0.1324", "117.4854", "Asia/Makassar"),
("1648266", "Bondowoso", "", "ID", "360", "08", "", "", "", "-7.91346", "113.82145", "Asia/Jakarta"),
("1648451", "Bojonegoro", "", "ID", "360", "08", "", "", "", "-7.1502", "111.8817", "Asia/Jakarta"),
("1648473", "Bogor", "Богор", "ID", "360", "30", "", "", "", "-6.59444", "106.78917", "Asia/Jakarta"),
("1648568", "Blora", "", "ID", "360", "07", "", "", "", "-6.9698", "111.4186", "Asia/Jakarta"),
("1648580", "Blitar", "", "ID", "360", "08", "", "", "", "-8.0983", "112.1681", "Asia/Jakarta"),
("1648636", "Bitung", "", "ID", "360", "31", "", "", "", "1.45697", "125.1895", "Asia/Makassar"),
("1648759", "Bima", "Бим", "ID", "360", "17", "Bima City (undefined)", "", "", "-8.46006", "118.72667", "Asia/Makassar"),
("1648918", "Besuki", "", "ID", "360", "08", "", "", "", "-7.73379", "113.69785", "Asia/Jakarta"),
("1649150", "Bengkulu", "Бенгкулу", "ID", "360", "03", "", "", "", "-3.80044", "102.26554", "Asia/Jakarta"),
("1649378", "Bekasi", "Бекаси", "ID", "360", "30", "", "", "", "-6.2349", "106.9896", "Asia/Jakarta"),
("1649593", "Baturaja", "", "ID", "360", "32", "", "", "", "-4.12891", "104.16695", "Asia/Jakarta"),
("1649595", "Baturaden", "", "ID", "360", "07", "", "", "", "-7.3", "109.21667", "Asia/Jakarta"),
("1649824", "Batu", "Батый", "ID", "360", "08", "", "", "", "-7.87", "112.52833", "Asia/Jakarta"),
("1649881", "Batang", "", "ID", "360", "07", "", "", "", "-6.4846", "110.7083", "Asia/Jakarta"),
("1650064", "Barabai", "", "ID", "360", "12", "", "", "", "-2.58333", "115.38333", "Asia/Makassar"),
("1650077", "Banyuwangi", "", "ID", "360", "08", "", "", "", "-8.2325", "114.35755", "Asia/Jakarta"),
("1650095", "Banyumas", "", "ID", "360", "07", "", "", "", "-7.51417", "109.29417", "Asia/Jakarta"),
("1650119", "Bantul", "", "ID", "360", "10", "", "", "", "-7.88806", "110.32889", "Asia/Jakarta"),
("1650213", "Banjarmasin", "", "ID", "360", "12", "", "", "", "-3.31987", "114.59075", "Asia/Makassar"),
("1650227", "Banjaran", "", "ID", "360", "30", "", "", "", "-7.04528", "107.58778", "Asia/Jakarta"),
("1650232", "Banjar", "", "ID", "360", "02", "", "", "", "-8.19", "114.9675", "Asia/Makassar"),
("1650234", "Banjar", "", "ID", "360", "30", "", "", "", "-7.1955", "107.4313", "Asia/Jakarta"),
("1650298", "Bangkalan", "", "ID", "360", "08", "", "", "", "-7.0455", "112.7351", "Asia/Jakarta"),
("1650319", "Bangil", "", "ID", "360", "08", "", "", "", "-7.59939", "112.8186", "Asia/Jakarta"),
("1650357", "Bandung", "Бандунг", "ID", "360", "30", "", "", "", "-6.90389", "107.61861", "Asia/Jakarta"),
("1650434", "Bambanglipuro", "", "ID", "360", "10", "", "", "", "-7.95", "110.28333", "Asia/Jakarta"),
("1650460", "Balung", "", "ID", "360", "08", "", "", "", "-7.73333", "113.91667", "Asia/Jakarta"),
("1650527", "Balikpapan", "Баликпапан", "ID", "360", "14", "", "", "", "-1.26753", "116.82887", "Asia/Makassar"),
("1650572", "Balapulang", "", "ID", "360", "07", "", "", "", "-7.05", "109.08333", "Asia/Jakarta"),
("1650600", "Balaipungut", "", "ID", "360", "37", "", "", "", "1.05949", "101.29054", "Asia/Jakarta"),
("1650670", "Baki", "", "ID", "360", "07", "", "", "", "-7.61278", "110.78389", "Asia/Jakarta"),
("1650815", "Baekrajan", "Бэ", "ID", "360", "07", "", "", "", "-6.7674", "110.8541", "Asia/Jakarta"),
("1650888", "Babat", "Бабат", "ID", "360", "08", "", "", "", "-7.11282", "112.16354", "Asia/Jakarta"),
("1651103", "Atambua", "Атамбуа", "ID", "360", "18", "", "", "", "-9.10611", "124.8925", "Asia/Makassar"),
("1651112", "Astanajapura", "", "ID", "360", "30", "", "", "", "-6.8017", "108.6311", "Asia/Jakarta"),
("1651226", "Arjawinangun", "", "ID", "360", "30", "", "", "", "-6.64528", "108.41028", "Asia/Jakarta"),
("1651461", "Amuntai", "", "ID", "360", "12", "", "", "", "-2.41773", "115.24941", "Asia/Makassar"),
("1651531", "Ambon", "Амбон", "ID", "360", "28", "", "", "", "-3.69543", "128.1814", "Asia/Jayapura"),
("1651555", "Ambarawa", "", "ID", "360", "07", "", "", "", "-7.26333", "110.3975", "Asia/Jakarta"),
("1651591", "Amahai", "", "ID", "360", "28", "", "", "", "-3.33984", "128.91975", "Asia/Jayapura"),
("1651887", "Adiwerna", "", "ID", "360", "07", "", "", "", "-6.9375", "109.1325", "Asia/Jakarta"),
("1963770", "Padalarang", "", "ID", "360", "30", "", "", "", "-6.83778", "107.47278", "Asia/Jakarta"),
("1964032", "Ciranjang-hilir", "", "ID", "360", "30", "", "", "", "-6.82", "107.25722", "Asia/Jakarta"),
("1985663", "Cikupa", "", "ID", "360", "30", "", "", "", "-6.23639", "106.50833", "Asia/Jakarta"),
("1990589", "Teluknaga", "", "ID", "360", "30", "", "", "", "-6.09889", "106.63806", "Asia/Jakarta"),
("2002872", "Wonosari", "", "ID", "360", "10", "", "", "", "-7.96556", "110.60361", "Asia/Jakarta"),
("2005057", "Gamping Lor", "", "ID", "360", "10", "", "", "", "-7.79556", "110.32639", "Asia/Jakarta"),
("2005237", "Kasihan", "", "ID", "360", "10", "", "", "", "-7.82694", "110.32917", "Asia/Jakarta"),
("2010971", "Ngemplak", "", "ID", "360", "07", "", "", "", "-7.54972", "110.71639", "Asia/Jakarta"),
("2010985", "Kartasura", "", "ID", "360", "07", "", "", "", "-7.55194", "110.73778", "Asia/Jakarta"),
("2011457", "Gatak", "", "ID", "360", "07", "", "", "", "-7.59083", "110.70444", "Asia/Jakarta"),
("2057087", "Kupang", "Купанге", "ID", "360", "18", "", "", "", "-10.1718", "123.6075", "Asia/Makassar"),
("2082600", "Jayapura", "Джаяпура", "ID", "360", "36", "", "", "", "-2.53371", "140.71813", "Asia/Jayapura"),
("2082727", "Abepura", "", "ID", "360", "36", "", "", "", "-2.5964", "140.6324", "Asia/Jayapura"),
("7084521", "Seririt", "Серирит", "ID", "360", "02", "", "", "", "-8.1928", "114.9388", "Asia/Makassar"),
("7870153", "Masjid Jamie Baitul Muttaqien", "", "ID", "360", "30", "", "", "", "-6.36836", "107.9558", "Asia/Jakarta"),
("8224624", "City of Balikpapan", "", "ID", "360", "14", "", "", "", "-1.24204", "116.89419", "Asia/Makassar"),
("8449493", "Pekan Bahapal", "", "ID", "360", "26", "", "", "", "3.11313", "99.17352", "Asia/Jakarta"),
("8581443", "South Tangerang", "", "ID", "360", "33", "", "", "", "-6.28862", "106.71789", "Asia/Jakarta"),
("2960964", "Loch Garman", "", "IE", "372", "L", "30", "", "", "52.33417", "-6.4575", "Europe/Dublin"),
("2960992", "Waterford", "Уотерфорд", "IE", "372", "M", "27", "", "", "52.25833", "-7.11194", "Europe/Dublin"),
("2961123", "Tralee", "Трали", "IE", "372", "M", "11", "", "", "52.27042", "-9.70264", "Europe/Dublin"),
("2961284", "Tallaght", "Талла", "IE", "372", "L", "07", "", "", "53.2859", "-6.37344", "Europe/Dublin"),
("2961297", "Swords", "Сордс", "IE", "372", "L", "35", "", "", "53.45972", "-6.21806", "Europe/Dublin"),
("2961423", "Sligo", "Слайго", "IE", "372", "C", "25", "", "", "54.26969", "-8.46943", "Europe/Dublin"),
("2962290", "Droichead Nua", "", "IE", "372", "L", "12", "", "", "53.18194", "-6.79667", "Europe/Dublin"),
("2962308", "Navan", "Ан-Уавь", "IE", "372", "L", "21", "", "", "53.65278", "-6.68139", "Europe/Dublin"),
("2962334", "Naas", "", "IE", "372", "L", "12", "", "", "53.21583", "-6.66694", "Europe/Dublin"),
("2962361", "An Muileann gCearr", "", "IE", "372", "L", "29", "", "", "53.53333", "-7.35", "Europe/Dublin"),
("2962725", "Malahide", "Малахайд", "IE", "372", "L", "07", "", "", "53.45083", "-6.15444", "Europe/Dublin"),
("2962785", "Lucan", "", "IE", "372", "L", "07", "", "", "53.35736", "-6.44859", "Europe/Dublin"),
("2962943", "Luimneach", "Лимерик", "IE", "372", "M", "16", "", "", "52.66472", "-8.62306", "Europe/Dublin"),
("2962961", "Letterkenny", "Леттеркенни", "IE", "372", "U", "06", "", "", "54.95", "-7.73333", "Europe/Dublin"),
("2962974", "Leixlip", "Лейкслип", "IE", "372", "L", "12", "", "", "53.36583", "-6.49556", "Europe/Dublin"),
("2963398", "Kilkenny", "Килкенни", "IE", "372", "L", "13", "", "", "52.65417", "-7.25222", "Europe/Dublin"),
("2964180", "Gaillimh", "Голуэй", "IE", "372", "C", "10", "", "", "53.27194", "-9.04889", "Europe/Dublin"),
("2964303", "Finglas", "", "IE", "372", "L", "33", "", "", "53.38917", "-6.29694", "Europe/Dublin"),
("2964405", "Ennis", "Эннис", "IE", "372", "M", "03", "", "", "52.84361", "-8.98639", "Europe/Dublin"),
("2964506", "Dun Laoghaire", "Дун-Лэаре", "IE", "372", "L", "34", "", "", "53.29395", "-6.13586", "Europe/Dublin"),
("2964540", "Dundalk", "Дандолк", "IE", "372", "L", "19", "", "", "54", "-6.41667", "Europe/Dublin"),
("2964574", "Dublin", "Дублин", "IE", "372", "L", "33", "", "", "53.33306", "-6.24889", "Europe/Dublin"),
("2964661", "Drogheda", "Дроэда", "IE", "372", "L", "19", "", "", "53.71889", "-6.34778", "Europe/Dublin"),
("2965140", "Cork", "Корк", "IE", "372", "M", "04", "", "", "51.89797", "-8.47061", "Europe/Dublin"),
("2965353", "Cluain Meala", "", "IE", "372", "M", "40", "", "", "52.355", "-7.70389", "Europe/Dublin"),
("2965529", "Celbridge", "Селбридж", "IE", "372", "L", "12", "", "", "53.33861", "-6.54361", "Europe/Dublin"),
("2965768", "Carlow", "", "IE", "372", "L", "01", "", "", "52.84083", "-6.92611", "Europe/Dublin"),
("2966110", "Blanchardstown", "", "IE", "372", "L", "35", "", "", "53.38806", "-6.37556", "Europe/Dublin"),
("2966794", "Balbriggan", "Балбригган", "IE", "372", "L", "07", "", "", "53.61278", "-6.18194", "Europe/Dublin"),
("2966839", "Athlone", "", "IE", "372", "L", "29", "", "", "53.43333", "-7.95", "Europe/Dublin"),
("3315278", "Sandyford", "", "IE", "372", "L", "07", "", "", "53.2747", "-6.2253", "Europe/Dublin"),
("6691033", "Donaghmede", "", "IE", "372", "L", "", "", "", "53.39845", "-6.16179", "Europe/Dublin"),
("281184", "Jerusalem", "Иерусалим", "IL", "376", "06", "", "", "", "31.76904", "35.21633", "Asia/Jerusalem"),
("293100", "Safed", "Цфат", "IL", "376", "03", "", "", "", "32.96465", "35.496", "Asia/Jerusalem"),
("293207", "Yehud", "Йехуд", "IL", "376", "02", "", "", "", "32.03317", "34.89091", "Asia/Jerusalem"),
("293222", "Yavne", "Явне", "IL", "376", "02", "", "", "", "31.88078", "34.73843", "Asia/Jerusalem"),
("293253", "Yafo", "Яффа", "IL", "376", "05", "", "", "", "32.05043", "34.75224", "Asia/Jerusalem"),
("293286", "Umm el Fahm", "", "IL", "376", "04", "", "", "", "32.51725", "35.15349", "Asia/Jerusalem"),
("293308", "Tirat Karmel", "Тират Кармель", "IL", "376", "04", "", "", "", "32.76021", "34.97183", "Asia/Jerusalem"),
("293322", "Tiberias", "Тверия", "IL", "376", "03", "", "", "", "32.7922", "35.53124", "Asia/Jerusalem"),
("293397", "Tel Aviv", "Тель-Авив", "IL", "376", "05", "", "", "", "32.08088", "34.78057", "Asia/Jerusalem"),
("293420", "maalot Tarshiha", "Маалот-Таршиха", "IL", "376", "03", "", "", "", "33.01667", "35.26667", "Asia/Jerusalem"),
("293426", "Tamra", "Тамра", "IL", "376", "03", "", "", "", "32.85301", "35.1987", "Asia/Jerusalem"),
("293619", "Sederot", "Сдерот", "IL", "376", "01", "", "", "", "31.525", "34.59693", "Asia/Jerusalem"),
("293655", "Sakhnin", "Сахнин", "IL", "376", "03", "", "", "", "32.86422", "35.29707", "Asia/Jerusalem"),
("293690", "Rosh Ha'Ayin", "", "IL", "376", "02", "", "", "", "32.09556", "34.95664", "Asia/Jerusalem"),
("293703", "Rishon LeZiyyon", "Ришон-ле-Цион", "IL", "376", "02", "", "", "", "31.97102", "34.78939", "Asia/Jerusalem"),
("293768", "Ramla", "Рамла", "IL", "376", "02", "", "", "", "31.92923", "34.86563", "Asia/Jerusalem"),
("293783", "Ramat HaSharon", "", "IL", "376", "05", "", "", "", "32.14613", "34.8394", "Asia/Jerusalem"),
("293788", "Ramat Gan", "Рамат-Ган", "IL", "376", "05", "", "", "", "32.08227", "34.81065", "Asia/Jerusalem"),
("293807", "Ra'anana", "", "IL", "376", "02", "", "", "", "32.1836", "34.87386", "Asia/Jerusalem"),
("293822", "Qiryat Yam", "Кирьят-Ям", "IL", "376", "04", "", "", "", "32.84966", "35.06973", "Asia/Jerusalem"),
("293825", "Qiryat Shemona", "Кирьят-Шмона", "IL", "376", "03", "", "", "", "33.20733", "35.57212", "Asia/Jerusalem"),
("293831", "Qiryat Motzkin", "Кирьят-Моцкин", "IL", "376", "04", "", "", "", "32.83706", "35.0776", "Asia/Jerusalem"),
("293842", "Qiryat Gat", "Кирьят-Гат", "IL", "376", "01", "", "", "", "31.60998", "34.76422", "Asia/Jerusalem"),
("293844", "Qiryat Bialik", "Кирьят-Бялик", "IL", "376", "04", "", "", "", "32.8275", "35.08583", "Asia/Jerusalem"),
("293845", "Qiryat Ata", "Кирьят-Ата", "IL", "376", "04", "", "", "", "32.81034", "35.11255", "Asia/Jerusalem"),
("293896", "Qalansuwa", "", "IL", "376", "02", "", "", "", "32.28493", "34.98106", "Asia/Jerusalem"),
("293918", "Petah Tiqwa", "", "IL", "376", "02", "", "", "", "32.08708", "34.88747", "Asia/Jerusalem"),
("293962", "Or Yehuda", "", "IL", "376", "05", "", "", "", "32.02923", "34.85788", "Asia/Jerusalem"),
("293992", "Ofaqim", "", "IL", "376", "01", "", "", "", "31.3141", "34.62025", "Asia/Jerusalem"),
("294068", "Netivot", "Нетивот", "IL", "376", "01", "", "", "", "31.42215", "34.58858", "Asia/Jerusalem"),
("294071", "Netanya", "Нетания", "IL", "376", "02", "", "", "", "32.33292", "34.85992", "Asia/Jerusalem"),
("294074", "Ness Ziona", "", "IL", "376", "02", "", "", "", "31.92933", "34.79868", "Asia/Jerusalem"),
("294078", "Nesher", "Нешер", "IL", "376", "04", "", "", "", "32.76651", "35.05003", "Asia/Jerusalem"),
("294098", "Nazareth", "Назарет", "IL", "376", "03", "", "", "", "32.69925", "35.30483", "Asia/Jerusalem"),
("294117", "Nahariya", "Нагария", "IL", "376", "03", "", "", "", "33.01135", "35.09467", "Asia/Jerusalem"),
("294210", "Migdal Ha`Emeq", "Мигдаль ХаЭмек", "IL", "376", "03", "", "", "", "32.67597", "35.23986", "Asia/Jerusalem"),
("294244", "Mevo Betar", "", "IL", "376", "06", "", "", "", "31.72177", "35.10669", "Asia/Jerusalem"),
("294387", "Maghar", "", "IL", "376", "03", "", "", "", "32.88984", "35.40703", "Asia/Jerusalem"),
("294421", "Lod", "Лод", "IL", "376", "02", "", "", "", "31.9467", "34.8903", "Asia/Jerusalem"),
("294514", "Kfar Saba", "Кефар-Сава", "IL", "376", "02", "", "", "", "32.175", "34.90694", "Asia/Jerusalem"),
("294577", "Karmi'el", "Кармиэль", "IL", "376", "03", "", "", "", "32.91669", "35.29918", "Asia/Jerusalem"),
("294604", "Kafr Qasim", "", "IL", "376", "02", "", "", "", "32.11406", "34.97624", "Asia/Jerusalem"),
("294608", "Kafr Manda", "", "IL", "376", "03", "", "", "", "32.81034", "35.26009", "Asia/Jerusalem"),
("294610", "Kafr Kanna", "", "IL", "376", "03", "", "", "", "32.7466", "35.34242", "Asia/Jerusalem"),
("294622", "Judieda Makr", "", "IL", "376", "03", "", "", "", "32.9282", "35.15705", "Asia/Jerusalem"),
("294751", "Holon", "Холон", "IL", "376", "05", "", "", "", "32.01034", "34.77918", "Asia/Jerusalem"),
("294760", "Hod HaSharon", "Ход-ха-Шарон", "IL", "376", "02", "", "", "", "32.15934", "34.8932", "Asia/Jerusalem"),
("294778", "Herzliyya", "Герцлия", "IL", "376", "05", "", "", "", "32.16627", "34.82536", "Asia/Jerusalem"),
("294801", "Haifa", "Хайфа", "IL", "376", "04", "", "", "", "32.81841", "34.9885", "Asia/Jerusalem"),
("294946", "Hadera", "Хадера", "IL", "376", "04", "", "", "", "32.43645", "34.91956", "Asia/Jerusalem"),
("294981", "Giv`at Shemu'el", "", "IL", "376", "05", "", "", "", "32.07817", "34.84858", "Asia/Jerusalem"),
("294999", "Giv`atayim", "Гиватаим", "IL", "376", "05", "", "", "", "32.07225", "34.81253", "Asia/Jerusalem"),
("295127", "Tirah", "", "IL", "376", "02", "", "", "", "32.2341", "34.95023", "Asia/Jerusalem"),
("295130", "Et Taiyiba", "", "IL", "376", "02", "", "", "", "32.26616", "35.00893", "Asia/Jerusalem"),
("295174", "Er Reina", "", "IL", "376", "03", "", "", "", "32.72339", "35.31622", "Asia/Jerusalem"),
("295277", "Eilat", "Эйлат", "IL", "376", "01", "", "", "", "29.55805", "34.94821", "Asia/Jerusalem"),
("295328", "Dimona", "Димона", "IL", "376", "01", "", "", "", "31.07127", "35.0337", "Asia/Jerusalem"),
("295365", "Daliyat el Karmil", "Кармель", "IL", "376", "04", "", "", "", "32.69383", "35.04686", "Asia/Jerusalem"),
("295432", "Bet Shemesh", "Бейт-Шемеш", "IL", "376", "06", "", "", "", "31.73072", "34.99293", "Asia/Jerusalem"),
("295435", "Bet She'an", "Бейт-Шеан", "IL", "376", "03", "", "", "", "32.49728", "35.49632", "Asia/Jerusalem"),
("295514", "Bene Beraq", "", "IL", "376", "05", "", "", "", "32.08074", "34.8338", "Asia/Jerusalem"),
("295530", "Beersheba", "Беэр-Шева", "IL", "376", "01", "", "", "", "31.25181", "34.7913", "Asia/Jerusalem"),
("295548", "Bat Yam", "Бат-Ям", "IL", "376", "05", "", "", "", "32.02379", "34.75185", "Asia/Jerusalem"),
("295620", "Ashqelon", "Ашкелон", "IL", "376", "01", "", "", "", "31.66926", "34.57149", "Asia/Jerusalem"),
("295629", "Ashdod", "Ашдод", "IL", "376", "01", "", "", "", "31.79213", "34.64966", "Asia/Jerusalem"),
("295657", "'Arad", "Арад", "IL", "376", "01", "", "", "", "31.25882", "35.21282", "Asia/Jerusalem"),
("295721", "`Akko", "Акко", "IL", "376", "03", "", "", "", "32.92814", "35.07647", "Asia/Jerusalem"),
("295739", "`Afula `Illit", "", "IL", "376", "03", "", "", "", "32.63323", "35.32522", "Asia/Jerusalem"),
("6693679", "Modiin", "", "IL", "376", "02", "", "", "", "31.89825", "35.01051", "Asia/Jerusalem"),
("6945291", "Old City", "", "IL", "376", "06", "", "", "", "31.77667", "35.23417", "Asia/Jerusalem"),
("7498240", "West Jerusalem", "", "IL", "376", "06", "", "", "", "31.78199", "35.21961", "Asia/Jerusalem"),
("8199378", "Modiin Ilit", "", "IL", "376", "06", "", "", "", "31.93221", "35.04416", "Asia/Jerusalem"),
("8199394", "Ariel", "", "IL", "376", "06", "", "", "", "32.1065", "35.18449", "Asia/Jerusalem"),
("1167718", "Punch", "", "IN", "356", "12", "", "", "", "33.76969", "74.09212", "Asia/Kolkata"),
("1252646", "Keelakarai", "", "IN", "356", "25", "", "", "", "9.23183", "78.78545", "Asia/Kolkata"),
("1252653", "Zunheboto", "", "IN", "356", "20", "", "", "", "25.96667", "94.51667", "Asia/Kolkata"),
("1252692", "Zamania", "", "IN", "356", "36", "", "", "", "25.41961", "83.55786", "Asia/Kolkata"),
("1252698", "Zaidpur", "", "IN", "356", "36", "", "", "", "26.82964", "81.32978", "Asia/Kolkata"),
("1252699", "Zahirabad", "", "IN", "356", "02", "", "", "", "17.68138", "77.60743", "Asia/Kolkata"),
("1252738", "Yeola", "", "IN", "356", "16", "", "", "", "20.04262", "74.48991", "Asia/Kolkata"),
("1252744", "Yellapur", "", "IN", "356", "19", "", "", "", "14.96584", "74.71034", "Asia/Kolkata"),
("1252745", "Yellandu", "", "IN", "356", "02", "", "", "", "17.59064", "80.32146", "Asia/Kolkata"),
("1252758", "Yelahanka", "", "IN", "356", "19", "", "", "", "13.10129", "77.59626", "Asia/Kolkata"),
("1252770", "Yavatmal", "", "IN", "356", "16", "", "", "", "20.39684", "78.13064", "Asia/Kolkata"),
("1252773", "Yaval", "", "IN", "356", "16", "", "", "", "21.16753", "75.69761", "Asia/Kolkata"),
("1252795", "Yanam", "Янам", "IN", "356", "02", "", "", "", "16.73308", "82.21364", "Asia/Kolkata"),
("1252797", "Yamunanagar", "", "IN", "356", "10", "", "", "", "30.12913", "77.28049", "Asia/Kolkata"),
("1252822", "Yadgir", "", "IN", "356", "19", "", "", "", "16.77023", "77.13754", "Asia/Kolkata"),
("1252840", "Wokha", "", "IN", "356", "20", "", "", "", "26.09716", "94.25817", "Asia/Kolkata"),
("1252885", "Wer", "", "IN", "356", "24", "", "", "", "27.0186", "77.17636", "Asia/Kolkata"),
("1252887", "Wellington", "Веллингтон", "IN", "356", "25", "", "", "", "11.36389", "76.78525", "Asia/Kolkata"),
("1252892", "Wazirganj", "", "IN", "356", "36", "", "", "", "28.21109", "79.05651", "Asia/Kolkata"),
("1252908", "Washim", "", "IN", "356", "16", "", "", "", "20.11152", "77.13221", "Asia/Kolkata"),
("1252919", "Warud", "", "IN", "356", "35", "", "", "", "21.47076", "78.26858", "Asia/Kolkata"),
("1252925", "Warora", "", "IN", "356", "16", "", "", "", "20.23014", "79.00161", "Asia/Kolkata"),
("1252930", "Waris Aliganj", "", "IN", "356", "34", "", "", "", "25.0172", "85.64048", "Asia/Kolkata"),
("1252942", "Wardha", "Вардха", "IN", "356", "16", "", "", "", "20.73807", "78.5967", "Asia/Kolkata"),
("1252946", "Waraseoni", "", "IN", "356", "35", "", "", "", "21.76454", "80.04631", "Asia/Kolkata"),
("1252948", "Warangal", "Варангал", "IN", "356", "02", "", "", "", "18", "79.58333", "Asia/Kolkata"),
("1252956", "Wanparti", "", "IN", "356", "02", "", "", "", "16.36738", "78.06889", "Asia/Kolkata"),
("1252958", "Wankaner", "", "IN", "356", "09", "", "", "", "22.61198", "70.94379", "Asia/Kolkata"),
("1252960", "Wani", "Ваня", "IN", "356", "16", "", "", "", "20.05556", "78.95345", "Asia/Kolkata"),
("1252997", "Walajapet", "", "IN", "356", "25", "", "", "", "12.9251", "79.36626", "Asia/Kolkata"),
("1253013", "Wai", "Вай", "IN", "356", "16", "", "", "", "17.95276", "73.89058", "Asia/Kolkata"),
("1253041", "Wadi", "Вади", "IN", "356", "19", "", "", "", "17.05206", "76.99024", "Asia/Kolkata"),
("1253074", "Vyara", "", "IN", "356", "09", "", "", "", "21.11079", "73.39365", "Asia/Kolkata"),
("1253077", "Vuyyuru", "", "IN", "356", "02", "", "", "", "16.36188", "80.84573", "Asia/Kolkata"),
("1253079", "Vrindavan", "Вриндаван", "IN", "356", "36", "", "", "", "27.57823", "77.69806", "Asia/Kolkata"),
("1253080", "Vriddhachalam", "", "IN", "356", "25", "", "", "", "11.51528", "79.32186", "Asia/Kolkata"),
("1253084", "Vizianagaram", "Визианагарам", "IN", "356", "02", "7626859", "", "", "18.11692", "83.41148", "Asia/Kolkata"),
("1253091", "Vite", "Вита", "IN", "356", "16", "", "", "", "17.27343", "74.53792", "Asia/Kolkata"),
("1253095", "Visnagar", "", "IN", "356", "09", "", "", "", "23.69855", "72.5521", "Asia/Kolkata"),
("1253102", "Visakhapatnam", "Вишакхапатнам", "IN", "356", "02", "1253103", "", "", "17.68009", "83.20161", "Asia/Kolkata"),
("1253105", "Visavadar", "", "IN", "356", "09", "", "", "", "21.33954", "70.74966", "Asia/Kolkata"),
("1253113", "Virudunagar", "", "IN", "356", "25", "", "", "", "9.58509", "77.95787", "Asia/Kolkata"),
("1253127", "Viravanallur", "", "IN", "356", "25", "", "", "", "8.6961", "77.51895", "Asia/Kolkata"),
("1253132", "Virarajendrapet", "", "IN", "356", "19", "", "", "", "12.19583", "75.80355", "Asia/Kolkata"),
("1253133", "Virar", "", "IN", "356", "16", "", "", "", "19.4559", "72.81136", "Asia/Kolkata"),
("1253150", "Vinukonda", "", "IN", "356", "02", "", "", "", "16.0518", "79.74017", "Asia/Kolkata"),
("1253166", "Villupuram", "", "IN", "356", "25", "", "", "", "11.93975", "79.49244", "Asia/Kolkata"),
("1253182", "Vikarabad", "", "IN", "356", "02", "", "", "", "17.3381", "77.90441", "Asia/Kolkata"),
("1253184", "Vijayawada", "Виджаявада", "IN", "356", "02", "", "", "", "16.51928", "80.63049", "Asia/Kolkata"),
("1253193", "Vijapur", "", "IN", "356", "09", "", "", "", "23.5623", "72.74848", "Asia/Kolkata"),
("1253200", "Vidisha", "", "IN", "356", "35", "", "", "", "23.52435", "77.80972", "Asia/Kolkata"),
("1253216", "Vettur", "", "IN", "356", "13", "", "", "", "8.7", "76.73333", "Asia/Kolkata"),
("1253219", "Vettaikkaranpudur", "", "IN", "356", "25", "", "", "", "10.56207", "76.91305", "Asia/Kolkata"),
("1253220", "Vetapalem", "", "IN", "356", "02", "", "", "", "15.78204", "80.30665", "Asia/Kolkata"),
("1253237", "Veraval", "", "IN", "356", "09", "", "", "", "20.9077", "70.36786", "Asia/Kolkata"),
("1253242", "Vepagunta", "", "IN", "356", "02", "", "", "", "17.77844", "83.21577", "Asia/Kolkata"),
("1253251", "Venkatagiri", "", "IN", "356", "02", "", "", "", "13.96065", "79.58024", "Asia/Kolkata"),
("1253275", "Vemalwada", "", "IN", "356", "02", "", "", "", "18.46523", "78.86894", "Asia/Kolkata"),
("1253278", "Velur", "", "IN", "356", "25", "", "", "", "11.10825", "78.00113", "Asia/Kolkata"),
("1253286", "Vellore", "Веллор", "IN", "356", "25", "", "", "", "12.9184", "79.13255", "Asia/Kolkata"),
("1253315", "Vejalpur", "", "IN", "356", "09", "", "", "", "22.69021", "73.56299", "Asia/Kolkata"),
("1253330", "Vedaraniyam", "", "IN", "356", "25", "", "", "", "10.37208", "79.85095", "Asia/Kolkata"),
("1253340", "Vayalar", "", "IN", "356", "13", "", "", "", "9.7", "76.33333", "Asia/Kolkata"),
("1253352", "Vattalkundu", "", "IN", "356", "25", "", "", "", "10.16069", "77.75883", "Asia/Kolkata"),
("1253357", "Vasudevanallur", "", "IN", "356", "25", "", "", "", "9.23921", "77.41132", "Asia/Kolkata"),
("1253363", "Vasind", "", "IN", "356", "16", "", "", "", "19.40844", "73.26285", "Asia/Kolkata"),
("1253367", "Vasco Da Gama", "Васко-да-Гама", "IN", "356", "33", "", "", "", "15.39585", "73.81568", "Asia/Kolkata"),
("1253374", "Vasa", "", "IN", "356", "09", "", "", "", "22.66079", "72.75519", "Asia/Kolkata"),
("1253392", "Varkala", "Варкала", "IN", "356", "13", "", "", "", "8.7333", "76.7167", "Asia/Kolkata"),
("1253403", "Varangaon", "", "IN", "356", "16", "", "", "", "21.01649", "75.90991", "Asia/Kolkata"),
("1253405", "Varanasi", "Варанаси", "IN", "356", "36", "", "", "", "25.31668", "83.01042", "Asia/Kolkata"),
("1253437", "Vaniyambadi", "", "IN", "356", "25", "", "", "", "12.68162", "78.62014", "Asia/Kolkata"),
("1253452", "Vandavasi", "", "IN", "356", "25", "", "", "", "12.50429", "79.60556", "Asia/Kolkata"),
("1253468", "Valsad", "", "IN", "356", "09", "", "", "", "20.61728", "72.92843", "Asia/Kolkata"),
("1253472", "Valparai", "", "IN", "356", "25", "", "", "", "10.32691", "76.95116", "Asia/Kolkata"),
("1253482", "Vallabh Vidyanagar", "", "IN", "356", "09", "", "", "", "22.53333", "72.9", "Asia/Kolkata"),
("1253512", "Valabhipur", "", "IN", "356", "09", "", "", "", "21.88868", "71.87935", "Asia/Kolkata"),
("1253544", "Vaikam", "", "IN", "356", "13", "", "", "", "9.74713", "76.39522", "Asia/Kolkata"),
("1253545", "Vaijapur", "", "IN", "356", "16", "", "", "", "19.92672", "74.7275", "Asia/Kolkata"),
("1253573", "Vadodara", "Вадодара", "IN", "356", "09", "", "", "", "22.2994", "73.20812", "Asia/Kolkata"),
("1253577", "Vadnagar", "", "IN", "356", "09", "", "", "", "23.78593", "72.63893", "Asia/Kolkata"),
("1253578", "Vadlapudi", "", "IN", "356", "02", "", "", "", "14.3097", "79.80296", "Asia/Kolkata"),
("1253579", "Vadippatti", "", "IN", "356", "25", "", "", "", "10.08481", "77.96113", "Asia/Kolkata"),
("1253595", "Vadamadurai", "", "IN", "356", "25", "", "", "", "10.44026", "78.09999", "Asia/Kolkata"),
("1253605", "Vadakku Valliyur", "", "IN", "356", "25", "", "", "", "8.38095", "77.6132", "Asia/Kolkata"),
("1253610", "Vada", "", "IN", "356", "16", "", "", "", "19.65347", "73.14811", "Asia/Kolkata"),
("1253623", "Uttiramerur", "", "IN", "356", "25", "", "", "", "12.61433", "79.75748", "Asia/Kolkata"),
("1253628", "Uttarkashi", "", "IN", "356", "39", "", "", "", "30.72986", "78.44342", "Asia/Kolkata"),
("1253635", "Uttamapalaiyam", "", "IN", "356", "25", "", "", "", "9.80701", "77.32718", "Asia/Kolkata"),
("1253638", "Utraula", "", "IN", "356", "36", "", "", "", "27.31929", "82.41838", "Asia/Kolkata"),
("1253671", "Usilampatti", "", "IN", "356", "25", "", "", "", "9.96936", "77.78621", "Asia/Kolkata"),
("1253673", "Usehat", "", "IN", "356", "36", "", "", "", "27.79817", "79.23682", "Asia/Kolkata"),
("1253698", "Uravakonda", "", "IN", "356", "02", "", "", "", "14.9456", "77.25928", "Asia/Kolkata"),
("1253702", "Uran", "Уран", "IN", "356", "16", "", "", "", "18.87813", "72.93924", "Asia/Kolkata"),
("1253736", "Upleta", "", "IN", "356", "09", "", "", "", "21.74015", "70.28256", "Asia/Kolkata"),
("1253744", "Uppal Kalan", "", "IN", "356", "02", "", "", "", "17.40577", "78.55911", "Asia/Kolkata"),
("1253747", "Unnao", "", "IN", "356", "36", "", "", "", "26.54706", "80.48781", "Asia/Kolkata"),
("1253750", "Unjha", "", "IN", "356", "09", "", "", "", "23.80366", "72.39102", "Asia/Kolkata"),
("1253754", "Unhel", "", "IN", "356", "35", "", "", "", "23.33794", "75.55931", "Asia/Kolkata"),
("1253782", "Una", "", "IN", "356", "11", "", "", "", "31.46493", "76.26914", "Asia/Kolkata"),
("1253783", "Una", "", "IN", "356", "09", "", "", "", "20.82318", "71.03795", "Asia/Kolkata"),
("1253785", "Un", "", "IN", "356", "36", "", "", "", "29.58594", "77.25398", "Asia/Kolkata"),
("1253786", "Un", "", "IN", "356", "09", "", "", "", "23.88745", "71.76975", "Asia/Kolkata"),
("1253805", "Umreth", "", "IN", "356", "09", "", "", "", "22.69881", "73.11561", "Asia/Kolkata"),
("1253807", "Umred", "", "IN", "356", "16", "", "", "", "20.85409", "79.3242", "Asia/Kolkata"),
("1253860", "Umarkot", "", "IN", "356", "37", "", "", "", "19.66529", "82.20629", "Asia/Kolkata"),
("1253861", "Umarkhed", "", "IN", "356", "16", "", "", "", "19.60144", "77.68878", "Asia/Kolkata"),
("1253863", "Umaria", "", "IN", "356", "35", "", "", "", "23.52684", "80.83745", "Asia/Kolkata"),
("1253870", "Umarga", "", "IN", "356", "16", "", "", "", "17.83841", "76.62331", "Asia/Kolkata"),
("1253888", "Ullal", "", "IN", "356", "19", "", "", "", "12.8108", "74.8629", "Asia/Kolkata"),
("1253894", "Ulhasnagar", "", "IN", "356", "16", "", "", "", "19.21667", "73.15", "Asia/Kolkata"),
("1253914", "Ujjain", "Удджайн", "IN", "356", "35", "", "", "", "23.18239", "75.77643", "Asia/Kolkata"),
("1253918", "Ujhani", "", "IN", "356", "36", "", "", "", "28.00203", "79.00926", "Asia/Kolkata"),
("1253944", "Udumalaippettai", "", "IN", "356", "25", "", "", "", "10.58806", "77.24779", "Asia/Kolkata"),
("1253952", "Udipi", "", "IN", "356", "19", "", "", "", "13.33467", "74.74617", "Asia/Kolkata"),
("1253956", "Udhampur", "", "IN", "356", "12", "", "", "", "32.92431", "75.13573", "Asia/Kolkata"),
("1253958", "Udgir", "", "IN", "356", "16", "", "", "", "18.39258", "77.11756", "Asia/Kolkata"),
("1253972", "Udankudi", "", "IN", "356", "25", "", "", "", "8.43048", "78.02882", "Asia/Kolkata"),
("1253977", "Udalguri", "", "IN", "356", "03", "", "", "", "26.75367", "92.10215", "Asia/Kolkata"),
("1253984", "Udaipura", "", "IN", "356", "35", "", "", "", "23.07564", "78.51115", "Asia/Kolkata"),
("1253985", "Udaipur", "", "IN", "356", "24", "", "", "", "27.72297", "75.47178", "Asia/Kolkata"),
("1253986", "Udaipur", "Удайпур", "IN", "356", "24", "", "", "", "24.57117", "73.69183", "Asia/Kolkata"),
("1253987", "Udaipur", "Удайпур", "IN", "356", "26", "", "", "", "23.53333", "91.48333", "Asia/Kolkata"),
("1253993", "Ooty", "Утакаманд", "IN", "356", "25", "", "", "", "11.4134", "76.69521", "Asia/Kolkata"),
("1254000", "Uchana", "", "IN", "356", "10", "", "", "", "29.46856", "76.176", "Asia/Kolkata"),
("1254043", "Turaiyur", "", "IN", "356", "25", "", "", "", "11.14985", "78.59888", "Asia/Kolkata"),
("1254046", "Tura", "", "IN", "356", "18", "", "", "", "25.51933", "90.22284", "Asia/Kolkata"),
("1254054", "Tuni", "", "IN", "356", "02", "", "", "", "17.35967", "82.54616", "Asia/Kolkata"),
("1254069", "Tundla", "", "IN", "356", "36", "", "", "", "27.21384", "78.23604", "Asia/Kolkata"),
("1254080", "Tumsar", "", "IN", "356", "16", "", "", "", "21.38333", "79.73333", "Asia/Kolkata"),
("1254089", "Tumkur", "", "IN", "356", "19", "", "", "", "13.34149", "77.101", "Asia/Kolkata"),
("1254102", "Tulsipur", "", "IN", "356", "36", "", "", "", "27.5337", "82.41653", "Asia/Kolkata"),
("1254111", "Tuljapur", "", "IN", "356", "16", "", "", "", "18.00804", "76.07011", "Asia/Kolkata"),
("1254131", "Tufanganj", "", "IN", "356", "28", "", "", "", "26.31688", "89.66549", "Asia/Kolkata"),
("1254133", "Tuensang", "", "IN", "356", "20", "", "", "", "26.26704", "94.82415", "Asia/Kolkata"),
("1254163", "Thiruvananthapuram", "Тируванантапурам", "IN", "356", "13", "", "", "", "8.4855", "76.94924", "Asia/Kolkata"),
("1254187", "Trichur", "Тричура", "IN", "356", "13", "1254188", "", "", "10.51667", "76.21667", "Asia/Kolkata"),
("1254241", "Tonk", "", "IN", "356", "24", "", "", "", "26.16638", "75.78824", "Asia/Kolkata"),
("1254249", "Tondi", "", "IN", "356", "25", "", "", "", "9.74172", "79.01774", "Asia/Kolkata"),
("1254274", "Tohana", "", "IN", "356", "10", "", "", "", "29.71179", "75.90284", "Asia/Kolkata"),
("1254282", "Todaraisingh", "", "IN", "356", "24", "", "", "", "26.02401", "75.48182", "Asia/Kolkata"),
("1254283", "Todabhim", "", "IN", "356", "24", "", "", "", "26.91667", "76.81667", "Asia/Kolkata"),
("1254304", "Titlagarh", "", "IN", "356", "21", "", "", "", "20.28961", "83.15233", "Asia/Kolkata"),
("1254309", "Titagarh", "", "IN", "356", "28", "", "", "", "22.74252", "88.37326", "Asia/Kolkata"),
("1254317", "Tisaiyanvilai", "", "IN", "356", "25", "", "", "", "8.33248", "77.86586", "Asia/Kolkata"),
("1254320", "Tiruvottiyur", "", "IN", "356", "25", "", "", "", "13.15823", "80.30181", "Asia/Kolkata"),
("1254322", "Cheyyar", "", "IN", "356", "25", "", "", "", "12.66052", "79.54308", "Asia/Kolkata"),
("1254327", "Tiruvannamalai", "Тируваннамалай", "IN", "356", "25", "", "", "", "12.22662", "79.07461", "Asia/Kolkata"),
("1254331", "Tiruvallur", "Тируваллур", "IN", "356", "25", "", "", "", "13.14376", "79.90889", "Asia/Kolkata"),
("1254335", "Tiruvalla", "", "IN", "356", "13", "", "", "", "9.3816", "76.57489", "Asia/Kolkata"),
("1254342", "Thiruthani", "", "IN", "356", "25", "", "", "", "13.17594", "79.61637", "Asia/Kolkata"),
("1254343", "Tiruttangal", "", "IN", "356", "25", "", "", "", "9.48333", "77.83333", "Asia/Kolkata"),
("1254346", "Tirur", "", "IN", "356", "13", "", "", "", "10.91607", "75.91862", "Asia/Kolkata"),
("1254347", "Tiruppuvanam", "", "IN", "356", "25", "", "", "", "9.82556", "78.25792", "Asia/Kolkata"),
("1254348", "Tiruppur", "Тируппур", "IN", "356", "25", "", "", "", "11.11541", "77.35456", "Asia/Kolkata"),
("1254356", "Tirupparangunram", "", "IN", "356", "25", "", "", "", "9.88085", "78.07252", "Asia/Kolkata"),
("1254360", "Tirupati", "Тирупати", "IN", "356", "02", "1274034", "", "", "13.6355", "79.41989", "Asia/Kolkata"),
("1254361", "Tirunelveli", "Тирунелвели", "IN", "356", "25", "", "", "", "8.72518", "77.68452", "Asia/Kolkata"),
("1254373", "Tirumala", "", "IN", "356", "02", "", "", "", "13.68333", "79.35", "Asia/Kolkata"),
("1254377", "Tirukkoyilur", "", "IN", "356", "25", "", "", "", "11.9662", "79.20259", "Asia/Kolkata"),
("1254385", "Tiruchengode", "", "IN", "356", "25", "", "", "", "11.38016", "77.89444", "Asia/Kolkata"),
("1254388", "Tiruchirappalli", "Тируччираппалли", "IN", "356", "25", "", "", "", "10.8155", "78.69651", "Asia/Kolkata"),
("1254390", "Tiruchchendur", "", "IN", "356", "25", "", "", "", "8.49725", "78.11906", "Asia/Kolkata"),
("1254396", "Tirthahalli", "", "IN", "356", "19", "", "", "", "13.68835", "75.24548", "Asia/Kolkata"),
("1254420", "Tiptur", "", "IN", "356", "19", "", "", "", "13.2563", "76.47768", "Asia/Kolkata"),
("1254432", "Tinsukia", "", "IN", "356", "03", "", "", "", "27.48905", "95.35992", "Asia/Kolkata"),
("1254436", "Tinnanur", "", "IN", "356", "25", "", "", "", "13.11448", "80.02713", "Asia/Kolkata"),
("1254444", "Tindivanam", "", "IN", "356", "25", "", "", "", "12.234", "79.65551", "Asia/Kolkata"),
("1254481", "Tilhar", "", "IN", "356", "36", "", "", "", "27.9614", "79.73962", "Asia/Kolkata"),
("1254534", "Tikamgarh", "", "IN", "356", "36", "", "", "", "24.74413", "78.83141", "Asia/Kolkata"),
("1254538", "Tijara", "", "IN", "356", "24", "", "", "", "27.93413", "76.85573", "Asia/Kolkata"),
("1254570", "Thoubal", "", "IN", "356", "17", "", "", "", "24.6388", "93.99638", "Asia/Kolkata"),
("1254589", "Thiruvarur", "", "IN", "356", "25", "", "", "", "10.77269", "79.6368", "Asia/Kolkata"),
("1254624", "Thasra", "", "IN", "356", "09", "", "", "", "22.79831", "73.21174", "Asia/Kolkata"),
("1254638", "Tharad", "", "IN", "356", "09", "", "", "", "24.39597", "71.62577", "Asia/Kolkata"),
("1254649", "Thanjavur", "Тханджавур", "IN", "356", "25", "", "", "", "10.78523", "79.13909", "Asia/Kolkata"),
("1254657", "Thanesar", "", "IN", "356", "10", "", "", "", "29.97415", "76.83201", "Asia/Kolkata"),
("1254661", "Thane", "Таня", "IN", "356", "16", "", "", "", "19.19704", "72.96356", "Asia/Kolkata"),
("1254673", "Thana Bhawan", "", "IN", "356", "36", "", "", "", "29.58653", "77.41712", "Asia/Kolkata"),
("1254675", "Than", "", "IN", "356", "09", "", "", "", "22.57422", "71.19942", "Asia/Kolkata"),
("1254694", "Thakurganj", "", "IN", "356", "34", "", "", "", "26.42742", "88.13112", "Asia/Kolkata"),
("1254695", "Thakurdwara", "", "IN", "356", "36", "", "", "", "29.19203", "78.86145", "Asia/Kolkata"),
("1254710", "Tezpur", "Тезпур", "IN", "356", "03", "", "", "", "26.63333", "92.8", "Asia/Kolkata"),
("1254727", "Terdal", "", "IN", "356", "19", "", "", "", "16.49379", "75.04667", "Asia/Kolkata"),
("1254732", "Teonthar", "", "IN", "356", "35", "", "", "", "24.98209", "81.64224", "Asia/Kolkata"),
("1254744", "Thenkasi", "", "IN", "356", "25", "", "", "", "8.96003", "77.31525", "Asia/Kolkata"),
("1254745", "Teni", "Тхени", "IN", "356", "25", "", "", "", "10.01531", "77.482", "Asia/Kolkata"),
("1254780", "Thalassery", "", "IN", "356", "13", "", "", "", "11.74776", "75.49338", "Asia/Kolkata"),
("1254787", "Telhara", "", "IN", "356", "16", "", "", "", "21.02694", "76.83889", "Asia/Kolkata"),
("1254794", "Tekkali", "", "IN", "356", "02", "", "", "", "18.6057", "84.23546", "Asia/Kolkata"),
("1254795", "Tekkalakote", "", "IN", "356", "19", "", "", "", "15.53466", "76.87562", "Asia/Kolkata"),
("1254797", "Tekari", "", "IN", "356", "34", "", "", "", "24.94216", "84.843", "Asia/Kolkata"),
("1254808", "Tehri", "Техри", "IN", "356", "39", "", "", "", "30.39086", "78.4803", "Asia/Kolkata"),
("1254813", "Teghra", "", "IN", "356", "34", "", "", "", "25.49109", "85.94166", "Asia/Kolkata"),
("1254858", "Tasgaon", "", "IN", "356", "16", "", "", "", "17.037", "74.60171", "Asia/Kolkata"),
("1254868", "Tarn Taran", "", "IN", "356", "23", "", "", "", "31.45112", "74.92538", "Asia/Kolkata"),
("1254880", "Tarikere", "", "IN", "356", "19", "", "", "", "13.70954", "75.81382", "Asia/Kolkata"),
("1254904", "Tharangambadi", "", "IN", "356", "25", "", "", "", "11.02764", "79.85425", "Asia/Kolkata"),
("1254908", "Taranagar", "", "IN", "356", "24", "", "", "", "28.6686", "75.03207", "Asia/Kolkata"),
("1254909", "Tarana", "Тарана", "IN", "356", "35", "", "", "", "23.33508", "76.04156", "Asia/Kolkata"),
("1254910", "Taramangalam", "", "IN", "356", "25", "", "", "", "11.7", "77.98333", "Asia/Kolkata"),
("1254912", "Tarakeswar", "", "IN", "356", "28", "", "", "", "22.88605", "88.01363", "Asia/Kolkata"),
("1254948", "Taoru", "", "IN", "356", "10", "", "", "", "28.2122", "76.94954", "Asia/Kolkata"),
("1254953", "Tanuku", "", "IN", "356", "02", "", "", "", "16.75319", "81.68456", "Asia/Kolkata"),
("1255004", "Tandur", "", "IN", "356", "02", "", "", "", "17.24849", "77.57698", "Asia/Kolkata"),
("1255023", "Tanda", "", "IN", "356", "36", "", "", "", "28.97474", "78.94243", "Asia/Kolkata"),
("1255024", "Tanda", "", "IN", "356", "36", "", "", "", "26.55063", "82.65802", "Asia/Kolkata"),
("1255027", "Tanakpur", "", "IN", "356", "39", "", "", "", "29.06925", "80.1126", "Asia/Kolkata"),
("1255046", "Tamluk", "", "IN", "356", "28", "", "", "", "22.30083", "87.92592", "Asia/Kolkata"),
("1255076", "Talwara", "", "IN", "356", "23", "", "", "", "31.9498", "75.86645", "Asia/Kolkata"),
("1255082", "Talwandi Bhai", "", "IN", "356", "23", "", "", "", "30.85612", "74.92944", "Asia/Kolkata"),
("1255104", "Taloda", "", "IN", "356", "16", "", "", "", "21.5606", "74.21258", "Asia/Kolkata"),
("1255121", "Taliparamba", "", "IN", "356", "13", "", "", "", "12.03454", "75.36161", "Asia/Kolkata"),
("1255122", "Talikota", "", "IN", "356", "19", "", "", "", "16.47632", "76.31087", "Asia/Kolkata"),
("1255131", "Taleigao", "", "IN", "356", "33", "", "", "", "15.46915", "73.83285", "Asia/Kolkata"),
("1255134", "Talegaon Dabhade", "", "IN", "356", "16", "", "", "", "18.73502", "73.67561", "Asia/Kolkata"),
("1255143", "Talcher", "", "IN", "356", "21", "", "", "", "20.94927", "85.23354", "Asia/Kolkata"),
("1255175", "Talaja", "", "IN", "356", "09", "", "", "", "21.3527", "72.03524", "Asia/Kolkata"),
("1255211", "Taki", "Такой", "IN", "356", "28", "", "", "", "22.58868", "88.93253", "Asia/Kolkata"),
("1255212", "Takhatpur", "", "IN", "356", "37", "", "", "", "22.12879", "81.86974", "Asia/Kolkata"),
("1255213", "Takhatgarh", "", "IN", "356", "24", "", "", "", "25.3227", "73.00322", "Asia/Kolkata"),
("1255224", "Tajpur", "", "IN", "356", "36", "", "", "", "29.16348", "78.48403", "Asia/Kolkata"),
("1255254", "Tadpatri", "", "IN", "356", "02", "", "", "", "14.90813", "78.01108", "Asia/Kolkata"),
("1255264", "Tadepallegudem", "", "IN", "356", "02", "", "", "", "16.81304", "81.52874", "Asia/Kolkata"),
("1255265", "Tadepalle", "", "IN", "356", "02", "", "", "", "16.48333", "80.6", "Asia/Kolkata"),
("1255344", "Suriapet", "", "IN", "356", "02", "", "", "", "17.14054", "79.62044", "Asia/Kolkata"),
("1255346", "Surianwan", "", "IN", "356", "36", "", "", "", "25.46333", "82.42058", "Asia/Kolkata"),
("1255349", "Surendranagar", "", "IN", "356", "09", "", "", "", "22.72706", "71.64856", "Asia/Kolkata"),
("1255361", "Suratgarh", "Суратгарх", "IN", "356", "24", "", "", "", "29.3215", "73.89979", "Asia/Kolkata"),
("1255364", "Surat", "", "IN", "356", "09", "", "", "", "21.19594", "72.83023", "Asia/Kolkata"),
("1255372", "Surandai", "", "IN", "356", "25", "", "", "", "8.97574", "77.41923", "Asia/Kolkata"),
("1255383", "Surajgarh", "", "IN", "356", "24", "", "", "", "28.31005", "75.73271", "Asia/Kolkata"),
("1255396", "Supaul", "", "IN", "356", "34", "", "", "", "26.11503", "86.59527", "Asia/Kolkata"),
("1255425", "Sunel", "", "IN", "356", "24", "", "", "", "24.37066", "75.95708", "Asia/Kolkata"),
("1255434", "Sundarnagar", "", "IN", "356", "11", "", "", "", "31.53276", "76.90594", "Asia/Kolkata"),
("1255437", "Sundargarh", "", "IN", "356", "21", "", "", "", "22.11667", "84.03333", "Asia/Kolkata"),
("1255449", "Sunam", "", "IN", "356", "23", "", "", "", "30.1297", "75.80715", "Asia/Kolkata"),
("1255482", "Sulya", "", "IN", "356", "19", "", "", "", "12.56458", "75.39085", "Asia/Kolkata"),
("1255483", "Suluru", "", "IN", "356", "02", "", "", "", "13.7", "80.01667", "Asia/Kolkata"),
("1255484", "Sulur", "", "IN", "356", "25", "", "", "", "11.02427", "77.12565", "Asia/Kolkata"),
("1255488", "Sultanpur Lodhi", "", "IN", "356", "23", "", "", "", "31.21448", "75.19563", "Asia/Kolkata"),
("1255491", "Sultanpur", "", "IN", "356", "36", "", "", "", "26.25996", "82.07314", "Asia/Kolkata"),
("1255551", "Suket", "", "IN", "356", "24", "", "", "", "24.64933", "76.04423", "Asia/Kolkata"),
("1255560", "Sujangarh", "", "IN", "356", "24", "", "", "", "27.7", "74.46667", "Asia/Kolkata"),
("1255597", "Suar", "Суар", "IN", "356", "36", "", "", "", "29.02668", "79.0576", "Asia/Kolkata"),
("1255616", "Srivilliputhur", "", "IN", "356", "25", "", "", "", "9.51272", "77.63369", "Asia/Kolkata"),
("1255619", "Srivardhan", "", "IN", "356", "16", "", "", "", "18.04592", "73.01552", "Asia/Kolkata"),
("1255620", "Srivaikuntam", "", "IN", "356", "25", "", "", "", "8.62931", "77.91281", "Asia/Kolkata"),
("1255621", "Srisailam", "", "IN", "356", "02", "", "", "", "16.07277", "78.8692", "Asia/Kolkata"),
("1255625", "Sriramnagar", "", "IN", "356", "02", "", "", "", "17.26652", "78.25544", "Asia/Kolkata"),
("1255630", "Sriperumbudur", "", "IN", "356", "25", "", "", "", "12.96763", "79.94197", "Asia/Kolkata"),
("1255631", "Srinivaspur", "", "IN", "356", "19", "", "", "", "13.33933", "78.2119", "Asia/Kolkata"),
("1255634", "Srinagar", "Шринагар", "IN", "356", "12", "", "", "", "34.08842", "74.80298", "Asia/Kolkata"),
("1255635", "Srinagar", "Шринагар", "IN", "356", "39", "", "", "", "30.22242", "78.78341", "Asia/Kolkata"),
("1255643", "Sri Madhopur", "", "IN", "356", "24", "", "", "", "27.46599", "75.59736", "Asia/Kolkata"),
("1255646", "Karanpur", "", "IN", "356", "24", "", "", "", "29.84042", "73.45519", "Asia/Kolkata"),
("1255647", "Srikakulam", "", "IN", "356", "02", "", "", "", "18.29692", "83.89732", "Asia/Kolkata"),
("1255654", "Sri Dungargarh", "", "IN", "356", "24", "", "", "", "28.09712", "74.00937", "Asia/Kolkata"),
("1255667", "Soygaon", "", "IN", "356", "16", "", "", "", "20.59611", "75.61781", "Asia/Kolkata"),
("1255704", "Soron", "Сорон", "IN", "356", "36", "", "", "", "27.89012", "78.7467", "Asia/Kolkata"),
("1255705", "Soro", "", "IN", "356", "21", "", "", "", "21.27851", "86.68833", "Asia/Kolkata"),
("1255712", "Sorada", "", "IN", "356", "21", "", "", "", "19.76082", "84.42997", "Asia/Kolkata"),
("1255714", "Sopur", "", "IN", "356", "12", "", "", "", "34.28787", "74.47219", "Asia/Kolkata"),
("1255744", "Sonipat", "", "IN", "356", "10", "", "", "", "28.99587", "77.01165", "Asia/Kolkata"),
("1255762", "Songadh", "", "IN", "356", "09", "", "", "", "21.16966", "73.56357", "Asia/Kolkata"),
("1255763", "Sonepur", "", "IN", "356", "21", "", "", "", "20.83333", "83.91667", "Asia/Kolkata"),
("1255788", "Sonari", "", "IN", "356", "03", "", "", "", "27.02462", "95.01629", "Asia/Kolkata"),
("1255792", "Sonamukhi", "", "IN", "356", "28", "", "", "", "23.3052", "87.41336", "Asia/Kolkata"),
("1255816", "Sompeta", "", "IN", "356", "02", "", "", "", "18.94419", "84.58449", "Asia/Kolkata"),
("1255823", "Someshwar", "", "IN", "356", "19", "", "", "", "13.49112", "75.06646", "Asia/Kolkata"),
("1255850", "Solan", "Солана", "IN", "356", "11", "", "", "", "30.9086", "77.10873", "Asia/Kolkata"),
("1255858", "Sojitra", "", "IN", "356", "09", "", "", "", "22.53884", "72.71984", "Asia/Kolkata"),
("1255860", "Sojat", "", "IN", "356", "24", "", "", "", "25.92493", "73.66633", "Asia/Kolkata"),
("1255870", "Sohna", "", "IN", "356", "10", "", "", "", "28.24737", "77.06544", "Asia/Kolkata"),
("1255884", "Sohagpur", "", "IN", "356", "35", "", "", "", "22.70133", "78.19895", "Asia/Kolkata"),
("1255925", "Siwana", "", "IN", "356", "24", "", "", "", "25.65154", "72.42244", "Asia/Kolkata"),
("1255927", "Siwan", "Сиван", "IN", "356", "34", "", "", "", "26.22152", "84.35879", "Asia/Kolkata"),
("1255947", "Sivakasi", "", "IN", "356", "25", "", "", "", "9.44999", "77.79797", "Asia/Kolkata"),
("1255950", "Sivagiri", "", "IN", "356", "25", "", "", "", "11.1194", "77.78788", "Asia/Kolkata"),
("1255951", "Sivagiri", "", "IN", "356", "25", "", "", "", "9.34461", "77.42911", "Asia/Kolkata"),
("1255953", "Sivaganga", "Шиваганга", "IN", "356", "25", "", "", "", "9.84701", "78.48358", "Asia/Kolkata"),
("1255955", "Siuri", "", "IN", "356", "28", "", "", "", "23.90806", "87.52773", "Asia/Kolkata"),
("1255963", "Sitarganj", "", "IN", "356", "39", "", "", "", "28.93214", "79.70452", "Asia/Kolkata"),
("1255969", "Sitapur", "", "IN", "356", "36", "", "", "", "27.56192", "80.68265", "Asia/Kolkata"),
("1255983", "Sitamarhi", "", "IN", "356", "34", "", "", "", "26.59356", "85.4906", "Asia/Kolkata"),
("1255995", "Siswa Bazar", "", "IN", "356", "36", "", "", "", "27.14652", "83.75803", "Asia/Kolkata"),
("1256003", "Sisauli", "", "IN", "356", "36", "", "", "", "29.41448", "77.46877", "Asia/Kolkata"),
("1256025", "Sirur", "", "IN", "356", "16", "", "", "", "18.8276", "74.37475", "Asia/Kolkata"),
("1256027", "Sirumugai", "", "IN", "356", "25", "1273866", "", "", "11.32137", "77.00521", "Asia/Kolkata"),
("1256029", "Siruguppa", "", "IN", "356", "19", "", "", "", "15.63138", "76.89271", "Asia/Kolkata"),
("1256039", "Sirsilla", "", "IN", "356", "02", "", "", "", "18.38865", "78.81048", "Asia/Kolkata"),
("1256040", "Sirsi", "", "IN", "356", "36", "", "", "", "28.63933", "78.64152", "Asia/Kolkata"),
("1256047", "Sirsi", "", "IN", "356", "19", "", "", "", "14.61686", "74.83087", "Asia/Kolkata"),
("1256050", "Sirsaganj", "", "IN", "356", "36", "", "", "", "27.05745", "78.68665", "Asia/Kolkata"),
("1256052", "Sirsa", "", "IN", "356", "10", "", "", "", "29.53489", "75.02898", "Asia/Kolkata"),
("1256064", "Sironj", "", "IN", "356", "35", "", "", "", "24.1038", "77.68959", "Asia/Kolkata"),
("1256067", "Sirohi", "", "IN", "356", "24", "", "", "", "24.88838", "72.84794", "Asia/Kolkata"),
("1256075", "Sirkazhi", "", "IN", "356", "25", "", "", "", "11.23725", "79.73585", "Asia/Kolkata"),
("1256087", "Sirhind", "", "IN", "356", "23", "", "", "", "30.64332", "76.38489", "Asia/Kolkata"),
("1256104", "Sira", "", "IN", "356", "19", "", "", "", "13.74155", "76.9043", "Asia/Kolkata"),
("1256119", "Sinnar", "Синнар", "IN", "356", "16", "", "", "", "19.84505", "73.99866", "Asia/Kolkata"),
("1256124", "Singur", "", "IN", "356", "28", "", "", "", "22.80917", "88.22944", "Asia/Kolkata"),
("1256176", "Singarayakonda", "", "IN", "356", "02", "", "", "", "15.23094", "80.02802", "Asia/Kolkata"),
("1256184", "Singanallur", "", "IN", "356", "25", "", "", "", "10.99816", "77.03375", "Asia/Kolkata"),
("1256207", "Sindhnur", "", "IN", "356", "19", "", "", "", "15.76982", "76.75581", "Asia/Kolkata"),
("1256214", "Sindgi", "", "IN", "356", "19", "", "", "", "16.91845", "76.23336", "Asia/Kolkata"),
("1256237", "Shimla", "Шимла", "IN", "356", "11", "", "", "", "31.10442", "77.16662", "Asia/Kolkata"),
("1256246", "Simdega", "", "IN", "356", "38", "", "", "", "22.61523", "84.50208", "Asia/Kolkata"),
("1256259", "Silvassa", "", "IN", "356", "06", "", "", "", "20.27386", "72.99673", "Asia/Kolkata"),
("1256269", "Sillod", "", "IN", "356", "16", "", "", "", "20.30303", "75.65284", "Asia/Kolkata"),
("1256287", "Silchar", "Силчар", "IN", "356", "03", "", "", "", "24.82733", "92.79787", "Asia/Kolkata"),
("1256295", "Silao", "Силао", "IN", "356", "34", "", "", "", "25.08317", "85.42782", "Asia/Kolkata"),
("1256320", "Sikar", "", "IN", "356", "24", "", "", "", "27.61206", "75.13996", "Asia/Kolkata"),
("1256322", "Sikandra Rao", "", "IN", "356", "36", "", "", "", "27.68806", "78.38114", "Asia/Kolkata"),
("1256328", "Sikandarpur", "", "IN", "356", "36", "", "", "", "26.04306", "84.05426", "Asia/Kolkata"),
("1256329", "Sikandarabad", "", "IN", "356", "36", "", "", "", "28.45341", "77.69807", "Asia/Kolkata"),
("1256333", "Sikka", "", "IN", "356", "09", "", "", "", "22.43218", "69.84158", "Asia/Kolkata"),
("1256335", "Sijua", "", "IN", "356", "38", "", "", "", "23.77617", "86.33028", "Asia/Kolkata"),
("1256340", "Sihora", "", "IN", "356", "35", "", "", "", "23.48872", "80.10348", "Asia/Kolkata"),
("1256343", "Sihor", "", "IN", "356", "09", "", "", "", "21.71134", "71.96179", "Asia/Kolkata"),
("1256363", "Sidlaghatta", "", "IN", "356", "19", "", "", "", "13.39141", "77.86488", "Asia/Kolkata"),
("1256369", "Sidhi", "Сидхи", "IN", "356", "35", "", "", "", "24.39329", "81.87935", "Asia/Kolkata"),
("1256372", "Sidhauli", "", "IN", "356", "36", "", "", "", "27.26761", "80.81029", "Asia/Kolkata"),
("1256377", "Siddipet", "", "IN", "356", "02", "", "", "", "18.10483", "78.84858", "Asia/Kolkata"),
("1256382", "Siddhapur", "", "IN", "356", "09", "", "", "", "23.91783", "72.37212", "Asia/Kolkata"),
("1256388", "Sibsagar", "Сибсагар", "IN", "356", "03", "", "", "", "26.98427", "94.63784", "Asia/Kolkata"),
("1256409", "Shyamnagar", "", "IN", "356", "28", "8335144", "", "", "22.83333", "88.36667", "Asia/Kolkata"),
("1256418", "Shujalpur", "", "IN", "356", "35", "", "", "", "23.40659", "76.70951", "Asia/Kolkata"),
("1256421", "Shrirangapattana", "", "IN", "356", "19", "", "", "", "12.42264", "76.68439", "Asia/Kolkata"),
("1256422", "Shrirampur", "", "IN", "356", "28", "", "", "", "22.75278", "88.34222", "Asia/Kolkata"),
("1256426", "Shrigonda", "", "IN", "356", "16", "", "", "", "18.61527", "74.69895", "Asia/Kolkata"),
("1256431", "Shorapur", "", "IN", "356", "19", "", "", "", "16.521", "76.75738", "Asia/Kolkata"),
("1256432", "Shoranur", "", "IN", "356", "13", "", "", "", "10.76097", "76.27001", "Asia/Kolkata"),
("1256435", "Sholinghur", "", "IN", "356", "25", "", "", "", "13.1181", "79.42025", "Asia/Kolkata"),
("1256436", "Solapur", "Солапур", "IN", "356", "16", "", "", "", "17.67152", "75.91044", "Asia/Kolkata"),
("1256451", "Shivpuri", "", "IN", "356", "35", "", "", "", "25.42348", "77.66067", "Asia/Kolkata"),
("1256468", "Shishgarh", "", "IN", "356", "36", "", "", "", "28.73178", "79.3139", "Asia/Kolkata"),
("1256475", "Shirpur", "Ширпуре", "IN", "356", "16", "", "", "", "21.35161", "74.88037", "Asia/Kolkata"),
("1256483", "Shirhatti", "", "IN", "356", "19", "", "", "", "15.23352", "75.57996", "Asia/Kolkata"),
("1256489", "Shirdi", "Ширди", "IN", "356", "16", "", "", "", "19.76616", "74.47738", "Asia/Kolkata"),
("1256515", "Shimoga", "", "IN", "356", "19", "", "", "", "13.93157", "75.56791", "Asia/Kolkata"),
("1256523", "Shillong", "Шиллонг", "IN", "356", "18", "", "", "", "25.56892", "91.88313", "Asia/Kolkata"),
("1256525", "Shiliguri", "Силигури", "IN", "356", "28", "", "", "", "26.71004", "88.42851", "Asia/Kolkata"),
("1256529", "Shikohabad", "", "IN", "356", "36", "", "", "", "27.10813", "78.58675", "Asia/Kolkata"),
("1256532", "Shikarpur", "", "IN", "356", "36", "", "", "", "28.28178", "78.01111", "Asia/Kolkata"),
("1256537", "Shikarpur", "", "IN", "356", "19", "", "", "", "14.2698", "75.35643", "Asia/Kolkata"),
("1256539", "Shiggaon", "", "IN", "356", "19", "", "", "", "14.99053", "75.22498", "Asia/Kolkata"),
("1256558", "Shertallai", "", "IN", "356", "13", "", "", "", "9.68428", "76.35337", "Asia/Kolkata"),
("1256569", "Sherkot", "", "IN", "356", "36", "", "", "", "29.32627", "78.57448", "Asia/Kolkata"),
("1256572", "Sherghati", "", "IN", "356", "34", "", "", "", "24.55971", "84.79344", "Asia/Kolkata"),
("1256593", "Sheopur", "", "IN", "356", "35", "", "", "", "25.66677", "76.69612", "Asia/Kolkata"),
("1256597", "Sheohar", "", "IN", "356", "34", "", "", "", "26.51393", "85.2934", "Asia/Kolkata"),
("1256598", "Sheoganj", "", "IN", "356", "24", "", "", "", "25.13915", "73.06784", "Asia/Kolkata"),
("1256620", "Shegaon", "", "IN", "356", "16", "", "", "", "20.7932", "76.69921", "Asia/Kolkata"),
("1256639", "Shantipur", "", "IN", "356", "28", "", "", "", "23.24722", "88.43302", "Asia/Kolkata"),
("1256659", "Shamsabad", "", "IN", "356", "36", "", "", "", "27.53733", "79.43622", "Asia/Kolkata"),
("1256660", "Shamsabad", "", "IN", "356", "36", "", "", "", "27.01628", "78.12348", "Asia/Kolkata"),
("1256671", "Shamli", "", "IN", "356", "36", "", "", "", "29.44934", "77.31282", "Asia/Kolkata"),
("1256673", "Shamgarh", "", "IN", "356", "35", "", "", "", "24.18817", "75.63903", "Asia/Kolkata"),
("1256693", "Shajapur", "", "IN", "356", "35", "", "", "", "23.42688", "76.27772", "Asia/Kolkata"),
("1256698", "Shaikhpura", "", "IN", "356", "34", "", "", "", "25.14067", "85.84332", "Asia/Kolkata"),
("1256705", "Shahpura", "", "IN", "356", "24", "", "", "", "27.3912", "75.95956", "Asia/Kolkata"),
("1256706", "Shahpura", "", "IN", "356", "24", "", "", "", "25.62094", "74.92487", "Asia/Kolkata"),
("1256713", "Shahpur", "Шахпура", "IN", "356", "36", "", "", "", "29.35014", "77.55062", "Asia/Kolkata"),
("1256715", "Shahpur", "", "IN", "356", "34", "", "", "", "25.60213", "84.40412", "Asia/Kolkata"),
("1256720", "Shahpur", "", "IN", "356", "35", "", "", "", "21.2372", "76.22562", "Asia/Kolkata"),
("1256722", "Shahpur", "Шахпура", "IN", "356", "19", "", "", "", "16.70056", "76.84136", "Asia/Kolkata"),
("1256728", "Shahjahanpur", "", "IN", "356", "36", "", "", "", "27.88142", "79.9109", "Asia/Kolkata"),
("1256731", "Shahi", "", "IN", "356", "36", "", "", "", "28.54946", "79.3169", "Asia/Kolkata"),
("1256735", "Shahganj", "", "IN", "356", "36", "", "", "", "26.05263", "82.68134", "Asia/Kolkata"),
("1256739", "Shahdol", "", "IN", "356", "35", "", "", "", "23.29356", "81.3619", "Asia/Kolkata"),
("1256750", "Shahada", "", "IN", "356", "16", "", "", "", "21.54537", "74.47132", "Asia/Kolkata"),
("1256752", "Shahabad", "", "IN", "356", "10", "", "", "", "30.16794", "76.86977", "Asia/Kolkata"),
("1256753", "Shahabad", "", "IN", "356", "36", "", "", "", "28.56681", "79.00956", "Asia/Kolkata"),
("1256755", "Shahabad", "", "IN", "356", "36", "", "", "", "27.64327", "79.93908", "Asia/Kolkata"),
("1256759", "Shahabad", "", "IN", "356", "19", "", "", "", "17.1307", "76.94361", "Asia/Kolkata"),
("1256812", "Serchhip", "", "IN", "356", "31", "", "", "", "23.29312", "92.84679", "Asia/Kolkata"),
("1256814", "Seram", "Серам", "IN", "356", "19", "", "", "", "17.17859", "77.28998", "Asia/Kolkata"),
("1256823", "Seoni Malwa", "", "IN", "356", "35", "", "", "", "22.45", "77.46667", "Asia/Kolkata"),
("1256826", "Seoni", "", "IN", "356", "35", "", "", "", "22.08664", "79.55044", "Asia/Kolkata"),
("1256828", "Seondha", "", "IN", "356", "35", "", "", "", "26.15422", "78.7812", "Asia/Kolkata"),
("1256832", "Seohara", "", "IN", "356", "36", "", "", "", "29.2088", "78.58695", "Asia/Kolkata"),
("1256854", "Sendhwa", "", "IN", "356", "35", "", "", "", "21.68586", "75.0975", "Asia/Kolkata"),
("1256913", "Sehore", "", "IN", "356", "35", "", "", "", "23.2", "77.08333", "Asia/Kolkata"),
("1256922", "Secunderabad", "", "IN", "356", "02", "", "", "", "17.50427", "78.54263", "Asia/Kolkata"),
("1256929", "Sayla", "", "IN", "356", "09", "", "", "", "22.54925", "71.48324", "Asia/Kolkata"),
("1256949", "Sawai Madhopur", "", "IN", "356", "24", "", "", "", "26.02301", "76.34408", "Asia/Kolkata"),
("1256959", "Savda", "", "IN", "356", "16", "", "", "", "21.15035", "75.88898", "Asia/Kolkata"),
("1256967", "Savanur", "", "IN", "356", "19", "", "", "", "14.97335", "75.33724", "Asia/Kolkata"),
("1256968", "Savantvadi", "", "IN", "356", "16", "", "", "", "15.90412", "73.82191", "Asia/Kolkata"),
("1256974", "Sausar", "", "IN", "356", "35", "", "", "", "21.65688", "78.79738", "Asia/Kolkata"),
("1256983", "Saundatti", "", "IN", "356", "19", "", "", "", "15.76615", "75.11778", "Asia/Kolkata"),
("1256989", "Sathyamangalam", "", "IN", "356", "25", "", "", "", "11.50526", "77.23826", "Asia/Kolkata"),
("1256995", "Sattur", "", "IN", "356", "25", "", "", "", "9.35592", "77.92457", "Asia/Kolkata"),
("1257001", "Sattenapalle", "", "IN", "356", "02", "", "", "", "16.39395", "80.15135", "Asia/Kolkata"),
("1257022", "Satna", "", "IN", "356", "35", "1257023", "", "", "24.58224", "80.8248", "Asia/Kolkata"),
("1257055", "Satara", "Сатара", "IN", "356", "16", "", "", "", "17.68589", "73.99333", "Asia/Kolkata"),
("1257060", "Satana", "", "IN", "356", "16", "", "", "", "20.59375", "74.20338", "Asia/Kolkata"),
("1257066", "Sasvad", "", "IN", "356", "16", "", "", "", "18.34351", "74.03102", "Asia/Kolkata"),
("1257093", "Sarwar", "", "IN", "356", "24", "", "", "", "26.06272", "75.01104", "Asia/Kolkata"),
("1257149", "Sarkhej", "", "IN", "356", "09", "", "", "", "22.98297", "72.50196", "Asia/Kolkata"),
("1257191", "Sardulgarh", "", "IN", "356", "23", "", "", "", "29.69224", "75.23608", "Asia/Kolkata"),
("1257196", "Sardhana", "", "IN", "356", "36", "", "", "", "29.14614", "77.61266", "Asia/Kolkata"),
("1257198", "Sardarshahr", "", "IN", "356", "24", "", "", "", "28.44062", "74.491", "Asia/Kolkata"),
("1257219", "Sarauli", "", "IN", "356", "36", "", "", "", "28.4929", "79.0914", "Asia/Kolkata"),
("1257237", "Sarangpur", "", "IN", "356", "35", "", "", "", "23.56645", "76.47194", "Asia/Kolkata"),
("1257259", "Saraipali", "", "IN", "356", "37", "", "", "", "21.31506", "83.00548", "Asia/Kolkata"),
("1257260", "Sarai Mir", "", "IN", "356", "36", "", "", "", "26.02796", "82.91795", "Asia/Kolkata"),
("1257268", "Sarai Akil", "", "IN", "356", "36", "", "", "", "25.37841", "81.5113", "Asia/Kolkata"),
("1257307", "Saoner", "", "IN", "356", "16", "", "", "", "21.38586", "78.92087", "Asia/Kolkata"),
("1257354", "Sankrail", "", "IN", "356", "28", "", "", "", "22.54997", "88.22515", "Asia/Kolkata"),
("1257369", "Sankeshwar", "", "IN", "356", "19", "", "", "", "16.25649", "74.48195", "Asia/Kolkata"),
("1257402", "Sangrur", "", "IN", "356", "23", "", "", "", "30.24608", "75.84686", "Asia/Kolkata"),
("1257409", "Sangola", "", "IN", "356", "16", "", "", "", "17.43948", "75.19379", "Asia/Kolkata"),
("1257410", "Sangod", "", "IN", "356", "24", "", "", "", "24.92707", "76.28649", "Asia/Kolkata"),
("1257416", "Sangli", "", "IN", "356", "16", "", "", "", "16.85438", "74.56417", "Asia/Kolkata"),
("1257429", "Sangaria", "", "IN", "356", "10", "", "", "", "29.79601", "74.4628", "Asia/Kolkata"),
("1257431", "Sangareddi", "", "IN", "356", "02", "", "", "", "17.62478", "78.08669", "Asia/Kolkata"),
("1257436", "Sangamner", "", "IN", "356", "16", "", "", "", "19.56784", "74.21154", "Asia/Kolkata"),
("1257456", "Sandur", "", "IN", "356", "19", "", "", "", "15.08613", "76.54692", "Asia/Kolkata"),
("1257459", "Sandila", "", "IN", "356", "36", "", "", "", "27.07042", "80.5146", "Asia/Kolkata"),
("1257461", "Sandi", "", "IN", "356", "36", "", "", "", "27.2884", "79.95204", "Asia/Kolkata"),
("1257476", "Sancoale", "", "IN", "356", "33", "", "", "", "15.37794", "73.90352", "Asia/Kolkata"),
("1257477", "Sanchor", "", "IN", "356", "24", "", "", "", "24.7536", "71.7728", "Asia/Kolkata"),
("1257481", "Sanawad", "", "IN", "356", "35", "", "", "", "22.17146", "76.07072", "Asia/Kolkata"),
("1257482", "Sanaur", "", "IN", "356", "23", "", "", "", "30.30145", "76.457", "Asia/Kolkata"),
("1257486", "Sanand", "", "IN", "356", "09", "", "", "", "22.99227", "72.38177", "Asia/Kolkata"),
("1257498", "Samthar", "", "IN", "356", "35", "", "", "", "25.84331", "78.90582", "Asia/Kolkata"),
("1257503", "Samrala", "", "IN", "356", "23", "", "", "", "30.83642", "76.19262", "Asia/Kolkata"),
("1257528", "Samdari", "", "IN", "356", "24", "", "", "", "25.81299", "72.57879", "Asia/Kolkata"),
("1257539", "Sambhar", "Самбхара", "IN", "356", "24", "", "", "", "26.90806", "75.19137", "Asia/Kolkata"),
("1257540", "Sambhal", "", "IN", "356", "36", "", "", "", "28.58323", "78.56689", "Asia/Kolkata"),
("1257542", "Sambalpur", "Самбалпур", "IN", "356", "21", "", "", "", "21.45", "83.96667", "Asia/Kolkata"),
("1257545", "Samba", "", "IN", "356", "12", "", "", "", "32.56113", "75.12494", "Asia/Kolkata"),
("1257551", "Samastipur", "", "IN", "356", "34", "", "", "", "25.86077", "85.78971", "Asia/Kolkata"),
("1257565", "Samalkot", "", "IN", "356", "02", "", "", "", "17.05359", "82.17216", "Asia/Kolkata"),
("1257566", "Samalkha", "", "IN", "356", "10", "", "", "", "29.23578", "77.0138", "Asia/Kolkata"),
("1257587", "Salur", "", "IN", "356", "02", "", "", "", "18.51652", "83.20515", "Asia/Kolkata"),
("1257588", "Salumbar", "", "IN", "356", "24", "", "", "", "24.13524", "74.04442", "Asia/Kolkata"),
("1257629", "Salem", "Салем", "IN", "356", "25", "", "", "", "11.65116", "78.15867", "Asia/Kolkata"),
("1257638", "Salaya", "", "IN", "356", "09", "", "", "", "22.31038", "69.60376", "Asia/Kolkata"),
("1257673", "Sakti", "Шакти", "IN", "356", "37", "", "", "", "22.0271", "82.96108", "Asia/Kolkata"),
("1257698", "Sakleshpur", "", "IN", "356", "19", "", "", "", "12.94005", "75.78388", "Asia/Kolkata"),
("1257749", "Saint Thomas Mount", "", "IN", "356", "25", "", "", "", "13.00334", "80.19614", "Asia/Kolkata"),
("1257751", "Sainthia", "", "IN", "356", "28", "", "", "", "23.94826", "87.68045", "Asia/Kolkata"),
("1257762", "Sailu", "", "IN", "356", "16", "", "", "", "19.45514", "76.43946", "Asia/Kolkata"),
("1257771", "Saiha", "", "IN", "356", "31", "", "", "", "22.49183", "92.98142", "Asia/Kolkata"),
("1257776", "Saidpur", "", "IN", "356", "36", "", "", "", "25.53834", "83.22122", "Asia/Kolkata"),
("1257794", "Sahibganj", "", "IN", "356", "38", "", "", "", "25.24237", "87.64908", "Asia/Kolkata"),
("1257799", "Sahawar", "", "IN", "356", "36", "", "", "", "27.79593", "78.83358", "Asia/Kolkata"),
("1257800", "Sahaswan", "", "IN", "356", "36", "", "", "", "28.07245", "78.7493", "Asia/Kolkata"),
("1257802", "Sahaspur", "", "IN", "356", "36", "", "", "", "29.12067", "78.62148", "Asia/Kolkata"),
("1257804", "Saharsa", "", "IN", "356", "34", "", "", "", "25.88504", "86.59471", "Asia/Kolkata"),
("1257806", "Saharanpur", "", "IN", "356", "36", "", "", "", "29.9679", "77.54522", "Asia/Kolkata"),
("1257830", "Sagauli", "", "IN", "356", "34", "", "", "", "26.77137", "84.74197", "Asia/Kolkata"),
("1257845", "Sagar", "Сагар", "IN", "356", "35", "", "", "", "23.84251", "78.74386", "Asia/Kolkata"),
("1257851", "Sagar", "", "IN", "356", "19", "", "", "", "14.16498", "75.02901", "Asia/Kolkata"),
("1257854", "Safipur", "", "IN", "356", "36", "", "", "", "26.73783", "80.3435", "Asia/Kolkata"),
("1257855", "Safidon", "", "IN", "356", "10", "", "", "", "29.40572", "76.6694", "Asia/Kolkata"),
("1257865", "Sadri", "", "IN", "356", "24", "", "", "", "25.18625", "73.45286", "Asia/Kolkata"),
("1257890", "Sadaseopet", "", "IN", "356", "02", "1263231", "", "", "17.61925", "77.95263", "Asia/Kolkata"),
("1257895", "Sadalgi", "", "IN", "356", "19", "", "", "", "16.5587", "74.53211", "Asia/Kolkata"),
("1257896", "Sadabad", "", "IN", "356", "36", "", "", "", "27.43978", "78.03667", "Asia/Kolkata"),
("1257928", "Sabalgarh", "", "IN", "356", "35", "", "", "", "26.24918", "77.40786", "Asia/Kolkata"),
("1257936", "Rusera", "", "IN", "356", "34", "", "", "", "25.75355", "86.02597", "Asia/Kolkata"),
("1257940", "Rura", "", "IN", "356", "36", "", "", "", "26.487", "79.90243", "Asia/Kolkata"),
("1257951", "Rupnagar", "", "IN", "356", "23", "", "", "", "30.96878", "76.52557", "Asia/Kolkata"),
("1258012", "Rudarpur", "", "IN", "356", "36", "", "", "", "26.44335", "83.61238", "Asia/Kolkata"),
("1258044", "Roorkee", "Рурки", "IN", "356", "39", "", "", "", "29.86313", "77.89126", "Asia/Kolkata"),
("1258061", "Ron", "Рона", "IN", "356", "19", "", "", "", "15.69935", "75.73408", "Asia/Kolkata"),
("1258076", "Rohtak", "Рохтак", "IN", "356", "10", "", "", "", "28.88838", "76.5754", "Asia/Kolkata"),
("1258099", "Roha", "", "IN", "356", "16", "", "", "", "18.43687", "73.11964", "Asia/Kolkata"),
("1258109", "Robertsonpet", "", "IN", "356", "19", "", "", "", "12.95629", "78.27543", "Asia/Kolkata"),
("1258111", "Robertsganj", "", "IN", "356", "36", "", "", "", "24.6889", "83.06632", "Asia/Kolkata"),
("1258124", "Risod", "", "IN", "356", "16", "", "", "", "19.9755", "76.78844", "Asia/Kolkata"),
("1258126", "Rishra", "", "IN", "356", "28", "", "", "", "22.72394", "88.34563", "Asia/Kolkata"),
("1258128", "Rishikesh", "Ришикеш", "IN", "356", "39", "", "", "", "30.10778", "78.29255", "Asia/Kolkata"),
("1258140", "Ringas", "", "IN", "356", "24", "", "", "", "27.3636", "75.56838", "Asia/Kolkata"),
("1258164", "Richha", "", "IN", "356", "36", "", "", "", "28.6937", "79.5219", "Asia/Kolkata"),
("1258178", "Rewari", "", "IN", "356", "10", "", "", "", "28.19721", "76.61757", "Asia/Kolkata"),
("1258182", "Rewa", "Рева", "IN", "356", "35", "", "", "", "24.53398", "81.29596", "Asia/Kolkata"),
("1258186", "Revelganj", "", "IN", "356", "34", "", "", "", "25.78553", "84.64038", "Asia/Kolkata"),
("1258201", "Repalle", "Репалле", "IN", "356", "02", "", "", "", "16.0184", "80.82958", "Asia/Kolkata"),
("1258203", "Reoti", "", "IN", "356", "34", "", "", "", "25.85017", "84.37794", "Asia/Kolkata"),
("1258207", "Renukut", "", "IN", "356", "36", "", "", "", "24.21641", "83.0358", "Asia/Kolkata"),
("1258213", "Renigunta", "", "IN", "356", "02", "", "", "", "13.63682", "79.5039", "Asia/Kolkata"),
("1258229", "Remuna", "", "IN", "356", "21", "", "", "", "21.52798", "86.87156", "Asia/Kolkata"),
("1258247", "Rehli", "", "IN", "356", "35", "", "", "", "23.63628", "79.06233", "Asia/Kolkata"),
("1258270", "Razam", "", "IN", "356", "02", "", "", "", "18.44799", "83.65672", "Asia/Kolkata"),
("1258278", "Raybag", "", "IN", "356", "19", "", "", "", "16.49178", "74.77391", "Asia/Kolkata"),
("1258290", "Rayadrug", "", "IN", "356", "02", "", "", "", "14.69743", "76.85769", "Asia/Kolkata"),
("1258291", "Rayachoti", "", "IN", "356", "02", "", "", "", "14.0568", "78.75127", "Asia/Kolkata"),
("1258292", "Raya", "Рая", "IN", "356", "36", "", "", "", "27.55668", "77.79017", "Asia/Kolkata"),
("1258294", "Raxaul", "Раксаул", "IN", "356", "34", "", "", "", "26.9832", "84.85109", "Asia/Kolkata"),
("1258295", "Rawatsar", "", "IN", "356", "24", "", "", "", "29.26724", "74.40288", "Asia/Kolkata"),
("1258297", "Rawatbhata", "", "IN", "356", "24", "", "", "", "24.92981", "75.59209", "Asia/Kolkata"),
("1258307", "Raver", "", "IN", "356", "16", "", "", "", "21.24749", "76.03483", "Asia/Kolkata"),
("1258338", "Ratnagiri", "Ратнагири", "IN", "356", "16", "8131499", "1258340", "", "16.99154", "73.31022", "Asia/Kolkata"),
("1258342", "Ratlam", "", "IN", "356", "35", "", "", "", "23.33033", "75.04032", "Asia/Kolkata"),
("1258347", "Ratia", "Ратиа", "IN", "356", "10", "", "", "", "29.6854", "75.57461", "Asia/Kolkata"),
("1258352", "Rath", "Рата", "IN", "356", "36", "", "", "", "25.59453", "79.56632", "Asia/Kolkata"),
("1258362", "Ratanpur", "", "IN", "356", "37", "", "", "", "22.28785", "82.16767", "Asia/Kolkata"),
("1258366", "Ratangarh", "", "IN", "356", "24", "", "", "", "28.08137", "74.61854", "Asia/Kolkata"),
("1258380", "Rasra", "", "IN", "356", "36", "", "", "", "25.85691", "83.85455", "Asia/Kolkata"),
("1258386", "Rasipuram", "", "IN", "356", "25", "6640313", "", "", "11.46009", "78.18635", "Asia/Kolkata"),
("1258406", "Rapar", "", "IN", "356", "09", "", "", "", "23.57267", "70.64718", "Asia/Kolkata"),
("1258449", "Ranipur", "", "IN", "356", "36", "", "", "", "25.25102", "79.06231", "Asia/Kolkata"),
("1258455", "Ranikhet", "", "IN", "356", "39", "", "", "", "29.64232", "79.4334", "Asia/Kolkata"),
("1258470", "Raniganj", "Ранигандже", "IN", "356", "28", "", "", "", "23.6164", "87.13061", "Asia/Kolkata"),
("1258474", "Ranibennur", "", "IN", "356", "19", "", "", "", "14.6224", "75.62951", "Asia/Kolkata"),
("1258477", "Rania", "Рания", "IN", "356", "10", "", "", "", "29.52454", "74.83689", "Asia/Kolkata"),
("1258492", "Rangia", "", "IN", "356", "03", "", "", "", "26.44931", "91.61356", "Asia/Kolkata"),
("1258501", "Rangapara", "", "IN", "356", "03", "", "", "", "26.83772", "92.66876", "Asia/Kolkata"),
("1258526", "Ranchi", "Ранчи", "IN", "356", "38", "", "", "", "23.34777", "85.33856", "Asia/Kolkata"),
("1258534", "Ranavav", "", "IN", "356", "09", "", "", "", "21.68734", "69.74485", "Asia/Kolkata"),
("1258546", "Ranaghat", "", "IN", "356", "28", "", "", "", "23.17623", "88.56666", "Asia/Kolkata"),
("1258553", "Ramtek", "Рамтек", "IN", "356", "16", "", "", "", "21.39551", "79.32702", "Asia/Kolkata"),
("1258581", "Rampur Hat", "", "IN", "356", "28", "", "", "", "24.17737", "87.78275", "Asia/Kolkata"),
("1258584", "Rampura", "", "IN", "356", "23", "", "", "", "30.25506", "75.24064", "Asia/Kolkata"),
("1258592", "Rampura", "", "IN", "356", "35", "", "", "", "24.467", "75.43996", "Asia/Kolkata"),
("1258598", "Rampur", "", "IN", "356", "36", "", "", "", "29.8058", "77.45146", "Asia/Kolkata"),
("1258599", "Rampur", "", "IN", "356", "36", "", "", "", "28.80904", "79.02896", "Asia/Kolkata"),
("1258637", "Ramnagar", "", "IN", "356", "39", "", "", "", "29.39484", "79.12693", "Asia/Kolkata"),
("1258639", "Ramnagar", "", "IN", "356", "34", "", "", "", "27.16576", "84.32308", "Asia/Kolkata"),
("1258642", "Ramnagar", "", "IN", "356", "36", "", "", "", "25.26873", "83.02934", "Asia/Kolkata"),
("1258658", "Ramjibanpur", "", "IN", "356", "28", "", "", "", "22.82815", "87.60888", "Asia/Kolkata"),
("1258662", "Ramgundam", "", "IN", "356", "02", "", "", "", "18.80084", "79.45206", "Asia/Kolkata"),
("1258677", "Ramgarh", "", "IN", "356", "24", "", "", "", "27.25097", "75.17893", "Asia/Kolkata"),
("1258686", "Ramgarh", "", "IN", "356", "38", "", "", "", "23.63018", "85.51926", "Asia/Kolkata"),
("1258692", "Ramganj Mandi", "", "IN", "356", "24", "", "", "", "24.64648", "75.94325", "Asia/Kolkata"),
("1258698", "Rameswaram", "Рамешварам", "IN", "356", "25", "", "", "", "9.2885", "79.31271", "Asia/Kolkata"),
("1258726", "Ramapuram", "", "IN", "356", "02", "", "", "", "13.10089", "79.18417", "Asia/Kolkata"),
("1258740", "Ramanathapuram", "Раманатхапурама", "IN", "356", "25", "", "", "", "9.37158", "78.83077", "Asia/Kolkata"),
("1258744", "Ramanagaram", "Раманагарам", "IN", "356", "19", "", "", "", "12.72031", "77.28176", "Asia/Kolkata"),
("1258756", "Ramachandrapuram", "", "IN", "356", "02", "", "", "", "16.83636", "82.02871", "Asia/Kolkata"),
("1258786", "Rajura", "", "IN", "356", "16", "", "", "", "19.77921", "79.36266", "Asia/Kolkata"),
("1258795", "Rajula", "", "IN", "356", "09", "", "", "", "21.03854", "71.44345", "Asia/Kolkata"),
("1258797", "Rajsamand", "", "IN", "356", "24", "", "", "", "25.07145", "73.8798", "Asia/Kolkata"),
("1258803", "Rajpura", "", "IN", "356", "23", "", "", "", "30.47276", "76.58671", "Asia/Kolkata"),
("1258815", "Rajpur", "", "IN", "356", "35", "", "", "", "22.30428", "74.35511", "Asia/Kolkata"),
("1258816", "Rajpur", "", "IN", "356", "35", "", "", "", "21.93954", "75.13612", "Asia/Kolkata"),
("1258819", "Rajpipla", "", "IN", "356", "09", "", "", "", "21.86667", "73.5", "Asia/Kolkata"),
("1258831", "Raj Nandgaon", "", "IN", "356", "37", "", "", "", "21.1", "81.03333", "Asia/Kolkata"),
("1258843", "Rajmahal", "", "IN", "356", "28", "", "", "", "25.05303", "87.83048", "Asia/Kolkata"),
("1258847", "Rajkot", "Раджкот", "IN", "356", "09", "", "", "", "22.29161", "70.79322", "Asia/Kolkata"),
("1258859", "Rajgurunagar", "", "IN", "356", "16", "", "", "", "18.86667", "73.9", "Asia/Kolkata"),
("1258864", "Rajgir", "Раджгир", "IN", "356", "34", "", "", "", "25.0277", "85.42133", "Asia/Kolkata"),
("1258868", "Rajgarh", "", "IN", "356", "24", "", "", "", "28.64201", "75.38612", "Asia/Kolkata"),
("1258869", "Rajgarh", "", "IN", "356", "24", "", "", "", "27.23731", "76.62243", "Asia/Kolkata"),
("1258875", "Rajgarh", "", "IN", "356", "35", "", "", "", "24.00826", "76.7325", "Asia/Kolkata"),
("1258876", "Rajgarh", "", "IN", "356", "35", "", "", "", "22.67756", "74.94481", "Asia/Kolkata"),
("1258891", "Rajauri", "", "IN", "356", "12", "", "", "", "33.37541", "74.30838", "Asia/Kolkata"),
("1258916", "Rajapalaiyam", "", "IN", "356", "25", "", "", "", "9.45296", "77.55335", "Asia/Kolkata"),
("1258922", "Rajampet", "", "IN", "356", "02", "", "", "", "14.19508", "79.15914", "Asia/Kolkata"),
("1258928", "Rajaldesar", "", "IN", "356", "24", "", "", "", "28.02822", "74.47304", "Asia/Kolkata"),
("1258930", "Rajakhera", "", "IN", "356", "24", "", "", "", "26.89802", "78.171", "Asia/Kolkata"),
("1258932", "Rajahmundry", "Раджамандри", "IN", "356", "02", "", "", "", "17.00517", "81.77784", "Asia/Kolkata"),
("1258950", "Raisinghnagar", "", "IN", "356", "24", "", "", "", "29.53583", "73.44917", "Asia/Kolkata"),
("1258952", "Raisen", "", "IN", "356", "35", "", "", "", "23.33058", "77.78206", "Asia/Kolkata"),
("1258967", "Raipur", "", "IN", "356", "39", "", "", "", "30.31162", "78.0934", "Asia/Kolkata"),
("1258972", "Raipur", "", "IN", "356", "24", "", "", "", "26.04259", "74.02373", "Asia/Kolkata"),
("1258980", "Raipur", "", "IN", "356", "37", "", "", "", "21.23333", "81.63333", "Asia/Kolkata"),
("1258993", "Raikot", "", "IN", "356", "23", "", "", "", "30.65", "75.6", "Asia/Kolkata"),
("1259005", "Raigarh", "Райгарх", "IN", "356", "37", "", "", "", "21.9", "83.4", "Asia/Kolkata"),
("1259009", "Raiganj", "", "IN", "356", "28", "", "", "", "25.61281", "88.12449", "Asia/Kolkata"),
("1259012", "Raichur", "Райчур", "IN", "356", "19", "", "", "", "16.2047", "77.354", "Asia/Kolkata"),
("1259019", "Rahuri", "", "IN", "356", "16", "", "", "", "19.39069", "74.64979", "Asia/Kolkata"),
("1259026", "Rahimatpur", "", "IN", "356", "16", "", "", "", "17.5921", "74.19966", "Asia/Kolkata"),
("1259034", "Rahatgarh", "", "IN", "356", "35", "", "", "", "23.78816", "78.39411", "Asia/Kolkata"),
("1259049", "Raghunathpur", "", "IN", "356", "28", "", "", "", "23.53878", "86.6735", "Asia/Kolkata"),
("1259056", "Raghogarh", "", "IN", "356", "35", "", "", "", "24.44406", "77.19824", "Asia/Kolkata"),
("1259060", "Rafiganj", "", "IN", "356", "34", "", "", "", "24.81705", "84.63324", "Asia/Kolkata"),
("1259064", "Rae Bareli", "", "IN", "356", "36", "", "", "", "26.2191", "81.24499", "Asia/Kolkata"),
("1259069", "Radhanpur", "", "IN", "356", "09", "", "", "", "23.83238", "71.6047", "Asia/Kolkata"),
("1259083", "Rabkavi", "", "IN", "356", "19", "", "", "", "16.47567", "75.1106", "Asia/Kolkata"),
("1259091", "Kollam", "Квилон", "IN", "356", "13", "7909821", "", "", "8.88113", "76.58469", "Asia/Kolkata"),
("1259108", "Kasba", "", "IN", "356", "34", "", "", "", "25.85643", "87.53836", "Asia/Kolkata"),
("1259110", "Qadian", "", "IN", "356", "23", "", "", "", "31.82198", "75.37663", "Asia/Kolkata"),
("1259123", "Puttur", "", "IN", "356", "02", "", "", "", "13.44189", "79.55314", "Asia/Kolkata"),
("1259124", "Puttur", "", "IN", "356", "19", "", "", "", "12.75975", "75.20169", "Asia/Kolkata"),
("1259148", "Pushkar", "", "IN", "356", "24", "", "", "", "26.49061", "74.55419", "Asia/Kolkata"),
("1259154", "Pusad", "", "IN", "356", "16", "", "", "", "19.9089", "77.56825", "Asia/Kolkata"),
("1259157", "Purwa", "", "IN", "356", "36", "", "", "", "26.45811", "80.77416", "Asia/Kolkata"),
("1259163", "Puruliya", "", "IN", "356", "28", "", "", "", "23.33062", "86.36303", "Asia/Kolkata"),
("1259166", "Purnia", "Пурния", "IN", "356", "34", "", "", "", "25.77895", "87.47422", "Asia/Kolkata"),
("1259177", "Purna", "Пурна", "IN", "356", "16", "", "", "", "19.1798", "77.02595", "Asia/Kolkata"),
("1259184", "Puri", "Пури", "IN", "356", "21", "", "", "", "19.79825", "85.82494", "Asia/Kolkata"),
("1259190", "Puranpur", "", "IN", "356", "36", "", "", "", "28.51283", "80.14829", "Asia/Kolkata"),
("1259210", "Pupri", "", "IN", "356", "34", "", "", "", "26.47079", "85.70311", "Asia/Kolkata"),
("1259222", "Punjai Puliyampatti", "", "IN", "356", "25", "", "", "", "11.35163", "77.16671", "Asia/Kolkata"),
("1259228", "Punganuru", "", "IN", "356", "02", "", "", "", "13.36488", "78.57141", "Asia/Kolkata"),
("1259229", "Pune", "Пуна", "IN", "356", "16", "8131502", "", "", "18.51957", "73.85535", "Asia/Kolkata"),
("1259231", "Pundri", "", "IN", "356", "10", "", "", "", "29.76142", "76.55849", "Asia/Kolkata"),
("1259239", "Punasa", "", "IN", "356", "35", "", "", "", "22.23544", "76.39295", "Asia/Kolkata"),
("1259243", "Punalur", "", "IN", "356", "13", "", "", "", "9.02165", "76.93265", "Asia/Kolkata"),
("1259244", "Punahana", "", "IN", "356", "10", "", "", "", "27.86348", "77.20434", "Asia/Kolkata"),
("1259251", "Pulwama", "", "IN", "356", "12", "", "", "", "33.87405", "74.89955", "Asia/Kolkata"),
("1259263", "Puliyangudi", "", "IN", "356", "25", "", "", "", "9.17489", "77.39799", "Asia/Kolkata"),
("1259264", "Pulivendla", "", "IN", "356", "02", "", "", "", "14.42166", "78.22573", "Asia/Kolkata"),
("1259272", "Pulgaon", "", "IN", "356", "16", "", "", "", "20.72081", "78.32086", "Asia/Kolkata"),
("1259283", "Pukhrayan", "", "IN", "356", "36", "", "", "", "26.22287", "79.83718", "Asia/Kolkata"),
("1259297", "Pudukkottai", "Пудуккоттай", "IN", "356", "25", "", "", "", "10.38128", "78.82141", "Asia/Kolkata"),
("1259312", "Proddatur", "", "IN", "356", "02", "", "", "", "14.7502", "78.54813", "Asia/Kolkata"),
("1259338", "Pratapgarh", "", "IN", "356", "24", "", "", "", "24.03215", "74.78162", "Asia/Kolkata"),
("1259385", "Port Blair", "Порт-Блэр", "IN", "356", "01", "", "", "", "11.66667", "92.75", "Asia/Kolkata"),
("1259388", "Porsa", "Порса", "IN", "356", "35", "", "", "", "26.67324", "78.37085", "Asia/Kolkata"),
("1259395", "Porbandar", "Порбандаром", "IN", "356", "09", "", "", "", "21.64219", "69.60929", "Asia/Kolkata"),
("1259400", "Poonamalle", "", "IN", "356", "25", "", "", "", "13.04888", "80.11488", "Asia/Kolkata"),
("1259408", "Ponnuru", "", "IN", "356", "02", "", "", "", "16.06547", "80.55203", "Asia/Kolkata"),
("1259409", "Ponneri", "", "IN", "356", "25", "", "", "", "13.33868", "80.19487", "Asia/Kolkata"),
("1259411", "Ponnani", "", "IN", "356", "13", "", "", "", "10.76695", "75.92523", "Asia/Kolkata"),
("1259425", "Puducherry", "Пондишери", "IN", "356", "22", "", "", "", "11.93381", "79.82979", "Asia/Kolkata"),
("1259429", "Ponda", "", "IN", "356", "33", "", "", "", "15.40341", "74.01519", "Asia/Kolkata"),
("1259434", "Polur", "", "IN", "356", "25", "", "", "", "12.51217", "79.12405", "Asia/Kolkata"),
("1259440", "Pollachi", "", "IN", "356", "25", "", "", "", "10.65825", "77.0085", "Asia/Kolkata"),
("1259444", "Polavaram", "", "IN", "356", "02", "", "", "", "17.25", "81.63333", "Asia/Kolkata"),
("1259446", "Polasara", "", "IN", "356", "21", "", "", "", "19.69386", "84.81401", "Asia/Kolkata"),
("1259460", "Pokaran", "", "IN", "356", "24", "", "", "", "26.92007", "71.91631", "Asia/Kolkata"),
("1259503", "Pithoragarh", "", "IN", "356", "39", "", "", "", "29.58349", "80.20947", "Asia/Kolkata"),
("1259508", "Pithapuram", "", "IN", "356", "02", "", "", "", "17.1168", "82.25284", "Asia/Kolkata"),
("1259530", "Piro", "", "IN", "356", "34", "", "", "", "25.32989", "84.40803", "Asia/Kolkata"),
("1259535", "Piriyapatna", "", "IN", "356", "19", "", "", "", "12.33573", "76.10003", "Asia/Kolkata"),
("1259541", "Piravam", "", "IN", "356", "13", "", "", "", "9.86667", "76.5", "Asia/Kolkata"),
("1259552", "Pipri", "", "IN", "356", "16", "", "", "", "19.79372", "75.53519", "Asia/Kolkata"),
("1259554", "Pipraich", "", "IN", "356", "36", "", "", "", "26.82799", "83.52689", "Asia/Kolkata"),
("1259592", "Pipili", "", "IN", "356", "21", "", "", "", "20.11357", "85.83147", "Asia/Kolkata"),
("1259608", "Pipar", "", "IN", "356", "24", "", "", "", "26.38441", "73.54394", "Asia/Kolkata"),
("1259630", "Pinjaur", "", "IN", "356", "10", "", "", "", "30.7974", "76.91888", "Asia/Kolkata"),
("1259638", "Pindwara", "", "IN", "356", "24", "", "", "", "24.79749", "73.05505", "Asia/Kolkata"),
("1259647", "Pinahat", "", "IN", "356", "36", "", "", "", "26.88513", "78.37496", "Asia/Kolkata"),
("1259652", "Pimpri", "", "IN", "356", "16", "", "", "", "18.62292", "73.80696", "Asia/Kolkata"),
("1259680", "Pilkhua", "", "IN", "356", "36", "", "", "", "28.71348", "77.65539", "Asia/Kolkata"),
("1259686", "Pilibhit", "Пилибхит", "IN", "356", "36", "", "", "", "28.63098", "79.80338", "Asia/Kolkata"),
("1259688", "Pilibangan", "", "IN", "356", "24", "", "", "", "29.44964", "74.10093", "Asia/Kolkata"),
("1259693", "Pilani", "", "IN", "356", "24", "", "", "", "28.3654", "75.60296", "Asia/Kolkata"),
("1259701", "Pihani", "", "IN", "356", "36", "", "", "", "27.62332", "80.19986", "Asia/Kolkata"),
("1259735", "Phulpur", "", "IN", "356", "36", "", "", "", "25.54842", "82.08978", "Asia/Kolkata"),
("1259744", "Phulera", "", "IN", "356", "24", "", "", "", "26.87401", "75.24171", "Asia/Kolkata"),
("1259756", "Phulabani", "", "IN", "356", "21", "", "", "", "20.47916", "84.23162", "Asia/Kolkata"),
("1259773", "Phirangipuram", "", "IN", "356", "02", "", "", "", "16.29078", "80.26234", "Asia/Kolkata"),
("1259775", "Phillaur", "", "IN", "356", "23", "", "", "", "31.02071", "75.78766", "Asia/Kolkata"),
("1259784", "Phek", "", "IN", "356", "17", "", "", "", "25.66667", "94.5", "Asia/Kolkata"),
("1259801", "Phaphund", "", "IN", "356", "36", "", "", "", "26.59941", "79.46392", "Asia/Kolkata"),
("1259811", "Phaltan", "", "IN", "356", "16", "", "", "", "17.99113", "74.43177", "Asia/Kolkata"),
("1259813", "Phalodi", "", "IN", "356", "24", "", "", "", "27.13102", "72.36826", "Asia/Kolkata"),
("1259818", "Phalauda", "", "IN", "356", "36", "", "", "", "29.18766", "77.82893", "Asia/Kolkata"),
("1259827", "Phagwara", "", "IN", "356", "23", "", "", "", "31.2185", "75.77166", "Asia/Kolkata"),
("1259841", "Petlad", "", "IN", "356", "09", "", "", "", "22.47681", "72.79995", "Asia/Kolkata"),
("1259855", "Perundurai", "", "IN", "356", "25", "", "", "", "11.27564", "77.58794", "Asia/Kolkata"),
("1259857", "Perumpavur", "", "IN", "356", "13", "", "", "", "10.11136", "76.47478", "Asia/Kolkata"),
("1259878", "Periyanayakkanpalaiyam", "", "IN", "356", "25", "", "", "", "11.15255", "76.95159", "Asia/Kolkata"),
("1259879", "Periyakulam", "", "IN", "356", "25", "", "", "", "10.12127", "77.54392", "Asia/Kolkata"),
("1259890", "Peravurani", "", "IN", "356", "25", "", "", "", "10.29035", "79.20156", "Asia/Kolkata"),
("1259892", "Peranampattu", "", "IN", "356", "25", "", "", "", "12.9343", "78.7189", "Asia/Kolkata"),
("1259896", "Perambalur", "", "IN", "356", "25", "", "", "", "11.23333", "78.88333", "Asia/Kolkata"),
("1259905", "Penukonda", "", "IN", "356", "02", "", "", "", "14.08339", "77.59588", "Asia/Kolkata"),
("1259907", "Penugonda", "", "IN", "356", "02", "", "", "", "16.65363", "81.7455", "Asia/Kolkata"),
("1259916", "Pennagaram", "", "IN", "356", "25", "", "", "", "12.1345", "77.89514", "Asia/Kolkata"),
("1259917", "Pennadam", "", "IN", "356", "25", "", "", "", "11.40316", "79.24103", "Asia/Kolkata"),
("1259931", "Pen", "", "IN", "356", "16", "", "", "", "18.73734", "73.09603", "Asia/Kolkata"),
("1259939", "Pehowa", "", "IN", "356", "10", "", "", "", "29.98178", "76.58305", "Asia/Kolkata"),
("1259954", "Peddapuram", "", "IN", "356", "02", "", "", "", "17.07575", "82.13905", "Asia/Kolkata"),
("1259961", "Peddapalli", "", "IN", "356", "02", "", "", "", "18.61357", "79.37442", "Asia/Kolkata"),
("1259986", "Pedana", "", "IN", "356", "02", "", "", "", "16.25582", "81.14378", "Asia/Kolkata"),
("1259994", "Payyannur", "", "IN", "356", "13", "", "", "", "12.0935", "75.20249", "Asia/Kolkata"),
("1260003", "Pawayan", "", "IN", "356", "36", "", "", "", "28.06626", "80.10305", "Asia/Kolkata"),
("1260014", "Pavagada", "", "IN", "356", "19", "", "", "", "14.10009", "77.28151", "Asia/Kolkata"),
("1260016", "Pauri", "", "IN", "356", "39", "", "", "", "30.15356", "78.76998", "Asia/Kolkata"),
("1260022", "Pauni", "", "IN", "356", "16", "", "", "", "20.79205", "79.63583", "Asia/Kolkata"),
("1260035", "Patur", "", "IN", "356", "16", "", "", "", "20.46093", "76.93724", "Asia/Kolkata"),
("1260040", "Pattukkottai", "", "IN", "356", "25", "", "", "", "10.42358", "79.31949", "Asia/Kolkata"),
("1260045", "Patti", "", "IN", "356", "23", "", "", "", "31.28083", "74.85722", "Asia/Kolkata"),
("1260082", "Patnagarh", "", "IN", "356", "21", "", "", "", "20.70833", "83.13263", "Asia/Kolkata"),
("1260086", "Patna", "Патна", "IN", "356", "34", "", "", "", "25.60222", "85.11936", "Asia/Kolkata"),
("1260107", "Patiala", "Патьяла", "IN", "356", "23", "", "", "", "30.32715", "76.40266", "Asia/Kolkata"),
("1260120", "Pathri", "Патри", "IN", "356", "16", "", "", "", "19.25946", "76.43354", "Asia/Kolkata"),
("1260129", "Patharia", "", "IN", "356", "35", "", "", "", "23.89824", "79.19392", "Asia/Kolkata"),
("1260134", "Pathardih", "", "IN", "356", "38", "", "", "", "23.6658", "86.43166", "Asia/Kolkata"),
("1260135", "Pathardi", "", "IN", "356", "16", "", "", "", "19.17279", "75.17425", "Asia/Kolkata"),
("1260137", "Pathankot", "Патханкот", "IN", "356", "23", "", "", "", "32.27306", "75.65256", "Asia/Kolkata"),
("1260138", "Pathanamthitta", "", "IN", "356", "13", "", "", "", "9.26667", "76.78333", "Asia/Kolkata"),
("1260141", "Pathalgaon", "", "IN", "356", "37", "", "", "", "22.55656", "83.46355", "Asia/Kolkata"),
("1260156", "Pataudi", "", "IN", "356", "10", "", "", "", "28.32547", "76.77858", "Asia/Kolkata"),
("1260168", "Patancheru", "", "IN", "356", "02", "", "", "", "17.53334", "78.2645", "Asia/Kolkata"),
("1260173", "Patan", "Патан", "IN", "356", "09", "", "", "", "23.8507", "72.12963", "Asia/Kolkata"),
("1260178", "Patamundai", "", "IN", "356", "21", "", "", "", "20.57806", "86.56063", "Asia/Kolkata"),
("1260206", "Pasighat", "", "IN", "356", "30", "", "", "", "28.06631", "95.32678", "Asia/Kolkata"),
("1260210", "Pasan", "", "IN", "356", "37", "", "", "", "22.8436", "82.19919", "Asia/Kolkata"),
("1260221", "Parvatsar", "", "IN", "356", "24", "", "", "", "26.88604", "74.76602", "Asia/Kolkata"),
("1260222", "Parvatipuram", "", "IN", "356", "02", "", "", "", "18.78303", "83.42668", "Asia/Kolkata"),
("1260228", "Partur", "", "IN", "356", "16", "", "", "", "19.59943", "76.21491", "Asia/Kolkata"),
("1260274", "Parola", "", "IN", "356", "16", "", "", "", "20.88025", "75.11723", "Asia/Kolkata"),
("1260290", "Parli Vaijnath", "", "IN", "356", "16", "", "", "", "18.85018", "76.53211", "Asia/Kolkata"),
("1260296", "Parlakimidi", "", "IN", "356", "02", "", "", "", "18.78113", "84.08836", "Asia/Kolkata"),
("1260304", "Pariyapuram", "", "IN", "356", "13", "", "", "", "11.01667", "75.86667", "Asia/Kolkata"),
("1260313", "Parichhatgarh", "", "IN", "356", "36", "", "", "", "28.97809", "77.93306", "Asia/Kolkata"),
("1260335", "Pardi", "", "IN", "356", "09", "", "", "", "20.5087", "72.94569", "Asia/Kolkata"),
("1260341", "Parbhani", "", "IN", "356", "16", "", "", "", "19.26855", "76.77081", "Asia/Kolkata"),
("1260354", "Paravur", "", "IN", "356", "13", "", "", "", "8.78333", "76.7", "Asia/Kolkata"),
("1260368", "Parasia", "", "IN", "356", "35", "", "", "", "22.19137", "78.7579", "Asia/Kolkata"),
("1260387", "Paramagudi", "", "IN", "356", "25", "", "", "", "9.54633", "78.5907", "Asia/Kolkata"),
("1260393", "Paradip Garh", "", "IN", "356", "21", "", "", "", "20.31641", "86.6085", "Asia/Kolkata"),
("1260406", "Pappinisseri", "", "IN", "356", "13", "", "", "", "11.95", "75.35", "Asia/Kolkata"),
("1260417", "Papanasam", "", "IN", "356", "25", "", "", "", "10.92687", "79.27056", "Asia/Kolkata"),
("1260421", "Paonta Sahib", "", "IN", "356", "11", "", "", "", "30.43853", "77.62479", "Asia/Kolkata"),
("1260434", "Panvel", "", "IN", "356", "16", "", "", "", "18.98878", "73.11013", "Asia/Kolkata"),
("1260448", "Panruti", "", "IN", "356", "25", "", "", "", "11.77662", "79.55269", "Asia/Kolkata"),
("1260454", "Panna", "", "IN", "356", "35", "", "", "", "24.72147", "80.18808", "Asia/Kolkata"),
("1260456", "Panmana", "", "IN", "356", "13", "", "", "", "9.01667", "76.51667", "Asia/Kolkata"),
("1260476", "Panipat", "Панипата", "IN", "356", "10", "", "", "", "29.39005", "76.96949", "Asia/Kolkata"),
("1260482", "Panihati", "", "IN", "356", "28", "", "", "", "22.69089", "88.37404", "Asia/Kolkata"),
("1260527", "Pandua", "", "IN", "356", "28", "", "", "", "23.07492", "88.28637", "Asia/Kolkata"),
("1260543", "Pandhurna", "", "IN", "356", "35", "", "", "", "21.59302", "78.52888", "Asia/Kolkata"),
("1260546", "Pandharpur", "Пандхарпур", "IN", "356", "16", "", "", "", "17.67924", "75.33098", "Asia/Kolkata"),
("1260553", "Pandavapura", "", "IN", "356", "19", "", "", "", "12.50083", "76.67452", "Asia/Kolkata"),
("1260607", "Panaji", "Панаджи", "IN", "356", "33", "", "", "", "15.49574", "73.82624", "Asia/Kolkata"),
("1260612", "Panagar", "", "IN", "356", "35", "", "", "", "23.28552", "79.99465", "Asia/Kolkata"),
("1260637", "Palwal", "", "IN", "356", "10", "", "", "", "28.14327", "77.32698", "Asia/Kolkata"),
("1260667", "Paloncha", "", "IN", "356", "02", "", "", "", "17.60184", "80.70509", "Asia/Kolkata"),
("1260671", "Palani", "Палани", "IN", "356", "25", "", "", "", "10.45034", "77.5209", "Asia/Kolkata"),
("1260674", "Palmaner", "", "IN", "356", "02", "", "", "", "13.20074", "78.74681", "Asia/Kolkata"),
("1260681", "Pallippatti", "", "IN", "356", "25", "", "", "", "11.93956", "78.40152", "Asia/Kolkata"),
("1260685", "Pallikondai", "", "IN", "356", "25", "", "", "", "12.90816", "78.94195", "Asia/Kolkata"),
("1260692", "Pallavaram", "", "IN", "356", "25", "", "", "", "12.96796", "80.15025", "Asia/Kolkata"),
("1260694", "Pallappatti", "", "IN", "356", "25", "", "", "", "10.72057", "77.87951", "Asia/Kolkata"),
("1260697", "Palladam", "", "IN", "356", "25", "", "", "", "10.99175", "77.28633", "Asia/Kolkata"),
("1260702", "Palkonda", "", "IN", "356", "02", "", "", "", "18.60354", "83.75504", "Asia/Kolkata"),
("1260707", "Palitana", "Палитана", "IN", "356", "09", "", "", "", "21.52519", "71.82308", "Asia/Kolkata"),
("1260713", "Palia Kalan", "", "IN", "356", "36", "", "", "", "28.43205", "80.58137", "Asia/Kolkata"),
("1260716", "Pali", "Пали", "IN", "356", "24", "", "", "", "25.77276", "73.32335", "Asia/Kolkata"),
("1260718", "Pali", "Пали", "IN", "356", "35", "", "", "", "23.36453", "81.04374", "Asia/Kolkata"),
("1260728", "Palakkad", "Палаккад", "IN", "356", "13", "", "", "", "10.7744", "76.65625", "Asia/Kolkata"),
("1260730", "Palghar", "", "IN", "356", "16", "", "", "", "19.69693", "72.76543", "Asia/Kolkata"),
("1260734", "Palera", "", "IN", "356", "35", "", "", "", "25.02023", "79.2318", "Asia/Kolkata"),
("1260771", "Palasa", "", "IN", "356", "02", "", "", "", "18.77257", "84.41012", "Asia/Kolkata"),
("1260777", "Palanpur", "", "IN", "356", "09", "", "", "", "24.17097", "72.43821", "Asia/Kolkata"),
("1260792", "Palakollu", "", "IN", "356", "02", "", "", "", "16.5167", "81.73", "Asia/Kolkata"),
("1260793", "Palakkodu", "", "IN", "356", "25", "", "", "", "12.30696", "78.07022", "Asia/Kolkata"),
("1260824", "Pakaur", "", "IN", "356", "28", "", "", "", "24.63846", "87.83893", "Asia/Kolkata"),
("1260830", "Pakala", "", "IN", "356", "02", "", "", "", "13.44917", "79.11749", "Asia/Kolkata"),
("1260833", "Paithan", "", "IN", "356", "16", "", "", "", "19.47506", "75.38558", "Asia/Kolkata"),
("1260868", "Pahasu", "", "IN", "356", "36", "", "", "", "28.17222", "78.06358", "Asia/Kolkata"),
("1260909", "Padrauna", "", "IN", "356", "36", "", "", "", "26.90424", "83.98104", "Asia/Kolkata"),
("1260911", "Padra", "", "IN", "356", "09", "", "", "", "22.2398", "73.08451", "Asia/Kolkata"),
("1260918", "Padmanabhapuram", "", "IN", "356", "25", "", "", "", "8.24462", "77.32581", "Asia/Kolkata"),
("1260938", "Padampur", "", "IN", "356", "24", "", "", "", "29.70885", "73.62539", "Asia/Kolkata"),
("1260940", "Padampur", "", "IN", "356", "21", "", "", "", "20.98333", "83.06667", "Asia/Kolkata"),
("1260942", "Padam", "", "IN", "356", "12", "", "", "", "33.46658", "76.88488", "Asia/Kolkata"),
("1260954", "Pachperwa", "", "IN", "356", "36", "", "", "", "27.51234", "82.64297", "Asia/Kolkata"),
("1260959", "Pachora", "", "IN", "356", "16", "", "", "", "20.66714", "75.35183", "Asia/Kolkata"),
("1261008", "Ottappalam", "", "IN", "356", "13", "", "", "", "10.77094", "76.37844", "Asia/Kolkata"),
("1261012", "Osmanabad", "Османабад", "IN", "356", "16", "Marathwada (undefined)", "1261013", "", "18.18158", "76.0389", "Asia/Kolkata"),
("1261039", "Orai", "", "IN", "356", "36", "", "", "", "25.99074", "79.45315", "Asia/Kolkata"),
("1261045", "Ongole", "Онголе", "IN", "356", "02", "", "", "", "15.50642", "80.04867", "Asia/Kolkata"),
("1261066", "Okha", "Оха", "IN", "356", "09", "", "", "", "22.46756", "69.07002", "Asia/Kolkata"),
("1261068", "Ozar", "", "IN", "356", "16", "8131501", "", "", "20.09473", "73.92816", "Asia/Kolkata"),
("1261086", "Obra", "", "IN", "356", "36", "", "", "", "24.41656", "82.9859", "Asia/Kolkata"),
("1261110", "Nuzvid", "", "IN", "356", "02", "", "", "", "16.78806", "80.84646", "Asia/Kolkata"),
("1261122", "Nurpur", "", "IN", "356", "36", "", "", "", "29.14984", "78.40917", "Asia/Kolkata"),
("1261162", "Nowrangapur", "", "IN", "356", "21", "8908677", "", "", "19.23114", "82.54826", "Asia/Kolkata"),
("1261181", "North Lakhimpur", "", "IN", "356", "03", "", "", "", "27.23517", "94.10357", "Asia/Kolkata"),
("1261186", "North Guwahati", "", "IN", "356", "03", "", "", "", "26.1975", "91.7202", "Asia/Kolkata"),
("1261205", "Nongstoin", "", "IN", "356", "18", "7701511", "", "", "25.51704", "91.26484", "Asia/Kolkata"),
("1261227", "Nokha", "", "IN", "356", "24", "", "", "", "27.56155", "73.47141", "Asia/Kolkata"),
("1261234", "Nohar", "", "IN", "356", "24", "", "", "", "29.18351", "74.77045", "Asia/Kolkata"),
("1261242", "Noamundi", "", "IN", "356", "38", "", "", "", "22.16094", "85.50416", "Asia/Kolkata"),
("1261258", "Nizamabad", "", "IN", "356", "02", "", "", "", "18.67154", "78.0988", "Asia/Kolkata"),
("1261285", "Nirmali", "", "IN", "356", "34", "", "", "", "26.31397", "86.58537", "Asia/Kolkata"),
("1261288", "Nirmal", "Нирмала", "IN", "356", "02", "", "", "", "19.09685", "78.34406", "Asia/Kolkata"),
("1261309", "Nipani", "", "IN", "356", "16", "", "", "", "16.399", "74.38285", "Asia/Kolkata"),
("1261342", "Neem ka Thana", "", "IN", "356", "24", "", "", "", "27.73976", "75.78652", "Asia/Kolkata"),
("1261369", "Nimbahera", "", "IN", "356", "24", "", "", "", "24.62166", "74.67999", "Asia/Kolkata"),
("1261375", "Nimaparha", "", "IN", "356", "21", "", "", "", "20.05756", "86.00436", "Asia/Kolkata"),
("1261378", "Nimbaj", "", "IN", "356", "24", "", "", "", "26.15006", "74.00152", "Asia/Kolkata"),
("1261382", "Nilokheri", "", "IN", "356", "10", "", "", "", "29.83671", "76.9319", "Asia/Kolkata"),
("1261394", "Nileshwar", "", "IN", "356", "13", "", "", "", "12.2649", "75.13914", "Asia/Kolkata"),
("1261396", "Nilanga", "", "IN", "356", "16", "", "", "", "18.11675", "76.75279", "Asia/Kolkata"),
("1261401", "Nilakottai", "", "IN", "356", "25", "", "", "", "10.165", "77.85024", "Asia/Kolkata"),
("1261402", "Nilgiri", "", "IN", "356", "21", "", "", "", "21.46236", "86.76794", "Asia/Kolkata"),
("1261415", "Nihtaur", "", "IN", "356", "36", "", "", "", "29.32396", "78.38673", "Asia/Kolkata"),
("1261446", "Nidadavole", "", "IN", "356", "02", "", "", "", "16.9027", "81.67451", "Asia/Kolkata"),
("1261451", "Nichlaul", "", "IN", "356", "36", "", "", "", "27.31247", "83.7253", "Asia/Kolkata"),
("1261470", "Neyyattinkara", "", "IN", "356", "13", "", "", "", "8.39854", "77.08586", "Asia/Kolkata"),
("1261481", "New Delhi", "Нью-Дели", "IN", "356", "07", "", "", "", "28.63576", "77.22445", "Asia/Kolkata"),
("1261512", "Neral", "", "IN", "356", "16", "", "", "", "19.02475", "73.31688", "Asia/Kolkata"),
("1261517", "Nepa Nagar", "", "IN", "356", "35", "", "", "", "21.45525", "76.3934", "Asia/Kolkata"),
("1261529", "Nellore", "Неллор", "IN", "356", "02", "", "", "", "14.45363", "79.98674", "Asia/Kolkata"),
("1261532", "Nellikkuppam", "", "IN", "356", "25", "", "", "", "11.77577", "79.66789", "Asia/Kolkata"),
("1261539", "Nelamangala", "", "IN", "356", "19", "", "", "", "13.09795", "77.39575", "Asia/Kolkata"),
("1261553", "Nedumangad", "", "IN", "356", "13", "", "", "", "8.60267", "77.00139", "Asia/Kolkata"),
("1261567", "Nayudupeta", "", "IN", "356", "02", "", "", "", "13.90777", "79.89649", "Asia/Kolkata"),
("1261580", "Nayagarh", "", "IN", "356", "21", "", "", "", "20.12856", "85.09563", "Asia/Kolkata"),
("1261598", "Nawashahr", "", "IN", "356", "23", "", "", "", "31.12612", "76.11633", "Asia/Kolkata"),
("1261613", "Nawalgarh", "", "IN", "356", "24", "", "", "", "27.85161", "75.27384", "Asia/Kolkata"),
("1261614", "Niwai", "", "IN", "356", "24", "", "", "", "26.36073", "75.91836", "Asia/Kolkata"),
("1261631", "Nawada", "", "IN", "356", "34", "", "", "", "24.8867", "85.54364", "Asia/Kolkata"),
("1261639", "Nawabganj", "", "IN", "356", "36", "", "", "", "28.53966", "79.63282", "Asia/Kolkata"),
("1261641", "Nawabganj", "", "IN", "356", "36", "", "", "", "26.93109", "81.19934", "Asia/Kolkata"),
("1261642", "Nawabganj", "", "IN", "356", "36", "", "", "", "26.86452", "82.14016", "Asia/Kolkata"),
("1261647", "Nawa", "", "IN", "356", "24", "", "", "", "27.0195", "75.00226", "Asia/Kolkata"),
("1261667", "Navalgund", "", "IN", "356", "19", "", "", "", "15.55877", "75.35305", "Asia/Kolkata"),
("1261669", "Navadwip", "Навадвип", "IN", "356", "28", "", "", "", "23.4067", "88.3686", "Asia/Kolkata"),
("1261672", "Nautanwa", "", "IN", "356", "36", "", "", "", "27.42752", "83.41789", "Asia/Kolkata"),
("1261696", "Naugachhia", "", "IN", "356", "34", "", "", "", "25.38706", "87.09856", "Asia/Kolkata"),
("1261705", "Nattam", "", "IN", "356", "25", "", "", "", "10.22776", "78.22969", "Asia/Kolkata"),
("1261711", "Nathdwara", "", "IN", "356", "24", "", "", "", "24.93805", "73.82392", "Asia/Kolkata"),
("1261721", "Nasrullahganj", "", "IN", "356", "35", "", "", "", "22.68411", "77.26887", "Asia/Kolkata"),
("1261722", "Nasriganj", "", "IN", "356", "34", "", "", "", "25.0503", "84.32762", "Asia/Kolkata"),
("1261726", "Naspur", "", "IN", "356", "02", "", "", "", "18.84577", "79.46165", "Asia/Kolkata"),
("1261727", "Nasirabad", "", "IN", "356", "24", "", "", "", "26.30473", "74.73364", "Asia/Kolkata"),
("1261731", "Nashik", "Насик", "IN", "356", "16", "8131501", "", "", "19.99727", "73.79096", "Asia/Kolkata"),
("1261736", "Narwar", "", "IN", "356", "35", "", "", "", "25.6439", "77.9129", "Asia/Kolkata"),
("1261739", "Narwana", "", "IN", "356", "10", "", "", "", "29.59489", "76.11816", "Asia/Kolkata"),
("1261748", "Narsipatnam", "", "IN", "356", "02", "", "", "", "17.66727", "82.61044", "Asia/Kolkata"),
("1261752", "Narsinghgarh", "", "IN", "356", "35", "", "", "", "23.70758", "77.09318", "Asia/Kolkata"),
("1261754", "Narsimhapur", "", "IN", "356", "35", "", "", "", "22.95078", "79.184", "Asia/Kolkata"),
("1261771", "Narnaund", "", "IN", "356", "10", "", "", "", "29.22123", "76.14171", "Asia/Kolkata"),
("1261772", "Narnaul", "", "IN", "356", "10", "", "", "", "28.04444", "76.10833", "Asia/Kolkata"),
("1261800", "Nargund", "", "IN", "356", "19", "", "", "", "15.72299", "75.38666", "Asia/Kolkata"),
("1261810", "Naregal", "", "IN", "356", "19", "", "", "", "15.57316", "75.80804", "Asia/Kolkata"),
("1261823", "Narayanpet", "", "IN", "356", "02", "", "", "", "16.74799", "77.4954", "Asia/Kolkata"),
("1261828", "Narayangarh", "", "IN", "356", "10", "", "", "", "30.47696", "77.12653", "Asia/Kolkata"),
("1261835", "Naravarikuppam", "", "IN", "356", "25", "", "", "", "13.19133", "80.18473", "Asia/Kolkata"),
("1261837", "Naraura", "", "IN", "356", "36", "", "", "", "28.19994", "78.38472", "Asia/Kolkata"),
("1261839", "Narauli", "", "IN", "356", "36", "", "", "", "28.48451", "78.71291", "Asia/Kolkata"),
("1261848", "Narasaraopet", "", "IN", "356", "02", "", "", "", "16.2347", "80.04711", "Asia/Kolkata"),
("1261852", "Narasapur", "", "IN", "356", "02", "", "", "", "16.4361", "81.70159", "Asia/Kolkata"),
("1261853", "Narasannapeta", "", "IN", "356", "02", "", "", "", "18.41428", "84.04463", "Asia/Kolkata"),
("1261871", "Naraini", "", "IN", "356", "35", "", "", "", "25.19032", "80.475", "Asia/Kolkata"),
("1261872", "Naraina", "", "IN", "356", "24", "", "", "", "26.79069", "75.20608", "Asia/Kolkata"),
("1261882", "Napasar", "", "IN", "356", "24", "", "", "", "27.96059", "73.55913", "Asia/Kolkata"),
("1261901", "Nanpara", "", "IN", "356", "36", "", "", "", "27.86459", "81.50036", "Asia/Kolkata"),
("1261910", "Nanjangud", "", "IN", "356", "19", "", "", "", "12.11802", "76.68411", "Asia/Kolkata"),
("1261913", "Nangloi Jat", "", "IN", "356", "07", "", "", "", "28.6786", "77.06749", "Asia/Kolkata"),
("1261922", "Nangal Township", "Нангал", "IN", "356", "23", "", "", "", "31.38966", "76.37574", "Asia/Kolkata"),
("1261927", "Nandyal", "", "IN", "356", "02", "", "", "", "15.48879", "78.48648", "Asia/Kolkata"),
("1261931", "Nandurbar", "", "IN", "356", "16", "", "", "", "21.36608", "74.23955", "Asia/Kolkata"),
("1261932", "Nandura", "", "IN", "356", "16", "", "", "", "20.83528", "76.45839", "Asia/Kolkata"),
("1261957", "Nandikotkur", "", "IN", "356", "02", "", "", "", "15.85668", "78.26569", "Asia/Kolkata"),
("1261960", "Nandigama", "", "IN", "356", "02", "", "", "", "16.77222", "80.28554", "Asia/Kolkata"),
("1261971", "Nandgaon", "", "IN", "356", "16", "", "", "", "20.30713", "74.65733", "Asia/Kolkata"),
("1261977", "Nanded", "Нандед", "IN", "356", "16", "Marathwada (undefined)", "1261978", "", "19.16023", "77.31497", "Asia/Kolkata"),
("1261998", "Nanauta", "", "IN", "356", "36", "", "", "", "29.71256", "77.4174", "Asia/Kolkata"),
("1262013", "Namrup", "", "IN", "356", "03", "", "", "", "27.19395", "95.31929", "Asia/Kolkata"),
("1262034", "Nambiyur", "", "IN", "356", "25", "", "", "", "11.35833", "77.32099", "Asia/Kolkata"),
("1262039", "Namakkal", "", "IN", "356", "25", "", "", "", "11.22126", "78.16524", "Asia/Kolkata"),
("1262040", "Namagiripettai", "", "IN", "356", "25", "", "", "", "11.455", "78.269", "Asia/Kolkata"),
("1262065", "Nalhati", "", "IN", "356", "28", "", "", "", "24.3", "87.81667", "Asia/Kolkata"),
("1262067", "Nalgonda", "Налгонда", "IN", "356", "02", "", "", "", "17.05439", "79.26707", "Asia/Kolkata"),
("1262073", "Naldurg", "", "IN", "356", "16", "", "", "", "17.81667", "76.28182", "Asia/Kolkata"),
("1262089", "Nakur", "", "IN", "356", "36", "", "", "", "29.91972", "77.30397", "Asia/Kolkata"),
("1262092", "Naksalbari", "", "IN", "356", "28", "", "", "", "26.6827", "88.22", "Asia/Kolkata"),
("1262097", "Nakodar", "", "IN", "356", "23", "", "", "", "31.1259", "75.47586", "Asia/Kolkata"),
("1262109", "Najibabad", "", "IN", "356", "36", "", "", "", "29.61207", "78.34338", "Asia/Kolkata"),
("1262115", "Nainwa", "", "IN", "356", "24", "", "", "", "25.77145", "75.84978", "Asia/Kolkata"),
("1262116", "Nainpur", "", "IN", "356", "35", "", "", "", "22.42743", "80.10875", "Asia/Kolkata"),
("1262117", "Naini Tal", "", "IN", "356", "39", "", "", "", "29.39743", "79.44686", "Asia/Kolkata"),
("1262131", "Naihati", "", "IN", "356", "28", "", "", "", "22.89396", "88.4152", "Asia/Kolkata"),
("1262140", "Nahorkatiya", "", "IN", "356", "03", "", "", "", "27.28912", "95.3418", "Asia/Kolkata"),
("1262151", "Nahan", "", "IN", "356", "11", "", "", "", "30.56056", "77.29403", "Asia/Kolkata"),
("1262180", "Nagpur", "Нагпур", "IN", "356", "16", "8131500", "", "", "21.14631", "79.08491", "Asia/Kolkata"),
("1262187", "Nagod", "", "IN", "356", "35", "", "", "", "24.5705", "80.58655", "Asia/Kolkata"),
("1262200", "Nagina", "", "IN", "356", "36", "", "", "", "29.44439", "78.43488", "Asia/Kolkata"),
("1262204", "Nagercoil", "", "IN", "356", "25", "", "", "", "8.17731", "77.43437", "Asia/Kolkata"),
("1262209", "Nagda", "", "IN", "356", "35", "", "", "", "23.45834", "75.41759", "Asia/Kolkata"),
("1262216", "Nagaur", "", "IN", "356", "24", "", "", "", "27.20201", "73.73394", "Asia/Kolkata"),
("1262230", "Nagar Karnul", "", "IN", "356", "02", "", "", "", "16.4821", "78.32471", "Asia/Kolkata"),
("1262240", "Nagari", "", "IN", "356", "02", "", "", "", "13.32139", "79.58557", "Asia/Kolkata"),
("1262253", "Nagar", "", "IN", "356", "24", "", "", "", "27.42397", "77.09922", "Asia/Kolkata"),
("1262260", "Nagappattinam", "", "IN", "356", "25", "", "", "", "10.76393", "79.84454", "Asia/Kolkata"),
("1262266", "Nagamangala", "", "IN", "356", "19", "", "", "", "12.81938", "76.75485", "Asia/Kolkata"),
("1262285", "Naduvannur", "", "IN", "356", "13", "", "", "", "11.48772", "75.77511", "Asia/Kolkata"),
("1262292", "Nadiad", "", "IN", "356", "09", "", "", "", "22.69385", "72.86157", "Asia/Kolkata"),
("1262296", "Nadbai", "", "IN", "356", "24", "", "", "", "27.22288", "77.19569", "Asia/Kolkata"),
("1262302", "Nadapuram", "", "IN", "356", "13", "", "", "", "11.7", "75.66667", "Asia/Kolkata"),
("1262318", "Nabinagar", "", "IN", "356", "34", "", "", "", "24.60658", "84.12719", "Asia/Kolkata"),
("1262319", "Nabha", "", "IN", "356", "23", "", "", "", "30.37475", "76.15077", "Asia/Kolkata"),
("1262321", "Mysore", "Майсур", "IN", "356", "19", "", "", "", "12.29791", "76.63925", "Asia/Kolkata"),
("1262330", "Muzaffarpur", "", "IN", "356", "34", "", "", "", "26.12259", "85.39055", "Asia/Kolkata"),
("1262332", "Muzaffarnagar", "", "IN", "356", "36", "", "", "", "29.47394", "77.70414", "Asia/Kolkata"),
("1262338", "Muvattupula", "", "IN", "356", "13", "", "", "", "9.98493", "76.57728", "Asia/Kolkata"),
("1262346", "Muttupet", "", "IN", "356", "25", "", "", "", "10.39531", "79.49425", "Asia/Kolkata"),
("1262374", "Mussoorie", "Муссури", "IN", "356", "39", "", "", "", "30.4571", "78.05498", "Asia/Kolkata"),
("1262380", "Musiri", "", "IN", "356", "25", "", "", "", "10.95299", "78.44427", "Asia/Kolkata"),
("1262382", "Mushabani", "", "IN", "356", "38", "", "", "", "22.51136", "86.45713", "Asia/Kolkata"),
("1262395", "Murwara", "", "IN", "356", "35", "", "", "", "23.83677", "80.39482", "Asia/Kolkata"),
("1262410", "Murtajapur", "", "IN", "356", "16", "", "", "", "20.73263", "77.36714", "Asia/Kolkata"),
("1262412", "Murshidabad", "Муршидабад", "IN", "356", "28", "", "", "", "24.1839", "88.27171", "Asia/Kolkata"),
("1262419", "Murliganj", "", "IN", "356", "34", "", "", "", "25.8969", "86.99577", "Asia/Kolkata"),
("1262426", "Morinda", "Моринда", "IN", "356", "23", "", "", "", "30.78957", "76.49733", "Asia/Kolkata"),
("1262444", "Murbad", "", "IN", "356", "16", "", "", "", "19.25395", "73.38993", "Asia/Kolkata"),
("1262453", "Muradnagar", "", "IN", "356", "36", "", "", "", "28.7809", "77.49865", "Asia/Kolkata"),
("1262463", "Munnar", "Муннар", "IN", "356", "13", "", "", "", "10.08873", "77.06269", "Asia/Kolkata"),
("1262482", "Munger", "Мангер", "IN", "356", "34", "", "", "", "25.37556", "86.47352", "Asia/Kolkata"),
("1262484", "Mungeli", "", "IN", "356", "37", "", "", "", "22.06709", "81.68822", "Asia/Kolkata"),
("1262485", "Mungaoli", "", "IN", "356", "35", "", "", "", "24.4078", "78.09666", "Asia/Kolkata"),
("1262491", "Mundwa", "", "IN", "356", "24", "", "", "", "27.0631", "73.82304", "Asia/Kolkata"),
("1262497", "Mundra", "", "IN", "356", "09", "", "", "", "22.83918", "69.7219", "Asia/Kolkata"),
("1262510", "Mundgod", "", "IN", "356", "19", "", "", "", "14.97144", "75.03658", "Asia/Kolkata"),
("1262516", "Mundargi", "", "IN", "356", "19", "", "", "", "15.20677", "75.8839", "Asia/Kolkata"),
("1262534", "Multai", "", "IN", "356", "35", "", "", "", "21.77449", "78.25866", "Asia/Kolkata"),
("1262546", "Mulki", "", "IN", "356", "19", "", "", "", "13.09154", "74.78437", "Asia/Kolkata"),
("1262553", "Mulgund", "", "IN", "356", "19", "", "", "", "15.2807", "75.52132", "Asia/Kolkata"),
("1262562", "Mulbagal", "", "IN", "356", "19", "", "", "", "13.16372", "78.39207", "Asia/Kolkata"),
("1262566", "Mulappilangad", "", "IN", "356", "13", "", "", "", "11.8", "75.45", "Asia/Kolkata"),
("1262574", "Mul", "", "IN", "356", "16", "", "", "", "20.0684", "79.67812", "Asia/Kolkata"),
("1262578", "Muktsar", "", "IN", "356", "23", "", "", "", "30.47764", "74.51513", "Asia/Kolkata"),
("1262591", "Mukher", "", "IN", "356", "16", "", "", "", "18.70413", "77.36641", "Asia/Kolkata"),
("1262596", "Mukerian", "", "IN", "356", "23", "", "", "", "31.95097", "75.61488", "Asia/Kolkata"),
("1262624", "Muhammadabad", "", "IN", "356", "36", "", "", "", "27.30854", "79.43368", "Asia/Kolkata"),
("1262625", "Muhammadabad", "", "IN", "356", "36", "", "", "", "26.03404", "83.38114", "Asia/Kolkata"),
("1262626", "Muhammadabad", "", "IN", "356", "36", "", "", "", "25.61873", "83.75499", "Asia/Kolkata"),
("1262634", "Mughal Sarai", "", "IN", "356", "36", "", "", "", "25.28183", "83.12096", "Asia/Kolkata"),
("1262651", "Mudkhed", "", "IN", "356", "16", "", "", "", "19.15657", "77.50304", "Asia/Kolkata"),
("1262663", "Mudhol", "", "IN", "356", "19", "", "", "", "16.33354", "75.28305", "Asia/Kolkata"),
("1262664", "Mudgal", "", "IN", "356", "19", "", "", "", "16.01187", "76.44207", "Asia/Kolkata"),
("1262669", "Muddebihal", "", "IN", "356", "19", "", "", "", "16.33711", "76.13201", "Asia/Kolkata"),
("1262672", "Mudbidri", "", "IN", "356", "19", "", "", "", "13.06653", "74.99525", "Asia/Kolkata"),
("1262678", "Mubarakpur", "", "IN", "356", "36", "", "", "", "26.08866", "83.29088", "Asia/Kolkata"),
("1262710", "Motihari", "", "IN", "356", "34", "", "", "", "26.65738", "84.91922", "Asia/Kolkata"),
("1262734", "Morwa", "", "IN", "356", "09", "", "", "", "22.90469", "73.83912", "Asia/Kolkata"),
("1262740", "Morsi", "", "IN", "356", "16", "", "", "", "21.34071", "78.01332", "Asia/Kolkata"),
("1262771", "Morena", "Морена", "IN", "356", "35", "", "", "", "26.50286", "78.00163", "Asia/Kolkata"),
("1262775", "Morbi", "", "IN", "356", "09", "", "", "", "22.8173", "70.8377", "Asia/Kolkata"),
("1262783", "Morar", "", "IN", "356", "35", "", "", "", "26.2264", "78.22482", "Asia/Kolkata"),
("1262794", "Moram", "", "IN", "356", "16", "", "", "", "17.78744", "76.4706", "Asia/Kolkata"),
("1262801", "Moradabad", "Морадабад", "IN", "356", "36", "", "", "", "28.83893", "78.77684", "Asia/Kolkata"),
("1262824", "Mon", "", "IN", "356", "20", "", "", "", "26.73583", "95.05841", "Asia/Kolkata"),
("1262843", "Mokokchung", "", "IN", "356", "20", "", "", "", "26.3248", "94.51834", "Asia/Kolkata"),
("1262852", "Mokama", "", "IN", "356", "34", "", "", "", "25.39679", "85.91923", "Asia/Kolkata"),
("1262863", "Moirang", "", "IN", "356", "17", "", "", "", "24.4975", "93.77791", "Asia/Kolkata"),
("1262951", "Moga", "Могу", "IN", "356", "23", "", "", "", "30.81571", "75.17419", "Asia/Kolkata"),
("1262958", "Modasa", "", "IN", "356", "09", "", "", "", "23.46254", "73.29857", "Asia/Kolkata"),
("1262988", "Misrikh", "", "IN", "356", "36", "", "", "", "27.43201", "80.53135", "Asia/Kolkata"),
("1262995", "Mirzapur", "Мирзапур", "IN", "356", "36", "", "", "", "25.14582", "82.56975", "Asia/Kolkata"),
("1263012", "Mirialguda", "", "IN", "356", "02", "", "", "", "16.8722", "79.56247", "Asia/Kolkata"),
("1263015", "Mirganj", "", "IN", "356", "36", "", "", "", "28.54012", "79.20817", "Asia/Kolkata"),
("1263021", "Miranpur Katra", "", "IN", "356", "36", "", "", "", "28.02929", "79.66619", "Asia/Kolkata"),
("1263022", "Miranpur", "", "IN", "356", "36", "", "", "", "29.29047", "77.94789", "Asia/Kolkata"),
("1263034", "Minjur", "", "IN", "356", "25", "", "", "", "13.27918", "80.25899", "Asia/Kolkata"),
("1263051", "Milak", "Милак", "IN", "356", "36", "", "", "", "28.61031", "79.16997", "Asia/Kolkata"),
("1263057", "Mihona", "", "IN", "356", "35", "", "", "", "26.2838", "78.98016", "Asia/Kolkata"),
("1263083", "Mhasvad", "", "IN", "356", "16", "", "", "", "17.63359", "74.78773", "Asia/Kolkata"),
("1263101", "Mettur", "", "IN", "356", "25", "", "", "", "11.78796", "77.8008", "Asia/Kolkata"),
("1263103", "Mettupalayam", "", "IN", "356", "25", "1273866", "", "", "11.29971", "76.93485", "Asia/Kolkata"),
("1263120", "Merta", "", "IN", "356", "24", "", "", "", "26.64859", "74.03414", "Asia/Kolkata"),
("1263142", "Mendarda", "", "IN", "356", "09", "", "", "", "21.32112", "70.44078", "Asia/Kolkata"),
("1263148", "Memari", "", "IN", "356", "28", "", "", "", "23.17647", "88.09749", "Asia/Kolkata"),
("1263151", "Melur", "", "IN", "356", "25", "", "", "", "10.03241", "78.3393", "Asia/Kolkata"),
("1263185", "Mehndawal", "", "IN", "356", "36", "", "", "", "26.97684", "83.10973", "Asia/Kolkata"),
("1263195", "Mehekar", "", "IN", "356", "16", "", "", "", "20.1505", "76.56841", "Asia/Kolkata"),
("1263214", "Meerut", "Меерут", "IN", "356", "36", "", "", "", "28.97155", "77.71934", "Asia/Kolkata"),
("1263220", "Medinipur", "Миднапор", "IN", "356", "28", "", "", "", "22.42114", "87.32257", "Asia/Kolkata"),
("1263230", "Medak", "Медак", "IN", "356", "02", "", "", "", "18.04531", "78.26078", "Asia/Kolkata"),
("1263247", "Mayiladuthurai", "", "IN", "356", "25", "", "", "", "11.10354", "79.655", "Asia/Kolkata"),
("1263255", "Mayang Imphal", "", "IN", "356", "17", "", "", "", "24.60998", "93.88873", "Asia/Kolkata"),
("1263275", "Mawana", "", "IN", "356", "36", "", "", "", "29.10436", "77.92134", "Asia/Kolkata"),
("1263280", "Mavoor", "", "IN", "356", "13", "", "", "", "11.26667", "75.91667", "Asia/Kolkata"),
("1263285", "Mavelikara", "", "IN", "356", "13", "", "", "", "9.25929", "76.55642", "Asia/Kolkata"),
("1263293", "Maur", "", "IN", "356", "23", "", "", "", "30.08333", "75.25", "Asia/Kolkata"),
("1263300", "Mauganj", "", "IN", "356", "35", "", "", "", "24.66629", "81.8741", "Asia/Kolkata"),
("1263303", "Maudaha", "", "IN", "356", "36", "", "", "", "25.68355", "80.1137", "Asia/Kolkata"),
("1263306", "Mau Aimma", "", "IN", "356", "36", "", "", "", "25.69452", "81.92259", "Asia/Kolkata"),
("1263309", "Mau", "", "IN", "356", "35", "", "", "", "26.26584", "78.67108", "Asia/Kolkata"),
("1263311", "Mau", "", "IN", "356", "36", "", "", "", "25.94167", "83.56111", "Asia/Kolkata"),
("1263331", "Mattanur", "", "IN", "356", "13", "", "", "", "11.91667", "75.58333", "Asia/Kolkata"),
("1263364", "Mathura", "Матхура", "IN", "356", "36", "", "", "", "27.50199", "77.6833", "Asia/Kolkata"),
("1263395", "Matabhanga", "", "IN", "356", "28", "", "", "", "26.34197", "89.21555", "Asia/Kolkata"),
("1263427", "Masaurhi Buzurg", "", "IN", "356", "34", "", "", "", "25.35249", "85.03445", "Asia/Kolkata"),
("1263494", "Marmagao", "Мармагао", "IN", "356", "33", "", "", "", "15.40927", "73.78868", "Asia/Kolkata"),
("1263504", "Markapur", "", "IN", "356", "02", "", "", "", "15.74041", "79.27056", "Asia/Kolkata"),
("1263522", "Mariani", "Мариани", "IN", "356", "03", "", "", "", "26.65725", "94.31529", "Asia/Kolkata"),
("1263523", "Mariahu", "", "IN", "356", "36", "", "", "", "25.60003", "82.60187", "Asia/Kolkata"),
("1263528", "Marhaura", "", "IN", "356", "34", "", "", "", "25.96927", "84.86221", "Asia/Kolkata"),
("1263532", "Margherita", "", "IN", "356", "30", "", "", "", "27.28482", "95.66796", "Asia/Kolkata"),
("1263564", "Marakkanam", "", "IN", "356", "25", "", "", "", "12.19214", "79.94193", "Asia/Kolkata"),
("1263567", "Marahra", "", "IN", "356", "36", "", "", "", "27.73645", "78.56923", "Asia/Kolkata"),
("1263580", "Mapuca", "Мапуса", "IN", "356", "33", "", "", "", "15.59154", "73.80898", "Asia/Kolkata"),
("1263591", "Manwat", "", "IN", "356", "16", "", "", "", "19.30133", "76.49735", "Asia/Kolkata"),
("1263594", "Manvi", "", "IN", "356", "19", "", "", "", "15.98949", "77.05046", "Asia/Kolkata"),
("1263610", "Manthani", "", "IN", "356", "02", "", "", "", "18.65087", "79.66501", "Asia/Kolkata"),
("1263622", "Mansa", "", "IN", "356", "23", "", "", "", "29.99092", "75.4012", "Asia/Kolkata"),
("1263623", "Mansa", "", "IN", "356", "09", "", "", "", "23.42564", "72.65739", "Asia/Kolkata"),
("1263649", "Manoharpur", "", "IN", "356", "24", "", "", "", "27.29769", "75.9495", "Asia/Kolkata"),
("1263659", "Mannargudi", "", "IN", "356", "25", "", "", "", "10.66626", "79.45064", "Asia/Kolkata"),
("1263661", "Mannarakkat", "", "IN", "356", "13", "", "", "", "10.9914", "76.4596", "Asia/Kolkata"),
("1263664", "Manmad", "", "IN", "356", "16", "", "", "", "20.25247", "74.44115", "Asia/Kolkata"),
("1263678", "Mankachar", "", "IN", "356", "18", "", "", "", "25.53347", "89.86373", "Asia/Kolkata"),
("1263684", "Manjlegaon", "", "IN", "356", "16", "", "", "", "19.15599", "76.21152", "Asia/Kolkata"),
("1263691", "Manjhanpur", "", "IN", "356", "36", "", "", "", "25.53057", "81.37371", "Asia/Kolkata"),
("1263694", "Manjeri", "", "IN", "356", "13", "", "", "", "11.1172", "76.11987", "Asia/Kolkata"),
("1263723", "Manihari", "", "IN", "356", "34", "", "", "", "25.33891", "87.61998", "Asia/Kolkata"),
("1263730", "Maniar", "", "IN", "356", "36", "", "", "", "25.98539", "84.17251", "Asia/Kolkata"),
("1263744", "Mangrul Pir", "", "IN", "356", "16", "", "", "", "20.31186", "77.34484", "Asia/Kolkata"),
("1263751", "Mangrol", "", "IN", "356", "24", "", "", "", "25.33061", "76.50973", "Asia/Kolkata"),
("1263752", "Mangrol", "", "IN", "356", "09", "", "", "", "21.12268", "70.11484", "Asia/Kolkata"),
("1263761", "Manglaur", "", "IN", "356", "36", "", "", "", "29.79163", "77.8793", "Asia/Kolkata"),
("1263780", "Mangalore", "Мангалуру", "IN", "356", "19", "", "", "", "12.91723", "74.85603", "Asia/Kolkata"),
("1263787", "Mangaldai", "", "IN", "356", "03", "", "", "", "26.44212", "92.03047", "Asia/Kolkata"),
("1263797", "Mangalagiri", "", "IN", "356", "02", "", "", "", "16.40348", "80.55846", "Asia/Kolkata"),
("1263807", "Maner", "Манера", "IN", "356", "34", "", "", "", "25.64728", "84.87418", "Asia/Kolkata"),
("1263814", "Mandya", "Мандья", "IN", "356", "19", "", "", "", "12.52145", "76.89527", "Asia/Kolkata"),
("1263824", "Mandvi", "Мандви", "IN", "356", "09", "", "", "", "22.83282", "69.35238", "Asia/Kolkata"),
("1263826", "Mandvi", "", "IN", "356", "09", "", "", "", "21.25526", "73.30412", "Asia/Kolkata"),
("1263833", "Mandu", "", "IN", "356", "35", "", "", "", "22.36667", "75.38333", "Asia/Kolkata"),
("1263834", "Mandsaur", "", "IN", "356", "35", "", "", "", "24.07184", "75.06986", "Asia/Kolkata"),
("1263852", "Mandla", "Мандла", "IN", "356", "35", "", "", "", "22.59974", "80.37108", "Asia/Kolkata"),
("1263862", "Mandi", "Манди", "IN", "356", "11", "", "", "", "31.71079", "76.93152", "Asia/Kolkata"),
("1263879", "Mandawar", "", "IN", "356", "36", "", "", "", "29.48584", "78.1259", "Asia/Kolkata"),
("1263898", "Mandapeta", "", "IN", "356", "02", "", "", "", "16.86254", "81.92921", "Asia/Kolkata"),
("1263900", "Mandapam", "", "IN", "356", "25", "", "", "", "9.27571", "79.12362", "Asia/Kolkata"),
("1263911", "Mandalgarh", "", "IN", "356", "24", "", "", "", "25.19407", "75.07215", "Asia/Kolkata"),
("1263917", "Mandal", "", "IN", "356", "24", "", "", "", "25.44126", "74.56979", "Asia/Kolkata"),
("1263936", "Mancheral", "", "IN", "356", "02", "", "", "", "18.87074", "79.42863", "Asia/Kolkata"),
("1263940", "Manawar", "", "IN", "356", "35", "", "", "", "22.23566", "75.08917", "Asia/Kolkata"),
("1263943", "Manavadar", "", "IN", "356", "09", "", "", "", "21.49813", "70.13775", "Asia/Kolkata"),
("1263949", "Manasa", "", "IN", "356", "35", "", "", "", "24.48371", "75.26871", "Asia/Kolkata"),
("1263952", "Manapparai", "", "IN", "356", "25", "", "", "", "10.60772", "78.42582", "Asia/Kolkata"),
("1263965", "Manamadurai", "", "IN", "356", "25", "", "", "", "9.67318", "78.47096", "Asia/Kolkata"),
("1263968", "Manali", "", "IN", "356", "25", "", "", "", "13.16667", "80.26667", "Asia/Kolkata"),
("1264007", "Malvan", "", "IN", "356", "16", "", "", "", "16.05981", "73.4629", "Asia/Kolkata"),
("1264010", "Malur", "", "IN", "356", "19", "", "", "", "13.00273", "77.93796", "Asia/Kolkata"),
("1264032", "Malpura", "", "IN", "356", "24", "", "", "", "26.2838", "75.36458", "Asia/Kolkata"),
("1264037", "Malpe", "", "IN", "356", "19", "", "", "", "13.35284", "74.70833", "Asia/Kolkata"),
("1264047", "Mallasamudram", "", "IN", "356", "25", "", "", "", "11.4892", "78.03277", "Asia/Kolkata"),
("1264071", "Malkapur", "", "IN", "356", "16", "", "", "", "20.8856", "76.20371", "Asia/Kolkata"),
("1264075", "Malkangiri", "", "IN", "356", "37", "", "", "", "18.36423", "81.88728", "Asia/Kolkata"),
("1264085", "Malihabad", "", "IN", "356", "36", "", "", "", "26.92223", "80.71078", "Asia/Kolkata"),
("1264111", "Maler Kotla", "", "IN", "356", "23", "", "", "", "30.5309", "75.87949", "Asia/Kolkata"),
("1264115", "Malegaon", "Малегаон", "IN", "356", "16", "", "", "", "20.5537", "74.52881", "Asia/Kolkata"),
("1264136", "Malavalli", "", "IN", "356", "19", "", "", "", "12.38613", "77.05954", "Asia/Kolkata"),
("1264138", "Malaut", "", "IN", "356", "23", "", "", "", "30.21108", "74.48223", "Asia/Kolkata"),
("1264154", "Malappuram", "Малаппурам", "IN", "356", "13", "", "", "", "11.04019", "76.08237", "Asia/Kolkata"),
("1264196", "Makum", "", "IN", "356", "03", "", "", "", "27.48652", "95.43646", "Asia/Kolkata"),
("1264198", "Maksi", "Макси", "IN", "356", "35", "", "", "", "23.26008", "76.1455", "Asia/Kolkata"),
("1264206", "Makrana", "", "IN", "356", "24", "", "", "", "27.04361", "74.72445", "Asia/Kolkata"),
("1264282", "Mairwa", "", "IN", "356", "34", "", "", "", "26.235", "84.14934", "Asia/Kolkata"),
("1264292", "Mainpuri", "", "IN", "356", "36", "", "", "", "27.23", "79.02882", "Asia/Kolkata"),
("1264301", "Mainaguri", "", "IN", "356", "28", "", "", "", "26.56263", "88.8204", "Asia/Kolkata"),
("1264317", "Maihar", "", "IN", "356", "35", "", "", "", "24.26447", "80.75941", "Asia/Kolkata"),
("1264323", "Mahwah", "", "IN", "356", "24", "", "", "", "27.04594", "76.93152", "Asia/Kolkata"),
("1264344", "Mahudha", "", "IN", "356", "09", "", "", "", "22.82082", "72.94032", "Asia/Kolkata"),
("1264356", "Maholi", "", "IN", "356", "36", "", "", "", "27.66368", "80.47371", "Asia/Kolkata"),
("1264359", "Mahoba", "", "IN", "356", "36", "", "", "", "25.29222", "79.87231", "Asia/Kolkata"),
("1264363", "Mahmudabad", "", "IN", "356", "36", "", "", "", "27.2976", "81.12399", "Asia/Kolkata"),
("1264368", "Mahishadal", "", "IN", "356", "28", "", "", "", "22.18616", "87.98072", "Asia/Kolkata"),
("1264383", "Mahgawan", "", "IN", "356", "35", "", "", "", "26.49471", "78.61593", "Asia/Kolkata"),
("1264385", "Maheshwar", "Махешвар", "IN", "356", "35", "", "", "", "22.17592", "75.58715", "Asia/Kolkata"),
("1264395", "Mahendragarh", "", "IN", "356", "10", "", "", "", "28.26935", "76.15253", "Asia/Kolkata"),
("1264398", "Mahemdavad", "", "IN", "356", "09", "", "", "", "22.82359", "72.75551", "Asia/Kolkata"),
("1264403", "Mahe", "Мах", "IN", "356", "13", "", "", "", "11.70044", "75.53409", "Asia/Kolkata"),
("1264407", "Mahbubnagar", "", "IN", "356", "02", "", "", "", "16.74385", "77.98597", "Asia/Kolkata"),
("1264409", "Mahbubabad", "", "IN", "356", "02", "", "", "", "17.59728", "80.00206", "Asia/Kolkata"),
("1264414", "Mahasamund", "", "IN", "356", "37", "", "", "", "21.1104", "82.09796", "Asia/Kolkata"),
("1264433", "Maharajganj", "", "IN", "356", "36", "", "", "", "27.14136", "83.56524", "Asia/Kolkata"),
("1264436", "Maharajganj", "", "IN", "356", "34", "", "", "", "26.11066", "84.50382", "Asia/Kolkata"),
("1264455", "Maham", "", "IN", "356", "10", "", "", "", "28.96797", "76.29538", "Asia/Kolkata"),
("1264457", "Mahalingpur", "", "IN", "356", "19", "", "", "", "16.3888", "75.10873", "Asia/Kolkata"),
("1264489", "Mahad", "Махад", "IN", "356", "16", "", "", "", "18.08333", "73.41667", "Asia/Kolkata"),
("1264504", "Maghar", "", "IN", "356", "36", "", "", "", "26.75599", "83.12765", "Asia/Kolkata"),
("1264514", "Magadi", "Магади", "IN", "356", "19", "", "", "", "12.957", "77.2231", "Asia/Kolkata"),
("1264520", "Madurantakam", "", "IN", "356", "25", "", "", "", "12.51167", "79.88485", "Asia/Kolkata"),
("1264521", "Madurai", "Мадурай", "IN", "356", "25", "", "", "", "9.91735", "78.11962", "Asia/Kolkata"),
("1264523", "Madukkur", "", "IN", "356", "25", "", "", "", "10.48134", "79.39681", "Asia/Kolkata"),
("1264524", "Madukkarai", "", "IN", "356", "25", "", "", "", "10.90481", "76.96461", "Asia/Kolkata"),
("1264527", "Chennai", "Ченнаи", "IN", "356", "25", "", "", "", "13.08784", "80.27847", "Asia/Kolkata"),
("1264540", "Madikeri", "", "IN", "356", "19", "", "", "", "12.42602", "75.7382", "Asia/Kolkata"),
("1264543", "Madhyamgram", "", "IN", "356", "28", "", "", "", "22.68944", "88.44594", "Asia/Kolkata"),
("1264551", "Madhupur", "", "IN", "356", "38", "", "", "", "24.27419", "86.63929", "Asia/Kolkata"),
("1264553", "Madhugiri", "", "IN", "356", "19", "", "", "", "13.66013", "77.21232", "Asia/Kolkata"),
("1264555", "Madhubani", "Мадхубани", "IN", "356", "34", "", "", "", "26.35367", "86.07169", "Asia/Kolkata"),
("1264570", "Madhipura", "", "IN", "356", "34", "", "", "", "25.92127", "86.79271", "Asia/Kolkata"),
("1264588", "Madgaon", "Маргао", "IN", "356", "33", "", "", "", "15.27501", "73.95786", "Asia/Kolkata"),
("1264592", "Maddur", "", "IN", "356", "19", "", "", "", "12.5839", "77.04344", "Asia/Kolkata"),
("1264621", "Madanapalle", "", "IN", "356", "02", "", "", "", "13.5503", "78.50288", "Asia/Kolkata"),
("1264637", "Machilipatnam", "", "IN", "356", "02", "", "", "", "16.18747", "81.13888", "Asia/Kolkata"),
("1264643", "Machhlishahr", "", "IN", "356", "36", "", "", "", "25.68692", "82.41206", "Asia/Kolkata"),
("1264644", "Machhiwara", "", "IN", "356", "23", "", "", "", "30.91547", "76.20134", "Asia/Kolkata"),
("1264647", "Macherla", "", "IN", "356", "02", "", "", "", "16.48333", "79.43333", "Asia/Kolkata"),
("1264688", "Lunglei", "Лунглеи", "IN", "356", "31", "", "", "", "22.89247", "92.74218", "Asia/Kolkata"),
("1264700", "Lunavada", "", "IN", "356", "09", "", "", "", "23.12854", "73.61065", "Asia/Kolkata"),
("1264728", "Ludhiana", "Лудхияна", "IN", "356", "23", "", "", "", "30.90015", "75.85229", "Asia/Kolkata"),
("1264733", "Lucknow", "Лакхнау", "IN", "356", "36", "", "", "", "26.83928", "80.92313", "Asia/Kolkata"),
("1264735", "Luckeesarai", "", "IN", "356", "34", "", "", "", "25.1765", "86.0947", "Asia/Kolkata"),
("1264756", "Losal", "", "IN", "356", "24", "", "", "", "27.4", "74.91667", "Asia/Kolkata"),
("1264773", "Loni", "Лоне", "IN", "356", "36", "", "", "", "28.75153", "77.288", "Asia/Kolkata"),
("1264793", "Lonavla", "", "IN", "356", "16", "", "", "", "18.75275", "73.40575", "Asia/Kolkata"),
("1264794", "Lonar", "", "IN", "356", "16", "", "", "", "19.98497", "76.5214", "Asia/Kolkata"),
("1264839", "Lohardaga", "", "IN", "356", "38", "", "", "", "23.43313", "84.67982", "Asia/Kolkata"),
("1264890", "Lingsugur", "", "IN", "356", "19", "", "", "", "16.15795", "76.52238", "Asia/Kolkata"),
("1264912", "Limbdi", "", "IN", "356", "09", "", "", "", "22.56507", "71.81076", "Asia/Kolkata"),
("1264949", "Leteri", "", "IN", "356", "35", "", "", "", "24.06067", "77.40667", "Asia/Kolkata"),
("1264976", "Leh", "Лех", "IN", "356", "12", "", "", "", "34.16504", "77.58402", "Asia/Kolkata"),
("1264989", "Lawar Khas", "", "IN", "356", "36", "", "", "", "29.11091", "77.77767", "Asia/Kolkata"),
("1265007", "Laungowal", "", "IN", "356", "23", "", "", "", "30.19406", "75.67963", "Asia/Kolkata"),
("1265014", "Latur", "Латур", "IN", "356", "16", "", "", "", "18.39721", "76.56784", "Asia/Kolkata"),
("1265022", "Lathi", "", "IN", "356", "09", "", "", "", "21.7231", "71.38843", "Asia/Kolkata"),
("1265025", "Latehar", "", "IN", "356", "38", "", "", "", "23.74395", "84.499", "Asia/Kolkata"),
("1265053", "Lar", "", "IN", "356", "36", "", "", "", "26.20258", "83.96792", "Asia/Kolkata"),
("1265143", "Lalsot", "", "IN", "356", "24", "", "", "", "26.55951", "76.32915", "Asia/Kolkata"),
("1265150", "Lalpur", "", "IN", "356", "09", "", "", "", "22.19072", "69.96351", "Asia/Kolkata"),
("1265157", "Lalitpur", "Лалитпур", "IN", "356", "36", "", "", "", "24.69054", "78.41888", "Asia/Kolkata"),
("1265163", "Lalgudi", "", "IN", "356", "25", "", "", "", "10.87419", "78.81935", "Asia/Kolkata"),
("1265166", "Lalgola", "", "IN", "356", "28", "", "", "", "24.42244", "88.25238", "Asia/Kolkata"),
("1265169", "Lalganj", "", "IN", "356", "36", "", "", "", "25.93182", "81.70478", "Asia/Kolkata"),
("1265170", "Lalganj", "", "IN", "356", "34", "", "", "", "25.8673", "85.17304", "Asia/Kolkata"),
("1265201", "Lakshmeshwar", "", "IN", "356", "19", "", "", "", "15.12689", "75.46935", "Asia/Kolkata"),
("1265208", "Laksar", "", "IN", "356", "39", "", "", "", "29.75876", "78.04086", "Asia/Kolkata"),
("1265220", "Lakhyabad", "", "IN", "356", "28", "", "", "", "23.66667", "86.66667", "Asia/Kolkata"),
("1265233", "Lakhnadon", "", "IN", "356", "35", "", "", "", "22.60058", "79.60135", "Asia/Kolkata"),
("1265242", "Lakhimpur", "", "IN", "356", "36", "", "", "", "27.952", "80.78257", "Asia/Kolkata"),
("1265246", "Lakheri", "", "IN", "356", "24", "", "", "", "25.67237", "76.17692", "Asia/Kolkata"),
("1265310", "Laharpur", "", "IN", "356", "36", "", "", "", "27.71008", "80.90069", "Asia/Kolkata"),
("1265311", "Lahar", "", "IN", "356", "35", "", "", "", "26.19401", "78.94137", "Asia/Kolkata"),
("1265323", "Ladwa", "", "IN", "356", "10", "", "", "", "29.99382", "77.04439", "Asia/Kolkata"),
("1265331", "Ladnun", "", "IN", "356", "24", "", "", "", "27.65312", "74.39993", "Asia/Kolkata"),
("1265354", "Lachhmangarh Sikar", "", "IN", "356", "24", "", "", "", "27.82294", "75.02754", "Asia/Kolkata"),
("1265387", "Kuzhithurai", "", "IN", "356", "25", "", "", "", "8.31792", "77.19192", "Asia/Kolkata"),
("1265400", "Koothanallur", "", "IN", "356", "25", "", "", "", "10.7199", "79.5157", "Asia/Kolkata"),
("1265401", "Kuttampuzha", "", "IN", "356", "13", "", "", "", "10.15", "76.73333", "Asia/Kolkata"),
("1265415", "Kutiyana", "", "IN", "356", "09", "", "", "", "21.6241", "69.98494", "Asia/Kolkata"),
("1265418", "Kutiatodu", "", "IN", "356", "13", "", "", "", "9.8", "76.33333", "Asia/Kolkata"),
("1265446", "Kushtagi", "", "IN", "356", "19", "", "", "", "15.75623", "76.19112", "Asia/Kolkata"),
("1265504", "Kurinjippadi", "", "IN", "356", "25", "", "", "", "11.55028", "79.59066", "Asia/Kolkata"),
("1265521", "Kurduvadi", "", "IN", "356", "16", "", "", "", "18.09339", "75.41568", "Asia/Kolkata"),
("1265539", "Kurandvad", "", "IN", "356", "16", "", "", "", "16.68317", "74.58892", "Asia/Kolkata"),
("1265555", "Kuppam", "", "IN", "356", "02", "", "", "", "12.74768", "78.34235", "Asia/Kolkata"),
("1265579", "Kunnamkulam", "", "IN", "356", "13", "", "", "", "10.6484", "76.07063", "Asia/Kolkata"),
("1265580", "Kunnamangalam", "", "IN", "356", "13", "1265874", "", "", "11.30459", "75.87772", "Asia/Kolkata"),
("1265591", "Kunigal", "", "IN", "356", "19", "", "", "", "13.02319", "77.02518", "Asia/Kolkata"),
("1265605", "Kundla", "", "IN", "356", "09", "", "", "", "21.34222", "71.30633", "Asia/Kolkata"),
("1265607", "Kundgol", "", "IN", "356", "19", "", "", "", "15.25612", "75.24735", "Asia/Kolkata"),
("1265613", "Kundarkhi", "", "IN", "356", "36", "", "", "", "28.68362", "78.78555", "Asia/Kolkata"),
("1265632", "Kunda", "", "IN", "356", "36", "", "", "", "25.71935", "81.51268", "Asia/Kolkata"),
("1265645", "Kumta", "", "IN", "356", "19", "", "", "", "14.42853", "74.4189", "Asia/Kolkata"),
("1265655", "Kumher", "", "IN", "356", "24", "", "", "", "27.31657", "77.37079", "Asia/Kolkata"),
("1265660", "Kumhari", "", "IN", "356", "37", "", "", "", "21.26667", "81.51667", "Asia/Kolkata"),
("1265670", "Kumbhraj", "", "IN", "356", "35", "", "", "", "24.37256", "77.04922", "Asia/Kolkata"),
("1265683", "Kumbakonam", "Кумбаконам", "IN", "356", "25", "", "", "", "10.96209", "79.39124", "Asia/Kolkata"),
("1265709", "Kulu", "", "IN", "356", "11", "", "", "", "31.95635", "77.11036", "Asia/Kolkata"),
("1265711", "Kulti", "Култи", "IN", "356", "28", "", "", "", "23.73166", "86.84372", "Asia/Kolkata"),
("1265716", "Kulpahar", "", "IN", "356", "36", "", "", "", "25.3202", "79.63987", "Asia/Kolkata"),
("1265723", "Kulittalai", "", "IN", "356", "25", "", "", "", "10.93487", "78.41251", "Asia/Kolkata"),
("1265734", "Kulgam", "", "IN", "356", "12", "", "", "", "33.64462", "75.0187", "Asia/Kolkata"),
("1265752", "Kukshi", "", "IN", "356", "35", "", "", "", "22.20801", "74.75814", "Asia/Kolkata"),
("1265767", "Kukatpalli", "", "IN", "356", "02", "", "", "", "17.48486", "78.41376", "Asia/Kolkata"),
("1265773", "Kuju", "", "IN", "356", "38", "", "", "", "23.72757", "85.50616", "Asia/Kolkata"),
("1265795", "Kudligi", "", "IN", "356", "19", "", "", "", "14.90467", "76.38441", "Asia/Kolkata"),
("1265811", "Kudachi", "", "IN", "356", "19", "", "", "", "16.62784", "74.85408", "Asia/Kolkata"),
("1265821", "Kuchera", "Кучер", "IN", "356", "24", "", "", "", "26.98747", "73.97108", "Asia/Kolkata"),
("1265828", "Kuchaman", "", "IN", "356", "24", "", "", "", "27.14745", "74.85655", "Asia/Kolkata"),
("1265830", "Kuchaiburi", "", "IN", "356", "21", "", "", "", "22.26675", "86.17385", "Asia/Kolkata"),
("1265852", "Krishnarajpet", "", "IN", "356", "19", "", "", "", "12.66628", "76.48812", "Asia/Kolkata"),
("1265859", "Krishnanagar", "Кришнанагар", "IN", "356", "28", "", "", "", "23.40576", "88.49073", "Asia/Kolkata"),
("1265863", "Krishnagiri", "Кришнагири", "IN", "356", "25", "", "", "", "12.51921", "78.21382", "Asia/Kolkata"),
("1265873", "Kozhikode", "Калькутта", "IN", "356", "13", "1265874", "", "", "11.24802", "75.7804", "Asia/Kolkata"),
("1265881", "Koynanagar", "", "IN", "356", "16", "", "", "", "17.4", "73.76667", "Asia/Kolkata"),
("1265886", "Kovvur", "", "IN", "356", "02", "1252873", "", "", "17.0162", "81.72934", "Asia/Kolkata"),
("1265888", "Kovur", "", "IN", "356", "02", "1261530", "", "", "14.50011", "79.98595", "Asia/Kolkata"),
("1265891", "Kovilpatti", "", "IN", "356", "25", "", "", "", "9.17167", "77.86989", "Asia/Kolkata"),
("1265905", "Kotturu", "", "IN", "356", "19", "", "", "", "14.82442", "76.22005", "Asia/Kolkata"),
("1265911", "Kottayam", "Коттаям", "IN", "356", "13", "", "", "", "9.58692", "76.52132", "Asia/Kolkata"),
("1265938", "Kottagudem", "", "IN", "356", "02", "", "", "", "17.55106", "80.61779", "Asia/Kolkata"),
("1265961", "Kotputli", "", "IN", "356", "24", "", "", "", "27.70207", "76.19911", "Asia/Kolkata"),
("1265964", "Kotma", "", "IN", "356", "35", "", "", "", "23.20383", "81.97904", "Asia/Kolkata"),
("1266014", "Kotdwara", "", "IN", "356", "39", "", "", "", "29.74336", "78.51945", "Asia/Kolkata"),
("1266029", "Kotaparh", "", "IN", "356", "37", "", "", "", "19.14256", "82.32536", "Asia/Kolkata"),
("1266031", "Kotamangalam", "", "IN", "356", "13", "", "", "", "10.06178", "76.62681", "Asia/Kolkata"),
("1266038", "Kotagiri", "", "IN", "356", "25", "", "", "", "11.42072", "76.86035", "Asia/Kolkata"),
("1266049", "Kota", "Кота", "IN", "356", "24", "", "", "", "25.18254", "75.83906", "Asia/Kolkata"),
("1266051", "Kota", "", "IN", "356", "37", "", "", "", "22.29344", "82.02353", "Asia/Kolkata"),
("1266070", "Kosigi", "", "IN", "356", "02", "", "", "", "15.85572", "77.24476", "Asia/Kolkata"),
("1266073", "Kosi", "", "IN", "356", "36", "", "", "", "27.794", "77.4383", "Asia/Kolkata"),
("1266087", "Kosamba", "", "IN", "356", "09", "", "", "", "21.46202", "72.95842", "Asia/Kolkata"),
("1266092", "Korwai", "", "IN", "356", "35", "", "", "", "24.11774", "78.04007", "Asia/Kolkata"),
("1266116", "Koregaon", "", "IN", "356", "16", "", "", "", "18.64573", "74.05909", "Asia/Kolkata"),
("1266122", "Korba", "Корба", "IN", "356", "37", "", "", "", "22.3458", "82.69633", "Asia/Kolkata"),
("1266124", "Koratla", "", "IN", "356", "02", "", "", "", "18.82154", "78.71186", "Asia/Kolkata"),
("1266128", "Koraput", "Корапут", "IN", "356", "21", "", "", "", "18.812", "82.71048", "Asia/Kolkata"),
("1266154", "Koppal", "Коппал", "IN", "356", "19", "", "", "", "15.34522", "76.15478", "Asia/Kolkata"),
("1266162", "Kopargaon", "", "IN", "356", "16", "", "", "", "19.88239", "74.47605", "Asia/Kolkata"),
("1266164", "Kopaganj", "", "IN", "356", "36", "", "", "", "26.02029", "83.56593", "Asia/Kolkata"),
("1266178", "Konnur", "", "IN", "356", "19", "", "", "", "16.20138", "74.74886", "Asia/Kolkata"),
("1266179", "Konnagar", "", "IN", "356", "28", "", "", "", "22.70508", "88.34446", "Asia/Kolkata"),
("1266209", "Kondapalle", "", "IN", "356", "02", "", "", "", "16.61667", "80.53333", "Asia/Kolkata"),
("1266216", "Kondagaon", "", "IN", "356", "37", "", "", "", "19.59083", "81.664", "Asia/Kolkata"),
("1266217", "Konch", "", "IN", "356", "36", "", "", "", "25.99451", "79.15127", "Asia/Kolkata"),
("1266220", "Konarka", "", "IN", "356", "21", "", "", "", "19.89758", "86.11413", "Asia/Kolkata"),
("1266258", "Kolasib", "", "IN", "356", "31", "", "", "", "24.22388", "92.67869", "Asia/Kolkata"),
("1266267", "Kollegal", "", "IN", "356", "19", "", "", "", "12.1569", "77.10694", "Asia/Kolkata"),
("1266285", "Kolhapur", "", "IN", "356", "16", "", "", "", "16.69563", "74.23167", "Asia/Kolkata"),
("1266302", "Kolaras", "", "IN", "356", "35", "", "", "", "25.21942", "77.61179", "Asia/Kolkata"),
("1266305", "Kolar", "Колар", "IN", "356", "19", "", "", "", "13.13671", "78.12917", "Asia/Kolkata"),
("1266322", "Colachel", "", "IN", "356", "25", "", "", "", "8.17938", "77.25818", "Asia/Kolkata"),
("1266330", "Kokrajhar", "Кокраджар", "IN", "356", "03", "", "", "", "26.40107", "90.27286", "Asia/Kolkata"),
("1266366", "Kohima", "Кохима", "IN", "356", "20", "", "", "", "25.67467", "94.11099", "Asia/Kolkata"),
("1266372", "Koelwar", "", "IN", "356", "34", "", "", "", "25.5811", "84.79632", "Asia/Kolkata"),
("1266385", "Kodungallur", "", "IN", "356", "13", "", "", "", "10.22222", "76.19917", "Asia/Kolkata"),
("1266390", "Kodoli", "", "IN", "356", "16", "", "", "", "16.8764", "74.1909", "Asia/Kolkata"),
("1266397", "Kodinar", "", "IN", "356", "09", "", "", "", "20.79393", "70.70216", "Asia/Kolkata"),
("1266414", "Kodarma", "", "IN", "356", "38", "", "", "", "24.46802", "85.59343", "Asia/Kolkata"),
("1266416", "Kodar", "", "IN", "356", "02", "", "", "", "16.9985", "79.9656", "Asia/Kolkata"),
("1266425", "Kodaikanal", "Кодайканал", "IN", "356", "25", "", "", "", "10.23925", "77.48932", "Asia/Kolkata"),
("1266436", "Koch Bihar", "", "IN", "356", "28", "", "", "", "26.32539", "89.44508", "Asia/Kolkata"),
("1266448", "Koath", "", "IN", "356", "34", "1258074", "", "", "25.32593", "84.25976", "Asia/Kolkata"),
("1266452", "Kizhake Chalakudi", "", "IN", "356", "13", "", "", "", "10.30067", "76.33763", "Asia/Kolkata"),
("1266461", "Kithor", "", "IN", "356", "36", "", "", "", "28.86663", "77.93822", "Asia/Kolkata"),
("1266475", "Kishtwar", "Киштваре", "IN", "356", "12", "", "", "", "33.31346", "75.76726", "Asia/Kolkata"),
("1266486", "Kishangarh", "Кишангарх", "IN", "356", "24", "", "", "", "26.5741", "74.86685", "Asia/Kolkata"),
("1266489", "Kishanganj", "", "IN", "356", "28", "", "", "", "26.10282", "87.95205", "Asia/Kolkata"),
("1266509", "Kiratpur", "", "IN", "356", "36", "", "", "", "29.50512", "78.2033", "Asia/Kolkata"),
("1266510", "Kiraoli", "", "IN", "356", "36", "", "", "", "27.13754", "77.78644", "Asia/Kolkata"),
("1266518", "Kinwat", "", "IN", "356", "16", "", "", "", "19.62368", "78.2", "Asia/Kolkata"),
("1266575", "Kichha", "", "IN", "356", "39", "", "", "", "28.91173", "79.51535", "Asia/Kolkata"),
("1266596", "Khutar", "", "IN", "356", "36", "", "", "", "28.20307", "80.27046", "Asia/Kolkata"),
("1266607", "Khurja", "", "IN", "356", "36", "", "", "", "28.25436", "77.85436", "Asia/Kolkata"),
("1266616", "Khurda", "", "IN", "356", "21", "", "", "", "20.18268", "85.61629", "Asia/Kolkata"),
("1266620", "Khurai", "", "IN", "356", "35", "", "", "", "24.04344", "78.33041", "Asia/Kolkata"),
("1266622", "Khunti", "", "IN", "356", "38", "", "", "", "23.07533", "85.27903", "Asia/Kolkata"),
("1266649", "Khowai", "", "IN", "356", "26", "", "", "", "24.07964", "91.59972", "Asia/Kolkata"),
("1266666", "Khopoli", "", "IN", "356", "16", "", "", "", "18.78562", "73.34589", "Asia/Kolkata"),
("1266710", "Khirkian", "", "IN", "356", "35", "", "", "", "22.16749", "76.8601", "Asia/Kolkata"),
("1266731", "Khilchipur", "", "IN", "356", "35", "", "", "", "24.03943", "76.578", "Asia/Kolkata"),
("1266744", "Khetri", "", "IN", "356", "24", "", "", "", "28.00069", "75.78644", "Asia/Kolkata"),
("1266746", "Khetia", "", "IN", "356", "16", "", "", "", "21.67124", "74.58535", "Asia/Kolkata"),
("1266762", "Kheri", "", "IN", "356", "36", "", "", "", "27.90308", "80.79752", "Asia/Kolkata"),
("1266774", "Kheralu", "", "IN", "356", "09", "", "", "", "23.88534", "72.61869", "Asia/Kolkata"),
("1266794", "Khekra", "", "IN", "356", "36", "", "", "", "28.86667", "77.28333", "Asia/Kolkata"),
("1266806", "Khed Brahma", "", "IN", "356", "09", "", "", "", "24.03165", "73.04697", "Asia/Kolkata"),
("1266809", "Kheda", "Хеда", "IN", "356", "09", "", "", "", "22.75218", "72.68533", "Asia/Kolkata"),
("1266838", "Khatra", "", "IN", "356", "28", "", "", "", "22.97617", "86.85462", "Asia/Kolkata"),
("1266843", "Khatima", "", "IN", "356", "39", "", "", "", "28.92221", "79.97015", "Asia/Kolkata"),
("1266847", "Khategaon", "", "IN", "356", "35", "", "", "", "22.5957", "76.91363", "Asia/Kolkata"),
("1266849", "Khatauli", "", "IN", "356", "36", "1262333", "", "", "29.2788", "77.73196", "Asia/Kolkata"),
("1266862", "Kharupatia", "", "IN", "356", "03", "", "", "", "26.51839", "92.14722", "Asia/Kolkata"),
("1266872", "Kharsia", "", "IN", "356", "37", "", "", "", "21.98637", "83.10613", "Asia/Kolkata"),
("1266891", "Kharkhauda", "", "IN", "356", "10", "", "", "", "28.87754", "76.90836", "Asia/Kolkata"),
("1266928", "Khargon", "", "IN", "356", "35", "", "", "", "21.82526", "75.6107", "Asia/Kolkata"),
("1266945", "Khardah", "", "IN", "356", "28", "", "", "", "22.71861", "88.37806", "Asia/Kolkata"),
("1266960", "Kharar", "", "IN", "356", "23", "", "", "", "30.74572", "76.64702", "Asia/Kolkata"),
("1266966", "Kharakvasla", "", "IN", "356", "16", "", "", "", "18.43997", "73.77546", "Asia/Kolkata"),
("1266975", "Kharagpur", "Харагпур", "IN", "356", "34", "", "", "", "25.12446", "86.55578", "Asia/Kolkata"),
("1266976", "Kharagpur", "Харагпур", "IN", "356", "28", "", "", "", "22.33971", "87.32501", "Asia/Kolkata"),
("1267006", "Khapa", "", "IN", "356", "35", "", "", "", "21.42264", "78.98165", "Asia/Kolkata"),
("1267016", "Khanna", "Ханна", "IN", "356", "23", "", "", "", "30.703", "76.22106", "Asia/Kolkata"),
("1267031", "Khandwa", "", "IN", "356", "35", "", "", "", "21.82451", "76.35202", "Asia/Kolkata"),
("1267044", "Khandela", "", "IN", "356", "24", "", "", "", "27.60499", "75.502", "Asia/Kolkata"),
("1267065", "Khanapur", "", "IN", "356", "19", "", "", "", "15.63968", "74.50847", "Asia/Kolkata"),
("1267076", "Khammam", "Кхаммам", "IN", "356", "02", "", "", "", "17.24767", "80.14368", "Asia/Kolkata"),
("1267084", "Khamgaon", "", "IN", "356", "16", "", "", "", "20.70738", "76.56827", "Asia/Kolkata"),
("1267090", "Khambhat", "", "IN", "356", "09", "", "", "", "22.31744", "72.61916", "Asia/Kolkata"),
("1267091", "Khambhaliya", "", "IN", "356", "09", "", "", "", "22.20685", "69.65031", "Asia/Kolkata"),
("1267097", "Khamaria", "", "IN", "356", "35", "", "", "", "23.22542", "79.88005", "Asia/Kolkata"),
("1267115", "Khalilabad", "", "IN", "356", "36", "", "", "", "26.77447", "83.0709", "Asia/Kolkata"),
("1267154", "Khajuraho", "Кхаджурахо", "IN", "356", "35", "", "", "", "24.8478", "79.93344", "Asia/Kolkata"),
("1267173", "Khairagarh", "", "IN", "356", "37", "", "", "", "26.94269", "77.8189", "Asia/Kolkata"),
("1267174", "Khairagarh", "", "IN", "356", "37", "", "", "", "21.41879", "80.98012", "Asia/Kolkata"),
("1267175", "Khairabad", "", "IN", "356", "36", "", "", "", "27.52708", "80.75553", "Asia/Kolkata"),
("1267182", "Khair", "", "IN", "356", "36", "", "", "", "27.94139", "77.84373", "Asia/Kolkata"),
("1267187", "Khagaul", "", "IN", "356", "34", "", "", "", "25.58282", "85.04548", "Asia/Kolkata"),
("1267189", "Khagaria", "", "IN", "356", "34", "", "", "", "25.51049", "86.47627", "Asia/Kolkata"),
("1267195", "Khadki", "", "IN", "356", "16", "", "", "", "18.5635", "73.85205", "Asia/Kolkata"),
("1267202", "Khada", "", "IN", "356", "36", "", "", "", "27.18333", "83.88333", "Asia/Kolkata"),
("1267203", "Khachrod", "", "IN", "356", "35", "", "", "", "23.42322", "75.28185", "Asia/Kolkata"),
("1267222", "Kesinga", "", "IN", "356", "21", "", "", "", "20.18778", "83.21949", "Asia/Kolkata"),
("1267226", "Keshorai Patan", "", "IN", "356", "24", "", "", "", "25.29275", "75.93948", "Asia/Kolkata"),
("1267227", "Keshod", "", "IN", "356", "09", "", "", "", "21.30328", "70.24861", "Asia/Kolkata"),
("1267239", "Kerur", "", "IN", "356", "19", "", "", "", "16.01384", "75.54631", "Asia/Kolkata"),
("1267283", "Kendraparha", "", "IN", "356", "21", "", "", "", "20.50166", "86.42227", "Asia/Kolkata"),
("1267290", "Kenda", "", "IN", "356", "28", "", "", "", "23.1959", "86.51499", "Asia/Kolkata"),
("1267297", "Kemri", "", "IN", "356", "36", "", "", "", "28.8054", "79.20396", "Asia/Kolkata"),
("1267336", "Kekri", "", "IN", "356", "24", "", "", "", "25.97132", "75.14992", "Asia/Kolkata"),
("1267360", "Kayankulam", "", "IN", "356", "13", "", "", "", "9.17243", "76.50017", "Asia/Kolkata"),
("1267361", "Kayalpattinam", "", "IN", "356", "25", "", "", "", "8.57143", "78.11992", "Asia/Kolkata"),
("1267369", "Kawardha", "", "IN", "356", "37", "", "", "", "22.00827", "81.2321", "Asia/Kolkata"),
("1267394", "Kavali", "", "IN", "356", "02", "", "", "", "14.91582", "79.9912", "Asia/Kolkata"),
("1267433", "Kattivakkam", "", "IN", "356", "25", "", "", "", "13.21667", "80.31667", "Asia/Kolkata"),
("1267435", "Kattanam", "", "IN", "356", "13", "", "", "", "9.18333", "76.55", "Asia/Kolkata"),
("1267439", "Katras", "", "IN", "356", "38", "", "", "", "23.79752", "86.29834", "Asia/Kolkata"),
("1267456", "Katpadi", "", "IN", "356", "25", "", "", "", "12.96951", "79.14552", "Asia/Kolkata"),
("1267457", "Katoya", "", "IN", "356", "28", "", "", "", "23.64558", "88.13258", "Asia/Kolkata"),
("1267461", "Katol", "", "IN", "356", "16", "", "", "", "21.26667", "78.58333", "Asia/Kolkata"),
("1267480", "Katihar", "", "IN", "356", "34", "", "", "", "25.53852", "87.57044", "Asia/Kolkata"),
("1267486", "Kathua", "", "IN", "356", "12", "", "", "", "32.37068", "75.52457", "Asia/Kolkata"),
("1267492", "Kathor", "", "IN", "356", "09", "", "", "", "21.28854", "72.9407", "Asia/Kolkata"),
("1267517", "Katghora", "", "IN", "356", "37", "", "", "", "22.50254", "82.54326", "Asia/Kolkata"),
("1267537", "Katangi", "", "IN", "356", "35", "", "", "", "23.44168", "79.79628", "Asia/Kolkata"),
("1267538", "Katangi", "", "IN", "356", "35", "", "", "", "21.77327", "79.80554", "Asia/Kolkata"),
("1267558", "Kasrawad", "", "IN", "356", "35", "", "", "", "22.12745", "75.611", "Asia/Kolkata"),
("1267579", "Kashipur", "", "IN", "356", "39", "", "", "", "29.21398", "78.95693", "Asia/Kolkata"),
("1267588", "Kasganj", "", "IN", "356", "36", "", "", "", "27.80544", "78.64602", "Asia/Kolkata"),
("1267616", "Kasaragod", "", "IN", "356", "13", "", "", "", "12.49838", "74.98959", "Asia/Kolkata"),
("1267635", "Karwar", "Карвар", "IN", "356", "19", "", "", "", "14.81361", "74.12972", "Asia/Kolkata"),
("1267648", "Karur", "Карур", "IN", "356", "25", "", "", "", "10.95771", "78.08095", "Asia/Kolkata"),
("1267669", "Kartarpur", "", "IN", "356", "23", "", "", "", "31.44155", "75.49992", "Asia/Kolkata"),
("1267675", "Karsiyang", "", "IN", "356", "28", "", "", "", "26.88251", "88.27729", "Asia/Kolkata"),
("1267696", "Karol Bagh", "", "IN", "356", "07", "8335421", "", "", "28.65156", "77.18858", "Asia/Kolkata"),
("1267708", "Karnal", "Карнал", "IN", "356", "10", "", "", "", "29.69009", "76.98839", "Asia/Kolkata"),
("1267716", "Karmala", "", "IN", "356", "16", "", "", "", "18.4077", "75.19386", "Asia/Kolkata"),
("1267739", "Karkal", "", "IN", "356", "19", "", "", "", "13.21051", "74.99914", "Asia/Kolkata"),
("1267742", "Karjat", "", "IN", "356", "16", "", "", "", "18.9107", "73.32354", "Asia/Kolkata"),
("1267755", "Karimnagar", "", "IN", "356", "02", "", "", "", "18.43916", "79.12856", "Asia/Kolkata"),
("1267758", "Karimganj", "", "IN", "356", "03", "", "", "", "24.86919", "92.35544", "Asia/Kolkata"),
("1267772", "Karhal", "", "IN", "356", "36", "", "", "", "27.00087", "78.93856", "Asia/Kolkata"),
("1267786", "Karera", "Кареры", "IN", "356", "35", "", "", "", "25.46165", "78.13941", "Asia/Kolkata"),
("1267794", "Kareli", "Карели", "IN", "356", "35", "", "", "", "22.91581", "79.06318", "Asia/Kolkata"),
("1267819", "Karauli", "", "IN", "356", "24", "", "", "", "26.49831", "77.02755", "Asia/Kolkata"),
("1267853", "Karanja", "Каранджа", "IN", "356", "16", "", "", "", "20.48263", "77.48748", "Asia/Kolkata"),
("1267862", "Karamsad", "", "IN", "356", "09", "", "", "", "22.54243", "72.90392", "Asia/Kolkata"),
("1267869", "Karamadai", "", "IN", "356", "25", "1273866", "", "", "11.24058", "76.96009", "Asia/Kolkata"),
("1267885", "Karaikkudi", "", "IN", "356", "25", "", "", "", "10.0661", "78.76786", "Asia/Kolkata"),
("1267887", "Karaikal", "", "IN", "356", "22", "", "", "", "10.91667", "79.83333", "Asia/Kolkata"),
("1267904", "Karad", "", "IN", "356", "16", "", "", "", "17.28937", "74.18183", "Asia/Kolkata"),
("1267911", "Kapurthala", "", "IN", "356", "23", "", "", "", "31.38011", "75.38105", "Asia/Kolkata"),
("1267923", "Kapren", "", "IN", "356", "24", "", "", "", "25.40529", "76.07431", "Asia/Kolkata"),
("1267939", "Kapadvanj", "", "IN", "356", "09", "", "", "", "23.02153", "73.07213", "Asia/Kolkata"),
("1267972", "Kanth", "", "IN", "356", "36", "", "", "", "29.05952", "78.62874", "Asia/Kolkata"),
("1267978", "Kantabanji", "", "IN", "356", "21", "", "", "", "20.46709", "82.92042", "Asia/Kolkata"),
("1267979", "Kant", "", "IN", "356", "36", "", "", "", "27.80961", "79.79228", "Asia/Kolkata"),
("1267995", "Kanpur", "Канпур", "IN", "356", "36", "", "", "", "26.4478", "80.34627", "Asia/Kolkata"),
("1268007", "Kannod", "", "IN", "356", "35", "", "", "", "22.66684", "76.73787", "Asia/Kolkata"),
("1268008", "Kanniyakumari", "Каньякумари", "IN", "356", "25", "", "", "", "8.09008", "77.53841", "Asia/Kolkata"),
("1268011", "Kannauj", "Каннаудж", "IN", "356", "36", "", "", "", "27.0546", "79.922", "Asia/Kolkata"),
("1268015", "Kannangad", "", "IN", "356", "13", "", "", "", "12.30814", "75.10632", "Asia/Kolkata"),
("1268020", "Kannad", "", "IN", "356", "16", "", "", "", "20.25784", "75.138", "Asia/Kolkata"),
("1268031", "Kanker", "", "IN", "356", "37", "", "", "", "20.27224", "81.49202", "Asia/Kolkata"),
("1268032", "Kanke", "", "IN", "356", "38", "", "", "", "23.43362", "85.3211", "Asia/Kolkata"),
("1268035", "Kankauli", "", "IN", "356", "16", "", "", "", "16.2661", "73.71217", "Asia/Kolkata"),
("1268059", "Kanigiri", "", "IN", "356", "02", "", "", "", "15.40593", "79.50269", "Asia/Kolkata"),
("1268095", "Kangayam", "", "IN", "356", "25", "", "", "", "11.00599", "77.5609", "Asia/Kolkata"),
("1268111", "Kandukur", "", "IN", "356", "02", "", "", "", "15.21542", "79.9039", "Asia/Kolkata"),
("1268124", "Kandla", "Кандла", "IN", "356", "09", "", "", "", "23.03333", "70.21667", "Asia/Kolkata"),
("1268135", "Kandi", "", "IN", "356", "28", "", "", "", "23.95946", "88.04018", "Asia/Kolkata"),
("1268138", "Kandhla", "", "IN", "356", "36", "", "", "", "29.32102", "77.26989", "Asia/Kolkata"),
("1268159", "Kanchipuram", "Канчипурам", "IN", "356", "25", "", "", "", "12.83515", "79.70006", "Asia/Kolkata"),
("1268189", "Kanakapura", "", "IN", "356", "19", "", "", "", "12.54614", "77.42099", "Asia/Kolkata"),
("1268205", "Kamthi", "", "IN", "356", "16", "", "", "", "21.21714", "79.19453", "Asia/Kolkata"),
("1268214", "Kampli", "", "IN", "356", "19", "", "", "", "15.40534", "76.60286", "Asia/Kolkata"),
("1268246", "Cumbum", "", "IN", "356", "25", "", "", "", "9.73647", "77.2847", "Asia/Kolkata"),
("1268257", "Kamarhati", "", "IN", "356", "28", "", "", "", "22.67111", "88.37472", "Asia/Kolkata"),
("1268259", "Kamareddi", "", "IN", "356", "02", "", "", "", "18.32001", "78.34177", "Asia/Kolkata"),
("1268266", "Kaman", "Каман", "IN", "356", "24", "", "", "", "27.65791", "77.26908", "Asia/Kolkata"),
("1268276", "Kamalganj", "", "IN", "356", "36", "", "", "", "27.2625", "79.63154", "Asia/Kolkata"),
("1268279", "Kamakhyanagar", "", "IN", "356", "21", "", "", "", "20.93385", "85.5449", "Asia/Kolkata"),
("1268293", "Kalyani", "", "IN", "356", "28", "", "", "", "22.98333", "88.48333", "Asia/Kolkata"),
("1268295", "Kalyan", "Кальян", "IN", "356", "16", "", "", "", "19.2437", "73.13554", "Asia/Kolkata"),
("1268310", "Kalugumalai", "", "IN", "356", "25", "", "", "", "9.14726", "77.70424", "Asia/Kolkata"),
("1268325", "Kalpi", "Калпи", "IN", "356", "36", "", "", "", "26.11667", "79.73333", "Asia/Kolkata"),
("1268327", "Kalpetta", "", "IN", "356", "13", "", "", "", "11.61056", "76.08222", "Asia/Kolkata"),
("1268339", "Kalol", "", "IN", "356", "09", "", "", "", "22.60777", "73.46272", "Asia/Kolkata"),
("1268341", "Kalna", "Кална", "IN", "356", "28", "", "", "", "23.21944", "88.36295", "Asia/Kolkata"),
("1268344", "Kalmeshwar", "", "IN", "356", "16", "", "", "", "21.23234", "78.9202", "Asia/Kolkata"),
("1268360", "Kallidaikurichchi", "", "IN", "356", "25", "", "", "", "8.68301", "77.46455", "Asia/Kolkata"),
("1268376", "Kallakkurichchi", "", "IN", "356", "25", "", "", "", "11.7404", "78.959", "Asia/Kolkata"),
("1268381", "Kalka", "Калки", "IN", "356", "11", "", "", "", "30.83915", "76.93947", "Asia/Kolkata"),
("1268383", "Kaliyaganj", "", "IN", "356", "28", "", "", "", "25.63442", "88.32665", "Asia/Kolkata"),
("1268403", "Kalimpang", "Калимпонг", "IN", "356", "28", "", "", "", "27.06834", "88.46508", "Asia/Kolkata"),
("1268434", "Kalghatgi", "", "IN", "356", "19", "", "", "", "15.18315", "74.97099", "Asia/Kolkata"),
("1268450", "Kalavad", "", "IN", "356", "09", "", "", "", "22.20788", "70.38343", "Asia/Kolkata"),
("1268469", "Kalanwali", "", "IN", "356", "10", "", "", "", "29.83281", "74.97857", "Asia/Kolkata"),
("1268476", "Kalanaur", "", "IN", "356", "10", "", "", "", "28.82753", "76.39482", "Asia/Kolkata"),
("1268480", "Kalamnuri", "", "IN", "356", "16", "", "", "", "19.67386", "77.31149", "Asia/Kolkata"),
("1268484", "Kalamb", "", "IN", "356", "16", "", "", "", "19.04437", "73.95554", "Asia/Kolkata"),
("1268495", "Kalakkadu", "", "IN", "356", "25", "", "", "", "8.51228", "77.5535", "Asia/Kolkata"),
("1268540", "Kakrala", "", "IN", "356", "36", "", "", "", "27.89269", "79.1945", "Asia/Kolkata"),
("1268545", "Kakori", "", "IN", "356", "36", "", "", "", "26.868", "80.7857", "Asia/Kolkata"),
("1268561", "Kakinada", "Какинада", "IN", "356", "02", "", "", "", "16.96036", "82.23809", "Asia/Kolkata"),
("1268567", "Kakching", "", "IN", "356", "17", "", "", "", "24.4982", "93.98126", "Asia/Kolkata"),
("1268593", "Kaithal", "", "IN", "356", "10", "", "", "", "29.8019", "76.39667", "Asia/Kolkata"),
("1268601", "Kairana", "", "IN", "356", "36", "", "", "", "29.3959", "77.20564", "Asia/Kolkata"),
("1268615", "Kaimori", "", "IN", "356", "35", "", "", "", "23.38465", "79.7442", "Asia/Kolkata"),
("1268616", "Kaimganj", "", "IN", "356", "36", "", "", "", "27.55497", "79.33747", "Asia/Kolkata"),
("1268622", "Kailashahar", "", "IN", "356", "26", "", "", "", "24.332", "92.00391", "Asia/Kolkata"),
("1268624", "Kailaras", "", "IN", "356", "35", "", "", "", "26.3054", "77.61605", "Asia/Kolkata"),
("1268627", "Kaikalur", "", "IN", "356", "02", "", "", "", "16.55084", "81.21177", "Asia/Kolkata"),
("1268651", "Kagal", "", "IN", "356", "16", "", "", "", "16.57702", "74.31544", "Asia/Kolkata"),
("1268662", "Kadur", "", "IN", "356", "19", "", "", "", "13.55259", "76.01096", "Asia/Kolkata"),
("1268667", "Kadod", "", "IN", "356", "09", "", "", "", "21.21716", "73.21972", "Asia/Kolkata"),
("1268673", "Kadiri", "Кадири", "IN", "356", "02", "", "", "", "14.11252", "78.16027", "Asia/Kolkata"),
("1268680", "Kadi", "", "IN", "356", "09", "", "", "", "23.29908", "72.33362", "Asia/Kolkata"),
("1268707", "Kadayanallur", "", "IN", "356", "25", "", "", "", "9.07277", "77.34152", "Asia/Kolkata"),
("1268715", "Kanchrapara", "", "IN", "356", "28", "", "", "", "22.95998", "88.4285", "Asia/Kolkata"),
("1268722", "Kachhwa", "", "IN", "356", "36", "", "", "", "25.20651", "82.71543", "Asia/Kolkata"),
("1268739", "Kabrai", "", "IN", "356", "36", "", "", "", "25.40525", "79.99421", "Asia/Kolkata"),
("1268761", "Junnar", "", "IN", "356", "16", "", "", "", "19.20815", "73.8752", "Asia/Kolkata"),
("1268772", "Junagarh", "", "IN", "356", "37", "", "", "", "19.85993", "82.93385", "Asia/Kolkata"),
("1268773", "Junagadh", "", "IN", "356", "09", "", "", "", "21.51966", "70.45981", "Asia/Kolkata"),
("1268775", "Jumri Tilaiya", "", "IN", "356", "38", "", "", "", "24.4349", "85.52951", "Asia/Kolkata"),
("1268782", "Jalandhar", "Джаландхар", "IN", "356", "23", "", "", "", "31.32556", "75.57917", "Asia/Kolkata"),
("1268799", "Jugsalai", "", "IN", "356", "38", "", "", "", "22.77668", "86.18351", "Asia/Kolkata"),
("1268820", "Jorhat", "Джорхат", "IN", "356", "03", "", "", "", "26.75751", "94.20306", "Asia/Kolkata"),
("1268823", "Jora", "Жора", "IN", "356", "35", "", "", "", "26.34209", "77.8092", "Asia/Kolkata"),
("1268834", "Jolarpettai", "", "IN", "356", "25", "", "", "", "12.57045", "78.57341", "Asia/Kolkata"),
("1268855", "Jogbani", "", "IN", "356", "34", "", "", "", "26.41667", "87.25", "Asia/Kolkata"),
("1268863", "Jodiya Bandar", "", "IN", "356", "09", "", "", "", "22.71667", "70.28333", "Asia/Kolkata"),
("1268865", "Jodhpur", "Джодхпур", "IN", "356", "24", "", "", "", "26.26841", "73.00594", "Asia/Kolkata"),
("1268866", "Jodhpur", "", "IN", "356", "09", "", "", "", "21.90174", "70.0327", "Asia/Kolkata"),
("1268896", "Jintur", "", "IN", "356", "16", "", "", "", "19.61186", "76.6874", "Asia/Kolkata"),
("1268907", "Jind", "", "IN", "356", "10", "", "", "", "29.31617", "76.31436", "Asia/Kolkata"),
("1268929", "Jhusi", "", "IN", "356", "36", "", "", "", "25.43806", "81.90606", "Asia/Kolkata"),
("1268936", "Jhunjhunun", "", "IN", "356", "24", "", "", "", "28.12559", "75.39797", "Asia/Kolkata"),
("1268961", "Jhinjhana", "", "IN", "356", "36", "", "", "", "29.52177", "77.22525", "Asia/Kolkata"),
("1268962", "Jhinjhak", "", "IN", "356", "36", "", "", "", "26.56004", "79.73442", "Asia/Kolkata"),
("1268977", "Jharsuguda", "", "IN", "356", "21", "", "", "", "21.86159", "84.01788", "Asia/Kolkata"),
("1268988", "Jharia", "", "IN", "356", "38", "", "", "", "23.74079", "86.41456", "Asia/Kolkata"),
("1268990", "Jhargram", "", "IN", "356", "28", "", "", "", "22.45384", "86.99497", "Asia/Kolkata"),
("1269006", "Jhansi", "", "IN", "356", "36", "", "", "", "25.45446", "78.58221", "Asia/Kolkata"),
("1269012", "Jhanjharpur", "", "IN", "356", "34", "", "", "", "26.26467", "86.27992", "Asia/Kolkata"),
("1269019", "Jhalu", "", "IN", "356", "36", "", "", "", "29.33616", "78.22514", "Asia/Kolkata"),
("1269020", "Jhalrapatan", "", "IN", "356", "24", "", "", "", "24.54205", "76.17242", "Asia/Kolkata"),
("1269026", "Jhalida", "", "IN", "356", "28", "", "", "", "23.36541", "85.97581", "Asia/Kolkata"),
("1269027", "Jhalawar", "", "IN", "356", "24", "", "", "", "24.59676", "76.16503", "Asia/Kolkata"),
("1269042", "Jhajjar", "", "IN", "356", "10", "", "", "", "28.6063", "76.6565", "Asia/Kolkata"),
("1269046", "Jha Jha", "", "IN", "356", "34", "", "", "", "24.77418", "86.38005", "Asia/Kolkata"),
("1269053", "Jhabua", "Дхабуа", "IN", "356", "35", "", "", "", "22.76819", "74.59143", "Asia/Kolkata"),
("1269056", "Jewar", "", "IN", "356", "36", "", "", "", "28.1228", "77.55622", "Asia/Kolkata"),
("1269057", "Jevargi", "", "IN", "356", "19", "", "", "", "17.01394", "76.77317", "Asia/Kolkata"),
("1269065", "Jetpur", "", "IN", "356", "09", "", "", "", "21.75482", "70.62347", "Asia/Kolkata"),
("1269092", "Jaypur", "", "IN", "356", "21", "", "", "", "18.8563", "82.5716", "Asia/Kolkata"),
("1269093", "Jaynagar", "", "IN", "356", "34", "", "", "", "26.58749", "86.13744", "Asia/Kolkata"),
("1269094", "Jaynagar-Majilpur", "", "IN", "356", "28", "", "", "", "22.17583", "88.41778", "Asia/Kolkata"),
("1269102", "Jayamkondacholapuram", "", "IN", "356", "25", "", "", "", "11.21206", "79.36473", "Asia/Kolkata"),
("1269126", "Jawad", "", "IN", "356", "35", "", "", "", "24.59916", "74.86261", "Asia/Kolkata"),
("1269135", "Jaunpur", "Джаунпур", "IN", "356", "36", "", "", "", "25.75506", "82.68361", "Asia/Kolkata"),
("1269153", "Jatara", "", "IN", "356", "35", "", "", "", "25.00921", "79.04778", "Asia/Kolkata"),
("1269154", "Jatani", "", "IN", "356", "21", "", "", "", "20.15975", "85.70742", "Asia/Kolkata"),
("1269158", "Jaswantnagar", "", "IN", "356", "36", "", "", "", "26.88234", "78.90187", "Asia/Kolkata"),
("1269168", "Jaspur", "", "IN", "356", "39", "", "", "", "29.27944", "78.82656", "Asia/Kolkata"),
("1269175", "Jasidih", "", "IN", "356", "38", "", "", "", "24.51379", "86.64576", "Asia/Kolkata"),
("1269177", "Jashpurnagar", "", "IN", "356", "37", "", "", "", "22.88772", "84.13925", "Asia/Kolkata"),
("1269179", "Jasdan", "", "IN", "356", "09", "", "", "", "22.03709", "71.20794", "Asia/Kolkata"),
("1269183", "Jarwal", "", "IN", "356", "36", "", "", "", "27.16442", "81.53993", "Asia/Kolkata"),
("1269217", "Jaora", "", "IN", "356", "35", "", "", "", "23.63783", "75.12711", "Asia/Kolkata"),
("1269227", "Jansath", "", "IN", "356", "36", "", "", "", "29.32508", "77.84945", "Asia/Kolkata"),
("1269239", "Janjgir", "", "IN", "356", "37", "", "", "", "22.0092", "82.57769", "Asia/Kolkata"),
("1269247", "Jangipur", "", "IN", "356", "28", "", "", "", "24.47001", "88.07659", "Asia/Kolkata"),
("1269256", "Jangaon", "", "IN", "356", "02", "", "", "", "17.72602", "79.15236", "Asia/Kolkata"),
("1269269", "Jandiala", "", "IN", "356", "23", "", "", "", "31.1593", "75.61755", "Asia/Kolkata"),
("1269280", "Jamuria", "", "IN", "356", "28", "", "", "", "23.70468", "87.07872", "Asia/Kolkata"),
("1269291", "Jamui", "", "IN", "356", "34", "", "", "", "24.92589", "86.22574", "Asia/Kolkata"),
("1269298", "Jamtara", "", "IN", "356", "38", "", "", "", "23.963", "86.80285", "Asia/Kolkata"),
("1269300", "Jamshedpur", "Джамшедпур", "IN", "356", "38", "", "", "", "22.80278", "86.18545", "Asia/Kolkata"),
("1269317", "Jamnagar", "Джамнагаром", "IN", "356", "09", "", "", "", "22.47292", "70.06673", "Asia/Kolkata"),
("1269321", "Jammu", "Джамму", "IN", "356", "12", "", "", "", "32.73569", "74.86911", "Asia/Kolkata"),
("1269323", "Jammalamadugu", "", "IN", "356", "02", "", "", "", "14.8474", "78.38401", "Asia/Kolkata"),
("1269328", "Jamkhandi", "", "IN", "356", "19", "", "", "", "16.50461", "75.29146", "Asia/Kolkata"),
("1269350", "Jambusar", "", "IN", "356", "09", "", "", "", "22.05236", "72.80074", "Asia/Kolkata"),
("1269374", "Jamalpur", "", "IN", "356", "34", "", "", "", "25.31258", "86.48888", "Asia/Kolkata"),
("1269377", "Jamai", "", "IN", "356", "35", "", "", "", "22.19565", "78.59121", "Asia/Kolkata"),
("1269379", "Jamadoba", "", "IN", "356", "38", "", "", "", "23.71667", "86.4", "Asia/Kolkata"),
("1269388", "Jalpaiguri", "", "IN", "356", "28", "1269389", "", "", "26.51667", "88.73333", "Asia/Kolkata"),
("1269392", "Jalor", "", "IN", "356", "24", "", "", "", "25.34558", "72.61559", "Asia/Kolkata"),
("1269395", "Jalna", "", "IN", "356", "16", "", "", "", "19.84102", "75.88636", "Asia/Kolkata"),
("1269406", "Jalgaon Jamod", "Джалгаоне", "IN", "356", "16", "", "", "", "21.05194", "76.53464", "Asia/Kolkata"),
("1269407", "Jalgaon", "Джалгаоне", "IN", "356", "16", "", "", "", "21.01009", "75.56843", "Asia/Kolkata"),
("1269413", "Jaleshwar", "", "IN", "356", "21", "", "", "", "21.80176", "87.2225", "Asia/Kolkata"),
("1269415", "Jalesar", "", "IN", "356", "36", "", "", "", "27.47235", "78.30247", "Asia/Kolkata"),
("1269422", "Jalaun", "", "IN", "356", "36", "", "", "", "26.1451", "79.3366", "Asia/Kolkata"),
("1269435", "Jalalpur", "", "IN", "356", "36", "", "", "", "26.31041", "82.73799", "Asia/Kolkata"),
("1269439", "Jalalpur", "", "IN", "356", "09", "", "", "", "20.94896", "72.89828", "Asia/Kolkata"),
("1269441", "Jalali", "", "IN", "356", "36", "", "", "", "27.86625", "78.25275", "Asia/Kolkata"),
("1269445", "Jalalabad", "", "IN", "356", "23", "", "", "", "30.60622", "74.25726", "Asia/Kolkata"),
("1269446", "Jalalabad", "", "IN", "356", "36", "", "", "", "29.61857", "77.43801", "Asia/Kolkata"),
("1269447", "Jalalabad", "", "IN", "356", "36", "", "", "", "27.72664", "79.65497", "Asia/Kolkata"),
("1269477", "Jajpur", "", "IN", "356", "21", "", "", "", "20.84852", "86.33729", "Asia/Kolkata"),
("1269488", "Jaito", "", "IN", "356", "23", "", "", "", "30.4475", "74.88744", "Asia/Kolkata"),
("1269498", "Jaitaran", "", "IN", "356", "24", "", "", "", "26.20441", "73.93686", "Asia/Kolkata"),
("1269502", "Jaisingpur", "", "IN", "356", "16", "", "", "", "16.77639", "74.55361", "Asia/Kolkata"),
("1269507", "Jaisalmer", "Джайсалмер", "IN", "356", "24", "", "", "", "26.91763", "70.90387", "Asia/Kolkata"),
("1269509", "Jais", "", "IN", "356", "36", "", "", "", "26.26459", "81.5478", "Asia/Kolkata"),
("1269515", "Jaipur", "Джайпур", "IN", "356", "24", "1269519", "", "", "26.91962", "75.78781", "Asia/Kolkata"),
("1269545", "Jahazpur", "", "IN", "356", "24", "", "", "", "25.61994", "75.27609", "Asia/Kolkata"),
("1269551", "Jahangirabad", "", "IN", "356", "36", "", "", "", "28.40338", "78.10562", "Asia/Kolkata"),
("1269557", "Jahanabad", "", "IN", "356", "34", "", "", "", "25.21398", "84.98772", "Asia/Kolkata"),
("1269562", "Jagtial", "", "IN", "356", "02", "", "", "", "18.79473", "78.91661", "Asia/Kolkata"),
("1269564", "Jagraon", "", "IN", "356", "23", "", "", "", "30.79013", "75.47492", "Asia/Kolkata"),
("1269570", "Jaggayyapeta", "", "IN", "356", "02", "", "", "", "16.8938", "80.09807", "Asia/Kolkata"),
("1269573", "Jagdispur", "", "IN", "356", "34", "", "", "", "25.46877", "84.41925", "Asia/Kolkata"),
("1269574", "Jagdishpur", "", "IN", "356", "36", "", "", "", "26.74967", "80.5451", "Asia/Kolkata"),
("1269578", "Jagdalpur", "Джагдалпур", "IN", "356", "37", "", "", "", "19.0836", "82.02331", "Asia/Kolkata"),
("1269581", "Jagatsinghapur", "", "IN", "356", "21", "", "", "", "20.2557", "86.17112", "Asia/Kolkata"),
("1269602", "Jagalur", "", "IN", "356", "19", "", "", "", "14.51976", "76.33892", "Asia/Kolkata"),
("1269605", "Jagadhri", "", "IN", "356", "10", "", "", "", "30.16676", "77.30311", "Asia/Kolkata"),
("1269633", "Jabalpur", "Джабалпур", "IN", "356", "35", "", "", "", "23.16697", "79.95006", "Asia/Kolkata"),
("1269646", "Itimadpur", "", "IN", "356", "36", "", "", "", "27.23423", "78.20021", "Asia/Kolkata"),
("1269653", "Itarsi", "", "IN", "356", "35", "", "", "", "22.61477", "77.76222", "Asia/Kolkata"),
("1269655", "Itanagar", "Итанагар", "IN", "356", "30", "", "", "", "27.08694", "93.60987", "Asia/Kolkata"),
("1269665", "Islampur", "", "IN", "356", "28", "", "", "", "26.26541", "88.18982", "Asia/Kolkata"),
("1269666", "Islampur", "", "IN", "356", "34", "", "", "", "25.14129", "85.20432", "Asia/Kolkata"),
("1269670", "Islamnagar", "", "IN", "356", "36", "", "", "", "28.32849", "78.72412", "Asia/Kolkata"),
("1269690", "Irugur", "", "IN", "356", "25", "", "", "", "11.01866", "77.06624", "Asia/Kolkata"),
("1269693", "Irinjalakuda", "", "IN", "356", "13", "", "", "", "10.34238", "76.21124", "Asia/Kolkata"),
("1269694", "Iringal", "", "IN", "356", "13", "", "", "", "11.56667", "75.6", "Asia/Kolkata"),
("1269723", "Ingraj Bazar", "", "IN", "356", "28", "", "", "", "25.00447", "88.14573", "Asia/Kolkata"),
("1269731", "Indri", "", "IN", "356", "10", "", "", "", "29.8799", "77.05882", "Asia/Kolkata"),
("1269743", "Indore", "Индор", "IN", "356", "35", "", "", "", "22.71792", "75.8333", "Asia/Kolkata"),
("1269751", "Indi", "", "IN", "356", "19", "", "", "", "17.17735", "75.9526", "Asia/Kolkata"),
("1269752", "Indergarh", "", "IN", "356", "36", "", "", "", "26.93521", "79.6712", "Asia/Kolkata"),
("1269761", "Indapur", "", "IN", "356", "16", "", "", "", "18.3", "73.25", "Asia/Kolkata"),
("1269771", "Imphal", "Импхал", "IN", "356", "17", "", "", "", "24.80805", "93.9442", "Asia/Kolkata"),
("1269784", "Ilkal", "", "IN", "356", "19", "", "", "", "15.95923", "76.11351", "Asia/Kolkata"),
("1269810", "Igatpuri", "", "IN", "356", "16", "", "", "", "19.69522", "73.5626", "Asia/Kolkata"),
("1269819", "Idappadi", "", "IN", "356", "25", "", "", "", "11.58624", "77.83891", "Asia/Kolkata"),
("1269827", "Ichchapuram", "", "IN", "356", "02", "", "", "", "19.11393", "84.68721", "Asia/Kolkata"),
("1269834", "Ichalkaranji", "", "IN", "356", "16", "", "", "", "16.69116", "74.46054", "Asia/Kolkata"),
("1269843", "Hyderabad", "Хайдарабад", "IN", "356", "02", "1269844", "", "", "17.38405", "78.45636", "Asia/Kolkata"),
("1269849", "Huvinabadgalli", "", "IN", "356", "19", "", "", "", "15.02048", "75.93186", "Asia/Kolkata"),
("1269862", "Husainabad", "", "IN", "356", "38", "", "", "", "24.5285", "84", "Asia/Kolkata"),
("1269873", "Hunsur", "Хунсур", "IN", "356", "19", "", "", "", "12.30485", "76.2905", "Asia/Kolkata"),
("1269876", "Hungund", "", "IN", "356", "19", "", "", "", "16.06226", "76.05839", "Asia/Kolkata"),
("1269908", "Hukeri", "", "IN", "356", "19", "", "", "", "16.23082", "74.60244", "Asia/Kolkata"),
("1269910", "Hugli", "Хугли", "IN", "356", "28", "", "", "", "22.90877", "88.39674", "Asia/Kolkata"),
("1269920", "Hubli", "", "IN", "356", "19", "", "", "", "15.34776", "75.13378", "Asia/Kolkata"),
("1269927", "Howli", "", "IN", "356", "03", "", "", "", "26.42237", "90.98004", "Asia/Kolkata"),
("1269934", "Hosur", "", "IN", "356", "25", "", "", "", "12.73647", "77.83264", "Asia/Kolkata"),
("1269935", "Hospet", "Хоспет", "IN", "356", "19", "", "", "", "15.26954", "76.3871", "Asia/Kolkata"),
("1269936", "Hoskote", "", "IN", "356", "19", "", "", "", "13.07192", "77.79061", "Asia/Kolkata"),
("1269937", "Hoshiarpur", "", "IN", "356", "23", "", "", "", "31.53238", "75.90799", "Asia/Kolkata"),
("1269939", "Hoshangabad", "", "IN", "356", "35", "", "", "", "22.75357", "77.72249", "Asia/Kolkata"),
("1269943", "Hosdurga", "", "IN", "356", "19", "", "", "", "13.79742", "76.2831", "Asia/Kolkata"),
("1269970", "Honnali", "", "IN", "356", "19", "", "", "", "14.23976", "75.64507", "Asia/Kolkata"),
("1269976", "Honavar", "", "IN", "356", "19", "", "", "", "14.28014", "74.4452", "Asia/Kolkata"),
("1269979", "Homnabad", "", "IN", "356", "19", "", "", "", "17.77074", "77.12519", "Asia/Kolkata"),
("1269985", "Hole Narsipur", "", "IN", "356", "19", "", "", "", "12.78693", "76.243", "Asia/Kolkata"),
("1269990", "Holalkere", "", "IN", "356", "19", "", "", "", "14.04262", "76.18424", "Asia/Kolkata"),
("1269993", "Hojai", "", "IN", "356", "03", "", "", "", "26.00282", "92.85605", "Asia/Kolkata"),
("1270000", "Hodal", "", "IN", "356", "10", "", "", "", "27.89208", "77.36686", "Asia/Kolkata"),
("1270021", "Hisua", "", "IN", "356", "34", "", "", "", "24.8351", "85.41794", "Asia/Kolkata"),
("1270022", "Hisar", "Хисар", "IN", "356", "10", "1270023", "", "", "29.14897", "75.73676", "Asia/Kolkata"),
("1270032", "Hiriyur", "", "IN", "356", "19", "", "", "", "13.94387", "76.61553", "Asia/Kolkata"),
("1270036", "Hirekerur", "", "IN", "356", "19", "", "", "", "14.45506", "75.3952", "Asia/Kolkata"),
("1270059", "Hirakud", "", "IN", "356", "21", "", "", "", "21.51667", "83.86667", "Asia/Kolkata"),
("1270066", "Hinjilikatu", "", "IN", "356", "21", "", "", "", "19.48166", "84.74489", "Asia/Kolkata"),
("1270072", "Hingoli", "", "IN", "356", "16", "", "", "", "19.71908", "77.14826", "Asia/Kolkata"),
("1270077", "Hinganghat", "", "IN", "356", "16", "", "", "", "20.54765", "78.84032", "Asia/Kolkata"),
("1270079", "Hindupur", "", "IN", "356", "02", "", "", "", "13.82908", "77.4924", "Asia/Kolkata"),
("1270082", "Hindoria", "", "IN", "356", "35", "", "", "", "23.90264", "79.56904", "Asia/Kolkata"),
("1270090", "Hindaun", "", "IN", "356", "24", "", "", "", "26.73411", "77.03519", "Asia/Kolkata"),
("1270099", "Himatnagar", "", "IN", "356", "09", "", "", "", "23.59893", "72.96602", "Asia/Kolkata"),
("1270102", "Hilsa", "", "IN", "356", "34", "", "", "", "25.31586", "85.28153", "Asia/Kolkata"),
("1270164", "Hazaribag", "Хазарибаг", "IN", "356", "38", "", "", "", "23.99507", "85.36109", "Asia/Kolkata"),
("1270171", "Haveri", "", "IN", "356", "19", "", "", "", "14.79354", "75.40448", "Asia/Kolkata"),
("1270185", "Hatta", "Хатта", "IN", "356", "35", "", "", "", "24.13388", "79.60076", "Asia/Kolkata"),
("1270216", "Hathras", "", "IN", "356", "36", "", "", "", "27.59621", "78.05237", "Asia/Kolkata"),
("1270237", "Hastinapur", "", "IN", "356", "36", "", "", "", "29.15602", "77.99659", "Asia/Kolkata"),
("1270239", "Hassan", "Хасан", "IN", "356", "19", "", "", "", "13.01426", "76.10351", "Asia/Kolkata"),
("1270245", "Hasimara", "", "IN", "356", "28", "", "", "", "26.7469", "89.35385", "Asia/Kolkata"),
("1270251", "Hasanpur", "", "IN", "356", "36", "", "", "", "28.72268", "78.28325", "Asia/Kolkata"),
("1270265", "Harur", "", "IN", "356", "25", "", "", "", "12.05267", "78.48023", "Asia/Kolkata"),
("1270271", "Harsud", "", "IN", "356", "35", "", "", "", "22.10002", "76.73466", "Asia/Kolkata"),
("1270287", "Harpanahalli", "", "IN", "356", "19", "", "", "", "14.78766", "75.98863", "Asia/Kolkata"),
("1270291", "Harpalpur", "", "IN", "356", "35", "", "", "", "25.28773", "79.33279", "Asia/Kolkata"),
("1270343", "Harij", "", "IN", "356", "09", "", "", "", "23.69356", "71.907", "Asia/Kolkata"),
("1270349", "Harihar", "", "IN", "356", "19", "", "", "", "14.51288", "75.80716", "Asia/Kolkata"),
("1270351", "Haridwar", "Харидвар", "IN", "356", "39", "", "", "", "29.94791", "78.16025", "Asia/Kolkata"),
("1270370", "Hardoi", "", "IN", "356", "36", "", "", "", "27.39433", "80.1311", "Asia/Kolkata"),
("1270375", "Harda", "", "IN", "356", "35", "", "", "", "22.33893", "77.09356", "Asia/Kolkata"),
("1270393", "Hapur", "", "IN", "356", "36", "", "", "", "28.73041", "77.78141", "Asia/Kolkata"),
("1270396", "Haora", "", "IN", "356", "28", "", "", "", "22.57688", "88.31857", "Asia/Kolkata"),
("1270407", "Hanumangarh", "", "IN", "356", "24", "", "", "", "29.58182", "74.32938", "Asia/Kolkata"),
("1270417", "Hansi", "Ханси", "IN", "356", "10", "", "", "", "29.10005", "75.9645", "Asia/Kolkata"),
("1270435", "Hangal", "", "IN", "356", "19", "", "", "", "14.76465", "75.1246", "Asia/Kolkata"),
("1270437", "Handia", "", "IN", "356", "36", "", "", "", "25.36344", "82.18772", "Asia/Kolkata"),
("1270454", "Hamirpur", "", "IN", "356", "11", "", "", "", "31.68411", "76.52506", "Asia/Kolkata"),
("1270455", "Hamirpur", "", "IN", "356", "36", "", "", "", "25.95582", "80.14882", "Asia/Kolkata"),
("1270466", "Halvad", "", "IN", "356", "09", "", "", "", "23.01516", "71.18029", "Asia/Kolkata"),
("1270474", "Halol", "", "IN", "356", "09", "", "", "", "22.50321", "73.47242", "Asia/Kolkata"),
("1270482", "Haliyal", "", "IN", "356", "19", "", "", "", "15.32864", "74.75638", "Asia/Kolkata"),
("1270484", "Halisahar", "", "IN", "356", "28", "", "", "", "22.93218", "88.41859", "Asia/Kolkata"),
("1270498", "Haldwani", "", "IN", "356", "39", "", "", "", "29.22254", "79.5286", "Asia/Kolkata"),
("1270509", "Haldaur", "", "IN", "356", "36", "", "", "", "29.28979", "78.28368", "Asia/Kolkata"),
("1270522", "Hajo", "", "IN", "356", "03", "", "", "", "26.2452", "91.52525", "Asia/Kolkata"),
("1270525", "Hajipur", "Хаджипур", "IN", "356", "34", "", "", "", "25.69003", "85.20954", "Asia/Kolkata"),
("1270530", "Hailakandi", "", "IN", "356", "03", "", "", "", "24.68394", "92.56097", "Asia/Kolkata"),
("1270543", "Haflong", "", "IN", "356", "03", "", "", "", "25.16478", "93.01744", "Asia/Kolkata"),
("1270554", "Hadgaon", "", "IN", "356", "16", "", "", "", "19.4949", "77.6587", "Asia/Kolkata"),
("1270568", "Habra", "", "IN", "356", "28", "", "", "", "22.84202", "88.65606", "Asia/Kolkata"),
("1270583", "Gwalior", "Гвалиор", "IN", "356", "35", "", "", "", "26.22982", "78.17337", "Asia/Kolkata"),
("1270598", "Guskhara", "", "IN", "356", "28", "", "", "", "23.49276", "87.73484", "Asia/Kolkata"),
("1270603", "Guruvayur", "", "IN", "356", "13", "", "", "", "10.5943", "76.0411", "Asia/Kolkata"),
("1270612", "Guru Har Sahai", "", "IN", "356", "23", "", "", "", "30.70862", "74.40407", "Asia/Kolkata"),
("1270618", "Gursarai", "", "IN", "356", "36", "", "", "", "25.61676", "79.18053", "Asia/Kolkata"),
("1270619", "Gursahaiganj", "", "IN", "356", "36", "", "", "", "27.11667", "79.71667", "Asia/Kolkata"),
("1270627", "Gurmatkal", "", "IN", "356", "19", "", "", "", "16.86562", "77.39074", "Asia/Kolkata"),
("1270642", "Gurgaon", "Гургаон", "IN", "356", "10", "1270644", "", "", "28.4601", "77.02635", "Asia/Kolkata"),
("1270667", "Gunupur", "", "IN", "356", "21", "", "", "", "19.07956", "83.80827", "Asia/Kolkata"),
("1270668", "Guntur", "Гунтура", "IN", "356", "02", "", "", "", "16.29974", "80.45729", "Asia/Kolkata"),
("1270670", "Guntakal", "", "IN", "356", "02", "", "", "", "15.17126", "77.36565", "Asia/Kolkata"),
("1270674", "Gunnaur", "", "IN", "356", "36", "", "", "", "28.23902", "78.43797", "Asia/Kolkata"),
("1270686", "Gundlupet", "", "IN", "356", "19", "", "", "", "11.8082", "76.69104", "Asia/Kolkata"),
("1270711", "Guna", "", "IN", "356", "35", "", "", "", "24.64761", "77.31191", "Asia/Kolkata"),
("1270718", "Gummidipundi", "", "IN", "356", "25", "", "", "", "13.40765", "80.10879", "Asia/Kolkata"),
("1270722", "Gumla", "", "IN", "356", "37", "", "", "", "23.04156", "84.54396", "Asia/Kolkata"),
("1270723", "Gumia", "", "IN", "356", "38", "", "", "", "23.79896", "85.82383", "Asia/Kolkata"),
("1270750", "Guledagudda", "", "IN", "356", "19", "", "", "", "16.05025", "75.78997", "Asia/Kolkata"),
("1270752", "Gulbarga", "Гульбарга", "IN", "356", "19", "", "", "", "17.33764", "76.83787", "Asia/Kolkata"),
("1270759", "Gulaothi", "", "IN", "356", "36", "", "", "", "28.58889", "77.79185", "Asia/Kolkata"),
("1270763", "Gulabpura", "", "IN", "356", "24", "", "", "", "25.90448", "74.66025", "Asia/Kolkata"),
("1270787", "Guduvancheri", "", "IN", "356", "25", "", "", "", "12.84519", "80.06054", "Asia/Kolkata"),
("1270791", "Gudur", "", "IN", "356", "02", "", "", "", "14.14903", "79.8514", "Asia/Kolkata"),
("1270800", "Gudiyatham", "", "IN", "356", "25", "", "", "", "12.94601", "78.87377", "Asia/Kolkata"),
("1270801", "Gudivada", "", "IN", "356", "02", "", "", "", "16.43171", "80.9963", "Asia/Kolkata"),
("1270820", "Gudalur", "", "IN", "356", "25", "", "", "", "9.67826", "77.24951", "Asia/Kolkata"),
("1270824", "Gubbi", "", "IN", "356", "19", "", "", "", "13.31216", "76.94102", "Asia/Kolkata"),
("1270845", "Goyerkata", "", "IN", "356", "28", "", "", "", "26.69984", "89.02565", "Asia/Kolkata"),
("1270863", "Govardhan", "Говардхан", "IN", "356", "36", "", "", "", "27.49658", "77.46263", "Asia/Kolkata"),
("1270896", "Gosaba", "", "IN", "356", "28", "", "", "", "22.16547", "88.8007", "Asia/Kolkata"),
("1270926", "Gorakhpur", "Горакпура", "IN", "356", "10", "", "", "", "29.44702", "75.67181", "Asia/Kolkata"),
("1270927", "Gorakhpur", "Горакпура", "IN", "356", "36", "", "", "", "26.75479", "83.37235", "Asia/Kolkata"),
("1270947", "Gobichettipalayam", "", "IN", "356", "25", "", "", "", "11.45496", "77.4422", "Asia/Kolkata"),
("1270965", "Gopalganj", "", "IN", "356", "34", "", "", "", "26.46734", "84.44041", "Asia/Kolkata"),
("1270990", "Gondia", "Гондия", "IN", "356", "16", "", "", "", "21.46015", "80.19203", "Asia/Kolkata"),
("1270994", "Gondal", "", "IN", "356", "09", "", "", "", "21.96074", "70.80255", "Asia/Kolkata"),
("1270996", "Gonda", "Гонда", "IN", "356", "36", "", "", "", "27.13253", "81.96897", "Asia/Kolkata"),
("1271005", "Gomoh", "", "IN", "356", "38", "", "", "", "23.87355", "86.1516", "Asia/Kolkata"),
("1271049", "Gola Gokarannath", "", "IN", "356", "36", "", "", "", "28.07837", "80.47054", "Asia/Kolkata"),
("1271050", "Golaghat", "", "IN", "356", "03", "", "", "", "26.51166", "93.95951", "Asia/Kolkata"),
("1271064", "Gokarna", "Гокарн", "IN", "356", "19", "", "", "", "14.55", "74.31667", "Asia/Kolkata"),
("1271067", "Gokak", "Гокак", "IN", "356", "19", "", "", "", "16.16901", "74.82393", "Asia/Kolkata"),
("1271079", "Gohana", "", "IN", "356", "10", "", "", "", "29.13648", "76.69534", "Asia/Kolkata"),
("1271083", "Gohad", "", "IN", "356", "35", "", "", "", "26.42416", "78.44094", "Asia/Kolkata"),
("1271107", "Godhra", "Годхре", "IN", "356", "09", "", "", "", "22.77547", "73.61488", "Asia/Kolkata"),
("1271113", "Godda", "", "IN", "356", "38", "", "", "", "24.82379", "87.21285", "Asia/Kolkata"),
("1271131", "Gobindpur", "", "IN", "356", "38", "", "", "", "22.63393", "86.07162", "Asia/Kolkata"),
("1271142", "Gobardanga", "", "IN", "356", "28", "", "", "", "22.8774", "88.75479", "Asia/Kolkata"),
("1271151", "Goalpara", "", "IN", "356", "03", "", "", "", "26.17668", "90.62634", "Asia/Kolkata"),
("1271175", "Giridih", "", "IN", "356", "38", "", "", "", "24.18561", "86.30772", "Asia/Kolkata"),
("1271199", "Gingee", "", "IN", "356", "25", "", "", "", "12.2559", "79.41724", "Asia/Kolkata"),
("1271212", "Giddarbaha", "", "IN", "356", "23", "", "", "", "30.2023", "74.66318", "Asia/Kolkata"),
("1271213", "Giddalur", "", "IN", "356", "02", "", "", "", "15.37726", "78.92748", "Asia/Kolkata"),
("1271244", "Ghugus", "", "IN", "356", "16", "", "", "", "19.94593", "79.10854", "Asia/Kolkata"),
("1271250", "Ghoti Budrukh", "", "IN", "356", "16", "", "", "", "19.71641", "73.62821", "Asia/Kolkata"),
("1271259", "Ghosi", "", "IN", "356", "36", "", "", "", "26.10318", "83.54379", "Asia/Kolkata"),
("1271306", "Ghazipur", "", "IN", "356", "36", "", "", "", "25.58052", "83.58058", "Asia/Kolkata"),
("1271308", "Ghaziabad", "Газиабад", "IN", "356", "36", "", "", "", "28.66249", "77.43777", "Asia/Kolkata"),
("1271319", "Ghatsila", "", "IN", "356", "38", "", "", "", "22.58531", "86.47682", "Asia/Kolkata"),
("1271343", "Ghatanji", "", "IN", "356", "16", "", "", "", "20.14195", "78.31308", "Asia/Kolkata"),
("1271345", "Ghatampur", "", "IN", "356", "36", "", "", "", "26.15272", "80.16803", "Asia/Kolkata"),
("1271346", "Ghatal", "", "IN", "356", "28", "", "", "", "22.66244", "87.73399", "Asia/Kolkata"),
("1271363", "Gharaunda", "", "IN", "356", "10", "", "", "", "29.53851", "76.97116", "Asia/Kolkata"),
("1271413", "Gevrai", "", "IN", "356", "16", "", "", "", "19.26372", "75.75006", "Asia/Kolkata"),
("1271439", "Gaya", "", "IN", "356", "34", "", "", "", "24.79686", "85.00385", "Asia/Kolkata"),
("1271453", "Gauripur", "", "IN", "356", "03", "", "", "", "26.08334", "89.96118", "Asia/Kolkata"),
("1271459", "Gauribidanur", "", "IN", "356", "19", "", "", "", "13.61072", "77.51738", "Asia/Kolkata"),
("1271476", "Guwahati", "Гувахати", "IN", "356", "03", "", "", "", "26.1844", "91.7458", "Asia/Kolkata"),
("1271493", "Garwa", "", "IN", "356", "38", "", "", "", "24.16291", "83.81037", "Asia/Kolkata"),
("1271495", "Garui", "", "IN", "356", "28", "", "", "", "22.63333", "88.4", "Asia/Kolkata"),
("1271533", "Gariadhar", "", "IN", "356", "09", "", "", "", "21.53888", "71.57737", "Asia/Kolkata"),
("1271538", "Garhshankar", "", "IN", "356", "23", "", "", "", "31.21537", "76.14149", "Asia/Kolkata"),
("1271543", "Garhmuktesar", "", "IN", "356", "36", "", "", "", "28.78659", "78.09884", "Asia/Kolkata"),
("1271563", "Garhakota", "", "IN", "356", "35", "", "", "", "23.78015", "79.1428", "Asia/Kolkata"),
("1271613", "Gannavaram", "", "IN", "356", "02", "", "", "", "16.54092", "80.80213", "Asia/Kolkata"),
("1271631", "Gangtok", "Гангток", "IN", "356", "29", "", "", "", "27.32574", "88.61216", "Asia/Kolkata"),
("1271642", "Gangolli", "", "IN", "356", "19", "", "", "", "13.65024", "74.67072", "Asia/Kolkata"),
("1271644", "Gangoh", "", "IN", "356", "36", "", "", "", "29.78027", "77.26425", "Asia/Kolkata"),
("1271662", "Gangawati", "", "IN", "356", "19", "", "", "", "15.43342", "76.5293", "Asia/Kolkata"),
("1271670", "Gangarampur", "", "IN", "356", "28", "", "", "", "25.40138", "88.52978", "Asia/Kolkata"),
("1271675", "Gangapur", "", "IN", "356", "24", "", "", "", "26.47249", "76.71744", "Asia/Kolkata"),
("1271676", "Gangapur", "", "IN", "356", "24", "", "", "", "25.21954", "74.26028", "Asia/Kolkata"),
("1271680", "Gangapur", "", "IN", "356", "16", "", "", "", "19.69718", "75.01045", "Asia/Kolkata"),
("1271685", "Ganganagar", "", "IN", "356", "24", "", "", "", "29.92008", "73.87496", "Asia/Kolkata"),
("1271688", "Gangakher", "", "IN", "356", "16", "", "", "", "18.96962", "76.74946", "Asia/Kolkata"),
("1271715", "Ghandinagar", "Гандинагар", "IN", "356", "09", "", "", "", "23.21667", "72.68333", "Asia/Kolkata"),
("1271717", "Gandhidham", "", "IN", "356", "09", "", "", "", "23.08333", "70.13333", "Asia/Kolkata"),
("1271722", "Gandevi", "", "IN", "356", "09", "", "", "", "20.81214", "72.99811", "Asia/Kolkata"),
("1271729", "Gandarbal", "", "IN", "356", "12", "", "", "", "34.22992", "74.7783", "Asia/Kolkata"),
("1271780", "Gajraula", "", "IN", "356", "36", "", "", "", "28.84463", "78.23874", "Asia/Kolkata"),
("1271789", "Gajendragarh", "", "IN", "356", "19", "", "", "", "15.73628", "75.96976", "Asia/Kolkata"),
("1271819", "Gadwal", "", "IN", "356", "02", "", "", "", "16.23504", "77.79556", "Asia/Kolkata"),
("1271834", "Gadhinglaj", "", "IN", "356", "16", "", "", "", "16.22291", "74.3501", "Asia/Kolkata"),
("1271839", "Gadhada", "", "IN", "356", "09", "", "", "", "21.96957", "71.57828", "Asia/Kolkata"),
("1271847", "Gadarwara", "", "IN", "356", "35", "", "", "", "22.92258", "78.78466", "Asia/Kolkata"),
("1271850", "Gadag", "", "IN", "356", "19", "", "", "", "15.42977", "75.62971", "Asia/Kolkata"),
("1271871", "Fort Gloster", "", "IN", "356", "28", "", "", "", "22.50444", "88.18333", "Asia/Kolkata"),
("1271874", "Forbesganj", "", "IN", "356", "34", "", "", "", "26.29857", "87.2671", "Asia/Kolkata"),
("1271881", "Firozpur Jhirka", "", "IN", "356", "10", "", "", "", "27.78913", "76.94297", "Asia/Kolkata"),
("1271883", "Firozpur", "", "IN", "356", "23", "", "", "", "30.92574", "74.61311", "Asia/Kolkata"),
("1271885", "Firozabad", "", "IN", "356", "36", "", "", "", "27.14941", "78.4018", "Asia/Kolkata"),
("1271888", "Ferokh", "", "IN", "356", "13", "", "", "", "11.17989", "75.84141", "Asia/Kolkata"),
("1271891", "Fazilka", "", "IN", "356", "23", "", "", "", "30.40207", "74.02836", "Asia/Kolkata"),
("1271892", "Fatwa", "", "IN", "356", "34", "", "", "", "25.50974", "85.30273", "Asia/Kolkata"),
("1271900", "Fatehpur Sikri", "", "IN", "356", "36", "", "", "", "27.0937", "77.66003", "Asia/Kolkata"),
("1271910", "Fatehpur", "", "IN", "356", "24", "", "", "", "27.99486", "74.95628", "Asia/Kolkata"),
("1271911", "Fatehpur", "", "IN", "356", "36", "", "", "", "27.17253", "81.21077", "Asia/Kolkata"),
("1271912", "Fatehpur", "Фатехпур", "IN", "356", "36", "", "", "", "25.93036", "80.8139", "Asia/Kolkata"),
("1271923", "Fatehgarh Churian", "", "IN", "356", "23", "", "", "", "31.8643", "74.95665", "Asia/Kolkata"),
("1271929", "Fatehganj West", "", "IN", "356", "36", "", "", "", "28.46125", "79.30418", "Asia/Kolkata"),
("1271934", "Fatehabad", "", "IN", "356", "10", "", "", "", "29.51171", "75.45515", "Asia/Kolkata"),
("1271936", "Fatehabad", "", "IN", "356", "36", "", "", "", "27.02637", "78.30297", "Asia/Kolkata"),
("1271940", "Farrukhnagar", "", "IN", "356", "02", "", "", "", "17.07788", "78.20339", "Asia/Kolkata"),
("1271942", "Farrukhabad", "", "IN", "356", "36", "", "", "", "27.39048", "79.58006", "Asia/Kolkata"),
("1271947", "Faridpur", "", "IN", "356", "36", "", "", "", "28.2091", "79.5393", "Asia/Kolkata"),
("1271949", "Faridkot", "", "IN", "356", "23", "", "", "", "30.67238", "74.75835", "Asia/Kolkata"),
("1271951", "Faridabad", "Фаридабад", "IN", "356", "10", "", "", "", "28.41252", "77.31977", "Asia/Kolkata"),
("1271954", "Farakka", "", "IN", "356", "28", "", "", "", "24.81667", "87.9", "Asia/Kolkata"),
("1271965", "Falakata", "", "IN", "356", "28", "", "", "", "26.51963", "89.20423", "Asia/Kolkata"),
("1271975", "Faizpur", "", "IN", "356", "16", "", "", "", "21.16613", "75.85862", "Asia/Kolkata"),
("1271976", "Faizabad", "Файзабад", "IN", "356", "36", "", "", "", "26.77691", "82.13292", "Asia/Kolkata"),
("1271987", "Etawah", "", "IN", "356", "36", "", "", "", "26.7778", "79.02159", "Asia/Kolkata"),
("1272008", "Erraguntla", "", "IN", "356", "02", "", "", "", "14.63853", "78.53974", "Asia/Kolkata"),
("1272013", "Erode", "Брод", "IN", "356", "25", "", "", "", "11.3428", "77.72741", "Asia/Kolkata"),
("1272022", "Erattupetta", "", "IN", "356", "13", "", "", "", "9.7", "76.78333", "Asia/Kolkata"),
("1272025", "Erandol", "", "IN", "356", "16", "", "", "", "20.92461", "75.32862", "Asia/Kolkata"),
("1272045", "Emmiganuru", "", "IN", "356", "02", "", "", "", "15.77098", "77.48325", "Asia/Kolkata"),
("1272051", "Eluru", "", "IN", "356", "02", "", "", "", "16.71084", "81.10559", "Asia/Kolkata"),
("1272052", "Elur", "", "IN", "356", "13", "", "", "", "10.06667", "76.28333", "Asia/Kolkata"),
("1272061", "Ellenabad", "", "IN", "356", "10", "", "", "", "29.45212", "74.6624", "Asia/Kolkata"),
("1272084", "Elamanchili", "", "IN", "356", "02", "", "", "", "17.54844", "82.8494", "Asia/Kolkata"),
("1272101", "Egra", "", "IN", "356", "28", "", "", "", "21.89947", "87.53794", "Asia/Kolkata"),
("1272140", "Dwarka", "Дварка", "IN", "356", "09", "", "", "", "22.23944", "68.96778", "Asia/Kolkata"),
("1272175", "Durgapur", "Дургапур", "IN", "356", "28", "", "", "", "23.49956", "87.32155", "Asia/Kolkata"),
("1272177", "Durgapur", "", "IN", "356", "16", "", "", "", "20.0048", "79.30306", "Asia/Kolkata"),
("1272181", "Durg", "", "IN", "356", "37", "", "", "", "21.18333", "81.28333", "Asia/Kolkata"),
("1272201", "Dungarpur", "", "IN", "356", "24", "", "", "", "23.84306", "73.71466", "Asia/Kolkata"),
("1272207", "Ganj Dundwara", "", "IN", "356", "36", "", "", "", "27.73356", "78.94177", "Asia/Kolkata"),
("1272225", "Dumraon", "", "IN", "356", "34", "", "", "", "25.55214", "84.15062", "Asia/Kolkata"),
("1272229", "Dumra", "", "IN", "356", "34", "", "", "", "26.56708", "85.5204", "Asia/Kolkata"),
("1272237", "Dumka", "Думка", "IN", "356", "38", "", "", "", "24.26778", "87.24855", "Asia/Kolkata"),
("1272242", "Dum Duma", "", "IN", "356", "03", "", "", "", "27.56884", "95.55664", "Asia/Kolkata"),
("1272243", "Dam Dam", "", "IN", "356", "28", "", "", "", "22.63341", "88.42286", "Asia/Kolkata"),
("1272259", "Duliagaon", "", "IN", "356", "03", "", "", "", "27.37227", "95.30754", "Asia/Kolkata"),
("1272277", "Dugda", "", "IN", "356", "38", "", "", "", "23.74516", "86.17175", "Asia/Kolkata"),
("1272320", "Dubrajpur", "", "IN", "356", "28", "", "", "", "23.7902", "87.37648", "Asia/Kolkata"),
("1272367", "Dornakal", "", "IN", "356", "02", "", "", "", "17.44475", "80.14905", "Asia/Kolkata"),
("1272375", "Doraha", "", "IN", "356", "23", "", "", "", "30.80026", "76.02276", "Asia/Kolkata"),
("1272396", "Dongargarh", "", "IN", "356", "37", "", "", "", "21.18852", "80.756", "Asia/Kolkata"),
("1272411", "Dondaicha", "", "IN", "356", "16", "", "", "", "21.32585", "74.56526", "Asia/Kolkata"),
("1272423", "Dombivli", "", "IN", "356", "16", "", "", "", "19.21667", "73.08333", "Asia/Kolkata"),
("1272473", "Dod Ballapur", "", "IN", "356", "19", "", "", "", "13.29455", "77.53745", "Asia/Kolkata"),
("1272476", "Doda", "", "IN", "356", "12", "", "", "", "33.14875", "75.54611", "Asia/Kolkata"),
("1272502", "Diu", "Диу", "IN", "356", "32", "", "", "", "20.71405", "70.98224", "Asia/Kolkata"),
("1272513", "Disa", "Дис", "IN", "356", "09", "", "", "", "24.25612", "72.17928", "Asia/Kolkata"),
("1272525", "Diphu", "", "IN", "356", "03", "", "", "", "25.84341", "93.43116", "Asia/Kolkata"),
("1272532", "Dinhata", "", "IN", "356", "28", "", "", "", "26.13526", "89.46129", "Asia/Kolkata"),
("1272540", "Dindori", "", "IN", "356", "35", "", "", "", "22.94321", "81.07781", "Asia/Kolkata"),
("1272543", "Dindigul", "Диндуккал", "IN", "356", "25", "", "", "", "10.36896", "77.98036", "Asia/Kolkata"),
("1272546", "Dinanagar", "", "IN", "356", "23", "", "", "", "32.13619", "75.47141", "Asia/Kolkata"),
("1272552", "Dimapur", "Димапур", "IN", "356", "20", "", "", "", "25.91174", "93.7217", "Asia/Kolkata"),
("1272596", "Digras", "", "IN", "356", "16", "", "", "", "20.10367", "77.71853", "Asia/Kolkata"),
("1272606", "Diglur", "", "IN", "356", "16", "", "", "", "18.5483", "77.57695", "Asia/Kolkata"),
("1272610", "Dighwara", "", "IN", "356", "34", "", "", "", "25.74359", "84.99865", "Asia/Kolkata"),
("1272629", "Digboi", "", "IN", "356", "03", "", "", "", "27.39321", "95.61839", "Asia/Kolkata"),
("1272639", "Dig", "", "IN", "356", "24", "", "", "", "27.47188", "77.32564", "Asia/Kolkata"),
("1272640", "Didwana", "", "IN", "356", "24", "", "", "", "27.40096", "74.57537", "Asia/Kolkata"),
("1272646", "Dicholi", "", "IN", "356", "33", "", "", "", "15.59319", "73.94571", "Asia/Kolkata"),
("1272648", "Dibrugarh", "Дибругарх", "IN", "356", "03", "", "", "", "27.47989", "94.90837", "Asia/Kolkata"),
("1272653", "Dibai", "", "IN", "356", "36", "", "", "", "28.20772", "78.26008", "Asia/Kolkata"),
("1272657", "Diamond Harbour", "", "IN", "356", "28", "", "", "", "22.19303", "88.18466", "Asia/Kolkata"),
("1272670", "Dhuri", "", "IN", "356", "23", "", "", "", "30.37246", "75.86185", "Asia/Kolkata"),
("1272674", "Dhupgari", "", "IN", "356", "28", "", "", "", "26.58904", "89.00732", "Asia/Kolkata"),
("1272689", "Dhulian", "", "IN", "356", "28", "", "", "", "24.68333", "87.96667", "Asia/Kolkata"),
("1272691", "Dhule", "Дхуле", "IN", "356", "16", "", "", "", "20.90251", "74.77735", "Asia/Kolkata"),
("1272694", "Dhuburi", "", "IN", "356", "03", "", "", "", "26.01856", "89.98564", "Asia/Kolkata"),
("1272699", "Dhrol", "", "IN", "356", "09", "", "", "", "22.567", "70.4177", "Asia/Kolkata"),
("1272701", "Dhrangadhra", "", "IN", "356", "09", "", "", "", "22.99167", "71.46793", "Asia/Kolkata"),
("1272720", "Dhoraji", "", "IN", "356", "09", "", "", "", "21.73359", "70.45004", "Asia/Kolkata"),
("1272722", "Dhone", "", "IN", "356", "02", "", "", "", "15.39524", "77.8731", "Asia/Kolkata"),
("1272733", "Dholka", "", "IN", "356", "09", "", "", "", "22.72732", "72.44128", "Asia/Kolkata"),
("1272768", "Dhing", "", "IN", "356", "03", "", "", "", "26.46793", "92.47336", "Asia/Kolkata"),
("1272780", "Dhenkanal", "", "IN", "356", "21", "", "", "", "20.65744", "85.59693", "Asia/Kolkata"),
("1272790", "Dhekiajuli", "", "IN", "356", "03", "", "", "", "26.70367", "92.47808", "Asia/Kolkata"),
("1272802", "Dhaurahra", "", "IN", "356", "36", "", "", "", "27.99903", "81.08909", "Asia/Kolkata"),
("1272805", "Dhaulpur", "", "IN", "356", "24", "", "", "", "26.69286", "77.87968", "Asia/Kolkata"),
("1272819", "Dharur", "", "IN", "356", "16", "", "", "", "18.82018", "76.10937", "Asia/Kolkata"),
("1272822", "Dharuhera", "", "IN", "356", "10", "", "", "", "28.20665", "76.79498", "Asia/Kolkata"),
("1272832", "Dharmsala", "Дармсала", "IN", "356", "11", "", "", "", "32.24194", "76.32133", "Asia/Kolkata"),
("1272842", "Dharmavaram", "", "IN", "356", "02", "", "", "", "14.41494", "77.71995", "Asia/Kolkata"),
("1272847", "Dharmapuri", "", "IN", "356", "25", "", "", "", "12.1277", "78.15794", "Asia/Kolkata"),
("1272852", "Dharmanagar", "", "IN", "356", "26", "", "", "", "24.36667", "92.16667", "Asia/Kolkata"),
("1272856", "Dharmadam", "", "IN", "356", "13", "", "", "", "11.78333", "75.43333", "Asia/Kolkata"),
("1272857", "Dharmabad", "", "IN", "356", "16", "", "", "", "18.89116", "77.8494", "Asia/Kolkata"),
("1272860", "Dhariwal", "", "IN", "356", "23", "", "", "", "31.95504", "75.32172", "Asia/Kolkata"),
("1272861", "Dhari", "", "IN", "356", "09", "", "", "", "21.32855", "71.02645", "Asia/Kolkata"),
("1272873", "Dharapuram", "", "IN", "356", "25", "", "", "", "10.73828", "77.53223", "Asia/Kolkata"),
("1272874", "Dharangaon", "", "IN", "356", "16", "", "", "", "21.01283", "75.27239", "Asia/Kolkata"),
("1272881", "Dharampur", "", "IN", "356", "09", "", "", "", "20.53693", "73.17368", "Asia/Kolkata"),
("1272892", "Dhar", "Дхар", "IN", "356", "35", "", "", "", "22.59373", "75.29774", "Asia/Kolkata"),
("1272962", "Dhanera", "", "IN", "356", "09", "", "", "", "24.50967", "72.02343", "Asia/Kolkata"),
("1272970", "Dhandhuka", "", "IN", "356", "09", "", "", "", "22.38185", "71.98664", "Asia/Kolkata"),
("1272979", "Dhanbad", "Дханбад", "IN", "356", "38", "", "", "", "23.80199", "86.44324", "Asia/Kolkata"),
("1272983", "Dhanaura", "", "IN", "356", "36", "", "", "", "28.95912", "78.25629", "Asia/Kolkata"),
("1272985", "Dhanaula", "", "IN", "356", "23", "", "", "", "30.28288", "75.57454", "Asia/Kolkata"),
("1272997", "Dhamtari", "", "IN", "356", "37", "", "", "", "20.70718", "81.54874", "Asia/Kolkata"),
("1273002", "Dhampur", "", "IN", "356", "36", "", "", "", "29.30604", "78.50802", "Asia/Kolkata"),
("1273006", "Dhamnod", "", "IN", "356", "35", "", "", "", "22.20928", "75.47057", "Asia/Kolkata"),
("1273043", "Dhaka", "", "IN", "356", "34", "", "", "", "26.67479", "85.16698", "Asia/Kolkata"),
("1273066", "Dewas", "", "IN", "356", "35", "", "", "", "22.96585", "76.05526", "Asia/Kolkata"),
("1273083", "Devli", "", "IN", "356", "24", "", "", "", "25.76042", "75.38093", "Asia/Kolkata"),
("1273098", "Devgarh", "", "IN", "356", "24", "", "", "", "25.52533", "73.90812", "Asia/Kolkata"),
("1273104", "Devgadh Bariya", "", "IN", "356", "09", "", "", "", "22.70517", "73.90882", "Asia/Kolkata"),
("1273109", "Devarkonda", "", "IN", "356", "02", "", "", "", "16.69186", "78.92072", "Asia/Kolkata"),
("1273123", "Devanhalli", "", "IN", "356", "19", "", "", "", "13.24729", "77.71179", "Asia/Kolkata"),
("1273128", "Devakottai", "", "IN", "356", "25", "", "", "", "9.94704", "78.8233", "Asia/Kolkata"),
("1273136", "Deulgaon Raja", "", "IN", "356", "16", "", "", "", "20.01757", "76.03755", "Asia/Kolkata"),
("1273153", "Deshnoke", "", "IN", "356", "24", "", "", "", "27.79836", "73.34297", "Asia/Kolkata"),
("1273181", "Depalpur", "", "IN", "356", "35", "", "", "", "22.85176", "75.54237", "Asia/Kolkata"),
("1273191", "Deori Khas", "", "IN", "356", "35", "", "", "", "23.39087", "79.01655", "Asia/Kolkata"),
("1273193", "Deoria", "", "IN", "356", "36", "", "", "", "26.50167", "83.77936", "Asia/Kolkata"),
("1273206", "Deoranian", "", "IN", "356", "36", "", "", "", "28.62988", "79.47648", "Asia/Kolkata"),
("1273228", "Deoli", "", "IN", "356", "16", "", "", "", "20.64898", "78.48044", "Asia/Kolkata"),
("1273232", "Deolali", "", "IN", "356", "16", "", "", "", "19.94404", "73.83441", "Asia/Kolkata"),
("1273246", "Deogarh", "", "IN", "356", "21", "", "", "", "21.53768", "84.73372", "Asia/Kolkata"),
("1273265", "Deoband", "Деобанде", "IN", "356", "36", "", "", "", "29.69291", "77.67778", "Asia/Kolkata"),
("1273272", "Denkanikota", "", "IN", "356", "25", "", "", "", "12.5301", "77.78887", "Asia/Kolkata"),
("1273294", "Delhi", "Дели", "IN", "356", "07", "", "", "", "28.65381", "77.22897", "Asia/Kolkata"),
("1273309", "Dehri", "", "IN", "356", "34", "1258074", "", "", "24.90504", "84.18289", "Asia/Kolkata"),
("1273313", "Dehradun", "Дехрадуне", "IN", "356", "39", "", "", "", "30.32443", "78.03392", "Asia/Kolkata"),
("1273369", "Dausa", "Дауса", "IN", "356", "24", "", "", "", "26.89", "76.33584", "Asia/Kolkata"),
("1273374", "Daund", "", "IN", "356", "16", "", "", "", "18.46515", "74.58375", "Asia/Kolkata"),
("1273390", "Daudnagar", "", "IN", "356", "34", "", "", "", "25.03475", "84.40017", "Asia/Kolkata"),
("1273397", "Dattapur", "", "IN", "356", "16", "", "", "", "20.78174", "78.13979", "Asia/Kolkata"),
("1273403", "Datia", "", "IN", "356", "35", "", "", "", "25.67249", "78.45815", "Asia/Kolkata"),
("1273409", "Dataganj", "", "IN", "356", "36", "", "", "", "28.0252", "79.40528", "Asia/Kolkata"),
("1273410", "Dasua", "", "IN", "356", "23", "", "", "", "31.81565", "75.65315", "Asia/Kolkata"),
("1273416", "Dasna", "", "IN", "356", "36", "", "", "", "28.67786", "77.52071", "Asia/Kolkata"),
("1273434", "Daryapur", "", "IN", "356", "16", "", "", "", "20.9249", "77.32622", "Asia/Kolkata"),
("1273440", "Darwha", "", "IN", "356", "16", "", "", "", "20.30862", "77.7691", "Asia/Kolkata"),
("1273467", "Darjiling", "Дарджилинг", "IN", "356", "28", "", "", "", "27.03333", "88.26667", "Asia/Kolkata"),
("1273491", "Darbhanga", "Дарбханга", "IN", "356", "34", "", "", "", "26.15216", "85.89707", "Asia/Kolkata"),
("1273574", "Dandeli", "", "IN", "356", "19", "", "", "", "15.26667", "74.61667", "Asia/Kolkata"),
("1273581", "Danapur", "", "IN", "356", "34", "", "", "", "25.6368", "85.04586", "Asia/Kolkata"),
("1273587", "Damoh", "", "IN", "356", "35", "", "", "", "23.83653", "79.44134", "Asia/Kolkata"),
("1273593", "Damnagar", "", "IN", "356", "09", "", "", "", "21.69232", "71.51747", "Asia/Kolkata"),
("1273618", "Daman", "Даман", "IN", "356", "32", "", "", "", "20.41432", "72.83236", "Asia/Kolkata"),
("1273626", "Daltenganj", "", "IN", "356", "38", "", "", "", "24.04306", "84.06866", "Asia/Kolkata"),
("1273628", "Dalsingh Sarai", "", "IN", "356", "34", "", "", "", "25.66795", "85.83636", "Asia/Kolkata"),
("1273642", "Dalkola", "", "IN", "356", "28", "", "", "", "25.87576", "87.84009", "Asia/Kolkata"),
("1273665", "Dakor", "Дакор", "IN", "356", "09", "", "", "", "22.75268", "73.14967", "Asia/Kolkata"),
("1273687", "Dahod", "", "IN", "356", "09", "", "", "", "22.83188", "74.2595", "Asia/Kolkata"),
("1273704", "Dahegam", "", "IN", "356", "09", "", "", "", "23.16903", "72.82161", "Asia/Kolkata"),
("1273708", "Dahanu", "", "IN", "356", "16", "", "", "", "19.96778", "72.71263", "Asia/Kolkata"),
("1273724", "Dadri", "", "IN", "356", "36", "", "", "", "28.55315", "77.55343", "Asia/Kolkata"),
("1273745", "Dabwali", "", "IN", "356", "10", "", "", "", "29.94878", "74.73707", "Asia/Kolkata"),
("1273751", "Dabra", "", "IN", "356", "35", "", "", "", "25.89696", "78.32938", "Asia/Kolkata"),
("1273756", "Daboh", "", "IN", "356", "35", "", "", "", "26.00239", "78.87658", "Asia/Kolkata"),
("1273766", "Dabhoi", "", "IN", "356", "09", "", "", "", "22.18333", "73.43333", "Asia/Kolkata"),
("1273780", "Cuttack", "Каттаке", "IN", "356", "21", "", "", "", "20.46497", "85.87927", "Asia/Kolkata"),
("1273788", "Curchorem", "", "IN", "356", "33", "", "", "", "15.26349", "74.10875", "Asia/Kolkata"),
("1273793", "Cuncolim", "", "IN", "356", "33", "", "", "", "15.1773", "73.99392", "Asia/Kolkata"),
("1273795", "Cumbum", "", "IN", "356", "02", "", "", "", "15.58302", "79.10981", "Asia/Kolkata"),
("1273800", "Cuddapah", "", "IN", "356", "02", "", "", "", "14.4775", "78.82352", "Asia/Kolkata"),
("1273802", "Cuddalore", "Куддалоре", "IN", "356", "25", "", "", "", "11.74629", "79.76436", "Asia/Kolkata"),
("1273834", "Coondapoor", "", "IN", "356", "19", "", "", "", "13.63007", "74.69068", "Asia/Kolkata"),
("1273850", "Colonelganj", "", "IN", "356", "36", "", "", "", "27.13333", "81.7", "Asia/Kolkata"),
("1273856", "Colgong", "", "IN", "356", "34", "", "", "", "25.26629", "87.23327", "Asia/Kolkata"),
("1273858", "Calangute", "Калангут", "IN", "356", "33", "", "", "", "15.5439", "73.7553", "Asia/Kolkata"),
("1273865", "Coimbatore", "Коимбатур", "IN", "356", "25", "", "", "", "11.00555", "76.96612", "Asia/Kolkata"),
("1273874", "Cochin", "Кочин", "IN", "356", "13", "", "", "", "9.93988", "76.26022", "Asia/Kolkata"),
("1273880", "Clement Town", "", "IN", "356", "39", "", "", "", "30.26055", "78.01188", "Asia/Kolkata"),
("1273892", "Churu", "", "IN", "356", "24", "", "", "", "28.30415", "74.96718", "Asia/Kolkata"),
("1273909", "Churachandpur", "", "IN", "356", "17", "", "", "", "24.33353", "93.66999", "Asia/Kolkata"),
("1273923", "Chunar", "", "IN", "356", "36", "", "", "", "25.12909", "82.8836", "Asia/Kolkata"),
("1273960", "Chotila", "", "IN", "356", "09", "", "", "", "22.42347", "71.19641", "Asia/Kolkata"),
("1273992", "Chopda", "", "IN", "356", "16", "", "", "", "21.24706", "75.29819", "Asia/Kolkata"),
("1274020", "Chodavaram", "", "IN", "356", "02", "", "", "", "17.82974", "82.93769", "Asia/Kolkata"),
("1274021", "Rampachodavaram", "", "IN", "356", "02", "", "", "", "17.44088", "81.77558", "Asia/Kolkata"),
("1274032", "Chittur", "", "IN", "356", "13", "", "", "", "10.69967", "76.7471", "Asia/Kolkata"),
("1274040", "Chittaurgarh", "", "IN", "356", "24", "", "", "", "24.88963", "74.62403", "Asia/Kolkata"),
("1274043", "Chittaranjan", "Читтаранджан", "IN", "356", "28", "", "", "", "23.85681", "86.90324", "Asia/Kolkata"),
("1274056", "Chitradurga", "Читрадурга", "IN", "356", "19", "", "", "", "14.22262", "76.40038", "Asia/Kolkata"),
("1274077", "Chitapur", "", "IN", "356", "19", "", "", "", "17.12357", "77.0824", "Asia/Kolkata"),
("1274102", "Chidawa", "", "IN", "356", "24", "", "", "", "28.23937", "75.64035", "Asia/Kolkata"),
("1274106", "Chirala", "", "IN", "356", "02", "", "", "", "15.82465", "80.35206", "Asia/Kolkata"),
("1274116", "Chipurupalle", "", "IN", "356", "02", "", "", "", "18.30846", "83.56745", "Asia/Kolkata"),
("1274119", "Chiplun", "", "IN", "356", "16", "", "", "", "17.53339", "73.50936", "Asia/Kolkata"),
("1274129", "Chintamani", "Чинтамани", "IN", "356", "19", "", "", "", "13.40181", "78.05448", "Asia/Kolkata"),
("1274146", "Chinna Salem", "", "IN", "356", "25", "", "", "", "11.63325", "78.87223", "Asia/Kolkata"),
("1274151", "Chinnamanur", "", "IN", "356", "25", "", "", "", "9.83999", "77.38109", "Asia/Kolkata"),
("1274169", "Chincholi", "", "IN", "356", "19", "", "", "", "17.46483", "77.41895", "Asia/Kolkata"),
("1274195", "Chillupar", "", "IN", "356", "36", "", "", "", "26.28259", "83.50678", "Asia/Kolkata"),
("1274213", "Chilakalurupet", "", "IN", "356", "02", "", "", "", "16.08943", "80.16715", "Asia/Kolkata"),
("1274218", "Chikodi", "", "IN", "356", "19", "", "", "", "16.42898", "74.58591", "Asia/Kolkata"),
("1274219", "Chiknayakanhalli", "", "IN", "356", "19", "", "", "", "13.41609", "76.62063", "Asia/Kolkata"),
("1274220", "Chikmagalur", "", "IN", "356", "19", "", "", "", "13.32231", "75.774", "Asia/Kolkata"),
("1274237", "Chikhli", "", "IN", "356", "16", "", "", "", "20.35046", "76.25774", "Asia/Kolkata"),
("1274243", "Chik Ballapur", "", "IN", "356", "19", "", "", "", "13.43501", "77.72781", "Asia/Kolkata"),
("1274256", "Chidambaram", "Чидамбарам", "IN", "356", "25", "", "", "", "11.39907", "79.69113", "Asia/Kolkata"),
("1274265", "Chicholi", "", "IN", "356", "16", "", "", "", "21.46939", "79.70164", "Asia/Kolkata"),
("1274284", "Chhoti Sadri", "", "IN", "356", "24", "", "", "", "24.38145", "74.7012", "Asia/Kolkata"),
("1274285", "Chhota Udepur", "", "IN", "356", "09", "", "", "", "22.30401", "74.0158", "Asia/Kolkata"),
("1274304", "Chhindwara", "", "IN", "356", "35", "", "", "", "22.05795", "78.93763", "Asia/Kolkata"),
("1274315", "Chhibramau", "", "IN", "356", "36", "", "", "", "27.14753", "79.49979", "Asia/Kolkata"),
("1274337", "Chhatarpur", "", "IN", "356", "35", "", "", "", "24.91422", "79.5878", "Asia/Kolkata"),
("1274342", "Chhatapur", "", "IN", "356", "34", "", "", "", "26.22268", "87.00346", "Asia/Kolkata"),
("1274343", "Chhata", "", "IN", "356", "36", "", "", "", "27.72352", "77.50945", "Asia/Kolkata"),
("1274346", "Chharra", "", "IN", "356", "36", "", "", "", "27.92458", "78.40092", "Asia/Kolkata"),
("1274351", "Chhaprauli", "", "IN", "356", "36", "", "", "", "29.21067", "77.17347", "Asia/Kolkata"),
("1274353", "Chhapra", "", "IN", "356", "34", "", "", "", "25.781", "84.73089", "Asia/Kolkata"),
("1274359", "Chhapar", "", "IN", "356", "24", "", "", "", "27.819", "74.43936", "Asia/Kolkata"),
("1274369", "Chhala", "", "IN", "356", "09", "", "", "", "23.30779", "72.77404", "Asia/Kolkata"),
("1274381", "Chhabra", "", "IN", "356", "24", "", "", "", "24.66472", "76.84379", "Asia/Kolkata"),
("1274389", "Chettipalaiyam", "", "IN", "356", "25", "", "", "", "10.91209", "77.03762", "Asia/Kolkata"),
("1274394", "Chetput", "", "IN", "356", "25", "", "", "", "13.07", "80.24083", "Asia/Kolkata"),
("1274422", "Chennimalai", "", "IN", "356", "25", "", "", "", "11.16394", "77.60414", "Asia/Kolkata"),
("1274428", "Chengannur", "", "IN", "356", "13", "", "", "", "9.31575", "76.61513", "Asia/Kolkata"),
("1274429", "Chengam", "", "IN", "356", "25", "", "", "", "12.30889", "78.79137", "Asia/Kolkata"),
("1274430", "Chengalpattu", "", "IN", "356", "25", "", "", "", "12.69274", "79.9773", "Asia/Kolkata"),
("1274468", "Chavakkad", "", "IN", "356", "13", "", "", "", "10.53333", "76.05", "Asia/Kolkata"),
("1274532", "Chaksu", "", "IN", "356", "24", "", "", "", "26.6051", "75.94814", "Asia/Kolkata"),
("1274533", "Chatrapur", "", "IN", "356", "21", "", "", "", "19.35574", "84.98359", "Asia/Kolkata"),
("1274536", "Chatra", "", "IN", "356", "38", "", "", "", "24.20376", "84.87032", "Asia/Kolkata"),
("1274553", "Chas", "Час", "IN", "356", "38", "", "", "", "23.63556", "86.16712", "Asia/Kolkata"),
("1274560", "Charthawal", "", "IN", "356", "36", "", "", "", "29.54717", "77.5937", "Asia/Kolkata"),
("1274571", "Charkhi Dadri", "", "IN", "356", "10", "", "", "", "28.5963", "76.27092", "Asia/Kolkata"),
("1274574", "Charkhari", "", "IN", "356", "36", "", "", "", "25.40139", "79.75045", "Asia/Kolkata"),
("1274618", "Chapar", "", "IN", "356", "03", "", "", "", "26.27266", "90.44556", "Asia/Kolkata"),
("1274640", "Channarayapatna", "", "IN", "356", "19", "", "", "", "12.90648", "76.38829", "Asia/Kolkata"),
("1274641", "Channapatna", "", "IN", "356", "19", "", "", "", "12.65481", "77.20495", "Asia/Kolkata"),
("1274642", "Channagiri", "", "IN", "356", "19", "", "", "", "14.02399", "75.92577", "Asia/Kolkata"),
("1274664", "Changanacheri", "", "IN", "356", "13", "", "", "", "9.44203", "76.53604", "Asia/Kolkata"),
("1274673", "Chandvad", "", "IN", "356", "16", "", "", "", "20.33045", "74.24439", "Asia/Kolkata"),
("1274674", "Chandur Bazar", "", "IN", "356", "16", "", "", "", "21.2391", "77.74703", "Asia/Kolkata"),
("1274675", "Chandur", "", "IN", "356", "16", "", "", "", "20.81389", "77.98001", "Asia/Kolkata"),
("1274676", "Chandur", "", "IN", "356", "16", "", "", "", "19.73436", "79.17089", "Asia/Kolkata"),
("1274693", "Chandrapur", "Чандрапур", "IN", "356", "16", "", "", "", "19.94711", "79.29607", "Asia/Kolkata"),
("1274699", "Chandrakona", "", "IN", "356", "28", "", "", "", "22.73333", "87.51667", "Asia/Kolkata"),
("1274714", "Chandpur", "", "IN", "356", "36", "", "", "", "29.13506", "78.26887", "Asia/Kolkata"),
("1274746", "Chandigarh", "Чандигарх", "IN", "356", "05", "", "", "", "30.73629", "76.7884", "Asia/Kolkata"),
("1274755", "Chanderi", "Чандери", "IN", "356", "35", "", "", "", "24.71514", "78.1376", "Asia/Kolkata"),
("1274767", "Chandausi", "", "IN", "356", "36", "", "", "", "28.45302", "78.78295", "Asia/Kolkata"),
("1274770", "Chandauli", "", "IN", "356", "36", "", "", "", "25.25716", "83.26787", "Asia/Kolkata"),
("1274784", "Chandannagar", "Чанданнагар", "IN", "356", "28", "", "", "", "22.86225", "88.36796", "Asia/Kolkata"),
("1274807", "Chanasma", "", "IN", "356", "09", "", "", "", "23.71472", "72.11279", "Asia/Kolkata"),
("1274821", "Chamrajnagar", "", "IN", "356", "19", "", "", "", "11.92312", "76.93949", "Asia/Kolkata"),
("1274837", "Champa", "", "IN", "356", "37", "", "", "", "22.03593", "82.64248", "Asia/Kolkata"),
("1274848", "Chamba", "", "IN", "356", "11", "", "", "", "32.5558", "76.12592", "Asia/Kolkata"),
("1274861", "Challapalle", "", "IN", "356", "02", "", "", "", "16.11756", "80.93139", "Asia/Kolkata"),
("1274862", "Challakere", "", "IN", "356", "19", "", "", "", "14.31199", "76.65141", "Asia/Kolkata"),
("1274868", "Chalisgaon", "", "IN", "356", "16", "", "", "", "20.46317", "75.01213", "Asia/Kolkata"),
("1274874", "Chalala", "", "IN", "356", "09", "", "", "", "21.41073", "71.16621", "Asia/Kolkata"),
("1274890", "Chakradharpur", "", "IN", "356", "38", "", "", "", "22.67626", "85.62906", "Asia/Kolkata"),
("1274896", "Chaklasi", "", "IN", "356", "09", "", "", "", "22.6532", "72.94497", "Asia/Kolkata"),
("1274899", "Chakia", "", "IN", "356", "34", "", "", "", "26.41598", "85.04665", "Asia/Kolkata"),
("1274914", "Chakan", "", "IN", "356", "16", "", "", "", "18.76059", "73.86351", "Asia/Kolkata"),
("1274928", "Chaibasa", "", "IN", "356", "38", "", "", "", "22.54825", "85.80458", "Asia/Kolkata"),
("1274984", "Canning", "", "IN", "356", "28", "", "", "", "22.31453", "88.66248", "Asia/Kolkata"),
("1274987", "Cannanore", "Кананорском", "IN", "356", "13", "", "", "", "11.86752", "75.35763", "Asia/Kolkata"),
("1275004", "Kolkata", "Колката", "IN", "356", "28", "", "", "", "22.56263", "88.36304", "Asia/Kolkata"),
("1275016", "Byadgi", "", "IN", "356", "19", "", "", "", "14.67325", "75.4868", "Asia/Kolkata"),
("1275019", "Buxar", "", "IN", "356", "34", "", "", "", "25.57473", "83.97867", "Asia/Kolkata"),
("1275050", "Burla", "", "IN", "356", "21", "", "", "", "21.5", "83.86667", "Asia/Kolkata"),
("1275066", "Burhar", "", "IN", "356", "35", "", "", "", "23.21494", "81.53204", "Asia/Kolkata"),
("1275068", "Burhanpur", "", "IN", "356", "35", "", "", "", "21.30898", "76.22996", "Asia/Kolkata"),
("1275097", "Bundu", "", "IN", "356", "38", "", "", "", "23.16139", "85.58925", "Asia/Kolkata"),
("1275103", "Bundi", "Бунди", "IN", "356", "24", "", "", "", "25.43855", "75.63735", "Asia/Kolkata"),
("1275117", "Buldana", "", "IN", "356", "16", "", "", "", "20.52932", "76.18457", "Asia/Kolkata"),
("1275120", "Bulandshahr", "Буландшахре", "IN", "356", "36", "", "", "", "28.40296", "77.85824", "Asia/Kolkata"),
("1275147", "Budhlada", "", "IN", "356", "23", "", "", "", "29.92799", "75.56205", "Asia/Kolkata"),
("1275152", "Budhana", "", "IN", "356", "36", "", "", "", "29.28889", "77.47401", "Asia/Kolkata"),
("1275163", "Budaun", "", "IN", "356", "36", "", "", "", "28.0362", "79.12631", "Asia/Kolkata"),
("1275194", "Brajarajnagar", "", "IN", "356", "21", "", "", "", "21.81667", "83.91667", "Asia/Kolkata"),
("1275198", "Brahmapur", "Берхампур", "IN", "356", "21", "", "", "", "19.31151", "84.7929", "Asia/Kolkata"),
("1275218", "Botad", "", "IN", "356", "09", "", "", "", "22.16917", "71.66671", "Asia/Kolkata"),
("1275230", "Borsad", "", "IN", "356", "09", "", "", "", "22.40788", "72.89817", "Asia/Kolkata"),
("1275248", "Borivli", "", "IN", "356", "16", "", "", "", "19.23496", "72.85976", "Asia/Kolkata"),
("1275321", "Bongaigaon", "", "IN", "356", "03", "", "", "", "26.47703", "90.55815", "Asia/Kolkata"),
("1275339", "Mumbai", "Мумбаи", "IN", "356", "16", "8131499", "", "", "19.07283", "72.88261", "Asia/Kolkata"),
("1275346", "Bolpur", "", "IN", "356", "28", "", "", "", "23.66278", "87.69695", "Asia/Kolkata"),
("1275362", "Bokaro", "Бокаро", "IN", "356", "38", "", "", "", "23.78732", "85.95622", "Asia/Kolkata"),
("1275364", "Bokajan", "", "IN", "356", "03", "", "", "", "26.02131", "93.77945", "Asia/Kolkata"),
("1275368", "Boisar", "", "IN", "356", "16", "", "", "", "19.80362", "72.75598", "Asia/Kolkata"),
("1275388", "Bodinayakkanur", "", "IN", "356", "25", "", "", "", "10.01171", "77.34976", "Asia/Kolkata"),
("1275389", "Bodh Gaya", "Бодх-Гая", "IN", "356", "34", "", "", "", "24.69794", "84.99213", "Asia/Kolkata"),
("1275391", "Bodhan", "", "IN", "356", "02", "", "", "", "18.66208", "77.88581", "Asia/Kolkata"),
("1275406", "Bobbili", "", "IN", "356", "02", "", "", "", "18.57351", "83.35899", "Asia/Kolkata"),
("1275435", "Biswan", "", "IN", "356", "36", "", "", "", "27.49672", "80.99688", "Asia/Kolkata"),
("1275441", "Bissau", "Бисау", "IN", "356", "24", "", "", "", "28.24718", "75.07606", "Asia/Kolkata"),
("1275462", "Bishnupur", "Бишнупур", "IN", "356", "28", "", "", "", "23.0738", "87.31991", "Asia/Kolkata"),
("1275476", "Bisauli", "", "IN", "356", "36", "", "", "", "28.30822", "78.93661", "Asia/Kolkata"),
("1275481", "Bisalpur", "", "IN", "356", "36", "", "", "", "28.29187", "79.80307", "Asia/Kolkata"),
("1275488", "Birur", "", "IN", "356", "19", "", "", "", "13.59723", "75.97167", "Asia/Kolkata"),
("1275499", "Birpur", "", "IN", "356", "34", "", "", "", "26.50823", "87.01194", "Asia/Kolkata"),
("1275506", "Birmitrapur", "", "IN", "356", "21", "", "", "", "22.4", "84.76667", "Asia/Kolkata"),
("1275558", "Binika", "", "IN", "356", "21", "", "", "", "21.03333", "83.8", "Asia/Kolkata"),
("1275572", "Bindki", "", "IN", "356", "36", "", "", "", "26.03613", "80.57617", "Asia/Kolkata"),
("1275582", "Etawa", "", "IN", "356", "35", "", "", "", "24.18386", "78.20128", "Asia/Kolkata"),
("1275589", "Belthara", "", "IN", "356", "36", "", "", "", "26.12747", "83.89078", "Asia/Kolkata"),
("1275590", "Bilsi", "", "IN", "356", "36", "", "", "", "28.13073", "78.91055", "Asia/Kolkata"),
("1275593", "Bilsanda", "", "IN", "356", "36", "", "", "", "28.24246", "79.95182", "Asia/Kolkata"),
("1275610", "Bilimora", "", "IN", "356", "09", "", "", "", "20.76957", "72.96134", "Asia/Kolkata"),
("1275614", "Bilhaur", "", "IN", "356", "36", "", "", "", "26.84345", "80.06388", "Asia/Kolkata"),
("1275618", "Bilgram", "", "IN", "356", "36", "", "", "", "27.17503", "80.03172", "Asia/Kolkata"),
("1275619", "Bilgi", "", "IN", "356", "19", "", "", "", "16.34714", "75.61804", "Asia/Kolkata"),
("1275634", "Bilaspur", "", "IN", "356", "36", "", "", "", "28.8869", "79.26663", "Asia/Kolkata"),
("1275637", "Bilaspur", "Биласпура", "IN", "356", "37", "", "", "", "22.07402", "82.1566", "Asia/Kolkata"),
("1275641", "Bilasipara", "", "IN", "356", "03", "", "", "", "26.23285", "90.2341", "Asia/Kolkata"),
("1275646", "Bilari", "", "IN", "356", "36", "", "", "", "28.62163", "78.80314", "Asia/Kolkata"),
("1275647", "Bilara", "", "IN", "356", "24", "", "", "", "26.18048", "73.70569", "Asia/Kolkata"),
("1275655", "Bikramganj", "", "IN", "356", "34", "", "", "", "25.21262", "84.25409", "Asia/Kolkata"),
("1275665", "Bikaner", "Биканер", "IN", "356", "24", "", "", "", "28.02094", "73.30749", "Asia/Kolkata"),
("1275679", "Bijnor", "Биджнор", "IN", "356", "36", "", "", "", "29.37219", "78.13632", "Asia/Kolkata"),
("1275692", "Bijbiara", "", "IN", "356", "12", "", "", "", "33.79403", "75.10679", "Asia/Kolkata"),
("1275694", "Bijawar", "", "IN", "356", "35", "", "", "", "24.62625", "79.49243", "Asia/Kolkata"),
("1275701", "Bijapur", "Биджапур", "IN", "356", "19", "", "", "", "16.82442", "75.71537", "Asia/Kolkata"),
("1275716", "Bihar Sharif", "", "IN", "356", "34", "", "", "", "25.19729", "85.52374", "Asia/Kolkata"),
("1275719", "Bihariganj", "", "IN", "356", "34", "", "", "", "25.73414", "86.98837", "Asia/Kolkata"),
("1275732", "Bidhuna", "", "IN", "356", "36", "", "", "", "26.80172", "79.50829", "Asia/Kolkata"),
("1275738", "Bidar", "Бидар", "IN", "356", "19", "", "", "", "17.91331", "77.5301", "Asia/Kolkata"),
("1275762", "Biaora", "", "IN", "356", "35", "", "", "", "23.86667", "76.91667", "Asia/Kolkata"),
("1275768", "Bhuvanagiri", "", "IN", "356", "25", "", "", "", "11.44154", "79.64568", "Asia/Kolkata"),
("1275778", "Bhusawal", "", "IN", "356", "16", "", "", "", "21.04658", "75.78175", "Asia/Kolkata"),
("1275804", "Bhum", "", "IN", "356", "16", "", "", "", "18.45908", "75.65877", "Asia/Kolkata"),
("1275812", "Bhuj", "Бхудж", "IN", "356", "09", "", "", "", "23.25397", "69.66928", "Asia/Kolkata"),
("1275814", "Bhudgaon", "", "IN", "356", "16", "", "", "", "16.90742", "74.59954", "Asia/Kolkata"),
("1275817", "Bhubaneshwar", "Бхубанешвар", "IN", "356", "21", "7644927", "", "", "20.27241", "85.83385", "Asia/Kolkata"),
("1275818", "Bhuban", "", "IN", "356", "21", "", "", "", "20.88197", "85.83334", "Asia/Kolkata"),
("1275836", "Bhor", "", "IN", "356", "16", "", "", "", "18.14861", "73.84336", "Asia/Kolkata"),
("1275841", "Bhopal", "Бхопал", "IN", "356", "35", "", "", "", "23.25469", "77.40289", "Asia/Kolkata"),
("1275848", "Bhongir", "", "IN", "356", "02", "", "", "", "17.51544", "78.88563", "Asia/Kolkata"),
("1275849", "Bhongaon", "", "IN", "356", "36", "", "", "", "27.25579", "79.18073", "Asia/Kolkata"),
("1275882", "Bhogpur", "", "IN", "356", "23", "", "", "", "31.55442", "75.64271", "Asia/Kolkata"),
("1275899", "Bhiwani", "", "IN", "356", "10", "", "", "", "28.79194", "76.14108", "Asia/Kolkata"),
("1275901", "Bhiwandi", "", "IN", "356", "16", "", "", "", "19.30023", "73.05881", "Asia/Kolkata"),
("1275905", "Bhitarwar", "", "IN", "356", "35", "", "", "", "25.79239", "78.11077", "Asia/Kolkata"),
("1275920", "Bhinmal", "", "IN", "356", "24", "", "", "", "24.99944", "72.27141", "Asia/Kolkata"),
("1275921", "Bhinga", "", "IN", "356", "36", "", "", "", "27.70354", "81.93417", "Asia/Kolkata"),
("1275925", "Bhindar", "", "IN", "356", "24", "", "", "", "24.50415", "74.18595", "Asia/Kolkata"),
("1275926", "Bhind", "", "IN", "356", "35", "", "", "", "26.56672", "78.78728", "Asia/Kolkata"),
("1275930", "Bhimunipatnam", "", "IN", "356", "02", "", "", "", "17.89017", "83.45203", "Asia/Kolkata"),
("1275947", "Bhimavaram", "", "IN", "356", "02", "", "", "", "16.54078", "81.52322", "Asia/Kolkata"),
("1275960", "Bhilwara", "", "IN", "356", "24", "", "", "", "25.34644", "74.63523", "Asia/Kolkata"),
("1275971", "Bhilai", "Бхилаи", "IN", "356", "37", "", "", "", "21.21667", "81.43333", "Asia/Kolkata"),
("1275977", "Bhikhi", "", "IN", "356", "23", "", "", "", "30.06114", "75.53433", "Asia/Kolkata"),
("1275978", "Bhikangaon", "", "IN", "356", "35", "", "", "", "21.86694", "75.96561", "Asia/Kolkata"),
("1276013", "Bhayavadar", "", "IN", "356", "09", "", "", "", "21.85523", "70.24791", "Asia/Kolkata"),
("1276014", "Bhayandar", "", "IN", "356", "16", "", "", "", "19.30157", "72.85107", "Asia/Kolkata"),
("1276023", "Bhawanipatna", "", "IN", "356", "21", "", "", "", "19.90765", "83.16858", "Asia/Kolkata"),
("1276026", "Bhawanigarh", "", "IN", "356", "23", "", "", "", "30.2666", "76.03695", "Asia/Kolkata"),
("1276027", "Bhawaniganj", "", "IN", "356", "35", "", "", "", "24.41582", "75.83552", "Asia/Kolkata"),
("1276032", "Bhavnagar", "Бхавнагаром", "IN", "356", "09", "", "", "", "21.77446", "72.1525", "Asia/Kolkata"),
("1276037", "Bhavani", "", "IN", "356", "25", "", "", "", "11.44713", "77.68424", "Asia/Kolkata"),
("1276054", "Bhattiprolu", "", "IN", "356", "02", "", "", "", "16.1026", "80.78074", "Asia/Kolkata"),
("1276058", "Bhatpara", "", "IN", "356", "28", "", "", "", "22.86643", "88.40113", "Asia/Kolkata"),
("1276067", "Bhatkal", "", "IN", "356", "19", "", "", "", "13.98194", "74.55498", "Asia/Kolkata"),
("1276070", "Bhatinda", "", "IN", "356", "23", "", "", "", "30.20712", "74.9414", "Asia/Kolkata"),
("1276084", "Bhatapara", "", "IN", "356", "37", "", "", "", "21.73333", "81.93333", "Asia/Kolkata"),
("1276092", "Bhasawar", "", "IN", "356", "24", "", "", "", "27.03895", "77.04849", "Asia/Kolkata"),
("1276095", "Bharwari", "", "IN", "356", "36", "", "", "", "25.5606", "81.49174", "Asia/Kolkata"),
("1276100", "Bharuch", "", "IN", "356", "09", "", "", "", "21.69482", "72.9805", "Asia/Kolkata"),
("1276103", "Bharthana", "", "IN", "356", "36", "", "", "", "26.75367", "79.22263", "Asia/Kolkata"),
("1276128", "Bharatpur", "Бхаратпур", "IN", "356", "24", "", "", "", "27.21731", "77.49009", "Asia/Kolkata"),
("1276147", "Bhanvad", "", "IN", "356", "09", "", "", "", "21.93053", "69.7808", "Asia/Kolkata"),
("1276151", "Bhanpuri", "", "IN", "356", "37", "", "", "", "21.09214", "80.93121", "Asia/Kolkata"),
("1276152", "Bhanpura", "", "IN", "356", "35", "", "", "", "24.513", "75.7469", "Asia/Kolkata"),
("1276159", "Bhanjanagar", "", "IN", "356", "21", "", "", "", "19.92719", "84.58201", "Asia/Kolkata"),
("1276178", "Bhander", "", "IN", "356", "35", "", "", "", "25.73533", "78.74576", "Asia/Kolkata"),
("1276191", "Bhandara", "Бхандара", "IN", "356", "16", "", "", "", "21.16667", "79.65", "Asia/Kolkata"),
("1276219", "Bhalki", "", "IN", "356", "19", "", "", "", "18.04348", "77.206", "Asia/Kolkata"),
("1276249", "Bhaisa", "", "IN", "356", "02", "", "", "", "19.11285", "77.96336", "Asia/Kolkata"),
("1276265", "Bhainsdehi", "", "IN", "356", "35", "", "", "", "21.64498", "77.63072", "Asia/Kolkata"),
("1276300", "Bhagalpur", "", "IN", "356", "34", "", "", "", "25.24446", "86.97183", "Asia/Kolkata"),
("1276320", "Bhadreswar", "", "IN", "356", "28", "", "", "", "22.82449", "88.33842", "Asia/Kolkata"),
("1276321", "Bhadravati", "", "IN", "356", "19", "", "", "", "13.84846", "75.70502", "Asia/Kolkata"),
("1276325", "Bhadrakh", "", "IN", "356", "21", "", "", "", "21.05447", "86.5156", "Asia/Kolkata"),
("1276328", "Bhadrachalam", "", "IN", "356", "02", "", "", "", "17.66846", "80.88888", "Asia/Kolkata"),
("1276330", "Bhadra", "Бхадра", "IN", "356", "24", "", "", "", "29.10298", "75.17138", "Asia/Kolkata"),
("1276335", "Bhadohi", "", "IN", "356", "36", "", "", "", "25.3949", "82.56636", "Asia/Kolkata"),
("1276353", "Bhadaur", "", "IN", "356", "23", "", "", "", "30.47534", "75.33011", "Asia/Kolkata"),
("1276355", "Bhadasar", "", "IN", "356", "24", "", "", "", "28.31506", "74.28836", "Asia/Kolkata"),
("1276370", "Bhachau", "", "IN", "356", "09", "", "", "", "23.29858", "70.34279", "Asia/Kolkata"),
("1276371", "Bhabua", "", "IN", "356", "34", "", "", "", "25.04133", "83.60789", "Asia/Kolkata"),
("1276378", "Beypore", "", "IN", "356", "13", "", "", "", "11.17151", "75.80611", "Asia/Kolkata"),
("1276381", "Bewar", "", "IN", "356", "36", "", "", "", "27.21818", "79.2983", "Asia/Kolkata"),
("1276389", "Betul", "", "IN", "356", "35", "", "", "", "21.90195", "77.90405", "Asia/Kolkata"),
("1276393", "Bettiah", "", "IN", "356", "34", "", "", "", "26.8024", "84.49873", "Asia/Kolkata"),
("1276416", "Betamcherla", "", "IN", "356", "02", "", "", "", "15.45185", "78.14611", "Asia/Kolkata"),
("1276437", "Beri Khas", "", "IN", "356", "10", "", "", "", "28.70266", "76.57831", "Asia/Kolkata"),
("1276449", "Berasia", "", "IN", "356", "35", "", "", "", "23.63134", "77.43351", "Asia/Kolkata"),
("1276455", "Beohari", "", "IN", "356", "35", "", "", "", "24.02335", "81.37812", "Asia/Kolkata"),
("1276478", "Bemetara", "", "IN", "356", "37", "", "", "", "21.7", "81.53333", "Asia/Kolkata"),
("1276486", "Belur", "Белур", "IN", "356", "19", "", "", "", "13.16558", "75.86519", "Asia/Kolkata"),
("1276495", "Belsand", "", "IN", "356", "34", "", "", "", "26.44365", "85.40076", "Asia/Kolkata"),
("1276502", "Belonia", "", "IN", "356", "26", "", "", "", "23.25178", "91.45407", "Asia/Kolkata"),
("1276509", "Bellary", "Беллари", "IN", "356", "19", "", "", "", "15.14575", "76.91751", "Asia/Kolkata"),
("1276533", "Belgaum", "Белгаум", "IN", "356", "19", "", "", "", "15.85212", "74.50447", "Asia/Kolkata"),
("1276548", "Beldanga", "", "IN", "356", "28", "", "", "", "23.93428", "88.26018", "Asia/Kolkata"),
("1276574", "Bela", "Бела", "IN", "356", "36", "", "", "", "25.92104", "81.99909", "Asia/Kolkata"),
("1276589", "Behror", "", "IN", "356", "24", "", "", "", "27.88832", "76.28108", "Asia/Kolkata"),
("1276600", "Behat", "", "IN", "356", "36", "", "", "", "30.1705", "77.61532", "Asia/Kolkata"),
("1276609", "Begusarai", "", "IN", "356", "34", "", "", "", "25.41853", "86.1339", "Asia/Kolkata"),
("1276615", "Begun", "Бегун", "IN", "356", "24", "", "", "", "24.98333", "75", "Asia/Kolkata"),
("1276621", "Begamganj", "", "IN", "356", "35", "", "", "", "23.60134", "78.33976", "Asia/Kolkata"),
("1276627", "Bedi", "Беда", "IN", "356", "09", "", "", "", "22.50143", "70.04363", "Asia/Kolkata"),
("1276634", "Beawar", "", "IN", "356", "24", "", "", "", "26.10119", "74.32028", "Asia/Kolkata"),
("1276642", "Bazpur", "", "IN", "356", "39", "", "", "", "29.15299", "79.1064", "Asia/Kolkata"),
("1276652", "Bayana", "Баян", "IN", "356", "24", "", "", "", "26.90791", "77.28985", "Asia/Kolkata"),
("1276663", "Bawana", "", "IN", "356", "07", "", "", "", "28.80059", "77.03473", "Asia/Kolkata"),
("1276686", "Bauda", "", "IN", "356", "21", "", "", "", "20.83333", "84.31667", "Asia/Kolkata"),
("1276720", "Batala", "", "IN", "356", "23", "", "", "", "31.81861", "75.20278", "Asia/Kolkata"),
("1276724", "Baswa", "", "IN", "356", "24", "", "", "", "27.14955", "76.58345", "Asia/Kolkata"),
("1276731", "Basudebpur", "", "IN", "356", "21", "", "", "", "21.11974", "86.72896", "Asia/Kolkata"),
("1276736", "Basti", "Басти", "IN", "356", "36", "", "", "", "26.79446", "82.73285", "Asia/Kolkata"),
("1276752", "Basoda", "", "IN", "356", "35", "", "", "", "23.85153", "77.93652", "Asia/Kolkata"),
("1276754", "Basni", "Басни", "IN", "356", "24", "", "", "", "27.17232", "73.64519", "Asia/Kolkata"),
("1276757", "Basmat", "", "IN", "356", "16", "", "", "", "19.32872", "77.15746", "Asia/Kolkata"),
("1276764", "Basi", "", "IN", "356", "23", "", "", "", "30.69001", "76.40154", "Asia/Kolkata"),
("1276765", "Basi", "", "IN", "356", "23", "", "", "", "30.5883", "76.84389", "Asia/Kolkata"),
("1276767", "Basi", "", "IN", "356", "24", "", "", "", "26.8315", "76.04856", "Asia/Kolkata"),
("1276782", "Basavana Bagevadi", "", "IN", "356", "19", "", "", "", "16.57278", "75.97252", "Asia/Kolkata"),
("1276783", "Basavakalyan", "", "IN", "356", "19", "", "", "", "17.87445", "76.94972", "Asia/Kolkata"),
("1276810", "Barwani", "", "IN", "356", "35", "", "", "", "22.03261", "74.89808", "Asia/Kolkata"),
("1276815", "Barwala", "", "IN", "356", "10", "", "", "", "29.3666", "75.90669", "Asia/Kolkata"),
("1276829", "Baruni", "Баруни", "IN", "356", "34", "", "", "", "25.47446", "85.96681", "Asia/Kolkata"),
("1276832", "Baruipur", "", "IN", "356", "28", "", "", "", "22.35253", "88.43882", "Asia/Kolkata"),
("1276856", "Barsi", "", "IN", "356", "16", "", "", "", "18.23454", "75.69275", "Asia/Kolkata"),
("1276867", "Barpeta", "", "IN", "356", "03", "", "", "", "26.32292", "91.00632", "Asia/Kolkata"),
("1276870", "Barpali", "", "IN", "356", "21", "", "", "", "21.2", "83.58333", "Asia/Kolkata"),
("1276895", "Barnala", "Барнала", "IN", "356", "23", "", "", "", "30.37205", "75.54537", "Asia/Kolkata"),
("1276901", "Barmer", "", "IN", "356", "24", "", "", "", "25.74572", "71.39211", "Asia/Kolkata"),
("1276919", "Barki Saria", "", "IN", "356", "38", "", "", "", "24.17543", "85.89077", "Asia/Kolkata"),
("1276927", "Barka Kana", "", "IN", "356", "38", "", "", "", "23.62199", "85.46714", "Asia/Kolkata"),
("1276938", "Barjala", "", "IN", "356", "26", "", "", "", "23.6182", "91.35596", "Asia/Kolkata"),
("1276939", "Bari Sadri", "", "IN", "356", "24", "", "", "", "24.41339", "74.47331", "Asia/Kolkata"),
("1276948", "Bari", "", "IN", "356", "24", "", "", "", "26.64661", "77.61634", "Asia/Kolkata"),
("1276954", "Barhiya", "", "IN", "356", "34", "", "", "", "25.28814", "86.02055", "Asia/Kolkata"),
("1276977", "Barh", "Барх", "IN", "356", "34", "", "", "", "25.48438", "85.71027", "Asia/Kolkata"),
("1276982", "Bargi", "", "IN", "356", "35", "", "", "", "22.99136", "79.87619", "Asia/Kolkata"),
("1276988", "Bargarh", "", "IN", "356", "21", "", "", "", "21.33333", "83.61667", "Asia/Kolkata"),
("1277013", "Bareilly", "Барейли", "IN", "356", "36", "", "", "", "28.34702", "79.42193", "Asia/Kolkata"),
("1277022", "Bardoli", "Бардоли", "IN", "356", "09", "", "", "", "21.12297", "73.11151", "Asia/Kolkata"),
("1277029", "Barddhaman", "", "IN", "356", "28", "", "", "", "23.25572", "87.85691", "Asia/Kolkata"),
("1277038", "Bar Bigha", "", "IN", "356", "34", "", "", "", "25.21855", "85.7332", "Asia/Kolkata"),
("1277044", "Baraut", "", "IN", "356", "36", "", "", "", "29.10167", "77.26242", "Asia/Kolkata"),
("1277053", "Barauli", "", "IN", "356", "34", "", "", "", "26.38149", "84.58724", "Asia/Kolkata"),
("1277065", "Barasat", "", "IN", "356", "28", "", "", "", "22.72154", "88.48198", "Asia/Kolkata"),
("1277066", "Barasat", "", "IN", "356", "28", "", "", "", "22.22516", "88.45086", "Asia/Kolkata"),
("1277082", "Baranagar", "", "IN", "356", "28", "", "", "", "22.64132", "88.37727", "Asia/Kolkata"),
("1277084", "Baran", "Баран", "IN", "356", "24", "", "", "", "25.1", "76.51667", "Asia/Kolkata"),
("1277085", "Baramula", "", "IN", "356", "12", "", "", "", "34.209", "74.34285", "Asia/Kolkata"),
("1277091", "Baramati", "Барамати", "IN", "356", "16", "", "", "", "18.15174", "74.57767", "Asia/Kolkata"),
("1277100", "Barakpur", "", "IN", "356", "28", "", "", "", "22.76602", "88.36336", "Asia/Kolkata"),
("1277183", "Bapatla", "", "IN", "356", "02", "", "", "", "15.90437", "80.4675", "Asia/Kolkata"),
("1277200", "Banur", "", "IN", "356", "23", "", "", "", "30.55375", "76.71867", "Asia/Kolkata"),
("1277201", "Bantval", "", "IN", "356", "19", "", "", "", "12.89122", "75.04097", "Asia/Kolkata"),
("1277202", "Bantva", "", "IN", "356", "09", "", "", "", "21.48816", "70.07576", "Asia/Kolkata"),
("1277214", "Banswara", "", "IN", "356", "24", "", "", "", "23.54109", "74.4425", "Asia/Kolkata"),
("1277216", "Banswada", "", "IN", "356", "02", "", "", "", "18.37725", "77.88007", "Asia/Kolkata"),
("1277232", "Bansi", "", "IN", "356", "36", "", "", "", "27.17979", "82.93409", "Asia/Kolkata"),
("1277238", "Bansdih", "", "IN", "356", "34", "", "", "", "25.88409", "84.21737", "Asia/Kolkata"),
("1277240", "Bansbaria", "", "IN", "356", "28", "", "", "", "22.95387", "88.40098", "Asia/Kolkata"),
("1277255", "Bannur", "", "IN", "356", "19", "", "", "", "12.33246", "76.86178", "Asia/Kolkata"),
("1277263", "Banmankhi", "", "IN", "356", "34", "", "", "", "25.88667", "87.19491", "Asia/Kolkata"),
("1277264", "Bankura", "Банкура", "IN", "356", "28", "", "", "", "23.23241", "87.0716", "Asia/Kolkata"),
("1277273", "Banki", "", "IN", "356", "21", "", "", "", "20.37912", "85.52952", "Asia/Kolkata"),
("1277289", "Banka", "", "IN", "356", "34", "", "", "", "24.88091", "86.92257", "Asia/Kolkata"),
("1277318", "Bangarmau", "", "IN", "356", "36", "", "", "", "26.8912", "80.21149", "Asia/Kolkata"),
("1277320", "Bangarapet", "", "IN", "356", "19", "", "", "", "12.99199", "78.17925", "Asia/Kolkata"),
("1277322", "Bangaon", "", "IN", "356", "34", "1257805", "", "", "25.86728", "86.51152", "Asia/Kolkata"),
("1277324", "Bangaon", "Бангаон", "IN", "356", "28", "", "", "", "23.04552", "88.83084", "Asia/Kolkata"),
("1277330", "Banganapalle", "", "IN", "356", "02", "", "", "", "15.31691", "78.22701", "Asia/Kolkata"),
("1277333", "Bangalore", "Бангалор", "IN", "356", "19", "", "", "", "12.97194", "77.59369", "Asia/Kolkata"),
("1277338", "Banga", "", "IN", "356", "23", "", "", "", "31.18602", "75.99643", "Asia/Kolkata"),
("1277358", "Bandipura", "", "IN", "356", "12", "", "", "", "34.41825", "74.64042", "Asia/Kolkata"),
("1277362", "Bandikui", "", "IN", "356", "24", "", "", "", "27.05087", "76.57325", "Asia/Kolkata"),
("1277397", "Banda", "", "IN", "356", "36", "", "", "", "25.47534", "80.3358", "Asia/Kolkata"),
("1277398", "Banda", "", "IN", "356", "35", "", "", "", "24.04449", "78.96163", "Asia/Kolkata"),
("1277409", "Banat", "Банат", "IN", "356", "36", "", "", "", "29.46406", "77.35306", "Asia/Kolkata"),
("1277426", "Banapur", "", "IN", "356", "21", "", "", "", "19.77889", "85.17032", "Asia/Kolkata"),
("1277442", "Bamor Kalan", "", "IN", "356", "35", "", "", "", "24.89309", "78.1513", "Asia/Kolkata"),
("1277508", "Balurghat", "", "IN", "356", "28", "", "", "", "25.22099", "88.77732", "Asia/Kolkata"),
("1277514", "Balugaon", "", "IN", "356", "21", "", "", "", "20.17811", "85.11225", "Asia/Kolkata"),
("1277525", "Balrampur", "", "IN", "356", "36", "", "", "", "27.42766", "82.1871", "Asia/Kolkata"),
("1277527", "Balotra", "", "IN", "356", "24", "", "", "", "25.83242", "72.24", "Asia/Kolkata"),
("1277530", "Baloda Bazar", "", "IN", "356", "37", "", "", "", "21.65678", "82.16062", "Asia/Kolkata"),
("1277535", "Balod", "", "IN", "356", "37", "", "", "", "20.73081", "81.20578", "Asia/Kolkata"),
("1277539", "Bali", "Бали", "IN", "356", "28", "", "", "", "22.64859", "88.34115", "Asia/Kolkata"),
("1277557", "Ballalpur", "", "IN", "356", "16", "", "", "", "19.84657", "79.34624", "Asia/Kolkata"),
("1277590", "Bali", "", "IN", "356", "24", "", "", "", "25.19725", "73.29117", "Asia/Kolkata"),
("1277599", "Balasore", "Баласор", "IN", "356", "21", "", "", "", "21.49266", "86.93348", "Asia/Kolkata"),
("1277634", "Balarampur", "", "IN", "356", "28", "", "", "", "23.09714", "86.22292", "Asia/Kolkata"),
("1277636", "Balapur", "", "IN", "356", "16", "", "", "", "20.66612", "76.77386", "Asia/Kolkata"),
("1277643", "Balangir", "", "IN", "356", "21", "", "", "", "20.70419", "83.49029", "Asia/Kolkata"),
("1277661", "Balaghat", "", "IN", "356", "35", "", "", "", "21.81667", "80.18489", "Asia/Kolkata"),
("1277666", "Balachor", "", "IN", "356", "23", "", "", "", "31.06062", "76.30166", "Asia/Kolkata"),
("1277684", "Bakhtiyarpur", "", "IN", "356", "34", "", "", "", "25.45931", "85.53301", "Asia/Kolkata"),
("1277723", "Baj Baj", "", "IN", "356", "28", "", "", "", "22.47514", "88.17767", "Asia/Kolkata"),
("1277748", "Bairagnia", "", "IN", "356", "34", "", "", "", "26.74062", "85.27323", "Asia/Kolkata"),
("1277759", "Byndoor", "", "IN", "356", "19", "", "", "", "13.86667", "74.63333", "Asia/Kolkata"),
("1277765", "Bail Hongal", "", "IN", "356", "19", "", "", "", "15.81619", "74.85752", "Asia/Kolkata"),
("1277776", "Baihar", "", "IN", "356", "35", "", "", "", "22.10176", "80.54963", "Asia/Kolkata"),
("1277780", "Baidyabati", "", "IN", "356", "28", "", "", "", "22.78498", "88.32586", "Asia/Kolkata"),
("1277799", "Bahraich", "", "IN", "356", "36", "", "", "", "27.5743", "81.59588", "Asia/Kolkata"),
("1277808", "Bahjoi", "", "IN", "356", "36", "", "", "", "28.39361", "78.62212", "Asia/Kolkata"),
("1277814", "Baheri", "", "IN", "356", "36", "", "", "", "28.77373", "79.49553", "Asia/Kolkata"),
("1277820", "Baharampur", "", "IN", "356", "28", "", "", "", "24.10473", "88.25155", "Asia/Kolkata"),
("1277835", "Bahadurgarh", "", "IN", "356", "10", "", "", "", "28.69108", "76.9316", "Asia/Kolkata"),
("1277836", "Bahadurganj", "", "IN", "356", "34", "", "", "", "26.2594", "87.82096", "Asia/Kolkata"),
("1277841", "Bah", "", "IN", "356", "36", "", "", "", "26.86991", "78.59443", "Asia/Kolkata"),
("1277844", "Bagula", "", "IN", "356", "28", "", "", "", "23.33664", "88.64109", "Asia/Kolkata"),
("1277882", "Baghpat", "", "IN", "356", "36", "", "", "", "28.94442", "77.21878", "Asia/Kolkata"),
("1277897", "Baghdogra", "", "IN", "356", "28", "", "", "", "26.69929", "88.31177", "Asia/Kolkata"),
("1277902", "Bagha Purana", "", "IN", "356", "23", "", "", "", "30.68747", "75.09572", "Asia/Kolkata"),
("1277909", "Bagepalli", "", "IN", "356", "19", "", "", "", "13.78338", "77.79667", "Asia/Kolkata"),
("1277924", "Bagasra", "", "IN", "356", "09", "", "", "", "21.48719", "70.95516", "Asia/Kolkata"),
("1277930", "Bagar", "", "IN", "356", "24", "", "", "", "28.1874", "75.5005", "Asia/Kolkata"),
("1277936", "Bagalkot", "Багалкот", "IN", "356", "19", "", "", "", "16.18673", "75.69614", "Asia/Kolkata"),
("1277939", "Bagaha", "", "IN", "356", "34", "", "", "", "27.09918", "84.09003", "Asia/Kolkata"),
("1277940", "Bagaha", "", "IN", "356", "34", "", "", "", "24.52627", "85.06094", "Asia/Kolkata"),
("1277949", "Badvel", "", "IN", "356", "02", "", "", "", "14.73959", "79.06201", "Asia/Kolkata"),
("1277950", "Baduria", "Бадурии", "IN", "356", "28", "", "", "", "22.74431", "88.78655", "Asia/Kolkata"),
("1277970", "Badnawar", "", "IN", "356", "35", "", "", "", "23.02181", "75.23268", "Asia/Kolkata"),
("1277976", "Badlapur", "", "IN", "356", "16", "", "", "", "19.15516", "73.26554", "Asia/Kolkata"),
("1278017", "Badami", "Бадами", "IN", "356", "19", "", "", "", "15.91495", "75.67683", "Asia/Kolkata"),
("1278023", "Badagara", "", "IN", "356", "13", "", "", "", "11.5964", "75.58622", "Asia/Kolkata"),
("1278026", "Bada Barabil", "", "IN", "356", "21", "", "", "", "22.11186", "85.38684", "Asia/Kolkata"),
("1278036", "Bachhraon", "", "IN", "356", "36", "", "", "", "28.92497", "78.23353", "Asia/Kolkata"),
("1278052", "Babrala", "", "IN", "356", "36", "", "", "", "28.2639", "78.40471", "Asia/Kolkata"),
("1278054", "Babra", "", "IN", "356", "09", "", "", "", "21.84577", "71.30544", "Asia/Kolkata"),
("1278058", "Babina", "Бабина", "IN", "356", "36", "", "", "", "25.24215", "78.46603", "Asia/Kolkata"),
("1278064", "Baberu", "", "IN", "356", "36", "", "", "", "25.54711", "80.70442", "Asia/Kolkata"),
("1278073", "Babai", "", "IN", "356", "35", "", "", "", "22.70256", "77.93494", "Asia/Kolkata"),
("1278083", "Azamgarh", "", "IN", "356", "36", "", "", "", "26.06758", "83.18364", "Asia/Kolkata"),
("1278094", "Ayodhya", "Айодхье", "IN", "356", "36", "", "", "", "26.79958", "82.20414", "Asia/Kolkata"),
("1278100", "Ayakudi", "", "IN", "356", "25", "", "", "", "10.44992", "77.55198", "Asia/Kolkata"),
("1278122", "Avanigadda", "", "IN", "356", "02", "", "", "", "16.02148", "80.91808", "Asia/Kolkata"),
("1278124", "Avinashi", "", "IN", "356", "25", "", "", "", "11.19297", "77.26865", "Asia/Kolkata"),
("1278130", "Avadi", "Авади", "IN", "356", "25", "", "", "", "13.1147", "80.10981", "Asia/Kolkata"),
("1278139", "Ausa", "", "IN", "356", "16", "", "", "", "18.24728", "76.4993", "Asia/Kolkata"),
("1278148", "Aurangabad", "", "IN", "356", "34", "", "", "", "24.75389", "84.37406", "Asia/Kolkata"),
("1278149", "Aurangabad", "Аурангабад", "IN", "356", "16", "8131498", "", "", "19.87757", "75.34226", "Asia/Kolkata"),
("1278152", "Auraiya", "", "IN", "356", "36", "", "", "", "26.46313", "79.51167", "Asia/Kolkata"),
("1278156", "Aurad", "", "IN", "356", "19", "", "", "", "18.25429", "77.4135", "Asia/Kolkata"),
("1278173", "Attur", "", "IN", "356", "25", "", "", "", "11.59414", "78.60143", "Asia/Kolkata"),
("1278176", "Attingal", "", "IN", "356", "13", "", "", "", "8.69282", "76.81518", "Asia/Kolkata"),
("1278178", "Attili", "", "IN", "356", "02", "", "", "", "16.7", "81.6", "Asia/Kolkata"),
("1278190", "Atrauli", "", "IN", "356", "36", "", "", "", "28.02964", "78.28572", "Asia/Kolkata"),
("1278201", "Atmakur", "", "IN", "356", "02", "", "", "", "15.88109", "78.58704", "Asia/Kolkata"),
("1278204", "Adirampattinam", "", "IN", "356", "25", "", "", "", "10.34059", "79.37905", "Asia/Kolkata"),
("1278208", "Athni", "", "IN", "356", "19", "", "", "", "16.72613", "75.06421", "Asia/Kolkata"),
("1278216", "Athagarh", "", "IN", "356", "21", "", "", "", "20.51999", "85.62965", "Asia/Kolkata"),
("1278228", "Atarra Buzurg", "", "IN", "356", "36", "", "", "", "25.2857", "80.57144", "Asia/Kolkata"),
("1278278", "Asind", "", "IN", "356", "24", "", "", "", "25.7342", "74.33278", "Asia/Kolkata"),
("1278279", "Asika", "", "IN", "356", "21", "", "", "", "19.61114", "84.65998", "Asia/Kolkata"),
("1278282", "Asifabad", "", "IN", "356", "02", "", "", "", "19.35851", "79.28415", "Asia/Kolkata"),
("1278294", "Ashta", "Ашта", "IN", "356", "35", "", "", "", "23.0179", "76.72024", "Asia/Kolkata"),
("1278296", "Ashta", "Ашта", "IN", "356", "16", "", "", "", "16.94943", "74.40936", "Asia/Kolkata"),
("1278297", "Ashoknagar", "", "IN", "356", "35", "", "", "", "24.57468", "77.73038", "Asia/Kolkata"),
("1278314", "Asansol", "Асансол", "IN", "356", "28", "", "", "", "23.68333", "86.98333", "Asia/Kolkata"),
("1278320", "Asandh", "", "IN", "356", "10", "", "", "", "29.52173", "76.60419", "Asia/Kolkata"),
("1278335", "Arvi", "", "IN", "356", "16", "", "", "", "20.99644", "78.22868", "Asia/Kolkata"),
("1278340", "Aruppukkottai", "", "IN", "356", "25", "", "", "", "9.50842", "78.09449", "Asia/Kolkata"),
("1278343", "Arumuganeri", "", "IN", "356", "25", "", "", "", "8.5688", "78.09091", "Asia/Kolkata"),
("1278345", "Arukutti", "", "IN", "356", "13", "", "", "", "9.86667", "76.35", "Asia/Kolkata"),
("1278354", "Arsikere", "", "IN", "356", "19", "", "", "", "13.31446", "76.25704", "Asia/Kolkata"),
("1278365", "Aron", "", "IN", "356", "35", "", "", "", "24.38362", "77.4192", "Asia/Kolkata"),
("1278393", "Arkalgud", "", "IN", "356", "19", "", "", "", "12.76521", "76.05622", "Asia/Kolkata"),
("1278405", "Ariyalur", "", "IN", "356", "25", "", "", "", "11.13849", "79.07556", "Asia/Kolkata"),
("1278432", "Arcot", "Аркота", "IN", "356", "25", "", "", "", "12.90569", "79.31897", "Asia/Kolkata"),
("1278446", "Araria", "Арария", "IN", "356", "34", "", "", "", "26.14845", "87.51404", "Asia/Kolkata"),
("1278448", "Arantangi", "", "IN", "356", "25", "", "", "", "10.17235", "78.99118", "Asia/Kolkata"),
("1278454", "Arani", "", "IN", "356", "25", "", "", "", "12.66987", "79.28555", "Asia/Kolkata"),
("1278455", "Arangaon", "", "IN", "356", "16", "", "", "", "18.67458", "75.17976", "Asia/Kolkata"),
("1278458", "Arang", "", "IN", "356", "37", "", "", "", "21.2", "81.96667", "Asia/Kolkata"),
("1278466", "Arambagh", "", "IN", "356", "28", "", "", "", "22.88333", "87.78333", "Asia/Kolkata"),
("1278471", "Arakkonam", "", "IN", "356", "25", "", "", "", "13.08449", "79.67053", "Asia/Kolkata"),
("1278483", "Ara", "Ара", "IN", "356", "34", "", "", "", "25.56314", "84.67137", "Asia/Kolkata"),
("1278498", "Aonla", "", "IN", "356", "36", "", "", "", "28.27358", "79.1597", "Asia/Kolkata"),
("1278507", "Anupshahr", "", "IN", "356", "36", "", "", "", "28.3573", "78.26921", "Asia/Kolkata"),
("1278508", "Anuppur", "", "IN", "356", "35", "", "", "", "23.10344", "81.69083", "Asia/Kolkata"),
("1278510", "Anupgarh", "", "IN", "356", "24", "", "", "", "29.19111", "73.20861", "Asia/Kolkata"),
("1278532", "Anta", "", "IN", "356", "24", "", "", "", "25.15", "76.3", "Asia/Kolkata"),
("1278534", "Anshing", "", "IN", "356", "16", "", "", "", "20.03997", "77.31519", "Asia/Kolkata"),
("1278539", "Annur", "", "IN", "356", "25", "", "", "", "11.23616", "77.10514", "Asia/Kolkata"),
("1278540", "Annigeri", "", "IN", "356", "19", "", "", "", "15.42513", "75.4335", "Asia/Kolkata"),
("1278553", "Ankleshwar", "", "IN", "356", "09", "", "", "", "21.63236", "72.99002", "Asia/Kolkata"),
("1278573", "Anjar", "Анджаром", "IN", "356", "09", "", "", "", "23.11316", "70.02671", "Asia/Kolkata"),
("1278580", "Anjangaon", "", "IN", "356", "16", "", "", "", "21.16342", "77.3107", "Asia/Kolkata"),
("1278588", "Anjad", "", "IN", "356", "35", "", "", "", "22.04171", "75.05519", "Asia/Kolkata"),
("1278593", "Angul", "", "IN", "356", "21", "", "", "", "20.84089", "85.10192", "Asia/Kolkata"),
("1278602", "Angamali", "", "IN", "356", "13", "", "", "", "10.2", "76.4", "Asia/Kolkata"),
("1278609", "Anekal", "", "IN", "356", "19", "", "", "", "12.7111", "77.69557", "Asia/Kolkata"),
("1278621", "Andol", "", "IN", "356", "02", "", "", "", "17.81458", "78.07713", "Asia/Kolkata"),
("1278622", "Anthiyur", "", "IN", "356", "25", "", "", "", "11.57506", "77.59043", "Asia/Kolkata"),
("1278625", "Andippatti", "", "IN", "356", "25", "", "", "", "9.99854", "77.62122", "Asia/Kolkata"),
("1278667", "Anantnag", "", "IN", "356", "12", "", "", "", "33.72993", "75.15167", "Asia/Kolkata"),
("1278672", "Anantapur", "Анантапуре", "IN", "356", "02", "", "", "", "14.6794", "77.59877", "Asia/Kolkata"),
("1278676", "Anandpur Sahib", "", "IN", "356", "23", "", "", "", "31.2388", "76.50069", "Asia/Kolkata"),
("1278685", "Anand", "Ананд", "IN", "356", "09", "", "", "", "22.55251", "72.9552", "Asia/Kolkata"),
("1278688", "Anakapalle", "", "IN", "356", "02", "", "", "", "17.69134", "83.00395", "Asia/Kolkata"),
("1278692", "Anaimalai", "", "IN", "356", "25", "", "", "", "10.58226", "76.9347", "Asia/Kolkata"),
("1278698", "Amudalavalasa", "", "IN", "356", "02", "", "", "", "18.41062", "83.90243", "Asia/Kolkata"),
("1278703", "Amta", "", "IN", "356", "28", "", "", "", "22.58344", "88.01039", "Asia/Kolkata"),
("1278707", "Amroli", "", "IN", "356", "09", "", "", "", "21.25084", "72.83878", "Asia/Kolkata"),
("1278708", "Amroha", "", "IN", "356", "36", "", "", "", "28.90314", "78.46984", "Asia/Kolkata"),
("1278710", "Amritsar", "Амритсар", "IN", "356", "23", "", "", "", "31.63661", "74.87476", "Asia/Kolkata"),
("1278715", "Amreli", "", "IN", "356", "09", "", "", "", "21.59984", "71.21169", "Asia/Kolkata"),
("1278718", "Amravati", "", "IN", "356", "16", "8131497", "", "", "20.93333", "77.75", "Asia/Kolkata"),
("1278742", "Amod", "", "IN", "356", "09", "", "", "", "21.99317", "72.87047", "Asia/Kolkata"),
("1278768", "Amli", "", "IN", "356", "06", "", "", "", "20.28333", "73.01667", "Asia/Kolkata"),
("1278774", "Amlagora", "", "IN", "356", "28", "", "", "", "22.84616", "87.33559", "Asia/Kolkata"),
("1278775", "Amla", "", "IN", "356", "35", "", "", "", "21.92429", "78.12766", "Asia/Kolkata"),
("1278808", "Amet", "", "IN", "356", "24", "", "", "", "25.30609", "73.9258", "Asia/Kolkata"),
("1278815", "Ambur", "", "IN", "356", "25", "", "", "", "12.79163", "78.71644", "Asia/Kolkata"),
("1278827", "Ambikapur", "", "IN", "356", "37", "", "", "", "23.11892", "83.19537", "Asia/Kolkata"),
("1278840", "Ambattur", "", "IN", "356", "25", "", "", "", "13.09818", "80.16152", "Asia/Kolkata"),
("1278841", "Ambasamudram", "", "IN", "356", "25", "", "", "", "8.71068", "77.4519", "Asia/Kolkata"),
("1278860", "Ambala", "", "IN", "356", "10", "", "", "", "30.36284", "76.79516", "Asia/Kolkata"),
("1278862", "Ambajogai", "", "IN", "356", "16", "", "", "", "18.73312", "76.38616", "Asia/Kolkata"),
("1278868", "Ambah", "", "IN", "356", "35", "", "", "", "26.70531", "78.22712", "Asia/Kolkata"),
("1278871", "Ambad", "", "IN", "356", "16", "", "", "", "19.61301", "75.78906", "Asia/Kolkata"),
("1278895", "Amarpur", "", "IN", "356", "34", "", "", "", "25.03967", "86.90247", "Asia/Kolkata"),
("1278899", "Amarpatan", "", "IN", "356", "35", "", "", "", "24.31415", "80.97758", "Asia/Kolkata"),
("1278903", "Amarnath", "Амарнатх", "IN", "356", "16", "", "", "", "19.2", "73.16667", "Asia/Kolkata"),
("1278931", "Amalner", "", "IN", "356", "16", "", "", "", "21.04303", "75.0601", "Asia/Kolkata"),
("1278935", "Amalapuram", "", "IN", "356", "02", "", "", "", "16.57868", "82.00609", "Asia/Kolkata"),
("1278941", "Aluva", "", "IN", "356", "13", "", "", "", "10.10468", "76.3565", "Asia/Kolkata"),
("1278946", "Alwar", "Алвар", "IN", "356", "24", "", "", "", "27.56246", "76.625", "Asia/Kolkata"),
("1278964", "Alot", "", "IN", "356", "35", "", "", "", "23.76336", "75.55662", "Asia/Kolkata"),
("1278969", "Along", "", "IN", "356", "30", "1252865", "", "", "28.16951", "94.8006", "Asia/Kolkata"),
("1278973", "Alnavar", "", "IN", "356", "19", "", "", "", "15.42726", "74.74111", "Asia/Kolkata"),
("1278974", "Almora", "Альмора", "IN", "356", "39", "", "", "", "29.59726", "79.66088", "Asia/Kolkata"),
("1278985", "Alleppey", "Алаппужа", "IN", "356", "13", "", "", "", "9.49004", "76.3264", "Asia/Kolkata"),
("1278994", "Allahabad", "Аллахабад", "IN", "356", "36", "", "", "", "25.44894", "81.83328", "Asia/Kolkata"),
("1279005", "Alipur", "", "IN", "356", "07", "", "", "", "28.79961", "77.13151", "Asia/Kolkata"),
("1279017", "Aligarh", "Алигарх", "IN", "356", "36", "", "", "", "27.88334", "78.07475", "Asia/Kolkata"),
("1279023", "Aliganj", "", "IN", "356", "36", "", "", "", "27.49435", "79.17045", "Asia/Kolkata"),
("1279027", "Alibag", "", "IN", "356", "16", "", "", "", "18.64813", "72.87579", "Asia/Kolkata"),
("1279058", "Alangulam", "", "IN", "356", "25", "", "", "", "8.86404", "77.49937", "Asia/Kolkata"),
("1279061", "Alangayam", "", "IN", "356", "25", "", "", "", "12.62239", "78.75158", "Asia/Kolkata"),
("1279064", "Alandur", "", "IN", "356", "25", "", "", "", "13.0025", "80.20611", "Asia/Kolkata"),
("1279066", "Alandi", "", "IN", "356", "16", "", "", "", "18.67756", "73.89868", "Asia/Kolkata"),
("1279068", "Aland", "", "IN", "356", "19", "", "", "", "17.56425", "76.56854", "Asia/Kolkata"),
("1279094", "Akot", "", "IN", "356", "16", "", "", "", "21.09639", "77.05861", "Asia/Kolkata"),
("1279105", "Akola", "Акола", "IN", "356", "16", "", "", "", "20.70957", "76.9981", "Asia/Kolkata"),
("1279115", "Aklera", "", "IN", "356", "24", "", "", "", "24.41384", "76.56863", "Asia/Kolkata"),
("1279123", "Akividu", "", "IN", "356", "02", "", "", "", "16.6", "81.38333", "Asia/Kolkata"),
("1279134", "Akbarpur", "", "IN", "356", "36", "", "", "", "26.43043", "82.53673", "Asia/Kolkata"),
("1279135", "Akbarpur", "", "IN", "356", "36", "", "", "", "26.38313", "79.95035", "Asia/Kolkata"),
("1279144", "Akaltara", "", "IN", "356", "37", "", "", "", "22.0253", "82.42689", "Asia/Kolkata"),
("1279147", "Akalkot", "", "IN", "356", "16", "", "", "", "17.52646", "76.20665", "Asia/Kolkata"),
("1279154", "Ajra", "", "IN", "356", "16", "", "", "", "16.11601", "74.21097", "Asia/Kolkata"),
("1279158", "Ajnala", "", "IN", "356", "23", "", "", "", "31.84391", "74.76166", "Asia/Kolkata"),
("1279159", "Ajmer", "Аджмер", "IN", "356", "24", "", "", "", "26.44976", "74.64116", "Asia/Kolkata"),
("1279186", "Aizawl", "Аиджал", "IN", "356", "31", "", "", "", "23.72894", "92.71791", "Asia/Kolkata"),
("1279219", "Ahraura", "", "IN", "356", "36", "", "", "", "25.01611", "83.03307", "Asia/Kolkata"),
("1279227", "Ahmadpur", "", "IN", "356", "16", "", "", "", "18.70622", "76.93731", "Asia/Kolkata"),
("1279228", "Ahmadnagar", "", "IN", "356", "16", "", "", "", "19.09457", "74.73843", "Asia/Kolkata"),
("1279233", "Ahmedabad", "Ахмадабад", "IN", "356", "09", "", "", "", "23.02579", "72.58726", "Asia/Kolkata"),
("1279259", "Agra", "Агра", "IN", "356", "36", "1279262", "", "", "27.18333", "78.01667", "Asia/Kolkata"),
("1279290", "Agartala", "Агартала", "IN", "356", "26", "", "", "", "23.83605", "91.27939", "Asia/Kolkata"),
("1279299", "Agar", "Агар-агар", "IN", "356", "35", "", "", "", "23.71177", "76.01571", "Asia/Kolkata"),
("1279306", "Afzalpur", "", "IN", "356", "19", "", "", "", "17.20006", "76.36024", "Asia/Kolkata"),
("1279307", "Afzalgarh", "", "IN", "356", "36", "", "", "", "29.39374", "78.67356", "Asia/Kolkata"),
("1279323", "Adur", "", "IN", "356", "13", "", "", "", "9.16667", "76.73333", "Asia/Kolkata"),
("1279334", "Adra", "Адра", "IN", "356", "28", "", "", "", "23.49668", "86.68363", "Asia/Kolkata"),
("1279335", "Adoni", "Адони", "IN", "356", "02", "", "", "", "15.62509", "77.27536", "Asia/Kolkata"),
("1279344", "Adilabad", "", "IN", "356", "02", "", "", "", "19.67203", "78.5359", "Asia/Kolkata"),
("1279356", "Addanki", "", "IN", "356", "02", "", "", "", "15.80994", "79.97311", "Asia/Kolkata"),
("1279382", "Achhnera", "", "IN", "356", "36", "", "", "", "27.1787", "77.75739", "Asia/Kolkata"),
("1279390", "Achalpur", "", "IN", "356", "16", "", "", "", "21.25722", "77.50861", "Asia/Kolkata"),
("1279394", "Abu Road", "", "IN", "356", "24", "", "", "", "24.48012", "72.78186", "Asia/Kolkata"),
("1279396", "Abu", "Абу", "IN", "356", "24", "", "", "", "24.59365", "72.71756", "Asia/Kolkata"),
("1279403", "Abohar", "", "IN", "356", "23", "", "", "", "30.1431", "74.19749", "Asia/Kolkata"),
("1279407", "Abhayapuri", "", "IN", "356", "03", "", "", "", "26.32255", "90.68526", "Asia/Kolkata"),
("1344069", "Contai", "", "IN", "356", "28", "", "", "", "21.77985", "87.74892", "Asia/Kolkata"),
("1344377", "Haldia", "", "IN", "356", "28", "", "", "", "22.06046", "88.10975", "Asia/Kolkata"),
("1348562", "Srirampur", "", "IN", "356", "28", "", "", "", "22.94849", "88.01954", "Asia/Kolkata"),
("1348739", "Dumjor", "", "IN", "356", "28", "", "", "", "22.61993", "88.24566", "Asia/Kolkata"),
("1348747", "Bankra", "", "IN", "356", "28", "", "", "", "22.60291", "88.27751", "Asia/Kolkata"),
("1348753", "Chakapara", "", "IN", "356", "28", "", "", "", "22.63222", "88.34861", "Asia/Kolkata"),
("1348775", "Mahiari", "", "IN", "356", "28", "", "", "", "22.58826", "88.23544", "Asia/Kolkata"),
("1348780", "Dhulagari", "", "IN", "356", "28", "", "", "", "22.58213", "88.171", "Asia/Kolkata"),
("1348785", "Panchla", "", "IN", "356", "28", "", "", "", "22.53665", "88.13785", "Asia/Kolkata"),
("1348818", "Nangi", "", "IN", "356", "28", "", "", "", "22.50833", "88.21528", "Asia/Kolkata"),
("1348820", "Pujali", "", "IN", "356", "28", "", "", "", "22.4711", "88.1453", "Asia/Kolkata"),
("1349041", "Monoharpur", "", "IN", "356", "28", "", "", "", "22.10833", "88.07889", "Asia/Kolkata"),
("1349357", "Nabagram", "", "IN", "356", "28", "", "", "", "22.28806", "88.50917", "Asia/Kolkata"),
("1430991", "Soyibug", "", "IN", "356", "12", "", "", "", "34.08049", "74.70871", "Asia/Kolkata"),
("1445156", "Singapur", "", "IN", "356", "02", "", "", "", "17.46982", "78.12574", "Asia/Kolkata"),
("1445378", "Ghatkesar", "", "IN", "356", "02", "", "", "", "17.45081", "78.68366", "Asia/Kolkata"),
("1462711", "Vijayapura", "", "IN", "356", "19", "", "", "", "13.29506", "77.80228", "Asia/Kolkata"),
("1462733", "Adampur", "", "IN", "356", "23", "", "", "", "31.43224", "75.71484", "Asia/Kolkata"),
("1465622", "Porur", "", "IN", "356", "25", "", "", "", "13.03565", "80.15821", "Asia/Kolkata"),
("1465825", "Madipakkam", "", "IN", "356", "25", "", "", "", "12.96226", "80.19864", "Asia/Kolkata"),
("1465828", "Perungudi", "", "IN", "356", "25", "", "", "", "12.96095", "80.24094", "Asia/Kolkata"),
("1465910", "Madambakkam", "", "IN", "356", "25", "", "", "", "12.8525", "80.04667", "Asia/Kolkata"),
("6324621", "Powai", "", "IN", "356", "16", "", "", "", "19.1164", "72.90471", "Asia/Kolkata"),
("6619347", "Navi Mumbai", "Нави Мумбаи", "IN", "356", "16", "", "", "", "19.03681", "73.01582", "Asia/Kolkata"),
("6941937", "Murudeshwara", "Мурудешвара", "IN", "356", "19", "", "", "", "14.0943", "74.4845", "Asia/Kolkata"),
("6943660", "Shivaji Nagar", "", "IN", "356", "16", "", "", "", "18.53017", "73.85263", "Asia/Kolkata"),
("6954929", "Greater Noida", "", "IN", "356", "36", "1263215", "7279602", "", "28.49615", "77.53601", "Asia/Kolkata"),
("6992326", "Mohali", "", "IN", "356", "23", "", "", "", "30.67995", "76.72211", "Asia/Kolkata"),
("7279595", "Pithampur", "", "IN", "356", "35", "", "", "", "22.60197", "75.69649", "Asia/Kolkata"),
("7279597", "Barbil", "", "IN", "356", "21", "", "", "", "21.65685", "85.64349", "Asia/Kolkata"),
("7279599", "Airoli", "", "IN", "356", "16", "", "", "", "19.15096", "72.99625", "Asia/Kolkata"),
("7279600", "Aluva", "", "IN", "356", "13", "", "", "", "10.10764", "76.35158", "Asia/Kolkata"),
("7279734", "Kotkapura", "", "IN", "356", "23", "", "", "", "30.5819", "74.83298", "Asia/Kolkata"),
("7279735", "Muvattupuzha", "", "IN", "356", "13", "", "", "", "9.97985", "76.57381", "Asia/Kolkata"),
("7279739", "Perumbavoor", "", "IN", "356", "13", "", "", "", "10.10695", "76.47366", "Asia/Kolkata"),
("7279741", "Vapi", "", "IN", "356", "09", "", "", "", "20.37175", "72.90493", "Asia/Kolkata"),
("7279742", "Baddi", "", "IN", "356", "11", "", "", "", "30.95783", "76.79136", "Asia/Kolkata"),
("7279746", "Noida", "Ноида", "IN", "356", "36", "1263215", "7279602", "", "28.58", "77.33", "Asia/Kolkata"),
("7279747", "Bhiwadi", "", "IN", "356", "24", "", "", "", "28.21024", "76.86056", "Asia/Kolkata"),
("7279752", "Mandideep", "", "IN", "356", "35", "", "", "", "23.08166", "77.53328", "Asia/Kolkata"),
("7279754", "Singrauli", "", "IN", "356", "35", "", "", "", "24.19973", "82.67535", "Asia/Kolkata"),
("7284803", "Birpara", "", "IN", "356", "28", "", "", "", "26.70421", "89.14547", "Asia/Kolkata"),
("7284820", "Jaigaon", "", "IN", "356", "28", "", "", "", "26.84766", "89.37558", "Asia/Kolkata"),
("7302805", "Akkarampalle", "", "IN", "356", "02", "", "", "", "13.65", "79.42", "Asia/Kolkata"),
("7302806", "Bellampalli", "", "IN", "356", "02", "", "", "", "19.05577", "79.493", "Asia/Kolkata"),
("7302808", "Chemmumiahpet", "", "IN", "356", "02", "", "", "", "15.89794", "79.32129", "Asia/Kolkata"),
("7302810", "Gaddi Annaram", "", "IN", "356", "02", "", "", "", "17.36687", "78.5242", "Asia/Kolkata"),
("7302812", "Dasnapur", "", "IN", "356", "02", "", "", "", "19.65399", "78.51213", "Asia/Kolkata"),
("7302825", "Kanuru", "", "IN", "356", "02", "", "", "", "16.28584", "81.25464", "Asia/Kolkata"),
("7302826", "Lal Bahadur Nagar", "", "IN", "356", "02", "", "", "", "17.34769", "78.55757", "Asia/Kolkata"),
("7302828", "Malkajgiri", "", "IN", "356", "02", "", "", "", "17.44781", "78.52633", "Asia/Kolkata"),
("7302829", "Mandamarri", "", "IN", "356", "02", "", "", "", "18.96506", "79.47475", "Asia/Kolkata"),
("7302830", "Chinnachowk", "", "IN", "356", "02", "", "", "", "14.47516", "78.8354", "Asia/Kolkata"),
("7302832", "Kyathampalle", "", "IN", "356", "02", "", "", "", "19.66781", "78.5289", "Asia/Kolkata"),
("7302833", "Gajuwaka", "", "IN", "356", "02", "", "", "", "17.7", "83.21667", "Asia/Kolkata"),
("7302836", "Manuguru", "", "IN", "356", "02", "", "", "", "17.98102", "80.7547", "Asia/Kolkata"),
("7302838", "Kalyandurg", "", "IN", "356", "02", "", "", "", "14.54519", "77.10552", "Asia/Kolkata"),
("7302844", "Ponnur", "", "IN", "356", "02", "", "", "", "16.07114", "80.54944", "Asia/Kolkata"),
("7302845", "Quthbullapur", "", "IN", "356", "02", "", "", "", "17.50107", "78.45818", "Asia/Kolkata"),
("7302846", "Ramanayyapeta", "", "IN", "356", "02", "", "", "", "16.94516", "82.2385", "Asia/Kolkata"),
("7302847", "Palwancha", "", "IN", "356", "02", "", "", "", "17.58152", "80.67651", "Asia/Kolkata"),
("7302849", "Barpeta Road", "", "IN", "356", "03", "", "", "", "26.50284", "90.96937", "Asia/Kolkata"),
("7302851", "Sathupalli", "", "IN", "356", "02", "", "", "", "17.24968", "80.86899", "Asia/Kolkata"),
("7302853", "Yanamalakuduru", "", "IN", "356", "02", "", "", "", "16.48531", "80.66746", "Asia/Kolkata"),
("7302854", "Marigaon", "", "IN", "356", "03", "", "", "", "26.37957", "92.34146", "Asia/Kolkata"),
("7302855", "Naharlagun", "", "IN", "356", "30", "", "", "", "27.10467", "93.69518", "Asia/Kolkata"),
("7302856", "Serilingampalle", "", "IN", "356", "02", "", "", "", "17.49313", "78.30196", "Asia/Kolkata"),
("7302857", "Silapathar", "", "IN", "356", "03", "", "", "", "26.20597", "93.80951", "Asia/Kolkata"),
("7302859", "Lumding Railway Colony", "", "IN", "356", "03", "", "", "", "25.74903", "93.16998", "Asia/Kolkata"),
("7302860", "Aistala", "", "IN", "356", "28", "", "", "", "23.18", "88.58", "Asia/Kolkata"),
("7302861", "Ashoknagar Kalyangarh", "", "IN", "356", "28", "", "", "", "22.86416", "88.63701", "Asia/Kolkata"),
("7302862", "Bahula", "", "IN", "356", "28", "", "", "", "23.65176", "87.16475", "Asia/Kolkata"),
("7626554", "Bhawanipur", "", "IN", "356", "34", "", "", "", "26.45352", "87.02744", "Asia/Kolkata"),
("7645176", "Zira", "", "IN", "356", "23", "", "", "", "30.96853", "74.99106", "Asia/Kolkata"),
("8347656", "Ramagundam", "", "IN", "356", "02", "", "", "", "18.755", "79.474", "Asia/Kolkata"),
("8504418", "Cherpulassery", "", "IN", "356", "13", "", "", "", "10.87655", "76.30932", "Asia/Kolkata"),
("8581647", "Kirandul", "", "IN", "356", "37", "", "", "", "18.63649", "81.25827", "Asia/Kolkata"),
("8714565", "Shiraguppi", "", "IN", "356", "16", "", "", "", "16.61875", "74.70907", "Asia/Kolkata"),
("8948694", "V.S.K.Valasai (Dindigul-Dist.)", "В.С.К.Валасаи", "IN", "356", "25", "", "", "", "10.31549", "78.15141", "Asia/Kolkata"),
("89570", "Zakhu", "Заху", "IQ", "368", "08", "", "", "", "37.14805", "42.70355", "Asia/Baghdad"),
("89824", "Umm Qasr", "", "IQ", "368", "02", "", "", "", "30.0362", "47.91951", "Asia/Baghdad"),
("90026", "Tozkhurmato", "", "IQ", "368", "18", "", "", "", "34.88808", "44.63256", "Asia/Baghdad"),
("90150", "Tikrit", "Тикрит", "IQ", "368", "18", "", "", "", "34.61581", "43.67861", "Asia/Baghdad"),
("90353", "Qada' Talkif", "Талль-Кайф", "IQ", "368", "15", "", "", "", "36.49109", "43.12026", "Asia/Baghdad"),
("90708", "Sinah", "", "IQ", "368", "08", "", "", "", "36.80752", "43.03831", "Asia/Baghdad"),
("91597", "Samarra'", "", "IQ", "368", "18", "", "", "", "34.19663", "43.8739", "Asia/Baghdad"),
("91812", "Nahiyat Saddat al Hindiyah", "", "IQ", "368", "06", "", "", "", "32.71557", "44.27857", "Asia/Baghdad"),
("92002", "Rawanduz", "Равандуз", "IQ", "368", "11", "", "", "", "36.61647", "44.53014", "Asia/Baghdad"),
("92004", "Rawah", "", "IQ", "368", "01", "", "", "", "34.47935", "41.90849", "Asia/Baghdad"),
("92430", "Al-Hamdaniya District", "", "IQ", "368", "15", "92430", "", "", "36.27093", "43.37758", "Asia/Baghdad"),
("93709", "Mandali", "Мандали", "IQ", "368", "10", "", "", "", "33.7481", "45.55503", "Asia/Baghdad"),
("94220", "Koysinceq", "", "IQ", "368", "11", "", "", "", "36.08289", "44.62873", "Asia/Baghdad"),
("94298", "Kifri", "Кифри", "IQ", "368", "10", "", "", "", "34.68963", "44.96057", "Asia/Baghdad"),
("94787", "Kirkuk", "Киркук", "IQ", "368", "13", "", "", "", "35.46806", "44.39222", "Asia/Baghdad"),
("94824", "Karbala", "Кербела", "IQ", "368", "12", "", "", "", "32.61603", "44.02488", "Asia/Baghdad"),
("95446", "Erbil", "", "IQ", "368", "11", "", "", "", "36.19257", "44.01062", "Asia/Baghdad"),
("95788", "Hit", "", "IQ", "368", "01", "", "", "", "33.63664", "42.82768", "Asia/Baghdad"),
("96205", "Halabjah", "Халабджа", "IQ", "368", "05", "", "", "", "35.17778", "45.98611", "Asia/Baghdad"),
("96309", "Hadithah", "Хадита", "IQ", "368", "01", "", "", "", "34.13477", "42.37724", "Asia/Baghdad"),
("96994", "Dihuk", "", "IQ", "368", "08", "", "", "", "36.86709", "42.98845", "Asia/Baghdad"),
("97417", "Chamchamal", "", "IQ", "368", "05", "", "", "", "35.53356", "44.8343", "Asia/Baghdad"),
("97783", "Bayji", "Байджи", "IQ", "368", "18", "", "", "", "34.9307", "43.49311", "Asia/Baghdad"),
("97990", "Baqubah", "", "IQ", "368", "10", "", "", "", "33.7466", "44.64366", "Asia/Baghdad"),
("98012", "Paynjuwayn", "", "IQ", "368", "05", "", "", "", "35.6169", "45.95338", "Asia/Baghdad"),
("98112", "Balad", "Балада", "IQ", "368", "18", "", "", "", "34.01485", "44.14574", "Asia/Baghdad"),
("98182", "Baghdad", "Багдад", "IQ", "368", "07", "", "", "", "33.34058", "44.40088", "Asia/Baghdad"),
("98245", "Az Zubayr", "", "IQ", "368", "02", "", "", "", "30.39213", "47.70174", "Asia/Baghdad"),
("98459", "As Suwayrah", "Сувайра", "IQ", "368", "16", "", "", "", "32.92556", "44.77583", "Asia/Baghdad"),
("98463", "As Sulaymaniyah", "Сулеймания", "IQ", "368", "05", "", "", "", "35.56496", "45.4329", "Asia/Baghdad"),
("98530", "As Samawah", "Самава", "IQ", "368", "03", "", "", "", "31.33198", "45.2944", "Asia/Baghdad"),
("98589", "Nahiyat ash Shinafiyah", "", "IQ", "368", "04", "", "", "", "31.58376", "44.64675", "Asia/Baghdad"),
("98622", "Ash Shatrah", "", "IQ", "368", "09", "", "", "", "31.40906", "46.1727", "Asia/Baghdad"),
("98629", "Ash Shamiyah", "", "IQ", "368", "04", "", "", "", "31.96257", "44.60075", "Asia/Baghdad"),
("98677", "Ar Rutbah", "", "IQ", "368", "01", "", "", "", "33.03718", "40.28586", "Asia/Baghdad"),
("98685", "Ar Rumaythah", "", "IQ", "368", "03", "", "", "", "31.52845", "45.20377", "Asia/Baghdad"),
("98717", "Ramadi", "", "IQ", "368", "01", "", "", "", "33.42056", "43.30778", "Asia/Baghdad"),
("98822", "'Aqrah", "", "IQ", "368", "15", "98820", "", "", "36.73322", "43.87964", "Asia/Baghdad"),
("98854", "An Nasiriyah", "Насирия", "IQ", "368", "09", "", "", "", "31.05799", "46.25726", "Asia/Baghdad"),
("98860", "An Najaf al Ashraf", "Ан-Наджаф", "IQ", "368", "17", "", "", "", "31.9892", "44.3291", "Asia/Baghdad"),
("98885", "`Anat al Qadimah", "", "IQ", "368", "01", "", "", "", "34.46934", "41.94224", "Asia/Baghdad"),
("99010", "Imam Qasim", "Аль-Касим", "IQ", "368", "06", "", "", "", "32.29799", "44.68282", "Asia/Baghdad"),
("99039", "Al Musayyib", "Аль-Эль-Мусайибе", "IQ", "368", "06", "", "", "", "32.78396", "44.27662", "Asia/Baghdad"),
("99060", "Al Mishkhab", "", "IQ", "368", "17", "", "", "", "31.80436", "44.4893", "Asia/Baghdad"),
("99062", "Al Miqdadiyah", "", "IQ", "368", "10", "", "", "", "33.97861", "44.93694", "Asia/Baghdad"),
("99071", "Al Mawsil al Jadidah", "", "IQ", "368", "15", "", "", "", "36.33091", "43.09065", "Asia/Baghdad"),
("99072", "Mosul", "Мосул", "IQ", "368", "15", "", "", "", "36.335", "43.11889", "Asia/Baghdad"),
("99131", "Al Kut", "", "IQ", "368", "16", "", "", "", "32.5128", "45.81817", "Asia/Baghdad"),
("99135", "Kufa", "Эль-Куфа", "IQ", "368", "17", "99135", "", "", "32.05114", "44.44017", "Asia/Baghdad"),
("99169", "Khalis", "Аль-Халиса", "IQ", "368", "10", "", "", "", "33.80809", "44.53344", "Asia/Baghdad"),
("99306", "`Ali al Gharbi", "", "IQ", "368", "14", "", "", "", "32.46186", "46.68794", "Asia/Baghdad"),
("99344", "Al Hindiyah", "", "IQ", "368", "12", "", "", "", "32.54217", "44.22111", "Asia/Baghdad"),
("99347", "Al Hillah", "Аль-Хилла", "IQ", "368", "06", "", "", "", "32.46367", "44.41963", "Asia/Baghdad"),
("99350", "Al Hayy", "Аль-Хая", "IQ", "368", "16", "", "", "", "32.17419", "46.04345", "Asia/Baghdad"),
("99369", "Al Harithah", "Аль-Харриса", "IQ", "368", "02", "", "", "", "30.71861", "47.72083", "Asia/Baghdad"),
("99434", "Nahiyat Ghammas", "", "IQ", "368", "04", "", "", "", "31.74311", "44.6196", "Asia/Baghdad"),
("99439", "Nahiyat al Fuhud", "", "IQ", "368", "09", "", "", "", "30.96972", "46.72278", "Asia/Baghdad"),
("99446", "Al Faw", "Аль-Фау", "IQ", "368", "02", "", "", "", "29.97421", "48.47309", "Asia/Baghdad"),
("99454", "Al Fallujah", "", "IQ", "368", "01", "", "", "", "33.35581", "43.78612", "Asia/Baghdad"),
("99532", "Al Basrah", "Басра", "IQ", "368", "02", "", "", "", "30.53302", "47.79747", "Asia/Baghdad"),
("99548", "Al `Aziziyah", "", "IQ", "368", "16", "", "", "", "32.90941", "45.06359", "Asia/Baghdad"),
("99608", "Al `Amarah", "", "IQ", "368", "14", "", "", "", "31.83588", "47.144", "Asia/Baghdad"),
("99738", "`Afak", "Афак", "IQ", "368", "04", "", "", "", "32.0643", "45.24743", "Asia/Baghdad"),
("99759", "Ad Dujayl", "", "IQ", "368", "18", "", "", "", "33.84667", "44.23444", "Asia/Baghdad"),
("99762", "Ad Diwaniyah", "Дивания", "IQ", "368", "04", "", "", "", "31.99289", "44.92552", "Asia/Baghdad"),
("100077", "Abu Ghurayb", "Абу-Грейб", "IQ", "368", "07", "9166542", "", "", "33.30703", "44.18694", "Asia/Baghdad"),
("388349", "Al Basrat al Qadimah", "", "IQ", "368", "02", "", "", "", "30.49528", "47.8169", "Asia/Baghdad"),
("448149", "Sinjar", "", "IQ", "368", "15", "", "", "", "36.3209", "41.87656", "Asia/Baghdad"),
("14256", "Azadshahr", "", "IR", "364", "09", "", "", "", "34.79049", "48.57011", "Asia/Tehran"),
("23814", "Kahriz", "", "IR", "364", "13", "", "", "", "34.3838", "47.0553", "Asia/Tehran"),
("24851", "Nurabad", "Нурабад", "IR", "364", "23", "", "", "", "34.0734", "47.9725", "Asia/Tehran"),
("32723", "Istgah-e Rah Ahan-e Garmsar", "", "IR", "364", "25", "", "", "", "35.23455", "52.30942", "Asia/Tehran"),
("32767", "Qarchak", "", "IR", "364", "26", "", "", "", "35.42867", "51.57544", "Asia/Tehran"),
("32909", "Shahre Jadide Andisheh", "", "IR", "364", "26", "", "", "", "35.6803", "51.0193", "Asia/Tehran"),
("41210", "Khorram Darreh", "", "IR", "364", "36", "", "", "", "36.213", "49.196", "Asia/Tehran"),
("66093", "Yasuj", "Ясудж", "IR", "364", "05", "", "", "", "30.66824", "51.58796", "Asia/Tehran"),
("110831", "Shah Pasand", "", "IR", "364", "37", "", "", "", "37.08701", "55.17397", "Asia/Tehran"),
("111421", "Zarand", "", "IR", "364", "29", "", "", "", "30.81271", "56.56399", "Asia/Tehran"),
("111453", "Zanjan", "Зенджан", "IR", "364", "36", "", "", "", "36.6736", "48.4787", "Asia/Tehran"),
("111822", "Yazd", "Йезд", "IR", "364", "40", "", "", "", "31.89722", "54.3675", "Asia/Tehran"),
("112214", "Varamin", "Варамин", "IR", "364", "26", "", "", "", "35.3242", "51.6457", "Asia/Tehran"),
("112646", "Torbat-e Heydariyeh", "", "IR", "364", "42", "", "", "", "35.27401", "59.21949", "Asia/Tehran"),
("112656", "Tonekabon", "Тонекабон", "IR", "364", "35", "", "", "", "36.81626", "50.87376", "Asia/Tehran"),
("112931", "Tehran", "Тегеран", "IR", "364", "26", "", "", "", "35.69439", "51.42151", "Asia/Tehran"),
("113343", "Hashtpar", "", "IR", "364", "08", "", "", "", "37.8008", "48.9037", "Asia/Tehran"),
("113491", "Takestan", "", "IR", "364", "38", "", "", "", "36.0696", "49.6959", "Asia/Tehran"),
("113508", "Takab", "", "IR", "364", "01", "", "", "", "36.4009", "47.1133", "Asia/Tehran"),
("113632", "Taft", "Тафт", "IR", "364", "40", "", "", "", "31.74384", "54.20278", "Asia/Tehran"),
("113646", "Tabriz", "Тебриз", "IR", "364", "33", "", "", "", "38.08", "46.2919", "Asia/Tehran"),
("113659", "Tabas", "Табас", "IR", "364", "40", "", "", "", "33.59586", "56.92437", "Asia/Tehran"),
("114049", "Sonqor", "", "IR", "364", "13", "", "", "", "34.7837", "47.6004", "Asia/Tehran"),
("114259", "Sirjan", "", "IR", "364", "29", "", "", "", "29.45137", "55.6809", "Asia/Tehran"),
("114584", "Shushtar", "Шуштэр", "IR", "364", "15", "", "", "", "32.0455", "48.8567", "Asia/Tehran"),
("114593", "Shush", "Сузы", "IR", "364", "15", "", "", "", "32.1942", "48.2436", "Asia/Tehran"),
("115019", "Shiraz", "Шираз", "IR", "364", "07", "", "", "", "29.61031", "52.53114", "Asia/Tehran"),
("115770", "Shahr-e Kord", "Шахре-Корд", "IR", "364", "03", "", "", "", "32.32556", "50.86444", "Asia/Tehran"),
("115781", "Shahr-e Babak", "", "IR", "364", "29", "", "", "", "30.1165", "55.1186", "Asia/Tehran"),
("116102", "Shadegan", "Шадеганские", "IR", "364", "15", "", "", "", "30.64972", "48.66472", "Asia/Tehran"),
("116402", "Semnan", "Семнан", "IR", "364", "25", "", "", "", "35.57692", "53.39205", "Asia/Tehran"),
("116406", "Semirom", "", "IR", "364", "28", "", "", "", "31.41667", "51.56667", "Asia/Tehran"),
("116667", "Saveh", "Сава", "IR", "364", "34", "", "", "", "35.0213", "50.3566", "Asia/Tehran"),
("116996", "Sari", "Сари", "IR", "364", "35", "", "", "", "36.56332", "53.06009", "Asia/Tehran"),
("117392", "Saqqez", "", "IR", "364", "16", "", "", "", "36.24992", "46.2735", "Asia/Tehran"),
("117574", "Sanandaj", "Сенендедж", "IR", "364", "16", "", "", "", "35.31495", "46.99883", "Asia/Tehran"),
("117656", "Salmas", "Салмас", "IR", "364", "01", "", "", "", "38.1973", "44.7653", "Asia/Tehran"),
("117793", "Shahin Dezh", "", "IR", "364", "01", "", "", "", "36.6793", "46.5669", "Asia/Tehran"),
("118063", "Sabzevar", "Себзевар", "IR", "364", "42", "", "", "", "36.2126", "57.68191", "Asia/Tehran"),
("118191", "Rudsar", "", "IR", "364", "08", "", "", "", "37.13761", "50.288", "Asia/Tehran"),
("118367", "Robat Karim", "", "IR", "364", "26", "", "", "", "35.4846", "51.0829", "Asia/Tehran"),
("118704", "Ravar", "", "IR", "364", "29", "", "", "", "31.26562", "56.80545", "Asia/Tehran"),
("118743", "Rasht", "Решт", "IR", "364", "08", "", "", "", "37.28077", "49.58319", "Asia/Tehran"),
("118805", "Ramshir", "", "IR", "364", "15", "", "", "", "30.8946", "49.4092", "Asia/Tehran"),
("118826", "Ramhormoz", "", "IR", "364", "15", "", "", "", "31.27997", "49.60351", "Asia/Tehran"),
("118994", "Rafsanjan", "Рафсанджане", "IR", "364", "29", "", "", "", "30.4067", "55.9939", "Asia/Tehran"),
("119115", "Quchan", "", "IR", "364", "42", "", "", "", "37.106", "58.50955", "Asia/Tehran"),
("119161", "Qorveh", "", "IR", "364", "16", "", "", "", "35.1664", "47.8045", "Asia/Tehran"),
("119208", "Qom", "Кум", "IR", "364", "39", "", "", "", "34.6401", "50.8764", "Asia/Tehran"),
("119374", "Qeshm", "Кешм", "IR", "364", "11", "449706", "", "", "26.9492", "56.2691", "Asia/Tehran"),
("119505", "Qazvin", "Казвин", "IR", "364", "38", "", "", "", "36.26877", "50.0041", "Asia/Tehran"),
("119730", "Qarah Zia' od Din", "", "IR", "364", "01", "", "", "", "38.8915", "45.0255", "Asia/Tehran"),
("120678", "Farrokh Shahr", "", "IR", "364", "03", "", "", "", "32.27174", "50.98008", "Asia/Tehran"),
("120694", "Qayen", "", "IR", "364", "42", "", "", "", "33.72654", "59.18439", "Asia/Tehran"),
("120931", "Sarpol-e Zahab", "", "IR", "364", "13", "", "", "", "34.46109", "45.86264", "Asia/Tehran"),
("120972", "Pishva", "", "IR", "364", "26", "", "", "", "35.308", "51.7267", "Asia/Tehran"),
("121110", "Piranshahr", "", "IR", "364", "01", "", "", "", "36.701", "45.1413", "Asia/Tehran"),
("121240", "Paveh", "", "IR", "364", "13", "", "", "", "35.0434", "46.3565", "Asia/Tehran"),
("121380", "Parsabad", "Парсабад", "IR", "364", "32", "", "", "", "39.6482", "47.9174", "Asia/Tehran"),
("121795", "Oshnaviyeh", "Ошнуйе", "IR", "364", "01", "", "", "", "37.0397", "45.0983", "Asia/Tehran"),
("121801", "Orumiyeh", "Урмия", "IR", "364", "01", "", "", "", "37.55274", "45.07605", "Asia/Tehran"),
("121861", "Omidiyeh", "", "IR", "364", "15", "", "", "", "30.75972", "49.705", "Asia/Tehran"),
("121925", "Nurabad", "", "IR", "364", "07", "", "", "", "30.11405", "51.52174", "Asia/Tehran"),
("121959", "Now Shahr", "", "IR", "364", "35", "449688", "", "", "36.649", "51.496", "Asia/Tehran"),
("122285", "Neyshabur", "Нишапур", "IR", "364", "42", "", "", "", "36.21329", "58.79576", "Asia/Tehran"),
("122289", "Neyriz", "", "IR", "364", "07", "", "", "", "29.1988", "54.3278", "Asia/Tehran"),
("122397", "Neka'", "Нека", "IR", "364", "35", "", "", "", "36.65079", "53.29905", "Asia/Tehran"),
("122438", "Nazarabad", "", "IR", "364", "44", "", "", "", "35.95411", "50.60608", "Asia/Tehran"),
("122698", "Naqadeh", "", "IR", "364", "01", "", "", "", "36.9553", "45.388", "Asia/Tehran"),
("122915", "Nahavand", "Нагаванде", "IR", "364", "09", "", "", "", "34.1885", "48.377", "Asia/Tehran"),
("123941", "Minab", "Минаб", "IR", "364", "11", "", "", "", "27.13104", "57.08716", "Asia/Tehran"),
("124085", "Miandowab", "Миандоаб", "IR", "364", "01", "", "", "", "36.9694", "46.1027", "Asia/Tehran"),
("124193", "Meybod", "", "IR", "364", "40", "", "", "", "32.25014", "54.01658", "Asia/Tehran"),
("124274", "Mahriz", "", "IR", "364", "40", "", "", "", "31.58428", "54.4428", "Asia/Tehran"),
("124620", "Masjed Soleyman", "", "IR", "364", "15", "", "", "", "31.9364", "49.3039", "Asia/Tehran"),
("124647", "Bardsir", "", "IR", "364", "29", "", "", "", "29.92266", "56.57434", "Asia/Tehran"),
("124665", "Mashhad", "Мешхед", "IR", "364", "42", "", "", "", "36.31559", "59.56796", "Asia/Tehran"),
("124862", "Marand", "Маранд", "IR", "364", "33", "", "", "", "38.4329", "45.7749", "Asia/Tehran"),
("125185", "Malayer", "", "IR", "364", "09", "", "", "", "34.2969", "48.8235", "Asia/Tehran"),
("125188", "Malard", "", "IR", "364", "26", "", "", "", "35.6659", "50.9767", "Asia/Tehran"),
("125446", "Mahabad", "Махабад", "IR", "364", "01", "", "", "", "36.7631", "45.7222", "Asia/Tehran"),
("125897", "Langerud", "", "IR", "364", "08", "", "", "", "37.19701", "50.15351", "Asia/Tehran"),
("126409", "Kuhdasht", "", "IR", "364", "23", "", "", "", "33.53335", "47.60999", "Asia/Tehran"),
("126914", "Kish", "Киш", "IR", "364", "11", "", "", "", "26.55778", "54.01944", "Asia/Tehran"),
("126972", "Khvoy", "", "IR", "364", "01", "", "", "", "38.5503", "44.9521", "Asia/Tehran"),
("127033", "Khvansar", "", "IR", "364", "28", "", "", "", "33.22052", "50.31497", "Asia/Tehran"),
("127319", "Khorramshahr", "Хорремшехр", "IR", "364", "15", "", "", "", "30.44079", "48.18428", "Asia/Tehran"),
("127349", "Khorramabad", "", "IR", "364", "23", "", "", "", "33.48778", "48.35583", "Asia/Tehran"),
("127403", "Khomeyn", "", "IR", "364", "34", "", "", "", "33.64226", "50.0789", "Asia/Tehran"),
("128008", "Herowabad", "", "IR", "364", "32", "", "", "", "37.6189", "48.5258", "Asia/Tehran"),
("128226", "Kermanshah", "Керманшах", "IR", "364", "13", "", "", "", "34.31417", "47.065", "Asia/Tehran"),
("128234", "Kerman", "Керман", "IR", "364", "29", "", "", "", "30.28321", "57.07879", "Asia/Tehran"),
("128321", "Kazerun", "Казеруна", "IR", "364", "07", "", "", "", "29.61949", "51.65415", "Asia/Tehran"),
("128447", "Kashmar", "", "IR", "364", "42", "", "", "", "35.23831", "58.46558", "Asia/Tehran"),
("128477", "Kashan", "Кашан", "IR", "364", "28", "", "", "", "33.98308", "51.43644", "Asia/Tehran"),
("128747", "Karaj", "Карай", "IR", "364", "44", "", "", "", "35.83266", "50.99154", "Asia/Tehran"),
("128831", "Kangavar", "", "IR", "364", "13", "", "", "", "34.5043", "47.9653", "Asia/Tehran"),
("128905", "Kamyaran", "", "IR", "364", "16", "", "", "", "34.7956", "46.9355", "Asia/Tehran"),
("129512", "Kalaleh", "", "IR", "364", "37", "", "", "", "37.38071", "55.49164", "Asia/Tehran"),
("129933", "Juybar", "", "IR", "364", "35", "", "", "", "36.64115", "52.91244", "Asia/Tehran"),
("130245", "Javanrud", "", "IR", "364", "13", "", "", "", "34.79611", "46.51722", "Asia/Tehran"),
("130802", "Ilam", "Илам", "IR", "364", "10", "", "", "", "33.6374", "46.4227", "Asia/Tehran"),
("131962", "Harsin", "", "IR", "364", "13", "", "", "", "34.2721", "47.5861", "Asia/Tehran"),
("132144", "Hamadan", "Хамадан", "IR", "364", "09", "", "", "", "34.79922", "48.51456", "Asia/Tehran"),
("132892", "Gorgan", "Горган", "IR", "364", "37", "", "", "", "36.84165", "54.44361", "Asia/Tehran"),
("132938", "Gonbad-e Qabus", "", "IR", "364", "37", "", "", "", "37.25004", "55.16721", "Asia/Tehran"),
("132961", "Gonabad", "", "IR", "364", "42", "", "", "", "34.35286", "58.68365", "Asia/Tehran"),
("133037", "Golpayegan", "", "IR", "364", "28", "", "", "", "33.4537", "50.28836", "Asia/Tehran"),
("133595", "Gerash", "", "IR", "364", "07", "", "", "", "27.6652", "54.1371", "Asia/Tehran"),
("134217", "Bandar-e Ganaveh", "", "IR", "364", "22", "", "", "", "29.5791", "50.517", "Asia/Tehran"),
("134518", "Firuzabad", "", "IR", "364", "07", "", "", "", "28.8438", "52.5707", "Asia/Tehran"),
("134602", "Fereydun Kenar", "", "IR", "364", "35", "", "", "", "36.68642", "52.52255", "Asia/Tehran"),
("134721", "Fasa", "", "IR", "364", "07", "", "", "", "28.9383", "53.6482", "Asia/Tehran"),
("134762", "Farsan", "", "IR", "364", "03", "", "", "", "32.25694", "50.56096", "Asia/Tehran"),
("135298", "Esfarayen", "", "IR", "364", "43", "", "", "", "37.07645", "57.51009", "Asia/Tehran"),
("135423", "Shahrud", "", "IR", "364", "25", "", "", "", "36.41819", "54.97628", "Asia/Tehran"),
("136014", "Dogonbadan", "", "IR", "364", "05", "", "", "", "30.3586", "50.7981", "Asia/Tehran"),
("136399", "Delijan", "", "IR", "364", "34", "", "", "", "33.9905", "50.6838", "Asia/Tehran"),
("136702", "Dehloran", "Дехлорана", "IR", "364", "10", "", "", "", "32.6941", "47.2679", "Asia/Tehran"),
("136987", "Dehdasht", "", "IR", "364", "05", "", "", "", "30.7949", "50.56458", "Asia/Tehran"),
("137268", "Susangerd", "", "IR", "364", "15", "", "", "", "31.5608", "48.1831", "Asia/Tehran"),
("137436", "Darreh Shahr", "", "IR", "364", "10", "449461", "", "", "33.1396", "47.3762", "Asia/Tehran"),
("137956", "Darab", "", "IR", "364", "07", "", "", "", "28.75194", "54.54444", "Asia/Tehran"),
("138025", "Damghan", "", "IR", "364", "25", "", "", "", "36.1679", "54.34292", "Asia/Tehran"),
("138042", "Damavand", "Дамаванд", "IR", "364", "26", "", "", "", "35.71842", "52.06958", "Asia/Tehran"),
("138742", "Chenaran", "", "IR", "364", "42", "", "", "", "36.64546", "59.12123", "Asia/Tehran"),
("139223", "Chalus", "Чалус", "IR", "364", "35", "", "", "", "36.655", "51.4204", "Asia/Tehran"),
("139817", "Bandar-e Bushehr", "Бушир", "IR", "364", "22", "", "", "", "28.9684", "50.8385", "Asia/Tehran"),
("139889", "Bukan", "Букан", "IR", "364", "01", "", "", "", "36.521", "46.2089", "Asia/Tehran"),
("140044", "Borujerd", "Боруджерд", "IR", "364", "23", "", "", "", "33.8973", "48.7516", "Asia/Tehran"),
("140046", "Borujen", "", "IR", "364", "03", "", "", "", "31.96523", "51.2873", "Asia/Tehran"),
("140097", "Borazjan", "", "IR", "364", "22", "", "", "", "29.2699", "51.2188", "Asia/Tehran"),
("140380", "Bojnurd", "Боджнурд", "IR", "364", "43", "", "", "", "37.47473", "57.32903", "Asia/Tehran"),
("140463", "Birjand", "Бирдженд", "IR", "364", "41", "", "", "", "32.86628", "59.22114", "Asia/Tehran"),
("140521", "Bijar", "Биджар", "IR", "364", "16", "", "", "", "35.8668", "47.60506", "Asia/Tehran"),
("140889", "Bonab", "Бонаб", "IR", "364", "33", "", "", "", "37.3404", "46.0561", "Asia/Tehran"),
("140918", "Behshahr", "Бехшехр", "IR", "364", "35", "", "", "", "36.69235", "53.55262", "Asia/Tehran"),
("140951", "Behbahan", "", "IR", "364", "15", "", "", "", "30.5959", "50.2417", "Asia/Tehran"),
("141584", "Baneh", "Бани", "IR", "364", "16", "", "", "", "35.9975", "45.8853", "Asia/Tehran"),
("141665", "Bandar-e Lengeh", "", "IR", "364", "11", "", "", "", "26.55792", "54.88067", "Asia/Tehran"),
("141679", "Bandar-e Anzali", "", "IR", "364", "08", "", "", "", "37.47258", "49.4593", "Asia/Tehran"),
("141681", "Bandar 'Abbas", "Бендер-Аббас", "IR", "364", "11", "", "", "", "27.1865", "56.2808", "Asia/Tehran"),
("141736", "Bam", "Бам", "IR", "364", "29", "", "", "", "29.106", "58.357", "Asia/Tehran"),
("142000", "Bahar", "Бахар", "IR", "364", "09", "", "", "", "34.9072", "48.4414", "Asia/Tehran"),
("142255", "Bafq", "Бафк", "IR", "364", "40", "", "", "", "31.6035", "55.40249", "Asia/Tehran"),
("142358", "Babolsar", "", "IR", "364", "35", "", "", "", "36.70251", "52.6576", "Asia/Tehran"),
("142363", "Babol", "Баболь", "IR", "364", "35", "", "", "", "36.55132", "52.67895", "Asia/Tehran"),
("142496", "Azna", "", "IR", "364", "23", "", "", "", "33.6095", "48.9307", "Asia/Tehran"),
("142554", "Hashtrud", "", "IR", "364", "33", "", "", "", "37.4779", "47.0508", "Asia/Tehran"),
("142676", "Astara", "Астара", "IR", "364", "08", "449649", "", "", "38.4291", "48.872", "Asia/Tehran"),
("142679", "Astaneh-ye Ashrafiyeh", "", "IR", "364", "08", "", "", "", "37.25962", "49.94444", "Asia/Tehran"),
("142872", "Asadabad", "Асадабада", "IR", "364", "09", "", "", "", "34.78241", "48.11853", "Asia/Tehran"),
("143052", "Ardestan", "", "IR", "364", "28", "", "", "", "33.3761", "52.3694", "Asia/Tehran"),
("143073", "Ardakan", "", "IR", "364", "40", "", "", "", "32.31001", "54.01747", "Asia/Tehran"),
("143083", "Ardabil", "", "IR", "364", "32", "", "", "", "38.2498", "48.2933", "Asia/Tehran"),
("143127", "Arak", "Эрак", "IR", "364", "34", "", "", "", "34.09174", "49.68916", "Asia/Tehran"),
("143534", "Amol", "Амоль", "IR", "364", "35", "", "", "", "36.46961", "52.35072", "Asia/Tehran"),
("143748", "Alvand", "Алванд", "IR", "364", "36", "", "", "", "36.3187", "49.1678", "Asia/Tehran"),
("143860", "Shahriar", "Шахрияр", "IR", "364", "26", "", "", "", "35.65884", "51.05775", "Asia/Tehran"),
("143921", "Aligudarz", "Алигударз", "IR", "364", "23", "", "", "", "33.40063", "49.6949", "Asia/Tehran"),
("144269", "Aleshtar", "", "IR", "364", "23", "", "", "", "33.86419", "48.26258", "Asia/Tehran"),
("144410", "Akbarabad", "Акбарабад", "IR", "364", "07", "", "", "", "29.2464", "52.7793", "Asia/Tehran"),
("144443", "`Ajab Shir", "", "IR", "364", "33", "", "", "", "37.4776", "45.8943", "Asia/Tehran"),
("144448", "Ahvaz", "Ахваз", "IR", "364", "15", "", "", "", "31.31901", "48.6842", "Asia/Tehran"),
("144616", "Ahar", "Ахар", "IR", "364", "33", "", "", "", "38.4774", "47.0699", "Asia/Tehran"),
("144696", "Aghajari", "", "IR", "364", "15", "", "", "", "30.7006", "49.8315", "Asia/Tehran"),
("144794", "Abyek", "", "IR", "364", "34", "", "", "", "36.06667", "50.55", "Asia/Tehran"),
("145034", "Abhar", "Абхар", "IR", "364", "36", "", "", "", "36.1468", "49.218", "Asia/Tehran"),
("145233", "Abdanan", "", "IR", "364", "10", "", "", "", "32.9926", "47.4198", "Asia/Tehran"),
("145449", "Abadeh", "", "IR", "364", "07", "", "", "", "31.1608", "52.6506", "Asia/Tehran"),
("145459", "Abadan", "Абадан", "IR", "364", "15", "", "", "", "30.3392", "48.3043", "Asia/Tehran"),
("406993", "Eqbaliyeh", "", "IR", "364", "26", "", "", "", "35.3022", "51.5358", "Asia/Tehran"),
("417594", "Shahreza", "", "IR", "364", "28", "", "", "", "32.03389", "51.87944", "Asia/Tehran"),
("418521", "Rehnan", "", "IR", "364", "28", "", "", "", "32.68325", "51.60158", "Asia/Tehran"),
("418571", "Qahderijan", "", "IR", "364", "28", "", "", "", "32.5767", "51.455", "Asia/Tehran"),
("418606", "Najafabad", "Наджафабад", "IR", "364", "28", "", "", "", "32.6344", "51.3668", "Asia/Tehran"),
("418710", "Khomeyni Shahr", "", "IR", "364", "28", "", "", "", "32.6856", "51.53609", "Asia/Tehran"),
("418723", "Kelishad va Sudarjan", "", "IR", "364", "28", "", "", "", "32.55118", "51.52758", "Asia/Tehran"),
("418851", "Felavarjan", "", "IR", "364", "28", "", "", "", "32.5553", "51.50974", "Asia/Tehran"),
("418863", "Isfahan", "Исфахан", "IR", "364", "28", "", "", "", "32.65246", "51.67462", "Asia/Tehran"),
("418868", "Dowlatabad", "", "IR", "364", "28", "", "", "", "32.79978", "51.69553", "Asia/Tehran"),
("418896", "Dorcheh Piaz", "", "IR", "364", "28", "", "", "", "32.61528", "51.55556", "Asia/Tehran"),
("1113217", "Zabol", "Заболь", "IR", "364", "04", "", "", "", "31.0306", "61.4949", "Asia/Tehran"),
("1159301", "Zahedan", "Захедан", "IR", "364", "04", "", "", "", "29.4963", "60.8629", "Asia/Tehran"),
("1159362", "Torbat-e Jam", "", "IR", "364", "42", "", "", "", "35.244", "60.6225", "Asia/Tehran"),
("1159384", "Taybad", "", "IR", "364", "42", "", "", "", "34.74", "60.7756", "Asia/Tehran"),
("1159716", "Sarakhs", "Сарахс", "IR", "364", "42", "", "", "", "36.5449", "61.1577", "Asia/Tehran"),
("1159877", "Qasr-e Qand", "", "IR", "364", "04", "", "", "", "26.24833", "60.7525", "Asia/Tehran"),
("1160571", "Khash", "Хаш", "IR", "364", "04", "", "", "", "28.22107", "61.21582", "Asia/Tehran"),
("1160939", "Iranshahr", "", "IR", "364", "04", "", "", "", "27.20245", "60.68476", "Asia/Tehran"),
("1161724", "Chabahar", "Чабахар", "IR", "364", "04", "", "", "", "25.2919", "60.643", "Asia/Tehran"),
("7100777", "Mahdishahr", "", "IR", "364", "25", "124337", "", "", "35.71071", "53.35394", "Asia/Tehran"),
("2633274", "Akureyri", "Акюрейри", "IS", "352", "40", "", "", "", "65.68353", "-18.0878", "Atlantic/Reykjavik"),
("3413829", "Reykjavik", "Рейкьявик", "IS", "352", "39", "", "", "", "64.13548", "-21.89541", "Atlantic/Reykjavik"),
("3415212", "Kopavogur", "Коупавогюр", "IS", "352", "39", "", "", "", "64.11234", "-21.91298", "Atlantic/Reykjavik"),
("3416706", "Hafnarfjoerdur", "Хабнарфьордюр", "IS", "352", "39", "", "", "", "64.0671", "-21.93774", "Atlantic/Reykjavik"),
("2522713", "Vittoria", "", "IT", "380", "15", "RG", "088012", "", "36.95151", "14.52788", "Europe/Rome"),
("2522767", "Villabate", "", "IT", "380", "15", "PA", "082079", "", "38.07789", "13.44275", "Europe/Rome"),
("2522776", "Vibo Valentia", "Вибо-Валентия", "IT", "380", "03", "VV", "102047", "", "38.67618", "16.10094", "Europe/Rome"),
("2522876", "Trapani", "Трапани", "IT", "380", "15", "TP", "081021", "", "38.01391", "12.54127", "Europe/Rome"),
("2522960", "Termini Imerese", "", "IT", "380", "15", "PA", "082070", "", "37.98225", "13.69729", "Europe/Rome"),
("2523083", "Siracusa", "Сиракуза", "IT", "380", "15", "SR", "089017", "", "37.08415", "15.27628", "Europe/Rome"),
("2523087", "Sinnai", "", "IT", "380", "14", "CA", "092080", "", "39.30286", "9.20283", "Europe/Rome"),
("2523113", "Siderno", "", "IT", "380", "03", "RC", "080088", "", "38.26993", "16.29607", "Europe/Rome"),
("2523136", "Sestu", "", "IT", "380", "14", "CA", "092074", "", "39.29846", "9.09248", "Europe/Rome"),
("2523166", "Selargius", "", "IT", "380", "14", "CA", "092068", "", "39.25779", "9.16323", "Europe/Rome"),
("2523180", "Scordia", "", "IT", "380", "15", "CT", "087049", "", "37.29548", "14.84058", "Europe/Rome"),
("2523192", "Scicli", "Шикли", "IT", "380", "15", "RG", "088011", "", "36.78831", "14.69883", "Europe/Rome"),
("2523194", "Sciacca", "", "IT", "380", "15", "AG", "084041", "", "37.50693", "13.08399", "Europe/Rome"),
("2523460", "San Giovanni la Punta", "", "IT", "380", "15", "CT", "087041", "", "37.5769", "15.09371", "Europe/Rome"),
("2523461", "San Giovanni in Fiore", "", "IT", "380", "03", "CS", "078119", "", "39.26291", "16.69531", "Europe/Rome"),
("2523513", "San Cataldo", "", "IT", "380", "15", "CL", "085016", "", "37.48412", "13.98542", "Europe/Rome"),
("2523577", "Rossano Stazione", "", "IT", "380", "03", "CS", "078108", "", "39.60196", "16.63475", "Europe/Rome"),
("2523581", "Rosolini", "", "IT", "380", "15", "SR", "089016", "", "36.82438", "14.94893", "Europe/Rome"),
("2523619", "Ribera", "Рибера", "IT", "380", "15", "AG", "084033", "", "37.49773", "13.26676", "Europe/Rome"),
("2523630", "Reggio Calabria", "Реджо-ди-Калабрия", "IT", "380", "03", "RC", "080063", "", "38.11047", "15.66129", "Europe/Rome"),
("2523650", "Ragusa", "Рагуза", "IT", "380", "15", "RG", "088009", "", "36.89639", "14.70689", "Europe/Rome"),
("2523664", "Quattromiglia", "", "IT", "380", "03", "CS", "078102", "", "39.34474", "16.23802", "Europe/Rome"),
("2523665", "Quartu Sant'Elena", "", "IT", "380", "14", "CA", "092051", "", "39.22935", "9.25004", "Europe/Rome"),
("2523693", "Pozzallo", "", "IT", "380", "15", "RG", "088008", "", "36.73028", "14.84672", "Europe/Rome"),
("2523705", "Porto Empedocle", "", "IT", "380", "15", "AG", "084028", "", "37.29117", "13.5161", "Europe/Rome"),
("2523796", "Piazza Armerina", "", "IT", "380", "15", "EN", "086014", "", "37.38417", "14.36921", "Europe/Rome"),
("2523866", "Paterno", "Патерно", "IT", "380", "15", "CT", "087033", "", "37.56675", "14.90254", "Europe/Rome"),
("2523871", "Partinico", "", "IT", "380", "15", "PA", "082054", "", "38.04822", "13.11915", "Europe/Rome"),
("2523902", "Palmi", "", "IT", "380", "03", "RC", "080057", "", "38.4069", "15.87173", "Europe/Rome"),
("2523908", "Palma di Montechiaro", "", "IT", "380", "15", "AG", "084027", "", "37.19066", "13.76603", "Europe/Rome"),
("2523920", "Palermo", "Палермо", "IT", "380", "15", "PA", "082053", "", "38.13205", "13.33561", "Europe/Rome"),
("2523927", "Palagonia", "", "IT", "380", "15", "CT", "087032", "", "37.32955", "14.74474", "Europe/Rome"),
("2523938", "Pachino", "Пакино", "IT", "380", "15", "SR", "089014", "", "36.71703", "15.09062", "Europe/Rome"),
("2523964", "Oristano", "Ористано", "IT", "380", "14", "OR", "095038", "", "39.89957", "8.59326", "Europe/Rome"),
("2523998", "Noto", "Ното", "IT", "380", "15", "SR", "089013", "", "36.89244", "15.06977", "Europe/Rome"),
("2524006", "Niscemi", "Нишеми", "IT", "380", "15", "CL", "085013", "", "37.14649", "14.39381", "Europe/Rome"),
("2524013", "Nicastro-Sambiase", "Никастро", "IT", "380", "03", "CZ", "079160", "", "38.96088", "16.31012", "Europe/Rome"),
("2524084", "Monserrato", "", "IT", "380", "14", "CA", "092109", "", "39.25974", "9.1384", "Europe/Rome"),
("2524085", "Monreale", "Монреаль", "IT", "380", "15", "PA", "082049", "", "38.07665", "13.29319", "Europe/Rome"),
("2524119", "Modica", "Модика", "IT", "380", "15", "RG", "088006", "", "36.8499", "14.76976", "Europe/Rome"),
("2524123", "Misterbianco", "", "IT", "380", "15", "CT", "087029", "", "37.51563", "15.02999", "Europe/Rome"),
("2524126", "Misilmeri", "", "IT", "380", "15", "PA", "082048", "", "38.02776", "13.45047", "Europe/Rome"),
("2524155", "Milazzo", "Милаццо", "IT", "380", "15", "ME", "083049", "", "38.2096", "15.24078", "Europe/Rome"),
("2524170", "Messina", "Мессина", "IT", "380", "15", "ME", "083048", "", "38.19394", "15.55256", "Europe/Rome"),
("2524205", "Mazara del Vallo", "", "IT", "380", "15", "TP", "081012", "", "37.65418", "12.59304", "Europe/Rome"),
("2524236", "Mascalucia", "Маскалуча", "IT", "380", "15", "CT", "087024", "", "37.58834", "15.03998", "Europe/Rome"),
("2524245", "Marsala", "Марсала", "IT", "380", "15", "TP", "081011", "", "37.86736", "12.4983", "Europe/Rome"),
("2524393", "Licata", "", "IT", "380", "15", "AG", "084021", "", "37.10837", "13.94487", "Europe/Rome"),
("2524410", "Lentini", "Лентини", "IT", "380", "15", "SR", "089011", "", "37.28929", "14.99644", "Europe/Rome"),
("2524533", "Iglesias", "Иглезиас", "IT", "380", "14", "CI", "107009", "", "39.3092", "8.5372", "Europe/Rome"),
("2524606", "Gioia Tauro", "", "IT", "380", "03", "RC", "080038", "", "38.4251", "15.8975", "Europe/Rome"),
("2524618", "Giarre", "Джарре", "IT", "380", "15", "CT", "087017", "", "37.72", "15.17584", "Europe/Rome"),
("2524653", "Gela", "", "IT", "380", "15", "CL", "085007", "", "37.0757", "14.23704", "Europe/Rome"),
("2524734", "Floridia", "Флоридии", "IT", "380", "15", "SR", "089009", "", "37.08507", "15.15414", "Europe/Rome"),
("2524786", "Favara", "", "IT", "380", "15", "AG", "084017", "", "37.31754", "13.66226", "Europe/Rome"),
("2524819", "Enna", "Энна", "IT", "380", "15", "EN", "086009", "", "37.5577", "14.28551", "Europe/Rome"),
("2524881", "Crotone", "Кротоне", "IT", "380", "03", "KR", "101010", "", "39.0823", "17.10997", "Europe/Rome"),
("2524907", "Cosenza", "Козенца", "IT", "380", "03", "CS", "078045", "", "39.30422", "16.25201", "Europe/Rome"),
("2524955", "Comiso", "Комизо", "IT", "380", "15", "RG", "088003", "", "36.95587", "14.60112", "Europe/Rome"),
("2525059", "Catanzaro", "Катандзаро", "IT", "380", "03", "CZ", "079023", "", "38.88247", "16.60086", "Europe/Rome"),
("2525068", "Catania", "Катания", "IT", "380", "15", "CT", "087015", "", "37.49223", "15.07041", "Europe/Rome"),
("2525070", "Castrovillari", "Кастровиллари", "IT", "380", "03", "CS", "078033", "", "39.81949", "16.21467", "Europe/Rome"),
("2525083", "Castelvetrano", "Кастельветрано", "IT", "380", "15", "TP", "081006", "", "37.68081", "12.79194", "Europe/Rome"),
("2525207", "Casarano", "", "IT", "380", "13", "LE", "075016", "", "40.01311", "18.1634", "Europe/Rome"),
("2525350", "Carini", "Карина", "IT", "380", "15", "PA", "082021", "", "38.15535", "13.18102", "Europe/Rome"),
("2525362", "Carbonia", "Карбония", "IT", "380", "14", "CI", "107003", "", "39.16465", "8.5213", "Europe/Rome"),
("2525405", "Canicatti", "", "IT", "380", "15", "AG", "084011", "", "37.35842", "13.84786", "Europe/Rome"),
("2525448", "Caltanissetta", "Кальтаниссетта", "IT", "380", "15", "CL", "085004", "", "37.48997", "14.05163", "Europe/Rome"),
("2525450", "Caltagirone", "Кальтаджироне", "IT", "380", "15", "CT", "087011", "", "37.21609", "14.51762", "Europe/Rome"),
("2525473", "Cagliari", "Кальяри", "IT", "380", "14", "CA", "092009", "", "39.23054", "9.11917", "Europe/Rome"),
("2525498", "Bronte", "Бронте", "IT", "380", "15", "CT", "087009", "", "37.78863", "14.83377", "Europe/Rome"),
("2525560", "Biancavilla", "", "IT", "380", "15", "CT", "087008", "", "37.64442", "14.86685", "Europe/Rome"),
("2525571", "Belpasso", "", "IT", "380", "15", "CT", "087007", "", "37.59192", "14.97985", "Europe/Rome"),
("2525597", "Barcellona Pozzo di Gotto", "", "IT", "380", "15", "ME", "083005", "", "38.15697", "15.21276", "Europe/Rome"),
("2525628", "Bagheria", "Багерия", "IT", "380", "15", "PA", "082006", "", "38.07892", "13.51236", "Europe/Rome"),
("2525643", "Avola", "", "IT", "380", "15", "SR", "089002", "", "36.9084", "15.13937", "Europe/Rome"),
("2525646", "Augusta", "", "IT", "380", "15", "SR", "089001", "", "37.25784", "15.23257", "Europe/Rome"),
("2525655", "Assemini", "Ассемини", "IT", "380", "14", "CA", "092003", "", "39.28982", "9.00366", "Europe/Rome"),
("2525725", "Amato", "", "IT", "380", "03", "RC", "080071", "", "38.38333", "16.13333", "Europe/Rome"),
("2525755", "Alcamo", "Алькамо", "IT", "380", "15", "TP", "081001", "", "37.99724", "12.94323", "Europe/Rome"),
("2525764", "Agrigento", "Агридженто", "IT", "380", "15", "AG", "084001", "", "37.32744", "13.59351", "Europe/Rome"),
("2525769", "Adrano", "Адрано", "IT", "380", "15", "CT", "087006", "", "37.66765", "14.83751", "Europe/Rome"),
("2525790", "Acireale", "", "IT", "380", "15", "CT", "087004", "", "37.62606", "15.16325", "Europe/Rome"),
("2525791", "Aci Catena", "", "IT", "380", "15", "CT", "087003", "", "37.59596", "15.13981", "Europe/Rome"),
("2525792", "Aci Castello", "", "IT", "380", "15", "CT", "087002", "", "37.55564", "15.14535", "Europe/Rome"),
("3163853", "Zola Predosa", "", "IT", "380", "05", "BO", "037060", "", "44.48966", "11.21831", "Europe/Rome"),
("3163995", "Voghera", "", "IT", "380", "09", "PV", "018182", "", "44.99467", "9.00862", "Europe/Rome"),
("3164028", "Vittorio Veneto", "Витторио-Венето", "IT", "380", "20", "TV", "026092", "", "45.97797", "12.30559", "Europe/Rome"),
("3164039", "Viterbo", "Витербо", "IT", "380", "07", "VT", "056059", "", "42.42322", "12.11141", "Europe/Rome"),
("3164080", "Vimodrone", "", "IT", "380", "09", "MI", "015242", "", "45.51461", "9.28772", "Europe/Rome"),
("3164083", "Vimercate", "Вимеркате", "IT", "380", "09", "MB", "108050", "", "45.61545", "9.36801", "Europe/Rome"),
("3164090", "Lancenigo-Villorba", "", "IT", "380", "20", "TV", "026091", "", "45.71289", "12.25697", "Europe/Rome"),
("3164153", "Villaricca", "Вилларикка", "IT", "380", "04", "NA", "063087", "", "40.91866", "14.18109", "Europe/Rome"),
("3164241", "Villafranca di Verona", "", "IT", "380", "20", "VR", "023096", "", "45.35807", "10.84939", "Europe/Rome"),
("3164342", "Vignola", "", "IT", "380", "05", "MO", "036046", "", "44.48758", "11.0058", "Europe/Rome"),
("3164376", "Vigevano", "Виджевано", "IT", "380", "09", "PV", "018177", "", "45.31407", "8.85437", "Europe/Rome"),
("3164419", "Vicenza", "Виченца", "IT", "380", "20", "VI", "024116", "", "45.54672", "11.5475", "Europe/Rome"),
("3164433", "Viareggio", "Виареджио", "IT", "380", "16", "LU", "046033", "", "43.87145", "10.25581", "Europe/Rome"),
("3164527", "Verona", "Верона", "IT", "380", "20", "VR", "023091", "", "45.4299", "10.98444", "Europe/Rome"),
("3164565", "Vercelli", "Верчелли", "IT", "380", "12", "VC", "002158", "", "45.32163", "8.41989", "Europe/Rome"),
("3164582", "Ventimiglia", "Вентимилья", "IT", "380", "08", "IM", "008065", "", "43.78956", "7.60872", "Europe/Rome"),
("3164603", "Venice", "Венеция", "IT", "380", "20", "VE", "027042", "", "45.43713", "12.33265", "Europe/Rome"),
("3164617", "Venaria Reale", "", "IT", "380", "12", "TO", "001292", "", "45.12597", "7.63136", "Europe/Rome"),
("3164630", "Velletri", "", "IT", "380", "07", "RM", "058111", "", "41.66784", "12.78103", "Europe/Rome"),
("3164672", "Vasto", "Васто", "IT", "380", "01", "CH", "069099", "", "42.12198", "14.70408", "Europe/Rome"),
("3164699", "Varese", "Варезе", "IT", "380", "09", "VA", "012133", "", "45.81934", "8.82223", "Europe/Rome"),
("3164919", "Valenzano", "", "IT", "380", "13", "BA", "072048", "", "41.04615", "16.88383", "Europe/Rome"),
("3164920", "Valenza", "Валенса", "IT", "380", "12", "AL", "006177", "", "45.01335", "8.63621", "Europe/Rome"),
("3164954", "Valdagno", "", "IT", "380", "20", "VI", "024111", "", "45.64498", "11.29886", "Europe/Rome"),
("3165072", "Udine", "Удине", "IT", "380", "06", "UD", "030129", "", "46.0637", "13.24458", "Europe/Rome"),
("3165178", "Triggiano", "", "IT", "380", "13", "BA", "072046", "", "41.06549", "16.92501", "Europe/Rome"),
("3165185", "Trieste", "Триест", "IT", "380", "06", "TS", "032006", "", "45.64325", "13.7903", "Europe/Rome"),
("3165198", "Trezzano sul Naviglio", "", "IT", "380", "09", "MI", "015220", "", "45.42212", "9.06342", "Europe/Rome"),
("3165201", "Treviso", "Тревизо", "IT", "380", "20", "TV", "026086", "", "45.66908", "12.23614", "Europe/Rome"),
("3165207", "Treviglio", "Тревильо", "IT", "380", "09", "BG", "016219", "", "45.52081", "9.59102", "Europe/Rome"),
("3165240", "Trentola-Ducenta", "", "IT", "380", "04", "CE", "061094", "", "40.97517", "14.1749", "Europe/Rome"),
("3165243", "Trento", "Тренто", "IT", "380", "17", "TN", "022205", "", "46.06787", "11.12108", "Europe/Rome"),
("3165275", "Trecate", "", "IT", "380", "12", "NO", "003149", "", "45.43399", "8.7364", "Europe/Rome"),
("3165322", "Trani", "Трани", "IT", "380", "13", "BT", "110009", "", "41.27733", "16.41011", "Europe/Rome"),
("3165340", "Tradate", "", "IT", "380", "09", "VA", "012127", "", "45.70843", "8.90763", "Europe/Rome"),
("3165370", "Tortona", "Тортона", "IT", "380", "12", "AL", "006174", "", "44.89784", "8.86374", "Europe/Rome"),
("3165435", "Torremaggiore", "", "IT", "380", "13", "FG", "071056", "", "41.69115", "15.29691", "Europe/Rome"),
("3165456", "Torre del Greco", "Торре-дель-Греко", "IT", "380", "04", "NA", "063084", "", "40.77939", "14.39782", "Europe/Rome"),
("3165475", "Torre Annunziata", "Торре-Аннунциата", "IT", "380", "04", "NA", "063083", "", "40.75011", "14.45886", "Europe/Rome"),
("3165524", "Turin", "Турин", "IT", "380", "12", "TO", "001272", "", "45.07049", "7.68682", "Europe/Rome"),
("3165595", "Tolentino", "", "IT", "380", "10", "MC", "043053", "", "43.21173", "13.2886", "Europe/Rome"),
("3165624", "Tivoli", "Тиволи", "IT", "380", "07", "RM", "058104", "", "41.95781", "12.80317", "Europe/Rome"),
("3165698", "Thiene", "Тьене", "IT", "380", "20", "VI", "024105", "", "45.7088", "11.47959", "Europe/Rome"),
("3165737", "Terzigno", "", "IT", "380", "04", "NA", "063082", "", "40.804", "14.49309", "Europe/Rome"),
("3165762", "Terracina", "Террачина", "IT", "380", "07", "LT", "059032", "", "41.28575", "13.20135", "Europe/Rome"),
("3165771", "Terni", "Терни", "IT", "380", "18", "TR", "055032", "", "42.56184", "12.63667", "Europe/Rome"),
("3165773", "Termoli", "Термоли", "IT", "380", "11", "CB", "070078", "", "41.98944", "14.9926", "Europe/Rome"),
("3165788", "Terlizzi", "Терлицци", "IT", "380", "13", "BA", "072043", "", "41.12905", "16.54536", "Europe/Rome"),
("3165803", "Teramo", "Терамо", "IT", "380", "01", "TE", "067041", "", "42.66123", "13.69901", "Europe/Rome"),
("3165926", "Taranto", "Таранто", "IT", "380", "13", "TA", "073027", "", "40.41639", "17.25478", "Europe/Rome"),
("3166006", "Suzzara", "", "IT", "380", "09", "MN", "020065", "", "44.99266", "10.74941", "Europe/Rome"),
("3166034", "Sulmona", "Сулмона", "IT", "380", "01", "AQ", "066098", "", "42.04945", "13.92578", "Europe/Rome"),
("3166236", "Spoleto", "Сполето", "IT", "380", "18", "PG", "054051", "", "42.75649", "12.72051", "Europe/Rome"),
("3166387", "Sora", "Сора", "IT", "380", "07", "FR", "060074", "", "41.71288", "13.60251", "Europe/Rome"),
("3166397", "Sondrio", "Сондрио", "IT", "380", "09", "SO", "014061", "", "46.16852", "9.87134", "Europe/Rome"),
("3166404", "Somma Vesuviana", "", "IT", "380", "04", "NA", "063079", "", "40.88094", "14.44262", "Europe/Rome"),
("3166548", "Siena", "Сиена", "IT", "380", "16", "SI", "052032", "", "43.32215", "11.3259", "Europe/Rome"),
("3166571", "Sezze", "", "IT", "380", "07", "LT", "059028", "", "41.50938", "13.07698", "Europe/Rome"),
("3166574", "Seveso", "", "IT", "380", "09", "MB", "108040", "", "45.64399", "9.14838", "Europe/Rome"),
("3166576", "Settimo Torinese", "", "IT", "380", "12", "TO", "001265", "", "45.14072", "7.76376", "Europe/Rome"),
("3166595", "Sestri Levante", "", "IT", "380", "08", "GE", "010059", "", "44.27317", "9.39683", "Europe/Rome"),
("3166598", "Sesto San Giovanni", "", "IT", "380", "09", "MI", "015209", "", "45.53449", "9.23401", "Europe/Rome"),
("3166601", "Sesto Fiorentino", "", "IT", "380", "16", "FI", "048043", "", "43.83193", "11.19924", "Europe/Rome"),
("3166706", "Seriate", "Сериате", "IT", "380", "09", "BG", "016198", "", "45.68225", "9.72715", "Europe/Rome"),
("3166711", "Seregno", "", "IT", "380", "09", "MB", "108039", "", "45.65002", "9.20548", "Europe/Rome"),
("3166740", "Senigallia", "Сенигаллия", "IT", "380", "10", "AN", "042045", "", "43.71626", "13.20882", "Europe/Rome"),
("3166753", "Senago", "", "IT", "380", "09", "MI", "015206", "", "45.57562", "9.1262", "Europe/Rome"),
("3166808", "Segrate", "", "IT", "380", "09", "MI", "015205", "", "45.49624", "9.29323", "Europe/Rome"),
("3166917", "Schio", "Скио", "IT", "380", "20", "VI", "024100", "", "45.71262", "11.35671", "Europe/Rome"),
("3166988", "Scandicci", "Скандиччи", "IT", "380", "16", "FI", "048041", "", "43.75423", "11.18794", "Europe/Rome"),
("3167010", "Scafati", "", "IT", "380", "04", "SA", "065137", "", "40.75766", "14.52919", "Europe/Rome"),
("3167022", "Savona", "Савона", "IT", "380", "08", "SV", "009056", "", "44.30905", "8.47715", "Europe/Rome"),
("3167034", "Savigliano", "", "IT", "380", "12", "CN", "004215", "", "44.64808", "7.65677", "Europe/Rome"),
("3167044", "Sava", "", "IT", "380", "13", "TA", "073026", "", "40.40203", "17.55267", "Europe/Rome"),
("3167053", "Sassuolo", "Сассуоло", "IT", "380", "05", "MO", "036040", "", "44.54826", "10.78962", "Europe/Rome"),
("3167096", "Sassari", "Сассари", "IT", "380", "14", "SS", "090064", "", "40.72787", "8.55037", "Europe/Rome"),
("3167104", "Sarzana", "", "IT", "380", "08", "SP", "011027", "", "44.11045", "9.96541", "Europe/Rome"),
("3167113", "Saronno", "", "IT", "380", "09", "VA", "012119", "", "45.62513", "9.03517", "Europe/Rome"),
("3167116", "Sarno", "Сарно", "IT", "380", "04", "SA", "065135", "", "40.80748", "14.62151", "Europe/Rome"),
("3167184", "San Vito dei Normanni", "", "IT", "380", "13", "BR", "074017", "", "40.65642", "17.70814", "Europe/Rome"),
("3167327", "Santeramo in Colle", "", "IT", "380", "13", "BA", "072041", "", "40.79236", "16.75873", "Europe/Rome"),
("3167393", "Sant'Antonio Abate", "", "IT", "380", "04", "NA", "063074", "", "40.72152", "14.54021", "Europe/Rome"),
("3167419", "Sant'Antimo", "", "IT", "380", "04", "NA", "063073", "", "40.94223", "14.23476", "Europe/Rome"),
("3167509", "Sant'Anastasia", "", "IT", "380", "04", "NA", "063072", "", "40.87258", "14.39744", "Europe/Rome"),
("3167561", "Santa Maria Capua Vetere", "Санта-Мария-Капуа-Ветере", "IT", "380", "04", "CE", "061083", "", "41.08156", "14.25342", "Europe/Rome"),
("3167731", "San Severo", "", "IT", "380", "13", "FG", "071051", "", "41.68564", "15.38148", "Europe/Rome"),
("3167744", "San Sebastiano", "", "IT", "380", "09", "BS", "017096", "", "45.65192", "10.25681", "Europe/Rome"),
("3167751", "San Salvo", "", "IT", "380", "01", "CH", "069083", "", "42.04592", "14.73922", "Europe/Rome"),
("3167777", "San Remo", "Сан-Ремо", "IT", "380", "08", "IM", "008055", "", "43.81725", "7.7772", "Europe/Rome"),
("3167940", "Sannicandro Garganico", "", "IT", "380", "13", "FG", "071049", "", "41.83844", "15.56535", "Europe/Rome"),
("3167953", "San Miniato", "", "IT", "380", "16", "PI", "050032", "", "43.69285", "10.7831", "Europe/Rome"),
("3167954", "San Miniato Basso", "", "IT", "380", "16", "PI", "050032", "", "43.69403", "10.84522", "Europe/Rome"),
("3167978", "San Mauro Torinese", "", "IT", "380", "12", "TO", "001249", "", "45.10359", "7.76803", "Europe/Rome"),
("3168175", "San Lazzaro", "", "IT", "380", "05", "BO", "037054", "", "44.46777", "11.41401", "Europe/Rome"),
("3168209", "San Giuseppe Vesuviano", "", "IT", "380", "04", "NA", "063068", "", "40.83034", "14.50342", "Europe/Rome"),
("3168222", "San Giuliano Milanese", "", "IT", "380", "09", "MI", "015195", "", "45.39574", "9.28757", "Europe/Rome"),
("3168231", "San Giovanni Valdarno", "", "IT", "380", "16", "AR", "051033", "", "43.56157", "11.53316", "Europe/Rome"),
("3168234", "San Giovanni Rotondo", "", "IT", "380", "13", "FG", "071046", "", "41.70643", "15.7277", "Europe/Rome"),
("3168236", "San Giovanni Lupatoto", "", "IT", "380", "20", "VR", "023071", "", "45.38506", "11.03458", "Europe/Rome"),
("3168239", "San Giovanni in Persiceto", "", "IT", "380", "05", "BO", "037053", "", "44.63838", "11.18419", "Europe/Rome"),
("3168309", "San Giorgio a Cremano", "", "IT", "380", "04", "NA", "063067", "", "40.83369", "14.33894", "Europe/Rome"),
("3168414", "San Donato Milanese", "", "IT", "380", "09", "MI", "015192", "", "45.4199", "9.26628", "Europe/Rome"),
("3168429", "San Dona di Piave", "", "IT", "380", "20", "VE", "027033", "", "45.63488", "12.57211", "Europe/Rome"),
("3168514", "San Bonifacio", "", "IT", "380", "20", "VR", "023069", "", "45.39662", "11.28768", "Europe/Rome"),
("3168550", "San Benedetto del Tronto", "", "IT", "380", "10", "AP", "044066", "", "42.90805", "13.88276", "Europe/Rome"),
("3168627", "Salsomaggiore Terme", "", "IT", "380", "05", "PR", "034032", "", "44.81592", "9.98637", "Europe/Rome"),
("3168673", "Salerno", "Салерно", "IT", "380", "04", "SA", "065116", "", "40.67545", "14.79328", "Europe/Rome"),
("3168730", "Sacile", "", "IT", "380", "06", "PN", "093037", "", "45.95412", "12.50274", "Europe/Rome"),
("3168770", "Ruvo di Puglia", "", "IT", "380", "13", "BA", "072038", "", "41.11658", "16.48974", "Europe/Rome"),
("3168775", "Rutigliano", "", "IT", "380", "13", "BA", "072037", "", "41.00997", "17.00558", "Europe/Rome"),
("3168837", "Rozzano", "", "IT", "380", "09", "MI", "015189", "", "45.38544", "9.16088", "Europe/Rome"),
("3168843", "Rovigo", "Ровиго", "IT", "380", "20", "RO", "029041", "", "45.07387", "11.79109", "Europe/Rome"),
("3168854", "Rovereto", "Роверето", "IT", "380", "17", "TN", "022161", "", "45.88204", "11.03647", "Europe/Rome"),
("3168930", "Rosignano Solvay-Castiglioncello", "", "IT", "380", "16", "LI", "049017", "", "43.38946", "10.43615", "Europe/Rome"),
("3168936", "Roseto degli Abruzzi", "", "IT", "380", "01", "TE", "067037", "", "42.67164", "14.01481", "Europe/Rome"),
("3169056", "Romano di Lombardia", "", "IT", "380", "09", "BG", "016183", "", "45.52184", "9.75233", "Europe/Rome"),
("3169070", "Rome", "Рим", "IT", "380", "07", "RM", "058091", "", "41.89193", "12.51133", "Europe/Rome"),
("3169181", "Rocca di Papa", "", "IT", "380", "07", "RM", "058086", "", "41.7658", "12.70188", "Europe/Rome"),
("3169231", "Rivoli", "Риволи", "IT", "380", "12", "TO", "001219", "", "45.07021", "7.52658", "Europe/Rome"),
("3169361", "Rimini", "Римини", "IT", "380", "05", "RN", "099014", "", "44.05755", "12.56528", "Europe/Rome"),
("3169412", "Rieti", "Риети", "IT", "380", "07", "RI", "057059", "", "42.42277", "12.91436", "Europe/Rome"),
("3169424", "Riccione", "", "IT", "380", "05", "RN", "099013", "", "43.99942", "12.65689", "Europe/Rome"),
("3169447", "Rho", "Ро", "IT", "380", "09", "MI", "015182", "", "45.52812", "9.05182", "Europe/Rome"),
("3169522", "Reggio nell'Emilia", "Реджо-Эмилия", "IT", "380", "05", "RE", "035033", "", "44.69825", "10.63125", "Europe/Rome"),
("3169561", "Ravenna", "Равенна", "IT", "380", "05", "RA", "039014", "", "44.41344", "12.20121", "Europe/Rome"),
("3169602", "Rapallo", "Рапалло", "IT", "380", "08", "GE", "010046", "", "44.3496", "9.22796", "Europe/Rome"),
("3169724", "Qualiano", "", "IT", "380", "04", "NA", "063062", "", "40.92269", "14.14844", "Europe/Rome"),
("3169742", "Putignano", "Путиньяно", "IT", "380", "13", "BA", "072036", "", "40.85106", "17.1219", "Europe/Rome"),
("3169921", "Prato", "Прато", "IT", "380", "16", "PO", "100005", "", "43.87309", "11.08278", "Europe/Rome"),
("3169984", "Pozzuoli", "", "IT", "380", "04", "NA", "063060", "", "40.82767", "14.15321", "Europe/Rome"),
("3170027", "Potenza", "", "IT", "380", "02", "PZ", "076063", "", "40.64175", "15.80794", "Europe/Rome"),
("3170069", "Porto Torres", "Порто-Торрес", "IT", "380", "14", "SS", "090058", "", "40.83126", "8.37519", "Europe/Rome"),
("3170072", "Porto Sant'Elpidio", "", "IT", "380", "10", "FM", "109034", "", "43.25297", "13.7597", "Europe/Rome"),
("3170073", "Porto San Giorgio", "", "IT", "380", "10", "FM", "109033", "", "43.17784", "13.79411", "Europe/Rome"),
("3170086", "Portogruaro", "", "IT", "380", "20", "VE", "027029", "", "45.78071", "12.84052", "Europe/Rome"),
("3170102", "Civitanova Marche", "", "IT", "380", "10", "MC", "043013", "", "43.30696", "13.72058", "Europe/Rome"),
("3170116", "Portici", "Портичи", "IT", "380", "04", "NA", "063059", "", "40.81563", "14.33716", "Europe/Rome"),
("3170147", "Pordenone", "Порденоне", "IT", "380", "06", "PN", "093033", "", "45.95689", "12.66051", "Europe/Rome"),
("3170272", "Pontedera", "", "IT", "380", "16", "PI", "050029", "", "43.66141", "10.63067", "Europe/Rome"),
("3170335", "Pompei", "Помпеи", "IT", "380", "04", "NA", "063058", "", "40.74574", "14.49698", "Europe/Rome"),
("3170341", "Pomigliano d'Arco", "", "IT", "380", "04", "NA", "063057", "", "40.90796", "14.38493", "Europe/Rome"),
("3170342", "Pomezia", "", "IT", "380", "07", "RM", "058079", "", "41.66369", "12.50015", "Europe/Rome"),
("3170457", "Poggiomarino", "", "IT", "380", "04", "NA", "063055", "", "40.80311", "14.53904", "Europe/Rome"),
("3170504", "Poggibonsi", "Поджибонси", "IT", "380", "16", "SI", "052022", "", "43.47064", "11.14804", "Europe/Rome"),
("3170621", "Pistoia", "Пистойя", "IT", "380", "16", "PT", "047014", "", "43.93064", "10.92365", "Europe/Rome"),
("3170647", "Pisa", "Пиза", "IT", "380", "16", "PI", "050026", "", "43.70853", "10.4036", "Europe/Rome"),
("3170659", "Piossasco", "", "IT", "380", "12", "TO", "001194", "", "44.98802", "7.4601", "Europe/Rome"),
("3170674", "Piombino", "Пьомбино", "IT", "380", "16", "LI", "049012", "", "42.93347", "10.52757", "Europe/Rome"),
("3170676", "Pioltello", "", "IT", "380", "09", "MI", "015175", "", "45.50502", "9.33151", "Europe/Rome"),
("3170694", "Pinerolo", "Пинероло", "IT", "380", "12", "TO", "001191", "", "44.88534", "7.33135", "Europe/Rome"),
("3170778", "Pietrasanta", "Пиетрасанта", "IT", "380", "16", "LU", "046024", "", "43.94519", "10.21827", "Europe/Rome"),
("3171058", "Piacenza", "Пьяченца", "IT", "380", "05", "PC", "033032", "", "45.04202", "9.70462", "Europe/Rome"),
("3171168", "Pescara", "Пескара", "IT", "380", "01", "PE", "068028", "", "42.4584", "14.20283", "Europe/Rome"),
("3171173", "Pesaro", "Пезаро", "IT", "380", "10", "PU", "041044", "", "43.90121", "12.895", "Europe/Rome"),
("3171180", "Perugia", "Перуджа", "IT", "380", "18", "PG", "054039", "", "43.1122", "12.38878", "Europe/Rome"),
("3171366", "Pavia", "Павия", "IT", "380", "09", "PV", "018110", "", "45.19205", "9.15917", "Europe/Rome"),
("3171457", "Parma", "Парма", "IT", "380", "05", "PR", "034027", "", "44.79935", "10.32618", "Europe/Rome"),
("3171484", "Parabiago", "", "IT", "380", "09", "MI", "015168", "", "45.55405", "8.94838", "Europe/Rome"),
("3171562", "Palo del Colle", "Пало-дель-Колле", "IT", "380", "13", "BA", "072033", "", "41.05562", "16.70321", "Europe/Rome"),
("3171586", "Palazzolo sull'Oglio", "", "IT", "380", "09", "BS", "017133", "", "45.59816", "9.8942", "Europe/Rome"),
("3171664", "Palagiano", "", "IT", "380", "13", "TA", "073021", "", "40.57762", "17.03812", "Europe/Rome"),
("3171703", "Pagani", "", "IT", "380", "04", "SA", "065088", "", "40.74989", "14.6098", "Europe/Rome"),
("3171728", "Padova", "Падуя", "IT", "380", "20", "PD", "028060", "", "45.40797", "11.88586", "Europe/Rome"),
("3171737", "Paderno Dugnano", "", "IT", "380", "09", "MI", "015166", "", "45.56899", "9.16483", "Europe/Rome"),
("3171778", "Ottaviano", "", "IT", "380", "04", "NA", "063051", "", "40.84985", "14.49341", "Europe/Rome"),
("3171786", "Ostuni", "Остуни", "IT", "380", "13", "BR", "074012", "", "40.72484", "17.57922", "Europe/Rome"),
("3171848", "Osimo", "Осимо", "IT", "380", "10", "AN", "042034", "", "43.48206", "13.48766", "Europe/Rome"),
("3171900", "Orta Nova", "", "IT", "380", "13", "FG", "071036", "", "41.32879", "15.70994", "Europe/Rome"),
("3171986", "Orbassano", "Орбассано", "IT", "380", "12", "TO", "001171", "", "45.00547", "7.53813", "Europe/Rome"),
("3172087", "Olbia", "Ольбия", "IT", "380", "14", "OT", "104017", "", "40.92334", "9.50395", "Europe/Rome"),
("3172116", "Oderzo", "", "IT", "380", "20", "TV", "026051", "", "45.7862", "12.49547", "Europe/Rome"),
("3172154", "Nuoro", "Нуоро", "IT", "380", "14", "NU", "091051", "", "40.31949", "9.31394", "Europe/Rome"),
("3172170", "Novi Ligure", "Нови-Лигуре", "IT", "380", "12", "AL", "006114", "", "44.76459", "8.78981", "Europe/Rome"),
("3172184", "Novate Milanese", "", "IT", "380", "09", "MI", "015157", "", "45.5305", "9.13954", "Europe/Rome"),
("3172189", "Novara", "Новара", "IT", "380", "12", "NO", "003106", "", "45.44834", "8.62328", "Europe/Rome"),
("3172191", "Nova Milanese", "", "IT", "380", "09", "MB", "108035", "", "45.58882", "9.19792", "Europe/Rome"),
("3172227", "Nola", "", "IT", "380", "04", "NA", "063050", "", "40.92606", "14.52816", "Europe/Rome"),
("3172228", "Noicattaro", "", "IT", "380", "13", "BA", "072032", "", "41.03449", "16.98963", "Europe/Rome"),
("3172240", "Noci", "", "IT", "380", "13", "BA", "072031", "", "40.79356", "17.12681", "Europe/Rome"),
("3172243", "Nocera Superiore", "", "IT", "380", "04", "SA", "065079", "", "40.74217", "14.67564", "Europe/Rome"),
("3172244", "Nocera Inferiore", "", "IT", "380", "04", "SA", "065078", "", "40.75448", "14.63919", "Europe/Rome"),
("3172269", "Nichelino", "Никелино", "IT", "380", "12", "TO", "001164", "", "44.99313", "7.64135", "Europe/Rome"),
("3172287", "Nettuno", "Неттуно", "IT", "380", "07", "RM", "058072", "", "41.48647", "12.67046", "Europe/Rome"),
("3172297", "Nerviano", "", "IT", "380", "09", "MI", "015154", "", "45.55343", "8.9792", "Europe/Rome"),
("3172379", "Nardo", "", "IT", "380", "13", "LE", "075052", "", "40.15308", "18.01183", "Europe/Rome"),
("3172394", "Napoli", "Неаполь", "IT", "380", "04", "NA", "063049", "", "40.85631", "14.24641", "Europe/Rome"),
("3172472", "Mugnano di Napoli", "", "IT", "380", "04", "NA", "063048", "", "40.90936", "14.20984", "Europe/Rome"),
("3172479", "Muggio", "", "IT", "380", "09", "MB", "108034", "", "45.58878", "9.22784", "Europe/Rome"),
("3172629", "Monza", "Монца", "IT", "380", "09", "MB", "108033", "", "45.58005", "9.27246", "Europe/Rome"),
("3172681", "Montichiari", "", "IT", "380", "09", "BS", "017113", "", "45.41317", "10.39799", "Europe/Rome"),
("3172718", "Montevarchi", "Монтеварки", "IT", "380", "16", "AR", "051026", "", "43.5252", "11.57238", "Europe/Rome"),
("3172729", "Montesilvano Marina", "", "IT", "380", "01", "PE", "068024", "", "42.51185", "14.13729", "Europe/Rome"),
("3172768", "Monterotondo", "Монтеротондо", "IT", "380", "07", "RM", "058065", "", "42.0784", "12.59636", "Europe/Rome"),
("3172828", "Montemurlo", "", "IT", "380", "16", "PO", "100003", "", "43.92686", "11.03718", "Europe/Rome"),
("3172979", "Montecchio Maggiore-Alte Ceccato", "", "IT", "380", "20", "VI", "024061", "", "45.50369", "11.412", "Europe/Rome"),
("3172996", "Montecatini-Terme", "", "IT", "380", "16", "PT", "047011", "", "43.88153", "10.7723", "Europe/Rome"),
("3173029", "Montebelluna", "Монтебеллуна", "IT", "380", "20", "TV", "026046", "", "45.77504", "12.04904", "Europe/Rome"),
("3173131", "Monopoli", "Монополи", "IT", "380", "13", "BA", "072030", "", "40.94918", "17.29717", "Europe/Rome"),
("3173153", "Monfalcone", "Монфальконе", "IT", "380", "06", "GO", "031012", "", "45.80052", "13.53777", "Europe/Rome"),
("3173160", "Mondragone", "", "IT", "380", "04", "CE", "061052", "", "41.11733", "13.8875", "Europe/Rome"),
("3173162", "Mondovi", "", "IT", "380", "12", "CN", "004130", "", "44.39603", "7.81764", "Europe/Rome"),
("3173180", "Moncalieri", "", "IT", "380", "12", "TO", "001156", "", "45.0031", "7.69202", "Europe/Rome"),
("3173287", "Molfetta", "Мольфетта", "IT", "380", "13", "BA", "072029", "", "41.19695", "16.59503", "Europe/Rome"),
("3173302", "Mola di Bari", "", "IT", "380", "13", "BA", "072028", "", "41.05906", "17.08512", "Europe/Rome"),
("3173314", "Mogliano Veneto", "", "IT", "380", "20", "TV", "026043", "", "45.55594", "12.24294", "Europe/Rome"),
("3173326", "Modugno", "Модуньо", "IT", "380", "13", "BA", "072027", "", "41.09454", "16.7959", "Europe/Rome"),
("3173331", "Modena", "Модена", "IT", "380", "05", "MO", "036023", "", "44.64783", "10.92539", "Europe/Rome"),
("3173369", "Mirano", "Мирано", "IT", "380", "20", "VE", "027024", "", "45.49458", "12.10775", "Europe/Rome"),
("3173370", "Mirandola", "Мирандола", "IT", "380", "05", "MO", "036022", "", "44.88515", "11.06902", "Europe/Rome"),
("3173385", "Mira Taglio", "Мира", "IT", "380", "20", "VE", "027023", "", "45.43", "12.11972", "Europe/Rome"),
("3173391", "Minturno", "", "IT", "380", "07", "LT", "059014", "", "41.25316", "13.73496", "Europe/Rome"),
("3173435", "Milano", "Милан", "IT", "380", "09", "MI", "015146", "", "45.46427", "9.18951", "Europe/Rome"),
("3173529", "Mestre", "Местре", "IT", "380", "20", "VE", "027042", "", "45.47152", "12.24017", "Europe/Rome"),
("3173537", "Mesagne", "", "IT", "380", "13", "BR", "074010", "", "40.55851", "17.80774", "Europe/Rome"),
("3173577", "Merano", "Мерано", "IT", "380", "17", "BZ", "021051", "", "46.66817", "11.15953", "Europe/Rome"),
("3173582", "Mentana", "", "IT", "380", "07", "RM", "058059", "", "42.03539", "12.64413", "Europe/Rome"),
("3173599", "Melzo", "", "IT", "380", "09", "MI", "015142", "", "45.4981", "9.42043", "Europe/Rome"),
("3173614", "Melito di Napoli", "", "IT", "380", "04", "NA", "063045", "", "40.91948", "14.23104", "Europe/Rome"),
("3173631", "Melegnano", "", "IT", "380", "09", "MI", "015140", "", "45.35781", "9.3236", "Europe/Rome"),
("3173671", "Meda", "Мед", "IT", "380", "09", "MB", "108030", "", "45.66115", "9.15928", "Europe/Rome"),
("3173721", "Matera", "Матера", "IT", "380", "02", "MT", "077014", "", "40.66983", "16.59723", "Europe/Rome"),
("3173762", "Massafra", "", "IT", "380", "13", "TA", "073015", "", "40.58618", "17.11635", "Europe/Rome"),
("3173775", "Massa", "Масса", "IT", "380", "16", "MS", "045010", "", "44.02079", "10.11869", "Europe/Rome"),
("3173841", "Martina Franca", "", "IT", "380", "13", "TA", "073013", "", "40.70142", "17.33304", "Europe/Rome"),
("3173914", "Marino", "", "IT", "380", "07", "RM", "058057", "", "41.7635", "12.63072", "Europe/Rome"),
("3173935", "Marina di Carrara", "", "IT", "380", "16", "MS", "045003", "", "44.03837", "10.04142", "Europe/Rome"),
("3173945", "Marigliano", "Марильяно", "IT", "380", "04", "NA", "063043", "", "40.922", "14.45412", "Europe/Rome"),
("3173949", "Mariano Comense", "", "IT", "380", "09", "CO", "013143", "", "45.69092", "9.18243", "Europe/Rome"),
("3173995", "Marcianise", "Марчанизе", "IT", "380", "04", "CE", "061049", "", "41.03064", "14.29868", "Europe/Rome"),
("3174021", "Marano di Napoli", "", "IT", "380", "04", "NA", "063041", "", "40.89601", "14.17476", "Europe/Rome"),
("3174051", "Mantova", "Мантуя", "IT", "380", "09", "MN", "020030", "", "45.16031", "10.79784", "Europe/Rome"),
("3174092", "Manfredonia", "Манфредония", "IT", "380", "13", "FG", "071029", "", "41.62746", "15.91038", "Europe/Rome"),
("3174096", "Manduria", "Мандурия", "IT", "380", "13", "TA", "073012", "", "40.40234", "17.63352", "Europe/Rome"),
("3174141", "Malnate", "", "IT", "380", "09", "VA", "012096", "", "45.79377", "8.88104", "Europe/Rome"),
("3174295", "Magenta", "", "IT", "380", "09", "MI", "015130", "", "45.46279", "8.87915", "Europe/Rome"),
("3174358", "Maddaloni", "Маддалони", "IT", "380", "04", "CE", "061048", "", "41.03578", "14.3823", "Europe/Rome"),
("3174380", "Macerata", "Мачерата", "IT", "380", "10", "MC", "043023", "", "43.29789", "13.45293", "Europe/Rome"),
("3174494", "Lugo", "Луго", "IT", "380", "05", "RA", "039012", "", "44.42277", "11.90817", "Europe/Rome"),
("3174526", "Lucera", "Лучера", "IT", "380", "13", "FG", "071028", "", "41.5055", "15.3391", "Europe/Rome"),
("3174530", "Lucca", "Лукка", "IT", "380", "16", "LU", "046017", "", "43.8497", "10.47234", "Europe/Rome"),
("3174638", "Lodi", "Лоди", "IT", "380", "09", "LO", "098031", "", "45.30989", "9.50085", "Europe/Rome"),
("3174659", "Livorno", "Ливорно", "IT", "380", "16", "LI", "049009", "", "43.54427", "10.32615", "Europe/Rome"),
("3174679", "Lissone", "Лиссоне", "IT", "380", "09", "MB", "108028", "", "45.61236", "9.23985", "Europe/Rome"),
("3174719", "Limbiate", "Лимбьяте", "IT", "380", "09", "MB", "108027", "", "45.60016", "9.12833", "Europe/Rome"),
("3174741", "Lido di Ostia", "Лидо-ди-Рома", "IT", "380", "07", "RM", "058091", "", "41.73212", "12.27654", "Europe/Rome"),
("3174748", "Lido", "", "IT", "380", "20", "VE", "027042", "", "45.4105", "12.36649", "Europe/Rome"),
("3174921", "Legnano", "Леньяно", "IT", "380", "09", "MI", "015118", "", "45.5947", "8.91355", "Europe/Rome"),
("3174922", "Legnago", "Леньяго", "IT", "380", "20", "VR", "023044", "", "45.18956", "11.25616", "Europe/Rome"),
("3174945", "Lecco", "Лекко", "IT", "380", "09", "LC", "097042", "", "45.85317", "9.39005", "Europe/Rome"),
("3174953", "Lecce", "Лечче", "IT", "380", "13", "LE", "075035", "", "40.35481", "18.17244", "Europe/Rome"),
("3175058", "Latina", "Латина", "IT", "380", "07", "LT", "059011", "", "41.46614", "12.9043", "Europe/Rome"),
("3175081", "La Spezia", "Специя", "IT", "380", "08", "SP", "011015", "", "44.11096", "9.83632", "Europe/Rome"),
("3175121", "L'Aquila", "Л’Аквила", "IT", "380", "01", "AQ", "066049", "", "42.35055", "13.39954", "Europe/Rome"),
("3175173", "Lanciano", "Ланчано", "IT", "380", "01", "CH", "069046", "", "42.22638", "14.39582", "Europe/Rome"),
("3175238", "Lainate", "", "IT", "380", "09", "MI", "015116", "", "45.57176", "9.02681", "Europe/Rome"),
("3175298", "Ladispoli", "Ладисполи", "IT", "380", "07", "RM", "058116", "", "41.9553", "12.07899", "Europe/Rome"),
("3175384", "Ivrea", "Ивреа", "IT", "380", "12", "TO", "001125", "", "45.46723", "7.87617", "Europe/Rome"),
("3175445", "Isernia", "Изерния", "IT", "380", "11", "IS", "094023", "", "41.60003", "14.23701", "Europe/Rome"),
("3175453", "Ischia Porto", "", "IT", "380", "04", "NA", "063037", "", "40.73913", "13.951", "Europe/Rome"),
("3175458", "Ischia", "Искья", "IT", "380", "04", "NA", "063037", "", "40.73793", "13.94862", "Europe/Rome"),
("3175500", "Pallanza-Intra-Suna", "", "IT", "380", "12", "VB", "103072", "", "45.93778", "8.57088", "Europe/Rome"),
("3175532", "Imperia", "Империя", "IT", "380", "08", "IM", "008031", "", "43.8875", "8.03083", "Europe/Rome"),
("3175537", "Imola", "", "IT", "380", "05", "BO", "037032", "", "44.35916", "11.7132", "Europe/Rome"),
("3175628", "Jesi", "Джези", "IT", "380", "10", "AN", "042021", "", "43.52142", "13.24368", "Europe/Rome"),
("3175678", "Guidonia", "", "IT", "380", "07", "RM", "058047", "", "41.99232", "12.71876", "Europe/Rome"),
("3175743", "Grumo Nevano", "", "IT", "380", "04", "NA", "063036", "", "40.93591", "14.25983", "Europe/Rome"),
("3175755", "Grugliasco", "", "IT", "380", "12", "TO", "001120", "", "45.05837", "7.58458", "Europe/Rome"),
("3175773", "Grottaglie", "Гротталье", "IT", "380", "13", "TA", "073008", "", "40.53694", "17.43723", "Europe/Rome"),
("3175775", "Grottaferrata", "", "IT", "380", "07", "RM", "058046", "", "41.78888", "12.67677", "Europe/Rome"),
("3175786", "Grosseto", "Гроссето", "IT", "380", "16", "GR", "053011", "", "42.76871", "11.10955", "Europe/Rome"),
("3175860", "Gravina in Puglia", "", "IT", "380", "13", "BA", "072023", "", "40.81892", "16.42148", "Europe/Rome"),
("3175952", "Gragnano", "Граньяно", "IT", "380", "04", "NA", "063035", "", "40.69572", "14.51545", "Europe/Rome"),
("3175986", "Gorizia", "Гориция", "IT", "380", "06", "GO", "031007", "", "45.94088", "13.62167", "Europe/Rome"),
("3175990", "Gorgonzola", "", "IT", "380", "09", "MI", "015108", "", "45.53069", "9.40531", "Europe/Rome"),
("3176041", "Giussano", "", "IT", "380", "09", "MB", "108024", "", "45.69066", "9.20886", "Europe/Rome"),
("3176053", "Giulianova", "", "IT", "380", "01", "TE", "067025", "", "42.75381", "13.9665", "Europe/Rome"),
("3176059", "Giugliano in Campania", "", "IT", "380", "04", "NA", "063034", "", "40.93188", "14.19557", "Europe/Rome"),
("3176072", "Giovinazzo", "Джовинаццо", "IT", "380", "13", "BA", "072022", "", "41.185", "16.67054", "Europe/Rome"),
("3176090", "Gioia del Colle", "Джоя-дель-Колле", "IT", "380", "13", "BA", "072021", "", "40.80415", "16.92387", "Europe/Rome"),
("3176097", "Ginosa", "", "IT", "380", "13", "TA", "073007", "", "40.5769", "16.75655", "Europe/Rome"),
("3176177", "Ghedi", "Геди", "IT", "380", "09", "BS", "017078", "", "45.40335", "10.27748", "Europe/Rome"),
("3176203", "Genzano di Roma", "Дженцано-ди-Рома", "IT", "380", "07", "RM", "058043", "", "41.70113", "12.69246", "Europe/Rome"),
("3176219", "Genoa", "Генуя", "IT", "380", "08", "GE", "010025", "", "44.4264", "8.91519", "Europe/Rome"),
("3176322", "Garbagnate Milanese", "", "IT", "380", "09", "MI", "015105", "", "45.57438", "9.07537", "Europe/Rome"),
("3176366", "Gallipoli", "Галлиполи", "IT", "380", "13", "LE", "075031", "", "40.05549", "17.99726", "Europe/Rome"),
("3176391", "Gallarate", "Галларате", "IT", "380", "09", "VA", "012070", "", "45.66019", "8.79164", "Europe/Rome"),
("3176407", "Galatina", "", "IT", "380", "13", "LE", "075029", "", "40.17416", "18.17032", "Europe/Rome"),
("3176438", "Gaeta", "Гаета", "IT", "380", "07", "LT", "059009", "", "41.21408", "13.57082", "Europe/Rome"),
("3176515", "Frosinone", "Фрозиноне", "IT", "380", "07", "FR", "060038", "", "41.63759", "13.33541", "Europe/Rome"),
("3176560", "Frattaminore", "", "IT", "380", "04", "NA", "063033", "", "40.9558", "14.27201", "Europe/Rome"),
("3176561", "Frattamaggiore", "Фраттамаджоре", "IT", "380", "04", "NA", "063032", "", "40.93971", "14.27329", "Europe/Rome"),
("3176589", "Frascati", "", "IT", "380", "07", "RM", "058039", "", "41.82124", "12.66294", "Europe/Rome"),
("3176603", "Francavilla Fontana", "", "IT", "380", "13", "BR", "074008", "", "40.53123", "17.58522", "Europe/Rome"),
("3176605", "Francavilla al Mare", "", "IT", "380", "01", "CH", "069035", "", "42.42158", "14.28217", "Europe/Rome"),
("3176639", "Fossano", "", "IT", "380", "12", "CN", "004089", "", "44.55077", "7.71922", "Europe/Rome"),
("3176722", "Fornacelle", "", "IT", "380", "16", "PO", "100003", "", "43.91507", "11.04071", "Europe/Rome"),
("3176733", "Formigine", "", "IT", "380", "05", "MO", "036015", "", "44.57677", "10.84544", "Europe/Rome"),
("3176738", "Formia", "", "IT", "380", "07", "LT", "059008", "", "41.26126", "13.6414", "Europe/Rome"),
("3176746", "Forli", "Форли", "IT", "380", "05", "FC", "040012", "", "44.22054", "12.05245", "Europe/Rome"),
("3176748", "Forio", "", "IT", "380", "04", "NA", "063031", "", "40.70876", "13.8649", "Europe/Rome"),
("3176843", "Fondi", "Фонда", "IT", "380", "07", "LT", "059007", "", "41.35285", "13.43227", "Europe/Rome"),
("3176849", "Follonica", "Фоллоника", "IT", "380", "16", "GR", "053009", "", "42.92779", "10.76451", "Europe/Rome"),
("3176854", "Foligno", "Фолиньо", "IT", "380", "18", "PG", "054018", "", "42.95324", "12.70664", "Europe/Rome"),
("3176885", "Foggia", "Фоджа", "IT", "380", "13", "FG", "071024", "", "41.45845", "15.55188", "Europe/Rome"),
("3176923", "Fiumicino-Isola Sacra", "Фьюмичино", "IT", "380", "07", "RM", "058120", "", "41.76747", "12.22907", "Europe/Rome"),
("3176959", "Florence", "Флоренция", "IT", "380", "16", "FI", "048017", "", "43.77925", "11.24626", "Europe/Rome"),
("3176970", "Fiorano", "", "IT", "380", "05", "MO", "036013", "", "44.54346", "10.83085", "Europe/Rome"),
("3177029", "Fidenza", "Фиденцы", "IT", "380", "05", "PR", "034014", "", "44.86223", "10.06546", "Europe/Rome"),
("3177090", "Ferrara", "Феррара", "IT", "380", "05", "FE", "038008", "", "44.84346", "11.60868", "Europe/Rome"),
("3177099", "Fermo", "Фермо", "IT", "380", "10", "FM", "109006", "", "43.16296", "13.72274", "Europe/Rome"),
("3177171", "Fasano", "Фазано", "IT", "380", "13", "BR", "074007", "", "40.83805", "17.35836", "Europe/Rome"),
("3177219", "Fano", "Фано", "IT", "380", "10", "PU", "041013", "", "43.84052", "13.01665", "Europe/Rome"),
("3177250", "Falconara Marittima", "", "IT", "380", "10", "AN", "042018", "", "43.61548", "13.37463", "Europe/Rome"),
("3177300", "Faenza", "", "IT", "380", "05", "RA", "039010", "", "44.2857", "11.88334", "Europe/Rome"),
("3177315", "Fabriano", "Фабриано", "IT", "380", "10", "AN", "042017", "", "43.34065", "12.90726", "Europe/Rome"),
("3177363", "Ercolano", "Геркуланум", "IT", "380", "04", "NA", "063064", "", "40.8138", "14.36382", "Europe/Rome"),
("3177372", "Erba", "", "IT", "380", "09", "CO", "013095", "", "45.8088", "9.22609", "Europe/Rome"),
("3177400", "Empoli", "", "IT", "380", "16", "FI", "048014", "", "43.71946", "10.94445", "Europe/Rome"),
("3177438", "Eboli", "", "IT", "380", "04", "SA", "065050", "", "40.61423", "15.05998", "Europe/Rome"),
("3177532", "Domodossola", "", "IT", "380", "12", "VB", "103028", "", "46.1165", "8.29313", "Europe/Rome"),
("3177608", "Desio", "Дезио", "IT", "380", "09", "MB", "108023", "", "45.61831", "9.20249", "Europe/Rome"),
("3177610", "Desenzano del Garda", "Дезенцано дель Гарда", "IT", "380", "09", "BS", "017067", "", "45.46222", "10.55264", "Europe/Rome"),
("3177650", "Dalmine", "Дальмине", "IT", "380", "09", "BG", "016091", "", "45.64658", "9.60213", "Europe/Rome"),
("3177664", "Cusano Milanino", "", "IT", "380", "09", "MI", "015098", "", "45.55187", "9.18373", "Europe/Rome"),
("3177700", "Cuneo", "Кунео", "IT", "380", "12", "CN", "004078", "", "44.39071", "7.54828", "Europe/Rome"),
("3177838", "Cremona", "Кремона", "IT", "380", "09", "CR", "019036", "", "45.14047", "10.02297", "Europe/Rome"),
("3177841", "Crema", "Крема", "IT", "380", "09", "CR", "019035", "", "45.36264", "9.68176", "Europe/Rome"),
("3178004", "Corsico", "Корсико", "IT", "380", "09", "MI", "015093", "", "45.43099", "9.11093", "Europe/Rome"),
("3178019", "Correggio", "Корреджо", "IT", "380", "05", "RE", "035020", "", "44.76737", "10.78345", "Europe/Rome"),
("3178074", "Cornaredo", "", "IT", "380", "09", "MI", "015087", "", "45.49415", "9.02458", "Europe/Rome"),
("3178087", "Cormano", "", "IT", "380", "09", "MI", "015086", "", "45.54343", "9.16652", "Europe/Rome"),
("3178112", "Cordenons", "", "IT", "380", "06", "PN", "093017", "", "45.9836", "12.70038", "Europe/Rome"),
("3178131", "Corato", "Корато", "IT", "380", "13", "BA", "072020", "", "41.14273", "16.40652", "Europe/Rome"),
("3178141", "Copertino", "", "IT", "380", "13", "LE", "075022", "", "40.26821", "18.0543", "Europe/Rome"),
("3178147", "Conversano", "Конверсано", "IT", "380", "13", "BA", "072019", "", "40.96836", "17.11329", "Europe/Rome"),
("3178197", "Conegliano", "Конельяно", "IT", "380", "20", "TV", "026021", "", "45.88246", "12.29645", "Europe/Rome"),
("3178229", "Como", "Комо", "IT", "380", "09", "CO", "013075", "", "45.80079", "9.08065", "Europe/Rome"),
("3178283", "Cologno Monzese", "", "IT", "380", "09", "MI", "015081", "", "45.53004", "9.27795", "Europe/Rome"),
("3178388", "Collegno", "Колленьо", "IT", "380", "12", "TO", "001090", "", "45.07919", "7.57832", "Europe/Rome"),
("3178398", "Colleferro", "Коллеферро", "IT", "380", "07", "RM", "058034", "", "41.72868", "13.00314", "Europe/Rome"),
("3178402", "Colle di Val d'Elsa", "Колле-ди-Валь-д'Эльса", "IT", "380", "16", "SI", "052012", "", "43.41463", "11.12824", "Europe/Rome"),
("3178587", "Civitavecchia", "Чивитавеккья", "IT", "380", "07", "RM", "058032", "", "42.09325", "11.79674", "Europe/Rome"),
("3178619", "Citta di Castello", "", "IT", "380", "18", "PG", "054013", "", "43.46556", "12.2375", "Europe/Rome"),
("3178631", "Cisterna di Latina", "", "IT", "380", "07", "LT", "059005", "", "41.5908", "12.82808", "Europe/Rome"),
("3178650", "Cirie", "", "IT", "380", "12", "TO", "001086", "", "45.22673", "7.5998", "Europe/Rome"),
("3178671", "Cinisello Balsamo", "", "IT", "380", "09", "MI", "015077", "", "45.55646", "9.22104", "Europe/Rome"),
("3178738", "Ciampino", "Чампино", "IT", "380", "07", "RM", "058118", "", "41.79916", "12.60722", "Europe/Rome"),
("3178745", "Chivasso", "Кивассо", "IT", "380", "12", "TO", "001082", "", "45.19418", "7.90055", "Europe/Rome"),
("3178784", "Chioggia", "", "IT", "380", "20", "VE", "027008", "", "45.21857", "12.27774", "Europe/Rome"),
("3178796", "Chieti", "Кьети", "IT", "380", "01", "CH", "069022", "", "42.38284", "14.13987", "Europe/Rome"),
("3178818", "Chieri", "", "IT", "380", "12", "TO", "001078", "", "45.01054", "7.82133", "Europe/Rome"),
("3178832", "Chiavari", "Киавари", "IT", "380", "08", "GE", "010015", "", "44.31771", "9.32241", "Europe/Rome"),
("3178850", "Chiari", "", "IT", "380", "09", "BS", "017052", "", "45.53763", "9.92699", "Europe/Rome"),
("3178956", "Cesenatico", "Чезенатико", "IT", "380", "05", "FC", "040008", "", "44.19987", "12.3991", "Europe/Rome"),
("3178957", "Cesena", "", "IT", "380", "05", "FC", "040007", "", "44.1391", "12.24315", "Europe/Rome"),
("3178972", "Cesano Maderno", "", "IT", "380", "09", "MB", "108019", "", "45.62915", "9.15189", "Europe/Rome"),
("3178998", "Cervia", "Червиа", "IT", "380", "05", "RA", "039007", "", "44.26204", "12.34812", "Europe/Rome"),
("3178999", "Cerveteri", "Черветери", "IT", "380", "07", "RM", "058029", "", "41.9908", "12.09082", "Europe/Rome"),
("3179066", "Cernusco sul Naviglio", "", "IT", "380", "09", "MI", "015070", "", "45.52716", "9.3334", "Europe/Rome"),
("3179075", "Cerignola", "", "IT", "380", "13", "FG", "071020", "", "41.26383", "15.8998", "Europe/Rome"),
("3179109", "Cercola", "", "IT", "380", "04", "NA", "063026", "", "40.86043", "14.35733", "Europe/Rome"),
("3179162", "Cento", "Ченто", "IT", "380", "05", "FE", "038004", "", "44.73099", "11.28716", "Europe/Rome"),
("3179218", "Ceglie Messapica", "", "IT", "380", "13", "BR", "074003", "", "40.6462", "17.51661", "Europe/Rome"),
("3179235", "Cecina", "Чечина", "IT", "380", "16", "LI", "049007", "", "43.30621", "10.51729", "Europe/Rome"),
("3179337", "Cava De Tirreni", "", "IT", "380", "04", "SA", "065037", "", "40.70091", "14.70564", "Europe/Rome"),
("3179347", "Cattolica", "", "IT", "380", "05", "RN", "099002", "", "43.96182", "12.73631", "Europe/Rome"),
("3179415", "Castiglione delle Stiviere", "", "IT", "380", "09", "MN", "020017", "", "45.3902", "10.48619", "Europe/Rome"),
("3179443", "Castel Volturno", "", "IT", "380", "04", "CE", "061027", "", "41.01161", "13.9561", "Europe/Rome"),
("3179560", "Castel Maggiore", "", "IT", "380", "05", "BO", "037019", "", "44.57707", "11.36071", "Europe/Rome"),
("3179661", "Castellammare di Stabia", "", "IT", "380", "04", "NA", "063024", "", "40.70805", "14.48597", "Europe/Rome"),
("3179684", "Castelfranco Veneto", "", "IT", "380", "20", "TV", "026012", "", "45.67254", "11.93728", "Europe/Rome"),
("3179686", "Castelfranco Emilia", "", "IT", "380", "05", "MO", "036006", "", "44.59445", "11.04979", "Europe/Rome"),
("3179781", "Cassino", "Кассино", "IT", "380", "07", "FR", "060019", "", "41.48581", "13.82835", "Europe/Rome"),
("3179795", "Cassano d'Adda", "", "IT", "380", "09", "MI", "015059", "", "45.52853", "9.51507", "Europe/Rome"),
("3179806", "Casoria", "", "IT", "380", "04", "NA", "063023", "", "40.90906", "14.29363", "Europe/Rome"),
("3179866", "Caserta", "Казерта", "IT", "380", "04", "CE", "061022", "", "41.07619", "14.34002", "Europe/Rome"),
("3179977", "Cascina", "", "IT", "380", "16", "PI", "050008", "", "43.6843", "10.50395", "Europe/Rome"),
("3180133", "Casamassima", "", "IT", "380", "13", "BA", "072015", "", "40.95653", "16.92075", "Europe/Rome"),
("3180172", "Casalnuovo di Napoli", "", "IT", "380", "04", "NA", "063017", "", "40.90834", "14.34993", "Europe/Rome"),
("3180208", "Casale Monferrato", "", "IT", "380", "12", "AL", "006039", "", "45.13338", "8.4525", "Europe/Rome"),
("3180224", "Casalecchio di Reno", "", "IT", "380", "05", "BO", "037011", "", "44.47563", "11.27495", "Europe/Rome"),
("3180240", "Casal di Principe", "", "IT", "380", "04", "CE", "061019", "", "41.01142", "14.12346", "Europe/Rome"),
("3180423", "Carrara", "Каррара", "IT", "380", "16", "MS", "045003", "", "44.05405", "10.06049", "Europe/Rome"),
("3180445", "Carpi Centro", "Карпи", "IT", "380", "05", "MO", "036005", "", "44.78237", "10.8777", "Europe/Rome"),
("3180496", "Carmagnola", "Карманьола", "IT", "380", "12", "TO", "001059", "", "44.84963", "7.72032", "Europe/Rome"),
("3180541", "Cardito", "", "IT", "380", "04", "NA", "063016", "", "40.93619", "14.29925", "Europe/Rome"),
("3180581", "Carate Brianza", "", "IT", "380", "09", "MB", "108015", "", "45.67149", "9.23576", "Europe/Rome"),
("3180601", "Capua", "Капуя", "IT", "380", "04", "CE", "061015", "", "41.10519", "14.21269", "Europe/Rome"),
("3180733", "Capannori", "Капаннори", "IT", "380", "16", "LU", "046007", "", "43.8438", "10.5691", "Europe/Rome"),
("3180758", "Cantu", "", "IT", "380", "09", "CO", "013041", "", "45.73626", "9.13664", "Europe/Rome"),
("3180792", "Canosa di Puglia", "", "IT", "380", "13", "BT", "110004", "", "41.21954", "16.06768", "Europe/Rome"),
("3180991", "Campobasso", "Кампобассо", "IT", "380", "11", "CB", "070006", "", "41.55947", "14.66737", "Europe/Rome"),
("3181018", "Campi Bisenzio", "", "IT", "380", "16", "FI", "048006", "", "43.82802", "11.13527", "Europe/Rome"),
("3181125", "Camaiore", "Камайоре", "IT", "380", "16", "LU", "046005", "", "43.909", "10.25038", "Europe/Rome"),
("3181258", "Caivano", "Кайвано", "IT", "380", "04", "NA", "063011", "", "40.95753", "14.30591", "Europe/Rome"),
("3181355", "Busto Arsizio", "", "IT", "380", "09", "VA", "012026", "", "45.61128", "8.84914", "Europe/Rome"),
("3181359", "Bussolengo", "", "IT", "380", "20", "VR", "023015", "", "45.46903", "10.85371", "Europe/Rome"),
("3181471", "Brusciano", "", "IT", "380", "04", "NA", "063010", "", "40.92237", "14.42386", "Europe/Rome"),
("3181495", "Brugherio", "Бругерио", "IT", "380", "09", "MB", "108012", "", "45.55301", "9.29907", "Europe/Rome"),
("3181528", "Brindisi", "Бриндизи", "IT", "380", "13", "BR", "074001", "", "40.63215", "17.93607", "Europe/Rome"),
("3181548", "Bresso", "Брессо", "IT", "380", "09", "MI", "015032", "", "45.53792", "9.18921", "Europe/Rome"),
("3181550", "Bressanone", "Брессаноне", "IT", "380", "17", "BZ", "021011", "", "46.71503", "11.65598", "Europe/Rome"),
("3181554", "Brescia", "Брешия", "IT", "380", "09", "BS", "017029", "", "45.53558", "10.21472", "Europe/Rome"),
("3181631", "Bra", "", "IT", "380", "12", "CN", "004029", "", "44.69944", "7.84979", "Europe/Rome"),
("3181641", "Bovisio-Masciago", "", "IT", "380", "09", "MB", "108010", "", "45.61019", "9.15301", "Europe/Rome"),
("3181683", "Boscoreale", "Боскореале", "IT", "380", "04", "NA", "063008", "", "40.77408", "14.50708", "Europe/Rome"),
("3181790", "Borgomanero", "", "IT", "380", "12", "NO", "003024", "", "45.69879", "8.46823", "Europe/Rome"),
("3181913", "Bolzano", "Больцано", "IT", "380", "17", "BZ", "021008", "", "46.49067", "11.33982", "Europe/Rome"),
("3181928", "Bologna", "Болонья", "IT", "380", "05", "BO", "037006", "", "44.49381", "11.33875", "Europe/Rome"),
("3181931", "Bollate", "", "IT", "380", "09", "MI", "015027", "", "45.54647", "9.12054", "Europe/Rome"),
("3181995", "Bitonto", "", "IT", "380", "13", "BA", "072011", "", "41.11006", "16.69086", "Europe/Rome"),
("3182007", "Bisceglie", "Бишеллье", "IT", "380", "13", "BT", "110003", "", "41.24106", "16.49492", "Europe/Rome"),
("3182043", "Biella", "Бьелла", "IT", "380", "12", "BI", "096004", "", "45.5663", "8.05499", "Europe/Rome"),
("3182164", "Bergamo", "Бергамо", "IT", "380", "09", "BG", "016024", "", "45.69601", "9.66721", "Europe/Rome"),
("3182179", "Benevento", "Беневенто", "IT", "380", "04", "BN", "062008", "", "41.1256", "14.78101", "Europe/Rome"),
("3182210", "Belluno", "Беллуно", "IT", "380", "20", "BL", "025006", "", "46.14675", "12.21324", "Europe/Rome"),
("3182272", "Battipaglia", "", "IT", "380", "04", "SA", "065014", "", "40.6045", "14.9876", "Europe/Rome"),
("3182289", "Bastia umbra", "", "IT", "380", "18", "PG", "054002", "", "43.06425", "12.54612", "Europe/Rome"),
("3182297", "Bassano del Grappa", "Бассано-дель-Граппа", "IT", "380", "20", "VI", "024012", "", "45.76231", "11.73112", "Europe/Rome"),
("3182340", "Barletta", "Барлетта", "IT", "380", "13", "BT", "110002", "", "41.31429", "16.28165", "Europe/Rome"),
("3182351", "Bari", "Бари", "IT", "380", "13", "BA", "072006", "", "41.11148", "16.8554", "Europe/Rome"),
("3182361", "Bareggio", "", "IT", "380", "09", "MI", "015012", "", "45.47506", "8.9978", "Europe/Rome"),
("3182518", "Bagnoli", "Баньоли", "IT", "380", "04", "NA", "063049", "", "40.81322", "14.16807", "Europe/Rome"),
("3182599", "Bacoli", "", "IT", "380", "04", "NA", "063006", "", "40.79926", "14.07846", "Europe/Rome"),
("3182636", "Avezzano", "Авеццано", "IT", "380", "01", "AQ", "066006", "", "42.03908", "13.43847", "Europe/Rome"),
("3182640", "Aversa", "Аверса", "IT", "380", "04", "CE", "061005", "", "40.97259", "14.20745", "Europe/Rome"),
("3182650", "Avellino", "Авеллино", "IT", "380", "04", "AV", "064008", "", "40.92033", "14.79652", "Europe/Rome"),
("3182714", "Asti", "Асти", "IT", "380", "12", "AT", "005005", "", "44.90162", "8.20751", "Europe/Rome"),
("3182749", "Ascoli Piceno", "Асколи-Пичено", "IT", "380", "10", "AP", "044007", "", "42.85185", "13.60658", "Europe/Rome"),
("3182757", "Arzignano", "Арциньяно", "IT", "380", "20", "VI", "024008", "", "45.51629", "11.34414", "Europe/Rome"),
("3182765", "Arzano", "", "IT", "380", "04", "NA", "063005", "", "40.91353", "14.26741", "Europe/Rome"),
("3182851", "Ariccia", "", "IT", "380", "07", "RM", "058009", "", "41.7108", "12.66255", "Europe/Rome"),
("3182884", "Arezzo", "Ареццо", "IT", "380", "16", "AR", "051002", "", "43.44708", "11.86867", "Europe/Rome"),
("3182886", "Arese", "", "IT", "380", "09", "MI", "015009", "", "45.552", "9.07265", "Europe/Rome"),
("3182897", "Ardea", "Ардеа", "IT", "380", "07", "RM", "058117", "", "41.6123", "12.51433", "Europe/Rome"),
("3182904", "Arcore", "", "IT", "380", "09", "MB", "108004", "", "45.62675", "9.32454", "Europe/Rome"),
("3182957", "Aprilia", "Априлия", "IT", "380", "07", "LT", "059001", "", "41.58808", "12.65729", "Europe/Rome"),
("3182997", "Aosta", "Аоста", "IT", "380", "19", "AO", "007003", "", "45.73764", "7.31722", "Europe/Rome"),
("3183005", "Anzio", "Анцио", "IT", "380", "07", "RM", "058007", "", "41.48493", "12.61883", "Europe/Rome"),
("3183063", "Angri", "", "IT", "380", "04", "SA", "065007", "", "40.74066", "14.56936", "Europe/Rome"),
("3183072", "Andria", "Андрия", "IT", "380", "13", "BT", "110001", "", "41.23117", "16.29797", "Europe/Rome"),
("3183089", "Ancona", "Анкона", "IT", "380", "10", "AN", "042002", "", "43.5942", "13.50337", "Europe/Rome"),
("3183178", "Altamura", "Алтамура", "IT", "380", "13", "BA", "072004", "", "40.82664", "16.54952", "Europe/Rome"),
("3183187", "Alpignano", "", "IT", "380", "12", "TO", "001008", "", "45.09964", "7.52199", "Europe/Rome"),
("3183284", "Alghero", "", "IT", "380", "14", "SS", "090003", "", "40.56541", "8.32092", "Europe/Rome"),
("3183299", "Alessandria", "Алессандрия", "IT", "380", "12", "AL", "006003", "", "44.90924", "8.61007", "Europe/Rome"),
("3183319", "Albignasego", "", "IT", "380", "20", "PD", "028003", "", "45.34896", "11.88807", "Europe/Rome"),
("3183343", "Albenga", "", "IT", "380", "08", "SV", "009002", "", "44.04997", "8.21829", "Europe/Rome"),
("3183356", "Albano Laziale", "", "IT", "380", "07", "RM", "058003", "", "41.72513", "12.63402", "Europe/Rome"),
("3183364", "Alba", "Альбом", "IT", "380", "12", "CN", "004003", "", "44.6999", "8.0347", "Europe/Rome"),
("3183412", "Agropoli", "", "IT", "380", "04", "SA", "065002", "", "40.35183", "14.99988", "Europe/Rome"),
("3183455", "Afragola", "Афрагола", "IT", "380", "04", "NA", "063002", "", "40.9242", "14.31323", "Europe/Rome"),
("3183472", "Adelfia", "", "IT", "380", "13", "BA", "072002", "", "41.0033", "16.87208", "Europe/Rome"),
("3183490", "Acqui Terme", "", "IT", "380", "12", "AL", "006001", "", "44.67508", "8.46476", "Europe/Rome"),
("3183494", "Acquaviva delle Fonti", "", "IT", "380", "13", "BA", "072001", "", "40.89704", "16.8433", "Europe/Rome"),
("3183539", "Acilia-Castel Fusano-Ostia Antica", "", "IT", "380", "07", "RM", "058091", "", "41.76337", "12.33078", "Europe/Rome"),
("3183541", "Acerra", "", "IT", "380", "04", "NA", "063001", "", "40.94744", "14.37261", "Europe/Rome"),
("3183573", "Abbiategrasso", "Аббиатеграссо", "IT", "380", "09", "MI", "015002", "", "45.39821", "8.91678", "Europe/Rome"),
("3183587", "Abano Terme", "Абано-Терме", "IT", "380", "20", "PD", "028001", "", "45.35753", "11.78725", "Europe/Rome"),
("3219114", "Spinea-Orgnano", "", "IT", "380", "20", "VE", "027038", "", "45.49306", "12.16056", "Europe/Rome"),
("6457398", "Verbania", "Вербания", "IT", "380", "12", "VB", "103072", "", "45.92136", "8.55183", "Europe/Rome"),
("6534216", "Lumezzane", "", "IT", "380", "09", "BS", "017096", "", "45.64788", "10.26487", "Europe/Rome"),
("6534228", "Guidonia Montecelio", "", "IT", "380", "07", "RM", "058047", "", "41.99362", "12.72238", "Europe/Rome"),
("6534232", "Lamezia Terme", "", "IT", "380", "03", "CZ", "079160", "", "38.96589", "16.3092", "Europe/Rome"),
("6534234", "Caronno Pertusella", "", "IT", "380", "09", "VA", "012034", "", "45.59777", "9.04634", "Europe/Rome"),
("6534235", "Cassano Magnago", "", "IT", "380", "09", "VA", "012040", "", "45.66972", "8.81996", "Europe/Rome"),
("6534252", "San Felice A Cancello", "", "IT", "380", "04", "CE", "061075", "", "41.00581", "14.45583", "Europe/Rome"),
("6534253", "San Nicola la Strada", "", "IT", "380", "04", "CE", "061078", "", "41.06073", "14.3348", "Europe/Rome"),
("6534256", "Quarto", "Кварто", "IT", "380", "04", "NA", "063063", "", "40.88088", "14.11436", "Europe/Rome"),
("6534264", "Orta di Atella", "", "IT", "380", "04", "CE", "061053", "", "40.96651", "14.26803", "Europe/Rome"),
("6534267", "Casavatore", "", "IT", "380", "04", "NA", "063021", "", "40.89921", "14.27663", "Europe/Rome"),
("6534268", "Volla", "", "IT", "380", "04", "NA", "063089", "", "40.87363", "14.34085", "Europe/Rome"),
("6534275", "Gravina di Catania", "", "IT", "380", "15", "CT", "087019", "", "37.56085", "15.06292", "Europe/Rome"),
("6534280", "Cesano Boscone", "", "IT", "380", "09", "MI", "015074", "", "45.44207", "9.09445", "Europe/Rome"),
("6534284", "Tor Lupara", "", "IT", "380", "07", "RM", "058122", "", "41.99771", "12.61814", "Europe/Rome"),
("6620312", "Torvaianica", "", "IT", "380", "07", "RM", "058079", "", "41.63431", "12.44768", "Europe/Rome"),
("8224092", "Bellaria-Igea Marina", "", "IT", "380", "05", "RN", "099001", "", "44.14212", "12.47", "Europe/Rome"),
("8378910", "Villanova", "", "IT", "380", "07", "RM", "058047", "", "41.96357", "12.75633", "Europe/Rome"),
("8394392", "Marina di Ardea-Tor San Lorenzo", "", "IT", "380", "07", "RM", "058117", "", "41.55439", "12.54115", "Europe/Rome"),
("8948702", "Portocivitanova", "", "IT", "380", "10", "MC", "043013", "", "43.30782", "13.73139", "Europe/Rome"),
("8948703", "San Paolo", "", "IT", "380", "13", "BA", "072006", "", "41.12476", "16.79258", "Europe/Rome"),
("8948704", "Monterusciello", "", "IT", "380", "04", "NA", "063060", "", "40.86626", "14.07582", "Europe/Rome"),
("8948705", "Romano Banco", "", "IT", "380", "09", "MI", "015036", "", "45.43546", "9.1187", "Europe/Rome"),
("8948706", "Casa Santa", "", "IT", "380", "15", "TP", "081008", "", "38.02739", "12.55146", "Europe/Rome"),
("8948708", "Arpino", "", "IT", "380", "04", "NA", "063023", "", "40.88882", "14.32015", "Europe/Rome"),
("8948709", "Paolo VI", "", "IT", "380", "13", "TA", "073027", "", "40.52218", "17.27401", "Europe/Rome"),
("9003711", "Corigliano Scalo", "", "IT", "380", "03", "CS", "078044", "", "39.62713", "16.51368", "Europe/Rome"),
("3488465", "Spanish Town", "Спаниш-Таун", "JM", "388", "10", "", "", "", "17.99107", "-76.95742", "America/Jamaica"),
("3488613", "Savanna-la-Mar", "", "JM", "388", "16", "", "", "", "18.21895", "-78.1332", "America/Jamaica"),
("3488981", "Portmore", "", "JM", "388", "10", "", "", "", "17.97024", "-76.86722", "America/Jamaica"),
("3489227", "Old Harbour", "", "JM", "388", "10", "", "", "", "17.94144", "-77.10898", "America/Jamaica"),
("3489297", "New Kingston", "", "JM", "388", "08", "", "", "", "18.00747", "-76.78319", "America/Jamaica"),
("3489460", "Montego Bay", "Монтего-Бей", "JM", "388", "12", "", "", "", "18.47116", "-77.91883", "America/Jamaica"),
("3489523", "May Pen", "", "JM", "388", "01", "", "", "", "17.96454", "-77.24515", "America/Jamaica"),
("3489577", "Mandeville", "Мандевиль", "JM", "388", "04", "", "", "", "18.04168", "-77.50714", "America/Jamaica"),
("3489760", "Linstead", "", "JM", "388", "10", "", "", "", "18.13683", "-77.03171", "America/Jamaica"),
("3489854", "Kingston", "Кингстон", "JM", "388", "17", "", "", "", "17.99702", "-76.79358", "America/Jamaica"),
("3490165", "Half Way Tree", "", "JM", "388", "08", "", "", "", "18.01248", "-76.79928", "America/Jamaica"),
("246013", "Wadi as Sir", "", "JO", "400", "16", "", "", "", "31.95126", "35.81979", "Asia/Amman"),
("246314", "Umm as Summaq", "", "JO", "400", "16", "", "", "", "31.88542", "35.8543", "Asia/Amman"),
("247105", "Sahab", "Сахаб", "JO", "400", "16", "", "", "", "31.87207", "36.00501", "Asia/Amman"),
("248370", "Madaba", "Мадаба", "JO", "400", "23", "", "", "", "31.71667", "35.8", "Asia/Amman"),
("248382", "Ma'an", "", "JO", "400", "19", "", "", "", "30.19624", "35.73405", "Asia/Amman"),
("248414", "Kurayyimah", "", "JO", "400", "18", "", "", "", "32.27639", "35.59938", "Asia/Amman"),
("248803", "Judita", "", "JO", "400", "18", "", "", "", "32.40792", "35.70802", "Asia/Amman"),
("248875", "Jarash", "Джераш", "JO", "400", "22", "", "", "", "32.28082", "35.89929", "Asia/Amman"),
("248923", "`Izra", "", "JO", "400", "09", "", "", "", "31.15889", "35.69278", "Asia/Amman"),
("248946", "Irbid", "Ирбид", "JO", "400", "18", "", "", "", "32.55556", "35.85", "Asia/Amman"),
("250090", "Zarqa", "Эз-Зарка", "JO", "400", "17", "", "", "", "32.07275", "36.08796", "Asia/Amman"),
("250152", "Aydun", "", "JO", "400", "18", "", "", "", "32.50722", "35.8575", "Asia/Amman"),
("250198", "At Tafilah", "Тафила", "JO", "400", "12", "", "", "", "30.83752", "35.60442", "Asia/Amman"),
("250258", "As Salt", "Ас-Сальт", "JO", "400", "02", "", "", "", "32.03917", "35.72722", "Asia/Amman"),
("250267", "Safi", "Сафи", "JO", "400", "09", "", "", "", "31.03608", "35.46544", "Asia/Amman"),
("250336", "Ar Ramtha", "", "JO", "400", "18", "", "", "", "32.55917", "36.00694", "Asia/Amman"),
("250420", "`Anjarah", "", "JO", "400", "18", "", "", "", "32.3063", "35.75653", "Asia/Amman"),
("250441", "Amman", "Амман", "JO", "400", "16", "", "", "", "31.95522", "35.94503", "Asia/Amman"),
("250461", "Al Quwaysimah", "", "JO", "400", "16", "", "", "", "31.9167", "35.95", "Asia/Amman"),
("250582", "Mafraq", "", "JO", "400", "15", "", "", "", "32.34289", "36.20804", "Asia/Amman"),
("250624", "Qir Moav", "Эль-Карак", "JO", "400", "19", "", "", "", "31.18248", "35.69999", "Asia/Amman"),
("250637", "Al Jubayhah", "", "JO", "400", "16", "", "", "", "32.02581", "35.86458", "Asia/Amman"),
("250774", "Aqaba", "Акаба", "JO", "400", "21", "", "", "", "29.52667", "35.00778", "Asia/Amman"),
("250799", "'Ajlun", "Аджлун", "JO", "400", "20", "", "", "", "32.33385", "35.75238", "Asia/Amman"),
("6946409", "Karak City", "Карак", "JO", "400", "09", "", "", "", "31.16368", "35.76204", "Asia/Amman"),
("7838895", "Russeifa", "", "JO", "400", "17", "", "", "", "32.01778", "36.04639", "Asia/Amman"),
("1847947", "Shingu", "Синг", "JP", "392", "43", "", "", "", "33.73333", "135.98333", "Asia/Tokyo"),
("1847963", "Atsugi", "Ацуги", "JP", "392", "19", "", "", "", "35.43889", "139.35972", "Asia/Tokyo"),
("1847966", "Akashi", "Акаси", "JP", "392", "13", "", "", "", "34.63333", "134.98333", "Asia/Tokyo"),
("1847968", "Zushi", "", "JP", "392", "19", "", "", "", "35.29264", "139.57735", "Asia/Tokyo"),
("1848004", "Zama", "Зама", "JP", "392", "19", "", "", "", "35.48889", "139.38861", "Asia/Tokyo"),
("1848016", "Yuza", "", "JP", "392", "44", "", "", "", "39.01573", "139.92909", "Asia/Tokyo"),
("1848087", "Yukuhashi", "", "JP", "392", "07", "", "", "", "33.72873", "130.983", "Asia/Tokyo"),
("1848096", "Yuki", "Юки", "JP", "392", "14", "", "", "", "36.3", "139.88333", "Asia/Tokyo"),
("1848113", "Yugawara", "", "JP", "392", "19", "", "", "", "35.15", "139.06667", "Asia/Tokyo"),
("1848188", "Yoshikawa", "Есикава", "JP", "392", "34", "", "", "", "35.88528", "139.83944", "Asia/Tokyo"),
("1848194", "Yoshii", "", "JP", "392", "10", "", "", "", "36.25", "138.98333", "Asia/Tokyo"),
("1848210", "Yoshida-kasugacho", "", "JP", "392", "29", "", "", "", "37.68333", "138.88333", "Asia/Tokyo"),
("1848243", "Yorii", "", "JP", "392", "34", "", "", "", "36.11667", "139.2", "Asia/Tokyo"),
("1848254", "Yono", "", "JP", "392", "34", "", "", "", "35.88333", "139.63333", "Asia/Tokyo"),
("1848277", "Yonago", "", "JP", "392", "41", "", "", "", "35.43333", "133.33333", "Asia/Tokyo"),
("1848313", "Yokosuka", "Йокосука", "JP", "392", "19", "", "", "", "35.28361", "139.66722", "Asia/Tokyo"),
("1848354", "Yokohama", "Иокогама", "JP", "392", "19", "", "", "", "35.44778", "139.6425", "Asia/Tokyo"),
("1848373", "Yokkaichi", "Йоккаичи", "JP", "392", "23", "", "", "", "34.96667", "136.61667", "Asia/Tokyo"),
("1848382", "Youkaichi", "", "JP", "392", "35", "", "", "", "35.11626", "136.19768", "Asia/Tokyo"),
("1848439", "Yawata", "", "JP", "392", "22", "", "", "", "34.87009", "135.7027", "Asia/Tokyo"),
("1848445", "Yatsushiro", "Яцусиро", "JP", "392", "21", "", "", "", "32.5", "130.6", "Asia/Tokyo"),
("1848447", "Yatsuomachi-higashikumisaka", "", "JP", "392", "42", "", "", "", "36.56667", "137.13333", "Asia/Tokyo"),
("1848482", "Yasugicho", "", "JP", "392", "36", "", "", "", "35.42146", "133.24224", "Asia/Tokyo"),
("1848498", "Yashiro", "", "JP", "392", "13", "", "", "", "34.91667", "134.96667", "Asia/Tokyo"),
("1848499", "Yashio-shi", "", "JP", "392", "34", "", "", "", "35.82255", "139.83905", "Asia/Tokyo"),
("1848522", "Yao", "Яо", "JP", "392", "32", "", "", "", "34.61667", "135.6", "Asia/Tokyo"),
("1848550", "Yanai", "Янаи", "JP", "392", "45", "", "", "", "33.96667", "132.11667", "Asia/Tokyo"),
("1848573", "Yanagawa", "Янагава", "JP", "392", "07", "", "", "", "33.16667", "130.4", "Asia/Tokyo"),
("1848633", "Yamasaki", "", "JP", "392", "13", "", "", "", "35", "134.55", "Asia/Tokyo"),
("1848689", "Yamaguchi-shi", "Ямагути", "JP", "392", "45", "", "", "", "34.18583", "131.47139", "Asia/Tokyo"),
("1848705", "Yamaga", "Ямага", "JP", "392", "21", "", "", "", "33.01667", "130.68333", "Asia/Tokyo"),
("1848774", "Yaizu", "Яидзу", "JP", "392", "37", "", "", "", "34.86877", "138.31952", "Asia/Tokyo"),
("1848776", "Yaita", "", "JP", "392", "38", "", "", "", "36.8", "139.93333", "Asia/Tokyo"),
("1848933", "Waki", "", "JP", "392", "39", "", "", "", "34.06667", "134.15", "Asia/Tokyo"),
("1849053", "Utsunomiya-shi", "Уцуномия", "JP", "392", "38", "", "", "", "36.56583", "139.88361", "Asia/Tokyo"),
("1849069", "Uto", "", "JP", "392", "21", "", "", "", "32.68333", "130.66667", "Asia/Tokyo"),
("1849094", "Usuki", "", "JP", "392", "30", "", "", "", "33.12342", "131.80401", "Asia/Tokyo"),
("1849154", "Ushibuka", "", "JP", "392", "21", "", "", "", "32.19537", "130.02554", "Asia/Tokyo"),
("1849183", "Ureshino", "", "JP", "392", "33", "", "", "", "33.1", "129.98333", "Asia/Tokyo"),
("1849186", "Urayasu", "Ураясу", "JP", "392", "40", "", "", "", "35.67056", "139.88861", "Asia/Tokyo"),
("1849237", "Uozu", "", "JP", "392", "42", "", "", "", "36.8", "137.4", "Asia/Tokyo"),
("1849299", "Umi", "", "JP", "392", "07", "", "", "", "33.56826", "130.51009", "Asia/Tokyo"),
("1849367", "Ujiie", "", "JP", "392", "38", "", "", "", "36.68333", "139.96667", "Asia/Tokyo"),
("1849372", "Uji", "Удзи", "JP", "392", "22", "", "", "", "34.88333", "135.8", "Asia/Tokyo"),
("1849407", "Uenohara", "", "JP", "392", "46", "", "", "", "35.61667", "139.11667", "Asia/Tokyo"),
("1849414", "Ueno", "", "JP", "392", "23", "", "", "", "34.75", "136.13333", "Asia/Tokyo"),
("1849424", "Ueki", "", "JP", "392", "21", "", "", "", "32.9", "130.68333", "Asia/Tokyo"),
("1849429", "Ueda", "Уэда", "JP", "392", "26", "", "", "", "36.40265", "138.28161", "Asia/Tokyo"),
("1849498", "Ube", "Убе", "JP", "392", "45", "", "", "", "33.94306", "131.25111", "Asia/Tokyo"),
("1849519", "Tsuyama", "Цуяма", "JP", "392", "31", "", "", "", "35.05215", "133.99885", "Asia/Tokyo"),
("1849539", "Tsushima", "Цусима", "JP", "392", "01", "1849535", "", "", "35.16667", "136.71667", "Asia/Tokyo"),
("1849561", "Tsurusaki", "", "JP", "392", "30", "", "", "", "33.24528", "131.69166", "Asia/Tokyo"),
("1849563", "Tsuruoka", "Цуруока", "JP", "392", "44", "", "", "", "38.72167", "139.82167", "Asia/Tokyo"),
("1849584", "Tsurugi-asahimachi", "", "JP", "392", "15", "", "", "", "36.45", "136.63333", "Asia/Tokyo"),
("1849592", "Tsuruga", "Цуруга", "JP", "392", "06", "", "", "", "35.64547", "136.0558", "Asia/Tokyo"),
("1849647", "Tsuma", "", "JP", "392", "25", "", "", "", "32.1", "131.4", "Asia/Tokyo"),
("1849661", "Tsukumiura", "", "JP", "392", "30", "", "", "", "33.07539", "131.86907", "Asia/Tokyo"),
("1849706", "Tsukawaki", "", "JP", "392", "30", "", "", "", "33.27668", "131.15628", "Asia/Tokyo"),
("1849782", "Tsubata", "", "JP", "392", "15", "", "", "", "36.67012", "136.7403", "Asia/Tokyo"),
("1849788", "Tsubame", "Цубамэ", "JP", "392", "29", "", "", "", "37.6645", "138.92518", "Asia/Tokyo"),
("1849796", "Tsu-shi", "Цу", "JP", "392", "23", "", "", "", "34.73028", "136.50861", "Asia/Tokyo"),
("1849814", "Toyota", "Тоёта", "JP", "392", "01", "1849809", "", "", "35.08333", "137.15", "Asia/Tokyo"),
("1849817", "Toyoshina", "", "JP", "392", "26", "", "", "", "36.29991", "137.90108", "Asia/Tokyo"),
("1849831", "Toyooka", "", "JP", "392", "13", "", "", "", "35.54008", "134.82038", "Asia/Tokyo"),
("1849837", "Toyonaka", "", "JP", "392", "32", "", "", "", "34.78244", "135.46932", "Asia/Tokyo"),
("1849845", "Toyokawa", "Тоёкава", "JP", "392", "01", "1850219", "", "", "34.81667", "137.4", "Asia/Tokyo"),
("1849846", "Toyohashi", "Тойохаши", "JP", "392", "01", "", "", "", "34.76667", "137.38333", "Asia/Tokyo"),
("1849850", "Toyohama", "", "JP", "392", "01", "", "", "", "34.70933", "136.93425", "Asia/Tokyo"),
("1849876", "Toyama-shi", "Тояма", "JP", "392", "42", "", "", "", "36.69528", "137.21139", "Asia/Tokyo"),
("1849892", "Tottori", "", "JP", "392", "41", "", "", "", "35.5", "134.23333", "Asia/Tokyo"),
("1849904", "Tosu", "", "JP", "392", "33", "", "", "", "33.36667", "130.51667", "Asia/Tokyo"),
("1850004", "Tonosho", "", "JP", "392", "17", "", "", "", "34.48333", "134.18333", "Asia/Tokyo"),
("1850034", "Tondabayashi", "", "JP", "392", "32", "", "", "", "34.5", "135.6", "Asia/Tokyo"),
("1850091", "Tomioka", "", "JP", "392", "10", "", "", "", "36.25", "138.9", "Asia/Tokyo"),
("1850108", "Tomigusuku", "", "JP", "392", "47", "", "", "", "26.185", "127.675", "Asia/Tokyo"),
("1850147", "Tokyo", "Токио", "JP", "392", "40", "", "", "", "35.6895", "139.69171", "Asia/Tokyo"),
("1850152", "Tokuyama", "", "JP", "392", "45", "", "", "", "34.05", "131.81667", "Asia/Tokyo"),
("1850158", "Tokushima-shi", "Токусима", "JP", "392", "39", "", "", "", "34.06583", "134.55944", "Asia/Tokyo"),
("1850181", "Tokorozawa", "Токородзава", "JP", "392", "34", "", "", "", "35.79916", "139.46903", "Asia/Tokyo"),
("1850185", "Tokoname", "Токонамэ", "JP", "392", "01", "", "", "", "34.88333", "136.85", "Asia/Tokyo"),
("1850207", "Toki", "Тока", "JP", "392", "09", "", "", "", "35.35", "137.18333", "Asia/Tokyo"),
("1850217", "Tokamachi", "Токамати", "JP", "392", "29", "", "", "", "37.13333", "138.76667", "Asia/Tokyo"),
("1850269", "Togitsu", "", "JP", "392", "27", "", "", "", "32.83333", "129.85", "Asia/Tokyo"),
("1850307", "Tochio-honcho", "", "JP", "392", "29", "", "", "", "37.47642", "138.99513", "Asia/Tokyo"),
("1850311", "Tochigi", "Тотиги", "JP", "392", "38", "", "", "", "36.38333", "139.73333", "Asia/Tokyo"),
("1850345", "Toba", "Тоба", "JP", "392", "23", "", "", "", "34.4833", "136.84186", "Asia/Tokyo"),
("1850396", "Tenri", "Тэнри", "JP", "392", "28", "", "", "", "34.58333", "135.83333", "Asia/Tokyo"),
("1850405", "Tenno", "", "JP", "392", "02", "", "", "", "39.9", "139.96667", "Asia/Tokyo"),
("1850472", "Tawaramoto", "", "JP", "392", "28", "", "", "", "34.55", "135.8", "Asia/Tokyo"),
("1850498", "Tatsuno", "", "JP", "392", "26", "", "", "", "35.98426", "137.99721", "Asia/Tokyo"),
("1850499", "Tatsuno", "", "JP", "392", "13", "", "", "", "34.86667", "134.55", "Asia/Tokyo"),
("1850523", "Tateyama", "Татеяма", "JP", "392", "04", "", "", "", "34.98333", "139.86667", "Asia/Tokyo"),
("1850559", "Tatebayashi", "", "JP", "392", "10", "", "", "", "36.25", "139.53333", "Asia/Tokyo"),
("1850589", "Tarumizu", "", "JP", "392", "18", "", "", "", "31.48333", "130.7", "Asia/Tokyo"),
("1850600", "Tarui", "Таруи", "JP", "392", "09", "", "", "", "35.36667", "136.53333", "Asia/Tokyo"),
("1850627", "Tanushimarumachi-toyoki", "", "JP", "392", "07", "", "", "", "33.35", "130.68333", "Asia/Tokyo"),
("1850630", "Tanuma", "", "JP", "392", "38", "", "", "", "36.36667", "139.58333", "Asia/Tokyo"),
("1850692", "Nishi-Tokyo-shi", "", "JP", "392", "40", "1850692", "", "", "35.72526", "139.5383", "Asia/Tokyo"),
("1850693", "Tanashicho", "", "JP", "392", "40", "", "", "", "35.7303", "139.53391", "Asia/Tokyo"),
("1850707", "Tanabe", "", "JP", "392", "22", "", "", "", "34.81667", "135.76667", "Asia/Tokyo"),
("1850708", "Tanabe", "Танабэ", "JP", "392", "43", "", "", "", "33.73333", "135.36667", "Asia/Tokyo"),
("1850742", "Tamano", "Тамано", "JP", "392", "31", "", "", "", "34.48333", "133.95", "Asia/Tokyo"),
("1850745", "Tamana", "Тамана", "JP", "392", "21", "", "", "", "32.91667", "130.56667", "Asia/Tokyo"),
("1850746", "Tamamura", "", "JP", "392", "10", "1852846", "", "", "36.3", "139.11667", "Asia/Tokyo"),
("1850818", "Taketoyo", "", "JP", "392", "01", "", "", "", "34.85", "136.91667", "Asia/Tokyo"),
("1850834", "Takeo", "Такео", "JP", "392", "33", "", "", "", "33.2", "130.01667", "Asia/Tokyo"),
("1850860", "Takehara", "", "JP", "392", "11", "", "", "", "34.33833", "132.91667", "Asia/Tokyo"),
("1850872", "Takefu", "", "JP", "392", "06", "", "", "", "35.90393", "136.16687", "Asia/Tokyo"),
("1850878", "Takedamachi", "", "JP", "392", "30", "", "", "", "32.96667", "131.4", "Asia/Tokyo"),
("1850892", "Takayama", "Такаяма", "JP", "392", "09", "", "", "", "36.13333", "137.25", "Asia/Tokyo"),
("1850910", "Takatsuki", "", "JP", "392", "32", "", "", "", "34.84833", "135.61678", "Asia/Tokyo"),
("1851002", "Takasaki", "Такасаки", "JP", "392", "10", "", "", "", "36.33333", "139.01667", "Asia/Tokyo"),
("1851012", "Takarazuka", "", "JP", "392", "13", "", "", "", "34.79936", "135.35697", "Asia/Tokyo"),
("1851032", "Takaoka", "", "JP", "392", "42", "", "", "", "36.75", "137.01667", "Asia/Tokyo"),
("1851068", "Takanabe", "", "JP", "392", "25", "", "", "", "32.13333", "131.5", "Asia/Tokyo"),
("1851100", "Takamatsu-shi", "Такамацу", "JP", "392", "17", "", "", "", "34.34028", "134.04333", "Asia/Tokyo"),
("1851125", "Takaishi", "", "JP", "392", "32", "", "", "", "34.51667", "135.43333", "Asia/Tokyo"),
("1851137", "Takahashi", "Такахаси", "JP", "392", "31", "", "", "", "34.78333", "133.61667", "Asia/Tokyo"),
("1851155", "Takahama", "Такахама", "JP", "392", "01", "", "", "", "34.91667", "136.98333", "Asia/Tokyo"),
("1851170", "Bungo-Takada-shi", "", "JP", "392", "30", "", "", "", "33.5567", "131.44506", "Asia/Tokyo"),
("1851193", "Tajimi", "", "JP", "392", "09", "", "", "", "35.31667", "137.13333", "Asia/Tokyo"),
("1851259", "Tahara", "", "JP", "392", "01", "", "", "", "34.66667", "137.26667", "Asia/Tokyo"),
("1851273", "Tagawa", "Тагава", "JP", "392", "07", "", "", "", "33.63333", "130.8", "Asia/Tokyo"),
("1851282", "Tadotsu", "", "JP", "392", "17", "", "", "", "34.275", "133.75", "Asia/Tokyo"),
("1851348", "Suzuka", "Судзука", "JP", "392", "23", "", "", "", "34.88333", "136.58333", "Asia/Tokyo"),
("1851357", "Suzaka", "", "JP", "392", "26", "", "", "", "36.65", "138.31667", "Asia/Tokyo"),
("1851368", "Suwa", "Сува", "JP", "392", "26", "", "", "", "36.03799", "138.11308", "Asia/Tokyo"),
("1851390", "Susaki", "", "JP", "392", "20", "", "", "", "33.39471", "133.29128", "Asia/Tokyo"),
("1851426", "Sumoto", "Сумото", "JP", "392", "13", "", "", "", "34.35", "134.9", "Asia/Tokyo"),
("1851462", "Sukumo", "", "JP", "392", "20", "", "", "", "32.93333", "132.73333", "Asia/Tokyo"),
("1851483", "Suita", "Суита", "JP", "392", "32", "", "", "", "34.76143", "135.51567", "Asia/Tokyo"),
("1851494", "Suibara", "", "JP", "392", "29", "", "", "", "37.84608", "139.23039", "Asia/Tokyo"),
("1851504", "Sugito", "", "JP", "392", "34", "", "", "", "36.03107", "139.72636", "Asia/Tokyo"),
("1851542", "Sueyoshicho-ninokata", "", "JP", "392", "18", "", "", "", "31.65", "131.01667", "Asia/Tokyo"),
("1851604", "Soka", "Сок", "JP", "392", "34", "", "", "", "35.82028", "139.80444", "Asia/Tokyo"),
("1851606", "Soja", "", "JP", "392", "31", "", "", "", "34.66667", "133.75", "Asia/Tokyo"),
("1851622", "Sobue", "", "JP", "392", "01", "", "", "", "35.25", "136.71667", "Asia/Tokyo"),
("1851711", "Shobu", "Себу", "JP", "392", "34", "", "", "", "36.06667", "139.6", "Asia/Tokyo"),
("1851713", "Shobara", "", "JP", "392", "11", "", "", "", "34.85", "133.01667", "Asia/Tokyo"),
("1851717", "Shizuoka-shi", "Сидзуока", "JP", "392", "37", "", "", "", "34.97694", "138.38306", "Asia/Tokyo"),
("1851813", "Shirone", "", "JP", "392", "29", "", "", "", "37.76354", "139.02199", "Asia/Tokyo"),
("1851883", "Shiraoka", "", "JP", "392", "34", "", "", "", "36.01839", "139.66034", "Asia/Tokyo"),
("1851935", "Shirahama", "Ширахама", "JP", "392", "13", "", "", "", "34.78333", "134.71667", "Asia/Tokyo"),
("1851952", "Shiozawa", "", "JP", "392", "29", "", "", "", "37.03757", "138.84867", "Asia/Tokyo"),
("1852003", "Shiojiri", "", "JP", "392", "26", "", "", "", "36.1", "137.96667", "Asia/Tokyo"),
("1852046", "Shinshiro", "Синсиро", "JP", "392", "01", "", "", "", "34.9", "137.5", "Asia/Tokyo"),
("1852102", "Shin'ichi", "", "JP", "392", "11", "", "", "", "34.55543", "133.27297", "Asia/Tokyo"),
("1852109", "Shingu", "Синг", "JP", "392", "07", "", "", "", "33.71667", "130.43333", "Asia/Tokyo"),
("1852225", "Shimonoseki", "Симоносеки", "JP", "392", "45", "", "", "", "33.95", "130.95", "Asia/Tokyo"),
("1852347", "Shimodate", "", "JP", "392", "14", "", "", "", "36.3", "139.98333", "Asia/Tokyo"),
("1852357", "Shimoda", "Симода", "JP", "392", "37", "", "", "", "34.66667", "138.95", "Asia/Tokyo"),
("1852383", "Shimminatocho", "", "JP", "392", "43", "", "", "", "34.18333", "135.2", "Asia/Tokyo"),
("1852385", "Nishishinminato", "", "JP", "392", "42", "", "", "", "36.77957", "137.07576", "Asia/Tokyo"),
("1852472", "Shimada", "Симада", "JP", "392", "37", "", "", "", "34.81667", "138.18333", "Asia/Tokyo"),
("1852479", "Shimabara", "", "JP", "392", "27", "", "", "", "32.78333", "130.36667", "Asia/Tokyo"),
("1852502", "Shiki", "Сики", "JP", "392", "34", "", "", "", "35.83333", "139.58333", "Asia/Tokyo"),
("1852561", "Shido", "", "JP", "392", "17", "", "", "", "34.32333", "134.17333", "Asia/Tokyo"),
("1852588", "Shibushi", "", "JP", "392", "18", "", "", "", "31.46667", "131.105", "Asia/Tokyo"),
("1852595", "Shibukawa", "", "JP", "392", "10", "", "", "", "36.48333", "139", "Asia/Tokyo"),
("1852607", "Shibata", "Шибата", "JP", "392", "29", "", "", "", "37.95", "139.33333", "Asia/Tokyo"),
("1852663", "Seto", "Сету", "JP", "392", "01", "", "", "", "35.23333", "137.1", "Asia/Tokyo"),
("1852673", "Setaka", "", "JP", "392", "07", "", "", "", "33.15", "130.46667", "Asia/Tokyo"),
("1852736", "Satsumasendai", "Сендай", "JP", "392", "18", "", "", "", "31.81667", "130.3", "Asia/Tokyo"),
("1852849", "Satte", "", "JP", "392", "34", "", "", "", "36.07254", "139.72615", "Asia/Tokyo"),
("1852899", "Sasebo", "Сасебо", "JP", "392", "27", "", "", "", "33.15917", "129.72278", "Asia/Tokyo"),
("1852901", "Sasayama", "Сасаяма", "JP", "392", "13", "", "", "", "35.06667", "135.21667", "Asia/Tokyo"),
("1852915", "Sasaguri", "", "JP", "392", "07", "", "", "", "33.61561", "130.55106", "Asia/Tokyo"),
("1852964", "Sano", "Сана", "JP", "392", "38", "", "", "", "36.31667", "139.58333", "Asia/Tokyo"),
("1852984", "Sanjo", "Сандзе", "JP", "392", "29", "", "", "", "37.61667", "138.95", "Asia/Tokyo"),
("1853008", "Sanda", "Санда", "JP", "392", "13", "", "", "", "34.88333", "135.23333", "Asia/Tokyo"),
("1853066", "Sakurai", "Сакураи", "JP", "392", "28", "", "", "", "34.5", "135.85", "Asia/Tokyo"),
("1853081", "Saku", "Саку", "JP", "392", "26", "", "", "", "36.21667", "138.48333", "Asia/Tokyo"),
("1853140", "Sakata", "Саката", "JP", "392", "44", "", "", "", "38.91667", "139.855", "Asia/Tokyo"),
("1853174", "Sakaiminato", "", "JP", "392", "36", "", "", "", "35.55", "133.23333", "Asia/Tokyo"),
("1853190", "Sakaide", "", "JP", "392", "17", "", "", "", "34.31667", "133.85", "Asia/Tokyo"),
("1853192", "Sakai", "", "JP", "392", "10", "", "", "", "36.26667", "139.25", "Asia/Tokyo"),
("1853193", "Sakai", "Сакаи", "JP", "392", "14", "", "", "", "36.1", "139.8", "Asia/Tokyo"),
("1853195", "Sakai", "Сакаи", "JP", "392", "32", "", "", "", "34.58333", "135.46667", "Asia/Tokyo"),
("1853209", "Sakado", "", "JP", "392", "34", "", "", "", "35.95694", "139.38889", "Asia/Tokyo"),
("1853237", "Saiki", "", "JP", "392", "30", "", "", "", "32.95", "131.9", "Asia/Tokyo"),
("1853280", "Sagara", "", "JP", "392", "37", "", "", "", "34.68503", "138.20461", "Asia/Tokyo"),
("1853303", "Saga-shi", "Сага Япония", "JP", "392", "33", "", "", "", "33.24932", "130.2988", "Asia/Tokyo"),
("1853338", "Sabae", "", "JP", "392", "06", "", "", "", "35.94647", "136.18498", "Asia/Tokyo"),
("1853354", "Ryuo", "", "JP", "392", "46", "", "", "", "35.65", "138.5", "Asia/Tokyo"),
("1853371", "Ryotsu-minato", "", "JP", "392", "29", "", "", "", "38.07817", "138.4394", "Asia/Tokyo"),
("1853433", "Ozu", "Одзу", "JP", "392", "21", "", "", "", "32.86667", "130.86667", "Asia/Tokyo"),
("1853483", "Oyama", "Ояма", "JP", "392", "38", "", "", "", "36.3", "139.8", "Asia/Tokyo"),
("1853486", "Oyama", "", "JP", "392", "37", "", "", "", "34.60359", "138.21719", "Asia/Tokyo"),
("1853514", "Owase", "Овасэ", "JP", "392", "23", "", "", "", "34.06667", "136.2", "Asia/Tokyo"),
("1853564", "Otsuki", "Оцуки", "JP", "392", "46", "", "", "", "35.6", "138.93333", "Asia/Tokyo"),
("1853574", "Otsu-shi", "Оцу", "JP", "392", "35", "", "", "", "35.00444", "135.86833", "Asia/Tokyo"),
("1853662", "Otake", "Отакэ", "JP", "392", "45", "", "", "", "34.2", "132.21667", "Asia/Tokyo"),
("1853677", "Ota", "Ота", "JP", "392", "10", "", "", "", "36.3", "139.36667", "Asia/Tokyo"),
("1853909", "Osaka-shi", "Осака", "JP", "392", "32", "", "", "", "34.69374", "135.50218", "Asia/Tokyo"),
("1853992", "Onomichi", "", "JP", "392", "11", "", "", "", "34.41667", "133.2", "Asia/Tokyo"),
("1854018", "Onoda", "", "JP", "392", "45", "", "", "", "34.00139", "131.18361", "Asia/Tokyo"),
("1854022", "Ono", "Оно", "JP", "392", "06", "", "", "", "35.98106", "136.48727", "Asia/Tokyo"),
("1854026", "Ono", "Оно", "JP", "392", "13", "", "", "", "34.85", "134.93333", "Asia/Tokyo"),
("1854028", "Ono-hara", "Оно", "JP", "392", "11", "", "", "", "34.28333", "132.26667", "Asia/Tokyo"),
("1854083", "Omuta", "Омута", "JP", "392", "07", "", "", "", "33.03333", "130.45", "Asia/Tokyo"),
("1854093", "Omura", "Омура", "JP", "392", "27", "", "", "", "32.92139", "129.95389", "Asia/Tokyo"),
("1854162", "Ome", "Оме", "JP", "392", "40", "", "", "", "35.78389", "139.24306", "Asia/Tokyo"),
("1854177", "Omama", "", "JP", "392", "10", "", "", "", "36.43333", "139.28333", "Asia/Tokyo"),
("1854186", "Omachi", "", "JP", "392", "26", "", "", "", "36.5", "137.86667", "Asia/Tokyo"),
("1854246", "Okuchi", "", "JP", "392", "18", "", "", "", "32.06667", "130.61667", "Asia/Tokyo"),
("1854371", "Okegawa", "", "JP", "392", "34", "", "", "", "36", "139.55722", "Asia/Tokyo"),
("1854376", "Okazaki", "Окадзаки", "JP", "392", "01", "", "", "", "34.95", "137.16667", "Asia/Tokyo"),
("1854383", "Okayama-shi", "Окаяма", "JP", "392", "31", "", "", "", "34.66167", "133.935", "Asia/Tokyo"),
("1854384", "Okaya", "", "JP", "392", "26", "", "", "", "36.05659", "138.0451", "Asia/Tokyo"),
("1854405", "Okawa", "Окава", "JP", "392", "33", "", "", "", "33.2", "130.35", "Asia/Tokyo"),
("1854444", "Ojiya", "", "JP", "392", "29", "", "", "", "37.3", "138.8", "Asia/Tokyo"),
("1854487", "Oita", "Оита", "JP", "392", "30", "", "", "", "33.23806", "131.6125", "Asia/Tokyo"),
("1854492", "Oiso", "", "JP", "392", "19", "", "", "", "35.30306", "139.30278", "Asia/Tokyo"),
("1854530", "Oi", "", "JP", "392", "34", "", "", "", "35.85091", "139.51998", "Asia/Tokyo"),
("1854629", "Ogori-shimogo", "", "JP", "392", "45", "", "", "", "34.1", "131.4", "Asia/Tokyo"),
("1854665", "Ogawa", "Огава", "JP", "392", "34", "", "", "", "36.05", "139.26667", "Asia/Tokyo"),
("1854703", "Ogaki", "", "JP", "392", "09", "", "", "", "35.35", "136.61667", "Asia/Tokyo"),
("1854747", "Odawara", "Одавара", "JP", "392", "19", "", "", "", "35.25556", "139.15972", "Asia/Tokyo"),
("1854774", "Odacho-oda", "Ода", "JP", "392", "36", "", "", "", "35.19025", "132.50846", "Asia/Tokyo"),
("1854803", "Obu", "Обу", "JP", "392", "01", "", "", "", "35", "136.96667", "Asia/Tokyo"),
("1854807", "Obita", "", "JP", "392", "27", "", "", "", "32.81667", "129.88333", "Asia/Tokyo"),
("1854849", "Obama", "Обама", "JP", "392", "06", "", "", "", "35.49576", "135.74604", "Asia/Tokyo"),
("1854868", "Nyuzen", "", "JP", "392", "42", "", "", "", "36.93744", "137.50059", "Asia/Tokyo"),
("1854902", "Numazu", "Нумадзу", "JP", "392", "37", "", "", "", "35.1", "138.86667", "Asia/Tokyo"),
("1854905", "Numata", "", "JP", "392", "10", "", "", "", "36.63333", "139.05", "Asia/Tokyo"),
("1854979", "Nonoichi", "Ноноичи", "JP", "392", "15", "", "", "", "36.53333", "136.61667", "Asia/Tokyo"),
("1855066", "Nogata", "", "JP", "392", "07", "", "", "", "33.73996", "130.72282", "Asia/Tokyo"),
("1855078", "Noda", "Нода", "JP", "392", "04", "", "", "", "35.94111", "139.85806", "Asia/Tokyo"),
("1855095", "Nobeoka", "Нобеока", "JP", "392", "25", "", "", "", "32.58333", "131.66667", "Asia/Tokyo"),
("1855134", "Nishiwaki", "Нишиваки", "JP", "392", "13", "", "", "", "34.98333", "134.96667", "Asia/Tokyo"),
("1855189", "Nishio", "Нисио", "JP", "392", "01", "", "", "", "34.86667", "137.05", "Asia/Tokyo"),
("1855203", "Nishinoomote", "", "JP", "392", "18", "", "", "", "30.73333", "131", "Asia/Tokyo"),
("1855207", "Nishinomiya", "Нисиномия", "JP", "392", "13", "", "", "", "34.71667", "135.33333", "Asia/Tokyo"),
("1855363", "Nirasaki", "", "JP", "392", "46", "", "", "", "35.7", "138.45", "Asia/Tokyo"),
("1855380", "Ninomiya", "Ниномия", "JP", "392", "19", "", "", "", "35.30333", "139.25333", "Asia/Tokyo"),
("1855395", "Nikko", "Никко", "JP", "392", "38", "", "", "", "36.75", "139.61667", "Asia/Tokyo"),
("1855410", "Niitsu-honcho", "", "JP", "392", "29", "", "", "", "37.80024", "139.1224", "Asia/Tokyo"),
("1855416", "Niimi", "Ниими", "JP", "392", "31", "", "", "", "34.98333", "133.46667", "Asia/Tokyo"),
("1855425", "Niihama", "", "JP", "392", "05", "", "", "", "33.96047", "133.30522", "Asia/Tokyo"),
("1855431", "Niigata-shi", "Ниигата", "JP", "392", "29", "", "", "", "37.90222", "139.02361", "Asia/Tokyo"),
("1855476", "Nichinan", "Нитинан", "JP", "392", "25", "", "", "", "31.6", "131.36667", "Asia/Tokyo"),
("1855540", "Naze", "", "JP", "392", "18", "", "", "", "28.36667", "129.48333", "Asia/Tokyo"),
("1855580", "Naruto", "Наруто", "JP", "392", "39", "", "", "", "34.18333", "134.61667", "Asia/Tokyo"),
("1855612", "Nara-shi", "Нара", "JP", "392", "28", "", "", "", "34.68505", "135.80485", "Asia/Tokyo"),
("1855670", "Nanao", "Нанао", "JP", "392", "15", "", "", "", "37.05", "136.96667", "Asia/Tokyo"),
("1855694", "Namerikawa", "Намэрикава", "JP", "392", "42", "", "", "", "36.76667", "137.33333", "Asia/Tokyo"),
("1855753", "Nakatsugawa", "", "JP", "392", "09", "", "", "", "35.48333", "137.5", "Asia/Tokyo"),
("1855757", "Nakatsu", "", "JP", "392", "07", "", "", "", "33.59811", "131.1883", "Asia/Tokyo"),
("1855852", "Nakanojo", "", "JP", "392", "10", "", "", "", "36.58333", "138.85", "Asia/Tokyo"),
("1855863", "Nakano", "Накано", "JP", "392", "26", "", "", "", "36.75", "138.36667", "Asia/Tokyo"),
("1855891", "Nakamura", "Накамура", "JP", "392", "20", "", "", "", "32.98333", "132.93333", "Asia/Tokyo"),
("1855907", "Nakama", "", "JP", "392", "07", "", "", "", "33.81667", "130.7", "Asia/Tokyo"),
("1856035", "Naha-shi", "Наха", "JP", "392", "47", "", "", "", "26.2125", "127.68111", "Asia/Tokyo"),
("1856057", "Nagoya-shi", "Нагоя", "JP", "392", "01", "", "", "", "35.18147", "136.90641", "Asia/Tokyo"),
("1856068", "Nago", "Нага", "JP", "392", "47", "", "", "", "26.58806", "127.97611", "Asia/Tokyo"),
("1856177", "Nagasaki-shi", "Нагасаки", "JP", "392", "27", "", "", "", "32.74472", "129.87361", "Asia/Tokyo"),
("1856184", "Nagareyama", "", "JP", "392", "04", "", "", "", "35.8563", "139.90266", "Asia/Tokyo"),
("1856199", "Nagaoka", "Нагаока", "JP", "392", "29", "", "", "", "37.45", "138.85", "Asia/Tokyo"),
("1856215", "Nagano-shi", "Нагано", "JP", "392", "26", "", "", "", "36.65139", "138.18111", "Asia/Tokyo"),
("1856243", "Nagahama", "Нагахама", "JP", "392", "35", "", "", "", "35.38333", "136.26667", "Asia/Tokyo"),
("1856293", "Nabari", "", "JP", "392", "23", "", "", "", "34.61667", "136.08333", "Asia/Tokyo"),
("1856367", "Musashino", "Мусасино", "JP", "392", "40", "", "", "", "35.70611", "139.55944", "Asia/Tokyo"),
("1856392", "Muroto-misakicho", "", "JP", "392", "20", "", "", "", "33.28662", "134.16832", "Asia/Tokyo"),
("1856426", "Muramatsu", "", "JP", "392", "29", "", "", "", "37.69257", "139.17127", "Asia/Tokyo"),
("1856434", "Murakami", "Мураками", "JP", "392", "29", "", "", "", "38.23333", "139.48333", "Asia/Tokyo"),
("1856456", "Muko", "Мука", "JP", "392", "22", "", "", "", "34.96545", "135.70415", "Asia/Tokyo"),
("1856476", "Muikamachi", "", "JP", "392", "29", "", "", "", "37.06667", "138.88333", "Asia/Tokyo"),
("1856560", "Morohongo", "", "JP", "392", "34", "", "", "", "35.93556", "139.30444", "Asia/Tokyo"),
("1856569", "Moriyama", "Морияма", "JP", "392", "35", "", "", "", "35.06667", "135.98333", "Asia/Tokyo"),
("1856584", "Moriguchi", "", "JP", "392", "32", "", "", "", "34.73333", "135.56667", "Asia/Tokyo"),
("1856586", "Mori", "Море", "JP", "392", "37", "", "", "", "34.83333", "137.93333", "Asia/Tokyo"),
("1856667", "Mizunami", "", "JP", "392", "09", "", "", "", "35.36667", "137.25", "Asia/Tokyo"),
("1856698", "Miyoshi", "", "JP", "392", "11", "", "", "", "34.8", "132.85", "Asia/Tokyo"),
("1856703", "Miyazu", "", "JP", "392", "22", "", "", "", "35.53333", "135.18333", "Asia/Tokyo"),
("1856717", "Miyazaki-shi", "Миядзаки", "JP", "392", "25", "", "", "", "31.91111", "131.42389", "Asia/Tokyo"),
("1856775", "Miyakonojo", "", "JP", "392", "25", "", "", "", "31.73333", "131.06667", "Asia/Tokyo"),
("1856828", "Miyata", "", "JP", "392", "07", "", "", "", "33.70811", "130.65297", "Asia/Tokyo"),
("1856878", "Mitsuke", "", "JP", "392", "29", "", "", "", "37.53333", "138.93333", "Asia/Tokyo"),
("1856881", "Mitsukaido", "", "JP", "392", "14", "", "", "", "36.01667", "139.98333", "Asia/Tokyo"),
("1856938", "Mitake", "", "JP", "392", "09", "", "", "", "35.41667", "137.13333", "Asia/Tokyo"),
("1856942", "Mitaka-shi", "", "JP", "392", "40", "1856942", "", "", "35.68351", "139.55963", "Asia/Tokyo"),
("1856977", "Mishima", "Мисима", "JP", "392", "37", "", "", "", "35.11667", "138.91667", "Asia/Tokyo"),
("1857046", "Mino", "", "JP", "392", "32", "", "", "", "34.82691", "135.47057", "Asia/Tokyo"),
("1857062", "Mino", "Мина", "JP", "392", "09", "", "", "", "35.53333", "136.91667", "Asia/Tokyo"),
("1857144", "Minami-rinkan", "", "JP", "392", "19", "", "", "", "35.48333", "139.45", "Asia/Tokyo"),
("1857208", "Minamata", "Минамата", "JP", "392", "21", "", "", "", "32.21667", "130.4", "Asia/Tokyo"),
("1857209", "Minakuchi", "", "JP", "392", "35", "", "", "", "34.96667", "136.16667", "Asia/Tokyo"),
("1857260", "Mikuni", "", "JP", "392", "06", "", "", "", "36.21706", "136.15185", "Asia/Tokyo"),
("1857276", "Miki", "Мики", "JP", "392", "13", "", "", "", "34.8", "134.98333", "Asia/Tokyo"),
("1857334", "Mihara", "", "JP", "392", "11", "", "", "", "34.4", "133.08333", "Asia/Tokyo"),
("1857379", "Mibu", "Мибу", "JP", "392", "38", "", "", "", "36.41667", "139.8", "Asia/Tokyo"),
("1857403", "Menuma", "", "JP", "392", "34", "", "", "", "36.21667", "139.38333", "Asia/Tokyo"),
("1857470", "Matsuto", "", "JP", "392", "15", "", "", "", "36.51667", "136.56667", "Asia/Tokyo"),
("1857519", "Matsumoto", "Мацумото", "JP", "392", "26", "", "", "", "36.23333", "137.96667", "Asia/Tokyo"),
("1857550", "Matsue-shi", "Мацуэ", "JP", "392", "36", "", "", "", "35.47222", "133.05056", "Asia/Tokyo"),
("1857553", "Matsudo", "Мацудо", "JP", "392", "04", "", "", "", "35.78333", "139.9", "Asia/Tokyo"),
("1857560", "Matsubase", "", "JP", "392", "21", "", "", "", "32.65", "130.66667", "Asia/Tokyo"),
("1857568", "Matsubara", "", "JP", "392", "32", "", "", "", "34.56667", "135.55", "Asia/Tokyo"),
("1857594", "Masuda", "Масуд", "JP", "392", "36", "", "", "", "34.66667", "131.85", "Asia/Tokyo"),
("1857651", "Maruoka", "", "JP", "392", "06", "", "", "", "36.1534", "136.27029", "Asia/Tokyo"),
("1857659", "Kamimaruko", "Маруко", "JP", "392", "26", "", "", "", "36.31865", "138.2733", "Asia/Tokyo"),
("1857665", "Marugame", "", "JP", "392", "17", "", "", "", "34.28333", "133.78333", "Asia/Tokyo"),
("1857712", "Makurazaki", "", "JP", "392", "18", "", "", "", "31.26667", "130.31667", "Asia/Tokyo"),
("1857751", "Maki", "", "JP", "392", "29", "", "", "", "37.75", "138.88333", "Asia/Tokyo"),
("1857766", "Maizuru", "Майдзуру", "JP", "392", "22", "", "", "", "35.45", "135.33333", "Asia/Tokyo"),
("1857843", "Maebashi-shi", "Маэбаси", "JP", "392", "10", "", "", "", "36.39111", "139.06083", "Asia/Tokyo"),
("1857844", "Maebaru", "", "JP", "392", "07", "", "", "", "33.55", "130.2", "Asia/Tokyo"),
("1857871", "Machida", "Мачида", "JP", "392", "40", "1857869", "", "", "35.54028", "139.45083", "Asia/Tokyo"),
("1857910", "Kyoto", "Киото", "JP", "392", "22", "", "", "", "35.02107", "135.75385", "Asia/Tokyo"),
("1858041", "Kushikino", "", "JP", "392", "18", "", "", "", "31.71667", "130.26667", "Asia/Tokyo"),
("1858067", "Kusatsu", "Кусацу", "JP", "392", "35", "", "", "", "35.01667", "135.96667", "Asia/Tokyo"),
("1858088", "Kurume", "Куруме", "JP", "392", "07", "", "", "", "33.31667", "130.51667", "Asia/Tokyo"),
("1858249", "Kuroda", "Курода", "JP", "392", "01", "", "", "", "35.35", "136.78333", "Asia/Tokyo"),
("1858283", "Kurihashi", "", "JP", "392", "34", "", "", "", "36.13333", "139.7", "Asia/Tokyo"),
("1858296", "Kure", "Куре", "JP", "392", "11", "", "", "", "34.23222", "132.56658", "Asia/Tokyo"),
("1858301", "Kurayoshi", "", "JP", "392", "41", "", "", "", "35.43333", "133.81667", "Asia/Tokyo"),
("1858311", "Kurashiki", "Курашики", "JP", "392", "31", "", "", "", "34.58333", "133.76667", "Asia/Tokyo"),
("1858421", "Kumamoto", "", "JP", "392", "21", "", "", "", "32.80589", "130.69181", "Asia/Tokyo"),
("1858428", "Kumagaya", "Кумагая", "JP", "392", "34", "", "", "", "36.13333", "139.38333", "Asia/Tokyo"),
("1858445", "Kukichuo", "Куки", "JP", "392", "34", "", "", "", "36.06739", "139.67498", "Asia/Tokyo"),
("1858498", "Kudamatsu", "", "JP", "392", "45", "", "", "", "34", "131.86667", "Asia/Tokyo"),
("1858591", "Kozakai-cho", "", "JP", "392", "01", "1862294", "", "", "34.8", "137.35889", "Asia/Tokyo"),
("1858695", "Kuragaki-kosugi", "", "JP", "392", "42", "", "", "", "36.73403", "137.14186", "Asia/Tokyo"),
("1858729", "Koshigaya", "", "JP", "392", "34", "", "", "", "35.88333", "139.78333", "Asia/Tokyo"),
("1858756", "Kosai-shi", "", "JP", "392", "37", "", "", "", "34.7184", "137.53175", "Asia/Tokyo"),
("1858794", "Konosu", "", "JP", "392", "34", "", "", "", "36.06868", "139.51684", "Asia/Tokyo"),
("1858836", "Konan", "Конан", "JP", "392", "01", "", "", "", "35.33165", "136.87042", "Asia/Tokyo"),
("1858858", "Komoro", "", "JP", "392", "26", "", "", "", "36.31667", "138.43333", "Asia/Tokyo"),
("1858866", "Komono", "", "JP", "392", "23", "", "", "", "35", "136.51667", "Asia/Tokyo"),
("1858902", "Komatsushimacho", "", "JP", "392", "39", "", "", "", "34", "134.58333", "Asia/Tokyo"),
("1858910", "Komatsu", "", "JP", "392", "15", "", "", "", "36.40263", "136.45088", "Asia/Tokyo"),
("1858926", "Komaki", "Комаки", "JP", "392", "01", "", "", "", "35.28333", "136.91667", "Asia/Tokyo"),
("1858964", "Kokubunji", "Кокубундзи", "JP", "392", "40", "", "", "", "35.70222", "139.47556", "Asia/Tokyo"),
("1858972", "Kokubu-matsuki", "Кокубу", "JP", "392", "18", "", "", "", "31.73333", "130.76667", "Asia/Tokyo"),
("1859093", "Koga", "Кога", "JP", "392", "14", "", "", "", "36.18333", "139.71667", "Asia/Tokyo"),
("1859094", "Koga", "Кога", "JP", "392", "07", "", "", "", "33.73333", "130.46667", "Asia/Tokyo"),
("1859100", "Kofu-shi", "Кофе", "JP", "392", "46", "", "", "", "35.66389", "138.56833", "Asia/Tokyo"),
("1859113", "Kodama", "Кодама", "JP", "392", "34", "", "", "", "36.18333", "139.13333", "Asia/Tokyo"),
("1859146", "Kochi-shi", "Кочин", "JP", "392", "20", "", "", "", "33.55972", "133.53111", "Asia/Tokyo"),
("1859171", "Kobe", "Кобе", "JP", "392", "13", "", "", "", "34.6913", "135.183", "Asia/Tokyo"),
("1859175", "Kobayashi", "Кобаяси", "JP", "392", "25", "", "", "", "31.98333", "130.98333", "Asia/Tokyo"),
("1859234", "Kitsuki", "Кицуки", "JP", "392", "30", "", "", "", "33.41998", "131.61836", "Asia/Tokyo"),
("1859307", "Kitakyushu", "Китакюсю", "JP", "392", "07", "", "", "", "33.83333", "130.83333", "Asia/Tokyo"),
("1859319", "Kitakata", "Китаката", "JP", "392", "08", "", "", "", "37.65", "139.86667", "Asia/Tokyo"),
("1859335", "Kitahama", "", "JP", "392", "35", "", "", "", "35.16667", "135.91667", "Asia/Tokyo"),
("1859383", "Kishiwada", "Кисивада", "JP", "392", "32", "", "", "", "34.46667", "135.36667", "Asia/Tokyo"),
("1859393", "Kisarazu", "Кисарадзу", "JP", "392", "04", "", "", "", "35.37472", "139.9225", "Asia/Tokyo"),
("1859400", "Kisai", "", "JP", "392", "34", "", "", "", "36.1", "139.58333", "Asia/Tokyo"),
("1859405", "Kiryu", "Кири", "JP", "392", "10", "", "", "", "36.4", "139.33333", "Asia/Tokyo"),
("1859492", "Kikuchi", "Кикути", "JP", "392", "21", "", "", "", "32.98333", "130.81667", "Asia/Tokyo"),
("1859586", "Kazo", "", "JP", "392", "34", "", "", "", "36.11667", "139.6", "Asia/Tokyo"),
("1859642", "Kawasaki", "Кавасаки", "JP", "392", "19", "1859635", "", "", "35.52056", "139.71722", "Asia/Tokyo"),
("1859647", "Kawasaki", "", "JP", "392", "07", "", "", "", "33.59993", "130.81495", "Asia/Tokyo"),
("1859675", "Kawanishi", "", "JP", "392", "13", "", "", "", "34.81667", "135.41667", "Asia/Tokyo"),
("1859730", "Kawaguchi", "Кавагути", "JP", "392", "34", "", "", "", "35.80521", "139.71072", "Asia/Tokyo"),
("1859740", "Kawagoe", "Кавагоэ", "JP", "392", "34", "", "", "", "35.90861", "139.48528", "Asia/Tokyo"),
("1859765", "Katsuyama", "", "JP", "392", "06", "", "", "", "36.06173", "136.50101", "Asia/Tokyo"),
("1859884", "Kasukabe", "", "JP", "392", "34", "", "", "", "35.98122", "139.74424", "Asia/Tokyo"),
("1859891", "Kasugai", "Касугай", "JP", "392", "01", "", "", "", "35.24762", "136.97229", "Asia/Tokyo"),
("1859908", "Kashiwazaki", "Касивадзаки", "JP", "392", "29", "", "", "", "37.36667", "138.55", "Asia/Tokyo"),
("1859924", "Kashiwa", "Касива", "JP", "392", "04", "", "", "", "35.85444", "139.96889", "Asia/Tokyo"),
("1859941", "Kashima", "Касима", "JP", "392", "33", "", "", "", "33.10611", "130.09056", "Asia/Tokyo"),
("1859951", "Kashihara-shi", "", "JP", "392", "28", "1859951", "", "", "34.50896", "135.7929", "Asia/Tokyo"),
("1859952", "Kashihara", "", "JP", "392", "32", "", "", "", "34.58333", "135.61667", "Asia/Tokyo"),
("1859964", "Kaseda-shirakame", "", "JP", "392", "18", "", "", "", "31.41667", "130.31667", "Asia/Tokyo"),
("1859990", "Kasaoka", "", "JP", "392", "31", "", "", "", "34.5", "133.5", "Asia/Tokyo"),
("1859998", "Kasamatsucho", "", "JP", "392", "09", "", "", "", "35.36667", "136.76667", "Asia/Tokyo"),
("1860034", "Kariya", "Кария", "JP", "392", "01", "", "", "", "34.98333", "136.98333", "Asia/Tokyo"),
("1860063", "Karatsu", "Карацу", "JP", "392", "33", "", "", "", "33.4425", "129.96972", "Asia/Tokyo"),
("1860095", "Kanzaki", "", "JP", "392", "33", "", "", "", "33.3", "130.36667", "Asia/Tokyo"),
("1860098", "Kanuma", "Канума", "JP", "392", "38", "", "", "", "36.55", "139.73333", "Asia/Tokyo"),
("1860112", "Kanoya", "Каноя", "JP", "392", "18", "", "", "", "31.38333", "130.85", "Asia/Tokyo"),
("1860122", "Kanonji", "", "JP", "392", "17", "", "", "", "34.11667", "133.65", "Asia/Tokyo"),
("1860176", "Kannabecho-yahiro", "", "JP", "392", "11", "", "", "", "34.55808", "133.41796", "Asia/Tokyo"),
("1860191", "Kanie", "", "JP", "392", "01", "", "", "", "35.13333", "136.8", "Asia/Tokyo"),
("1860211", "Kaneko", "", "JP", "392", "10", "", "", "", "36.4", "139", "Asia/Tokyo"),
("1860234", "Kanda", "Канда", "JP", "392", "07", "", "", "", "33.78333", "130.98333", "Asia/Tokyo"),
("1860243", "Kanazawa-shi", "Канадзава", "JP", "392", "15", "", "", "", "36.59444", "136.62556", "Asia/Tokyo"),
("1860256", "Kanaya", "", "JP", "392", "37", "", "", "", "34.82022", "138.12775", "Asia/Tokyo"),
("1860321", "Kamojima", "", "JP", "392", "39", "", "", "", "34.06667", "134.35", "Asia/Tokyo"),
("1860335", "Kamogata", "", "JP", "392", "31", "", "", "", "34.53333", "133.58333", "Asia/Tokyo"),
("1860341", "Kamo", "Камо", "JP", "392", "29", "", "", "", "37.66442", "139.03502", "Asia/Tokyo"),
("1860437", "Kamirenjaku", "Митака", "JP", "392", "40", "", "", "", "35.70034", "139.55665", "Asia/Tokyo"),
("1860458", "Kaminokawa", "", "JP", "392", "38", "", "", "", "36.43333", "139.91667", "Asia/Tokyo"),
("1860563", "Kamiichi", "", "JP", "392", "42", "", "", "", "36.7", "137.36667", "Asia/Tokyo"),
("1860626", "Kameyama", "", "JP", "392", "23", "", "", "", "34.85", "136.45", "Asia/Tokyo"),
("1860635", "Kameoka", "Камеока", "JP", "392", "22", "", "", "", "35", "135.58333", "Asia/Tokyo"),
("1860648", "Kameda-honcho", "", "JP", "392", "29", "", "", "", "37.87214", "139.1099", "Asia/Tokyo"),
("1860672", "Kamakura", "Камакура", "JP", "392", "19", "", "", "", "35.30889", "139.55028", "Asia/Tokyo"),
("1860704", "Kakogawa", "", "JP", "392", "13", "", "", "", "34.76667", "134.85", "Asia/Tokyo"),
("1860728", "Kakegawa", "Какэгава", "JP", "392", "37", "", "", "", "34.76667", "138.01667", "Asia/Tokyo"),
("1860735", "Kakamigahara", "", "JP", "392", "09", "", "", "", "35.41667", "136.86667", "Asia/Tokyo"),
("1860748", "Kashima-shi", "", "JP", "392", "14", "", "", "", "35.96536", "140.64474", "Asia/Tokyo"),
("1860750", "Kajiki", "", "JP", "392", "18", "", "", "", "31.73333", "130.66667", "Asia/Tokyo"),
("1860765", "Kaizuka", "", "JP", "392", "32", "", "", "", "34.45", "135.35", "Asia/Tokyo"),
("1860785", "Kainan", "", "JP", "392", "43", "", "", "", "34.15", "135.2", "Asia/Tokyo"),
("1860827", "Kagoshima-shi", "", "JP", "392", "18", "", "", "", "31.56018", "130.55814", "Asia/Tokyo"),
("1860871", "Kadoma", "Кадоме", "JP", "392", "32", "", "", "", "34.73333", "135.58333", "Asia/Tokyo"),
("1861084", "Izumo", "Идзумо", "JP", "392", "36", "", "", "", "35.36667", "132.76667", "Asia/Tokyo"),
("1861095", "Izumiotsu", "Идзумотсу", "JP", "392", "32", "", "", "", "34.5", "135.4", "Asia/Tokyo"),
("1861107", "Izumi", "", "JP", "392", "32", "", "", "", "34.48333", "135.43333", "Asia/Tokyo"),
("1861108", "Izumi", "Изуми", "JP", "392", "18", "", "", "", "32.08333", "130.36667", "Asia/Tokyo"),
("1861164", "Iwatsuki", "", "JP", "392", "34", "", "", "", "35.95225", "139.68502", "Asia/Tokyo"),
("1861171", "Iwata", "Ивата", "JP", "392", "37", "", "", "", "34.7", "137.85", "Asia/Tokyo"),
("1861207", "Iwakura", "", "JP", "392", "01", "", "", "", "35.28333", "136.86667", "Asia/Tokyo"),
("1861212", "Iwakuni", "Ивакуни", "JP", "392", "45", "", "", "", "34.16297", "132.22", "Asia/Tokyo"),
("1861223", "Iwai", "", "JP", "392", "14", "", "", "", "36.05", "139.9", "Asia/Tokyo"),
("1861244", "Iwade", "", "JP", "392", "43", "", "", "", "34.25", "135.31667", "Asia/Tokyo"),
("1861261", "Itsukaichi", "", "JP", "392", "40", "", "", "", "35.72528", "139.21778", "Asia/Tokyo"),
("1861280", "Itoman", "", "JP", "392", "47", "", "", "", "26.12647", "127.66918", "Asia/Tokyo"),
("1861285", "Itoigawa", "", "JP", "392", "29", "", "", "", "37.03333", "137.85", "Asia/Tokyo"),
("1861290", "Ito", "Ито", "JP", "392", "37", "", "", "", "34.96667", "139.08333", "Asia/Tokyo"),
("1861310", "Itami", "Итами", "JP", "392", "13", "", "", "", "34.78427", "135.40126", "Asia/Tokyo"),
("1861383", "Ishiki", "", "JP", "392", "01", "", "", "", "34.8", "137.01667", "Asia/Tokyo"),
("1861393", "Ishikawa", "Исикава", "JP", "392", "47", "", "", "", "26.42333", "127.82139", "Asia/Tokyo"),
("1861400", "Ishii", "Исии", "JP", "392", "39", "", "", "", "34.06667", "134.43333", "Asia/Tokyo"),
("1861406", "Ishige", "", "JP", "392", "14", "", "", "", "36.11667", "139.96667", "Asia/Tokyo"),
("1861416", "Ishigaki", "Ишигаки", "JP", "392", "47", "", "", "", "24.34478", "124.15717", "Asia/Tokyo"),
("1861436", "Isesaki", "", "JP", "392", "10", "", "", "", "36.31667", "139.2", "Asia/Tokyo"),
("1861449", "Isehara", "", "JP", "392", "19", "", "", "", "35.39056", "139.30778", "Asia/Tokyo"),
("1861450", "Ise", "Исэ", "JP", "392", "23", "", "", "", "34.48333", "136.7", "Asia/Tokyo"),
("1861454", "Isawa", "", "JP", "392", "46", "", "", "", "35.65", "138.63333", "Asia/Tokyo"),
("1861464", "Isahaya", "", "JP", "392", "27", "", "", "", "32.84111", "130.04306", "Asia/Tokyo"),
("1861528", "Inuyama", "Инуяма", "JP", "392", "09", "", "", "", "35.37995", "136.94295", "Asia/Tokyo"),
("1861584", "Ino", "Ино", "JP", "392", "20", "", "", "", "33.55", "133.43333", "Asia/Tokyo"),
("1861586", "Innoshima", "", "JP", "392", "11", "", "", "", "34.28333", "133.18333", "Asia/Tokyo"),
("1861602", "Inazawa", "", "JP", "392", "01", "", "", "", "35.25", "136.78333", "Asia/Tokyo"),
("1861641", "Ina", "Ина", "JP", "392", "26", "", "", "", "35.82756", "137.95378", "Asia/Tokyo"),
("1861677", "Imari", "Имари", "JP", "392", "33", "", "", "", "33.26667", "129.88333", "Asia/Tokyo"),
("1861699", "Imaichi", "", "JP", "392", "38", "", "", "", "36.71667", "139.68333", "Asia/Tokyo"),
("1861749", "Ikoma", "Икома", "JP", "392", "28", "1861747", "", "", "34.68333", "135.7", "Asia/Tokyo"),
("1861795", "Ikeda", "Икеда", "JP", "392", "32", "", "", "", "34.82208", "135.4298", "Asia/Tokyo"),
("1861799", "Ikeda", "", "JP", "392", "39", "", "", "", "34.01667", "133.8", "Asia/Tokyo"),
("1861825", "Ijuin", "", "JP", "392", "18", "", "", "", "31.61667", "130.4", "Asia/Tokyo"),
("1861835", "Iizuka", "Иидзука", "JP", "392", "07", "", "", "", "33.63654", "130.68678", "Asia/Tokyo"),
("1861838", "Iiyama", "", "JP", "392", "26", "", "", "", "36.85", "138.36667", "Asia/Tokyo"),
("1861864", "Iida", "Иида", "JP", "392", "26", "", "", "", "35.51965", "137.82074", "Asia/Tokyo"),
("1861949", "Ichinomiya", "", "JP", "392", "01", "", "", "", "35.3", "136.8", "Asia/Tokyo"),
("1862010", "Ibusuki", "", "JP", "392", "18", "", "", "", "31.23333", "130.65", "Asia/Tokyo"),
("1862033", "Ibaraki", "Ибараки", "JP", "392", "32", "", "", "", "34.81641", "135.56828", "Asia/Tokyo"),
("1862034", "Ibara", "", "JP", "392", "31", "", "", "", "34.6", "133.46667", "Asia/Tokyo"),
("1862098", "Hotaka", "", "JP", "392", "26", "", "", "", "36.3396", "137.88254", "Asia/Tokyo"),
("1862198", "Honjo", "", "JP", "392", "34", "", "", "", "36.23333", "139.18333", "Asia/Tokyo"),
("1862230", "Hondo", "Хондо", "JP", "392", "21", "", "", "", "32.45", "130.2", "Asia/Tokyo"),
("1862302", "Hofu", "", "JP", "392", "45", "", "", "", "34.05", "131.56667", "Asia/Tokyo"),
("1862352", "Hitoyoshi", "", "JP", "392", "21", "", "", "", "32.21667", "130.75", "Asia/Tokyo"),
("1862373", "Hita", "Хиты", "JP", "392", "30", "", "", "", "33.3213", "130.94098", "Asia/Tokyo"),
("1862389", "Hisai", "", "JP", "392", "23", "", "", "", "34.66667", "136.46667", "Asia/Tokyo"),
("1862415", "Hiroshima-shi", "Хиросима", "JP", "392", "11", "", "", "", "34.39627", "132.45937", "Asia/Tokyo"),
("1862462", "Hiratsuka", "Хирацука", "JP", "392", "19", "", "", "", "35.32306", "139.34222", "Asia/Tokyo"),
("1862471", "Hiratacho", "", "JP", "392", "36", "", "", "", "35.43333", "132.81667", "Asia/Tokyo"),
("1862505", "Hirara", "", "JP", "392", "47", "", "", "", "24.80379", "125.30222", "Asia/Tokyo"),
("1862540", "Hirakata", "", "JP", "392", "32", "", "", "", "34.81352", "135.64914", "Asia/Tokyo"),
("1862555", "Hirado", "Хирадо", "JP", "392", "27", "7418805", "", "", "33.36853", "129.55247", "Asia/Tokyo"),
("1862599", "Hino", "", "JP", "392", "40", "", "", "", "35.67306", "139.40028", "Asia/Tokyo"),
("1862601", "Hino", "", "JP", "392", "35", "", "", "", "35", "136.25", "Asia/Tokyo"),
("1862612", "Himi", "Хими", "JP", "392", "42", "", "", "", "36.85", "136.98333", "Asia/Tokyo"),
("1862627", "Himeji", "Химэдзи", "JP", "392", "13", "", "", "", "34.81667", "134.7", "Asia/Tokyo"),
("1862636", "Hikone", "Хиконэ", "JP", "392", "35", "", "", "", "35.25", "136.25", "Asia/Tokyo"),
("1862689", "Hiji", "", "JP", "392", "30", "", "", "", "33.37081", "131.53025", "Asia/Tokyo"),
("1862912", "Hekinan", "Хекинан", "JP", "392", "01", "", "", "", "34.88333", "136.98333", "Asia/Tokyo"),
("1862992", "Hayama", "Хаяма", "JP", "392", "19", "", "", "", "35.27651", "139.57733", "Asia/Tokyo"),
("1863018", "Hatsukaichi", "", "JP", "392", "11", "", "", "", "34.35", "132.33333", "Asia/Tokyo"),
("1863023", "Hatogaya-honcho", "", "JP", "392", "34", "1859726", "", "", "35.83314", "139.7425", "Asia/Tokyo"),
("1863082", "Hashimoto", "Хасимото", "JP", "392", "43", "", "", "", "34.31667", "135.61667", "Asia/Tokyo"),
("1863173", "Hanyu", "Ханьюй", "JP", "392", "34", "", "", "", "36.16667", "139.53333", "Asia/Tokyo"),
("1863183", "Hanno", "Ханно", "JP", "392", "34", "", "", "", "35.85194", "139.31806", "Asia/Tokyo"),
("1863209", "Handa", "Ханда", "JP", "392", "01", "", "", "", "34.88333", "136.93333", "Asia/Tokyo"),
("1863279", "Hamanoichi", "", "JP", "392", "18", "", "", "", "31.71667", "130.73333", "Asia/Tokyo"),
("1863289", "Hamamatsu", "Хамамацу", "JP", "392", "37", "", "", "", "34.7", "137.73333", "Asia/Tokyo"),
("1863293", "Hamakita", "", "JP", "392", "37", "", "", "", "34.8", "137.78333", "Asia/Tokyo"),
("1863310", "Hamada", "Хамада", "JP", "392", "36", "", "", "", "34.88333", "132.08333", "Asia/Tokyo"),
("1863341", "Hakui", "", "JP", "392", "15", "", "", "", "36.88333", "136.78333", "Asia/Tokyo"),
("1863398", "Haibara", "", "JP", "392", "28", "", "", "", "34.53333", "135.95", "Asia/Tokyo"),
("1863418", "Hagi", "", "JP", "392", "45", "", "", "", "34.4", "131.41667", "Asia/Tokyo"),
("1863426", "Haebaru", "", "JP", "392", "47", "", "", "", "26.33694", "127.87194", "Asia/Tokyo"),
("1863431", "Hadano", "Хадано", "JP", "392", "19", "", "", "", "35.37111", "139.22361", "Asia/Tokyo"),
("1863440", "Hachioji", "Хатиодзи", "JP", "392", "40", "", "", "", "35.65583", "139.32389", "Asia/Tokyo"),
("1863451", "Omihachiman", "", "JP", "392", "35", "", "", "", "35.12861", "136.0976", "Asia/Tokyo"),
("1863482", "Gyoda", "", "JP", "392", "34", "", "", "", "36.13333", "139.45", "Asia/Tokyo"),
("1863495", "Gushikawa", "", "JP", "392", "47", "", "", "", "26.35937", "127.86735", "Asia/Tokyo"),
("1863521", "Gotsucho", "", "JP", "392", "36", "", "", "", "35.00856", "132.2257", "Asia/Tokyo"),
("1863528", "Gotemba", "Готемба", "JP", "392", "37", "", "", "", "35.3", "138.93333", "Asia/Tokyo"),
("1863540", "Gosen", "Госен", "JP", "392", "29", "", "", "", "37.73333", "139.16667", "Asia/Tokyo"),
("1863541", "Gose", "", "JP", "392", "28", "", "", "", "34.45", "135.73333", "Asia/Tokyo"),
("1863592", "Gojo", "", "JP", "392", "28", "", "", "", "34.35", "135.7", "Asia/Tokyo"),
("1863611", "Godo", "Года", "JP", "392", "09", "", "", "", "35.41667", "136.6", "Asia/Tokyo"),
("1863614", "Gobo", "Гобо", "JP", "392", "43", "", "", "", "33.88333", "135.15", "Asia/Tokyo"),
("1863627", "Ginowan", "", "JP", "392", "47", "", "", "", "26.26265", "127.76147", "Asia/Tokyo"),
("1863641", "Gifu-shi", "Гифу", "JP", "392", "09", "", "", "", "35.42291", "136.76039", "Asia/Tokyo"),
("1863693", "Gamagori", "", "JP", "392", "01", "", "", "", "34.83333", "137.23333", "Asia/Tokyo"),
("1863713", "Futtsu", "Фуццу", "JP", "392", "04", "", "", "", "35.30528", "139.81861", "Asia/Tokyo"),
("1863905", "Funabashi", "Фунабаси", "JP", "392", "04", "", "", "", "35.69306", "139.98333", "Asia/Tokyo"),
("1863917", "Fukuyama", "Фукуяма", "JP", "392", "11", "", "", "", "34.48333", "133.36667", "Asia/Tokyo"),
("1863945", "Fukuroi", "Фукурои", "JP", "392", "37", "", "", "", "34.75", "137.91667", "Asia/Tokyo"),
("1863953", "Fukura", "", "JP", "392", "13", "", "", "", "34.25", "134.71667", "Asia/Tokyo"),
("1863967", "Fukuoka-shi", "Фукуока", "JP", "392", "07", "", "", "", "33.60639", "130.41806", "Asia/Tokyo"),
("1863973", "Fukumitsu", "", "JP", "392", "42", "", "", "", "36.55751", "136.86945", "Asia/Tokyo"),
("1863978", "Fukuma", "", "JP", "392", "07", "", "", "", "33.76667", "130.46667", "Asia/Tokyo"),
("1863985", "Fukui-shi", "Фукуй", "JP", "392", "06", "", "", "", "36.06443", "136.22257", "Asia/Tokyo"),
("1863997", "Fukuecho", "", "JP", "392", "27", "", "", "", "32.69732", "128.84561", "Asia/Tokyo"),
("1864009", "Fukuchiyama", "", "JP", "392", "22", "", "", "", "35.3", "135.11667", "Asia/Tokyo"),
("1864025", "Fukiage", "", "JP", "392", "34", "", "", "", "36.1", "139.45", "Asia/Tokyo"),
("1864031", "Fukaya", "", "JP", "392", "34", "", "", "", "36.2", "139.28333", "Asia/Tokyo"),
("1864092", "Fujisawa", "Фудзисава", "JP", "392", "19", "", "", "", "35.34194", "139.47", "Asia/Tokyo"),
("1864098", "Fujioka", "Фудзиока", "JP", "392", "38", "", "", "", "36.25", "139.65", "Asia/Tokyo"),
("1864099", "Fujioka", "Фудзиока", "JP", "392", "10", "", "", "", "36.25", "139.08333", "Asia/Tokyo"),
("1864105", "Fujinomiya", "Фудзиномия", "JP", "392", "37", "", "", "", "35.21667", "138.61667", "Asia/Tokyo"),
("1864132", "Fujieda", "Фудзиэда", "JP", "392", "37", "", "", "", "34.86667", "138.26667", "Asia/Tokyo"),
("1864134", "Fuji", "Фудзи", "JP", "392", "37", "", "", "", "35.16667", "138.68333", "Asia/Tokyo"),
("1864155", "Fuchucho", "Фучу", "JP", "392", "11", "", "", "", "34.5735", "133.23513", "Asia/Tokyo"),
("1864180", "Enzan", "", "JP", "392", "46", "", "", "", "35.7", "138.73333", "Asia/Tokyo"),
("1864416", "Daito", "", "JP", "392", "32", "", "", "", "34.7", "135.61667", "Asia/Tokyo"),
("1864518", "Chofugaoka", "", "JP", "392", "40", "", "", "", "35.65924", "139.54837", "Asia/Tokyo"),
("1864549", "Chiryu", "", "JP", "392", "01", "", "", "", "35", "137.03333", "Asia/Tokyo"),
("1864557", "Chino", "", "JP", "392", "26", "", "", "", "35.9944", "138.15428", "Asia/Tokyo"),
("1864572", "Chikushino-shi", "", "JP", "392", "07", "1864572", "", "", "33.49631", "130.5156", "Asia/Tokyo"),
("1864624", "Chigasaki", "", "JP", "392", "19", "", "", "", "35.32611", "139.40389", "Asia/Tokyo"),
("1864637", "Chichibu", "", "JP", "392", "34", "", "", "", "35.99028", "139.07639", "Asia/Tokyo"),
("1864652", "Chatan", "", "JP", "392", "47", "", "", "", "26.30944", "127.77028", "Asia/Tokyo"),
("1864750", "Beppu", "Бэппу", "JP", "392", "30", "", "", "", "33.27945", "131.49751", "Asia/Tokyo"),
("1864873", "Ayabe", "Аябе", "JP", "392", "22", "", "", "", "35.3", "135.25", "Asia/Tokyo"),
("1864945", "Atami", "Атами", "JP", "392", "37", "", "", "", "35.08944", "139.06861", "Asia/Tokyo"),
("1864985", "Ashiya", "", "JP", "392", "13", "", "", "", "34.72807", "135.30264", "Asia/Tokyo"),
("1865005", "Ashikaga", "Асикага", "JP", "392", "38", "", "", "", "36.33333", "139.45", "Asia/Tokyo"),
("1865207", "Arai", "", "JP", "392", "29", "", "", "", "37.00059", "138.2259", "Asia/Tokyo"),
("1865290", "Annaka", "", "JP", "392", "10", "", "", "", "36.31667", "138.9", "Asia/Tokyo"),
("1865294", "Anjo", "Андзё", "JP", "392", "01", "", "", "", "34.95828", "137.08054", "Asia/Tokyo"),
("1865309", "Anan", "Анан", "JP", "392", "39", "", "", "", "33.91667", "134.65", "Asia/Tokyo"),
("1865375", "Amagi", "", "JP", "392", "07", "", "", "", "33.41804", "130.65413", "Asia/Tokyo"),
("1865387", "Amagasaki", "", "JP", "392", "13", "", "", "", "34.71667", "135.41667", "Asia/Tokyo"),
("1865401", "Akune", "", "JP", "392", "18", "", "", "", "32.01667", "130.2", "Asia/Tokyo"),
("1865412", "Ako", "Ако", "JP", "392", "13", "", "", "", "34.75", "134.4", "Asia/Tokyo"),
("1865449", "Aki", "Аки", "JP", "392", "20", "", "", "", "33.5", "133.9", "Asia/Tokyo"),
("1865661", "Aioi-shi", "", "JP", "392", "13", "", "", "", "34.80361", "134.46806", "Asia/Tokyo"),
("1865714", "Ageoshimo", "", "JP", "392", "34", "", "", "", "35.97145", "139.61382", "Asia/Tokyo"),
("1894616", "Okinawa", "Окинава", "JP", "392", "47", "", "", "", "26.33583", "127.80139", "Asia/Tokyo"),
("1895695", "Kushima", "", "JP", "392", "25", "", "", "", "31.48621", "131.2421", "Asia/Tokyo"),
("1896348", "Hikari", "Хикари", "JP", "392", "45", "", "", "", "33.955", "131.95", "Asia/Tokyo"),
("1899102", "Nagato", "Нагато", "JP", "392", "45", "", "", "", "34.38333", "131.2", "Asia/Tokyo"),
("1907123", "Hasuda", "", "JP", "392", "34", "", "", "", "35.97134", "139.6534", "Asia/Tokyo"),
("1907125", "Kamifukuoka", "", "JP", "392", "34", "", "", "", "35.87076", "139.51393", "Asia/Tokyo"),
("1907146", "Sayama", "Саяма", "JP", "392", "34", "", "", "", "35.85295", "139.41212", "Asia/Tokyo"),
("1907148", "Fussa", "", "JP", "392", "40", "", "", "", "35.73667", "139.32361", "Asia/Tokyo"),
("1907299", "Asaka", "Асака", "JP", "392", "34", "", "", "", "35.80472", "139.60194", "Asia/Tokyo"),
("1907300", "Wako", "Вако", "JP", "392", "34", "", "", "", "35.78944", "139.62333", "Asia/Tokyo"),
("1907301", "Shimotoda", "Тода", "JP", "392", "34", "", "", "", "35.81251", "139.6856", "Asia/Tokyo"),
("1907307", "Kimitsu", "Кимицу", "JP", "392", "04", "", "", "", "35.32528", "139.89111", "Asia/Tokyo"),
("1907309", "Miura", "Миура", "JP", "392", "19", "", "", "", "35.14", "139.61917", "Asia/Tokyo"),
("1926004", "Wakayama-shi", "Вакаяма", "JP", "392", "43", "", "", "", "34.22611", "135.1675", "Asia/Tokyo"),
("1926006", "Iyo", "Ие", "JP", "392", "05", "", "", "", "33.75139", "132.70139", "Asia/Tokyo"),
("1926020", "Uwajima", "Увадзима", "JP", "392", "05", "", "", "", "33.22375", "132.56001", "Asia/Tokyo"),
("1926054", "Saijo", "Сайдзё", "JP", "392", "05", "", "", "", "33.91667", "133.18333", "Asia/Tokyo"),
("1926055", "Ozu", "Одзу", "JP", "392", "05", "", "", "", "33.5", "132.55", "Asia/Tokyo"),
("1926099", "Matsuyama", "Мацуяма", "JP", "392", "05", "7406319", "", "", "33.83916", "132.76574", "Asia/Tokyo"),
("1926101", "Masaki-cho", "", "JP", "392", "05", "", "1926101", "", "33.78757", "132.71124", "Asia/Tokyo"),
("1926116", "Kawanoe", "", "JP", "392", "05", "", "", "", "34.01667", "133.56667", "Asia/Tokyo"),
("1926142", "Hojo", "Ходзе", "JP", "392", "05", "", "", "", "33.97661", "132.77767", "Asia/Tokyo"),
("2110460", "Yuzawa", "Юдзава", "JP", "392", "02", "", "", "", "39.16667", "140.5", "Asia/Tokyo"),
("2110480", "Yotsukaido", "", "JP", "392", "04", "", "", "", "35.65", "140.16667", "Asia/Tokyo"),
("2110498", "Yonezawa", "Йонезава", "JP", "392", "44", "", "", "", "37.91", "140.11667", "Asia/Tokyo"),
("2110506", "Yokotemachi", "", "JP", "392", "02", "", "", "", "39.31691", "140.55034", "Asia/Tokyo"),
("2110518", "Yokaichiba", "", "JP", "392", "04", "", "", "", "35.7", "140.55", "Asia/Tokyo"),
("2110538", "Yanagawamachi-saiwaicho", "Янагава", "JP", "392", "08", "", "", "", "37.85", "140.6", "Asia/Tokyo"),
("2110541", "Yamoto", "", "JP", "392", "24", "", "", "", "38.42738", "141.21487", "Asia/Tokyo"),
("2110556", "Yamagata-shi", "Ямагата", "JP", "392", "44", "", "", "", "38.24056", "140.36333", "Asia/Tokyo"),
("2110560", "Yamada", "Ямада", "JP", "392", "16", "", "", "", "39.46667", "141.95", "Asia/Tokyo"),
("2110579", "Yachimata", "", "JP", "392", "04", "", "", "", "35.65", "140.31667", "Asia/Tokyo"),
("2110586", "Watari", "Ватари", "JP", "392", "24", "", "", "", "38.035", "140.85111", "Asia/Tokyo"),
("2110596", "Wakuya", "", "JP", "392", "24", "", "", "", "38.54465", "141.13461", "Asia/Tokyo"),
("2110629", "Ushiku", "", "JP", "392", "14", "", "", "", "35.96667", "140.13333", "Asia/Tokyo"),
("2110683", "Tsukuba", "", "JP", "392", "14", "", "", "", "36.2", "140.1", "Asia/Tokyo"),
("2110729", "Toride", "", "JP", "392", "14", "", "", "", "35.9", "140.08333", "Asia/Tokyo"),
("2110735", "Tono", "Тона", "JP", "392", "16", "", "", "", "39.31667", "141.53333", "Asia/Tokyo"),
("2110743", "Tomobe", "", "JP", "392", "14", "", "", "", "36.35", "140.3", "Asia/Tokyo"),
("2110744", "Tomiya", "", "JP", "392", "24", "", "", "", "38.39306", "140.88611", "Asia/Tokyo"),
("2110774", "Togane", "", "JP", "392", "04", "", "", "", "35.55", "140.36667", "Asia/Tokyo"),
("2110793", "Tendo", "Тендо", "JP", "392", "44", "", "", "", "38.35361", "140.36972", "Asia/Tokyo"),
("2110891", "Takahata", "Такахата", "JP", "392", "44", "", "", "", "38.0025", "140.19111", "Asia/Tokyo"),
("2110893", "Takahagi", "", "JP", "392", "14", "", "", "", "36.71667", "140.71667", "Asia/Tokyo"),
("2110959", "Sukagawa", "", "JP", "392", "08", "", "", "", "37.28333", "140.38333", "Asia/Tokyo"),
("2110994", "Shizukuishi", "", "JP", "392", "16", "", "", "", "39.69414", "140.98442", "Asia/Tokyo"),
("2111008", "Shisui", "", "JP", "392", "04", "", "", "", "35.71667", "140.26667", "Asia/Tokyo"),
("2111016", "Shiroishi", "", "JP", "392", "24", "", "", "", "38.00333", "140.61833", "Asia/Tokyo"),
("2111018", "Shiroi", "", "JP", "392", "04", "", "", "", "35.8", "140.06667", "Asia/Tokyo"),
("2111049", "Shiogama", "Сиогама", "JP", "392", "24", "", "", "", "38.31667", "141.03333", "Asia/Tokyo"),
("2111065", "Shinjo", "Синдзе", "JP", "392", "44", "", "", "", "38.75861", "140.30083", "Asia/Tokyo"),
("2111149", "Sendai-shi", "Сендай", "JP", "392", "24", "", "", "", "38.26889", "140.87194", "Asia/Tokyo"),
("2111173", "Sawara", "", "JP", "392", "04", "", "", "", "35.88333", "140.5", "Asia/Tokyo"),
("2111220", "Sakura", "Сакура", "JP", "392", "04", "", "", "", "35.71667", "140.23333", "Asia/Tokyo"),
("2111248", "Sagae", "", "JP", "392", "44", "", "", "", "38.3725", "140.2725", "Asia/Tokyo"),
("2111258", "Ryugasaki", "", "JP", "392", "14", "", "", "", "35.9", "140.18333", "Asia/Tokyo"),
("2111277", "Rifu", "", "JP", "392", "24", "", "", "", "38.33092", "140.97691", "Asia/Tokyo"),
("2111310", "Otsuchi", "", "JP", "392", "16", "", "", "", "39.36667", "141.9", "Asia/Tokyo"),
("2111325", "Otawara", "", "JP", "392", "38", "", "", "", "36.86667", "140.03333", "Asia/Tokyo"),
("2111425", "Omiya", "", "JP", "392", "14", "", "", "", "36.55", "140.41667", "Asia/Tokyo"),
("2111429", "Omigawa", "", "JP", "392", "04", "", "", "", "35.85", "140.61667", "Asia/Tokyo"),
("2111435", "Omagari", "", "JP", "392", "02", "", "", "", "39.45", "140.48333", "Asia/Tokyo"),
("2111441", "Okunoya", "", "JP", "392", "14", "", "", "", "36.28333", "140.41667", "Asia/Tokyo"),
("2111461", "Okawara", "", "JP", "392", "24", "", "", "", "38.05", "140.73361", "Asia/Tokyo"),
("2111495", "Ohara", "", "JP", "392", "04", "", "", "", "35.25", "140.38333", "Asia/Tokyo"),
("2111530", "Ofunato", "", "JP", "392", "16", "", "", "", "39.07167", "141.71667", "Asia/Tokyo"),
("2111559", "Obanazawa", "", "JP", "392", "44", "", "", "", "38.60333", "140.40194", "Asia/Tokyo"),
("2111567", "Oarai", "", "JP", "392", "14", "", "", "", "36.31409", "140.58389", "Asia/Tokyo"),
("2111568", "Oami", "", "JP", "392", "04", "", "", "", "35.51667", "140.31667", "Asia/Tokyo"),
("2111656", "Nihommatsu", "", "JP", "392", "08", "", "", "", "37.58333", "140.43333", "Asia/Tokyo"),
("2111677", "Naruto", "", "JP", "392", "04", "", "", "", "35.6", "140.41667", "Asia/Tokyo"),
("2111684", "Narita", "Нарита", "JP", "392", "04", "", "", "", "35.78333", "140.31667", "Asia/Tokyo"),
("2111704", "Namie", "", "JP", "392", "08", "", "", "", "37.48333", "141", "Asia/Tokyo"),
("2111749", "Naka", "", "JP", "392", "14", "", "", "", "36.05", "140.16667", "Asia/Tokyo"),
("2111781", "Nagai", "Нагаи", "JP", "392", "44", "", "", "", "38.10361", "140.035", "Asia/Tokyo"),
("2111824", "Motomiya", "", "JP", "392", "08", "", "", "", "37.51391", "140.40063", "Asia/Tokyo"),
("2111827", "Motegi", "", "JP", "392", "38", "", "", "", "36.51667", "140.18333", "Asia/Tokyo"),
("2111831", "Moriya", "Мория", "JP", "392", "14", "", "", "", "35.93333", "140", "Asia/Tokyo"),
("2111834", "Morioka-shi", "Мориока", "JP", "392", "16", "", "", "", "39.70361", "141.1525", "Asia/Tokyo"),
("2111836", "Mooka", "", "JP", "392", "38", "", "", "", "36.43333", "140.01667", "Asia/Tokyo"),
("2111855", "Mobara", "", "JP", "392", "04", "", "", "", "35.41667", "140.3", "Asia/Tokyo"),
("2111859", "Mizusawa", "Мидзусава", "JP", "392", "16", "", "", "", "39.13333", "141.13333", "Asia/Tokyo"),
("2111884", "Miyako", "Мияко", "JP", "392", "16", "", "", "", "39.64692", "141.94057", "Asia/Tokyo"),
("2111901", "Mito-shi", "", "JP", "392", "14", "", "", "", "36.34139", "140.44667", "Asia/Tokyo"),
("2111943", "Miharu", "", "JP", "392", "08", "", "", "", "37.43333", "140.48333", "Asia/Tokyo"),
("2111964", "Matsushima", "Мацусима", "JP", "392", "24", "", "", "", "38.37357", "141.06105", "Asia/Tokyo"),
("2111999", "Mashiko", "", "JP", "392", "38", "", "", "", "36.46667", "140.1", "Asia/Tokyo"),
("2112008", "Marumori", "", "JP", "392", "24", "", "", "", "37.91667", "140.76667", "Asia/Tokyo"),
("2112019", "Makabe", "", "JP", "392", "14", "", "", "", "36.26667", "140.1", "Asia/Tokyo"),
("2112077", "Kuroiso", "", "JP", "392", "38", "", "", "", "36.96667", "140.05", "Asia/Tokyo"),
("2112141", "Koriyama", "Корияма", "JP", "392", "08", "", "", "", "37.4", "140.38333", "Asia/Tokyo"),
("2112182", "Kogota", "", "JP", "392", "24", "", "", "", "38.55", "141.05", "Asia/Tokyo"),
("2112227", "Kitakami", "Китаками", "JP", "392", "16", "", "", "", "39.28333", "141.11667", "Asia/Tokyo"),
("2112232", "Kitaibaraki", "", "JP", "392", "14", "", "", "", "36.78671", "140.74901", "Asia/Tokyo"),
("2112297", "Kawaguchi", "Кавагути", "JP", "392", "04", "", "", "", "35.0969", "140.1003", "Asia/Tokyo"),
("2112309", "Katsuura", "Кацуура", "JP", "392", "04", "", "", "", "35.14297", "140.31388", "Asia/Tokyo"),
("2112312", "Katsuta", "", "JP", "392", "14", "", "", "", "36.38333", "140.53333", "Asia/Tokyo"),
("2112319", "Katori-shi", "", "JP", "392", "04", "", "", "", "35.89767", "140.49943", "Asia/Tokyo"),
("2112343", "Kasama", "Касама", "JP", "392", "14", "", "", "", "36.38333", "140.26667", "Asia/Tokyo"),
("2112354", "Karasuyama", "", "JP", "392", "38", "", "", "", "36.65", "140.15", "Asia/Tokyo"),
("2112409", "Kaminoyama", "", "JP", "392", "44", "", "", "", "38.15389", "140.27361", "Asia/Tokyo"),
("2112444", "Kamaishi", "Камаиси", "JP", "392", "16", "", "", "", "39.27694", "141.86801", "Asia/Tokyo"),
("2112455", "Kakuda", "Какудский", "JP", "392", "24", "", "", "", "37.97451", "140.77202", "Asia/Tokyo"),
("2112521", "Iwase", "Ивасэ", "JP", "392", "14", "", "", "", "36.35", "140.1", "Asia/Tokyo"),
("2112527", "Iwanuma", "", "JP", "392", "24", "", "", "", "38.10472", "140.85944", "Asia/Tokyo"),
("2112539", "Iwaki", "Иваки", "JP", "392", "08", "", "", "", "37.05", "140.88333", "Asia/Tokyo"),
("2112555", "Itako", "", "JP", "392", "14", "", "", "", "35.93333", "140.55", "Asia/Tokyo"),
("2112571", "Ishioka", "Исиока", "JP", "392", "14", "", "", "", "36.18333", "140.26667", "Asia/Tokyo"),
("2112576", "Ishinomaki", "", "JP", "392", "24", "", "", "", "38.41667", "141.3", "Asia/Tokyo"),
("2112583", "Ishikawa", "Исикава", "JP", "392", "08", "", "", "", "37.15", "140.45", "Asia/Tokyo"),
("2112615", "Inawashiro", "", "JP", "392", "08", "", "", "", "37.56667", "140.11667", "Asia/Tokyo"),
("2112656", "Ichinoseki", "", "JP", "392", "16", "", "", "", "38.91667", "141.13333", "Asia/Tokyo"),
("2112664", "Ichihara", "Итихара", "JP", "392", "04", "", "", "", "35.51667", "140.08333", "Asia/Tokyo"),
("2112692", "Hobaramachi", "", "JP", "392", "08", "", "", "", "37.81667", "140.55", "Asia/Tokyo"),
("2112708", "Hitachi", "", "JP", "392", "14", "", "", "", "36.6", "140.65", "Asia/Tokyo"),
("2112758", "Higashine", "", "JP", "392", "44", "", "", "", "38.43889", "140.40056", "Asia/Tokyo"),
("2112802", "Hasaki", "", "JP", "392", "04", "", "", "", "35.73333", "140.83333", "Asia/Tokyo"),
("2112823", "Hanamaki", "", "JP", "392", "16", "", "", "", "39.38333", "141.11667", "Asia/Tokyo"),
("2112899", "Furukawa", "", "JP", "392", "24", "", "", "", "38.57167", "140.95556", "Asia/Tokyo"),
("2112903", "Funehikimachi-funehiki", "", "JP", "392", "08", "", "", "", "37.44722", "140.5771", "Asia/Tokyo"),
("2112913", "Funaishikawa", "", "JP", "392", "14", "", "", "", "36.46667", "140.56667", "Asia/Tokyo"),
("2112923", "Fukushima-shi", "Фукусима", "JP", "392", "08", "", "", "", "37.75", "140.46778", "Asia/Tokyo"),
("2112940", "Fujishiro", "", "JP", "392", "14", "", "", "", "35.91667", "140.11667", "Asia/Tokyo"),
("2112963", "Edosaki", "", "JP", "392", "14", "", "", "", "35.95", "140.31667", "Asia/Tokyo"),
("2112989", "Daigo", "Даиго", "JP", "392", "14", "", "", "", "36.76667", "140.35", "Asia/Tokyo"),
("2113015", "Chiba", "Чиба", "JP", "392", "04", "", "", "", "35.60472", "140.12333", "Asia/Tokyo"),
("2113077", "Asahi", "Асахи", "JP", "392", "04", "", "", "", "35.71667", "140.65", "Asia/Tokyo"),
("2113115", "Ami", "Ами", "JP", "392", "14", "", "", "", "36.03333", "140.2", "Asia/Tokyo"),
("2113126", "Akita", "", "JP", "392", "02", "", "", "", "39.71667", "140.11667", "Asia/Tokyo"),
("2113164", "Abiko", "", "JP", "392", "04", "", "", "", "35.86667", "140.01667", "Asia/Tokyo"),
("2113719", "Akita Shi", "", "JP", "392", "02", "", "", "", "39.71806", "140.10333", "Asia/Tokyo"),
("2127383", "Bihoro", "", "JP", "392", "12", "", "", "", "43.82278", "144.10444", "Asia/Tokyo"),
("2127515", "Wakkanai", "Вакканай", "JP", "392", "12", "", "", "", "45.40944", "141.67389", "Asia/Tokyo"),
("2127733", "Tomakomai", "Томакомай", "JP", "392", "12", "", "", "", "42.63694", "141.60333", "Asia/Tokyo"),
("2127802", "Tobetsu", "", "JP", "392", "12", "", "", "", "43.21694", "141.51694", "Asia/Tokyo"),
("2127878", "Mutsu", "Муцу", "JP", "392", "03", "", "", "", "41.28944", "141.21694", "Asia/Tokyo"),
("2127896", "Takikawa", "", "JP", "392", "12", "", "", "", "43.55278", "141.90639", "Asia/Tokyo"),
("2127910", "Takanosu", "", "JP", "392", "02", "", "", "", "40.22194", "140.36944", "Asia/Tokyo"),
("2127955", "Sunagawa", "", "JP", "392", "12", "", "", "", "43.48639", "141.90556", "Asia/Tokyo"),
("2128025", "Shizunai-furukawacho", "", "JP", "392", "12", "", "", "", "42.33389", "142.36694", "Asia/Tokyo"),
("2128072", "Shiraoi", "", "JP", "392", "12", "", "", "", "42.55", "141.35", "Asia/Tokyo"),
("2128147", "Shimo-furano", "", "JP", "392", "12", "", "", "", "43.35", "142.38333", "Asia/Tokyo"),
("2128206", "Shibetsu", "", "JP", "392", "12", "", "", "", "43.65899", "145.13197", "Asia/Tokyo"),
("2128295", "Sapporo", "Саппоро", "JP", "392", "12", "", "", "", "43.06417", "141.34694", "Asia/Tokyo"),
("2128382", "Rumoi", "", "JP", "392", "12", "", "", "", "43.93444", "141.64278", "Asia/Tokyo"),
("2128558", "Otofuke", "", "JP", "392", "12", "", "", "", "42.99167", "143.20028", "Asia/Tokyo"),
("2128574", "Otaru", "Отару", "JP", "392", "12", "", "", "", "43.18944", "141.00222", "Asia/Tokyo"),
("2128787", "Odate", "Одатэ", "JP", "392", "02", "", "", "", "40.27178", "140.55756", "Asia/Tokyo"),
("2128815", "Obihiro", "Обихиро", "JP", "392", "12", "", "", "", "42.91722", "143.20444", "Asia/Tokyo"),
("2128867", "Noshiro", "Носирский", "JP", "392", "02", "", "", "", "40.20389", "140.02417", "Asia/Tokyo"),
("2128975", "Nemuro", "Нэмуро", "JP", "392", "12", "", "", "", "43.32361", "145.575", "Asia/Tokyo"),
("2128983", "Nayoro", "Наеро", "JP", "392", "12", "", "", "", "44.35056", "142.45778", "Asia/Tokyo"),
("2129003", "Nanae", "", "JP", "392", "12", "", "", "", "41.88333", "140.68333", "Asia/Tokyo"),
("2129005", "Namioka", "Намиока", "JP", "392", "03", "", "", "", "40.71069", "140.59048", "Asia/Tokyo"),
("2129101", "Muroran", "Муроран", "JP", "392", "12", "", "", "", "42.31722", "140.98806", "Asia/Tokyo"),
("2129163", "Mombetsu", "Момбецу", "JP", "392", "12", "", "", "", "44.3525", "143.3525", "Asia/Tokyo"),
("2129211", "Misawa", "Мисава", "JP", "392", "03", "", "", "", "40.68682", "141.38969", "Asia/Tokyo"),
("2129218", "Yoichi", "", "JP", "392", "12", "", "", "", "43.20389", "140.77028", "Asia/Tokyo"),
("2129324", "Makubetsu", "", "JP", "392", "12", "", "", "", "45.37139", "141.82111", "Asia/Tokyo"),
("2129376", "Kushiro", "", "JP", "392", "12", "", "", "", "42.975", "144.37472", "Asia/Tokyo"),
("2129395", "Kuroishi", "", "JP", "392", "03", "", "", "", "40.64581", "140.58354", "Asia/Tokyo"),
("2129513", "Shimokizukuri", "", "JP", "392", "03", "", "", "", "40.81609", "140.37539", "Asia/Tokyo"),
("2129537", "Kitami", "Киты", "JP", "392", "12", "", "", "", "43.80306", "143.89083", "Asia/Tokyo"),
("2129766", "Kamiiso", "", "JP", "392", "12", "", "", "", "41.82013", "140.64482", "Asia/Tokyo"),
("2129868", "Iwanai", "", "JP", "392", "12", "", "", "", "42.97444", "140.50889", "Asia/Tokyo"),
("2129870", "Iwamizawa", "", "JP", "392", "12", "", "", "", "43.20028", "141.75972", "Asia/Tokyo"),
("2129909", "Ishikari", "Исикари", "JP", "392", "12", "", "", "", "43.23972", "141.35389", "Asia/Tokyo"),
("2129961", "Ichinohe", "", "JP", "392", "16", "", "", "", "40.21965", "141.28986", "Asia/Tokyo"),
("2130054", "Kitahiroshima", "Хиросима", "JP", "392", "12", "", "", "", "42.97583", "141.56722", "Asia/Tokyo"),
("2130057", "Hirosaki", "Хиросаки", "JP", "392", "03", "", "", "", "40.59306", "140.4725", "Asia/Tokyo"),
("2130146", "Kazuno", "", "JP", "392", "02", "", "", "", "40.18361", "140.78722", "Asia/Tokyo"),
("2130188", "Hakodate", "Хакодате", "JP", "392", "12", "", "", "", "41.77583", "140.73667", "Asia/Tokyo"),
("2130203", "Hachinohe", "", "JP", "392", "03", "", "", "", "40.5", "141.5", "Asia/Tokyo"),
("2130332", "Fukagawa", "Фукагава", "JP", "392", "12", "", "", "", "43.70806", "142.03917", "Asia/Tokyo"),
("2130404", "Ebetsu", "", "JP", "392", "12", "", "", "", "43.10806", "141.55056", "Asia/Tokyo"),
("2130421", "Date", "", "JP", "392", "12", "", "", "", "42.46806", "140.86806", "Asia/Tokyo"),
("2130452", "Chitose", "", "JP", "392", "12", "", "", "", "42.81944", "141.65222", "Asia/Tokyo"),
("2130534", "Bibai", "", "JP", "392", "12", "", "", "", "43.32472", "141.85861", "Asia/Tokyo"),
("2130612", "Ashibetsu", "", "JP", "392", "12", "", "", "", "43.50972", "142.18556", "Asia/Tokyo"),
("2130629", "Asahikawa", "Асахикава", "JP", "392", "12", "2130628", "", "", "43.77063", "142.36489", "Asia/Tokyo"),
("2130658", "Aomori Shi", "Аомори", "JP", "392", "03", "", "", "", "40.82444", "140.74", "Asia/Tokyo"),
("2130741", "Abashiri", "Абасири", "JP", "392", "12", "", "", "", "44.02127", "144.26971", "Asia/Tokyo"),
("2131612", "Goshogawara", "Госёгавара", "JP", "392", "03", "", "", "", "40.80444", "140.44139", "Asia/Tokyo"),
("6324583", "Aso", "Асо", "JP", "392", "21", "", "", "", "32.93726", "131.08008", "Asia/Tokyo"),
("6694821", "Nanto-shi", "", "JP", "392", "42", "", "", "", "36.56922", "136.91162", "Asia/Tokyo"),
("6696932", "Kawage", "", "JP", "392", "23", "", "", "", "34.80447", "136.54645", "Asia/Tokyo"),
("6697563", "Neyagawa", "", "JP", "392", "32", "", "", "", "34.76615", "135.62759", "Asia/Tokyo"),
("6822096", "Hitachi-Naka", "", "JP", "392", "14", "", "", "", "36.39659", "140.53479", "Asia/Tokyo"),
("6822108", "Inashiki", "", "JP", "392", "14", "", "", "", "35.95633", "140.32356", "Asia/Tokyo"),
("6822146", "Onojo", "", "JP", "392", "07", "", "", "", "33.53567", "130.47861", "Asia/Tokyo"),
("6822217", "Minokamo", "Минокамо", "JP", "392", "09", "", "", "", "35.48199", "137.02166", "Asia/Tokyo"),
("6822219", "Gujo", "Гудзё", "JP", "392", "09", "", "", "", "35.73691", "136.95852", "Asia/Tokyo"),
("6825489", "Joetsu", "", "JP", "392", "29", "", "", "", "37.14828", "138.23642", "Asia/Tokyo"),
("6940394", "Saitama", "Саитама", "JP", "392", "34", "", "", "", "35.90807", "139.65657", "Asia/Tokyo"),
("7279570", "Higashimurayama-shi", "", "JP", "392", "40", "", "", "", "35.75459", "139.46852", "Asia/Tokyo"),
("7281819", "Fujikawaguchiko", "Фудзикавагутико", "JP", "392", "46", "", "", "", "35.48933", "138.68832", "Asia/Tokyo"),
("7422816", "Dazaifu", "Дадзайфу", "JP", "392", "07", "", "", "", "33.51278", "130.52389", "Asia/Tokyo"),
("8125829", "Kamigyo-ku", "", "JP", "392", "22", "1857906", "", "", "35.02954", "135.75666", "Asia/Tokyo"),
("8198709", "Buzen", "", "JP", "392", "07", "1864660", "", "", "33.61153", "131.13002", "Asia/Tokyo"),
("8555918", "Sendai", "", "JP", "392", "24", "", "", "", "38.25759", "140.8667", "Asia/Tokyo"),
("178202", "Webuye", "", "KE", "404", "12", "", "", "", "0.60751", "34.76966", "Africa/Nairobi"),
("178443", "Wajir", "", "KE", "404", "54", "", "", "", "1.7471", "40.05732", "Africa/Nairobi"),
("178522", "Voi", "", "KE", "404", "47", "", "", "", "-3.39605", "38.55609", "Africa/Nairobi"),
("179330", "Thika", "Тик", "KE", "404", "05", "", "", "", "-1.03326", "37.06933", "Africa/Nairobi"),
("181135", "Rongai", "", "KE", "404", "39", "", "", "", "-0.17333", "35.86382", "Africa/Nairobi"),
("181501", "Pumwani", "", "KE", "404", "05", "", "", "", "-1.28333", "36.85", "Africa/Nairobi"),
("182701", "Nyeri", "Ньери", "KE", "404", "44", "", "", "", "-0.42013", "36.94759", "Africa/Nairobi"),
("183027", "Nyahururu", "", "KE", "404", "29", "", "", "", "0.0421", "36.36734", "Africa/Nairobi"),
("184379", "Narok", "", "KE", "404", "41", "", "", "", "-1.07829", "35.86012", "Africa/Nairobi"),
("184433", "Nanyuki", "", "KE", "404", "29", "", "", "", "0.01667", "37.07283", "Africa/Nairobi"),
("184622", "Nakuru", "Накуру", "KE", "404", "39", "", "", "", "-0.28333", "36.06667", "Africa/Nairobi"),
("184707", "Naivasha", "Найваша", "KE", "404", "39", "", "", "", "-0.71667", "36.43591", "Africa/Nairobi"),
("184745", "Nairobi", "Найроби", "KE", "404", "05", "", "", "", "-1.28333", "36.81667", "Africa/Nairobi"),
("185702", "Mumias", "", "KE", "404", "20", "", "", "", "0.33511", "34.4864", "Africa/Nairobi"),
("185939", "Muhoroni", "", "KE", "404", "26", "", "", "", "-0.15406", "35.19878", "Africa/Nairobi"),
("186180", "Moyale", "", "KE", "404", "34", "", "", "", "3.5216", "39.05472", "Africa/Nairobi"),
("186301", "Mombasa", "Момбаса", "KE", "404", "37", "", "", "", "-4.05466", "39.66359", "Africa/Nairobi"),
("186315", "Molo", "Моло", "KE", "404", "39", "", "", "", "-0.2479", "35.73743", "Africa/Nairobi"),
("186731", "Migori", "", "KE", "404", "36", "", "", "", "-1.06344", "34.47313", "Africa/Nairobi"),
("186827", "Meru", "Меры", "KE", "404", "35", "", "", "", "0.04626", "37.65587", "Africa/Nairobi"),
("187110", "Mbale", "", "KE", "404", "53", "", "", "", "-3.4", "38.38333", "Africa/Nairobi"),
("187585", "Marsabit", "", "KE", "404", "34", "", "", "", "2.32839", "37.98986", "Africa/Nairobi"),
("187725", "Maralal", "", "KE", "404", "45", "", "", "", "1.09679", "36.69799", "Africa/Nairobi"),
("187896", "Mandera", "Мандере", "KE", "404", "33", "", "", "", "3.93726", "41.85688", "Africa/Nairobi"),
("187968", "Malindi", "Малинди", "KE", "404", "23", "", "", "", "-3.21799", "40.11692", "Africa/Nairobi"),
("188080", "Makueni", "", "KE", "404", "32", "", "", "", "-1.80409", "37.62034", "Africa/Nairobi"),
("188492", "Machakos", "Мачакосский", "KE", "404", "31", "", "", "", "-1.51667", "37.26667", "Africa/Nairobi"),
("188657", "Lugulu", "", "KE", "404", "13", "", "", "", "0.39361", "34.30528", "Africa/Nairobi"),
("189280", "Lodwar", "Лодвар", "KE", "404", "51", "", "", "", "3.11911", "35.59727", "Africa/Nairobi"),
("189741", "Lamu", "Лама", "KE", "404", "30", "", "", "", "-2.27169", "40.90201", "Africa/Nairobi"),
("191038", "Kitui", "", "KE", "404", "27", "", "", "", "-1.36696", "38.01056", "Africa/Nairobi"),
("191220", "Kitale", "Китале", "KE", "404", "50", "", "", "", "1.01572", "35.00622", "Africa/Nairobi"),
("191245", "Kisumu", "Кисуму", "KE", "404", "26", "", "", "", "-0.10221", "34.76171", "Africa/Nairobi"),
("191299", "Kisii", "", "KE", "404", "25", "", "", "", "-0.68174", "34.76666", "Africa/Nairobi"),
("192067", "Kilifi", "Килифи", "KE", "404", "23", "", "", "", "-3.63045", "39.84992", "Africa/Nairobi"),
("192710", "Kiambu", "Киамбу", "KE", "404", "22", "", "", "", "-1.16667", "36.83333", "Africa/Nairobi"),
("192859", "Keruguya", "", "KE", "404", "24", "", "", "", "-0.49886", "37.28031", "Africa/Nairobi"),
("192900", "Kericho", "", "KE", "404", "21", "", "", "", "-0.36774", "35.28314", "Africa/Nairobi"),
("193627", "Karuri", "", "KE", "404", "38", "", "", "", "-0.7", "37.18333", "Africa/Nairobi"),
("194160", "Kapenguria", "", "KE", "404", "55", "", "", "", "1.23333", "35.11667", "Africa/Nairobi"),
("195272", "Kakamega", "Какамеге", "KE", "404", "20", "", "", "", "0.28422", "34.75228", "Africa/Nairobi"),
("195821", "Kabarnet", "", "KE", "404", "10", "", "", "", "0.49194", "35.74303", "Africa/Nairobi"),
("196231", "Isiolo", "Исиоло", "KE", "404", "18", "", "", "", "0.35462", "37.58218", "Africa/Nairobi"),
("196742", "Homa Bay", "", "KE", "404", "17", "", "", "", "-0.52731", "34.45714", "Africa/Nairobi"),
("197745", "Garissa", "", "KE", "404", "16", "", "", "", "-0.45275", "39.64601", "Africa/Nairobi"),
("198476", "Embu", "Эмба", "KE", "404", "15", "", "", "", "-0.53112", "37.4506", "Africa/Nairobi"),
("198629", "Eldoret", "Элдорет", "KE", "404", "52", "", "", "", "0.52036", "35.26992", "Africa/Nairobi"),
("199989", "Busia", "", "KE", "404", "13", "", "", "", "0.46005", "34.11169", "Africa/Nairobi"),
("200067", "Bungoma", "Бунгома", "KE", "404", "12", "", "", "", "0.5635", "34.56055", "Africa/Nairobi"),
("200787", "Athi River", "", "KE", "404", "31", "", "", "", "-1.4563", "36.97826", "Africa/Nairobi"),
("383388", "Siaya", "", "KE", "404", "46", "", "", "", "0.06116", "34.28823", "Africa/Nairobi"),
("7931933", "Ol Kalou", "", "KE", "404", "43", "", "", "", "-0.27088", "36.37917", "Africa/Nairobi"),
("1222562", "Sulyukta", "Сулюкта", "KG", "417", "09", "", "", "", "39.93652", "69.56779", "Asia/Bishkek"),
("1222662", "Isfana", "Исфана", "KG", "417", "09", "", "", "", "39.83895", "69.5276", "Asia/Bishkek"),
("1527004", "Balykchy", "Балыкчи", "KG", "417", "07", "", "", "", "42.46017", "76.18709", "Asia/Bishkek"),
("1527199", "Tokmok", "Токмак", "KG", "417", "02", "", "", "", "42.84194", "75.30149", "Asia/Bishkek"),
("1527260", "Tash-Kumyr", "Таш-Кумыр", "KG", "417", "03", "", "", "", "41.34612", "72.21708", "Asia/Bishkek"),
("1527299", "Talas", "Талас", "KG", "417", "06", "", "", "", "42.52277", "72.24274", "Asia/Bishkek"),
("1527497", "Pokrovka", "Покровка", "KG", "417", "07", "", "", "", "42.34211", "78.00644", "Asia/Bishkek"),
("1527513", "Uzgen", "Узген", "KG", "417", "08", "", "", "", "40.76994", "73.30068", "Asia/Bishkek"),
("1527534", "Osh", "Ош", "KG", "417", "08", "", "", "", "40.51506", "72.80826", "Asia/Bishkek"),
("1527592", "Naryn", "Нарын", "KG", "417", "04", "", "", "", "41.42866", "75.99111", "Asia/Bishkek"),
("1527719", "Kyzyl-Kyya", "Кызыл-Кия", "KG", "417", "08", "", "", "", "40.25684", "72.12793", "Asia/Bishkek"),
("1528091", "Kara Suu", "Кара-Суу", "KG", "417", "08", "", "", "", "40.7046", "72.86666", "Asia/Bishkek"),
("1528121", "Karakol", "Каракол", "KG", "417", "07", "", "", "", "42.49068", "78.39362", "Asia/Bishkek"),
("1528182", "Kara-Balta", "Кара-Балта", "KG", "417", "02", "", "", "", "42.81423", "73.84813", "Asia/Bishkek"),
("1528193", "Kant", "Кант", "KG", "417", "02", "", "", "", "42.89106", "74.85077", "Asia/Bishkek"),
("1528249", "Jalal-Abad", "Джалал-Абад", "KG", "417", "03", "", "", "", "40.93333", "73", "Asia/Bishkek"),
("1528283", "Iradan", "", "KG", "417", "09", "", "", "", "40.26667", "72.1", "Asia/Bishkek"),
("1528512", "Cholpon-Ata", "Чолпон-Ата", "KG", "417", "07", "", "", "", "42.64944", "77.08225", "Asia/Bishkek"),
("1528675", "Bishkek", "Бишкек", "KG", "417", "02", "", "", "", "42.87", "74.59", "Asia/Bishkek"),
("1528717", "Bazar-Korgon", "Базар-Коргон", "KG", "417", "03", "", "", "", "41.0376", "72.74586", "Asia/Bishkek"),
("1528796", "At-Bashi", "Ат-Баши", "KG", "417", "04", "", "", "", "41.17017", "75.81058", "Asia/Bishkek"),
("1538648", "Toktogul", "Токтогул", "KG", "417", "03", "", "", "", "41.87079", "72.9402", "Asia/Bishkek"),
("1821306", "Phnom Penh", "Пномпень", "KH", "116", "22", "", "", "", "11.56245", "104.91601", "Asia/Phnom_Penh"),
("1821935", "Ta Khmau", "Такхмау", "KH", "116", "07", "", "", "", "11.48333", "104.95", "Asia/Phnom_Penh"),
("1821940", "Takeo", "", "KH", "116", "19", "", "", "", "10.99081", "104.78498", "Asia/Phnom_Penh"),
("1821993", "Svay Rieng", "", "KH", "116", "18", "", "", "", "11.08785", "105.79935", "Asia/Phnom_Penh"),
("1822029", "Stung Treng", "", "KH", "116", "17", "", "", "", "13.52586", "105.9683", "Asia/Phnom_Penh"),
("1822207", "Sisophon", "", "KH", "116", "25", "", "", "", "13.58588", "102.97369", "Asia/Phnom_Penh"),
("1822214", "Siem Reap", "Сием-Реап", "KH", "116", "24", "", "", "", "13.36179", "103.86056", "Asia/Phnom_Penh"),
("1822610", "Prey Veng", "", "KH", "116", "14", "", "", "", "11.48682", "105.32533", "Asia/Phnom_Penh"),
("1822768", "Pursat", "", "KH", "116", "12", "", "", "", "12.53878", "103.9192", "Asia/Phnom_Penh"),
("1822906", "Phumi Veal Sre", "", "KH", "116", "19", "", "", "", "10.98081", "104.77828", "Asia/Phnom_Penh"),
("1825093", "Samraong", "", "KH", "116", "27", "", "", "", "14.18175", "103.51761", "Asia/Phnom_Penh"),
("1830098", "Tbeng Meanchey", "", "KH", "116", "13", "", "", "", "13.80732", "104.98046", "Asia/Phnom_Penh"),
("1830194", "Paoy Pet", "Пойпет", "KH", "116", "25", "", "", "", "13.65611", "102.5625", "Asia/Phnom_Penh"),
("1830205", "Pailin", "", "KH", "116", "30", "", "", "", "12.84895", "102.60928", "Asia/Phnom_Penh"),
("1830377", "Lumphat", "", "KH", "116", "23", "", "", "", "13.48784", "106.98158", "Asia/Phnom_Penh"),
("1830468", "Koh Kong", "", "KH", "116", "08", "", "", "", "11.61531", "102.9838", "Asia/Phnom_Penh"),
("1830564", "Kratie", "", "KH", "116", "09", "", "", "", "12.48811", "106.01879", "Asia/Phnom_Penh"),
("1831112", "Kampot", "Кампот", "KH", "116", "21", "", "", "", "10.61041", "104.18145", "Asia/Phnom_Penh"),
("1831125", "Kampong Thom", "", "KH", "116", "05", "", "", "", "12.71112", "104.88873", "Asia/Phnom_Penh"),
("1831133", "Kampong Speu", "", "KH", "116", "04", "", "", "", "11.45332", "104.52085", "Asia/Phnom_Penh"),
("1831142", "Sihanoukville", "Сиануквиль", "KH", "116", "28", "", "", "", "10.60932", "103.52958", "Asia/Phnom_Penh"),
("1831167", "Kampong Chhnang", "Кампонгчнанг", "KH", "116", "03", "", "", "", "12.25", "104.66667", "Asia/Phnom_Penh"),
("1831173", "Kampong Cham", "Кампонгтям", "KH", "116", "02", "", "", "", "11.99339", "105.4635", "Asia/Phnom_Penh"),
("1831732", "Ban Lung", "", "KH", "116", "23", "", "", "", "13.73939", "106.98727", "Asia/Phnom_Penh"),
("1831797", "Battambang", "Баттамбанг", "KH", "116", "29", "", "", "", "13.10271", "103.19822", "Asia/Phnom_Penh"),
("8740221", "Smach Mean Chey", "", "KH", "116", "08", "", "", "", "11.54665", "103.03569", "Asia/Phnom_Penh"),
("1832015", "Heung-hai", "", "KR", "411", "14", "", "", "", "36.1125", "129.35222", "Asia/Seoul"),
("1832215", "Enjitsu", "", "KR", "411", "14", "", "", "", "35.99417", "129.345", "Asia/Seoul"),
("1832257", "Neietsu", "", "KR", "411", "06", "", "", "", "37.18447", "128.46821", "Asia/Seoul"),
("1832384", "Eisen", "", "KR", "411", "14", "", "", "", "36.82167", "128.63083", "Asia/Seoul"),
("1832501", "Reiko", "", "KR", "411", "16", "", "", "", "35.275", "126.50944", "Asia/Seoul"),
("1832566", "Yong-dong", "", "KR", "411", "05", "", "", "", "36.175", "127.77639", "Asia/Seoul"),
("1832617", "Eisen", "", "KR", "411", "14", "", "", "", "35.9675", "128.93083", "Asia/Seoul"),
("1832743", "Yeoju", "", "KR", "411", "13", "", "", "", "37.29583", "127.63389", "Asia/Seoul"),
("1832771", "Yesan", "Есан", "KR", "411", "17", "", "", "", "36.67756", "126.84272", "Asia/Seoul"),
("1832828", "Yangsan", "Янсан", "KR", "411", "20", "", "", "", "35.33861", "129.03861", "Asia/Seoul"),
("1832830", "Yangp'yong", "", "KR", "411", "13", "", "", "", "37.48972", "127.49056", "Asia/Seoul"),
("1832847", "Yangju", "Янджу", "KR", "411", "13", "", "", "", "37.83311", "127.06169", "Asia/Seoul"),
("1832909", "Yanggu", "", "KR", "411", "06", "", "", "", "38.10583", "127.98944", "Asia/Seoul"),
("1833105", "Wonju", "", "KR", "411", "06", "", "", "", "37.35139", "127.94528", "Asia/Seoul"),
("1833466", "Wanju", "", "KR", "411", "03", "", "", "", "35.84509", "127.14752", "Asia/Seoul"),
("1833514", "Waegwan", "", "KR", "411", "14", "", "", "", "35.99175", "128.39732", "Asia/Seoul"),
("1833747", "Ulsan", "Ульсан", "KR", "411", "21", "", "", "", "35.53722", "129.31667", "Asia/Seoul"),
("1833788", "Uijeongbu-si", "", "KR", "411", "13", "", "", "", "37.7415", "127.0474", "Asia/Seoul"),
("1834885", "Tangjin", "", "KR", "411", "17", "", "", "", "36.89444", "126.62972", "Asia/Seoul"),
("1835096", "Taesal-li", "", "KR", "411", "17", "", "", "", "36.9714", "126.4542", "Asia/Seoul"),
("1835235", "Daejeon", "Тэджон", "KR", "411", "19", "", "", "", "36.32139", "127.41972", "Asia/Seoul"),
("1835329", "Daegu", "Тэгу", "KR", "411", "15", "", "", "", "35.87028", "128.59111", "Asia/Seoul"),
("1835447", "Taisen-ri", "", "KR", "411", "17", "", "", "", "36.34931", "126.59772", "Asia/Seoul"),
("1835515", "T'aebaek", "Тхэбэк", "KR", "411", "06", "", "", "", "37.1759", "128.9889", "Asia/Seoul"),
("1835553", "Suwon-si", "", "KR", "411", "13", "", "", "", "37.29111", "127.00889", "Asia/Seoul"),
("1835648", "Suncheon", "", "KR", "411", "16", "", "", "", "34.94808", "127.48947", "Asia/Seoul"),
("1835848", "Seoul", "Сеул", "KR", "411", "11", "", "", "", "37.566", "126.9784", "Asia/Seoul"),
("1835895", "Suisan", "Сосан", "KR", "411", "17", "", "", "", "36.78167", "126.45222", "Asia/Seoul"),
("1835967", "Jenzan", "", "KR", "411", "14", "", "", "", "36.24083", "128.2975", "Asia/Seoul"),
("1836208", "Songwon", "", "KR", "411", "17", "", "", "", "36.91556", "127.13139", "Asia/Seoul"),
("1836553", "Sogcho", "Сокчхо", "KR", "411", "06", "", "", "", "38.20833", "128.59111", "Asia/Seoul"),
("1837706", "Sangju", "Санджу", "KR", "411", "14", "", "", "", "36.41528", "128.16056", "Asia/Seoul"),
("1838069", "Santyoku", "", "KR", "411", "06", "", "", "", "37.44056", "129.17083", "Asia/Seoul"),
("1838508", "Fuyo", "Пуйо", "KR", "411", "17", "", "", "", "36.28194", "126.9125", "Asia/Seoul"),
("1838524", "Busan", "Пусан", "KR", "411", "10", "", "", "", "35.10278", "129.04028", "Asia/Seoul"),
("1838716", "Bucheon-si", "", "KR", "411", "13", "", "", "", "37.49889", "126.78306", "Asia/Seoul"),
("1838722", "Puan", "", "KR", "411", "03", "", "", "", "35.72806", "126.73194", "Asia/Seoul"),
("1839011", "Beolgyo", "", "KR", "411", "16", "", "", "", "34.84494", "127.34293", "Asia/Seoul"),
("1839071", "Pohang", "", "KR", "411", "14", "1832431", "", "", "36.03222", "129.365", "Asia/Seoul"),
("1839652", "Osan", "", "KR", "411", "13", "", "", "", "37.15222", "127.07056", "Asia/Seoul"),
("1839726", "Asan", "Асан", "KR", "411", "17", "", "", "", "36.78361", "127.00417", "Asia/Seoul"),
("1839873", "Okcheon", "", "KR", "411", "05", "", "", "", "36.3012", "127.568", "Asia/Seoul"),
("1840179", "Kosong", "", "KR", "411", "06", "", "", "", "38.37881", "128.4676", "Asia/Seoul"),
("1840211", "Nonsan", "Нонсан", "KR", "411", "17", "", "", "", "36.20389", "127.08472", "Asia/Seoul"),
("1840379", "Nangen", "Намвон", "KR", "411", "03", "", "", "", "35.41", "127.38583", "Asia/Seoul"),
("1840536", "Naju", "Наджу", "KR", "411", "16", "", "", "", "35.02833", "126.7175", "Asia/Seoul"),
("1840862", "Munsan", "Мунсан", "KR", "411", "13", "", "", "", "37.85944", "126.785", "Asia/Seoul"),
("1840886", "Mungyeong", "Мунгён", "KR", "411", "14", "1840886", "", "", "36.59458", "128.19946", "Asia/Seoul"),
("1840982", "Muan", "", "KR", "411", "16", "", "", "", "34.99014", "126.47899", "Asia/Seoul"),
("1841066", "Moppo", "Могпхо", "KR", "411", "16", "", "", "", "34.79361", "126.38861", "Asia/Seoul"),
("1841149", "Miryang", "Мирян", "KR", "411", "20", "", "", "", "35.49333", "128.74889", "Asia/Seoul"),
("1841598", "Gyeongsan-si", "", "KR", "411", "14", "", "", "", "35.82333", "128.73778", "Asia/Seoul"),
("1841603", "Kyonju", "Кёнджу", "KR", "411", "14", "", "", "", "35.84278", "129.21167", "Asia/Seoul"),
("1841775", "Kwangyang", "", "KR", "411", "16", "", "", "", "34.97528", "127.58917", "Asia/Seoul"),
("1841810", "Kwangju", "", "KR", "411", "13", "", "", "", "37.41", "127.25722", "Asia/Seoul"),
("1841811", "Gwangju", "Кванджу", "KR", "411", "18", "", "", "", "35.15472", "126.91556", "Asia/Seoul"),
("1841976", "Kurye", "", "KR", "411", "16", "", "", "", "35.20944", "127.46444", "Asia/Seoul"),
("1841988", "Guri-si", "", "KR", "411", "13", "", "", "", "37.5986", "127.1394", "Asia/Seoul"),
("1842016", "Kunwi", "", "KR", "411", "14", "", "", "", "36.23472", "128.57278", "Asia/Seoul"),
("1842025", "Kunsan", "Кунсан", "KR", "411", "03", "", "", "", "35.97861", "126.71139", "Asia/Seoul"),
("1842153", "Kinzan", "", "KR", "411", "17", "", "", "", "36.10306", "127.48889", "Asia/Seoul"),
("1842225", "Gumi", "Куми", "KR", "411", "14", "", "", "", "36.1136", "128.336", "Asia/Seoul"),
("1842485", "Goyang-si", "", "KR", "411", "13", "", "", "", "37.65639", "126.835", "Asia/Seoul"),
("1842518", "Goseong", "Косон", "KR", "411", "20", "", "", "", "34.97631", "128.32361", "Asia/Seoul"),
("1842616", "Gongju", "Конджу", "KR", "411", "17", "", "", "", "36.45556", "127.12472", "Asia/Seoul"),
("1842754", "Kyosai", "", "KR", "411", "20", "", "", "", "34.85028", "128.58861", "Asia/Seoul"),
("1842800", "Koesan", "", "KR", "411", "05", "", "", "", "36.81083", "127.79472", "Asia/Seoul"),
("1842859", "Koch'ang", "", "KR", "411", "03", "", "", "", "35.43333", "126.7", "Asia/Seoul"),
("1842939", "Kimje", "", "KR", "411", "03", "", "", "", "35.80167", "126.88889", "Asia/Seoul"),
("1842943", "Kimhae", "", "KR", "411", "20", "", "", "", "35.23417", "128.88111", "Asia/Seoul"),
("1842944", "Gimcheon", "", "KR", "411", "14", "", "", "", "36.12176", "128.11981", "Asia/Seoul"),
("1842966", "Kijang", "", "KR", "411", "10", "", "", "", "35.24417", "129.21389", "Asia/Seoul"),
("1843082", "Gapyeong", "Капхён", "KR", "411", "13", "1843082", "", "", "37.83101", "127.51059", "Asia/Seoul"),
("1843137", "Kang-neung", "Каннын", "KR", "411", "06", "", "", "", "37.75556", "128.89611", "Asia/Seoul"),
("1843163", "Ganghwa-gun", "", "KR", "411", "12", "", "", "", "37.74722", "126.48556", "Asia/Seoul"),
("1843491", "Iksan", "Иксан", "KR", "411", "03", "", "", "", "35.94389", "126.95444", "Asia/Seoul"),
("1843564", "Incheon", "Инчхон", "KR", "411", "12", "", "", "", "37.45646", "126.70515", "Asia/Seoul"),
("1843585", "Imsil", "", "KR", "411", "03", "", "", "", "35.61306", "127.27944", "Asia/Seoul"),
("1843702", "Icheon-si", "", "KR", "411", "13", "", "", "", "37.27917", "127.4425", "Asia/Seoul"),
("1843841", "Hwasun", "Хвасун", "KR", "411", "16", "", "", "", "35.05944", "126.985", "Asia/Seoul"),
("1843847", "Hwaseong-si", "", "KR", "411", "13", "1843847", "", "", "37.20682", "126.8169", "Asia/Seoul"),
("1844045", "Hwacheon", "", "KR", "411", "06", "", "", "", "38.10611", "127.70667", "Asia/Seoul"),
("1844174", "Hongsung", "", "KR", "411", "17", "", "", "", "36.6009", "126.665", "Asia/Seoul"),
("1844191", "Hongch'on", "", "KR", "411", "06", "", "", "", "37.6918", "127.8857", "Asia/Seoul"),
("1844308", "Hayang", "", "KR", "411", "14", "", "", "", "35.91333", "128.82", "Asia/Seoul"),
("1844751", "Haenam", "", "KR", "411", "16", "", "", "", "34.57111", "126.59889", "Asia/Seoul"),
("1845136", "Chuncheon", "Чхунчхон", "KR", "411", "06", "", "", "", "37.87472", "127.73417", "Asia/Seoul"),
("1845457", "Jeonju", "Чонджу", "KR", "411", "03", "", "", "", "35.82194", "127.14889", "Asia/Seoul"),
("1845519", "Cheongsong gun", "", "KR", "411", "14", "1845519", "", "", "36.43351", "129.057", "Asia/Seoul"),
("1845604", "Cheongju-si", "", "KR", "411", "05", "", "", "", "36.63722", "127.48972", "Asia/Seoul"),
("1845759", "Cheonan", "Чхонан", "KR", "411", "17", "", "", "", "36.8065", "127.1522", "Asia/Seoul"),
("1846052", "Chinju", "Чинджу", "KR", "411", "20", "", "", "", "35.19278", "128.08472", "Asia/Seoul"),
("1846095", "Chinch'on", "", "KR", "411", "05", "", "", "", "36.85667", "127.44333", "Asia/Seoul"),
("1846114", "Jinan-gun", "", "KR", "411", "03", "", "", "", "35.79167", "127.42528", "Asia/Seoul"),
("1846266", "Jeju-si", "Чеджу", "KR", "411", "01", "", "", "", "33.50972", "126.52194", "Asia/Seoul"),
("1846326", "Changwon", "Чханвон", "KR", "411", "20", "", "", "", "35.22806", "128.68111", "Asia/Seoul"),
("1846355", "Changsu", "", "KR", "411", "03", "", "", "", "35.64842", "127.51523", "Asia/Seoul"),
("1846898", "Anyang-si", "", "KR", "411", "13", "", "", "", "37.3925", "126.92694", "Asia/Seoul"),
("1846912", "Anseong", "Ансон", "KR", "411", "13", "Ansŏng-si", "", "", "37.01083", "127.27028", "Asia/Seoul"),
("1846918", "Ansan-si", "", "KR", "411", "13", "", "", "", "37.32361", "126.82194", "Asia/Seoul"),
("1846986", "Andong", "Андон", "KR", "411", "14", "", "", "", "36.56556", "128.725", "Asia/Seoul"),
("1847050", "Gaigeturi", "", "KR", "411", "01", "", "", "", "33.46444", "126.31833", "Asia/Seoul"),
("1882056", "Sinhyeon", "", "KR", "411", "20", "", "", "", "34.8825", "128.62667", "Asia/Seoul"),
("1884138", "Yeosu", "Йосу", "KR", "411", "16", "1832149", "", "", "34.76278", "127.66528", "Asia/Seoul"),
("1886598", "Yonmu", "", "KR", "411", "17", "", "", "", "36.12944", "127.1", "Asia/Seoul"),
("1892823", "Tonghae", "", "KR", "411", "06", "", "", "", "37.54389", "129.10694", "Asia/Seoul"),
("1896953", "Pubal", "", "KR", "411", "13", "", "", "", "37.29167", "127.50778", "Asia/Seoul"),
("1897000", "Seongnam-si", "", "KR", "411", "13", "", "", "", "37.43861", "127.13778", "Asia/Seoul"),
("1897007", "Hanam", "", "KR", "411", "13", "", "", "", "37.54", "127.20556", "Asia/Seoul"),
("1897118", "Hwado", "", "KR", "411", "13", "", "", "", "37.6525", "127.3075", "Asia/Seoul"),
("1897122", "Namyangju", "Намянджу", "KR", "411", "13", "", "", "", "37.63667", "127.21417", "Asia/Seoul"),
("1912205", "Ungsang", "", "KR", "411", "20", "", "", "", "35.40611", "129.16861", "Asia/Seoul"),
("1912209", "Wabu", "", "KR", "411", "13", "", "", "", "37.58972", "127.22028", "Asia/Seoul"),
("1925936", "Naeso", "", "KR", "411", "20", "", "", "", "35.24972", "128.52", "Asia/Seoul"),
("1925943", "Hwawon", "", "KR", "411", "15", "", "", "", "35.80167", "128.50083", "Asia/Seoul"),
("1948005", "Kwangmyong", "", "KR", "411", "13", "", "", "", "37.47722", "126.86639", "Asia/Seoul"),
("6395804", "Sinan", "", "KR", "411", "16", "", "", "", "34.8262", "126.10863", "Asia/Seoul"),
("6621166", "Seogwipo", "Сеогвипо", "KR", "411", "01", "", "", "", "33.25333", "126.56181", "Asia/Seoul"),
("6903078", "Changnyeong", "", "KR", "411", "20", "", "6903078", "", "35.54145", "128.49506", "Asia/Seoul"),
("608362", "Shalkar", "Шалкар", "KZ", "398", "06", "", "", "", "48.03333", "48.9", "Asia/Oral"),
("608668", "Oral", "Уральск", "KZ", "398", "07", "", "", "", "51.23333", "51.36667", "Asia/Oral"),
("608679", "Oktyabr'sk", "Октябрьск", "KZ", "398", "04", "", "", "", "49.46912", "57.41914", "Asia/Aqtobe"),
("609123", "Qulsary", "Кульсары", "KZ", "398", "06", "", "", "", "46.95307", "54.01978", "Asia/Oral"),
("609404", "Khromtau", "Хромтау", "KZ", "398", "04", "", "", "", "50.25117", "58.44003", "Asia/Aqtobe"),
("609655", "Karagandy", "Караганда", "KZ", "398", "12", "1537266", "", "", "49.83333", "73.1658", "Asia/Almaty"),
("609924", "Embi", "Эмба", "KZ", "398", "04", "", "", "", "48.82981", "58.15042", "Asia/Aqtobe"),
("610445", "Balyqshy", "Балыкши", "KZ", "398", "06", "", "", "", "47.06667", "51.86667", "Asia/Oral"),
("610529", "Atyrau", "Атырау", "KZ", "398", "06", "", "", "", "47.11667", "51.88333", "Asia/Oral"),
("610611", "Aqtobe", "Актобе", "KZ", "398", "04", "", "", "", "50.27969", "57.20718", "Asia/Aqtobe"),
("610612", "Aktau", "Актау", "KZ", "398", "09", "", "", "", "43.64806", "51.17222", "Asia/Aqtau"),
("610613", "Aqsay", "Аксай", "KZ", "398", "07", "", "", "", "51.1681", "52.99782", "Asia/Oral"),
("1516438", "Zyryanovsk", "Зыряновск", "KZ", "398", "15", "", "", "", "49.72654", "84.27318", "Asia/Almaty"),
("1516519", "Zhosaly", "Джусалы", "KZ", "398", "14", "", "", "", "45.48778", "64.07806", "Asia/Qyzylorda"),
("1516589", "Zhezqazghan", "Джезказган", "KZ", "398", "12", "", "", "", "47.78333", "67.76667", "Asia/Almaty"),
("1516601", "Dzhetygara", "Джетыгара", "KZ", "398", "13", "", "", "", "52.19019", "61.19894", "Asia/Qyzylorda"),
("1516788", "Zhangatas", "", "KZ", "398", "17", "", "", "", "43.56667", "69.75", "Asia/Almaty"),
("1516789", "Ayteke Bi", "", "KZ", "398", "14", "", "", "", "45.84608", "62.15264", "Asia/Qyzylorda"),
("1516905", "Taraz", "Тараз", "KZ", "398", "17", "", "", "", "42.9", "71.36667", "Asia/Almaty"),
("1517060", "Zaysan", "", "KZ", "398", "15", "", "", "", "47.46657", "84.87144", "Asia/Almaty"),
("1517323", "Zhangaqorghan", "", "KZ", "398", "14", "", "", "", "43.915", "67.24806", "Asia/Qyzylorda"),
("1517501", "Turar Ryskulov", "", "KZ", "398", "10", "", "", "", "42.53333", "70.33333", "Asia/Almaty"),
("1517637", "Ush-Tyube", "Уштобе", "KZ", "398", "01", "", "", "", "45.25201", "77.98007", "Asia/Almaty"),
("1517945", "Turkestan", "Туркестан", "KZ", "398", "10", "", "", "", "43.33333", "68.25", "Asia/Almaty"),
("1518262", "Temirtau", "Темиртау", "KZ", "398", "12", "", "", "", "50.05494", "72.96464", "Asia/Almaty"),
("1518296", "Tekeli", "Текели", "KZ", "398", "01", "", "", "", "44.83322", "78.8309", "Asia/Almaty"),
("1518431", "Tasboget", "", "KZ", "398", "14", "", "", "", "44.77384", "65.55227", "Asia/Qyzylorda"),
("1518518", "Talghar", "", "KZ", "398", "01", "", "", "", "43.30348", "77.24085", "Asia/Almaty"),
("1518542", "Taldykorgan", "Талдыкорган", "KZ", "398", "01", "", "", "", "45.01556", "78.37389", "Asia/Almaty"),
("1518543", "Taldyqorghan", "Талды - Курган", "KZ", "398", "01", "", "", "", "45", "77.91667", "Asia/Almaty"),
("1518980", "Shymkent", "Шымкент", "KZ", "398", "10", "", "", "", "42.3", "69.6", "Asia/Almaty"),
("1519030", "Shu", "Шу", "KZ", "398", "17", "", "", "", "43.59833", "73.76139", "Asia/Almaty"),
("1519226", "Shemonaikha", "Шемонаиха", "KZ", "398", "15", "", "", "", "50.62811", "81.91213", "Asia/Almaty"),
("1519244", "Shchuchinsk", "Щучинск", "KZ", "398", "16", "", "", "", "52.93818", "70.1895", "Asia/Almaty"),
("1519422", "Semey", "Семей", "KZ", "398", "15", "", "", "", "50.42675", "80.26669", "Asia/Almaty"),
("1519673", "Saryaghash", "Сарыагаш", "KZ", "398", "10", "", "", "", "41.45", "69.16667", "Asia/Almaty"),
("1519691", "Sarkand", "Сарканд", "KZ", "398", "01", "", "", "", "45.41126", "79.91545", "Asia/Almaty"),
("1519725", "Sorang", "Сарань", "KZ", "398", "12", "", "", "", "49.7908", "72.83744", "Asia/Almaty"),
("1519843", "Rudnyy", "Рудный", "KZ", "398", "13", "", "", "", "52.9729", "63.11677", "Asia/Qyzylorda"),
("1519922", "Kyzylorda", "Кызылорда", "KZ", "398", "14", "", "", "", "44.85278", "65.50917", "Asia/Qyzylorda"),
("1519928", "Kostanay", "Костанай", "KZ", "398", "13", "", "", "", "53.21435", "63.62463", "Asia/Qyzylorda"),
("1519938", "Karatau", "", "KZ", "398", "17", "", "", "", "43.16667", "70.46667", "Asia/Almaty"),
("1519948", "Kapshagay", "Капшагай", "KZ", "398", "01", "", "", "", "43.86681", "77.06304", "Asia/Almaty"),
("1520172", "Petropavlovsk", "Петропавловск", "KZ", "398", "16", "", "", "", "54.87278", "69.143", "Asia/Almaty"),
("1520240", "Pavlodar", "Павлодар", "KZ", "398", "11", "", "", "", "52.27401", "77.00438", "Asia/Almaty"),
("1520253", "Zharkent", "Жаркент", "KZ", "398", "01", "", "", "", "44.1666", "80.00655", "Asia/Almaty"),
("1520316", "Ust-Kamenogorsk", "Усть-Каменогорск", "KZ", "398", "15", "", "", "", "49.97143", "82.60586", "Asia/Almaty"),
("1520947", "Sarykemer", "", "KZ", "398", "17", "", "", "", "43", "71.5", "Asia/Almaty"),
("1520969", "Merke", "Мерке", "KZ", "398", "17", "", "", "", "42.86772", "73.17623", "Asia/Almaty"),
("1521230", "Makinsk", "Макинск", "KZ", "398", "03", "", "", "", "52.63373", "70.4177", "Asia/Almaty"),
("1521315", "Lisakovsk", "Лисаковка", "KZ", "398", "13", "", "", "", "52.54707", "62.49987", "Asia/Qyzylorda"),
("1521368", "Baykonyr", "Байконур", "KZ", "398", "08", "", "", "", "45.61667", "63.31667", "Asia/Almaty"),
("1521370", "Ridder", "Лениногорск", "KZ", "398", "15", "", "", "", "50.34413", "83.51287", "Asia/Almaty"),
("1521379", "Lenger", "Ленгер", "KZ", "398", "10", "", "", "", "42.18301", "69.88393", "Asia/Almaty"),
("1522203", "Kokshetau", "Кокшетау", "KZ", "398", "03", "", "", "", "53.28244", "69.39692", "Asia/Almaty"),
("1522751", "Kentau", "Кентау", "KZ", "398", "10", "", "", "", "43.52061", "68.5094", "Asia/Almaty"),
("1523741", "Esik", "Есик", "KZ", "398", "01", "", "", "", "43.3552", "77.45245", "Asia/Almaty"),
("1524245", "Georgievka", "Георгиевка", "KZ", "398", "15", "", "", "", "49.32671", "81.57373", "Asia/Almaty"),
("1524298", "Aksu", "Аксу", "KZ", "398", "11", "", "", "", "52.07287", "76.9039", "Asia/Almaty"),
("1524308", "Energeticheskiy", "", "KZ", "398", "01", "", "", "", "43.42684", "77.01908", "Asia/Almaty"),
("1524325", "Ekibastuz", "Экибастуз", "KZ", "398", "11", "", "", "", "51.72371", "75.32287", "Asia/Almaty"),
("1524801", "Shieli", "Шиели", "KZ", "398", "14", "", "", "", "44.16882", "66.73887", "Asia/Qyzylorda"),
("1524889", "Shardara", "Шардара", "KZ", "398", "10", "", "", "", "41.26182", "67.98437", "Asia/Almaty"),
("1524958", "Burunday", "Бурундай", "KZ", "398", "01", "", "", "", "43.36028", "76.85778", "Asia/Almaty"),
("1525462", "Aksu", "Аксу", "KZ", "398", "10", "", "", "", "42.4219", "69.82795", "Asia/Almaty"),
("1525798", "Balqash", "Балхаш", "KZ", "398", "12", "", "", "", "46.84806", "74.995", "Asia/Almaty"),
("1525988", "Ayagoz", "", "KZ", "398", "15", "", "", "", "47.96447", "80.43437", "Asia/Almaty"),
("1526038", "Atbasar", "Атбасар", "KZ", "398", "03", "", "", "", "51.80652", "68.35996", "Asia/Almaty"),
("1526168", "Arys", "Арысь", "KZ", "398", "10", "", "", "", "42.42965", "68.80463", "Asia/Almaty"),
("1526193", "Arkalyk", "Аркалык", "KZ", "398", "13", "", "", "", "50.24915", "66.92027", "Asia/Almaty"),
("1526265", "Aral", "Аральск", "KZ", "398", "14", "", "", "", "46.8", "61.66667", "Asia/Qyzylorda"),
("1526273", "Astana", "Астана", "KZ", "398", "05", "", "", "", "51.1801", "71.44598", "Asia/Almaty"),
("1526384", "Almaty", "Алма-Ата", "KZ", "398", "02", "", "", "", "43.25654", "76.92848", "Asia/Almaty"),
("1526797", "Akkol'", "Акколь", "KZ", "398", "03", "", "", "", "53.29617", "69.59997", "Asia/Almaty"),
("1526970", "Abay", "Абай", "KZ", "398", "12", "", "", "", "49.63574", "72.86164", "Asia/Almaty"),
("1537939", "Stepnogorsk", "Степногорск", "KZ", "398", "03", "", "", "", "52.35533", "71.88641", "Asia/Almaty"),
("266045", "Zahle", "Захле", "LB", "422", "08", "", "", "", "33.84675", "35.90203", "Asia/Beirut"),
("266826", "Tripoli", "Триполи", "LB", "422", "09", "", "", "", "34.43667", "35.84972", "Asia/Beirut"),
("267008", "Tyre", "Тир", "LB", "422", "06", "", "", "", "33.27333", "35.19389", "Asia/Beirut"),
("268064", "Sidon", "Сайда", "LB", "422", "06", "", "", "", "33.55993", "35.37564", "Asia/Beirut"),
("268743", "Ra's Bayrut", "", "LB", "422", "04", "", "", "", "33.9", "35.48333", "Asia/Beirut"),
("273140", "Djounie", "", "LB", "422", "05", "", "", "", "33.98083", "35.61778", "Asia/Beirut"),
("273203", "Jbail", "Библ (Bibl)", "LB", "422", "05", "", "", "", "34.12111", "35.64806", "Asia/Beirut"),
("274874", "Habbouch", "Хаббуше", "LB", "422", "07", "", "", "", "33.40729", "35.48169", "Asia/Beirut"),
("276359", "Bcharre", "Бишари", "LB", "422", "09", "", "", "", "34.25083", "36.01056", "Asia/Beirut"),
("276781", "Beirut", "Бейрут", "LB", "422", "04", "", "", "", "33.88894", "35.49442", "Asia/Beirut"),
("277130", "Baalbek", "Баальбек", "LB", "422", "11", "", "", "", "34.00583", "36.21806", "Asia/Beirut"),
("278913", "Nabatiye et Tahta", "", "LB", "422", "07", "", "", "", "33.37889", "35.48389", "Asia/Beirut"),
("3042030", "Vaduz", "Вадуц", "LI", "438", "11", "", "", "", "47.14151", "9.52154", "Europe/Vaduz"),
("1223648", "Welisara", "", "LK", "144", "36", "", "", "", "7.0281", "79.9014", "Asia/Colombo"),
("1223738", "Weligama", "", "LK", "144", "34", "", "", "", "5.97501", "80.42968", "Asia/Colombo"),
("1224085", "Wattala", "", "LK", "144", "36", "", "", "", "6.9779", "79.8898", "Asia/Colombo"),
("1225018", "Vavuniya", "Вавуния", "LK", "144", "38", "", "", "", "8.7514", "80.4971", "Asia/Colombo"),
("1225142", "Valvedditturai", "", "LK", "144", "38", "", "", "", "9.81667", "80.16667", "Asia/Colombo"),
("1226260", "Trincomalee", "Тринкомали", "LK", "144", "37", "", "", "", "8.5711", "81.2335", "Asia/Colombo"),
("1228730", "Ratnapura", "Ратнапуры", "LK", "144", "33", "", "", "", "6.68278", "80.39917", "Asia/Colombo"),
("1229293", "Puttalam", "", "LK", "144", "32", "", "", "", "8.0362", "79.8283", "Asia/Colombo"),
("1229989", "Point Pedro", "Пойнт-Педро", "LK", "144", "38", "", "", "", "9.81667", "80.23333", "Asia/Colombo"),
("1230089", "Pita Kotte", "", "LK", "144", "36", "", "", "", "6.8905", "79.9015", "Asia/Colombo"),
("1230613", "Peliyagoda", "", "LK", "144", "36", "", "", "", "6.9685", "79.8836", "Asia/Colombo"),
("1231410", "Panadura", "", "LK", "144", "36", "", "", "", "6.7132", "79.9026", "Asia/Colombo"),
("1232783", "Nuwara Eliya", "Нувара-Элия", "LK", "144", "29", "1232781", "", "", "6.97078", "80.78286", "Asia/Colombo"),
("1233369", "Negombo", "Негомбо", "LK", "144", "36", "", "", "", "7.2083", "79.8358", "Asia/Colombo"),
("1234378", "Mulleriyawa", "", "LK", "144", "36", "", "", "", "6.933", "79.9297", "Asia/Colombo"),
("1234633", "Moratuwa", "", "LK", "144", "36", "", "", "", "6.773", "79.8816", "Asia/Colombo"),
("1235846", "Matara", "Матара", "LK", "144", "34", "", "", "", "5.94851", "80.53528", "Asia/Colombo"),
("1236854", "Maharagama", "", "LK", "144", "36", "", "", "", "6.848", "79.9265", "Asia/Colombo"),
("1237980", "Kurunegala", "Курунегала", "LK", "144", "32", "", "", "", "7.4863", "80.3623", "Asia/Colombo"),
("1238992", "Sri Jayewardenepura Kotte", "Шри-Джаяварденепура-Котте", "LK", "144", "36", "", "", "", "6.88297", "79.90708", "Asia/Colombo"),
("1239047", "Kotikawatta", "", "LK", "144", "36", "", "", "", "6.9269", "79.9095", "Asia/Colombo"),
("1239593", "Kolonnawa", "", "LK", "144", "36", "", "", "", "6.9329", "79.8848", "Asia/Colombo"),
("1240622", "Kelaniya", "", "LK", "144", "36", "", "", "", "6.9553", "79.922", "Asia/Colombo"),
("1240935", "Katunayaka North", "", "LK", "144", "36", "", "", "", "7.1643", "79.8757", "Asia/Colombo"),
("1241622", "Kandy", "Канди", "LK", "144", "29", "", "", "", "7.2955", "80.6356", "Asia/Colombo"),
("1241750", "Kandana", "", "LK", "144", "36", "", "", "", "7.048", "79.8937", "Asia/Colombo"),
("1241964", "Kalutara", "Калутара", "LK", "144", "36", "", "", "", "6.5831", "79.9593", "Asia/Colombo"),
("1242110", "Kalmunai", "", "LK", "144", "37", "", "", "", "7.40902", "81.83472", "Asia/Colombo"),
("1242833", "Jaffna", "Джафна", "LK", "144", "38", "", "", "", "9.66845", "80.00742", "Asia/Colombo"),
("1242835", "Ja Ela", "", "LK", "144", "36", "", "", "", "7.0744", "79.8919", "Asia/Colombo"),
("1243936", "Homagama", "", "LK", "144", "36", "", "", "", "6.844", "80.0024", "Asia/Colombo"),
("1244397", "Hendala", "", "LK", "144", "36", "", "", "", "6.9909", "79.883", "Asia/Colombo"),
("1244596", "Hatton", "", "LK", "144", "29", "", "", "", "6.8916", "80.5955", "Asia/Colombo"),
("1244773", "Hanwella Ihala", "", "LK", "144", "36", "", "", "", "6.9012", "80.0852", "Asia/Colombo"),
("1246000", "Gampola", "", "LK", "144", "29", "", "", "", "7.1643", "80.5696", "Asia/Colombo"),
("1246294", "Galle", "Галле", "LK", "144", "34", "", "", "", "6.0367", "80.217", "Asia/Colombo"),
("1246321", "Galkissa", "", "LK", "144", "36", "", "", "", "6.8293", "79.863", "Asia/Colombo"),
("1246924", "Eravur Town", "Эравуре", "LK", "144", "37", "", "", "", "7.7782", "81.6038", "Asia/Colombo"),
("1248749", "Dambulla", "Дамбулла", "LK", "144", "29", "", "", "", "7.86", "80.65167", "Asia/Colombo"),
("1248991", "Colombo", "Коломбо", "LK", "144", "36", "", "", "", "6.93194", "79.84778", "Asia/Colombo"),
("1249145", "Chilaw", "", "LK", "144", "32", "", "", "", "7.57583", "79.79528", "Asia/Colombo"),
("1249931", "Beruwala", "", "LK", "144", "36", "", "", "", "6.4788", "79.9828", "Asia/Colombo"),
("1249978", "Bentota", "Бентота", "LK", "144", "34", "", "", "", "6.42598", "79.99575", "Asia/Colombo"),
("1250161", "Batticaloa", "Баттикалоа", "LK", "144", "37", "", "", "", "7.7102", "81.6924", "Asia/Colombo"),
("1250164", "Battaramulla South", "", "LK", "144", "36", "", "", "", "6.8964", "79.9181", "Asia/Colombo"),
("1250615", "Badulla", "Бадуллы", "LK", "144", "35", "", "", "", "6.9895", "81.0557", "Asia/Colombo"),
("1251081", "Anuradhapura", "Анурадхапура", "LK", "144", "30", "", "", "", "8.31223", "80.41306", "Asia/Colombo"),
("1251459", "Ampara", "", "LK", "144", "37", "", "", "", "7.29754", "81.68202", "Asia/Colombo"),
("1251574", "Ambalangoda", "", "LK", "144", "34", "", "", "", "6.2355", "80.0538", "Asia/Colombo"),
("8260318", "Shanjeev Home", "", "LK", "144", "37", "", "", "", "7.38216", "81.84198", "Asia/Colombo"),
("932183", "Quthing", "Цгутинг", "LS", "426", "18", "", "", "", "-30.40001", "27.70027", "Africa/Maseru"),
("932218", "Qacha's Nek", "", "LS", "426", "17", "", "", "", "-30.11537", "28.68936", "Africa/Maseru"),
("932438", "Mohale's Hoek", "", "LS", "426", "15", "", "", "", "-30.15137", "27.47691", "Africa/Maseru"),
("932505", "Maseru", "Масеру", "LS", "426", "14", "", "", "", "-29.31667", "27.48333", "Africa/Maseru"),
("932521", "Maputsoe", "", "LS", "426", "12", "", "", "", "-28.8866", "27.89914", "Africa/Maseru"),
("932614", "Mafeteng", "", "LS", "426", "13", "", "", "", "-29.823", "27.23744", "Africa/Maseru"),
("932698", "Leribe", "Лерибе", "LS", "426", "12", "", "", "", "-28.87185", "28.04501", "Africa/Maseru"),
("932886", "Butha-Buthe", "Бута-Бутэ", "LS", "426", "11", "", "", "", "-28.76659", "28.24936", "Africa/Maseru"),
("593063", "Visaginas", "Висагинас", "LT", "440", "64", "", "", "", "55.6", "26.41667", "Europe/Vilnius"),
("593116", "Vilnius", "Вильнюс", "LT", "440", "65", "593118", "", "", "54.68916", "25.2798", "Europe/Vilnius"),
("593672", "Utena", "Утена", "LT", "440", "64", "864514", "", "", "55.5", "25.6", "Europe/Vilnius"),
("593733", "Ukmerge", "Укмерге", "LT", "440", "65", "", "", "", "55.25", "24.75", "Europe/Vilnius"),
("593926", "Telsiai", "Тельшяй", "LT", "440", "63", "864511", "", "", "55.98139", "22.24722", "Europe/Vilnius"),
("593959", "Taurage", "Таураге", "LT", "440", "62", "", "", "", "55.25222", "22.28972", "Europe/Vilnius"),
("594656", "Silute", "Шилуте", "LT", "440", "58", "", "", "", "55.34889", "21.48306", "Europe/Vilnius"),
("594739", "Siauliai", "Шяуляй", "LT", "440", "61", "594743", "", "", "55.93333", "23.31667", "Europe/Vilnius"),
("595213", "Rokiskis", "Рокишкис", "LT", "440", "60", "", "", "", "55.96667", "25.58333", "Europe/Vilnius"),
("595449", "Radviliskis", "Радвилишкис", "LT", "440", "61", "", "", "", "55.81667", "23.53333", "Europe/Vilnius"),
("595689", "Plunge", "Плунге", "LT", "440", "63", "", "", "", "55.91139", "21.84417", "Europe/Vilnius"),
("596128", "Panevezys", "Паневежис", "LT", "440", "60", "596132", "", "", "55.73333", "24.35", "Europe/Vilnius"),
("596238", "Palanga", "Паланга", "LT", "440", "58", "598099", "", "", "55.9175", "21.06861", "Europe/Vilnius"),
("597188", "Mazeikiai", "Мажейкяй", "LT", "440", "63", "", "", "", "56.31667", "22.33333", "Europe/Vilnius"),
("597231", "Marijampole", "Мариямполе", "LT", "440", "59", "597233", "", "", "54.56667", "23.35", "Europe/Vilnius"),
("597989", "Kretinga", "Кретинга", "LT", "440", "58", "", "", "", "55.87583", "21.25083", "Europe/Vilnius"),
("598098", "Klaipeda", "Клайпеда", "LT", "440", "58", "598099", "", "", "55.71722", "21.1175", "Europe/Vilnius"),
("598272", "Kedainiai", "Кедайняй", "LT", "440", "57", "", "", "", "55.28833", "23.97472", "Europe/Vilnius"),
("598316", "Kaunas", "Каунас", "LT", "440", "57", "598318", "", "", "54.9", "23.9", "Europe/Vilnius"),
("598818", "Jonava", "Ионава", "LT", "440", "57", "598814", "", "", "55.08333", "24.28333", "Europe/Vilnius"),
("599506", "Gargzdai", "Гаргждай", "LT", "440", "58", "", "", "", "55.71278", "21.40333", "Europe/Vilnius"),
("599757", "Druskininkai", "Друскининкай", "LT", "440", "56", "", "", "", "54.01667", "23.96667", "Europe/Vilnius"),
("601084", "Alytus", "Алитус", "LT", "440", "56", "601086", "", "", "54.4", "24.05", "Europe/Vilnius"),
("6618486", "Dainava (Kaunas)", "", "LT", "440", "57", "", "", "", "54.91525", "23.96831", "Europe/Vilnius"),
("2960316", "Luxembourg", "Люксембург", "LU", "442", "03", "04", "", "", "49.61167", "6.13", "Europe/Luxembourg"),
("2960596", "Esch-sur-Alzette", "Эш-сюр-Алзетте", "LU", "442", "03", "03", "04", "", "49.49583", "5.98056", "Europe/Luxembourg"),
("2960634", "Dudelange", "Дюделанж", "LU", "442", "03", "03", "03", "", "49.48056", "6.0875", "Europe/Luxembourg"),
("453754", "Valmiera", "Валмиера", "LV", "428", "31", "", "", "", "57.54108", "25.42751", "Europe/Riga"),
("454310", "Ventspils", "Вентспилс", "LV", "428", "33", "", "", "", "57.38944", "21.56056", "Europe/Riga"),
("454432", "Vec-Liepaja", "", "LV", "428", "16", "", "", "", "56.53333", "21.01667", "Europe/Riga"),
("454768", "Tukums", "Тукумс", "LV", "428", "29", "", "", "", "56.96694", "23.15528", "Europe/Riga"),
("455898", "Salaspils", "Саласпилс", "LV", "428", "C3", "", "", "", "56.86014", "24.36544", "Europe/Riga"),
("456172", "Riga", "Рига", "LV", "428", "25", "", "", "", "56.946", "24.10589", "Europe/Riga"),
("456202", "Rezekne", "Резекне", "LV", "428", "23", "", "", "", "56.5", "27.31667", "Europe/Riga"),
("457065", "Ogre", "Огре", "LV", "428", "21", "", "", "", "56.8162", "24.61401", "Europe/Riga"),
("457954", "Liepaja", "Лиепая", "LV", "428", "16", "", "", "", "56.51667", "21.01667", "Europe/Riga"),
("459201", "Jurmala", "Юрмала", "LV", "428", "13", "", "", "", "56.968", "23.77038", "Europe/Riga"),
("459279", "Jelgava", "Елгава", "LV", "428", "11", "", "", "", "56.65", "23.71278", "Europe/Riga"),
("459283", "Jekabpils", "Екабпилс", "LV", "428", "10", "", "", "", "56.49903", "25.85735", "Europe/Riga"),
("460413", "Daugavpils", "Даугавпилс", "LV", "428", "07", "", "", "", "55.88333", "26.53333", "Europe/Riga"),
("460570", "Cesis", "Цесис", "LV", "428", "05", "", "", "", "57.31188", "25.27456", "Europe/Riga"),
("2526435", "Zaio", "", "MA", "504", "54", "", "", "", "34.94282", "-2.7329", "Africa/Casablanca"),
("2526452", "Zagora", "Загора", "MA", "504", "55", "587", "0458701131", "", "30.33241", "-5.8384", "Africa/Casablanca"),
("2526488", "Youssoufia", "", "MA", "504", "51", "431", "1143101131", "", "32.24634", "-8.52941", "Africa/Casablanca"),
("2527089", "Tiznit", "Тизнит", "MA", "504", "55", "581", "0458101071", "", "29.69742", "-9.73162", "Africa/Casablanca"),
("2527645", "Tirhanimine", "", "MA", "504", "58", "", "", "", "35.23619", "-3.95453", "Africa/Casablanca"),
("2527915", "Tinghir", "", "MA", "504", "55", "", "", "", "31.51472", "-5.53278", "Africa/Casablanca"),
("2528659", "Tiflet", "", "MA", "504", "49", "291", "1029101051", "", "33.89469", "-6.3065", "Africa/Casablanca"),
("2528910", "Tetouan", "Тетуан", "MA", "504", "57", "", "", "", "35.57845", "-5.36837", "Africa/Casablanca"),
("2529317", "Taza", "Таза", "MA", "504", "58", "561", "1556101111", "", "34.21", "-4.01", "Africa/Casablanca"),
("2529649", "Taroudant", "Тарудант", "MA", "504", "55", "541", "0454101131", "", "30.47028", "-8.87695", "Africa/Casablanca"),
("2530048", "Taourirt", "", "MA", "504", "54", "533", "0853301331", "", "34.4073", "-2.89732", "Africa/Casablanca"),
("2530155", "Taounate", "Таунат", "MA", "504", "58", "531", "1553101051", "", "34.53661", "-4.64009", "Africa/Casablanca"),
("2530241", "Tan-Tan", "Тан-Тан", "MA", "504", "53", "", "", "", "28.43799", "-11.10321", "Africa/Casablanca"),
("2530335", "Tangier", "Танжер", "MA", "504", "57", "511", "1651101071", "", "35.76727", "-5.79975", "Africa/Casablanca"),
("2531480", "Tahala", "", "MA", "504", "58", "", "", "", "34.04845", "-4.42795", "Africa/Casablanca"),
("2532394", "Souq Larb'a al Gharb", "", "MA", "504", "52", "", "", "", "34.68664", "-6.00272", "Africa/Casablanca"),
("2532822", "Sidi Yahia el Gharb", "", "MA", "504", "52", "", "", "", "34.30652", "-6.30618", "Africa/Casablanca"),
("2532945", "Sidi Slimane", "Сиди-Слимане", "MA", "504", "52", "281", "0528101071", "", "34.26478", "-5.92598", "Africa/Casablanca"),
("2533191", "Sidi Qacem", "", "MA", "504", "52", "", "", "", "34.22149", "-5.70775", "Africa/Casablanca"),
("2534515", "Sidi Ifni", "Сиди Ифни", "MA", "504", "55", "581", "0458101031", "", "29.37975", "-10.17299", "Africa/Casablanca"),
("2536074", "Sidi Bennour", "", "MA", "504", "51", "181", "1118101071", "", "32.65236", "-8.42769", "Africa/Casablanca"),
("2537406", "Settat", "Сеттат", "MA", "504", "50", "461", "0646101151", "", "33.00103", "-7.61662", "Africa/Casablanca"),
("2537545", "Sefrou", "", "MA", "504", "46", "451", "1445101091", "", "33.83186", "-4.828", "Africa/Casablanca"),
("2537763", "Sale", "Сале", "MA", "504", "49", "", "", "", "34.0531", "-6.79846", "Africa/Casablanca"),
("2537881", "Safi", "Сафи", "MA", "504", "51", "431", "1143101031", "", "32.29939", "-9.23718", "Africa/Casablanca"),
("2538475", "Rabat", "Рабат", "MA", "504", "49", "421", "", "", "34.01325", "-6.83255", "Africa/Casablanca"),
("2539134", "Oulad Teima", "", "MA", "504", "55", "", "", "", "30.39467", "-9.20897", "Africa/Casablanca"),
("2540483", "Oujda", "Уджда", "MA", "504", "54", "411", "0841101231", "", "34.68052", "-1.90764", "Africa/Casablanca"),
("2540689", "Oued Zem", "", "MA", "504", "50", "311", "0631101091", "", "32.8627", "-6.57359", "Africa/Casablanca"),
("2540810", "Ouazzane", "", "MA", "504", "52", "", "", "", "34.79711", "-5.58224", "Africa/Casablanca"),
("2540850", "Ouarzazat", "Варзазат", "MA", "504", "55", "401", "", "", "30.91894", "-6.89341", "Africa/Casablanca"),
("2541479", "Nador", "Надор", "MA", "504", "54", "381", "0838101051", "", "35.16813", "-2.93352", "Africa/Casablanca"),
("2542051", "Mohammedia", "Мохаммедия", "MA", "504", "45", "371", "0937101011", "", "33.68607", "-7.38298", "Africa/Casablanca"),
("2542227", "Midelt", "", "MA", "504", "48", "301", "1330101031", "", "32.6852", "-4.74512", "Africa/Casablanca"),
("2542715", "Meknes", "Мекнес", "MA", "504", "48", "061", "1306101011", "", "33.89352", "-5.54727", "Africa/Casablanca"),
("2542866", "Mechra Belqsiri", "", "MA", "504", "52", "", "", "", "34.57396", "-5.95372", "Africa/Casablanca"),
("2542987", "Martil", "", "MA", "504", "57", "571", "1657101031", "", "35.61662", "-5.27522", "Africa/Casablanca"),
("2542997", "Marrakesh", "Марракеш", "MA", "504", "47", "351", "0735101071", "", "31.63416", "-7.99994", "Africa/Casablanca"),
("2543549", "Larache", "Лараша", "MA", "504", "57", "331", "1633101031", "", "35.19321", "-6.15572", "Africa/Casablanca"),
("2544001", "Ksar el Kebir", "", "MA", "504", "57", "", "", "", "35.00174", "-5.90534", "Africa/Casablanca"),
("2544248", "Khouribga", "", "MA", "504", "50", "311", "0631101071", "", "32.88108", "-6.9063", "Africa/Casablanca"),
("2544333", "Khenifra", "Хенифра", "MA", "504", "48", "301", "1330101011", "", "32.9391", "-5.6686", "Africa/Casablanca"),
("2544571", "Kenitra", "Кенитра", "MA", "504", "52", "281", "0528101011", "", "34.26101", "-6.5802", "Africa/Casablanca"),
("2544720", "Kasba Tadla", "", "MA", "504", "56", "091", "1209101071", "", "32.5977", "-6.26844", "Africa/Casablanca"),
("2545017", "Jerada", "Джерада", "MA", "504", "54", "275", "0827501171", "", "34.31", "-2.16", "Africa/Casablanca"),
("2545985", "Imzourene", "", "MA", "504", "58", "", "", "", "35.15", "-3.86", "Africa/Casablanca"),
("2548489", "Guercif", "", "MA", "504", "58", "561", "1556101031", "", "34.22568", "-3.35361", "Africa/Casablanca"),
("2548526", "Guelmim", "", "MA", "504", "53", "261", "0326101031", "", "28.98696", "-10.05738", "Africa/Casablanca"),
("2548830", "Fkih Ben Salah", "", "MA", "504", "56", "", "", "", "32.50093", "-6.69062", "Africa/Casablanca"),
("2548885", "Fes", "Фес", "MA", "504", "46", "231", "1423101071", "", "34.03715", "-4.9998", "Africa/Casablanca"),
("2549263", "Essaouira", "Эссуэйра", "MA", "504", "47", "211", "0721101051", "", "31.5125", "-9.77", "Africa/Casablanca"),
("2550078", "El Jadida", "Эль-Джадида", "MA", "504", "51", "181", "", "", "33.25492", "-8.50602", "Africa/Casablanca"),
("2550252", "El Hajeb", "", "MA", "504", "48", "171", "1317101051", "", "33.68786", "-5.371", "Africa/Casablanca"),
("2550806", "El Aioun", "", "MA", "504", "54", "", "", "", "34.58319", "-2.50612", "Africa/Casablanca"),
("2553455", "Chefchaouene", "Шефшауен", "MA", "504", "57", "", "", "", "35.16878", "-5.2636", "Africa/Casablanca"),
("2553604", "Casablanca", "Касабланка", "MA", "504", "45", "141", "", "", "33.58831", "-7.61138", "Africa/Casablanca"),
("2553751", "Bouznika", "Бузнике", "MA", "504", "50", "111", "0611101031", "", "33.78942", "-7.15968", "Africa/Casablanca"),
("2555467", "Berkane", "", "MA", "504", "54", "113", "0811301091", "", "34.92", "-2.32", "Africa/Casablanca"),
("2555745", "Beni Mellal", "Бени-Меллаль", "MA", "504", "56", "091", "1209109012", "", "32.33725", "-6.34984", "Africa/Casablanca"),
("2556272", "Berrechid", "", "MA", "504", "50", "461", "0646101031", "", "33.26553", "-7.58754", "Africa/Casablanca"),
("2556464", "Azrou", "", "MA", "504", "48", "271", "1327101011", "", "33.43443", "-5.22126", "Africa/Casablanca"),
("2556657", "Azemmour", "", "MA", "504", "51", "181", "1118101011", "", "33.28952", "-8.3425", "Africa/Casablanca"),
("2557055", "Asilah", "Асилах", "MA", "504", "57", "", "", "", "35.46522", "-6.03415", "Africa/Casablanca"),
("2558470", "Khemisset", "", "MA", "504", "49", "291", "1029101011", "", "33.82404", "-6.06627", "Africa/Casablanca"),
("2558545", "Al Hoceima", "", "MA", "504", "58", "", "", "", "35.25165", "-3.93723", "Africa/Casablanca"),
("2561124", "Ahfir", "", "MA", "504", "54", "113", "0811301011", "", "34.95368", "-2.10027", "Africa/Casablanca"),
("2561668", "Agadir", "Агадир", "MA", "504", "55", "001", "0400101011", "", "30.42018", "-9.59815", "Africa/Casablanca"),
("2562055", "Skhirat", "", "MA", "504", "49", "", "", "", "33.84984", "-7.04037", "Africa/Casablanca"),
("6546693", "Boujniba", "", "MA", "504", "50", "311", "0631101031", "", "32.90046", "-6.77464", "Africa/Casablanca"),
("8542188", "Dakhla", "", "MA", "504", "EH", "", "", "", "30.41071", "-9.55572", "Africa/Casablanca"),
("2992741", "Monte-Carlo", "Монте-Карло", "MC", "492", "00", "", "", "", "43.73976", "7.42732", "Europe/Monaco"),
("2993458", "Monaco", "Монако", "MC", "492", "00", "", "", "", "43.73333", "7.41667", "Europe/Monaco"),
("617076", "Edinet", "Единцы", "MD", "498", "73", "", "", "", "48.16806", "27.305", "Europe/Chisinau"),
("617180", "Ungheni", "Унгень", "MD", "498", "92", "", "", "", "47.20417", "27.79583", "Europe/Chisinau"),
("617239", "Tiraspol", "Тирасполь", "MD", "498", "58", "", "", "", "46.84028", "29.64333", "Europe/Chisinau"),
("617302", "Straseni", "Страшенский район", "MD", "498", "89", "", "", "", "47.14139", "28.61028", "Europe/Chisinau"),
("617345", "Bilicenii Vechi", "", "MD", "498", "85", "", "", "", "47.65639", "28.04722", "Europe/Chisinau"),
("617367", "Soroca", "Сорока", "MD", "498", "87", "", "", "", "48.15583", "28.2975", "Europe/Chisinau"),
("617381", "Slobozia", "", "MD", "498", "58", "", "", "", "46.72806", "29.70778", "Europe/Chisinau"),
("617486", "Ribnita", "Рыбница", "MD", "498", "58", "", "", "", "47.76639", "29.00111", "Europe/Chisinau"),
("617638", "Orhei", "Оргеев", "MD", "498", "82", "", "", "", "47.38306", "28.82306", "Europe/Chisinau"),
("617993", "Hincesti", "Хынчешты", "MD", "498", "77", "", "", "", "46.82583", "28.59361", "Europe/Chisinau"),
("618120", "Causeni", "Каушаны", "MD", "498", "67", "", "", "", "46.64417", "29.41389", "Europe/Chisinau"),
("618329", "Floresti", "Флорешты", "MD", "498", "75", "", "", "", "47.89333", "28.30139", "Europe/Chisinau"),
("618365", "Dubasari", "Дубоссары", "MD", "498", "58", "", "", "", "47.26306", "29.16083", "Europe/Chisinau"),
("618370", "Drochia", "Дрокия", "MD", "498", "71", "", "", "", "48.035", "27.81611", "Europe/Chisinau"),
("618405", "Comrat", "Комрат", "MD", "498", "51", "", "", "", "46.30028", "28.65722", "Europe/Chisinau"),
("618426", "Chisinau", "Кишинёв", "MD", "498", "57", "", "", "", "47.00556", "28.8575", "Europe/Chisinau"),
("618450", "Ceadir-Lunga", "Чадыр-Лунга", "MD", "498", "51", "", "", "", "46.055", "28.83028", "Europe/Chisinau"),
("618456", "Cahul", "Кахул", "MD", "498", "64", "", "", "", "45.9075", "28.19444", "Europe/Chisinau"),
("618577", "Bender", "Бендеры", "MD", "498", "62", "", "", "", "46.83056", "29.47111", "Europe/Chisinau"),
("618605", "Balti", "Бельцы", "MD", "498", "60", "", "", "", "47.76167", "27.92889", "Europe/Chisinau"),
("3193044", "Podgorica", "Подгорица", "ME", "499", "16", "", "", "", "42.44111", "19.26361", "Europe/Podgorica"),
("3193161", "Pljevlja", "Плевля", "ME", "499", "14", "", "", "", "43.3567", "19.35843", "Europe/Podgorica"),
("3194494", "Niksic", "Никшич", "ME", "499", "12", "", "", "", "42.7731", "18.94446", "Europe/Podgorica"),
("3199394", "Herceg-Novi", "Херцег-Нови", "ME", "499", "08", "", "", "", "42.45306", "18.5375", "Europe/Podgorica"),
("3202641", "Cetinje", "Цетине", "ME", "499", "06", "", "", "", "42.39063", "18.91417", "Europe/Podgorica"),
("3203106", "Budva", "Будва", "ME", "499", "05", "", "", "", "42.28639", "18.84", "Europe/Podgorica"),
("3204176", "Bijelo Polje", "Биело-Поле", "ME", "499", "04", "", "", "", "43.03834", "19.74758", "Europe/Podgorica"),
("3204509", "Bar", "Бар", "ME", "499", "02", "", "", "", "42.09306", "19.10028", "Europe/Podgorica"),
("1053384", "Toamasina", "Туамасина", "MG", "450", "7670857", "", "", "", "-18.1492", "49.40234", "Indian/Antananarivo"),
("1053507", "Vondrozo", "", "MG", "450", "7670908", "", "", "", "-22.81667", "47.28333", "Indian/Antananarivo"),
("1053778", "Vohipaho", "", "MG", "450", "7670908", "", "", "", "-23.55", "47.5", "Indian/Antananarivo"),
("1054035", "Vohibinany", "", "MG", "450", "7670857", "", "", "", "-17.35", "49.03333", "Indian/Antananarivo"),
("1054192", "Vavatenina", "", "MG", "450", "7670848", "", "", "", "-17.46667", "49.2", "Indian/Antananarivo"),
("1054329", "Vangaindrano", "", "MG", "450", "7670908", "", "", "", "-23.35", "47.6", "Indian/Antananarivo"),
("1054463", "Tsiroanomandidy", "", "MG", "450", "7670853", "", "", "", "-18.76908", "46.05005", "Indian/Antananarivo"),
("1054500", "Tsiombe", "", "MG", "450", "7670911", "", "", "", "-25.3", "45.48333", "Indian/Antananarivo"),
("1055059", "Tsaratanana", "", "MG", "450", "7670850", "", "", "", "-16.79706", "47.65165", "Indian/Antananarivo"),
("1055429", "Toliara", "Тулиара", "MG", "450", "7670913", "8299677", "", "", "-23.35", "43.66667", "Indian/Antananarivo"),
("1055433", "Fort Dauphin", "", "MG", "450", "7670910", "", "", "", "-25.03249", "46.98329", "Indian/Antananarivo"),
("1056151", "Soavinandriana", "", "MG", "450", "7670855", "", "", "", "-19.16667", "46.73333", "Indian/Antananarivo"),
("1056381", "Soanindrariny", "", "MG", "450", "7670854", "", "", "", "-19.9", "47.23333", "Indian/Antananarivo"),
("1056386", "Soanierana Ivongo", "", "MG", "450", "7670848", "", "", "", "-16.91667", "49.58333", "Indian/Antananarivo"),
("1056531", "Sitampiky", "", "MG", "450", "7670849", "", "", "", "-16.66667", "46.1", "Indian/Antananarivo"),
("1056899", "Sambava", "Самбава", "MG", "450", "7670846", "", "", "", "-14.26667", "50.16667", "Indian/Antananarivo"),
("1057095", "Sakaraha", "", "MG", "450", "7670913", "", "", "", "-22.9", "44.53333", "Indian/Antananarivo"),
("1057277", "Sahavato", "", "MG", "450", "7670906", "", "", "", "-20.6", "48.33333", "Indian/Antananarivo"),
("1057688", "Sadabe", "", "MG", "450", "7670856", "", "", "", "-18.63333", "47.7", "Indian/Antananarivo"),
("1058080", "Nosy Varika", "", "MG", "450", "7670906", "", "", "", "-20.58333", "48.53333", "Indian/Antananarivo"),
("1058381", "Morondava", "", "MG", "450", "7670902", "", "", "", "-20.28869", "44.31782", "Indian/Antananarivo"),
("1058532", "Moramanga", "", "MG", "450", "7670851", "", "", "", "-18.94948", "48.23007", "Indian/Antananarivo"),
("1059051", "Miandrivazo", "", "MG", "450", "7670902", "", "", "", "-19.52905", "45.45559", "Indian/Antananarivo"),
("1059059", "Miandrarivo", "", "MG", "450", "7670854", "", "", "", "-19.43333", "46.75", "Indian/Antananarivo"),
("1059507", "Marovoay", "", "MG", "450", "7670849", "", "", "", "-16.11064", "46.64383", "Indian/Antananarivo"),
("1060007", "Marolambo", "", "MG", "450", "7670857", "", "", "", "-20.05", "48.11667", "Indian/Antananarivo"),
("1060283", "Maroantsetra", "Маруанцентре", "MG", "450", "7670848", "", "", "", "-15.43689", "49.73871", "Indian/Antananarivo"),
("1060673", "Manjakandriana", "", "MG", "450", "7670856", "", "", "", "-18.91667", "47.8", "Indian/Antananarivo"),
("1061335", "Mananjary", "", "MG", "450", "7670906", "", "", "", "-21.23034", "48.34173", "Indian/Antananarivo"),
("1061412", "Mananara", "", "MG", "450", "7670848", "", "", "", "-16.16864", "49.76622", "Indian/Antananarivo"),
("1061605", "Manakara", "Манакара", "MG", "450", "7670906", "", "", "", "-22.14862", "48.01055", "Indian/Antananarivo"),
("1061912", "Maintirano", "", "MG", "450", "7670852", "", "", "", "-18.06354", "44.02951", "Indian/Antananarivo"),
("1062553", "Mahanoro", "", "MG", "450", "7670857", "", "", "", "-19.9", "48.8", "Indian/Antananarivo"),
("1062663", "Mahajanga", "Махадзанга", "MG", "450", "7670849", "", "", "", "-15.71667", "46.31667", "Indian/Antananarivo"),
("1062842", "Maevatanana", "", "MG", "450", "7670850", "", "", "", "-16.95", "46.83333", "Indian/Antananarivo"),
("1064234", "Ikongo", "", "MG", "450", "7670906", "", "", "", "-21.88333", "47.43333", "Indian/Antananarivo"),
("1064258", "Ikalamavony", "", "MG", "450", "7670905", "", "", "", "-21.15", "46.58333", "Indian/Antananarivo"),
("1064275", "Ihosy", "", "MG", "450", "7670907", "", "", "", "-22.40293", "46.12576", "Indian/Antananarivo"),
("1064366", "Ifanadiana", "", "MG", "450", "7670906", "", "", "", "-21.3", "47.63333", "Indian/Antananarivo"),
("1064890", "Fianarantsoa", "Фианаранцуа", "MG", "450", "7670905", "", "", "", "-21.45267", "47.08569", "Indian/Antananarivo"),
("1064978", "Fenoarivo Be", "", "MG", "450", "7670853", "", "", "", "-18.43333", "46.56667", "Indian/Antananarivo"),
("1064980", "Fenoarivo Atsinanana", "", "MG", "450", "7670848", "", "", "", "-17.38095", "49.40826", "Indian/Antananarivo"),
("1065140", "Faratsiho", "", "MG", "450", "7670854", "", "", "", "-19.4", "46.95", "Indian/Antananarivo"),
("1065158", "Farafangana", "", "MG", "450", "7670908", "8299290", "", "", "-22.82223", "47.82615", "Indian/Antananarivo"),
("1065222", "Fandriana", "", "MG", "450", "7670904", "", "", "", "-20.23333", "47.38333", "Indian/Antananarivo"),
("1066310", "Betioky", "", "MG", "450", "7670913", "", "", "", "-23.72065", "44.38069", "Indian/Antananarivo"),
("1066514", "Betafo", "", "MG", "450", "7670854", "", "", "", "-19.83333", "46.85", "Indian/Antananarivo"),
("1066831", "Beroroha", "", "MG", "450", "7670913", "", "", "", "-21.66667", "45.16667", "Indian/Antananarivo"),
("1067531", "Belo sur Tsiribihina", "", "MG", "450", "7670902", "", "", "", "-19.69787", "44.54587", "Indian/Antananarivo"),
("1067565", "Beloha", "", "MG", "450", "7670911", "", "", "", "-25.16667", "45.05", "Indian/Antananarivo"),
("1068670", "Bealanana", "", "MG", "450", "7670847", "", "", "", "-14.54329", "48.74981", "Indian/Antananarivo"),
("1068865", "Arivonimamo", "", "MG", "450", "7670855", "", "", "", "-19.01667", "47.18333", "Indian/Antananarivo"),
("1068955", "Antsohimbondrona", "", "MG", "450", "7670842", "", "", "", "-13.08333", "48.85", "Indian/Antananarivo"),
("1068971", "Antsohihy", "", "MG", "450", "7670847", "", "", "", "-14.87959", "47.98751", "Indian/Antananarivo"),
("1069129", "Antsiranana", "Анцеранана", "MG", "450", "7670842", "", "", "", "-12.2787", "49.29171", "Indian/Antananarivo"),
("1069166", "Antsirabe", "Анцирабе", "MG", "450", "7670854", "", "", "", "-19.86586", "47.03333", "Indian/Antananarivo"),
("1070661", "Antanifotsy", "", "MG", "450", "7670854", "", "", "", "-19.65", "47.31667", "Indian/Antananarivo"),
("1070940", "Antananarivo", "Антананариву", "MG", "450", "7670856", "", "", "", "-18.91368", "47.53613", "Indian/Antananarivo"),
("1071296", "Antalaha", "Анталахи", "MG", "450", "7670846", "", "", "", "-14.90033", "50.27876", "Indian/Antananarivo"),
("1072711", "Ankazondandy", "", "MG", "450", "7670856", "", "", "", "-18.7", "47.78333", "Indian/Antananarivo"),
("1072849", "Ankazobe", "", "MG", "450", "7670856", "", "", "", "-18.31667", "47.11667", "Indian/Antananarivo"),
("1072879", "Ankazoabo", "", "MG", "450", "7670913", "", "", "", "-22.28333", "44.51667", "Indian/Antananarivo"),
("1073482", "Anjozorobe", "", "MG", "450", "7670856", "", "", "", "-18.4", "47.86667", "Indian/Antananarivo"),
("1076105", "Andoany", "", "MG", "450", "7670842", "", "", "", "-13.4", "48.26667", "Indian/Antananarivo"),
("1076194", "Andilamena", "", "MG", "450", "7670851", "8335145", "", "", "-17.01009", "48.57313", "Indian/Antananarivo"),
("1076454", "Andapa", "", "MG", "450", "7670846", "", "", "", "-14.65", "49.65", "Indian/Antananarivo"),
("1078171", "Ampasimanolotra", "", "MG", "450", "7670857", "", "", "", "-18.81667", "49.06667", "Indian/Antananarivo"),
("1078446", "Amparafaravola", "", "MG", "450", "7670851", "7670894", "", "", "-17.5876", "48.22391", "Indian/Antananarivo"),
("1078553", "Ampanihy", "", "MG", "450", "7670913", "", "", "", "-24.6937", "44.74581", "Indian/Antananarivo"),
("1078966", "Ampahana", "", "MG", "450", "7670846", "", "", "", "-14.75", "50.21667", "Indian/Antananarivo"),
("1079048", "Ambovombe", "", "MG", "450", "7670911", "", "", "", "-25.17838", "46.08722", "Indian/Antananarivo"),
("1079088", "Ambositra", "", "MG", "450", "7670904", "", "", "", "-20.53034", "47.24344", "Indian/Antananarivo"),
("1079777", "Ambohitrolomahitsy", "", "MG", "450", "7670856", "", "", "", "-18.7", "47.68333", "Indian/Antananarivo"),
("1081790", "Amboasary", "", "MG", "450", "7670910", "", "", "", "-25.03333", "46.38333", "Indian/Antananarivo"),
("1081863", "Amboanjo", "", "MG", "450", "7670906", "", "", "", "-22", "47.85", "Indian/Antananarivo"),
("1082243", "Ambilobe", "", "MG", "450", "7670842", "", "", "", "-13.2", "49.05", "Indian/Antananarivo"),
("1082639", "Ambatondrazaka", "", "MG", "450", "7670851", "", "", "", "-17.83333", "48.41667", "Indian/Antananarivo"),
("1082992", "Ambatolampy", "", "MG", "450", "7670854", "", "", "", "-19.38333", "47.41667", "Indian/Antananarivo"),
("1083239", "Ambatofinandrahana", "", "MG", "450", "7670904", "8335147", "", "", "-20.55284", "46.80365", "Indian/Antananarivo"),
("1083257", "Ambato Boeny", "", "MG", "450", "7670849", "", "", "", "-16.46667", "46.71667", "Indian/Antananarivo"),
("1083676", "Ambarakaraka", "", "MG", "450", "7670842", "", "", "", "-13.5", "48.86667", "Indian/Antananarivo"),
("1083724", "Ambanja", "", "MG", "450", "7670842", "", "", "", "-13.68333", "48.45", "Indian/Antananarivo"),
("1083968", "Ambalavao", "", "MG", "450", "7670905", "", "", "", "-21.83333", "46.93333", "Indian/Antananarivo"),
("1084740", "Alarobia", "", "MG", "450", "7670856", "", "", "", "-18.96667", "47.73333", "Indian/Antananarivo"),
("2448442", "Yorosso", "Йоросо", "ML", "466", "06", "", "", "", "12.35812", "-4.77688", "Africa/Bamako"),
("2449067", "Timbuktu", "Тимбукту", "ML", "466", "08", "", "", "", "16.77348", "-3.00742", "Africa/Bamako"),
("2451185", "Sikasso", "Сикасо", "ML", "466", "06", "", "", "", "11.31755", "-5.66654", "Africa/Bamako"),
("2451478", "Segou", "Сеги", "ML", "466", "05", "", "", "", "13.4317", "-6.2157", "Africa/Bamako"),
("2451778", "San", "", "ML", "466", "05", "", "", "", "13.30335", "-4.89562", "Africa/Bamako"),
("2451935", "Sagalo", "", "ML", "466", "03", "", "", "", "12.2", "-10.7", "Africa/Bamako"),
("2453348", "Mopti", "Мопти", "ML", "466", "04", "", "", "", "14.4843", "-4.18296", "Africa/Bamako"),
("2453662", "Markala", "", "ML", "466", "05", "", "", "", "13.7021", "-6.0659", "Africa/Bamako"),
("2454268", "Koutiala", "Кутиала", "ML", "466", "06", "", "", "", "12.39173", "-5.46421", "Africa/Bamako"),
("2454530", "Koulikoro", "Куликоро", "ML", "466", "07", "", "", "", "12.86273", "-7.55985", "Africa/Bamako"),
("2454955", "Kolokani", "Колокани", "ML", "466", "07", "", "", "", "13.5728", "-8.0339", "Africa/Bamako"),
("2455518", "Kayes", "Каес", "ML", "466", "03", "", "", "", "14.44693", "-11.44448", "Africa/Bamako"),
("2455558", "Kati", "Кати", "ML", "466", "07", "", "", "", "12.74409", "-8.07257", "Africa/Bamako"),
("2455735", "Kangaba", "Кангаба", "ML", "466", "07", "", "", "", "11.93333", "-8.41667", "Africa/Bamako"),
("2457163", "Gao", "Гао", "ML", "466", "09", "", "", "", "16.27167", "-0.04472", "Africa/Bamako"),
("2458589", "Djenne", "", "ML", "466", "04", "", "", "", "13.90608", "-4.55332", "Africa/Bamako"),
("2459775", "Bougouni", "", "ML", "466", "06", "", "", "", "11.41769", "-7.48323", "Africa/Bamako"),
("2460546", "Banamba", "", "ML", "466", "07", "", "", "", "13.54773", "-7.44808", "Africa/Bamako"),
("2460596", "Bamako", "Бамако", "ML", "466", "01", "", "", "", "12.65", "-8", "Africa/Bamako"),
("2460755", "Bafoulabe", "", "ML", "466", "03", "", "", "", "13.8065", "-10.8321", "Africa/Bamako"),
("1285173", "Yenangyaung", "", "MM", "104", "15", "", "", "", "20.46504", "94.8712", "Asia/Rangoon"),
("1285871", "Nyaungdon", "", "MM", "104", "03", "", "", "", "17.04459", "95.63957", "Asia/Rangoon"),
("1285899", "Yamethin", "", "MM", "104", "08", "", "", "", "20.43189", "96.13874", "Asia/Rangoon"),
("1289828", "Wakema", "", "MM", "104", "03", "", "", "", "16.60333", "95.18278", "Asia/Rangoon"),
("1290374", "Twante", "", "MM", "104", "17", "", "", "", "16.71047", "95.92866", "Asia/Rangoon"),
("1290596", "Taungoo", "Таунгу", "MM", "104", "16", "", "", "", "18.94291", "96.43408", "Asia/Rangoon"),
("1291193", "Thongwa", "", "MM", "104", "17", "", "", "", "16.75998", "96.52498", "Asia/Rangoon"),
("1292037", "Thayetmyo", "", "MM", "104", "15", "", "", "", "19.32076", "95.18272", "Asia/Rangoon"),
("1292288", "Thaton", "", "MM", "104", "13", "", "", "", "16.91867", "97.37001", "Asia/Rangoon"),
("1292313", "Tharyarwady", "", "MM", "104", "16", "", "", "", "17.65399", "95.78813", "Asia/Rangoon"),
("1292579", "Thanatpin", "", "MM", "104", "16", "", "", "", "17.29136", "96.57523", "Asia/Rangoon"),
("1292580", "Thanatpin", "", "MM", "104", "16", "", "", "", "17.21194", "96.30333", "Asia/Rangoon"),
("1293625", "Dawei", "", "MM", "104", "12", "", "", "", "14.07375", "98.19423", "Asia/Rangoon"),
("1293960", "Taunggyi", "", "MM", "104", "11", "", "", "", "20.78919", "97.03776", "Asia/Rangoon"),
("1294041", "Taungdwingyi", "", "MM", "104", "15", "", "", "", "20.0065", "95.54531", "Asia/Rangoon"),
("1295395", "Syriam", "", "MM", "104", "17", "", "", "", "16.76887", "96.24503", "Asia/Rangoon"),
("1295765", "Sittwe", "Ситуэ", "MM", "104", "01", "", "", "", "20.14624", "92.89835", "Asia/Rangoon"),
("1296736", "Shwebo", "", "MM", "104", "10", "", "", "", "22.56925", "95.69818", "Asia/Rangoon"),
("1298482", "Sagaing", "Сагайн", "MM", "104", "10", "", "", "", "21.8787", "95.97965", "Asia/Rangoon"),
("1298824", "Yangon", "Янгон", "MM", "104", "17", "", "", "", "16.80528", "96.15611", "Asia/Rangoon"),
("1298911", "Pyu", "", "MM", "104", "16", "", "", "", "18.4813", "96.43742", "Asia/Rangoon"),
("1298987", "Pyinmana", "Пьинмана", "MM", "104", "08", "", "", "", "19.7381", "96.20742", "Asia/Rangoon"),
("1299154", "Pyay", "Проме", "MM", "104", "16", "", "", "", "18.82464", "95.22216", "Asia/Rangoon"),
("1299237", "Pyapon", "Пьяпон", "MM", "104", "03", "", "", "", "16.28543", "95.67882", "Asia/Rangoon"),
("1300466", "Bago", "Пегу", "MM", "104", "16", "", "", "", "17.33521", "96.48135", "Asia/Rangoon"),
("1300969", "Paungde", "", "MM", "104", "16", "", "", "", "18.49167", "95.50591", "Asia/Rangoon"),
("1302439", "Pakokku", "Пакокку", "MM", "104", "15", "", "", "", "21.33489", "95.08438", "Asia/Rangoon"),
("1302849", "Hpa-an", "", "MM", "104", "05", "", "", "", "16.88953", "97.63482", "Asia/Rangoon"),
("1303406", "Nyaunglebin", "", "MM", "104", "16", "", "", "", "17.95363", "96.72247", "Asia/Rangoon"),
("1307741", "Myitkyina", "Мьичина", "MM", "104", "04", "", "", "", "25.38641", "97.39439", "Asia/Rangoon"),
("1307835", "Myingyan", "", "MM", "104", "08", "", "", "", "21.46002", "95.3884", "Asia/Rangoon"),
("1308204", "Myanaung", "", "MM", "104", "03", "", "", "", "18.28651", "95.32014", "Asia/Rangoon"),
("1308415", "Mudon", "", "MM", "104", "13", "", "", "", "16.25624", "97.7246", "Asia/Rangoon"),
("1308464", "Mawlamyinegyunn", "", "MM", "104", "03", "", "", "", "16.3772", "95.26488", "Asia/Rangoon"),
("1308465", "Mawlamyine", "Моламьяйн", "MM", "104", "13", "", "", "", "16.49051", "97.62825", "Asia/Rangoon"),
("1308522", "Monywa", "", "MM", "104", "10", "", "", "", "22.10856", "95.13583", "Asia/Rangoon"),
("1308937", "Mogok", "Могок", "MM", "104", "08", "", "", "", "22.91766", "96.50982", "Asia/Rangoon"),
("1309289", "Minbu", "", "MM", "104", "15", "", "", "", "20.18059", "94.87595", "Asia/Rangoon"),
("1309611", "Myeik", "", "MM", "104", "12", "", "", "", "12.43954", "98.60028", "Asia/Rangoon"),
("1309793", "Meiktila", "", "MM", "104", "08", "", "", "", "20.87776", "95.85844", "Asia/Rangoon"),
("1309937", "Maymyo", "", "MM", "104", "08", "", "", "", "22.02826", "96.47066", "Asia/Rangoon"),
("1310120", "Mawlaik", "", "MM", "104", "10", "", "", "", "23.64254", "94.40478", "Asia/Rangoon"),
("1310362", "Maubin", "", "MM", "104", "03", "", "", "", "16.73148", "95.65441", "Asia/Rangoon"),
("1310460", "Martaban", "Мартабан", "MM", "104", "13", "", "", "", "16.52834", "97.6157", "Asia/Rangoon"),
("1311874", "Mandalay", "Мандалай", "MM", "104", "08", "", "", "", "21.97473", "96.08359", "Asia/Rangoon"),
("1312609", "Magway", "Магуэ", "MM", "104", "15", "", "", "", "20.14956", "94.93246", "Asia/Rangoon"),
("1313479", "Loikaw", "", "MM", "104", "06", "", "", "", "19.67798", "97.20975", "Asia/Rangoon"),
("1314042", "Letpandan", "", "MM", "104", "16", "", "", "", "17.78664", "95.75076", "Asia/Rangoon"),
("1314759", "Lashio", "Лаша", "MM", "104", "11", "", "", "", "22.9359", "97.7498", "Asia/Rangoon"),
("1316703", "Kyaukse", "", "MM", "104", "08", "", "", "", "21.6056", "96.13508", "Asia/Rangoon"),
("1317375", "Kyaikto", "", "MM", "104", "13", "", "", "", "17.30858", "97.01124", "Asia/Rangoon"),
("1317397", "Kyaiklat", "", "MM", "104", "03", "", "", "", "16.44502", "95.72373", "Asia/Rangoon"),
("1317402", "Kyaikkami", "", "MM", "104", "13", "", "", "", "16.07686", "97.56388", "Asia/Rangoon"),
("1319533", "Kayan", "", "MM", "104", "17", "", "", "", "16.90802", "96.56037", "Asia/Rangoon"),
("1320944", "Kanbe", "Канбе", "MM", "104", "17", "", "", "", "16.70728", "96.00168", "Asia/Rangoon"),
("1325211", "Hinthada", "", "MM", "104", "03", "", "", "", "17.64944", "95.45706", "Asia/Rangoon"),
("1325443", "Hakha", "", "MM", "104", "02", "", "", "", "22.65", "93.61667", "Asia/Rangoon"),
("1327659", "Chauk", "Чаук", "MM", "104", "15", "", "", "", "20.89921", "94.81784", "Asia/Rangoon"),
("1328121", "Bogale", "", "MM", "104", "03", "", "", "", "16.29416", "95.39742", "Asia/Rangoon"),
("1328218", "Bhamo", "Бамо", "MM", "104", "04", "", "", "", "24.25256", "97.23357", "Asia/Rangoon"),
("1328421", "Pathein", "Патейн", "MM", "104", "03", "", "", "", "16.77919", "94.73212", "Asia/Rangoon"),
("1329239", "Myaydo", "", "MM", "104", "15", "", "", "", "19.36838", "95.21512", "Asia/Rangoon"),
("6611854", "Nay Pyi Taw", "", "MM", "104", "08", "", "", "", "19.745", "96.12972", "Asia/Rangoon"),
("1515007", "Uliastay", "", "MN", "496", "09", "", "", "", "47.74167", "96.84444", "Asia/Hovd"),
("1515029", "Ulaangom", "Улангом", "MN", "496", "19", "", "", "", "49.98111", "92.06667", "Asia/Hovd"),
("1515436", "OElgiy", "Улгий", "MN", "496", "03", "", "", "", "48.96833", "89.9625", "Asia/Hovd"),
("1516048", "Khovd", "Ховд", "MN", "496", "12", "6987767", "", "", "48.00556", "91.64194", "Asia/Hovd"),
("1516393", "Altai", "", "MN", "496", "10", "", "", "", "46.37222", "96.25833", "Asia/Hovd"),
("2028462", "Ulaanbaatar", "Улан-Батор", "MN", "496", "20", "", "", "", "47.90771", "106.88324", "Asia/Ulaanbaatar"),
("2029156", "Suhbaatar", "Сухэ-Батор", "MN", "496", "16", "", "", "", "50.23139", "106.20778", "Asia/Ulaanbaatar"),
("2029945", "Murun-kuren", "Мурэн", "MN", "496", "13", "", "", "", "49.63417", "100.1625", "Asia/Ulaanbaatar"),
("2030065", "Mandalgovi", "", "MN", "496", "08", "", "", "", "45.7625", "106.27083", "Asia/Ulaanbaatar"),
("2030474", "Hovd", "Ховд", "MN", "496", "15", "", "", "", "44.67024", "102.17491", "Asia/Ulaanbaatar"),
("2031405", "Erdenet", "Эрдэнэт", "MN", "496", "25", "", "", "", "49.03333", "104.08333", "Asia/Ulaanbaatar"),
("2031533", "Dzuunharaa", "Дзунхара", "MN", "496", "16", "", "", "", "48.85229", "106.45786", "Asia/Ulaanbaatar"),
("2031964", "Darhan", "Дархан", "MN", "496", "23", "", "", "", "49.48667", "105.92278", "Asia/Ulaanbaatar"),
("2032007", "Dalandzadgad", "", "MN", "496", "14", "", "", "", "43.57083", "104.425", "Asia/Ulaanbaatar"),
("2032081", "Saynshand", "Сайншанд", "MN", "496", "07", "", "", "", "44.88239", "110.11631", "Asia/Ulaanbaatar"),
("2032201", "Bulgan", "Булган", "MN", "496", "21", "6618895", "", "", "48.8125", "103.53472", "Asia/Ulaanbaatar"),
("2032532", "Bayanhongor", "Баянхонгор", "MN", "496", "02", "", "", "", "46.71667", "100.11667", "Asia/Ulaanbaatar"),
("2032533", "Bayanhongor", "", "MN", "496", "02", "", "", "", "46.19444", "100.71806", "Asia/Ulaanbaatar"),
("2032614", "Baruun-Urt", "", "MN", "496", "17", "", "", "", "46.68056", "113.27917", "Asia/Choibalsan"),
("2032814", "Arvayheer", "", "MN", "496", "15", "", "", "", "46.26389", "102.775", "Asia/Ulaanbaatar"),
("7648817", "Zuunmod", "", "MN", "496", "18", "", "", "", "47.70693", "106.95276", "Asia/Ulaanbaatar"),
("2375558", "Zouerat", "", "MR", "478", "11", "", "", "", "22.71873", "-12.45205", "Africa/Nouakchott"),
("2376189", "Tekane", "", "MR", "478", "06", "", "", "", "16.57806", "-15.45972", "Africa/Nouakchott"),
("2376719", "Selibabi", "", "MR", "478", "10", "", "", "", "15.15895", "-12.1829", "Africa/Nouakchott"),
("2376898", "Rosso", "", "MR", "478", "06", "", "", "", "16.51378", "-15.80503", "Africa/Nouakchott"),
("2377450", "Nouakchott", "Нуакшот", "MR", "478", "NKC", "", "", "", "18.08581", "-15.9785", "Africa/Nouakchott"),
("2377457", "Nouadhibou", "Нуадибу", "MR", "478", "08", "", "", "", "20.93098", "-17.03465", "Africa/Nouakchott"),
("2377539", "Nema", "", "MR", "478", "01", "", "", "", "16.6162", "-7.2535", "Africa/Nouakchott"),
("2378538", "Kiffa", "Киффа", "MR", "478", "03", "", "", "", "16.61659", "-11.40453", "Africa/Nouakchott"),
("2378736", "Kaedi", "", "MR", "478", "04", "", "", "", "16.14653", "-13.50474", "Africa/Nouakchott"),
("2381334", "Atar", "", "MR", "478", "07", "", "", "", "20.51686", "-13.04986", "Africa/Nouakchott"),
("2381659", "Aleg", "", "MR", "478", "05", "", "", "", "17.0481", "-13.9209", "Africa/Nouakchott"),
("933945", "Vacoas", "", "MU", "480", "17", "", "", "", "-20.29806", "57.47833", "Indian/Mauritius"),
("933959", "Triolet", "Триолет", "MU", "480", "16", "", "", "", "-20.05472", "57.54528", "Indian/Mauritius"),
("934032", "Saint Pierre", "", "MU", "480", "15", "", "", "", "-20.2175", "57.52083", "Indian/Mauritius"),
("934131", "Quatre Bornes", "", "MU", "480", "17", "", "", "", "-20.26381", "57.4791", "Indian/Mauritius"),
("934154", "Port Louis", "Порт-Луи", "MU", "480", "18", "", "", "", "-20.16194", "57.49889", "Indian/Mauritius"),
("934322", "Mahebourg", "", "MU", "480", "14", "", "", "", "-20.40806", "57.7", "Indian/Mauritius"),
("934488", "Goodlands", "", "MU", "480", "19", "", "", "", "-20.035", "57.64306", "Indian/Mauritius"),
("934570", "Curepipe", "Кюрпип", "MU", "480", "17", "", "", "", "-20.31472", "57.52028", "Indian/Mauritius"),
("934631", "Centre de Flacq", "", "MU", "480", "13", "", "", "", "-20.18972", "57.71444", "Indian/Mauritius"),
("934750", "Bel Air Riviere Seche", "", "MU", "480", "13", "", "", "", "-20.25777", "57.74976", "Indian/Mauritius"),
("1106809", "Le Hochet", "", "MU", "480", "16", "", "", "", "-20.135", "57.52111", "Indian/Mauritius"),
("1282027", "Male", "Мале", "MV", "462", "40", "", "", "", "4.1748", "73.50888", "Indian/Maldives"),
("235715", "Karonga", "Каронга", "MW", "454", "N", "08", "", "", "-9.93333", "33.93333", "Africa/Blantyre"),
("923295", "Zomba", "Зомба", "MW", "454", "S", "23", "", "", "-15.38596", "35.3188", "Africa/Blantyre"),
("924055", "Salima", "Салима", "MW", "454", "C", "22", "", "", "-13.7804", "34.4587", "Africa/Blantyre"),
("924102", "Rumphi", "", "MW", "454", "N", "21", "", "", "-11.01863", "33.85746", "Africa/Blantyre"),
("924572", "Nsanje", "", "MW", "454", "S", "19", "", "", "-16.91995", "35.26199", "Africa/Blantyre"),
("924705", "Nkhotakota", "", "MW", "454", "C", "18", "", "", "-12.92744", "34.29614", "Africa/Blantyre"),
("925475", "Mzuzu", "Мзузу", "MW", "454", "N", "15", "", "", "-11.46556", "34.02071", "Africa/Blantyre"),
("925498", "Mzimba", "Мзимба", "MW", "454", "N", "15", "", "", "-11.9", "33.6", "Africa/Blantyre"),
("925789", "Mulanje", "", "MW", "454", "S", "29", "", "", "-16.03163", "35.5", "Africa/Blantyre"),
("926747", "Mchinji", "", "MW", "454", "C", "13", "", "", "-13.79841", "32.88019", "Africa/Blantyre"),
("927246", "Mangochi", "Мангочи", "MW", "454", "S", "12", "", "", "-14.47815", "35.26448", "Africa/Blantyre"),
("927834", "Liwonde", "", "MW", "454", "S", "28", "", "", "-15.06665", "35.22543", "Africa/Blantyre"),
("927967", "Lilongwe", "Лилонгве", "MW", "454", "C", "11", "", "", "-13.96692", "33.78725", "Africa/Blantyre"),
("928534", "Kasungu", "Касунгу", "MW", "454", "C", "09", "", "", "-13.03333", "33.48333", "Africa/Blantyre"),
("930025", "Dedza", "", "MW", "454", "C", "06", "", "", "-14.3779", "34.33322", "Africa/Blantyre"),
("931755", "Blantyre", "Блантайр", "MW", "454", "S", "24", "", "", "-15.78499", "35.00854", "Africa/Blantyre"),
("931865", "Balaka", "Балака", "MW", "454", "S", "26", "", "", "-14.97928", "34.95575", "Africa/Blantyre"),
("3482969", "Gustavo A. Madero", "", "MX", "484", "28", "", "", "", "22.8694", "-98.75886", "America/Monterrey"),
("3483197", "San Fernando", "", "MX", "484", "28", "", "", "", "24.84749", "-98.14828", "America/Monterrey"),
("3513966", "Zumpango", "Зумпанго-де-Окампо", "MX", "484", "15", "120", "", "", "19.7967", "-99.09946", "America/Mexico_City"),
("3513967", "Zumpango del Rio", "Зумпанго-дель-Рио", "MX", "484", "12", "", "", "", "17.65319", "-99.52607", "America/Mexico_City"),
("3514134", "Zacualtipan", "", "MX", "484", "13", "", "", "", "20.65002", "-98.65628", "America/Mexico_City"),
("3514148", "Zacatlan", "Сакатлан", "MX", "484", "21", "", "", "", "19.93372", "-97.96119", "America/Mexico_City"),
("3514163", "Zacatepec", "", "MX", "484", "17", "", "", "", "18.65388", "-99.19054", "America/Mexico_City"),
("3514278", "Yecapixtla", "", "MX", "484", "17", "030", "", "", "18.88333", "-98.865", "America/Mexico_City"),
("3514321", "Yautepec", "", "MX", "484", "17", "", "", "", "18.88188", "-99.06715", "America/Mexico_City"),
("3514398", "Xoxocotla", "", "MX", "484", "17", "", "", "", "18.68502", "-99.24608", "America/Mexico_City"),
("3514409", "Xonacatlan", "", "MX", "484", "15", "", "", "", "19.40513", "-99.52752", "America/Mexico_City"),
("3514437", "Xochitepec", "", "MX", "484", "17", "", "", "", "18.78121", "-99.23055", "America/Mexico_City"),
("3514450", "Xochimilco", "", "MX", "484", "09", "", "", "", "19.25785", "-99.10513", "America/Mexico_City"),
("3514510", "Xicotepec de Juarez", "", "MX", "484", "21", "", "", "", "20.27606", "-97.9611", "America/Mexico_City"),
("3514518", "Xico", "", "MX", "484", "30", "", "", "", "19.42178", "-97.00819", "America/Mexico_City"),
("3514519", "San Miguel Xico", "", "MX", "484", "15", "", "", "", "19.27081", "-98.94803", "America/Mexico_City"),
("3514663", "Alvaro Obregon", "", "MX", "484", "09", "", "", "", "19.35867", "-99.20329", "America/Mexico_City"),
("3514670", "Villahermosa", "Вильяэрмоса", "MX", "484", "27", "", "", "", "17.98689", "-92.93028", "America/Mexico_City"),
("3514674", "Gustavo A. Madero", "", "MX", "484", "09", "", "", "", "19.49016", "-99.10978", "America/Mexico_City"),
("3514683", "Villa Cuauhtemoc", "", "MX", "484", "15", "", "", "", "19.41652", "-99.55876", "America/Mexico_City"),
("3514783", "Veracruz", "Веракрус", "MX", "484", "30", "", "", "", "19.18095", "-96.1429", "America/Mexico_City"),
("3514785", "Venustiano Carranza", "", "MX", "484", "05", "", "", "", "16.33893", "-92.56312", "America/Mexico_City"),
("3514868", "Valle Hermoso", "", "MX", "484", "28", "", "", "", "25.6718", "-97.81181", "America/Monterrey"),
("3514876", "Valladolid", "Вальядолид", "MX", "484", "31", "", "", "", "20.68812", "-88.19936", "America/Merida"),
("3514929", "Uman", "Умань", "MX", "484", "31", "", "", "", "20.88213", "-89.74649", "America/Merida"),
("3515001", "Tuxtla Gutierrez", "Тустла-Гутьеррес", "MX", "484", "05", "", "", "", "16.75469", "-93.11485", "America/Mexico_City"),
("3515011", "Tuxpan de Rodriguez Cano", "", "MX", "484", "30", "", "", "", "20.95773", "-97.40798", "America/Mexico_City"),
("3515042", "Tultitlan", "Тультитлан", "MX", "484", "15", "", "", "", "19.64756", "-99.16796", "America/Mexico_City"),
("3515044", "Tultepec", "", "MX", "484", "15", "108", "", "", "19.685", "-99.12806", "America/Mexico_City"),
("3515062", "Tulancingo", "", "MX", "484", "13", "", "", "", "20.08363", "-98.36332", "America/Mexico_City"),
("3515064", "Tula de Allende", "Тула-де-Альенде", "MX", "484", "13", "", "", "", "20.05161", "-99.34397", "America/Mexico_City"),
("3515302", "Toluca", "Толука", "MX", "484", "15", "", "", "", "19.28786", "-99.65324", "America/Mexico_City"),
("3515358", "Tlaxcalancingo", "", "MX", "484", "21", "", "", "", "19.02863", "-98.28334", "America/Mexico_City"),
("3515373", "Tlaquiltenango", "", "MX", "484", "17", "", "", "", "18.63693", "-99.16208", "America/Mexico_City"),
("3515384", "Tlapa de Comonfort", "Тлапа-де-Комонфорт", "MX", "484", "12", "", "", "", "17.54042", "-98.57952", "America/Mexico_City"),
("3515386", "Tlapacoyan", "", "MX", "484", "30", "", "", "", "19.96268", "-97.21141", "America/Mexico_City"),
("3515428", "Tlalpan", "", "MX", "484", "09", "", "", "", "19.29708", "-99.16787", "America/Mexico_City"),
("3515431", "Tlalnepantla", "Тлалнепантла", "MX", "484", "15", "", "", "", "19.54005", "-99.19538", "America/Mexico_City"),
("3515463", "Tlahuac", "", "MX", "484", "09", "", "", "", "19.28348", "-99.00317", "America/Mexico_City"),
("3515504", "Tizimin", "Тисимин", "MX", "484", "31", "096", "", "", "21.14284", "-88.15119", "America/Merida"),
("3515505", "Tizayuca", "", "MX", "484", "17", "", "", "", "19.83721", "-98.97607", "America/Mexico_City"),
("3515510", "Tixtla de Guerrero", "Тихтла-де-Герреро", "MX", "484", "12", "", "", "", "17.56732", "-99.39799", "America/Mexico_City"),
("3515665", "Ticul", "", "MX", "484", "31", "", "", "", "20.39833", "-89.53541", "America/Merida"),
("3515679", "Tianguistenco", "", "MX", "484", "15", "", "", "", "19.17927", "-99.46731", "America/Mexico_City"),
("3515690", "Tezontepec de Aldama", "", "MX", "484", "13", "", "", "", "20.19073", "-99.27429", "America/Mexico_City"),
("3515696", "Teziutlan", "", "MX", "484", "21", "", "", "", "19.8173", "-97.35992", "America/Mexico_City"),
("3515715", "Texcoco de Mora", "", "MX", "484", "17", "", "", "", "19.51194", "-98.88293", "America/Mexico_City"),
("3515794", "Tequixquiac", "", "MX", "484", "15", "096", "", "", "19.90944", "-99.14472", "America/Mexico_City"),
("3515796", "Tequisquiapan", "", "MX", "484", "22", "017", "", "", "20.5225", "-99.89167", "America/Mexico_City"),
("3515807", "Cuautitlan Izcalli", "", "MX", "484", "15", "", "", "", "19.64388", "-99.21598", "America/Mexico_City"),
("3515811", "Tepoztlan", "", "MX", "484", "17", "", "", "", "18.98603", "-99.09914", "America/Mexico_City"),
("3515827", "Tepotzotlan", "", "MX", "484", "15", "", "", "", "19.71981", "-99.2237", "America/Mexico_City"),
("3515887", "Tepeji de Ocampo", "", "MX", "484", "13", "", "", "", "19.9063", "-99.34297", "America/Mexico_City"),
("3515904", "Tepeaca", "", "MX", "484", "21", "", "", "", "18.96923", "-97.90074", "America/Mexico_City"),
("3515906", "Tepatlaxco de Hidalgo", "", "MX", "484", "21", "", "", "", "19.06747", "-97.96595", "America/Mexico_City"),
("3515942", "Teoloyucan", "", "MX", "484", "15", "", "", "", "19.7458", "-99.17855", "America/Mexico_City"),
("3515956", "Tenosique de Pino Suarez", "", "MX", "484", "27", "", "", "", "17.47496", "-91.42214", "America/Mexico_City"),
("3515993", "Tenango de Arista", "", "MX", "484", "15", "", "", "", "19.10641", "-99.59068", "America/Mexico_City"),
("3516035", "Temixco", "", "MX", "484", "17", "", "", "", "18.85528", "-99.23072", "America/Mexico_City"),
("3516053", "Temapache", "", "MX", "484", "30", "", "", "", "21.06611", "-97.64207", "America/Mexico_City"),
("3516060", "Teloloapan", "", "MX", "484", "12", "", "", "", "18.36874", "-99.8723", "America/Mexico_City"),
("3516076", "Tecax", "", "MX", "484", "31", "", "", "", "20.2052", "-89.28522", "America/Merida"),
("3516109", "Tehuacan", "Теуакан", "MX", "484", "21", "", "", "", "18.46148", "-97.39282", "America/Mexico_City"),
("3516188", "Tecamachalco", "", "MX", "484", "21", "", "", "", "18.88179", "-97.73132", "America/Mexico_City"),
("3516210", "Teapa", "", "MX", "484", "27", "", "", "", "17.54815", "-92.95228", "America/Mexico_City"),
("3516225", "Taxco de Alarcon", "Таско-де-Аларкон", "MX", "484", "12", "", "", "", "18.55629", "-99.60491", "America/Mexico_City"),
("3516266", "Tapachula", "Тапачуле", "MX", "484", "05", "", "", "", "14.90696", "-92.26185", "America/Mexico_City"),
("3516271", "Tantoyuca", "", "MX", "484", "30", "", "", "", "21.35064", "-98.2257", "America/Mexico_City"),
("3516355", "Tampico", "Тампико", "MX", "484", "28", "", "", "", "22.27817", "-97.86772", "America/Monterrey"),
("3516385", "Tamazunchale", "", "MX", "484", "24", "", "", "", "21.25993", "-98.78935", "America/Mexico_City"),
("3516843", "Santo Domingo Tehuantepec", "Санто-Доминго-Теуантепек", "MX", "484", "20", "", "", "", "16.31841", "-95.24783", "America/Mexico_City"),
("3516912", "Santiago Tuxtla", "", "MX", "484", "30", "", "", "", "18.46576", "-95.3006", "America/Mexico_City"),
("3516926", "Santiago Pinotepa Nacional", "", "MX", "484", "20", "", "", "", "16.33847", "-98.05532", "America/Mexico_City"),
("3516982", "Santiago Tulantepec", "", "MX", "484", "13", "", "", "", "20.0357", "-98.35638", "America/Mexico_City"),
("3517231", "Santa Maria Moyotzingo", "", "MX", "484", "21", "", "", "", "19.24968", "-98.40473", "America/Mexico_City"),
("3517270", "Santa Maria Chimalhuacan", "", "MX", "484", "15", "", "", "", "19.42155", "-98.95038", "America/Mexico_City"),
("3517517", "Santa Cruz Xoxocotlan", "", "MX", "484", "20", "", "", "", "17.02909", "-96.73328", "America/Mexico_City"),
("3517524", "Tecamac de Felipe Villanueva", "", "MX", "484", "17", "", "", "", "19.71288", "-98.96896", "America/Mexico_City"),
("3517742", "Chiautempan", "", "MX", "484", "29", "", "", "", "19.30633", "-98.21772", "America/Mexico_City"),
("3517831", "San Salvador El Seco", "", "MX", "484", "21", "", "", "", "19.13326", "-97.64167", "America/Mexico_City"),
("3517832", "San Salvador Atenco", "", "MX", "484", "15", "", "", "", "19.5517", "-98.91867", "America/Mexico_City"),
("3518135", "San Pablo de las Salinas", "", "MX", "484", "15", "", "", "", "19.6667", "-99.09527", "America/Mexico_City"),
("3518138", "San Pablo Autopan", "", "MX", "484", "15", "", "", "", "19.3546", "-99.65694", "America/Mexico_City"),
("3518221", "San Miguel Zinacantepec", "", "MX", "484", "15", "118", "", "", "19.28501", "-99.73478", "America/Mexico_City"),
("3518277", "San Miguel Coatlinchan", "", "MX", "484", "15", "", "", "", "19.44999", "-98.87274", "America/Mexico_City"),
("3518387", "San Mateo Atenco", "", "MX", "484", "15", "", "", "", "19.26919", "-99.53201", "America/Mexico_City"),
("3518407", "San Martin Texmelucan de Labastida", "", "MX", "484", "21", "", "", "", "19.28431", "-98.43884", "America/Mexico_City"),
("3518475", "Teolocholco", "", "MX", "484", "29", "028", "", "", "19.24333", "-98.19083", "America/Mexico_City"),
("3518618", "Teotihuacan de Arista", "", "MX", "484", "17", "", "", "", "19.68782", "-98.86208", "America/Mexico_City"),
("3518692", "San Juan del Rio", "", "MX", "484", "22", "", "", "", "20.3878", "-99.99605", "America/Mexico_City"),
("3518723", "Tuxtepec", "", "MX", "484", "20", "", "", "", "18.08829", "-96.12981", "America/Mexico_City"),
("3519290", "San Francisco Acuautla", "", "MX", "484", "15", "", "", "", "19.34317", "-98.85557", "America/Mexico_City"),
("3519531", "Sanctorum", "", "MX", "484", "21", "041", "", "", "19.09917", "-98.25417", "America/Mexico_City"),
("3519537", "San Cristobal de Las Casas", "", "MX", "484", "05", "", "", "", "16.73788", "-92.63819", "America/Mexico_City"),
("3519907", "San Andres Tuxtla", "", "MX", "484", "30", "", "", "", "18.4487", "-95.21327", "America/Mexico_City"),
("3520064", "Salina Cruz", "Салина-Крус", "MX", "484", "20", "", "", "", "16.18798", "-95.19952", "America/Mexico_City"),
("3520235", "Rio Verde", "", "MX", "484", "24", "", "", "", "21.93032", "-99.99169", "America/Mexico_City"),
("3520271", "Rio Bravo", "Рио-Браво", "MX", "484", "28", "", "", "", "25.98729", "-98.09414", "America/Monterrey"),
("3520274", "Rio Blanco", "Рио-Бланко", "MX", "484", "30", "", "", "", "18.83936", "-97.12829", "America/Mexico_City"),
("3520339", "Reynosa", "Рейноса", "MX", "484", "28", "", "", "", "26.07681", "-98.29748", "America/Matamoros"),
("3520994", "Puerto Escondido", "Пуэрто-Эскондидо", "MX", "484", "20", "318", "", "", "15.87037", "-97.07726", "America/Mexico_City"),
("3521051", "Puente de Ixtla", "", "MX", "484", "17", "", "", "", "18.61472", "-99.31806", "America/Mexico_City"),
("3521081", "Puebla", "", "MX", "484", "21", "", "", "", "19.04334", "-98.20193", "America/Mexico_City"),
("3521103", "Progreso de Alvaro Obregon", "", "MX", "484", "13", "", "", "", "20.24928", "-99.18988", "America/Mexico_City"),
("3521108", "Progreso", "Прогресо", "MX", "484", "31", "", "", "", "21.28953", "-89.6292", "America/Merida"),
("3521168", "Poza Rica de Hidalgo", "", "MX", "484", "30", "", "", "", "20.53315", "-97.45946", "America/Mexico_City"),
("3521305", "Polanco", "", "MX", "484", "09", "", "", "", "19.41667", "-99.2", "America/Mexico_City"),
("3521342", "Playa del Carmen", "Плая-дель-Кармен", "MX", "484", "23", "", "", "", "20.6274", "-87.07987", "America/Cancun"),
("3521476", "Pijijiapan", "", "MX", "484", "05", "", "", "", "15.68618", "-93.20938", "America/Mexico_City"),
("3521596", "Peto", "", "MX", "484", "31", "", "", "", "20.12776", "-88.92282", "America/Merida"),
("3521628", "Perote", "", "MX", "484", "30", "", "", "", "19.5633", "-97.24228", "America/Mexico_City"),
("3521912", "Paraiso", "", "MX", "484", "27", "", "", "", "18.39877", "-93.21314", "America/Mexico_City"),
("3521922", "Papantla de Olarte", "", "MX", "484", "30", "", "", "", "20.44655", "-97.32495", "America/Mexico_City"),
("3521941", "Panuco", "", "MX", "484", "30", "", "", "", "22.05372", "-98.18498", "America/Mexico_City"),
("3522118", "Palmarito Tochapan", "", "MX", "484", "21", "", "", "", "18.89891", "-97.63892", "America/Mexico_City"),
("3522164", "Palenque", "Паленке", "MX", "484", "05", "", "", "", "17.50904", "-91.98334", "America/Mexico_City"),
("3522210", "Pachuca de Soto", "Пачука-де-Сото", "MX", "484", "13", "", "", "", "20.11697", "-98.73329", "America/Mexico_City"),
("3522232", "Ozumba de Alzate", "", "MX", "484", "15", "", "", "", "19.03689", "-98.79516", "America/Mexico_City"),
("3522251", "Oxkutzkab", "", "MX", "484", "31", "", "", "", "20.30734", "-89.41809", "America/Merida"),
("3522307", "Orizaba", "Орисаба", "MX", "484", "30", "", "", "", "18.85101", "-97.10084", "America/Mexico_City"),
("3522343", "Ometepec", "", "MX", "484", "12", "", "", "", "16.68848", "-98.40776", "America/Mexico_City"),
("3522444", "Ocozocuautla", "", "MX", "484", "05", "", "", "", "16.75989", "-93.37317", "America/Mexico_City"),
("3522445", "Ocoyoacac", "", "MX", "484", "15", "", "", "", "19.27127", "-99.45662", "America/Mexico_City"),
("3522484", "Ocosingo", "", "MX", "484", "05", "", "", "", "16.90639", "-92.09374", "America/Mexico_City"),
("3522507", "Oaxaca", "Оахака-де-Хуарес", "MX", "484", "20", "", "", "", "17.07108", "-96.71914", "America/Mexico_City"),
("3522551", "Nuevo Laredo", "Нуэво-Ларедо", "MX", "484", "28", "", "", "", "27.47629", "-99.51639", "America/Matamoros"),
("3522696", "Nogales", "", "MX", "484", "30", "", "", "", "18.83141", "-97.15603", "America/Mexico_City"),
("3522732", "Nicolas Romero", "", "MX", "484", "15", "", "", "", "19.63658", "-99.30682", "America/Mexico_City"),
("3522790", "Naucalpan de Juarez", "Наукальпан-де-Хуарес", "MX", "484", "15", "", "", "", "19.47851", "-99.23963", "America/Mexico_City"),
("3522804", "Naranjos", "", "MX", "484", "30", "", "", "", "21.35087", "-97.68656", "America/Mexico_City"),
("3522845", "Villa Nanchital", "", "MX", "484", "30", "", "", "", "18.07117", "-94.40756", "America/Mexico_City"),
("3522924", "Motul", "", "MX", "484", "31", "", "", "", "21.09571", "-89.28332", "America/Merida"),
("3522926", "Motozintla de Mendoza", "", "MX", "484", "05", "", "", "", "15.36643", "-92.24812", "America/Mexico_City"),
("3523011", "Montemorelos", "", "MX", "484", "19", "", "", "", "25.1891", "-99.82866", "America/Monterrey"),
("3523061", "Santiago Momoxpan", "", "MX", "484", "21", "140", "", "", "19.07361", "-98.26694", "America/Mexico_City"),
("3523127", "Mixquiahuala de Juarez", "", "MX", "484", "13", "", "", "", "20.23031", "-99.21396", "America/Mexico_City"),
("3523141", "Misantla", "", "MX", "484", "30", "", "", "", "19.92992", "-96.85194", "America/Mexico_City"),
("3523149", "Miramar", "", "MX", "484", "28", "", "", "", "22.32085", "-97.8595", "America/Monterrey"),
("3523183", "Minatitlan", "Минатитлан", "MX", "484", "30", "", "", "", "17.99925", "-94.55441", "America/Mexico_City"),
("3523202", "Milpa Alta", "", "MX", "484", "09", "", "", "", "19.19174", "-99.02277", "America/Mexico_City"),
("3523240", "Miahuatlan de Porfirio Diaz", "", "MX", "484", "20", "", "", "", "16.3327", "-96.59558", "America/Mexico_City"),
("3523303", "Metepec", "Метепек", "MX", "484", "15", "", "", "", "19.26169", "-99.59844", "America/Mexico_City"),
("3523349", "Merida", "Мерида", "MX", "484", "31", "", "", "", "20.97537", "-89.61696", "America/Merida"),
("3523450", "Matias Romero", "", "MX", "484", "20", "", "", "", "16.87984", "-95.03908", "America/Mexico_City"),
("3523466", "Heroica Matamoros", "Матаморос", "MX", "484", "28", "022", "", "", "25.87972", "-97.50417", "America/Matamoros"),
("3523513", "Martinez de la Torre", "", "MX", "484", "30", "", "", "", "20.07082", "-97.06078", "America/Mexico_City"),
("3523590", "Mapastepec", "", "MX", "484", "05", "", "", "", "15.44224", "-92.89395", "America/Mexico_City"),
("3523683", "Malinaltepec", "", "MX", "484", "12", "", "", "", "17.05", "-98.66667", "America/Mexico_City"),
("3523760", "Magdalena Contreras", "", "MX", "484", "09", "", "", "", "19.33212", "-99.21118", "America/Mexico_City"),
("3523791", "Macuspana", "", "MX", "484", "27", "", "", "", "17.76152", "-92.5965", "America/Mexico_City"),
("3523900", "Reyes Acozac", "", "MX", "484", "17", "", "", "", "19.7755", "-98.98079", "America/Mexico_City"),
("3523908", "Los Reyes", "", "MX", "484", "15", "", "", "", "19.36356", "-98.97707", "America/Mexico_City"),
("3524348", "Linares", "Линарес", "MX", "484", "19", "", "", "", "24.85908", "-99.56568", "America/Monterrey"),
("3524389", "Lerma de Villada", "", "MX", "484", "15", "", "", "", "19.28986", "-99.51236", "America/Mexico_City"),
("3524391", "Lerdo de Tejada", "", "MX", "484", "30", "", "", "", "18.62936", "-95.51968", "America/Mexico_City"),
("3524744", "Las Margaritas", "", "MX", "484", "05", "", "", "", "16.3119", "-91.98028", "America/Mexico_City"),
("3524903", "Las Choapas", "", "MX", "484", "30", "", "", "", "17.93333", "-94.08333", "America/Mexico_City"),
("3525596", "La Isla", "", "MX", "484", "30", "", "", "", "18.6", "-96.15", "America/Mexico_City"),
("3526323", "Kanasin", "", "MX", "484", "31", "041", "", "", "20.93482", "-89.55871", "America/Merida"),
("3526357", "Juchitan de Zaragoza", "Хучитан-де-Сарагоса", "MX", "484", "20", "", "", "", "16.43603", "-95.01975", "America/Mexico_City"),
("3526467", "Jojutla", "", "MX", "484", "17", "012", "", "", "18.61472", "-99.18028", "America/Mexico_City"),
("3526485", "Jiutepec", "", "MX", "484", "17", "011", "", "", "18.88139", "-99.17778", "America/Mexico_City"),
("3526603", "Jalpa de Mendez", "", "MX", "484", "27", "", "", "", "18.17633", "-93.063", "America/Mexico_City"),
("3526617", "Xalapa de Enriquez", "", "MX", "484", "30", "087", "", "", "19.53124", "-96.91589", "America/Mexico_City"),
("3526657", "Izucar de Matamoros", "", "MX", "484", "21", "", "", "", "18.60151", "-98.46499", "America/Mexico_City"),
("3526674", "San Jeronimo Ixtepec", "", "MX", "484", "20", "", "", "", "16.57855", "-95.10223", "America/Mexico_City"),
("3526681", "Ixtapan de la Sal", "", "MX", "484", "15", "", "", "", "18.84206", "-99.67654", "America/Mexico_City"),
("3526682", "Ixtapaluca", "", "MX", "484", "15", "", "", "", "19.31905", "-98.88432", "America/Mexico_City"),
("3526683", "Iztapalapa", "Истапалапа", "MX", "484", "09", "", "", "", "19.35738", "-99.0671", "America/Mexico_City"),
("3526696", "Ixtac Zoquitlan", "", "MX", "484", "30", "", "", "", "18.85504", "-97.06088", "America/Mexico_City"),
("3526700", "Iztacalco", "", "MX", "484", "09", "006", "", "", "19.39528", "-99.09778", "America/Mexico_City"),
("3526708", "Ixmiquilpan", "", "MX", "484", "13", "", "", "", "20.47841", "-99.21697", "America/Mexico_City"),
("3526798", "Iguala de la Independencia", "Игуала-де-ла-Индепенденсия", "MX", "484", "12", "", "", "", "18.34928", "-99.53936", "America/Mexico_City"),
("3526838", "Hunucma", "", "MX", "484", "31", "", "", "", "21.017", "-89.8759", "America/Merida"),
("3526855", "Huixtla", "", "MX", "484", "05", "", "", "", "15.1391", "-92.4648", "America/Mexico_City"),
("3526864", "Huitzuco de los Figueroa", "", "MX", "484", "12", "", "", "", "18.30668", "-99.33541", "America/Mexico_City"),
("3526908", "Huimanguillo", "", "MX", "484", "27", "", "", "", "17.83386", "-93.39198", "America/Mexico_City"),
("3526952", "Huejutla de Reyes", "Уэхутла-де-Рейес", "MX", "484", "13", "028", "", "", "21.14", "-98.41944", "America/Mexico_City"),
("3526953", "Huejotzingo", "", "MX", "484", "21", "", "", "", "19.15945", "-98.40734", "America/Mexico_City"),
("3526992", "Huauchinango", "", "MX", "484", "21", "", "", "", "20.17376", "-98.05491", "America/Mexico_City"),
("3526993", "Huatusco de Chicuellar", "", "MX", "484", "30", "", "", "", "19.14876", "-96.9676", "America/Mexico_City"),
("3527023", "Ciudad de Huajuapam de Leon", "", "MX", "484", "20", "", "", "", "17.80967", "-97.77643", "America/Mexico_City"),
("3527542", "Frontera Comalapa", "", "MX", "484", "05", "", "", "", "15.65866", "-92.14388", "America/Mexico_City"),
("3527545", "Frontera", "Фронтера", "MX", "484", "27", "", "", "", "18.54326", "-92.6453", "America/Mexico_City"),
("3527596", "Fortin de las Flores", "", "MX", "484", "30", "068", "", "", "18.90806", "-97", "America/Mexico_City"),
("3527639", "Felipe Carrillo Puerto", "", "MX", "484", "23", "", "", "", "19.5775", "-88.04529", "America/Cancun"),
("3527795", "Escarcega", "Эскарсега", "MX", "484", "04", "", "", "", "18.60891", "-90.74544", "America/Merida"),
("3527879", "Emiliano Zapata", "", "MX", "484", "17", "", "", "", "18.83677", "-99.18207", "America/Mexico_City"),
("3527880", "Emiliano Zapata", "Эмилиано Сапата", "MX", "484", "27", "", "", "", "17.74042", "-91.76602", "America/Mexico_City"),
("3528756", "Ciudad Mante", "", "MX", "484", "28", "", "", "", "22.74304", "-98.9739", "America/Monterrey"),
("3529612", "Ecatepec", "", "MX", "484", "15", "", "", "", "19.61725", "-99.06601", "America/Mexico_City"),
("3529886", "Cunduacan", "", "MX", "484", "27", "", "", "", "18.06557", "-93.17302", "America/Mexico_City"),
("3529947", "Cuernavaca", "Куэрнавака", "MX", "484", "17", "007", "", "", "18.9261", "-99.23075", "America/Mexico_City"),
("3529981", "Cuautlancingo", "", "MX", "484", "21", "", "", "", "19.08912", "-98.27137", "America/Mexico_City"),
("3529982", "Cuautla Morelos", "", "MX", "484", "17", "", "", "", "18.80459", "-98.94555", "America/Mexico_City"),
("3529986", "Cuautitlan", "Куаутитлан", "MX", "484", "15", "", "", "", "19.67029", "-99.17865", "America/Mexico_City"),
("3529989", "Cuautepec de Hinojosa", "", "MX", "484", "13", "", "", "", "20.03557", "-98.31015", "America/Mexico_City"),
("3530049", "Cuajimalpa", "", "MX", "484", "09", "", "", "", "19.35993", "-99.29388", "America/Mexico_City"),
("3530103", "San Miguel de Cozumel", "", "MX", "484", "23", "", "", "", "20.501", "-86.94598", "America/Cancun"),
("3530123", "Coyotepec", "", "MX", "484", "17", "", "", "", "19.77722", "-99.21295", "America/Mexico_City"),
("3530139", "Coyoacan", "", "MX", "484", "09", "", "", "", "19.3467", "-99.16174", "America/Mexico_City"),
("3530167", "Cosoleacaque", "", "MX", "484", "30", "", "", "", "17.99794", "-94.63542", "America/Mexico_City"),
("3530177", "Cosamaloapan de Carpio", "", "MX", "484", "30", "", "", "", "18.36759", "-95.79857", "America/Mexico_City"),
("3530240", "Cordoba", "Кордова", "MX", "484", "30", "", "", "", "18.88584", "-96.93125", "America/Mexico_City"),
("3530276", "San Bernardino Contla", "", "MX", "484", "29", "", "", "", "19.32932", "-98.1664", "America/Mexico_City"),
("3530367", "Comitan", "Комитан-де-Домингес", "MX", "484", "05", "", "", "", "16.24471", "-92.13425", "America/Mexico_City"),
("3530385", "Comalcalco", "", "MX", "484", "27", "", "", "", "18.26316", "-93.22397", "America/Mexico_City"),
("3530513", "Coatzintla", "", "MX", "484", "30", "", "", "", "20.48699", "-97.46823", "America/Mexico_City"),
("3530517", "Coatzacoalcos", "Коацакоалькос", "MX", "484", "30", "", "", "", "18.13346", "-94.44242", "America/Mexico_City"),
("3530531", "Coatepec", "", "MX", "484", "30", "", "", "", "19.45229", "-96.96148", "America/Mexico_City"),
("3530569", "Coacalco", "", "MX", "484", "15", "", "", "", "19.63452", "-99.1005", "America/Mexico_City"),
("3530580", "Ciudad Victoria", "Сьюдад-Виктория", "MX", "484", "28", "", "", "", "23.74174", "-99.14599", "America/Monterrey"),
("3530582", "Ciudad Valles", "Сьюдад-Вальес", "MX", "484", "24", "", "", "", "21.98333", "-99.01667", "America/Mexico_City"),
("3530584", "Ciudad Serdan", "", "MX", "484", "21", "", "", "", "18.9894", "-97.44702", "America/Mexico_City"),
("3530587", "Ciudad Sahagun", "", "MX", "484", "13", "", "", "", "19.77558", "-98.57471", "America/Mexico_City"),
("3530589", "Ciudad Nezahualcoyotl", "Несауалькойотль", "MX", "484", "15", "", "", "", "19.40061", "-99.01483", "America/Mexico_City"),
("3530590", "Ciudad Miguel Aleman", "", "MX", "484", "28", "", "", "", "26.35", "-99.1", "America/Monterrey"),
("3530592", "Ciudad Mendoza", "Сьюдад-Мендоса", "MX", "484", "30", "", "", "", "18.80615", "-97.17777", "America/Mexico_City"),
("3530594", "Ciudad Madero", "Сьюдад-Мадеро", "MX", "484", "28", "", "", "", "22.27228", "-97.83623", "America/Monterrey"),
("3530596", "Ciudad Fernandez", "Сьюдад-Фернандес", "MX", "484", "24", "", "", "", "21.94037", "-100.0117", "America/Mexico_City"),
("3530597", "Mexico City", "Мехико", "MX", "484", "09", "", "", "", "19.42847", "-99.12766", "America/Mexico_City"),
("3530599", "Ciudad del Carmen", "Сьюдад-дель-Кармен", "MX", "484", "04", "003", "", "", "18.64592", "-91.82991", "America/Merida"),
("3530617", "Cintalapa de Figueroa", "", "MX", "484", "05", "", "", "", "16.69567", "-93.72352", "America/Mexico_City"),
("3530757", "Cholula", "Чолула", "MX", "484", "21", "", "", "", "19.06406", "-98.30352", "America/Mexico_City"),
("3530870", "Chilpancingo de los Bravos", "", "MX", "484", "12", "", "", "", "17.5506", "-99.50578", "America/Mexico_City"),
("3530886", "Chilapa de Alvarez", "", "MX", "484", "12", "", "", "", "17.59459", "-99.17639", "America/Mexico_City"),
("3530908", "Chignahuapan", "", "MX", "484", "21", "", "", "", "19.83866", "-98.03171", "America/Mexico_City"),
("3530932", "Chiconcuac", "", "MX", "484", "15", "", "", "", "19.55939", "-98.89884", "America/Mexico_City"),
("3530937", "San Vicente Chicoloapan", "", "MX", "484", "15", "", "", "", "19.41686", "-98.90202", "America/Mexico_City"),
("3530978", "Chichen-Itza", "Чичен-Ица", "MX", "484", "31", "", "", "", "20.66667", "-88.56667", "America/Merida"),
("3531007", "Chiautla", "", "MX", "484", "15", "", "", "", "19.54895", "-98.88236", "America/Mexico_City"),
("3531013", "Chiapa de Corzo", "Чьяпа-де-Корсо", "MX", "484", "05", "", "", "", "16.71375", "-92.98804", "America/Mexico_City"),
("3531023", "Chetumal", "Четумаль", "MX", "484", "23", "", "", "", "18.51138", "-88.301", "America/Cancun"),
("3531177", "Champoton", "Чампотон", "MX", "484", "04", "004", "", "", "19.34441", "-90.72576", "America/Merida"),
("3531200", "Chalco de Diaz Covarrubias", "", "MX", "484", "15", "", "", "", "19.26174", "-98.89775", "America/Mexico_City"),
("3531321", "Cerro Azul", "", "MX", "484", "30", "", "", "", "21.192", "-97.74088", "America/Mexico_City"),
("3531416", "Catemaco", "", "MX", "484", "30", "", "", "", "18.42131", "-95.11398", "America/Mexico_City"),
("3531556", "Carlos A. Carrillo", "", "MX", "484", "30", "", "", "", "18.37477", "-95.75444", "America/Mexico_City"),
("3531574", "Cardenas", "Карденас", "MX", "484", "24", "", "", "", "22.00144", "-99.64247", "America/Mexico_City"),
("3531576", "Cardenas", "Карденас", "MX", "484", "27", "", "", "", "17.99647", "-93.37835", "America/Mexico_City"),
("3531598", "Capulhuac", "", "MX", "484", "15", "", "", "", "19.19305", "-99.46512", "America/Mexico_City"),
("3531673", "Cancun", "Канкун", "MX", "484", "23", "", "", "", "21.17429", "-86.84656", "America/Cancun"),
("3531732", "Campeche", "Кампече", "MX", "484", "04", "002", "", "", "19.83803", "-90.5277", "America/Merida"),
("3531784", "Calpulalpan", "Кальпулальпане", "MX", "484", "13", "", "", "", "19.58867", "-98.56972", "America/Mexico_City"),
("3531865", "Cadereyta", "", "MX", "484", "19", "", "", "", "25.58333", "-99.98333", "America/Monterrey"),
("3532254", "Berriozabal", "", "MX", "484", "05", "", "", "", "16.79925", "-93.27249", "America/Mexico_City"),
("3532414", "Banderilla", "", "MX", "484", "30", "", "", "", "19.58893", "-96.93727", "America/Mexico_City"),
("3532497", "Azcapotzalco", "", "MX", "484", "09", "", "", "", "19.48698", "-99.18594", "America/Mexico_City"),
("3532545", "Axochiapan", "", "MX", "484", "17", "", "", "", "18.50307", "-98.75219", "America/Mexico_City"),
("3532592", "Atlixco", "Атликско", "MX", "484", "21", "", "", "", "18.90815", "-98.43613", "America/Mexico_City"),
("3532617", "Atlacomulco", "Атлакомулько", "MX", "484", "15", "", "", "", "19.80038", "-99.87376", "America/Mexico_City"),
("3532624", "Ciudad Lopez Mateos", "Сьюдад-Лопес-Матеус", "MX", "484", "15", "", "", "", "19.58547", "-99.26034", "America/Mexico_City"),
("3532792", "Apizaco", "", "MX", "484", "29", "", "", "", "19.41333", "-98.14358", "America/Mexico_City"),
("3532815", "Apan", "", "MX", "484", "13", "", "", "", "19.71128", "-98.45086", "America/Mexico_City"),
("3532881", "Amozoc de Mota", "", "MX", "484", "21", "015", "", "", "19.04611", "-98.045", "America/Mexico_City"),
("3532899", "Amecameca de Juarez", "", "MX", "484", "15", "", "", "", "19.12384", "-98.76649", "America/Mexico_City"),
("3532964", "Heroica Alvarado", "Альварадо", "MX", "484", "30", "", "", "", "18.77143", "-95.76181", "America/Mexico_City"),
("3532969", "Altotonga", "", "MX", "484", "30", "", "", "", "19.76613", "-97.24514", "America/Mexico_City"),
("3532989", "Altepexi", "", "MX", "484", "21", "", "", "", "18.36886", "-97.29832", "America/Mexico_City"),
("3533005", "Altamira", "Альтамира", "MX", "484", "28", "", "", "", "22.39215", "-97.93867", "America/Monterrey"),
("3533056", "Allende", "", "MX", "484", "30", "", "", "", "18.15514", "-94.39289", "America/Mexico_City"),
("3533107", "Alamo", "", "MX", "484", "30", "", "", "", "20.91063", "-97.67485", "America/Mexico_City"),
("3533126", "Ajalpan", "", "MX", "484", "21", "", "", "", "18.37831", "-97.25766", "America/Mexico_City"),
("3533269", "Agua Dulce", "", "MX", "484", "30", "", "", "", "18.13909", "-94.14527", "America/Mexico_City"),
("3533389", "Actopan", "", "MX", "484", "13", "", "", "", "20.26961", "-98.94377", "America/Mexico_City"),
("3533426", "Acayucan", "", "MX", "484", "30", "", "", "", "17.94885", "-94.91399", "America/Mexico_City"),
("3533433", "Acatzingo de Hidalgo", "", "MX", "484", "21", "", "", "", "18.98036", "-97.78474", "America/Mexico_City"),
("3533440", "Acatlan de Osorio", "", "MX", "484", "21", "", "", "", "18.2025", "-98.04864", "America/Mexico_City"),
("3533462", "Acapulco", "Акапулько", "MX", "484", "12", "", "", "", "16.86336", "-99.8901", "America/Mexico_City"),
("3533486", "Acajete", "", "MX", "484", "21", "", "", "", "19.10412", "-97.95104", "America/Mexico_City"),
("3762770", "San Antonio de la Cal", "", "MX", "484", "20", "107", "", "", "17.02833", "-96.70056", "America/Mexico_City"),
("3792044", "Hidalgo", "", "MX", "484", "19", "", "", "", "25.8569", "-99.61855", "America/Monterrey"),
("3802739", "Rio de Teapa", "", "MX", "484", "27", "", "", "", "17.78282", "-92.90042", "America/Mexico_City"),
("3815324", "Huamantla", "Уамантла", "MX", "484", "29", "", "", "", "19.31491", "-97.92322", "America/Mexico_City"),
("3815392", "Zacatelco", "", "MX", "484", "29", "044", "", "", "19.21583", "-98.23972", "America/Mexico_City"),
("3815415", "Tlaxcala de Xicohtencatl", "Тласкала", "MX", "484", "29", "", "", "", "19.31906", "-98.19982", "America/Mexico_City"),
("3815447", "Papalotla", "", "MX", "484", "29", "041", "", "", "19.16861", "-98.20389", "America/Mexico_City"),
("3815453", "Vicente Guerrero", "", "MX", "484", "29", "", "", "", "19.12516", "-98.16192", "America/Mexico_City"),
("3816721", "Tonala", "Тонала", "MX", "484", "05", "", "", "", "16.0887", "-93.75588", "America/Mexico_City"),
("3816739", "Arriaga", "", "MX", "484", "05", "", "", "", "16.2375", "-93.90184", "America/Mexico_City"),
("3818742", "San Andres Cholula", "", "MX", "484", "21", "", "", "", "19.05", "-98.3", "America/Mexico_City"),
("3824166", "Tampico", "Тампико", "MX", "484", "28", "038", "", "", "22.25528", "-97.86861", "America/Monterrey"),
("3824536", "Alto Lucero", "", "MX", "484", "30", "189", "", "", "20.95361", "-97.44194", "America/Mexico_City"),
("3827254", "San Mateo Otzacatipan", "", "MX", "484", "15", "", "", "", "19.33241", "-99.60349", "America/Mexico_City"),
("3827256", "San Maria Totoltepec", "", "MX", "484", "15", "", "", "", "19.3056", "-99.59399", "America/Mexico_City"),
("3827403", "San Lorenzo Acopilco", "", "MX", "484", "09", "004", "", "", "19.32889", "-99.32556", "America/Mexico_City"),
("3827406", "Benito Juarez", "", "MX", "484", "09", "", "", "", "19.3984", "-99.15766", "America/Mexico_City"),
("3827407", "Venustiano Carranza", "", "MX", "484", "09", "", "", "", "19.44286", "-99.09724", "America/Mexico_City"),
("3827408", "Miguel Hidalgo", "", "MX", "484", "09", "", "", "", "19.43471", "-99.20091", "America/Mexico_City"),
("3827409", "Cuauhtemoc", "", "MX", "484", "09", "", "", "", "19.44506", "-99.14612", "America/Mexico_City"),
("3827414", "Huixquilucan", "", "MX", "484", "15", "", "", "", "19.35985", "-99.35016", "America/Mexico_City"),
("3827586", "Melchor Ocampo", "", "MX", "484", "15", "", "", "", "19.70246", "-99.1438", "America/Mexico_City"),
("3827588", "Huilango", "", "MX", "484", "15", "121", "", "", "19.68056", "-99.25639", "America/Mexico_City"),
("3827596", "Santiago Teyahualco", "", "MX", "484", "15", "", "", "", "19.65791", "-99.1234", "America/Mexico_City"),
("3827598", "Ojo de Agua", "", "MX", "484", "15", "081", "", "", "19.68028", "-99.01", "America/Mexico_City"),
("3827606", "Buenavista", "", "MX", "484", "15", "109", "", "", "19.60833", "-99.16944", "America/Mexico_City"),
("3970972", "Miguel Aleman (La Doce)", "", "MX", "484", "26", "030", "", "", "28.84028", "-111.4775", "America/Hermosillo"),
("3976775", "Leyva Solano", "", "MX", "484", "25", "", "", "", "25.66163", "-108.637", "America/Mazatlan"),
("3976999", "Cihuatlan", "", "MX", "484", "14", "", "", "", "19.2366", "-104.56512", "America/Mexico_City"),
("3979505", "Guadalupe Victoria", "", "MX", "484", "02", "", "", "", "32.28924", "-115.10534", "America/Tijuana"),
("3979673", "Ixtapa-Zihuatanejo", "Сиуатанехо", "MX", "484", "12", "038", "", "", "17.64344", "-101.55212", "America/Mexico_City"),
("3979717", "Zapotlanejo", "", "MX", "484", "14", "", "", "", "20.62248", "-103.06766", "America/Mexico_City"),
("3979727", "Zapotiltic", "", "MX", "484", "14", "", "", "", "19.62749", "-103.41752", "America/Mexico_City"),
("3979770", "Zapopan", "Сапопан", "MX", "484", "14", "120", "", "", "20.72356", "-103.38479", "America/Mexico_City"),
("3979802", "Zamora de Hidalgo", "Самора-де-Идальго", "MX", "484", "16", "", "", "", "19.98912", "-102.28477", "America/Mexico_City"),
("3979822", "Zacoalco de Torres", "", "MX", "484", "14", "", "", "", "20.22816", "-103.5687", "America/Mexico_City"),
("3979844", "Zacatecas", "Сакатекас", "MX", "484", "32", "", "", "", "22.76843", "-102.58141", "America/Mexico_City"),
("3979846", "Zacapu", "Сакапу", "MX", "484", "16", "", "", "", "19.81389", "-101.79042", "America/Mexico_City"),
("3979855", "Yuriria", "", "MX", "484", "11", "", "", "", "20.21081", "-101.13212", "America/Mexico_City"),
("3979856", "Yurecuaro", "", "MX", "484", "16", "106", "", "", "20.33738", "-102.28342", "America/Mexico_City"),
("3980174", "Villagran", "Вильягран", "MX", "484", "11", "", "", "", "20.51499", "-100.9967", "America/Mexico_City"),
("3980180", "Ciudad Frontera", "Вилла-Фронтера", "MX", "484", "07", "", "", "", "26.92814", "-101.45212", "America/Monterrey"),
("3980190", "Garcia", "Вилья-де-Гарсиа", "MX", "484", "19", "", "", "", "25.81147", "-100.5941", "America/Monterrey"),
("3980194", "Ciudad de Villa de Alvarez", "Вилья-де-Альварес", "MX", "484", "08", "010", "", "", "19.26722", "-103.73778", "America/Mexico_City"),
("3980605", "Valle de Santiago", "Валье-де-Сантьяго", "MX", "484", "11", "", "", "", "20.39321", "-101.18917", "America/Mexico_City"),
("3980621", "Valle de Bravo", "Валье-де-Браво", "MX", "484", "15", "", "", "", "19.19387", "-100.13394", "America/Mexico_City"),
("3980760", "Uruapan", "Уруапан", "MX", "484", "16", "102", "", "", "19.41362", "-102.05278", "America/Mexico_City"),
("3980777", "Uriangato", "", "MX", "484", "11", "", "", "", "20.14085", "-101.1825", "America/Mexico_City"),
("3980844", "Tuxpan", "", "MX", "484", "14", "", "", "", "19.55555", "-103.37587", "America/Mexico_City"),
("3981254", "Torreon", "Торреон", "MX", "484", "07", "", "", "", "25.54389", "-103.41898", "America/Monterrey"),
("3981369", "Tonala", "Тонала", "MX", "484", "14", "", "", "", "20.62445", "-103.23423", "America/Mexico_City"),
("3981461", "Tlaquepaque", "Тлакепаке", "MX", "484", "14", "", "", "", "20.6409", "-103.29327", "America/Mexico_City"),
("3981467", "Tlajomulco de Zuniga", "", "MX", "484", "14", "", "", "", "20.47421", "-103.44654", "America/Mexico_City"),
("3981609", "Tijuana", "Тихуана", "MX", "484", "02", "", "", "", "32.5027", "-117.00371", "America/Tijuana"),
("3981791", "Tesistan", "", "MX", "484", "14", "", "", "", "20.80051", "-103.46993", "America/Mexico_City"),
("3981885", "Tequila", "Текила", "MX", "484", "14", "", "", "", "20.88197", "-103.83569", "America/Mexico_City"),
("3981941", "Tepic", "Тепик", "MX", "484", "18", "", "", "", "21.5008", "-104.88936", "America/Mazatlan"),
("3981984", "Tepatitlan de Morelos", "", "MX", "484", "14", "", "", "", "20.81692", "-102.76347", "America/Mexico_City"),
("3982007", "Tepalcatepec", "", "MX", "484", "16", "", "", "", "19.18666", "-102.84926", "America/Mexico_City"),
("3982034", "Teocaltiche", "", "MX", "484", "14", "", "", "", "21.43421", "-102.57449", "America/Mexico_City"),
("3982121", "Tejupilco de Hidalgo", "", "MX", "484", "15", "", "", "", "18.90467", "-100.15301", "America/Mexico_City"),
("3982213", "Tecoman", "Текомане", "MX", "484", "08", "", "", "", "18.91463", "-103.87564", "America/Mexico_City"),
("3982266", "Tecate", "", "MX", "484", "02", "", "", "", "32.56716", "-116.62509", "America/Tijuana"),
("3982545", "Tangancicuaro de Arista", "", "MX", "484", "16", "", "", "", "19.88667", "-102.20514", "America/Mexico_City"),
("3982567", "Tamazula de Gordiano", "", "MX", "484", "14", "", "", "", "19.67754", "-103.25225", "America/Mexico_City"),
("3982616", "Tala", "", "MX", "484", "14", "", "", "", "20.6536", "-103.70092", "America/Mexico_City"),
("3982693", "Tacambaro de Codallos", "", "MX", "484", "16", "", "", "", "19.23514", "-101.45817", "America/Mexico_City"),
("3982887", "Sombrerete", "", "MX", "484", "32", "", "", "", "23.63466", "-103.64244", "America/Mexico_City"),
("3982912", "Soledad Diez Gutierrez", "", "MX", "484", "24", "", "", "", "22.18778", "-100.94192", "America/Mexico_City"),
("3983058", "Silao", "", "MX", "484", "11", "", "", "", "20.94356", "-101.42964", "America/Mexico_City"),
("3983216", "Sayula", "", "MX", "484", "14", "", "", "", "19.88442", "-103.59993", "America/Mexico_City"),
("3983631", "Santiago Papasquiaro", "", "MX", "484", "10", "032", "", "", "25.04389", "-105.41917", "America/Monterrey"),
("3983636", "Santiago Ixcuintla", "", "MX", "484", "18", "", "", "", "21.81102", "-105.20789", "America/Mazatlan"),
("3983671", "Santiago", "Сантьяго", "MX", "484", "19", "", "", "", "25.42533", "-100.15205", "America/Monterrey"),
("3983820", "Santa Rosa Jauregui", "", "MX", "484", "22", "", "", "", "20.74206", "-100.44615", "America/Mexico_City"),
("3984583", "Santa Catarina", "", "MX", "484", "19", "", "", "", "25.67325", "-100.45813", "America/Monterrey"),
("3984680", "Santa Anita", "", "MX", "484", "14", "098", "", "", "20.55056", "-103.44", "America/Mexico_City"),
("3984791", "San Sebastian el Grande", "", "MX", "484", "14", "", "", "", "20.51667", "-103.41667", "America/Mexico_City"),
("3985129", "San Pedro", "", "MX", "484", "07", "", "", "", "25.43333", "-103.21667", "America/Monterrey"),
("3985241", "San Nicolas de los Garza", "", "MX", "484", "19", "046", "", "", "25.74167", "-100.30222", "America/Monterrey"),
("3985323", "San Miguel el Alto", "", "MX", "484", "14", "", "", "", "21.03011", "-102.40414", "America/Mexico_City"),
("3985327", "San Miguel de Papasquiaro", "", "MX", "484", "10", "", "", "", "24.83078", "-105.3364", "America/Monterrey"),
("3985344", "San Miguel de Allende", "Сан-Мигель-де-Альенде", "MX", "484", "11", "003", "", "", "20.91528", "-100.74389", "America/Mexico_City"),
("3985604", "San Luis Rio Colorado", "Сан-Луис-Рио-Колорадо", "MX", "484", "26", "", "", "", "32.45612", "-114.77186", "America/Hermosillo"),
("3985606", "San Luis Potosi", "Сан-Луис-Потоси", "MX", "484", "24", "028", "", "", "22.14993", "-100.9828", "America/Mexico_City"),
("3985620", "San Luis de la Paz", "", "MX", "484", "11", "033", "", "", "21.29861", "-100.51639", "America/Mexico_City"),
("3985621", "San Luis de la Paz", "", "MX", "484", "12", "", "", "", "21.29787", "-100.51676", "America/Mexico_City"),
("3985710", "Cabo San Lucas", "Кабо-Сан-Лукас", "MX", "484", "03", "", "", "", "22.89088", "-109.91238", "America/Mazatlan"),
("3985865", "San Juan de los Lagos", "", "MX", "484", "14", "", "", "", "21.24891", "-102.33184", "America/Mexico_City"),
("3986088", "San Jose Iturbide", "", "MX", "484", "11", "", "", "", "21.00116", "-100.38379", "America/Mexico_City"),
("3986172", "San Jose del Cabo", "Сан-Хосе-дель-Кабо", "MX", "484", "03", "008", "", "", "23.05888", "-109.69771", "America/Mazatlan"),
("3986984", "San Francisco del Rincon", "", "MX", "484", "11", "", "", "", "21.01958", "-101.85695", "America/Mexico_City"),
("3987224", "San Felipe", "", "MX", "484", "02", "", "", "", "31.02468", "-114.83919", "America/Tijuana"),
("3987246", "San Felipe", "", "MX", "484", "11", "", "", "", "21.47777", "-101.21593", "America/Mexico_City"),
("3987500", "San Buenaventura", "", "MX", "484", "07", "", "", "", "27.06193", "-101.54891", "America/Monterrey"),
("3988025", "Nicolas R Casillas", "", "MX", "484", "14", "", "", "", "20.54638", "-103.46622", "America/Mexico_City"),
("3988050", "Salvatierra", "Сальватьерра", "MX", "484", "11", "", "", "", "20.21249", "-100.87923", "America/Mexico_City"),
("3988086", "Saltillo", "Салтилло", "MX", "484", "07", "", "", "", "25.42321", "-101.0053", "America/Monterrey"),
("3988214", "Salamanca", "Саламанка", "MX", "484", "11", "", "", "", "20.57224", "-101.19119", "America/Mexico_City"),
("3988258", "Sahuayo de Morelos", "", "MX", "484", "16", "", "", "", "20.05858", "-102.71575", "America/Mexico_City"),
("3988327", "Sabinas Hidalgo", "", "MX", "484", "19", "", "", "", "26.50358", "-100.18187", "America/Monterrey"),
("3988333", "Ciudad Sabinas", "", "MX", "484", "07", "", "", "", "27.85591", "-101.11738", "America/Monterrey"),
("3988392", "Rosarito", "Росарито", "MX", "484", "02", "", "", "", "32.36044", "-117.04645", "America/Tijuana"),
("3988462", "Romita", "", "MX", "484", "11", "", "", "", "20.87179", "-101.51666", "America/Mexico_City"),
("3988594", "Rio Grande", "", "MX", "484", "32", "", "", "", "23.82647", "-103.03034", "America/Mexico_City"),
("3988651", "Rincon de Romos", "Ринкон-де-Ромос", "MX", "484", "01", "", "", "", "22.22869", "-102.32156", "America/Mexico_City"),
("3991043", "Ramos Arizpe", "Рамос-Ариспе", "MX", "484", "07", "027", "", "", "25.53928", "-100.94742", "America/Monterrey"),
("3991164", "Santiago de Queretaro", "Керетаро", "MX", "484", "22", "014", "", "", "20.58806", "-100.38806", "America/Mexico_City"),
("3991219", "Puruandiro", "", "MX", "484", "16", "", "", "", "20.08695", "-101.51418", "America/Mexico_City"),
("3991328", "Puerto Vallarta", "Пуэрто-Вальярта", "MX", "484", "14", "067", "", "", "20.617", "-105.23018", "America/Mexico_City"),
("3991347", "Puerto Penasco", "Пуэрто-Пеньяско", "MX", "484", "26", "048", "", "", "31.31716", "-113.53799", "America/Hermosillo"),
("3992619", "Piedras Negras", "", "MX", "484", "07", "025", "", "", "28.70007", "-100.52353", "America/Matamoros"),
("3992842", "Petatlan", "Петатлан", "MX", "484", "12", "", "", "", "17.53892", "-101.26685", "America/Mexico_City"),
("3992986", "Penjamo", "", "MX", "484", "11", "", "", "", "20.43222", "-101.7213", "America/Mexico_City"),
("3993179", "Patzcuaro", "Пацкуаро", "MX", "484", "16", "", "", "", "19.51931", "-101.6097", "America/Mexico_City"),
("3993335", "Parras de la Fuente", "Паррас", "MX", "484", "07", "", "", "", "25.44156", "-102.1792", "America/Monterrey"),
("3993457", "Paracho de Verduzco", "", "MX", "484", "16", "", "", "", "19.64654", "-102.04763", "America/Mexico_City"),
("3993893", "Palau", "", "MX", "484", "07", "", "", "", "27.89232", "-101.42319", "America/Monterrey"),
("3994469", "Ojinaga", "", "MX", "484", "06", "", "", "", "29.56689", "-104.54487", "America/Ojinaga"),
("3994489", "Ocotlan", "", "MX", "484", "14", "", "", "", "20.3553", "-102.77358", "America/Mexico_City"),
("3994604", "Nuevo Mexico", "Нуэво-Мексико", "MX", "484", "14", "", "", "", "20.7565", "-103.44297", "America/Mexico_City"),
("3994616", "Nuevo Casas Grandes", "Нуэво-Касас-Грандес", "MX", "484", "06", "050", "", "", "30.41552", "-107.91166", "America/Chihuahua"),
("3994667", "Nueva Rosita", "Нуэва-Росита", "MX", "484", "07", "", "", "", "27.94028", "-101.21812", "America/Monterrey"),
("3994674", "Nueva Italia de Ruiz", "", "MX", "484", "16", "", "", "", "19.02612", "-102.09136", "America/Mexico_City"),
("3994912", "Nochistlan", "", "MX", "484", "32", "", "", "", "21.36545", "-102.84659", "America/Mexico_City"),
("3995017", "Navolato", "", "MX", "484", "25", "", "", "", "24.7661", "-107.70225", "America/Mazatlan"),
("3995019", "Navojoa", "Навохоа", "MX", "484", "26", "", "", "", "27.07015", "-109.44391", "America/Hermosillo"),
("3995050", "Nava", "", "MX", "484", "07", "", "", "", "28.42071", "-100.76565", "America/Monterrey"),
("3995343", "Moroleon", "", "MX", "484", "11", "", "", "", "20.12571", "-101.19208", "America/Mexico_City"),
("3995402", "Morelia", "Морелия", "MX", "484", "16", "", "", "", "19.70078", "-101.18443", "America/Mexico_City"),
("3995465", "Monterrey", "Монтеррей", "MX", "484", "19", "039", "", "", "25.67506", "-100.31846", "America/Monterrey"),
("3995523", "Monclova", "", "MX", "484", "07", "", "", "", "26.90687", "-101.42056", "America/Monterrey"),
("3996069", "Mexicali", "Мехикали", "MX", "484", "02", "002", "", "", "32.62781", "-115.45446", "America/Tijuana"),
("3996234", "Pedro Meoqui", "", "MX", "484", "06", "", "", "", "28.28333", "-105.48333", "America/Chihuahua"),
("3996271", "Melchor Muzquiz", "", "MX", "484", "07", "", "", "", "27.87933", "-101.51615", "America/Monterrey"),
("3996299", "Medina", "", "MX", "484", "11", "020", "", "", "21.14972", "-101.6225", "America/Mexico_City"),
("3996322", "Mazatlan", "Масатлан", "MX", "484", "25", "", "", "", "23.2329", "-106.4062", "America/Mazatlan"),
("3996387", "Matehuala", "Матеуала", "MX", "484", "24", "", "", "", "23.64824", "-100.64334", "America/Mexico_City"),
("3996426", "Matamoros", "Матаморос", "MX", "484", "07", "", "", "", "25.52699", "-103.2285", "America/Monterrey"),
("3996595", "Marfil", "", "MX", "484", "11", "", "", "", "20.99884", "-101.28752", "America/Mexico_City"),
("3996626", "Maravatio", "", "MX", "484", "16", "", "", "", "19.89167", "-100.44229", "America/Mexico_City"),
("3996663", "Manzanillo", "Мансанильо", "MX", "484", "08", "007", "", "", "19.11695", "-104.34214", "America/Mexico_City"),
("3996737", "Rodolfo Sanchez Taboada", "", "MX", "484", "02", "", "", "", "31.72099", "-116.57184", "America/Tijuana"),
("3996893", "Magdalena de Kino", "Магдалена-де-Кино", "MX", "484", "26", "", "", "", "30.62789", "-110.96203", "America/Hermosillo"),
("3996956", "San Pedro Madera", "", "MX", "484", "06", "", "", "", "29.19366", "-108.14684", "America/Chihuahua"),
("3997479", "Los Mochis", "Лос-Мочис", "MX", "484", "25", "", "", "", "25.79535", "-108.99244", "America/Mazatlan"),
("3998291", "Loreto", "", "MX", "484", "32", "", "", "", "22.27248", "-101.98898", "America/Mexico_City"),
("3998655", "Leon", "", "MX", "484", "11", "", "", "", "21.12131", "-101.66801", "America/Mexico_City"),
("3999325", "Las Pintas de Arriba", "", "MX", "484", "14", "", "", "", "20.57376", "-103.32345", "America/Mexico_City"),
("4000821", "La Piedad Cavadas", "", "MX", "484", "16", "", "", "", "20.34763", "-102.02806", "America/Mexico_City"),
("4000900", "La Paz", "Ла-Пас", "MX", "484", "03", "003", "", "", "24.1423", "-110.31274", "America/Mazatlan"),
("4001056", "La Orilla", "", "MX", "484", "16", "052", "", "", "17.99583", "-102.22694", "America/Mexico_City"),
("4002224", "Lagos de Moreno", "", "MX", "484", "14", "053", "", "", "21.3559", "-101.93399", "America/Mexico_City"),
("4003526", "La Barca", "", "MX", "484", "14", "", "", "", "20.29028", "-102.54565", "America/Mexico_City"),
("4003662", "Juventino Rosas", "", "MX", "484", "11", "", "", "", "20.64364", "-100.99239", "America/Mexico_City"),
("4003908", "Jocotepec", "", "MX", "484", "14", "", "", "", "20.28527", "-103.42897", "America/Mexico_City"),
("4003923", "Jiquilpan de Juarez", "", "MX", "484", "16", "", "", "", "19.99419", "-102.71919", "America/Mexico_City"),
("4003938", "Jimenez", "", "MX", "484", "06", "", "", "", "28.33333", "-105.4", "America/Chihuahua"),
("4003995", "Jesus Maria", "", "MX", "484", "01", "005", "", "", "21.96111", "-102.34333", "America/Mexico_City"),
("4004024", "Jerez de Garcia Salinas", "Херес-де-Гарсия-Салинас", "MX", "484", "32", "020", "", "", "22.64862", "-102.99034", "America/Mexico_City"),
("4004092", "Jaral del Progreso", "", "MX", "484", "11", "", "", "", "20.37266", "-101.06361", "America/Mexico_City"),
("4004126", "Jamay", "", "MX", "484", "14", "", "", "", "20.29348", "-102.70754", "America/Mexico_City"),
("4004153", "Jalostotitlan", "Халостотитлан", "MX", "484", "14", "", "", "", "21.16741", "-102.46386", "America/Mexico_City"),
("4004267", "Ixtlan del Rio", "", "MX", "484", "18", "", "", "", "21.03821", "-104.3706", "America/Mazatlan"),
("4004293", "Ixtapa", "", "MX", "484", "14", "", "", "", "20.71623", "-105.20408", "America/Mexico_City"),
("4004330", "Irapuato", "Ирапуато", "MX", "484", "11", "", "", "", "20.6784", "-101.34654", "America/Mexico_City"),
("4004555", "Huetamo de Nunez", "", "MX", "484", "16", "", "", "", "18.63028", "-100.89885", "America/Mexico_City"),
("4004647", "Huatabampo", "Уатабампо", "MX", "484", "26", "", "", "", "26.8261", "-109.6422", "America/Hermosillo"),
("4004867", "Hidalgo del Parral", "", "MX", "484", "06", "", "", "", "26.92961", "-105.6662", "America/Chihuahua"),
("4004885", "Heroica Zitacuaro", "", "MX", "484", "16", "", "", "", "19.43661", "-100.35691", "America/Mexico_City"),
("4004886", "Nogales", "Ногалес", "MX", "484", "26", "", "", "", "31.30862", "-110.94217", "America/Hermosillo"),
("4004887", "Heroica Caborca", "", "MX", "484", "26", "", "", "", "30.72043", "-112.15847", "America/Hermosillo"),
("4004898", "Hermosillo", "Эрмосильо", "MX", "484", "26", "", "", "", "29.1026", "-110.97732", "America/Hermosillo"),
("4005143", "Heroica Guaymas", "Гуаймас", "MX", "484", "26", "", "", "", "27.91928", "-110.89755", "America/Hermosillo"),
("4005219", "Guasave", "", "MX", "484", "25", "", "", "", "25.56745", "-108.46756", "America/Mazatlan"),
("4005270", "Guanajuato", "Гуанахуато", "MX", "484", "11", "", "", "", "21.01858", "-101.2591", "America/Mexico_City"),
("4005297", "Guamuchil", "", "MX", "484", "25", "", "", "", "25.45978", "-108.0753", "America/Mazatlan"),
("4005492", "Guadalupe", "Гвадалупе", "MX", "484", "19", "", "", "", "25.67678", "-100.25646", "America/Monterrey"),
("4005509", "Guadalupe", "Гвадалупе", "MX", "484", "32", "", "", "", "22.75433", "-102.5225", "America/Mexico_City"),
("4005539", "Guadalajara", "Гвадалахара", "MX", "484", "14", "", "", "", "20.66682", "-103.39182", "America/Mexico_City"),
("4005775", "Gomez Palacio", "", "MX", "484", "10", "", "", "", "25.56985", "-103.49588", "America/Monterrey"),
("4005864", "Juan Jose Rios", "", "MX", "484", "25", "", "", "", "25.75694", "-108.8247", "America/Mazatlan"),
("4005867", "General Escobedo", "", "MX", "484", "19", "", "", "", "25.79516", "-100.3146", "America/Monterrey"),
("4005937", "Garza Garcia", "", "MX", "484", "19", "", "", "", "25.65384", "-100.37758", "America/Monterrey"),
("4006163", "Fresnillo de Gonzalez Echeverria", "", "MX", "484", "32", "", "", "", "23.17569", "-102.86942", "America/Mexico_City"),
("4006622", "Escuinapa de Hidalgo", "", "MX", "484", "25", "", "", "", "22.83253", "-105.77539", "America/Mazatlan"),
("4006702", "Ensenada", "Энсенада", "MX", "484", "02", "", "", "", "31.86612", "-116.59972", "America/Tijuana"),
("4006783", "Encarnacion de Diaz", "Энкарнасьон-де-Диас", "MX", "484", "14", "", "", "", "21.52727", "-102.23975", "America/Mexico_City"),
("4006806", "Empalme", "", "MX", "484", "26", "", "", "", "27.9634", "-110.80911", "America/Hermosillo"),
("4007676", "Pueblo Nuevo", "Эль-Сальто", "MX", "484", "10", "", "", "", "23.37927", "-105.38313", "America/Monterrey"),
("4007684", "El Salto", "", "MX", "484", "14", "", "", "", "20.33333", "-104.5", "America/Mexico_City"),
("4008303", "El Pueblito", "", "MX", "484", "22", "006", "", "", "20.53972", "-100.44139", "America/Mexico_City"),
("4009697", "El Grullo", "", "MX", "484", "14", "", "", "", "19.80647", "-104.21707", "America/Mexico_City"),
("4011743", "Victoria de Durango", "Дуранго", "MX", "484", "10", "", "", "", "24.02032", "-104.65756", "America/Monterrey"),
("4012176", "Culiacan", "Кулиакан", "MX", "484", "25", "", "", "", "24.79032", "-107.38782", "America/Mazatlan"),
("4012406", "Cuauhtemoc", "", "MX", "484", "06", "", "", "", "28.40884", "-106.86319", "America/Chihuahua"),
("4012693", "Villa de Costa Rica", "Коста-Рика", "MX", "484", "25", "", "", "", "24.59168", "-107.38836", "America/Mazatlan"),
("4012721", "Cortazar", "Кортасар", "MX", "484", "11", "", "", "", "20.48008", "-100.96067", "America/Mexico_City"),
("4013085", "Compostela", "", "MX", "484", "18", "", "", "", "21.23777", "-104.9001", "America/Mazatlan"),
("4013094", "Comonfort", "Комонфорт", "MX", "484", "11", "", "", "", "20.72154", "-100.76056", "America/Mexico_City"),
("4013516", "Colima", "Колима", "MX", "484", "08", "", "", "", "19.24341", "-103.72767", "America/Mexico_City"),
("4013704", "Ciudad Obregon", "Сьюдад-Обрегон", "MX", "484", "26", "", "", "", "27.48642", "-109.94083", "America/Hermosillo"),
("4013706", "Ciudad Lerdo", "", "MX", "484", "07", "", "", "", "25.53718", "-103.52456", "America/Monterrey"),
("4013708", "Ciudad Juarez", "Сьюдад-Хуарес", "MX", "484", "06", "", "", "", "31.73333", "-106.48333", "America/Ojinaga"),
("4013712", "Ciudad Hidalgo", "Сьюдад-Идальго", "MX", "484", "16", "", "", "", "19.69229", "-100.55739", "America/Mexico_City"),
("4013714", "Ciudad Guzman", "Сьюдад-Гусман", "MX", "484", "14", "", "", "", "19.70466", "-103.4617", "America/Mexico_City"),
("4013720", "Ciudad Delicias", "Делисьяс", "MX", "484", "06", "", "", "", "28.19013", "-105.47012", "America/Chihuahua"),
("4013723", "Ciudad Constitucion", "", "MX", "484", "03", "", "", "", "25.0321", "-111.66256", "America/Mazatlan"),
("4013724", "Ciudad Camargo", "", "MX", "484", "06", "", "", "", "27.67842", "-105.17136", "America/Chihuahua"),
("4013726", "Ciudad Anahuac", "", "MX", "484", "19", "", "", "", "27.24457", "-100.13229", "America/Matamoros"),
("4013727", "Ciudad Altamirano", "Сьюдад-Альтамирано", "MX", "484", "12", "", "", "", "18.3571", "-100.66832", "America/Mexico_City"),
("4013728", "Ciudad Acuna", "", "MX", "484", "07", "", "", "", "29.32322", "-100.95217", "America/Matamoros"),
("4014338", "Chihuahua", "Чиуауа", "MX", "484", "06", "019", "", "", "28.63528", "-106.08889", "America/Chihuahua"),
("4014553", "Chapala", "", "MX", "484", "14", "", "", "", "20.29616", "-103.19123", "America/Mexico_City"),
("4014875", "Celaya", "Селая", "MX", "484", "11", "", "", "", "20.52353", "-100.81566", "America/Mexico_City"),
("4015022", "Castanos", "", "MX", "484", "07", "", "", "", "26.78932", "-101.43211", "America/Monterrey"),
("4015700", "Cananea", "Кананеа", "MX", "484", "26", "", "", "", "30.98699", "-110.29062", "America/Hermosillo"),
("4015938", "Villa Juarez", "", "MX", "484", "25", "", "", "", "24.65869", "-107.54059", "America/Mazatlan"),
("4016086", "Calvillo", "", "MX", "484", "01", "", "", "", "21.84583", "-102.71849", "America/Mexico_City"),
("4016132", "Victor Rosales", "", "MX", "484", "32", "005", "", "", "22.94889", "-102.70222", "America/Mexico_City"),
("4017957", "Autlan de Navarro", "", "MX", "484", "14", "", "", "", "19.77249", "-104.36531", "America/Mexico_City"),
("4017984", "Atoyac de Alvarez", "Атояк-де-Альварес", "MX", "484", "12", "011", "", "", "17.20667", "-100.43306", "America/Mexico_City"),
("4017992", "Atotonilco el Alto", "", "MX", "484", "14", "", "", "", "20.55078", "-102.50942", "America/Mexico_City"),
("4018227", "Armeria", "", "MX", "484", "08", "", "", "", "18.93725", "-103.96531", "America/Mexico_City"),
("4018320", "Arcelia", "", "MX", "484", "12", "", "", "", "18.31788", "-100.28345", "America/Mexico_City"),
("4018348", "Arandas", "", "MX", "484", "14", "", "", "", "20.70519", "-102.34635", "America/Mexico_City"),
("4018390", "Apodaca", "Аподака", "MX", "484", "19", "", "", "", "25.75976", "-100.16287", "America/Monterrey"),
("4018400", "Apatzingan", "", "MX", "484", "16", "006", "", "", "19.08864", "-102.35704", "America/Mexico_City"),
("4018403", "Apaseo el Grande", "Апасео-эль-Гранде", "MX", "484", "11", "", "", "", "20.5448", "-100.6843", "America/Mexico_City"),
("4018404", "Apaseo el Alto", "Апасео-эль-Альто", "MX", "484", "11", "", "", "", "20.45748", "-100.6224", "America/Mexico_City"),
("4018582", "Ameca", "", "MX", "484", "14", "", "", "", "20.54906", "-104.04678", "America/Mexico_City"),
("4018761", "Allende", "", "MX", "484", "07", "", "", "", "28.34124", "-100.85111", "America/Monterrey"),
("4018762", "Allende", "", "MX", "484", "19", "", "", "", "25.27673", "-100.01442", "America/Monterrey"),
("4019233", "Aguascalientes", "Агуаскальентес", "MX", "484", "01", "001", "", "", "21.88234", "-102.28259", "America/Mexico_City"),
("4019260", "Agua Prieta", "", "MX", "484", "26", "", "", "", "31.33071", "-109.54876", "America/Hermosillo"),
("4019819", "Acaponeta", "", "MX", "484", "18", "", "", "", "22.49317", "-105.36267", "America/Mazatlan"),
("4019827", "Acambaro", "Акамбаро", "MX", "484", "11", "", "", "", "20.03024", "-100.72249", "America/Mexico_City"),
("4019869", "Abasolo", "Абасоло", "MX", "484", "11", "", "", "", "20.45001", "-101.53", "America/Mexico_City"),
("4022908", "Anahuac", "", "MX", "484", "19", "005", "", "", "27.24056", "-100.13222", "America/Matamoros"),
("4023117", "Dolores Hidalgo Cuna de la Independencia Nacional", "", "MX", "484", "11", "014", "", "", "21.15611", "-100.9325", "America/Mexico_City"),
("4026075", "Las Guacamayas", "", "MX", "484", "16", "", "", "", "18.02108", "-102.21268", "America/Mexico_City"),
("4026082", "Lazaro Cardenas", "", "MX", "484", "16", "", "", "", "17.98085", "-102.22172", "America/Mexico_City"),
("7280708", "Colonia del Valle", "", "MX", "484", "09", "", "", "", "19.38611", "-99.16204", "America/Mexico_City"),
("7280711", "Colonia Lindavista", "", "MX", "484", "15", "", "", "", "19.49156", "-99.12475", "America/Mexico_City"),
("7280718", "Colonia Nativitas", "", "MX", "484", "09", "", "", "", "19.38119", "-99.13685", "America/Mexico_City"),
("8599061", "Las Delicias", "", "MX", "484", "02", "004", "", "", "32.40889", "-116.94361", "America/Tijuana"),
("8617692", "San Pedro Garza Garcia", "", "MX", "484", "19", "019", "", "", "25.65716", "-100.40268", "America/Monterrey"),
("8858078", "Soledad de Graciano Sanchez", "", "MX", "484", "24", "035", "", "", "22.18306", "-100.94083", "America/Mexico_City"),
("8858079", "Manzanillo", "", "MX", "484", "08", "007", "", "", "19.05222", "-104.31583", "America/Mexico_City"),
("8858082", "Naucalpan de Juarez", "", "MX", "484", "15", "037", "", "", "19.39694", "-99.27667", "America/Mexico_City"),
("8858085", "Hacienda Santa Fe", "", "MX", "484", "14", "097", "", "", "20.51806", "-103.38056", "America/Mexico_City"),
("8858086", "Fuentes del Valle", "", "MX", "484", "15", "109", "", "", "19.6325", "-99.13861", "America/Mexico_City"),
("8858087", "San Salvador Tizatlalli", "", "MX", "484", "15", "054", "", "", "19.26028", "-99.59083", "America/Mexico_City"),
("8858088", "Jardines de la Silla (Jardines)", "", "MX", "484", "19", "031", "", "", "25.62944", "-100.18778", "America/Monterrey"),
("8858089", "San Buenaventura", "", "MX", "484", "15", "039", "", "", "19.3025", "-98.86306", "America/Mexico_City"),
("8858090", "Colonia Santa Teresa", "", "MX", "484", "15", "035", "", "", "19.845", "-99.23333", "America/Mexico_City"),
("8858091", "San Jeronimo Cuatro Vientos", "", "MX", "484", "15", "039", "", "", "19.29306", "-98.84167", "America/Mexico_City"),
("8858092", "San Martin Azcatepec", "", "MX", "484", "15", "081", "", "", "19.68667", "-98.97278", "America/Mexico_City"),
("8858093", "Fraccionamiento Real Palmas", "", "MX", "484", "19", "025", "", "", "25.90417", "-100.15972", "America/Monterrey"),
("8858094", "Porticos de San Antonio", "", "MX", "484", "02", "004", "", "", "32.4425", "-117.03417", "America/Tijuana"),
("8858095", "San Isidro", "", "MX", "484", "15", "070", "", "", "19.33972", "-98.95056", "America/Mexico_City"),
("8858096", "Centro Familiar la Soledad", "", "MX", "484", "11", "020", "", "", "21.135", "-101.74972", "America/Mexico_City"),
("8858097", "San Jose Guadalupe Otzacatipan", "", "MX", "484", "15", "106", "", "", "19.34472", "-99.59194", "America/Mexico_City"),
("8858098", "Las Pintitas", "", "MX", "484", "14", "070", "", "", "20.56444", "-103.30222", "America/Mexico_City"),
("8858099", "Emiliano Zapata", "", "MX", "484", "15", "070", "", "", "19.34361", "-98.97472", "America/Mexico_City"),
("8858100", "San Antonio Tecomitl", "", "MX", "484", "09", "009", "", "", "19.21778", "-98.98806", "America/Mexico_City"),
("8858101", "Licenciado Benito Juarez (Campo Gobierno)", "", "MX", "484", "25", "018", "", "", "24.65667", "-107.545", "America/Mazatlan"),
("8858102", "Teotihuacan de Arista", "", "MX", "484", "15", "092", "", "", "19.68972", "-98.86083", "America/Mexico_City"),
("8858103", "Jesus del Monte", "", "MX", "484", "15", "037", "", "", "19.375", "-99.29444", "America/Mexico_City"),
("8858104", "San Jorge Pueblo Nuevo", "", "MX", "484", "15", "054", "", "", "19.25417", "-99.62778", "America/Mexico_City"),
("8858105", "Manuel Ojinaga", "", "MX", "484", "06", "052", "", "", "29.56444", "-104.41639", "America/Ojinaga"),
("8858106", "Terrazas del Valle", "", "MX", "484", "02", "004", "", "", "32.4875", "-116.82667", "America/Tijuana"),
("8858107", "La Ermita", "", "MX", "484", "11", "020", "", "", "21.15194", "-101.73306", "America/Mexico_City"),
("8858108", "Lomas del Sur", "", "MX", "484", "14", "097", "", "", "20.4925", "-103.4175", "America/Mexico_City"),
("8858109", "Parque Industrial Ciudad Mitras", "", "MX", "484", "19", "018", "", "", "25.78861", "-100.44778", "America/Monterrey"),
("8858110", "Mitras Poniente", "", "MX", "484", "19", "018", "", "", "25.77583", "-100.42583", "America/Monterrey"),
("8858111", "Villa del Prado 2da Seccion", "", "MX", "484", "02", "004", "", "", "32.42389", "-116.97167", "America/Tijuana"),
("8858112", "Tres de Mayo", "", "MX", "484", "17", "008", "", "", "18.86861", "-99.20833", "America/Mexico_City"),
("8858113", "Don Antonio", "", "MX", "484", "13", "069", "", "", "19.87444", "-98.93472", "America/Mexico_City"),
("8858114", "Heroica Ciudad de Tlaxiaco", "", "MX", "484", "20", "397", "", "", "17.26944", "-97.67917", "America/Mexico_City"),
("8858115", "Ciudad de Huitzuco", "", "MX", "484", "12", "034", "", "", "18.30111", "-99.33111", "America/Mexico_City"),
("8858116", "Casa Blanca", "", "MX", "484", "21", "015", "", "", "19.04222", "-98.11889", "America/Mexico_City"),
("8858117", "La Providencia Siglo XXI", "", "MX", "484", "13", "051", "", "", "20.06417", "-98.71722", "America/Mexico_City"),
("8858118", "Ampliacion San Mateo (Colonia Solidaridad)", "", "MX", "484", "15", "109", "", "", "19.61639", "-99.14722", "America/Mexico_City"),
("8858119", "Fraccionamiento Ciudad Olmeca", "", "MX", "484", "30", "039", "", "", "18.15056", "-94.5525", "America/Mexico_City"),
("8858120", "San Rafael Tlanalapan", "", "MX", "484", "21", "132", "", "", "19.29167", "-98.46806", "America/Mexico_City"),
("8858121", "Tecamac de Felipe Villanueva", "", "MX", "484", "15", "081", "", "", "19.71306", "-98.96833", "America/Mexico_City"),
("8858122", "Venceremos", "", "MX", "484", "22", "006", "", "", "20.55083", "-100.39806", "America/Mexico_City"),
("8858123", "Alborada Jaltenco", "", "MX", "484", "15", "044", "", "", "19.66194", "-99.06889", "America/Mexico_City"),
("8858124", "Crucecita", "", "MX", "484", "20", "413", "", "", "15.76889", "-96.135", "America/Mexico_City"),
("1222396", "Kuah", "", "MY", "458", "02", "1222381", "", "", "6.32649", "99.8432", "Asia/Kuala_Lumpur"),
("1732602", "Jerantut", "", "MY", "458", "06", "", "", "", "3.936", "102.3626", "Asia/Kuala_Lumpur"),
("1732663", "Raub", "", "MY", "458", "06", "", "", "", "3.7899", "101.857", "Asia/Kuala_Lumpur"),
("1732687", "Batu Pahat", "", "MY", "458", "01", "", "", "", "1.8548", "102.9325", "Asia/Kuala_Lumpur"),
("1732698", "Parit Raja", "", "MY", "458", "01", "", "", "", "1.8681", "103.1124", "Asia/Kuala_Lumpur"),
("1732706", "Pekan Nenas", "", "MY", "458", "01", "", "", "", "1.51", "103.5141", "Asia/Kuala_Lumpur"),
("1732711", "Pontian Kechil", "", "MY", "458", "01", "", "", "", "1.4866", "103.3896", "Asia/Kuala_Lumpur"),
("1732721", "Kampung Pasir Gudang Baru", "", "MY", "458", "01", "", "", "", "1.4726", "103.878", "Asia/Kuala_Lumpur"),
("1732738", "Kota Tinggi", "", "MY", "458", "01", "", "", "", "1.7381", "103.8999", "Asia/Kuala_Lumpur"),
("1732741", "Taman Senai", "Сенаи", "MY", "458", "01", "", "", "", "1.6006", "103.6419", "Asia/Kuala_Lumpur"),
("1732742", "Kulai", "", "MY", "458", "01", "", "", "", "1.6561", "103.6032", "Asia/Kuala_Lumpur"),
("1732745", "Skudai", "", "MY", "458", "01", "", "", "", "1.53742", "103.65779", "Asia/Kuala_Lumpur"),
("1732752", "Johor Bahru", "Джохор-Бару", "MY", "458", "01", "", "", "", "1.4655", "103.7578", "Asia/Kuala_Lumpur"),
("1732811", "Kluang", "", "MY", "458", "01", "", "", "", "2.0251", "103.3328", "Asia/Kuala_Lumpur"),
("1732814", "Yong Peng", "", "MY", "458", "01", "", "", "", "2.0136", "103.0659", "Asia/Kuala_Lumpur"),
("1732826", "Mersing", "", "MY", "458", "01", "1732827", "", "", "2.4312", "103.8405", "Asia/Kuala_Lumpur"),
("1732846", "Segamat", "", "MY", "458", "01", "", "", "", "2.5148", "102.8158", "Asia/Kuala_Lumpur"),
("1732857", "Tangkak", "", "MY", "458", "01", "", "", "", "2.2673", "102.5453", "Asia/Kuala_Lumpur"),
("1732869", "Muar", "Муар", "MY", "458", "01", "", "", "", "2.0442", "102.5689", "Asia/Kuala_Lumpur"),
("1732871", "Bakri", "Бакри", "MY", "458", "01", "", "", "", "2.0441", "102.6527", "Asia/Kuala_Lumpur"),
("1732877", "Labis", "", "MY", "458", "01", "", "", "", "2.385", "103.021", "Asia/Kuala_Lumpur"),
("1732891", "Kuala Selangor", "Куала-Селангор", "MY", "458", "12", "", "", "", "3.35", "101.25", "Asia/Kuala_Lumpur"),
("1732892", "Batang Berjuntai", "", "MY", "458", "12", "", "", "", "3.38333", "101.41667", "Asia/Kuala_Lumpur"),
("1732893", "Batu Arang", "", "MY", "458", "12", "", "", "", "3.31667", "101.46667", "Asia/Kuala_Lumpur"),
("1732903", "Shah Alam", "Шах-Алам", "MY", "458", "12", "", "", "", "3.08507", "101.53281", "Asia/Kuala_Lumpur"),
("1732905", "Klang", "", "MY", "458", "12", "", "", "", "3.03333", "101.45", "Asia/Kuala_Lumpur"),
("1732945", "Cukai", "", "MY", "458", "13", "", "", "", "4.25", "103.41667", "Asia/Kuala_Lumpur"),
("1733023", "Kuala Lipis", "", "MY", "458", "06", "", "", "", "4.1842", "102.0468", "Asia/Kuala_Lumpur"),
("1733353", "Papar", "", "MY", "458", "16", "", "", "", "5.73333", "115.93333", "Asia/Kuching"),
("1733432", "Kota Kinabalu", "Кота-Кинабалу", "MY", "458", "16", "", "", "", "5.9749", "116.0724", "Asia/Kuching"),
("1733438", "Donggongon", "", "MY", "458", "16", "", "", "", "5.90702", "116.10146", "Asia/Kuching"),
("1733440", "Putatan", "", "MY", "458", "16", "", "", "", "5.9258", "116.06094", "Asia/Kuching"),
("1733449", "Kinarut", "", "MY", "458", "16", "", "", "", "5.8231", "116.0466", "Asia/Kuching"),
("1733502", "Ranau", "", "MY", "458", "16", "", "", "", "5.9538", "116.6641", "Asia/Kuching"),
("1733697", "Semporna", "Семпорна", "MY", "458", "16", "", "", "", "4.48178", "118.61118", "Asia/Kuching"),
("1733782", "Victoria", "Виктория", "MY", "458", "15", "", "", "", "5.27667", "115.24167", "Asia/Kuching"),
("1733874", "Beaufort", "", "MY", "458", "16", "", "", "", "5.3473", "115.7455", "Asia/Kuching"),
("1733953", "Lahad Datu", "", "MY", "458", "16", "", "", "", "5.0268", "118.327", "Asia/Kuching"),
("1734052", "Sandakan", "Сандакан", "MY", "458", "16", "", "", "", "5.8402", "118.1179", "Asia/Kuching"),
("1734098", "Keningau", "", "MY", "458", "16", "", "", "", "5.3378", "116.1602", "Asia/Kuching"),
("1734199", "Tawau", "Тавау", "MY", "458", "16", "", "", "", "4.2498", "117.8871", "Asia/Kuching"),
("1734313", "Paka", "Пак", "MY", "458", "13", "", "", "", "4.6374", "103.4368", "Asia/Kuala_Lumpur"),
("1734316", "Kertih", "", "MY", "458", "13", "", "", "", "4.5141", "103.4483", "Asia/Kuala_Lumpur"),
("1734393", "Kulim", "", "MY", "458", "02", "", "", "", "5.36499", "100.56177", "Asia/Kuala_Lumpur"),
("1734409", "Bagan Serai", "", "MY", "458", "07", "", "", "", "5.0108", "100.54101", "Asia/Kuala_Lumpur"),
("1734439", "Bedong", "", "MY", "458", "02", "", "", "", "5.72744", "100.50876", "Asia/Kuala_Lumpur"),
("1734576", "Simpang Empat", "", "MY", "458", "07", "", "", "", "4.95", "100.63333", "Asia/Kuala_Lumpur"),
("1734586", "Taiping", "Тайпин", "MY", "458", "07", "", "", "", "4.85", "100.73333", "Asia/Kuala_Lumpur"),
("1734599", "Kuala Kangsar", "", "MY", "458", "07", "", "", "", "4.76667", "100.93333", "Asia/Kuala_Lumpur"),
("1734634", "Ipoh", "Ипо", "MY", "458", "07", "", "", "", "4.5841", "101.0829", "Asia/Kuala_Lumpur"),
("1734651", "Gua Musang", "", "MY", "458", "03", "", "", "", "4.8823", "101.9644", "Asia/Kuala_Lumpur"),
("1734705", "Kuala Terengganu", "Куала-Тренгану", "MY", "458", "13", "", "", "", "5.3302", "103.1408", "Asia/Kuala_Lumpur"),
("1734715", "Marang", "Маранг", "MY", "458", "13", "", "", "", "5.2056", "103.2059", "Asia/Kuala_Lumpur"),
("1734738", "Tampin", "", "MY", "458", "05", "", "", "", "2.4701", "102.2302", "Asia/Kuala_Lumpur"),
("1734745", "Alor Gajah", "", "MY", "458", "04", "", "", "", "2.3804", "102.2089", "Asia/Kuala_Lumpur"),
("1734753", "Kampung Ayer Keroh", "", "MY", "458", "04", "", "", "", "2.2654", "102.2801", "Asia/Kuala_Lumpur"),
("1734757", "Sungai Udang", "", "MY", "458", "04", "", "", "", "2.269", "102.1427", "Asia/Kuala_Lumpur"),
("1734759", "Malacca", "Малакка", "MY", "458", "04", "", "", "", "2.196", "102.2405", "Asia/Kuala_Lumpur"),
("1734781", "Banting", "", "MY", "458", "12", "", "", "", "2.8136", "101.50185", "Asia/Kuala_Lumpur"),
("1734793", "Jenjarum", "", "MY", "458", "12", "", "", "", "2.8724", "101.49484", "Asia/Kuala_Lumpur"),
("1734798", "Semenyih", "", "MY", "458", "12", "1735173", "1734798", "", "2.9516", "101.843", "Asia/Kuala_Lumpur"),
("1734810", "Seremban", "Серембан", "MY", "458", "05", "", "", "", "2.7297", "101.9381", "Asia/Kuala_Lumpur"),
("1734815", "Port Dickson", "", "MY", "458", "05", "", "", "", "2.5228", "101.7959", "Asia/Kuala_Lumpur"),
("1734839", "Bahau", "", "MY", "458", "05", "", "", "", "2.8079", "102.4049", "Asia/Kuala_Lumpur"),
("1734841", "Kuala Pilah", "", "MY", "458", "05", "", "", "", "2.7389", "102.2487", "Asia/Kuala_Lumpur"),
("1734971", "Pekan", "Пекан", "MY", "458", "06", "", "", "", "3.4836", "103.3996", "Asia/Kuala_Lumpur"),
("1735018", "Mentekab", "", "MY", "458", "06", "", "", "", "3.4854", "102.3484", "Asia/Kuala_Lumpur"),
("1735022", "Temerluh", "", "MY", "458", "06", "", "", "", "3.4506", "102.4176", "Asia/Kuala_Lumpur"),
("1735076", "Butterworth", "", "MY", "458", "09", "", "", "", "5.3991", "100.36382", "Asia/Kuala_Lumpur"),
("1735077", "Perai", "", "MY", "458", "09", "", "", "", "5.38333", "100.38333", "Asia/Kuala_Lumpur"),
("1735079", "Bukit Mertajam", "", "MY", "458", "09", "", "", "", "5.36301", "100.4667", "Asia/Kuala_Lumpur"),
("1735086", "Nibong Tebal", "", "MY", "458", "09", "", "", "", "5.16586", "100.47793", "Asia/Kuala_Lumpur"),
("1735089", "Parit Buntar", "", "MY", "458", "07", "", "", "", "5.12671", "100.49316", "Asia/Kuala_Lumpur"),
("1735093", "Tasek Glugor", "", "MY", "458", "09", "", "", "", "5.48032", "100.49849", "Asia/Kuala_Lumpur"),
("1735106", "George Town", "Джорджтаун", "MY", "458", "09", "", "", "", "5.41123", "100.33543", "Asia/Kuala_Lumpur"),
("1735148", "Serendah", "", "MY", "458", "12", "", "", "", "3.3646", "101.6041", "Asia/Kuala_Lumpur"),
("1735150", "Rawang", "", "MY", "458", "12", "", "", "", "3.3213", "101.5767", "Asia/Kuala_Lumpur"),
("1735158", "Petaling Jaya", "Петалинг-Джая", "MY", "458", "12", "1735156", "", "", "3.10726", "101.60671", "Asia/Kuala_Lumpur"),
("1735161", "Kuala Lumpur", "Куала-Лумпур", "MY", "458", "14", "", "", "", "3.1412", "101.68653", "Asia/Kuala_Lumpur"),
("1735195", "Sabak Bernam", "", "MY", "458", "12", "", "", "", "3.7698", "100.9879", "Asia/Kuala_Lumpur"),
("1735199", "Sungai Besar", "", "MY", "458", "12", "", "", "", "3.6746", "100.9867", "Asia/Kuala_Lumpur"),
("1735227", "Kuantan", "Куантан", "MY", "458", "06", "", "", "", "3.8077", "103.326", "Asia/Kuala_Lumpur"),
("1735268", "Batu Gajah", "", "MY", "458", "07", "", "", "", "4.46916", "101.04107", "Asia/Kuala_Lumpur"),
("1735274", "Kampar", "", "MY", "458", "07", "", "", "", "4.3", "101.15", "Asia/Kuala_Lumpur"),
("1735282", "Tapah Road", "", "MY", "458", "07", "", "", "", "4.16667", "101.2", "Asia/Kuala_Lumpur"),
("1735287", "Bidur", "", "MY", "458", "07", "", "", "", "4.11667", "101.28333", "Asia/Kuala_Lumpur"),
("1735450", "Lumut", "", "MY", "458", "07", "", "", "", "4.2323", "100.6298", "Asia/Kuala_Lumpur"),
("1735459", "Teluk Intan", "", "MY", "458", "07", "", "", "", "4.0259", "101.0213", "Asia/Kuala_Lumpur"),
("1735485", "Gurun", "", "MY", "458", "02", "", "", "", "5.81717", "100.47381", "Asia/Kuala_Lumpur"),
("1735498", "Sungai Petani", "", "MY", "458", "02", "", "", "", "5.647", "100.48772", "Asia/Kuala_Lumpur"),
("1735506", "Kepala Batas", "", "MY", "458", "09", "", "", "", "5.51707", "100.4265", "Asia/Kuala_Lumpur"),
("1735553", "Tanah Merah", "", "MY", "458", "03", "", "", "", "5.8", "102.15", "Asia/Kuala_Lumpur"),
("1735634", "Kuching", "Кучинг", "MY", "458", "11", "", "", "", "1.55", "110.33333", "Asia/Kuching"),
("1735799", "Simanggang", "", "MY", "458", "11", "", "", "", "1.24722", "111.45278", "Asia/Kuching"),
("1735837", "Sarikei", "", "MY", "458", "11", "", "", "", "2.11667", "111.51667", "Asia/Kuching"),
("1735902", "Sibu", "Сибу", "MY", "458", "11", "", "", "", "2.3", "111.81667", "Asia/Kuching"),
("1736278", "Kangar", "Кангар", "MY", "458", "08", "", "", "", "6.4414", "100.19862", "Asia/Kuala_Lumpur"),
("1736302", "Jitra", "", "MY", "458", "02", "", "", "", "6.26812", "100.42167", "Asia/Kuala_Lumpur"),
("1736305", "Kuala Kedah", "", "MY", "458", "02", "", "", "", "6.1", "100.3", "Asia/Kuala_Lumpur"),
("1736309", "Alor Setar", "Алор-Сетар", "MY", "458", "02", "", "", "", "6.12104", "100.36014", "Asia/Kuala_Lumpur"),
("1736372", "Pasir Mas", "", "MY", "458", "03", "", "", "", "6.04934", "102.13987", "Asia/Kuala_Lumpur"),
("1736376", "Kota Bharu", "Кота-Бару", "MY", "458", "03", "", "", "", "6.13328", "102.2386", "Asia/Kuala_Lumpur"),
("1736458", "Kudat", "", "MY", "458", "16", "", "", "", "6.8837", "116.8477", "Asia/Kuching"),
("1737185", "Kapit", "", "MY", "458", "11", "", "", "", "2.01667", "112.93333", "Asia/Kuching"),
("1737486", "Bintulu", "Бинтулу", "MY", "458", "11", "", "", "", "3.16667", "113.03333", "Asia/Kuching"),
("1737714", "Limbang", "", "MY", "458", "11", "", "", "", "4.75", "115", "Asia/Kuching"),
("1738050", "Miri", "Мири", "MY", "458", "11", "", "", "", "4.4148", "114.0089", "Asia/Kuching"),
("1738294", "Ulu Tiram", "", "MY", "458", "01", "", "", "", "1.6", "103.81667", "Asia/Kuala_Lumpur"),
("1741550", "Tanjung Tokong", "", "MY", "458", "09", "", "", "", "5.46061", "100.30742", "Asia/Kuala_Lumpur"),
("1741562", "Tanjung Sepat", "", "MY", "458", "12", "", "", "", "2.6579", "101.5629", "Asia/Kuala_Lumpur"),
("1750500", "Permatang Kuching", "", "MY", "458", "09", "", "", "", "5.46339", "100.38144", "Asia/Kuala_Lumpur"),
("1750582", "Peringat", "", "MY", "458", "03", "", "", "", "6.03333", "102.28333", "Asia/Kuala_Lumpur"),
("1750974", "Ladang Seri Kundang", "", "MY", "458", "12", "", "", "", "3.2856", "101.519", "Asia/Kuala_Lumpur"),
("1752256", "Pantai Remis", "", "MY", "458", "07", "", "", "", "4.4557", "100.6288", "Asia/Kuala_Lumpur"),
("1759486", "Kuang", "Куанг", "MY", "458", "12", "", "", "", "3.2594", "101.5541", "Asia/Kuala_Lumpur"),
("1761242", "Klebang Besar", "", "MY", "458", "04", "", "", "", "2.2186", "102.1995", "Asia/Kuala_Lumpur"),
("1763412", "Kampung Tanjung Karang", "", "MY", "458", "12", "", "", "", "3.4242", "101.1849", "Asia/Kuala_Lumpur"),
("1764160", "Kampung Sungai Ara", "", "MY", "458", "09", "", "", "", "5.32699", "100.27348", "Asia/Kuala_Lumpur"),
("1764318", "Kampung Simpang Renggam", "", "MY", "458", "01", "", "", "", "1.8278", "103.3", "Asia/Kuala_Lumpur"),
("1766249", "Kampong Pangkal Kalong", "", "MY", "458", "03", "", "", "", "5.91667", "102.21667", "Asia/Kuala_Lumpur"),
("1767021", "Kampong Masjid Tanah", "", "MY", "458", "04", "", "", "", "2.35", "102.11667", "Asia/Kuala_Lumpur"),
("1768664", "Kampong Kadok", "", "MY", "458", "03", "", "", "", "6", "102.25", "Asia/Kuala_Lumpur"),
("1769612", "Kampong Dungun", "", "MY", "458", "07", "", "", "", "3.21667", "101.31667", "Asia/Kuala_Lumpur"),
("1770351", "Kampung Bukit Baharu", "", "MY", "458", "04", "", "", "", "2.2152", "102.2851", "Asia/Kuala_Lumpur"),
("1771023", "Kampung Baru Subang", "", "MY", "458", "12", "", "", "", "3.15", "101.53333", "Asia/Kuala_Lumpur"),
("1771287", "Kampung Baharu Nilai", "", "MY", "458", "05", "", "", "", "2.8033", "101.7972", "Asia/Kuala_Lumpur"),
("1771304", "Kampong Baharu Balakong", "", "MY", "458", "12", "", "", "", "3.03333", "101.75", "Asia/Kuala_Lumpur"),
("1771485", "Kampung Ayer Molek", "", "MY", "458", "04", "", "", "", "2.2139", "102.3278", "Asia/Kuala_Lumpur"),
("1778290", "Bukit Rambai", "", "MY", "458", "04", "", "", "", "2.2594", "102.1838", "Asia/Kuala_Lumpur"),
("1779790", "Bentong Town", "", "MY", "458", "06", "", "", "", "3.51667", "101.9", "Asia/Kuala_Lumpur"),
("1780890", "Batu Berendam", "", "MY", "458", "04", "", "", "", "2.2487", "102.246", "Asia/Kuala_Lumpur"),
("6697380", "Putrajaya", "", "MY", "458", "17", "", "", "", "2.93527", "101.69112", "Asia/Kuala_Lumpur"),
("7302815", "Bandar Labuan", "", "MY", "458", "16", "", "", "", "5.28883", "115.26924", "Asia/Kuching"),
("8504423", "Subang Jaya", "", "MY", "458", "12", "", "", "", "3.04384", "101.58062", "Asia/Kuala_Lumpur"),
("1024552", "Xai-Xai", "Шаи-Шаи", "MZ", "508", "02", "", "", "", "-25.05194", "33.64417", "Africa/Maputo"),
("1024696", "Dondo", "Дондо", "MZ", "508", "05", "", "", "", "-19.60944", "34.74306", "Africa/Maputo"),
("1024701", "Macia", "", "MZ", "508", "02", "", "", "", "-25.02694", "33.09889", "Africa/Maputo"),
("1026014", "Tete", "", "MZ", "508", "08", "", "", "", "-16.15639", "33.58667", "Africa/Maputo"),
("1028079", "Ressano Garcia", "", "MZ", "508", "04", "", "", "", "-25.44278", "31.99528", "Africa/Maputo"),
("1028434", "Quelimane", "Келимане", "MZ", "508", "09", "", "", "", "-17.87861", "36.88833", "Africa/Maputo"),
("1028918", "Pemba", "Пемба", "MZ", "508", "01", "", "", "", "-12.97395", "40.51775", "Africa/Maputo"),
("1033356", "Nampula", "Нампула", "MZ", "508", "06", "", "", "", "-15.11646", "39.2666", "Africa/Maputo"),
("1035025", "Nacala", "Город-де-Накала", "MZ", "508", "06", "", "", "", "-14.56257", "40.68538", "Africa/Maputo"),
("1037125", "Montepuez", "Монтепвезе", "MZ", "508", "01", "", "", "", "-13.12556", "38.99972", "Africa/Maputo"),
("1037370", "Mocimboa", "", "MZ", "508", "01", "", "", "", "-11.31667", "40.35", "Africa/Maputo"),
("1037390", "Ilha de Mocambique", "", "MZ", "508", "06", "", "", "", "-15.03417", "40.73583", "Africa/Maputo"),
("1039536", "Maxixe", "", "MZ", "508", "03", "", "", "", "-23.85972", "35.34722", "Africa/Maputo"),
("1039854", "Matola", "Матола", "MZ", "508", "04", "", "", "", "-25.96222", "32.45889", "Africa/Maputo"),
("1040652", "Maputo", "Мапуту", "MZ", "508", "11", "", "", "", "-25.96553", "32.58322", "Africa/Maputo"),
("1040938", "Manjacaze", "", "MZ", "508", "02", "", "", "", "-24.71167", "33.88278", "Africa/Maputo"),
("1043893", "Lichinga", "", "MZ", "508", "07", "", "", "", "-13.31278", "35.24056", "Africa/Maputo"),
("1045114", "Inhambane", "Иньямбане", "MZ", "508", "03", "", "", "", "-23.865", "35.38333", "Africa/Maputo"),
("1047660", "Cuamba", "", "MZ", "508", "07", "", "", "", "-14.80306", "36.53722", "Africa/Maputo"),
("1048364", "Chokwe", "", "MZ", "508", "02", "", "", "", "-24.53333", "32.98333", "Africa/Maputo"),
("1049261", "Chimoio", "Шимойо", "MZ", "508", "10", "", "", "", "-19.11639", "33.48333", "Africa/Maputo"),
("1049861", "Chibuto", "", "MZ", "508", "02", "", "", "", "-24.68667", "33.53056", "Africa/Maputo"),
("1052373", "Beira", "Бейра", "MZ", "508", "05", "", "", "", "-19.84361", "34.83889", "Africa/Maputo"),
("1052944", "Antonio Enes", "", "MZ", "508", "06", "", "", "", "-16.2325", "39.90861", "Africa/Maputo"),
("1088155", "Mutuali", "", "MZ", "508", "06", "", "", "", "-14.87056", "37.00444", "Africa/Maputo"),
("877178", "Katima Mulilo", "", "NA", "516", "28", "", "", "", "-17.5", "24.26667", "Africa/Windhoek"),
("3352136", "Windhoek", "Виндхук", "NA", "516", "21", "", "", "", "-22.55941", "17.08323", "Africa/Windhoek"),
("3352844", "Swakopmund", "Свакопмунд", "NA", "516", "29", "", "", "", "-22.68333", "14.53333", "Africa/Windhoek"),
("3353383", "Rundu", "Рунду", "NA", "516", "40", "", "", "", "-17.93333", "19.76667", "Africa/Windhoek"),
("3353540", "Rehoboth", "Рехобот", "NA", "516", "30", "", "", "", "-23.31667", "17.08333", "Africa/Windhoek"),
("3353811", "Otjiwarongo", "Отьиваронго", "NA", "516", "39", "", "", "", "-20.46369", "16.64772", "Africa/Windhoek"),
("3354021", "Oshakati", "Ошакати", "NA", "516", "37", "", "", "", "-17.78333", "15.68333", "Africa/Windhoek"),
("3354898", "Okahandja", "", "NA", "516", "39", "", "", "", "-21.98333", "16.91667", "Africa/Windhoek"),
("3355672", "Luderitz", "Людериц", "NA", "516", "31", "", "", "", "-26.64806", "15.15944", "Africa/Windhoek"),
("3356264", "Keetmanshoop", "Китмансхуп", "NA", "516", "31", "", "", "", "-26.58333", "18.13333", "Africa/Windhoek"),
("3357114", "Grootfontein", "", "NA", "516", "39", "", "", "", "-19.56667", "18.11667", "Africa/Windhoek"),
("3357247", "Gobabis", "", "NA", "516", "35", "", "", "", "-22.45", "18.96667", "Africa/Windhoek"),
("3359638", "Walvis Bay", "Уолфиш-Бей", "NA", "516", "29", "", "", "", "-22.9575", "14.50528", "Africa/Windhoek"),
("2437732", "Birni N Konni", "Бирнин-Конни", "NE", "562", "06", "", "", "", "13.79599", "5.25026", "Africa/Niamey"),
("2437798", "Zinder", "Зиндер", "NE", "562", "07", "", "", "", "13.80716", "8.9881", "Africa/Niamey"),
("2438678", "Tillaberi", "", "NE", "562", "09", "", "", "", "14.20711", "1.45418", "Africa/Niamey"),
("2438774", "Tibiri", "", "NE", "562", "04", "", "", "", "13.56271", "7.04848", "Africa/Niamey"),
("2438823", "Tessaoua", "", "NE", "562", "04", "", "", "", "13.75737", "7.9874", "Africa/Niamey"),
("2438855", "Tera", "Тера", "NE", "562", "09", "", "", "", "14.00776", "0.75306", "Africa/Niamey"),
("2439155", "Tanout", "", "NE", "562", "07", "", "", "", "14.97089", "8.88786", "Africa/Niamey"),
("2439376", "Tahoua", "Тахуа", "NE", "562", "06", "", "", "", "14.8888", "5.2692", "Africa/Niamey"),
("2440485", "Niamey", "Ниамей", "NE", "562", "08", "", "", "", "13.51366", "2.1098", "Africa/Niamey"),
("2440495", "Nguigmi", "", "NE", "562", "02", "", "", "", "14.24953", "13.10921", "Africa/Niamey"),
("2440921", "Mirriah", "Мирриа", "NE", "562", "07", "", "", "", "13.70727", "9.15013", "Africa/Niamey"),
("2441194", "Mayahi", "Майахи", "NE", "562", "04", "", "", "", "13.95532", "7.67122", "Africa/Niamey"),
("2441217", "Matamey", "", "NE", "562", "07", "", "", "", "13.42309", "8.47485", "Africa/Niamey"),
("2441291", "Maradi", "Маради", "NE", "562", "04", "", "", "", "13.5", "7.10174", "Africa/Niamey"),
("2441482", "Magaria", "", "NE", "562", "07", "", "", "", "12.99826", "8.90991", "Africa/Niamey"),
("2441530", "Madaoua", "", "NE", "562", "06", "", "", "", "14.073", "5.96", "Africa/Niamey"),
("2443304", "Illela", "", "NE", "562", "06", "", "", "", "14.4605", "5.2437", "Africa/Niamey"),
("2444489", "Gaya", "", "NE", "562", "03", "", "", "", "11.88435", "3.44919", "Africa/Niamey"),
("2445488", "Dosso", "Доссо", "NE", "562", "03", "", "", "", "13.049", "3.1937", "Africa/Niamey"),
("2445553", "Dogondoutchi", "", "NE", "562", "03", "", "", "", "13.63933", "4.02875", "Africa/Niamey"),
("2445704", "Diffa", "Диффа", "NE", "562", "02", "", "", "", "13.31536", "12.61134", "Africa/Niamey"),
("2446267", "Dakoro", "", "NE", "562", "04", "", "", "", "14.51056", "6.765", "Africa/Niamey"),
("2447416", "Ayorou", "", "NE", "562", "09", "", "", "", "14.73075", "0.91738", "Africa/Niamey"),
("2447938", "Alaghsas", "", "NE", "562", "01", "", "", "", "17.0187", "8.0168", "Africa/Niamey"),
("2448085", "Agadez", "Агадес", "NE", "562", "01", "", "", "", "16.97333", "7.99111", "Africa/Niamey"),
("2317548", "Zuru", "", "NG", "566", "40", "", "", "", "11.42406", "5.22879", "Africa/Lagos"),
("2317569", "Zungeru", "", "NG", "566", "31", "", "", "", "9.81278", "6.15583", "Africa/Lagos"),
("2317765", "Zaria", "Заря", "NG", "566", "23", "", "", "", "11.11128", "7.7227", "Africa/Lagos"),
("2318044", "Yola", "Йола", "NG", "566", "35", "", "", "", "9.2", "12.48333", "Africa/Lagos"),
("2318123", "Yenagoa", "", "NG", "566", "52", "", "", "", "4.92472", "6.26417", "Africa/Lagos"),
("2318921", "Wukari", "", "NG", "566", "43", "", "", "", "7.85", "9.78333", "Africa/Lagos"),
("2318933", "Wudil", "", "NG", "566", "29", "", "", "", "11.81067", "8.84505", "Africa/Lagos"),
("2319133", "Warri", "Варри", "NG", "566", "36", "", "", "", "5.51667", "5.75", "Africa/Lagos"),
("2319257", "Wamba", "", "NG", "566", "56", "", "", "", "8.93333", "8.6", "Africa/Lagos"),
("2319480", "Uyo", "", "NG", "566", "21", "", "", "", "5.05127", "7.9335", "Africa/Lagos"),
("2319668", "Uromi", "", "NG", "566", "37", "", "", "", "6.7", "6.33333", "Africa/Lagos"),
("2320576", "Umuahia", "", "NG", "566", "45", "", "", "", "5.52627", "7.48959", "Africa/Lagos"),
("2320829", "Ughelli", "", "NG", "566", "36", "", "", "", "5.48986", "6.00743", "Africa/Lagos"),
("2320831", "Ugep", "", "NG", "566", "22", "", "", "", "5.80854", "8.08159", "Africa/Lagos"),
("2320920", "Uga", "", "NG", "566", "25", "", "", "", "5.93576", "7.0793", "Africa/Lagos"),
("2321031", "Ubiaja", "", "NG", "566", "37", "", "", "", "6.65504", "6.38687", "Africa/Lagos"),
("2322263", "Tegina", "", "NG", "566", "31", "", "", "", "10.0706", "6.1906", "Africa/Lagos"),
("2322495", "Tambawel", "", "NG", "566", "51", "", "", "", "12.40386", "4.64692", "Africa/Lagos"),
("2322529", "Talata Mafara", "", "NG", "566", "57", "", "", "", "12.57317", "6.05971", "Africa/Lagos"),
("2322552", "Takum", "", "NG", "566", "26", "", "", "", "7.26667", "9.98333", "Africa/Lagos"),
("2322794", "Suleja", "Абуджа", "NG", "566", "31", "", "", "", "9.18052", "7.17933", "Africa/Lagos"),
("2322911", "Sokoto", "Сокото", "NG", "566", "51", "", "", "", "13.06092", "5.23902", "Africa/Lagos"),
("2322957", "Soba", "", "NG", "566", "23", "", "", "", "10.98134", "8.05749", "Africa/Lagos"),
("2323390", "Saki", "Саки", "NG", "566", "32", "", "", "", "8.66667", "3.38333", "Africa/Lagos"),
("2323411", "Shagamu", "", "NG", "566", "16", "", "", "", "6.84323", "3.64776", "Africa/Lagos"),
("2323675", "Sapele", "", "NG", "566", "36", "", "", "", "5.89405", "5.67666", "Africa/Lagos"),
("2324504", "Rijau", "", "NG", "566", "31", "", "", "", "11.10298", "5.25068", "Africa/Lagos"),
("2324575", "Rano", "", "NG", "566", "29", "", "", "", "11.54912", "8.57464", "Africa/Lagos"),
("2324767", "Potiskum", "", "NG", "566", "44", "", "", "", "11.71391", "11.08108", "Africa/Lagos"),
("2324774", "Port Harcourt", "Порт-Харкорт", "NG", "566", "50", "", "", "", "4.77742", "7.0134", "Africa/Lagos"),
("2324857", "Pindiga", "", "NG", "566", "55", "", "", "", "9.98333", "10.93333", "Africa/Lagos"),
("2324960", "Pategi", "", "NG", "566", "30", "", "", "", "8.73333", "5.75", "Africa/Lagos"),
("2325060", "Pankshin", "", "NG", "566", "49", "", "", "", "9.33333", "9.45", "Africa/Lagos"),
("2325161", "Ozubulu", "", "NG", "566", "25", "", "", "", "5.95666", "6.84904", "Africa/Lagos"),
("2325200", "Oyo", "Ойо", "NG", "566", "32", "", "", "", "7.85", "3.93333", "Africa/Lagos"),
("2325249", "Oyan", "", "NG", "566", "42", "", "", "", "8.05", "4.76667", "Africa/Lagos"),
("2325314", "Owo", "Ово", "NG", "566", "48", "", "", "", "7.1962", "5.58681", "Africa/Lagos"),
("2325330", "Owerri", "Оверри", "NG", "566", "28", "", "", "", "5.48333", "7.03041", "Africa/Lagos"),
("2325437", "Otukpa", "", "NG", "566", "26", "", "", "", "7.08921", "7.64989", "Africa/Lagos"),
("2325506", "Otan Aiyegbaju", "", "NG", "566", "42", "", "", "", "7.95", "4.8", "Africa/Lagos"),
("2325590", "Osogbo", "", "NG", "566", "42", "", "", "", "7.76667", "4.56667", "Africa/Lagos"),
("2325733", "Orita Eruwa", "", "NG", "566", "32", "", "", "", "7.55", "3.43333", "Africa/Lagos"),
("2326016", "Onitsha", "Онича", "NG", "566", "25", "", "", "", "6.14543", "6.78845", "Africa/Lagos"),
("2326171", "Ondo", "Ондо", "NG", "566", "48", "", "", "", "7.1", "4.83333", "Africa/Lagos"),
("2326302", "Olupona", "", "NG", "566", "42", "", "", "", "7.6", "4.18333", "Africa/Lagos"),
("2326811", "Okuta", "", "NG", "566", "30", "", "", "", "9.21667", "3.18333", "Africa/Lagos"),
("2326899", "Okrika", "", "NG", "566", "50", "", "", "", "4.74159", "7.08488", "Africa/Lagos"),
("2327143", "Okigwi", "", "NG", "566", "28", "", "", "", "5.83523", "7.35989", "Africa/Lagos"),
("2327223", "Oke Mesi", "", "NG", "566", "42", "", "", "", "7.81667", "4.91667", "Africa/Lagos"),
("2327233", "Oke Ila", "", "NG", "566", "54", "", "", "", "7.95", "4.98333", "Africa/Lagos"),
("2327494", "Ohafia-Ifigh", "", "NG", "566", "45", "", "", "", "5.61455", "7.81191", "Africa/Lagos"),
("2327513", "Ogwashi-Uku", "Огваши-Уку", "NG", "566", "36", "", "", "", "6.17818", "6.52429", "Africa/Lagos"),
("2327521", "Oguta", "", "NG", "566", "28", "", "", "", "5.7089", "6.81026", "Africa/Lagos"),
("2327650", "Ogoja", "", "NG", "566", "22", "", "", "", "6.65471", "8.79764", "Africa/Lagos"),
("2327827", "Ogaminan", "", "NG", "566", "41", "", "", "", "7.59464", "6.22476", "Africa/Lagos"),
("2327879", "Offa", "Оффа", "NG", "566", "30", "", "", "", "8.15", "4.71667", "Africa/Lagos"),
("2328090", "Ode", "Ода", "NG", "566", "48", "", "", "", "7.7899", "5.7117", "Africa/Lagos"),
("2328151", "Obudu", "", "NG", "566", "22", "", "", "", "6.66737", "9.17157", "Africa/Lagos"),
("2328185", "Obonoma", "", "NG", "566", "50", "", "", "", "4.71131", "6.79084", "Africa/Lagos"),
("2328617", "Numan", "", "NG", "566", "35", "", "", "", "9.46667", "12.03333", "Africa/Lagos"),
("2328684", "Nsukka", "Нсукка", "NG", "566", "47", "", "", "", "6.85783", "7.39577", "Africa/Lagos"),
("2328765", "Nnewi", "Ннюви", "NG", "566", "25", "", "", "", "6.01986", "6.91478", "Africa/Lagos"),
("2328790", "Nkwerre", "", "NG", "566", "28", "", "", "", "5.75555", "7.10627", "Africa/Lagos"),
("2328811", "Nkpor", "", "NG", "566", "25", "", "", "", "6.15164", "6.84458", "Africa/Lagos"),
("2328952", "Nguru", "", "NG", "566", "44", "", "", "", "12.8791", "10.4526", "Africa/Lagos"),
("2329451", "Nassarawa", "Нассарава", "NG", "566", "56", "", "", "", "8.52944", "7.72417", "Africa/Lagos"),
("2329562", "Nafada", "", "NG", "566", "55", "", "", "", "11.09596", "11.33261", "Africa/Lagos"),
("2329821", "Mubi", "Муби", "NG", "566", "35", "", "", "", "10.26761", "13.26436", "Africa/Lagos"),
("2329920", "Moriki", "", "NG", "566", "57", "", "", "", "12.87405", "6.48754", "Africa/Lagos"),
("2329946", "Monguno", "", "NG", "566", "27", "", "", "", "12.67024", "13.61174", "Africa/Lagos"),
("2329981", "Mokwa", "", "NG", "566", "31", "", "", "", "9.28333", "5.05", "Africa/Lagos"),
("2330028", "Modakeke", "", "NG", "566", "42", "", "", "", "7.38333", "4.26667", "Africa/Lagos"),
("2330100", "Minna", "Минна", "NG", "566", "31", "", "", "", "9.61389", "6.55694", "Africa/Lagos"),
("2330719", "Marte", "", "NG", "566", "27", "", "", "", "12.36532", "13.8293", "Africa/Lagos"),
("2331005", "Malumfashi", "", "NG", "566", "24", "", "", "", "11.78529", "7.62175", "Africa/Lagos"),
("2331140", "Makurdi", "Макурди", "NG", "566", "26", "", "", "", "7.7411", "8.5121", "Africa/Lagos"),
("2331158", "Makoko", "", "NG", "566", "05", "", "", "", "6.49611", "3.38778", "Africa/Lagos"),
("2331447", "Maiduguri", "Майдугури", "NG", "566", "27", "", "", "", "11.84692", "13.15712", "Africa/Lagos"),
("2331528", "Magumeri", "", "NG", "566", "27", "", "", "", "12.1131", "12.8274", "Africa/Lagos"),
("2331939", "Lokoja", "", "NG", "566", "41", "", "", "", "7.80236", "6.743", "Africa/Lagos"),
("2332079", "Lere", "Лера", "NG", "566", "23", "", "", "", "10.38697", "8.57262", "Africa/Lagos"),
("2332249", "Lapai", "", "NG", "566", "31", "", "", "", "9.05", "6.56667", "Africa/Lagos"),
("2332357", "Lalupon", "", "NG", "566", "32", "", "", "", "7.46667", "4.06667", "Africa/Lagos"),
("2332459", "Lagos", "Лагос", "NG", "566", "05", "", "", "", "6.45306", "3.39583", "Africa/Lagos"),
("2332504", "Lafiagi", "", "NG", "566", "30", "", "", "", "8.86667", "5.41667", "Africa/Lagos"),
("2332515", "Lafia", "", "NG", "566", "56", "", "", "", "8.48333", "8.51667", "Africa/Lagos"),
("2332871", "Kwale", "", "NG", "566", "36", "", "", "", "5.70632", "6.43741", "Africa/Lagos"),
("2333451", "Kumo", "", "NG", "566", "55", "", "", "", "10.04469", "11.21217", "Africa/Lagos"),
("2333490", "Kumagunnam", "", "NG", "566", "44", "", "", "", "13.15514", "10.63423", "Africa/Lagos"),
("2333563", "Kukawa", "", "NG", "566", "27", "", "", "", "12.92475", "13.56617", "Africa/Lagos"),
("2333604", "Kuje", "", "NG", "566", "11", "", "", "", "8.89639", "7.24306", "Africa/Lagos"),
("2334008", "Kontagora", "", "NG", "566", "31", "", "", "", "10.39989", "5.46949", "Africa/Lagos"),
("2334306", "Kiyawa", "", "NG", "566", "39", "", "", "", "11.78278", "9.6125", "Africa/Lagos"),
("2334327", "Kishi", "", "NG", "566", "32", "", "", "", "9.08333", "3.85", "Africa/Lagos"),
("2334652", "Keffi", "", "NG", "566", "56", "", "", "", "8.84861", "7.87361", "Africa/Lagos"),
("2334756", "Kaura Namoda", "", "NG", "566", "57", "", "", "", "12.58979", "6.57791", "Africa/Lagos"),
("2334801", "Katsina Ala", "", "NG", "566", "26", "", "", "", "7.16667", "9.28333", "Africa/Lagos"),
("2334802", "Katsina", "Катсина", "NG", "566", "24", "", "", "", "12.98943", "7.60063", "Africa/Lagos"),
("2335015", "Kari", "", "NG", "566", "46", "", "", "", "11.2471", "10.561", "Africa/Lagos"),
("2335204", "Kano", "Кано", "NG", "566", "29", "", "", "", "12.00012", "8.51672", "Africa/Lagos"),
("2335333", "Kamba", "Камба", "NG", "566", "40", "", "", "", "11.84864", "3.65761", "Africa/Lagos"),
("2335596", "Kaiama", "", "NG", "566", "30", "", "", "", "9.6225", "3.94806", "Africa/Lagos"),
("2335614", "Kagoro", "", "NG", "566", "23", "", "", "", "9.6", "8.38333", "Africa/Lagos"),
("2335713", "Kafachan", "", "NG", "566", "23", "", "", "", "9.58333", "8.3", "Africa/Lagos"),
("2335727", "Kaduna", "Кадуна", "NG", "566", "23", "", "", "", "10.52224", "7.43828", "Africa/Lagos"),
("2335798", "Kachia", "", "NG", "566", "23", "", "", "", "9.86667", "7.95", "Africa/Lagos"),
("2335843", "Kabba", "", "NG", "566", "41", "", "", "", "7.82873", "6.0731", "Africa/Lagos"),
("2335953", "Jos", "Йос", "NG", "566", "49", "", "", "", "9.92849", "8.89212", "Africa/Lagos"),
("2336056", "Jimeta", "", "NG", "566", "35", "", "", "", "9.28333", "12.46667", "Africa/Lagos"),
("2336237", "Jega", "", "NG", "566", "40", "", "", "", "12.2175", "4.37917", "Africa/Lagos"),
("2336251", "Jebba", "", "NG", "566", "30", "", "", "", "9.13333", "4.83333", "Africa/Lagos"),
("2336589", "Jalingo", "", "NG", "566", "43", "", "", "", "8.88333", "11.36667", "Africa/Lagos"),
("2336905", "Iwo", "Иво", "NG", "566", "42", "", "", "", "7.63333", "4.18333", "Africa/Lagos"),
("2336985", "Itu", "", "NG", "566", "21", "", "", "", "5.2004", "7.98475", "Africa/Lagos"),
("2337148", "Isieke", "", "NG", "566", "53", "", "", "", "6.37831", "8.03524", "Africa/Lagos"),
("2337207", "Ise-Ekiti", "", "NG", "566", "54", "", "", "", "7.4632", "5.4281", "Africa/Lagos"),
("2337235", "Isanlu Itedoijowa", "", "NG", "566", "41", "", "", "", "8.26667", "5.83333", "Africa/Lagos"),
("2337352", "Ipoti", "", "NG", "566", "54", "", "", "", "7.87377", "5.07692", "Africa/Lagos"),
("2337379", "Iperu", "", "NG", "566", "16", "", "", "", "6.91002", "3.66557", "Africa/Lagos"),
("2337490", "Inisa", "", "NG", "566", "42", "", "", "", "7.85", "4.33333", "Africa/Lagos"),
("2337639", "Ilorin", "", "NG", "566", "30", "", "", "", "8.5", "4.55", "Africa/Lagos"),
("2337659", "Ilobu", "", "NG", "566", "42", "", "", "", "7.83333", "4.48333", "Africa/Lagos"),
("2337680", "Illela", "", "NG", "566", "51", "", "", "", "13.72918", "5.29752", "Africa/Lagos"),
("2337704", "Ilesa", "", "NG", "566", "42", "", "", "", "7.61667", "4.73333", "Africa/Lagos"),
("2337759", "Ilaro", "", "NG", "566", "16", "", "", "", "6.88653", "3.0205", "Africa/Lagos"),
("2337765", "Ila Orangun", "", "NG", "566", "42", "", "", "", "8.01667", "4.9", "Africa/Lagos"),
("2338106", "Ikot-Ekpene", "", "NG", "566", "21", "", "", "", "5.17938", "7.71082", "Africa/Lagos"),
("2338242", "Ikom", "", "NG", "566", "22", "", "", "", "5.96669", "8.70632", "Africa/Lagos"),
("2338269", "Ikirun", "", "NG", "566", "42", "", "", "", "7.91667", "4.66667", "Africa/Lagos"),
("2338273", "Ikire", "", "NG", "566", "42", "", "", "", "7.35", "4.18333", "Africa/Lagos"),
("2338287", "Ikerre", "", "NG", "566", "54", "", "", "", "7.49133", "5.23225", "Africa/Lagos"),
("2338313", "Ikeja", "", "NG", "566", "05", "", "", "", "6.59422", "3.33748", "Africa/Lagos"),
("2338385", "Ijero-Ekiti", "", "NG", "566", "54", "", "", "", "7.8139", "5.0742", "Africa/Lagos"),
("2338400", "Ijebu-Ode", "", "NG", "566", "16", "", "", "", "6.81609", "3.91588", "Africa/Lagos"),
("2338401", "Ijebu Ijesha", "", "NG", "566", "42", "", "", "", "7.68333", "4.81667", "Africa/Lagos"),
("2338403", "Ijebu-Igbo", "", "NG", "566", "16", "", "", "", "6.9798", "4.00329", "Africa/Lagos"),
("2338497", "Ihiala", "", "NG", "566", "25", "", "", "", "5.85377", "6.86026", "Africa/Lagos"),
("2338630", "Igede-Ekiti", "", "NG", "566", "54", "", "", "", "7.66676", "5.13205", "Africa/Lagos"),
("2338640", "Igbo-Ukwu", "", "NG", "566", "25", "", "", "", "6.01798", "7.02027", "Africa/Lagos"),
("2338660", "Igbor", "", "NG", "566", "26", "", "", "", "7.4527", "8.6098", "Africa/Lagos"),
("2338669", "Igbo Ora", "", "NG", "566", "32", "", "", "", "7.43333", "3.28333", "Africa/Lagos"),
("2338711", "Igboho", "", "NG", "566", "32", "", "", "", "8.83333", "3.75", "Africa/Lagos"),
("2338772", "Igbeti", "", "NG", "566", "32", "", "", "", "8.75", "4.13333", "Africa/Lagos"),
("2338810", "Igbara-Odo", "", "NG", "566", "54", "", "", "", "7.50251", "5.06258", "Africa/Lagos"),
("2338876", "Ifo", "", "NG", "566", "16", "", "", "", "6.81437", "3.19575", "Africa/Lagos"),
("2339150", "Idanre", "", "NG", "566", "48", "", "", "", "7.1127", "5.1159", "Africa/Lagos"),
("2339156", "Idah", "", "NG", "566", "41", "", "", "", "7.10651", "6.73415", "Africa/Lagos"),
("2339287", "Ibi", "", "NG", "566", "43", "", "", "", "8.18333", "9.75", "Africa/Lagos"),
("2339293", "Ibeto", "", "NG", "566", "31", "", "", "", "10.48536", "5.14502", "Africa/Lagos"),
("2339354", "Ibadan", "Ибадан", "NG", "566", "32", "", "", "", "7.38778", "3.89639", "Africa/Lagos"),
("2339631", "Hadejia", "", "NG", "566", "39", "", "", "", "12.4498", "10.0444", "Africa/Lagos"),
("2339665", "Gwoza", "", "NG", "566", "27", "", "", "", "11.08243", "13.69745", "Africa/Lagos"),
("2339756", "Gwarzo", "", "NG", "566", "29", "", "", "", "11.91521", "7.9346", "Africa/Lagos"),
("2339786", "Gwaram", "", "NG", "566", "39", "", "", "", "11.27639", "9.88583", "Africa/Lagos"),
("2339892", "Gwadabawa", "", "NG", "566", "51", "", "", "", "13.35612", "5.23664", "Africa/Lagos"),
("2339937", "Gusau", "Гусау", "NG", "566", "57", "", "", "", "12.16278", "6.66135", "Africa/Lagos"),
("2340086", "Gummi", "Кунми", "NG", "566", "57", "", "", "", "12.14358", "5.10809", "Africa/Lagos"),
("2340091", "Gumel", "", "NG", "566", "39", "", "", "", "12.62791", "9.39119", "Africa/Lagos"),
("2340446", "Little Gombi", "", "NG", "566", "35", "", "", "", "10.16138", "12.7399", "Africa/Lagos"),
("2340451", "Gombe", "", "NG", "566", "55", "", "", "", "10.28969", "11.16729", "Africa/Lagos"),
("2341275", "Gembu", "", "NG", "566", "43", "", "", "", "6.7", "11.26667", "Africa/Lagos"),
("2341294", "Geidam", "", "NG", "566", "44", "", "", "", "12.897", "11.9304", "Africa/Lagos"),
("2341355", "Gbongan", "", "NG", "566", "42", "", "", "", "7.46667", "4.35", "Africa/Lagos"),
("2341580", "Gaya", "", "NG", "566", "29", "", "", "", "11.86136", "8.99714", "Africa/Lagos"),
("2341656", "Gashua", "", "NG", "566", "44", "", "", "", "12.871", "11.0482", "Africa/Lagos"),
("2341758", "Garko", "", "NG", "566", "55", "", "", "", "10.17506", "11.16458", "Africa/Lagos"),
("2341955", "Ganye", "", "NG", "566", "35", "", "", "", "8.43333", "12.06667", "Africa/Lagos"),
("2342192", "Gambaru", "", "NG", "566", "27", "", "", "", "12.37066", "14.21731", "Africa/Lagos"),
("2342490", "Funtua", "", "NG", "566", "24", "", "", "", "11.52325", "7.30813", "Africa/Lagos"),
("2342628", "Fiditi", "", "NG", "566", "32", "", "", "", "7.71361", "3.91722", "Africa/Lagos"),
("2342883", "Ezza Ohu", "", "NG", "566", "53", "", "", "", "6.4373", "8.0862", "Africa/Lagos"),
("2343093", "Esuk Oron", "", "NG", "566", "21", "", "", "", "4.80293", "8.25341", "Africa/Lagos"),
("2343252", "Epe", "Эпе", "NG", "566", "05", "", "", "", "6.58412", "3.98336", "Africa/Lagos"),
("2343270", "Enugu-Ukwu", "", "NG", "566", "25", "", "", "", "6.17146", "7.00525", "Africa/Lagos"),
("2343273", "Enugu-Ezike", "", "NG", "566", "47", "", "", "", "6.9827", "7.45534", "Africa/Lagos"),
("2343279", "Enugu", "Энугу", "NG", "566", "47", "", "", "", "6.44258", "7.5022", "Africa/Lagos"),
("2343299", "Emure-Ekiti", "", "NG", "566", "54", "", "", "", "7.43614", "5.45932", "Africa/Lagos"),
("2343512", "Elele", "", "NG", "566", "50", "", "", "", "5.1009", "6.81411", "Africa/Lagos"),
("2343641", "Ekpoma", "", "NG", "566", "37", "", "", "", "6.74206", "6.139", "Africa/Lagos"),
("2343720", "Eket", "", "NG", "566", "21", "", "", "", "4.64122", "7.92092", "Africa/Lagos"),
("2343784", "Ejigbo", "", "NG", "566", "42", "", "", "", "7.9", "4.31667", "Africa/Lagos"),
("2343822", "Eha Amufu", "", "NG", "566", "47", "", "", "", "6.65915", "7.75961", "Africa/Lagos"),
("2343943", "Egbe", "", "NG", "566", "41", "", "", "", "8.21667", "5.51667", "Africa/Lagos"),
("2343983", "Effon Alaiye", "", "NG", "566", "42", "", "", "", "7.65", "4.91667", "Africa/Lagos"),
("2343985", "Effium", "", "NG", "566", "53", "", "", "", "6.62917", "8.05925", "Africa/Lagos"),
("2344082", "Ebute Ikorodu", "", "NG", "566", "05", "", "", "", "6.60086", "3.48818", "Africa/Lagos"),
("2344229", "Dutsen Wai", "", "NG", "566", "23", "", "", "", "10.85009", "8.199", "Africa/Lagos"),
("2344245", "Dutse", "", "NG", "566", "39", "", "", "", "11.7594", "9.33921", "Africa/Lagos"),
("2344418", "Dukku", "", "NG", "566", "55", "", "", "", "10.82306", "10.77167", "Africa/Lagos"),
("2344600", "Doma", "", "NG", "566", "56", "", "", "", "8.38333", "8.35", "Africa/Lagos"),
("2344854", "Dikwa", "", "NG", "566", "27", "", "", "", "12.03609", "13.91815", "Africa/Lagos"),
("2345029", "Deba Habe", "", "NG", "566", "55", "", "", "", "10.20864", "11.38586", "Africa/Lagos"),
("2345094", "Daura", "Даура", "NG", "566", "24", "", "", "", "13.03594", "8.31631", "Africa/Lagos"),
("2345096", "Daura", "", "NG", "566", "44", "", "", "", "11.5541", "11.406", "Africa/Lagos"),
("2345152", "Darazo", "", "NG", "566", "46", "", "", "", "10.99375", "10.41179", "Africa/Lagos"),
("2345498", "Damboa", "", "NG", "566", "27", "", "", "", "11.1554", "12.75551", "Africa/Lagos"),
("2345521", "Damaturu", "", "NG", "566", "44", "", "", "", "11.74697", "11.96083", "Africa/Lagos"),
("2346229", "Calabar", "Калабар", "NG", "566", "22", "", "", "", "4.9517", "8.322", "Africa/Lagos"),
("2346317", "Burutu", "", "NG", "566", "36", "", "", "", "5.35091", "5.50758", "Africa/Lagos"),
("2346561", "Bukuru", "", "NG", "566", "49", "", "", "", "9.79399", "8.86397", "Africa/Lagos"),
("2346615", "Buguma", "", "NG", "566", "50", "", "", "", "4.73614", "6.86236", "Africa/Lagos"),
("2346812", "Bonny", "", "NG", "566", "50", "", "", "", "4.4522", "7.16808", "Africa/Lagos"),
("2346951", "Bode Sadu", "", "NG", "566", "30", "", "", "", "8.93333", "4.78333", "Africa/Lagos"),
("2346995", "Biu", "", "NG", "566", "27", "", "", "", "10.61285", "12.19458", "Africa/Lagos"),
("2347057", "Birnin Kudu", "", "NG", "566", "39", "", "", "", "11.44588", "9.4984", "Africa/Lagos"),
("2347059", "Birnin Kebbi", "", "NG", "566", "40", "", "", "", "12.45389", "4.1975", "Africa/Lagos"),
("2347061", "Sofo-Birnin-Gwari", "", "NG", "566", "23", "", "", "", "11.01537", "6.78036", "Africa/Lagos"),
("2347155", "Biliri", "", "NG", "566", "55", "", "", "", "9.86472", "11.22528", "Africa/Lagos"),
("2347209", "Bida", "Бида", "NG", "566", "31", "", "", "", "9.08333", "6.01667", "Africa/Lagos"),
("2347283", "Benin City", "Бенин-Сити", "NG", "566", "37", "", "", "", "6.33504", "5.62749", "Africa/Lagos"),
("2347303", "Bende", "", "NG", "566", "45", "", "", "", "5.55718", "7.63676", "Africa/Lagos"),
("2347330", "Beli", "", "NG", "566", "43", "", "", "", "7.85868", "10.97187", "Africa/Lagos"),
("2347470", "Bauchi", "Баучи", "NG", "566", "46", "", "", "", "10.31344", "9.84327", "Africa/Lagos"),
("2347592", "Baro", "Баро", "NG", "566", "31", "", "", "", "8.6", "6.41667", "Africa/Lagos"),
("2347954", "Bama", "", "NG", "566", "27", "", "", "", "11.52147", "13.68826", "Africa/Lagos"),
("2348395", "Badagry", "", "NG", "566", "05", "", "", "", "6.41667", "2.88333", "Africa/Lagos"),
("2348507", "Babana", "", "NG", "566", "31", "", "", "", "10.42949", "3.81495", "Africa/Lagos"),
("2348595", "Azare", "", "NG", "566", "46", "", "", "", "11.6765", "10.1948", "Africa/Lagos"),
("2348773", "Awka", "", "NG", "566", "25", "", "", "", "6.21253", "7.07231", "Africa/Lagos"),
("2348783", "Awgu", "", "NG", "566", "47", "", "", "", "6.07278", "7.47739", "Africa/Lagos"),
("2348892", "Auchi", "", "NG", "566", "37", "", "", "", "7.06667", "6.26667", "Africa/Lagos"),
("2349276", "Asaba", "Асаба", "NG", "566", "36", "", "", "", "6.19824", "6.73187", "Africa/Lagos"),
("2349431", "Argungu", "", "NG", "566", "40", "", "", "", "12.74334", "4.52687", "Africa/Lagos"),
("2349529", "Araomoko Ekiti", "", "NG", "566", "54", "", "", "", "7.70927", "5.04474", "Africa/Lagos"),
("2349558", "Apomu", "", "NG", "566", "42", "", "", "", "7.33333", "4.18333", "Africa/Lagos"),
("2349951", "Anchau", "", "NG", "566", "23", "", "", "", "10.95967", "8.39155", "Africa/Lagos"),
("2350249", "Amaigbo", "", "NG", "566", "45", "", "", "", "5.78917", "7.83829", "Africa/Lagos"),
("2350806", "Akwanga", "", "NG", "566", "56", "", "", "", "8.91667", "8.38333", "Africa/Lagos"),
("2350841", "Akure", "", "NG", "566", "48", "", "", "", "7.25256", "5.19312", "Africa/Lagos"),
("2350886", "Aku", "", "NG", "566", "47", "", "", "", "6.70902", "7.31826", "Africa/Lagos"),
("2351470", "Ajaokuta", "", "NG", "566", "41", "", "", "", "7.56229", "6.65497", "Africa/Lagos"),
("2351740", "Agulu", "", "NG", "566", "25", "", "", "", "6.10045", "7.061", "Africa/Lagos"),
("2351979", "Agbor", "Агбор", "NG", "566", "36", "", "", "", "6.25183", "6.19337", "Africa/Lagos"),
("2352250", "Afikpo", "", "NG", "566", "53", "", "", "", "5.89312", "7.93735", "Africa/Lagos"),
("2352356", "Ado Odo", "", "NG", "566", "16", "", "", "", "6.6", "2.93333", "Africa/Lagos"),
("2352379", "Ado-Ekiti", "", "NG", "566", "54", "", "", "", "7.621", "5.2215", "Africa/Lagos"),
("2352778", "Abuja", "Абуджа", "NG", "566", "11", "", "", "", "9.05785", "7.49508", "Africa/Lagos"),
("2352947", "Abeokuta", "Абеокута", "NG", "566", "16", "", "", "", "7.15", "3.35", "Africa/Lagos"),
("2353099", "Abakaliki", "", "NG", "566", "53", "", "", "", "6.31625", "8.11691", "Africa/Lagos"),
("2353151", "Aba", "Аба", "NG", "566", "45", "", "", "", "5.10658", "7.36667", "Africa/Lagos"),
("2591159", "Degema Hulk", "", "NG", "566", "50", "", "", "", "4.76145", "6.74957", "Africa/Lagos"),
("2743477", "Zwolle", "Зволле", "NL", "528", "15", "0193", "", "", "52.5125", "6.09444", "Europe/Amsterdam"),
("2743493", "Zwijndrecht", "Звейндрехте", "NL", "528", "11", "0642", "", "", "51.8175", "4.63333", "Europe/Amsterdam"),
("2743608", "Zutphen", "Зютфен", "NL", "528", "03", "0301", "", "", "52.13833", "6.20139", "Europe/Amsterdam"),
("2743619", "Zundert", "Зюндерт", "NL", "528", "06", "0879", "", "", "51.47167", "4.65556", "Europe/Amsterdam"),
("2743856", "Zoetermeer", "", "NL", "528", "11", "0637", "", "", "52.0575", "4.49306", "Europe/Amsterdam"),
("2743949", "Zevenaar", "Зевенар", "NL", "528", "03", "0299", "", "", "51.93", "6.07083", "Europe/Amsterdam"),
("2743977", "Zeist", "Зейст", "NL", "528", "09", "0355", "", "", "52.09", "5.23333", "Europe/Amsterdam"),
("2743997", "Zeewolde", "", "NL", "528", "16", "0050", "", "", "52.33", "5.54167", "Europe/Amsterdam"),
("2744042", "Zandvoort", "Зандвоорт", "NL", "528", "07", "0473", "", "", "52.37487", "4.53409", "Europe/Amsterdam"),
("2744102", "Zaltbommel", "", "NL", "528", "03", "0297", "", "", "51.81", "5.24444", "Europe/Amsterdam"),
("2744114", "Zaanstad", "", "NL", "528", "07", "0479", "", "", "52.45313", "4.81356", "Europe/Amsterdam"),
("2744118", "Zaandam", "Заандам", "NL", "528", "07", "0479", "", "", "52.43854", "4.82643", "Europe/Amsterdam"),
("2744194", "Wolvega", "Вольвега", "NL", "528", "02", "0098", "", "", "52.87545", "5.99691", "Europe/Amsterdam"),
("2744248", "Woerden", "Верден", "NL", "528", "09", "0632", "", "", "52.085", "4.88333", "Europe/Amsterdam"),
("2744257", "Woensdrecht", "Вонсдрехт", "NL", "528", "06", "0873", "", "", "51.42897", "4.30355", "Europe/Amsterdam"),
("2744324", "Wisch", "", "NL", "528", "03", "1509", "", "", "51.92648", "6.41705", "Europe/Amsterdam"),
("2744332", "Winterswijk", "Винтерсвейк", "NL", "528", "03", "0294", "", "", "51.9725", "6.71944", "Europe/Amsterdam"),
("2744344", "Winschoten", "Винсхотен", "NL", "528", "04", "1895", "", "", "53.14417", "7.03472", "Europe/Amsterdam"),
("2744483", "Wijk bij Duurstede", "", "NL", "528", "09", "0352", "", "", "51.97417", "5.34167", "Europe/Amsterdam"),
("2744514", "Wijchen", "Вийчен", "NL", "528", "03", "0296", "", "", "51.80917", "5.725", "Europe/Amsterdam"),
("2744549", "Wierden", "Виерден", "NL", "528", "15", "0189", "", "", "52.35917", "6.59306", "Europe/Amsterdam"),
("2744675", "Westervoort", "", "NL", "528", "03", "0293", "", "", "51.95583", "5.97222", "Europe/Amsterdam"),
("2744827", "Werkendam", "Веркендам", "NL", "528", "06", "0870", "", "", "51.81", "4.89444", "Europe/Amsterdam"),
("2744904", "Weesp", "Весп", "NL", "528", "07", "0457", "", "", "52.3075", "5.04167", "Europe/Amsterdam"),
("2744911", "Weert", "Верт", "NL", "528", "05", "0988", "", "", "51.25167", "5.70694", "Europe/Amsterdam"),
("2744991", "Wassenaar", "", "NL", "528", "11", "0629", "", "", "52.14583", "4.40278", "Europe/Amsterdam"),
("2745088", "Wageningen", "Вагенинген", "NL", "528", "03", "0289", "", "", "51.97", "5.66667", "Europe/Amsterdam"),
("2745096", "Waddinxveen", "", "NL", "528", "11", "0627", "", "", "52.045", "4.65139", "Europe/Amsterdam"),
("2745123", "Waalwijk", "", "NL", "528", "06", "0867", "", "", "51.6825", "5.07083", "Europe/Amsterdam"),
("2745127", "Waalre", "", "NL", "528", "06", "0866", "", "", "51.38667", "5.44444", "Europe/Amsterdam"),
("2745154", "Vught", "", "NL", "528", "06", "0865", "", "", "51.65333", "5.2875", "Europe/Amsterdam"),
("2745297", "Voorst", "Воорст", "NL", "528", "03", "0285", "", "", "52.17", "6.14167", "Europe/Amsterdam"),
("2745301", "Voorschoten", "", "NL", "528", "11", "0626", "", "", "52.1275", "4.44861", "Europe/Amsterdam"),
("2745311", "Voorhout", "", "NL", "528", "11", "1525", "", "", "52.22167", "4.48472", "Europe/Amsterdam"),
("2745321", "Voorburg", "Воорбург", "NL", "528", "11", "1916", "", "", "52.07417", "4.35972", "Europe/Amsterdam"),
("2745340", "Volendam", "Волендам", "NL", "528", "07", "0385", "", "", "52.495", "5.07083", "Europe/Amsterdam"),
("2745392", "Vlissingen", "Влиссинген", "NL", "528", "10", "0718", "", "", "51.4425", "3.57361", "Europe/Amsterdam"),
("2745461", "Vlagtwedde", "", "NL", "528", "04", "0048", "", "", "53.0275", "7.10833", "Europe/Amsterdam"),
("2745467", "Vlaardingen", "", "NL", "528", "11", "0622", "", "", "51.9125", "4.34167", "Europe/Amsterdam"),
("2745580", "Vianen", "", "NL", "528", "09", "0620", "", "", "51.9925", "5.09167", "Europe/Amsterdam"),
("2745634", "Venray", "", "NL", "528", "05", "0984", "", "", "51.525", "5.975", "Europe/Amsterdam"),
("2745641", "Venlo", "Венло", "NL", "528", "05", "0983", "", "", "51.37", "6.16806", "Europe/Amsterdam"),
("2745673", "Velsen-Zuid", "", "NL", "528", "07", "0453", "", "", "52.46", "4.65", "Europe/Amsterdam"),
("2745677", "Velp", "", "NL", "528", "03", "0275", "", "", "51.995", "5.97361", "Europe/Amsterdam"),
("2745706", "Veldhoven", "", "NL", "528", "06", "0861", "", "", "51.41833", "5.40278", "Europe/Amsterdam"),
("2745726", "Veghel", "Вегел", "NL", "528", "06", "0860", "", "", "51.61667", "5.54861", "Europe/Amsterdam"),
("2745739", "Veere", "Веера", "NL", "528", "10", "0717", "", "", "51.54833", "3.66667", "Europe/Amsterdam"),
("2745774", "Veenendaal", "", "NL", "528", "09", "0345", "", "", "52.02863", "5.55891", "Europe/Amsterdam"),
("2745783", "Veendam", "", "NL", "528", "04", "0047", "", "", "53.10667", "6.87917", "Europe/Amsterdam"),
("2745860", "Valkenswaard", "", "NL", "528", "06", "0858", "", "", "51.35083", "5.45972", "Europe/Amsterdam"),
("2745912", "Utrecht", "Утрехт", "NL", "528", "09", "0344", "", "", "52.09083", "5.12222", "Europe/Amsterdam"),
("2745932", "Urk", "", "NL", "528", "16", "0184", "", "", "52.6625", "5.60139", "Europe/Amsterdam"),
("2745973", "Uithoorn", "", "NL", "528", "07", "0451", "", "", "52.2375", "4.82639", "Europe/Amsterdam"),
("2746005", "Uden", "Уден", "NL", "528", "06", "0856", "", "", "51.66083", "5.61944", "Europe/Amsterdam"),
("2746133", "Tubbergen", "Тубберген", "NL", "528", "15", "0183", "", "", "52.4075", "6.78472", "Europe/Amsterdam"),
("2746215", "Tongelre", "", "NL", "528", "06", "0772", "", "", "51.44889", "5.51978", "Europe/Amsterdam"),
("2746301", "Tilburg", "Тилбург", "NL", "528", "06", "0855", "", "", "51.55551", "5.0913", "Europe/Amsterdam"),
("2746331", "Tiel", "Тил", "NL", "528", "03", "0281", "", "", "51.88667", "5.42917", "Europe/Amsterdam"),
("2746420", "Terneuzen", "Тернезен", "NL", "528", "10", "0715", "", "", "51.33583", "3.82778", "Europe/Amsterdam"),
("2746504", "Tegelen", "", "NL", "528", "05", "0983", "", "", "51.34417", "6.13611", "Europe/Amsterdam"),
("2746766", "Steenwijk", "", "NL", "528", "15", "1708", "", "", "52.7875", "6.12083", "Europe/Amsterdam"),
("2746804", "Steenbergen", "", "NL", "528", "06", "0851", "", "", "51.58417", "4.31944", "Europe/Amsterdam"),
("2746839", "Staphorst", "", "NL", "528", "15", "0180", "", "", "52.645", "6.21111", "Europe/Amsterdam"),
("2746860", "Stadskanaal", "", "NL", "528", "04", "0037", "", "", "52.98947", "6.9504", "Europe/Amsterdam"),
("2746932", "Spijkenisse", "", "NL", "528", "11", "0612", "", "", "51.845", "4.32917", "Europe/Amsterdam"),
("2747021", "Someren", "", "NL", "528", "06", "0847", "", "", "51.385", "5.71111", "Europe/Amsterdam"),
("2747034", "Soest", "Зоест", "NL", "528", "09", "0342", "", "", "52.17333", "5.29167", "Europe/Amsterdam"),
("2747063", "Sneek", "Снек", "NL", "528", "02", "1900", "", "", "53.03297", "5.6589", "Europe/Amsterdam"),
("2747169", "Sliedrecht", "Слидрехт", "NL", "528", "11", "0610", "", "", "51.82083", "4.77639", "Europe/Amsterdam"),
("2747203", "Sittard", "Ситтард", "NL", "528", "05", "1883", "", "", "50.99833", "5.86944", "Europe/Amsterdam"),
("2747227", "Sint-Oedenrode", "", "NL", "528", "06", "0846", "", "", "51.5675", "5.45972", "Europe/Amsterdam"),
("2747351", "'s-Hertogenbosch", "Хертогенбос", "NL", "528", "06", "0796", "", "", "51.69917", "5.30417", "Europe/Amsterdam"),
("2747364", "'s-Gravenzande", "", "NL", "528", "11", "1783", "", "", "52.00167", "4.16528", "Europe/Amsterdam"),
("2747373", "The Hague", "Гаага", "NL", "528", "11", "0518", "", "", "52.07667", "4.29861", "Europe/Amsterdam"),
("2747584", "Schijndel", "", "NL", "528", "06", "0844", "", "", "51.6225", "5.43194", "Europe/Amsterdam"),
("2747596", "Schiedam", "Схидам", "NL", "528", "11", "0606", "", "", "51.91917", "4.38889", "Europe/Amsterdam"),
("2747599", "Scheveningen", "Схевенинген", "NL", "528", "11", "0518", "", "", "52.10461", "4.27557", "Europe/Amsterdam"),
("2747720", "Schagen", "Схаген", "NL", "528", "07", "0441", "", "", "52.7875", "4.79861", "Europe/Amsterdam"),
("2747858", "Rucphen", "", "NL", "528", "06", "0840", "", "", "51.53167", "4.55833", "Europe/Amsterdam"),
("2747891", "Rotterdam", "Роттердам", "NL", "528", "11", "0599", "", "", "51.9225", "4.47917", "Europe/Amsterdam"),
("2747930", "Roosendaal", "Розендаль", "NL", "528", "06", "1674", "", "", "51.53083", "4.46528", "Europe/Amsterdam"),
("2748000", "Roermond", "Рурмонда", "NL", "528", "05", "0957", "", "", "51.19417", "5.9875", "Europe/Amsterdam"),
("2748076", "Rijswijk", "", "NL", "528", "11", "0603", "", "", "52.03634", "4.32501", "Europe/Amsterdam"),
("2748172", "Ridderkerk", "Риддеркерк", "NL", "528", "11", "0597", "", "", "51.8725", "4.60278", "Europe/Amsterdam"),
("2748178", "Rhoon", "", "NL", "528", "11", "0613", "", "", "51.8575", "4.42222", "Europe/Amsterdam"),
("2748185", "Rhenen", "", "NL", "528", "09", "0340", "", "", "51.95917", "5.56806", "Europe/Amsterdam"),
("2748371", "Raalte", "Раалт", "NL", "528", "15", "0177", "", "", "52.38583", "6.275", "Europe/Amsterdam"),
("2748392", "Putten", "Путтен", "NL", "528", "03", "0273", "", "", "52.25917", "5.60694", "Europe/Amsterdam"),
("2748413", "Purmerend", "", "NL", "528", "07", "0439", "", "", "52.505", "4.95972", "Europe/Amsterdam"),
("2748591", "Pijnacker", "", "NL", "528", "11", "1926", "", "", "52.01954", "4.42946", "Europe/Amsterdam"),
("2748729", "Papendrecht", "Папендрехт", "NL", "528", "11", "0590", "", "", "51.83167", "4.6875", "Europe/Amsterdam"),
("2749182", "Oud-Beijerland", "", "NL", "528", "11", "0584", "", "", "51.82417", "4.4125", "Europe/Amsterdam"),
("2749234", "Oss", "Осс", "NL", "528", "06", "0828", "", "", "51.765", "5.51806", "Europe/Amsterdam"),
("2749450", "Oosterhout", "Остерхоут", "NL", "528", "06", "0826", "", "", "51.645", "4.85972", "Europe/Amsterdam"),
("2749644", "Oldenzaal", "Олдензал", "NL", "528", "15", "0173", "", "", "52.31333", "6.92917", "Europe/Amsterdam"),
("2749668", "Oldebroek", "Олдебрук", "NL", "528", "03", "0269", "", "", "52.445", "5.90139", "Europe/Amsterdam"),
("2749680", "Oisterwijk", "Ойстервейк", "NL", "528", "06", "0824", "", "", "51.57917", "5.18889", "Europe/Amsterdam"),
("2749723", "Oegstgeest", "", "NL", "528", "11", "0579", "", "", "52.18", "4.46944", "Europe/Amsterdam"),
("2749753", "Nuth", "", "NL", "528", "05", "0951", "", "", "50.9175", "5.88611", "Europe/Amsterdam"),
("2749756", "Nunspeet", "", "NL", "528", "03", "0302", "", "", "52.37917", "5.78611", "Europe/Amsterdam"),
("2749780", "Nuenen", "Нюнен", "NL", "528", "06", "0820", "", "", "51.47", "5.55278", "Europe/Amsterdam"),
("2749811", "Noordwijkerhout", "", "NL", "528", "11", "0576", "", "", "52.26167", "4.49306", "Europe/Amsterdam"),
("2749812", "Noordwijk-Binnen", "", "NL", "528", "11", "0575", "", "", "52.234", "4.44474", "Europe/Amsterdam"),
("2750053", "Nijmegen", "Неймеген", "NL", "528", "03", "0268", "", "", "51.8425", "5.85278", "Europe/Amsterdam"),
("2750065", "Nijkerk", "", "NL", "528", "03", "0267", "", "", "52.22", "5.48611", "Europe/Amsterdam"),
("2750325", "Nieuwegein", "", "NL", "528", "09", "0356", "", "", "52.02917", "5.08056", "Europe/Amsterdam"),
("2750467", "Nederweert", "Недерверт", "NL", "528", "05", "0946", "", "", "51.28583", "5.74861", "Europe/Amsterdam"),
("2750521", "Naarden", "", "NL", "528", "07", "0425", "", "", "52.29583", "5.1625", "Europe/Amsterdam"),
("2750523", "Naaldwijk", "", "NL", "528", "11", "1783", "", "", "51.99417", "4.20972", "Europe/Amsterdam"),
("2750815", "Mijdrecht", "", "NL", "528", "09", "0736", "", "", "52.20667", "4.8625", "Europe/Amsterdam"),
("2750884", "Middelharnis", "Мидделхарнис", "NL", "528", "11", "1924", "", "", "51.7575", "4.16528", "Europe/Amsterdam"),
("2750896", "Middelburg", "Мидделбург", "NL", "528", "10", "0687", "", "", "51.5", "3.61389", "Europe/Amsterdam"),
("2750947", "Meppel", "Меппел", "NL", "528", "01", "0119", "", "", "52.69583", "6.19444", "Europe/Amsterdam"),
("2751037", "Meerssen", "", "NL", "528", "05", "0938", "", "", "50.8875", "5.75", "Europe/Amsterdam"),
("2751073", "Medemblik", "", "NL", "528", "07", "0420", "", "", "52.77167", "5.10556", "Europe/Amsterdam"),
("2751283", "Maastricht", "Маастрихт", "NL", "528", "05", "0935", "", "", "50.84833", "5.68889", "Europe/Amsterdam"),
("2751285", "Maassluis", "", "NL", "528", "11", "0556", "", "", "51.92333", "4.25", "Europe/Amsterdam"),
("2751316", "Maarssen", "", "NL", "528", "09", "1904", "", "", "52.13917", "5.04167", "Europe/Amsterdam"),
("2751424", "Losser", "Лоссер", "NL", "528", "15", "0168", "", "", "52.26083", "7.00417", "Europe/Amsterdam"),
("2751456", "Loon op Zand", "", "NL", "528", "06", "0809", "", "", "51.6275", "5.075", "Europe/Amsterdam"),
("2751547", "Lisse", "", "NL", "528", "11", "0553", "", "", "52.26", "4.55694", "Europe/Amsterdam"),
("2751582", "Lindenholt", "", "NL", "528", "03", "0268", "", "", "51.8327", "5.7934", "Europe/Amsterdam"),
("2751651", "Lichtenvoorde", "", "NL", "528", "03", "1586", "", "", "51.98667", "6.56667", "Europe/Amsterdam"),
("2751687", "Leusden", "Леусден", "NL", "528", "09", "0327", "", "", "52.1325", "5.43194", "Europe/Amsterdam"),
("2751738", "Lelystad", "", "NL", "528", "16", "0995", "", "", "52.50833", "5.475", "Europe/Amsterdam"),
("2751771", "Leiderdorp", "Лейдердорпе", "NL", "528", "11", "0547", "", "", "52.15833", "4.52917", "Europe/Amsterdam"),
("2751773", "Leiden", "Лейден", "NL", "528", "11", "0546", "", "", "52.15833", "4.49306", "Europe/Amsterdam"),
("2751792", "Leeuwarden", "Леуварден", "NL", "528", "02", "0080", "", "", "53.20139", "5.80859", "Europe/Amsterdam"),
("2751808", "Leerdam", "Лердам", "NL", "528", "11", "0545", "", "", "51.89333", "5.09167", "Europe/Amsterdam"),
("2751834", "Leek", "Лек", "NL", "528", "04", "0022", "", "", "53.1625", "6.37639", "Europe/Amsterdam"),
("2752264", "Krimpen aan den IJssel", "", "NL", "528", "11", "0542", "", "", "51.91667", "4.60278", "Europe/Amsterdam"),
("2752420", "Korrewegwijk", "", "NL", "528", "04", "0014", "", "", "53.23235", "6.56804", "Europe/Amsterdam"),
("2752923", "Kerkrade", "Керкраде", "NL", "528", "05", "0928", "", "", "50.86583", "6.0625", "Europe/Amsterdam"),
("2753010", "Katwijk aan Zee", "", "NL", "528", "11", "0537", "", "", "52.20333", "4.39861", "Europe/Amsterdam"),
("2753106", "Kampen", "Кампен", "NL", "528", "15", "0166", "", "", "52.555", "5.91111", "Europe/Amsterdam"),
("2753355", "IJsselstein", "Иссельстейн", "NL", "528", "09", "0353", "", "", "52.02", "5.04306", "Europe/Amsterdam"),
("2753468", "Huizen", "", "NL", "528", "07", "0406", "", "", "52.29917", "5.24167", "Europe/Amsterdam"),
("2753557", "Houten", "", "NL", "528", "09", "0321", "", "", "52.02833", "5.16806", "Europe/Amsterdam"),
("2753587", "Horst", "Хорст", "NL", "528", "03", "0233", "", "", "52.30833", "5.58194", "Europe/Amsterdam"),
("2753638", "Hoorn", "Хоорн", "NL", "528", "07", "0405", "", "", "52.6425", "5.05972", "Europe/Amsterdam"),
("2753706", "Hoogezand", "", "NL", "528", "04", "0018", "", "", "53.16167", "6.76111", "Europe/Amsterdam"),
("2753719", "Hoogeveen", "Хоогевеен", "NL", "528", "01", "0118", "", "", "52.7225", "6.47639", "Europe/Amsterdam"),
("2753801", "Hoofddorp", "", "NL", "528", "07", "0394", "", "", "52.3025", "4.68889", "Europe/Amsterdam"),
("2753955", "Hoge Vucht", "", "NL", "528", "06", "0758", "", "", "51.60794", "4.7915", "Europe/Amsterdam"),
("2753996", "Hoensbroek", "", "NL", "528", "05", "0917", "", "", "50.92387", "5.92528", "Europe/Amsterdam"),
("2754064", "Hilversum", "Хилверсюм", "NL", "528", "07", "0402", "", "", "52.22333", "5.17639", "Europe/Amsterdam"),
("2754066", "Hilvarenbeek", "", "NL", "528", "06", "0798", "", "", "51.48583", "5.1375", "Europe/Amsterdam"),
("2754073", "Hillegom", "", "NL", "528", "11", "0534", "", "", "52.29083", "4.58333", "Europe/Amsterdam"),
("2754135", "Heusden", "", "NL", "528", "06", "0797", "", "", "51.73417", "5.13889", "Europe/Amsterdam"),
("2754394", "Hengelo", "", "NL", "528", "15", "0164", "", "", "52.26583", "6.79306", "Europe/Amsterdam"),
("2754408", "Hendrik-Ido-Ambacht", "Хендрик-Идо-Амбахт", "NL", "528", "11", "0531", "", "", "51.84417", "4.63889", "Europe/Amsterdam"),
("2754447", "Helmond", "Хелмонд", "NL", "528", "06", "0794", "", "", "51.48167", "5.66111", "Europe/Amsterdam"),
("2754454", "Hellevoetsluis", "Хеллевутслёйс", "NL", "528", "11", "0530", "", "", "51.83333", "4.13333", "Europe/Amsterdam"),
("2754516", "Heiloo", "", "NL", "528", "07", "0399", "", "", "52.60252", "4.68815", "Europe/Amsterdam"),
("2754635", "Heesch", "", "NL", "528", "06", "1721", "", "", "51.73362", "5.52672", "Europe/Amsterdam"),
("2754652", "Heerlen", "", "NL", "528", "05", "0917", "", "", "50.88365", "5.98154", "Europe/Amsterdam"),
("2754659", "Heerhugowaard", "Херхюговард", "NL", "528", "07", "0398", "", "", "52.67144", "4.84862", "Europe/Amsterdam"),
("2754669", "Heerenveen", "Херенвен", "NL", "528", "02", "0074", "", "", "52.95929", "5.91854", "Europe/Amsterdam"),
("2754681", "Heerde", "", "NL", "528", "03", "0246", "", "", "52.38723", "6.04016", "Europe/Amsterdam"),
("2754692", "Heemstede", "", "NL", "528", "07", "0397", "", "", "52.34992", "4.62301", "Europe/Amsterdam"),
("2754697", "Heemskerk", "Хеемскерк", "NL", "528", "07", "0396", "", "", "52.51108", "4.67165", "Europe/Amsterdam"),
("2754817", "Harlingen", "Харлинген", "NL", "528", "02", "0072", "", "", "53.17477", "5.42244", "Europe/Amsterdam"),
("2754837", "Harenkarspel", "Харенкарспел", "NL", "528", "07", "0441", "", "", "52.73416", "4.77682", "Europe/Amsterdam"),
("2754841", "Haren", "Харен", "NL", "528", "04", "0017", "", "", "53.17209", "6.60931", "Europe/Amsterdam"),
("2754848", "Harderwijk", "", "NL", "528", "03", "0243", "", "", "52.34167", "5.62083", "Europe/Amsterdam"),
("2754861", "Hardenberg", "Харденберге", "NL", "528", "15", "0160", "", "", "52.57583", "6.61944", "Europe/Amsterdam"),
("2755003", "Haarlem", "Харлем", "NL", "528", "07", "0392", "", "", "52.38084", "4.63683", "Europe/Amsterdam"),
("2755030", "Haaksbergen", "Хааксберген", "NL", "528", "15", "0158", "", "", "52.15667", "6.73889", "Europe/Amsterdam"),
("2755251", "Groningen", "Гронинген", "NL", "528", "04", "0014", "", "", "53.21917", "6.56667", "Europe/Amsterdam"),
("2755272", "Groesbeek", "", "NL", "528", "03", "0241", "", "", "51.77667", "5.93611", "Europe/Amsterdam"),
("2755420", "Gouda", "Гауда", "NL", "528", "11", "0513", "", "", "52.01667", "4.70833", "Europe/Amsterdam"),
("2755434", "Gorinchem", "Горинхем", "NL", "528", "11", "0512", "", "", "51.83652", "4.97243", "Europe/Amsterdam"),
("2755464", "Goirle", "Гоирл", "NL", "528", "06", "0785", "", "", "51.52083", "5.06667", "Europe/Amsterdam"),
("2755476", "Goes", "Гус", "NL", "528", "10", "0664", "", "", "51.50417", "3.88889", "Europe/Amsterdam"),
("2755584", "Gennep", "", "NL", "528", "05", "0907", "", "", "51.69833", "5.97361", "Europe/Amsterdam"),
("2755599", "Gendringen", "Гендринген", "NL", "528", "03", "1509", "", "", "51.87333", "6.37639", "Europe/Amsterdam"),
("2755619", "Geldrop", "Гельдроп", "NL", "528", "06", "1771", "", "", "51.42167", "5.55972", "Europe/Amsterdam"),
("2755633", "Geldermalsen", "Гельдермалсен", "NL", "528", "03", "0236", "", "", "51.88083", "5.28889", "Europe/Amsterdam"),
("2755669", "Geertruidenberg", "Гетруденберг", "NL", "528", "06", "0779", "", "", "51.70167", "4.85694", "Europe/Amsterdam"),
("2756039", "Ermelo", "Эрмело", "NL", "528", "03", "0233", "", "", "52.29833", "5.62222", "Europe/Amsterdam"),
("2756059", "Epe", "Эпе", "NL", "528", "03", "0232", "", "", "52.3475", "5.98333", "Europe/Amsterdam"),
("2756071", "Enschede", "Энсхеде", "NL", "528", "15", "0153", "", "", "52.21833", "6.89583", "Europe/Amsterdam"),
("2756077", "Enkhuizen", "", "NL", "528", "07", "0388", "", "", "52.70333", "5.29167", "Europe/Amsterdam"),
("2756136", "Emmen", "Эммен", "NL", "528", "01", "0114", "", "", "52.77917", "6.90694", "Europe/Amsterdam"),
("2756139", "Emmeloord", "Эммелорд", "NL", "528", "16", "0171", "", "", "52.71083", "5.74861", "Europe/Amsterdam"),
("2756161", "Elst", "", "NL", "528", "03", "1734", "", "", "51.91917", "5.84167", "Europe/Amsterdam"),
("2756232", "Elburg", "Элбург", "NL", "528", "03", "0230", "", "", "52.4475", "5.84306", "Europe/Amsterdam"),
("2756253", "Eindhoven", "Эйндховен", "NL", "528", "06", "0772", "", "", "51.44083", "5.47778", "Europe/Amsterdam"),
("2756295", "Eibergen", "", "NL", "528", "03", "1859", "", "", "52.1", "6.64861", "Europe/Amsterdam"),
("2756342", "Eersel", "", "NL", "528", "06", "0770", "", "", "51.3575", "5.31806", "Europe/Amsterdam"),
("2756429", "Ede", "Эде", "NL", "528", "03", "0228", "", "", "52.03333", "5.65833", "Europe/Amsterdam"),
("2756507", "Duiven", "", "NL", "528", "03", "0226", "", "", "51.94667", "6.01389", "Europe/Amsterdam"),
("2756539", "Druten", "", "NL", "528", "03", "0225", "", "", "51.88833", "5.60556", "Europe/Amsterdam"),
("2756559", "Dronten", "Дронтен", "NL", "528", "16", "0303", "", "", "52.525", "5.71806", "Europe/Amsterdam"),
("2756569", "Drimmelen", "Дримлен", "NL", "528", "06", "1719", "", "", "51.70667", "4.80417", "Europe/Amsterdam"),
("2756619", "Driebergen-Rijsenburg", "", "NL", "528", "09", "1581", "", "", "52.05333", "5.28056", "Europe/Amsterdam"),
("2756644", "Drachten", "Драхтен", "NL", "528", "02", "0090", "", "", "53.11254", "6.0989", "Europe/Amsterdam"),
("2756669", "Dordrecht", "", "NL", "528", "11", "0505", "", "", "51.81", "4.67361", "Europe/Amsterdam"),
("2756723", "Dongen", "Донген", "NL", "528", "06", "0766", "", "", "51.62667", "4.93889", "Europe/Amsterdam"),
("2756767", "Doetinchem", "Дутинхем", "NL", "528", "03", "0222", "", "", "51.965", "6.28889", "Europe/Amsterdam"),
("2756888", "Diemen", "Димен", "NL", "528", "07", "0384", "", "", "52.33964", "4.96256", "Europe/Amsterdam"),
("2756987", "Deventer", "Девентер", "NL", "528", "15", "0150", "", "", "52.255", "6.16389", "Europe/Amsterdam"),
("2757220", "Den Helder", "Ден-Хелдер", "NL", "528", "07", "0400", "", "", "52.95988", "4.75933", "Europe/Amsterdam"),
("2757340", "Delfzijl", "Делфзейл", "NL", "528", "04", "0010", "", "", "53.33", "6.91806", "Europe/Amsterdam"),
("2757345", "Delft", "Делфт", "NL", "528", "11", "0503", "", "", "52.00667", "4.35556", "Europe/Amsterdam"),
("2757347", "Delfshaven", "", "NL", "528", "11", "0599", "", "", "51.90488", "4.45315", "Europe/Amsterdam"),
("2757783", "De Bilt", "", "NL", "528", "09", "0310", "", "", "52.11", "5.18056", "Europe/Amsterdam"),
("2757850", "Dalfsen", "Дальфсен", "NL", "528", "15", "0148", "", "", "52.51167", "6.25694", "Europe/Amsterdam"),
("2757872", "Culemborg", "Кулемборг", "NL", "528", "03", "0216", "", "", "51.955", "5.22778", "Europe/Amsterdam"),
("2757874", "Cuijk", "", "NL", "528", "06", "1684", "", "", "51.73083", "5.87917", "Europe/Amsterdam"),
("2757890", "Cranendonck", "", "NL", "528", "06", "1706", "", "", "51.30417", "5.58889", "Europe/Amsterdam"),
("2757991", "Castricum", "", "NL", "528", "07", "0383", "", "", "52.54833", "4.66944", "Europe/Amsterdam"),
("2758012", "Capelle aan den IJssel", "Капелле-ан-ден-Эйссел", "NL", "528", "11", "0502", "", "", "51.92917", "4.57778", "Europe/Amsterdam"),
("2758064", "Bussum", "Бюссюм", "NL", "528", "07", "0381", "", "", "52.27333", "5.16111", "Europe/Amsterdam"),
("2758104", "Bunschoten", "", "NL", "528", "09", "0313", "", "", "52.24304", "5.37884", "Europe/Amsterdam"),
("2758174", "Brunssum", "Брюнссуме", "NL", "528", "05", "0899", "", "", "50.94667", "5.97083", "Europe/Amsterdam"),
("2758177", "Brummen", "Бруммен", "NL", "528", "03", "0213", "", "", "52.09", "6.15556", "Europe/Amsterdam"),
("2758245", "Broek op Langedijk", "", "NL", "528", "07", "0416", "", "", "52.67417", "4.80556", "Europe/Amsterdam"),
("2758258", "Broek in Waterland", "", "NL", "528", "07", "0852", "", "", "52.43417", "4.99583", "Europe/Amsterdam"),
("2758401", "Breda", "Бреда", "NL", "528", "06", "0758", "", "", "51.58656", "4.77596", "Europe/Amsterdam"),
("2758460", "Boxtel", "Бокстел", "NL", "528", "06", "0757", "", "", "51.59083", "5.32917", "Europe/Amsterdam"),
("2758547", "Boskoop", "", "NL", "528", "11", "0499", "", "", "52.075", "4.65556", "Europe/Amsterdam"),
("2758587", "Borssele", "Борссель", "NL", "528", "10", "0654", "", "", "51.42333", "3.73472", "Europe/Amsterdam"),
("2758598", "Borne", "Борне", "NL", "528", "15", "0147", "", "", "52.30136", "6.7482", "Europe/Amsterdam"),
("2758602", "Born", "", "NL", "528", "05", "1883", "", "", "51.03167", "5.80972", "Europe/Amsterdam"),
("2758621", "Borger", "Боргер", "NL", "528", "01", "1681", "", "", "52.92333", "6.79306", "Europe/Amsterdam"),
("2758765", "Bodegraven", "", "NL", "528", "11", "1901", "", "", "52.0825", "4.75", "Europe/Amsterdam"),
("2758804", "Bloemendaal", "", "NL", "528", "07", "0377", "", "", "52.4025", "4.62222", "Europe/Amsterdam"),
("2758878", "Bladel", "", "NL", "528", "06", "1728", "", "", "51.36833", "5.22083", "Europe/Amsterdam"),
("2758998", "Beverwijk", "", "NL", "528", "07", "0375", "", "", "52.48333", "4.65694", "Europe/Amsterdam"),
("2759016", "Beuningen", "", "NL", "528", "03", "0209", "", "", "51.86083", "5.76667", "Europe/Amsterdam"),
("2759040", "Best", "", "NL", "528", "06", "0753", "", "", "51.5075", "5.39028", "Europe/Amsterdam"),
("2759113", "Bergschenhoek", "", "NL", "528", "11", "1621", "", "", "51.99", "4.49861", "Europe/Amsterdam"),
("2759132", "Bergeyk", "", "NL", "528", "06", "1724", "", "", "51.31917", "5.35833", "Europe/Amsterdam"),
("2759145", "Bergen op Zoom", "Берген-оп-Зом", "NL", "528", "06", "0748", "", "", "51.495", "4.29167", "Europe/Amsterdam"),
("2759178", "Benthuizen", "", "NL", "528", "11", "1672", "", "", "52.0775", "4.54444", "Europe/Amsterdam"),
("2759350", "Beek", "", "NL", "528", "05", "0888", "", "", "50.94083", "5.79722", "Europe/Amsterdam"),
("2759407", "Barneveld", "Барневелд", "NL", "528", "03", "0203", "", "", "52.14", "5.58472", "Europe/Amsterdam"),
("2759426", "Barendrecht", "Барендрехт", "NL", "528", "11", "0489", "", "", "51.85667", "4.53472", "Europe/Amsterdam"),
("2759544", "Baarn", "Баан", "NL", "528", "09", "0308", "", "", "52.21167", "5.2875", "Europe/Amsterdam"),
("2759621", "Asten", "", "NL", "528", "06", "0743", "", "", "51.40417", "5.74861", "Europe/Amsterdam"),
("2759633", "Assen", "Ассен", "NL", "528", "01", "0106", "", "", "52.99667", "6.5625", "Europe/Amsterdam"),
("2759661", "Arnhem", "Арнем", "NL", "528", "03", "0202", "", "", "51.98", "5.91111", "Europe/Amsterdam"),
("2759706", "Apeldoorn", "Апелдорн", "NL", "528", "03", "0200", "", "", "52.21", "5.96944", "Europe/Amsterdam"),
("2759746", "Anloo", "", "NL", "528", "01", "1680", "", "", "53.04417", "6.70139", "Europe/Amsterdam"),
("2759794", "Amsterdam", "Амстердам", "NL", "528", "07", "0363", "", "", "52.37403", "4.88969", "Europe/Amsterdam"),
("2759798", "Amstelveen", "Амстелвин", "NL", "528", "07", "0362", "", "", "52.30083", "4.86389", "Europe/Amsterdam"),
("2759821", "Amersfoort", "Амерсфорт", "NL", "528", "09", "0307", "", "", "52.155", "5.3875", "Europe/Amsterdam"),
("2759875", "Alphen aan den Rijn", "", "NL", "528", "11", "0484", "", "", "52.12917", "4.65546", "Europe/Amsterdam"),
("2759879", "Almere Stad", "", "NL", "528", "16", "0034", "", "", "52.37025", "5.21413", "Europe/Amsterdam"),
("2759887", "Almelo", "Алмело", "NL", "528", "15", "0141", "", "", "52.35667", "6.6625", "Europe/Amsterdam"),
("2759899", "Alkmaar", "Алкмаар", "NL", "528", "07", "0361", "", "", "52.63167", "4.74861", "Europe/Amsterdam"),
("2759915", "Alblasserdam", "Алблассердам", "NL", "528", "11", "0482", "", "", "51.86583", "4.66111", "Europe/Amsterdam"),
("2760123", "Aalten", "", "NL", "528", "03", "0197", "", "", "51.925", "6.58056", "Europe/Amsterdam"),
("2760134", "Aalsmeer", "Алсмер", "NL", "528", "07", "0358", "", "", "52.25917", "4.75972", "Europe/Amsterdam"),
("6544881", "Amsterdam-Zuidoost", "", "NL", "528", "07", "0363", "", "", "52.3075", "4.97222", "Europe/Amsterdam"),
("6929992", "Berkel en Rodenrijs", "", "NL", "528", "11", "1621", "", "", "51.99313", "4.47865", "Europe/Amsterdam"),
("6941548", "Ypenburg", "", "NL", "528", "11", "0518", "", "", "52.04098", "4.36981", "Europe/Amsterdam"),
("3133880", "Trondheim", "Тронхейм", "NO", "578", "16", "1601", "", "", "63.43049", "10.39506", "Europe/Oslo"),
("3133895", "Tromso", "Тромсё", "NO", "578", "18", "1902", "", "", "69.6489", "18.95508", "Europe/Oslo"),
("3134331", "Tonsberg", "Тёнсберг", "NO", "578", "20", "0704", "", "", "59.26754", "10.40762", "Europe/Oslo"),
("3136947", "Steinkjer", "", "NO", "578", "10", "1702", "", "", "64.01487", "11.49537", "Europe/Oslo"),
("3137115", "Stavanger", "Ставангер", "NO", "578", "14", "1103", "", "", "58.97005", "5.73332", "Europe/Oslo"),
("3139075", "Skien", "Шиен", "NO", "578", "17", "0806", "", "", "59.20962", "9.60897", "Europe/Oslo"),
("3140084", "Sarpsborg", "Сарпсборг", "NO", "578", "13", "0105", "", "", "59.28391", "11.10962", "Europe/Oslo"),
("3140321", "Sandnes", "", "NO", "578", "14", "1102", "", "", "58.85244", "5.73521", "Europe/Oslo"),
("3140390", "Sandefjord", "Саннефьорд", "NO", "578", "20", "0706", "", "", "59.13118", "10.21665", "Europe/Oslo"),
("3142657", "Porsgrunn", "Пушгрён", "NO", "578", "17", "0805", "", "", "59.14054", "9.6561", "Europe/Oslo"),
("3143244", "Oslo", "Осло", "NO", "578", "12", "0301", "", "", "59.91273", "10.74609", "Europe/Oslo"),
("3145375", "Moss", "Мосс", "NO", "578", "13", "0104", "", "", "59.43403", "10.65771", "Europe/Oslo"),
("3145580", "Molde", "Молде", "NO", "578", "08", "1502", "", "", "62.73752", "7.15912", "Europe/Oslo"),
("3145614", "Mo i Rana", "Му-и-Рана", "NO", "578", "09", "1833", "", "", "66.31278", "14.14278", "Europe/Oslo"),
("3147474", "Lillehammer", "Лиллехаммер", "NO", "578", "11", "0501", "", "", "61.11514", "10.46628", "Europe/Oslo"),
("3148129", "Larvik", "Ларвик", "NO", "578", "20", "0709", "", "", "59.05328", "10.03517", "Europe/Oslo"),
("3149312", "Kristiansund", "Кристиансунн", "NO", "578", "08", "1505", "", "", "63.11045", "7.72795", "Europe/Oslo"),
("3149318", "Kristiansand", "Кристиансанн", "NO", "578", "19", "1001", "", "", "58.14671", "7.9956", "Europe/Oslo"),
("3149563", "Kongsberg", "Конгсберг", "NO", "578", "04", "0604", "", "", "59.66858", "9.65017", "Europe/Oslo"),
("3151770", "Horten", "Хортен", "NO", "578", "20", "0701", "", "", "59.41721", "10.48343", "Europe/Oslo"),
("3153623", "Haugesund", "Хаугезунд", "NO", "578", "14", "1106", "", "", "59.41378", "5.268", "Europe/Oslo"),
("3153823", "Harstad", "Харстад", "NO", "578", "18", "1903", "", "", "68.79833", "16.54165", "Europe/Oslo"),
("3154084", "Hamar", "Хамар", "NO", "578", "06", "0403", "", "", "60.7945", "11.06798", "Europe/Oslo"),
("3154209", "Halden", "Халден", "NO", "578", "13", "0101", "", "", "59.12478", "11.38754", "Europe/Oslo"),
("3155573", "Gjovik", "Йёвик", "NO", "578", "11", "0502", "", "", "60.79574", "10.69155", "Europe/Oslo"),
("3156529", "Fredrikstad", "Фредрикстад", "NO", "578", "13", "0106", "", "", "59.2181", "10.9298", "Europe/Oslo"),
("3159016", "Drammen", "Драммен", "NO", "578", "04", "0602", "", "", "59.74389", "10.20449", "Europe/Oslo"),
("3160881", "Bodo", "Бодо", "NO", "578", "09", "1804", "", "", "67.28", "14.40501", "Europe/Oslo"),
("3161732", "Bergen", "Берген", "NO", "578", "07", "1201", "", "", "60.39299", "5.32415", "Europe/Oslo"),
("3162955", "Arendal", "Арендал", "NO", "578", "02", "0906", "", "", "58.46151", "8.77253", "Europe/Oslo"),
("3163392", "Alesund", "Олесунн", "NO", "578", "08", "1504", "", "", "62.47225", "6.15492", "Europe/Oslo"),
("3336587", "Askoy", "Аскёй", "NO", "578", "07", "1247", "", "", "60.4", "5.18333", "Europe/Oslo"),
("6697344", "Ytrebygda", "", "NO", "578", "07", "1201", "", "", "60.30504", "5.28236", "Europe/Oslo"),
("1282616", "Waling", "", "NP", "524", "WR", "", "", "", "27.98333", "83.76667", "Asia/Kathmandu"),
("1282635", "Tulsipur", "", "NP", "524", "MR", "", "", "", "28.13099", "82.29726", "Asia/Kathmandu"),
("1282666", "Tikapur", "", "NP", "524", "FR", "", "", "", "28.5", "81.13333", "Asia/Kathmandu"),
("1282714", "Tansen", "Тансен", "NP", "524", "WR", "", "", "", "27.86731", "83.5467", "Asia/Kathmandu"),
("1282770", "Siraha", "Сираха", "NP", "524", "ER", "", "", "", "26.65411", "86.2087", "Asia/Kathmandu"),
("1282884", "Rajbiraj", "", "NP", "524", "ER", "", "", "", "26.53333", "86.75", "Asia/Kathmandu"),
("1282898", "Pokhara", "Покхара", "NP", "524", "WR", "04", "", "", "28.26689", "83.96851", "Asia/Kathmandu"),
("1282931", "Patan", "Лалитпур", "NP", "524", "CR", "01", "25", "", "27.67658", "85.31417", "Asia/Kathmandu"),
("1282950", "Panaoti", "", "NP", "524", "CR", "", "", "", "27.58138", "85.5124", "Asia/Kathmandu"),
("1283082", "Malangwa", "", "NP", "524", "CR", "", "", "", "26.85679", "85.55811", "Asia/Kathmandu"),
("1283095", "Mahendranagar", "", "NP", "524", "FR", "", "", "", "28.91667", "80.33333", "Asia/Kathmandu"),
("1283161", "Lahan", "", "NP", "524", "ER", "", "", "", "26.72958", "86.49515", "Asia/Kathmandu"),
("1283190", "Kirtipur", "", "NP", "524", "CR", "", "", "", "27.67988", "85.27544", "Asia/Kathmandu"),
("1283217", "Khandbari", "", "NP", "524", "ER", "", "", "", "27.37469", "87.2039", "Asia/Kathmandu"),
("1283240", "Kathmandu", "Катманду", "NP", "524", "CR", "01", "", "", "27.70169", "85.3206", "Asia/Kathmandu"),
("1283318", "Janakpur", "", "NP", "524", "CR", "", "", "", "26.71828", "85.90646", "Asia/Kathmandu"),
("1283323", "Jaleswar", "", "NP", "524", "CR", "", "", "", "26.64711", "85.80081", "Asia/Kathmandu"),
("1283329", "Ithari", "", "NP", "524", "ER", "", "", "", "26.66667", "87.28333", "Asia/Kathmandu"),
("1283333", "Ilam", "", "NP", "524", "ER", "10", "3", "", "26.90943", "87.92824", "Asia/Kathmandu"),
("1283339", "Hitura", "", "NP", "524", "CR", "11", "", "", "27.42839", "85.03219", "Asia/Kathmandu"),
("1283368", "Gulariya", "", "NP", "524", "MR", "", "", "", "28.23333", "81.33333", "Asia/Kathmandu"),
("1283401", "Gaur", "Гаура", "NP", "524", "CR", "", "", "", "26.76667", "85.26667", "Asia/Kathmandu"),
("1283460", "Dharan Bazar", "", "NP", "524", "ER", "", "", "", "26.81248", "87.28355", "Asia/Kathmandu"),
("1283465", "Dhankuta", "", "NP", "524", "ER", "", "", "", "26.98333", "87.33333", "Asia/Kathmandu"),
("1283467", "Dhangarhi", "", "NP", "524", "FR", "", "", "", "28.70792", "80.59611", "Asia/Kathmandu"),
("1283484", "Darchula", "", "NP", "524", "WR", "", "", "", "29.84121", "80.52874", "Asia/Kathmandu"),
("1283496", "Dailekh", "", "NP", "524", "MR", "02", "60", "", "28.84434", "81.71011", "Asia/Kathmandu"),
("1283499", "Dadeldhura", "", "NP", "524", "FR", "", "", "", "29.29842", "80.58059", "Asia/Kathmandu"),
("1283562", "Butwal", "", "NP", "524", "WR", "", "", "", "27.70055", "83.44836", "Asia/Kathmandu"),
("1283581", "Birganj", "", "NP", "524", "CR", "", "", "", "27.01043", "84.87735", "Asia/Kathmandu"),
("1283582", "Biratnagar", "Биратнагар", "NP", "524", "ER", "07", "", "", "26.4831", "87.28337", "Asia/Kathmandu"),
("1283613", "Bharatpur", "", "NP", "524", "CR", "11", "35", "350005", "27.68333", "84.43333", "Asia/Kathmandu"),
("1283621", "Bhairahawa", "", "NP", "524", "WR", "08", "49", "490063", "27.5", "83.45", "Asia/Kathmandu"),
("1283628", "Bhadrapur", "", "NP", "524", "ER", "", "", "", "26.54404", "88.09436", "Asia/Kathmandu"),
("1283679", "Banepa", "", "NP", "524", "CR", "", "", "", "27.62979", "85.52138", "Asia/Kathmandu"),
("1283711", "Baglung", "Баглунг", "NP", "524", "WR", "", "", "", "28.27189", "83.58976", "Asia/Kathmandu"),
("6254843", "Birendranagar", "Бирендранаган", "NP", "524", "MR", "", "", "", "28.60194", "81.63389", "Asia/Kathmandu"),
("6254845", "Dipayal", "", "NP", "524", "FR", "", "", "", "29.26083", "80.94", "Asia/Kathmandu"),
("6941099", "Nepalgunj", "Непалгун", "NP", "524", "MR", "02", "", "", "28.05", "81.61667", "Asia/Kathmandu"),
("286245", "Sur", "Сур", "OM", "512", "04", "", "", "", "22.56667", "59.52889", "Asia/Muscat"),
("286282", "Al Sohar", "Сухар", "OM", "512", "11", "", "", "", "24.3643", "56.74681", "Asia/Muscat"),
("286293", "Sufalat Sama'il", "", "OM", "512", "01", "", "", "", "23.31667", "58.01667", "Asia/Muscat"),
("286402", "Shinas", "", "OM", "512", "11", "", "", "", "24.74333", "56.46583", "Asia/Muscat"),
("286621", "Salalah", "Салала", "OM", "512", "08", "", "", "", "17.01505", "54.09237", "Asia/Muscat"),
("286647", "Saham", "Салам", "OM", "512", "11", "", "", "", "24.17222", "56.88861", "Asia/Muscat"),
("286987", "Nizwa", "Низва", "OM", "512", "01", "", "", "", "22.93333", "57.53333", "Asia/Muscat"),
("287286", "Muscat", "Маскат", "OM", "512", "06", "", "", "", "23.61387", "58.5922", "Asia/Muscat"),
("287614", "Khasab", "", "OM", "512", "07", "", "", "", "26.17993", "56.24774", "Asia/Muscat"),
("287814", "Izki", "", "OM", "512", "01", "", "", "", "22.93333", "57.76667", "Asia/Muscat"),
("287830", "`Ibri", "", "OM", "512", "09", "", "", "", "23.22573", "56.51572", "Asia/Muscat"),
("287832", "Ibra'", "Ибра", "OM", "512", "12", "", "", "", "22.69057", "58.53337", "Asia/Muscat"),
("288721", "Bidbid", "", "OM", "512", "01", "", "", "", "23.40786", "58.1283", "Asia/Muscat"),
("288764", "Bawshar", "", "OM", "512", "06", "", "", "", "23.55563", "58.3989", "Asia/Muscat"),
("288789", "Barka'", "", "OM", "512", "02", "", "", "", "23.70739", "57.88908", "Asia/Muscat"),
("288899", "Bahla'", "", "OM", "512", "01", "", "", "", "22.97339", "57.29958", "Asia/Muscat"),
("288902", "Badiyah", "", "OM", "512", "12", "", "", "", "22.45", "58.8", "Asia/Muscat"),
("288955", "As Suwayq", "", "OM", "512", "11", "", "", "", "23.84944", "57.43861", "Asia/Muscat"),
("288967", "As Sib al Jadidah", "", "OM", "512", "06", "", "", "", "23.67027", "58.18911", "Asia/Muscat"),
("289011", "Rustaq", "Рустака", "OM", "512", "02", "", "", "", "23.39083", "57.42444", "Asia/Muscat"),
("289174", "Al Liwa'", "", "OM", "512", "11", "", "", "", "24.53611", "56.56556", "Asia/Muscat"),
("289199", "Al Khaburah", "", "OM", "512", "11", "", "", "", "23.98864", "57.09838", "Asia/Muscat"),
("289317", "Al Buraymi", "", "OM", "512", "10", "", "", "", "24.25088", "55.79312", "Asia/Muscat"),
("289433", "Adam", "", "OM", "512", "01", "", "", "", "22.3756", "57.52334", "Asia/Muscat"),
("411849", "Yanqul", "", "OM", "512", "09", "", "", "", "23.59051", "56.55008", "Asia/Muscat"),
("1108161", "Chuhar Jamali", "", "PK", "586", "05", "", "", "", "24.38953", "67.99234", "Asia/Karachi"),
("1161983", "Rawala Kot", "", "PK", "586", "06", "", "", "", "33.85782", "73.76043", "Asia/Karachi"),
("1161991", "Pir jo Goth", "", "PK", "586", "05", "", "", "", "27.59102", "68.61786", "Asia/Karachi"),
("1162004", "Khairpur", "Хайрпура", "PK", "586", "05", "", "", "", "27.52948", "68.7617", "Asia/Karachi"),
("1162105", "Zhob", "", "PK", "586", "02", "", "", "", "31.34111", "69.44806", "Asia/Karachi"),
("1162261", "Zaida", "", "PK", "586", "03", "", "", "", "34.06028", "72.46778", "Asia/Karachi"),
("1162275", "Zahir Pir", "", "PK", "586", "04", "", "", "", "28.81239", "70.52405", "Asia/Karachi"),
("1162285", "Zafarwal", "", "PK", "586", "04", "", "", "", "32.34631", "74.89987", "Asia/Karachi"),
("1162316", "Yazman", "", "PK", "586", "04", "", "", "", "29.12122", "71.74459", "Asia/Karachi"),
("1162456", "Wazirabad", "", "PK", "586", "04", "", "", "", "32.44583", "74.11594", "Asia/Karachi"),
("1162572", "Warburton", "Уорбертон", "PK", "586", "04", "", "", "", "31.55", "73.83333", "Asia/Karachi"),
("1162589", "Warah", "", "PK", "586", "05", "", "", "", "27.44808", "67.79776", "Asia/Karachi"),
("1162813", "Vihari", "", "PK", "586", "04", "", "", "", "30.03333", "72.35", "Asia/Karachi"),
("1162855", "Utmanzai", "", "PK", "586", "03", "", "", "", "34.18799", "71.76286", "Asia/Karachi"),
("1162862", "Uthal", "", "PK", "586", "02", "", "", "", "25.80722", "66.62194", "Asia/Karachi"),
("1162868", "Usta Muhammad", "", "PK", "586", "02", "", "", "", "28.17943", "68.04454", "Asia/Karachi"),
("1162959", "Umarkot", "", "PK", "586", "05", "", "", "", "25.36157", "69.73624", "Asia/Karachi"),
("1163021", "Ubauro", "", "PK", "586", "05", "", "", "", "28.16524", "69.7289", "Asia/Karachi"),
("1163054", "Turbat", "", "PK", "586", "02", "", "", "", "26.00228", "63.04399", "Asia/Karachi"),
("1163224", "Topi", "Топи", "PK", "586", "03", "", "", "", "34.07041", "72.62358", "Asia/Karachi"),
("1163272", "Toba Tek Singh", "", "PK", "586", "04", "", "", "", "30.97433", "72.48269", "Asia/Karachi"),
("1163414", "Thul", "", "PK", "586", "05", "", "", "", "28.24034", "68.77588", "Asia/Karachi"),
("1163582", "Thatta", "Татта", "PK", "586", "05", "", "", "", "24.74745", "67.92353", "Asia/Karachi"),
("1163595", "Tharu Shah", "", "PK", "586", "05", "", "", "", "26.94423", "68.11602", "Asia/Karachi"),
("1163724", "Taunsa", "", "PK", "586", "04", "", "", "", "30.70484", "70.65051", "Asia/Karachi"),
("1163905", "Tank", "", "PK", "586", "03", "", "", "", "32.22168", "70.37928", "Asia/Karachi"),
("1163927", "Tangi", "", "PK", "586", "03", "", "", "", "34.30056", "71.65361", "Asia/Karachi"),
("1163952", "Tando Muhammad Khan", "", "PK", "586", "05", "", "", "", "25.12301", "68.53577", "Asia/Karachi"),
("1163958", "Tando Jam", "", "PK", "586", "05", "", "", "", "25.42718", "68.53619", "Asia/Karachi"),
("1163965", "Tando Allahyar", "", "PK", "586", "05", "", "", "", "25.46263", "68.71923", "Asia/Karachi"),
("1163967", "Tando Adam", "", "PK", "586", "05", "", "", "", "25.76374", "68.66098", "Asia/Karachi"),
("1163968", "Tandlianwala", "", "PK", "586", "04", "", "", "", "31.03333", "73.13333", "Asia/Karachi"),
("1164045", "Talhar", "", "PK", "586", "05", "", "", "", "24.88333", "68.81667", "Asia/Karachi"),
("1164064", "Talamba", "", "PK", "586", "04", "", "", "", "30.52708", "72.24011", "Asia/Karachi"),
("1164069", "Talagang", "", "PK", "586", "04", "", "", "", "32.92973", "72.41583", "Asia/Karachi"),
("1164076", "Tal", "Таль", "PK", "586", "03", "", "", "", "35.47908", "72.24385", "Asia/Karachi"),
("1164216", "Swabi", "", "PK", "586", "03", "", "", "", "34.11988", "72.46987", "Asia/Karachi"),
("1164245", "Surkhpur", "", "PK", "586", "04", "1177651", "", "", "32.71667", "74.45", "Asia/Karachi"),
("1164408", "Sukkur", "Суккур", "PK", "586", "05", "", "", "", "27.70516", "68.85738", "Asia/Karachi"),
("1164419", "Sukheke Mandi", "", "PK", "586", "04", "", "", "", "31.86388", "73.51122", "Asia/Karachi"),
("1164679", "Sodhra", "", "PK", "586", "04", "", "", "", "32.46162", "74.18234", "Asia/Karachi"),
("1164716", "Sita Road", "", "PK", "586", "05", "", "", "", "27.03333", "67.85", "Asia/Karachi"),
("1164776", "Sinjhoro", "", "PK", "586", "05", "", "", "", "26.03031", "68.80898", "Asia/Karachi"),
("1164825", "Sillanwali", "", "PK", "586", "04", "", "", "", "31.82611", "72.53984", "Asia/Karachi"),
("1164896", "Sibi", "Сиби", "PK", "586", "02", "", "", "", "29.5448", "67.8764", "Asia/Karachi"),
("1164909", "Sialkot", "Сиалкот", "PK", "586", "04", "", "", "", "32.49268", "74.53134", "Asia/Karachi"),
("1164970", "Shujaabad", "", "PK", "586", "04", "", "", "", "29.87967", "71.29313", "Asia/Karachi"),
("1164987", "Shorko", "", "PK", "586", "03", "", "", "", "31.90991", "70.87741", "Asia/Karachi"),
("1165108", "Shikarpur", "", "PK", "586", "05", "", "", "", "27.95706", "68.63789", "Asia/Karachi"),
("1165221", "Sheikhupura", "", "PK", "586", "04", "", "", "", "31.71306", "73.97833", "Asia/Karachi"),
("1165260", "Sharqpur", "", "PK", "586", "04", "", "", "", "31.46333", "74.1", "Asia/Karachi"),
("1165388", "Shakargarr", "", "PK", "586", "04", "", "", "", "32.26232", "75.16682", "Asia/Karachi"),
("1165486", "Shahr Sultan", "", "PK", "586", "04", "", "", "", "29.57646", "71.02116", "Asia/Karachi"),
("1165507", "Shahpur Chakar", "", "PK", "586", "05", "", "", "", "26.15497", "68.65093", "Asia/Karachi"),
("1165569", "Shahkot", "", "PK", "586", "04", "7419159", "", "", "31.5709", "73.48531", "Asia/Karachi"),
("1165635", "Shahdadpur", "", "PK", "586", "05", "", "", "", "25.92406", "68.61999", "Asia/Karachi"),
("1165638", "Shahdadkot", "", "PK", "586", "05", "", "", "", "27.84771", "67.9055", "Asia/Karachi"),
("1165744", "Shabqadar", "", "PK", "586", "03", "", "", "", "34.2139", "71.55523", "Asia/Karachi"),
("1165789", "Sehwan", "", "PK", "586", "05", "", "", "", "26.42794", "67.863", "Asia/Karachi"),
("1166000", "Sargodha", "Саргодха", "PK", "586", "04", "", "", "", "32.08361", "72.67111", "Asia/Karachi"),
("1166062", "Sarai Sidhu", "", "PK", "586", "04", "", "", "", "30.59489", "71.96977", "Asia/Karachi"),
("1166066", "Sarai Naurang", "", "PK", "586", "03", "", "", "", "32.82591", "70.78136", "Asia/Karachi"),
("1166073", "Sarai Alamgir", "", "PK", "586", "04", "1177651", "", "", "32.90122", "73.75591", "Asia/Karachi"),
("1166146", "Sangla", "", "PK", "586", "04", "", "", "", "31.71667", "73.38333", "Asia/Karachi"),
("1166164", "Sanghar", "", "PK", "586", "05", "", "", "", "26.04656", "68.9481", "Asia/Karachi"),
("1166265", "Sambrial", "", "PK", "586", "04", "", "", "", "32.47455", "74.35209", "Asia/Karachi"),
("1166381", "Sakrand", "", "PK", "586", "05", "", "", "", "26.13839", "68.27361", "Asia/Karachi"),
("1166547", "Sahiwal", "Сахивале", "PK", "586", "04", "1165999", "", "", "31.97446", "72.33087", "Asia/Karachi"),
("1166548", "Sahiwal", "Сахивал", "PK", "586", "04", "1166545", "", "", "30.66667", "73.1", "Asia/Karachi"),
("1166652", "Sadiqabad", "", "PK", "586", "04", "", "", "", "28.30623", "70.13065", "Asia/Karachi"),
("1166827", "Rohri", "", "PK", "586", "05", "", "", "", "27.69223", "68.89506", "Asia/Karachi"),
("1166933", "Renala Khurd", "", "PK", "586", "04", "", "", "", "30.88333", "73.6", "Asia/Karachi"),
("1166993", "Rawalpindi", "Равалпинди", "PK", "586", "04", "", "", "", "33.6007", "73.0679", "Asia/Karachi"),
("1167031", "Ratodero", "", "PK", "586", "05", "", "", "", "27.80296", "68.28708", "Asia/Karachi"),
("1167142", "Ranipur", "", "PK", "586", "05", "", "", "", "27.28792", "68.50505", "Asia/Karachi"),
("1167380", "Rajanpur", "", "PK", "586", "04", "", "", "", "29.10351", "70.32504", "Asia/Karachi"),
("1167386", "Raja Jang", "", "PK", "586", "04", "", "", "", "31.22083", "74.25194", "Asia/Karachi"),
("1167398", "Raiwind", "", "PK", "586", "04", "", "", "", "31.25444", "74.21778", "Asia/Karachi"),
("1167501", "Radhan", "", "PK", "586", "05", "", "", "", "27.18333", "67.95", "Asia/Karachi"),
("1167507", "Rabwah", "", "PK", "586", "04", "", "", "", "31.75583", "72.91972", "Asia/Karachi"),
("1167528", "Quetta", "Кветта", "PK", "586", "02", "", "", "", "30.199", "67.00971", "Asia/Karachi"),
("1167622", "Kambar", "Камбар", "PK", "586", "05", "", "", "", "27.58676", "68.00103", "Asia/Karachi"),
("1167648", "Qadirpur Ran", "", "PK", "586", "04", "", "", "", "30.29238", "71.67117", "Asia/Karachi"),
("1167821", "Pishin", "Пишин", "PK", "586", "02", "", "", "", "30.58028", "66.99611", "Asia/Karachi"),
("1167873", "Pir Mahal", "", "PK", "586", "04", "", "", "", "30.76667", "72.43333", "Asia/Karachi"),
("1168015", "Pindi Gheb", "", "PK", "586", "04", "", "", "", "33.24024", "72.26609", "Asia/Karachi"),
("1168021", "Pindi Bhattian", "", "PK", "586", "04", "", "", "", "31.89781", "73.27302", "Asia/Karachi"),
("1168036", "Pind Dadan Khan", "", "PK", "586", "04", "", "", "", "32.58789", "73.04564", "Asia/Karachi"),
("1168166", "Phalia", "", "PK", "586", "04", "", "", "", "32.42973", "73.57745", "Asia/Karachi"),
("1168197", "Peshawar", "Пешавар", "PK", "586", "03", "", "", "", "34.008", "71.57849", "Asia/Karachi"),
("1168226", "Pattoki", "", "PK", "586", "04", "", "", "", "31.01667", "73.85", "Asia/Karachi"),
("1168307", "Pasrur", "", "PK", "586", "04", "", "", "", "32.26413", "74.66342", "Asia/Karachi"),
("1168312", "Pasni", "Пасни", "PK", "586", "02", "", "", "", "25.26311", "63.47103", "Asia/Karachi"),
("1168412", "Pano Aqil", "", "PK", "586", "05", "", "", "", "27.85685", "69.11156", "Asia/Karachi"),
("1168555", "Pakpattan", "", "PK", "586", "04", "", "", "", "30.34104", "73.38664", "Asia/Karachi"),
("1168633", "Paharpur", "", "PK", "586", "03", "", "", "", "32.10384", "70.97235", "Asia/Karachi"),
("1168652", "Pad Idan", "", "PK", "586", "05", "", "", "", "26.77475", "68.30197", "Asia/Karachi"),
("1168680", "Pabbi", "", "PK", "586", "03", "", "", "", "34.01056", "71.79889", "Asia/Karachi"),
("1168718", "Okara", "Окара", "PK", "586", "04", "", "", "", "30.80806", "73.44583", "Asia/Karachi"),
("1168749", "Nushki", "", "PK", "586", "02", "", "", "", "29.55423", "66.02148", "Asia/Karachi"),
("1169116", "Nawabshah", "", "PK", "586", "05", "", "", "", "26.24833", "68.40955", "Asia/Karachi"),
("1169143", "Naushahro Firoz", "", "PK", "586", "05", "", "", "", "26.84238", "68.12298", "Asia/Karachi"),
("1169145", "Naushahra Virkan", "", "PK", "586", "04", "", "", "", "31.96284", "73.97225", "Asia/Karachi"),
("1169187", "Naudero", "", "PK", "586", "05", "", "", "", "27.66477", "68.36217", "Asia/Karachi"),
("1169254", "Nasirabad", "", "PK", "586", "05", "", "", "", "27.38091", "67.91678", "Asia/Karachi"),
("1169278", "Narowal", "", "PK", "586", "04", "", "", "", "32.1", "74.88333", "Asia/Karachi"),
("1169334", "Narang", "Наранг", "PK", "586", "04", "", "", "", "31.9132", "74.51756", "Asia/Karachi"),
("1169367", "Naukot", "", "PK", "586", "05", "", "", "", "24.85869", "69.40238", "Asia/Karachi"),
("1169372", "Nankana Sahib", "", "PK", "586", "04", "", "", "", "31.4475", "73.69722", "Asia/Karachi"),
("1169605", "Muzaffargarh", "Музаффаргар", "PK", "586", "04", "", "", "", "30.07537", "71.19213", "Asia/Karachi"),
("1169607", "Muzaffarabad", "", "PK", "586", "06", "", "", "", "34.37002", "73.47082", "Asia/Karachi"),
("1169620", "Mustafabad", "", "PK", "586", "04", "", "", "", "30.89222", "73.49889", "Asia/Karachi"),
("1169684", "Murree", "", "PK", "586", "04", "", "", "", "33.90727", "73.39295", "Asia/Karachi"),
("1169692", "Muridke", "", "PK", "586", "04", "", "", "", "31.8025", "74.26167", "Asia/Karachi"),
("1169825", "Multan", "Мултан", "PK", "586", "04", "", "", "", "30.19556", "71.47528", "Asia/Karachi"),
("1170013", "Moro", "", "PK", "586", "05", "", "", "", "26.66459", "68.00156", "Asia/Karachi"),
("1170219", "Mithi", "", "PK", "586", "05", "", "", "", "24.73183", "69.79811", "Asia/Karachi"),
("1170222", "Mitha Tiwana", "", "PK", "586", "04", "", "", "", "32.24861", "72.11083", "Asia/Karachi"),
("1170294", "Mirpur Mathelo", "", "PK", "586", "05", "", "", "", "28.02271", "69.54886", "Asia/Karachi"),
("1170295", "Mirpur Khas", "Мирпур-Хас", "PK", "586", "05", "", "", "", "25.5251", "69.0159", "Asia/Karachi"),
("1170395", "Mingora", "", "PK", "586", "03", "", "", "", "34.7795", "72.36265", "Asia/Karachi"),
("1170398", "Minchinabad", "", "PK", "586", "04", "", "", "", "30.163", "73.56854", "Asia/Karachi"),
("1170425", "Mianwali", "", "PK", "586", "04", "", "", "", "32.5741", "71.52639", "Asia/Karachi"),
("1170486", "Mian Channun", "", "PK", "586", "04", "", "", "", "30.44004", "72.35431", "Asia/Karachi"),
("1170564", "Mehrabpur", "", "PK", "586", "02", "", "", "", "28.1085", "68.0254", "Asia/Karachi"),
("1170584", "Mehar", "", "PK", "586", "05", "", "", "", "27.18067", "67.82288", "Asia/Karachi"),
("1170667", "Matli", "", "PK", "586", "05", "", "", "", "25.04312", "68.65568", "Asia/Karachi"),
("1170677", "Matiari", "", "PK", "586", "05", "", "", "", "25.59609", "68.44666", "Asia/Karachi"),
("1170706", "Mastung", "", "PK", "586", "02", "", "", "", "29.79936", "66.84505", "Asia/Karachi"),
("1170880", "Mardan", "Мардан", "PK", "586", "03", "", "", "", "34.20195", "72.05254", "Asia/Karachi"),
("1170951", "Mansehra", "Мансехра", "PK", "586", "03", "", "", "", "34.33333", "73.2", "Asia/Karachi"),
("1171050", "Mangla", "", "PK", "586", "04", "", "", "", "31.89306", "72.38167", "Asia/Karachi"),
("1171123", "Mandi Bahauddin", "", "PK", "586", "04", "", "", "", "32.58339", "73.48432", "Asia/Karachi"),
("1171165", "Mananwala", "", "PK", "586", "04", "", "", "", "31.58417", "73.68778", "Asia/Karachi"),
("1171198", "Mamu Kanjan", "", "PK", "586", "04", "", "", "", "30.83333", "72.8", "Asia/Karachi"),
("1171305", "Malir Cantonment", "", "PK", "586", "05", "", "", "", "24.9424", "67.2066", "Asia/Karachi"),
("1171376", "Malakwal", "", "PK", "586", "04", "", "", "", "32.55362", "73.21234", "Asia/Karachi"),
("1171502", "Mailsi", "", "PK", "586", "04", "", "", "", "29.80028", "72.17583", "Asia/Karachi"),
("1171757", "Mach", "", "PK", "586", "02", "", "", "", "29.86371", "67.32978", "Asia/Karachi"),
("1171868", "Loralai", "", "PK", "586", "02", "", "", "", "30.37053", "68.59798", "Asia/Karachi"),
("1171965", "Lodhran", "", "PK", "586", "04", "", "", "", "29.54051", "71.63357", "Asia/Karachi"),
("1172035", "Leiah", "", "PK", "586", "04", "", "", "", "30.96128", "70.93904", "Asia/Karachi"),
("1172128", "Larkana", "Ларкане", "PK", "586", "05", "", "", "", "27.55508", "68.21414", "Asia/Karachi"),
("1172295", "Lalian", "", "PK", "586", "04", "", "", "", "31.82414", "72.79971", "Asia/Karachi"),
("1172318", "Lala Musa", "", "PK", "586", "04", "", "", "", "32.70235", "73.96", "Asia/Karachi"),
("1172339", "Lakki Marwat", "", "PK", "586", "03", "", "", "", "32.60795", "70.91142", "Asia/Karachi"),
("1172451", "Lahore", "Лахор", "PK", "586", "04", "", "", "", "31.54972", "74.34361", "Asia/Karachi"),
("1172488", "Ladhewala Waraich", "", "PK", "586", "04", "", "", "", "32.15656", "74.11701", "Asia/Karachi"),
("1172513", "Lachi", "", "PK", "586", "03", "", "", "", "33.38325", "71.33858", "Asia/Karachi"),
("1172657", "Kunri", "", "PK", "586", "05", "", "", "", "25.17847", "69.56913", "Asia/Karachi"),
("1172663", "Kunjah", "", "PK", "586", "04", "", "", "", "32.52848", "73.97368", "Asia/Karachi"),
("1172682", "Kundian", "", "PK", "586", "04", "", "", "", "32.45872", "71.47754", "Asia/Karachi"),
("1172779", "Kulachi", "", "PK", "586", "03", "", "", "", "31.92861", "70.45917", "Asia/Karachi"),
("1172888", "Kot Samaba", "", "PK", "586", "04", "", "", "", "28.5522", "70.46837", "Asia/Karachi"),
("1172904", "Kotri", "", "PK", "586", "05", "", "", "", "25.366", "68.31216", "Asia/Karachi"),
("1172915", "Kot Radha Kishan", "", "PK", "586", "04", "", "", "", "31.1725", "74.09972", "Asia/Karachi"),
("1172964", "Kot Mumin", "", "PK", "586", "04", "", "", "", "32.18954", "73.02798", "Asia/Karachi"),
("1172993", "Kot Malik", "", "PK", "586", "02", "", "", "", "30.19438", "66.99299", "Asia/Karachi"),
("1173025", "Kotli Loharan", "", "PK", "586", "04", "", "", "", "32.5883", "74.49321", "Asia/Karachi"),
("1173055", "Kotli", "", "PK", "586", "06", "", "", "", "33.51667", "73.91667", "Asia/Karachi"),
("1173272", "Kot Ghulam Muhammad", "", "PK", "586", "04", "", "", "", "32.33298", "74.54798", "Asia/Karachi"),
("1173302", "Kot Diji", "", "PK", "586", "05", "", "", "", "27.34272", "68.70834", "Asia/Karachi"),
("1173378", "Kot Addu", "", "PK", "586", "04", "", "", "", "30.4692", "70.96714", "Asia/Karachi"),
("1173491", "Kohat", "Кохат", "PK", "586", "03", "", "", "", "33.58196", "71.44929", "Asia/Karachi"),
("1173687", "Khushab", "", "PK", "586", "04", "", "", "", "32.29667", "72.3525", "Asia/Karachi"),
("1173692", "Khurrianwala", "", "PK", "586", "04", "", "", "", "31.50056", "73.26667", "Asia/Karachi"),
("1173920", "Khewra", "", "PK", "586", "04", "", "", "", "32.64793", "73.01058", "Asia/Karachi"),
("1174042", "Kharian", "", "PK", "586", "04", "", "", "", "32.81493", "73.86359", "Asia/Karachi"),
("1174062", "Kharan", "", "PK", "586", "02", "", "", "", "28.58333", "65.41667", "Asia/Karachi"),
("1174167", "Khanpur", "", "PK", "586", "04", "", "", "", "28.64534", "70.6567", "Asia/Karachi"),
("1174171", "Khanpur", "", "PK", "586", "05", "", "", "", "27.84358", "69.41373", "Asia/Karachi"),
("1174211", "Khangarh", "", "PK", "586", "04", "", "", "", "29.9173", "71.16184", "Asia/Karachi"),
("1174217", "Khangah Dogran", "", "PK", "586", "04", "", "", "", "31.83167", "73.62306", "Asia/Karachi"),
("1174301", "Khalabat", "", "PK", "586", "03", "", "", "", "34.06", "72.88944", "Asia/Karachi"),
("1174344", "Khairpur Nathan Shah", "", "PK", "586", "05", "", "", "", "27.09359", "67.73366", "Asia/Karachi"),
("1174355", "Khairpur", "", "PK", "586", "04", "", "", "", "29.58111", "72.23639", "Asia/Karachi"),
("1174357", "Khairpur", "Хайрпура", "PK", "586", "05", "", "", "", "28.06526", "69.70076", "Asia/Karachi"),
("1174625", "Kasur", "Касур", "PK", "586", "04", "", "", "", "31.11556", "74.44667", "Asia/Karachi"),
("1174653", "Kashmor", "", "PK", "586", "05", "", "", "", "28.43333", "69.58333", "Asia/Karachi"),
("1174720", "Karor", "", "PK", "586", "04", "", "", "", "31.22741", "70.94923", "Asia/Karachi"),
("1174872", "Karachi", "Карачи", "PK", "586", "05", "1174870", "", "", "24.9056", "67.0822", "Asia/Karachi"),
("1174984", "Kanganpur", "", "PK", "586", "04", "", "", "", "30.76629", "74.12311", "Asia/Karachi"),
("1175010", "Kandiaro", "", "PK", "586", "05", "", "", "", "27.06011", "68.20909", "Asia/Karachi"),
("1175021", "Kandhkot", "", "PK", "586", "05", "", "", "", "28.24396", "69.18235", "Asia/Karachi"),
("1175082", "Kamra", "", "PK", "586", "04", "", "", "", "33.74734", "73.51107", "Asia/Karachi"),
("1175088", "Kamoke", "", "PK", "586", "04", "", "", "", "31.97444", "74.22444", "Asia/Karachi"),
("1175098", "Kamir", "", "PK", "586", "04", "", "", "", "30.43333", "73.05", "Asia/Karachi"),
("1175125", "Kamar Mushani", "", "PK", "586", "04", "", "", "", "32.84389", "71.36694", "Asia/Karachi"),
("1175156", "Kamalia", "", "PK", "586", "04", "", "", "", "30.73333", "72.65", "Asia/Karachi"),
("1175180", "Kalur Kot", "", "PK", "586", "04", "", "", "", "32.15639", "71.25944", "Asia/Karachi"),
("1175232", "Kallar Kahar", "", "PK", "586", "04", "", "", "", "32.78333", "72.7", "Asia/Karachi"),
("1175283", "Kaleke Mandi", "", "PK", "586", "04", "", "", "", "31.97718", "73.60259", "Asia/Karachi"),
("1175296", "Kalat", "Калат", "PK", "586", "02", "", "", "", "29.02252", "66.5916", "Asia/Karachi"),
("1175365", "Kalabagh", "", "PK", "586", "04", "", "", "", "32.965", "71.55697", "Asia/Karachi"),
("1175436", "Kahuta", "Кахуте", "PK", "586", "04", "", "", "", "33.5913", "73.38676", "Asia/Karachi"),
("1175446", "Kohror Pakka", "", "PK", "586", "04", "", "", "", "29.62382", "71.91673", "Asia/Karachi"),
("1175453", "Kahna", "", "PK", "586", "04", "", "", "", "31.36917", "74.36528", "Asia/Karachi"),
("1175560", "Kabirwala", "", "PK", "586", "04", "", "", "", "30.40677", "71.8667", "Asia/Karachi"),
("1175678", "Johi", "", "PK", "586", "05", "", "", "", "26.69206", "67.6133", "Asia/Karachi"),
("1175712", "Jiwani", "", "PK", "586", "02", "", "", "", "25.04992", "61.7468", "Asia/Karachi"),
("1175748", "Jhumra", "", "PK", "586", "04", "", "", "", "31.56781", "73.18347", "Asia/Karachi"),
("1175762", "Jhol", "", "PK", "586", "05", "", "", "", "25.95507", "68.88821", "Asia/Karachi"),
("1175864", "Jhelum", "Джелам", "PK", "586", "04", "", "", "", "32.93313", "73.72637", "Asia/Karachi"),
("1175870", "Jhawarian", "", "PK", "586", "04", "", "", "", "32.36139", "72.62278", "Asia/Karachi"),
("1175892", "Jhang Sadr", "", "PK", "586", "04", "", "", "", "31.27154", "72.32842", "Asia/Karachi"),
("1176022", "Jauharabad", "", "PK", "586", "04", "", "", "", "32.2898", "72.2813", "Asia/Karachi"),
("1176035", "Jatoi Shimali", "", "PK", "586", "04", "", "", "", "29.51654", "70.85032", "Asia/Karachi"),
("1176106", "Jaranwala", "", "PK", "586", "04", "", "", "", "31.33333", "73.43333", "Asia/Karachi"),
("1176218", "Jand", "", "PK", "586", "04", "", "", "", "33.42985", "72.01928", "Asia/Karachi"),
("1176241", "Jampur", "", "PK", "586", "04", "", "", "", "29.64414", "70.59544", "Asia/Karachi"),
("1176358", "Jalalpur Pirwala", "", "PK", "586", "04", "", "", "", "29.50687", "71.21917", "Asia/Karachi"),
("1176368", "Jalalpur", "", "PK", "586", "04", "", "", "", "32.63744", "74.21829", "Asia/Karachi"),
("1176444", "Jahanian Shah", "", "PK", "586", "04", "", "", "", "31.80552", "72.27711", "Asia/Karachi"),
("1176515", "Jacobabad", "", "PK", "586", "05", "", "", "", "28.281", "68.43876", "Asia/Karachi"),
("1176615", "Islamabad", "Исламабад", "PK", "586", "08", "", "", "", "33.72148", "73.04329", "Asia/Karachi"),
("1176734", "Hyderabad", "Хайдарабад", "PK", "586", "05", "", "", "", "25.39242", "68.37366", "Asia/Karachi"),
("1176800", "Hujra", "", "PK", "586", "04", "", "", "", "30.74179", "73.82358", "Asia/Karachi"),
("1176889", "Hingorja", "", "PK", "586", "05", "", "", "", "27.21088", "68.41598", "Asia/Karachi"),
("1176948", "Hazro", "", "PK", "586", "04", "", "", "", "33.90914", "72.49212", "Asia/Karachi"),
("1176995", "Havelian", "", "PK", "586", "03", "", "", "", "34.0536", "73.16571", "Asia/Karachi"),
("1176997", "Haveli", "", "PK", "586", "04", "", "", "", "30.45016", "73.69888", "Asia/Karachi"),
("1177042", "Hasilpur", "", "PK", "586", "04", "", "", "", "29.71222", "72.55528", "Asia/Karachi"),
("1177064", "Hasan Abdal", "", "PK", "586", "04", "", "", "", "30.43333", "72.7", "Asia/Karachi"),
("1177073", "Haru Zbad", "", "PK", "586", "04", "", "", "", "29.61333", "73.13889", "Asia/Karachi"),
("1177089", "Harnoli", "", "PK", "586", "04", "", "", "", "32.27917", "71.55389", "Asia/Karachi"),
("1177107", "Haripur", "Харипур", "PK", "586", "03", "", "", "", "33.99997", "72.93409", "Asia/Karachi"),
("1177203", "Hangu", "", "PK", "586", "03", "", "", "", "33.53108", "71.05934", "Asia/Karachi"),
("1177278", "Hala", "Хала", "PK", "586", "02", "", "", "", "25.81308", "68.42273", "Asia/Karachi"),
("1177384", "Hafizabad", "", "PK", "586", "04", "", "", "", "32.06786", "73.68545", "Asia/Karachi"),
("1177397", "Hadali", "", "PK", "586", "04", "", "", "", "32.64132", "74.56904", "Asia/Karachi"),
("1177446", "Gwadar", "Гвадар", "PK", "586", "02", "", "", "", "25.12163", "62.32541", "Asia/Karachi"),
("1177654", "Gujrat", "Гуджарат", "PK", "586", "04", "", "", "", "32.57284", "74.07897", "Asia/Karachi"),
("1177662", "Gujranwala", "Гайранвала", "PK", "586", "04", "", "", "", "32.16167", "74.18831", "Asia/Karachi"),
("1177682", "Gujar Khan", "", "PK", "586", "04", "", "", "", "33.25579", "73.30255", "Asia/Karachi"),
("1178231", "Gojra", "", "PK", "586", "04", "", "", "", "31.14874", "72.68656", "Asia/Karachi"),
("1178456", "Ghotki", "", "PK", "586", "05", "", "", "", "28.00604", "69.31608", "Asia/Karachi"),
("1178560", "Ghauspur", "", "PK", "586", "05", "", "", "", "28.13906", "69.08305", "Asia/Karachi"),
("1178587", "Gharo", "", "PK", "586", "05", "", "", "", "24.74241", "67.58565", "Asia/Karachi"),
("1178841", "Garh Maharaja", "", "PK", "586", "04", "", "", "", "30.83388", "71.90529", "Asia/Karachi"),
("1179061", "Gambat", "", "PK", "586", "05", "", "", "", "27.35145", "68.52051", "Asia/Karachi"),
("1179223", "Fort Abbas", "", "PK", "586", "04", "", "", "", "29.1925", "72.85361", "Asia/Karachi"),
("1179255", "Fazalpur", "", "PK", "586", "04", "", "", "", "32.18333", "75.06667", "Asia/Karachi"),
("1179305", "Chak Two Hundred Forty-Nine TDA", "", "PK", "586", "04", "", "", "", "31.17959", "71.20946", "Asia/Karachi"),
("1179346", "Faruka", "", "PK", "586", "04", "", "", "", "31.88722", "72.4144", "Asia/Karachi"),
("1179377", "Faqirwali", "", "PK", "586", "04", "", "", "", "29.46631", "73.03403", "Asia/Karachi"),
("1179400", "Faisalabad", "Фейсалабаде", "PK", "586", "04", "", "", "", "31.41667", "73.08333", "Asia/Karachi"),
("1179406", "Eminabad", "", "PK", "586", "04", "", "", "", "32.04219", "74.25944", "Asia/Karachi"),
("1179450", "Dunyapur", "", "PK", "586", "04", "", "", "", "29.7995", "71.71958", "Asia/Karachi"),
("1179463", "Dunga Bunga", "", "PK", "586", "04", "", "", "", "29.74931", "73.24324", "Asia/Karachi"),
("1179496", "Dullewala", "", "PK", "586", "04", "", "", "", "31.83587", "71.43625", "Asia/Karachi"),
("1179757", "Dir", "", "PK", "586", "03", "", "", "", "35.20583", "71.87556", "Asia/Karachi"),
("1179760", "Dipalpur", "", "PK", "586", "04", "", "", "", "30.67091", "73.65292", "Asia/Karachi"),
("1179790", "Dinga", "", "PK", "586", "04", "", "", "", "32.63976", "73.72202", "Asia/Karachi"),
("1179834", "Dijkot", "", "PK", "586", "04", "", "", "", "31.21667", "72.98333", "Asia/Karachi"),
("1179837", "Digri", "", "PK", "586", "05", "", "", "", "25.15579", "69.11129", "Asia/Karachi"),
("1179902", "Dhoro Naro", "", "PK", "586", "05", "", "", "", "25.5", "69.56667", "Asia/Karachi"),
("1180133", "Dhanot", "", "PK", "586", "04", "", "", "", "29.57991", "71.75213", "Asia/Karachi"),
("1180281", "Dera Ismail Khan", "", "PK", "586", "03", "", "", "", "31.83269", "70.9024", "Asia/Karachi"),
("1180289", "Dera Ghazi Khan", "Дера-Гази-Хан", "PK", "586", "04", "", "", "", "30.05614", "70.63477", "Asia/Karachi"),
("1180295", "Dera Bugti", "", "PK", "586", "02", "", "", "", "29.03069", "69.15099", "Asia/Karachi"),
("1180374", "Daur", "", "PK", "586", "05", "", "", "", "26.45834", "68.31915", "Asia/Karachi"),
("1180419", "Daud Khel", "", "PK", "586", "04", "", "", "", "32.87498", "71.57012", "Asia/Karachi"),
("1180436", "Daska", "", "PK", "586", "04", "", "", "", "32.32426", "74.34974", "Asia/Karachi"),
("1180454", "Darya Khan", "", "PK", "586", "04", "", "", "", "31.79123", "71.10394", "Asia/Karachi"),
("1180752", "Dajal", "", "PK", "586", "04", "", "", "", "29.55767", "70.37615", "Asia/Karachi"),
("1180809", "Dadu", "", "PK", "586", "05", "", "", "", "26.73286", "67.77631", "Asia/Karachi"),
("1180825", "Dadhar", "", "PK", "586", "02", "", "", "", "29.47527", "67.65135", "Asia/Karachi"),
("1180942", "Chunian", "", "PK", "586", "04", "", "", "", "30.96397", "73.98029", "Asia/Karachi"),
("1180983", "Chuhar Kana", "", "PK", "586", "04", "", "", "", "31.75", "73.8", "Asia/Karachi"),
("1181022", "Chor", "", "PK", "586", "05", "", "", "", "25.51667", "69.76667", "Asia/Karachi"),
("1181053", "Choa Saidan Shah", "", "PK", "586", "04", "", "", "", "32.72006", "72.98486", "Asia/Karachi"),
("1181073", "Chishtian Mandi", "", "PK", "586", "04", "", "", "", "29.8", "72.86667", "Asia/Karachi"),
("1181096", "Chiniot", "Чиниот", "PK", "586", "04", "", "", "", "31.72", "72.97889", "Asia/Karachi"),
("1181163", "Chichawatni", "", "PK", "586", "04", "", "", "", "30.53333", "72.7", "Asia/Karachi"),
("1181352", "Chawinda", "", "PK", "586", "04", "", "", "", "32.34692", "74.70612", "Asia/Karachi"),
("1181439", "Charsadda", "", "PK", "586", "03", "", "", "", "34.14345", "71.73173", "Asia/Karachi"),
("1181611", "Chaman", "", "PK", "586", "02", "", "", "", "30.9236", "66.45116", "Asia/Karachi"),
("1181636", "Chakwal", "", "PK", "586", "04", "", "", "", "32.93338", "72.85853", "Asia/Karachi"),
("1181887", "Chak Azam Saffo", "", "PK", "586", "04", "", "", "", "30.75", "73.03333", "Asia/Karachi"),
("1182092", "Burewala", "", "PK", "586", "04", "", "", "", "30.16667", "72.65", "Asia/Karachi"),
("1182577", "Bhopalwala", "", "PK", "586", "04", "", "", "", "32.42888", "74.3633", "Asia/Karachi"),
("1182607", "Bhit Shah", "", "PK", "586", "05", "", "", "", "25.80437", "68.49265", "Asia/Karachi"),
("1182637", "Bhimbar", "", "PK", "586", "06", "", "", "", "32.97568", "74.07926", "Asia/Karachi"),
("1182665", "Bhera", "", "PK", "586", "04", "", "", "", "32.48318", "72.9097", "Asia/Karachi"),
("1182682", "Bhawana", "", "PK", "586", "04", "", "", "", "31.56918", "72.64899", "Asia/Karachi"),
("1182775", "Bhan", "", "PK", "586", "05", "", "", "", "26.55831", "67.72139", "Asia/Karachi"),
("1182787", "Bhalwal", "", "PK", "586", "04", "", "", "", "32.27204", "72.90425", "Asia/Karachi"),
("1182815", "Bhakkar", "", "PK", "586", "04", "", "", "", "31.62525", "71.06574", "Asia/Karachi"),
("1182829", "Bhai Pheru", "", "PK", "586", "04", "", "", "", "31.2", "73.95", "Asia/Karachi"),
("1182998", "Bela", "Бела", "PK", "586", "02", "", "", "", "26.2271", "66.3111", "Asia/Karachi"),
("1183090", "Bat Khela", "", "PK", "586", "03", "", "", "", "34.61667", "71.97139", "Asia/Karachi"),
("1183224", "Basirpur", "", "PK", "586", "04", "", "", "", "30.58318", "73.829", "Asia/Karachi"),
("1183460", "Bannu", "", "PK", "586", "03", "", "", "", "32.98541", "70.6027", "Asia/Karachi"),
("1183880", "Bahawalpur", "Бахавалпура", "PK", "586", "04", "", "", "", "29.4", "71.68333", "Asia/Karachi"),
("1183883", "Bahawalnagar", "", "PK", "586", "04", "", "", "", "29.99866", "73.2536", "Asia/Karachi"),
("1184055", "Badin", "", "PK", "586", "05", "", "", "", "24.65599", "68.83841", "Asia/Karachi"),
("1184075", "Baddomalhi", "", "PK", "586", "04", "", "", "", "31.99283", "74.66834", "Asia/Karachi"),
("1184249", "Attock City", "", "PK", "586", "04", "", "", "", "33.77311", "72.3741", "Asia/Karachi"),
("1184370", "Arifwala", "", "PK", "586", "04", "", "", "", "30.29399", "73.07354", "Asia/Karachi"),
("1184569", "Amangarh", "", "PK", "586", "03", "", "", "", "34.00583", "71.93", "Asia/Karachi"),
("1184655", "Alipur", "", "PK", "586", "04", "", "", "", "29.38464", "70.91157", "Asia/Karachi"),
("1184752", "Akora", "Акора", "PK", "586", "03", "", "", "", "34.00361", "72.12611", "Asia/Karachi"),
("1184845", "Ahmadpur East", "", "PK", "586", "04", "", "", "", "29.14309", "71.25976", "Asia/Karachi"),
("1185056", "Abbottabad", "", "PK", "586", "03", "", "", "", "34.14685", "73.21449", "Asia/Karachi"),
("1332083", "Bahawalnagar", "", "PK", "586", "04", "", "", "", "30.55083", "73.39083", "Asia/Karachi"),
("1341204", "Nowshera Cantonment", "", "PK", "586", "03", "", "", "", "33.99829", "71.99834", "Asia/Karachi"),
("1356491", "Ahmadpur Sial", "", "PK", "586", "04", "", "", "", "30.67539", "71.74828", "Asia/Karachi"),
("1357699", "New Badah", "", "PK", "586", "05", "", "", "", "27.34167", "68.03194", "Asia/Karachi"),
("1360491", "Tando Ghulam Ali", "", "PK", "586", "05", "", "", "", "25.13111", "68.86759", "Asia/Karachi"),
("1412008", "Setharja Old", "", "PK", "586", "05", "", "", "", "27.2127", "68.46883", "Asia/Karachi"),
("1448637", "Risalpur", "", "PK", "586", "03", "", "", "", "34.06186", "71.99166", "Asia/Karachi"),
("6457378", "Malakwal City", "", "PK", "586", "04", "", "", "", "32.55492", "73.2122", "Asia/Karachi"),
("752967", "Zyrardow", "Жирардув", "PL", "616", "78", "1438", "143801", "", "52.0488", "20.44599", "Europe/Warsaw"),
("753142", "Zoliborz", "", "PL", "616", "78", "1465", "146501", "", "52.26896", "20.98644", "Europe/Warsaw"),
("753276", "Zielonka", "Зеленка", "PL", "616", "78", "", "", "", "52.30376", "21.16018", "Europe/Warsaw"),
("753866", "Zamosc", "Замосць", "PL", "616", "75", "0664", "066401", "", "50.72314", "23.25196", "Europe/Warsaw"),
("753895", "Zambrow", "Замбрув", "PL", "616", "81", "2014", "201401", "", "52.9855", "22.24319", "Europe/Warsaw"),
("754351", "Zabki", "Зомбки", "PL", "616", "78", "1434", "143403", "", "52.29271", "21.10539", "Europe/Warsaw"),
("754454", "Wyszkow", "Вышкув", "PL", "616", "78", "1435", "143505", "", "52.59278", "21.4584", "Europe/Warsaw"),
("754800", "Wolomin", "Воломин", "PL", "616", "78", "1434", "143412", "", "52.34006", "21.24207", "Europe/Warsaw"),
("755330", "Wola", "", "PL", "616", "78", "1465", "146501", "", "52.2401", "20.98869", "Europe/Warsaw"),
("755475", "Wlochy", "", "PL", "616", "78", "1465", "146501", "", "52.17941", "20.94612", "Europe/Warsaw"),
("755889", "Wieliczka", "Величка", "PL", "616", "77", "1219", "121905", "", "49.98738", "20.06473", "Europe/Warsaw"),
("756004", "Wesola", "", "PL", "616", "78", "1465", "146501", "", "52.25451", "21.22407", "Europe/Warsaw"),
("756092", "Wawer", "", "PL", "616", "78", "1465", "146501", "", "52.19656", "21.17752", "Europe/Warsaw"),
("756135", "Warsaw", "Варшава", "PL", "616", "78", "1465", "", "", "52.22977", "21.01178", "Europe/Warsaw"),
("756320", "Ursus", "", "PL", "616", "78", "1465", "146501", "", "52.19517", "20.88419", "Europe/Warsaw"),
("756867", "Tomaszow Mazowiecki", "Томашув-Мазовецкий", "PL", "616", "74", "1016", "101601", "", "51.53131", "20.00855", "Europe/Warsaw"),
("756868", "Tomaszow Lubelski", "Томашув-Любельски", "PL", "616", "75", "0618", "061801", "", "50.44767", "23.41616", "Europe/Warsaw"),
("757026", "Tarnow", "Тарнув", "PL", "616", "77", "1263", "126301", "", "50.01381", "20.98698", "Europe/Warsaw"),
("757033", "Tarnobrzeg", "Тарнобжеге", "PL", "616", "80", "1864", "186401", "", "50.57304", "21.67937", "Europe/Warsaw"),
("757065", "Targowek", "", "PL", "616", "78", "1465", "146501", "", "52.29185", "21.04845", "Europe/Warsaw"),
("757357", "Szczytno", "Щитно", "PL", "616", "85", "2817", "281706", "", "53.56259", "20.98747", "Europe/Warsaw"),
("757692", "Swidnik", "", "PL", "616", "75", "0617", "061701", "", "51.21898", "22.69621", "Europe/Warsaw"),
("757718", "Suwalki", "Сувалки", "PL", "616", "81", "2063", "206301", "", "54.11175", "22.93087", "Europe/Warsaw"),
("757809", "Sulejowek", "", "PL", "616", "78", "1412", "141215", "", "52.25221", "21.26902", "Europe/Warsaw"),
("758252", "Staszow", "Сташув", "PL", "616", "84", "2612", "261207", "", "50.56307", "21.16593", "Europe/Warsaw"),
("758390", "Starachowice", "Стараховице", "PL", "616", "84", "2611", "261101", "", "51.0374", "21.07126", "Europe/Warsaw"),
("758445", "Stalowa Wola", "Сталёва-Воля", "PL", "616", "80", "1818", "181801", "", "50.58286", "22.05334", "Europe/Warsaw"),
("758470", "Srodmiescie", "Средместье", "PL", "616", "78", "1465", "146501", "", "52.22904", "21.01644", "Europe/Warsaw"),
("758626", "Sokolow Podlaski", "Соколув-Подляски", "PL", "616", "78", "1429", "142901", "", "52.40677", "22.25307", "Europe/Warsaw"),
("758651", "Sokolka", "Сокулка", "PL", "616", "81", "2011", "201108", "", "53.40715", "23.50228", "Europe/Warsaw"),
("758682", "Sochaczew", "Сохачев", "PL", "616", "78", "1428", "142801", "", "52.22944", "20.23838", "Europe/Warsaw"),
("759123", "Skierniewice", "Скерневице", "PL", "616", "74", "1063", "106301", "", "51.95485", "20.15837", "Europe/Warsaw"),
("759141", "Skarzysko-Kamienna", "Скаржиско-Каменна", "PL", "616", "84", "2610", "261001", "", "51.11311", "20.87162", "Europe/Warsaw"),
("759320", "Siemiatycze", "Семятыче", "PL", "616", "81", "2010", "201001", "", "52.42719", "22.86231", "Europe/Warsaw"),
("759412", "Siedlce", "Седльце", "PL", "616", "78", "1464", "146401", "", "52.16772", "22.29006", "Europe/Warsaw"),
("759591", "Sanok", "Санок", "PL", "616", "80", "1817", "181701", "", "49.55573", "22.2056", "Europe/Warsaw"),
("759603", "Sandomierz", "Сандомир", "PL", "616", "84", "2609", "260901", "", "50.68265", "21.74898", "Europe/Warsaw"),
("759734", "Rzeszow", "Жешув", "PL", "616", "80", "1863", "186301", "", "50.04132", "21.99901", "Europe/Warsaw"),
("760343", "Ropczyce", "Ропчице", "PL", "616", "80", "1815", "181503", "", "50.05229", "21.60891", "Europe/Warsaw"),
("760503", "Rembertow", "", "PL", "616", "78", "1465", "146501", "", "52.26059", "21.16355", "Europe/Warsaw"),
("760584", "Rawa Mazowiecka", "Рава-Мазовецкая", "PL", "616", "74", "1013", "101301", "", "51.76437", "20.25493", "Europe/Warsaw"),
("760680", "Radzyn Podlaski", "Радзынь-Подляский", "PL", "616", "75", "0615", "061501", "", "51.78333", "22.61667", "Europe/Warsaw"),
("760778", "Radom", "Радом", "PL", "616", "78", "1463", "146301", "", "51.40253", "21.14714", "Europe/Warsaw"),
("760917", "Pultusk", "Пултуск", "PL", "616", "78", "1424", "142404", "", "52.7025", "21.08276", "Europe/Warsaw"),
("760924", "Pulawy", "Пулавы", "PL", "616", "75", "0614", "061401", "", "51.41655", "21.96939", "Europe/Warsaw"),
("761131", "Przeworsk", "Пшеворск", "PL", "616", "80", "1814", "181401", "", "50.05912", "22.49408", "Europe/Warsaw"),
("761168", "Przemysl", "Перемышль", "PL", "616", "80", "1862", "186201", "", "49.78498", "22.76728", "Europe/Warsaw"),
("761218", "Przasnysz", "Пшасныш", "PL", "616", "78", "1422", "142201", "", "53.01907", "20.88029", "Europe/Warsaw"),
("761228", "Pruszkow", "Прушкув", "PL", "616", "78", "1421", "142102", "", "52.17072", "20.81214", "Europe/Warsaw"),
("762021", "Plonsk", "Плоньск", "PL", "616", "78", "1420", "142001", "", "52.62348", "20.37552", "Europe/Warsaw"),
("762120", "Pisz", "Пиш", "PL", "616", "85", "2816", "281603", "", "53.62744", "21.81253", "Europe/Warsaw"),
("762199", "Pionki", "Пёнки", "PL", "616", "78", "1425", "142501", "", "51.47604", "21.44995", "Europe/Warsaw"),
("762381", "Piastow", "", "PL", "616", "78", "1421", "142101", "", "52.18435", "20.83952", "Europe/Warsaw"),
("762423", "Piaseczno", "Пясечно", "PL", "616", "78", "1418", "141804", "", "52.0814", "21.02397", "Europe/Warsaw"),
("762788", "Otwock", "Отвоцк", "PL", "616", "78", "1417", "141702", "", "52.10577", "21.26129", "Europe/Warsaw"),
("762850", "Ostrow Mazowiecka", "Острув-Мазовецка", "PL", "616", "78", "1416", "141601", "", "52.80245", "21.89507", "Europe/Warsaw"),
("762863", "Ostrowiec Swietokrzyski", "Островец-Свентокшиский", "PL", "616", "84", "2607", "260701", "", "50.92936", "21.38525", "Europe/Warsaw"),
("762909", "Ostroleka", "Остроленка", "PL", "616", "78", "1461", "146101", "", "53.08621", "21.57566", "Europe/Warsaw"),
("763111", "Opoczno", "Опочно", "PL", "616", "74", "1007", "100704", "", "51.37569", "20.27827", "Europe/Warsaw"),
("763166", "Olsztyn", "Ольштын", "PL", "616", "85", "2814", "", "", "53.77995", "20.49416", "Europe/Warsaw"),
("763291", "Olecko", "Олецко", "PL", "616", "85", "2813", "281304", "", "54.03374", "22.50704", "Europe/Warsaw"),
("763442", "Ochota", "", "PL", "616", "78", "1465", "146501", "", "52.22096", "20.98526", "Europe/Warsaw"),
("763523", "Nowy Targ", "Новы-Тарг", "PL", "616", "77", "1211", "121101", "", "49.47783", "20.03228", "Europe/Warsaw"),
("763534", "Nowy Sacz", "Новы-Сонч", "PL", "616", "77", "1262", "126201", "", "49.62177", "20.69705", "Europe/Warsaw"),
("763556", "Nowy Dwor Mazowiecki", "Новы-Двур-Мазовецки", "PL", "616", "78", "1414", "141401", "", "52.43022", "20.71652", "Europe/Warsaw"),
("763829", "Nisko", "Ниско", "PL", "616", "80", "1812", "181205", "", "50.51987", "22.13968", "Europe/Warsaw"),
("764312", "Mragowo", "Мронгово", "PL", "616", "85", "2810", "281001", "", "53.86437", "21.30507", "Europe/Warsaw"),
("764484", "Mokotow", "", "PL", "616", "78", "1465", "146501", "", "52.1934", "21.03487", "Europe/Warsaw"),
("764634", "Mlawa", "Млава", "PL", "616", "78", "1413", "141301", "", "53.11278", "20.3841", "Europe/Warsaw"),
("764679", "Minsk Mazowiecki", "Миньск-Мазовецки", "PL", "616", "78", "1412", "141201", "", "52.17935", "21.57251", "Europe/Warsaw"),
("764749", "Milanowek", "Милянувек", "PL", "616", "78", "1405", "140501", "", "52.11879", "20.67155", "Europe/Warsaw"),
("764849", "Mielec", "Мелец", "PL", "616", "80", "1811", "181101", "", "50.28709", "21.4239", "Europe/Warsaw"),
("764862", "Miedzyrzec Podlaski", "Мендзыжец-Подляский", "PL", "616", "75", "0601", "060110", "", "51.9864", "22.78248", "Europe/Warsaw"),
("765191", "Marki", "Марки", "PL", "616", "78", "1434", "143402", "", "52.32065", "21.10474", "Europe/Warsaw"),
("765749", "Lukow", "Лукув", "PL", "616", "75", "0611", "061101", "", "51.929", "22.37956", "Europe/Warsaw"),
("765876", "Lublin", "Люблин", "PL", "616", "75", "0609", "", "", "51.25", "22.56667", "Europe/Warsaw"),
("765927", "Lubartow", "Любартув", "PL", "616", "75", "0608", "060801", "", "51.46026", "22.60952", "Europe/Warsaw"),
("766027", "Lomza", "Ломжа", "PL", "616", "81", "2062", "206201", "", "53.17806", "22.05935", "Europe/Warsaw"),
("766042", "Lomianki", "Ломянки", "PL", "616", "78", "1432", "143205", "", "52.33413", "20.88602", "Europe/Warsaw"),
("766307", "Lidzbark Warminski", "Лидзбарк-Варминьски", "PL", "616", "85", "2809", "280901", "", "54.12588", "20.57954", "Europe/Warsaw"),
("766555", "Legionowo", "Легионово", "PL", "616", "78", "1408", "140801", "", "52.40149", "20.92664", "Europe/Warsaw"),
("766583", "Leczna", "Ленчна", "PL", "616", "75", "0610", "061003", "", "51.30121", "22.88135", "Europe/Warsaw"),
("766783", "Lapy", "Лапы", "PL", "616", "81", "2002", "200206", "", "52.9911", "22.88422", "Europe/Warsaw"),
("766810", "Lancut", "Ланьцут", "PL", "616", "80", "1810", "181001", "", "50.06871", "22.22912", "Europe/Warsaw"),
("767470", "Krosno", "Кросно", "PL", "616", "80", "1861", "186101", "", "49.68866", "21.77058", "Europe/Warsaw"),
("767605", "Krasnystaw", "Красныстав", "PL", "616", "75", "0606", "060601", "", "50.98464", "23.1742", "Europe/Warsaw"),
("767623", "Krasnik", "Красник", "PL", "616", "75", "0607", "060701", "", "50.9236", "22.22706", "Europe/Warsaw"),
("767814", "Kozienice", "Козенице", "PL", "616", "78", "1407", "140705", "", "51.58294", "21.54779", "Europe/Warsaw"),
("768216", "Konstancin-Jeziorna", "Констанцин-Езерна", "PL", "616", "78", "1418", "141802", "", "52.0938", "21.11761", "Europe/Warsaw"),
("768218", "Konskie", "Коньске", "PL", "616", "84", "2605", "260503", "", "51.19166", "20.40607", "Europe/Warsaw"),
("768905", "Kobylka", "", "PL", "616", "78", "1434", "143401", "", "52.33953", "21.19589", "Europe/Warsaw"),
("769250", "Kielce", "Кельце", "PL", "616", "84", "2604", "", "", "50.87033", "20.62752", "Europe/Warsaw"),
("769274", "Ketrzyn", "Кентшин", "PL", "616", "85", "2808", "280801", "", "54.07676", "21.37527", "Europe/Warsaw"),
("769893", "Kabaty", "", "PL", "616", "78", "1465", "146501", "", "52.13012", "21.08148", "Europe/Warsaw"),
("769981", "Jozefow", "Юзефув", "PL", "616", "78", "1417", "141701", "", "52.13707", "21.23589", "Europe/Warsaw"),
("770157", "Jedrzejow", "", "PL", "616", "84", "2602", "260202", "", "50.63945", "20.30454", "Europe/Warsaw"),
("770293", "Jaslo", "Ясло", "PL", "616", "80", "1805", "180501", "", "49.74506", "21.47252", "Europe/Warsaw"),
("770380", "Jaroslaw", "Ярослав", "PL", "616", "80", "1804", "180401", "", "50.01623", "22.67776", "Europe/Warsaw"),
("770966", "Hrubieszow", "Грубешов", "PL", "616", "75", "0604", "060401", "", "50.80502", "23.89251", "Europe/Warsaw"),
("771158", "Hajnowka", "Хайнувка", "PL", "616", "81", "2005", "200506", "", "52.74328", "23.58122", "Europe/Warsaw"),
("771401", "Grodzisk Mazowiecki", "Гродзиск-Мазовецки", "PL", "616", "78", "1405", "140504", "", "52.10387", "20.6337", "Europe/Warsaw"),
("771506", "Grajewo", "Граево", "PL", "616", "81", "2004", "200401", "", "53.64728", "22.45537", "Europe/Warsaw"),
("771804", "Gorlice", "Горлице", "PL", "616", "77", "1205", "120501", "", "49.65563", "21.16035", "Europe/Warsaw"),
("772195", "Gizycko", "Гижицко", "PL", "616", "85", "2806", "280604", "", "54.03811", "21.76441", "Europe/Warsaw"),
("772227", "Gierloz", "", "PL", "616", "85", "", "", "", "54.08134", "21.49551", "Europe/Warsaw"),
("772339", "Garwolin", "Гарволин", "PL", "616", "78", "1403", "140301", "", "51.89747", "21.61466", "Europe/Warsaw"),
("772621", "Elk", "Элк", "PL", "616", "85", "2805", "280501", "", "53.82824", "22.36469", "Europe/Warsaw"),
("772748", "Dzialdowo", "Дзялдово", "PL", "616", "85", "2803", "280302", "", "53.23958", "20.17004", "Europe/Warsaw"),
("773357", "Deblin", "Демблин", "PL", "616", "75", "0616", "061601", "", "51.55912", "21.84829", "Europe/Warsaw"),
("773380", "Debica", "Дембица", "PL", "616", "80", "1803", "180301", "", "50.05146", "21.41141", "Europe/Warsaw"),
("774208", "Ciechanow", "Цеханув", "PL", "616", "78", "1402", "140201", "", "52.88141", "20.61996", "Europe/Warsaw"),
("774558", "Chelm", "Хелм", "PL", "616", "75", "0662", "066201", "", "51.14312", "23.4716", "Europe/Warsaw"),
("774747", "Busko-Zdroj", "Буско-Здруй", "PL", "616", "84", "2601", "260101", "", "50.47078", "20.71884", "Europe/Warsaw"),
("775183", "Brzesko", "", "PL", "616", "77", "1202", "120202", "", "49.96911", "20.60606", "Europe/Warsaw"),
("775758", "Bochnia", "Бохня", "PL", "616", "77", "1201", "120101", "", "49.96905", "20.43028", "Europe/Warsaw"),
("775922", "Bilgoraj", "Билгорай", "PL", "616", "75", "0602", "060201", "", "50.54114", "22.72204", "Europe/Warsaw"),
("775986", "Bielsk Podlaski", "Бельск-Подляски", "PL", "616", "81", "2003", "200301", "", "52.76512", "23.18647", "Europe/Warsaw"),
("776029", "Bielany", "", "PL", "616", "78", "1465", "146501", "", "52.29242", "20.93531", "Europe/Warsaw"),
("776069", "Bialystok", "Белосток", "PL", "616", "81", "2061", "206101", "", "53.13333", "23.16433", "Europe/Warsaw"),
("776103", "Bialoleka", "", "PL", "616", "78", "1465", "146501", "", "52.32127", "20.97204", "Europe/Warsaw"),
("776175", "Biala Podlaska", "Бяла-Подляска", "PL", "616", "75", "0661", "066101", "", "52.03238", "23.11652", "Europe/Warsaw"),
("776251", "Bemowo", "", "PL", "616", "78", "1465", "146501", "", "52.2546", "20.90844", "Europe/Warsaw"),
("776337", "Bartoszyce", "Бартошице", "PL", "616", "85", "2801", "280101", "", "54.25354", "20.80819", "Europe/Warsaw"),
("776597", "Augustow", "Августов", "PL", "616", "81", "2001", "200102", "", "53.84321", "22.97979", "Europe/Warsaw"),
("3079855", "Zywiec", "Живец", "PL", "616", "83", "2417", "241701", "", "49.68529", "19.19243", "Europe/Warsaw"),
("3080004", "Zory", "Жоры", "PL", "616", "83", "2479", "247901", "", "50.04523", "18.70062", "Europe/Warsaw"),
("3080071", "Zlotow", "Злотув", "PL", "616", "86", "3031", "303108", "", "53.36346", "17.04082", "Europe/Warsaw"),
("3080074", "Zlotoryja", "Злоторыя", "PL", "616", "72", "0226", "022602", "", "51.12637", "15.91979", "Europe/Warsaw"),
("3080165", "Zielona Gora", "Зелёна-Гура", "PL", "616", "76", "0862", "086201", "", "51.93548", "15.50643", "Europe/Warsaw"),
("3080231", "Zgorzelec", "Згожелец", "PL", "616", "72", "0225", "022502", "", "51.14942", "15.00835", "Europe/Warsaw"),
("3080251", "Zgierz", "Згеж", "PL", "616", "74", "1020", "102003", "", "51.85561", "19.40623", "Europe/Warsaw"),
("3080414", "Zdunska Wola", "Здуньская-Воля", "PL", "616", "74", "1019", "101901", "", "51.59915", "18.93974", "Europe/Warsaw"),
("3080526", "Zawiercie", "Заверце", "PL", "616", "83", "2416", "241602", "", "50.48766", "19.41679", "Europe/Warsaw"),
("3080644", "Zary", "Жара", "PL", "616", "76", "0811", "081102", "", "51.64205", "15.13727", "Europe/Warsaw"),
("3080866", "Zakopane", "Закопане", "PL", "616", "77", "1217", "121701", "", "49.29899", "19.94885", "Europe/Warsaw"),
("3080944", "Zagan", "Жагань", "PL", "616", "76", "0810", "081002", "", "51.61759", "15.31486", "Europe/Warsaw"),
("3080985", "Zabrze", "Забже", "PL", "616", "83", "2478", "247801", "", "50.32492", "18.78576", "Europe/Warsaw"),
("3081046", "Zabkowice Slaskie", "Зомбковице-Слёнске", "PL", "616", "72", "0224", "022405", "", "50.58969", "16.81239", "Europe/Warsaw"),
("3081324", "Wrzesnia", "Вжесня", "PL", "616", "86", "3030", "303005", "", "52.32512", "17.56519", "Europe/Warsaw"),
("3081368", "Wroclaw", "Вроцлав", "PL", "616", "72", "0223", "", "", "51.1", "17.03333", "Europe/Warsaw"),
("3081677", "Wodzislaw Slaski", "Водзислав-Слёнски", "PL", "616", "83", "2415", "241504", "", "50.00377", "18.47205", "Europe/Warsaw"),
("3081741", "Wloclawek", "Влоцлавек", "PL", "616", "73", "0464", "046401", "", "52.64817", "19.0678", "Europe/Warsaw"),
("3082197", "Wielun", "Велюнь", "PL", "616", "74", "1017", "101709", "", "51.22097", "18.56964", "Europe/Warsaw"),
("3082473", "Wejherowo", "Вейхерово", "PL", "616", "82", "2215", "221503", "", "54.60568", "18.23559", "Europe/Warsaw"),
("3082704", "Walcz", "Валч", "PL", "616", "87", "3217", "321701", "", "53.27787", "16.47122", "Europe/Warsaw"),
("3082707", "Walbrzych", "Валбжих", "PL", "616", "72", "0221", "022109", "", "50.77141", "16.28432", "Europe/Warsaw"),
("3082712", "Wagrowiec", "Вонгровец", "PL", "616", "86", "3028", "302801", "", "52.80842", "17.19961", "Europe/Warsaw"),
("3082722", "Wadowice", "Вадовице", "PL", "616", "77", "1218", "121809", "", "49.88335", "19.49292", "Europe/Warsaw"),
("3082751", "Ustron", "Устронь", "PL", "616", "83", "2403", "240302", "", "49.72153", "18.80198", "Europe/Warsaw"),
("3082756", "Ustka", "Устка", "PL", "616", "82", "2212", "221201", "", "54.58048", "16.86194", "Europe/Warsaw"),
("3082914", "Tychy", "Тыхы", "PL", "616", "83", "2477", "247701", "", "50.13717", "18.96641", "Europe/Warsaw"),
("3082998", "Turek", "Турек", "PL", "616", "86", "3027", "302701", "", "52.01548", "18.50055", "Europe/Warsaw"),
("3083111", "Trzebinia", "Тшебиня", "PL", "616", "77", "1203", "120305", "", "50.15931", "19.46966", "Europe/Warsaw"),
("3083185", "Trzcianka", "Тшчанка", "PL", "616", "86", "3002", "300207", "", "53.04063", "16.45628", "Europe/Warsaw"),
("3083271", "Torun", "Торунь", "PL", "616", "73", "0463", "046301", "", "53.01375", "18.59814", "Europe/Warsaw"),
("3083426", "Tczew", "Тчев", "PL", "616", "82", "2214", "221401", "", "54.09242", "18.77787", "Europe/Warsaw"),
("3083440", "Tarnowskie Gory", "Тарновске-Гуры", "PL", "616", "83", "2413", "241304", "", "50.44548", "18.86147", "Europe/Warsaw"),
("3083826", "Szczecinek", "Щецинек", "PL", "616", "87", "3215", "321501", "", "53.70791", "16.69937", "Europe/Warsaw"),
("3083829", "Szczecin", "Щецин", "PL", "616", "87", "3262", "326201", "", "53.42894", "14.55302", "Europe/Warsaw"),
("3083878", "Szamotuly", "Шамотулы", "PL", "616", "86", "3024", "302407", "", "52.61201", "16.57794", "Europe/Warsaw"),
("3083955", "Swinoujscie", "Свиноуйсьце", "PL", "616", "87", "3263", "326301", "", "53.91053", "14.24712", "Europe/Warsaw"),
("3083988", "Swietochlowice", "Свентохловице", "PL", "616", "83", "2476", "247601", "", "50.29636", "18.91726", "Europe/Warsaw"),
("3084062", "Swiebodzin", "Свебодзин", "PL", "616", "76", "0808", "080805", "", "52.24751", "15.53355", "Europe/Warsaw"),
("3084074", "Swiecie", "", "PL", "616", "73", "0414", "041409", "", "53.40953", "18.44742", "Europe/Warsaw"),
("3084084", "Swiebodzice", "Свебодзице", "PL", "616", "72", "0219", "021902", "", "50.85976", "16.3282", "Europe/Warsaw"),
("3084085", "Swidwin", "Свидвин", "PL", "616", "87", "3216", "321601", "", "53.77464", "15.77671", "Europe/Warsaw"),
("3084093", "Swidnica", "Свидница", "PL", "616", "72", "0219", "021901", "", "50.84378", "16.48859", "Europe/Warsaw"),
("3084130", "Swarzedz", "Сважендз", "PL", "616", "86", "3021", "302116", "", "52.41289", "17.08503", "Europe/Warsaw"),
("3084241", "Sulechow", "Сулехув", "PL", "616", "76", "0809", "080906", "", "52.08362", "15.62513", "Europe/Warsaw"),
("3084415", "Strzelce Opolskie", "Стшельце-Опольске", "PL", "616", "79", "1611", "161105", "", "50.5107", "18.30056", "Europe/Warsaw"),
("3084440", "Strzegom", "Стшегом", "PL", "616", "72", "0219", "021906", "", "50.96264", "16.35006", "Europe/Warsaw"),
("3084826", "Starogard Gdanski", "Старогард-Гданьски", "PL", "616", "82", "2213", "221303", "", "53.96396", "18.52638", "Europe/Warsaw"),
("3084840", "Stargard Szczecinski", "Старгард-Щециньски", "PL", "616", "87", "3214", "321401", "", "53.33672", "15.0499", "Europe/Warsaw"),
("3085045", "Sroda Wielkopolska", "Сьрода-Велькопольска", "PL", "616", "86", "3025", "302504", "", "52.22843", "17.27617", "Europe/Warsaw"),
("3085056", "Srem", "Срем", "PL", "616", "86", "3026", "302604", "", "52.08868", "17.01508", "Europe/Warsaw"),
("3085128", "Sosnowiec", "Сосновец", "PL", "616", "83", "2475", "247501", "", "50.28682", "19.10385", "Europe/Warsaw"),
("3085151", "Sopot", "Сопот", "PL", "616", "82", "2264", "226401", "", "54.4418", "18.56003", "Europe/Warsaw"),
("3085172", "Solec Kujawski", "Солец-Куявски", "PL", "616", "73", "0403", "040308", "", "53.08371", "18.22572", "Europe/Warsaw"),
("3085450", "Slupsk", "Слупск", "PL", "616", "82", "2263", "226301", "", "54.46405", "17.02872", "Europe/Warsaw"),
("3085495", "Slubice", "Слубице", "PL", "616", "76", "0805", "080505", "", "52.35088", "14.56065", "Europe/Warsaw"),
("3085807", "Skawina", "Скавина", "PL", "616", "77", "1206", "120611", "", "49.97524", "19.82869", "Europe/Warsaw"),
("3085941", "Sierpc", "Серпц", "PL", "616", "78", "1427", "142701", "", "52.8568", "19.66913", "Europe/Warsaw"),
("3085978", "Sieradz", "Серадз", "PL", "616", "74", "1014", "101401", "", "51.59584", "18.73023", "Europe/Warsaw"),
("3086024", "Siemianowice Slaskie", "Семяновице-Слёнске", "PL", "616", "83", "2474", "247401", "", "50.32738", "19.02901", "Europe/Warsaw"),
("3086511", "Rypin", "Рыпин", "PL", "616", "73", "0412", "041201", "", "53.06603", "19.40941", "Europe/Warsaw"),
("3086531", "Rydultowy", "Рыдултовы", "PL", "616", "83", "2415", "241503", "", "50.05857", "18.41703", "Europe/Warsaw"),
("3086586", "Rybnik", "Рыбник", "PL", "616", "83", "2473", "247301", "", "50.09713", "18.54179", "Europe/Warsaw"),
("3086706", "Rumia", "Румя", "PL", "616", "82", "2215", "221502", "", "54.57092", "18.38802", "Europe/Warsaw"),
("3086800", "Ruda Slaska", "Руда-Сленска", "PL", "616", "83", "2472", "247201", "", "50.2584", "18.85632", "Europe/Warsaw"),
("3087281", "Reda", "Реда", "PL", "616", "82", "2215", "221501", "", "54.60528", "18.34717", "Europe/Warsaw"),
("3087307", "Rawicz", "Равич", "PL", "616", "86", "3022", "302205", "", "51.60946", "16.85852", "Europe/Warsaw"),
("3087418", "Radzionkow", "", "PL", "616", "83", "2413", "241303", "", "50.40026", "18.90232", "Europe/Warsaw"),
("3087497", "Radomsko", "Радомско", "PL", "616", "74", "1012", "101201", "", "51.06713", "19.44477", "Europe/Warsaw"),
("3087529", "Radlin", "", "PL", "616", "83", "2415", "241502", "", "50.0502", "18.47626", "Europe/Warsaw"),
("3087584", "Raciborz", "Ратибор", "PL", "616", "83", "2411", "241101", "", "50.09195", "18.21928", "Europe/Warsaw"),
("3087628", "Pyskowice", "Пысковице", "PL", "616", "83", "2405", "240502", "", "50.4", "18.63333", "Europe/Warsaw"),
("3087705", "Pszczyna", "Пщина", "PL", "616", "83", "2410", "241005", "", "49.98037", "18.95382", "Europe/Warsaw"),
("3088034", "Pruszcz Gdanski", "Прущ-Гданьский", "PL", "616", "82", "2204", "220401", "", "54.26217", "18.63625", "Europe/Warsaw"),
("3088065", "Prudnik", "Прудник", "PL", "616", "79", "1610", "161004", "", "50.32124", "17.57461", "Europe/Warsaw"),
("3088171", "Poznan", "Познань", "PL", "616", "86", "3064", "306401", "", "52.40692", "16.92993", "Europe/Warsaw"),
("3088435", "Polkowice", "Польковице", "PL", "616", "72", "0216", "021604", "", "51.50391", "16.07261", "Europe/Warsaw"),
("3088461", "Police", "Полиция", "PL", "616", "87", "3211", "321104", "", "53.55214", "14.57182", "Europe/Warsaw"),
("3088825", "Plock", "Плоцк", "PL", "616", "78", "1462", "146201", "", "52.54682", "19.70638", "Europe/Warsaw"),
("3088848", "Pleszew", "Плешев", "PL", "616", "86", "3020", "302006", "", "51.89636", "17.78549", "Europe/Warsaw"),
("3088972", "Piotrkow Trybunalski", "Пётркув-Трыбунальский", "PL", "616", "74", "1062", "106201", "", "51.40547", "19.70321", "Europe/Warsaw"),
("3089033", "Pila", "Пилы", "PL", "616", "86", "3019", "301901", "", "53.15145", "16.73782", "Europe/Warsaw"),
("3089125", "Piekary Slaskie", "Пекары-Слёнске", "PL", "616", "83", "2471", "247101", "", "50.38017", "18.92653", "Europe/Warsaw"),
("3089578", "Pabianice", "Пабьянице", "PL", "616", "74", "1008", "100802", "", "51.66446", "19.35473", "Europe/Warsaw"),
("3089582", "Ozorkow", "Озоркув", "PL", "616", "74", "1020", "102002", "", "51.96336", "19.29139", "Europe/Warsaw"),
("3089658", "Oswiecim", "Освенцим", "PL", "616", "77", "1213", "121301", "", "50.03437", "19.21037", "Europe/Warsaw"),
("3089684", "Ostrow Wielkopolski", "Острув-Велькопольски", "PL", "616", "86", "3017", "301701", "", "51.65501", "17.80686", "Europe/Warsaw"),
("3089779", "Ostroda", "Оструда", "PL", "616", "85", "2815", "281501", "", "53.69671", "19.96486", "Europe/Warsaw"),
("3089965", "Orzesze", "Ожеше", "PL", "616", "83", "2408", "240803", "", "50.15595", "18.77924", "Europe/Warsaw"),
("3090048", "Opole", "Ополе", "PL", "616", "79", "1609", "", "", "50.67212", "17.92532", "Europe/Warsaw"),
("3090146", "Olkusz", "Олькуш", "PL", "616", "77", "1212", "121205", "", "50.2813", "19.56503", "Europe/Warsaw"),
("3090170", "Olesnica", "Олесница", "PL", "616", "72", "0214", "021401", "", "51.21338", "17.38986", "Europe/Warsaw"),
("3090205", "Olawa", "Олава", "PL", "616", "72", "0215", "021501", "", "50.9466", "17.2926", "Europe/Warsaw"),
("3090403", "Oborniki", "Оборники", "PL", "616", "86", "3016", "301601", "", "52.64739", "16.81406", "Europe/Warsaw"),
("3090433", "Nysa Zamlynie", "", "PL", "616", "79", "", "", "", "50.4575", "17.31308", "Europe/Warsaw"),
("3090436", "Nysa", "Ныса", "PL", "616", "79", "1607", "160705", "", "50.47379", "17.33437", "Europe/Warsaw"),
("3090452", "Nowy Tomysl", "", "PL", "616", "86", "3015", "301504", "", "52.3195", "16.12844", "Europe/Warsaw"),
("3090558", "Nowogard", "Новогард", "PL", "616", "87", "3204", "320404", "", "53.67437", "15.1163", "Europe/Warsaw"),
("3090764", "Nowa Sol", "Нова-Суль", "PL", "616", "76", "0804", "080401", "", "51.80333", "15.71702", "Europe/Warsaw"),
("3090768", "Nowa Ruda", "Нова-Руда", "PL", "616", "72", "0208", "020804", "", "50.58008", "16.50164", "Europe/Warsaw"),
("3091141", "Namyslow", "Намыслув", "PL", "616", "79", "1606", "160602", "", "51.07592", "17.72284", "Europe/Warsaw"),
("3091150", "Naklo nad Notecia", "Накло-над-Нотецью", "PL", "616", "73", "0410", "041003", "", "53.14214", "17.60181", "Europe/Warsaw"),
("3091217", "Myszkow", "Мышков", "PL", "616", "83", "2409", "240901", "", "50.5752", "19.32461", "Europe/Warsaw"),
("3091232", "Myslowice", "Мысловице", "PL", "616", "83", "2470", "247001", "", "50.20745", "19.16668", "Europe/Warsaw"),
("3091256", "Myslenice", "Мысленице", "PL", "616", "77", "1209", "120903", "", "49.83383", "19.9383", "Europe/Warsaw"),
("3091831", "Mikolow", "Миколув", "PL", "616", "83", "2408", "240802", "", "50.17103", "18.9041", "Europe/Warsaw"),
("3091969", "Miedzyrzecz", "Мендзыжеч", "PL", "616", "76", "0803", "080302", "", "52.44461", "15.57801", "Europe/Warsaw"),
("3092472", "Malbork", "Мальборк", "PL", "616", "82", "2209", "220901", "", "54.03591", "19.0266", "Europe/Warsaw"),
("3092856", "Lubon", "Любон", "PL", "616", "86", "3021", "302101", "", "52.34705", "16.89267", "Europe/Warsaw"),
("3092906", "Lubliniec", "Люблинец", "PL", "616", "83", "2407", "240701", "", "50.66897", "18.6844", "Europe/Warsaw"),
("3092931", "Lubin", "Любин", "PL", "616", "72", "0211", "021101", "", "51.40089", "16.20149", "Europe/Warsaw"),
("3093040", "Luban", "Любань", "PL", "616", "72", "0210", "021001", "", "51.12014", "15.28768", "Europe/Warsaw"),
("3093066", "Lowicz", "Лович", "PL", "616", "74", "1005", "100501", "", "52.10714", "19.94525", "Europe/Warsaw"),
("3093133", "Lodz", "Лодзь", "PL", "616", "74", "", "", "", "51.75", "19.46667", "Europe/Warsaw"),
("3093457", "Libiaz", "", "PL", "616", "77", "1203", "120304", "", "50.10396", "19.31568", "Europe/Warsaw"),
("3093524", "Leszno", "Лешно", "PL", "616", "86", "3063", "306301", "", "51.84034", "16.57494", "Europe/Warsaw"),
("3093692", "Legnica", "Легница", "PL", "616", "72", "0262", "026201", "", "51.21006", "16.1619", "Europe/Warsaw"),
("3093708", "Ledziny", "", "PL", "616", "83", "2414", "241403", "", "50.14264", "19.13149", "Europe/Warsaw"),
("3093726", "Leczyca", "Ленчица", "PL", "616", "74", "1004", "100401", "", "52.05959", "19.19972", "Europe/Warsaw"),
("3093739", "Lebork", "Лемборк", "PL", "616", "82", "2208", "220801", "", "54.53921", "17.75012", "Europe/Warsaw"),
("3093785", "Laziska Gorne", "Лазиска-Гурне", "PL", "616", "83", "2408", "240801", "", "50.14952", "18.84215", "Europe/Warsaw"),
("3093902", "Lask", "Ласк", "PL", "616", "74", "1003", "100302", "", "51.59056", "19.13278", "Europe/Warsaw"),
("3094086", "Kwidzyn", "Квидзын", "PL", "616", "82", "2207", "220701", "", "53.72495", "18.93114", "Europe/Warsaw"),
("3094170", "Kutno", "Кутно", "PL", "616", "74", "1002", "100201", "", "52.23064", "19.36409", "Europe/Warsaw"),
("3094625", "Krotoszyn", "Кротошин", "PL", "616", "86", "3012", "301204", "", "51.69868", "17.43738", "Europe/Warsaw"),
("3094788", "Krapkowice", "Крапковице", "PL", "616", "79", "1605", "160502", "", "50.47515", "17.96539", "Europe/Warsaw"),
("3094802", "Krakow", "Краков", "PL", "616", "77", "1261", "126101", "", "50.06143", "19.93658", "Europe/Warsaw"),
("3095049", "Koszalin", "Кошалин", "PL", "616", "87", "3261", "326101", "", "54.19438", "16.17222", "Europe/Warsaw"),
("3095057", "Kostrzyn nad Odra", "Костшин-над-Одрой", "PL", "616", "76", "0801", "080101", "", "52.58713", "14.64953", "Europe/Warsaw"),
("3095126", "Koscierzyna", "Косцежина", "PL", "616", "82", "2206", "220601", "", "54.12226", "17.98119", "Europe/Warsaw"),
("3095151", "Koscian", "Косьцян", "PL", "616", "86", "3011", "301101", "", "52.08829", "16.64866", "Europe/Warsaw"),
("3095277", "Konstantynow Lodzki", "", "PL", "616", "74", "1008", "100801", "", "51.74776", "19.32564", "Europe/Warsaw"),
("3095321", "Konin", "Конин", "PL", "616", "86", "3062", "306201", "", "52.22338", "18.25121", "Europe/Warsaw"),
("3095795", "Kolobrzeg", "Колобжег", "PL", "616", "87", "3208", "320804", "", "54.17565", "15.58342", "Europe/Warsaw"),
("3095797", "Kolo", "Коло", "PL", "616", "86", "3009", "300901", "", "52.20024", "18.63865", "Europe/Warsaw"),
("3095971", "Knurow", "", "PL", "616", "83", "2405", "240501", "", "50.21971", "18.65067", "Europe/Warsaw"),
("3096003", "Kluczbork", "Ключборк", "PL", "616", "79", "1604", "160402", "", "50.97281", "18.21816", "Europe/Warsaw"),
("3096053", "Klodzko", "Клодзко", "PL", "616", "72", "0208", "020802", "", "50.43488", "16.66145", "Europe/Warsaw"),
("3096328", "Kety", "Кенты", "PL", "616", "77", "1213", "121304", "", "49.88214", "19.22333", "Europe/Warsaw"),
("3096372", "Kedzierzyn-Kozle", "Кендзежин-Козле", "PL", "616", "79", "1603", "160301", "", "50.34984", "18.22606", "Europe/Warsaw"),
("3096472", "Katowice", "Катовице", "PL", "616", "83", "2469", "", "", "50.25842", "19.02754", "Europe/Warsaw"),
("3096525", "Kartuzy", "Картузы", "PL", "616", "82", "2205", "220502", "", "54.33424", "18.19735", "Europe/Warsaw"),
("3096779", "Kamienna Gora", "Каменна-Гура", "PL", "616", "72", "0207", "020701", "", "50.78314", "16.03037", "Europe/Warsaw"),
("3096880", "Kalisz", "Калиш", "PL", "616", "86", "3061", "306101", "", "51.76109", "18.09102", "Europe/Warsaw"),
("3097257", "Jelenia Gora", "", "PL", "616", "72", "0261", "026101", "", "50.89973", "15.72899", "Europe/Warsaw"),
("3097271", "Jelcz", "", "PL", "616", "72", "", "", "", "51.02102", "17.32095", "Europe/Warsaw"),
("3097333", "Jaworzno", "Явожно", "PL", "616", "83", "2468", "246801", "", "50.20528", "19.27498", "Europe/Warsaw"),
("3097367", "Jawor", "Явор", "PL", "616", "72", "0205", "020501", "", "51.05132", "16.19347", "Europe/Warsaw"),
("3097391", "Jastrzebie Zdroj", "", "PL", "616", "83", "2467", "246701", "", "49.95542", "18.57479", "Europe/Warsaw"),
("3097528", "Jarocin", "Яроцин", "PL", "616", "86", "3006", "300602", "", "51.97266", "17.50256", "Europe/Warsaw"),
("3097872", "Inowroclaw", "Иновроцлав", "PL", "616", "73", "0407", "040701", "", "52.79886", "18.26388", "Europe/Warsaw"),
("3097902", "Ilawa", "Илава", "PL", "616", "85", "2807", "280701", "", "53.59601", "19.56849", "Europe/Warsaw"),
("3098130", "Gubin", "Губин", "PL", "616", "76", "0802", "080201", "", "51.94956", "14.72837", "Europe/Warsaw"),
("3098200", "Gryfino", "Грыфино", "PL", "616", "87", "3206", "320604", "", "53.25243", "14.48831", "Europe/Warsaw"),
("3098201", "Gryfice", "Грыфице", "PL", "616", "87", "3205", "320502", "", "53.9165", "15.20027", "Europe/Warsaw"),
("3098218", "Grudziadz", "Грудзендз", "PL", "616", "73", "0462", "046201", "", "53.48411", "18.75366", "Europe/Warsaw"),
("3098619", "Gostynin", "Гостынин", "PL", "616", "78", "1404", "140401", "", "52.42938", "19.46194", "Europe/Warsaw"),
("3098625", "Gostyn", "Гостын", "PL", "616", "86", "3004", "300402", "", "51.88247", "17.01226", "Europe/Warsaw"),
("3098722", "Gorzow Wielkopolski", "Гожув-Велькопольски", "PL", "616", "76", "", "", "", "52.73679", "15.22878", "Europe/Warsaw"),
("3098966", "Goleniow", "Голенюв", "PL", "616", "87", "3204", "320402", "", "53.56392", "14.82854", "Europe/Warsaw"),
("3099112", "Gniezno", "Гнезно", "PL", "616", "86", "3003", "300301", "", "52.53481", "17.58259", "Europe/Warsaw"),
("3099169", "Glucholazy", "Глухолазы", "PL", "616", "79", "1607", "160701", "", "50.31505", "17.38355", "Europe/Warsaw"),
("3099180", "Glowno", "Гловно", "PL", "616", "74", "1020", "102001", "", "51.96463", "19.71565", "Europe/Warsaw"),
("3099213", "Glogow", "Глогув", "PL", "616", "72", "0203", "020301", "", "51.66361", "16.0845", "Europe/Warsaw"),
("3099230", "Gliwice", "Гливице", "PL", "616", "83", "2466", "246601", "", "50.29761", "18.67658", "Europe/Warsaw"),
("3099424", "Gdynia", "Гдыня", "PL", "616", "82", "2262", "226201", "", "54.51889", "18.53188", "Europe/Warsaw"),
("3099434", "Gdansk", "Гданьск", "PL", "616", "82", "2261", "226101", "", "54.35205", "18.64637", "Europe/Warsaw"),
("3099654", "Fordon", "", "PL", "616", "73", "0461", "046101", "", "53.14821", "18.17036", "Europe/Warsaw"),
("3099759", "Elblag", "Эльблонг", "PL", "616", "85", "2804", "", "", "54.1522", "19.40884", "Europe/Warsaw"),
("3099828", "Dzierzoniow", "Дзержонюв", "PL", "616", "72", "0202", "020202", "", "50.7282", "16.65141", "Europe/Warsaw"),
("3100796", "Dabrowa Gornicza", "Домброва-Гурнича", "PL", "616", "83", "2465", "246501", "", "50.31818", "19.2374", "Europe/Warsaw"),
("3100946", "Czestochowa", "Ченстохова", "PL", "616", "83", "2464", "246401", "", "50.79646", "19.12409", "Europe/Warsaw"),
("3100974", "Czerwionka-Leszczyny", "", "PL", "616", "83", "2412", "241201", "", "50.15007", "18.67762", "Europe/Warsaw"),
("3101057", "Czeladz", "", "PL", "616", "83", "2401", "240102", "", "50.31542", "19.07824", "Europe/Warsaw"),
("3101076", "Czechowice-Dziedzice", "Чеховице-Дзедзице", "PL", "616", "83", "2402", "240204", "", "49.91342", "19.00479", "Europe/Warsaw"),
("3101321", "Cieszyn", "Цешин", "PL", "616", "83", "2403", "240301", "", "49.75133", "18.63213", "Europe/Warsaw"),
("3101547", "Chrzanow", "Хшанув", "PL", "616", "77", "1203", "120303", "", "50.13546", "19.40203", "Europe/Warsaw"),
("3101613", "Choszczno", "Хощно", "PL", "616", "87", "3202", "320202", "", "53.16905", "15.42054", "Europe/Warsaw"),
("3101619", "Chorzow", "Хожув", "PL", "616", "83", "2463", "246301", "", "50.30582", "18.9742", "Europe/Warsaw"),
("3101672", "Chojnice", "Хойнице", "PL", "616", "82", "2202", "220201", "", "53.69554", "17.55701", "Europe/Warsaw"),
("3101680", "Chodziez", "Ходзеж", "PL", "616", "86", "3001", "300101", "", "52.99505", "16.9198", "Europe/Warsaw"),
("3101787", "Chelmza", "Хелмжа", "PL", "616", "73", "0415", "041501", "", "53.18463", "18.60466", "Europe/Warsaw"),
("3101795", "Chelmno", "Хелмно", "PL", "616", "73", "0404", "040401", "", "53.34855", "18.4251", "Europe/Warsaw"),
("3101943", "Bytow", "Бытув", "PL", "616", "82", "2201", "220102", "", "54.17057", "17.49187", "Europe/Warsaw"),
("3101950", "Bytom", "Бытом", "PL", "616", "83", "2462", "246201", "", "50.34802", "18.93282", "Europe/Warsaw"),
("3102014", "Bydgoszcz", "Быдгощ", "PL", "616", "73", "0461", "046101", "", "53.1235", "18.00762", "Europe/Warsaw"),
("3102459", "Brzeg", "Бжег", "PL", "616", "79", "1601", "160101", "", "50.86079", "17.4674", "Europe/Warsaw"),
("3102627", "Brodnica", "Бродница", "PL", "616", "73", "0402", "040201", "", "53.25967", "19.39653", "Europe/Warsaw"),
("3102677", "Braniewo", "Бранево", "PL", "616", "85", "2802", "280201", "", "54.37971", "19.81959", "Europe/Warsaw"),
("3102987", "Boleslawiec", "Болеславец", "PL", "616", "72", "0201", "020102", "", "51.26418", "15.5697", "Europe/Warsaw"),
("3103034", "Boguszow-Gorce", "Богушув-Горце", "PL", "616", "72", "0221", "022101", "", "50.75514", "16.20494", "Europe/Warsaw"),
("3103096", "Bogatynia", "Богатыня", "PL", "616", "72", "0225", "022503", "", "50.90747", "14.95634", "Europe/Warsaw"),
("3103365", "Bierun", "Берунь", "PL", "616", "83", "2414", "241401", "", "50.09", "19.09291", "Europe/Warsaw"),
("3103402", "Bielsko-Biala", "Бельско-Бяла", "PL", "616", "83", "2461", "246101", "", "49.82245", "19.04686", "Europe/Warsaw"),
("3103476", "Bielawa", "Белява", "PL", "616", "72", "0202", "020201", "", "50.69075", "16.623", "Europe/Warsaw"),
("3103556", "Bialogard", "Бялогард", "PL", "616", "87", "3201", "320101", "", "54.00696", "15.98751", "Europe/Warsaw"),
("3103709", "Belchatow", "Белхатув", "PL", "616", "74", "1001", "100101", "", "51.36883", "19.35671", "Europe/Warsaw"),
("3103719", "Bedzin", "Бендзин", "PL", "616", "83", "2401", "240101", "", "50.32607", "19.12565", "Europe/Warsaw"),
("3104115", "Andrychow", "Андрыхув", "PL", "616", "77", "1218", "121801", "", "49.85497", "19.33834", "Europe/Warsaw"),
("3104132", "Aleksandrow Lodzki", "Александрув-Лодзинский", "PL", "616", "74", "1020", "102004", "", "51.81965", "19.30384", "Europe/Warsaw"),
("6545326", "Ursynow", "", "PL", "616", "78", "1465", "146501", "", "52.15051", "21.05041", "Europe/Warsaw"),
("6545347", "Praga Polnoc", "", "PL", "616", "78", "1465", "146501", "", "52.25443", "21.03472", "Europe/Warsaw"),
("6545348", "Praga Poludnie", "", "PL", "616", "78", "1465", "146501", "", "52.24424", "21.08545", "Europe/Warsaw"),
("7303641", "Jelcz Laskowice", "", "PL", "616", "72", "0215", "021503", "", "51.02134", "17.31649", "Europe/Warsaw"),
("2261639", "Vila Franca de Xira", "", "PT", "620", "14", "1114", "111409", "", "38.95525", "-8.98966", "Europe/Lisbon"),
("2261697", "Vialonga", "", "PT", "620", "14", "1114", "111411", "", "38.87094", "-9.06823", "Europe/Lisbon"),
("2262581", "Torres Vedras", "Торреш", "PT", "620", "14", "1113", "111315", "", "39.09109", "-9.2586", "Europe/Lisbon"),
("2262644", "Tomar", "Томар", "PT", "620", "18", "1418", "", "", "39.60199", "-8.40924", "Europe/Lisbon"),
("2262912", "Sintra", "Синтра", "PT", "620", "14", "1111", "111109", "", "38.80097", "-9.37826", "Europe/Lisbon"),
("2262957", "Sesimbra", "Сесимбра", "PT", "620", "19", "1511", "151102", "", "38.44451", "-9.10149", "Europe/Lisbon"),
("2262963", "Setubal", "Сетубал", "PT", "620", "19", "1512", "151202", "", "38.5244", "-8.8882", "Europe/Lisbon"),
("2263326", "Sao Joao da Talha", "", "PT", "620", "14", "1107", "110715", "", "38.82183", "-9.09079", "Europe/Lisbon"),
("2263352", "Sao Domingos de Rana", "", "PT", "620", "14", "1105", "110502", "", "38.70123", "-9.3276", "Europe/Lisbon"),
("2263480", "Santarem", "Сантарен", "PT", "620", "18", "1416", "141612", "", "39.23333", "-8.68333", "Europe/Lisbon"),
("2263523", "Santa Iria da Azoia", "", "PT", "620", "14", "1107", "110713", "", "38.84629", "-9.08748", "Europe/Lisbon"),
("2263667", "Sacavem", "Сакавен", "PT", "620", "14", "1107", "110712", "", "38.79202", "-9.10801", "Europe/Lisbon"),
("2263827", "Rio de Mouro", "", "PT", "620", "14", "1111", "111108", "", "38.77457", "-9.3276", "Europe/Lisbon"),
("2264087", "Ramada", "", "PT", "620", "14", "1116", "111607", "", "38.80235", "-9.19216", "Europe/Lisbon"),
("2264268", "Queluz", "Келуш", "PT", "620", "14", "1111", "111107", "", "38.75657", "-9.25451", "Europe/Lisbon"),
("2264299", "Quarteira", "", "PT", "620", "09", "0808", "080805", "", "37.06946", "-8.10064", "Europe/Lisbon"),
("2264359", "Povoa de Santa Iria", "Повуа-де-Санта-Ирия", "PT", "620", "14", "1114", "111406", "", "38.86101", "-9.06453", "Europe/Lisbon"),
("2264456", "Portimao", "Портимао", "PT", "620", "09", "0811", "081103", "", "37.13856", "-8.53775", "Europe/Lisbon"),
("2264508", "Portalegre", "Порталегре", "PT", "620", "16", "1214", "121408", "", "39.29379", "-7.43122", "Europe/Lisbon"),
("2264526", "Pontinha", "", "PT", "620", "14", "1116", "111605", "", "38.76771", "-9.19935", "Europe/Lisbon"),
("2264575", "Pombal", "Помбал", "PT", "620", "13", "1015", "101509", "", "39.91674", "-8.62847", "Europe/Lisbon"),
("2264718", "Pinhal Novo", "", "PT", "620", "19", "1508", "150803", "", "38.63106", "-8.91376", "Europe/Lisbon"),
("2264736", "Piedade", "", "PT", "620", "19", "1503", "150310", "", "38.66667", "-9.15", "Europe/Lisbon"),
("2264923", "Peniche", "", "PT", "620", "13", "1014", "101403", "", "39.3558", "-9.38112", "Europe/Lisbon"),
("2265169", "Parede", "", "PT", "620", "14", "1105", "110505", "", "38.69282", "-9.35412", "Europe/Lisbon"),
("2265223", "Palmela", "", "PT", "620", "19", "1508", "150802", "", "38.56902", "-8.90126", "Europe/Lisbon"),
("2265326", "Paco de Arcos", "", "PT", "620", "14", "1110", "111005", "", "38.69569", "-9.29143", "Europe/Lisbon"),
("2265447", "Olhao", "", "PT", "620", "09", "0810", "081003", "", "37.0286", "-7.8411", "Europe/Lisbon"),
("2265467", "Odivelas", "", "PT", "620", "14", "1116", "111603", "", "38.79269", "-9.1838", "Europe/Lisbon"),
("2265788", "Montijo", "Монтихо", "PT", "620", "19", "1507", "150702", "", "38.70675", "-8.97388", "Europe/Lisbon"),
("2265927", "Monte Estoril", "", "PT", "620", "14", "1105", "110503", "", "38.70279", "-9.41606", "Europe/Lisbon"),
("2266249", "Monsanto", "Монсанто", "PT", "620", "18", "1402", "140208", "", "39.46203", "-8.7118", "Europe/Lisbon"),
("2266319", "Moita", "", "PT", "620", "19", "1506", "150603", "", "38.65078", "-8.99038", "Europe/Lisbon"),
("2266703", "Marinha Grande", "", "PT", "620", "13", "1010", "101001", "", "39.74769", "-8.93228", "Europe/Lisbon"),
("2266977", "Loures", "", "PT", "620", "14", "1107", "110707", "", "38.83091", "-9.16845", "Europe/Lisbon"),
("2266988", "Loule", "Лола", "PT", "620", "09", "0808", "080808", "", "37.13772", "-8.01968", "Europe/Lisbon"),
("2267057", "Lisbon", "Лиссабон", "PT", "620", "14", "1106", "110653", "", "38.71667", "-9.13333", "Europe/Lisbon"),
("2267067", "Linda-a-Velha", "", "PT", "620", "14", "1110", "111008", "", "38.71446", "-9.2422", "Europe/Lisbon"),
("2267095", "Leiria", "Лейрия", "PT", "620", "13", "1009", "100912", "", "39.74362", "-8.80705", "Europe/Lisbon"),
("2267131", "Laranjeiro", "", "PT", "620", "09", "0810", "081002", "", "37.06831", "-7.7937", "Europe/Lisbon"),
("2267226", "Lagos", "", "PT", "620", "09", "0807", "080706", "", "37.10202", "-8.67422", "Europe/Lisbon"),
("2267827", "Funchal", "Фуншал", "PT", "620", "10", "3103", "", "", "32.63333", "-16.9", "Atlantic/Madeira"),
("2268339", "Faro", "Фару", "PT", "620", "09", "0805", "080505", "", "37.01937", "-7.93223", "Europe/Lisbon"),
("2268406", "Evora", "Эвора", "PT", "620", "08", "0705", "070521", "", "38.56667", "-7.9", "Europe/Lisbon"),
("2268436", "Estoril", "Эшторил", "PT", "620", "14", "1105", "110504", "", "38.70571", "-9.39773", "Europe/Lisbon"),
("2268575", "Entroncamento", "", "PT", "620", "18", "1410", "141001", "", "39.46667", "-8.46667", "Europe/Lisbon"),
("2269041", "Corroios", "", "PT", "620", "19", "1510", "151005", "", "38.64502", "-9.14843", "Europe/Lisbon"),
("2269282", "Charneca", "Шарнека", "PT", "620", "19", "1503", "150309", "", "38.62059", "-9.19149", "Europe/Lisbon"),
("2269514", "Castelo Branco", "Каштелу-Бранку", "PT", "620", "06", "0502", "050205", "", "39.82219", "-7.49087", "Europe/Lisbon"),
("2269594", "Cascais", "Кашкайш", "PT", "620", "14", "1105", "110503", "", "38.6979", "-9.42146", "Europe/Lisbon"),
("2270157", "Carnaxide", "Карнашиде", "PT", "620", "14", "1110", "111003", "", "38.72706", "-9.24671", "Europe/Lisbon"),
("2270184", "Carcavelos", "", "PT", "620", "14", "1110", "111004", "", "38.69105", "-9.32215", "Europe/Lisbon"),
("2270229", "Caparica", "", "PT", "620", "19", "1503", "150302", "", "38.66667", "-9.2", "Europe/Lisbon"),
("2270377", "Camarate", "Камарате", "PT", "620", "14", "1107", "110703", "", "38.80358", "-9.12808", "Europe/Lisbon"),
("2270380", "Camara de Lobos", "Камара-де-Лобос", "PT", "620", "10", "", "", "", "32.63333", "-16.96667", "Atlantic/Madeira"),
("2270437", "Caldas da Rainha", "Калдаш-да-Раинья", "PT", "620", "13", "1006", "100603", "", "39.40326", "-9.13839", "Europe/Lisbon"),
("2270503", "Cacem", "", "PT", "620", "14", "1111", "111118", "", "38.76698", "-9.29793", "Europe/Lisbon"),
("2270981", "Belas", "", "PT", "620", "14", "1111", "111104", "", "38.77721", "-9.26078", "Europe/Lisbon"),
("2270985", "Beja", "", "PT", "620", "03", "0205", "020511", "", "38.01506", "-7.86323", "Europe/Lisbon"),
("2271071", "Barreiro", "Баррейру", "PT", "620", "19", "1504", "150401", "", "38.66314", "-9.0724", "Europe/Lisbon"),
("2271473", "Arrentela", "Аррентела", "PT", "620", "19", "1510", "151003", "", "38.61667", "-9.1", "Europe/Lisbon"),
("2271680", "Amora", "", "PT", "620", "19", "1510", "151002", "", "38.62961", "-9.11557", "Europe/Lisbon"),
("2271772", "Amadora", "Амадора", "PT", "620", "14", "1115", "111507", "", "38.75382", "-9.23083", "Europe/Lisbon"),
("2271961", "Almada", "Алмада", "PT", "620", "19", "1503", "150301", "", "38.67902", "-9.1569", "Europe/Lisbon"),
("2271985", "Alges", "", "PT", "620", "14", "1110", "111006", "", "38.70245", "-9.22936", "Europe/Lisbon"),
("2272215", "Alcabideche", "Алкабидеше", "PT", "620", "14", "1105", "110501", "", "38.73366", "-9.40928", "Europe/Lisbon"),
("2272222", "Albufeira", "", "PT", "620", "09", "0801", "080101", "", "37.08819", "-8.2503", "Europe/Lisbon"),
("2732265", "Viseu", "Визеу", "PT", "620", "22", "1823", "182328", "", "40.66101", "-7.90971", "Europe/Lisbon"),
("2732438", "Vila Real", "Вила-Реал", "PT", "620", "21", "1714", "171424", "", "41.30062", "-7.74413", "Europe/Lisbon"),
("2732475", "Vilar de Andorinho", "", "PT", "620", "17", "1317", "131710", "", "41.10751", "-8.59632", "Europe/Lisbon"),
("2732544", "Vila Nova de Gaia", "Вила-Нова-де-Гайя", "PT", "620", "17", "1317", "131716", "", "41.13363", "-8.61742", "Europe/Lisbon"),
("2732649", "Vila do Conde", "Вила-ду-Конде", "PT", "620", "17", "1316", "131628", "", "41.35481", "-8.7434", "Europe/Lisbon"),
("2732773", "Viana do Castelo", "", "PT", "620", "20", "1609", "160919", "", "41.69323", "-8.83287", "Europe/Lisbon"),
("2732978", "Valongo", "Валонгу", "PT", "620", "17", "1315", "131505", "", "41.19501", "-8.51027", "Europe/Lisbon"),
("2734106", "Sequeira", "", "PT", "620", "11", "0907", "090755", "", "40.55364", "-7.22594", "Europe/Lisbon"),
("2734140", "Senhora da Hora", "", "PT", "620", "17", "1308", "130810", "", "41.1864", "-8.65172", "Europe/Lisbon"),
("2734363", "Sao Pedro da Cova", "", "PT", "620", "17", "1304", "130410", "", "41.15508", "-8.50412", "Europe/Lisbon"),
("2734434", "Sao Mamede de Infesta", "Сан-Мамед-де-Инфешта", "PT", "620", "17", "1308", "130809", "", "41.20042", "-8.60251", "Europe/Lisbon"),
("2734484", "Sao Joao da Madeira", "Сан-Жуан-да-Мадейра", "PT", "620", "02", "0116", "011601", "", "40.90229", "-8.48969", "Europe/Lisbon"),
("2735083", "Rio Tinto", "", "PT", "620", "17", "1304", "130408", "", "41.18259", "-8.55811", "Europe/Lisbon"),
("2735787", "Povoa de Varzim", "Повуа-ди-Варзин", "PT", "620", "17", "1313", "131310", "", "41.38344", "-8.76364", "Europe/Lisbon"),
("2735943", "Porto", "Порту", "PT", "620", "17", "1312", "131212", "", "41.14961", "-8.61099", "Europe/Lisbon"),
("2736041", "Ponte de Lima", "Понте де Лима", "PT", "620", "20", "1607", "160735", "", "41.76719", "-8.58393", "Europe/Lisbon"),
("2736521", "Pedroso", "", "PT", "620", "17", "1313", "131303", "", "41.41103", "-8.74897", "Europe/Lisbon"),
("2736930", "Ovar", "Овар", "PT", "620", "02", "0115", "011505", "", "40.85862", "-8.62513", "Europe/Lisbon"),
("2737039", "Oliveira do Douro", "", "PT", "620", "17", "1317", "131712", "", "41.12466", "-8.58463", "Europe/Lisbon"),
("2737523", "Moncao", "", "PT", "620", "20", "1604", "160417", "", "42.07892", "-8.48076", "Europe/Madrid"),
("2737824", "Matosinhos", "Матозиньюш", "PT", "620", "17", "1308", "130806", "", "41.18207", "-8.68908", "Europe/Lisbon"),
("2738014", "Maia", "Майя", "PT", "620", "17", "1306", "130615", "", "41.23574", "-8.6199", "Europe/Lisbon"),
("2738347", "Leca do Bailio", "", "PT", "620", "17", "1306", "130606", "", "41.21457", "-8.61348", "Europe/Lisbon"),
("2738348", "Leca da Palmeira", "", "PT", "620", "17", "1308", "130805", "", "41.191", "-8.70027", "Europe/Lisbon"),
("2738707", "Ilhavo", "", "PT", "620", "02", "0110", "011004", "", "40.5999", "-8.66732", "Europe/Lisbon"),
("2738752", "Guimaraes", "Гимарайнш", "PT", "620", "04", "0308", "030860", "", "41.44444", "-8.29619", "Europe/Lisbon"),
("2738785", "Guarda", "Гуарда", "PT", "620", "11", "0907", "090742", "", "40.53733", "-7.26575", "Europe/Lisbon"),
("2738925", "Gondomar", "Гондомар", "PT", "620", "17", "1304", "130409", "", "41.14454", "-8.53223", "Europe/Lisbon"),
("2739723", "Feira", "", "PT", "620", "02", "0109", "010906", "", "40.92535", "-8.54277", "Europe/Lisbon"),
("2739756", "Fanzeres", "", "PT", "620", "17", "1304", "130402", "", "41.17087", "-8.5257", "Europe/Lisbon"),
("2739788", "Fafe", "Фафе", "PT", "620", "04", "0307", "030709", "", "41.45423", "-8.168", "Europe/Lisbon"),
("2739848", "Esposende", "", "PT", "620", "04", "0306", "030605", "", "41.5361", "-8.78201", "Europe/Lisbon"),
("2739849", "Esposende", "Эшпозенде", "PT", "620", "04", "0306", "030605", "", "41.53333", "-8.78333", "Europe/Lisbon"),
("2739997", "Ermezinde", "Эрмезинде", "PT", "620", "17", "1315", "131503", "", "41.22176", "-8.55462", "Europe/Lisbon"),
("2740174", "Custoias", "", "PT", "620", "11", "0914", "091405", "", "41.1053", "-7.32097", "Europe/Lisbon"),
("2740313", "Covilha", "Ковильян", "PT", "620", "06", "0503", "050307", "", "40.28601", "-7.50396", "Europe/Lisbon"),
("2740637", "Coimbra", "Коимбра", "PT", "620", "07", "0603", "060325", "", "40.20564", "-8.41955", "Europe/Lisbon"),
("2741551", "Canidelo", "", "PT", "620", "17", "1317", "131704", "", "41.12402", "-8.65104", "Europe/Lisbon"),
("2742027", "Braganca", "Браганца", "PT", "620", "05", "0402", "040245", "", "41.80582", "-6.75719", "Europe/Lisbon"),
("2742032", "Braga", "Брага", "PT", "620", "04", "0303", "030342", "", "41.55032", "-8.42005", "Europe/Lisbon"),
("2742051", "Bougado", "", "PT", "620", "17", "1318", "131803", "", "41.33979", "-8.5518", "Europe/Lisbon"),
("2742416", "Barcelos", "Барселуш", "PT", "620", "04", "0302", "030209", "", "41.53876", "-8.61505", "Europe/Lisbon"),
("2742506", "Baguim do Monte", "", "PT", "620", "17", "1304", "130412", "", "41.19392", "-8.54133", "Europe/Lisbon"),
("2742611", "Aveiro", "Авейру", "PT", "620", "02", "0105", "010512", "", "40.64427", "-8.64554", "Europe/Lisbon"),
("2743304", "Aguas Santas", "", "PT", "620", "17", "1306", "130608", "", "41.21061", "-8.5866", "Europe/Lisbon"),
("3372783", "Ponta Delgada", "", "PT", "620", "23", "", "", "", "37.73333", "-25.66667", "Atlantic/Azores"),
("289523", "Umm Salal Muhammad", "", "QA", "634", "09", "", "", "", "25.41694", "51.40389", "Asia/Qatar"),
("289888", "Ar Rayyan", "", "QA", "634", "06", "", "", "", "25.29194", "51.42444", "Asia/Qatar"),
("289915", "Al Wakrah", "", "QA", "634", "10", "", "", "", "25.17151", "51.60337", "Asia/Qatar"),
("289962", "Al Khawr", "", "QA", "634", "04", "", "", "", "25.68389", "51.50583", "Asia/Qatar"),
("290030", "Doha", "Доха", "QA", "634", "01", "", "", "", "25.27932", "51.52245", "Asia/Qatar"),
("935214", "Saint-Pierre", "Сент-Пьер", "RE", "638", "RE", "974", "9742", "97416", "-21.3393", "55.47811", "Indian/Reunion"),
("935221", "Saint-Paul", "", "RE", "638", "RE", "974", "9744", "97415", "-21.00963", "55.27071", "Indian/Reunion"),
("935223", "Saint-Louis", "Сен-Луи", "RE", "638", "RE", "974", "9742", "97414", "-21.28585", "55.41124", "Indian/Reunion"),
("935225", "Saint-Leu", "Санкт-Леу", "RE", "638", "RE", "974", "9744", "97413", "-21.17059", "55.28824", "Indian/Reunion"),
("935227", "Saint-Joseph", "Сент-Джозеф", "RE", "638", "RE", "974", "9742", "97412", "-21.37838", "55.61918", "Indian/Reunion"),
("935248", "Sainte-Suzanne", "", "RE", "638", "RE", "974", "9741", "97420", "-20.90614", "55.60886", "Indian/Reunion"),
("935255", "Sainte-Marie", "Сент-Мари", "RE", "638", "RE", "974", "9741", "97418", "-20.89684", "55.5496", "Indian/Reunion"),
("935264", "Saint-Denis", "Сен-Дени", "RE", "638", "RE", "974", "9741", "97411", "-20.88231", "55.4504", "Indian/Reunion"),
("935267", "Saint-Benoit", "Санкт-Бенуа", "RE", "638", "RE", "974", "9743", "97410", "-21.03801", "55.71937", "Indian/Reunion"),
("935268", "Saint-Andre", "Санкт-Андре", "RE", "638", "RE", "974", "9743", "97409", "-20.96333", "55.65031", "Indian/Reunion"),
("935582", "Le Tampon", "Ле-Тампон", "RE", "638", "RE", "974", "9742", "97422", "-21.28309", "55.51802", "Indian/Reunion"),
("935616", "Le Port", "", "RE", "638", "RE", "974", "9744", "97407", "-20.9373", "55.29189", "Indian/Reunion"),
("935691", "La Possession", "", "RE", "638", "RE", "974", "9744", "97408", "-20.92892", "55.33513", "Indian/Reunion"),
("7932385", "Piton Saint-Leu", "", "RE", "638", "", "", "", "", "-21.21962", "55.31513", "Indian/Reunion"),
("662187", "Zimnicea", "", "RO", "642", "35", "151978", "", "", "43.66667", "25.36667", "Europe/Bucharest"),
("662284", "Zarnesti", "", "RO", "642", "09", "40492", "", "", "45.56093", "25.31787", "Europe/Bucharest"),
("662334", "Zalau", "Залэу", "RO", "642", "31", "", "", "", "47.2", "23.05", "Europe/Bucharest"),
("662432", "Vulcan", "", "RO", "642", "21", "", "", "", "45.38333", "23.26667", "Europe/Bucharest"),
("662476", "Voluntari", "Волунтари", "RO", "642", "43", "179551", "", "", "44.49002", "26.17338", "Europe/Bucharest"),
("662699", "Viseu de Sus", "", "RO", "642", "25", "", "", "", "47.71667", "24.43333", "Europe/Bucharest"),
("663100", "Vatra Dornei", "", "RO", "642", "34", "146744", "", "", "47.35", "25.36667", "Europe/Bucharest"),
("663118", "Vaslui", "Васлуй", "RO", "642", "38", "", "", "", "46.63333", "27.73333", "Europe/Bucharest"),
("664074", "Urziceni", "", "RO", "642", "22", "100683", "", "", "44.71667", "26.63333", "Europe/Bucharest"),
("664437", "Turnu Magurele", "", "RO", "642", "35", "151683", "", "", "43.75", "24.86667", "Europe/Bucharest"),
("664460", "Turda", "Турда", "RO", "642", "13", "", "", "", "46.56667", "23.78333", "Europe/Bucharest"),
("664518", "Tulcea", "Тулча", "RO", "642", "37", "159614", "", "", "45.16667", "28.8", "Europe/Bucharest"),
("664963", "Tarnaveni", "", "RO", "642", "27", "114925", "", "", "46.33191", "24.29662", "Europe/Bucharest"),
("665000", "Targu Secuiesc", "", "RO", "642", "15", "63740", "", "", "46", "26.13333", "Europe/Bucharest"),
("665003", "Targu Neamt", "", "RO", "642", "28", "121055", "", "", "47.2", "26.36667", "Europe/Bucharest"),
("665004", "Targu-Mures", "Тыргу-Муреш", "RO", "642", "27", "", "", "", "46.54245", "24.55747", "Europe/Bucharest"),
("665010", "Targu Jiu", "Тыргу-Жиу", "RO", "642", "19", "", "", "", "45.05", "23.28333", "Europe/Bucharest"),
("665024", "Targoviste", "", "RO", "642", "16", "65342", "", "", "44.92543", "25.4567", "Europe/Bucharest"),
("665087", "Timisoara", "Тимишоара", "RO", "642", "36", "", "", "", "45.75372", "21.22571", "Europe/Bucharest"),
("665355", "Tecuci", "Текуч", "RO", "642", "18", "75203", "", "", "45.84973", "27.43441", "Europe/Bucharest"),
("665850", "Suceava", "Сучава", "RO", "642", "34", "", "", "", "47.63333", "26.25", "Europe/Bucharest"),
("666767", "Slatina", "Слатина", "RO", "642", "29", "125347", "", "", "44.43333", "24.36667", "Europe/Bucharest"),
("667101", "Simleu Silvaniei", "", "RO", "642", "31", "139884", "", "", "47.23333", "22.8", "Europe/Bucharest"),
("667227", "Sighetu Marmatiei", "", "RO", "642", "25", "106559", "", "", "47.93195", "23.88603", "Europe/Bucharest"),
("667268", "Sibiu", "Сибиу", "RO", "642", "33", "143450", "", "", "45.8", "24.15", "Europe/Bucharest"),
("667303", "Sfantu-Gheorghe", "Сфэнту-Георг", "RO", "642", "15", "63394", "", "", "45.86667", "25.78333", "Europe/Bucharest"),
("667526", "Sebes", "Себеш", "RO", "642", "01", "1874", "", "", "45.95646", "23.571", "Europe/Bucharest"),
("667873", "Satu Mare", "Сату-Маре", "RO", "642", "32", "136483", "", "", "47.8", "22.88333", "Europe/Bucharest"),
("668129", "Salonta", "Салонта", "RO", "642", "05", "26975", "", "", "46.8", "21.65", "Europe/Bucharest"),
("668314", "Sacele", "Сэчеле", "RO", "642", "09", "40438", "", "", "45.61674", "25.71101", "Europe/Bucharest"),
("668605", "Rosiori de Vede", "", "RO", "642", "35", "", "", "", "44.11667", "24.98333", "Europe/Bucharest"),
("668732", "Roman", "Роман", "RO", "642", "28", "120860", "", "", "46.91667", "26.91667", "Europe/Bucharest"),
("668828", "Rasnov", "", "RO", "642", "09", "40367", "", "", "45.58333", "25.45", "Europe/Bucharest"),
("668872", "Ramnicu Valcea", "Рымнику-Вылча", "RO", "642", "39", "167473", "", "", "45.1", "24.36667", "Europe/Bucharest"),
("668873", "Ramnicu Sarat", "", "RO", "642", "11", "44845", "", "", "45.38333", "27.05", "Europe/Bucharest"),
("668954", "Resita", "", "RO", "642", "12", "", "", "", "45.30083", "21.88917", "Europe/Bucharest"),
("668995", "Reghin-Sat", "", "RO", "642", "27", "", "", "", "46.78333", "24.71667", "Europe/Bucharest"),
("669289", "Radauti", "Рэдэуци", "RO", "642", "34", "146263", "", "", "47.85", "25.91667", "Europe/Bucharest"),
("669870", "Popesti-Leordeni", "", "RO", "642", "43", "179533", "", "", "44.38333", "26.16667", "Europe/Bucharest"),
("670474", "Ploiesti", "", "RO", "642", "30", "", "", "", "44.95", "26.01667", "Europe/Bucharest"),
("670609", "Pitesti", "", "RO", "642", "03", "13819", "", "", "44.85", "24.86667", "Europe/Bucharest"),
("670889", "Piatra Neamt", "", "RO", "642", "28", "", "", "", "46.91667", "26.33333", "Europe/Bucharest"),
("670938", "Petrosani", "Петрошани", "RO", "642", "21", "86990", "", "", "45.41667", "23.36667", "Europe/Bucharest"),
("670969", "Petrila", "", "RO", "642", "21", "87077", "", "", "45.45", "23.41667", "Europe/Bucharest"),
("671382", "Pantelimon", "", "RO", "642", "43", "179515", "", "", "44.45", "26.2", "Europe/Bucharest"),
("671757", "Orastie", "Орэштие", "RO", "642", "21", "87638", "", "", "45.83333", "23.2", "Europe/Bucharest"),
("671768", "Oradea", "Орадя", "RO", "642", "05", "27436", "", "", "47.06667", "21.93333", "Europe/Bucharest"),
("671832", "Oltenita", "Олтенице", "RO", "642", "41", "100610", "", "", "44.08333", "26.63333", "Europe/Bucharest"),
("671964", "Odorheiu Secuiesc", "Одорхею-Секуйеск", "RO", "642", "20", "83133", "", "", "46.3", "25.3", "Europe/Bucharest"),
("672024", "Ocna Mures", "", "RO", "642", "01", "1794", "", "", "46.38333", "23.85", "Europe/Bucharest"),
("672486", "Navodari", "Нэводари", "RO", "642", "14", "60507", "", "", "44.31667", "28.6", "Europe/Bucharest"),
("672757", "Motru", "", "RO", "642", "19", "78141", "", "", "44.80333", "22.97194", "Europe/Bucharest"),
("672862", "Moreni", "", "RO", "642", "16", "65841", "", "", "44.98301", "25.64415", "Europe/Bucharest"),
("672926", "Moinesti", "", "RO", "642", "04", "20876", "", "", "46.47523", "26.48907", "Europe/Bucharest"),
("673033", "Mizil", "Мизил", "RO", "642", "30", "131407", "", "", "45.01667", "26.45", "Europe/Bucharest"),
("673441", "Miercurea-Ciuc", "Меркуря-Чук", "RO", "642", "20", "83320", "", "", "46.35", "25.8", "Europe/Bucharest"),
("673634", "Medias", "", "RO", "642", "33", "143619", "", "", "46.16667", "24.35", "Europe/Bucharest"),
("673636", "Medgidia", "Меджидия", "RO", "642", "14", "60847", "", "", "44.25", "28.28333", "Europe/Bucharest"),
("673816", "Margita", "", "RO", "642", "05", "", "", "", "47.35", "22.33333", "Europe/Bucharest"),
("673921", "Mangalia", "Мангалия", "RO", "642", "14", "60482", "", "", "43.8", "28.58333", "Europe/Bucharest"),
("674295", "Lupeni", "Лупени", "RO", "642", "21", "", "", "", "45.36029", "23.23832", "Europe/Bucharest"),
("674531", "Lugoj", "Лугож", "RO", "642", "36", "155350", "", "", "45.68861", "21.90306", "Europe/Bucharest"),
("674541", "Ludus", "", "RO", "642", "27", "114710", "", "", "46.48333", "24.1", "Europe/Bucharest"),
("675810", "Iasi", "Яссы", "RO", "642", "23", "95060", "", "", "47.16667", "27.6", "Europe/Bucharest"),
("675892", "Husi", "Гуси", "RO", "642", "38", "161829", "", "", "46.67361", "28.05944", "Europe/Bucharest"),
("675918", "Hunedoara", "Хунедоара", "RO", "642", "21", "", "", "", "45.75", "22.9", "Europe/Bucharest"),
("676527", "Gura Humorului", "", "RO", "642", "34", "146584", "", "", "47.55", "25.9", "Europe/Bucharest"),
("677106", "Giurgiu", "", "RO", "642", "42", "", "", "", "43.88333", "25.96667", "Europe/Bucharest"),
("677429", "Gherla", "Герла", "RO", "642", "13", "55384", "", "", "47.03333", "23.91667", "Europe/Bucharest"),
("677458", "Gheorgheni", "", "RO", "642", "20", "83561", "", "", "46.72292", "25.60055", "Europe/Bucharest"),
("677697", "Galati", "Галац", "RO", "642", "18", "", "", "", "45.45", "28.05", "Europe/Bucharest"),
("677742", "Gaesti", "", "RO", "642", "16", "65681", "", "", "44.71667", "25.31667", "Europe/Bucharest"),
("678015", "Focsani", "", "RO", "642", "40", "178750", "", "", "45.7", "27.18333", "Europe/Bucharest"),
("678261", "Filiasi", "", "RO", "642", "17", "70414", "", "", "44.55", "23.51667", "Europe/Bucharest"),
("678301", "Fetesti-Gara", "", "RO", "642", "22", "92701", "", "", "44.4196", "27.82536", "Europe/Bucharest"),
("678306", "Fetesti", "", "RO", "642", "22", "92701", "", "", "44.38333", "27.83333", "Europe/Bucharest"),
("678459", "Falticeni", "Фэлтичени", "RO", "642", "34", "146539", "", "", "47.45", "26.3", "Europe/Bucharest"),
("678499", "Fogarasch", "Фэгэраш", "RO", "642", "09", "", "", "", "45.85", "24.96667", "Europe/Bucharest"),
("678817", "Drobeta-Turnu Severin", "Дробета-Турну-Северин", "RO", "642", "26", "109773", "", "", "44.63194", "22.65611", "Europe/Bucharest"),
("678978", "Dragasani", "Дрэгэшани", "RO", "642", "39", "167981", "", "", "44.65", "24.26667", "Europe/Bucharest"),
("679065", "Dorohoi", "Дорохой", "RO", "642", "07", "36006", "", "", "47.95", "26.4", "Europe/Bucharest"),
("679452", "Deva", "Дева", "RO", "642", "21", "86687", "", "", "45.88333", "22.9", "Europe/Bucharest"),
("679550", "Dej", "Дей", "RO", "642", "13", "55008", "", "", "47.15", "23.86667", "Europe/Bucharest"),
("679907", "Curtea de Arges", "", "RO", "642", "03", "13622", "", "", "45.13422", "24.67409", "Europe/Bucharest"),
("679995", "Cugir", "", "RO", "642", "01", "1696", "", "", "45.83651", "23.36998", "Europe/Bucharest"),
("680332", "Craiova", "Крайова", "RO", "642", "17", "", "", "", "44.31667", "23.8", "Europe/Bucharest"),
("680897", "Corabia", "", "RO", "642", "29", "125542", "", "", "43.78333", "24.5", "Europe/Bucharest"),
("680963", "Constanta", "Констанца", "RO", "642", "14", "60419", "", "", "44.18073", "28.63432", "Europe/Bucharest"),
("681017", "Comanesti", "", "RO", "642", "04", "20821", "", "", "46.42135", "26.43645", "Europe/Bucharest"),
("681179", "Codlea", "", "RO", "642", "09", "", "", "", "45.7", "25.45", "Europe/Bucharest"),
("681290", "Cluj-Napoca", "Клуж-Напока", "RO", "642", "13", "54975", "", "", "46.76667", "23.6", "Europe/Bucharest"),
("681502", "Cisnadie", "", "RO", "642", "33", "143735", "", "", "45.71667", "24.15", "Europe/Bucharest"),
("681845", "Campulung Moldovenesc", "", "RO", "642", "34", "146502", "", "", "47.53333", "25.56667", "Europe/Bucharest"),
("681862", "Campina", "Кымпина", "RO", "642", "30", "131256", "", "", "45.12619", "25.73496", "Europe/Bucharest"),
("681865", "Campia Turzii", "", "RO", "642", "13", "55357", "", "", "46.55", "23.88333", "Europe/Bucharest"),
("682321", "Cernavoda", "", "RO", "642", "14", "60776", "", "", "44.36667", "28.01667", "Europe/Bucharest"),
("682685", "Carei", "Карей", "RO", "642", "32", "", "", "", "47.68333", "22.46667", "Europe/Bucharest"),
("682729", "Caransebes", "Карансебеше", "RO", "642", "12", "51010", "", "", "45.41667", "22.21667", "Europe/Bucharest"),
("682747", "Caracal", "", "RO", "642", "29", "125472", "", "", "44.11667", "24.35", "Europe/Bucharest"),
("683034", "Calafat", "", "RO", "642", "17", "70352", "", "", "43.99111", "22.93278", "Europe/Bucharest"),
("683123", "Buzau", "Бузэу", "RO", "642", "11", "", "", "", "45.15", "26.83333", "Europe/Bucharest"),
("683365", "Buhusi", "", "RO", "642", "04", "20778", "", "", "46.71667", "26.7", "Europe/Bucharest"),
("683394", "Buftea", "", "RO", "642", "43", "100576", "", "", "44.56139", "25.94889", "Europe/Bucharest"),
("683506", "Bucharest", "Бухарест", "RO", "642", "10", "179132", "", "", "44.43225", "26.10626", "Europe/Bucharest"),
("683760", "Breaza", "", "RO", "642", "30", "131103", "", "", "45.18333", "25.66667", "Europe/Bucharest"),
("683844", "Brasov", "Брашов", "RO", "642", "09", "", "", "", "45.64861", "25.60613", "Europe/Bucharest"),
("683902", "Braila", "", "RO", "642", "08", "42682", "", "", "45.26667", "27.98333", "Europe/Bucharest"),
("683974", "Brad", "", "RO", "642", "21", "87291", "", "", "46.13333", "22.78333", "Europe/Bucharest"),
("684039", "Botosani", "", "RO", "642", "07", "", "", "", "47.75", "26.66667", "Europe/Bucharest"),
("684156", "Borsa", "", "RO", "642", "25", "106746", "", "", "47.65527", "24.66328", "Europe/Bucharest"),
("684490", "Bocsa", "", "RO", "642", "12", "50969", "", "", "45.37333", "21.70917", "Europe/Bucharest"),
("684612", "Blaj", "Блай", "RO", "642", "01", "1348", "", "", "46.17508", "23.91578", "Europe/Bucharest"),
("684657", "Bistrita", "", "RO", "642", "06", "", "", "", "47.13316", "24.50011", "Europe/Bucharest"),
("684802", "Barlad", "", "RO", "642", "38", "161794", "", "", "46.23333", "27.66667", "Europe/Bucharest"),
("685586", "Bals", "", "RO", "642", "29", "125418", "", "", "44.35", "24.1", "Europe/Bucharest"),
("685785", "Bailesti", "", "RO", "642", "17", "70316", "", "", "44.01667", "23.35", "Europe/Bucharest"),
("685811", "Baicoi", "", "RO", "642", "30", "130981", "", "", "45.03333", "25.85", "Europe/Bucharest"),
("685823", "Baia Sprie", "", "RO", "642", "25", "106684", "", "", "47.66189", "23.69215", "Europe/Bucharest"),
("685826", "Baia Mare", "Бая-Маре", "RO", "642", "25", "", "", "", "47.65729", "23.56808", "Europe/Bucharest"),
("685948", "Bacau", "", "RO", "642", "04", "20297", "", "", "46.56667", "26.9", "Europe/Bucharest"),
("686254", "Arad", "Арад", "RO", "642", "02", "", "", "", "46.18333", "21.31667", "Europe/Bucharest"),
("686502", "Alexandria", "", "RO", "642", "35", "", "", "", "43.98333", "25.33333", "Europe/Bucharest"),
("686578", "Alba Iulia", "Алба-Юлия", "RO", "642", "01", "1017", "", "", "46.06667", "23.58333", "Europe/Bucharest"),
("686590", "Aiud", "Айуд", "RO", "642", "01", "1213", "", "", "46.31006", "23.72128", "Europe/Bucharest"),
("686669", "Adjud", "", "RO", "642", "40", "", "", "", "46.1", "27.16667", "Europe/Bucharest"),
("6697993", "Baia Mare", "Бая-Маре", "RO", "642", "32", "", "", "", "47.65331", "23.57949", "Europe/Bucharest"),
("6945426", "Pascani", "", "RO", "642", "23", "95391", "", "", "47.2469", "26.72291", "Europe/Bucharest"),
("7733099", "Mioveni", "", "RO", "642", "03", "13301", "", "", "44.95905", "24.94198", "Europe/Bucharest"),
("8436351", "Sighisoara", "Сигишоара", "RO", "642", "27", "114514", "", "", "46.22141", "24.79279", "Europe/Bucharest"),
("8581467", "Slobozia", "", "RO", "642", "22", "92658", "", "", "44.5647", "27.3633", "Europe/Bucharest"),
("783814", "Zrenjanin", "Зренянин", "RS", "688", "VO", "2", "80152", "", "45.38361", "20.38194", "Europe/Belgrade"),
("783920", "Zemun", "Земун", "RS", "688", "SE", "0", "70157", "", "44.84306", "20.40111", "Europe/Belgrade"),
("784024", "Zajecar", "Заечар", "RS", "688", "SE", "15", "70556", "", "43.90358", "22.26405", "Europe/Belgrade"),
("784136", "Vrsac", "Вршац", "RS", "688", "VO", "4", "784135", "", "45.11667", "21.30361", "Europe/Belgrade"),
("784227", "Vranje", "Вране", "RS", "688", "SE", "24", "70432", "", "42.55139", "21.90028", "Europe/Belgrade"),
("784873", "Trstenik", "Трстеник", "RS", "688", "SE", "19", "71170", "", "43.61694", "21.0025", "Europe/Belgrade"),
("785559", "Stara Pazova", "", "RS", "688", "VO", "7", "80420", "", "44.985", "20.16083", "Europe/Belgrade"),
("785615", "Sremcica", "", "RS", "688", "SE", "", "", "", "44.67653", "20.39232", "Europe/Belgrade"),
("785753", "Smederevska Palanka", "Смедеревска-Паланка", "RS", "688", "SE", "10", "71102", "", "44.36548", "20.95885", "Europe/Belgrade"),
("785756", "Smederevo", "Смедерево", "RS", "688", "SE", "10", "71099", "", "44.66278", "20.93", "Europe/Belgrade"),
("785965", "Senta", "Сента", "RS", "688", "VO", "3", "80365", "", "45.9275", "20.07722", "Europe/Belgrade"),
("786690", "Prokuplje", "Прокупле", "RS", "688", "SE", "21", "70998", "", "43.23417", "21.58806", "Europe/Belgrade"),
("786827", "Pozarevac", "Пожаревац", "RS", "688", "SE", "11", "70947", "", "44.62133", "21.18782", "Europe/Belgrade"),
("787050", "Pirot", "Пирот", "RS", "688", "SE", "22", "70939", "", "43.15306", "22.58611", "Europe/Belgrade"),
("787237", "Pancevo", "Панчево", "RS", "688", "VO", "4", "787236", "", "44.87083", "20.64028", "Europe/Belgrade"),
("787516", "Obrenovac", "", "RS", "688", "SE", "0", "70190", "", "44.65486", "20.20017", "Europe/Belgrade"),
("787595", "Novi Pazar", "Нови-Пазар", "RS", "688", "SE", "18", "70874", "", "43.13667", "20.51222", "Europe/Belgrade"),
("787615", "Nova Pazova", "", "RS", "688", "VO", "", "", "", "44.94366", "20.21931", "Europe/Belgrade"),
("787657", "Nis", "Ниш", "RS", "688", "SE", "20", "", "", "43.32472", "21.90333", "Europe/Belgrade"),
("787718", "Negotin", "Неготин", "RS", "688", "SE", "14", "70840", "", "44.22639", "22.53083", "Europe/Belgrade"),
("788709", "Leskovac", "Лесковац", "RS", "688", "SE", "23", "70726", "", "42.99806", "21.94611", "Europe/Belgrade"),
("788771", "Lazarevac", "Лазаревац", "RS", "688", "SE", "0", "70165", "", "44.38534", "20.2557", "Europe/Belgrade"),
("788975", "Krusevac", "Крушевац", "RS", "688", "SE", "19", "70670", "", "43.58", "21.33389", "Europe/Belgrade"),
("789107", "Kraljevo", "Кралево", "RS", "688", "SE", "18", "70653", "", "43.72583", "20.68944", "Europe/Belgrade"),
("789128", "Kragujevac", "Крагуевац", "RS", "688", "SE", "12", "70645", "", "44.01667", "20.91667", "Europe/Belgrade"),
("789518", "Kikinda", "Кикинда", "RS", "688", "VO", "3", "80209", "", "45.82972", "20.46528", "Europe/Belgrade"),
("789923", "Jagodina", "Ягодина", "RS", "688", "SE", "13", "71048", "", "43.97713", "21.26121", "Europe/Belgrade"),
("790015", "Ingija", "Инджия", "RS", "688", "VO", "7", "80179", "", "45.04816", "20.08165", "Europe/Belgrade"),
("790367", "Gornji Milanovac", "", "RS", "688", "SE", "17", "70483", "", "44.02603", "20.46152", "Europe/Belgrade"),
("791678", "Cuprija", "Чуприя", "RS", "688", "SE", "13", "71200", "", "43.9275", "21.37", "Europe/Belgrade"),
("792078", "Cacak", "Чачак", "RS", "688", "SE", "17", "71242", "", "43.89139", "20.34972", "Europe/Belgrade"),
("792456", "Bor", "Бор", "RS", "688", "SE", "14", "70327", "", "44.07488", "22.09591", "Europe/Belgrade"),
("792680", "Belgrade", "Белград", "RS", "688", "SE", "", "", "", "44.80401", "20.46513", "Europe/Belgrade"),
("792814", "Becej", "Бечей", "RS", "688", "VO", "6", "3204390", "", "45.61632", "20.03331", "Europe/Belgrade"),
("793111", "Arangelovac", "Аранджеловац", "RS", "688", "SE", "12", "70033", "", "44.30694", "20.56", "Europe/Belgrade"),
("3187297", "Vrbas", "Врбас", "RS", "688", "VO", "6", "3187295", "", "45.57139", "19.64083", "Europe/Belgrade"),
("3188402", "Valjevo", "Валево", "RS", "688", "SE", "9", "70360", "", "44.27513", "19.89821", "Europe/Belgrade"),
("3188434", "Uzice", "Ужице", "RS", "688", "SE", "16", "71145", "", "43.85861", "19.84878", "Europe/Belgrade"),
("3189595", "Subotica", "Суботица", "RS", "688", "VO", "1", "80438", "", "46.1", "19.66667", "Europe/Belgrade"),
("3190103", "Sremska Mitrovica", "", "RS", "688", "VO", "7", "80403", "", "44.97639", "19.61222", "Europe/Belgrade"),
("3190342", "Sombor", "Сомбор", "RS", "688", "VO", "5", "3190341", "", "45.77417", "19.11222", "Europe/Belgrade"),
("3191376", "Sabac", "Шабац", "RS", "688", "SE", "8", "71269", "", "44.74667", "19.69", "Europe/Belgrade"),
("3191429", "Ruma", "Рума", "RS", "688", "VO", "7", "80357", "", "45.00806", "19.82222", "Europe/Belgrade"),
("3194360", "Novi Sad", "Нови-Сад", "RS", "688", "VO", "6", "3194359", "", "45.25167", "19.83694", "Europe/Belgrade"),
("3204672", "Backa Topola", "", "RS", "688", "VO", "1", "80071", "", "45.81516", "19.6318", "Europe/Belgrade"),
("3204674", "Backa Palanka", "Бачка-Паланка", "RS", "688", "VO", "6", "3204673", "", "45.25083", "19.39194", "Europe/Belgrade"),
("3204793", "Apatin", "Апатин", "RS", "688", "VO", "5", "3204792", "", "45.67111", "18.98472", "Europe/Belgrade"),
("6619277", "Knjazevac", "", "RS", "688", "SE", "15", "70602", "", "43.56634", "22.25701", "Europe/Belgrade"),
("452949", "Udomlya", "Удомля", "RU", "643", "77", "", "", "", "57.87944", "34.9925", "Europe/Moscow"),
("461698", "Sosnovka", "Сосновка", "RU", "643", "66", "", "", "", "60.01667", "30.35", "Europe/Moscow"),
("461699", "Sasovo", "Сасово", "RU", "643", "62", "", "", "", "54.35369", "41.91986", "Europe/Moscow"),
("461740", "Zyuzino", "Зюзино", "RU", "643", "48", "", "", "", "55.65608", "37.56846", "Europe/Moscow"),
("461835", "Zyablikovo", "Зябликово", "RU", "643", "48", "", "", "", "55.61667", "37.76667", "Europe/Moscow"),
("461910", "Zverevo", "Зверево", "RU", "643", "61", "", "", "", "48.02108", "40.12282", "Europe/Moscow"),
("461920", "Zvenigorod", "Звенигород", "RU", "643", "47", "", "", "", "55.73402", "36.85918", "Europe/Moscow"),
("462444", "Zlatoust", "Златоуст", "RU", "643", "13", "", "", "", "55.17111", "59.65083", "Asia/Yekaterinburg"),
("462522", "Zimovniki", "Зимовники", "RU", "643", "61", "", "", "", "47.1474", "42.4721", "Europe/Moscow"),
("462745", "Zhulebino", "Жулебино", "RU", "643", "48", "", "", "", "55.7", "37.85", "Europe/Moscow"),
("462755", "Zhukovskiy", "Жуковский", "RU", "643", "47", "", "", "", "55.59528", "38.12028", "Europe/Moscow"),
("462822", "Zhukovka", "Жуковка", "RU", "643", "10", "", "", "", "53.53395", "33.72798", "Europe/Moscow"),
("462984", "Zhirnovsk", "Жирновск", "RU", "643", "84", "", "", "", "50.98448", "44.77347", "Europe/Volgograd"),
("463082", "Zhigulevsk", "Жигулевск", "RU", "643", "65", "", "", "", "53.39972", "49.49528", "Europe/Samara"),
("463217", "Zherdevka", "Жердевка", "RU", "643", "72", "", "", "", "51.84861", "41.46056", "Europe/Moscow"),
("463340", "Zheleznovodsk", "Железноводск", "RU", "643", "70", "", "", "", "44.13944", "43.01972", "Europe/Moscow"),
("463343", "Zheleznogorsk", "Железногорск", "RU", "643", "41", "", "", "", "52.331", "35.3711", "Europe/Moscow"),
("463355", "Zheleznodorozhnyy", "Железнодорожный", "RU", "643", "47", "", "", "", "55.744", "38.01684", "Europe/Moscow"),
("463637", "Zernograd", "Зерноград", "RU", "643", "61", "", "", "", "46.84518", "40.30834", "Europe/Moscow"),
("463824", "Zelenokumsk", "Зеленокумск", "RU", "643", "70", "", "", "", "44.40694", "43.88056", "Europe/Moscow"),
("463829", "Zelenograd", "Зеленоград", "RU", "643", "48", "", "", "", "55.9825", "37.18139", "Europe/Moscow"),
("463835", "Zelenodolsk", "Зеленодольск", "RU", "643", "73", "Zelenodol'skiy Rayon", "", "", "55.84376", "48.51784", "Europe/Moscow"),
("463885", "Zelenchukskaya", "Зеленчукская", "RU", "643", "27", "", "", "", "43.85804", "41.5894", "Europe/Moscow"),
("464101", "Zavolzh'ye", "Заволжье", "RU", "643", "51", "", "", "", "56.64051", "43.39446", "Europe/Moscow"),
("464625", "Zarechnyy", "Заречный", "RU", "643", "57", "", "", "", "53.20356", "45.19227", "Europe/Moscow"),
("464687", "Zaraysk", "Зарайск", "RU", "643", "47", "", "", "", "54.7605", "38.87841", "Europe/Moscow"),
("464790", "Zapolyarnyy", "Заполярный", "RU", "643", "49", "", "", "", "69.41541", "30.81355", "Europe/Moscow"),
("465057", "Zamoskvorech'ye", "Замоскворечье", "RU", "643", "48", "", "", "", "55.73333", "37.63333", "Europe/Moscow"),
("465543", "Zainsk", "Заинск", "RU", "643", "73", "", "", "", "55.3195", "52.06942", "Europe/Moscow"),
("466215", "Yur'yev-Pol'skiy", "Юрьев-Польский", "RU", "643", "83", "", "", "", "56.50339", "39.67911", "Europe/Moscow"),
("466806", "Yoshkar-Ola", "Йошкар-Ола", "RU", "643", "45", "", "", "", "56.63877", "47.89078", "Europe/Moscow"),
("466885", "Yeysk", "Ейск", "RU", "643", "38", "", "", "", "46.7055", "38.2739", "Europe/Moscow"),
("466989", "Yessentukskaya", "Ессентукская", "RU", "643", "70", "", "", "", "44.0328", "42.8813", "Europe/Moscow"),
("466990", "Yessentuki", "Ессентуки", "RU", "643", "70", "", "", "", "44.04444", "42.86056", "Europe/Moscow"),
("467120", "Yershov", "Ершов", "RU", "643", "67", "", "", "", "51.3513", "48.2766", "Europe/Volgograd"),
("467525", "Yemva", "Железнодорожный", "RU", "643", "34", "", "", "", "62.58999", "50.85939", "Europe/Moscow"),
("467854", "Yelizavetinskaya", "Елизаветинская", "RU", "643", "38", "", "", "", "45.04616", "38.79491", "Europe/Moscow"),
("467978", "Yelets", "Елец", "RU", "643", "43", "", "", "", "52.62366", "38.50169", "Europe/Moscow"),
("468063", "Yelan'", "Елань", "RU", "643", "84", "", "", "", "50.949", "43.73781", "Europe/Volgograd"),
("468082", "Yelabuga", "Елабуга", "RU", "643", "73", "", "", "", "55.76127", "52.06493", "Europe/Moscow"),
("468250", "Yegor'yevsk", "Егорьевск", "RU", "643", "47", "", "", "", "55.38283", "39.03233", "Europe/Moscow"),
("468307", "Yegorlykskaya", "Егорлыкская", "RU", "643", "61", "", "", "", "46.56564", "40.65621", "Europe/Moscow"),
("468390", "Yefremov", "Ефремов", "RU", "643", "76", "", "", "", "53.14806", "38.09924", "Europe/Moscow"),
("468657", "Yasnyy", "Ясный", "RU", "643", "55", "", "", "", "51.0333", "59.8742", "Asia/Yekaterinburg"),
("468671", "Yasnogorsk", "Ясногорск", "RU", "643", "76", "", "", "", "54.48082", "37.69854", "Europe/Moscow"),
("468809", "Yasenevo", "Ясенево", "RU", "643", "48", "", "", "", "55.60686", "37.51991", "Europe/Moscow"),
("468866", "Yartsevo", "Ярцево", "RU", "643", "69", "", "", "", "55.06667", "32.69639", "Europe/Moscow"),
("468902", "Yaroslavl", "Ярославль", "RU", "643", "88", "", "", "", "57.62987", "39.87368", "Europe/Moscow"),
("469005", "Yaransk", "Яранск", "RU", "643", "33", "", "", "", "57.30331", "47.88611", "Europe/Volgograd"),
("469178", "Yanaul", "Янаул", "RU", "643", "08", "", "", "", "56.2751", "54.9338", "Asia/Yekaterinburg"),
("469844", "Yablonovskiy", "Яблоновский", "RU", "643", "01", "", "", "", "44.98901", "38.94324", "Europe/Moscow"),
("470252", "Vyshniy Volochek", "Вышний Волочек", "RU", "643", "77", "", "", "", "57.59125", "34.56453", "Europe/Moscow"),
("470338", "Vyselki", "Выселки", "RU", "643", "38", "", "", "", "45.58128", "39.66409", "Europe/Moscow"),
("470444", "Vyksa", "Выкса", "RU", "643", "51", "", "", "", "55.3175", "42.17444", "Europe/Moscow"),
("470451", "Vykhino-Zhulebino", "Выхино-Жулебино", "RU", "643", "48", "", "", "", "55.70196", "37.81178", "Europe/Moscow"),
("470546", "Vyborg", "Выборг", "RU", "643", "42", "", "", "", "60.70763", "28.75283", "Europe/Moscow"),
("470666", "Vyazniki", "Вязники", "RU", "643", "83", "", "", "", "56.24057", "42.15563", "Europe/Moscow"),
("470676", "Vyaz'ma", "Вязьма", "RU", "643", "69", "", "", "", "55.21039", "34.29508", "Europe/Moscow"),
("470734", "Vyatskiye Polyany", "Вятские Поляны", "RU", "643", "33", "", "", "", "56.22602", "51.06557", "Europe/Volgograd"),
("471101", "Vsevolozhsk", "Всеволожск", "RU", "643", "42", "", "", "", "60.01512", "30.67314", "Europe/Moscow"),
("471430", "Votkinsk", "Воткинск", "RU", "643", "80", "", "", "", "57.04865", "53.98717", "Europe/Samara"),
("471456", "Vostryakovo", "Востряково", "RU", "643", "47", "", "", "", "55.66667", "37.45", "Europe/Moscow"),
("471457", "Vostryakovo", "Востряково", "RU", "643", "47", "", "", "", "55.39934", "37.80829", "Europe/Moscow"),
("471656", "Voskresensk", "Воскресенск", "RU", "643", "47", "", "", "", "55.31733", "38.65264", "Europe/Moscow"),
("472045", "Voronezh", "Воронеж", "RU", "643", "86", "", "", "", "51.67204", "39.1843", "Europe/Moscow"),
("472072", "Altuf'yevskiy", "Алтуфьевский", "RU", "643", "48", "", "", "", "55.88333", "37.58333", "Europe/Moscow"),
("472079", "Vorob'yovo", "Воробьево", "RU", "643", "48", "", "", "", "55.71667", "37.53333", "Europe/Moscow"),
("472231", "Volzhskiy", "Волжский", "RU", "643", "84", "", "", "", "48.78583", "44.77973", "Europe/Volgograd"),
("472234", "Volzhsk", "Волжск", "RU", "643", "45", "", "", "", "55.86638", "48.3594", "Europe/Moscow"),
("472278", "Vol'sk", "Вольск", "RU", "643", "67", "", "", "", "52.04541", "47.37993", "Europe/Volgograd"),
("472433", "Volokolamsk", "Волоколамск", "RU", "643", "47", "472430", "", "", "56.03361", "35.96944", "Europe/Moscow"),
("472459", "Vologda", "Вологда", "RU", "643", "85", "", "", "", "59.2239", "39.88398", "Europe/Moscow"),
("472722", "Volkhov", "Волхов", "RU", "643", "42", "", "", "", "59.9258", "32.33819", "Europe/Moscow"),
("472732", "Nagornyy", "Нагорный", "RU", "643", "48", "", "", "", "55.65", "37.61667", "Europe/Moscow"),
("472750", "Volgorechensk", "Волгореченск", "RU", "643", "37", "", "", "", "57.43931", "41.15553", "Europe/Moscow"),
("472757", "Volgograd", "Волгоград", "RU", "643", "84", "", "", "", "48.71939", "44.50184", "Europe/Volgograd"),
("472761", "Volgodonsk", "Волгодонск", "RU", "643", "61", "", "", "", "47.51361", "42.15139", "Europe/Moscow"),
("473021", "Vnukovo", "Внуково", "RU", "643", "48", "", "", "", "55.6", "37.21667", "Europe/Moscow"),
("473127", "Novovladykino", "Нововладыкино", "RU", "643", "48", "", "", "", "55.85", "37.58333", "Europe/Moscow"),
("473247", "Vladimir", "Владимир", "RU", "643", "83", "", "", "", "56.13655", "40.39658", "Europe/Moscow"),
("473249", "Vladikavkaz", "Владикавказ", "RU", "643", "68", "", "", "", "43.03667", "44.66778", "Europe/Moscow"),
("473778", "Vidnoye", "Видное", "RU", "643", "47", "", "", "", "55.55239", "37.70966", "Europe/Moscow"),
("473788", "Vichuga", "Вичуга", "RU", "643", "21", "", "", "", "57.21276", "41.93012", "Europe/Moscow"),
("473972", "Veshnyaki", "Вешняки", "RU", "643", "48", "", "", "", "55.72393", "37.81952", "Europe/Moscow"),
("475777", "Vereshchagino", "Верещагино", "RU", "643", "90", "", "", "", "58.07894", "54.6557", "Asia/Yekaterinburg"),
("475881", "Venev", "Венёв", "RU", "643", "76", "", "", "", "54.35533", "38.26843", "Europe/Moscow"),
("475938", "Vel'sk", "Вельск", "RU", "643", "06", "", "", "", "61.07006", "42.0983", "Europe/Moscow"),
("476062", "Velikiy Ustyug", "Великий Устюг", "RU", "643", "85", "", "", "", "60.76186", "46.31352", "Europe/Moscow"),
("476077", "Velikiye Luki", "Великие Луки", "RU", "643", "60", "", "", "", "56.34", "30.54517", "Europe/Moscow"),
("476368", "Vatutino", "", "RU", "643", "48", "", "", "", "55.88441", "37.69055", "Europe/Moscow"),
("477192", "Valuyki", "Валуйки", "RU", "643", "09", "", "", "", "50.2035", "38.1067", "Europe/Moscow"),
("477301", "Valday", "Валдай", "RU", "643", "52", "", "", "", "57.97472", "33.2525", "Europe/Moscow"),
("477377", "Vagonoremont", "", "RU", "643", "48", "", "", "", "55.9", "37.55", "Europe/Moscow"),
("477494", "Uzlovaya", "Узловая", "RU", "643", "76", "", "", "", "53.98179", "38.17118", "Europe/Moscow"),
("477626", "Uvarovo", "Уварово", "RU", "643", "72", "", "", "", "51.98486", "42.26147", "Europe/Moscow"),
("477656", "Uva", "Ува", "RU", "643", "80", "", "", "", "56.99081", "52.18517", "Europe/Samara"),
("478044", "Ust'-Labinsk", "Усть-Лабинск", "RU", "643", "38", "", "", "", "45.21077", "39.68914", "Europe/Moscow"),
("478071", "Ust'-Katav", "Усть-Катав", "RU", "643", "13", "", "", "", "54.9366", "58.1757", "Asia/Yekaterinburg"),
("478130", "Ust'-Dzheguta", "Усть-Джегута", "RU", "643", "27", "", "", "", "44.0834", "41.9763", "Europe/Moscow"),
("478317", "Usman'", "Усмань", "RU", "643", "43", "", "", "", "52.04662", "39.7288", "Europe/Moscow"),
("478544", "Uryupinsk", "Урюпинск", "RU", "643", "84", "", "", "", "50.8047", "42.0138", "Europe/Volgograd"),
("478581", "Urus-Martan", "Урус-Мартан", "RU", "643", "12", "", "", "", "43.13053", "45.53791", "Europe/Moscow"),
("478724", "Uritsk", "Урицк", "RU", "643", "66", "", "", "", "59.83889", "30.17528", "Europe/Moscow"),
("479028", "Unecha", "Унеча", "RU", "643", "10", "", "", "", "52.84591", "32.67394", "Europe/Moscow"),
("479123", "Ulyanovsk", "Ульяновск", "RU", "643", "81", "479105", "", "", "54.32824", "48.38657", "Europe/Moscow"),
("479411", "Ukhta", "Ухта", "RU", "643", "34", "", "", "", "63.56705", "53.68348", "Europe/Moscow"),
("479532", "Uglich", "Углич", "RU", "643", "88", "", "", "", "57.5275", "38.33167", "Europe/Moscow"),
("479561", "Ufa", "Уфа", "RU", "643", "08", "", "", "", "54.74306", "55.96779", "Asia/Yekaterinburg"),
("479687", "Uchkeken", "Учкекен", "RU", "643", "27", "", "", "", "43.93778", "42.51167", "Europe/Moscow"),
("479703", "Uchaly", "Учалы", "RU", "643", "08", "", "", "", "54.35806", "59.43611", "Asia/Yekaterinburg"),
("479704", "Uchaly", "Учалы", "RU", "643", "08", "", "", "", "54.2996", "59.4521", "Asia/Yekaterinburg"),
("479933", "Tyrnyauz", "Тырныауз", "RU", "643", "22", "", "", "", "43.38278", "42.91833", "Europe/Moscow"),
("480060", "Tver", "Тверь", "RU", "643", "77", "", "", "", "56.85836", "35.90057", "Europe/Moscow"),
("480089", "Tuymazy", "Туймазы", "RU", "643", "08", "", "", "", "54.60666", "53.7097", "Asia/Yekaterinburg"),
("480122", "Tutayev", "Тутаев", "RU", "643", "88", "", "", "", "57.88529", "39.5406", "Europe/Moscow"),
("480562", "Tula", "Тула", "RU", "643", "76", "", "", "", "54.19609", "37.61822", "Europe/Moscow"),
("480685", "Tuchkovo", "Тучково", "RU", "643", "47", "", "", "", "55.60111", "36.46806", "Europe/Moscow"),
("480716", "Tuapse", "Туапсе", "RU", "643", "38", "", "", "", "44.1053", "39.0802", "Europe/Moscow"),
("480876", "Tsimlyansk", "Цимлянск", "RU", "643", "61", "", "", "", "47.64611", "42.10194", "Europe/Moscow"),
("481350", "Trubchevsk", "Трубчевск", "RU", "643", "10", "", "", "", "52.5798", "33.7644", "Europe/Moscow"),
("481453", "Troparevo", "Тропарёво", "RU", "643", "48", "", "", "", "55.65625", "37.48496", "Europe/Moscow"),
("481605", "Troitskaya", "Троицкая", "RU", "643", "19", "", "", "", "43.30664", "44.98395", "Europe/Moscow"),
("481608", "Troitsk", "Троицк", "RU", "643", "47", "", "", "", "55.48498", "37.30736", "Europe/Moscow"),
("481964", "Tosno", "Тосно", "RU", "643", "42", "", "", "", "59.54", "30.8775", "Europe/Moscow"),
("481985", "Torzhok", "Торжок", "RU", "643", "77", "", "", "", "57.0436", "34.96221", "Europe/Moscow"),
("482260", "Tomilino", "Томилино", "RU", "643", "47", "", "", "", "55.6562", "37.94713", "Europe/Moscow"),
("482283", "Tol'yatti", "Тольятти", "RU", "643", "65", "", "", "", "53.5303", "49.3461", "Europe/Samara"),
("482965", "Timashevsk", "Тимашёвск", "RU", "643", "38", "", "", "", "45.61694", "38.94528", "Europe/Moscow"),
("483019", "Tikhvin", "Тихвин", "RU", "643", "42", "", "", "", "59.64511", "33.52937", "Europe/Moscow"),
("483029", "Tikhoretsk", "Тихорецк", "RU", "643", "38", "", "", "", "45.85472", "40.12528", "Europe/Moscow"),
("483137", "Teykovo", "Тейково", "RU", "643", "21", "", "", "", "56.85796", "40.53692", "Europe/Moscow"),
("483495", "Terek", "Терек", "RU", "643", "22", "", "", "", "43.48333", "44.13611", "Europe/Moscow"),
("483551", "Tyoply Stan", "Тёплый Стан", "RU", "643", "48", "", "", "", "55.62047", "37.49338", "Europe/Moscow"),
("483661", "Temryuk", "Темрюк", "RU", "643", "38", "", "", "", "45.27055", "37.38716", "Europe/Moscow"),
("483826", "Tekstil'shchiki", "Текстильщики", "RU", "643", "48", "", "", "", "55.70033", "37.74271", "Europe/Moscow"),
("483883", "Tbilisskaya", "Тбилисская", "RU", "643", "38", "", "", "", "45.36333", "40.19", "Europe/Moscow"),
("484646", "Tambov", "Тамбов", "RU", "643", "72", "", "", "", "52.73169", "41.44326", "Europe/Moscow"),
("484856", "Agidel'", "Агидель", "RU", "643", "08", "", "", "", "55.9077", "53.9355", "Asia/Yekaterinburg"),
("484907", "Taganrog", "Таганрог", "RU", "643", "61", "", "", "", "47.23617", "38.89688", "Europe/Moscow"),
("484912", "Taganskiy", "Таганский", "RU", "643", "48", "", "", "", "55.73333", "37.66667", "Europe/Moscow"),
("484972", "Syzran'", "Сызрань", "RU", "643", "65", "", "", "", "53.1585", "48.4681", "Europe/Samara"),
("485239", "Syktyvkar", "Сыктывкар", "RU", "643", "34", "485241", "", "", "61.67642", "50.80994", "Europe/Moscow"),
("485432", "Svobody", "Свободы", "RU", "643", "70", "", "", "", "44.02556", "43.05028", "Europe/Moscow"),
("485630", "Sviblovo", "Свиблово", "RU", "643", "48", "", "", "", "55.85", "37.63333", "Europe/Moscow"),
("485639", "Svetogorsk", "Светогорск", "RU", "643", "42", "", "", "", "61.11213", "28.86321", "Europe/Moscow"),
("485660", "Svetlyy", "Светлый", "RU", "643", "23", "", "", "", "54.67501", "20.13473", "Europe/Kaliningrad"),
("485698", "Svetlograd", "Светлоград", "RU", "643", "70", "", "", "", "45.33528", "42.85472", "Europe/Moscow"),
("485871", "Suvorovskaya", "Суворовская", "RU", "643", "70", "", "", "", "44.1901", "42.6595", "Europe/Moscow"),
("485888", "Suvorov", "Суворов", "RU", "643", "76", "", "", "", "54.1223", "36.49657", "Europe/Moscow"),
("486071", "Surovikino", "Суровикино", "RU", "643", "84", "", "", "", "48.60734", "42.84621", "Europe/Volgograd"),
("486110", "Surkhakhi", "Сурхахи", "RU", "643", "19", "", "", "", "43.1875", "44.90194", "Europe/Moscow"),
("486665", "Sukhinichi", "Сухиничи", "RU", "643", "25", "", "", "", "54.09989", "35.34254", "Europe/Moscow"),
("486968", "Stupino", "Ступино", "RU", "643", "47", "", "", "", "54.90083", "38.07083", "Europe/Moscow"),
("487095", "Strunino", "Струнино", "RU", "643", "83", "", "", "", "56.37328", "38.58321", "Europe/Moscow"),
("487147", "Stroitel'", "Строитель", "RU", "643", "09", "", "", "", "50.78543", "36.4831", "Europe/Moscow"),
("487150", "Strogino", "Строгино", "RU", "643", "48", "", "", "", "55.81838", "37.41224", "Europe/Moscow"),
("487495", "Sterlitamak", "Стерлитамак", "RU", "643", "08", "", "", "", "53.62462", "55.95015", "Asia/Yekaterinburg"),
("487846", "Stavropol'", "Ставрополь", "RU", "643", "70", "", "", "", "45.0428", "41.9734", "Europe/Moscow"),
("487928", "Staryy Oskol", "Старый Оскол", "RU", "643", "09", "", "", "", "51.29667", "37.84167", "Europe/Moscow"),
("488635", "Staroshcherbinovskaya", "Старощербиновская", "RU", "643", "38", "", "", "", "46.6311", "38.6742", "Europe/Moscow"),
("488742", "Starominskaya", "Староминская", "RU", "643", "38", "", "", "", "46.53", "39.04972", "Europe/Moscow"),
("488852", "Starodub", "Стародуб", "RU", "643", "10", "", "", "", "52.58444", "32.76333", "Europe/Moscow"),
("489088", "Staraya Russa", "Старая Русса", "RU", "643", "52", "", "", "", "57.99439", "31.36081", "Europe/Moscow"),
("489162", "Staraya Kupavna", "Старая Купавна", "RU", "643", "47", "", "", "", "55.80799", "38.1805", "Europe/Moscow"),
("489226", "Staraya Derevnya", "Старая Деревня", "RU", "643", "66", "", "", "", "59.98834", "30.24296", "Europe/Moscow"),
("490067", "Sovetsk", "Советск", "RU", "643", "33", "", "", "", "57.58475", "48.95844", "Europe/Volgograd"),
("490068", "Sovetsk", "Совецк", "RU", "643", "23", "", "", "", "55.08392", "21.87851", "Europe/Kaliningrad"),
("490172", "Sosnovyy Bor", "Сосновый Бор", "RU", "643", "42", "", "", "", "59.8996", "29.08574", "Europe/Moscow"),
("490377", "Sosnovaya Polyana", "Сосновая Поляна", "RU", "643", "66", "", "", "", "59.83528", "30.14667", "Europe/Moscow"),
("490391", "Sosnogorsk", "Сосногорск", "RU", "643", "34", "", "", "", "63.60229", "53.88175", "Europe/Moscow"),
("490466", "Sortavala", "Сортавала", "RU", "643", "28", "", "", "", "61.71233", "30.70953", "Europe/Moscow"),
("490554", "Sorochinsk", "Сорочинск", "RU", "643", "55", "", "", "", "52.4338", "53.1583", "Asia/Yekaterinburg"),
("490971", "Solntsevo", "Солнцево", "RU", "643", "48", "", "", "", "55.63711", "37.38115", "Europe/Moscow"),
("490996", "Solnechnogorsk", "Солнечногорск", "RU", "643", "47", "", "", "", "56.18333", "36.98333", "Europe/Moscow"),
("491019", "Sol'-Iletsk", "Соль-Илецк", "RU", "643", "55", "", "", "", "51.1631", "54.99176", "Asia/Yekaterinburg"),
("491023", "Solikamsk", "Соликамск", "RU", "643", "90", "", "", "", "59.6316", "56.7685", "Asia/Yekaterinburg"),
("491250", "Sokol'niki", "Сокольники", "RU", "643", "48", "", "", "", "55.80202", "37.67159", "Europe/Moscow"),
("491280", "Sokol", "Сокол", "RU", "643", "48", "", "", "", "55.8", "37.51667", "Europe/Moscow"),
("491281", "Sokol", "Сокол", "RU", "643", "85", "", "", "", "59.46167", "40.12056", "Europe/Moscow"),
("491351", "Sofrino", "Софрино", "RU", "643", "47", "", "", "", "56.15", "37.96667", "Europe/Moscow"),
("491422", "Sochi", "Сочи", "RU", "643", "38", "6695246", "", "", "43.59917", "39.72569", "Europe/Moscow"),
("491480", "Sobinka", "Собинка", "RU", "643", "83", "", "", "", "55.98553", "40.01111", "Europe/Moscow"),
("491687", "Smolensk", "Смоленск", "RU", "643", "69", "", "", "", "54.7818", "32.0401", "Europe/Moscow"),
("491882", "Slobodskoy", "Слободской", "RU", "643", "33", "", "", "", "58.73222", "50.17722", "Europe/Volgograd"),
("491895", "Slobodka", "Слободка", "RU", "643", "48", "", "", "", "55.86667", "37.58333", "Europe/Moscow"),
("492094", "Slavyansk-na-Kubani", "Славянск На Кубани", "RU", "643", "38", "", "", "", "45.2558", "38.1256", "Europe/Moscow"),
("492162", "Slantsy", "Сланцы", "RU", "643", "42", "", "", "", "59.11817", "28.09137", "Europe/Moscow"),
("492376", "Skopin", "Скопин", "RU", "643", "62", "", "", "", "53.82486", "39.55053", "Europe/Moscow"),
("492448", "Skhodnya", "Сходня", "RU", "643", "47", "", "", "", "55.94806", "37.29778", "Europe/Moscow"),
("492944", "Sim", "Сим", "RU", "643", "13", "", "", "", "54.993", "57.6982", "Asia/Yekaterinburg"),
("493160", "Sibay", "Сибай", "RU", "643", "08", "", "", "", "52.71806", "58.66583", "Asia/Yekaterinburg"),
("493231", "Shuya", "Шуя", "RU", "643", "21", "", "", "", "56.84865", "41.38833", "Europe/Moscow"),
("493316", "Shushary", "Шушары", "RU", "643", "66", "", "", "", "59.80917", "30.38167", "Europe/Moscow"),
("493463", "Shumerlya", "Шумерля", "RU", "643", "16", "", "", "", "55.5005", "46.41288", "Europe/Moscow"),
("493702", "Mikhaylovsk", "Михайловск", "RU", "643", "70", "", "", "", "45.12833", "42.02556", "Europe/Moscow"),
("494427", "Shilovo", "Шилово", "RU", "643", "62", "", "", "", "54.3204", "40.874", "Europe/Moscow"),
("495062", "Sheksna", "Шексна", "RU", "643", "85", "", "", "", "59.20998", "38.51066", "Europe/Moscow"),
("495112", "Shebekino", "Шебекино", "RU", "643", "09", "", "", "", "50.40967", "36.9136", "Europe/Moscow"),
("495136", "Shchukino", "Щукино", "RU", "643", "48", "", "", "", "55.8", "37.45", "Europe/Moscow"),
("495206", "Shchigry", "Щигры", "RU", "643", "41", "", "", "", "51.87555", "36.90432", "Europe/Moscow"),
("495260", "Shcherbinka", "Щербинка", "RU", "643", "47", "", "", "", "55.49972", "37.55972", "Europe/Moscow"),
("495344", "Shchelkovo", "Щёлково", "RU", "643", "47", "", "", "", "55.89303", "38.0586", "Europe/Moscow"),
("495394", "Shchekino", "Щекино", "RU", "643", "76", "", "", "", "54.00513", "37.52194", "Europe/Moscow"),
("495518", "Shatura", "Шатура", "RU", "643", "47", "", "", "", "55.57253", "39.53682", "Europe/Moscow"),
("495619", "Shar'ya", "Шарья", "RU", "643", "37", "", "", "", "58.36909", "45.51558", "Europe/Moscow"),
("495957", "Shali", "Шали", "RU", "643", "12", "", "", "", "43.14806", "45.90194", "Europe/Moscow"),
("496012", "Shakhun'ya", "Шахунья", "RU", "643", "51", "", "", "", "57.67579", "46.61136", "Europe/Moscow"),
("496015", "Shakhty", "Шахты", "RU", "643", "61", "", "", "", "47.70911", "40.21443", "Europe/Moscow"),
("496267", "Severskaya", "Северская", "RU", "643", "38", "", "", "", "44.85407", "38.67686", "Europe/Moscow"),
("496269", "Severo-Zadonsk", "Северо-Задонск", "RU", "643", "76", "", "", "", "54.03481", "38.40172", "Europe/Moscow"),
("496275", "Severoural'sk", "Североуральск", "RU", "643", "71", "", "", "", "60.15328", "59.95205", "Asia/Yekaterinburg"),
("496278", "Severomorsk", "Североморск", "RU", "643", "49", "", "", "", "69.06889", "33.41622", "Europe/Moscow"),
("496285", "Severodvinsk", "Северодвинск", "RU", "643", "06", "", "", "", "64.5635", "39.8302", "Europe/Moscow"),
("496348", "Severnyy", "Северный", "RU", "643", "48", "", "", "", "55.93583", "37.54889", "Europe/Moscow"),
("496456", "Setun'", "Сетунь", "RU", "643", "48", "", "", "", "55.71667", "37.41667", "Europe/Moscow"),
("496478", "Sestroretsk", "Сестрорецк", "RU", "643", "66", "", "", "", "60.09802", "29.96378", "Europe/Moscow"),
("496519", "Sertolovo", "Сертолово", "RU", "643", "42", "", "", "", "60.1444", "30.20165", "Europe/Moscow"),
("496527", "Serpukhov", "Серпухов", "RU", "643", "47", "", "", "", "54.91578", "37.41114", "Europe/Moscow"),
("496638", "Sergiyev Posad", "Сергиев Посад", "RU", "643", "47", "", "", "", "56.3", "38.13333", "Europe/Moscow"),
("496802", "Sergach", "Сергач", "RU", "643", "51", "", "", "", "55.53079", "45.46611", "Europe/Moscow"),
("496934", "Serdobsk", "Сердобск", "RU", "643", "57", "", "", "", "52.45861", "44.21689", "Europe/Moscow"),
("497206", "Semiluki", "Семилуки", "RU", "643", "86", "", "", "", "51.68526", "39.02787", "Europe/Moscow"),
("497218", "Semikarakorsk", "Семикаракорск", "RU", "643", "61", "", "", "", "47.51943", "40.8112", "Europe/Moscow"),
("497271", "Semenovskoye", "Семёновское", "RU", "643", "47", "", "", "", "55.68333", "37.55", "Europe/Moscow"),
("497450", "Semenov", "Семёнов", "RU", "643", "51", "", "", "", "56.78749", "44.49297", "Europe/Moscow"),
("497610", "Sel'tso", "Сельцо", "RU", "643", "10", "", "", "", "53.36831", "34.10328", "Europe/Moscow"),
("497927", "Segezha", "Сегежа", "RU", "643", "28", "", "", "", "63.74147", "34.32218", "Europe/Moscow"),
("498418", "Satka", "Сатка", "RU", "643", "13", "", "", "", "55.0425", "59.04", "Asia/Yekaterinburg"),
("498525", "Sarov", "Саров", "RU", "643", "51", "", "", "", "54.93583", "43.32352", "Europe/Moscow"),
("498677", "Saratov", "Саратов", "RU", "643", "67", "498661", "", "", "51.54056", "46.00861", "Europe/Volgograd"),
("498687", "Sarapul", "Сарапул", "RU", "643", "80", "", "", "", "56.47633", "53.79782", "Europe/Samara"),
("498698", "Saransk", "Саранск", "RU", "643", "46", "", "", "", "54.1838", "45.1749", "Europe/Moscow"),
("498708", "Saraktash", "Саракташ", "RU", "643", "55", "", "", "", "51.78771", "56.36091", "Asia/Yekaterinburg"),
("498817", "Saint Petersburg", "Санкт-Петербург", "RU", "643", "66", "", "", "", "59.93863", "30.31413", "Europe/Moscow"),
("499099", "Samara", "Самара", "RU", "643", "65", "", "", "", "53.20006", "50.15", "Europe/Samara"),
("499161", "Sal'sk", "Сальск", "RU", "643", "61", "", "", "", "46.4747", "41.54114", "Europe/Moscow"),
("499292", "Salavat", "Салават", "RU", "643", "08", "", "", "", "53.38365", "55.90773", "Asia/Yekaterinburg"),
("499452", "Safonovo", "Сафоново", "RU", "643", "69", "", "", "", "55.15", "33.21667", "Europe/Moscow"),
("499717", "Rzhev", "Ржев", "RU", "643", "77", "", "", "", "56.26241", "34.32817", "Europe/Moscow"),
("499975", "Rybnoye", "Рыбное", "RU", "643", "62", "", "", "", "54.72774", "39.51731", "Europe/Moscow"),
("500004", "Rybinsk", "Рыбинск", "RU", "643", "88", "", "", "", "58.0446", "38.84259", "Europe/Moscow"),
("500019", "Rybatskoye", "Рыбатское", "RU", "643", "42", "", "", "", "59.8393", "30.49873", "Europe/Moscow"),
("500047", "Ryazhsk", "Ряжск", "RU", "643", "62", "", "", "", "53.7038", "40.1109", "Europe/Moscow"),
("500096", "Ryazan'", "Рязань", "RU", "643", "62", "", "", "", "54.6269", "39.6916", "Europe/Moscow"),
("500299", "Ruzayevka", "Рузаевка", "RU", "643", "46", "", "", "", "54.06387", "44.9509", "Europe/Moscow"),
("500843", "Rublevo", "Рублево", "RU", "643", "48", "", "", "", "55.78514", "37.35481", "Europe/Moscow"),
("500886", "Rtishchevo", "Ртищево", "RU", "643", "67", "", "", "", "52.26041", "43.78745", "Europe/Volgograd"),
("501175", "Rostov-na-Donu", "Ростов-на-Дону", "RU", "643", "61", "", "", "", "47.23135", "39.72328", "Europe/Moscow"),
("501183", "Rostov", "Ростов", "RU", "643", "88", "", "", "", "57.1914", "39.41394", "Europe/Moscow"),
("501187", "Rostokino", "Ростокино", "RU", "643", "48", "", "", "", "55.83333", "37.66667", "Europe/Moscow"),
("501215", "Rossosh'", "Россошь", "RU", "643", "86", "", "", "", "51.1209", "38.5116", "Europe/Moscow"),
("501231", "Rossosh'", "Россошь", "RU", "643", "86", "", "", "", "50.19828", "39.56726", "Europe/Moscow"),
("501283", "Roslavl'", "Рославль", "RU", "643", "69", "", "", "", "53.95278", "32.86389", "Europe/Moscow"),
("501320", "Roshal'", "Рошаль", "RU", "643", "47", "", "", "", "55.66853", "39.87488", "Europe/Moscow"),
("501730", "Rodniki", "Родники", "RU", "643", "21", "", "", "", "57.10513", "41.73048", "Europe/Moscow"),
("502011", "Revda", "Ревда", "RU", "643", "71", "", "", "", "56.80097", "59.93028", "Asia/Yekaterinburg"),
("502018", "Reutov", "Реутов", "RU", "643", "47", "", "", "", "55.76111", "37.8575", "Europe/Moscow"),
("502400", "Razumnoye", "Разумное", "RU", "643", "09", "", "", "", "50.53439", "36.68462", "Europe/Moscow"),
("502540", "Rayevskiy", "Раевский", "RU", "643", "08", "", "", "", "54.0658", "54.9468", "Asia/Yekaterinburg"),
("502793", "Rasskazovo", "Рассказово", "RU", "643", "72", "", "", "", "52.65599", "41.88461", "Europe/Moscow"),
("502971", "Ramenki", "Раменки", "RU", "643", "48", "", "", "", "55.7", "37.5", "Europe/Moscow"),
("503550", "Pyatigorsk", "Пятигорск", "RU", "643", "70", "", "", "", "44.04861", "43.05944", "Europe/Moscow"),
("503977", "Pushkino", "Пушкино", "RU", "643", "47", "", "", "", "56.01722", "37.86667", "Europe/Moscow"),
("504003", "Pushkin", "Пушкин", "RU", "643", "66", "", "", "", "59.71417", "30.39642", "Europe/Moscow"),
("504042", "Pushchino", "Пущино", "RU", "643", "47", "", "", "", "54.83373", "37.61138", "Europe/Moscow"),
("504341", "Pskov", "Псков", "RU", "643", "60", "", "", "", "57.8136", "28.3496", "Europe/Moscow"),
("504576", "Protvino", "Протвино", "RU", "643", "47", "", "", "", "54.8682", "37.21584", "Europe/Moscow"),
("504831", "Proletarsk", "Пролетарск", "RU", "643", "61", "", "", "", "46.70289", "41.72717", "Europe/Moscow"),
("504935", "Prokhladnyy", "Прохладный", "RU", "643", "22", "", "", "", "43.75741", "44.0297", "Europe/Moscow"),
("505014", "Priyutovo", "Приютово", "RU", "643", "08", "", "", "", "53.9", "53.93333", "Asia/Yekaterinburg"),
("505057", "Privolzhskiy", "Приволжский", "RU", "643", "67", "", "", "", "51.40944", "46.04833", "Europe/Volgograd"),
("505060", "Privolzhsk", "Приволжск", "RU", "643", "21", "", "", "", "57.38698", "41.28666", "Europe/Moscow"),
("505230", "Priozersk", "Приозерск", "RU", "643", "42", "", "", "", "61.03928", "30.12907", "Europe/Moscow"),
("505259", "Primorsko-Akhtarsk", "Приморско-Ахтарск", "RU", "643", "38", "", "", "", "46.0497", "38.1747", "Europe/Moscow"),
("505421", "Pridonskoy", "Придонской", "RU", "643", "86", "", "", "", "51.68406", "39.0727", "Europe/Moscow"),
("505806", "Povorino", "Поворино", "RU", "643", "86", "", "", "", "51.1945", "42.2457", "Europe/Moscow"),
("506043", "Kotlovka", "Котловка", "RU", "643", "48", "", "", "", "55.65928", "37.60404", "Europe/Moscow"),
("506117", "Annino", "Аннино", "RU", "643", "48", "", "", "", "55.58333", "37.6", "Europe/Moscow"),
("506762", "Polyarnyye Zori", "Полярные Зори", "RU", "643", "49", "", "", "", "67.36611", "32.49806", "Europe/Moscow"),
("506763", "Polyarnyy", "Полярный", "RU", "643", "49", "", "", "", "69.19889", "33.44778", "Europe/Moscow"),
("507338", "Pokrovskoye-Streshnevo", "Покровское-Стрешнёво", "RU", "643", "48", "", "", "", "55.80797", "37.45814", "Europe/Moscow"),
("507599", "Pokrov", "Покров", "RU", "643", "83", "", "", "", "55.91797", "39.17242", "Europe/Moscow"),
("507624", "Pokhvistnevo", "Похвистнево", "RU", "643", "65", "", "", "", "53.65237", "52.12738", "Europe/Samara"),
("508034", "Podporozh'ye", "Подпорожье", "RU", "643", "42", "", "", "", "60.91124", "34.17064", "Europe/Moscow"),
("508101", "Podol'sk", "Подольск", "RU", "643", "47", "508091", "", "", "55.42418", "37.55472", "Europe/Moscow"),
("508656", "Pochep", "Почеп", "RU", "643", "10", "508648", "", "", "52.9336", "33.4464", "Europe/Moscow"),
("508751", "Ryazanskiy", "Рязанский", "RU", "643", "48", "", "", "", "55.73333", "37.76667", "Europe/Moscow"),
("509052", "Plavsk", "Плавск", "RU", "643", "76", "", "", "", "53.70944", "37.29194", "Europe/Moscow"),
("509598", "Pikalevo", "Пикалёво", "RU", "643", "42", "", "", "", "59.51833", "34.16639", "Europe/Moscow"),
("509697", "Petushki", "Петушки", "RU", "643", "83", "", "", "", "55.92639", "39.46104", "Europe/Moscow"),
("509820", "Petrozavodsk", "Петрозаводск", "RU", "643", "28", "", "", "", "61.78491", "34.34691", "Europe/Moscow"),
("509981", "Petrovskaya", "Петровская", "RU", "643", "47", "", "", "", "55.55", "37.78333", "Europe/Moscow"),
("509987", "Petrovsk", "Петровск", "RU", "643", "67", "", "", "", "52.30639", "45.39167", "Europe/Volgograd"),
("510225", "Petrodvorets", "Петродворец", "RU", "643", "66", "", "", "", "59.89565", "29.80145", "Europe/Moscow"),
("510291", "Peterhof", "Петергоф", "RU", "643", "66", "", "", "", "59.88333", "29.9", "Europe/Moscow"),
("510364", "Pestovo", "Пестово", "RU", "643", "52", "", "", "", "58.59382", "35.80244", "Europe/Moscow"),
("510808", "Pervoural'sk", "Первоуральск", "RU", "643", "71", "", "", "", "56.90528", "59.94361", "Asia/Yekaterinburg"),
("511153", "Perovo", "Перово", "RU", "643", "48", "", "", "", "55.73501", "37.79088", "Europe/Moscow"),
("511196", "Perm", "Пермь", "RU", "643", "90", "", "", "", "58.01046", "56.25017", "Asia/Yekaterinburg"),
("511359", "Pereslavl'-Zalesskiy", "Переславль-Залесский", "RU", "643", "88", "", "", "", "56.73934", "38.85626", "Europe/Moscow"),
("511510", "Novo-Peredelkino", "Ново-Переделкино", "RU", "643", "48", "", "", "", "55.64528", "37.33583", "Europe/Moscow"),
("511565", "Penza", "Пенза", "RU", "643", "57", "", "", "", "53.20066", "45.00464", "Europe/Moscow"),
("511794", "Pechora", "Печора", "RU", "643", "34", "", "", "", "65.14716", "57.22439", "Europe/Moscow"),
("512023", "Pavlovskiy Posad", "Павловский Посад", "RU", "643", "47", "", "", "", "55.78187", "38.65025", "Europe/Moscow"),
("512051", "Pavlovskaya", "Павловская", "RU", "643", "38", "", "", "", "46.1377", "39.7832", "Europe/Moscow"),
("512052", "Pavlovsk", "Павловск", "RU", "643", "66", "", "", "", "59.68333", "30.43472", "Europe/Moscow"),
("512053", "Pavlovsk", "Павловск", "RU", "643", "86", "", "", "", "50.45778", "40.10806", "Europe/Moscow"),
("512382", "Pashkovskiy", "Пашковский", "RU", "643", "38", "", "", "", "45.02366", "39.10436", "Europe/Moscow"),
("513042", "Pallasovka", "Палласовка", "RU", "643", "84", "", "", "", "50.05", "46.88333", "Europe/Volgograd"),
("513378", "Ozery", "Озеры", "RU", "643", "47", "", "", "", "54.85998", "38.55062", "Europe/Moscow"),
("513471", "Ozerki", "Озерки", "RU", "643", "66", "", "", "", "60.03947", "30.31128", "Europe/Moscow"),
("513883", "Otradnyy", "Отрадный", "RU", "643", "65", "", "", "", "53.37596", "51.3452", "Europe/Samara"),
("513896", "Otradnoye", "Отрадное", "RU", "643", "48", "", "", "", "55.86667", "37.6", "Europe/Moscow"),
("513898", "Otradnoye", "Отрадное", "RU", "643", "42", "", "", "", "59.7775", "30.81806", "Europe/Moscow"),
("513911", "Otradnaya", "Отрадная", "RU", "643", "38", "", "", "", "44.39333", "41.52056", "Europe/Moscow"),
("514171", "Ostrov", "Остров", "RU", "643", "60", "", "", "", "57.34395", "28.35368", "Europe/Moscow"),
("514198", "Ostrogozhsk", "Острогожск", "RU", "643", "86", "", "", "", "50.8664", "39.07562", "Europe/Moscow"),
("514259", "Ostashkov", "Осташков", "RU", "643", "77", "", "", "", "57.14667", "33.10753", "Europe/Moscow"),
("514284", "Ostankinskiy", "Останкинский", "RU", "643", "48", "", "", "", "55.82958", "37.61604", "Europe/Moscow"),
("514706", "Osa", "Оса", "RU", "643", "90", "", "", "", "57.283", "55.4589", "Asia/Yekaterinburg"),
("514734", "Orsk", "Орск", "RU", "643", "55", "", "", "", "51.20487", "58.56685", "Asia/Yekaterinburg"),
("514796", "Orlovskiy", "Орловский", "RU", "643", "61", "", "", "", "46.87139", "42.05917", "Europe/Moscow"),
("515003", "Orenburg", "Оренбург", "RU", "643", "55", "", "", "", "51.7727", "55.0988", "Asia/Yekaterinburg"),
("515012", "Orel", "Орёл", "RU", "643", "56", "", "", "", "52.96508", "36.0785", "Europe/Moscow"),
("515024", "Orekhovo-Zuyevo", "Орехово-Зуево", "RU", "643", "47", "", "", "", "55.80672", "38.96178", "Europe/Moscow"),
("515027", "Orekhovo-Borisovo Severnoye", "Орехово-Борисово Северное", "RU", "643", "48", "", "", "", "55.61667", "37.68333", "Europe/Moscow"),
("515083", "Ordzhonikidzevskaya", "Орджоникидзевская", "RU", "643", "19", "", "", "", "43.3195", "45.04911", "Europe/Moscow"),
("515246", "Onega", "Онега", "RU", "643", "06", "", "", "", "63.90692", "38.11112", "Europe/Moscow"),
("515267", "Omutninsk", "Омутнинск", "RU", "643", "33", "", "", "", "58.67001", "52.1932", "Europe/Volgograd"),
("515698", "Olenegorsk", "Оленегорск", "RU", "643", "49", "", "", "", "68.1432", "33.25287", "Europe/Moscow"),
("515804", "Tsotsin-Yurt", "Цоцин-Юрт", "RU", "643", "12", "", "", "", "43.24206", "46.00013", "Europe/Moscow"),
("515879", "Oktyabr'skiy", "Октябрьский", "RU", "643", "08", "", "", "", "54.48147", "53.47103", "Asia/Yekaterinburg"),
("516215", "Odintsovo", "Одинцово", "RU", "643", "47", "", "", "", "55.67798", "37.27773", "Europe/Moscow"),
("516256", "Ocher", "Очер", "RU", "643", "90", "", "", "", "57.89035", "54.7202", "Asia/Yekaterinburg"),
("516264", "Ochakovo-Matveyevskoye", "Очаково-Матвеевское", "RU", "643", "48", "", "", "", "55.68432", "37.44654", "Europe/Moscow"),
("516436", "Obninsk", "Обнинск", "RU", "643", "25", "", "", "", "55.09681", "36.61006", "Europe/Moscow"),
("516576", "Nytva", "Нытва", "RU", "643", "90", "", "", "", "57.9437", "55.3396", "Asia/Yekaterinburg"),
("516647", "Nyandoma", "Няндома", "RU", "643", "06", "", "", "", "61.6656", "40.2013", "Europe/Moscow"),
("516716", "Nurlat", "Нурлат", "RU", "643", "73", "", "", "", "54.42766", "50.80511", "Europe/Moscow"),
("516931", "Novyy Oskol", "Новый Оскол", "RU", "643", "09", "", "", "", "50.7633", "37.86402", "Europe/Moscow"),
("517121", "Novyye Kuz'minki", "Новые Кузьминки", "RU", "643", "48", "", "", "", "55.7", "37.75", "Europe/Moscow"),
("517161", "Novyye Cheremushki", "Новые Черёмушки", "RU", "643", "48", "", "", "", "55.7", "37.58333", "Europe/Moscow"),
("517269", "Novozybkov", "Новозыбков", "RU", "643", "10", "", "", "", "52.5396", "31.9275", "Europe/Moscow"),
("517716", "Novovoronezh", "Нововоронеж", "RU", "643", "86", "", "", "", "51.30719", "39.21732", "Europe/Moscow"),
("517739", "Novouzensk", "Новоузенск", "RU", "643", "67", "", "", "", "50.45917", "48.14306", "Europe/Volgograd"),
("517766", "Novoul'yanovsk", "Новоульяновск", "RU", "643", "81", "", "", "", "54.14961", "48.38907", "Europe/Moscow"),
("517836", "Novotroitsk", "Новотроицк", "RU", "643", "55", "", "", "", "51.20301", "58.32665", "Asia/Yekaterinburg"),
("517842", "Novotitarovskaya", "Новотитаровская", "RU", "643", "38", "", "", "", "45.23756", "38.98059", "Europe/Moscow"),
("517963", "Novoshakhtinsk", "Новошахтинск", "RU", "643", "61", "", "", "", "47.76037", "39.93335", "Europe/Moscow"),
("518255", "Novorossiysk", "Новороссийск", "RU", "643", "38", "", "", "", "44.72439", "37.76752", "Europe/Moscow"),
("518325", "Novopokrovskaya", "Новопокровская", "RU", "643", "38", "", "", "", "45.95139", "40.70056", "Europe/Moscow"),
("518383", "Novopavlovsk", "Новопавловск", "RU", "643", "70", "", "", "", "43.96222", "43.63417", "Europe/Moscow"),
("518557", "Novomoskovsk", "Новомосковск", "RU", "643", "76", "", "", "", "54.0105", "38.2846", "Europe/Moscow"),
("518602", "Novomichurinsk", "Новомичуринск", "RU", "643", "62", "", "", "", "54.0384", "39.7479", "Europe/Moscow"),
("518657", "Novokuz'minki", "Новокузьминки", "RU", "643", "48", "", "", "", "55.71667", "37.78333", "Europe/Moscow"),
("518659", "Novokuybyshevsk", "Новокуйбышевск", "RU", "643", "65", "", "", "", "53.0959", "49.9462", "Europe/Samara"),
("518682", "Novokubansk", "Новокубанск", "RU", "643", "38", "", "", "", "45.117", "41.0267", "Europe/Moscow"),
("518740", "Novokhovrino", "Новоховрино", "RU", "643", "48", "", "", "", "55.86667", "37.5", "Europe/Moscow"),
("518879", "Novogireyevo", "Новогиреево", "RU", "643", "47", "", "", "", "55.75378", "37.81885", "Europe/Moscow"),
("518909", "Novodvinsk", "Новодвинск", "RU", "643", "06", "", "", "", "64.4165", "40.8122", "Europe/Moscow"),
("518970", "Novocherkassk", "Новочеркасск", "RU", "643", "61", "", "", "", "47.42018", "40.09132", "Europe/Moscow"),
("518976", "Novocheboksarsk", "Новочебоксарск", "RU", "643", "16", "", "", "", "56.11095", "47.47755", "Europe/Moscow"),
("519062", "Novoanninskiy", "Новоаннинский", "RU", "643", "84", "", "", "", "50.5287", "42.6747", "Europe/Volgograd"),
("519106", "Novoaleksandrovsk", "Новоалександровск", "RU", "643", "70", "", "", "", "45.4948", "41.22075", "Europe/Moscow"),
("519336", "Velikiy Novgorod", "Великий Новгород", "RU", "643", "52", "", "", "", "58.52131", "31.27104", "Europe/Moscow"),
("519447", "Novaya Usman'", "Новая Усмань", "RU", "643", "86", "", "", "", "51.64177", "39.40863", "Europe/Moscow"),
("519711", "Novaya Derevnya", "Новая деревня", "RU", "643", "66", "", "", "", "59.98748", "30.28682", "Europe/Moscow"),
("520068", "Noginsk", "Ногинск", "RU", "643", "47", "", "", "", "55.86647", "38.4438", "Europe/Moscow"),
("520204", "Nizhnyaya Tura", "Нижняя Тура", "RU", "643", "71", "", "", "", "58.6293", "59.8118", "Asia/Yekaterinburg"),
("520494", "Nizhniy Tagil", "Нижний Тагил", "RU", "643", "71", "", "", "", "57.91944", "59.965", "Asia/Yekaterinburg"),
("520555", "Nizhniy Novgorod", "Нижний Новгород", "RU", "643", "51", "", "", "", "56.32867", "44.00205", "Europe/Moscow"),
("520574", "Nizhniy Lomov", "Ниж.Ломов", "RU", "643", "57", "", "", "", "53.53041", "43.67664", "Europe/Moscow"),
("521118", "Nizhnekamsk", "Нижнекамск", "RU", "643", "73", "", "", "", "55.63657", "51.82447", "Europe/Moscow"),
("521416", "Nikulino", "Никулино", "RU", "643", "48", "", "", "", "55.66943", "37.46598", "Europe/Moscow"),
("521500", "Nikol'skoye", "Никольское", "RU", "643", "48", "", "", "", "55.68333", "37.48333", "Europe/Moscow"),
("521509", "Nikol'skoye", "Никольское", "RU", "643", "42", "", "", "", "59.70056", "30.78472", "Europe/Moscow"),
("521776", "Nikol'sk", "Никольск", "RU", "643", "57", "", "", "", "53.71886", "46.07118", "Europe/Moscow"),
("521874", "Nikolayevsk", "Николаевск", "RU", "643", "84", "", "", "", "50.02824", "45.45953", "Europe/Volgograd"),
("522260", "Nikel'", "Никель", "RU", "643", "49", "", "", "", "69.41285", "30.22198", "Europe/Moscow"),
("522301", "Nezlobnaya", "Незлобная", "RU", "643", "70", "", "", "", "44.11806", "43.40278", "Europe/Moscow"),
("522377", "Nevinnomyssk", "Невинномысск", "RU", "643", "70", "", "", "", "44.6333", "41.9444", "Europe/Moscow"),
("522410", "Nevel'", "Невель", "RU", "643", "60", "", "", "", "56.02094", "29.92844", "Europe/Moscow"),
("522470", "Nesterovskaya", "Нестеровская", "RU", "643", "19", "", "", "", "43.23861", "45.05028", "Europe/Moscow"),
("522594", "Nerekhta", "Нерехта", "RU", "643", "37", "", "", "", "57.45881", "40.57471", "Europe/Moscow"),
("522775", "Nelidovo", "Нелидово", "RU", "643", "77", "", "", "", "56.22107", "32.77738", "Europe/Moscow"),
("522942", "Neftekamsk", "Нефтекамск", "RU", "643", "08", "", "", "", "56.092", "54.2661", "Asia/Yekaterinburg"),
("522945", "Neftegorsk", "Нефтегорск", "RU", "643", "65", "", "", "", "52.802", "51.166", "Europe/Samara"),
("523064", "Nazran'", "Назрань", "RU", "643", "19", "", "", "", "43.22597", "44.77323", "Europe/Moscow"),
("523198", "Navashino", "Навашино", "RU", "643", "51", "", "", "", "55.5441", "42.1968", "Europe/Moscow"),
("523392", "Nar'yan-Mar", "Нарьян-Мар", "RU", "643", "50", "", "", "", "67.63869", "53.00371", "Europe/Moscow"),
("523405", "Nartkala", "Нарткала", "RU", "643", "22", "", "", "", "43.5575", "43.85083", "Europe/Moscow"),
("523426", "Naro-Fominsk", "Наро-Фоминск", "RU", "643", "47", "", "", "", "55.38752", "36.73307", "Europe/Moscow"),
("523523", "Nal'chik", "Нальчик", "RU", "643", "22", "825098", "", "", "43.49806", "43.61889", "Europe/Moscow"),
("523553", "Nakhabino", "Нахабино", "RU", "643", "47", "", "", "", "55.84854", "37.17788", "Europe/Moscow"),
("523750", "Naberezhnyye Chelny", "Набережные Челны", "RU", "643", "73", "480620", "", "", "55.72545", "52.41122", "Europe/Moscow"),
("523812", "Mytishchi", "Мытищи", "RU", "643", "47", "", "", "", "55.91163", "37.73076", "Europe/Moscow"),
("524294", "Murom", "Муром", "RU", "643", "83", "", "", "", "55.575", "42.0426", "Europe/Moscow"),
("524305", "Murmansk", "Мурманск", "RU", "643", "49", "", "", "", "68.97917", "33.09251", "Europe/Moscow"),
("524640", "Mtsensk", "Мценск", "RU", "643", "56", "", "", "", "53.27657", "36.57334", "Europe/Moscow"),
("524699", "Mozhga", "Можга", "RU", "643", "80", "", "", "", "56.44469", "52.22763", "Europe/Samara"),
("524712", "Mozhaysk", "Можайск", "RU", "643", "47", "", "524708", "", "55.50194", "36.02722", "Europe/Moscow"),
("524736", "Mozdok", "Моздок", "RU", "643", "68", "", "", "", "43.74359", "44.65177", "Europe/Moscow"),
("524809", "Mostovskoy", "Мостовской", "RU", "643", "38", "", "", "", "44.41222", "40.79361", "Europe/Moscow"),
("524901", "Moscow", "Москва", "RU", "643", "48", "562331", "", "", "55.75222", "37.61556", "Europe/Moscow"),
("525138", "Morshansk", "Моршанск", "RU", "643", "72", "", "", "", "53.44354", "41.81065", "Europe/Moscow"),
("525162", "Morozovsk", "Морозовск", "RU", "643", "61", "", "", "", "48.35502", "41.82627", "Europe/Moscow"),
("525396", "Monino", "Монино", "RU", "643", "47", "", "", "", "55.84244", "38.19362", "Europe/Moscow"),
("525404", "Monchegorsk", "Мончегорск", "RU", "643", "49", "", "", "", "67.93972", "32.87389", "Europe/Moscow"),
("526346", "Mirnyy", "Мирный", "RU", "643", "06", "", "", "", "61.33289", "44.53598", "Europe/Moscow"),
("526480", "Mineralnye Vody", "Минеральные Воды", "RU", "643", "70", "", "", "", "44.21028", "43.13528", "Europe/Moscow"),
("526558", "Millerovo", "Миллерово", "RU", "643", "61", "", "", "", "48.92265", "40.39673", "Europe/Moscow"),
("527012", "Mikhaylovka", "Михайловка", "RU", "643", "84", "", "", "", "50.06", "43.2379", "Europe/Volgograd"),
("527057", "Mikhalkovo", "Михалково", "RU", "643", "48", "", "", "", "55.68333", "37.43333", "Europe/Moscow"),
("527191", "Michurinsk", "Мичуринск", "RU", "643", "72", "", "", "", "52.8978", "40.4907", "Europe/Moscow"),
("527361", "Metallostroy", "Металлострой", "RU", "643", "66", "", "", "", "59.80083", "30.54778", "Europe/Moscow"),
("527529", "Menzelinsk", "Мензелинск", "RU", "643", "73", "", "", "", "55.72706", "53.10258", "Europe/Moscow"),
("527579", "Mendeleyevsk", "Менделеевск", "RU", "643", "73", "", "", "", "55.90818", "52.29047", "Europe/Moscow"),
("527717", "Meleuz", "Мелеуз", "RU", "643", "08", "", "", "", "52.96467", "55.93277", "Asia/Yekaterinburg"),
("527740", "Melenki", "Меленки", "RU", "643", "83", "", "", "", "55.3343", "41.6295", "Europe/Moscow"),
("527888", "Medvezh'yegorsk", "Медвежьегорск", "RU", "643", "28", "", "", "", "62.91713", "34.45689", "Europe/Moscow"),
("527968", "Medvedovskaya", "Медведовская", "RU", "643", "38", "", "", "", "45.45151", "39.02485", "Europe/Moscow"),
("528056", "Medvedevo", "Медведево", "RU", "643", "45", "", "", "", "56.63388", "47.80405", "Europe/Moscow"),
("528109", "Mednogorsk", "Медногорск", "RU", "643", "55", "", "", "", "51.4128", "57.595", "Asia/Yekaterinburg"),
("528293", "Maykop", "Майкоп", "RU", "643", "01", "", "", "", "44.60778", "40.10583", "Europe/Moscow"),
("528454", "Matveyevskoye", "Матвеевское", "RU", "643", "48", "", "", "", "55.71112", "37.47502", "Europe/Moscow"),
("529073", "Marks", "Маркс", "RU", "643", "67", "", "", "", "51.71111", "46.74861", "Europe/Volgograd"),
("529237", "Mar'ino", "Марьино", "RU", "643", "48", "", "", "", "55.65", "37.71667", "Europe/Moscow"),
("529334", "Mar'ina Roshcha", "Марьина Роща", "RU", "643", "48", "", "", "", "55.8", "37.61667", "Europe/Moscow"),
("529505", "Manturovo", "Мантурово", "RU", "643", "37", "", "", "", "58.32889", "44.76406", "Europe/Moscow"),
("530088", "Yaroslavskiy", "Ярославский", "RU", "643", "48", "", "", "", "55.88333", "37.71667", "Europe/Moscow"),
("530849", "Maloyaroslavets", "Малоярославец", "RU", "643", "25", "", "", "", "55.01457", "36.47185", "Europe/Moscow"),
("531129", "Malgobek", "Малгобек", "RU", "643", "19", "", "", "", "43.51118", "44.58821", "Europe/Moscow"),
("531820", "Malakhovka", "Малаховка", "RU", "643", "47", "", "", "", "55.64776", "38.02486", "Europe/Moscow"),
("532096", "Makhachkala", "Махачкала", "RU", "643", "17", "", "", "", "42.97638", "47.50236", "Europe/Moscow"),
("532288", "Magnitogorsk", "Магнитогорск", "RU", "643", "13", "825030", "", "", "53.41861", "59.04722", "Asia/Yekaterinburg"),
("532459", "Lyudinovo", "Людиново", "RU", "643", "25", "", "", "", "53.86639", "34.44778", "Europe/Moscow"),
("532535", "Lyublino", "Люблино", "RU", "643", "48", "", "", "", "55.67923", "37.7525", "Europe/Moscow"),
("532615", "Lyubertsy", "Люберцы", "RU", "643", "47", "", "", "", "55.67719", "37.89322", "Europe/Moscow"),
("532657", "Lytkarino", "Лыткарино", "RU", "643", "47", "", "", "", "55.58271", "37.90516", "Europe/Moscow"),
("532675", "Lys'va", "Лысьва", "RU", "643", "90", "", "", "", "58.10861", "57.80528", "Asia/Yekaterinburg"),
("532715", "Lyskovo", "Лысково", "RU", "643", "51", "", "", "", "56.03282", "45.0422", "Europe/Moscow"),
("533067", "Luzhniki", "Лужники", "RU", "643", "48", "", "", "", "55.71599", "37.55376", "Europe/Moscow"),
("533543", "Lukhovitsy", "Луховицы", "RU", "643", "47", "", "", "", "54.97661", "39.0444", "Europe/Moscow"),
("533690", "Luga", "Луга", "RU", "643", "42", "", "", "", "58.73722", "29.84528", "Europe/Moscow"),
("534015", "Losino-Petrovskiy", "Лосино-Петровский", "RU", "643", "47", "", "", "", "55.86959", "38.20065", "Europe/Moscow"),
("534341", "Lomonosov", "Ломоносов", "RU", "643", "66", "", "", "", "59.90612", "29.77253", "Europe/Moscow"),
("534560", "Lodeynoye Pole", "Лодейное Поле", "RU", "643", "42", "", "", "", "60.726", "33.55306", "Europe/Moscow"),
("534595", "Lobnya", "Лобня", "RU", "643", "47", "", "", "", "56.00972", "37.48194", "Europe/Moscow"),
("534701", "Livny", "Ливны", "RU", "643", "56", "", "", "", "52.42534", "37.60689", "Europe/Moscow"),
("534838", "Liski", "Лиски", "RU", "643", "86", "", "", "", "50.98405", "39.51545", "Europe/Moscow"),
("535121", "Lipetsk", "Липецк", "RU", "643", "43", "", "", "", "52.60311", "39.57076", "Europe/Moscow"),
("535243", "Likino-Dulevo", "Ликино-Дулево", "RU", "643", "47", "", "", "", "55.7083", "38.9542", "Europe/Moscow"),
("535270", "Likhobory", "Лихоборы", "RU", "643", "48", "", "", "", "55.85", "37.56667", "Europe/Moscow"),
("535330", "Lianozovo", "Лианозово", "RU", "643", "48", "", "", "", "55.89783", "37.5868", "Europe/Moscow"),
("535334", "L'govskiy", "Льгов", "RU", "643", "41", "", "", "", "51.63069", "35.2775", "Europe/Moscow"),
("535451", "Levoberezhnaya", "Левобережная", "RU", "643", "47", "", "", "", "55.88333", "37.48333", "Europe/Moscow"),
("535729", "Komendantsky aerodrom", "Комендантский аэродром", "RU", "643", "66", "", "", "", "60.00448", "30.27523", "Europe/Moscow"),
("535886", "Lermontov", "Лермонтов", "RU", "643", "70", "", "", "", "44.10667", "42.97333", "Europe/Moscow"),
("535966", "Leonovo", "Леоново", "RU", "643", "48", "", "", "", "55.85", "37.65", "Europe/Moscow"),
("536098", "Leninskiye Gory", "Ленинские горы", "RU", "643", "47", "", "", "", "55.7", "37.56667", "Europe/Moscow"),
("536156", "Leninsk", "Ленинск", "RU", "643", "84", "", "", "", "48.70233", "45.19798", "Europe/Volgograd"),
("536162", "Leninogorsk", "Лениногорск", "RU", "643", "73", "", "", "", "54.60256", "52.46087", "Europe/Moscow"),
("536164", "Tsaritsyno", "Царицино", "RU", "643", "48", "", "", "", "55.6254", "37.65032", "Europe/Moscow"),
("536200", "Leningradskaya", "Ленинградская", "RU", "643", "38", "", "", "", "46.3214", "39.3877", "Europe/Moscow"),
("536206", "Yubileyny", "Юбилейный", "RU", "643", "47", "", "", "", "55.93333", "37.83333", "Europe/Moscow"),
("536398", "Lefortovo", "Лефортово", "RU", "643", "48", "", "", "", "55.76667", "37.7", "Europe/Moscow"),
("536518", "Lebedyan'", "Лебедянь", "RU", "643", "43", "", "", "", "53.01942", "39.16639", "Europe/Moscow"),
("536625", "Lazarevskoye", "Лазаревское", "RU", "643", "38", "6695246", "", "", "43.90886", "39.33137", "Europe/Moscow"),
("537107", "Lakinsk", "Лакинск", "RU", "643", "83", "", "", "", "56.01931", "39.94848", "Europe/Moscow"),
("537281", "Labinsk", "Лабинск", "RU", "643", "38", "", "", "", "44.63417", "40.73556", "Europe/Moscow"),
("537345", "Dugulubgey", "Дугулубгей", "RU", "643", "22", "", "", "", "43.6625", "43.53694", "Europe/Moscow"),
("537737", "Kuznetsk", "Кузнецк", "RU", "643", "57", "", "", "", "53.11675", "46.60037", "Europe/Moscow"),
("537832", "Kuz'minki", "Кузьминки", "RU", "643", "48", "", "", "", "55.7", "37.8", "Europe/Moscow"),
("538138", "Kuvandyk", "Кувандык", "RU", "643", "55", "", "", "", "51.4781", "57.3552", "Asia/Yekaterinburg"),
("538321", "Kuskovo", "Кусково", "RU", "643", "47", "", "", "", "55.73423", "37.82616", "Europe/Moscow"),
("538340", "Kushva", "Кушва", "RU", "643", "71", "", "", "", "58.29056", "59.75917", "Asia/Yekaterinburg"),
("538416", "Kushchevskaya", "Кущёвская", "RU", "643", "38", "", "", "", "46.5599", "39.6321", "Europe/Moscow"),
("538442", "Kusa", "Куса", "RU", "643", "13", "", "", "", "55.33833", "59.44056", "Asia/Yekaterinburg"),
("538472", "Kur'yanovo", "Курьяново", "RU", "643", "47", "", "", "", "55.65", "37.7", "Europe/Moscow"),
("538560", "Kursk", "Курск", "RU", "643", "41", "", "", "", "51.73733", "36.18735", "Europe/Moscow"),
("538601", "Kurovskoye", "Куровское", "RU", "643", "47", "", "", "", "55.58183", "38.91994", "Europe/Moscow"),
("538836", "Kurganinsk", "Курганинск", "RU", "643", "38", "", "", "", "44.88", "40.59861", "Europe/Moscow"),
("538908", "Kurchatov", "Курчатов", "RU", "643", "41", "", "", "", "51.6601", "35.6521", "Europe/Moscow"),
("538913", "Kurchaloy", "Курчалой", "RU", "643", "12", "", "", "", "43.20184", "46.0881", "Europe/Moscow"),
("539061", "Kupchino", "Купчино", "RU", "643", "66", "", "", "", "59.85278", "30.35667", "Europe/Moscow"),
("539147", "Kungur", "Кунгур", "RU", "643", "90", "", "", "", "57.4368", "56.9593", "Asia/Yekaterinburg"),
("539283", "Kumertau", "Кумертау", "RU", "643", "08", "", "", "", "52.76667", "55.78333", "Asia/Yekaterinburg"),
("539555", "Kulebaki", "Кулебаки", "RU", "643", "51", "", "", "", "55.41333", "42.5325", "Europe/Moscow"),
("539689", "Kukmor", "Кукмор", "RU", "643", "73", "", "", "", "56.1855", "50.8944", "Europe/Moscow"),
("539817", "Kudymkar", "Кудымкар", "RU", "643", "90", "", "", "", "59.01306", "54.65556", "Asia/Yekaterinburg"),
("539907", "Kudepsta", "Кудепста", "RU", "643", "38", "", "", "", "43.49547", "39.89294", "Europe/Moscow"),
("540030", "Kubinka", "Кубинка", "RU", "643", "47", "", "", "", "55.57957", "36.70392", "Europe/Moscow"),
("540103", "Kstovo", "Кстово", "RU", "643", "51", "", "", "", "56.14733", "44.19787", "Europe/Moscow"),
("540251", "Krymsk", "Крымск", "RU", "643", "38", "", "", "", "44.92934", "37.99117", "Europe/Moscow"),
("540761", "Kropotkin", "Кропоткин", "RU", "643", "38", "", "", "", "45.4375", "40.57556", "Europe/Moscow"),
("540771", "Kronshtadt", "Кронштадт", "RU", "643", "66", "", "", "", "59.99541", "29.76668", "Europe/Kaliningrad"),
("541404", "Krasnyy Sulin", "Красный Сулин", "RU", "643", "61", "", "", "", "47.89221", "40.07037", "Europe/Moscow"),
("541406", "Biryulevo Zapadnoye", "Красный Строитель", "RU", "643", "47", "", "", "", "55.58766", "37.64282", "Europe/Moscow"),
("542000", "Krasnoye Selo", "Красное Село", "RU", "643", "66", "", "", "", "59.73833", "30.08944", "Europe/Moscow"),
("542184", "Krasnovishersk", "Красновишерск", "RU", "643", "90", "", "", "", "60.40783", "57.08199", "Asia/Yekaterinburg"),
("542199", "Krasnoufimsk", "Красноуфимск", "RU", "643", "71", "", "", "", "56.60585", "57.76686", "Asia/Yekaterinburg"),
("542327", "Krasnokamsk", "Краснокамск", "RU", "643", "90", "", "", "", "58.0796", "55.7552", "Asia/Yekaterinburg"),
("542334", "Krasnogvardeyskoye", "Красногвардейское", "RU", "643", "70", "", "", "", "45.84604", "41.51885", "Europe/Moscow"),
("542374", "Krasnogorsk", "Красногорск", "RU", "643", "47", "", "", "", "55.82036", "37.33017", "Europe/Moscow"),
("542420", "Krasnodar", "Краснодар", "RU", "643", "38", "", "", "", "45.04484", "38.97603", "Europe/Moscow"),
("542461", "Krasnoarmeyskaya", "Полтавская", "RU", "643", "38", "", "", "", "45.36614", "38.21171", "Europe/Moscow"),
("542463", "Krasnoarmeysk", "Красноармейск", "RU", "643", "47", "", "", "", "56.1", "38.13333", "Europe/Moscow"),
("542464", "Krasnoarmeysk", "Красноармейск", "RU", "643", "67", "", "", "", "51.02389", "45.69694", "Europe/Volgograd"),
("542634", "Presnenskiy", "Красная Пресня", "RU", "643", "47", "", "", "", "55.75", "37.55", "Europe/Moscow"),
("543018", "Koz'modem'yansk", "Козьмодемьянск", "RU", "643", "45", "", "", "", "56.3419", "46.56353", "Europe/Moscow"),
("543254", "Kozhukhovo", "Кожухово", "RU", "643", "47", "", "", "", "55.7", "37.66667", "Europe/Moscow"),
("543344", "Kozeyevo", "Козеево", "RU", "643", "48", "", "", "", "55.86667", "37.61667", "Europe/Moscow"),
("543348", "Kozel'sk", "Козельск", "RU", "643", "25", "", "", "", "54.03746", "35.77159", "Europe/Moscow"),
("543436", "Kovylkino", "Ковылкино", "RU", "643", "46", "", "", "", "54.03876", "43.91386", "Europe/Moscow"),
("543460", "Kovrov", "Ковров", "RU", "643", "83", "543454", "", "", "56.35722", "41.31917", "Europe/Moscow"),
("543508", "Kovdor", "Ковдор", "RU", "643", "49", "", "", "", "67.56616", "30.47576", "Europe/Moscow"),
("543605", "Kotovsk", "Котовск", "RU", "643", "72", "", "", "", "52.58666", "41.5021", "Europe/Moscow"),
("543633", "Kotovo", "Котово", "RU", "643", "84", "", "", "", "50.32113", "44.80119", "Europe/Volgograd"),
("543704", "Kotlas", "Котлас", "RU", "643", "06", "", "", "", "61.25745", "46.64963", "Europe/Moscow"),
("543728", "Kotel'nikovo", "Котельниково", "RU", "643", "84", "", "", "", "47.63009", "43.14068", "Europe/Volgograd"),
("543731", "Kotel'niki", "Котельники", "RU", "643", "47", "", "", "", "55.63546", "37.8445", "Europe/Moscow"),
("543737", "Kotel'nich", "Котельнич", "RU", "643", "33", "", "", "", "58.3089", "48.348", "Europe/Volgograd"),
("543878", "Kostroma", "Кострома", "RU", "643", "37", "543869", "", "", "57.76647", "40.92686", "Europe/Moscow"),
("543899", "Kostomuksha", "Костомукша", "RU", "643", "28", "", "", "", "64.571", "30.57667", "Europe/Moscow"),
("544293", "Kosaya Gora", "Косая Гора", "RU", "643", "76", "", "", "", "54.11896", "37.54459", "Europe/Moscow"),
("544370", "Koryazhma", "Коряжма", "RU", "643", "06", "", "", "", "61.31433", "47.16914", "Europe/Moscow"),
("544896", "Korenovsk", "Кореновск", "RU", "643", "38", "", "", "", "45.46899", "39.45136", "Europe/Moscow"),
("545277", "Konstantinovsk", "Константиновск", "RU", "643", "61", "", "", "", "47.58278", "41.09222", "Europe/Moscow"),
("545575", "Kondrovo", "Кондрово", "RU", "643", "25", "", "", "", "54.80639", "35.92778", "Europe/Moscow"),
("545626", "Kondopoga", "Кондопога", "RU", "643", "28", "", "", "", "62.20565", "34.26138", "Europe/Moscow"),
("545673", "Konakovo", "Конаково", "RU", "643", "77", "", "", "", "56.7", "36.76667", "Europe/Moscow"),
("545788", "Kommunar", "Коммунар", "RU", "643", "42", "", "", "", "59.62056", "30.39", "Europe/Moscow"),
("546105", "Kolpino", "Колпино", "RU", "643", "66", "", "", "", "59.75069", "30.58856", "Europe/Moscow"),
("546225", "Kolomyagi", "Коломяги", "RU", "643", "66", "", "", "", "60.02427", "30.28491", "Europe/Moscow"),
("546230", "Kolomna", "Коломна", "RU", "643", "47", "", "", "", "55.07944", "38.77833", "Europe/Moscow"),
("546244", "Kolomenskoye", "Коломенское", "RU", "643", "48", "", "", "", "55.66667", "37.68333", "Europe/Moscow"),
("546521", "Kol'chugino", "Кольчугино", "RU", "643", "83", "", "", "", "56.29929", "39.38304", "Europe/Moscow"),
("546672", "Kokhma", "Кохма", "RU", "643", "21", "", "", "", "56.93486", "41.0915", "Europe/Moscow"),
("547475", "Klintsy", "Клинцы", "RU", "643", "10", "", "", "", "52.76019", "32.23934", "Europe/Moscow"),
("547523", "Klin", "Клин", "RU", "643", "47", "", "", "", "56.33333", "36.73333", "Europe/Moscow"),
("547560", "Klimovsk", "Климовск", "RU", "643", "47", "", "", "", "55.36352", "37.52984", "Europe/Moscow"),
("547840", "Kizlyar", "Кизляр", "RU", "643", "17", "", "", "", "43.84712", "46.71445", "Europe/Moscow"),
("547849", "Kizilyurt", "Кизилюрт", "RU", "643", "17", "", "", "", "43.20697", "46.8679", "Europe/Moscow"),
("547875", "Kizel", "Кизел", "RU", "643", "90", "", "", "", "59.04709", "57.64767", "Asia/Yekaterinburg"),
("548114", "Kislovodsk", "Кисловодск", "RU", "643", "70", "", "", "", "43.91333", "42.72083", "Europe/Moscow"),
("548278", "Kirzhach", "Киржач", "RU", "643", "83", "", "", "", "56.15273", "38.85509", "Europe/Moscow"),
("548330", "Kirsanov", "Кирсанов", "RU", "643", "72", "", "", "", "52.65494", "42.72236", "Europe/Moscow"),
("548391", "Kirovsk", "Кировск", "RU", "643", "49", "", "", "", "67.61475", "33.67274", "Europe/Moscow"),
("548392", "Kirovsk", "Кировск", "RU", "643", "42", "", "", "", "59.88101", "30.99507", "Europe/Moscow"),
("548395", "Kirovo-Chepetsk", "Кирово-Чепецк", "RU", "643", "33", "", "", "", "58.55386", "50.03986", "Europe/Volgograd"),
("548408", "Kirov", "Киров", "RU", "643", "33", "548394", "", "", "58.59665", "49.66007", "Europe/Volgograd"),
("548410", "Kirov", "Киров", "RU", "643", "25", "", "", "", "54.06686", "34.29955", "Europe/Moscow"),
("548442", "Kirishi", "Кириши", "RU", "643", "42", "", "", "", "59.44712", "32.02049", "Europe/Moscow"),
("548506", "Kireyevsk", "Киреевск", "RU", "643", "76", "", "", "", "53.93361", "37.92792", "Europe/Moscow"),
("548602", "Kingisepp", "Кингисепп", "RU", "643", "42", "", "", "", "59.37331", "28.61343", "Europe/Moscow"),
("548605", "Kineshma", "Кинешма", "RU", "643", "21", "", "", "", "57.43914", "42.12894", "Europe/Moscow"),
("548622", "Kinel'-Cherkassy", "Кинель-Черкассы", "RU", "643", "65", "", "", "", "53.4706", "51.4743", "Europe/Samara"),
("548625", "Kinel'", "Кинель", "RU", "643", "65", "", "", "", "53.22571", "50.62907", "Europe/Samara"),
("548652", "Kimry", "Кимры", "RU", "643", "77", "", "", "", "56.86667", "37.35", "Europe/Moscow"),
("548658", "Kimovsk", "Кимовск", "RU", "643", "76", "", "", "", "53.97164", "38.53186", "Europe/Moscow"),
("549373", "Khot'kovo", "Хотьково", "RU", "643", "47", "", "", "", "56.25699", "37.99544", "Europe/Moscow"),
("549424", "Khosta", "Хоста", "RU", "643", "38", "6695246", "", "", "43.51484", "39.86825", "Europe/Moscow"),
("549479", "Khoroshevo-Mnevniki", "Хорошёво", "RU", "643", "47", "", "", "", "55.78364", "37.47137", "Europe/Moscow"),
("549741", "Kholmskiy", "Холмская", "RU", "643", "38", "", "", "", "44.84694", "38.385", "Europe/Moscow"),
("550280", "Khimki", "Химки", "RU", "643", "48", "", "", "", "55.89704", "37.42969", "Europe/Moscow"),
("550478", "Khasavyurt", "Хасавюрт", "RU", "643", "17", "Gorod Khasavyurt", "", "", "43.2509", "46.58766", "Europe/Moscow"),
("550671", "Kharabali", "Харабали", "RU", "643", "07", "", "", "", "47.41958", "47.25678", "Europe/Volgograd"),
("550846", "Khadyzhensk", "Хадыженск", "RU", "643", "38", "", "", "", "44.4258", "39.5362", "Europe/Moscow"),
("551487", "Kazan", "Казань", "RU", "643", "73", "862913", "", "", "55.78874", "49.12214", "Europe/Moscow"),
("551794", "Katav-Ivanovsk", "Катав-Ивановск", "RU", "643", "13", "", "", "", "54.75306", "58.19556", "Asia/Yekaterinburg"),
("551835", "Kastanayevo", "Кастанаево", "RU", "643", "47", "", "", "", "55.71667", "37.5", "Europe/Moscow"),
("551847", "Kaspiysk", "Каспийск", "RU", "643", "17", "", "", "", "42.88165", "47.63919", "Europe/Moscow"),
("551891", "Kasimov", "Касимов", "RU", "643", "62", "", "", "", "54.94111", "41.39528", "Europe/Moscow"),
("551964", "Kashira", "Кашира", "RU", "643", "47", "", "", "", "54.84444", "38.16694", "Europe/Moscow"),
("551986", "Kashin", "Кашин", "RU", "643", "77", "", "", "", "57.35917", "37.60806", "Europe/Moscow"),
("552920", "Karachev", "Карачев", "RU", "643", "10", "", "", "", "53.12292", "34.98517", "Europe/Moscow"),
("552924", "Karachayevsk", "Карачаевск", "RU", "643", "27", "", "", "", "43.77399", "41.91419", "Europe/Moscow"),
("552951", "Karabulak", "Карабулак", "RU", "643", "19", "", "", "", "43.30513", "44.89949", "Europe/Moscow"),
("552977", "Karabanovo", "Карабаново", "RU", "643", "83", "", "", "", "56.31667", "38.7", "Europe/Moscow"),
("553034", "Kapotnya", "Капотня", "RU", "643", "48", "", "", "", "55.63806", "37.79306", "Europe/Moscow"),
("553092", "Kantyshevo", "Кантышево", "RU", "643", "19", "", "", "", "43.22824", "44.63322", "Europe/Moscow"),
("553152", "Kanevskaya", "Каневская", "RU", "643", "38", "", "", "", "46.0849", "38.9596", "Europe/Moscow"),
("553190", "Kandalaksha", "Кандалакша", "RU", "643", "49", "", "", "", "67.162", "32.41229", "Europe/Moscow"),
("553216", "Kanash", "Канаш", "RU", "643", "16", "", "", "", "55.50962", "47.49127", "Europe/Moscow"),
("553248", "Kamyzyak", "Камызяк", "RU", "643", "07", "", "", "", "46.10995", "48.07364", "Europe/Volgograd"),
("553287", "Kamyshin", "Камышин", "RU", "643", "84", "", "", "", "50.09833", "45.41601", "Europe/Volgograd"),
("553399", "Kamensk-Shakhtinskiy", "Каменск", "RU", "643", "61", "", "", "", "48.31779", "40.25948", "Europe/Moscow"),
("553915", "Kaluga", "Калуга", "RU", "643", "25", "", "", "", "54.5293", "36.27542", "Europe/Moscow"),
("554199", "Kalininsk", "Калининск", "RU", "643", "67", "", "", "", "51.5", "44.4758", "Europe/Volgograd"),
("554233", "Korolev", "Королёв", "RU", "643", "47", "", "", "", "55.91417", "37.82556", "Europe/Moscow"),
("554234", "Kaliningrad", "Калининград", "RU", "643", "23", "825118", "", "", "54.70649", "20.51095", "Europe/Kaliningrad"),
("554397", "Kalach-na-Donu", "Калач-на-Дону", "RU", "643", "84", "", "", "", "48.69099", "43.52638", "Europe/Volgograd"),
("554410", "Kalach", "Калач", "RU", "643", "86", "", "", "", "50.4258", "41.0261", "Europe/Moscow"),
("554599", "Kachkanar", "Качканар", "RU", "643", "71", "", "", "", "58.7002", "59.4839", "Asia/Yekaterinburg"),
("554787", "Izmaylovo", "Измайлово", "RU", "643", "47", "", "", "", "55.78677", "37.80165", "Europe/Moscow"),
("554840", "Izhevsk", "Ижевск", "RU", "643", "80", "", "", "", "56.84976", "53.20448", "Europe/Samara"),
("554894", "Izberbash", "Избербаш", "RU", "643", "17", "", "", "", "42.56955", "47.86447", "Europe/Moscow"),
("555111", "Ivanteyevka", "Ивантеевка", "RU", "643", "47", "", "", "", "55.97111", "37.92083", "Europe/Moscow"),
("555129", "Ivanovskoye", "Ивановское", "RU", "643", "48", "", "", "", "55.76667", "37.83333", "Europe/Moscow"),
("555312", "Ivanovo", "Иваново", "RU", "643", "21", "825094", "", "", "56.99719", "40.97139", "Europe/Moscow"),
("555746", "Istra", "Истра", "RU", "643", "47", "", "", "", "55.91997", "36.86867", "Europe/Moscow"),
("555980", "Ishimbay", "Ишимбай", "RU", "643", "08", "", "", "", "53.45446", "56.04149", "Asia/Yekaterinburg"),
("556230", "Ipatovo", "Ипатово", "RU", "643", "70", "", "", "", "45.71806", "42.90361", "Europe/Moscow"),
("556283", "Inza", "Инза", "RU", "643", "81", "", "", "", "53.85672", "46.35622", "Europe/Moscow"),
("556320", "Inozemtsevo", "Иноземцево", "RU", "643", "70", "", "", "", "44.09264", "43.09113", "Europe/Moscow"),
("556951", "Il'skiy", "Ильский", "RU", "643", "38", "", "", "", "44.84222", "38.56686", "Europe/Moscow"),
("557469", "Igra", "Игра", "RU", "643", "80", "", "", "", "57.5549", "53.0544", "Europe/Samara"),
("557775", "Gus'-Khrustal'nyy", "Гусь-Хрустальный", "RU", "643", "83", "", "", "", "55.61113", "40.65186", "Europe/Moscow"),
("557882", "Gusev", "Гусев", "RU", "643", "23", "", "", "", "54.59222", "22.19972", "Europe/Kaliningrad"),
("558066", "Gul'kevichi", "Гулькевичи", "RU", "643", "38", "", "", "", "45.35383", "40.69465", "Europe/Moscow"),
("558082", "Gukovo", "Гуково", "RU", "643", "61", "", "", "", "48.05306", "39.93111", "Europe/Moscow"),
("558118", "Gudermes", "Гудермес", "RU", "643", "12", "", "", "", "43.35071", "46.10925", "Europe/Moscow"),
("558146", "Gubkin", "Губкин", "RU", "643", "09", "", "", "", "51.28167", "37.54583", "Europe/Moscow"),
("558209", "Gubakha", "Губаха", "RU", "643", "90", "", "", "", "58.83862", "57.55325", "Asia/Yekaterinburg"),
("558236", "Gryazovets", "Грязовец", "RU", "643", "85", "", "", "", "58.88", "40.2525", "Europe/Moscow"),
("558312", "Gryazi", "Грязи", "RU", "643", "43", "", "", "", "52.49657", "39.93593", "Europe/Moscow"),
("558418", "Groznyy", "Грозный", "RU", "643", "12", "", "", "", "43.31195", "45.68895", "Europe/Moscow"),
("558799", "Gribanovskiy", "Грибановский", "RU", "643", "86", "", "", "", "51.45792", "41.97636", "Europe/Moscow"),
("559029", "Grazhdanka", "Гражданка", "RU", "643", "66", "", "", "", "60.03587", "30.40518", "Europe/Moscow"),
("559317", "Goryachiy Klyuch", "Горячий Ключ", "RU", "643", "38", "", "", "", "44.63083", "39.13", "Europe/Moscow"),
("559320", "Goryachevodskiy", "Горячеводский", "RU", "643", "70", "", "", "", "44.02361", "43.09222", "Europe/Moscow"),
("559654", "Gorodishche", "Городище", "RU", "643", "84", "", "", "", "48.80454", "44.47439", "Europe/Volgograd"),
("559678", "Gorodets", "Городец", "RU", "643", "51", "", "", "", "56.65493", "43.47273", "Europe/Moscow"),
("560142", "Gorelovo", "Горелово", "RU", "643", "66", "", "", "", "59.77472", "30.11971", "Europe/Moscow"),
("560465", "Gol'yanovo", "Гольяново", "RU", "643", "48", "", "", "", "55.82299", "37.81306", "Europe/Moscow"),
("560756", "Golitsyno", "Голицыно", "RU", "643", "47", "", "", "", "55.60928", "36.98212", "Europe/Moscow"),
("561347", "Glazov", "Глазов", "RU", "643", "80", "", "", "", "58.1393", "52.658", "Europe/Samara"),
("561515", "Giaginskaya", "Гиагинская", "RU", "643", "01", "", "", "", "44.86208", "40.07195", "Europe/Moscow"),
("561627", "Georgiyevsk", "Георгиевск", "RU", "643", "70", "", "", "", "44.15194", "43.46972", "Europe/Moscow"),
("561667", "Gelendzhik", "Геленджик", "RU", "643", "38", "", "", "", "44.5622", "38.0848", "Europe/Moscow"),
("561731", "Gay", "Гай", "RU", "643", "55", "", "", "", "51.4666", "58.4552", "Asia/Yekaterinburg"),
("561762", "Gavrilov-Yam", "Гаврилов-Ям", "RU", "643", "88", "", "", "", "57.30185", "39.85331", "Europe/Moscow"),
("561887", "Gatchina", "Гатчина", "RU", "643", "42", "", "", "", "59.57639", "30.12833", "Europe/Moscow"),
("562161", "Galich", "Галич", "RU", "643", "37", "", "", "", "58.37884", "42.34633", "Europe/Moscow"),
("562237", "Gagarin", "Гагарин", "RU", "643", "69", "", "", "", "55.55291", "34.99537", "Europe/Moscow"),
("562309", "Furmanov", "Фурманов", "RU", "643", "21", "", "", "", "57.25363", "41.10849", "Europe/Moscow"),
("562319", "Fryazino", "Фрязино", "RU", "643", "47", "", "", "", "55.96056", "38.04556", "Europe/Moscow"),
("562321", "Fryazevo", "Фрязево", "RU", "643", "47", "", "", "", "55.73321", "38.46458", "Europe/Moscow"),
("562389", "Frolovo", "Фролово", "RU", "643", "84", "", "", "", "49.77133", "43.66222", "Europe/Volgograd"),
("562820", "Fili", "Фили", "RU", "643", "47", "", "", "", "55.74819", "37.47968", "Europe/Moscow"),
("563379", "Ezhva", "Эжва", "RU", "643", "34", "", "", "", "61.81281", "50.72834", "Europe/Moscow"),
("563464", "Engel's", "Энгельс", "RU", "643", "67", "", "", "", "51.48389", "46.10528", "Europe/Volgograd"),
("563472", "Enem", "Энем", "RU", "643", "01", "", "", "", "44.9264", "38.90584", "Europe/Moscow"),
("563514", "Elista", "Элиста", "RU", "643", "24", "", "", "", "46.30778", "44.25583", "Europe/Moscow"),
("563522", "Elektrougli", "Электроугли", "RU", "643", "47", "", "", "", "55.72445", "38.20908", "Europe/Moscow"),
("563523", "Elektrostal'", "Электросталь", "RU", "643", "47", "", "", "", "55.78959", "38.44671", "Europe/Moscow"),
("563524", "Elektrogorsk", "Электрогорск", "RU", "643", "47", "", "", "", "55.88431", "38.7864", "Europe/Moscow"),
("563551", "Ekazhevo", "Экажево", "RU", "643", "19", "", "", "", "43.21222", "44.82306", "Europe/Moscow"),
("563705", "Dzerzhinskiy", "Дзержинский", "RU", "643", "47", "", "", "", "55.62945", "37.85654", "Europe/Moscow"),
("563708", "Dzerzhinsk", "Дзержинск", "RU", "643", "51", "", "", "", "56.24143", "43.45539", "Europe/Moscow"),
("563719", "Dyurtyuli", "Дюртюли", "RU", "643", "08", "", "", "", "55.49106", "54.86883", "Asia/Yekaterinburg"),
("563822", "Dyat'kovo", "Дятьково", "RU", "643", "10", "", "", "", "53.59782", "34.33825", "Europe/Moscow"),
("564654", "Dubovka", "Дубовка", "RU", "643", "84", "", "", "", "49.05825", "44.829", "Europe/Volgograd"),
("564719", "Dubna", "Дубна", "RU", "643", "47", "", "", "", "56.73333", "37.16667", "Europe/Moscow"),
("565197", "Dorogomilovo", "Дорогомилово", "RU", "643", "47", "", "", "", "55.75", "37.56667", "Europe/Moscow"),
("565289", "Donskoye", "Донское", "RU", "643", "70", "", "", "", "45.45518", "41.97411", "Europe/Moscow"),
("565290", "Donskoy", "Донской", "RU", "643", "76", "", "", "", "53.97106", "38.33627", "Europe/Moscow"),
("565348", "Donetsk", "Донецк", "RU", "643", "61", "", "", "", "48.33372", "39.94776", "Europe/Moscow"),
("565381", "Domodedovo", "Домодедово", "RU", "643", "47", "", "", "", "55.4413", "37.75367", "Europe/Moscow"),
("565614", "Dolgoprudnyy", "Долгопрудный", "RU", "643", "47", "", "", "", "55.94958", "37.50183", "Europe/Moscow"),
("565778", "Dobryanka", "Добрянка", "RU", "643", "90", "", "", "", "58.4644", "56.4127", "Asia/Yekaterinburg"),
("565955", "Dmitrov", "Дмитров", "RU", "643", "47", "", "", "", "56.34485", "37.52041", "Europe/Moscow"),
("566155", "Divnoye", "Дивное", "RU", "643", "70", "", "", "", "45.90889", "43.35472", "Europe/Moscow"),
("566181", "Dinskaya", "Динская", "RU", "643", "38", "", "", "", "45.21516", "39.2265", "Europe/Moscow"),
("566199", "Dimitrovgrad", "Димитровград", "RU", "643", "81", "", "", "", "54.21386", "49.61838", "Europe/Moscow"),
("566384", "Desnogorsk", "Десногорск", "RU", "643", "69", "", "", "", "54.15077", "33.28151", "Europe/Moscow"),
("566532", "Derbent", "Дербент", "RU", "643", "17", "", "", "", "42.0678", "48.28987", "Europe/Moscow"),
("566809", "Zapadnoye Degunino", "Дегунино", "RU", "643", "48", "", "", "", "55.86667", "37.53333", "Europe/Moscow"),
("566854", "Dedovsk", "Дедовск", "RU", "643", "47", "", "", "", "55.86861", "37.12222", "Europe/Moscow"),
("566976", "Davydkovo", "Давыдково", "RU", "643", "48", "", "", "", "55.71815", "37.47271", "Europe/Moscow"),
("567006", "Davlekanovo", "Давлеканово", "RU", "643", "08", "", "", "", "54.22145", "55.03434", "Asia/Yekaterinburg"),
("567109", "Dankov", "Данков", "RU", "643", "43", "", "", "", "53.25155", "39.15553", "Europe/Moscow"),
("567183", "Danilov", "Данилов", "RU", "643", "88", "", "", "", "58.1908", "40.17171", "Europe/Moscow"),
("567290", "Dagestanskiye Ogni", "Дагестанские Огни", "RU", "643", "17", "", "", "", "42.11589", "48.19204", "Europe/Moscow"),
("567311", "Dachnoye", "Дачное", "RU", "643", "66", "", "", "", "59.84167", "30.25583", "Europe/Moscow"),
("567434", "Chusovoy", "Чусовой", "RU", "643", "90", "", "", "", "58.3013", "57.8131", "Asia/Yekaterinburg"),
("567774", "Chudovo", "Чудово", "RU", "643", "52", "", "", "", "59.11667", "31.68333", "Europe/Moscow"),
("567990", "Chistopol'", "Чистополь", "RU", "643", "73", "Chistopol'skiy Rayon", "", "", "55.36311", "50.64244", "Europe/Moscow"),
("568012", "Chishmy", "Чишмы", "RU", "643", "08", "", "", "", "54.57648", "55.37642", "Asia/Yekaterinburg"),
("568587", "Chernyanka", "Чернянка", "RU", "643", "09", "", "", "", "50.94095", "37.80693", "Europe/Moscow"),
("568595", "Chernyakhovsk", "Черняховск", "RU", "643", "23", "", "", "", "54.63345", "21.81557", "Europe/Kaliningrad"),
("568608", "Chernushka", "Чернушка", "RU", "643", "90", "", "", "", "56.50722", "56.07661", "Asia/Yekaterinburg"),
("568808", "Chernogolovka", "Черноголовка", "RU", "643", "47", "", "", "", "56", "38.36667", "Europe/Moscow"),
("569154", "Cherkessk", "Черкесск", "RU", "643", "27", "", "", "", "44.22333", "42.05778", "Europe/Moscow"),
("569223", "Cherepovets", "Череповец", "RU", "643", "85", "", "", "", "59.13333", "37.9", "Europe/Moscow"),
("569273", "Cheremushki", "Черёмушки", "RU", "643", "47", "", "", "", "55.66473", "37.56135", "Europe/Moscow"),
("569591", "Chekhov", "Чехов", "RU", "643", "47", "569587", "", "", "55.1477", "37.47728", "Europe/Moscow"),
("569639", "Chegem", "Чегем", "RU", "643", "22", "", "", "", "43.28333", "43.13333", "Europe/Moscow"),
("569696", "Cheboksary", "Чебоксары", "RU", "643", "16", "569698", "", "", "56.13222", "47.25194", "Europe/Moscow"),
("569742", "Chaykovskiy", "Чайковский", "RU", "643", "90", "", "", "", "56.76864", "54.11484", "Asia/Yekaterinburg"),
("569955", "Chapayevsk", "Чапаевск", "RU", "643", "65", "", "", "", "52.9771", "49.7086", "Europe/Samara"),
("570427", "Buzuluk", "Бузулук", "RU", "643", "55", "", "", "", "52.7807", "52.2635", "Asia/Yekaterinburg"),
("570479", "Buynaksk", "Буйнакск", "RU", "643", "17", "", "", "", "42.819", "47.1192", "Europe/Moscow"),
("570508", "Buy", "Буй", "RU", "643", "37", "", "", "", "58.48067", "41.53699", "Europe/Moscow"),
("570563", "Buturlinovka", "Бутурлиновка", "RU", "643", "86", "", "", "", "50.82389", "40.60917", "Europe/Moscow"),
("570636", "Businovo", "Бусиново", "RU", "643", "48", "", "", "", "55.88333", "37.5", "Europe/Moscow"),
("571155", "Buinsk", "Буинск", "RU", "643", "73", "", "", "", "54.97119", "48.29184", "Europe/Moscow"),
("571159", "Buguruslan", "Бугуруслан", "RU", "643", "55", "", "", "", "53.6554", "52.442", "Asia/Yekaterinburg"),
("571170", "Bugul'ma", "Бугульма", "RU", "643", "73", "Bugul'minskiy Rayon", "", "", "54.5378", "52.7985", "Europe/Moscow"),
("571306", "Budennovsk", "Буденновск", "RU", "643", "70", "", "", "", "44.78389", "44.16583", "Europe/Moscow"),
("571420", "Bryukhovetskaya", "Брюховецкая", "RU", "643", "38", "", "", "", "45.80603", "38.99959", "Europe/Moscow"),
("571476", "Bryansk", "Брянск", "RU", "643", "10", "571467", "", "", "53.25209", "34.37167", "Europe/Moscow"),
("571557", "Bronnitsy", "Бронницы", "RU", "643", "47", "", "", "", "55.42112", "38.26188", "Europe/Moscow"),
("571741", "Brateyevo", "Братеево", "RU", "643", "48", "", "", "", "55.63755", "37.76438", "Europe/Moscow"),
("572154", "Borovichi", "Боровичи", "RU", "643", "52", "", "", "", "58.38778", "33.91546", "Europe/Moscow"),
("572525", "Borisoglebsk", "Борисоглебск", "RU", "643", "86", "", "", "", "51.36713", "42.08494", "Europe/Moscow"),
("572665", "Bor", "Бор", "RU", "643", "51", "", "", "", "56.35808", "44.07477", "Europe/Moscow"),
("574675", "Bol'shaya Setun'", "Большая Сетунь", "RU", "643", "47", "", "", "", "55.71667", "37.41667", "Europe/Moscow"),
("575349", "Bologoye", "Бологое", "RU", "643", "77", "", "", "", "57.8799", "34.1068", "Europe/Moscow"),
("575410", "Boksitogorsk", "Бокситогорск", "RU", "643", "42", "", "", "", "59.47405", "33.84853", "Europe/Moscow"),
("575457", "Boguchar", "Богучар", "RU", "643", "86", "", "", "", "49.93577", "40.545", "Europe/Moscow"),
("575505", "Bogorodskoye", "Богородское", "RU", "643", "47", "", "", "", "55.81353", "37.71617", "Europe/Moscow"),
("575560", "Bogorodsk", "Богородск", "RU", "643", "51", "", "", "", "56.10514", "43.51294", "Europe/Moscow"),
("575591", "Bogoroditsk", "Богородицк", "RU", "643", "76", "", "", "", "53.77166", "38.12408", "Europe/Moscow"),
("575948", "Bobrov", "Бобров", "RU", "643", "86", "", "", "", "51.09611", "40.03333", "Europe/Moscow"),
("576116", "Blagoveshchensk", "Благовещенск", "RU", "643", "08", "", "", "", "55.035", "55.97806", "Asia/Yekaterinburg"),
("576172", "Blagodarnyy", "Благодарный", "RU", "643", "70", "", "", "", "45.09778", "43.43639", "Europe/Moscow"),
("576279", "Biryulevo", "Бирюлёво", "RU", "643", "48", "", "", "", "55.58635", "37.67781", "Europe/Moscow"),
("576317", "Birsk", "Бирск", "RU", "643", "08", "", "", "", "55.42111", "55.54278", "Asia/Yekaterinburg"),
("576432", "Bibirevo", "Бибирево", "RU", "643", "48", "", "", "", "55.88333", "37.6", "Europe/Moscow"),
("576566", "Bezhetsk", "Бежецк", "RU", "643", "77", "", "", "", "57.78506", "36.69651", "Europe/Moscow"),
("576590", "Bezenchuk", "Бородинский", "RU", "643", "65", "", "", "", "52.982", "49.4333", "Europe/Samara"),
("576697", "Beslan", "Беслан", "RU", "643", "68", "", "", "", "43.19217", "44.54313", "Europe/Moscow"),
("577206", "Berezniki", "Березники", "RU", "643", "90", "", "", "", "59.4091", "56.8204", "Asia/Yekaterinburg"),
("577881", "Beloretsk", "Белорецк", "RU", "643", "08", "", "", "", "53.96306", "58.39806", "Asia/Yekaterinburg"),
("577893", "Belorechensk", "Белореченск", "RU", "643", "38", "", "", "", "44.77127", "39.87879", "Europe/Moscow"),
("577901", "Beloozerskiy", "Белоозёрский", "RU", "643", "47", "", "", "", "55.45978", "38.44358", "Europe/Moscow"),
("578072", "Belgorod", "Белгород", "RU", "643", "09", "578070", "", "", "50.61074", "36.58015", "Europe/Moscow"),
("578091", "Belev", "Белёв", "RU", "643", "76", "", "", "", "53.81194", "36.13194", "Europe/Moscow"),
("578120", "Belebey", "Белебей", "RU", "643", "08", "", "", "", "54.11667", "54.11667", "Asia/Yekaterinburg"),
("578155", "Belaya Kalitva", "Белая-Калитва", "RU", "643", "61", "", "", "", "48.18585", "40.77424", "Europe/Moscow"),
("578169", "Belaya Glina", "Белая Глина", "RU", "643", "38", "", "", "", "46.07802", "40.86651", "Europe/Moscow"),
("578534", "Baymak", "Баймак", "RU", "643", "08", "", "", "", "52.59333", "58.3225", "Asia/Yekaterinburg"),
("578638", "Bavly", "Бавлы", "RU", "643", "73", "578639", "", "", "54.39304", "53.26023", "Europe/Moscow"),
("578740", "Bataysk", "Батайск", "RU", "643", "61", "", "", "", "47.13975", "39.75181", "Europe/Moscow"),
("578931", "Barysh", "Барыш", "RU", "643", "81", "", "", "", "53.65533", "47.11229", "Europe/Moscow"),
("579432", "Balezino", "Балезино", "RU", "643", "80", "", "", "", "57.9787", "53.0138", "Europe/Samara"),
("579460", "Balashov", "Балашов", "RU", "643", "67", "", "", "", "51.5502", "43.1667", "Europe/Volgograd"),
("579464", "Balashikha", "Балашиха", "RU", "643", "47", "", "", "", "55.80945", "37.95806", "Europe/Moscow"),
("579492", "Balakovo", "Балаково", "RU", "643", "67", "", "", "", "52.02782", "47.8007", "Europe/Volgograd"),
("579514", "Novaya Balakhna", "Балахна", "RU", "643", "51", "", "", "", "56.48989", "43.60114", "Europe/Moscow"),
("579529", "Balabanovo", "Балабаново", "RU", "643", "25", "", "", "", "55.18161", "36.6606", "Europe/Moscow"),
("579574", "Baksan", "Баксан", "RU", "643", "22", "", "", "", "43.68806", "43.53694", "Europe/Moscow"),
("579738", "Bakal", "Бакал", "RU", "643", "13", "", "", "", "54.9417", "58.8083", "Asia/Yekaterinburg"),
("579771", "Bagayevskaya", "Багаевская", "RU", "643", "61", "", "", "", "47.32411", "40.38791", "Europe/Moscow"),
("579870", "Babushkin", "Бабушкин", "RU", "643", "48", "", "", "", "55.86931", "37.72966", "Europe/Moscow"),
("580054", "Azov", "Азов", "RU", "643", "61", "", "", "", "47.10779", "39.41648", "Europe/Moscow"),
("580218", "Avtury", "Автуры", "RU", "643", "12", "495940", "", "", "43.16354", "46.0012", "Europe/Moscow"),
("580222", "Avtovo", "Автово", "RU", "643", "66", "", "", "", "59.87167", "30.26583", "Europe/Moscow"),
("580420", "Atkarsk", "Аткарск", "RU", "643", "67", "", "", "", "51.87185", "45.00775", "Europe/Volgograd"),
("580497", "Astrakhan'", "Астрахань", "RU", "643", "07", "824964", "", "", "46.34968", "48.04076", "Europe/Volgograd"),
("580660", "Asha", "Аша", "RU", "643", "13", "", "", "", "54.9973", "57.2722", "Asia/Yekaterinburg"),
("580716", "Arzgir", "Арзгир", "RU", "643", "70", "", "", "", "45.37278", "44.22056", "Europe/Moscow"),
("580724", "Arzamas", "Арзамас", "RU", "643", "51", "", "", "", "55.39485", "43.83992", "Europe/Moscow"),
("580850", "Arsk", "Арск", "RU", "643", "73", "580846", "", "", "56.09151", "49.87783", "Europe/Moscow"),
("580922", "Armavir", "Армавир", "RU", "643", "38", "", "", "", "44.9892", "41.1234", "Europe/Moscow"),
("581049", "Arkhangel'sk", "Архангельск", "RU", "643", "06", "", "", "", "64.5401", "40.5433", "Europe/Moscow"),
("581126", "Argun", "Аргун", "RU", "643", "12", "", "", "", "43.29713", "45.87454", "Europe/Moscow"),
("581179", "Ardon", "Ардон", "RU", "643", "68", "", "", "", "43.1772", "44.29702", "Europe/Moscow"),
("581313", "Apsheronsk", "Апшеронск", "RU", "643", "38", "", "", "", "44.46472", "39.73417", "Europe/Moscow"),
("581321", "Aprelevka", "Апрелевка", "RU", "643", "47", "", "", "", "55.55194", "37.0801", "Europe/Moscow"),
("581357", "Apatity", "Апатиты", "RU", "643", "49", "", "", "", "67.56414", "33.4031", "Europe/Moscow"),
("581671", "Anna", "Анна", "RU", "643", "86", "", "", "", "51.4842", "40.4299", "Europe/Moscow"),
("581928", "Andreyevskoye", "Андреевское", "RU", "643", "47", "", "", "", "55.55487", "37.92566", "Europe/Moscow"),
("582182", "Anapa", "Анапа", "RU", "643", "38", "", "", "", "44.89084", "37.3239", "Europe/Moscow"),
("582266", "Amin'yevo", "Аминьево", "RU", "643", "48", "", "", "", "55.7", "37.46667", "Europe/Moscow"),
("582432", "Al'met'yevsk", "Альметьевск", "RU", "643", "73", "Al’met’yevskiy Rayon", "", "", "54.90442", "52.3154", "Europe/Moscow"),
("582750", "Aleksin", "Алексин", "RU", "643", "76", "", "", "", "54.50503", "37.0674", "Europe/Moscow"),
("582846", "Alekseyevka", "Алексеевка", "RU", "643", "47", "", "", "", "55.63", "37.8", "Europe/Moscow"),
("582956", "Alekseyevka", "Алексеевка", "RU", "643", "09", "", "", "", "50.6309", "38.6903", "Europe/Moscow"),
("582978", "Aleksandrow", "Александров", "RU", "643", "83", "", "", "", "56.4", "38.71667", "Europe/Moscow"),
("582993", "Aleksandrovskoye", "Александровское", "RU", "643", "70", "", "", "", "44.71417", "43.00083", "Europe/Moscow"),
("583041", "Aleksandrovsk", "Александровск", "RU", "643", "90", "", "", "", "59.1581", "57.5695", "Asia/Yekaterinburg"),
("583350", "Aleksandrov", "Александров", "RU", "643", "83", "", "", "", "56.39516", "38.71216", "Europe/Moscow"),
("583437", "Alatyr'", "Алатырь", "RU", "643", "16", "", "", "", "54.8421", "46.5813", "Europe/Moscow"),
("583589", "Levoberezhnyy", "Аксиньино", "RU", "643", "47", "", "", "", "55.85", "37.48333", "Europe/Moscow"),
("583673", "Aksay", "Аксай", "RU", "643", "61", "", "", "", "47.25838", "39.86675", "Europe/Moscow"),
("583785", "Akhtyrskiy", "Ахтырский", "RU", "643", "38", "", "", "", "44.8546", "38.3031", "Europe/Moscow"),
("583798", "Akhtubinsk", "Ахтубинск", "RU", "643", "07", "", "", "", "48.27955", "46.17217", "Europe/Volgograd"),
("583983", "Agryz", "Агрыз", "RU", "643", "73", "", "", "", "56.52034", "52.99422", "Europe/Moscow"),
("584126", "Afipskiy", "Афипский", "RU", "643", "38", "", "", "", "44.90005", "38.84265", "Europe/Moscow"),
("584243", "Adler", "Адлер", "RU", "643", "38", "", "", "", "43.42896", "39.92391", "Europe/Moscow"),
("584298", "Achkhoy-Martan", "Ачхой-Мартан", "RU", "643", "12", "", "", "", "43.18997", "45.28373", "Europe/Moscow"),
("584441", "Abinsk", "Абинск", "RU", "643", "38", "", "", "", "44.86804", "38.15728", "Europe/Moscow"),
("584471", "Abdulino", "Абдулино", "RU", "643", "55", "", "", "", "53.7", "53.66667", "Asia/Yekaterinburg"),
("611182", "Vasil'yevo", "Васильево", "RU", "643", "73", "Zelenodol'skiy Rayon", "", "", "55.83596", "48.6582", "Europe/Moscow"),
("695019", "Ryl'sk", "Рыльск", "RU", "643", "41", "", "", "", "51.5655", "34.6822", "Europe/Moscow"),
("797781", "Neftekumsk", "Нефтекумск", "RU", "643", "70", "", "", "", "44.75583", "44.9925", "Europe/Moscow"),
("802078", "Alagir", "Алагир", "RU", "643", "68", "", "", "", "43.04222", "44.22222", "Europe/Moscow"),
("802714", "Persianovka", "Персиановский", "RU", "643", "61", "", "", "", "47.52972", "39.41833", "Europe/Moscow"),
("819552", "Annino", "Аннино", "RU", "643", "47", "", "", "", "55.58316", "37.26019", "Europe/Moscow"),
("823674", "Dagomys", "Дагомыс", "RU", "643", "38", "", "", "", "43.66974", "39.66863", "Europe/Moscow"),
("827329", "Pavlovo", "Павлово", "RU", "643", "51", "", "", "", "55.9686", "43.0912", "Europe/Moscow"),
("828055", "Belidzhi", "Белиджи", "RU", "643", "17", "", "", "", "41.89184", "48.41247", "Europe/Moscow"),
("829005", "Lesnoy", "Лесной", "RU", "643", "71", "", "", "", "58.63667", "59.80222", "Asia/Yekaterinburg"),
("830844", "Trekhgornyy", "Трёхгорный", "RU", "643", "13", "", "", "", "54.815", "58.45917", "Asia/Yekaterinburg"),
("831129", "Mirnyy", "Мирный", "RU", "643", "06", "", "", "", "62.76409", "40.33746", "Europe/Moscow"),
("831130", "Znamensk", "Капустин Яр", "RU", "643", "07", "", "", "", "48.5842", "45.7338", "Europe/Volgograd"),
("831165", "Zarechnyy", "Заречный", "RU", "643", "57", "", "", "", "53.13333", "46.58333", "Europe/Moscow"),
("841006", "Kochubeyevskoye", "Кочубеевское", "RU", "643", "70", "", "", "", "44.64417", "41.84528", "Europe/Moscow"),
("857689", "Vnukovo", "Внуково", "RU", "643", "47", "536086", "", "", "55.61194", "37.29611", "Europe/Moscow"),
("857690", "Moskovskiy", "Московский", "RU", "643", "47", "", "", "", "55.59911", "37.35495", "Europe/Moscow"),
("863061", "Usinsk", "Усинск", "RU", "643", "34", "", "", "", "65.99389", "57.52806", "Europe/Moscow"),
("873901", "Obukhovo", "Обухово", "RU", "643", "66", "", "", "", "59.84389", "30.45111", "Europe/Moscow"),
("874045", "Staryy Malgobek", "Старый Малгобек", "RU", "643", "19", "", "", "", "43.54437", "44.59592", "Europe/Moscow"),
("1485357", "Zavodoukovsk", "Заводоуковск", "RU", "643", "78", "", "", "", "56.5042", "66.55153", "Asia/Yekaterinburg"),
("1485439", "Zarinsk", "Заринск", "RU", "643", "04", "", "", "", "53.7074", "84.9493", "Asia/Omsk"),
("1485445", "Zarechnyy", "Заречный", "RU", "643", "71", "", "", "", "56.811", "61.3254", "Asia/Yekaterinburg"),
("1485627", "Yuzhnyy", "Южный", "RU", "643", "04", "", "", "", "53.25417", "83.69361", "Asia/Omsk"),
("1485634", "Yuzhnoural'sk", "Южноуральск", "RU", "643", "13", "", "", "", "54.4418", "61.2536", "Asia/Yekaterinburg"),
("1485724", "Yurga", "Юрга", "RU", "643", "29", "", "", "", "55.72306", "84.88611", "Asia/Novokuznetsk"),
("1485997", "Yeniseysk", "Енисейск", "RU", "643", "91", "", "", "", "58.44937", "92.17968", "Asia/Krasnoyarsk"),
("1486039", "Yemanzhelinsk", "Еманжелинск", "RU", "643", "13", "", "", "", "54.75472", "61.32083", "Asia/Yekaterinburg"),
("1486209", "Yekaterinburg", "Екатеринбург", "RU", "643", "71", "", "", "", "56.8519", "60.6122", "Asia/Yekaterinburg"),
("1486298", "Yashkino", "Яшкино", "RU", "643", "29", "", "", "", "55.8736", "85.4265", "Asia/Novokuznetsk"),
("1486340", "Yarovoye", "Яровое", "RU", "643", "04", "", "", "", "52.9273", "78.58", "Asia/Omsk"),
("1486468", "Yalutorovsk", "Ялуторовск", "RU", "643", "78", "", "", "", "56.65358", "66.30058", "Asia/Yekaterinburg"),
("1486910", "Vorkuta", "Воркута", "RU", "643", "34", "", "", "", "67.49884", "64.05253", "Europe/Moscow"),
("1486913", "Vorgashor", "Воргашор", "RU", "643", "34", "", "", "", "67.58355", "63.79399", "Europe/Moscow"),
("1487277", "Verkhnyaya Salda", "Верхняя Салда", "RU", "643", "71", "", "", "", "58.04874", "60.55949", "Asia/Yekaterinburg"),
("1487281", "Verkhnyaya Pyshma", "Верхняя Пышма", "RU", "643", "71", "", "", "", "56.97047", "60.58219", "Asia/Yekaterinburg"),
("1487394", "Verkhniy Ufaley", "Верхний Уфалей", "RU", "643", "13", "", "", "", "56.0556", "60.2397", "Asia/Yekaterinburg"),
("1487882", "Uzhur", "Ужур", "RU", "643", "91", "", "", "", "55.31246", "89.83301", "Asia/Krasnoyarsk"),
("1488253", "Zelenogorsk", "Зеленогорск", "RU", "643", "91", "", "", "", "56.1124", "94.5985", "Asia/Krasnoyarsk"),
("1488429", "Uray", "Урай", "RU", "643", "32", "", "", "", "60.13044", "64.78896", "Asia/Yekaterinburg"),
("1488754", "Tyumen", "Тюмень", "RU", "643", "78", "", "", "", "57.15222", "65.52722", "Asia/Yekaterinburg"),
("1488933", "Turinsk", "Туринск", "RU", "643", "71", "", "", "", "58.04575", "63.69605", "Asia/Yekaterinburg"),
("1489246", "Troitsk", "Троицк", "RU", "643", "13", "", "", "", "54.0979", "61.5773", "Asia/Yekaterinburg"),
("1489394", "Topki", "Топки", "RU", "643", "29", "", "", "", "55.2769", "85.6163", "Asia/Novokuznetsk"),
("1489425", "Tomsk", "Томск", "RU", "643", "75", "1489419", "", "", "56.49771", "84.97437", "Asia/Novosibirsk"),
("1489508", "Toguchin", "Тогучин", "RU", "643", "53", "", "", "", "55.23528", "84.38583", "Asia/Novosibirsk"),
("1489530", "Tobol'sk", "Тобольск", "RU", "643", "78", "", "", "", "58.19807", "68.25457", "Asia/Yekaterinburg"),
("1489870", "Tayshet", "Тайшет", "RU", "643", "20", "", "", "", "55.9342", "98.0044", "Asia/Irkutsk"),
("1489907", "Tayga", "Тайга", "RU", "643", "29", "", "", "", "56.06402", "85.62238", "Asia/Novokuznetsk"),
("1489962", "Tavda", "Тавда", "RU", "643", "71", "", "", "", "58.04254", "65.27258", "Asia/Yekaterinburg"),
("1490003", "Tatarsk", "Татарск", "RU", "643", "53", "", "", "", "55.21904", "75.98284", "Asia/Novosibirsk"),
("1490042", "Tashtagol", "Таштагол", "RU", "643", "29", "", "", "", "52.7657", "87.8894", "Asia/Novokuznetsk"),
("1490085", "Tarko-Sale", "Тарко-Сале", "RU", "643", "87", "", "", "", "64.91611", "77.77457", "Asia/Yekaterinburg"),
("1490140", "Tara", "Тара", "RU", "643", "54", "", "", "", "56.89436", "74.37096", "Asia/Omsk"),
("1490256", "Talnakh", "Талнах", "RU", "643", "91", "", "", "", "69.4865", "88.3972", "Asia/Krasnoyarsk"),
("1490266", "Tal'menka", "Тальменка", "RU", "643", "04", "", "", "", "53.8183", "83.5677", "Asia/Omsk"),
("1490277", "Talitsa", "Талица", "RU", "643", "71", "", "", "", "56.8804", "60.0213", "Asia/Yekaterinburg"),
("1490281", "Talitsa", "Талица", "RU", "643", "71", "", "", "", "57.01095", "63.73254", "Asia/Yekaterinburg"),
("1490402", "Sysert'", "Сысерть", "RU", "643", "71", "", "", "", "56.50243", "60.81917", "Asia/Yekaterinburg"),
("1490551", "Suzun", "Сузун", "RU", "643", "53", "", "", "", "53.7841", "82.3116", "Asia/Novosibirsk"),
("1490624", "Surgut", "Сургут", "RU", "643", "32", "", "", "", "61.25", "73.41667", "Asia/Yekaterinburg"),
("1490686", "Sukhoy Log", "Сухой Лог", "RU", "643", "71", "", "", "", "56.9094", "62.0296", "Asia/Yekaterinburg"),
("1490796", "Strezhevoy", "Стрежевой", "RU", "643", "75", "", "", "", "60.7333", "77.5889", "Asia/Novosibirsk"),
("1491159", "Sredneuralsk", "Среднеуральск", "RU", "643", "71", "", "", "", "56.98921", "60.46662", "Asia/Yekaterinburg"),
("1491230", "Sovetskiy", "Советский", "RU", "643", "32", "", "", "", "61.36139", "63.58417", "Asia/Yekaterinburg"),
("1491291", "Sosnovoborsk", "Сосновоборск", "RU", "643", "91", "", "", "", "56.1217", "93.3385", "Asia/Krasnoyarsk"),
("1491706", "Slavgorod", "Славгород", "RU", "643", "04", "", "", "", "52.9978", "78.6449", "Asia/Omsk"),
("1491953", "Shushenskoye", "Шушенское", "RU", "643", "91", "", "", "", "53.325", "91.93556", "Asia/Krasnoyarsk"),
("1491999", "Shumikha", "Шумиха", "RU", "643", "40", "", "", "", "55.22611", "63.29611", "Asia/Yekaterinburg"),
("1492401", "Sharypovo", "Шарыпово", "RU", "643", "91", "", "", "", "55.54028", "89.20083", "Asia/Krasnoyarsk"),
("1492517", "Shadrinsk", "Шадринск", "RU", "643", "40", "", "", "", "56.0852", "63.6335", "Asia/Yekaterinburg"),
("1492663", "Serov", "Серов", "RU", "643", "71", "", "", "", "59.60334", "60.5787", "Asia/Yekaterinburg"),
("1492893", "Sayanogorsk", "Саяногорск", "RU", "643", "31", "", "", "", "53.0875", "91.39972", "Asia/Krasnoyarsk"),
("1493197", "Salekhard", "Салехард", "RU", "643", "87", "", "", "", "66.53", "66.60194", "Asia/Yekaterinburg"),
("1493467", "Rubtsovsk", "Рубцовск", "RU", "643", "04", "", "", "", "51.51473", "81.20613", "Asia/Omsk"),
("1493648", "Rezh", "Реж", "RU", "643", "71", "", "", "", "57.37005", "61.40428", "Asia/Yekaterinburg"),
("1493687", "Reftinskiy", "Рефтинский", "RU", "643", "71", "", "", "", "57.09013", "61.67692", "Asia/Yekaterinburg"),
("1494091", "Promyshlennaya", "Промышленная", "RU", "643", "29", "", "", "", "54.9159", "85.6385", "Asia/Novokuznetsk"),
("1494114", "Prokop'yevsk", "Прокопьевск", "RU", "643", "29", "", "", "", "53.9059", "86.719", "Asia/Novokuznetsk"),
("1494276", "Poykovskiy", "Пойковский", "RU", "643", "32", "", "", "", "61.23333", "73.33333", "Asia/Yekaterinburg"),
("1494456", "Polysayevo", "Полысаево", "RU", "643", "29", "", "", "", "54.6012", "86.2459", "Asia/Novokuznetsk"),
("1494573", "Polevskoy", "Полевской", "RU", "643", "71", "", "", "", "56.44222", "60.18778", "Asia/Yekaterinburg"),
("1494907", "Plast", "Пласт", "RU", "643", "13", "", "", "", "54.36914", "60.81361", "Asia/Yekaterinburg"),
("1495974", "Osinniki", "Осинники", "RU", "643", "29", "", "", "", "53.6239", "87.3598", "Asia/Novokuznetsk"),
("1496153", "Omsk", "Омск", "RU", "643", "54", "", "", "", "54.99244", "73.36859", "Asia/Omsk"),
("1496421", "Ob'", "Обь", "RU", "643", "53", "", "", "", "54.9872", "82.7166", "Asia/Novosibirsk"),
("1496476", "Nyagan", "Нягань", "RU", "643", "32", "", "", "", "62.14056", "65.39361", "Asia/Yekaterinburg"),
("1496503", "Noyabrsk", "Ноябрьск", "RU", "643", "87", "", "", "", "63.19309", "75.43728", "Asia/Yekaterinburg"),
("1496511", "Novyy Urengoy", "Новый Уренгой", "RU", "643", "87", "", "", "", "66.08333", "76.63333", "Asia/Yekaterinburg"),
("1496739", "Novosilikatnyy", "Новосиликатный", "RU", "643", "04", "", "", "", "53.30972", "83.62389", "Asia/Omsk"),
("1496747", "Novosibirsk", "Новосибирск", "RU", "643", "53", "1496742", "", "", "55.0415", "82.9346", "Asia/Novosibirsk"),
("1496990", "Novokuznetsk", "Новокузнецк", "RU", "643", "29", "", "", "", "53.7557", "87.1099", "Asia/Novokuznetsk"),
("1497173", "Novoaltaysk", "Новоалтайск", "RU", "643", "04", "", "", "", "53.3917", "83.9363", "Asia/Omsk"),
("1497337", "Noril'sk", "Норильск", "RU", "643", "91", "", "", "", "69.3535", "88.2027", "Asia/Krasnoyarsk"),
("1497393", "Nizhnyaya Salda", "Нижняя Салда", "RU", "643", "71", "", "", "", "58.07756", "60.7202", "Asia/Yekaterinburg"),
("1497543", "Nizhnevartovsk", "Нижневартовск", "RU", "643", "32", "", "", "", "60.9344", "76.5531", "Asia/Yekaterinburg"),
("1497549", "Nizhneudinsk", "Нижнеудинск", "RU", "643", "20", "", "", "", "54.9076", "99.0276", "Asia/Irkutsk"),
("1497795", "Nev'yansk", "Невьянск", "RU", "643", "71", "", "", "", "57.4953", "60.2112", "Asia/Yekaterinburg"),
("1497917", "Nefteyugansk", "Нефтеюганск", "RU", "643", "32", "", "", "", "61.09979", "72.60349", "Asia/Yekaterinburg"),
("1497951", "Nazarovo", "Назарово", "RU", "643", "91", "", "", "", "56.0104", "90.4011", "Asia/Krasnoyarsk"),
("1498087", "Nadym", "Надым", "RU", "643", "87", "", "", "", "65.53333", "72.51667", "Asia/Yekaterinburg"),
("1498129", "Myski", "Мыски", "RU", "643", "29", "", "", "", "53.709", "87.8014", "Asia/Novokuznetsk"),
("1498693", "Minusinsk", "Минусинск", "RU", "643", "91", "", "", "", "53.71028", "91.6875", "Asia/Krasnoyarsk"),
("1498894", "Miass", "Миасс", "RU", "643", "13", "", "", "", "55.045", "60.10833", "Asia/Yekaterinburg"),
("1498920", "Mezhdurechensk", "Междуреченск", "RU", "643", "29", "", "", "", "53.69417", "88.06028", "Asia/Novokuznetsk"),
("1499053", "Megion", "Мегион", "RU", "643", "32", "", "", "", "61.0296", "76.1136", "Asia/Yekaterinburg"),
("1499163", "Mayma", "Майма", "RU", "643", "30", "", "", "", "52.01577", "85.90963", "Asia/Omsk"),
("1499350", "Mariinsk", "Мариинск", "RU", "643", "29", "", "", "", "56.21389", "87.74722", "Asia/Novokuznetsk"),
("1500532", "Linevo", "Линево", "RU", "643", "53", "", "", "", "54.4589", "83.3764", "Asia/Novosibirsk"),
("1500607", "Lesosibirsk", "Новомаклаково", "RU", "643", "91", "", "", "", "58.23583", "92.48278", "Asia/Krasnoyarsk"),
("1500665", "Leninsk-Kuznetsky", "Ленинск-Кузнецкий", "RU", "643", "29", "", "", "", "54.6567", "86.1737", "Asia/Novokuznetsk"),
("1500933", "Labytnangi", "Лабытнанги", "RU", "643", "87", "", "", "", "66.65722", "66.41833", "Asia/Yekaterinburg"),
("1500973", "Kyzyl", "Кызыл", "RU", "643", "79", "", "", "", "51.71472", "94.45338", "Asia/Krasnoyarsk"),
("1500997", "Kyshtym", "Кыштым", "RU", "643", "13", "", "", "", "55.714", "60.5528", "Asia/Yekaterinburg"),
("1501141", "Kuybyshev", "Куйбышев", "RU", "643", "53", "", "", "", "55.44753", "78.32181", "Asia/Novosibirsk"),
("1501255", "Kurtamysh", "Куртамыш", "RU", "643", "40", "", "", "", "54.91028", "64.43194", "Asia/Yekaterinburg"),
("1501321", "Kurgan", "Курган", "RU", "643", "40", "", "", "", "55.45", "65.33333", "Asia/Yekaterinburg"),
("1501365", "Kupino", "Купино", "RU", "643", "53", "", "", "", "54.36635", "77.29805", "Asia/Novosibirsk"),
("1501460", "Kulunda", "Кулунда", "RU", "643", "04", "", "", "", "52.566", "78.9385", "Asia/Omsk"),
("1502026", "Krasnoyarsk", "Красноярск", "RU", "643", "91", "", "", "", "56.01839", "92.86717", "Asia/Krasnoyarsk"),
("1502060", "Krasnoural'sk", "Красноуральск", "RU", "643", "71", "", "", "", "58.3638", "60.0407", "Asia/Yekaterinburg"),
("1502061", "Krasnotur'insk", "Краснотурьинск", "RU", "643", "71", "", "", "", "59.7666", "60.2086", "Asia/Yekaterinburg"),
("1502091", "Krasnoobsk", "Краснообск", "RU", "643", "53", "", "", "", "54.9198", "82.9909", "Asia/Novosibirsk"),
("1502536", "Korkino", "Коркино", "RU", "643", "13", "", "", "", "54.8913", "61.3969", "Asia/Yekaterinburg"),
("1502603", "Kopeysk", "Копейск", "RU", "643", "13", "", "", "", "55.11722", "61.62824", "Asia/Yekaterinburg"),
("1502725", "Yugorsk", "Югорск", "RU", "643", "32", "", "", "", "61.31226", "63.33068", "Asia/Yekaterinburg"),
("1502862", "Kolpashevo", "Колпашево", "RU", "643", "75", "", "", "", "58.31306", "82.90889", "Asia/Novosibirsk"),
("1503037", "Kodinsk", "Кодинск", "RU", "643", "91", "", "", "", "58.68806", "99.18444", "Asia/Krasnoyarsk"),
("1503082", "Kochenevo", "Коченёво", "RU", "643", "53", "", "", "", "55.0218", "82.202", "Asia/Novosibirsk"),
("1503277", "Kiselevsk", "Киселевск", "RU", "643", "29", "", "", "", "53.99", "86.6621", "Asia/Novokuznetsk"),
("1503335", "Kirovgrad", "Кировград", "RU", "643", "71", "", "", "", "57.42972", "60.05972", "Asia/Yekaterinburg"),
("1503772", "Khanty-Mansiysk", "Ханты-Мансийск", "RU", "643", "32", "", "", "", "61.00417", "69.00194", "Asia/Yekaterinburg"),
("1503901", "Kemerovo", "Кемерово", "RU", "643", "29", "", "", "", "55.33333", "86.08333", "Asia/Novokuznetsk"),
("1503940", "Kedrovka", "Кедровка", "RU", "643", "29", "", "", "", "55.53333", "86.05", "Asia/Novokuznetsk"),
("1504139", "Kayyerkan", "Кайеркан", "RU", "643", "91", "", "", "", "69.37861", "87.74389", "Asia/Krasnoyarsk"),
("1504212", "Kataysk", "Катайск", "RU", "643", "40", "", "", "", "56.289", "62.5841", "Asia/Yekaterinburg"),
("1504251", "Kasli", "Касли", "RU", "643", "13", "", "", "", "55.8909", "60.7616", "Asia/Yekaterinburg"),
("1504317", "Kartaly", "Карталы", "RU", "643", "13", "", "", "", "53.05285", "60.64903", "Asia/Yekaterinburg"),
("1504343", "Karpinsk", "Карпинск", "RU", "643", "71", "", "", "", "59.7703", "59.9964", "Asia/Yekaterinburg"),
("1504489", "Karasuk", "Карасук", "RU", "643", "53", "", "", "", "53.73772", "78.04026", "Asia/Novosibirsk"),
("1504636", "Karabash", "Карабаш", "RU", "643", "13", "", "", "", "55.4808", "60.2157", "Asia/Yekaterinburg"),
("1504682", "Kansk", "Канск", "RU", "643", "91", "", "", "", "56.20167", "95.7175", "Asia/Krasnoyarsk"),
("1504769", "Kamyshlov", "Камышлов", "RU", "643", "71", "", "", "", "56.84278", "62.71111", "Asia/Yekaterinburg"),
("1504826", "Kamensk-Ural'skiy", "Каменск-Уральский", "RU", "643", "71", "", "", "", "56.4185", "61.9329", "Asia/Yekaterinburg"),
("1504871", "Kamen'-na-Obi", "Камень-на-Оби", "RU", "643", "04", "", "", "", "53.7884", "81.3423", "Asia/Omsk"),
("1504972", "Kaltan", "Калтан", "RU", "643", "29", "", "", "", "53.5347", "87.2457", "Asia/Novokuznetsk"),
("1505074", "Kalachinsk", "Калачинск", "RU", "643", "54", "", "", "", "55.05286", "74.57511", "Asia/Omsk"),
("1505260", "Ivdel'", "Ивдель-1", "RU", "643", "71", "", "", "", "60.69111", "60.42056", "Asia/Yekaterinburg"),
("1505429", "Iskitim", "Искитим", "RU", "643", "53", "", "", "", "54.6366", "83.3045", "Asia/Novosibirsk"),
("1505453", "Ishim", "Ишим", "RU", "643", "78", "", "", "", "56.11281", "69.49015", "Asia/Yekaterinburg"),
("1505526", "Irbit", "Ирбит", "RU", "643", "71", "", "", "", "57.67052", "63.071", "Asia/Yekaterinburg"),
("1505933", "Ilanskiy", "Иланский", "RU", "643", "91", "", "", "", "56.2325", "96.0652", "Asia/Krasnoyarsk"),
("1506073", "Gur'yevsk", "Гурьевск", "RU", "643", "29", "", "", "", "54.28333", "85.93333", "Asia/Novokuznetsk"),
("1506260", "Gornyak", "Горняк", "RU", "643", "04", "", "", "", "50.99417", "81.46611", "Asia/Omsk"),
("1506271", "Gorno-Altaysk", "Горно-Алтайск", "RU", "643", "03", "1499159", "", "", "51.96056", "85.91892", "Asia/Omsk"),
("1507116", "Dudinka", "Дудинка", "RU", "643", "91", "", "", "", "69.40583", "86.17778", "Asia/Krasnoyarsk"),
("1507379", "Divnogorsk", "Дивногорск", "RU", "643", "91", "", "", "", "55.9581", "92.3726", "Asia/Krasnoyarsk"),
("1507488", "Degtyarsk", "Дегтярск", "RU", "643", "71", "", "", "", "56.704", "60.0879", "Asia/Yekaterinburg"),
("1507636", "Chunskiy", "Чунский", "RU", "643", "20", "", "", "", "56.0815", "99.6342", "Asia/Irkutsk"),
("1508054", "Chernogorsk", "Черногорск", "RU", "643", "31", "", "", "", "53.82361", "91.28417", "Asia/Krasnoyarsk"),
("1508161", "Cherepanovo", "Черепаново", "RU", "643", "53", "", "", "", "54.2222", "83.381", "Asia/Novosibirsk"),
("1508291", "Chelyabinsk", "Челябинск", "RU", "643", "13", "1535932", "", "", "55.15402", "61.42915", "Asia/Yekaterinburg"),
("1508350", "Chebarkul'", "Чебаркуль", "RU", "643", "13", "", "", "", "54.9749", "60.3633", "Asia/Yekaterinburg"),
("1508879", "Borovskiy", "Боровский", "RU", "643", "78", "", "", "", "57.04096", "65.72018", "Asia/Yekaterinburg"),
("1508943", "Borodino", "Бородино", "RU", "643", "91", "", "", "", "55.9061", "94.9079", "Asia/Krasnoyarsk"),
("1509819", "Bolotnoye", "Болотное", "RU", "643", "53", "", "", "", "55.67167", "84.39806", "Asia/Novosibirsk"),
("1509852", "Bogotol", "Боготол", "RU", "643", "91", "", "", "", "56.20778", "89.53417", "Asia/Krasnoyarsk"),
("1509888", "Bogdanovich", "Богданович", "RU", "643", "71", "", "", "", "56.78028", "62.04944", "Asia/Yekaterinburg"),
("1510018", "Biysk", "Бийск", "RU", "643", "04", "", "", "", "52.53639", "85.20722", "Asia/Omsk"),
("1510203", "Beryozovsky", "Берёзовский", "RU", "643", "71", "", "", "", "56.9083", "60.8019", "Asia/Yekaterinburg"),
("1510205", "Berezovskiy", "Березовский", "RU", "643", "29", "", "", "", "55.6", "86.2", "Asia/Novokuznetsk"),
("1510255", "Berezovka", "Березовка", "RU", "643", "91", "", "", "", "56.03044", "93.11164", "Asia/Krasnoyarsk"),
("1510350", "Berdsk", "Бердск", "RU", "643", "53", "", "", "", "54.7551", "83.0967", "Asia/Novosibirsk"),
("1510450", "Beloyarskiy", "Белоярский", "RU", "643", "32", "", "", "", "63.71194", "66.67222", "Asia/Yekaterinburg"),
("1510469", "Belovo", "Белово", "RU", "643", "29", "", "", "", "54.4165", "86.2976", "Asia/Novokuznetsk"),
("1510853", "Barnaul", "Барнаул", "RU", "643", "04", "1535931", "", "", "53.36056", "83.76361", "Asia/Omsk"),
("1510916", "Barabinsk", "Барабинск", "RU", "643", "53", "", "", "", "55.35709", "78.35697", "Asia/Novosibirsk"),
("1511309", "Asino", "Асино", "RU", "643", "75", "", "", "", "56.99987", "86.14393", "Asia/Novosibirsk"),
("1511330", "Asbest", "Асбест", "RU", "643", "71", "", "", "", "57.00993", "61.45776", "Asia/Yekaterinburg"),
("1511368", "Artemovskiy", "Артемовский", "RU", "643", "71", "", "", "", "57.3555", "61.86865", "Asia/Yekaterinburg"),
("1511466", "Aramil", "Арамиль", "RU", "643", "71", "", "", "", "56.6977", "60.8369", "Asia/Yekaterinburg"),
("1511494", "Anzhero-Sudzhensk", "Анжеро-Судженск", "RU", "643", "29", "", "", "", "56.081", "86.0285", "Asia/Novokuznetsk"),
("1511783", "Aleysk", "Алейск", "RU", "643", "04", "", "", "", "52.4926", "82.7822", "Asia/Omsk"),
("1511954", "Alapayevsk", "Алапаевск", "RU", "643", "71", "", "", "", "57.85158", "61.69627", "Asia/Yekaterinburg"),
("1512086", "Akademgorodok", "Академгородок", "RU", "643", "53", "", "", "", "54.8523", "83.106", "Asia/Novosibirsk"),
("1512165", "Achinsk", "Ачинск", "RU", "643", "91", "", "", "", "56.2694", "90.4993", "Asia/Krasnoyarsk"),
("1512205", "Abaza", "Абаза", "RU", "643", "31", "", "", "", "52.655", "90.09278", "Asia/Krasnoyarsk"),
("1512236", "Abakan", "Абакан", "RU", "643", "31", "", "", "", "53.71556", "91.42917", "Asia/Krasnoyarsk"),
("1536289", "Snezhinsk", "Снежинск", "RU", "643", "13", "", "", "", "56.085", "60.73139", "Asia/Yekaterinburg"),
("1538634", "Ozersk", "Озёрск", "RU", "643", "13", "", "", "", "55.75556", "60.70278", "Asia/Yekaterinburg"),
("1538635", "Zheleznogorsk", "Железногорск", "RU", "643", "91", "", "", "", "56.25111", "93.53194", "Asia/Krasnoyarsk"),
("1538636", "Novoural'sk", "Новоуральск", "RU", "643", "71", "", "", "", "57.24389", "60.08389", "Asia/Yekaterinburg"),
("1538637", "Seversk", "Северск", "RU", "643", "75", "", "", "", "56.60056", "84.88639", "Asia/Novosibirsk"),
("1539209", "Gubkinskiy", "Губкинский", "RU", "643", "87", "", "", "", "64.434", "76.50261", "Asia/Yekaterinburg"),
("1540356", "Raduzhny", "Радужный", "RU", "643", "32", "", "", "", "62.09611", "77.475", "Asia/Yekaterinburg"),
("1540711", "Muravlenko", "Муравленко", "RU", "643", "87", "", "", "", "63.78977", "74.52301", "Asia/Yekaterinburg"),
("1541359", "Lyantor", "Лянтор", "RU", "643", "32", "", "", "", "61.61945", "72.15546", "Asia/Yekaterinburg"),
("2012484", "Zima", "Зима", "RU", "643", "20", "", "", "", "53.9202", "102.0442", "Asia/Irkutsk"),
("2012557", "Zheleznogorsk-Ilimskiy", "Железногорск-Илимский", "RU", "643", "20", "", "", "", "56.5768", "104.1217", "Asia/Irkutsk"),
("2012593", "Zeya", "Зея", "RU", "643", "05", "", "", "", "53.73601", "127.257", "Asia/Yakutsk"),
("2013159", "Yakutsk", "Якутск", "RU", "643", "63", "Yakutsk (undefined)", "", "", "62.03389", "129.73306", "Asia/Yakutsk"),
("2013229", "Vyazemskiy", "Вяземский", "RU", "643", "30", "", "", "", "47.53758", "134.75556", "Asia/Vladivostok"),
("2013258", "Vrangel'", "Врангель", "RU", "643", "59", "", "", "", "42.73021", "133.08322", "Asia/Vladivostok"),
("2013348", "Vladivostok", "Владивосток", "RU", "643", "59", "", "", "", "43.10562", "131.87353", "Asia/Vladivostok"),
("2013399", "Vikhorevka", "Вихоревка", "RU", "643", "20", "", "", "", "56.12128", "101.17767", "Asia/Irkutsk"),
("2013923", "Ust'-Kut", "Усть-Кут", "RU", "643", "20", "", "", "", "56.7938", "105.7672", "Asia/Irkutsk"),
("2013952", "Ust'-Ilimsk", "Усть-Илимск", "RU", "643", "20", "", "", "", "58.00056", "102.66194", "Asia/Irkutsk"),
("2014006", "Ussuriysk", "Уссурийск", "RU", "643", "59", "", "", "", "43.80291", "131.94578", "Asia/Vladivostok"),
("2014022", "Usol'ye-Sibirskoye", "Усолье-Сибирское", "RU", "643", "20", "", "", "", "52.75194", "103.64528", "Asia/Irkutsk"),
("2014407", "Ulan-Ude", "Улан-Удэ", "RU", "643", "11", "2050912", "", "", "51.82721", "107.60627", "Asia/Irkutsk"),
("2014624", "Udachny", "Удачный", "RU", "643", "63", "", "", "", "66.42989", "112.4021", "Asia/Yakutsk"),
("2014718", "Tynda", "Тында", "RU", "643", "05", "", "", "", "55.156", "124.72479", "Asia/Yakutsk"),
("2014927", "Tulun", "Тулун", "RU", "643", "20", "", "", "", "54.56358", "100.58143", "Asia/Irkutsk"),
("2015051", "Trudovoye", "Трудовое", "RU", "643", "59", "", "", "", "43.29823", "132.06877", "Asia/Vladivostok"),
("2015310", "Fokino", "Фокино", "RU", "643", "59", "", "", "", "42.97429", "132.40574", "Asia/Vladivostok"),
("2015833", "Svobodnyy", "Свободный", "RU", "643", "05", "", "", "", "51.37525", "128.14097", "Asia/Yakutsk"),
("2016187", "Spassk-Dal'niy", "Спасск-Дальний", "RU", "643", "59", "", "", "", "44.59884", "132.82593", "Asia/Vladivostok"),
("2016422", "Slyudyanka", "Слюдянка", "RU", "643", "20", "", "", "", "51.65944", "103.70611", "Asia/Irkutsk"),
("2016701", "Shimanovsk", "Шимановск", "RU", "643", "05", "", "", "", "52.00575", "127.67756", "Asia/Yakutsk"),
("2016764", "Shelekhov", "Шелехов", "RU", "643", "20", "", "", "", "52.21389", "104.1", "Asia/Irkutsk"),
("2016910", "Severobaykal'sk", "Северобайкальск", "RU", "643", "11", "", "", "", "55.63695", "109.32297", "Asia/Irkutsk"),
("2017487", "Raychikhinsk", "Райчихинск", "RU", "643", "05", "", "", "", "49.78998", "129.40992", "Asia/Yakutsk"),
("2017945", "Petrovsk-Zabaykal'skiy", "Петровск-Забайкальский", "RU", "643", "93", "", "", "", "51.2753", "108.843", "Asia/Yakutsk"),
("2018116", "Partizansk", "Партизанск", "RU", "643", "59", "", "", "", "43.12165", "133.12347", "Asia/Vladivostok"),
("2019309", "Neryungri", "Нерюнгри", "RU", "643", "63", "", "", "", "56.66637", "124.63825", "Asia/Yakutsk"),
("2019326", "Nerchinsk", "Нерчинск", "RU", "643", "93", "", "", "", "51.98333", "116.58333", "Asia/Yakutsk"),
("2019528", "Nakhodka", "Находка", "RU", "643", "59", "", "", "", "42.81384", "132.87348", "Asia/Vladivostok"),
("2019951", "Mirny", "Мирный", "RU", "643", "63", "", "", "", "62.53528", "113.96111", "Asia/Yakutsk"),
("2020689", "Luchegorsk", "Лучегорск", "RU", "643", "59", "", "", "", "46.47656", "134.19532", "Asia/Vladivostok"),
("2020812", "Lesozavodsk", "Лесозаводск", "RU", "643", "59", "", "", "", "45.47885", "133.42825", "Asia/Vladivostok"),
("2020838", "Lensk", "Ленск", "RU", "643", "63", "", "", "", "60.72528", "114.92778", "Asia/Yakutsk"),
("2021066", "Kyakhta", "Кяхта", "RU", "643", "11", "", "", "", "50.35737", "106.45033", "Asia/Irkutsk"),
("2021618", "Krasnokamensk", "Краснокаменск", "RU", "643", "93", "", "", "", "50.0979", "118.0369", "Asia/Yakutsk"),
("2021851", "Komsomolsk-on-Amur", "Комсомольск-на-Амуре", "RU", "643", "30", "", "", "", "50.55034", "137.00995", "Asia/Vladivostok"),
("2022890", "Khabarovsk", "Хабаровск", "RU", "643", "30", "2022887", "", "", "48.48272", "135.08379", "Asia/Vladivostok"),
("2023058", "Kavalerovo", "Кавалерово", "RU", "643", "59", "", "", "", "44.27221", "135.05227", "Asia/Vladivostok"),
("2023469", "Irkutsk", "Иркутск", "RU", "643", "20", "2023464", "", "", "52.29778", "104.29639", "Asia/Irkutsk"),
("2023782", "Gusinoozyorsk", "Гусиноозёрск", "RU", "643", "11", "", "", "", "51.28333", "106.5", "Asia/Irkutsk"),
("2025159", "Dal'nerechensk", "Дальнереченск", "RU", "643", "59", "", "", "", "45.93149", "133.73906", "Asia/Vladivostok"),
("2025339", "Chita", "Чита", "RU", "643", "93", "", "", "", "52.03171", "113.50087", "Asia/Yakutsk"),
("2025527", "Cheremkhovo", "Черемхово", "RU", "643", "20", "", "", "", "53.15611", "103.0675", "Asia/Irkutsk"),
("2026126", "Borzya", "Борзя", "RU", "643", "93", "", "", "", "50.38333", "116.51667", "Asia/Yakutsk"),
("2026303", "Bol'shoy Kamen'", "Большой Камень", "RU", "643", "59", "", "", "", "43.11283", "132.354", "Asia/Vladivostok"),
("2026583", "Bodaybo", "Бодайбо", "RU", "643", "20", "", "", "", "57.85056", "114.19333", "Asia/Irkutsk"),
("2026609", "Blagoveshchensk", "Благовещенск", "RU", "643", "05", "", "", "", "50.27961", "127.5405", "Asia/Yakutsk"),
("2026643", "Birobidzhan", "Биробиджан", "RU", "643", "89", "", "", "", "48.79284", "132.92386", "Asia/Vladivostok"),
("2026696", "Bikin", "Бикин", "RU", "643", "30", "", "", "", "46.81293", "134.25012", "Asia/Vladivostok"),
("2026895", "Belogorsk", "Белогорск", "RU", "643", "05", "", "", "", "50.91644", "128.47726", "Asia/Yakutsk"),
("2026979", "Baykal'sk", "Байкальск", "RU", "643", "20", "", "", "", "51.5151", "104.1402", "Asia/Irkutsk"),
("2027296", "Aykhal", "Айхал", "RU", "643", "63", "", "", "", "65.9338", "111.4834", "Asia/Yakutsk"),
("2027456", "Artem", "Артем", "RU", "643", "59", "", "", "", "43.3595", "132.18887", "Asia/Vladivostok"),
("2027468", "Arsen'yev", "Арсеньев", "RU", "643", "59", "", "", "", "44.15254", "133.27791", "Asia/Vladivostok"),
("2027667", "Angarsk", "Ангарск", "RU", "643", "20", "", "", "", "52.53667", "103.88639", "Asia/Irkutsk"),
("2027749", "Amursk", "Амурск", "RU", "643", "30", "", "", "", "50.23685", "136.88136", "Asia/Vladivostok"),
("2027968", "Aldan", "Алдан", "RU", "643", "63", "", "", "", "58.61021", "125.39613", "Asia/Yakutsk"),
("2051471", "Dal'negorsk", "Дальнегорск", "RU", "643", "59", "", "", "", "44.56039", "135.57009", "Asia/Vladivostok"),
("2051523", "Bratsk", "Братск", "RU", "643", "20", "", "", "", "56.1325", "101.61417", "Asia/Irkutsk"),
("2055166", "Sayansk", "Саянск", "RU", "643", "20", "", "", "", "54.1088", "102.1648", "Asia/Irkutsk"),
("2056752", "Khabarovsk Vtoroy", "Хабаровск Второй", "RU", "643", "30", "", "", "", "48.43776", "135.13328", "Asia/Vladivostok"),
("2118647", "Vilyuchinsk", "Вилючинск", "RU", "643", "92", "", "", "", "52.9311", "158.40469", "Asia/Kamchatka"),
("2119441", "Yuzhno-Sakhalinsk", "Южно-Сахалинск", "RU", "643", "64", "", "", "", "46.95407", "142.73603", "Asia/Sakhalin"),
("2119538", "Yelizovo", "Елизово", "RU", "643", "92", "", "", "", "53.18909", "158.38135", "Asia/Kamchatka"),
("2119932", "Vanino", "Ванино", "RU", "643", "30", "", "", "", "49.09848", "140.25313", "Asia/Vladivostok"),
("2121052", "Sovetskaya Gavan'", "Советская Гавань", "RU", "643", "30", "", "", "", "48.97215", "140.28919", "Asia/Vladivostok"),
("2121909", "Poronaysk", "Поронайск", "RU", "643", "64", "", "", "", "49.22188", "143.09694", "Asia/Sakhalin"),
("2122104", "Petropavlovsk-Kamchatsky", "Петропавловск-Камчатский", "RU", "643", "92", "", "", "", "53.04444", "158.65076", "Asia/Kamchatka"),
("2122614", "Okha", "Оха", "RU", "643", "64", "", "", "", "53.58991", "142.95313", "Asia/Sakhalin"),
("2122850", "Nikolayevsk-on-Amure", "Николаевск-на-Амуре", "RU", "643", "30", "", "", "", "53.14657", "140.72288", "Asia/Vladivostok"),
("2122894", "Nevel'sk", "Невельск", "RU", "643", "64", "", "", "", "46.67902", "141.8563", "Asia/Sakhalin"),
("2123628", "Magadan", "Магадан", "RU", "643", "44", "", "", "", "59.5638", "150.80347", "Asia/Magadan"),
("2124286", "Korsakov", "Корсаков", "RU", "643", "64", "", "", "", "46.6342", "142.77722", "Asia/Sakhalin"),
("2124615", "Kholmsk", "Холмск", "RU", "643", "64", "", "", "", "47.04737", "142.05048", "Asia/Sakhalin"),
("2609906", "Baltiysk", "Балтийск", "RU", "643", "23", "825118", "", "", "54.65455", "19.90929", "Europe/Kaliningrad"),
("6417459", "Krasnoznamensk", "Краснознаменск", "RU", "643", "47", "", "", "", "55.59944", "37.03861", "Europe/Moscow"),
("6418146", "Chertanovo Yuzhnoye", "Чертаново Второе", "RU", "643", "48", "", "", "", "55.59072", "37.59519", "Europe/Moscow"),
("6418201", "Zagor'ye", "", "RU", "643", "48", "", "", "", "55.57657", "37.66709", "Europe/Moscow"),
("6418220", "Orekhovo-Borisovo", "Орехово-Борисово", "RU", "643", "48", "", "", "", "55.61252", "37.72639", "Europe/Moscow"),
("6418787", "Metrogorodok", "Метрогородок", "RU", "643", "48", "", "", "", "55.80961", "37.78739", "Europe/Moscow"),
("6695754", "Kogalym", "Когалым", "RU", "643", "32", "", "", "", "62.26537", "74.47906", "Asia/Yekaterinburg"),
("6696686", "Pyt-Yakh", "Пыть-Ях", "RU", "643", "32", "", "", "", "60.74985", "72.85824", "Asia/Yekaterinburg"),
("6696767", "Langepas", "Лангепас", "RU", "643", "32", "", "", "", "61.25439", "75.2124", "Asia/Yekaterinburg"),
("6853140", "Lesnoy", "Лесной", "RU", "643", "71", "", "", "", "57.6198", "63.0784", "Asia/Yekaterinburg"),
("7117880", "Zarya", "Заря", "RU", "643", "47", "", "", "", "55.75533", "38.09578", "Europe/Moscow"),
("7117885", "Raduzhnyy", "Радужный", "RU", "643", "83", "", "", "", "56.0038", "40.33905", "Europe/Moscow"),
("7287775", "Nizhnesortymskiy", "Нижнесортымский", "RU", "643", "32", "", "", "", "62.43965", "71.76029", "Asia/Yekaterinburg"),
("7289676", "Pokachi", "Покачи", "RU", "643", "32", "", "", "", "61.71982", "75.36827", "Asia/Yekaterinburg"),
("7290697", "Izluchinsk", "Излучинск", "RU", "643", "32", "", "", "", "60.97944", "76.92421", "Asia/Yekaterinburg"),
("8436165", "Kurortnyy", "", "RU", "643", "42", "", "", "", "60.16562", "29.908", "Europe/Moscow"),
("8504946", "Chernaya Rechka", "Черная речка", "RU", "643", "42", "", "", "", "59.98594", "30.30338", "Europe/Moscow"),
("8504947", "Untolovo", "Юнтолово", "RU", "643", "42", "", "", "", "60.0122", "30.20897", "Europe/Moscow"),
("8504948", "Petrogradka", "Петроградка", "RU", "643", "66", "", "", "", "59.96567", "30.31154", "Europe/Moscow"),
("8504949", "Vasyl'evsky Ostrov", "Васильевский остров", "RU", "643", "66", "", "", "", "59.94091", "30.25377", "Europe/Moscow"),
("8504950", "Parnas", "Парнас", "RU", "643", "42", "", "", "", "60.06964", "30.3487", "Europe/Moscow"),
("8504951", "Kalininskiy", "Калининский", "RU", "643", "42", "", "", "", "59.99675", "30.3899", "Europe/Moscow"),
("8504952", "Krasnogvargeisky", "Красногвардейский", "RU", "643", "66", "", "", "", "59.97305", "30.47607", "Europe/Moscow"),
("8504953", "Admiralteisky", "Адмиралтейский", "RU", "643", "66", "", "", "", "59.90839", "30.28484", "Europe/Moscow"),
("8504955", "Krestovskiy ostrov", "Крестовский остров", "RU", "643", "42", "", "", "", "59.97091", "30.25789", "Europe/Moscow"),
("8504958", "Akademicheskoe", "Академическое", "RU", "643", "42", "", "", "", "60.01375", "30.39471", "Europe/Moscow"),
("8504959", "Finlyandskiy", "Финляндский", "RU", "643", "42", "", "", "", "59.96824", "30.36415", "Europe/Moscow"),
("8504960", "Centralniy", "Центральный", "RU", "643", "66", "", "", "", "59.93111", "30.36072", "Europe/Moscow"),
("8504964", "Svetlanovskiy", "Светлановское", "RU", "643", "42", "", "", "", "60.00276", "30.33051", "Europe/Moscow"),
("8504965", "Sampsonievskiy", "Сампсониевское", "RU", "643", "42", "", "", "", "59.98499", "30.34295", "Europe/Moscow"),
("8505053", "Vostochnoe Degunino", "Восточное Дегунино", "RU", "643", "47", "", "", "", "55.8801", "37.55758", "Europe/Moscow"),
("201463", "Rwamagana", "Рвамагана", "RW", "646", "11", "", "", "", "-1.9487", "30.4347", "Africa/Kigali"),
("201521", "Musanze", "Рухенгери", "RW", "646", "13", "", "", "", "-1.49984", "29.63497", "Africa/Kigali"),
("201865", "Nzega", "", "RW", "646", "15", "", "", "", "-2.479", "29.5564", "Africa/Kigali"),
("202061", "Kigali", "Кигали", "RW", "646", "12", "", "", "", "-1.94995", "30.05885", "Africa/Kigali"),
("202065", "Kibuye", "Кибуе", "RW", "646", "14", "", "", "", "-2.06028", "29.34778", "Africa/Kigali"),
("202068", "Kibungo", "Кибунго", "RW", "646", "11", "", "", "", "-2.1597", "30.5427", "Africa/Kigali"),
("202217", "Gitarama", "Гитараме", "RW", "646", "15", "", "", "", "-2.07444", "29.75667", "Africa/Kigali"),
("202326", "Cyangugu", "Сиангугу", "RW", "646", "14", "", "", "", "-2.4846", "28.9075", "Africa/Kigali"),
("202905", "Gisenyi", "Гисеньи", "RW", "646", "14", "", "", "", "-1.70278", "29.25639", "Africa/Kigali"),
("203104", "Byumba", "Биумба", "RW", "646", "13", "", "", "", "-1.5763", "30.0675", "Africa/Kigali"),
("203112", "Butare", "Бутаре", "RW", "646", "15", "", "", "", "-2.59667", "29.73944", "Africa/Kigali"),
("100425", "Yanbu` al Bahr", "", "SA", "682", "05", "", "", "", "24.08912", "38.06374", "Asia/Riyadh"),
("100926", "Umm Lajj", "", "SA", "682", "19", "", "", "", "25.02126", "37.2685", "Asia/Riyadh"),
("101312", "Turayf", "", "SA", "682", "15", "", "", "", "31.67252", "38.66374", "Asia/Riyadh"),
("101322", "Turabah", "", "SA", "682", "14", "", "", "", "21.21406", "41.6331", "Asia/Riyadh"),
("101554", "Tarut", "", "SA", "682", "06", "", "", "", "26.57332", "50.03694", "Asia/Riyadh"),
("101628", "Tabuk", "Табук", "SA", "682", "19", "", "", "", "28.3998", "36.5715", "Asia/Riyadh"),
("101631", "Tubarjal", "", "SA", "682", "20", "", "", "", "30.49987", "38.21603", "Asia/Riyadh"),
("101760", "Sultanah", "", "SA", "682", "05", "", "", "", "24.49258", "39.58572", "Asia/Riyadh"),
("102318", "Sayhat", "", "SA", "682", "06", "", "", "", "26.48522", "50.04046", "Asia/Riyadh"),
("102451", "Samitah", "Самта", "SA", "682", "17", "", "", "", "16.59601", "42.94435", "Asia/Riyadh"),
("102527", "Sakaka", "", "SA", "682", "20", "", "", "", "29.96974", "40.20641", "Asia/Riyadh"),
("102585", "Safwa", "", "SA", "682", "06", "", "", "", "26.64986", "49.95223", "Asia/Riyadh"),
("102651", "Sabya", "", "SA", "682", "17", "", "", "", "17.1495", "42.62537", "Asia/Riyadh"),
("102985", "Rahimah", "", "SA", "682", "06", "", "", "", "26.70791", "50.06194", "Asia/Riyadh"),
("103035", "Rabigh", "", "SA", "682", "14", "", "", "", "22.79856", "39.03493", "Asia/Riyadh"),
("103369", "Qal`at Bishah", "", "SA", "682", "11", "", "", "", "20.00054", "42.6052", "Asia/Riyadh"),
("103630", "Najran", "", "SA", "682", "16", "", "", "", "17.4924", "44.12766", "Asia/Riyadh"),
("104515", "Mecca", "Мекка", "SA", "682", "14", "", "", "", "21.42664", "39.82563", "Asia/Riyadh"),
("105072", "Khamis Mushait", "", "SA", "682", "11", "", "", "", "18.3", "42.73333", "Asia/Riyadh"),
("105299", "Jizan", "Джизан", "SA", "682", "17", "", "", "", "16.88917", "42.55111", "Asia/Riyadh"),
("105343", "Jeddah", "Джидда", "SA", "682", "14", "", "", "", "21.54238", "39.19797", "Asia/Riyadh"),
("106281", "Hayil", "", "SA", "682", "13", "", "", "", "27.52188", "41.69073", "Asia/Riyadh"),
("106909", "Duba", "Дуба", "SA", "682", "19", "", "", "", "27.35134", "35.69014", "Asia/Riyadh"),
("107304", "Buraydah", "", "SA", "682", "08", "", "", "", "26.32599", "43.97497", "Asia/Riyadh"),
("107312", "Abqaiq", "", "SA", "682", "06", "", "", "", "25.9371", "49.67761", "Asia/Riyadh"),
("107744", "Badr Hunayn", "", "SA", "682", "05", "", "", "", "23.78292", "38.79047", "Asia/Riyadh"),
("107781", "Az Zulfi", "", "SA", "682", "10", "", "", "", "26.29945", "44.81542", "Asia/Riyadh"),
("107797", "Dhahran", "Дахран", "SA", "682", "06", "", "", "", "26.28864", "50.11396", "Asia/Riyadh"),
("107959", "At Taraf", "", "SA", "682", "06", "", "", "", "25.36276", "49.72504", "Asia/Riyadh"),
("107968", "Ta'if", "", "SA", "682", "14", "", "", "", "21.27028", "40.41583", "Asia/Riyadh"),
("108048", "As Sulayyil", "", "SA", "682", "10", "", "", "", "20.46067", "45.57792", "Asia/Riyadh"),
("108410", "Riyadh", "Эр-Рияд", "SA", "682", "10", "", "", "", "24.68773", "46.72185", "Asia/Riyadh"),
("108435", "Ar Rass", "", "SA", "682", "08", "", "", "", "25.86944", "43.4973", "Asia/Riyadh"),
("108512", "'Ar'ar", "", "SA", "682", "15", "", "", "", "30.97531", "41.03808", "Asia/Riyadh"),
("108617", "An Nimas", "", "SA", "682", "11", "", "", "", "19.14547", "42.1201", "Asia/Riyadh"),
("108648", "Al Qurayyat", "", "SA", "682", "20", "", "", "", "31.33176", "37.34282", "Asia/Riyadh"),
("108773", "Al Wajh", "", "SA", "682", "19", "", "", "", "26.24551", "36.45248", "Asia/Riyadh"),
("108841", "Al 'Ula", "Аль-Ула", "SA", "682", "05", "", "", "", "26.60853", "37.92316", "Asia/Riyadh"),
("108918", "Al Qaysumah", "", "SA", "682", "06", "", "", "", "28.31117", "46.12729", "Asia/Riyadh"),
("108927", "Al Qatif", "Эль-Катиф", "SA", "682", "06", "", "", "", "26.5208", "50.02452", "Asia/Riyadh"),
("109059", "Al Munayzilah", "", "SA", "682", "06", "", "", "", "25.38333", "49.66667", "Asia/Riyadh"),
("109101", "Al Mubarraz", "", "SA", "682", "06", "", "", "", "25.41", "49.58083", "Asia/Riyadh"),
("109131", "Al Mithnab", "", "SA", "682", "08", "", "", "", "25.86012", "44.22228", "Asia/Riyadh"),
("109223", "Medina", "Медина", "SA", "682", "05", "", "", "", "24.46861", "39.61417", "Asia/Riyadh"),
("109323", "Khobar", "Эль-Хубар", "SA", "682", "06", "", "", "", "26.27944", "50.20833", "Asia/Riyadh"),
("109380", "Al Khafji", "", "SA", "682", "06", "", "", "", "28.43905", "48.49132", "Asia/Riyadh"),
("109417", "Al Jumum", "", "SA", "682", "14", "", "", "", "21.61694", "39.69806", "Asia/Riyadh"),
("109435", "Al Jubayl", "Аль-Джубайль", "SA", "682", "06", "", "", "", "27.01122", "49.65826", "Asia/Riyadh"),
("109571", "Al Hufuf", "", "SA", "682", "06", "", "", "", "25.36457", "49.56532", "Asia/Riyadh"),
("109878", "Al Bukayriyah", "", "SA", "682", "08", "", "", "", "26.14422", "43.65933", "Asia/Riyadh"),
("109915", "Al Battaliyah", "", "SA", "682", "06", "", "", "", "25.43333", "49.63333", "Asia/Riyadh"),
("109953", "Al Bahah", "", "SA", "682", "02", "", "", "", "20.01288", "41.46767", "Asia/Riyadh"),
("110250", "`Afif", "", "SA", "682", "10", "", "", "", "23.9065", "42.91724", "Asia/Riyadh"),
("110314", "Ad Dilam", "", "SA", "682", "10", "", "", "", "23.99146", "47.16266", "Asia/Riyadh"),
("110325", "Ad Dawadimi", "", "SA", "682", "10", "", "", "", "24.50772", "44.39237", "Asia/Riyadh"),
("110336", "Dammam", "Даммам", "SA", "682", "06", "", "", "", "26.43442", "50.10326", "Asia/Riyadh"),
("110619", "Abu `Arish", "", "SA", "682", "17", "", "", "", "16.96887", "42.83251", "Asia/Riyadh"),
("110690", "Abha", "Абха", "SA", "682", "11", "", "", "", "18.21639", "42.50528", "Asia/Riyadh"),
("410096", "Ash Shafa", "Аш-Шафа", "SA", "682", "14", "", "", "", "21.0721", "40.31185", "Asia/Riyadh"),
("8394316", "Unaizah", "Унайза", "SA", "682", "08", "", "", "", "26.08427", "43.99355", "Asia/Riyadh"),
("363533", "Zalingei", "Залингее", "SD", "736", "61", "", "", "", "12.9096", "23.47406", "Africa/Khartoum"),
("364103", "Wad Medani", "", "SD", "736", "38", "", "", "", "14.40118", "33.51989", "Africa/Khartoum"),
("364706", "Umm Ruwaba", "", "SD", "736", "56", "", "", "", "12.9061", "31.2158", "Africa/Khartoum"),
("365137", "Omdurman", "Омдурман", "SD", "736", "29", "", "", "", "15.64453", "32.47773", "Africa/Khartoum"),
("366323", "Tokar", "", "SD", "736", "36", "", "", "", "18.4254", "37.729", "Africa/Khartoum"),
("366426", "Tandalti", "", "SD", "736", "41", "", "", "", "13.01667", "31.86667", "Africa/Khartoum"),
("366847", "Sinja", "", "SD", "736", "58", "", "", "", "13.15", "33.93333", "Africa/Khartoum"),
("367308", "Shendi", "", "SD", "736", "53", "", "", "", "16.6915", "33.4341", "Africa/Khartoum"),
("367544", "Sawakin", "Савакине", "SD", "736", "36", "", "", "", "19.1059", "37.3321", "Africa/Khartoum"),
("367644", "Sinnar", "", "SD", "736", "58", "", "", "", "13.56907", "33.56718", "Africa/Khartoum"),
("368277", "Rabak", "", "SD", "736", "41", "", "", "", "13.18087", "32.73999", "Africa/Khartoum"),
("370838", "Maiurno", "", "SD", "736", "58", "", "", "", "13.41667", "33.66667", "Africa/Khartoum"),
("371760", "Kosti", "Кусти", "SD", "736", "41", "", "", "", "13.1629", "32.66347", "Africa/Khartoum"),
("371870", "Kuraymah", "", "SD", "736", "43", "", "", "", "18.55", "31.85", "Africa/Khartoum"),
("372386", "Kinana", "", "SD", "736", "58", "", "", "", "14.0361", "33.1712", "Africa/Khartoum"),
("372753", "Kassala", "Кассале", "SD", "736", "52", "", "", "", "15.45099", "36.39998", "Africa/Khartoum"),
("373141", "Kadugli", "Кадугли", "SD", "736", "50", "", "", "", "11.01667", "29.71667", "Africa/Khartoum"),
("376332", "Doka", "", "SD", "736", "39", "", "", "", "13.51667", "35.76667", "Africa/Khartoum"),
("376450", "Dilling", "Диллинг", "SD", "736", "50", "", "", "", "12.05", "29.65", "Africa/Khartoum"),
("377039", "Port Sudan", "Порт-Судан", "SD", "736", "36", "", "", "", "19.61745", "37.21644", "Africa/Khartoum"),
("377690", "Berber", "", "SD", "736", "53", "", "", "", "18.02158", "33.98299", "Africa/Khartoum"),
("377724", "Barah", "", "SD", "736", "56", "", "", "", "13.7", "30.36667", "Africa/Khartoum"),
("378231", "Atbara", "Атбаре", "SD", "736", "53", "", "", "", "17.70217", "33.98638", "Africa/Khartoum"),
("378271", "As Suki", "", "SD", "736", "58", "", "", "", "13.31667", "33.88333", "Africa/Khartoum"),
("378459", "Ar Ruseris", "", "SD", "736", "42", "", "", "", "11.8659", "34.3869", "Africa/Khartoum"),
("378493", "Ar Rahad", "", "SD", "736", "56", "", "", "", "12.71667", "30.65", "Africa/Khartoum"),
("378699", "An Nuhud", "", "SD", "736", "56", "", "", "", "12.7", "28.43333", "Africa/Khartoum"),
("379003", "El Obeid", "", "SD", "736", "56", "", "", "", "13.18421", "30.21669", "Africa/Khartoum"),
("379014", "Al Qitena", "", "SD", "736", "41", "", "", "", "14.8648", "32.3668", "Africa/Khartoum"),
("379062", "Al Qadarif", "", "SD", "736", "39", "", "", "", "14.03493", "35.38344", "Africa/Khartoum"),
("379102", "Al Mijlad", "", "SD", "736", "50", "", "", "", "11.03333", "27.73333", "Africa/Khartoum"),
("379149", "Al Manaqil", "", "SD", "736", "38", "", "", "", "14.2459", "32.9891", "Africa/Khartoum"),
("379252", "Khartoum", "Хартум", "SD", "736", "29", "", "", "", "15.55177", "32.53241", "Africa/Khartoum"),
("379303", "Geneina", "", "SD", "736", "47", "", "", "", "13.45262", "22.44725", "Africa/Khartoum"),
("379406", "Al Hilaliyya", "", "SD", "736", "38", "", "", "", "14.9398", "33.234", "Africa/Khartoum"),
("379416", "Al Hawatah", "", "SD", "736", "39", "", "", "", "13.41667", "34.63333", "Africa/Khartoum"),
("379427", "Al Hasaheisa", "", "SD", "736", "38", "", "", "", "14.75264", "33.29836", "Africa/Khartoum"),
("379555", "El Fasher", "Эль-Фашир", "SD", "736", "55", "", "", "", "13.62793", "25.34936", "Africa/Khartoum"),
("379630", "El Bauga", "", "SD", "736", "53", "", "", "", "18.26196", "33.90812", "Africa/Khartoum"),
("380129", "Ad Douiem", "Эд-Дуэйм", "SD", "736", "41", "", "", "", "14.0012", "32.3116", "Africa/Khartoum"),
("380148", "El Daein", "", "SD", "736", "60", "", "", "", "11.46186", "26.12583", "Africa/Khartoum"),
("380151", "Ad Dindar", "", "SD", "736", "58", "", "", "", "13.2", "34.16667", "Africa/Khartoum"),
("380173", "Ed Damer", "", "SD", "736", "53", "", "", "", "17.59278", "33.95917", "Africa/Khartoum"),
("380174", "Ad-Damazin", "", "SD", "736", "42", "", "", "", "11.7891", "34.3592", "Africa/Khartoum"),
("380348", "Abu Zabad", "", "SD", "736", "56", "", "", "", "12.35", "29.25", "Africa/Khartoum"),
("380757", "Abu Jibeha", "", "SD", "736", "50", "", "", "", "11.4562", "31.2285", "Africa/Khartoum"),
("602150", "Umea", "Умео", "SE", "752", "23", "2480", "", "", "63.82842", "20.25972", "Europe/Stockholm"),
("602913", "Skelleftea", "Шеллефтео", "SE", "752", "23", "2482", "", "", "64.75067", "20.95279", "Europe/Stockholm"),
("603570", "Pitea", "Питео", "SE", "752", "14", "2581", "", "", "65.31717", "21.47944", "Europe/Stockholm"),
("604490", "Lulea", "Лулео", "SE", "752", "14", "2580", "", "", "65.58415", "22.15465", "Europe/Stockholm"),
("605155", "Kiruna", "Кируна", "SE", "752", "14", "2584", "", "", "67.85572", "20.22513", "Europe/Stockholm"),
("606531", "Boden", "", "SE", "752", "14", "2582", "", "", "65.82518", "21.68864", "Europe/Stockholm"),
("2662149", "Ystad", "Истад", "SE", "752", "27", "1286", "", "", "55.42966", "13.82041", "Europe/Stockholm"),
("2662689", "Visby", "Висбю", "SE", "752", "05", "0980", "", "", "57.64089", "18.29602", "Europe/Stockholm"),
("2663536", "Vaexjoe", "Векшё", "SE", "752", "12", "0780", "", "", "56.87767", "14.80906", "Europe/Stockholm"),
("2664203", "Vaestervik", "", "SE", "752", "09", "0883", "", "", "57.7584", "16.63733", "Europe/Stockholm"),
("2664454", "Vasteras", "Вестерос", "SE", "752", "25", "1980", "", "", "59.61617", "16.55276", "Europe/Stockholm"),
("2664855", "Varnamo", "", "SE", "752", "08", "0683", "", "", "57.18604", "14.04001", "Europe/Stockholm"),
("2664996", "Varberg", "Варберг", "SE", "752", "06", "1383", "", "", "57.10557", "12.25078", "Europe/Stockholm"),
("2665171", "Vanersborg", "Венерсборг", "SE", "752", "28", "1487", "", "", "58.38075", "12.3234", "Europe/Stockholm"),
("2665452", "Vallentuna", "", "SE", "752", "26", "0115", "", "", "59.53436", "18.07758", "Europe/Stockholm"),
("2666199", "Uppsala", "Уппсала", "SE", "752", "21", "0380", "038001", "0282", "59.85882", "17.63889", "Europe/Stockholm"),
("2666238", "Upplands Vaesby", "", "SE", "752", "26", "0114", "", "", "59.51839", "17.91128", "Europe/Stockholm"),
("2666670", "Uddevalla", "Уддевалла", "SE", "752", "28", "1485", "", "", "58.34784", "11.9424", "Europe/Stockholm"),
("2667094", "Tumba", "Тумба", "SE", "752", "26", "0127", "", "", "59.19858", "17.83317", "Europe/Stockholm"),
("2667109", "Tullinge", "", "SE", "752", "26", "0127", "", "", "59.2", "17.9", "Europe/Stockholm"),
("2667303", "Trollhattan", "Трольхеттан", "SE", "752", "28", "1488", "", "", "58.28365", "12.28864", "Europe/Stockholm"),
("2667402", "Trelleborg", "Треллеборг", "SE", "752", "27", "1287", "", "", "55.37514", "13.15691", "Europe/Stockholm"),
("2669772", "Taby", "", "SE", "752", "26", "0160", "", "", "59.4439", "18.06872", "Europe/Stockholm"),
("2670781", "Sundsvall", "Сундсвалль", "SE", "752", "24", "2281", "", "", "62.39129", "17.3063", "Europe/Stockholm"),
("2670879", "Sundbyberg", "", "SE", "752", "26", "0183", "", "", "59.36128", "17.97114", "Europe/Stockholm"),
("2673730", "Stockholm", "Стокгольм", "SE", "752", "26", "0180", "", "", "59.33258", "18.0649", "Europe/Stockholm"),
("2675397", "Solna", "", "SE", "752", "26", "0184", "", "", "59.36004", "18.00086", "Europe/Stockholm"),
("2675408", "Sollentuna", "", "SE", "752", "26", "0163", "", "", "59.42804", "17.95093", "Europe/Stockholm"),
("2676176", "Soedertaelje", "Сёдертелье", "SE", "752", "26", "0181", "", "", "59.19554", "17.62525", "Europe/Stockholm"),
("2677234", "Skoevde", "Шёвде", "SE", "752", "28", "1496", "", "", "58.39118", "13.84506", "Europe/Stockholm"),
("2680075", "Sandviken", "Сандвикен", "SE", "752", "03", "2181", "", "", "60.61667", "16.76667", "Europe/Stockholm"),
("2683034", "Rasunda", "", "SE", "752", "26", "0184", "", "", "59.36667", "17.98333", "Europe/Stockholm"),
("2684395", "Partille", "", "SE", "752", "28", "1402", "", "", "57.7395", "12.10642", "Europe/Stockholm"),
("2685750", "Ostersund", "Эстерсунд", "SE", "752", "07", "2380", "", "", "63.1792", "14.63566", "Europe/Stockholm"),
("2685828", "OEstermalm", "", "SE", "752", "26", "0180", "", "", "59.33879", "18.08487", "Europe/Stockholm"),
("2686162", "Oskarshamn", "Оскарсхамн", "SE", "752", "09", "0882", "", "", "57.26455", "16.44837", "Europe/Stockholm"),
("2686469", "Ornskoldsvik", "Эрншёльдсвик", "SE", "752", "24", "2284", "", "", "63.29091", "18.71525", "Europe/Stockholm"),
("2686657", "Orebro", "Эребру", "SE", "752", "15", "1880", "", "", "59.27412", "15.2066", "Europe/Stockholm"),
("2687700", "Nykoping", "Нючёпинг", "SE", "752", "18", "0480", "", "", "58.753", "17.00788", "Europe/Stockholm"),
("2688250", "Norrtalje", "Норртелье", "SE", "752", "26", "0188", "", "", "59.75799", "18.70496", "Europe/Stockholm"),
("2688368", "Norrkoping", "Норрчёпинг", "SE", "752", "16", "0581", "", "", "58.59419", "16.1826", "Europe/Stockholm"),
("2690170", "Nassjo", "", "SE", "752", "08", "0682", "", "", "57.65307", "14.69676", "Europe/Stockholm"),
("2690580", "Nacka", "", "SE", "752", "26", "0182", "", "", "59.31053", "18.16372", "Europe/Stockholm"),
("2690960", "Motala", "Мутала", "SE", "752", "16", "0583", "", "", "58.53706", "15.03649", "Europe/Stockholm"),
("2691459", "Moelndal", "", "SE", "752", "28", "1481", "", "", "57.6554", "12.01378", "Europe/Stockholm"),
("2692475", "Marsta", "Мерста", "SE", "752", "26", "0191", "", "", "59.62157", "17.85476", "Europe/Stockholm"),
("2692969", "Malmoe", "Мальмё", "SE", "752", "27", "1280", "", "", "55.60587", "13.00073", "Europe/Stockholm"),
("2693678", "Lund", "Лунд", "SE", "752", "27", "1281", "", "", "55.70584", "13.19321", "Europe/Stockholm"),
("2694762", "Linkoping", "Линчёпинг", "SE", "752", "16", "0580", "058002", "0461", "58.41086", "15.62157", "Europe/Stockholm"),
("2696329", "Lidkoping", "Лидкопинг", "SE", "752", "28", "1494", "", "", "58.50517", "13.15765", "Europe/Stockholm"),
("2696334", "Lidingoe", "", "SE", "752", "26", "0186", "", "", "59.36667", "18.13333", "Europe/Stockholm"),
("2696503", "Lerum", "", "SE", "752", "28", "1441", "", "", "57.77051", "12.26904", "Europe/Stockholm"),
("2697720", "Landskrona", "Ландскруна", "SE", "752", "27", "1282", "", "", "55.8708", "12.83016", "Europe/Stockholm"),
("2698729", "Kungsbacka", "", "SE", "752", "06", "1384", "", "", "57.48719", "12.07612", "Europe/Stockholm"),
("2698739", "Kungalv", "Кунглев", "SE", "752", "28", "1482", "", "", "57.87096", "11.98054", "Europe/Stockholm"),
("2699282", "Kristinehamn", "Кристинехамн", "SE", "752", "22", "1781", "", "", "59.30978", "14.10808", "Europe/Stockholm"),
("2699310", "Kristianstad", "Кристианстад", "SE", "752", "27", "1290", "", "", "56.03129", "14.15242", "Europe/Stockholm"),
("2699791", "Koping", "", "SE", "752", "25", "1983", "", "", "59.51404", "15.99255", "Europe/Stockholm"),
("2701223", "Katrineholm", "Катринехольм", "SE", "752", "18", "0483", "", "", "58.99587", "16.20721", "Europe/Stockholm"),
("2701680", "Karlstad", "Карлстад", "SE", "752", "22", "1780", "", "", "59.3793", "13.50357", "Europe/Stockholm"),
("2701713", "Karlskrona", "Карлскруна", "SE", "752", "02", "1080", "", "", "56.16156", "15.58661", "Europe/Stockholm"),
("2701715", "Karlskoga", "", "SE", "752", "15", "1883", "", "", "59.32667", "14.52386", "Europe/Stockholm"),
("2701727", "Karlshamn", "Карлсхамн", "SE", "752", "02", "1082", "", "", "56.1706", "14.86188", "Europe/Stockholm"),
("2702261", "Kalmar", "Кальмар", "SE", "752", "09", "0880", "", "", "56.66157", "16.36163", "Europe/Stockholm"),
("2702979", "Jonkoping", "Йёнчёпинг", "SE", "752", "08", "0680", "", "", "57.78145", "14.15618", "Europe/Stockholm"),
("2703396", "Jakobsberg", "", "SE", "752", "26", "0123", "", "", "59.42268", "17.83508", "Europe/Stockholm"),
("2704136", "Huskvarna", "Хускварна", "SE", "752", "08", "0680", "", "", "57.78596", "14.30214", "Europe/Stockholm"),
("2704620", "Huddinge", "", "SE", "752", "26", "0126", "", "", "59.23705", "17.98192", "Europe/Stockholm"),
("2706767", "Helsingborg", "Хельсингборг", "SE", "752", "27", "1283", "", "", "56.04673", "12.69437", "Europe/Stockholm"),
("2707399", "Hassleholm", "", "SE", "752", "27", "1293", "", "", "56.15905", "13.76638", "Europe/Stockholm"),
("2707684", "Haernoesand", "", "SE", "752", "24", "2280", "", "", "62.63228", "17.93794", "Europe/Stockholm"),
("2707953", "Haninge", "", "SE", "752", "26", "0136", "", "", "59.16775", "18.14478", "Europe/Stockholm"),
("2708365", "Halmstad", "Хальмстад", "SE", "752", "06", "1380", "", "", "56.67446", "12.85676", "Europe/Stockholm"),
("2711537", "Goeteborg", "Гётеборг", "SE", "752", "28", "1480", "", "", "57.70716", "11.96679", "Europe/Stockholm"),
("2712414", "Gavle", "Евле", "SE", "752", "03", "2180", "", "", "60.67452", "17.14174", "Europe/Stockholm"),
("2715459", "Falun", "Фалун", "SE", "752", "10", "2080", "", "", "60.60357", "15.62597", "Europe/Stockholm"),
("2715568", "Falkoeping", "Фальчёпинг", "SE", "752", "28", "1499", "", "", "58.17347", "13.55068", "Europe/Stockholm"),
("2715573", "Falkenberg", "Фалькенберг", "SE", "752", "06", "1382", "", "", "56.90552", "12.49118", "Europe/Stockholm"),
("2715946", "Eslov", "", "SE", "752", "27", "1285", "", "", "55.83928", "13.30393", "Europe/Stockholm"),
("2715953", "Eskilstuna", "Эскильстуна", "SE", "752", "18", "0484", "", "", "59.36661", "16.5077", "Europe/Stockholm"),
("2716166", "Enkoping", "", "SE", "752", "21", "0381", "", "", "59.63607", "17.07768", "Europe/Stockholm"),
("2719111", "Bromma", "", "SE", "752", "26", "0180", "", "", "59.34", "17.94", "Europe/Stockholm"),
("2720383", "Borlaenge", "Бурленге", "SE", "752", "10", "2081", "", "", "60.4858", "15.43714", "Europe/Stockholm"),
("2720501", "Boras", "Бурос", "SE", "752", "28", "1490", "", "", "57.72101", "12.9401", "Europe/Stockholm"),
("2721259", "Boo", "", "SE", "752", "26", "0182", "", "", "59.33333", "18.28333", "Europe/Stockholm"),
("2725201", "Arsta", "", "SE", "752", "26", "0180", "", "", "59.2978", "18.0514", "Europe/Stockholm"),
("2725901", "AEngelholm", "", "SE", "752", "27", "1292", "", "", "56.2428", "12.86219", "Europe/Stockholm"),
("2726756", "Alingsas", "Алингсас", "SE", "752", "28", "1489", "", "", "57.93033", "12.53345", "Europe/Stockholm"),
("2727234", "Akersberga", "Акерсберга", "SE", "752", "26", "0117", "", "", "59.47944", "18.29967", "Europe/Stockholm"),
("6619708", "Majorna", "", "SE", "752", "28", "1480", "", "", "57.69195", "11.91605", "Europe/Stockholm"),
("1880252", "Singapore", "Сингапур", "SG", "702", "00", "", "", "", "1.28967", "103.85007", "Asia/Singapore"),
("3188915", "Trbovlje", "", "SI", "705", "D3", "", "", "", "46.155", "15.05333", "Europe/Ljubljana"),
("3189075", "Velenje", "Веленье", "SI", "705", "D7", "", "", "", "46.35917", "15.11028", "Europe/Ljubljana"),
("3192241", "Ptuj", "Птуй", "SI", "705", "K7", "", "", "", "46.42005", "15.87018", "Europe/Ljubljana"),
("3194351", "Novo Mesto", "Ново-Место", "SI", "705", "J7", "", "", "", "45.80397", "15.16886", "Europe/Ljubljana"),
("3195506", "Maribor", "Марибор", "SI", "705", "J2", "", "", "", "46.55472", "15.64667", "Europe/Ljubljana"),
("3196359", "Ljubljana", "Любляна", "SI", "705", "61", "", "", "", "46.05108", "14.50513", "Europe/Ljubljana"),
("3197378", "Kranj", "Крань", "SI", "705", "52", "", "", "", "46.23887", "14.35561", "Europe/Ljubljana"),
("3197753", "Koper", "Копер", "SI", "705", "50", "", "", "", "45.54694", "13.72944", "Europe/Ljubljana"),
("3202781", "Celje", "Целе", "SI", "705", "11", "", "", "", "46.23092", "15.26044", "Europe/Ljubljana"),
("723195", "Vranov nad Topl'ou", "Вранов-над-Топлёу", "SK", "703", "05", "", "", "", "48.88836", "21.68479", "Europe/Bratislava"),
("723358", "Trebisov", "Требишов", "SK", "703", "03", "", "", "", "48.62858", "21.71954", "Europe/Bratislava"),
("723505", "Stara L'ubovna", "Стара Любовня", "SK", "703", "05", "", "", "", "49.29859", "20.6862", "Europe/Bratislava"),
("723526", "Spisska Nova Ves", "Спишска Нова Вес", "SK", "703", "03", "", "", "", "48.94464", "20.56154", "Europe/Bratislava"),
("723559", "Snina", "Снина", "SK", "703", "05", "", "", "", "48.98857", "22.15099", "Europe/Bratislava"),
("723713", "Roznava", "Рожнява", "SK", "703", "03", "", "", "", "48.66008", "20.53758", "Europe/Bratislava"),
("723736", "Rimavska Sobota", "Римавска Собота", "SK", "703", "01", "", "", "", "48.38284", "20.0224", "Europe/Bratislava"),
("723819", "Presov", "Прешов", "SK", "703", "05", "707", "", "", "48.99839", "21.23393", "Europe/Bratislava"),
("723846", "Poprad", "Попрад", "SK", "703", "05", "706", "", "", "49.06144", "20.29798", "Europe/Bratislava"),
("724144", "Michalovce", "Михаловце", "SK", "703", "03", "", "", "", "48.75434", "21.9195", "Europe/Bratislava"),
("724443", "Kosice", "Кошице", "SK", "703", "03", "", "", "", "48.71395", "21.25808", "Europe/Bratislava"),
("724503", "Kezmarok", "Кежмарок", "SK", "703", "05", "707", "", "", "49.1357", "20.43352", "Europe/Bratislava"),
("724627", "Humenne", "Гуменне", "SK", "703", "05", "", "", "", "48.93707", "21.91625", "Europe/Bratislava"),
("725168", "Bardejov", "Бардейов", "SK", "703", "05", "701", "", "", "49.29175", "21.27271", "Europe/Bratislava"),
("3056459", "Zvolen", "Зволен", "SK", "703", "01", "601", "", "", "48.57442", "19.15324", "Europe/Bratislava"),
("3056495", "Zlate Moravce", "", "SK", "703", "04", "", "", "", "48.38553", "18.40063", "Europe/Bratislava"),
("3056508", "Zilina", "Жилина", "SK", "703", "08", "511", "", "", "49.22315", "18.73941", "Europe/Bratislava"),
("3056523", "Ziar nad Hronom", "", "SK", "703", "01", "", "", "", "48.59184", "18.84958", "Europe/Bratislava"),
("3057124", "Trnava", "Трнава", "SK", "703", "07", "207", "", "", "48.3774", "17.58723", "Europe/Bratislava"),
("3057140", "Trencin", "Тренчин", "SK", "703", "06", "309", "", "", "48.89452", "18.04436", "Europe/Bratislava"),
("3057630", "Skalica", "", "SK", "703", "07", "206", "", "", "48.8449", "17.22635", "Europe/Bratislava"),
("3057691", "Senica", "Сеница", "SK", "703", "07", "205", "", "", "48.67922", "17.36697", "Europe/Bratislava"),
("3057769", "Sellye", "Шаля", "SK", "703", "04", "", "", "", "48.15127", "17.88062", "Europe/Bratislava"),
("3057789", "Ruzomberok", "Ружомберок", "SK", "703", "08", "", "", "", "49.0748", "19.30751", "Europe/Bratislava"),
("3057963", "Puchov", "Пухов", "SK", "703", "04", "", "", "", "49.12494", "18.32596", "Europe/Bratislava"),
("3058000", "Prievidza", "Прьевидза", "SK", "703", "04", "", "", "", "48.77446", "18.6275", "Europe/Bratislava"),
("3058060", "Povazska Bystrica", "Поважска-Бистрица", "SK", "703", "06", "306", "", "", "49.12153", "18.42169", "Europe/Bratislava"),
("3058202", "Piestany", "Пьештяны", "SK", "703", "07", "207", "", "", "48.59479", "17.82591", "Europe/Bratislava"),
("3058210", "Pezinok", "Пезинок", "SK", "703", "02", "107", "", "", "48.28986", "17.26664", "Europe/Bratislava"),
("3058268", "Partizanske", "Партизанске", "SK", "703", "04", "", "", "", "48.62861", "18.38456", "Europe/Bratislava"),
("3058472", "Nove Zamky", "Нове Замки", "SK", "703", "04", "404", "", "", "47.98544", "18.16195", "Europe/Bratislava"),
("3058477", "Nove Mesto nad Vahom", "", "SK", "703", "06", "304", "", "", "48.75763", "17.8309", "Europe/Bratislava"),
("3058531", "Nitra", "Нитра", "SK", "703", "04", "403", "", "", "48.30763", "18.08453", "Europe/Bratislava"),
("3058780", "Martin", "Мартин", "SK", "703", "08", "506", "", "", "49.06651", "18.92399", "Europe/Bratislava"),
("3058897", "Malacky", "Малацки", "SK", "703", "02", "106", "", "", "48.43604", "17.02188", "Europe/Bratislava"),
("3058986", "Lucenec", "Лученец", "SK", "703", "01", "", "", "", "48.33249", "19.66708", "Europe/Bratislava"),
("3059050", "Liptovsky Mikulas", "Липтовски Микулаш", "SK", "703", "08", "505", "", "", "49.08061", "19.62218", "Europe/Bratislava"),
("3059101", "Levice", "Левице", "SK", "703", "04", "", "", "", "48.21563", "18.60705", "Europe/Bratislava"),
("3059179", "Kysucke Nove Mesto", "Кисуцке Нове Место", "SK", "703", "08", "", "", "", "49.3", "18.78333", "Europe/Bratislava"),
("3059436", "Komarno", "Комарно", "SK", "703", "04", "", "", "", "47.76356", "18.12263", "Europe/Bratislava"),
("3060095", "Hlohovec", "Глоговец", "SK", "703", "07", "", "", "", "48.43174", "17.8031", "Europe/Bratislava"),
("3060139", "Handlova", "", "SK", "703", "04", "", "", "", "48.7276", "18.76012", "Europe/Bratislava"),
("3060219", "Galanta", "Галанта", "SK", "703", "07", "202", "", "", "48.19001", "17.72747", "Europe/Bratislava"),
("3060308", "Dunajska Streda", "Дунайска-Стреда", "SK", "703", "07", "", "", "", "47.99268", "17.61211", "Europe/Bratislava"),
("3060346", "Dubnica nad Vahom", "Дубница-над-Вагом", "SK", "703", "04", "", "", "", "48.95981", "18.16634", "Europe/Bratislava"),
("3060405", "Dolny Kubin", "Долны Кубин", "SK", "703", "08", "503", "", "", "49.20983", "19.30341", "Europe/Bratislava"),
("3060589", "Detva", "Детва", "SK", "703", "01", "", "", "", "48.56082", "19.41954", "Europe/Bratislava"),
("3060835", "Cadca", "Чадца", "SK", "703", "08", "", "", "", "49.43503", "18.78895", "Europe/Bratislava"),
("3060950", "Brezno", "Брезно", "SK", "703", "01", "601", "", "", "48.80431", "19.63631", "Europe/Bratislava"),
("3060972", "Bratislava", "Братислава", "SK", "703", "02", "", "", "", "48.14816", "17.10674", "Europe/Bratislava"),
("3061186", "Banska Bystrica", "Банска-Бистрица", "SK", "703", "01", "601", "", "", "48.73946", "19.15349", "Europe/Bratislava"),
("3061188", "Banovce nad Bebravou", "", "SK", "703", "04", "", "", "", "48.7213", "18.25754", "Europe/Bratislava"),
("2403094", "Waterloo", "", "SL", "694", "04", "", "", "", "8.33833", "-13.07194", "Africa/Freetown"),
("2404041", "Segbwema", "", "SL", "694", "01", "", "", "", "8", "-10.95", "Africa/Freetown"),
("2404433", "Port Loko", "Порт-Локо", "SL", "694", "02", "", "", "", "8.76667", "-12.78333", "Africa/Freetown"),
("2406407", "Makeni", "Макени", "SL", "694", "02", "", "", "", "8.88333", "-12.05", "Africa/Freetown"),
("2406916", "Lunsar", "Лунсаре", "SL", "694", "02", "", "", "", "8.68333", "-12.53333", "Africa/Freetown"),
("2407656", "Koidu", "", "SL", "694", "01", "", "", "", "8.63333", "-10.98333", "Africa/Freetown"),
("2407790", "Kenema", "Кенеме", "SL", "694", "01", "", "", "", "7.87667", "-11.1875", "Africa/Freetown"),
("2408329", "Kabala", "", "SL", "694", "02", "", "", "", "9.58333", "-11.55", "Africa/Freetown"),
("2409306", "Freetown", "Фритаун", "SL", "694", "04", "", "", "", "8.484", "-13.22994", "Africa/Freetown"),
("2410048", "Bo", "Бо", "SL", "694", "03", "", "", "", "7.96472", "-11.73833", "Africa/Freetown"),
("2243940", "Ziguinchor", "Зигиншор", "SN", "686", "12", "", "", "", "12.58333", "-16.27194", "Africa/Dakar"),
("2244177", "Velingara", "", "SN", "686", "11", "", "", "", "13.15", "-14.11667", "Africa/Dakar"),
("2244322", "Touba", "", "SN", "686", "03", "", "", "", "14.85", "-15.88333", "Africa/Dakar"),
("2244616", "Tiebo", "", "SN", "686", "03", "", "", "", "14.63333", "-16.23333", "Africa/Dakar"),
("2244799", "Thies Nones", "", "SN", "686", "07", "", "", "", "14.78333", "-16.96667", "Africa/Dakar"),
("2244991", "Tambacounda", "", "SN", "686", "05", "", "", "", "13.77073", "-13.66734", "Africa/Dakar"),
("2245704", "Sedhiou", "", "SN", "686", "18", "", "", "", "12.70806", "-15.55694", "Africa/Dakar"),
("2246452", "Saint-Louis", "Сен-Луи", "SN", "686", "14", "", "", "", "16.01793", "-16.48962", "Africa/Dakar"),
("2246544", "Richard-Toll", "", "SN", "686", "14", "", "", "", "16.4625", "-15.70083", "Africa/Dakar"),
("2246606", "Pout", "", "SN", "686", "07", "", "", "", "14.77099", "-17.06107", "Africa/Dakar"),
("2246608", "Pourham", "", "SN", "686", "09", "", "", "", "14.35", "-16.41667", "Africa/Dakar"),
("2246678", "Pikine", "Пикин", "SN", "686", "01", "", "", "", "14.76457", "-17.39071", "Africa/Dakar"),
("2247157", "Nioro du Rip", "", "SN", "686", "10", "", "", "", "13.75", "-15.8", "Africa/Dakar"),
("2247381", "Nguekhokh", "", "SN", "686", "07", "", "", "", "14.51255", "-17.00447", "Africa/Dakar"),
("2247813", "Ndibene Dahra", "", "SN", "686", "13", "", "", "", "15.3338", "-15.4766", "Africa/Dakar"),
("2248409", "Mekhe", "", "SN", "686", "07", "", "", "", "15.1097", "-16.6218", "Africa/Dakar"),
("2248698", "Mbake", "", "SN", "686", "03", "", "", "", "14.79032", "-15.90803", "Africa/Dakar"),
("2248752", "Matam", "", "SN", "686", "15", "", "", "", "15.65587", "-13.25544", "Africa/Dakar"),
("2249222", "Louga", "", "SN", "686", "13", "", "", "", "15.61867", "-16.22436", "Africa/Dakar"),
("2249782", "Kolda", "Колда", "SN", "686", "11", "", "", "", "12.88333", "-14.95", "Africa/Dakar"),
("2250645", "Kedougou", "", "SN", "686", "17", "", "", "", "12.5579", "-12.1743", "Africa/Dakar"),
("2250677", "Kayar", "", "SN", "686", "07", "", "", "", "14.91893", "-17.11978", "Africa/Dakar"),
("2250805", "Kaolack", "", "SN", "686", "10", "", "", "", "14.1825", "-16.25333", "Africa/Dakar"),
("2251007", "Kaffrine", "", "SN", "686", "16", "", "", "", "14.10594", "-15.5508", "Africa/Dakar"),
("2251084", "Joal-Fadiout", "", "SN", "686", "07", "", "", "", "14.16667", "-16.83333", "Africa/Dakar"),
("2251230", "Guinguineo", "", "SN", "686", "09", "", "", "", "14.26667", "-15.95", "Africa/Dakar"),
("2251339", "Grand Dakar", "", "SN", "686", "01", "", "", "", "14.71331", "-17.45472", "Africa/Dakar"),
("2253277", "Dara", "Дар", "SN", "686", "13", "", "", "", "15.34844", "-15.47993", "Africa/Dakar"),
("2253354", "Dakar", "Дакар", "SN", "686", "01", "", "", "", "14.6937", "-17.44406", "Africa/Dakar"),
("2253901", "Bignona", "", "SN", "686", "12", "", "", "", "12.81028", "-16.22639", "Africa/Dakar"),
("50672", "Wanlaweyn", "", "SO", "706", "14", "", "", "", "2.6185", "44.8938", "Africa/Mogadishu"),
("52867", "Qoryooley", "", "SO", "706", "14", "", "", "", "1.78784", "44.52999", "Africa/Mogadishu"),
("53157", "Qandala", "", "SO", "706", "03", "", "", "", "11.47197", "49.87282", "Africa/Mogadishu"),
("53654", "Mogadishu", "Могадишо", "SO", "706", "02", "", "", "", "2.03711", "45.34375", "Africa/Mogadishu"),
("54225", "Marka", "", "SO", "706", "14", "", "", "", "1.71594", "44.77166", "Africa/Mogadishu"),
("54715", "Luuq", "Лук", "SO", "706", "06", "", "", "", "3.79376", "42.5445", "Africa/Mogadishu"),
("55671", "Kismayo", "", "SO", "706", "09", "", "", "", "-0.35817", "42.54536", "Africa/Mogadishu"),
("56166", "Jilib", "Джилиб", "SO", "706", "08", "", "", "", "0.48829", "42.78535", "Africa/Mogadishu"),
("56335", "Jawhar", "", "SO", "706", "13", "", "", "", "2.78087", "45.50048", "Africa/Mogadishu"),
("56399", "Jamaame", "", "SO", "706", "09", "", "", "", "0.06968", "42.74497", "Africa/Mogadishu"),
("57289", "Hargeysa", "Харгейсе", "SO", "706", "20", "", "", "", "9.56", "44.065", "Africa/Mogadishu"),
("58933", "Garoowe", "", "SO", "706", "18", "", "", "", "8.40207", "48.48284", "Africa/Mogadishu"),
("59611", "Gaalkacyo", "Галькайо", "SO", "706", "10", "", "", "", "6.76972", "47.43083", "Africa/Mogadishu"),
("60019", "Eyl", "", "SO", "706", "18", "", "", "", "7.9803", "49.8164", "Africa/Mogadishu"),
("62691", "Ceerigaabo", "", "SO", "706", "12", "", "", "", "10.61616", "47.36795", "Africa/Mogadishu"),
("62788", "Ceeldheer", "", "SO", "706", "05", "", "", "", "3.84878", "47.18064", "Africa/Mogadishu"),
("63571", "Buurhakaba", "", "SO", "706", "04", "", "", "", "2.80257", "44.07806", "Africa/Mogadishu"),
("63689", "Buulobarde", "", "SO", "706", "07", "", "", "", "3.85375", "45.56744", "Africa/Mogadishu"),
("63795", "Burao", "Бурао", "SO", "706", "19", "", "", "", "9.52212", "45.53363", "Africa/Mogadishu"),
("64013", "Bosaso", "Босасо", "SO", "706", "03", "", "", "", "11.28421", "49.18158", "Africa/Mogadishu"),
("64435", "Berbera", "Бербера", "SO", "706", "20", "", "", "", "10.43959", "45.01432", "Africa/Mogadishu"),
("64460", "Beledweyne", "Беледуэйне", "SO", "706", "07", "", "", "", "4.73583", "45.20361", "Africa/Mogadishu"),
("64536", "Baidoa", "Байдоа", "SO", "706", "04", "", "", "", "3.11383", "43.6498", "Africa/Mogadishu"),
("65170", "Baardheere", "", "SO", "706", "06", "", "", "", "2.34464", "42.27644", "Africa/Mogadishu"),
("65785", "Afgooye", "Афгойе", "SO", "706", "14", "", "", "", "2.1381", "45.1212", "Africa/Mogadishu"),
("400769", "Laascaanood", "", "SO", "706", "22", "", "", "", "8.47738", "47.35971", "Africa/Mogadishu"),
("8045596", "Baki", "", "SO", "706", "21", "", "", "", "9.89206", "43.38531", "Africa/Mogadishu"),
("2410763", "Sao Tome", "Сан-Томе", "ST", "678", "02", "", "", "", "0.33654", "6.72732", "Africa/Sao_Tome"),
("162627", "Yabrud", "Ябруд", "SY", "760", "08", "", "", "", "33.96736", "36.65741", "Asia/Damascus"),
("163270", "Tayyibat al Imam", "", "SY", "760", "10", "", "", "", "35.26592", "36.71219", "Asia/Damascus"),
("163345", "Tartouss", "Тартус", "SY", "760", "14", "", "", "", "34.88902", "35.88659", "Asia/Damascus"),
("163476", "Tall Rif`at", "", "SY", "760", "09", "", "", "", "36.47362", "37.09672", "Asia/Damascus"),
("163533", "Tallkalakh", "", "SY", "760", "11", "", "", "", "34.66842", "36.25995", "Asia/Damascus"),
("163779", "Tallbisah", "", "SY", "760", "11", "", "", "", "34.84063", "36.73093", "Asia/Damascus"),
("163806", "Tafas", "Тафас", "SY", "760", "06", "", "", "", "32.73564", "36.06694", "Asia/Damascus"),
("163808", "Tadmur", "Пальмира", "SY", "760", "11", "", "", "", "34.56077", "38.28055", "Asia/Damascus"),
("163811", "Tadif", "", "SY", "760", "09", "", "", "", "36.34814", "37.5309", "Asia/Damascus"),
("163915", "Souran", "Суран", "SY", "760", "10", "", "", "", "35.29193", "36.74848", "Asia/Damascus"),
("164025", "Subaykhan", "", "SY", "760", "07", "", "", "", "34.85444", "40.60833", "Asia/Damascus"),
("164328", "Ash Shaykh Miskin", "Шейх-Мискин", "SY", "760", "06", "", "", "", "32.82944", "36.15933", "Asia/Damascus"),
("164816", "Saraqib", "", "SY", "760", "12", "", "", "", "35.86447", "36.80591", "Asia/Damascus"),
("164898", "Salqin", "", "SY", "760", "12", "", "", "", "36.13951", "36.45413", "Asia/Damascus"),
("164947", "As Salamiyah", "", "SY", "760", "10", "", "", "", "35.01127", "37.05324", "Asia/Damascus"),
("165060", "Satita", "", "SY", "760", "14", "", "", "", "34.81836", "36.11376", "Asia/Damascus"),
("165929", "Qatana", "", "SY", "760", "08", "", "", "", "33.43646", "36.07757", "Asia/Damascus"),
("165997", "Jasim", "Джасим", "SY", "760", "06", "", "", "", "32.99233", "36.06018", "Asia/Damascus"),
("166111", "Qarah", "", "SY", "760", "08", "", "", "", "34.1527", "36.74152", "Asia/Damascus"),
("166331", "Nubl", "", "SY", "760", "09", "", "", "", "36.37867", "36.99294", "Asia/Damascus"),
("167046", "Masyaf", "", "SY", "760", "10", "", "", "", "35.0653", "36.3406", "Asia/Damascus"),
("167357", "Manbij", "", "SY", "760", "09", "", "", "", "36.52815", "37.95495", "Asia/Damascus"),
("167605", "Ma`arratmisrin", "", "SY", "760", "12", "", "", "", "36.01152", "36.67183", "Asia/Damascus"),
("168325", "Khan Shaykhun", "", "SY", "760", "12", "", "", "", "35.44208", "36.65095", "Asia/Damascus"),
("168620", "Kafr Zayta", "", "SY", "760", "10", "", "", "", "35.37425", "36.6033", "Asia/Damascus"),
("168629", "Kafr Takharim", "", "SY", "760", "12", "", "", "", "36.1168", "36.51522", "Asia/Damascus"),
("168661", "Kafr Nubl", "", "SY", "760", "12", "", "", "", "35.61376", "36.56449", "Asia/Damascus"),
("168668", "Kafr Laha", "", "SY", "760", "11", "", "", "", "34.89469", "36.49582", "Asia/Damascus"),
("169023", "Jisr ash Shughur", "", "SY", "760", "12", "", "", "", "35.81426", "36.32062", "Asia/Damascus"),
("169113", "Jayrud", "", "SY", "760", "08", "", "", "", "33.8074", "36.74036", "Asia/Damascus"),
("169179", "Jarabulus", "", "SY", "760", "09", "", "", "", "36.8175", "38.01111", "Asia/Damascus"),
("169304", "Jablah", "", "SY", "760", "02", "", "", "", "35.36211", "35.92759", "Asia/Damascus"),
("169372", "`Irbin", "", "SY", "760", "08", "", "", "", "33.53719", "36.36635", "Asia/Damascus"),
("169375", "Inkhil", "", "SY", "760", "06", "", "", "", "33.01797", "36.12806", "Asia/Damascus"),
("169389", "Idlib", "Идлиб", "SY", "760", "12", "", "", "", "35.93062", "36.63393", "Asia/Damascus"),
("169577", "Homs", "Хомс", "SY", "760", "11", "", "", "", "34.72682", "36.72339", "Asia/Damascus"),
("169897", "Harasta", "", "SY", "760", "08", "", "", "", "33.55869", "36.36515", "Asia/Damascus"),
("170017", "Hamah", "Хама", "SY", "760", "10", "", "", "", "35.13179", "36.75783", "Asia/Damascus"),
("170044", "Halfaya", "", "SY", "760", "10", "", "", "", "35.26014", "36.60581", "Asia/Damascus"),
("170063", "Aleppo", "Алеппо", "SY", "760", "09", "", "", "", "36.20124", "37.16117", "Asia/Damascus"),
("170592", "Douma", "Дума", "SY", "760", "08", "", "", "", "33.57175", "36.4027", "Asia/Damascus"),
("170654", "Damascus", "Дамаск", "SY", "760", "13", "", "", "", "33.5102", "36.29128", "Asia/Damascus"),
("170785", "Dayr Hafir", "", "SY", "760", "09", "", "", "", "36.15694", "37.70778", "Asia/Damascus"),
("170794", "Deir ez-Zor", "Дейр-эз-Зор", "SY", "760", "07", "", "", "", "35.33588", "40.14084", "Asia/Damascus"),
("170887", "Ad Darbasiyah", "", "SY", "760", "01", "", "", "", "37.07279", "40.65199", "Asia/Damascus"),
("170892", "Darayya", "Дарайе", "SY", "760", "08", "", "", "", "33.45834", "36.23256", "Asia/Damascus"),
("170905", "Dar'a", "Деръа", "SY", "760", "06", "", "", "", "32.61889", "36.10213", "Asia/Damascus"),
("171451", "Binnish", "", "SY", "760", "12", "", "", "", "35.95664", "36.7138", "Asia/Damascus"),
("171830", "Baniyas", "Банияс", "SY", "760", "14", "", "", "", "35.18188", "35.94871", "Asia/Damascus"),
("172059", "Az Zabadani", "", "SY", "760", "08", "", "", "", "33.72488", "36.1005", "Asia/Damascus"),
("172082", "I`zaz", "Азаз", "SY", "760", "09", "", "", "", "36.58662", "37.04628", "Asia/Damascus"),
("172349", "At Tall", "", "SY", "760", "08", "", "", "", "33.61033", "36.3107", "Asia/Damascus"),
("172374", "Ath Thawrah", "", "SY", "760", "04", "", "", "", "35.83453", "38.54659", "Asia/Damascus"),
("172408", "As Suwayda'", "Эс-Сувейда", "SY", "760", "05", "", "", "", "32.70896", "36.56951", "Asia/Damascus"),
("172469", "As Sanamayn", "Эс-Санамейн", "SY", "760", "06", "", "", "", "33.07227", "36.18382", "Asia/Damascus"),
("172503", "As Safirah", "", "SY", "760", "09", "", "", "", "36.07696", "37.37251", "Asia/Damascus"),
("172946", "Ar Rastan", "", "SY", "760", "11", "", "", "", "34.92653", "36.73238", "Asia/Damascus"),
("172955", "Ar Raqqah", "Ар-Ракка", "SY", "760", "04", "", "", "", "35.95283", "39.00788", "Asia/Damascus"),
("173193", "An Nabk", "", "SY", "760", "08", "", "", "", "34.02547", "36.72837", "Asia/Damascus"),
("173312", "Al Qutayfah", "", "SY", "760", "08", "", "", "", "33.73848", "36.60071", "Asia/Damascus"),
("173322", "Al Qusayr", "Аль-Кусайра", "SY", "760", "11", "", "", "", "34.50914", "36.57975", "Asia/Damascus"),
("173334", "Al Qunaytirah", "Эль-Кунейтра", "SY", "760", "03", "", "", "", "33.12594", "35.82461", "Asia/Damascus"),
("173361", "Al Qaryatayn", "", "SY", "760", "11", "", "", "", "34.22956", "37.24066", "Asia/Damascus"),
("173480", "Al Mayadin", "", "SY", "760", "07", "", "", "", "35.02089", "40.45346", "Asia/Damascus"),
("173576", "Latakia", "Латакия", "SY", "760", "02", "", "", "", "35.53168", "35.79011", "Asia/Damascus"),
("173598", "Al Kiswah", "", "SY", "760", "08", "", "", "", "33.3581", "36.2419", "Asia/Damascus"),
("173811", "Al Hasakah", "", "SY", "760", "01", "", "", "", "36.50237", "40.74772", "Asia/Damascus"),
("173819", "Al Harak", "", "SY", "760", "06", "", "", "", "32.74932", "36.30994", "Asia/Damascus"),
("174018", "Al Bab", "", "SY", "760", "09", "", "", "", "36.36994", "37.51788", "Asia/Damascus"),
("174186", "`Afrin", "", "SY", "760", "09", "", "", "", "36.51194", "36.86954", "Asia/Damascus"),
("174259", "Ad Dana", "", "SY", "760", "12", "", "", "", "36.21252", "36.76978", "Asia/Damascus"),
("174448", "Albu Kamal", "Абу-Камаль", "SY", "760", "07", "", "", "", "34.45", "40.91861", "Asia/Damascus"),
("174506", "Hajin", "", "SY", "760", "07", "", "", "", "34.6927", "40.827", "Asia/Damascus"),
("934985", "Mbabane", "Мбабане", "SZ", "748", "01", "", "", "", "-26.31667", "31.13333", "Africa/Mbabane"),
("934995", "Manzini", "", "SZ", "748", "03", "", "", "", "-26.49884", "31.38004", "Africa/Mbabane"),
("935048", "Lobamba", "", "SZ", "748", "01", "", "", "", "-26.46667", "31.2", "Africa/Mbabane"),
("244128", "Fada", "", "TD", "148", "24", "", "", "", "17.1832", "21.58862", "Africa/Ndjamena"),
("245338", "Am Timan", "", "TD", "148", "13", "", "", "", "11.0297", "20.2827", "Africa/Ndjamena"),
("245785", "Abeche", "Абеше", "TD", "148", "12", "", "", "", "13.82916", "20.8324", "Africa/Ndjamena"),
("2425791", "Sagh", "Сарх", "TD", "148", "17", "", "", "", "9.1429", "18.3923", "Africa/Ndjamena"),
("2426240", "Pala", "Пала", "TD", "148", "20", "", "", "", "9.3642", "14.9046", "Africa/Ndjamena"),
("2426370", "Oum Hadjer", "", "TD", "148", "01", "", "", "", "13.2954", "19.6966", "Africa/Ndjamena"),
("2427123", "N'Djamena", "Нджамена", "TD", "148", "15", "", "", "", "12.10672", "15.0444", "Africa/Ndjamena"),
("2427336", "Moussoro", "", "TD", "148", "22", "", "", "", "13.64084", "16.49007", "Africa/Ndjamena"),
("2427455", "Moundou", "Мунду", "TD", "148", "08", "", "", "", "8.56667", "16.08333", "Africa/Ndjamena"),
("2427637", "Mongo", "Монго", "TD", "148", "05", "", "", "", "12.18441", "18.69303", "Africa/Ndjamena"),
("2428042", "Mboursou Lere", "", "TD", "148", "20", "", "", "", "9.7639", "14.1539", "Africa/Ndjamena"),
("2428228", "Massakory", "", "TD", "148", "18", "", "", "", "12.996", "15.72927", "Africa/Ndjamena"),
("2428231", "Massaguet", "", "TD", "148", "18", "", "", "", "12.47554", "15.43647", "Africa/Ndjamena"),
("2428394", "Mao", "", "TD", "148", "06", "", "", "", "14.12116", "15.3103", "Africa/Ndjamena"),
("2429296", "Lai", "", "TD", "148", "14", "", "", "", "9.3952", "16.2989", "Africa/Ndjamena"),
("2429344", "Kyabe", "", "TD", "148", "17", "", "", "", "9.45149", "18.94493", "Africa/Ndjamena"),
("2429605", "Koumra", "", "TD", "148", "19", "", "", "", "8.91256", "17.55392", "Africa/Ndjamena"),
("2430506", "Kelo", "Кел", "TD", "148", "14", "", "", "", "9.30859", "15.80658", "Africa/Ndjamena"),
("2433055", "Dourbali", "", "TD", "148", "15", "", "", "", "11.80909", "15.86323", "Africa/Ndjamena"),
("2433437", "Doba", "Доба", "TD", "148", "09", "", "", "", "8.65", "16.85", "Africa/Ndjamena"),
("2434910", "Bongor", "Бонгор", "TD", "148", "16", "", "", "", "10.28056", "15.37222", "Africa/Ndjamena"),
("2435124", "Bitkine", "", "TD", "148", "05", "", "", "", "11.9801", "18.2138", "Africa/Ndjamena"),
("2435508", "Benoy", "", "TD", "148", "08", "", "", "", "8.98327", "16.31991", "Africa/Ndjamena"),
("2436400", "Ati", "Ати", "TD", "148", "01", "", "", "", "13.2154", "18.3353", "Africa/Ndjamena"),
("2363490", "Vogan", "Воган", "TG", "768", "24", "", "", "", "6.33333", "1.53333", "Africa/Lome"),
("2363534", "Tsevie", "", "TG", "768", "24", "", "", "", "6.42611", "1.21333", "Africa/Lome"),
("2363908", "Tchamba", "", "TG", "768", "22", "", "", "", "9.03333", "1.41667", "Africa/Lome"),
("2364079", "Sotouboua", "", "TG", "768", "22", "", "", "", "8.5634", "0.98399", "Africa/Lome"),
("2364104", "Sokode", "Сокоде", "TG", "768", "22", "", "", "", "8.98333", "1.13333", "Africa/Lome"),
("2364752", "Notse", "", "TG", "768", "25", "", "", "", "6.95", "1.16667", "Africa/Lome"),
("2364812", "Niamtougou", "Ниамтугу", "TG", "768", "23", "", "", "", "9.76806", "1.10528", "Africa/Lome"),
("2365190", "Sansanne-Mango", "", "TG", "768", "26", "", "", "", "10.35917", "0.47083", "Africa/Lome"),
("2365267", "Lome", "Ломе", "TG", "768", "24", "", "", "", "6.13748", "1.21227", "Africa/Lome"),
("2365560", "Kpalime", "", "TG", "768", "25", "", "", "", "6.9", "0.63333", "Africa/Lome"),
("2366152", "Kara", "Кара", "TG", "768", "23", "", "", "", "9.55111", "1.18611", "Africa/Lome"),
("2367164", "Dapaong", "Дапаонге", "TG", "768", "26", "", "", "", "10.86225", "0.20762", "Africa/Lome"),
("2367568", "Bassar", "Басар", "TG", "768", "23", "", "", "", "9.26021", "0.78106", "Africa/Lome"),
("2367656", "Bafilo", "Бафило", "TG", "768", "23", "", "", "", "9.35", "1.26667", "Africa/Lome"),
("2367660", "Badou", "Бад", "TG", "768", "25", "", "", "", "7.58333", "0.6", "Africa/Lome"),
("2367886", "Atakpame", "", "TG", "768", "25", "", "", "", "7.53333", "1.13333", "Africa/Lome"),
("2367990", "Aneho", "", "TG", "768", "24", "", "", "", "6.23333", "1.6", "Africa/Lome"),
("1117652", "Ban Talat Yai", "Талат-Яи", "TH", "764", "62", "", "", "", "7.88481", "98.40008", "Asia/Bangkok"),
("1117656", "Ban Talat Nua", "Талат-Нуа", "TH", "764", "62", "", "", "", "7.88489", "98.38557", "Asia/Bangkok"),
("1117823", "Sam Roi Yot", "", "TH", "764", "57", "", "", "", "12.27081", "99.87203", "Asia/Bangkok"),
("1149698", "Phetchaburi", "Пхетчабури", "TH", "764", "56", "", "", "", "13.11189", "99.94467", "Asia/Bangkok"),
("1150007", "Trang", "Транг", "TH", "764", "65", "", "", "", "7.55633", "99.61141", "Asia/Bangkok"),
("1150085", "Thung Song", "", "TH", "764", "64", "", "", "", "8.16453", "99.68039", "Asia/Bangkok"),
("1150154", "Thoen", "", "TH", "764", "06", "", "", "", "17.61289", "99.21612", "Asia/Bangkok"),
("1150210", "Thap Than", "", "TH", "764", "15", "", "", "", "15.46063", "99.89166", "Asia/Bangkok"),
("1150246", "Tha Muang", "", "TH", "764", "50", "", "", "", "13.96118", "99.64122", "Asia/Bangkok"),
("1150275", "Tha Maka", "", "TH", "764", "50", "", "", "", "13.9", "99.76667", "Asia/Bangkok"),
("1150490", "Tak", "Так", "TH", "764", "08", "", "", "", "16.86968", "99.12898", "Asia/Bangkok"),
("1150515", "Surat Thani", "Сураттхани", "TH", "764", "60", "", "", "", "9.14011", "99.33311", "Asia/Bangkok"),
("1150533", "Sukhothai", "Сукхотай", "TH", "764", "09", "", "", "", "17.00778", "99.823", "Asia/Bangkok"),
("1150624", "Si Satchanalai", "", "TH", "764", "09", "1150623", "", "", "17.51692", "99.75978", "Asia/Bangkok"),
("1150681", "Sawankhalok", "", "TH", "764", "09", "", "", "", "17.31597", "99.83186", "Asia/Bangkok"),
("1150728", "San Pa Tong", "", "TH", "764", "02", "", "", "", "18.62828", "98.89572", "Asia/Bangkok"),
("1150732", "San Kamphaeng", "", "TH", "764", "02", "", "", "", "18.74486", "99.11953", "Asia/Bangkok"),
("1150921", "Ron Phibun", "", "TH", "764", "64", "", "", "", "8.17911", "99.85425", "Asia/Bangkok"),
("1150954", "Ratchaburi", "Ратчабури", "TH", "764", "52", "", "", "", "13.53671", "99.81712", "Asia/Bangkok"),
("1150965", "Ranong", "Ранонг", "TH", "764", "59", "", "", "", "9.96583", "98.63476", "Asia/Bangkok"),
("1151063", "Pran Buri", "", "TH", "764", "57", "", "", "", "12.38487", "99.90158", "Asia/Bangkok"),
("1151074", "Prachuap Khiri Khan", "", "TH", "764", "57", "", "", "", "11.82098", "99.7841", "Asia/Bangkok"),
("1151211", "Phunphin", "", "TH", "764", "60", "", "", "", "9.11072", "99.23208", "Asia/Bangkok"),
("1151254", "Phuket", "Пхукет", "TH", "764", "62", "", "", "", "7.89059", "98.3981", "Asia/Bangkok"),
("1151340", "Photharam", "Пхотхарам", "TH", "764", "52", "", "", "", "13.69234", "99.84969", "Asia/Bangkok"),
("1151426", "Phayao", "Пхаяо", "TH", "764", "41", "", "", "", "19.19203", "99.87883", "Asia/Bangkok"),
("1151528", "Pa Sang", "", "TH", "764", "05", "", "", "", "18.52617", "98.93936", "Asia/Bangkok"),
("1151933", "Nakhon Si Thammarat", "Накхонситхаммарат", "TH", "764", "64", "", "", "", "8.43333", "99.96667", "Asia/Bangkok"),
("1152188", "Mae Sot", "", "TH", "764", "08", "", "", "", "16.71667", "98.56667", "Asia/Bangkok"),
("1152194", "Mae Sai", "", "TH", "764", "03", "", "", "", "20.43353", "99.87617", "Asia/Bangkok"),
("1152202", "Mae Ramat", "", "TH", "764", "08", "", "", "", "16.98403", "98.51665", "Asia/Bangkok"),
("1152227", "Mae Chan", "", "TH", "764", "03", "", "", "", "20.14675", "99.85256", "Asia/Bangkok"),
("1152377", "Lat Yao", "", "TH", "764", "16", "", "", "", "15.751", "99.78925", "Asia/Bangkok"),
("1152432", "Lang Suan", "", "TH", "764", "58", "", "", "", "9.94561", "99.07847", "Asia/Bangkok"),
("1152468", "Lamphun", "Лампхун", "TH", "764", "05", "", "", "", "18.58054", "99.00745", "Asia/Bangkok"),
("1152473", "Lampang", "Лампанг", "TH", "764", "06", "", "", "", "18.29232", "99.49277", "Asia/Bangkok"),
("1152562", "Kui Buri", "", "TH", "764", "57", "", "", "", "12.08283", "99.85431", "Asia/Bangkok"),
("1152633", "Krabi", "Краби", "TH", "764", "63", "", "", "", "8.07257", "98.91052", "Asia/Bangkok"),
("1152919", "Khao Yoi", "", "TH", "764", "56", "", "", "", "13.24025", "99.82428", "Asia/Bangkok"),
("1152953", "Khanu Woralaksaburi", "", "TH", "764", "11", "", "", "", "16.0617", "99.86058", "Asia/Bangkok"),
("1153035", "Kathu", "Кату", "TH", "764", "62", "1153034", "", "", "7.91779", "98.33322", "Asia/Bangkok"),
("1153081", "Kanchanaburi", "Канчанабури", "TH", "764", "50", "", "", "", "14.00412", "99.54832", "Asia/Bangkok"),
("1153090", "Kamphaeng Phet", "", "TH", "764", "11", "", "", "", "16.48344", "99.52153", "Asia/Bangkok"),
("1153241", "Huai Yot", "", "TH", "764", "65", "", "", "", "7.78937", "99.63469", "Asia/Bangkok"),
("1153269", "Hua Hin", "", "TH", "764", "57", "", "", "", "12.57065", "99.95876", "Asia/Bangkok"),
("1153386", "Hang Dong", "", "TH", "764", "02", "", "", "", "18.68703", "98.91939", "Asia/Bangkok"),
("1153464", "Dok Kham Tai", "", "TH", "764", "41", "", "", "", "19.16242", "99.99342", "Asia/Bangkok"),
("1153513", "Damnoen Saduak", "Дамноенсадуак", "TH", "764", "52", "", "", "", "13.51824", "99.95469", "Asia/Bangkok"),
("1153557", "Chumphon", "Чумпхон", "TH", "764", "58", "", "", "", "10.4957", "99.17971", "Asia/Bangkok"),
("1153646", "Chom Bueng", "", "TH", "764", "52", "1153645", "", "", "13.62", "99.59169", "Asia/Bangkok"),
("1153669", "Chiang Rai", "Чианг-Рай", "TH", "764", "03", "", "", "", "19.90858", "99.8325", "Asia/Bangkok"),
("1153671", "Chiang Mai", "Чианг-Май", "TH", "764", "02", "", "", "", "18.79038", "98.98468", "Asia/Bangkok"),
("1153807", "Cha-am", "Ча-ам", "TH", "764", "56", "", "", "", "12.8", "99.96667", "Asia/Bangkok"),
("1153850", "Bo Phloi", "", "TH", "764", "50", "", "", "", "14.32517", "99.51467", "Asia/Bangkok"),
("1154677", "Ban Tak", "", "TH", "764", "08", "", "", "", "17.04325", "99.08128", "Asia/Bangkok"),
("1154689", "Ko Samui", "", "TH", "764", "60", "", "", "", "9.53567", "99.93567", "Asia/Bangkok"),
("1155139", "Ban Pong", "Пан-понг", "TH", "764", "52", "", "", "", "13.81629", "99.87739", "Asia/Bangkok"),
("1156046", "Ban Na San", "", "TH", "764", "60", "", "", "", "8.80036", "99.36372", "Asia/Bangkok"),
("1156257", "Ban Na", "", "TH", "764", "09", "", "", "", "17.01717", "99.73283", "Asia/Bangkok"),
("1157662", "Bang Saphan", "", "TH", "764", "57", "", "", "", "11.21259", "99.51167", "Asia/Bangkok"),
("1157683", "Bang Phae", "", "TH", "764", "52", "", "", "", "13.69157", "99.92982", "Asia/Bangkok"),
("1595679", "Nong Kung Si", "", "TH", "764", "23", "", "", "", "16.65", "103.3", "Asia/Bangkok"),
("1599640", "Ban Nong Wua So", "", "TH", "764", "76", "", "", "", "17.2675", "103.22472", "Asia/Bangkok"),
("1601579", "Ban Mai", "", "TH", "764", "68", "", "", "", "7.20411", "100.54508", "Asia/Bangkok"),
("1603235", "Ban Huai Thalaeng", "", "TH", "764", "27", "", "", "", "14.98333", "102.65", "Asia/Bangkok"),
("1604452", "Ban Khlong Bang Sao Thong", "", "TH", "764", "42", "", "", "", "13.64172", "100.83272", "Asia/Bangkok"),
("1604654", "Na Klang", "", "TH", "764", "79", "", "", "", "17.3072", "102.18886", "Asia/Bangkok"),
("1604769", "Yasothon", "Ясотхон", "TH", "764", "72", "", "", "", "15.79408", "104.1451", "Asia/Bangkok"),
("1604771", "Yaring", "", "TH", "764", "69", "", "", "", "6.86617", "101.36894", "Asia/Bangkok"),
("1604870", "Yala", "Яла", "TH", "764", "70", "", "", "", "6.53995", "101.28128", "Asia/Bangkok"),
("1605018", "Wiset Chaichan", "", "TH", "764", "35", "", "", "", "14.5945", "100.33825", "Asia/Bangkok"),
("1605024", "Wichian Buri", "", "TH", "764", "14", "", "", "", "15.65778", "101.10603", "Asia/Bangkok"),
("1605069", "Warin Chamrap", "", "TH", "764", "75", "", "", "", "15.19319", "104.8628", "Asia/Bangkok"),
("1605102", "Wang Saphung", "", "TH", "764", "18", "", "", "", "17.30097", "101.7685", "Asia/Bangkok"),
("1605118", "Wang Noi", "", "TH", "764", "36", "", "", "", "14.22689", "100.7155", "Asia/Bangkok"),
("1605119", "Wang Nam Yen", "", "TH", "764", "80", "", "", "", "13.50325", "102.18115", "Asia/Bangkok"),
("1605215", "Uttaradit", "Уттарадит", "TH", "764", "10", "", "", "", "17.62557", "100.09421", "Asia/Bangkok"),
("1605221", "Uthai Thani", "", "TH", "764", "15", "", "", "", "15.37939", "100.0245", "Asia/Bangkok"),
("1605239", "Udon Thani", "Удон-Тхани", "TH", "764", "76", "", "", "", "17.41567", "102.78589", "Asia/Bangkok"),
("1605245", "Ubon Ratchathani", "", "TH", "764", "75", "", "", "", "15.23844", "104.84866", "Asia/Bangkok"),
("1605279", "Trat", "Трат", "TH", "764", "49", "", "", "", "12.24364", "102.51514", "Asia/Bangkok"),
("1605467", "Tha Yang", "", "TH", "764", "56", "", "", "", "12.95772", "99.90555", "Asia/Bangkok"),
("1605509", "Tha Ruea", "", "TH", "764", "36", "1605508", "", "", "14.56739", "100.72598", "Asia/Bangkok"),
("1605538", "Thap Khlo", "", "TH", "764", "13", "", "", "", "16.16003", "100.59656", "Asia/Bangkok"),
("1605601", "Tha Mai", "", "TH", "764", "48", "", "", "", "12.62137", "102.0048", "Asia/Bangkok"),
("1605677", "Tha Bo", "", "TH", "764", "17", "", "", "", "17.85003", "102.58139", "Asia/Bangkok"),
("1605754", "Taphan Hin", "", "TH", "764", "13", "", "", "", "16.22094", "100.41978", "Asia/Bangkok"),
("1605957", "Tak Bai", "", "TH", "764", "31", "", "", "", "6.25947", "102.05461", "Asia/Bangkok"),
("1606030", "Surin", "Сурин", "TH", "764", "29", "", "", "", "14.88181", "103.49364", "Asia/Bangkok"),
("1606033", "Suphan Buri", "Суфан Бури", "TH", "764", "51", "", "", "", "14.47418", "100.12218", "Asia/Bangkok"),
("1606050", "Su-ngai Kolok", "", "TH", "764", "31", "", "", "", "6.02977", "101.96586", "Asia/Bangkok"),
("1606147", "Songkhla", "Сонгкхла", "TH", "764", "68", "", "", "", "7.19882", "100.5951", "Asia/Bangkok"),
("1606239", "Si Sa Ket", "Си Са Кет", "TH", "764", "30", "", "", "", "15.11481", "104.32938", "Asia/Bangkok"),
("1606250", "Si Racha", "", "TH", "764", "46", "", "", "", "13.17372", "100.93111", "Asia/Bangkok"),
("1606270", "Sing Buri", "Синг Бури", "TH", "764", "33", "", "", "", "14.88786", "100.40464", "Asia/Bangkok"),
("1606343", "Seka", "", "TH", "764", "81", "", "", "", "17.92851", "103.95519", "Asia/Bangkok"),
("1606350", "Sawang Daen Din", "", "TH", "764", "20", "", "", "", "17.47531", "103.45753", "Asia/Bangkok"),
("1606376", "Satun", "Сатун", "TH", "764", "67", "", "", "", "6.62314", "100.06676", "Asia/Bangkok"),
("1606386", "Sattahip", "", "TH", "764", "46", "", "", "", "12.66644", "100.90073", "Asia/Bangkok"),
("1606418", "Saraburi", "", "TH", "764", "37", "", "", "", "14.53333", "100.91667", "Asia/Bangkok"),
("1606586", "Samut Songkhram", "", "TH", "764", "54", "", "", "", "13.41456", "100.00264", "Asia/Bangkok"),
("1606588", "Samut Sakhon", "", "TH", "764", "55", "", "", "", "13.54753", "100.27362", "Asia/Bangkok"),
("1606590", "Samut Prakan", "Самутпракан", "TH", "764", "42", "", "", "", "13.59934", "100.59675", "Asia/Bangkok"),
("1606638", "Sam Phran", "", "TH", "764", "53", "", "", "", "13.72698", "100.21526", "Asia/Bangkok"),
("1606790", "Sakon Nakhon", "", "TH", "764", "20", "", "", "", "17.16116", "104.14725", "Asia/Bangkok"),
("1606807", "Sa Kaeo", "", "TH", "764", "80", "", "", "", "13.81411", "102.07222", "Asia/Bangkok"),
("1606939", "Sadao", "Садао", "TH", "764", "68", "", "", "", "6.63883", "100.42342", "Asia/Bangkok"),
("1607001", "Roi Et", "Рои Эт", "TH", "764", "25", "", "", "", "16.0567", "103.65309", "Asia/Bangkok"),
("1607017", "Rayong", "Районг", "TH", "764", "47", "", "", "", "12.68095", "101.25798", "Asia/Bangkok"),
("1607068", "Ranot", "", "TH", "764", "68", "", "", "", "7.77768", "100.32134", "Asia/Bangkok"),
("1607083", "Ra-ngae", "", "TH", "764", "31", "", "", "", "6.29678", "101.72844", "Asia/Bangkok"),
("1607257", "Prakhon Chai", "", "TH", "764", "28", "", "", "", "14.60592", "103.12081", "Asia/Bangkok"),
("1607280", "Prachin Buri", "", "TH", "764", "74", "", "", "", "14.04992", "101.36864", "Asia/Bangkok"),
("1607435", "Phu Kradueng", "", "TH", "764", "18", "", "", "", "16.88425", "101.88467", "Asia/Bangkok"),
("1607439", "Phu Khiao", "", "TH", "764", "26", "", "", "", "16.3765", "102.12853", "Asia/Bangkok"),
("1607508", "Phra Pradaeng", "", "TH", "764", "42", "", "", "", "13.65854", "100.53362", "Asia/Bangkok"),
("1607512", "Phra Phutthabat", "", "TH", "764", "37", "", "", "", "14.72526", "100.79536", "Asia/Bangkok"),
("1607532", "Phra Nakhon Si Ayutthaya", "Аюттхая", "TH", "764", "36", "", "", "", "14.35167", "100.57739", "Asia/Bangkok"),
("1607552", "Phrae", "Пхрае", "TH", "764", "07", "", "", "", "18.14589", "100.14103", "Asia/Bangkok"),
("1607615", "Phon Charoen", "", "TH", "764", "17", "", "", "", "18.03333", "103.16667", "Asia/Bangkok"),
("1607708", "Phitsanulok", "Пхитсанулок", "TH", "764", "12", "", "", "", "16.82481", "100.25858", "Asia/Bangkok"),
("1607725", "Phichit", "Пхичит", "TH", "764", "13", "", "", "", "16.44184", "100.34879", "Asia/Bangkok"),
("1607730", "Phibun Mangsahan", "", "TH", "764", "75", "", "", "", "15.24467", "105.22908", "Asia/Bangkok"),
("1607737", "Phetchabun", "Пхетчабун", "TH", "764", "14", "", "", "", "16.41904", "101.16056", "Asia/Bangkok"),
("1607779", "Phatthalung", "Пхетчабун", "TH", "764", "66", "", "", "", "7.61786", "100.07792", "Asia/Bangkok"),
("1607793", "Phan Thong", "", "TH", "764", "46", "", "", "", "13.46804", "101.09532", "Asia/Bangkok"),
("1607801", "Phanom Sarakham", "", "TH", "764", "44", "", "", "", "13.74787", "101.3553", "Asia/Bangkok"),
("1607838", "Phanat Nikhom", "", "TH", "764", "46", "", "", "", "13.44581", "101.18445", "Asia/Bangkok"),
("1607865", "Phak Hai", "", "TH", "764", "36", "", "", "", "14.45736", "100.36989", "Asia/Bangkok"),
("1607978", "Pattani", "Паттани", "TH", "764", "69", "", "", "", "6.86814", "101.25009", "Asia/Bangkok"),
("1607983", "Pathum Thani", "Ратхум Тхани", "TH", "764", "39", "", "", "", "14.01346", "100.53049", "Asia/Bangkok"),
("1608033", "Pak Phanang", "", "TH", "764", "64", "", "", "", "8.35109", "100.20195", "Asia/Bangkok"),
("1608048", "Pak Kret", "", "TH", "764", "38", "", "", "", "13.91301", "100.49883", "Asia/Bangkok"),
("1608057", "Pak Chong", "", "TH", "764", "27", "", "", "", "14.70802", "101.41614", "Asia/Bangkok"),
("1608133", "Mueang Nonthaburi", "Нонтхабури", "TH", "764", "38", "", "", "", "13.86075", "100.51477", "Asia/Bangkok"),
("1608136", "Non Sung", "", "TH", "764", "27", "", "", "", "15.18014", "102.25694", "Asia/Bangkok"),
("1608191", "Nong Phai", "", "TH", "764", "14", "", "", "", "15.99025", "101.06183", "Asia/Bangkok"),
("1608232", "Nong Khai", "Нонг-Кхай", "TH", "764", "17", "", "", "", "17.87847", "102.742", "Asia/Bangkok"),
("1608239", "Nong Khae", "", "TH", "764", "37", "", "", "", "14.34062", "100.86733", "Asia/Bangkok"),
("1608269", "Nong Bua Lamphu", "", "TH", "764", "79", "", "", "", "17.20406", "102.44068", "Asia/Bangkok"),
("1608409", "Narathiwat", "Наратхиват", "TH", "764", "31", "", "", "", "6.42639", "101.82308", "Asia/Bangkok"),
("1608424", "Nang Rong", "", "TH", "764", "28", "", "", "", "14.6377", "102.79138", "Asia/Bangkok"),
("1608452", "Nan", "Нан", "TH", "764", "04", "", "", "", "18.78378", "100.77899", "Asia/Bangkok"),
("1608462", "Nam Som", "", "TH", "764", "76", "", "", "", "17.77036", "102.18947", "Asia/Bangkok"),
("1608527", "Nakhon Sawan", "", "TH", "764", "16", "", "", "", "15.70472", "100.13717", "Asia/Bangkok"),
("1608529", "Nakhon Ratchasima", "Накхонратчасима", "TH", "764", "27", "", "", "", "14.97066", "102.10196", "Asia/Bangkok"),
("1608531", "Nakhon Phanom", "", "TH", "764", "73", "", "", "", "17.41081", "104.77856", "Asia/Bangkok"),
("1608534", "Nakhon Pathom", "", "TH", "764", "53", "", "", "", "13.8196", "100.04427", "Asia/Bangkok"),
("1608539", "Nakhon Nayok", "", "TH", "764", "43", "", "", "", "14.20463", "101.21295", "Asia/Bangkok"),
("1608541", "Nakhon Luang", "", "TH", "764", "36", "", "", "", "14.46281", "100.60832", "Asia/Bangkok"),
("1608597", "Mukdahan", "Мукдахан", "TH", "764", "78", "", "", "", "16.54531", "104.72351", "Asia/Bangkok"),
("1608900", "Maha Sarakham", "", "TH", "764", "24", "", "", "", "16.18483", "103.30067", "Asia/Bangkok"),
("1609032", "Lop Buri", "Лопбури", "TH", "764", "34", "", "", "", "14.79808", "100.65397", "Asia/Bangkok"),
("1609043", "Lom Sak", "", "TH", "764", "14", "", "", "", "16.77983", "101.24225", "Asia/Bangkok"),
("1609071", "Loei", "Лоэ", "TH", "764", "18", "", "", "", "17.49052", "101.72749", "Asia/Bangkok"),
("1609278", "Laem Sing", "", "TH", "764", "48", "", "", "", "12.48164", "102.07375", "Asia/Bangkok"),
("1609324", "Kut Chap", "", "TH", "764", "76", "", "", "", "17.4257", "102.56692", "Asia/Bangkok"),
("1609345", "Kuchinarai", "", "TH", "764", "23", "", "", "", "16.541", "104.05004", "Asia/Bangkok"),
("1609350", "Bangkok", "Бангкок", "TH", "764", "40", "", "", "", "13.75398", "100.50144", "Asia/Bangkok"),
("1609395", "Krathum Baen", "", "TH", "764", "55", "", "", "", "13.6533", "100.25972", "Asia/Bangkok"),
("1609610", "Klaeng", "", "TH", "764", "47", "", "", "", "12.77972", "101.64831", "Asia/Bangkok"),
("1609776", "Khon Kaen", "Кхонкэн", "TH", "764", "22", "", "", "", "16.44671", "102.833", "Asia/Bangkok"),
("1609795", "Khon Buri", "", "TH", "764", "27", "", "", "", "14.52541", "102.24591", "Asia/Bangkok"),
("1609899", "Khlong Luang", "", "TH", "764", "39", "", "", "", "14.06467", "100.64578", "Asia/Bangkok"),
("1609990", "Khao Wong", "", "TH", "764", "23", "", "", "", "16.70008", "104.0902", "Asia/Bangkok"),
("1610185", "Kaset Wisai", "", "TH", "764", "25", "", "", "", "15.65558", "103.58361", "Asia/Bangkok"),
("1610187", "Kaset Sombun", "", "TH", "764", "26", "", "", "", "16.28053", "101.95422", "Asia/Bangkok"),
("1610227", "Kantharalak", "Кантхаралак", "TH", "764", "30", "", "", "", "14.64056", "104.64992", "Asia/Bangkok"),
("1610459", "Kamalasai", "", "TH", "764", "23", "", "", "", "16.33839", "103.57564", "Asia/Bangkok"),
("1610469", "Kalasin", "Каласин", "TH", "764", "23", "", "", "", "16.43281", "103.50658", "Asia/Bangkok"),
("1610503", "Kaeng Khoi", "", "TH", "764", "37", "", "", "", "14.58617", "100.99758", "Asia/Bangkok"),
("1610505", "Kaeng Khro", "", "TH", "764", "26", "", "", "", "16.10864", "102.25808", "Asia/Bangkok"),
("1610538", "Kabin Buri", "", "TH", "764", "74", "", "", "", "13.95114", "101.71769", "Asia/Bangkok"),
("1610780", "Hat Yai", "Хатъяй", "TH", "764", "68", "", "", "", "7.00836", "100.47668", "Asia/Bangkok"),
("1610940", "Det Udom", "", "TH", "764", "75", "", "", "", "14.90598", "105.07836", "Asia/Bangkok"),
("1610943", "Den Chai", "", "TH", "764", "07", "", "", "", "17.98372", "100.05217", "Asia/Bangkok"),
("1610963", "Dan Khun Thot", "", "TH", "764", "27", "", "", "", "15.2085", "101.77138", "Asia/Bangkok"),
("1611026", "Chum Phae", "", "TH", "764", "22", "", "", "", "16.5443", "102.09924", "Asia/Bangkok"),
("1611106", "Chon Daen", "", "TH", "764", "14", "", "", "", "16.18953", "100.85958", "Asia/Bangkok"),
("1611110", "Chon Buri", "Чонбури", "TH", "764", "46", "", "", "", "13.3622", "100.98345", "Asia/Bangkok"),
("1611135", "Chok Chai", "", "TH", "764", "27", "", "", "", "14.72844", "102.16524", "Asia/Bangkok"),
("1611269", "Chanthaburi", "Чантхабури", "TH", "764", "48", "", "", "", "12.60961", "102.10447", "Asia/Bangkok"),
("1611407", "Chaiyaphum", "Чайяпхум", "TH", "764", "26", "", "", "", "15.81047", "102.02881", "Asia/Bangkok"),
("1611416", "Chai Nat", "", "TH", "764", "32", "", "", "", "15.18636", "100.12353", "Asia/Bangkok"),
("1611424", "Chai Badan", "", "TH", "764", "34", "", "", "", "15.2", "101.13333", "Asia/Bangkok"),
("1611439", "Chachoengsao", "Чачоенгсао", "TH", "764", "44", "", "", "", "13.6882", "101.07156", "Asia/Bangkok"),
("1611453", "Buriram", "Бурирам", "TH", "764", "28", "", "", "", "14.99433", "103.10392", "Asia/Bangkok"),
("1611492", "Bua Yai", "", "TH", "764", "27", "", "", "", "15.58552", "102.42587", "Asia/Bangkok"),
("1611635", "Betong", "Бетонг", "TH", "764", "70", "1611635", "", "", "5.77434", "101.07231", "Asia/Bangkok"),
("1613284", "Ban Selaphum", "", "TH", "764", "25", "", "", "", "16.01667", "103.95", "Asia/Bangkok"),
("1613769", "Ban Rangsit", "", "TH", "764", "39", "", "", "", "14.02775", "100.75603", "Asia/Bangkok"),
("1614295", "Phatthaya", "Паттайя", "TH", "764", "46", "", "", "", "12.93333", "100.88333", "Asia/Bangkok"),
("1614336", "Ban Phan Don", "", "TH", "764", "76", "", "", "", "17.14272", "102.97261", "Asia/Bangkok"),
("1614455", "Ban Phai", "", "TH", "764", "22", "", "", "", "16.05997", "102.73097", "Asia/Bangkok"),
("1614465", "Ban Phaeo", "", "TH", "764", "55", "", "", "", "13.59072", "100.10748", "Asia/Bangkok"),
("1616658", "Ban Mo", "", "TH", "764", "37", "", "", "", "14.61544", "100.72731", "Asia/Bangkok"),
("1617111", "Ban Lam Luk Ka", "", "TH", "764", "39", "", "", "", "13.97738", "100.77776", "Asia/Bangkok"),
("1619276", "Bang Rakam", "", "TH", "764", "12", "", "", "", "16.75847", "100.11742", "Asia/Bangkok"),
("1619281", "Bang Racham", "", "TH", "764", "33", "", "", "", "14.892", "100.31728", "Asia/Bangkok"),
("1619363", "Bang Pakong", "", "TH", "764", "44", "", "", "", "13.54297", "100.99333", "Asia/Bangkok"),
("1619369", "Bang Pa-in", "", "TH", "764", "36", "", "", "", "14.22783", "100.57589", "Asia/Bangkok"),
("1619400", "Bang Mun Nak", "", "TH", "764", "13", "", "", "", "16.02781", "100.37917", "Asia/Bangkok"),
("1619415", "Bang Len", "", "TH", "764", "53", "", "", "", "14.02188", "100.17183", "Asia/Bangkok"),
("1619423", "Bang Lamung", "", "TH", "764", "46", "", "", "", "13.04704", "100.92891", "Asia/Bangkok"),
("1619434", "Bang Kruai", "", "TH", "764", "38", "", "", "", "13.805", "100.47283", "Asia/Bangkok"),
("1619437", "Bang Krathum", "", "TH", "764", "12", "", "", "", "16.57831", "100.30034", "Asia/Bangkok"),
("1619602", "Bang Bua Thong", "", "TH", "764", "38", "", "", "", "13.91783", "100.42403", "Asia/Bangkok"),
("1619616", "Bang Ban", "", "TH", "764", "36", "", "", "", "14.37394", "100.48528", "Asia/Bangkok"),
("1619650", "Ban Dung", "", "TH", "764", "76", "", "", "", "17.699", "103.25957", "Asia/Bangkok"),
("1620254", "Ban Chang", "", "TH", "764", "47", "", "", "", "12.72543", "101.0553", "Asia/Bangkok"),
("1620371", "Ban Bueng", "", "TH", "764", "46", "", "", "", "13.311", "101.11214", "Asia/Bangkok"),
("1620442", "Ban Talat Bueng", "", "TH", "764", "46", "", "", "", "13.07147", "101.00314", "Asia/Bangkok"),
("1620875", "Ban Bang Kadi Pathum Thani", "", "TH", "764", "36", "", "", "", "13.99904", "100.54962", "Asia/Bangkok"),
("1620919", "Bang Bo District", "", "TH", "764", "42", "", "", "", "13.58333", "100.81667", "Asia/Bangkok"),
("1621020", "Aranyaprathet", "Араньяпратхет", "TH", "764", "80", "", "", "", "13.69276", "102.50128", "Asia/Bangkok"),
("1621060", "Amnat Charoen", "Амнат Чароен", "TH", "764", "77", "", "", "", "15.85851", "104.62883", "Asia/Bangkok"),
("1948015", "Amphoe Sikhiu", "", "TH", "764", "27", "", "", "", "14.89944", "101.70833", "Asia/Bangkok"),
("6696291", "Wichit", "", "TH", "764", "62", "", "", "", "7.8894", "98.38523", "Asia/Bangkok"),
("7091861", "Ban Chalong", "", "TH", "764", "62", "", "", "", "7.84468", "98.33897", "Asia/Bangkok"),
("7091912", "Ban Ratsada", "Ратсада", "TH", "764", "62", "", "", "", "7.90963", "98.40248", "Asia/Bangkok"),
("1220112", "Yovon", "", "TJ", "762", "02", "", "", "", "38.31408", "69.03784", "Asia/Dushanbe"),
("1220163", "Vose'", "", "TJ", "762", "02", "", "", "", "37.80396", "69.64416", "Asia/Dushanbe"),
("1220219", "Vakhsh", "", "TJ", "762", "02", "", "", "", "37.71485", "68.83456", "Asia/Dushanbe"),
("1220253", "Istaravshan", "Истаравшан", "TJ", "762", "03", "", "", "", "39.9142", "69.00328", "Asia/Dushanbe"),
("1220301", "Tursunzoda", "Турсунзаде", "TJ", "762", "RR", "", "", "", "38.51437", "68.23327", "Asia/Dushanbe"),
("1220747", "Qurghonteppa", "Курган Тюбе", "TJ", "762", "02", "", "", "", "37.83399", "68.78186", "Asia/Dushanbe"),
("1220798", "Panjakent", "Пенджикент", "TJ", "762", "03", "", "", "", "39.49524", "67.60931", "Asia/Dushanbe"),
("1220826", "Farkhor", "Фархор", "TJ", "762", "02", "", "", "", "37.49219", "69.40356", "Asia/Dushanbe"),
("1220855", "Vahdat", "Кофарнихона", "TJ", "762", "RR", "", "", "", "38.55632", "69.01354", "Asia/Dushanbe"),
("1220905", "Norak", "", "TJ", "762", "02", "", "", "", "38.38917", "69.32272", "Asia/Dushanbe"),
("1221194", "Kulob", "Куляб", "TJ", "762", "02", "", "", "", "37.91458", "69.78454", "Asia/Dushanbe"),
("1221259", "Kolkhozobod", "", "TJ", "762", "02", "", "", "", "37.58823", "68.65886", "Asia/Dushanbe"),
("1221328", "Khorugh", "Хорог", "TJ", "762", "01", "", "", "", "37.48974", "71.55304", "Asia/Dushanbe"),
("1221614", "Ishqoshim", "Ишкашим", "TJ", "762", "01", "", "", "", "36.72484", "71.61331", "Asia/Dushanbe"),
("1221714", "Hisor", "Гиссар", "TJ", "762", "RR", "", "", "", "38.52504", "68.55124", "Asia/Dushanbe"),
("1221874", "Dushanbe", "Душанбе", "TJ", "762", "7280679", "", "", "", "38.53575", "68.77905", "Asia/Dushanbe"),
("1221965", "Danghara", "Дангара", "TJ", "762", "02", "", "", "", "38.09578", "69.33998", "Asia/Dushanbe"),
("1221997", "Chubek", "", "TJ", "762", "02", "", "", "", "37.61453", "69.70525", "Asia/Dushanbe"),
("1222107", "Boshkengash", "", "TJ", "762", "7280679", "", "", "", "38.46613", "68.80533", "Asia/Dushanbe"),
("1514839", "Proletar", "", "TJ", "762", "03", "", "", "", "40.16713", "69.50163", "Asia/Dushanbe"),
("1514879", "Khujand", "Худжанд", "TJ", "762", "03", "", "", "", "40.28256", "69.62216", "Asia/Dushanbe"),
("1514891", "Konibodom", "Канибадам", "TJ", "762", "03", "", "", "", "40.29414", "70.43122", "Asia/Dushanbe"),
("1514896", "Isfara", "Исфара", "TJ", "762", "03", "", "", "", "40.12648", "70.62526", "Asia/Dushanbe"),
("1538311", "Chkalov", "", "TJ", "762", "03", "", "", "", "40.23417", "69.69481", "Asia/Dushanbe"),
("161616", "Balkanabat", "Балканабат", "TM", "795", "02", "", "", "", "39.51075", "54.36713", "Asia/Ashgabat"),
("161901", "Kaka", "Кака", "TM", "795", "01", "", "", "", "37.34821", "59.61431", "Asia/Ashgabat"),
("161943", "Gumdag", "Гумдаге", "TM", "795", "02", "", "", "", "39.20611", "54.59056", "Asia/Ashgabat"),
("161974", "Gazanjyk", "Газанджык", "TM", "795", "02", "", "", "", "39.24463", "55.51536", "Asia/Ashgabat"),
("162099", "Buzmeyin", "", "TM", "795", "01", "", "", "", "38.05067", "58.20559", "Asia/Ashgabat"),
("162158", "Baharly", "Бахарден", "TM", "795", "01", "", "", "", "38.43624", "57.43158", "Asia/Ashgabat"),
("162183", "Ashgabat", "Ашхабад", "TM", "795", "01", "", "", "", "37.95", "58.38333", "Asia/Ashgabat"),
("162199", "Annau", "", "TM", "795", "01", "", "", "", "37.88757", "58.516", "Asia/Ashgabat"),
("601432", "Yylanly", "", "TM", "795", "03", "", "", "", "41.83333", "59.65", "Asia/Ashgabat"),
("601475", "Tagta", "", "TM", "795", "03", "", "", "", "41.65041", "59.9164", "Asia/Ashgabat"),
("601594", "Turkmenbasy", "Туркменбашы", "TM", "795", "02", "", "", "", "40.02216", "52.95518", "Asia/Ashgabat"),
("601608", "Koeneuergench", "Куня-Ургенч", "TM", "795", "03", "", "", "", "42.32773", "59.15442", "Asia/Ashgabat"),
("601661", "Boldumsaz", "Болдумсаз", "TM", "795", "03", "", "", "", "42.12824", "59.67101", "Asia/Ashgabat"),
("601734", "Dasoguz", "Дашогуз", "TM", "795", "03", "", "", "", "41.83625", "59.96662", "Asia/Ashgabat"),
("1218021", "Yoloeten", "Иолотань", "TM", "795", "05", "", "", "", "37.29886", "62.35975", "Asia/Ashgabat"),
("1218239", "Tejen", "Теджен", "TM", "795", "01", "", "", "", "37.38338", "60.50544", "Asia/Ashgabat"),
("1218420", "Seydi", "Сейди", "TM", "795", "05", "", "", "", "39.4816", "62.91374", "Asia/Ashgabat"),
("1218436", "Sayat", "", "TM", "795", "04", "", "", "", "38.78392", "63.88035", "Asia/Ashgabat"),
("1218667", "Mary", "Мары", "TM", "795", "05", "", "", "", "37.59378", "61.83031", "Asia/Ashgabat"),
("1219002", "Atamyrat", "Атамырат", "TM", "795", "04", "", "", "", "37.83574", "65.21058", "Asia/Ashgabat"),
("1219392", "Gowurdak", "", "TM", "795", "04", "", "", "", "37.81244", "66.04656", "Asia/Ashgabat"),
("1219649", "Turkmenabat", "Туркменабад", "TM", "795", "04", "", "", "", "39.07328", "63.57862", "Asia/Ashgabat"),
("1219762", "Bayramaly", "Байрамалийского", "TM", "795", "05", "", "", "", "37.61852", "62.16715", "Asia/Ashgabat"),
("1514792", "Gazojak", "", "TM", "795", "04", "", "", "", "41.18746", "61.4036", "Asia/Ashgabat"),
("2464041", "Zaghouan", "", "TN", "788", "37", "", "", "", "36.40291", "10.14292", "Africa/Tunis"),
("2464168", "Oued Lill", "", "TN", "788", "36", "", "", "", "36.83408", "10.04057", "Africa/Tunis"),
("2464470", "Tunis", "Тунис", "TN", "788", "36", "", "", "", "36.81897", "10.16579", "Africa/Tunis"),
("2464648", "Tozeur", "Тозер", "TN", "788", "35", "", "", "", "33.91968", "8.13352", "Africa/Tunis"),
("2464701", "Tataouine", "", "TN", "788", "34", "", "", "", "32.92967", "10.45177", "Africa/Tunis"),
("2464795", "Thala", "", "TN", "788", "02", "", "", "", "35.57244", "8.67031", "Africa/Tunis"),
("2464804", "Taklisah", "", "TN", "788", "19", "", "", "", "36.78333", "10.63333", "Africa/Tunis"),
("2464809", "Tajerouine", "", "TN", "788", "14", "", "", "", "35.89174", "8.55276", "Africa/Tunis"),
("2464915", "Sousse", "Сусс", "TN", "788", "23", "", "", "", "35.82539", "10.63699", "Africa/Tunis"),
("2465030", "Siliana", "Силиана", "TN", "788", "22", "", "", "", "36.08497", "9.37082", "Africa/Tunis"),
("2465840", "Sidi Bouzid", "Сиди-Бу-Зид", "TN", "788", "33", "", "", "", "35.03823", "9.48494", "Africa/Tunis"),
("2467246", "Saqanis", "", "TN", "788", "16", "", "", "", "35.78333", "10.8", "Africa/Tunis"),
("2467454", "Sfax", "Сфвкс", "TN", "788", "32", "", "", "", "34.74056", "10.76028", "Africa/Tunis"),
("2467521", "La Sebala du Mornag", "", "TN", "788", "36", "", "", "", "36.67931", "10.29195", "Africa/Tunis"),
("2467815", "Rades", "", "TN", "788", "36", "", "", "", "36.76806", "10.27528", "Africa/Tunis"),
("2467856", "Ksour Essaf", "", "TN", "788", "15", "", "", "", "35.41808", "10.99475", "Africa/Tunis"),
("2467920", "Korba", "Корба", "TN", "788", "19", "", "", "", "36.57861", "10.85861", "Africa/Tunis"),
("2467959", "Qulaybiyah", "Келибия", "TN", "788", "19", "", "", "", "36.84757", "11.09386", "Africa/Tunis"),
("2468018", "Kebili", "", "TN", "788", "31", "", "", "", "33.70439", "8.96903", "Africa/Tunis"),
("2468106", "Qasr Hallal", "", "TN", "788", "16", "", "", "", "35.64773", "10.89046", "Africa/Tunis"),
("2468245", "Carthage", "Карфаген", "TN", "788", "36", "", "", "", "36.86108", "10.33161", "Africa/Tunis"),
("2468285", "El Fahs", "", "TN", "788", "37", "", "", "", "36.37419", "9.90651", "Africa/Tunis"),
("2468329", "Qal'at al Andalus", "Калат-аль-Андалус", "TN", "788", "38", "", "", "", "37.0629", "10.11829", "Africa/Tunis"),
("2468353", "Gafsa", "Гафса", "TN", "788", "30", "2468352", "", "", "34.425", "8.78417", "Africa/Tunis"),
("2468369", "Gabes", "Габес", "TN", "788", "29", "", "", "", "33.88146", "10.0982", "Africa/Tunis"),
("2468561", "Nefta", "Нефта", "TN", "788", "35", "", "", "", "33.87309", "7.87765", "Africa/Tunis"),
("2468579", "Nabeul", "Набул", "TN", "788", "19", "", "", "", "36.45606", "10.73763", "Africa/Tunis"),
("2468925", "Midoun", "Мидун", "TN", "788", "28", "", "", "", "33.80813", "10.99228", "Africa/Tunis"),
("2469088", "Mateur", "", "TN", "788", "18", "", "", "", "37.04045", "9.66557", "Africa/Tunis"),
("2469140", "Masakin", "", "TN", "788", "23", "", "", "", "35.72917", "10.58082", "Africa/Tunis"),
("2469256", "Menzel Jemil", "", "TN", "788", "18", "", "", "", "37.23618", "9.91448", "Africa/Tunis"),
("2469262", "Manzil Bu Zalafah", "", "TN", "788", "19", "", "", "", "36.68312", "10.58431", "Africa/Tunis"),
("2469264", "Menzel Bourguiba", "", "TN", "788", "18", "", "", "", "37.15368", "9.78594", "Africa/Tunis"),
("2469268", "Menzel Abderhaman", "", "TN", "788", "18", "", "", "", "37.23737", "9.86313", "Africa/Tunis"),
("2469274", "Manouba", "", "TN", "788", "39", "", "", "", "36.80803", "10.0972", "Africa/Tunis"),
("2469386", "Majaz al Bab", "", "TN", "788", "17", "", "", "", "36.64964", "9.61231", "Africa/Tunis"),
("2469473", "Medenine", "", "TN", "788", "28", "", "", "", "33.35495", "10.50548", "Africa/Tunis"),
("2470088", "Jendouba", "Джендуба", "TN", "788", "06", "", "", "", "36.50114", "8.78024", "Africa/Tunis"),
("2470173", "Zarzis", "", "TN", "788", "28", "", "", "", "33.50398", "11.11216", "Africa/Tunis"),
("2470191", "Jammal", "Джамаль", "TN", "788", "16", "", "", "", "35.62231", "10.75696", "Africa/Tunis"),
("2470384", "Houmt Souk", "Хумт-Сук", "TN", "788", "28", "", "", "", "33.87576", "10.85745", "Africa/Tunis"),
("2470579", "Hammam Sousse", "", "TN", "788", "23", "", "", "", "35.8609", "10.60313", "Africa/Tunis"),
("2470588", "Hammam-Lif", "Хаммам-Лиф", "TN", "788", "36", "", "", "", "36.72866", "10.34163", "Africa/Tunis"),
("2470656", "La Goulette", "", "TN", "788", "36", "", "", "", "36.81806", "10.305", "Africa/Tunis"),
("2471287", "Douz", "Дуз", "TN", "788", "31", "", "", "", "33.46632", "9.0203", "Africa/Tunis"),
("2471475", "Dawwar Tinjah", "", "TN", "788", "18", "", "", "", "37.16667", "9.75", "Africa/Tunis"),
("2471637", "Dar Chabanne", "", "TN", "788", "19", "", "", "", "36.46798", "10.75167", "Africa/Tunis"),
("2472479", "Ben Arous", "", "TN", "788", "27", "", "", "", "36.75306", "10.21889", "Africa/Tunis"),
("2472706", "Bizerte", "Бизерта", "TN", "788", "18", "", "", "", "37.27442", "9.87391", "Africa/Tunis"),
("2472722", "Beni Khiar", "", "TN", "788", "19", "", "", "", "36.46917", "10.78222", "Africa/Tunis"),
("2472774", "Beja", "Беджа", "TN", "788", "17", "", "", "", "36.72564", "9.18169", "Africa/Tunis"),
("2472833", "Zouila", "", "TN", "788", "15", "", "", "", "35.50056", "11.06056", "Africa/Tunis"),
("2473229", "Chebba", "", "TN", "788", "15", "", "", "", "35.23722", "11.115", "Africa/Tunis"),
("2473247", "Ariana", "", "TN", "788", "38", "", "", "", "36.86012", "10.19337", "Africa/Tunis"),
("2473257", "Ar Rudayyif", "", "TN", "788", "30", "", "", "", "34.3827", "8.15549", "Africa/Tunis"),
("2473420", "Al Wardanin", "", "TN", "788", "16", "", "", "", "35.70915", "10.67397", "Africa/Tunis"),
("2473449", "Kairouan", "Кайруан", "TN", "788", "03", "", "", "", "35.6781", "10.09633", "Africa/Tunis"),
("2473457", "Kasserine", "Кассерин", "TN", "788", "02", "", "", "", "35.16758", "8.83651", "Africa/Tunis"),
("2473470", "Al Qarmadah", "", "TN", "788", "32", "", "", "", "34.75", "10.78333", "Africa/Tunis"),
("2473493", "Monastir", "Монастир", "TN", "788", "16", "", "", "", "35.77799", "10.82617", "Africa/Tunis"),
("2473499", "La Mohammedia", "", "TN", "788", "36", "", "", "", "36.67446", "10.15633", "Africa/Tunis"),
("2473517", "Al Metlaoui", "", "TN", "788", "30", "", "", "", "34.32081", "8.40158", "Africa/Tunis"),
("2473540", "Al Marsa", "", "TN", "788", "36", "", "", "", "36.87818", "10.32466", "Africa/Tunis"),
("2473572", "Mahdia", "Махдия", "TN", "788", "15", "", "", "", "35.50472", "11.06222", "Africa/Tunis"),
("2473634", "El Kef", "Эль-Кеф", "TN", "788", "14", "", "", "", "36.17424", "8.70486", "Africa/Tunis"),
("2473654", "El Jem", "Эль Джем", "TN", "788", "15", "", "", "", "35.3", "10.71667", "Africa/Tunis"),
("2473744", "Al Hammamat", "Хаммамет", "TN", "788", "19", "", "", "", "36.4", "10.61667", "Africa/Tunis"),
("2473747", "El Hamma", "Эль-Хамма", "TN", "788", "29", "", "", "", "33.89152", "9.79629", "Africa/Tunis"),
("2473826", "Al Baqalitah", "", "TN", "788", "16", "", "", "", "35.61739", "10.99466", "Africa/Tunis"),
("2473876", "Al `Aliyah", "Эль-Алия", "TN", "788", "18", "", "", "", "37.1691", "10.03478", "Africa/Tunis"),
("2473913", "Akouda", "", "TN", "788", "23", "", "", "", "35.8691", "10.5653", "Africa/Tunis"),
("2581754", "Douane", "", "TN", "788", "19", "", "", "", "36.44766", "10.7557", "Africa/Tunis"),
("296173", "Yuksekova", "", "TR", "792", "70", "", "", "", "37.57362", "44.28716", "Europe/Istanbul"),
("296562", "Yozgat", "Йозгат", "TR", "792", "66", "", "", "", "39.82", "34.80444", "Europe/Istanbul"),
("296832", "Yesilli", "", "TR", "792", "72", "", "", "", "37.3405", "40.82558", "Europe/Istanbul"),
("296852", "Erzin", "Эрзин", "TR", "792", "31", "", "", "", "36.95589", "36.2", "Europe/Istanbul"),
("296895", "Yerkoy", "", "TR", "792", "66", "", "", "", "39.63806", "34.46722", "Europe/Istanbul"),
("297090", "Didim", "Дидимы", "TR", "792", "09", "8632405", "", "", "37.38496", "27.25643", "Europe/Istanbul"),
("297564", "Yatagan", "", "TR", "792", "48", "", "", "", "37.34026", "28.14279", "Europe/Istanbul"),
("297789", "Yalvac", "Ялвач", "TR", "792", "33", "", "", "", "38.29556", "31.17778", "Europe/Istanbul"),
("297917", "Yahyali", "Яхьялы", "TR", "792", "38", "", "", "", "38.10228", "35.35704", "Europe/Istanbul"),
("298033", "Viransehir", "Вираншехире", "TR", "792", "63", "", "", "", "37.23528", "39.76306", "Europe/Istanbul"),
("298088", "Varto", "", "TR", "792", "49", "", "", "", "39.17321", "41.45593", "Europe/Istanbul"),
("298117", "Van", "Ван", "TR", "792", "65", "", "", "", "38.49239", "43.38311", "Europe/Istanbul"),
("298230", "Cimin", "", "TR", "792", "24", "", "", "", "39.71011", "39.70213", "Europe/Istanbul"),
("298299", "Usak", "Ушак", "TR", "792", "64", "", "", "", "38.67351", "29.4058", "Europe/Istanbul"),
("298316", "Urla", "Урла", "TR", "792", "35", "", "", "", "38.32292", "26.76403", "Europe/Istanbul"),
("298326", "Urgub", "", "TR", "792", "50", "", "", "", "38.6296", "34.91198", "Europe/Istanbul"),
("298333", "Sanliurfa", "Эдесса", "TR", "792", "63", "", "", "", "37.16708", "38.79392", "Europe/Istanbul"),
("298806", "Turgutlu", "", "TR", "792", "45", "", "", "", "38.49533", "27.6997", "Europe/Istanbul"),
("298846", "Tunceli", "Тунджели", "TR", "792", "62", "", "", "", "39.10829", "39.54711", "Europe/Istanbul"),
("298935", "Torbali", "Торбалы", "TR", "792", "35", "", "", "", "38.1519", "27.36223", "Europe/Istanbul"),
("299137", "Tire", "", "TR", "792", "35", "", "", "", "38.08877", "27.73508", "Europe/Istanbul"),
("299445", "Tekirova", "Текирова", "TR", "792", "07", "", "", "", "36.5017", "30.52723", "Europe/Istanbul"),
("299545", "Tavsanli", "", "TR", "792", "43", "", "", "", "39.54237", "29.49866", "Europe/Istanbul"),
("299582", "Tatvan", "Татван", "TR", "792", "13", "", "", "", "38.50667", "42.28167", "Europe/Istanbul"),
("299817", "Tarsus", "Тарсус", "TR", "792", "32", "", "", "", "36.91876", "34.8784", "Europe/Istanbul"),
("299900", "Talas", "Талас", "TR", "792", "38", "", "", "", "38.6908", "35.5538", "Europe/Istanbul"),
("300058", "Susurluk", "", "TR", "792", "10", "", "", "", "39.91361", "28.15778", "Europe/Istanbul"),
("300075", "Suruc", "Суруч", "TR", "792", "63", "", "", "", "36.97614", "38.42495", "Europe/Istanbul"),
("300352", "Sorgun", "Соргуне", "TR", "792", "66", "", "", "", "39.81012", "35.18596", "Europe/Istanbul"),
("300371", "Soma", "Сомы", "TR", "792", "45", "", "", "", "39.18554", "27.60945", "Europe/Istanbul"),
("300377", "Solhan", "", "TR", "792", "12", "", "", "", "38.96338", "41.02931", "Europe/Istanbul"),
("300399", "Soeke", "Сок", "TR", "792", "09", "", "", "", "37.7482", "27.40614", "Europe/Istanbul"),
("300614", "Siverek", "Сивереке", "TR", "792", "63", "", "", "", "37.75502", "39.31667", "Europe/Istanbul"),
("300619", "Sivas", "Сивас", "TR", "792", "58", "", "", "", "39.74833", "37.01611", "Europe/Istanbul"),
("300640", "Sirnak", "Ширнак", "TR", "792", "80", "", "", "", "37.52278", "42.45944", "Europe/Istanbul"),
("300791", "Simav", "", "TR", "792", "43", "", "", "", "39.0882", "28.97767", "Europe/Istanbul"),
("300796", "Silvan", "Сильван", "TR", "792", "21", "", "", "", "38.14194", "41.00806", "Europe/Istanbul"),
("300797", "Silopi", "Силопи", "TR", "792", "80", "", "", "", "37.24972", "42.46944", "Europe/Istanbul"),
("300808", "Silifke", "Силифке", "TR", "792", "32", "", "", "", "36.37778", "33.93444", "Europe/Istanbul"),
("300822", "Siirt", "Сиирт", "TR", "792", "74", "", "", "", "37.93262", "41.94025", "Europe/Istanbul"),
("301010", "Seydisehir", "", "TR", "792", "71", "", "", "", "37.41926", "31.84527", "Europe/Istanbul"),
("301089", "Serinyol", "", "TR", "792", "31", "", "", "", "36.36139", "36.21361", "Europe/Istanbul"),
("301101", "Serik", "Серик", "TR", "792", "07", "", "", "", "36.91694", "31.09889", "Europe/Istanbul"),
("301116", "Sereflikochisar", "", "TR", "792", "68", "", "", "", "38.93925", "33.5386", "Europe/Istanbul"),
("301172", "Senirkent", "", "TR", "792", "33", "", "", "", "38.10444", "30.54861", "Europe/Istanbul"),
("301209", "Semdinli", "", "TR", "792", "70", "", "", "", "37.30514", "44.5742", "Europe/Istanbul"),
("301256", "Selcuk", "Сельчук", "TR", "792", "35", "", "", "", "37.95137", "27.36849", "Europe/Istanbul"),
("301350", "Seferihisar", "", "TR", "792", "35", "7732732", "", "", "38.19686", "26.83902", "Europe/Istanbul"),
("301537", "Sarkisla", "", "TR", "792", "58", "", "", "", "39.35186", "36.40976", "Europe/Istanbul"),
("301539", "Sarkikaraagac", "", "TR", "792", "33", "", "", "", "38.07944", "31.36639", "Europe/Istanbul"),
("301827", "Saraykoy", "", "TR", "792", "20", "", "", "", "37.92448", "28.92516", "Europe/Istanbul"),
("301911", "Sandikli", "Сандикли", "TR", "792", "03", "", "", "", "38.46472", "30.26946", "Europe/Istanbul"),
("302043", "Salihli", "", "TR", "792", "45", "", "", "", "38.48258", "28.14774", "Europe/Istanbul"),
("302355", "Reyhanli", "Рейханлы", "TR", "792", "31", "", "", "", "36.26917", "36.56722", "Europe/Istanbul"),
("302525", "Polatli", "", "TR", "792", "68", "", "", "", "39.57716", "32.14132", "Europe/Istanbul"),
("302800", "Pazarcik", "Пазарджик", "TR", "792", "46", "", "", "", "37.48685", "37.29961", "Europe/Istanbul"),
("302819", "Patnos", "", "TR", "792", "04", "", "", "", "39.23361", "42.86344", "Europe/Istanbul"),
("302824", "Pasinler", "", "TR", "792", "25", "", "", "", "39.98031", "41.67635", "Europe/Istanbul"),
("303195", "Osmaniye", "Османие", "TR", "792", "91", "", "", "", "37.07417", "36.24778", "Europe/Istanbul"),
("303290", "Ortakoy", "", "TR", "792", "75", "", "", "", "38.73728", "34.03866", "Europe/Istanbul"),
("303354", "Ortaca", "", "TR", "792", "48", "", "", "", "36.82944", "28.77083", "Europe/Istanbul"),
("303700", "Hypaepa", "", "TR", "792", "35", "", "", "", "38.2278", "27.96955", "Europe/Istanbul"),
("303750", "Nusaybin", "Нузайбин", "TR", "792", "72", "", "", "", "37.0778", "41.2178", "Europe/Istanbul"),
("303798", "Nizip", "Низипе", "TR", "792", "83", "", "", "", "37.00972", "37.79417", "Europe/Istanbul"),
("303827", "Nigde", "Нигде", "TR", "792", "73", "", "", "", "37.96583", "34.67935", "Europe/Istanbul"),
("303831", "Nevsehir", "Невшехир", "TR", "792", "50", "", "", "", "38.625", "34.71222", "Europe/Istanbul"),
("303873", "Nazilli", "Назилли", "TR", "792", "09", "", "", "", "37.91631", "28.32225", "Europe/Istanbul"),
("304013", "Mut", "", "TR", "792", "32", "", "", "", "36.64389", "33.43885", "Europe/Istanbul"),
("304081", "Mus", "Муш", "TR", "792", "49", "", "", "", "38.74525", "41.50693", "Europe/Istanbul"),
("304184", "Mugla", "Мугла", "TR", "792", "48", "", "", "", "37.21807", "28.3665", "Europe/Istanbul"),
("304196", "Mucur", "", "TR", "792", "40", "", "", "", "39.06147", "34.38286", "Europe/Istanbul"),
("304355", "Milas", "Милас", "TR", "792", "48", "", "", "", "37.31639", "27.78389", "Europe/Istanbul"),
("304382", "Midyat", "Мидьят", "TR", "792", "72", "", "", "", "37.4247", "41.33934", "Europe/Istanbul"),
("304531", "Mercin", "Мерсин", "TR", "792", "32", "", "", "", "36.79526", "34.61792", "Europe/Istanbul"),
("304612", "Menemen", "Менемен", "TR", "792", "35", "", "", "", "38.60754", "27.06938", "Europe/Istanbul"),
("304782", "Marmaris", "Мармарис", "TR", "792", "48", "7732942", "", "", "36.855", "28.27417", "Europe/Istanbul"),
("304797", "Mardin", "Мардин", "TR", "792", "72", "441866", "", "", "37.31309", "40.74357", "Europe/Istanbul"),
("304827", "Manisa", "Маниса", "TR", "792", "45", "", "", "", "38.61202", "27.42646", "Europe/Istanbul"),
("304854", "Manavgat", "Манавгат", "TR", "792", "07", "7732193", "", "", "36.78667", "31.44306", "Europe/Istanbul"),
("304916", "Malazgirt", "", "TR", "792", "49", "", "", "", "39.14265", "42.54008", "Europe/Istanbul"),
("304922", "Malatya", "Малатья", "TR", "792", "44", "", "", "", "38.35018", "38.31667", "Europe/Istanbul"),
("304964", "Mahmutlar", "", "TR", "792", "07", "7732185", "", "", "36.49463", "32.09085", "Europe/Istanbul"),
("305089", "Lice", "", "TR", "792", "21", "", "", "", "38.45917", "40.6475", "Europe/Istanbul"),
("305268", "Kutahya", "Кютахья", "TR", "792", "43", "", "", "", "39.42417", "29.98333", "Europe/Istanbul"),
("305359", "Kusadasi", "Кушадасы", "TR", "792", "09", "", "", "", "37.85562", "27.2566", "Europe/Istanbul"),
("305532", "Kurtalan", "", "TR", "792", "74", "", "", "", "37.92717", "41.70282", "Europe/Istanbul"),
("305680", "Beykonak", "", "TR", "792", "07", "", "", "", "36.32573", "30.30302", "Europe/Istanbul"),
("305742", "Kulu", "", "TR", "792", "71", "", "", "", "39.09514", "33.07989", "Europe/Istanbul"),
("305750", "Kulp", "", "TR", "792", "21", "", "", "", "38.49722", "41.01222", "Europe/Istanbul"),
("305810", "Kula", "Кул", "TR", "792", "45", "7910589", "", "", "38.54726", "28.64976", "Europe/Istanbul"),
("306041", "Kozluk", "", "TR", "792", "76", "", "", "", "38.19383", "41.48853", "Europe/Istanbul"),
("306112", "Kozan", "", "TR", "792", "81", "", "", "", "37.45517", "35.81573", "Europe/Istanbul"),
("306207", "Kovancilar", "", "TR", "792", "23", "", "", "", "38.72139", "39.86806", "Europe/Istanbul"),
("306474", "Korkuteli", "Коркутели", "TR", "792", "07", "", "", "", "37.06498", "30.19565", "Europe/Istanbul"),
("306571", "Konya", "Конья", "TR", "792", "71", "", "", "", "37.87135", "32.48464", "Europe/Istanbul"),
("307084", "Kiziltepe", "Кызылтепе", "TR", "792", "72", "", "", "", "37.19319", "40.58799", "Europe/Istanbul"),
("307211", "Serinhisar", "", "TR", "792", "20", "", "", "", "37.58104", "29.26639", "Europe/Istanbul"),
("307515", "Kirsehir", "Кыршехир", "TR", "792", "40", "", "", "", "39.14583", "34.16389", "Europe/Istanbul"),
("307623", "Kirkagac", "", "TR", "792", "45", "", "", "", "39.10638", "27.66925", "Europe/Istanbul"),
("307654", "Kirikkale", "Кырыккале", "TR", "792", "79", "", "", "", "39.84528", "33.50639", "Europe/Istanbul"),
("307657", "Kirikhan", "", "TR", "792", "31", "", "", "", "36.49939", "36.35755", "Europe/Istanbul"),
("307864", "Kilis", "Килис", "TR", "792", "90", "", "", "", "36.71611", "37.115", "Europe/Istanbul"),
("308024", "Keskin", "Кескин", "TR", "792", "79", "", "", "", "39.67306", "33.61361", "Europe/Istanbul"),
("308220", "Kemer", "Кемер", "TR", "792", "07", "", "", "", "36.59778", "30.56056", "Europe/Istanbul"),
("308224", "Kemalpasa", "Кемальпаша", "TR", "792", "35", "", "", "", "38.42621", "27.41731", "Europe/Istanbul"),
("308464", "Kayseri", "Кайсери", "TR", "792", "38", "", "", "", "38.73222", "35.48528", "Europe/Istanbul"),
("309415", "Karapinar", "", "TR", "792", "71", "", "", "", "37.71596", "33.55064", "Europe/Istanbul"),
("309527", "Karaman", "Караман", "TR", "792", "78", "", "", "", "37.18111", "33.215", "Europe/Istanbul"),
("309647", "Agri", "Агры", "TR", "792", "04", "", "", "", "39.71944", "43.05139", "Europe/Istanbul"),
("309663", "Karakocan", "Каракоджана", "TR", "792", "23", "", "", "", "38.95583", "40.03861", "Europe/Istanbul"),
("310004", "Karacoban", "", "TR", "792", "25", "", "", "", "39.34919", "42.11239", "Europe/Istanbul"),
("310641", "Kaman", "Каман", "TR", "792", "40", "", "", "", "39.3575", "33.72389", "Europe/Istanbul"),
("310855", "Kahta", "Кахта", "TR", "792", "02", "", "", "", "37.78552", "38.6237", "Europe/Istanbul"),
("310859", "Kahramanmaras", "Кахраманмараш", "TR", "792", "46", "", "", "", "37.5847", "36.9264", "Europe/Istanbul"),
("310892", "Kadirli", "", "TR", "792", "81", "", "", "", "37.37389", "36.09611", "Europe/Istanbul"),
("310907", "Kadinhani", "", "TR", "792", "71", "", "", "", "38.23972", "32.21139", "Europe/Istanbul"),
("311046", "Izmir", "Измир", "TR", "792", "35", "", "", "", "38.41273", "27.13838", "Europe/Istanbul"),
("311073", "Isparta", "Испарта", "TR", "792", "33", "", "", "", "37.76444", "30.55222", "Europe/Istanbul"),
("311111", "Iskenderun", "Искендерун", "TR", "792", "31", "", "", "", "36.58718", "36.17347", "Europe/Istanbul"),
("311314", "Incirliova", "", "TR", "792", "09", "", "", "", "37.85222", "27.72361", "Europe/Istanbul"),
("311453", "Imamoglu", "", "TR", "792", "81", "", "", "", "37.26506", "35.65717", "Europe/Istanbul"),
("311553", "Ilgin", "", "TR", "792", "71", "", "", "", "38.27917", "31.91389", "Europe/Istanbul"),
("311665", "Igdir", "Игдир", "TR", "792", "88", "", "", "", "39.92371", "44.045", "Europe/Istanbul"),
("311704", "Idil", "Идиль", "TR", "792", "80", "", "", "", "37.34114", "41.8895", "Europe/Istanbul"),
("312024", "Hizan", "", "TR", "792", "13", "", "", "", "38.22572", "42.42776", "Europe/Istanbul"),
("312114", "Hinis", "", "TR", "792", "25", "", "", "", "39.3606", "41.70222", "Europe/Istanbul"),
("312134", "Hilvan", "", "TR", "792", "63", "", "", "", "37.58686", "38.95505", "Europe/Istanbul"),
("312899", "Hadim", "Хадим", "TR", "792", "71", "", "", "", "36.98776", "32.45674", "Europe/Istanbul"),
("313013", "Hacilar", "", "TR", "792", "38", "", "", "", "38.64631", "35.44937", "Europe/Istanbul"),
("313331", "Guroymak", "", "TR", "792", "13", "", "", "", "38.57739", "42.02811", "Europe/Istanbul"),
("314136", "Golbasi", "", "TR", "792", "02", "", "", "", "37.78361", "37.63667", "Europe/Istanbul"),
("314188", "Goksun", "", "TR", "792", "46", "", "", "", "38.02096", "36.4973", "Europe/Istanbul"),
("314648", "Genc", "Генк", "TR", "792", "12", "", "", "", "38.75071", "40.56035", "Europe/Istanbul"),
("314665", "Gemerek", "", "TR", "792", "58", "", "", "", "39.18342", "36.07189", "Europe/Istanbul"),
("314716", "Gediz", "Гедиз", "TR", "792", "43", "", "", "", "39.04167", "29.41", "Europe/Istanbul"),
("314812", "Gazipasa", "", "TR", "792", "07", "", "", "", "36.26942", "32.31792", "Europe/Istanbul"),
("314830", "Gaziantep", "Газиантеп", "TR", "792", "83", "", "", "", "37.05944", "37.3825", "Europe/Istanbul"),
("314903", "Foca", "", "TR", "792", "35", "", "", "", "38.6703", "26.75656", "Europe/Istanbul"),
("314967", "Fethiye", "Фетхие", "TR", "792", "48", "7732940", "", "", "36.62167", "29.11639", "Europe/Istanbul"),
("315061", "Ezine", "", "TR", "792", "17", "", "", "", "39.78561", "26.34083", "Europe/Istanbul"),
("315202", "Eskisehir", "Эскишехир", "TR", "792", "26", "", "", "", "39.77667", "30.52056", "Europe/Istanbul"),
("315368", "Erzurum", "Эрзурум", "TR", "792", "25", "", "", "", "39.90861", "41.27694", "Europe/Istanbul"),
("315373", "Erzincan", "Эрзинджан", "TR", "792", "24", "", "", "", "39.75222", "39.49278", "Europe/Istanbul"),
("315401", "Ermenek", "", "TR", "792", "78", "", "", "", "36.64043", "32.89179", "Europe/Istanbul"),
("315468", "Ergani", "Эграни", "TR", "792", "21", "", "", "", "38.26533", "39.76212", "Europe/Istanbul"),
("315498", "Eregli", "Эрегли", "TR", "792", "71", "", "", "", "37.51333", "34.04672", "Europe/Istanbul"),
("315515", "Erdemli", "Эрдемли", "TR", "792", "32", "", "", "", "36.60498", "34.30836", "Europe/Istanbul"),
("315530", "Ercis", "", "TR", "792", "65", "", "", "", "39.02869", "43.35864", "Europe/Istanbul"),
("315621", "Emirdag", "", "TR", "792", "03", "", "", "", "39.01972", "31.15", "Europe/Istanbul"),
("315639", "Emet", "Эмет", "TR", "792", "43", "", "", "", "39.343", "29.25847", "Europe/Istanbul"),
("315697", "Elmali", "", "TR", "792", "07", "", "", "", "36.73583", "29.91775", "Europe/Istanbul"),
("315720", "Elmadag", "", "TR", "792", "68", "", "", "", "39.92083", "33.23083", "Europe/Istanbul"),
("315758", "Eleskirt", "", "TR", "792", "04", "", "", "", "39.80333", "42.67361", "Europe/Istanbul"),
("315795", "Elbistan", "Эльбистан", "TR", "792", "46", "", "", "", "38.20591", "37.1983", "Europe/Istanbul"),
("315808", "Elazig", "Элязыг", "TR", "792", "23", "", "", "", "38.67431", "39.22321", "Europe/Istanbul"),
("315905", "Egirdir", "", "TR", "792", "33", "", "", "", "37.87462", "30.85042", "Europe/Istanbul"),
("315985", "Edremit", "Эдремит", "TR", "792", "10", "", "", "", "39.59611", "27.02444", "Europe/Istanbul"),
("316102", "Dursunbey", "", "TR", "792", "10", "", "", "", "39.58596", "28.62568", "Europe/Istanbul"),
("316284", "Dortyol", "", "TR", "792", "31", "436927", "", "", "36.86158", "36.22885", "Europe/Istanbul"),
("316411", "Dogubayazit", "Догубаязит", "TR", "792", "04", "", "", "", "39.54694", "44.08417", "Europe/Istanbul"),
("316541", "Diyarbakir", "Диярбакыр", "TR", "792", "21", "", "", "", "37.91583", "40.21889", "Europe/Istanbul"),
("316542", "Diyadin", "", "TR", "792", "04", "", "", "", "39.54056", "43.67135", "Europe/Istanbul"),
("316634", "Dinar", "Динар", "TR", "792", "03", "", "", "", "38.065", "30.16557", "Europe/Istanbul"),
("316795", "Develi", "", "TR", "792", "38", "", "", "", "38.39056", "35.49222", "Europe/Istanbul"),
("317109", "Denizli", "Денизли", "TR", "792", "20", "", "", "", "37.77417", "29.0875", "Europe/Istanbul"),
("317241", "Demirci", "", "TR", "792", "45", "", "", "", "39.04607", "28.65889", "Europe/Istanbul"),
("317587", "Dargecit", "Даргечит", "TR", "792", "72", "", "", "", "37.54545", "41.71966", "Europe/Istanbul"),
("317588", "Darende", "Даренде", "TR", "792", "44", "", "", "", "38.54583", "37.50583", "Europe/Istanbul"),
("317844", "Cumra", "", "TR", "792", "71", "", "", "", "37.5732", "32.77446", "Europe/Istanbul"),
("317851", "Menderes", "Мендерес", "TR", "792", "35", "", "", "", "38.24963", "27.13429", "Europe/Istanbul"),
("318137", "Hakkari", "Хаккари", "TR", "792", "70", "", "", "", "37.57444", "43.74083", "Europe/Istanbul"),
("318253", "Cizre", "Джизре", "TR", "792", "80", "", "", "", "37.33024", "42.18484", "Europe/Istanbul"),
("318372", "Cine", "", "TR", "792", "09", "", "", "", "37.61167", "28.06139", "Europe/Istanbul"),
("318668", "Ceylanpinar", "", "TR", "792", "63", "", "", "", "36.84722", "40.05", "Europe/Istanbul"),
("318675", "Ceyhan", "Джейхан", "TR", "792", "81", "", "", "", "37.02472", "35.8175", "Europe/Istanbul"),
("318755", "Cesme", "Чешме", "TR", "792", "35", "", "", "", "38.32278", "26.30639", "Europe/Istanbul"),
("318766", "Cermik", "", "TR", "792", "21", "", "", "", "38.13613", "39.44929", "Europe/Istanbul"),
("319104", "Cay", "Кей", "TR", "792", "03", "", "", "", "38.59167", "31.02861", "Europe/Istanbul"),
("320004", "Caglayancerit", "", "TR", "792", "46", "", "", "", "37.74959", "37.29622", "Europe/Istanbul"),
("320369", "Burhaniye", "", "TR", "792", "10", "", "", "", "39.50041", "26.97269", "Europe/Istanbul"),
("320392", "Burdur", "Бурдур", "TR", "792", "15", "", "", "", "37.72028", "30.29083", "Europe/Istanbul"),
("320448", "Bulanik", "", "TR", "792", "49", "", "", "", "39.09292", "42.27031", "Europe/Istanbul"),
("320533", "Bucak", "Буджак", "TR", "792", "15", "", "", "", "37.45917", "30.595", "Europe/Istanbul"),
("320552", "Bozyazi", "", "TR", "792", "32", "", "", "", "36.1082", "32.96113", "Europe/Istanbul"),
("320557", "Bozuyuk", "", "TR", "792", "11", "", "", "", "39.90778", "30.03667", "Europe/Istanbul"),
("320581", "Bozova", "Бозова", "TR", "792", "63", "", "", "", "37.3625", "38.52667", "Europe/Istanbul"),
("320871", "Bor", "Бор", "TR", "792", "73", "", "", "", "37.89056", "34.55889", "Europe/Istanbul"),
("320879", "Bolvadin", "", "TR", "792", "03", "", "", "", "38.71111", "31.04861", "Europe/Istanbul"),
("320995", "Bodrum", "Бодрум", "TR", "792", "48", "7733242", "", "", "37.03833", "27.42917", "Europe/Istanbul"),
("321025", "Bitlis", "Битлис", "TR", "792", "13", "", "", "", "38.40115", "42.10784", "Europe/Istanbul"),
("321031", "Bismil", "", "TR", "792", "21", "", "", "", "37.84861", "40.66583", "Europe/Istanbul"),
("321062", "Birecik", "Биреджик", "TR", "792", "63", "", "", "", "37.02944", "37.99028", "Europe/Istanbul"),
("321082", "Bingol", "Бингол", "TR", "792", "12", "", "", "", "38.88472", "40.49389", "Europe/Istanbul"),
("321136", "Bigadic", "", "TR", "792", "10", "", "", "", "39.3925", "28.13111", "Europe/Istanbul"),
("321191", "Beysehir", "Бейшехир", "TR", "792", "71", "", "", "", "37.67735", "31.72458", "Europe/Istanbul"),
("321337", "Besni", "Бесни", "TR", "792", "02", "", "", "", "37.69278", "37.86111", "Europe/Istanbul"),
("321426", "Bergama", "Пергам", "TR", "792", "35", "7732716", "", "", "39.12074", "27.18052", "Europe/Istanbul"),
("321572", "Belen", "Белен", "TR", "792", "31", "", "", "", "36.48911", "36.22331", "Europe/Istanbul"),
("321580", "Belek", "Белек", "TR", "792", "07", "", "", "", "36.86278", "31.05556", "Europe/Istanbul"),
("321786", "Bayindir", "Байиндыр", "TR", "792", "35", "", "", "", "38.21741", "27.64744", "Europe/Istanbul"),
("321836", "Batman", "Батман", "TR", "792", "76", "", "", "", "37.88738", "41.13221", "Europe/Istanbul"),
("321929", "Baskil", "", "TR", "792", "23", "", "", "", "38.56791", "38.82382", "Europe/Istanbul"),
("322051", "Banaz", "", "TR", "792", "64", "", "", "", "38.73707", "29.75194", "Europe/Istanbul"),
("322165", "Balikesir", "Балыкесир", "TR", "792", "10", "", "", "", "39.64917", "27.88611", "Europe/Istanbul"),
("322391", "Bahce", "", "TR", "792", "81", "", "", "", "37.19724", "36.57658", "Europe/Istanbul"),
("322673", "Ayvalik", "Айвалык", "TR", "792", "10", "", "", "", "39.31905", "26.6954", "Europe/Istanbul"),
("322830", "Aydin", "Айдын", "TR", "792", "09", "", "", "", "37.84501", "27.83963", "Europe/Istanbul"),
("323094", "Askale", "", "TR", "792", "25", "", "", "", "39.92083", "40.695", "Europe/Istanbul"),
("323777", "Antalya", "Анталия", "TR", "792", "07", "", "", "", "36.90812", "30.69556", "Europe/Istanbul"),
("323779", "Hatay", "Антиохия", "TR", "792", "31", "438417", "", "", "36.20655", "36.15722", "Europe/Istanbul"),
("323786", "Ankara", "Анкара", "TR", "792", "68", "", "", "", "39.91987", "32.85427", "Europe/Istanbul"),
("323828", "Anamur", "Анамур", "TR", "792", "32", "", "", "", "36.07508", "32.83691", "Europe/Istanbul"),
("324106", "Aliaga", "Алиага", "TR", "792", "35", "", "", "", "38.79975", "26.97203", "Europe/Istanbul"),
("324172", "Alasehir", "Алашехир", "TR", "792", "45", "", "", "", "38.35083", "28.51718", "Europe/Istanbul"),
("324190", "Alanya", "Аланья", "TR", "792", "07", "7732185", "", "", "36.54375", "31.99982", "Europe/Istanbul"),
("324490", "Aksehir", "", "TR", "792", "71", "", "", "", "38.3575", "31.41639", "Europe/Istanbul"),
("324496", "Aksaray", "Аксарай", "TR", "792", "75", "", "", "", "38.37255", "34.02537", "Europe/Istanbul"),
("324698", "Akhisar", "Акхисар", "TR", "792", "45", "", "", "", "38.91852", "27.84006", "Europe/Istanbul"),
("324768", "Akdagmadeni", "", "TR", "792", "66", "", "", "", "39.66028", "35.88361", "Europe/Istanbul"),
("324944", "Akcakale", "", "TR", "792", "63", "", "", "", "36.71111", "38.9475", "Europe/Istanbul"),
("325103", "Ahlat", "Ахлат", "TR", "792", "13", "", "", "", "38.75178", "42.48135", "Europe/Istanbul"),
("325303", "Afyonkarahisar", "Афьонкарахисар", "TR", "792", "03", "", "", "", "38.75667", "30.54333", "Europe/Istanbul"),
("325304", "Afsin", "", "TR", "792", "46", "", "", "", "38.24769", "36.91399", "Europe/Istanbul"),
("325330", "Adiyaman", "Адыяман", "TR", "792", "02", "", "", "", "37.76441", "38.27629", "Europe/Istanbul"),
("325336", "Adilcevaz", "Адилджеваз", "TR", "792", "13", "", "", "", "38.80389", "42.73422", "Europe/Istanbul"),
("325363", "Adana", "Адана", "TR", "792", "81", "", "", "", "37.00167", "35.32889", "Europe/Istanbul"),
("438400", "Denizciler", "", "TR", "792", "31", "", "", "", "36.64951", "36.22956", "Europe/Istanbul"),
("442301", "Batikent", "", "TR", "792", "68", "", "", "", "39.96833", "32.73083", "Europe/Istanbul"),
("447273", "Dalaman", "", "TR", "792", "48", "", "", "", "36.76591", "28.8028", "Europe/Istanbul"),
("737022", "Zonguldak", "Зонгулдак", "TR", "792", "85", "", "", "", "41.45139", "31.79305", "Europe/Istanbul"),
("737054", "Zile", "Зил", "TR", "792", "60", "", "", "", "40.30306", "35.88639", "Europe/Istanbul"),
("737071", "Zeytinburnu", "", "TR", "792", "34", "", "", "", "40.99441", "28.90417", "Europe/Istanbul"),
("737421", "Yomra", "", "TR", "792", "61", "", "", "", "40.95411", "39.86405", "Europe/Istanbul"),
("737611", "Yenisehir", "", "TR", "792", "16", "", "", "", "40.26444", "29.65306", "Europe/Istanbul"),
("737961", "Korfez", "", "TR", "792", "41", "", "", "", "40.76704", "29.78275", "Europe/Istanbul"),
("738025", "Yalova", "Ялова", "TR", "792", "92", "", "", "", "40.65502", "29.27693", "Europe/Istanbul"),
("738064", "Yakuplu", "", "TR", "792", "34", "", "", "", "40.98894", "28.67582", "Europe/Istanbul"),
("738167", "Vezirkopru", "Везиркепрю", "TR", "792", "55", "", "", "", "41.14361", "35.45472", "Europe/Istanbul"),
("738228", "Vakfikebir", "", "TR", "792", "61", "", "", "", "41.04583", "39.27639", "Europe/Istanbul"),
("738251", "Uzun Keupru", "Узункепрю", "TR", "792", "22", "", "", "", "41.26598", "26.6885", "Europe/Istanbul"),
("738329", "UEskuedar", "Ускюдар", "TR", "792", "34", "", "", "", "41.02252", "29.02369", "Europe/Istanbul"),
("738349", "Unieh", "Унье", "TR", "792", "52", "", "", "", "41.13139", "37.2825", "Europe/Istanbul"),
("738377", "Umraniye", "", "TR", "792", "34", "", "", "", "41.01643", "29.12476", "Europe/Istanbul"),
("738618", "Turhal", "Турхал", "TR", "792", "60", "", "", "", "40.3875", "36.08111", "Europe/Istanbul"),
("738648", "Trabzon", "Трабзон", "TR", "792", "61", "", "", "", "41.005", "39.72694", "Europe/Istanbul"),
("738662", "Tosya", "Тося", "TR", "792", "37", "", "", "", "41.01545", "34.04013", "Europe/Istanbul"),
("738743", "Tokat", "Токат", "TR", "792", "60", "", "", "", "40.31389", "36.55444", "Europe/Istanbul"),
("738753", "Tirebolu", "Тиреболу", "TR", "792", "28", "", "", "", "41.00694", "38.81389", "Europe/Istanbul"),
("738803", "Terme", "Терме", "TR", "792", "55", "", "", "", "41.20917", "36.97389", "Europe/Istanbul"),
("738858", "Tepecik", "", "TR", "792", "34", "", "", "", "41.02931", "28.54978", "Europe/Istanbul"),
("738907", "Tekkekoy", "Теккекей", "TR", "792", "55", "", "", "", "41.21167", "36.46", "Europe/Istanbul"),
("738927", "Tekirdag", "Текирдаг", "TR", "792", "59", "", "", "", "40.97801", "27.50852", "Europe/Istanbul"),
("739015", "Tasova", "Ташова", "TR", "792", "05", "", "", "", "40.75972", "36.3225", "Europe/Istanbul"),
("739061", "Taskopru", "", "TR", "792", "37", "", "", "", "41.5098", "34.21414", "Europe/Istanbul"),
("739209", "Susehri", "Сушехри", "TR", "792", "58", "", "", "", "40.16444", "38.08667", "Europe/Istanbul"),
("739215", "Surmene", "Сюрмене", "TR", "792", "61", "", "", "", "40.91258", "40.11676", "Europe/Istanbul"),
("739236", "Sungurlu", "Сунгурлу", "TR", "792", "19", "", "", "", "40.1675", "34.37389", "Europe/Istanbul"),
("739251", "Suluova", "", "TR", "792", "05", "", "", "", "40.83128", "35.64788", "Europe/Istanbul"),
("739549", "Sisli", "", "TR", "792", "34", "", "", "", "41.06046", "28.98717", "Europe/Istanbul"),
("739600", "Sinop", "Синоп", "TR", "792", "57", "", "", "", "42.02683", "35.16252", "Europe/Istanbul"),
("739634", "Silivri", "", "TR", "792", "34", "", "", "", "41.07393", "28.24644", "Europe/Istanbul"),
("739914", "Sebinkarahisar", "Шебинкарахисар", "TR", "792", "28", "", "", "", "40.28833", "38.42361", "Europe/Istanbul"),
("740088", "Sarikamis", "Сарыкамыш", "TR", "792", "84", "", "", "", "40.33806", "42.57306", "Europe/Istanbul"),
("740230", "Sapanca", "", "TR", "792", "54", "7732953", "", "", "40.69141", "30.26738", "Europe/Istanbul"),
("740264", "Samsun", "Самсун", "TR", "792", "55", "", "", "", "41.28667", "36.33", "Europe/Istanbul"),
("740430", "Safranbolu", "Сафранболу", "TR", "792", "89", "", "", "", "41.25083", "32.69417", "Europe/Istanbul"),
("740483", "Rize", "Ризе", "TR", "792", "53", "", "", "", "41.02083", "40.52194", "Europe/Istanbul"),
("740881", "Osmaneli", "", "TR", "792", "11", "", "", "", "40.35722", "30.01417", "Europe/Istanbul"),
("740883", "Osmancik", "", "TR", "792", "19", "", "", "", "40.97818", "34.8047", "Europe/Istanbul"),
("741045", "Orhangazi", "", "TR", "792", "16", "", "", "", "40.48917", "29.30889", "Europe/Istanbul"),
("741100", "Ordu", "Орду", "TR", "792", "52", "", "", "", "40.98472", "37.87889", "Europe/Istanbul"),
("741160", "Oltu", "Олту", "TR", "792", "25", "", "", "", "40.54983", "42.00126", "Europe/Istanbul"),
("741240", "Of", "Оф", "TR", "792", "61", "", "", "", "40.94458", "40.26746", "Europe/Istanbul"),
("741304", "Niksar", "Никсар", "TR", "792", "60", "", "", "", "40.59167", "36.95167", "Europe/Istanbul"),
("741347", "Nallihan", "", "TR", "792", "68", "", "", "", "40.18593", "31.35179", "Europe/Istanbul"),
("741487", "Mudanya", "Муданьи", "TR", "792", "16", "7732334", "", "", "40.37528", "28.88222", "Europe/Istanbul"),
("741529", "Mimarsinan", "Мимарсинан", "TR", "792", "34", "", "", "", "41.0179", "28.56176", "Europe/Istanbul"),
("741609", "Merzifon", "Мерзифон", "TR", "792", "05", "", "", "", "40.87333", "35.46306", "Europe/Istanbul"),
("741763", "Maltepe", "", "TR", "792", "34", "", "", "", "40.93567", "29.15507", "Europe/Istanbul"),
("741771", "Malkara", "Малкара", "TR", "792", "59", "", "", "", "40.89", "26.90111", "Europe/Istanbul"),
("741855", "Luleburgaz", "", "TR", "792", "39", "", "", "", "41.40385", "27.35918", "Europe/Istanbul"),
("742238", "Kumru", "Кумру", "TR", "792", "52", "", "", "", "40.87444", "37.26389", "Europe/Istanbul"),
("742658", "Korgan", "Корган", "TR", "792", "52", "", "", "", "40.82472", "37.34667", "Europe/Istanbul"),
("742902", "Kocaali", "", "TR", "792", "54", "", "", "", "41.05336", "30.85278", "Europe/Istanbul"),
("743051", "Kizilcahamam", "", "TR", "792", "68", "", "", "", "40.46972", "32.65056", "Europe/Istanbul"),
("743166", "Kirklareli", "Кыркларели", "TR", "792", "39", "", "", "", "41.73508", "27.22521", "Europe/Istanbul"),
("743404", "Kestel", "", "TR", "792", "16", "", "", "", "40.19828", "29.21237", "Europe/Istanbul"),
("743439", "Kesan", "Кешан", "TR", "792", "22", "", "", "", "40.85583", "26.63028", "Europe/Istanbul"),
("743537", "Kelkit", "Келькит", "TR", "792", "69", "", "", "", "40.12978", "39.43607", "Europe/Istanbul"),
("743615", "Kazan", "", "TR", "792", "68", "", "", "", "40.23167", "32.68389", "Europe/Istanbul"),
("743818", "Kavakli", "Каваклы", "TR", "792", "34", "", "", "", "41.09258", "28.33172", "Europe/Istanbul"),
("743882", "Kastamonu", "Кастамону", "TR", "792", "37", "7732736", "", "", "41.37805", "33.77528", "Europe/Istanbul"),
("743952", "Kars", "Карс", "TR", "792", "84", "", "", "", "40.60199", "43.09495", "Europe/Istanbul"),
("744093", "Karasu", "Карасу", "TR", "792", "54", "", "", "", "41.07096", "30.78543", "Europe/Istanbul"),
("744168", "Karamursel", "", "TR", "792", "41", "", "", "", "40.69144", "29.61568", "Europe/Istanbul"),
("744537", "Karacabey", "Караджабей", "TR", "792", "16", "", "", "", "40.21323", "28.3612", "Europe/Istanbul"),
("744562", "Karabuk", "Карабюк", "TR", "792", "89", "", "", "", "41.20488", "32.62768", "Europe/Istanbul"),
("744873", "Kagizman", "Кагызман", "TR", "792", "84", "", "", "", "40.15669", "43.13424", "Europe/Istanbul"),
("745026", "Iznik", "Изник", "TR", "792", "16", "", "", "", "40.42861", "29.72111", "Europe/Istanbul"),
("745028", "Izmit", "Измит", "TR", "792", "41", "", "", "", "40.76694", "29.91694", "Europe/Istanbul"),
("745044", "Istanbul", "Стамбул", "TR", "792", "34", "", "", "", "41.01384", "28.94966", "Europe/Istanbul"),
("745076", "Iskilip", "", "TR", "792", "19", "", "", "", "40.73528", "34.47389", "Europe/Istanbul"),
("745169", "Inegol", "", "TR", "792", "16", "7732332", "", "", "40.07806", "29.51333", "Europe/Istanbul"),
("745527", "Horasan", "Хорасан", "TR", "792", "25", "", "", "", "40.04583", "42.17278", "Europe/Istanbul"),
("745530", "Hopa", "Хопа", "TR", "792", "08", "", "", "", "41.39046", "41.41966", "Europe/Istanbul"),
("745664", "Hendek", "", "TR", "792", "54", "", "", "", "40.79944", "30.74806", "Europe/Istanbul"),
("745697", "Hayrabolu", "", "TR", "792", "59", "", "", "", "41.21311", "27.10688", "Europe/Istanbul"),
("745714", "Havza", "Хавза", "TR", "792", "55", "", "", "", "40.97056", "35.66222", "Europe/Istanbul"),
("746232", "Gursu", "", "TR", "792", "16", "", "", "", "40.21876", "29.19487", "Europe/Istanbul"),
("746234", "Gurpinar", "Гюрпынар", "TR", "792", "34", "", "", "", "40.99256", "28.61428", "Europe/Istanbul"),
("746252", "Gurgentepe", "", "TR", "792", "52", "", "", "", "40.78833", "37.60167", "Europe/Istanbul"),
("746425", "Gumushkhane", "Гюмюшане", "TR", "792", "69", "", "", "", "40.46028", "39.48139", "Europe/Istanbul"),
("746565", "Gorele", "Гереле", "TR", "792", "28", "", "", "", "41.03083", "39.00306", "Europe/Istanbul"),
("746574", "Gonen", "Гонен", "TR", "792", "10", "", "", "", "40.1049", "27.65399", "Europe/Istanbul"),
("746666", "Geulzuk", "", "TR", "792", "41", "", "", "", "40.70324", "29.87216", "Europe/Istanbul"),
("746881", "Giresun", "Гиресун", "TR", "792", "28", "", "", "", "40.91698", "38.38741", "Europe/Istanbul"),
("746898", "Geyve", "", "TR", "792", "54", "", "", "", "40.5075", "30.2925", "Europe/Istanbul"),
("746940", "Gerede", "Гереде", "TR", "792", "14", "", "", "", "40.80083", "32.19694", "Europe/Istanbul"),
("746958", "Gemlik", "Гемлик", "TR", "792", "16", "", "", "", "40.43094", "29.15969", "Europe/Istanbul"),
("746983", "Gelibolu", "Гелиболу", "TR", "792", "17", "", "", "", "40.41028", "26.67083", "Europe/Istanbul"),
("747014", "Gebze", "Гебзе", "TR", "792", "41", "", "", "", "40.80276", "29.43068", "Europe/Istanbul"),
("747135", "Ferizli", "", "TR", "792", "54", "", "", "", "40.94082", "30.48583", "Europe/Istanbul"),
("747155", "Fatsa", "Фатса", "TR", "792", "52", "", "", "", "41.02778", "37.50139", "Europe/Istanbul"),
("747323", "Esenyurt", "", "TR", "792", "34", "", "", "", "41.02697", "28.67732", "Europe/Istanbul"),
("747340", "Esenler", "", "TR", "792", "34", "", "", "", "41.0435", "28.87619", "Europe/Istanbul"),
("747471", "Eregli", "Эрегли", "TR", "792", "85", "", "", "", "41.28262", "31.41806", "Europe/Istanbul"),
("747482", "Erdek", "", "TR", "792", "10", "", "", "", "40.3996", "27.79348", "Europe/Istanbul"),
("747489", "Erbaa", "Эрба", "TR", "792", "60", "", "", "", "40.66889", "36.5675", "Europe/Istanbul"),
("747538", "Eminoenue", "Эминёню", "TR", "792", "34", "", "", "", "41.01766", "28.97438", "Europe/Istanbul"),
("747712", "Edirne", "Эдирне", "TR", "792", "22", "", "", "", "41.67719", "26.55597", "Europe/Istanbul"),
("747764", "Duzce", "", "TR", "792", "93", "", "", "", "40.83889", "31.16389", "Europe/Istanbul"),
("748167", "Devrek", "", "TR", "792", "85", "", "", "", "41.21917", "31.95583", "Europe/Istanbul"),
("748870", "Cubuk", "", "TR", "792", "68", "", "", "", "40.23861", "33.03222", "Europe/Istanbul"),
("748879", "Corum", "Чорум", "TR", "792", "19", "", "", "", "40.54889", "34.95333", "Europe/Istanbul"),
("748893", "Corlu", "Чорлу", "TR", "792", "59", "", "", "", "41.15917", "27.8", "Europe/Istanbul"),
("749274", "Cerkezkoey", "", "TR", "792", "59", "", "", "", "41.28629", "27.99939", "Europe/Istanbul"),
("749279", "Cerkes", "", "TR", "792", "82", "", "", "", "40.81164", "32.89358", "Europe/Istanbul"),
("749502", "Cayeli", "", "TR", "792", "53", "", "", "", "41.09228", "40.72924", "Europe/Istanbul"),
("749508", "Caycuma", "", "TR", "792", "85", "", "", "", "41.42639", "32.07556", "Europe/Istanbul"),
("749644", "Catalca", "", "TR", "792", "34", "", "", "", "41.14324", "28.46154", "Europe/Istanbul"),
("749704", "Carsamba", "Чаршамба", "TR", "792", "55", "", "", "", "41.19889", "36.72194", "Europe/Istanbul"),
("749748", "Khanjarah", "Чанкыры", "TR", "792", "82", "", "", "", "40.59995", "33.6153", "Europe/Istanbul"),
("749780", "Canakkale", "Чанаккале", "TR", "792", "17", "", "", "", "40.14556", "26.40639", "Europe/Istanbul"),
("749795", "Can", "", "TR", "792", "17", "", "", "", "40.03328", "27.05236", "Europe/Istanbul"),
("750269", "Bursa", "Бурса", "TR", "792", "16", "7732338", "", "", "40.19266", "29.08403", "Europe/Istanbul"),
("750317", "Bulancak", "Буланджак", "TR", "792", "28", "", "", "", "40.93717", "38.22907", "Europe/Istanbul"),
("750468", "Boyabat", "", "TR", "792", "57", "", "", "", "41.46889", "34.76667", "Europe/Istanbul"),
("750516", "Bolu", "Болу", "TR", "792", "14", "", "", "", "40.73583", "31.60611", "Europe/Istanbul"),
("750598", "Bilecik", "Биледжик", "TR", "792", "11", "", "", "", "40.14192", "29.97932", "Europe/Istanbul"),
("750605", "Biga", "Биг", "TR", "792", "17", "", "", "", "40.22806", "27.24222", "Europe/Istanbul"),
("750637", "Beypazari", "", "TR", "792", "68", "", "", "", "40.1675", "31.92111", "Europe/Istanbul"),
("750735", "Besikduzu", "", "TR", "792", "61", "", "", "", "41.05199", "39.22844", "Europe/Istanbul"),
("750938", "Bayburt", "Байбурт", "TR", "792", "77", "", "", "", "40.25889", "40.22778", "Europe/Istanbul"),
("751057", "Bartin", "Бартин", "TR", "792", "87", "", "", "", "41.63583", "32.3375", "Europe/Istanbul"),
("751077", "Bandirma", "Бандырма", "TR", "792", "10", "", "", "", "40.35222", "27.97667", "Europe/Istanbul"),
("751324", "Bagcilar", "Багджылар", "TR", "792", "34", "", "", "", "41.03903", "28.85671", "Europe/Istanbul"),
("751335", "Bafra", "Бафра", "TR", "792", "55", "", "", "", "41.56778", "35.90694", "Europe/Istanbul"),
("751371", "Babaeski", "", "TR", "792", "39", "", "", "", "41.4325", "27.09306", "Europe/Istanbul"),
("751817", "Artvin", "Артвин", "TR", "792", "08", "", "", "", "41.18161", "41.82172", "Europe/Istanbul"),
("751838", "Arsin", "", "TR", "792", "61", "", "", "", "40.94958", "39.92756", "Europe/Istanbul"),
("751931", "Arhavi", "Мусазаде", "TR", "792", "08", "", "", "", "41.35121", "41.30456", "Europe/Istanbul"),
("751949", "Ardesen", "Ардешен", "TR", "792", "53", "", "", "", "41.19111", "40.9875", "Europe/Istanbul"),
("751952", "Ardahan", "Ардаган", "TR", "792", "86", "", "", "", "41.10871", "42.70222", "Europe/Istanbul"),
("751971", "Arakli", "Араклы", "TR", "792", "61", "", "", "", "40.93854", "40.05842", "Europe/Istanbul"),
("752015", "Amasya", "Амасья", "TR", "792", "05", "", "", "", "40.65333", "35.83306", "Europe/Istanbul"),
("752184", "Alapli", "", "TR", "792", "85", "", "", "", "41.1694", "31.37917", "Europe/Istanbul"),
("752278", "Alaca", "", "TR", "792", "19", "", "", "", "40.16833", "34.8425", "Europe/Istanbul"),
("752288", "Akyazi", "", "TR", "792", "54", "", "", "", "40.685", "30.62222", "Europe/Istanbul"),
("752584", "Akcakoca", "", "TR", "792", "93", "", "", "", "41.08663", "31.11623", "Europe/Istanbul"),
("752627", "Akcaabat", "Акчаабад", "TR", "792", "61", "", "", "", "41.0212", "39.57146", "Europe/Istanbul"),
("752850", "Adapazari", "Сакарья", "TR", "792", "54", "", "", "", "40.78056", "30.40333", "Europe/Istanbul"),
("831432", "Espiye", "", "TR", "792", "28", "", "", "", "40.94794", "38.71148", "Europe/Istanbul"),
("6354984", "merter keresteciler", "", "TR", "792", "34", "", "", "", "41.01295", "28.88593", "Europe/Istanbul"),
("6354985", "guengoeren merter", "", "TR", "792", "34", "", "", "", "41.00711", "28.88795", "Europe/Istanbul"),
("6620290", "Turgutreis", "", "TR", "792", "48", "7733242", "", "", "37.01667", "27.26667", "Europe/Istanbul"),
("6692524", "Sarigerme", "Саригерме", "TR", "792", "48", "", "", "", "36.71549", "28.70436", "Europe/Istanbul"),
("6947637", "Atasehir", "", "TR", "792", "34", "8521529", "", "", "40.9833", "29.1167", "Europe/Istanbul"),
("6947639", "Basaksehir", "", "TR", "792", "34", "", "", "", "41.09307", "28.80203", "Europe/Istanbul"),
("6947640", "Beylikduezue", "", "TR", "792", "34", "", "", "", "40.982", "28.6399", "Europe/Istanbul"),
("6947641", "Bueyuekcekmece", "", "TR", "792", "34", "", "", "", "41.02072", "28.58502", "Europe/Istanbul"),
("6955677", "Cankaya", "", "TR", "792", "68", "", "", "", "39.9179", "32.86268", "Europe/Istanbul"),
("7627067", "Bahcelievler", "", "TR", "792", "34", "", "", "", "41.00231", "28.8598", "Europe/Istanbul"),
("7628416", "Sultangazi", "", "TR", "792", "34", "", "", "", "41.10652", "28.86847", "Europe/Istanbul"),
("7628419", "Sultanbeyli", "", "TR", "792", "34", "", "", "", "40.96072", "29.27067", "Europe/Istanbul"),
("7628420", "Sancaktepe", "", "TR", "792", "34", "", "", "", "41.00244", "29.23187", "Europe/Istanbul"),
("7701384", "Karabaglar", "", "TR", "792", "35", "", "", "", "38.37396", "27.1352", "Europe/Istanbul"),
("1665196", "Douliu", "Доулю", "TW", "158", "04", "YUN", "", "", "23.70944", "120.54333", "Asia/Taipei"),
("1665357", "Yujing", "", "TW", "158", "04", "", "", "", "23.12493", "120.46138", "Asia/Taipei"),
("1668341", "Taipei", "Тайбэй", "TW", "158", "03", "TPE", "", "", "25.04776", "121.53185", "Asia/Taipei"),
("1668355", "Tainan", "Тайнань", "TW", "158", "04", "TNN", "", "", "22.99083", "120.21333", "Asia/Taipei"),
("1668399", "Taichung", "Тайчжун", "TW", "158", "04", "TXG", "", "", "24.1469", "120.6839", "Asia/Taipei"),
("1668467", "Daxi", "Та-Си-чен", "TW", "158", "04", "", "", "", "24.88373", "121.29043", "Asia/Taipei"),
("1670029", "Banqiao", "", "TW", "158", "03", "TPQ", "", "", "25.01427", "121.46719", "Asia/Taipei"),
("1670310", "Puli", "Пули", "TW", "158", "04", "NAN", "", "", "23.96639", "120.96952", "Asia/Taipei"),
("1671566", "Nantou", "Наньтоу", "TW", "158", "04", "NAN", "", "", "23.91566", "120.66387", "Asia/Taipei"),
("1672228", "Ma-kung", "Магун", "TW", "158", "04", "PEN", "", "", "23.5654", "119.58627", "Asia/Taipei"),
("1672551", "Lugu", "Лугу", "TW", "158", "04", "", "", "", "23.74639", "120.7525", "Asia/Taipei"),
("1673820", "Kaohsiung", "Гаосюн", "TW", "158", "02", "", "", "", "22.61626", "120.31333", "Asia/Taipei"),
("1674199", "Yilan", "Илань", "TW", "158", "04", "ILA", "", "", "24.757", "121.753", "Asia/Taipei"),
("1674504", "Hualian", "", "TW", "158", "04", "HUA", "", "", "23.97694", "121.60444", "Asia/Taipei"),
("1675151", "Hsinchu", "Синьчжу", "TW", "158", "04", "HSZ", "", "", "24.80361", "120.96861", "Asia/Taipei"),
("1676242", "Hengchun", "", "TW", "158", "04", "", "", "", "22.00417", "120.74389", "Asia/Taipei"),
("1678008", "Jincheng", "", "TW", "158", "01", "1676511", "", "", "24.43667", "118.31833", "Asia/Taipei"),
("1678228", "Keelung", "Ши-лун", "TW", "158", "04", "KEE", "", "", "25.12825", "121.7419", "Asia/Taipei"),
("6696918", "Taoyuan City", "Таоюань", "TW", "158", "04", "", "", "", "24.99368", "121.29696", "Asia/Taipei"),
("6949678", "Taitung City", "", "TW", "158", "04", "", "", "", "22.7583", "121.1444", "Asia/Taipei"),
("7601921", "Zhongxing New Village", "", "TW", "158", "04", "", "", "", "23.95908", "120.68516", "Asia/Taipei"),
("148730", "Zanzibar", "Занзибар", "TZ", "834", "25", "", "", "", "-6.16394", "39.19793", "Africa/Dar_es_Salaam"),
("148842", "Wete", "Вето", "TZ", "834", "13", "", "", "", "-5.05589", "39.72938", "Africa/Dar_es_Salaam"),
("148942", "Vwawa", "", "TZ", "834", "09", "", "", "", "-9.11667", "32.93333", "Africa/Dar_es_Salaam"),
("148987", "Vikindu", "", "TZ", "834", "02", "", "", "", "-7.00667", "39.29849", "Africa/Dar_es_Salaam"),
("149027", "Uyovu", "", "TZ", "834", "28", "", "", "", "-3.28333", "31.52583", "Africa/Dar_es_Salaam"),
("149050", "Uvinza", "", "TZ", "834", "05", "", "", "", "-5.10361", "30.39111", "Africa/Dar_es_Salaam"),
("149129", "Ushirombo", "", "TZ", "834", "28", "", "", "", "-3.49194", "31.96389", "Africa/Dar_es_Salaam"),
("149132", "Usevia", "", "TZ", "834", "29", "", "", "", "-7.1", "31.23333", "Africa/Dar_es_Salaam"),
("149151", "Usagara", "", "TZ", "834", "12", "", "", "", "-2.68333", "33", "Africa/Dar_es_Salaam"),
("149155", "Usa River", "", "TZ", "834", "26", "", "", "", "-3.36667", "36.85", "Africa/Dar_es_Salaam"),
("149172", "Urambo", "", "TZ", "834", "17", "", "", "", "-5.06667", "32.05", "Africa/Dar_es_Salaam"),
("149402", "Tunduma", "", "TZ", "834", "09", "", "", "", "-9.3", "32.76667", "Africa/Dar_es_Salaam"),
("149418", "Tumbi", "", "TZ", "834", "17", "", "", "", "-5.06667", "32.73333", "Africa/Dar_es_Salaam"),
("149437", "Tukuyu", "", "TZ", "834", "09", "", "", "", "-9.25", "33.65", "Africa/Dar_es_Salaam"),
("149512", "Tinde", "", "TZ", "834", "15", "", "", "", "-3.88333", "33.2", "Africa/Dar_es_Salaam"),
("149581", "Tarime", "", "TZ", "834", "08", "", "", "", "-1.35", "34.36667", "Africa/Dar_es_Salaam"),
("149606", "Tanga", "Танга", "TZ", "834", "18", "", "", "", "-5.06893", "39.09875", "Africa/Dar_es_Salaam"),
("149658", "Tabora", "", "TZ", "834", "17", "", "", "", "-5.01622", "32.82663", "Africa/Dar_es_Salaam"),
("149703", "Sumbawanga", "", "TZ", "834", "24", "", "", "", "-7.96667", "31.61667", "Africa/Dar_es_Salaam"),
("149775", "Songwa", "", "TZ", "834", "15", "", "", "", "-3.51667", "33.51667", "Africa/Dar_es_Salaam"),
("149792", "Somanda", "", "TZ", "834", "31", "", "", "", "-3.36667", "33.95", "Africa/Dar_es_Salaam"),
("149812", "Sokoni", "", "TZ", "834", "21", "", "", "", "-6.43333", "39.55", "Africa/Dar_es_Salaam"),
("149854", "Sirari", "", "TZ", "834", "08", "", "", "", "-1.23333", "34.43333", "Africa/Dar_es_Salaam"),
("149879", "Singida", "", "TZ", "834", "16", "", "", "", "-4.81629", "34.74358", "Africa/Dar_es_Salaam"),
("149929", "Sikonge", "", "TZ", "834", "17", "", "", "", "-5.63333", "32.76667", "Africa/Dar_es_Salaam"),
("150006", "Shinyanga", "", "TZ", "834", "15", "", "", "", "-3.66393", "33.42118", "Africa/Dar_es_Salaam"),
("150037", "Shelui", "", "TZ", "834", "16", "", "", "", "-4.36667", "34.2", "Africa/Dar_es_Salaam"),
("150099", "Sepuka", "", "TZ", "834", "16", "", "", "", "-4.75", "34.53333", "Africa/Dar_es_Salaam"),
("150276", "Same", "", "TZ", "834", "06", "", "", "", "-4.06667", "37.73333", "Africa/Dar_es_Salaam"),
("150436", "Rulenge", "", "TZ", "834", "19", "", "", "", "-2.7175", "30.6325", "Africa/Dar_es_Salaam"),
("150453", "Rujewa", "", "TZ", "834", "09", "", "", "", "-8.7", "34.38333", "Africa/Dar_es_Salaam"),
("150634", "Puma", "", "TZ", "834", "16", "", "", "", "-5", "34.73333", "Africa/Dar_es_Salaam"),
("150885", "Old Shinyanga", "", "TZ", "834", "15", "", "", "", "-3.55", "33.4", "Africa/Dar_es_Salaam"),
("150930", "Nzega", "", "TZ", "834", "17", "", "", "", "-4.21667", "33.18333", "Africa/Dar_es_Salaam"),
("151108", "Nyamuswa", "", "TZ", "834", "08", "", "", "", "-1.9", "34.01667", "Africa/Dar_es_Salaam"),
("151211", "Nyalikungu", "", "TZ", "834", "31", "", "", "", "-3.18333", "33.78333", "Africa/Dar_es_Salaam"),
("151266", "Nyakabindi", "", "TZ", "834", "31", "", "", "", "-2.63333", "33.98333", "Africa/Dar_es_Salaam"),
("151363", "Nsunga", "", "TZ", "834", "19", "", "", "", "-1.14389", "31.39472", "Africa/Dar_es_Salaam"),
("151373", "Nshamba", "", "TZ", "834", "19", "", "", "", "-1.79833", "31.55111", "Africa/Dar_es_Salaam"),
("151479", "Njombe", "", "TZ", "834", "30", "", "", "", "-9.33333", "34.76667", "Africa/Dar_es_Salaam"),
("151567", "Nguruka", "", "TZ", "834", "05", "", "", "", "-5.10917", "31.04194", "Africa/Dar_es_Salaam"),
("151599", "Ngudu", "", "TZ", "834", "12", "", "", "", "-2.96667", "33.33333", "Africa/Dar_es_Salaam"),
("151678", "Ngerengere", "", "TZ", "834", "10", "", "", "", "-6.75", "38.11667", "Africa/Dar_es_Salaam"),
("151711", "Ngara", "", "TZ", "834", "19", "", "", "", "-2.51222", "30.65583", "Africa/Dar_es_Salaam"),
("151929", "Nangwa", "", "TZ", "834", "27", "", "", "", "-4.46667", "35.45", "Africa/Dar_es_Salaam"),
("151986", "Namanyere", "", "TZ", "834", "24", "", "", "", "-7.51667", "31.05", "Africa/Dar_es_Salaam"),
("152224", "Mwanza", "Мванза", "TZ", "834", "12", "", "", "", "-2.51667", "32.9", "Africa/Dar_es_Salaam"),
("152376", "Mwadui", "", "TZ", "834", "15", "", "", "", "-3.55", "33.6", "Africa/Dar_es_Salaam"),
("152403", "Mvomero", "", "TZ", "834", "02", "", "", "", "-6.25", "38.66667", "Africa/Dar_es_Salaam"),
("152451", "Musoma", "Мусома", "TZ", "834", "08", "", "", "", "-1.5", "33.8", "Africa/Dar_es_Salaam"),
("152497", "Muriti", "", "TZ", "834", "08", "", "", "", "-1.98333", "32.91667", "Africa/Dar_es_Salaam"),
("152546", "Mungaa", "", "TZ", "834", "16", "", "", "", "-4.96667", "34.88333", "Africa/Dar_es_Salaam"),
("152632", "Muheza", "", "TZ", "834", "18", "", "", "", "-5.16667", "38.78333", "Africa/Dar_es_Salaam"),
("152663", "Mugumu", "", "TZ", "834", "08", "", "", "", "-1.85", "34.7", "Africa/Dar_es_Salaam"),
("152718", "Mtwango", "", "TZ", "834", "30", "", "", "", "-9.01667", "34.8", "Africa/Dar_es_Salaam"),
("152743", "Mto wa Mbu", "", "TZ", "834", "26", "", "", "", "-3.35", "35.85", "Africa/Dar_es_Salaam"),
("152781", "Mtinko", "", "TZ", "834", "16", "", "", "", "-4.55", "34.85", "Africa/Dar_es_Salaam"),
("152933", "Msowero", "", "TZ", "834", "10", "", "", "", "-6.53333", "37.2", "Africa/Dar_es_Salaam"),
("153094", "Mpwapwa", "", "TZ", "834", "03", "", "", "", "-6.35", "36.48333", "Africa/Dar_es_Salaam"),
("153176", "Mpanda", "", "TZ", "834", "29", "", "", "", "-6.34379", "31.06951", "Africa/Dar_es_Salaam"),
("153209", "Moshi", "Моши", "TZ", "834", "06", "", "", "", "-3.35", "37.33333", "Africa/Dar_es_Salaam"),
("153220", "Morogoro", "Морогоро", "TZ", "834", "10", "", "", "", "-6.82102", "37.66122", "Africa/Dar_es_Salaam"),
("153352", "Mlowo", "", "TZ", "834", "09", "", "", "", "-9", "32.98333", "Africa/Dar_es_Salaam"),
("153384", "Mlimba", "", "TZ", "834", "10", "", "", "", "-8.8", "35.81667", "Africa/Dar_es_Salaam"),
("153408", "Mlangali", "", "TZ", "834", "30", "", "", "", "-9.78333", "34.51667", "Africa/Dar_es_Salaam"),
("153412", "Mlandizi", "", "TZ", "834", "02", "", "", "", "-6.7", "38.73333", "Africa/Dar_es_Salaam"),
("153423", "Mlalo", "", "TZ", "834", "18", "", "", "", "-4.93333", "38.93333", "Africa/Dar_es_Salaam"),
("153482", "Mkuranga", "", "TZ", "834", "02", "", "", "", "-7.11799", "39.20782", "Africa/Dar_es_Salaam"),
("153709", "Mwandiga", "", "TZ", "834", "05", "", "", "", "-4.83", "29.65806", "Africa/Dar_es_Salaam"),
("153759", "Misungwi", "", "TZ", "834", "12", "", "", "", "-2.85", "33.08333", "Africa/Dar_es_Salaam"),
("153871", "Mikumi", "", "TZ", "834", "10", "", "", "", "-7.40409", "36.98309", "Africa/Dar_es_Salaam"),
("154002", "Mhango", "", "TZ", "834", "15", "", "", "", "-3.28333", "32.85", "Africa/Dar_es_Salaam"),
("154097", "Mgandu", "", "TZ", "834", "16", "", "", "", "-5.95", "34.13333", "Africa/Dar_es_Salaam"),
("154321", "Mbuguni", "", "TZ", "834", "26", "", "", "", "-3.56667", "36.95", "Africa/Dar_es_Salaam"),
("154380", "Mbeya", "Мбее", "TZ", "834", "09", "", "", "", "-8.9", "33.45", "Africa/Dar_es_Salaam"),
("154470", "Mazinde", "", "TZ", "834", "18", "", "", "", "-4.8", "38.21667", "Africa/Dar_es_Salaam"),
("154566", "Matui", "", "TZ", "834", "18", "", "", "", "-4.8", "38.25", "Africa/Dar_es_Salaam"),
("154638", "Matai", "", "TZ", "834", "24", "", "", "", "-8.3", "31.51667", "Africa/Dar_es_Salaam"),
("154648", "Maswa", "", "TZ", "834", "31", "", "", "", "-2.68333", "33.98333", "Africa/Dar_es_Salaam"),
("154654", "Masumbwe", "", "TZ", "834", "28", "", "", "", "-3.63333", "32.18333", "Africa/Dar_es_Salaam"),
("154780", "Maramba", "", "TZ", "834", "18", "", "", "", "-5.05", "38.61667", "Africa/Dar_es_Salaam"),
("155016", "Malinyi", "", "TZ", "834", "10", "", "", "", "-8.93333", "36.13333", "Africa/Dar_es_Salaam"),
("155056", "Malampaka", "", "TZ", "834", "31", "", "", "", "-3.13333", "33.53333", "Africa/Dar_es_Salaam"),
("155076", "Makuyuni", "", "TZ", "834", "18", "", "", "", "-4.73333", "38.1", "Africa/Dar_es_Salaam"),
("155101", "Makumbako", "", "TZ", "834", "30", "", "", "", "-8.85", "34.83333", "Africa/Dar_es_Salaam"),
("155285", "Mahanje", "", "TZ", "834", "14", "", "", "", "-9.93333", "35.33333", "Africa/Dar_es_Salaam"),
("155307", "Kihangara", "", "TZ", "834", "12", "", "", "", "-2.58333", "33.35", "Africa/Dar_es_Salaam"),
("155310", "Magugu", "", "TZ", "834", "27", "", "", "", "-4.01667", "35.76667", "Africa/Dar_es_Salaam"),
("155321", "Magomeni", "", "TZ", "834", "23", "", "", "", "-6.8", "39.25", "Africa/Dar_es_Salaam"),
("155334", "Magole", "", "TZ", "834", "10", "", "", "", "-6.36667", "37.36667", "Africa/Dar_es_Salaam"),
("155405", "Mafinga", "", "TZ", "834", "04", "", "", "", "-7.25", "35.06667", "Africa/Dar_es_Salaam"),
("155515", "Mabama", "", "TZ", "834", "17", "", "", "", "-5.13333", "32.53333", "Africa/Dar_es_Salaam"),
("155569", "Lushoto", "", "TZ", "834", "18", "", "", "", "-4.78333", "38.28333", "Africa/Dar_es_Salaam"),
("155743", "Lugoba", "", "TZ", "834", "02", "", "", "", "-6.45", "38.33333", "Africa/Dar_es_Salaam"),
("155921", "Liwale", "", "TZ", "834", "07", "", "", "", "-9.76667", "37.93333", "Africa/Dar_es_Salaam"),
("156025", "Lembeni", "", "TZ", "834", "06", "", "", "", "-3.78333", "37.61667", "Africa/Dar_es_Salaam"),
("156080", "Lalago", "", "TZ", "834", "31", "", "", "", "-3.45", "33.95", "Africa/Dar_es_Salaam"),
("156098", "Laela", "", "TZ", "834", "24", "", "", "", "-8.56667", "32.05", "Africa/Dar_es_Salaam"),
("156111", "Kyela", "", "TZ", "834", "09", "", "", "", "-9.58333", "33.85", "Africa/Dar_es_Salaam"),
("156510", "Kondoa", "", "TZ", "834", "03", "", "", "", "-4.9", "35.78333", "Africa/Dar_es_Salaam"),
("156627", "Kiwira", "", "TZ", "834", "09", "", "", "", "-9.16667", "33.53333", "Africa/Dar_es_Salaam"),
("156963", "Kishapu", "", "TZ", "834", "15", "", "", "", "-3.61667", "33.86667", "Africa/Dar_es_Salaam"),
("156974", "Kisesa", "", "TZ", "834", "31", "", "", "", "-3.08333", "34.15", "Africa/Dar_es_Salaam"),
("157107", "Kirando", "", "TZ", "834", "24", "", "", "", "-7.41667", "30.6", "Africa/Dar_es_Salaam"),
("157198", "Kiomboi", "", "TZ", "834", "16", "", "", "", "-4.26667", "34.36667", "Africa/Dar_es_Salaam"),
("157268", "Kingori", "", "TZ", "834", "26", "", "", "", "-3.28333", "36.98333", "Africa/Dar_es_Salaam"),
("157403", "Kilosa", "", "TZ", "834", "10", "", "", "", "-6.83333", "36.98333", "Africa/Dar_es_Salaam"),
("157738", "Kigoma", "Кигоме", "TZ", "834", "05", "", "", "", "-4.87694", "29.62667", "Africa/Dar_es_Salaam"),
("157826", "Kidodi", "", "TZ", "834", "10", "", "", "", "-7.60361", "37.00438", "Africa/Dar_es_Salaam"),
("157863", "Kidatu", "", "TZ", "834", "10", "", "", "", "-7.69916", "36.95722", "Africa/Dar_es_Salaam"),
("157960", "Kibondo", "", "TZ", "834", "05", "", "", "", "-3.58639", "30.72028", "Africa/Dar_es_Salaam"),
("157977", "Kibiti", "", "TZ", "834", "02", "", "", "", "-7.72178", "38.93749", "Africa/Dar_es_Salaam"),
("158016", "Kibara", "", "TZ", "834", "08", "", "", "", "-2.15", "33.45", "Africa/Dar_es_Salaam"),
("158024", "Kibakwe", "", "TZ", "834", "03", "", "", "", "-6.71667", "36.36667", "Africa/Dar_es_Salaam"),
("158027", "Kibaha", "", "TZ", "834", "02", "", "", "", "-6.76667", "38.91667", "Africa/Dar_es_Salaam"),
("158151", "Katumba", "Катумба", "TZ", "834", "09", "", "", "", "-9.23333", "33.61667", "Africa/Dar_es_Salaam"),
("158160", "Katoro", "", "TZ", "834", "28", "", "", "", "-3.02028", "31.89583", "Africa/Dar_es_Salaam"),
("158179", "Katerero", "", "TZ", "834", "19", "", "", "", "-1.4", "31.73333", "Africa/Dar_es_Salaam"),
("158214", "Kasulu", "Касулу", "TZ", "834", "05", "", "", "", "-4.57667", "30.1025", "Africa/Dar_es_Salaam"),
("158289", "Kasamwa", "", "TZ", "834", "28", "", "", "", "-2.85", "32.43333", "Africa/Dar_es_Salaam"),
("158324", "Kiratu", "", "TZ", "834", "26", "", "", "", "-3.33333", "35.66667", "Africa/Dar_es_Salaam"),
("158492", "Kamachumu", "", "TZ", "834", "19", "", "", "", "-1.61861", "31.62", "Africa/Dar_es_Salaam"),
("158563", "Kakonko", "", "TZ", "834", "05", "", "", "", "-3.28278", "30.96417", "Africa/Dar_es_Salaam"),
("158597", "Kahama", "", "TZ", "834", "15", "", "", "", "-3.83333", "32.6", "Africa/Dar_es_Salaam"),
("158684", "Kabanga", "", "TZ", "834", "19", "", "", "", "-2.63861", "30.46778", "Africa/Dar_es_Salaam"),
("158825", "Izazi", "", "TZ", "834", "04", "", "", "", "-7.2", "35.73333", "Africa/Dar_es_Salaam"),
("158904", "Itigi", "", "TZ", "834", "16", "", "", "", "-5.7", "34.48333", "Africa/Dar_es_Salaam"),
("159045", "Isaka", "Исака", "TZ", "834", "15", "", "", "", "-3.9", "32.93333", "Africa/Dar_es_Salaam"),
("159071", "Iringa", "Иринга", "TZ", "834", "04", "", "", "", "-7.76667", "35.7", "Africa/Dar_es_Salaam"),
("159107", "Ipinda", "", "TZ", "834", "09", "", "", "", "-9.48333", "33.9", "Africa/Dar_es_Salaam"),
("159179", "Ilula", "", "TZ", "834", "04", "", "", "", "-7.6766", "36.03658", "Africa/Dar_es_Salaam"),
("159186", "Ilongero", "", "TZ", "834", "16", "", "", "", "-4.66667", "34.86667", "Africa/Dar_es_Salaam"),
("159218", "Ilembula", "", "TZ", "834", "30", "", "", "", "-8.9", "34.58333", "Africa/Dar_es_Salaam"),
("159267", "Ikungi", "", "TZ", "834", "16", "", "", "", "-5.13333", "34.76667", "Africa/Dar_es_Salaam"),
("159380", "Igurusi", "", "TZ", "834", "09", "", "", "", "-8.85", "33.85", "Africa/Dar_es_Salaam"),
("159386", "Igunga", "", "TZ", "834", "17", "", "", "", "-4.28333", "33.88333", "Africa/Dar_es_Salaam"),
("159398", "Igugunu", "", "TZ", "834", "16", "", "", "", "-4.56667", "34.63333", "Africa/Dar_es_Salaam"),
("159492", "Ifakara", "", "TZ", "834", "10", "", "", "", "-8.13333", "36.68333", "Africa/Dar_es_Salaam"),
("159647", "Hedaru", "", "TZ", "834", "06", "", "", "", "-4.5", "37.9", "Africa/Dar_es_Salaam"),
("159908", "Geita", "", "TZ", "834", "28", "", "", "", "-2.86667", "32.16667", "Africa/Dar_es_Salaam"),
("159909", "Geiro", "", "TZ", "834", "10", "", "", "", "-6.15", "36.86667", "Africa/Dar_es_Salaam"),
("159951", "Galappo", "", "TZ", "834", "27", "", "", "", "-4.26667", "35.85", "Africa/Dar_es_Salaam"),
("160172", "Dongobesh", "", "TZ", "834", "27", "", "", "", "-4.06667", "35.38333", "Africa/Dar_es_Salaam"),
("160196", "Dodoma", "Додома", "TZ", "834", "03", "", "", "", "-6.17221", "35.73947", "Africa/Dar_es_Salaam"),
("160263", "Dar es Salaam", "Дар-эс-Салам", "TZ", "834", "23", "", "", "", "-6.82349", "39.26951", "Africa/Dar_es_Salaam"),
("160266", "Dareda", "", "TZ", "834", "27", "", "", "", "-4.21667", "35.55", "Africa/Dar_es_Salaam"),
("160464", "Chimala", "", "TZ", "834", "09", "", "", "", "-8.85", "34.01667", "Africa/Dar_es_Salaam"),
("160552", "Chato", "", "TZ", "834", "28", "", "", "", "-2.63778", "31.76694", "Africa/Dar_es_Salaam"),
("160592", "Chanika", "", "TZ", "834", "18", "", "", "", "-5.41667", "38.01667", "Africa/Dar_es_Salaam"),
("160660", "Chalinze", "", "TZ", "834", "02", "", "", "", "-6.63784", "38.35396", "Africa/Dar_es_Salaam"),
("160670", "Chala", "", "TZ", "834", "24", "", "", "", "-7.58333", "31.26667", "Africa/Dar_es_Salaam"),
("160677", "Chake Chake", "", "TZ", "834", "20", "", "", "", "-5.24586", "39.76659", "Africa/Dar_es_Salaam"),
("160798", "Butiama", "", "TZ", "834", "08", "", "", "", "-1.76667", "33.96667", "Africa/Dar_es_Salaam"),
("160833", "Buseresere", "", "TZ", "834", "28", "", "", "", "-3.02361", "31.87472", "Africa/Dar_es_Salaam"),
("160877", "Bungu", "", "TZ", "834", "02", "", "", "", "-7.63369", "39.05818", "Africa/Dar_es_Salaam"),
("160892", "Bunda", "", "TZ", "834", "08", "", "", "", "-2.05", "33.86667", "Africa/Dar_es_Salaam"),
("160961", "Bukoba", "Букоба", "TZ", "834", "19", "", "", "", "-1.33167", "31.81222", "Africa/Dar_es_Salaam"),
("161023", "Bugarama", "", "TZ", "834", "19", "", "", "", "-2.87056", "30.52806", "Africa/Dar_es_Salaam"),
("161154", "Biharamulo", "", "TZ", "834", "19", "", "", "", "-2.63194", "31.30889", "Africa/Dar_es_Salaam"),
("161197", "Basotu", "", "TZ", "834", "27", "", "", "", "-4.36667", "35.08333", "Africa/Dar_es_Salaam"),
("161204", "Bashanet", "", "TZ", "834", "27", "", "", "", "-4.23333", "35.41667", "Africa/Dar_es_Salaam"),
("161218", "Bariadi", "", "TZ", "834", "31", "", "", "", "-2.8", "33.98333", "Africa/Dar_es_Salaam"),
("161290", "Bagamoyo", "", "TZ", "834", "02", "", "", "", "-6.43333", "38.9", "Africa/Dar_es_Salaam"),
("161312", "Babati", "", "TZ", "834", "27", "", "", "", "-4.21667", "35.75", "Africa/Dar_es_Salaam"),
("161325", "Arusha", "Аруша", "TZ", "834", "26", "", "", "", "-3.36667", "36.68333", "Africa/Dar_es_Salaam"),
("877384", "Tingi", "", "TZ", "834", "14", "", "", "", "-11.3", "35.03333", "Africa/Dar_es_Salaam"),
("877391", "Tandahimba", "", "TZ", "834", "11", "", "", "", "-10.75", "39.63333", "Africa/Dar_es_Salaam"),
("877401", "Songea", "Сонгеа", "TZ", "834", "14", "", "", "", "-10.68333", "35.65", "Africa/Dar_es_Salaam"),
("877471", "Nyangao", "", "TZ", "834", "07", "", "", "", "-10.33333", "39.28333", "Africa/Dar_es_Salaam"),
("877532", "Newala Kisimani", "", "TZ", "834", "11", "", "", "", "-10.95", "39.28333", "Africa/Dar_es_Salaam"),
("877581", "Nanyamba", "", "TZ", "834", "11", "", "", "", "-10.68333", "39.83333", "Africa/Dar_es_Salaam"),
("877597", "Nangomba", "", "TZ", "834", "11", "", "", "", "-10.9", "38.5", "Africa/Dar_es_Salaam"),
("877605", "Nanganga", "", "TZ", "834", "11", "", "", "", "-10.38333", "39.15", "Africa/Dar_es_Salaam"),
("877702", "Nachingwea", "", "TZ", "834", "07", "", "", "", "-10.3725", "38.76251", "Africa/Dar_es_Salaam"),
("877747", "Mtwara", "Мтвара", "TZ", "834", "11", "", "", "", "-10.26667", "40.18333", "Africa/Dar_es_Salaam"),
("877998", "Mbinga", "", "TZ", "834", "14", "", "", "", "-10.93333", "35.01667", "Africa/Dar_es_Salaam"),
("878041", "Matiri", "", "TZ", "834", "14", "", "", "", "-10.75", "34.9", "Africa/Dar_es_Salaam"),
("878058", "Masasi", "Масаси", "TZ", "834", "11", "", "", "", "-10.71667", "38.8", "Africa/Dar_es_Salaam"),
("878073", "Maposeni", "", "TZ", "834", "14", "", "", "", "-10.58333", "35.4", "Africa/Dar_es_Salaam"),
("878195", "Lukuledi", "", "TZ", "834", "11", "", "", "", "-10.56667", "38.8", "Africa/Dar_es_Salaam"),
("878223", "Luchingu", "", "TZ", "834", "11", "", "", "", "-10.9", "39.33333", "Africa/Dar_es_Salaam"),
("878281", "Lindi", "Линда", "TZ", "834", "07", "", "", "", "-10", "39.71667", "Africa/Dar_es_Salaam"),
("878367", "Kitama", "", "TZ", "834", "11", "", "", "", "-10.71667", "39.73333", "Africa/Dar_es_Salaam"),
("878400", "Kigonsera", "", "TZ", "834", "14", "", "", "", "-10.8", "35.05", "Africa/Dar_es_Salaam"),
("6640202", "Merelani", "", "TZ", "834", "26", "", "", "", "-3.56182", "36.97895", "Africa/Dar_es_Salaam"),
("613273", "Lebedyn", "Лебедин", "UA", "804", "21", "", "", "", "50.58518", "34.4849", "Europe/Kiev"),
("616743", "Druzhkivka", "Дружковка", "UA", "804", "05", "", "", "", "48.63013", "37.55259", "Europe/Kiev"),
("686729", "Vasylivka", "Василівка", "UA", "804", "26", "", "", "", "47.43694", "35.27417", "Europe/Zaporozhye"),
("686803", "Zvenyhorodka", "Звенигородка", "UA", "804", "01", "", "", "", "49.07866", "30.96754", "Europe/Kiev"),
("686818", "Zuhres", "Зугрес", "UA", "804", "05", "", "", "", "48.0114", "38.26444", "Europe/Kiev"),
("686875", "Zolotonosha", "Золотоноша", "UA", "804", "01", "", "", "", "49.66886", "32.03773", "Europe/Kiev"),
("686896", "Zolochiv", "Золочев", "UA", "804", "15", "", "", "", "49.80597", "24.89436", "Europe/Kiev"),
("686919", "Znomenka", "Знаменка", "UA", "804", "10", "", "", "", "48.71278", "32.66472", "Europe/Kiev"),
("686928", "Zmiyiv", "Зміїв", "UA", "804", "07", "", "", "", "49.67453", "36.34775", "Europe/Kiev"),
("686967", "Zhytomyr", "Житомир", "UA", "804", "27", "", "", "", "50.26487", "28.67669", "Europe/Kiev"),
("687116", "Zhmerynka", "Жмеринка", "UA", "804", "23", "", "", "", "49.03705", "28.11201", "Europe/Kiev"),
("687196", "Zhovti Vody", "Желтые Воды", "UA", "804", "04", "", "", "", "48.34731", "33.50034", "Europe/Kiev"),
("687245", "Zhashkiv", "Жашків", "UA", "804", "01", "", "", "", "49.24545", "30.1102", "Europe/Kiev"),
("687432", "Zdolbuniv", "Здолбунів", "UA", "804", "19", "", "", "", "50.5206", "26.24251", "Europe/Kiev"),
("687700", "Zaporizhzhya", "Запорожье", "UA", "804", "26", "", "", "", "47.82289", "35.19031", "Europe/Zaporozhye"),
("687997", "Yuzhne", "Южне", "UA", "804", "17", "", "", "", "46.62211", "31.10131", "Europe/Kiev"),
("688105", "Yevpatoriya", "Евпатория", "UA", "804", "11", "8449691", "", "", "45.20091", "33.36655", "Europe/Simferopol"),
("688148", "Yenakiyeve", "Енакиево", "UA", "804", "05", "", "", "", "48.23331", "38.21137", "Europe/Kiev"),
("688373", "Yasynuvata", "Ясиноватая", "UA", "804", "05", "", "", "", "48.1298", "37.8594", "Europe/Kiev"),
("688533", "Yalta", "Ялта", "UA", "804", "11", "8449687", "", "", "44.50013", "34.16148", "Europe/Simferopol"),
("688587", "Yahotyn", "Яготин", "UA", "804", "13", "", "", "", "50.27975", "31.76246", "Europe/Kiev"),
("688723", "Vyshhorod", "Вишгород", "UA", "804", "13", "", "", "", "50.58476", "30.4898", "Europe/Kiev"),
("688746", "Vynohradiv", "Виноградов", "UA", "804", "25", "", "", "", "48.14135", "23.02666", "Europe/Uzhgorod"),
("688860", "Voznesensk", "Вознесенск", "UA", "804", "16", "", "", "", "47.56494", "31.33078", "Europe/Kiev"),
("689198", "Volnovakha", "Волноваха", "UA", "804", "05", "", "", "", "47.60103", "37.49674", "Europe/Kiev"),
("689304", "Vovchans'k", "Вовчанськ", "UA", "804", "07", "", "", "", "50.29078", "36.94108", "Europe/Kiev"),
("689378", "Volodymyr-Volyns'kyy", "Владимир-Волынский", "UA", "804", "24", "", "", "", "50.85253", "24.32364", "Europe/Kiev"),
("689487", "Vyshneve", "Вишневе", "UA", "804", "13", "", "", "", "50.38913", "30.3705", "Europe/Kiev"),
("689558", "Vinnytsya", "Винница", "UA", "804", "23", "", "", "", "49.23278", "28.48097", "Europe/Kiev"),
("690312", "Vatutine", "Ватутіне", "UA", "804", "01", "", "", "", "49.01502", "31.06211", "Europe/Kiev"),
("690412", "Vasylkiv", "Васильков", "UA", "804", "13", "Vasylkiv Raion (undefined)", "", "", "50.18692", "30.31346", "Europe/Kiev"),
("690548", "Uzhhorod", "Ужгород", "UA", "804", "25", "690549", "", "", "48.61667", "22.3", "Europe/Uzhgorod"),
("690688", "Uman'", "Умань", "UA", "804", "01", "", "", "", "48.74838", "30.22184", "Europe/Kiev"),
("691016", "Tul'chyn", "Тульчин", "UA", "804", "23", "", "", "", "48.67448", "28.84641", "Europe/Kiev"),
("691037", "Tsyurupyns'k", "Цюрупинск", "UA", "804", "08", "", "", "", "46.61842", "32.7189", "Europe/Kiev"),
("691179", "Truskavets", "Трускавец", "UA", "804", "15", "", "", "", "49.27837", "23.50618", "Europe/Kiev"),
("691374", "Torez", "Торез", "UA", "804", "05", "", "", "", "48.03876", "38.59685", "Europe/Kiev"),
("691469", "Tokmak", "Токмак", "UA", "804", "26", "", "", "", "47.25522", "35.71238", "Europe/Zaporozhye"),
("691650", "Ternopil'", "Тернополь", "UA", "804", "22", "", "", "", "49.55589", "25.60556", "Europe/Kiev"),
("691936", "Tal'ne", "Тальное", "UA", "804", "01", "", "", "", "48.88877", "30.69482", "Europe/Kiev"),
("691999", "Syevyerodonets'k", "Северодонецк", "UA", "804", "14", "", "", "", "48.94832", "38.49166", "Europe/Zaporozhye"),
("692087", "Svitlovods'k", "Светловодск", "UA", "804", "10", "", "", "", "49.04894", "33.24106", "Europe/Kiev"),
("692105", "Sverdlovs'k", "Свердловск", "UA", "804", "14", "", "", "", "48.08964", "39.65243", "Europe/Zaporozhye"),
("692118", "Svatove", "Сватове", "UA", "804", "14", "", "", "", "49.41029", "38.15035", "Europe/Zaporozhye"),
("692129", "Svalyava", "Свалява", "UA", "804", "25", "", "", "", "48.54853", "22.99578", "Europe/Uzhgorod"),
("692194", "Sumy", "Сумы", "UA", "804", "21", "", "", "", "50.9216", "34.80029", "Europe/Kiev"),
("692372", "Stryi", "Стрый", "UA", "804", "15", "", "", "", "49.26223", "23.85609", "Europe/Kiev"),
("692632", "Stebnyk", "Стебник", "UA", "804", "15", "", "", "", "49.29416", "23.56357", "Europe/Kiev"),
("692818", "Starokostyantyniv", "Старокостянтинів", "UA", "804", "09", "", "", "", "49.75764", "27.20342", "Europe/Kiev"),
("692832", "Starobil's'k", "Старобельск", "UA", "804", "14", "", "", "", "49.27832", "38.91069", "Europe/Zaporozhye"),
("692975", "Stakhanov", "Стаханов", "UA", "804", "14", "", "", "", "48.56818", "38.64352", "Europe/Zaporozhye"),
("693301", "Sokal'", "Сокаль", "UA", "804", "15", "", "", "", "50.47438", "24.28288", "Europe/Kiev"),
("693381", "Snizhne", "Снежное", "UA", "804", "05", "", "", "", "48.02612", "38.77225", "Europe/Kiev"),
("693457", "Smila", "Смела", "UA", "804", "01", "", "", "", "49.22242", "31.88714", "Europe/Kiev"),
("693468", "Sloviansk", "Славянск", "UA", "804", "05", "", "", "", "48.86667", "37.61667", "Europe/Kiev"),
("693581", "Slavuta", "Славута", "UA", "804", "09", "", "", "", "50.30155", "26.86506", "Europe/Kiev"),
("693615", "Skvyra", "Сквира", "UA", "804", "13", "", "", "", "49.73177", "29.66569", "Europe/Kiev"),
("693709", "Skadovsk", "Скадовск", "UA", "804", "08", "", "", "", "46.1161", "32.91124", "Europe/Kiev"),
("693796", "Synel'nykove", "Синельниково", "UA", "804", "04", "", "", "", "48.32044", "35.51792", "Europe/Kiev"),
("693805", "Simferopol", "Симферополь", "UA", "804", "11", "8449684", "", "", "44.95719", "34.11079", "Europe/Simferopol"),
("693920", "Shpola", "Шпола", "UA", "804", "01", "", "", "", "49.00687", "31.39471", "Europe/Kiev"),
("693942", "Shostka", "Шостка", "UA", "804", "21", "", "", "", "51.86296", "33.4698", "Europe/Kiev"),
("694216", "Shepetivka", "Шепетівка", "UA", "804", "09", "", "", "", "50.18545", "27.06365", "Europe/Kiev"),
("694382", "Shakhtars'k", "Шахтерск", "UA", "804", "05", "", "", "", "48.06252", "38.51665", "Europe/Kiev"),
("694423", "Sevastopol", "Севастополь", "UA", "804", "20", "", "", "", "44.58883", "33.5224", "Europe/Simferopol"),
("694677", "Selydove", "Селидово", "UA", "804", "05", "", "", "", "48.14708", "37.30032", "Europe/Kiev"),
("694792", "Sarny", "Сарни", "UA", "804", "19", "", "", "", "51.33795", "26.60191", "Europe/Kiev"),
("694864", "Sambir", "Самбор", "UA", "804", "15", "", "", "", "49.5183", "23.19752", "Europe/Kiev"),
("694910", "Saky", "Саки", "UA", "804", "11", "8449685", "", "", "45.13424", "33.59996", "Europe/Simferopol"),
("695274", "Rubizhne", "Рубежное", "UA", "804", "14", "", "", "", "49.01229", "38.37967", "Europe/Zaporozhye"),
("695344", "Rozdil'na", "Раздельная", "UA", "804", "17", "", "", "", "46.84334", "30.07919", "Europe/Kiev"),
("695379", "Roven'ky", "Ровеньки", "UA", "804", "14", "", "", "", "48.08332", "39.37764", "Europe/Zaporozhye"),
("695464", "Romny", "Ромни", "UA", "804", "21", "", "", "", "50.75104", "33.47471", "Europe/Kiev"),
("695594", "Rivne", "Ровно", "UA", "804", "19", "", "", "", "50.62308", "26.22743", "Europe/Kiev"),
("695670", "Reni", "Рені", "UA", "804", "17", "", "", "", "45.45727", "28.29317", "Europe/Kiev"),
("695912", "Radomyshl'", "Радомышль", "UA", "804", "27", "", "", "", "50.49613", "29.22911", "Europe/Kiev"),
("695965", "Piatykhatky", "Пятихатки", "UA", "804", "04", "", "", "", "48.41333", "33.71056", "Europe/Kiev"),
("696008", "Putyvl'", "Путивль", "UA", "804", "21", "", "", "", "51.33745", "33.87066", "Europe/Kiev"),
("696108", "Pryluky", "Прилуки", "UA", "804", "02", "", "", "", "50.59324", "32.38761", "Europe/Kiev"),
("696566", "Popasna", "Попасная", "UA", "804", "14", "", "", "", "48.63328", "38.37804", "Europe/Zaporozhye"),
("696643", "Poltava", "Полтава", "UA", "804", "18", "", "", "", "49.59373", "34.54073", "Europe/Kiev"),
("696660", "Polonne", "Полонне", "UA", "804", "09", "", "", "", "50.12424", "27.51087", "Europe/Kiev"),
("696677", "Polohy", "Пологи", "UA", "804", "26", "", "", "", "47.48444", "36.25361", "Europe/Zaporozhye"),
("696943", "Pidhorodne", "Підгородне", "UA", "804", "04", "", "", "", "48.57528", "35.1068", "Europe/Kiev"),
("697183", "Pyryatyn", "Пирятин", "UA", "804", "18", "", "", "", "50.24242", "32.50621", "Europe/Kiev"),
("697592", "Pervomays'k", "Первомайск", "UA", "804", "14", "", "", "", "48.62988", "38.54806", "Europe/Zaporozhye"),
("697593", "Pervomays'k", "Первомайск", "UA", "804", "16", "", "", "", "48.04433", "30.85073", "Europe/Kiev"),
("697637", "Pereyaslav-Khmel'nyts'kyy", "Переяслав-Хмельницкий", "UA", "804", "13", "", "", "", "50.08768", "31.4795", "Europe/Kiev"),
("697650", "Pereval's'k", "Перевальск", "UA", "804", "14", "", "", "", "48.43779", "38.84384", "Europe/Zaporozhye"),
("697889", "Pavlohrad", "Павлоград", "UA", "804", "04", "", "", "", "48.53341", "35.8705", "Europe/Kiev"),
("698131", "Ovruch", "Овруч", "UA", "804", "27", "", "", "", "51.3246", "28.80351", "Europe/Kiev"),
("698428", "Orikhiv", "Оріхів", "UA", "804", "26", "", "", "", "47.56731", "35.78575", "Europe/Zaporozhye"),
("698625", "Oleksandriya", "Александрия", "UA", "804", "10", "", "", "", "48.66961", "33.11593", "Europe/Kiev"),
("698740", "Odessa", "Одесса", "UA", "804", "17", "", "", "", "46.47747", "30.73262", "Europe/Kiev"),
("698770", "Ochakiv", "Очаков", "UA", "804", "16", "", "", "", "46.61283", "31.54982", "Europe/Kiev"),
("698782", "Obukhiv", "Обухов", "UA", "804", "13", "Obukhiv Raion (undefined)", "", "", "50.10997", "30.62272", "Europe/Kiev"),
("698953", "Novyy Buh", "Новий Буг", "UA", "804", "16", "", "", "", "47.69308", "32.5216", "Europe/Kiev"),
("699035", "Novovolyns'k", "Нововолынск", "UA", "804", "24", "", "", "", "50.72576", "24.16265", "Europe/Kiev"),
("699078", "Novoukrayinka", "Новоукраїнка", "UA", "804", "10", "", "", "", "48.32635", "31.52852", "Europe/Kiev"),
("699445", "Novomoskovs'k", "Новомосковск", "UA", "804", "04", "", "", "", "48.63798", "35.24548", "Europe/Kiev"),
("699553", "Novohrad-Volyns'kyy", "Новоград-Волынский", "UA", "804", "27", "", "", "", "50.59412", "27.6165", "Europe/Kiev"),
("699839", "Nova Kakhovka", "Новая Каховка", "UA", "804", "08", "", "", "", "46.75451", "33.34864", "Europe/Kiev"),
("699917", "Nosivka", "Носівка", "UA", "804", "02", "", "", "", "50.93152", "31.58282", "Europe/Kiev"),
("699942", "Nizhyn", "Нежин", "UA", "804", "02", "", "", "", "51.04801", "31.88688", "Europe/Kiev"),
("700019", "Nyzhn'ohirs'kyy", "Нижнегорский", "UA", "804", "11", "", "", "", "45.44789", "34.73839", "Europe/Simferopol"),
("700051", "Nikopol'", "Никополь", "UA", "804", "04", "", "", "", "47.57119", "34.39637", "Europe/Kiev"),
("700261", "Netishyn", "Нетішин", "UA", "804", "09", "", "", "", "50.34004", "26.64171", "Europe/Kiev"),
("700507", "Nadvirna", "Надворная", "UA", "804", "06", "", "", "", "48.6348", "24.56936", "Europe/Kiev"),
("700569", "Mykolayiv", "Николаев", "UA", "804", "16", "", "", "", "46.96591", "31.9974", "Europe/Kiev"),
("700646", "Mukacheve", "Мукачево", "UA", "804", "25", "", "", "", "48.43919", "22.71779", "Europe/Uzhgorod"),
("700829", "Molodohvardiys'k", "Молодогвардейск", "UA", "804", "14", "", "", "", "48.34578", "39.65824", "Europe/Zaporozhye"),
("700918", "Mohyliv-Podil's'kyy", "Могилев-Подольский", "UA", "804", "23", "", "", "", "48.44598", "27.7982", "Europe/Kiev"),
("700997", "Miskhor", "Мисхор", "UA", "804", "11", "", "", "", "44.43333", "34.08333", "Europe/Simferopol"),
("701075", "Myrhorod", "Миргород", "UA", "804", "18", "", "", "", "49.96854", "33.60886", "Europe/Kiev"),
("701347", "Merefa", "Мерефа", "UA", "804", "07", "", "", "", "49.82302", "36.05069", "Europe/Kiev"),
("701404", "Melitopol'", "Мелитополь", "UA", "804", "26", "", "", "", "46.84891", "35.36533", "Europe/Zaporozhye"),
("701822", "Mariupol", "Мариуполь", "UA", "804", "05", "", "", "", "47.09514", "37.54131", "Europe/Kiev"),
("701855", "Marhanets'", "Марганец", "UA", "804", "04", "", "", "", "47.63543", "34.62769", "Europe/Kiev"),
("702116", "Malyn", "Малин", "UA", "804", "27", "", "", "", "50.77233", "29.23833", "Europe/Kiev"),
("702320", "Makiyivka", "Макеевка", "UA", "804", "05", "", "", "", "48.04782", "37.92576", "Europe/Kiev"),
("702417", "Lyubotyn", "Люботин", "UA", "804", "07", "", "", "", "49.94691", "35.92907", "Europe/Kiev"),
("702550", "L'viv", "Львов", "UA", "804", "15", "", "", "", "49.83826", "24.02324", "Europe/Kiev"),
("702563", "Lutuhyne", "Лутугино", "UA", "804", "14", "", "", "", "48.40507", "39.22675", "Europe/Zaporozhye"),
("702569", "Luts'k", "Луцк", "UA", "804", "24", "", "", "", "50.75932", "25.34244", "Europe/Kiev"),
("702658", "Luhansk", "Луганск", "UA", "804", "14", "", "", "", "48.56705", "39.31706", "Europe/Zaporozhye"),
("702723", "Lubny", "Лубни", "UA", "804", "18", "", "", "", "50.01625", "32.99694", "Europe/Kiev"),
("702760", "Lozova", "Лозова", "UA", "804", "07", "", "", "", "48.88937", "36.31755", "Europe/Kiev"),
("702972", "Lysychans'k", "Лисичанск", "UA", "804", "14", "", "", "", "48.90485", "38.44207", "Europe/Zaporozhye"),
("703428", "Ladyzhyn", "Ладижин", "UA", "804", "23", "", "", "", "48.68496", "29.23678", "Europe/Kiev"),
("703448", "Kiev", "Киев", "UA", "804", "12", "", "", "", "50.45466", "30.5238", "Europe/Kiev"),
("703464", "Kuznetsovs'k", "Кузнецовск", "UA", "804", "19", "", "", "", "51.68333", "25.86667", "Europe/Kiev"),
("703646", "Kurakhovo", "Курахово", "UA", "804", "05", "", "", "", "47.98522", "37.2821", "Europe/Kiev"),
("703656", "Kupjansk", "Купьянск", "UA", "804", "07", "", "", "", "49.71054", "37.61517", "Europe/Kiev"),
("703845", "Kryvyy Rih", "Кривой Рог", "UA", "804", "04", "", "", "", "47.90966", "33.38044", "Europe/Kiev"),
("704000", "Krolevets'", "Кролевец", "UA", "804", "21", "", "", "", "51.54775", "33.38475", "Europe/Kiev"),
("704138", "Kreminna", "Кремінна", "UA", "804", "14", "", "", "", "49.0495", "38.21792", "Europe/Zaporozhye"),
("704143", "Kremenets'", "Кременец", "UA", "804", "22", "", "", "", "50.09693", "25.72459", "Europe/Kiev"),
("704147", "Kremenchuk", "Кременчуг", "UA", "804", "18", "", "", "", "49.06802", "33.42041", "Europe/Kiev"),
("704202", "Krasnyy Luch", "Красный луч", "UA", "804", "14", "", "", "", "48.13954", "38.93715", "Europe/Zaporozhye"),
("704204", "Krasnyy Lyman", "Красный Лиман", "UA", "804", "05", "", "", "", "48.98836", "37.80225", "Europe/Kiev"),
("704362", "Krasnoperekops'k", "Красноперекопск", "UA", "804", "11", "8449693", "", "", "45.95716", "33.7965", "Europe/Simferopol"),
("704388", "Krasnohrad", "Красноград", "UA", "804", "07", "", "", "", "49.3814", "35.44021", "Europe/Kiev"),
("704403", "Krasnodon", "Краснодон", "UA", "804", "14", "", "", "", "48.29229", "39.73729", "Europe/Zaporozhye"),
("704422", "Krasnoarmiys'k", "Красноармейск", "UA", "804", "05", "", "", "", "48.28198", "37.17585", "Europe/Kiev"),
("704492", "Krasyliv", "Красилів", "UA", "804", "09", "", "", "", "49.65186", "26.97252", "Europe/Kiev"),
("704508", "Kramators'k", "Краматорск", "UA", "804", "05", "", "", "", "48.72305", "37.55629", "Europe/Kiev"),
("704608", "Kivsharivka", "Ківшарівка", "UA", "804", "07", "", "", "", "49.63096", "37.68821", "Europe/Kiev"),
("704617", "Kovel'", "Ковель", "UA", "804", "24", "", "", "", "51.21526", "24.70867", "Europe/Kiev"),
("704679", "Kotovs'k", "Котовск", "UA", "804", "17", "", "", "", "47.75305", "29.53205", "Europe/Kiev"),
("704737", "Kostopil'", "Костополь", "UA", "804", "19", "", "", "", "50.87841", "26.45192", "Europe/Kiev"),
("704858", "Korsun'-Shevchenkivs'kyy", "Корсунь-Шевченковский", "UA", "804", "01", "", "", "", "49.41894", "31.25865", "Europe/Kiev"),
("704885", "Korostyshiv", "Коростишів", "UA", "804", "27", "", "", "", "50.31723", "29.0563", "Europe/Kiev"),
("704901", "Korosten'", "Коростень", "UA", "804", "27", "", "", "", "50.95937", "28.63855", "Europe/Kiev"),
("705104", "Kostyantynivka", "Константиновка", "UA", "804", "05", "", "", "", "48.5277", "37.7069", "Europe/Kiev"),
("705135", "Konotop", "Конотоп", "UA", "804", "21", "", "", "", "51.24032", "33.20263", "Europe/Kiev"),
("705183", "Komsomol's'ke", "Комсомольское", "UA", "804", "07", "", "", "", "49.59701", "36.52618", "Europe/Kiev"),
("705392", "Kolomyya", "Коломия", "UA", "804", "06", "705389", "", "", "48.53115", "25.03649", "Europe/Kiev"),
("705730", "Kivertsi", "Ківерці", "UA", "804", "24", "", "", "", "50.83425", "25.45821", "Europe/Kiev"),
("705809", "Kirovs'k", "Кировск", "UA", "804", "14", "", "", "", "48.63751", "38.6428", "Europe/Zaporozhye"),
("705812", "Kirovohrad", "Кировоград", "UA", "804", "10", "", "", "", "48.5132", "32.2597", "Europe/Kiev"),
("705883", "Kiliya", "Килия", "UA", "804", "17", "", "", "", "45.45518", "29.26367", "Europe/Kiev"),
("706165", "Khust", "Хуст", "UA", "804", "25", "", "", "", "48.1793", "23.29909", "Europe/Uzhgorod"),
("706369", "Khmel'nyts'kyy", "Хмельницкий", "UA", "804", "09", "", "", "", "49.42161", "26.99653", "Europe/Kiev"),
("706380", "Khmil'nyk", "Хмельник", "UA", "804", "23", "", "", "", "49.55979", "27.95754", "Europe/Kiev"),
("706448", "Kherson", "Херсон", "UA", "804", "08", "", "", "", "46.65581", "32.6178", "Europe/Kiev"),
("706466", "Khartsyz'k", "Харцызск", "UA", "804", "05", "", "", "", "48.04243", "38.14728", "Europe/Kiev"),
("706483", "Kharkiv", "Харьков", "UA", "804", "07", "", "", "", "49.98081", "36.25272", "Europe/Kiev"),
("706524", "Kerch", "Керчь", "UA", "804", "11", "8449692", "", "", "45.3607", "36.4706", "Europe/Simferopol"),
("706571", "Kozyatyn", "Козятин", "UA", "804", "23", "", "", "", "49.71431", "28.83385", "Europe/Kiev"),
("706749", "Karlivka", "Карлівка", "UA", "804", "18", "", "", "", "49.45668", "35.12947", "Europe/Kiev"),
("706900", "Kaniv", "Канів", "UA", "804", "01", "", "", "", "49.75182", "31.46004", "Europe/Kiev"),
("706950", "Kamieniec Podolski", "Каменец-Подольский", "UA", "804", "09", "710863", "", "", "48.6845", "26.58559", "Europe/Kiev"),
("707099", "Kalush", "Калуш", "UA", "804", "06", "707098", "", "", "49.01187", "24.37308", "Europe/Kiev"),
("707155", "Kalynivka", "Калиновка", "UA", "804", "23", "", "", "", "49.45389", "28.52608", "Europe/Kiev"),
("707244", "Kakhovka", "Каховка", "UA", "804", "08", "", "", "", "46.81371", "33.48698", "Europe/Kiev"),
("707292", "Izyum", "Изюм", "UA", "804", "07", "", "", "", "49.20875", "37.24848", "Europe/Kiev"),
("707296", "Izyaslav", "Изяслав", "UA", "804", "09", "", "", "", "50.11947", "26.82125", "Europe/Kiev"),
("707308", "Izmayil", "Измаил", "UA", "804", "17", "", "", "", "45.34929", "28.84079", "Europe/Kiev"),
("707471", "Ivano-Frankivs'k", "Ивано-Франковск", "UA", "804", "06", "", "", "", "48.9215", "24.70972", "Europe/Kiev"),
("707565", "Irpin", "Ирпень", "UA", "804", "13", "", "", "", "50.52175", "30.25055", "Europe/Kiev"),
("707679", "Ilovays'k", "Иловайск", "UA", "804", "05", "", "", "", "47.92498", "38.20236", "Europe/Kiev"),
("707688", "Illichivs'k", "Ильичевск", "UA", "804", "17", "", "", "", "46.30495", "30.65478", "Europe/Kiev"),
("707752", "Horodok", "Городок", "UA", "804", "09", "", "", "", "49.16374", "26.58394", "Europe/Kiev"),
("707753", "Horlivka", "Горловка", "UA", "804", "05", "", "", "", "48.33576", "38.05325", "Europe/Kiev"),
("707758", "Hlukhiv", "Глухів", "UA", "804", "21", "", "", "", "51.67822", "33.9162", "Europe/Kiev"),
("707898", "Hulyaypole", "Гуляйполе", "UA", "804", "26", "", "", "", "47.66389", "36.25633", "Europe/Zaporozhye"),
("708313", "Horodok", "Городок", "UA", "804", "15", "", "", "", "49.78465", "23.64806", "Europe/Kiev"),
("708366", "Horodyshche", "Городище", "UA", "804", "01", "", "", "", "49.28489", "31.44513", "Europe/Kiev"),
("708632", "Hola Prystan'", "Голая Пристань", "UA", "804", "08", "", "", "", "46.5272", "32.52417", "Europe/Kiev"),
("708878", "Heniches'k", "Геническ", "UA", "804", "08", "", "", "", "46.17592", "34.8034", "Europe/Kiev"),
("708898", "Hayvoron", "Гайворон", "UA", "804", "10", "", "", "", "48.33958", "29.86791", "Europe/Kiev"),
("708901", "Haysyn", "Гайсин", "UA", "804", "23", "", "", "", "48.81143", "29.38977", "Europe/Kiev"),
("709054", "Hadyach", "Гадяч", "UA", "804", "18", "", "", "", "50.37112", "33.99099", "Europe/Kiev"),
("709161", "Feodosiya", "Феодосия", "UA", "804", "11", "8449683", "", "", "45.03677", "35.37789", "Europe/Simferopol"),
("709248", "Fastiv", "Фастов", "UA", "804", "13", "Fastiv Raion (undefined)", "", "", "50.0767", "29.9177", "Europe/Kiev"),
("709276", "Energodar", "Энергодар", "UA", "804", "26", "", "", "", "47.49865", "34.6574", "Europe/Zaporozhye"),
("709334", "Dzhankoy", "Джанкой", "UA", "804", "11", "", "", "", "45.71168", "34.39274", "Europe/Simferopol"),
("709354", "Dzerzhyns'k", "Дзержинськ", "UA", "804", "05", "", "", "", "48.39869", "37.84787", "Europe/Kiev"),
("709429", "Dunaivtsi", "Дунаївці", "UA", "804", "09", "", "", "", "48.88909", "26.85636", "Europe/Kiev"),
("709540", "Dubno", "Дубно", "UA", "804", "19", "", "", "", "50.41694", "25.73432", "Europe/Kiev"),
("709611", "Drohobych", "Дрогобич", "UA", "804", "15", "", "", "", "49.34991", "23.50561", "Europe/Kiev"),
("709717", "Donetsk", "Донецк", "UA", "804", "05", "", "", "", "48.023", "37.80224", "Europe/Kiev"),
("709755", "Dolyna", "Долина", "UA", "804", "06", "709779", "", "", "48.9733", "24.00944", "Europe/Kiev"),
("709782", "Dolyns'ka", "Долинская", "UA", "804", "10", "", "", "", "48.11041", "32.76449", "Europe/Kiev"),
("709835", "Dokuchayevs'k", "Докучаевск", "UA", "804", "05", "", "", "", "47.74773", "37.67384", "Europe/Kiev"),
("709900", "Dobropillya", "Доброполье", "UA", "804", "05", "", "", "", "48.46147", "37.08524", "Europe/Kiev"),
("709930", "Dnipropetrovsk", "Днепропетровск", "UA", "804", "04", "", "", "", "48.45", "34.98333", "Europe/Kiev"),
("709932", "Dniprodzerzhyns'k", "Днепродзержинск", "UA", "804", "04", "", "", "", "48.51134", "34.6021", "Europe/Kiev"),
("709960", "Dniprorudne", "Дніпрорудне", "UA", "804", "26", "", "", "", "47.38169", "34.97652", "Europe/Zaporozhye"),
("710098", "Derhachi", "Дергачи", "UA", "804", "07", "", "", "", "50.10659", "36.12112", "Europe/Kiev"),
("710229", "Debal'tseve", "Дебальцево", "UA", "804", "05", "", "", "", "48.34072", "38.4049", "Europe/Kiev"),
("710374", "Chuhuyiv", "Чугуїв", "UA", "804", "07", "", "", "", "49.83588", "36.68803", "Europe/Kiev"),
("710400", "Chortkiv", "Чортков", "UA", "804", "22", "", "", "", "49.01709", "25.79804", "Europe/Kiev"),
("710548", "Chervonopartyzans'k", "Червонопартизанск", "UA", "804", "14", "", "", "", "48.07613", "39.79618", "Europe/Zaporozhye"),
("710554", "Chervonohrad", "Червоноград", "UA", "804", "15", "", "", "", "50.39105", "24.23514", "Europe/Kiev"),
("710719", "Chernivtsi", "Черновцы", "UA", "804", "03", "", "", "", "48.29149", "25.94034", "Europe/Kiev"),
("710735", "Chernihiv", "Чернигов", "UA", "804", "02", "", "", "", "51.50551", "31.28488", "Europe/Kiev"),
("710791", "Cherkasy", "Черкассы", "UA", "804", "01", "", "", "", "49.42854", "32.06207", "Europe/Kiev"),
("711350", "Bucha", "Буча", "UA", "804", "13", "", "", "", "50.54345", "30.21201", "Europe/Kiev"),
("711369", "Bryanka", "Брянка", "UA", "804", "14", "", "", "", "48.511", "38.67222", "Europe/Zaporozhye"),
("711390", "Brovary", "Бровары", "UA", "804", "13", "Brovary Raion (undefined)", "", "", "50.51809", "30.80671", "Europe/Kiev"),
("711416", "Brody", "Броды", "UA", "804", "15", "", "", "", "50.08791", "25.15027", "Europe/Kiev"),
("711515", "Boyarka", "Боярка", "UA", "804", "13", "", "", "", "50.3191", "30.29728", "Europe/Kiev"),
("711660", "Boryspil'", "Борисполь", "UA", "804", "13", "", "", "", "50.35269", "30.95501", "Europe/Kiev"),
("711669", "Boryslav", "Борислав", "UA", "804", "15", "", "", "", "49.28672", "23.43238", "Europe/Kiev"),
("711841", "Bolhrad", "Болград", "UA", "804", "17", "", "", "", "45.68262", "28.61487", "Europe/Kiev"),
("711867", "Bohuslav", "Богуслав", "UA", "804", "13", "", "", "", "49.54939", "30.8744", "Europe/Kiev"),
("711894", "Bohodukhiv", "Богодухів", "UA", "804", "07", "", "", "", "50.16466", "35.52765", "Europe/Kiev"),
("712160", "Bilhorod-Dnistrovs'kyy", "Белгород-Днестровский", "UA", "804", "17", "", "", "", "46.1952", "30.34938", "Europe/Kiev"),
("712165", "Bila Tserkva", "Белая Церковь", "UA", "804", "13", "", "", "", "49.80939", "30.11209", "Europe/Kiev"),
("712374", "Berezhani", "Бережаны", "UA", "804", "22", "", "", "", "49.45", "24.93333", "Europe/Kiev"),
("712423", "Berehove", "Берегово", "UA", "804", "25", "", "", "", "48.20555", "22.64418", "Europe/Uzhgorod"),
("712441", "Berdychiv", "Бердичев", "UA", "804", "27", "", "", "", "49.89928", "28.60235", "Europe/Kiev"),
("712451", "Berdyans'k", "Бердянск", "UA", "804", "26", "", "", "", "46.7663", "36.79882", "Europe/Zaporozhye"),
("712559", "Bilopillya", "Білопілля", "UA", "804", "21", "", "", "", "51.15016", "34.31287", "Europe/Kiev"),
("712587", "Bilohirs'k", "Белогорск", "UA", "804", "11", "", "", "", "45.05462", "34.60185", "Europe/Simferopol"),
("712861", "Bar", "Бар", "UA", "804", "23", "", "", "", "49.07717", "27.68256", "Europe/Kiev"),
("712886", "Balta", "Балта", "UA", "804", "17", "", "", "", "47.93548", "29.61982", "Europe/Kiev"),
("712926", "Balakliya", "Балаклея", "UA", "804", "07", "", "", "", "49.4627", "36.85951", "Europe/Kiev"),
("712930", "Balaklava", "Балаклава", "UA", "804", "20", "", "", "", "44.51428", "33.60013", "Europe/Simferopol"),
("712967", "Bakhmach", "Бахмач", "UA", "804", "02", "", "", "", "51.18144", "32.83463", "Europe/Kiev"),
("712969", "Bakhchysaray", "Бахчисарай", "UA", "804", "11", "", "", "", "44.75525", "33.85782", "Europe/Simferopol"),
("713122", "Avdiyivka", "Авдеевка", "UA", "804", "05", "", "", "", "48.13989", "37.74255", "Europe/Kiev"),
("713163", "Artsyz", "Арциз", "UA", "804", "17", "", "", "", "45.99194", "29.41824", "Europe/Kiev"),
("713174", "Artemivs'k", "Артемовск", "UA", "804", "05", "", "", "", "48.59559", "37.99987", "Europe/Kiev"),
("713203", "Armyans'k", "Армянск", "UA", "804", "11", "8449689", "", "", "46.10919", "33.69206", "Europe/Simferopol"),
("713245", "Apostolove", "Апостолово", "UA", "804", "04", "", "", "", "47.66003", "33.71369", "Europe/Kiev"),
("713259", "Antratsyt", "Антрацит", "UA", "804", "14", "", "", "", "48.11503", "39.09128", "Europe/Zaporozhye"),
("713504", "Amvrosiyivka", "Амвросиевка", "UA", "804", "05", "", "", "", "47.79348", "38.47768", "Europe/Kiev"),
("713513", "Alushta", "Алушта", "UA", "804", "11", "", "", "", "44.67631", "34.40778", "Europe/Simferopol"),
("713716", "Alchevs'k", "Алчевск", "UA", "804", "14", "", "", "", "48.46893", "38.81669", "Europe/Zaporozhye"),
("713749", "Okhtyrka", "Охтирка", "UA", "804", "21", "", "", "", "50.31036", "34.89879", "Europe/Kiev"),
("6559559", "Komsomolsk", "Комсомольск", "UA", "804", "18", "", "", "", "49.01018", "33.63567", "Europe/Kiev"),
("6930327", "Slavutich", "Славутич", "UA", "804", "13", "", "", "", "51.51964", "30.73434", "Europe/Kiev"),
("7525990", "Yuzhnoukrains'k", "Южноукраинск", "UA", "804", "16", "", "", "", "47.81777", "31.18263", "Europe/Kiev"),
("8468760", "Novoyavorivs'k", "Новояворовск", "UA", "804", "15", "", "", "", "49.93023", "23.57357", "Europe/Kiev"),
("225835", "Yumbe", "", "UG", "800", "N", "97", "", "", "3.46506", "31.24689", "Africa/Kampala"),
("225858", "Wobulenzi", "", "UG", "800", "C", "70", "", "", "0.72833", "32.51222", "Africa/Kampala"),
("225964", "Wakiso", "", "UG", "800", "C", "96", "", "", "0.40444", "32.45944", "Africa/Kampala"),
("226110", "Tororo", "Тороро", "UG", "800", "E", "76", "", "", "0.69299", "34.18085", "Africa/Kampala"),
("226234", "Soroti", "", "UG", "800", "E", "95", "", "", "1.71464", "33.61113", "Africa/Kampala"),
("226823", "Pallisa", "Паллиса", "UG", "800", "E", "60", "", "", "1.145", "33.70944", "Africa/Kampala"),
("226853", "Paidha", "", "UG", "800", "N", "H7", "", "", "2.41669", "30.98551", "Africa/Kampala"),
("227528", "Nyachera", "", "UG", "800", "W", "59", "", "", "-0.9", "30.41667", "Africa/Kampala"),
("227592", "Ntungamo", "", "UG", "800", "W", "82", "", "", "-0.88333", "29.65", "Africa/Kampala"),
("227593", "Ntungamo", "", "UG", "800", "W", "59", "", "", "-0.87944", "30.26417", "Africa/Kampala"),
("227812", "Njeru", "", "UG", "800", "C", "E7", "", "", "0.41861", "33.17306", "Africa/Kampala"),
("227904", "Nebbi", "", "UG", "800", "N", "58", "", "", "2.47826", "31.08894", "Africa/Kampala"),
("228227", "Namasuba", "", "UG", "800", "C", "D9", "", "", "0.68944", "32.42139", "Africa/Kampala"),
("228853", "Mukono", "", "UG", "800", "C", "90", "", "", "0.35333", "32.75528", "Africa/Kampala"),
("228971", "Mubende", "", "UG", "800", "C", "56", "", "", "0.55849", "31.39489", "Africa/Kampala"),
("229059", "Moyo", "", "UG", "800", "N", "72", "", "", "3.66088", "31.72474", "Africa/Kampala"),
("229139", "Mityana", "Митьяна", "UG", "800", "C", "D8", "", "", "0.4175", "32.02278", "Africa/Kampala"),
("229268", "Mbarara", "Мбарара", "UG", "800", "W", "52", "", "", "-0.60467", "30.64851", "Africa/Kampala"),
("229278", "Mbale", "Мбале", "UG", "800", "E", "87", "", "", "1.08209", "34.17503", "Africa/Kampala"),
("229362", "Masindi", "Масинди", "UG", "800", "W", "50", "", "", "1.67444", "31.715", "Africa/Kampala"),
("229380", "Masaka", "Масаки", "UG", "800", "C", "", "", "", "-0.33379", "31.73409", "Africa/Kampala"),
("229746", "Luwero", "", "UG", "800", "C", "70", "", "", "0.84917", "32.47306", "Africa/Kampala"),
("229911", "Lugazi", "", "UG", "800", "C", "18", "", "", "0.37722", "32.91972", "Africa/Kampala"),
("230166", "Lira", "Лира", "UG", "800", "N", "47", "", "", "2.2499", "32.89985", "Africa/Kampala"),
("230299", "Kyenjojo", "", "UG", "800", "W", "85", "", "", "0.63278", "30.62139", "Africa/Kampala"),
("230617", "Kotido", "", "UG", "800", "N", "45", "", "", "2.98056", "34.13306", "Africa/Kampala"),
("230893", "Kitgum", "Китгум", "UG", "800", "N", "84", "", "", "3.27833", "32.88667", "Africa/Kampala"),
("231139", "Kireka", "", "UG", "800", "C", "96", "", "", "0.3475", "32.64917", "Africa/Kampala"),
("231696", "Kayunga", "", "UG", "800", "C", "83", "", "", "0.7025", "32.88861", "Africa/Kampala"),
("232066", "Kasese", "Касесе", "UG", "800", "W", "40", "", "", "0.18333", "30.08333", "Africa/Kampala"),
("232371", "Kamwenge", "", "UG", "800", "W", "81", "", "", "0.1866", "30.45393", "Africa/Kampala"),
("232422", "Kampala", "Кампала", "UG", "800", "C", "37", "", "", "0.31628", "32.58219", "Africa/Kampala"),
("233070", "Kabale", "Кабале", "UG", "800", "W", "34", "", "", "-1.24857", "29.98993", "Africa/Kampala"),
("233114", "Jinja", "Джинджа", "UG", "800", "E", "33", "", "", "0.43902", "33.20317", "Africa/Kampala"),
("233275", "Iganga", "", "UG", "800", "E", "78", "", "", "0.60917", "33.46861", "Africa/Kampala"),
("233312", "Hoima", "", "UG", "800", "W", "31", "", "", "1.43314", "31.35241", "Africa/Kampala"),
("233346", "Gulu", "Гул", "UG", "800", "N", "30", "", "", "2.77457", "32.29899", "Africa/Kampala"),
("233476", "Fort Portal", "Форт-Портал", "UG", "800", "W", "79", "", "", "0.66174", "30.2748", "Africa/Kampala"),
("233508", "Entebbe", "Энтеббе", "UG", "800", "C", "96", "", "", "0.06444", "32.44694", "Africa/Kampala"),
("233730", "Bwizibwera", "", "UG", "800", "W", "52", "", "", "-0.59167", "30.62861", "Africa/Kampala"),
("233886", "Buwenge", "", "UG", "800", "E", "33", "", "", "0.64222", "33.17444", "Africa/Kampala"),
("234077", "Busia", "", "UG", "800", "E", "67", "", "", "0.46588", "34.09221", "Africa/Kampala"),
("234092", "Busembatia", "", "UG", "800", "E", "78", "", "", "0.76972", "33.61306", "Africa/Kampala"),
("234178", "Bundibugyo", "", "UG", "800", "W", "28", "", "", "0.71117", "30.06469", "Africa/Kampala"),
("234565", "Bugiri", "", "UG", "800", "E", "66", "", "", "0.57139", "33.74167", "Africa/Kampala"),
("235039", "Arua", "Аруа", "UG", "800", "N", "77", "", "", "3.02013", "30.91105", "Africa/Kampala"),
("235489", "Adjumani", "", "UG", "800", "N", "65", "", "", "3.37786", "31.7909", "Africa/Kampala"),
("4046704", "Fort Hunt", "", "US", "840", "VA", "059", "", "", "38.73289", "-77.05803", "America/New_York"),
("4048023", "Bessemer", "", "US", "840", "AL", "073", "", "", "33.40178", "-86.95444", "America/Chicago"),
("4048662", "Paducah", "", "US", "840", "KY", "145", "", "", "37.08339", "-88.60005", "America/Chicago"),
("4049979", "Birmingham", "Бирмингем", "US", "840", "AL", "073", "", "", "33.52066", "-86.80249", "America/Chicago"),
("4054378", "Center Point", "", "US", "840", "AL", "073", "", "", "33.64566", "-86.6836", "America/Chicago"),
("4058219", "Daphne", "", "US", "840", "AL", "003", "", "", "30.60353", "-87.9036", "America/Chicago"),
("4058553", "Decatur", "", "US", "840", "AL", "103", "", "", "34.60593", "-86.98334", "America/Chicago"),
("4059102", "Dothan", "", "US", "840", "AL", "069", "", "", "31.22323", "-85.39049", "America/Chicago"),
("4059870", "East Florence", "", "US", "840", "AL", "077", "", "", "34.80953", "-87.64947", "America/Chicago"),
("4060791", "Enterprise", "", "US", "840", "AL", "031", "", "", "31.31517", "-85.85522", "America/Chicago"),
("4061234", "Fairhope", "", "US", "840", "AL", "003", "", "", "30.52297", "-87.90333", "America/Chicago"),
("4062577", "Florence", "Флоренция", "US", "840", "AL", "077", "", "", "34.79981", "-87.67725", "America/Chicago"),
("4063619", "Gadsden", "", "US", "840", "AL", "055", "", "", "34.01426", "-86.00664", "America/Chicago"),
("4066811", "Helena", "Хелена", "US", "840", "AL", "117", "", "", "33.29622", "-86.8436", "America/Chicago"),
("4067927", "Homewood", "Хомвуд", "US", "840", "AL", "073", "", "", "33.47177", "-86.80082", "America/Chicago"),
("4067994", "Hoover", "Гувер", "US", "840", "AL", "073", "", "", "33.40539", "-86.81138", "America/Chicago"),
("4068446", "Hueytown", "", "US", "840", "AL", "073", "", "", "33.45122", "-86.99666", "America/Chicago"),
("4068590", "Huntsville", "Хантсвилл", "US", "840", "AL", "089", "", "", "34.73037", "-86.5861", "America/Chicago"),
("4074267", "Madison", "Мадисон", "US", "840", "AL", "089", "", "", "34.69926", "-86.74833", "America/Chicago"),
("4076598", "Mobile", "Мобил", "US", "840", "AL", "097", "", "", "30.69436", "-88.04305", "America/Chicago"),
("4076784", "Montgomery", "Монтгомери", "US", "840", "AL", "101", "", "", "32.36681", "-86.29997", "America/Chicago"),
("4078646", "Mountain Brook", "", "US", "840", "AL", "073", "", "", "33.50094", "-86.75221", "America/Chicago"),
("4080555", "Northport", "", "US", "840", "AL", "125", "", "", "33.22901", "-87.57723", "America/Chicago"),
("4081644", "Opelika", "", "US", "840", "AL", "081", "", "", "32.64541", "-85.37828", "America/Chicago"),
("4081914", "Oxford", "Оксфорд", "US", "840", "AL", "015", "", "", "33.61427", "-85.83496", "America/Chicago"),
("4082569", "Pelham", "", "US", "840", "AL", "117", "", "", "33.28567", "-86.80999", "America/Chicago"),
("4082866", "Phenix City", "", "US", "840", "AL", "113", "", "", "32.47098", "-85.00077", "America/New_York"),
("4084796", "Prattville", "", "US", "840", "AL", "001", "", "", "32.46402", "-86.4597", "America/Chicago"),
("4084888", "Prichard", "Причард", "US", "840", "AL", "097", "", "", "30.7388", "-88.07889", "America/Chicago"),
("4089114", "Selma", "Сельма", "US", "840", "AL", "047", "", "", "32.40736", "-87.0211", "America/Chicago"),
("4092788", "Talladega", "", "US", "840", "AL", "121", "", "", "33.43594", "-86.1058", "America/Chicago"),
("4093753", "Tillmans Corner", "", "US", "840", "AL", "097", "", "", "30.59019", "-88.17084", "America/Chicago"),
("4094163", "Troy", "Троя", "US", "840", "AL", "109", "", "", "31.80877", "-85.96995", "America/Chicago"),
("4094212", "Trussville", "", "US", "840", "AL", "073", "", "", "33.61983", "-86.60888", "America/Chicago"),
("4094455", "Tuscaloosa", "Таскалуса", "US", "840", "AL", "125", "", "", "33.20984", "-87.56917", "America/Chicago"),
("4095415", "Vestavia Hills", "", "US", "840", "AL", "073", "", "", "33.44872", "-86.78777", "America/Chicago"),
("4101114", "Bella Vista", "", "US", "840", "AR", "007", "", "", "36.4807", "-94.27134", "America/Chicago"),
("4101241", "Benton", "Бентон", "US", "840", "AR", "125", "", "", "34.56454", "-92.58683", "America/Chicago"),
("4101260", "Bentonville", "Бентонвилле", "US", "840", "AR", "007", "", "", "36.37285", "-94.20882", "America/Chicago"),
("4102412", "Blytheville", "Блайтвилл", "US", "840", "AR", "093", "", "", "35.9273", "-89.91898", "America/Chicago"),
("4103448", "Bryant", "", "US", "840", "AR", "125", "", "", "34.59593", "-92.48905", "America/Chicago"),
("4103957", "Cabot", "Кабот", "US", "840", "AR", "085", "", "", "34.97453", "-92.01653", "America/Chicago"),
("4106458", "Conway", "Конвей", "US", "840", "AR", "045", "", "", "35.0887", "-92.4421", "America/Chicago"),
("4109785", "El Dorado", "Эль-Дорадо", "US", "840", "AR", "139", "", "", "33.20763", "-92.66627", "America/Chicago"),
("4110486", "Fayetteville", "Фейетвилл", "US", "840", "AR", "143", "", "", "36.06258", "-94.15743", "America/Chicago"),
("4111382", "Forrest City", "Форрест-Сити", "US", "840", "AR", "123", "", "", "35.00815", "-90.78983", "America/Chicago"),
("4111410", "Fort Smith", "Форт-Смит", "US", "840", "AR", "131", "", "", "35.38592", "-94.39855", "America/Chicago"),
("4115412", "Hot Springs", "Хот-Спрингс", "US", "840", "AR", "051", "", "", "34.5037", "-93.05518", "America/Chicago"),
("4116315", "Jacksonville", "Джексонвилл", "US", "840", "AR", "119", "", "", "34.8662", "-92.11015", "America/Chicago"),
("4116834", "Jonesboro", "Джонсборо", "US", "840", "AR", "031", "", "", "35.8423", "-90.70428", "America/Chicago"),
("4119403", "Little Rock", "Литл-Рок", "US", "840", "AR", "119", "", "", "34.74648", "-92.28959", "America/Chicago"),
("4120792", "Maumelle", "", "US", "840", "AR", "119", "", "", "34.86676", "-92.40432", "America/Chicago"),
("4124112", "North Little Rock", "", "US", "840", "AR", "119", "", "", "34.76954", "-92.26709", "America/Chicago"),
("4125388", "Paragould", "Парагулд", "US", "840", "AR", "055", "", "", "36.0584", "-90.49733", "America/Chicago"),
("4126226", "Pine Bluff", "", "US", "840", "AR", "069", "", "", "34.22843", "-92.0032", "America/Chicago"),
("4128894", "Rogers", "Роджерс", "US", "840", "AR", "007", "", "", "36.33202", "-94.11854", "America/Chicago"),
("4129397", "Russellville", "", "US", "840", "AR", "115", "", "", "35.27842", "-93.13379", "America/Chicago"),
("4130430", "Searcy", "Серси", "US", "840", "AR", "145", "", "", "35.25064", "-91.73625", "America/Chicago"),
("4131116", "Siloam Springs", "Сайлом-Спрингс", "US", "840", "AR", "007", "", "", "36.18814", "-94.5405", "America/Chicago"),
("4132093", "Springdale", "Спрингдейл", "US", "840", "AR", "143", "", "", "36.18674", "-94.12881", "America/Chicago"),
("4133367", "Texarkana", "Тексаркана", "US", "840", "AR", "091", "", "", "33.44179", "-94.03769", "America/Chicago"),
("4134716", "Van Buren", "Ван-Бьюрен", "US", "840", "AR", "033", "", "", "35.43676", "-94.34827", "America/Chicago"),
("4135865", "West Memphis", "", "US", "840", "AR", "035", "", "", "35.14648", "-90.18454", "America/Chicago"),
("4140963", "Washington, D.C.", "Вашингтон", "US", "840", "DC", "001", "", "", "38.89511", "-77.03637", "America/New_York"),
("4141363", "Bear", "", "US", "840", "DE", "003", "", "", "39.62928", "-75.65826", "America/New_York"),
("4142290", "Dover", "Довер", "US", "840", "DE", "001", "", "", "39.15817", "-75.52437", "America/New_York"),
("4143637", "Middletown", "", "US", "840", "DE", "003", "", "", "39.44956", "-75.71632", "America/New_York"),
("4143861", "Newark", "Ньюарк", "US", "840", "DE", "003", "", "", "39.68372", "-75.74966", "America/New_York"),
("4145381", "Wilmington", "Уилмингтон", "US", "840", "DE", "003", "", "", "39.74595", "-75.54659", "America/New_York"),
("4145805", "Allapattah", "", "US", "840", "FL", "086", "", "", "25.81454", "-80.22394", "America/New_York"),
("4145941", "Altamonte Springs", "", "US", "840", "FL", "117", "", "", "28.66111", "-81.36562", "America/New_York"),
("4146166", "Apopka", "", "US", "840", "FL", "095", "", "", "28.68055", "-81.50952", "America/New_York"),
("4146429", "Aventura", "", "US", "840", "FL", "086", "", "", "25.95648", "-80.13921", "America/New_York"),
("4146723", "Bartow", "", "US", "840", "FL", "105", "", "", "27.89641", "-81.84314", "America/New_York"),
("4146901", "Bayonet Point", "", "US", "840", "FL", "101", "", "", "28.32667", "-82.68343", "America/New_York"),
("4146934", "Bayshore Gardens", "", "US", "840", "FL", "081", "", "", "27.42532", "-82.59038", "America/New_York"),
("4147241", "Belle Glade", "", "US", "840", "FL", "099", "", "", "26.68451", "-80.66756", "America/New_York"),
("4147290", "Bellview", "", "US", "840", "FL", "033", "", "", "30.46159", "-87.31497", "America/Chicago"),
("4148207", "Bloomingdale", "", "US", "840", "FL", "057", "", "", "27.89364", "-82.24037", "America/New_York"),
("4148399", "Boca Del Mar", "", "US", "840", "FL", "099", "", "", "26.34508", "-80.14671", "America/New_York"),
("4148411", "Boca Raton", "Бока-Ратон", "US", "840", "FL", "099", "", "", "26.35869", "-80.0831", "America/New_York"),
("4148533", "Bonita Springs", "", "US", "840", "FL", "071", "", "", "26.33981", "-81.7787", "America/New_York"),
("4148677", "Boynton Beach", "", "US", "840", "FL", "099", "", "", "26.52535", "-80.06643", "America/New_York"),
("4148708", "Bradenton", "", "US", "840", "FL", "081", "", "", "27.49893", "-82.57482", "America/New_York"),
("4148757", "Brandon", "Брэндон", "US", "840", "FL", "057", "", "", "27.9378", "-82.28592", "America/New_York"),
("4148803", "Brent", "", "US", "840", "FL", "033", "", "", "30.46881", "-87.23608", "America/Chicago"),
("4149077", "Brownsville", "", "US", "840", "FL", "086", "", "", "25.82176", "-80.24116", "America/New_York"),
("4149269", "Buenaventura Lakes", "", "US", "840", "FL", "097", "", "", "28.33584", "-81.35313", "America/New_York"),
("4149956", "Cantonment", "", "US", "840", "FL", "033", "", "", "30.60853", "-87.33998", "America/Chicago"),
("4149962", "Cape Coral", "", "US", "840", "FL", "071", "", "", "26.56285", "-81.94953", "America/New_York"),
("4150066", "Carol City", "", "US", "840", "FL", "086", "", "", "25.94065", "-80.2456", "America/New_York"),
("4150115", "Carrollwood", "", "US", "840", "FL", "057", "", "", "28.05002", "-82.49287", "America/New_York"),
("4150118", "Carrollwood Village", "", "US", "840", "FL", "057", "", "", "28.06752", "-82.52093", "America/New_York"),
("4150190", "Casselberry", "", "US", "840", "FL", "117", "", "", "28.67778", "-81.32785", "America/New_York"),
("4151157", "Citrus Park", "", "US", "840", "FL", "057", "", "", "28.07835", "-82.56982", "America/New_York"),
("4151316", "Clearwater", "Клируотер", "US", "840", "FL", "103", "", "", "27.96585", "-82.8001", "America/New_York"),
("4151352", "Clermont", "", "US", "840", "FL", "069", "", "", "28.54944", "-81.77285", "America/New_York"),
("4151440", "Cocoa", "Коко", "US", "840", "FL", "009", "", "", "28.38612", "-80.742", "America/New_York"),
("4151455", "Coconut Creek", "", "US", "840", "FL", "011", "", "", "26.25175", "-80.17894", "America/New_York"),
("4151460", "Coconut Grove", "", "US", "840", "FL", "086", "", "", "25.7126", "-80.25699", "America/New_York"),
("4151824", "Cooper City", "", "US", "840", "FL", "011", "", "", "26.05731", "-80.27172", "America/New_York"),
("4151871", "Coral Gables", "", "US", "840", "FL", "086", "", "", "25.72149", "-80.26838", "America/New_York"),
("4151909", "Coral Springs", "Корал-Спрингс", "US", "840", "FL", "011", "", "", "26.27119", "-80.2706", "America/New_York"),
("4151921", "Coral Terrace", "", "US", "840", "FL", "086", "", "", "25.74593", "-80.3045", "America/New_York"),
("4152064", "Country Walk", "", "US", "840", "FL", "086", "", "", "25.63399", "-80.43228", "America/New_York"),
("4152093", "Country Club", "", "US", "840", "FL", "086", "", "", "25.94815", "-80.317", "America/New_York"),
("4152311", "Crestview", "", "US", "840", "FL", "091", "", "", "30.76213", "-86.57051", "America/Chicago"),
("4152564", "Cutler", "", "US", "840", "FL", "086", "", "", "25.6151", "-80.31061", "America/New_York"),
("4152574", "Cutler Ridge", "", "US", "840", "FL", "086", "", "", "25.58066", "-80.34672", "America/New_York"),
("4152772", "Dania Beach", "", "US", "840", "FL", "011", "", "", "26.05231", "-80.14393", "America/New_York"),
("4152820", "Davie", "Дэви", "US", "840", "FL", "011", "", "", "26.06287", "-80.2331", "America/New_York"),
("4152872", "Daytona Beach", "Дейтона-Бич", "US", "840", "FL", "127", "", "", "29.21081", "-81.02283", "America/New_York"),
("4152890", "DeLand", "", "US", "840", "FL", "127", "", "", "29.02832", "-81.30312", "America/New_York"),
("4152926", "DeBary", "", "US", "840", "FL", "127", "", "", "28.88305", "-81.30868", "America/New_York"),
("4153071", "Deerfield Beach", "", "US", "840", "FL", "011", "", "", "26.31841", "-80.09977", "America/New_York"),
("4153132", "Delray Beach", "Делрей-Бич", "US", "840", "FL", "099", "", "", "26.46146", "-80.07282", "America/New_York"),
("4153146", "Deltona", "Делтона", "US", "840", "FL", "127", "", "", "28.90054", "-81.26367", "America/New_York"),
("4153471", "Doral", "", "US", "840", "FL", "086", "", "", "25.81954", "-80.35533", "America/New_York"),
("4153759", "Dunedin", "Данедин", "US", "840", "FL", "103", "", "", "28.01974", "-82.77177", "America/New_York"),
("4154008", "East Lake", "", "US", "840", "FL", "103", "", "", "28.11085", "-82.69482", "America/New_York"),
("4154047", "East Pensacola Heights", "", "US", "840", "FL", "033", "", "", "30.42881", "-87.17997", "America/Chicago"),
("4154205", "Edgewater", "", "US", "840", "FL", "127", "", "", "28.98888", "-80.90228", "America/New_York"),
("4154280", "Egypt Lake-Leto", "", "US", "840", "FL", "057", "", "", "28.01769", "-82.50619", "America/New_York"),
("4154489", "Ensley", "", "US", "840", "FL", "033", "", "", "30.51881", "-87.27275", "America/Chicago"),
("4154568", "Estero", "", "US", "840", "FL", "071", "", "", "26.43814", "-81.80675", "America/New_York"),
("4154606", "Eustis", "", "US", "840", "FL", "069", "", "", "28.85277", "-81.68535", "America/New_York"),
("4155017", "Ferry Pass", "", "US", "840", "FL", "033", "", "", "30.5102", "-87.21247", "America/Chicago"),
("4155529", "Flagami", "", "US", "840", "FL", "086", "", "", "25.76232", "-80.31616", "America/New_York"),
("4155726", "Florida Ridge", "", "US", "840", "FL", "061", "", "", "27.58031", "-80.38672", "America/New_York"),
("4155966", "Fort Lauderdale", "Форт-Лодердейл", "US", "840", "FL", "011", "", "", "26.12231", "-80.14338", "America/New_York"),
("4155995", "Fort Myers", "", "US", "840", "FL", "071", "", "", "26.62168", "-81.84059", "America/New_York"),
("4156018", "Fort Pierce", "", "US", "840", "FL", "111", "", "", "27.44671", "-80.32561", "America/New_York"),
("4156042", "Fort Walton Beach", "", "US", "840", "FL", "091", "", "", "30.40576", "-86.61884", "America/Chicago"),
("4156091", "Fountainebleau", "", "US", "840", "FL", "086", "", "", "25.77288", "-80.34783", "America/New_York"),
("4156331", "Fruit Cove", "", "US", "840", "FL", "109", "", "", "30.11107", "-81.64176", "America/New_York"),
("4156404", "Gainesville", "Гейнсвилл", "US", "840", "FL", "001", "", "", "29.65163", "-82.32483", "America/New_York"),
("4156857", "Glenvar Heights", "", "US", "840", "FL", "086", "", "", "25.7076", "-80.32561", "America/New_York"),
("4156920", "Golden Gate", "", "US", "840", "FL", "021", "", "", "26.18787", "-81.69509", "America/New_York"),
("4156931", "Golden Glades", "", "US", "840", "FL", "086", "", "", "25.91176", "-80.20033", "America/New_York"),
("4157467", "Greenacres City", "", "US", "840", "FL", "099", "", "", "26.62368", "-80.12532", "America/New_York"),
("4157827", "Haines City", "", "US", "840", "FL", "105", "", "", "28.11418", "-81.61785", "America/New_York"),
("4157898", "Hallandale Beach", "", "US", "840", "FL", "011", "", "", "25.9812", "-80.14838", "America/New_York"),
("4158476", "Hialeah", "Хайалиа", "US", "840", "FL", "086", "", "", "25.8576", "-80.27811", "America/New_York"),
("4158482", "Hialeah Gardens", "", "US", "840", "FL", "086", "", "", "25.8651", "-80.3245", "America/New_York"),
("4158865", "Holiday", "", "US", "840", "FL", "101", "", "", "28.18779", "-82.73955", "America/New_York"),
("4158928", "Hollywood", "Голливуд", "US", "840", "FL", "011", "", "", "26.0112", "-80.14949", "America/New_York"),
("4159050", "Homestead", "", "US", "840", "FL", "086", "", "", "25.46872", "-80.47756", "America/New_York"),
("4159553", "Immokalee", "", "US", "840", "FL", "021", "", "", "26.41869", "-81.4173", "America/New_York"),
("4159805", "Iona", "", "US", "840", "FL", "071", "", "", "26.52036", "-81.96398", "America/New_York"),
("4159896", "Ives Estates", "", "US", "840", "FL", "086", "", "", "25.96231", "-80.17671", "America/New_York"),
("4160021", "Jacksonville", "Джэксонвилл", "US", "840", "FL", "031", "", "", "30.33218", "-81.65565", "America/New_York"),
("4160023", "Jacksonville Beach", "", "US", "840", "FL", "031", "", "", "30.29469", "-81.39314", "America/New_York"),
("4160100", "Jasmine Estates", "", "US", "840", "FL", "101", "", "", "28.29306", "-82.6901", "America/New_York"),
("4160610", "Jupiter", "Юпитер", "US", "840", "FL", "099", "", "", "26.93422", "-80.09421", "America/New_York"),
("4160705", "Kendale Lakes", "", "US", "840", "FL", "086", "", "", "25.70816", "-80.407", "America/New_York"),
("4160711", "Kendall", "Кендалл", "US", "840", "FL", "086", "", "", "25.67927", "-80.31727", "America/New_York"),
("4160812", "Key West", "Ки-Уэст", "US", "840", "FL", "087", "", "", "24.5557", "-81.78259", "America/New_York"),
("4160822", "Keystone", "", "US", "840", "FL", "057", "", "", "28.15585", "-82.62121", "America/New_York"),
("4160983", "Kissimmee", "Киссимми", "US", "840", "FL", "097", "", "", "28.30468", "-81.41667", "America/New_York"),
("4161178", "Lake Butler", "", "US", "840", "FL", "095", "", "", "28.50167", "-81.54091", "America/New_York"),
("4161313", "Lake Magdalene", "", "US", "840", "FL", "057", "", "", "28.07418", "-82.47176", "America/New_York"),
("4161422", "Lake Worth", "", "US", "840", "FL", "099", "", "", "26.6159", "-80.05699", "America/New_York"),
("4161424", "Lake Worth Corridor", "", "US", "840", "FL", "099", "", "", "26.61649", "-80.10102", "America/New_York"),
("4161438", "Lakeland", "", "US", "840", "FL", "105", "", "", "28.03947", "-81.9498", "America/New_York"),
("4161461", "Lakeside", "", "US", "840", "FL", "019", "", "", "30.12996", "-81.76815", "America/New_York"),
("4161534", "Land O' Lakes", "", "US", "840", "FL", "101", "", "", "28.2189", "-82.45759", "America/New_York"),
("4161580", "Largo", "", "US", "840", "FL", "103", "", "", "27.90947", "-82.78732", "America/New_York"),
("4161616", "Lauderdale Lakes", "", "US", "840", "FL", "011", "", "", "26.16647", "-80.20838", "America/New_York"),
("4161625", "Lauderhill", "", "US", "840", "FL", "011", "", "", "26.14036", "-80.21338", "America/New_York"),
("4161705", "Lealman", "", "US", "840", "FL", "103", "", "", "27.82114", "-82.67927", "America/New_York"),
("4161771", "Leesburg", "", "US", "840", "FL", "069", "", "", "28.81082", "-81.87786", "America/New_York"),
("4161785", "Lehigh Acres", "", "US", "840", "FL", "071", "", "", "26.62535", "-81.6248", "America/New_York"),
("4161797", "Leisure City", "", "US", "840", "FL", "086", "", "", "25.49539", "-80.42922", "America/New_York"),
("4163033", "Lutz", "Лутц", "US", "840", "FL", "057", "", "", "28.15112", "-82.46148", "America/New_York"),
("4163049", "Lynn Haven", "", "US", "840", "FL", "005", "", "", "30.24548", "-85.64826", "America/Chicago"),
("4163220", "Maitland", "", "US", "840", "FL", "095", "", "", "28.62778", "-81.36312", "America/New_York"),
("4163407", "Margate", "", "US", "840", "FL", "011", "", "", "26.24453", "-80.20644", "America/New_York"),
("4163918", "Meadow Woods", "", "US", "840", "FL", "095", "", "", "28.38556", "-81.36646", "America/New_York"),
("4163971", "Melbourne", "Мельбурн", "US", "840", "FL", "009", "", "", "28.08363", "-80.60811", "America/New_York"),
("4164092", "Merritt Island", "", "US", "840", "FL", "009", "", "", "28.53917", "-80.672", "America/New_York"),
("4164138", "Miami", "Майами", "US", "840", "FL", "086", "", "", "25.77427", "-80.19366", "America/New_York"),
("4164143", "Miami Beach", "Майами-Бич", "US", "840", "FL", "086", "", "", "25.79065", "-80.13005", "America/New_York"),
("4164167", "Miami Gardens", "", "US", "840", "FL", "086", "", "", "25.94204", "-80.2456", "America/New_York"),
("4164186", "Miami Lakes", "", "US", "840", "FL", "086", "", "", "25.90871", "-80.30866", "America/New_York"),
("4164601", "Miramar", "Мирамар", "US", "840", "FL", "011", "", "", "25.98731", "-80.23227", "America/New_York"),
("4165519", "Myrtle Grove", "", "US", "840", "FL", "033", "", "", "30.42103", "-87.30747", "America/Chicago"),
("4165565", "Naples", "Неаполь", "US", "840", "FL", "021", "", "", "26.14204", "-81.79481", "America/New_York"),
("4165637", "Navarre", "", "US", "840", "FL", "113", "", "", "30.40159", "-86.86357", "America/Chicago"),
("4165913", "New Smyrna Beach", "", "US", "840", "FL", "127", "", "", "29.02582", "-80.927", "America/New_York"),
("4166066", "Norland", "Норланд", "US", "840", "FL", "086", "", "", "25.94898", "-80.21227", "America/New_York"),
("4166195", "North Fort Myers", "", "US", "840", "FL", "071", "", "", "26.66729", "-81.88009", "America/New_York"),
("4166222", "North Lauderdale", "", "US", "840", "FL", "011", "", "", "26.2173", "-80.22588", "America/New_York"),
("4166232", "North Miami", "", "US", "840", "FL", "086", "", "", "25.89009", "-80.18671", "America/New_York"),
("4166233", "North Miami Beach", "", "US", "840", "FL", "086", "", "", "25.93315", "-80.16255", "America/New_York"),
("4166274", "North Port", "", "US", "840", "FL", "115", "", "", "27.04422", "-82.23593", "America/New_York"),
("4166583", "Oak Ridge", "", "US", "840", "FL", "095", "", "", "28.47112", "-81.42452", "America/New_York"),
("4166638", "Oakland Park", "", "US", "840", "FL", "011", "", "", "26.17231", "-80.13199", "America/New_York"),
("4166673", "Ocala", "Окала", "US", "840", "FL", "083", "", "", "29.1872", "-82.14009", "America/New_York"),
("4166776", "Ocoee", "", "US", "840", "FL", "095", "", "", "28.56917", "-81.54396", "America/New_York"),
("4166805", "Ojus", "", "US", "840", "FL", "086", "", "", "25.94843", "-80.1506", "America/New_York"),
("4167003", "Opa-locka", "", "US", "840", "FL", "086", "", "", "25.90232", "-80.25033", "America/New_York"),
("4167147", "Orlando", "Орландо", "US", "840", "FL", "095", "", "", "28.53834", "-81.37924", "America/New_York"),
("4167178", "Ormond Beach", "", "US", "840", "FL", "127", "", "", "29.28581", "-81.05589", "America/New_York"),
("4167348", "Oviedo", "Овьедо", "US", "840", "FL", "117", "", "", "28.67", "-81.20812", "America/New_York"),
("4167424", "Pace", "", "US", "840", "FL", "113", "", "", "30.59936", "-87.16108", "America/Chicago"),
("4167499", "Palm Bay", "Палм-Бей", "US", "840", "FL", "009", "", "", "28.03446", "-80.58866", "America/New_York"),
("4167519", "Palm Beach Gardens", "", "US", "840", "FL", "099", "", "", "26.82339", "-80.13865", "America/New_York"),
("4167536", "Palm City", "", "US", "840", "FL", "085", "", "", "27.16783", "-80.26616", "America/New_York"),
("4167538", "Palm Coast", "", "US", "840", "FL", "035", "", "", "29.58497", "-81.20784", "America/New_York"),
("4167545", "Palm Harbor", "", "US", "840", "FL", "103", "", "", "28.07807", "-82.76371", "America/New_York"),
("4167583", "Palm Springs", "Палм Спрингс", "US", "840", "FL", "099", "", "", "26.6359", "-80.09615", "America/New_York"),
("4167601", "Palm Valley", "", "US", "840", "FL", "109", "", "", "30.17746", "-81.38758", "America/New_York"),
("4167634", "Palmetto Bay", "", "US", "840", "FL", "086", "", "", "25.62177", "-80.32477", "America/New_York"),
("4167694", "Panama City", "Панама", "US", "840", "FL", "005", "", "", "30.15946", "-85.65983", "America/Chicago"),
("4167829", "Parkland", "", "US", "840", "FL", "011", "", "", "26.31008", "-80.23727", "America/New_York"),
("4168139", "Pembroke Pines", "Пемброк-Пайнс", "US", "840", "FL", "011", "", "", "26.00315", "-80.22394", "America/New_York"),
("4168228", "Pensacola", "Пенсакола", "US", "840", "FL", "033", "", "", "30.42131", "-87.21691", "America/Chicago"),
("4168459", "Pine Hills", "", "US", "840", "FL", "095", "", "", "28.55778", "-81.4534", "America/New_York"),
("4168590", "Pinecrest", "", "US", "840", "FL", "086", "", "", "25.66705", "-80.30811", "America/New_York"),
("4168630", "Pinellas Park", "", "US", "840", "FL", "103", "", "", "27.8428", "-82.69954", "America/New_York"),
("4168659", "Pinewood", "", "US", "840", "FL", "086", "", "", "25.86898", "-80.21699", "America/New_York"),
("4168773", "Plant City", "", "US", "840", "FL", "057", "", "", "28.01863", "-82.11286", "America/New_York"),
("4168782", "Plantation", "Плантация", "US", "840", "FL", "011", "", "", "26.13421", "-80.23184", "America/New_York"),
("4168930", "Poinciana", "", "US", "840", "FL", "097", "", "", "28.14029", "-81.45841", "America/New_York"),
("4169014", "Pompano Beach", "", "US", "840", "FL", "011", "", "", "26.23786", "-80.12477", "America/New_York"),
("4169060", "Ponte Vedra Beach", "Понте-Ведра-Бич", "US", "840", "FL", "109", "", "", "30.23969", "-81.38564", "America/New_York"),
("4169130", "Port Charlotte", "Порт-Шарлотт", "US", "840", "FL", "015", "", "", "26.97617", "-82.09064", "America/New_York"),
("4169156", "Port Orange", "", "US", "840", "FL", "127", "", "", "29.13832", "-80.99561", "America/New_York"),
("4169171", "Port Saint Lucie", "", "US", "840", "FL", "111", "", "", "27.29393", "-80.35033", "America/New_York"),
("4169345", "Princeton", "Принстон", "US", "840", "FL", "086", "", "", "25.53844", "-80.40894", "America/New_York"),
("4169452", "Punta Gorda", "", "US", "840", "FL", "015", "", "", "26.92978", "-82.04537", "America/New_York"),
("4169455", "Punta Gorda Isles", "", "US", "840", "FL", "015", "", "", "26.91756", "-82.07842", "America/New_York"),
("4170005", "Richmond West", "", "US", "840", "FL", "086", "", "", "25.6105", "-80.42971", "America/New_York"),
("4170156", "Riverview", "", "US", "840", "FL", "057", "", "", "27.86614", "-82.32648", "America/New_York"),
("4170174", "Riviera Beach", "", "US", "840", "FL", "099", "", "", "26.77534", "-80.0581", "America/New_York"),
("4170358", "Rockledge", "Рокледж", "US", "840", "FL", "009", "", "", "28.35084", "-80.72533", "America/New_York"),
("4170617", "Royal Palm Beach", "", "US", "840", "FL", "099", "", "", "26.7084", "-80.2306", "America/New_York"),
("4170688", "Ruskin", "", "US", "840", "FL", "057", "", "", "27.72086", "-82.43315", "America/New_York"),
("4170797", "Safety Harbor", "", "US", "840", "FL", "103", "", "", "27.99085", "-82.69316", "America/New_York"),
("4170965", "Saint Cloud", "", "US", "840", "FL", "097", "", "", "28.2489", "-81.28118", "America/New_York"),
("4171563", "Saint Petersburg", "", "US", "840", "FL", "103", "", "", "27.77086", "-82.67927", "America/New_York"),
("4171782", "San Carlos Park", "", "US", "840", "FL", "071", "", "", "26.4673", "-81.80147", "America/New_York"),
("4172086", "Sanford", "", "US", "840", "FL", "117", "", "", "28.80055", "-81.27312", "America/New_York"),
("4172131", "Sarasota", "Сарасота", "US", "840", "FL", "115", "", "", "27.33643", "-82.53065", "America/New_York"),
("4172372", "Sebastian", "", "US", "840", "FL", "061", "", "", "27.81642", "-80.47061", "America/New_York"),
("4172434", "Seminole", "", "US", "840", "FL", "103", "", "", "27.83975", "-82.79121", "America/New_York"),
("4173392", "South Bradenton", "", "US", "840", "FL", "081", "", "", "27.4631", "-82.58176", "America/New_York"),
("4173497", "South Miami Heights", "", "US", "840", "FL", "086", "", "", "25.59761", "-80.38061", "America/New_York"),
("4173600", "Southchase", "", "US", "840", "FL", "095", "", "", "28.39306", "-81.3834", "America/New_York"),
("4173838", "Spring Hill", "Спринг-Хилл", "US", "840", "FL", "053", "", "", "28.47688", "-82.52546", "America/New_York"),
("4174201", "Stuart", "", "US", "840", "FL", "085", "", "", "27.19755", "-80.25283", "America/New_York"),
("4174317", "Sun City Center", "", "US", "840", "FL", "057", "", "", "27.71809", "-82.35176", "America/New_York"),
("4174383", "Sunny Isles Beach", "", "US", "840", "FL", "086", "", "", "25.95065", "-80.12282", "America/New_York"),
("4174402", "Sunrise", "", "US", "840", "FL", "011", "", "", "26.15767", "-80.28611", "America/New_York"),
("4174425", "Sunset", "", "US", "840", "FL", "086", "", "", "25.70594", "-80.35228", "America/New_York"),
("4174715", "Tallahassee", "Таллахасси", "US", "840", "FL", "073", "", "", "30.43826", "-84.28073", "America/New_York"),
("4174738", "Tamarac", "", "US", "840", "FL", "011", "", "", "26.21286", "-80.24977", "America/New_York"),
("4174744", "Tamiami", "", "US", "840", "FL", "086", "", "", "25.75871", "-80.39839", "America/New_York"),
("4174757", "Tampa", "Тампа", "US", "840", "FL", "057", "", "", "27.94752", "-82.45843", "America/New_York"),
("4174855", "Tarpon Springs", "", "US", "840", "FL", "103", "", "", "28.14612", "-82.75677", "America/New_York"),
("4174969", "Temple Terrace", "", "US", "840", "FL", "057", "", "", "28.0353", "-82.38926", "America/New_York"),
("4175091", "The Crossings", "", "US", "840", "FL", "086", "", "", "25.67066", "-80.40117", "America/New_York"),
("4175117", "The Hammocks", "", "US", "840", "FL", "086", "", "", "25.67149", "-80.4445", "America/New_York"),
("4175179", "The Villages", "", "US", "840", "FL", "119", "", "", "28.93408", "-81.95994", "America/New_York"),
("4175296", "Three Lakes", "", "US", "840", "FL", "086", "", "", "25.64205", "-80.39839", "America/New_York"),
("4175437", "Titusville", "Титусвилль", "US", "840", "FL", "009", "", "", "28.61222", "-80.80755", "America/New_York"),
("4175538", "Town 'n' Country", "", "US", "840", "FL", "057", "", "", "28.01057", "-82.57732", "America/New_York"),
("4176217", "University Park", "", "US", "840", "FL", "086", "", "", "25.74649", "-80.36755", "America/New_York"),
("4176318", "Valrico", "", "US", "840", "FL", "057", "", "", "27.93789", "-82.23644", "America/New_York"),
("4176380", "Venice", "Венеция", "US", "840", "FL", "115", "", "", "27.09978", "-82.45426", "America/New_York"),
("4176409", "Vero Beach", "", "US", "840", "FL", "061", "", "", "27.63864", "-80.39727", "America/New_York"),
("4177671", "Wekiwa Springs", "", "US", "840", "FL", "117", "", "", "28.69861", "-81.42563", "America/New_York"),
("4177703", "Wellington", "Веллингтон", "US", "840", "FL", "099", "", "", "26.65868", "-80.24144", "America/New_York"),
("4177727", "Wesley Chapel", "", "US", "840", "FL", "101", "", "", "28.23973", "-82.32787", "America/New_York"),
("4177779", "Westchase", "", "US", "840", "FL", "057", "", "", "28.05502", "-82.60982", "America/New_York"),
("4177865", "West Little River", "", "US", "840", "FL", "086", "", "", "25.85704", "-80.23699", "America/New_York"),
("4177872", "West Melbourne", "", "US", "840", "FL", "009", "", "", "28.07168", "-80.65339", "America/New_York"),
("4177887", "West Palm Beach", "Уэст-Палм-Бич", "US", "840", "FL", "099", "", "", "26.71534", "-80.05337", "America/New_York"),
("4177908", "West Pensacola", "", "US", "840", "FL", "033", "", "", "30.42659", "-87.27969", "America/Chicago"),
("4177960", "West and East Lealman", "", "US", "840", "FL", "103", "", "", "27.81993", "-82.68944", "America/New_York"),
("4177965", "Westchester", "Вестчестер", "US", "840", "FL", "086", "", "", "25.75482", "-80.32727", "America/New_York"),
("4178003", "Weston", "Уэстон", "US", "840", "FL", "011", "", "", "26.10037", "-80.39977", "America/New_York"),
("4178550", "Winter Garden", "", "US", "840", "FL", "095", "", "", "28.56528", "-81.58618", "America/New_York"),
("4178552", "Winter Haven", "", "US", "840", "FL", "105", "", "", "28.02224", "-81.73286", "America/New_York"),
("4178560", "Winter Park", "", "US", "840", "FL", "095", "", "", "28.6", "-81.33924", "America/New_York"),
("4178573", "Winter Springs", "", "US", "840", "FL", "117", "", "", "28.69889", "-81.30812", "America/New_York"),
("4178775", "Wright", "Райт", "US", "840", "FL", "091", "", "", "30.45575", "-86.63829", "America/Chicago"),
("4179074", "Acworth", "", "US", "840", "GA", "067", "", "", "34.06593", "-84.67688", "America/New_York"),
("4179320", "Albany", "Олбани", "US", "840", "GA", "095", "", "", "31.57851", "-84.15574", "America/New_York"),
("4179574", "Alpharetta", "Альфаретта", "US", "840", "GA", "121", "", "", "34.07538", "-84.29409", "America/New_York"),
("4179667", "Americus", "", "US", "840", "GA", "261", "", "", "32.07239", "-84.23269", "America/New_York"),
("4180386", "Athens", "Атенс", "US", "840", "GA", "059", "", "", "33.96095", "-83.37794", "America/New_York"),
("4180439", "Atlanta", "Атланта", "US", "840", "GA", "121", "", "", "33.749", "-84.38798", "America/New_York"),
("4180531", "Augusta", "Огаста", "US", "840", "GA", "245", "", "", "33.47097", "-81.97484", "America/New_York"),
("4181936", "Belvedere Park", "", "US", "840", "GA", "089", "", "", "33.75483", "-84.26742", "America/New_York"),
("4184845", "Brunswick", "Брауншвейг", "US", "840", "GA", "127", "", "", "31.14995", "-81.49149", "America/New_York"),
("4185657", "Calhoun", "", "US", "840", "GA", "129", "", "", "34.50259", "-84.95105", "America/New_York"),
("4186213", "Canton", "", "US", "840", "GA", "057", "", "", "34.23676", "-84.49076", "America/New_York"),
("4186416", "Carrollton", "", "US", "840", "GA", "045", "", "", "33.58011", "-85.07661", "America/New_York"),
("4186531", "Cartersville", "", "US", "840", "GA", "015", "", "", "34.1651", "-84.79994", "America/New_York"),
("4188985", "Columbus", "Коламбус", "US", "840", "GA", "215", "", "", "32.46098", "-84.98771", "America/New_York"),
("4189213", "Conyers", "", "US", "840", "GA", "247", "", "", "33.66761", "-84.01769", "America/New_York"),
("4190581", "Dalton", "Далтон", "US", "840", "GA", "313", "", "", "34.7698", "-84.97022", "America/New_York"),
("4191124", "Decatur", "Декейтер", "US", "840", "GA", "089", "", "", "33.77483", "-84.29631", "America/New_York"),
("4191955", "Douglasville", "", "US", "840", "GA", "097", "", "", "33.7515", "-84.74771", "America/New_York"),
("4192205", "Dublin", "Дублин", "US", "840", "GA", "175", "", "", "32.54044", "-82.90375", "America/New_York"),
("4192289", "Duluth", "Дулут", "US", "840", "GA", "135", "", "", "34.00288", "-84.14464", "America/New_York"),
("4192375", "Dunwoody", "Данвуди", "US", "840", "GA", "089", "", "", "33.94621", "-84.33465", "America/New_York"),
("4192674", "East Point", "", "US", "840", "GA", "121", "", "", "33.67955", "-84.43937", "America/New_York"),
("4193699", "Evans", "", "US", "840", "GA", "073", "", "", "33.53375", "-82.13067", "America/New_York"),
("4194474", "Fayetteville", "", "US", "840", "GA", "113", "", "", "33.44873", "-84.45493", "America/New_York"),
("4195701", "Forest Park", "", "US", "840", "GA", "063", "", "", "33.62205", "-84.36909", "America/New_York"),
("4196586", "Gainesville", "", "US", "840", "GA", "139", "", "", "34.29788", "-83.82407", "America/New_York"),
("4198322", "Griffin", "Гриффин", "US", "840", "GA", "255", "", "", "33.24678", "-84.26409", "America/New_York"),
("4200671", "Hinesville", "", "US", "840", "GA", "179", "", "", "31.84688", "-81.59595", "America/New_York"),
("4203696", "Kennesaw", "Кеннесо", "US", "840", "GA", "067", "", "", "34.02343", "-84.61549", "America/New_York"),
("4204007", "Kingsland", "", "US", "840", "GA", "039", "", "", "30.79996", "-81.68983", "America/New_York"),
("4204230", "La Grange", "", "US", "840", "GA", "285", "", "", "33.03929", "-85.03133", "America/New_York"),
("4205196", "Lawrenceville", "", "US", "840", "GA", "135", "", "", "33.95621", "-83.98796", "America/New_York"),
("4205885", "Lithia Springs", "", "US", "840", "GA", "097", "", "", "33.794", "-84.66049", "America/New_York"),
("4207226", "Mableton", "", "US", "840", "GA", "067", "", "", "33.81574", "-84.56194", "America/New_York"),
("4207400", "Macon", "Макон", "US", "840", "GA", "021", "", "", "32.84069", "-83.6324", "America/New_York"),
("4207783", "Marietta", "Мариетта", "US", "840", "GA", "067", "", "", "33.9526", "-84.54993", "America/New_York"),
("4207981", "Martinez", "Мартинес", "US", "840", "GA", "073", "", "", "33.51736", "-82.07567", "America/New_York"),
("4208442", "McDonough", "", "US", "840", "GA", "151", "", "", "33.44734", "-84.14686", "America/New_York"),
("4209448", "Milledgeville", "", "US", "840", "GA", "009", "", "", "33.08014", "-83.2321", "America/New_York"),
("4212684", "Newnan", "", "US", "840", "GA", "077", "", "", "33.38067", "-84.79966", "America/New_York"),
("4212937", "North Atlanta", "", "US", "840", "GA", "089", "", "", "33.8651", "-84.33659", "America/New_York"),
("4212992", "North Decatur", "", "US", "840", "GA", "089", "", "", "33.79038", "-84.30603", "America/New_York"),
("4212995", "North Druid Hills", "", "US", "840", "GA", "089", "", "", "33.81677", "-84.31326", "America/New_York"),
("4215110", "Peachtree City", "", "US", "840", "GA", "113", "", "", "33.39678", "-84.59576", "America/New_York"),
("4216948", "Pooler", "", "US", "840", "GA", "051", "", "", "32.11548", "-81.24706", "America/New_York"),
("4218165", "Redan", "Редан", "US", "840", "GA", "089", "", "", "33.74538", "-84.13158", "America/New_York"),
("4219001", "Riverdale", "", "US", "840", "GA", "063", "", "", "33.57261", "-84.41326", "America/New_York"),
("4219762", "Rome", "", "US", "840", "GA", "115", "", "", "34.25704", "-85.16467", "America/New_York"),
("4219934", "Roswell", "", "US", "840", "GA", "121", "", "", "34.02316", "-84.36159", "America/New_York"),
("4220629", "Saint Marys", "", "US", "840", "GA", "039", "", "", "30.73051", "-81.54649", "America/New_York"),
("4221333", "Sandy Springs", "", "US", "840", "GA", "121", "", "", "33.92427", "-84.37854", "America/New_York"),
("4221552", "Savannah", "Саванна", "US", "840", "GA", "051", "", "", "32.08354", "-81.09983", "America/New_York"),
("4223379", "Smyrna", "Смирна", "US", "840", "GA", "067", "", "", "33.88399", "-84.51438", "America/New_York"),
("4223413", "Snellville", "", "US", "840", "GA", "135", "", "", "33.85733", "-84.01991", "America/New_York"),
("4224413", "Statesboro", "", "US", "840", "GA", "031", "", "", "32.44879", "-81.78317", "America/New_York"),
("4224681", "Stockbridge", "", "US", "840", "GA", "151", "", "", "33.54428", "-84.23381", "America/New_York"),
("4225039", "Sugar Hill", "", "US", "840", "GA", "135", "", "", "34.10649", "-84.03352", "America/New_York"),
("4225309", "Suwanee", "", "US", "840", "GA", "135", "", "", "34.05149", "-84.0713", "America/New_York"),
("4226348", "Thomasville", "", "US", "840", "GA", "275", "", "", "30.83658", "-83.97878", "America/New_York"),
("4226552", "Tifton", "", "US", "840", "GA", "277", "", "", "31.45046", "-83.5085", "America/New_York"),
("4227213", "Tucker", "Такер", "US", "840", "GA", "089", "", "", "33.85455", "-84.21714", "America/New_York"),
("4227777", "Union City", "Юнион-Сити", "US", "840", "GA", "121", "", "", "33.58706", "-84.54243", "America/New_York"),
("4228147", "Valdosta", "Валдоста", "US", "840", "GA", "185", "", "", "30.8327", "-83.27849", "America/New_York"),
("4229476", "Warner Robins", "", "US", "840", "GA", "153", "", "", "32.62098", "-83.5999", "America/New_York"),
("4231354", "Wilmington Island", "", "US", "840", "GA", "051", "", "", "32.00355", "-80.97372", "America/New_York"),
("4231874", "Woodstock", "Вудсток", "US", "840", "GA", "057", "", "", "34.10149", "-84.51938", "America/New_York"),
("4232679", "Alton", "", "US", "840", "IL", "119", "", "", "38.8906", "-90.18428", "America/Chicago"),
("4233813", "Belleville", "Беллвилл", "US", "840", "IL", "163", "", "", "38.52005", "-89.98399", "America/Chicago"),
("4234969", "Cahokia", "", "US", "840", "IL", "163", "", "", "38.57088", "-90.19011", "America/Chicago"),
("4235193", "Carbondale", "", "US", "840", "IL", "077", "", "", "37.72727", "-89.21675", "America/Chicago"),
("4235668", "Charleston", "Чарлстон", "US", "840", "IL", "029", "", "", "39.49615", "-88.17615", "America/Chicago"),
("4236191", "Collinsville", "Коллинсвиль", "US", "840", "IL", "119", "", "", "38.67033", "-89.98455", "America/Chicago"),
("4236895", "Decatur", "Декейтер", "US", "840", "IL", "115", "", "", "39.84031", "-88.9548", "America/Chicago"),
("4237579", "East Saint Louis", "", "US", "840", "IL", "163", "", "", "38.6245", "-90.15094", "America/Chicago"),
("4237717", "Edwardsville", "", "US", "840", "IL", "119", "", "", "38.81144", "-89.95316", "America/Chicago"),
("4238132", "Fairview Heights", "", "US", "840", "IL", "163", "", "", "38.58894", "-89.99038", "America/Chicago"),
("4239509", "Godfrey", "", "US", "840", "IL", "119", "", "", "38.9556", "-90.18678", "America/Chicago"),
("4239714", "Granite City", "", "US", "840", "IL", "119", "", "", "38.70144", "-90.14872", "America/Chicago"),
("4241704", "Jacksonville", "Джексонвилл", "US", "840", "IL", "137", "", "", "39.73394", "-90.22901", "America/Chicago"),
("4243899", "Marion", "Мэрион", "US", "840", "IL", "199", "", "", "37.73061", "-88.93313", "America/Chicago"),
("4244099", "Mattoon", "", "US", "840", "IL", "029", "", "", "39.48309", "-88.37283", "America/Chicago"),
("4245152", "Mount Vernon", "", "US", "840", "IL", "081", "", "", "38.31727", "-88.90312", "America/Chicago"),
("4245926", "O'Fallon", "", "US", "840", "IL", "163", "", "", "38.59227", "-89.91121", "America/Chicago"),
("4247703", "Quincy", "Куинси", "US", "840", "IL", "001", "", "", "39.9356", "-91.40987", "America/Chicago"),
("4250542", "Springfield", "Спрингфилд", "US", "840", "IL", "167", "", "", "39.80172", "-89.64371", "America/Chicago"),
("4251841", "Upper Alton", "", "US", "840", "IL", "119", "", "", "38.91144", "-90.15066", "America/Chicago"),
("4254679", "Bloomington", "Блумингтон", "US", "840", "IN", "105", "", "", "39.16532", "-86.52639", "America/Indiana/Indianapolis"),
("4254957", "Broad Ripple", "", "US", "840", "IN", "097", "", "", "39.86671", "-86.14165", "America/Indiana/Indianapolis"),
("4255056", "Brownsburg", "", "US", "840", "IN", "063", "", "", "39.84338", "-86.39777", "America/Indiana/Indianapolis"),
("4255466", "Carmel", "Кармель", "US", "840", "IN", "057", "", "", "39.97837", "-86.11804", "America/Indiana/Indianapolis"),
("4255836", "Clarksville", "", "US", "840", "IN", "019", "", "", "38.29674", "-85.75996", "America/Kentucky/Louisville"),
("4256038", "Columbus", "Колумбус", "US", "840", "IN", "005", "", "", "39.20144", "-85.92138", "America/Indiana/Indianapolis"),
("4257227", "Evansville", "Эвансвилл", "US", "840", "IN", "163", "", "", "37.97476", "-87.55585", "America/Chicago"),
("4257494", "Fishers", "", "US", "840", "IN", "057", "", "", "39.95559", "-86.01387", "America/Indiana/Indianapolis"),
("4258285", "Greenfield", "Гринфилд", "US", "840", "IN", "059", "", "", "39.78504", "-85.76942", "America/Indiana/Indianapolis"),
("4258313", "Greenwood", "", "US", "840", "IN", "081", "", "", "39.61366", "-86.10665", "America/Indiana/Indianapolis"),
("4259418", "Indianapolis", "Индианаполис", "US", "840", "IN", "097", "", "", "39.76838", "-86.15804", "America/Indiana/Indianapolis"),
("4259640", "Jasper", "", "US", "840", "IN", "037", "", "", "38.39144", "-86.93111", "America/Indiana/Vincennes"),
("4259671", "Jeffersonville", "", "US", "840", "IN", "019", "", "", "38.27757", "-85.73718", "America/Kentucky/Louisville"),
("4260210", "Lawrence", "Лоуренс", "US", "840", "IN", "097", "", "", "39.83865", "-86.02526", "America/Indiana/Indianapolis"),
("4262045", "New Albany", "Нью-Албани", "US", "840", "IN", "043", "", "", "38.28562", "-85.82413", "America/Kentucky/Louisville"),
("4262072", "New Castle", "", "US", "840", "IN", "065", "", "", "39.92894", "-85.37025", "America/Indiana/Indianapolis"),
("4263108", "Plainfield", "", "US", "840", "IN", "063", "", "", "39.70421", "-86.39944", "America/Indiana/Indianapolis"),
("4263681", "Richmond", "Ричмонд", "US", "840", "IN", "177", "", "", "39.82894", "-84.89024", "America/Indiana/Indianapolis"),
("4264617", "Seymour", "", "US", "840", "IN", "071", "", "", "38.95922", "-85.89025", "America/Indiana/Indianapolis"),
("4264688", "Shelbyville", "", "US", "840", "IN", "145", "", "", "39.52144", "-85.77692", "America/Indiana/Indianapolis"),
("4265737", "Terre Haute", "Терре-Хот", "US", "840", "IN", "167", "", "", "39.4667", "-87.41391", "America/Indiana/Indianapolis"),
("4266307", "Vincennes", "", "US", "840", "IN", "083", "", "", "38.67727", "-87.52863", "America/Indiana/Vincennes"),
("4270356", "Derby", "", "US", "840", "KS", "173", "", "", "37.54557", "-97.26893", "America/Chicago"),
("4271086", "Emporia", "", "US", "840", "KS", "111", "", "", "38.4039", "-96.18166", "America/Chicago"),
("4271935", "Gardner", "Гарднер", "US", "840", "KS", "091", "", "", "38.81084", "-94.92719", "America/Chicago"),
("4272340", "Great Bend", "", "US", "840", "KS", "009", "", "", "38.36446", "-98.76481", "America/Chicago"),
("4272782", "Hays", "", "US", "840", "KS", "051", "", "", "38.87918", "-99.32677", "America/Chicago"),
("4273299", "Hutchinson", "Хатчинсон", "US", "840", "KS", "155", "", "", "38.06084", "-97.92977", "America/Chicago"),
("4273680", "Junction City", "", "US", "840", "KS", "061", "", "", "39.02861", "-96.8314", "America/Chicago"),
("4273837", "Kansas City", "Канзас-Сити", "US", "840", "KS", "209", "", "", "39.11417", "-94.62746", "America/Chicago"),
("4274277", "Lawrence", "Лоуренс", "US", "840", "KS", "045", "", "", "38.97167", "-95.23525", "America/Chicago"),
("4274305", "Leavenworth", "Ливенворс", "US", "840", "KS", "103", "", "", "39.31111", "-94.92246", "America/Chicago"),
("4274317", "Leawood", "", "US", "840", "KS", "091", "", "", "38.96667", "-94.6169", "America/Chicago"),
("4274356", "Lenexa", "", "US", "840", "KS", "091", "", "", "38.95362", "-94.73357", "America/Chicago"),
("4274994", "Manhattan", "Манхэттен", "US", "840", "KS", "161", "", "", "39.18361", "-96.57167", "America/Chicago"),
("4276248", "Newton", "Ньютон", "US", "840", "KS", "079", "", "", "38.04668", "-97.34504", "America/Chicago"),
("4276614", "Olathe", "", "US", "840", "KS", "091", "", "", "38.8814", "-94.81913", "America/Chicago"),
("4276873", "Overland Park", "Оверленд-Парк", "US", "840", "KS", "091", "", "", "38.98223", "-94.67079", "America/Chicago"),
("4277241", "Pittsburg", "Питсбург", "US", "840", "KS", "037", "", "", "37.41088", "-94.70496", "America/Chicago"),
("4277718", "Prairie Village", "", "US", "840", "KS", "091", "", "", "38.99167", "-94.63357", "America/Chicago"),
("4278890", "Salina", "Салина", "US", "840", "KS", "169", "", "", "38.84028", "-97.61142", "America/Chicago"),
("4279247", "Shawnee", "", "US", "840", "KS", "091", "", "", "39.04167", "-94.72024", "America/Chicago"),
("4280539", "Topeka", "Топика", "US", "840", "KS", "177", "", "", "39.04833", "-95.67804", "America/Chicago"),
("4281730", "Wichita", "Уичито", "US", "840", "KS", "173", "", "", "37.69224", "-97.33754", "America/Chicago"),
("4282757", "Ashland", "", "US", "840", "KY", "019", "", "", "38.47841", "-82.63794", "America/New_York"),
("4285268", "Bowling Green", "Боулинг-Грин", "US", "840", "KY", "227", "", "", "36.99032", "-86.4436", "America/Chicago"),
("4286281", "Burlington", "Берлингтон", "US", "840", "KY", "015", "", "", "39.02756", "-84.72411", "America/New_York"),
("4288809", "Covington", "Ковингтон", "US", "840", "KY", "117", "", "", "39.08367", "-84.50855", "America/New_York"),
("4289445", "Danville", "", "US", "840", "KY", "021", "", "", "37.64563", "-84.77217", "America/New_York"),
("4290988", "Elizabethtown", "Элизабеттаун", "US", "840", "KY", "093", "", "", "37.69395", "-85.85913", "America/New_York"),
("4291255", "Erlanger", "", "US", "840", "KY", "117", "", "", "39.01673", "-84.60078", "America/New_York"),
("4291620", "Fern Creek", "", "US", "840", "KY", "111", "", "", "38.15979", "-85.58774", "America/Kentucky/Louisville"),
("4291945", "Florence", "Флоренция", "US", "840", "KY", "015", "", "", "38.99895", "-84.62661", "America/New_York"),
("4292071", "Fort Thomas", "", "US", "840", "KY", "037", "", "", "39.07506", "-84.44716", "America/New_York"),
("4292188", "Frankfort", "Франкфурт", "US", "840", "KY", "073", "", "", "38.20091", "-84.87328", "America/New_York"),
("4292686", "Georgetown", "", "US", "840", "KY", "209", "", "", "38.2098", "-84.55883", "America/New_York"),
("4294494", "Henderson", "Хендерсон", "US", "840", "KY", "101", "", "", "37.83615", "-87.59001", "America/Chicago"),
("4294799", "Highview", "", "US", "840", "KY", "111", "", "", "38.14285", "-85.62413", "America/Kentucky/Louisville"),
("4295251", "Hopkinsville", "Хопкинсвилле", "US", "840", "KY", "047", "", "", "36.8656", "-87.48862", "America/Chicago"),
("4295776", "Independence", "", "US", "840", "KY", "117", "", "", "38.94312", "-84.54411", "America/New_York"),
("4295940", "Ironville", "", "US", "840", "KY", "019", "", "", "38.45647", "-82.69238", "America/New_York"),
("4296218", "Jeffersontown", "", "US", "840", "KY", "111", "", "", "38.19424", "-85.5644", "America/Kentucky/Louisville"),
("4297983", "Lexington", "Лексингтон", "US", "840", "KY", "067", "", "", "37.98869", "-84.47772", "America/New_York"),
("4297999", "Lexington-Fayette", "", "US", "840", "KY", "067", "", "", "38.0498", "-84.45855", "America/New_York"),
("4299276", "Louisville", "Луисвилл", "US", "840", "KY", "111", "", "", "38.25424", "-85.75941", "America/Kentucky/Louisville"),
("4299670", "Madisonville", "", "US", "840", "KY", "107", "", "", "37.3281", "-87.49889", "America/Chicago"),
("4300488", "Meads", "", "US", "840", "KY", "019", "", "", "38.41258", "-82.70905", "America/New_York"),
("4302035", "Murray", "Мюррей", "US", "840", "KY", "035", "", "", "36.61033", "-88.31476", "America/Chicago"),
("4302504", "Newburg", "", "US", "840", "KY", "111", "", "", "38.16007", "-85.65968", "America/Kentucky/Louisville"),
("4302529", "Newport", "Ньюпорт", "US", "840", "KY", "037", "", "", "39.09145", "-84.49578", "America/New_York"),
("4302561", "Nicholasville", "", "US", "840", "KY", "113", "", "", "37.88063", "-84.573", "America/New_York"),
("4303012", "Okolona", "", "US", "840", "KY", "111", "", "", "38.14118", "-85.68774", "America/Kentucky/Louisville"),
("4303436", "Owensboro", "", "US", "840", "KY", "059", "", "", "37.77422", "-87.11333", "America/Chicago"),
("4304713", "Pleasure Ridge Park", "", "US", "840", "KY", "111", "", "", "38.14535", "-85.8583", "America/Kentucky/Louisville"),
("4305504", "Radcliff", "Радклиф", "US", "840", "KY", "093", "", "", "37.84035", "-85.94913", "America/New_York"),
("4305974", "Richmond", "Ричмонд", "US", "840", "KY", "151", "", "", "37.74786", "-84.29465", "America/New_York"),
("4307238", "Saint Matthews", "", "US", "840", "KY", "111", "", "", "38.25285", "-85.65579", "America/Kentucky/Louisville"),
("4308225", "Shively", "", "US", "840", "KY", "111", "", "", "38.20007", "-85.82274", "America/Kentucky/Louisville"),
("4311963", "Valley Station", "", "US", "840", "KY", "111", "", "", "38.11118", "-85.87024", "America/Kentucky/Louisville"),
("4313697", "Winchester", "", "US", "840", "KY", "049", "", "", "37.99008", "-84.17965", "America/New_York"),
("4314550", "Alexandria", "Александрия", "US", "840", "LA", "079", "", "", "31.31129", "-92.44514", "America/Chicago"),
("4315588", "Baton Rouge", "Батон-Руж", "US", "840", "LA", "033", "", "", "30.45075", "-91.15455", "America/Chicago"),
("4315768", "Bayou Cane", "", "US", "840", "LA", "109", "", "", "29.6241", "-90.7512", "America/Chicago"),
("4317639", "Bossier City", "", "US", "840", "LA", "015", "", "", "32.51599", "-93.73212", "America/Chicago"),
("4319435", "Central", "", "US", "840", "LA", "033", "", "", "30.55435", "-91.03677", "America/Chicago"),
("4319518", "Chalmette", "", "US", "840", "LA", "087", "", "", "29.9427", "-89.9634", "America/Chicago"),
("4323873", "Estelle", "", "US", "840", "LA", "051", "", "", "29.84576", "-90.10674", "America/Chicago"),
("4326575", "Gretna", "", "US", "840", "LA", "051", "", "", "29.91465", "-90.05396", "America/Chicago"),
("4326868", "Hammond", "Хаммонд", "US", "840", "LA", "105", "", "", "30.50436", "-90.4612", "America/Chicago"),
("4327047", "Harvey", "Харви", "US", "840", "LA", "051", "", "", "29.90354", "-90.07729", "America/Chicago"),
("4328010", "Houma", "", "US", "840", "LA", "109", "", "", "29.59577", "-90.71953", "America/Chicago"),
("4329753", "Kenner", "Кеннер", "US", "840", "LA", "051", "", "", "29.99409", "-90.24174", "America/Chicago"),
("4330145", "Lafayette", "Лафайет", "US", "840", "LA", "055", "", "", "30.22409", "-92.01984", "America/Chicago"),
("4330236", "Lake Charles", "Лейк-Чарльз", "US", "840", "LA", "019", "", "", "30.21309", "-93.2044", "America/Chicago"),
("4330525", "Laplace", "Лаплас", "US", "840", "LA", "095", "", "", "30.06659", "-90.48008", "America/Chicago"),
("4332628", "Marrero", "Марреро", "US", "840", "LA", "051", "", "", "29.89937", "-90.10035", "America/Chicago"),
("4333177", "Metairie", "", "US", "840", "LA", "051", "", "", "29.98409", "-90.15285", "America/Chicago"),
("4333190", "Metairie Terrace", "", "US", "840", "LA", "051", "", "", "29.97854", "-90.16396", "America/Chicago"),
("4333669", "Monroe", "Монро", "US", "840", "LA", "073", "", "", "32.50931", "-92.1193", "America/Chicago"),
("4334720", "Natchitoches", "", "US", "840", "LA", "069", "", "", "31.76072", "-93.08627", "America/Chicago"),
("4334971", "New Iberia", "", "US", "840", "LA", "045", "", "", "30.00354", "-91.81873", "America/Chicago"),
("4335045", "New Orleans", "Новый Орлеан", "US", "840", "LA", "071", "", "", "29.95465", "-90.07507", "America/Chicago"),
("4336153", "Opelousas", "", "US", "840", "LA", "097", "", "", "30.53353", "-92.08151", "America/Chicago"),
("4338012", "Prairieville", "", "US", "840", "LA", "005", "", "", "30.30297", "-90.97205", "America/Chicago"),
("4339348", "Ruston", "", "US", "840", "LA", "061", "", "", "32.52321", "-92.63793", "America/Chicago"),
("4341378", "Shenandoah", "", "US", "840", "LA", "033", "", "", "30.4013", "-91.00094", "America/Chicago"),
("4341513", "Shreveport", "Шревепорт", "US", "840", "LA", "017", "", "", "32.52515", "-93.75018", "America/Chicago"),
("4341727", "Slidell", "", "US", "840", "LA", "103", "", "", "30.27519", "-89.78117", "America/Chicago"),
("4342816", "Sulphur", "", "US", "840", "LA", "019", "", "", "30.23659", "-93.37738", "America/Chicago"),
("4343327", "Terrytown", "", "US", "840", "LA", "051", "", "", "29.9102", "-90.03257", "America/Chicago"),
("4346991", "Adelphi", "", "US", "840", "MD", "033", "", "", "39.00317", "-76.97192", "America/New_York"),
("4347242", "Annapolis", "Аннаполис", "US", "840", "MD", "003", "", "", "38.97845", "-76.49218", "America/New_York"),
("4347371", "Arbutus", "", "US", "840", "MD", "005", "", "", "39.25455", "-76.69997", "America/New_York"),
("4347426", "Arnold", "Арнольд", "US", "840", "MD", "003", "", "", "39.03206", "-76.50274", "America/New_York"),
("4347553", "Aspen Hill", "", "US", "840", "MD", "031", "", "", "39.07955", "-77.07303", "America/New_York"),
("4347778", "Baltimore", "Балтимор", "US", "840", "MD", "510", "", "", "39.29038", "-76.61219", "America/New_York"),
("4347839", "Ballenger Creek", "", "US", "840", "MD", "021", "", "", "39.3726", "-77.43526", "America/New_York"),
("4348353", "Beltsville", "", "US", "840", "MD", "033", "", "", "39.03483", "-76.90747", "America/New_York"),
("4348599", "Bethesda", "Бетесда", "US", "840", "MD", "031", "", "", "38.98067", "-77.10026", "America/New_York"),
("4349159", "Bowie", "Боуи", "US", "840", "MD", "033", "", "", "38.94278", "-76.73028", "America/New_York"),
("4350160", "Calverton", "", "US", "840", "MD", "033", "", "", "39.05761", "-76.93581", "America/New_York"),
("4350288", "Camp Springs", "", "US", "840", "MD", "033", "", "", "38.804", "-76.90664", "America/New_York"),
("4350413", "Carney", "Карни", "US", "840", "MD", "005", "", "", "39.39427", "-76.52358", "America/New_York"),
("4350635", "Catonsville", "", "US", "840", "MD", "005", "", "", "39.27205", "-76.73192", "America/New_York"),
("4351383", "Chillum", "", "US", "840", "MD", "033", "", "", "38.96372", "-76.99081", "America/New_York"),
("4351851", "Cloverly", "", "US", "840", "MD", "031", "", "", "39.10816", "-76.99775", "America/New_York"),
("4351871", "Clinton", "Клинтон", "US", "840", "MD", "033", "", "", "38.76511", "-76.89831", "America/New_York"),
("4351887", "Cockeysville", "", "US", "840", "MD", "005", "", "", "39.48122", "-76.64386", "America/New_York"),
("4351977", "College Park", "", "US", "840", "MD", "033", "", "", "38.98067", "-76.93692", "America/New_York"),
("4352053", "Columbia", "Колумбия", "US", "840", "MD", "027", "", "", "39.24038", "-76.83942", "America/New_York"),
("4352539", "Crofton", "Крофтона", "US", "840", "MD", "003", "", "", "39.00178", "-76.68747", "America/New_York"),
("4352681", "Cumberland", "Камберленд", "US", "840", "MD", "001", "", "", "39.65287", "-78.76252", "America/New_York"),
("4352728", "Damascus", "", "US", "840", "MD", "031", "", "", "39.28844", "-77.20387", "America/New_York"),
("4353765", "Dundalk", "Дандолк", "US", "840", "MD", "005", "", "", "39.25066", "-76.52052", "America/New_York"),
("4353925", "East Riverdale", "", "US", "840", "MD", "033", "", "", "38.96206", "-76.92192", "America/New_York"),
("4353962", "Easton", "Истон", "US", "840", "MD", "041", "", "", "38.77428", "-76.07633", "America/New_York"),
("4354087", "Edgewood", "", "US", "840", "MD", "025", "", "", "39.41872", "-76.2944", "America/New_York"),
("4354163", "Eldersburg", "", "US", "840", "MD", "013", "", "", "39.40371", "-76.95026", "America/New_York"),
("4354234", "Elkton", "", "US", "840", "MD", "015", "", "", "39.60678", "-75.83327", "America/New_York"),
("4354256", "Elkridge", "", "US", "840", "MD", "027", "", "", "39.21261", "-76.71358", "America/New_York"),
("4354265", "Ellicott City", "", "US", "840", "MD", "027", "", "", "39.26733", "-76.79831", "America/New_York"),
("4354428", "Essex", "Эссекс", "US", "840", "MD", "005", "", "", "39.30927", "-76.47496", "America/New_York"),
("4354573", "Fairland", "", "US", "840", "MD", "031", "", "", "39.07622", "-76.95775", "America/New_York"),
("4354821", "Ferndale", "", "US", "840", "MD", "003", "", "", "39.18316", "-76.64024", "America/New_York"),
("4355355", "Fort Washington", "", "US", "840", "MD", "033", "", "", "38.70734", "-77.02303", "America/New_York"),
("4355585", "Frederick", "Фредерик", "US", "840", "MD", "021", "", "", "39.41427", "-77.41054", "America/New_York"),
("4355843", "Gaithersburg", "Гейтерсберг", "US", "840", "MD", "031", "", "", "39.14344", "-77.20137", "America/New_York"),
("4356050", "Germantown", "", "US", "840", "MD", "031", "", "", "39.17316", "-77.27165", "America/New_York"),
("4356165", "Glassmanor", "", "US", "840", "MD", "033", "", "", "38.819", "-76.99859", "America/New_York"),
("4356188", "Glen Burnie", "", "US", "840", "MD", "003", "", "", "39.16261", "-76.62469", "America/New_York"),
("4356783", "Green Haven", "", "US", "840", "MD", "003", "", "", "39.13955", "-76.54774", "America/New_York"),
("4356847", "Greenbelt", "Гринбелте", "US", "840", "MD", "033", "", "", "39.00455", "-76.87553", "America/New_York"),
("4357141", "Hagerstown", "", "US", "840", "MD", "043", "", "", "39.64176", "-77.71999", "America/New_York"),
("4357340", "Hanover", "", "US", "840", "MD", "027", "", "", "39.19289", "-76.72414", "America/New_York"),
("4358082", "Hillcrest Heights", "", "US", "840", "MD", "033", "", "", "38.83289", "-76.95942", "America/New_York"),
("4358701", "Hunt Valley", "", "US", "840", "MD", "005", "", "", "39.49983", "-76.64108", "America/New_York"),
("4358821", "Hyattsville", "", "US", "840", "MD", "033", "", "", "38.95594", "-76.94553", "America/New_York"),
("4358864", "Ilchester", "", "US", "840", "MD", "027", "", "", "39.25094", "-76.76469", "America/New_York"),
("4360201", "Lake Shore", "", "US", "840", "MD", "003", "", "", "39.10705", "-76.48496", "America/New_York"),
("4360287", "Landover", "", "US", "840", "MD", "033", "", "", "38.934", "-76.89664", "America/New_York"),
("4360314", "Langley Park", "", "US", "840", "MD", "033", "", "", "38.98872", "-76.98136", "America/New_York"),
("4360369", "Laurel", "", "US", "840", "MD", "033", "", "", "39.09928", "-76.84831", "America/New_York"),
("4360954", "Lochearn", "", "US", "840", "MD", "005", "", "", "39.34066", "-76.72219", "America/New_York"),
("4361831", "Maryland City", "", "US", "840", "MD", "003", "", "", "39.09205", "-76.81775", "America/New_York"),
("4362344", "Middle River", "", "US", "840", "MD", "005", "", "", "39.33427", "-76.43941", "America/New_York"),
("4362438", "Milford Mill", "", "US", "840", "MD", "005", "", "", "39.34788", "-76.76997", "America/New_York"),
("4362743", "Montgomery Village", "", "US", "840", "MD", "031", "", "", "39.17677", "-77.19526", "America/New_York"),
("4363836", "North Bel Air", "", "US", "840", "MD", "025", "", "", "39.53983", "-76.35496", "America/New_York"),
("4363843", "North Bethesda", "", "US", "840", "MD", "031", "", "", "39.04455", "-77.11887", "America/New_York"),
("4363990", "North Potomac", "", "US", "840", "MD", "031", "", "", "39.08289", "-77.26498", "America/New_York"),
("4364362", "Odenton", "", "US", "840", "MD", "003", "", "", "39.084", "-76.70025", "America/New_York"),
("4364537", "Olney", "Олни", "US", "840", "MD", "031", "", "", "39.15316", "-77.06692", "America/New_York"),
("4364727", "Owings Mills", "", "US", "840", "MD", "005", "", "", "39.41955", "-76.78025", "America/New_York"),
("4364759", "Oxon Hill", "", "US", "840", "MD", "033", "", "", "38.80345", "-76.9897", "America/New_York"),
("4364946", "Parkville", "", "US", "840", "MD", "005", "", "", "39.37733", "-76.53969", "America/New_York"),
("4364964", "Parole", "", "US", "840", "MD", "003", "", "", "38.97956", "-76.53052", "America/New_York"),
("4364990", "Pasadena", "Пасадена", "US", "840", "MD", "003", "", "", "39.10733", "-76.57108", "America/New_York"),
("4365227", "Perry Hall", "", "US", "840", "MD", "005", "", "", "39.41261", "-76.46357", "America/New_York"),
("4365387", "Pikesville", "", "US", "840", "MD", "005", "", "", "39.37427", "-76.72247", "America/New_York"),
("4366001", "Potomac", "Потомак", "US", "840", "MD", "031", "", "", "39.01817", "-77.20859", "America/New_York"),
("4366476", "Randallstown", "", "US", "840", "MD", "005", "", "", "39.36733", "-76.79525", "America/New_York"),
("4366593", "Redland", "", "US", "840", "MD", "031", "", "", "39.14539", "-77.14415", "America/New_York"),
("4366647", "Reisterstown", "", "US", "840", "MD", "005", "", "", "39.46955", "-76.82942", "America/New_York"),
("4367175", "Rockville", "Роквилл", "US", "840", "MD", "031", "", "", "39.084", "-77.15276", "America/New_York"),
("4367372", "Rosedale", "", "US", "840", "MD", "005", "", "", "39.32011", "-76.51552", "America/New_York"),
("4367419", "Rossville", "", "US", "840", "MD", "005", "", "", "39.33844", "-76.47968", "America/New_York"),
("4367734", "Saint Charles", "", "US", "840", "MD", "017", "", "", "38.60317", "-76.93858", "America/New_York"),
("4368711", "Salisbury", "Солсбери", "US", "840", "MD", "045", "", "", "38.36067", "-75.59937", "America/New_York"),
("4369076", "Seabrook", "", "US", "840", "MD", "033", "", "", "38.96789", "-76.84497", "America/New_York"),
("4369190", "Severn", "Северн", "US", "840", "MD", "003", "", "", "39.13705", "-76.6983", "America/New_York"),
("4369224", "Severna Park", "", "US", "840", "MD", "003", "", "", "39.07039", "-76.54524", "America/New_York"),
("4369596", "Silver Spring", "", "US", "840", "MD", "031", "", "", "38.99067", "-77.02609", "America/New_York"),
("4369928", "South Bel Air", "", "US", "840", "MD", "025", "", "", "39.53316", "-76.33746", "America/New_York"),
("4369964", "South Gate", "", "US", "840", "MD", "003", "", "", "39.129", "-76.6258", "America/New_York"),
("4369978", "South Laurel", "", "US", "840", "MD", "033", "", "", "39.06983", "-76.85025", "America/New_York"),
("4370616", "Suitland", "", "US", "840", "MD", "033", "", "", "38.84872", "-76.92386", "America/New_York"),
("4370890", "Takoma Park", "", "US", "840", "MD", "031", "", "", "38.97789", "-77.00748", "America/New_York"),
("4371582", "Towson", "", "US", "840", "MD", "005", "", "", "39.4015", "-76.60191", "America/New_York"),
("4372599", "Waldorf", "", "US", "840", "MD", "017", "", "", "38.62456", "-76.93914", "America/New_York"),
("4373104", "West Elkridge", "", "US", "840", "MD", "027", "", "", "39.20705", "-76.72692", "America/New_York"),
("4373238", "Westminster", "", "US", "840", "MD", "013", "", "", "39.57538", "-76.99581", "America/New_York"),
("4373349", "Wheaton", "", "US", "840", "MD", "031", "", "", "39.03983", "-77.05526", "America/New_York"),
("4373449", "White Oak", "", "US", "840", "MD", "031", "", "", "39.03983", "-76.99303", "America/New_York"),
("4374054", "Woodlawn", "", "US", "840", "MD", "005", "", "", "39.32288", "-76.72803", "America/New_York"),
("4374513", "Affton", "", "US", "840", "MO", "189", "", "", "38.55061", "-90.33317", "America/Chicago"),
("4375087", "Arnold", "Арнольд", "US", "840", "MO", "099", "", "", "38.43283", "-90.37762", "America/Chicago"),
("4375663", "Ballwin", "", "US", "840", "MO", "189", "", "", "38.59505", "-90.54623", "America/Chicago"),
("4376482", "Belton", "Белтон", "US", "840", "MO", "037", "", "", "38.81195", "-94.5319", "America/Chicago"),
("4377664", "Blue Springs", "", "US", "840", "MO", "095", "", "", "39.01695", "-94.28161", "America/Chicago"),
("4379966", "Cape Girardeau", "", "US", "840", "MO", "031", "", "", "37.30588", "-89.51815", "America/Chicago"),
("4381072", "Chesterfield", "", "US", "840", "MO", "189", "", "", "38.66311", "-90.57707", "America/Chicago"),
("4381478", "Clayton", "", "US", "840", "MO", "189", "", "", "38.64255", "-90.32373", "America/Chicago"),
("4381982", "Columbia", "Колумбия", "US", "840", "MO", "019", "", "", "38.95171", "-92.33407", "America/Chicago"),
("4382072", "Concord", "", "US", "840", "MO", "189", "", "", "38.5245", "-90.35734", "America/Chicago"),
("4382837", "Creve Coeur", "", "US", "840", "MO", "189", "", "", "38.66089", "-90.42262", "America/Chicago"),
("4385018", "East Independence", "", "US", "840", "MO", "095", "", "", "39.09556", "-94.35523", "America/Chicago"),
("4386289", "Farmington", "Фармингтон", "US", "840", "MO", "187", "", "", "37.78088", "-90.42179", "America/Chicago"),
("4386387", "Ferguson", "Фергюсон", "US", "840", "MO", "189", "", "", "38.74422", "-90.30539", "America/Chicago"),
("4386802", "Florissant", "", "US", "840", "MO", "189", "", "", "38.78922", "-90.32261", "America/Chicago"),
("4387990", "Gladstone", "Гладстон", "US", "840", "MO", "047", "", "", "39.20389", "-94.55468", "America/Chicago"),
("4388460", "Grandview", "", "US", "840", "MO", "095", "", "", "38.88584", "-94.53301", "America/Chicago"),
("4389418", "Hannibal", "Ганнибал", "US", "840", "MO", "127", "", "", "39.70838", "-91.35848", "America/Chicago"),
("4389967", "Hazelwood", "", "US", "840", "MO", "189", "", "", "38.77144", "-90.37095", "America/Chicago"),
("4391812", "Independence", "Индепенденс", "US", "840", "MO", "095", "", "", "39.09112", "-94.41551", "America/Chicago"),
("4392388", "Jefferson City", "Джефферсон-Сити", "US", "840", "MO", "051", "", "", "38.5767", "-92.17352", "America/Chicago"),
("4392768", "Joplin", "Джоплин", "US", "840", "MO", "097", "", "", "37.08423", "-94.51328", "America/Chicago"),
("4393217", "Kansas City", "Канзас-Сити", "US", "840", "MO", "095", "", "", "39.09973", "-94.57857", "America/Chicago"),
("4393739", "Kirkwood", "Кирквуда", "US", "840", "MO", "189", "", "", "38.58339", "-90.40678", "America/Chicago"),
("4394870", "Lees Summit", "", "US", "840", "MO", "095", "", "", "38.91084", "-94.38217", "America/Chicago"),
("4394905", "Lemay", "", "US", "840", "MO", "189", "", "", "38.53339", "-90.27928", "America/Chicago"),
("4395052", "Liberty", "", "US", "840", "MO", "047", "", "", "39.24611", "-94.41912", "America/Chicago"),
("4396915", "Manchester", "Манчестер", "US", "840", "MO", "189", "", "", "38.597", "-90.50929", "America/Chicago"),
("4397340", "Maryland Heights", "", "US", "840", "MO", "189", "", "", "38.71311", "-90.42984", "America/Chicago"),
("4397962", "Mehlville", "", "US", "840", "MO", "189", "", "", "38.50839", "-90.32289", "America/Chicago"),
("4400648", "Nixa", "", "US", "840", "MO", "043", "", "", "37.04339", "-93.29435", "America/Chicago"),
("4401242", "O'Fallon", "", "US", "840", "MO", "183", "", "", "38.81061", "-90.69985", "America/Chicago"),
("4401618", "Oakville", "", "US", "840", "MO", "189", "", "", "38.47005", "-90.30456", "America/Chicago"),
("4402178", "Overland", "", "US", "840", "MO", "189", "", "", "38.70116", "-90.36234", "America/Chicago"),
("4402245", "Ozark", "", "US", "840", "MO", "043", "", "", "37.02089", "-93.20602", "America/Chicago"),
("4404233", "Poplar Bluff", "", "US", "840", "MO", "023", "", "", "36.757", "-90.39289", "America/Chicago"),
("4405180", "Raymore", "", "US", "840", "MO", "037", "", "", "38.80195", "-94.45273", "America/Chicago"),
("4405188", "Raytown", "", "US", "840", "MO", "095", "", "", "39.00862", "-94.46356", "America/Chicago"),
("4406282", "Rolla", "Ролла", "US", "840", "MO", "161", "", "", "37.95143", "-91.77127", "America/Chicago"),
("4406831", "Saint Charles", "Сент-Чарльз", "US", "840", "MO", "183", "", "", "38.78394", "-90.48123", "America/Chicago"),
("4407010", "Saint Joseph", "Сент-Джозеф", "US", "840", "MO", "021", "", "", "39.76861", "-94.84663", "America/Chicago"),
("4407066", "St. Louis", "Сент-Луис", "US", "840", "MO", "510", "", "", "38.62727", "-90.19789", "America/Chicago"),
("4407237", "Saint Peters", "Санкт-Петербу", "US", "840", "MO", "183", "", "", "38.80033", "-90.62651", "America/Chicago"),
("4408000", "Sedalia", "", "US", "840", "MO", "159", "", "", "38.70446", "-93.22826", "America/Chicago"),
("4408672", "Sikeston", "", "US", "840", "MO", "201", "", "", "36.87672", "-89.58786", "America/Chicago"),
("4409591", "Spanish Lake", "", "US", "840", "MO", "189", "", "", "38.78783", "-90.21594", "America/Chicago"),
("4409896", "Springfield", "Спрингфилд", "US", "840", "MO", "077", "", "", "37.21533", "-93.29824", "America/Chicago"),
("4412697", "University City", "", "US", "840", "MO", "189", "", "", "38.65588", "-90.30928", "America/Chicago"),
("4413595", "Warrensburg", "", "US", "840", "MO", "101", "", "", "38.76279", "-93.73605", "America/Chicago"),
("4413872", "Webster Groves", "", "US", "840", "MO", "189", "", "", "38.59255", "-90.35734", "America/Chicago"),
("4414001", "Wentzville", "", "US", "840", "MO", "183", "", "", "38.81144", "-90.85291", "America/Chicago"),
("4414749", "Wildwood", "", "US", "840", "MO", "189", "", "", "38.58283", "-90.6629", "America/Chicago"),
("4418478", "Biloxi", "Билокси", "US", "840", "MS", "047", "", "", "30.39603", "-88.88531", "America/Chicago"),
("4419290", "Brandon", "Брэндон", "US", "840", "MS", "121", "", "", "32.2732", "-89.98592", "America/Chicago"),
("4421935", "Clarksdale", "", "US", "840", "MS", "027", "", "", "34.20011", "-90.57093", "America/Chicago"),
("4422133", "Clinton", "Клинтон", "US", "840", "MS", "049", "", "", "32.34153", "-90.32176", "America/Chicago"),
("4422442", "Columbus", "Колумбус", "US", "840", "MS", "087", "", "", "33.49567", "-88.42726", "America/Chicago"),
("4427569", "Gautier", "Готье", "US", "840", "MS", "059", "", "", "30.38576", "-88.61169", "America/Chicago"),
("4428475", "Greenville", "Гринвилл", "US", "840", "MS", "151", "", "", "33.41012", "-91.06177", "America/Chicago"),
("4428495", "Greenwood", "", "US", "840", "MS", "083", "", "", "33.51623", "-90.17953", "America/Chicago"),
("4428667", "Gulfport", "Галфпорта", "US", "840", "MS", "047", "", "", "30.36742", "-89.09282", "America/Chicago"),
("4429295", "Hattiesburg", "", "US", "840", "MS", "035", "", "", "31.32712", "-89.29034", "America/Chicago"),
("4430400", "Horn Lake", "", "US", "840", "MS", "033", "", "", "34.95537", "-90.03481", "America/Chicago"),
("4431410", "Jackson", "Джексон", "US", "840", "MS", "049", "", "", "32.29876", "-90.18481", "America/Chicago"),
("4433039", "Laurel", "", "US", "840", "MS", "067", "", "", "31.69405", "-89.13061", "America/Chicago"),
("4434663", "Madison", "Мадисон", "US", "840", "MS", "089", "", "", "32.46181", "-90.11536", "America/Chicago"),
("4435764", "Meridian", "Меридиан", "US", "840", "MS", "075", "", "", "32.36431", "-88.70366", "America/Chicago"),
("4437982", "Natchez", "Натчез", "US", "840", "MS", "001", "", "", "31.56044", "-91.40317", "America/Chicago"),
("4439506", "Ocean Springs", "", "US", "840", "MS", "059", "", "", "30.41131", "-88.82781", "America/Chicago"),
("4439869", "Olive Branch", "", "US", "840", "MS", "033", "", "", "34.96176", "-89.82953", "America/Chicago"),
("4440076", "Oxford", "Оксфорд", "US", "840", "MS", "071", "", "", "34.3665", "-89.51925", "America/Chicago"),
("4440397", "Pascagoula", "Паскагула", "US", "840", "MS", "059", "", "", "30.36576", "-88.55613", "America/Chicago"),
("4440559", "Pearl", "", "US", "840", "MS", "121", "", "", "32.27459", "-90.13203", "America/Chicago"),
("4443296", "Ridgeland", "", "US", "840", "MS", "089", "", "", "32.42848", "-90.13231", "America/Chicago"),
("4446675", "Southaven", "", "US", "840", "MS", "033", "", "", "34.98898", "-90.01259", "America/Chicago"),
("4447161", "Starkville", "", "US", "840", "MS", "105", "", "", "33.4504", "-88.81839", "America/Chicago"),
("4448903", "Tupelo", "", "US", "840", "MS", "081", "", "", "34.25761", "-88.70339", "America/Chicago"),
("4449620", "Vicksburg", "Виксберг", "US", "840", "MS", "149", "", "", "32.35265", "-90.87788", "America/Chicago"),
("4450687", "West Gulfport", "", "US", "840", "MS", "047", "", "", "30.40409", "-89.0942", "America/Chicago"),
("4452303", "Albemarle", "", "US", "840", "NC", "167", "", "", "35.35014", "-80.20006", "America/New_York"),
("4452808", "Apex", "Апекс", "US", "840", "NC", "183", "", "", "35.73265", "-78.85029", "America/New_York"),
("4453035", "Asheboro", "", "US", "840", "NC", "151", "", "", "35.70791", "-79.81364", "America/New_York"),
("4453066", "Asheville", "Эшвилл", "US", "840", "NC", "021", "", "", "35.60095", "-82.55402", "America/New_York"),
("4456703", "Boone", "", "US", "840", "NC", "189", "", "", "36.2168", "-81.67455", "America/New_York"),
("4458228", "Burlington", "Берлингтон", "US", "840", "NC", "001", "", "", "36.09569", "-79.4378", "America/New_York"),
("4459343", "Carrboro", "", "US", "840", "NC", "135", "", "", "35.91014", "-79.07529", "America/New_York"),
("4459467", "Cary", "Кэри", "US", "840", "NC", "183", "", "", "35.79154", "-78.78112", "America/New_York"),
("4460162", "Chapel Hill", "", "US", "840", "NC", "135", "", "", "35.9132", "-79.05584", "America/New_York"),
("4460243", "Charlotte", "Шарлотт", "US", "840", "NC", "119", "", "", "35.22709", "-80.84313", "America/New_York"),
("4460943", "Clayton", "", "US", "840", "NC", "101", "", "", "35.65071", "-78.45639", "America/New_York"),
("4461015", "Clemmons", "", "US", "840", "NC", "067", "", "", "36.02153", "-80.382", "America/New_York"),
("4461574", "Concord", "Конкорд", "US", "840", "NC", "025", "", "", "35.40875", "-80.57951", "America/New_York"),
("4461941", "Cornelius", "Корнелиус", "US", "840", "NC", "119", "", "", "35.4868", "-80.86007", "America/New_York"),
("4464368", "Durham", "Дарем", "US", "840", "NC", "063", "", "", "35.99403", "-78.89862", "America/New_York"),
("4464873", "Eden", "", "US", "840", "NC", "157", "", "", "36.48847", "-79.7667", "America/New_York"),
("4465088", "Elizabeth City", "", "US", "840", "NC", "139", "", "", "36.2946", "-76.25105", "America/New_York"),
("4466033", "Fayetteville", "Фейетвилл", "US", "840", "NC", "051", "", "", "35.05266", "-78.87836", "America/New_York"),
("4467485", "Fuquay-Varina", "", "US", "840", "NC", "183", "", "", "35.58432", "-78.80001", "America/New_York"),
("4467657", "Garner", "Гарнер", "US", "840", "NC", "183", "", "", "35.71126", "-78.61417", "America/New_York"),
("4467732", "Gastonia", "Гастония", "US", "840", "NC", "071", "", "", "35.26208", "-81.1873", "America/New_York"),
("4468261", "Goldsboro", "Голдсборо", "US", "840", "NC", "191", "", "", "35.38488", "-77.99277", "America/New_York"),
("4469146", "Greensboro", "Гринсборо", "US", "840", "NC", "081", "", "", "36.07264", "-79.79198", "America/New_York"),
("4469160", "Greenville", "Гринвилл", "US", "840", "NC", "147", "", "", "35.61266", "-77.36635", "America/New_York"),
("4470244", "Havelock", "", "US", "840", "NC", "049", "", "", "34.87905", "-76.90133", "America/New_York"),
("4470566", "Henderson", "Хендерсон", "US", "840", "NC", "181", "", "", "36.32959", "-78.39916", "America/New_York"),
("4470778", "Hickory", "Хикори", "US", "840", "NC", "035", "", "", "35.73319", "-81.3412", "America/New_York"),
("4471025", "High Point", "Хай-Пойнт", "US", "840", "NC", "081", "", "", "35.95569", "-80.00532", "America/New_York"),
("4471641", "Holly Springs", "", "US", "840", "NC", "183", "", "", "35.65127", "-78.83362", "America/New_York"),
("4471851", "Hope Mills", "", "US", "840", "NC", "051", "", "", "34.97044", "-78.94531", "America/New_York"),
("4472370", "Huntersville", "", "US", "840", "NC", "119", "", "", "35.41069", "-80.84285", "America/New_York"),
("4472687", "Indian Trail", "", "US", "840", "NC", "179", "", "", "35.07681", "-80.66924", "America/New_York"),
("4473083", "Jacksonville", "Джексонвилл", "US", "840", "NC", "133", "", "", "34.75405", "-77.43024", "America/New_York"),
("4474040", "Kannapolis", "", "US", "840", "NC", "025", "", "", "35.48736", "-80.62173", "America/New_York"),
("4474221", "Kernersville", "", "US", "840", "NC", "067", "", "", "36.11986", "-80.07365", "America/New_York"),
("4474436", "Kinston", "", "US", "840", "NC", "107", "", "", "35.26266", "-77.58164", "America/New_York"),
("4475347", "Laurinburg", "", "US", "840", "NC", "165", "", "", "34.77405", "-79.46282", "America/New_York"),
("4475640", "Lenoir", "", "US", "840", "NC", "027", "", "", "35.91402", "-81.53898", "America/New_York"),
("4475773", "Lexington", "Лексингтон", "US", "840", "NC", "057", "", "", "35.82403", "-80.25338", "America/New_York"),
("4477525", "Lumberton", "", "US", "840", "NC", "155", "", "", "34.61822", "-79.00864", "America/New_York"),
("4478334", "Matthews", "", "US", "840", "NC", "119", "", "", "35.11681", "-80.72368", "America/New_York"),
("4479759", "Mint Hill", "", "US", "840", "NC", "119", "", "", "35.17959", "-80.64729", "America/New_York"),
("4479946", "Monroe", "Монро", "US", "840", "NC", "179", "", "", "34.98543", "-80.54951", "America/New_York"),
("4480125", "Mooresville", "", "US", "840", "NC", "097", "", "", "35.58486", "-80.81007", "America/New_York"),
("4480219", "Morganton", "", "US", "840", "NC", "023", "", "", "35.74541", "-81.68482", "America/New_York"),
("4480285", "Morrisville", "", "US", "840", "NC", "183", "", "", "35.82348", "-78.82556", "America/New_York"),
("4481682", "New Bern", "Нью-Берн", "US", "840", "NC", "049", "", "", "35.10849", "-77.04411", "America/New_York"),
("4487042", "Raleigh", "Роли", "US", "840", "NC", "183", "", "", "35.7721", "-78.63861", "America/New_York"),
("4488232", "Roanoke Rapids", "", "US", "840", "NC", "083", "", "", "36.46154", "-77.65415", "America/New_York"),
("4488762", "Rocky Mount", "Роки-Маунт", "US", "840", "NC", "127", "", "", "35.93821", "-77.79053", "America/New_York"),
("4489985", "Salisbury", "", "US", "840", "NC", "159", "", "", "35.67097", "-80.47423", "America/New_York"),
("4490329", "Sanford", "", "US", "840", "NC", "105", "", "", "35.47988", "-79.1803", "America/New_York"),
("4491180", "Shelby", "", "US", "840", "NC", "045", "", "", "35.29235", "-81.53565", "America/New_York"),
("4493316", "Statesville", "", "US", "840", "NC", "097", "", "", "35.78264", "-80.8873", "America/New_York"),
("4494942", "Thomasville", "", "US", "840", "NC", "057", "", "", "35.88264", "-80.08199", "America/New_York"),
("4497290", "Wake Forest", "", "US", "840", "NC", "183", "", "", "35.97987", "-78.50972", "America/New_York"),
("4498303", "West Raleigh", "", "US", "840", "NC", "183", "", "", "35.78682", "-78.66389", "America/New_York"),
("4499379", "Wilmington", "Уилмингтон", "US", "840", "NC", "129", "", "", "34.22573", "-77.94471", "America/New_York"),
("4499389", "Wilson", "Уилсон", "US", "840", "NC", "195", "", "", "35.72127", "-77.91554", "America/New_York"),
("4499612", "Winston-Salem", "Винстон-Салем", "US", "840", "NC", "067", "", "", "36.09986", "-80.24422", "America/New_York"),
("4500546", "Atlantic City", "Атлантик-Сити", "US", "840", "NJ", "001", "", "", "39.36428", "-74.42293", "America/New_York"),
("4500942", "Bridgeton", "", "US", "840", "NJ", "011", "", "", "39.42734", "-75.23408", "America/New_York"),
("4501018", "Camden", "Камден", "US", "840", "NJ", "007", "", "", "39.92595", "-75.11962", "America/New_York"),
("4501198", "Cherry Hill", "", "US", "840", "NJ", "007", "", "", "39.93484", "-75.03073", "America/New_York"),
("4501931", "Glassboro", "", "US", "840", "NJ", "015", "", "", "39.70289", "-75.11184", "America/New_York"),
("4502434", "Jackson", "", "US", "840", "NJ", "007", "", "", "39.7765", "-74.86238", "America/New_York"),
("4502687", "Lindenwold", "", "US", "840", "NJ", "007", "", "", "39.82428", "-74.99767", "America/New_York"),
("4502901", "Maple Shade", "", "US", "840", "NJ", "005", "", "", "39.95261", "-74.99239", "America/New_York"),
("4503078", "Millville", "", "US", "840", "NJ", "011", "", "", "39.40206", "-75.03934", "America/New_York"),
("4503136", "Mount Laurel", "", "US", "840", "NJ", "005", "", "", "39.934", "-74.891", "America/New_York"),
("4503346", "Ocean Acres", "", "US", "840", "NJ", "029", "", "", "39.74345", "-74.28098", "America/New_York"),
("4503548", "Pennsauken", "", "US", "840", "NJ", "007", "", "", "39.95622", "-75.05795", "America/New_York"),
("4503646", "Pleasantville", "", "US", "840", "NJ", "001", "", "", "39.38984", "-74.52404", "America/New_York"),
("4504118", "Sicklerville", "", "US", "840", "NJ", "007", "", "", "39.71734", "-74.96933", "America/New_York"),
("4504225", "South Vineland", "", "US", "840", "NJ", "011", "", "", "39.44595", "-75.02879", "America/New_York"),
("4504476", "Toms River", "", "US", "840", "NJ", "029", "", "", "39.95373", "-74.19792", "America/New_York"),
("4504621", "Vineland", "", "US", "840", "NJ", "011", "", "", "39.48623", "-75.02573", "America/New_York"),
("4504871", "Williamstown", "", "US", "840", "NJ", "015", "", "", "39.68623", "-74.99517", "America/New_York"),
("4505542", "Athens", "Афины", "US", "840", "OH", "009", "", "", "39.32924", "-82.10126", "America/New_York"),
("4506008", "Beavercreek", "", "US", "840", "OH", "057", "", "", "39.70923", "-84.06327", "America/New_York"),
("4508204", "Centerville", "", "US", "840", "OH", "113", "", "", "39.62839", "-84.15938", "America/New_York"),
("4508722", "Cincinnati", "Цинциннати", "US", "840", "OH", "061", "", "", "39.162", "-84.45689", "America/New_York"),
("4509177", "Columbus", "Колумбус", "US", "840", "OH", "049", "", "", "39.96118", "-82.99879", "America/New_York"),
("4509884", "Dayton", "Дейтон", "US", "840", "OH", "113", "", "", "39.75895", "-84.19161", "America/New_York"),
("4511263", "Fairborn", "", "US", "840", "OH", "057", "", "", "39.82089", "-84.01938", "America/New_York"),
("4511283", "Fairfield", "Феърфилд", "US", "840", "OH", "017", "", "", "39.34589", "-84.5605", "America/New_York"),
("4512060", "Forest Park", "", "US", "840", "OH", "061", "", "", "39.29034", "-84.50411", "America/New_York"),
("4513409", "Grove City", "", "US", "840", "OH", "049", "", "", "39.88145", "-83.09296", "America/New_York"),
("4513575", "Hamilton", "Гамильтон", "US", "840", "OH", "017", "", "", "39.3995", "-84.56134", "America/New_York"),
("4514746", "Huber Heights", "", "US", "840", "OH", "113", "", "", "39.84395", "-84.12466", "America/New_York"),
("4515843", "Kettering", "Кеттеринг", "US", "840", "OH", "113", "", "", "39.6895", "-84.16883", "America/New_York"),
("4516233", "Lancaster", "Ланкастер", "US", "840", "OH", "045", "", "", "39.71368", "-82.59933", "America/New_York"),
("4516412", "Lebanon", "", "US", "840", "OH", "165", "", "", "39.43534", "-84.20299", "America/New_York"),
("4517698", "Mason", "Мейсон", "US", "840", "OH", "165", "", "", "39.36006", "-84.30994", "America/New_York"),
("4518188", "Miamisburg", "", "US", "840", "OH", "113", "", "", "39.64284", "-84.28661", "America/New_York"),
("4518264", "Middletown", "Мидлтаун", "US", "840", "OH", "017", "", "", "39.51506", "-84.39828", "America/New_York"),
("4519995", "Norwood", "", "US", "840", "OH", "061", "", "", "39.15561", "-84.45966", "America/New_York"),
("4520760", "Oxford", "Оксфорд", "US", "840", "OH", "017", "", "", "39.507", "-84.74523", "America/New_York"),
("4521209", "Pickerington", "", "US", "840", "OH", "045", "", "", "39.88423", "-82.7535", "America/New_York"),
("4521816", "Portsmouth", "Портсмут", "US", "840", "OH", "145", "", "", "38.73174", "-82.99767", "America/New_York"),
("4522411", "Reynoldsburg", "", "US", "840", "OH", "049", "", "", "39.95479", "-82.81212", "America/New_York"),
("4522586", "Riverside", "Риверсайд", "US", "840", "OH", "113", "", "", "39.77978", "-84.1241", "America/New_York"),
("4525304", "Springboro", "", "US", "840", "OH", "165", "", "", "39.55228", "-84.23327", "America/New_York"),
("4525353", "Springfield", "Спрингфилд", "US", "840", "OH", "023", "", "", "39.92423", "-83.80882", "America/New_York"),
("4526576", "Trotwood", "Тротвуд", "US", "840", "OH", "113", "", "", "39.79728", "-84.31133", "America/New_York"),
("4526993", "Upper Arlington", "", "US", "840", "OH", "049", "", "", "39.99451", "-83.06241", "America/New_York"),
("4527124", "Vandalia", "", "US", "840", "OH", "113", "", "", "39.89061", "-84.19883", "America/New_York"),
("4528259", "White Oak", "", "US", "840", "OH", "061", "", "", "39.21311", "-84.59939", "America/New_York"),
("4528291", "Whitehall", "", "US", "840", "OH", "049", "", "", "39.96673", "-82.88546", "America/New_York"),
("4528810", "Xenia", "Ксения", "US", "840", "OH", "057", "", "", "39.68478", "-83.92965", "America/New_York"),
("4528923", "Zanesville", "", "US", "840", "OH", "119", "", "", "39.94035", "-82.01319", "America/New_York"),
("4529096", "Ada", "", "US", "840", "OK", "123", "", "", "34.77453", "-96.67834", "America/Chicago"),
("4529292", "Altus", "", "US", "840", "OK", "065", "", "", "34.63813", "-99.33398", "America/Chicago"),
("4529469", "Ardmore", "", "US", "840", "OK", "019", "", "", "34.17426", "-97.14363", "America/Chicago"),
("4529987", "Bartlesville", "", "US", "840", "OK", "147", "", "", "36.74731", "-95.98082", "America/Chicago"),
("4530372", "Bethany", "", "US", "840", "OK", "109", "", "", "35.51867", "-97.63226", "America/Chicago"),
("4530801", "Bixby", "", "US", "840", "OK", "143", "", "", "35.94204", "-95.88332", "America/Chicago"),
("4531405", "Broken Arrow", "Брокен-Эрроу", "US", "840", "OK", "143", "", "", "36.0526", "-95.79082", "America/Chicago"),
("4533029", "Chickasha", "", "US", "840", "OK", "051", "", "", "35.05256", "-97.93643", "America/Chicago"),
("4533580", "Claremore", "Клермор", "US", "840", "OK", "131", "", "", "36.3126", "-95.61609", "America/Chicago"),
("4534934", "Del City", "", "US", "840", "OK", "109", "", "", "35.44201", "-97.44087", "America/Chicago"),
("4535389", "Duncan", "Дункан", "US", "840", "OK", "137", "", "", "34.5023", "-97.95781", "America/Chicago"),
("4535414", "Durant", "", "US", "840", "OK", "013", "", "", "33.99399", "-96.37082", "America/Chicago"),
("4535740", "Edmond", "Эдмон", "US", "840", "OK", "109", "", "", "35.65283", "-97.4781", "America/Chicago"),
("4535783", "El Reno", "", "US", "840", "OK", "017", "", "", "35.53227", "-97.95505", "America/Chicago"),
("4535961", "Enid", "Энид", "US", "840", "OK", "047", "", "", "36.39559", "-97.87839", "America/Chicago"),
("4539615", "Jenks", "", "US", "840", "OK", "143", "", "", "36.02287", "-95.96833", "America/Chicago"),
("4540737", "Lawton", "Лоутон", "US", "840", "OK", "031", "", "", "34.60869", "-98.39033", "America/Chicago"),
("4542367", "McAlester", "", "US", "840", "OK", "121", "", "", "34.93343", "-95.76971", "America/Chicago"),
("4542765", "Midwest City", "", "US", "840", "OK", "109", "", "", "35.44951", "-97.3967", "America/Chicago"),
("4542975", "Moore", "Мур", "US", "840", "OK", "027", "", "", "35.33951", "-97.4867", "America/Chicago"),
("4543338", "Muskogee", "Маскоги", "US", "840", "OK", "101", "", "", "35.74788", "-95.36969", "America/Chicago"),
("4543352", "Mustang", "", "US", "840", "OK", "017", "", "", "35.38423", "-97.72449", "America/Chicago"),
("4543762", "Norman", "Норман", "US", "840", "OK", "027", "", "", "35.22257", "-97.43948", "America/Chicago"),
("4544349", "Oklahoma City", "Оклахома Сити", "US", "840", "OK", "109", "", "", "35.46756", "-97.51643", "America/Chicago"),
("4547407", "Owasso", "", "US", "840", "OK", "143", "", "", "36.26954", "-95.85471", "America/Chicago"),
("4548267", "Ponca City", "", "US", "840", "OK", "071", "", "", "36.70698", "-97.08559", "America/Chicago"),
("4550659", "Sand Springs", "", "US", "840", "OK", "143", "", "", "36.13981", "-96.10889", "America/Chicago"),
("4550881", "Sapulpa", "", "US", "840", "OK", "037", "", "", "35.9987", "-96.11417", "America/Chicago"),
("4551177", "Shawnee", "", "US", "840", "OK", "125", "", "", "35.32729", "-96.9253", "America/Chicago"),
("4552215", "Stillwater", "", "US", "840", "OK", "119", "", "", "36.11561", "-97.05837", "America/Chicago"),
("4552707", "Tahlequah", "", "US", "840", "OK", "021", "", "", "35.91537", "-94.96996", "America/Chicago"),
("4553433", "Tulsa", "Талса", "US", "840", "OK", "143", "", "", "36.15398", "-95.99278", "America/Chicago"),
("4556165", "Yukon", "Юкон", "US", "840", "OK", "017", "", "", "35.50672", "-97.76254", "America/Chicago"),
("4557109", "Chambersburg", "", "US", "840", "PA", "055", "", "", "39.93759", "-77.6611", "America/New_York"),
("4557137", "Chester", "Честер", "US", "840", "PA", "045", "", "", "39.84956", "-75.35575", "America/New_York"),
("4557606", "Drexel Hill", "", "US", "840", "PA", "045", "", "", "39.94706", "-75.29213", "America/New_York"),
("4558475", "Hanover", "", "US", "840", "PA", "133", "", "", "39.80066", "-76.98304", "America/New_York"),
("4560349", "Philadelphia", "Филадельфия", "US", "840", "PA", "101", "", "", "39.95234", "-75.16379", "America/New_York"),
("4561407", "Springfield", "Спрингфилд", "US", "840", "PA", "045", "", "", "39.93067", "-75.32019", "America/New_York"),
("4562144", "West Chester", "", "US", "840", "PA", "029", "", "", "39.96066", "-75.60549", "America/New_York"),
("4562407", "York", "Йорк", "US", "840", "PA", "133", "", "", "39.9626", "-76.72774", "America/New_York"),
("4569067", "Aiken", "Айкен", "US", "840", "SC", "003", "", "", "33.56042", "-81.71955", "America/New_York"),
("4569298", "Anderson", "Андерсон", "US", "840", "SC", "007", "", "", "34.50344", "-82.65013", "America/New_York"),
("4574324", "Charleston", "Чарлстон", "US", "840", "SC", "019", "", "", "32.77657", "-79.93092", "America/New_York"),
("4575352", "Columbia", "Колумбия", "US", "840", "SC", "079", "", "", "34.00071", "-81.03481", "America/New_York"),
("4575461", "Conway", "Конвей", "US", "840", "SC", "051", "", "", "33.836", "-79.04781", "America/New_York"),
("4577263", "Easley", "", "US", "840", "SC", "077", "4577263", "", "34.82984", "-82.60152", "America/New_York"),
("4578737", "Florence", "Флоренция", "US", "840", "SC", "041", "", "", "34.19543", "-79.76256", "America/New_York"),
("4580098", "Goose Creek", "", "US", "840", "SC", "015", "", "", "32.98101", "-80.03259", "America/New_York"),
("4580543", "Greenville", "Гринвилл", "US", "840", "SC", "045", "", "", "34.85262", "-82.39401", "America/New_York"),
("4580569", "Greenwood", "", "US", "840", "SC", "047", "", "", "34.1954", "-82.16179", "America/New_York"),
("4580599", "Greer", "Грир", "US", "840", "SC", "045", "", "", "34.93873", "-82.22706", "America/New_York"),
("4581023", "Hanahan", "", "US", "840", "SC", "015", "", "", "32.91851", "-80.02203", "America/New_York"),
("4581833", "Hilton Head Island", "", "US", "840", "SC", "013", "", "", "32.21632", "-80.75261", "America/New_York"),
("4585000", "Lexington", "Лексингтон", "US", "840", "SC", "063", "", "", "33.98154", "-81.23621", "America/New_York"),
("4586523", "Mauldin", "", "US", "840", "SC", "045", "", "", "34.77873", "-82.31012", "America/New_York"),
("4588165", "Mount Pleasant", "", "US", "840", "SC", "019", "", "", "32.79407", "-79.86259", "America/New_York"),
("4588718", "Myrtle Beach", "Мертл-Бич", "US", "840", "SC", "051", "", "", "33.68906", "-78.88669", "America/New_York"),
("4589368", "North Augusta", "", "US", "840", "SC", "003", "", "", "33.5018", "-81.96512", "America/New_York"),
("4589387", "North Charleston", "", "US", "840", "SC", "019", "", "", "32.85306", "-79.97463", "America/New_York"),
("4593142", "Rock Hill", "", "US", "840", "SC", "091", "", "", "34.92487", "-81.02508", "America/New_York"),
("4593724", "Saint Andrews", "", "US", "840", "SC", "063", "", "", "34.04543", "-81.12926", "America/New_York"),
("4595374", "Seven Oaks", "", "US", "840", "SC", "063", "", "", "34.04876", "-81.14648", "America/New_York"),
("4595864", "Simpsonville", "", "US", "840", "SC", "045", "", "", "34.73706", "-82.25428", "America/New_York"),
("4596208", "Socastee", "", "US", "840", "SC", "051", "", "", "33.6835", "-78.99837", "America/New_York"),
("4597200", "Spartanburg", "Спартанберг", "US", "840", "SC", "083", "", "", "34.94957", "-81.93205", "America/New_York"),
("4597919", "Summerville", "", "US", "840", "SC", "035", "", "", "33.0185", "-80.17565", "America/New_York"),
("4597948", "Sumter", "", "US", "840", "SC", "085", "", "", "33.92044", "-80.34147", "America/New_York"),
("4598353", "Taylors", "", "US", "840", "SC", "045", "", "", "34.92039", "-82.29623", "America/New_York"),
("4599937", "Wade Hampton", "", "US", "840", "SC", "045", "", "", "34.90373", "-82.33317", "America/New_York"),
("4604183", "Bartlett", "Бартлетт", "US", "840", "TN", "157", "", "", "35.20453", "-89.87398", "America/Chicago"),
("4608408", "Brentwood", "", "US", "840", "TN", "187", "", "", "36.03312", "-86.78278", "America/Chicago"),
("4608418", "Brentwood Estates", "", "US", "840", "TN", "187", "", "", "36.02506", "-86.77917", "America/Chicago"),
("4608657", "Bristol", "", "US", "840", "TN", "163", "", "", "36.59511", "-82.18874", "America/New_York"),
("4612862", "Chattanooga", "Чаттануга", "US", "840", "TN", "065", "", "", "35.04563", "-85.30968", "America/New_York"),
("4613868", "Clarksville", "Кларксвилл", "US", "840", "TN", "125", "", "", "36.52977", "-87.35945", "America/Chicago"),
("4614088", "Cleveland", "Кливленд", "US", "840", "TN", "011", "", "", "35.15952", "-84.87661", "America/New_York"),
("4614748", "Collierville", "", "US", "840", "TN", "157", "", "", "35.04204", "-89.66453", "America/Chicago"),
("4614867", "Columbia", "Колумбия", "US", "840", "TN", "119", "", "", "35.61507", "-87.03528", "America/Chicago"),
("4615145", "Cookeville", "", "US", "840", "TN", "141", "", "", "36.16284", "-85.50164", "America/Chicago"),
("4619800", "Dyersburg", "", "US", "840", "TN", "045", "", "", "36.03452", "-89.38563", "America/Chicago"),
("4619943", "East Brainerd", "", "US", "840", "TN", "065", "", "", "34.99591", "-85.15023", "America/New_York"),
("4619947", "East Chattanooga", "", "US", "840", "TN", "065", "", "", "35.06535", "-85.24912", "America/New_York"),
("4620131", "East Ridge", "", "US", "840", "TN", "065", "", "", "35.01424", "-85.2519", "America/New_York"),
("4621846", "Farragut", "", "US", "840", "TN", "093", "", "", "35.88452", "-84.15353", "America/New_York"),
("4623560", "Franklin", "Франклин", "US", "840", "TN", "187", "", "", "35.92506", "-86.86889", "America/Chicago"),
("4624180", "Gallatin", "", "US", "840", "TN", "165", "", "", "36.38838", "-86.44666", "America/Chicago"),
("4624601", "Germantown", "", "US", "840", "TN", "157", "", "", "35.08676", "-89.81009", "America/Chicago"),
("4625282", "Goodlettsville", "", "US", "840", "TN", "037", "", "", "36.32311", "-86.71333", "America/Chicago"),
("4626334", "Greeneville", "", "US", "840", "TN", "059", "", "", "36.16316", "-82.83099", "America/New_York"),
("4628735", "Hendersonville", "", "US", "840", "TN", "165", "", "", "36.30477", "-86.62", "America/Chicago"),
("4632595", "Jackson", "Джексон", "US", "840", "TN", "113", "", "", "35.61452", "-88.81395", "America/Chicago"),
("4633419", "Johnson City", "", "US", "840", "TN", "179", "", "", "36.31344", "-82.35347", "America/New_York"),
("4634662", "Kingsport", "", "US", "840", "TN", "163", "", "", "36.54843", "-82.56182", "America/New_York"),
("4634946", "Knoxville", "Ноксвилл", "US", "840", "TN", "093", "", "", "35.96064", "-83.92074", "America/New_York"),
("4635031", "La Vergne", "", "US", "840", "TN", "149", "", "", "36.01562", "-86.58194", "America/Chicago"),
("4636045", "Lebanon", "", "US", "840", "TN", "189", "", "", "36.20811", "-86.2911", "America/Chicago"),
("4639848", "Maryville", "", "US", "840", "TN", "009", "", "", "35.75647", "-83.97046", "America/New_York"),
("4641239", "Memphis", "Мемфис", "US", "840", "TN", "157", "", "", "35.14953", "-90.04898", "America/Chicago"),
("4642938", "Morristown", "", "US", "840", "TN", "063", "", "", "36.21398", "-83.29489", "America/New_York"),
("4643336", "Mount Juliet", "", "US", "840", "TN", "189", "", "", "36.20006", "-86.51861", "America/Chicago"),
("4644312", "Murfreesboro", "Мерфрисборо", "US", "840", "TN", "149", "", "", "35.84562", "-86.39027", "America/Chicago"),
("4644585", "Nashville", "Нашвилл", "US", "840", "TN", "037", "", "", "36.16589", "-86.78444", "America/Chicago"),
("4645421", "New South Memphis", "", "US", "840", "TN", "157", "", "", "35.08676", "-90.05676", "America/Chicago"),
("4646571", "Oak Ridge", "Оук-Ридж", "US", "840", "TN", "001", "", "", "36.01036", "-84.26964", "America/New_York"),
("4657077", "Shelbyville", "", "US", "840", "TN", "003", "", "", "35.48341", "-86.46027", "America/Chicago"),
("4658590", "Smyrna", "Смирна", "US", "840", "TN", "149", "", "", "35.98284", "-86.5186", "America/Chicago"),
("4659446", "Spring Hill", "Спринг-Хилл", "US", "840", "TN", "119", "", "", "35.75118", "-86.93", "America/Chicago"),
("4659557", "Springfield", "Спрингфилд", "US", "840", "TN", "147", "", "", "36.50921", "-86.885", "America/Chicago"),
("4663494", "Tullahoma", "", "US", "840", "TN", "031", "", "", "35.36202", "-86.20943", "America/Chicago"),
("4669635", "Abilene", "Абилин", "US", "840", "TX", "441", "", "", "32.44874", "-99.73314", "America/Chicago"),
("4670074", "Alamo", "", "US", "840", "TX", "215", "", "", "26.18369", "-98.12306", "America/Chicago"),
("4670146", "Aldine", "", "US", "840", "TX", "201", "", "", "29.93244", "-95.38021", "America/Chicago"),
("4670234", "Alice", "", "US", "840", "TX", "249", "", "", "27.75225", "-98.06972", "America/Chicago"),
("4670300", "Allen", "Аллен", "US", "840", "TX", "085", "", "", "33.10317", "-96.67055", "America/Chicago"),
("4670592", "Alvin", "Элвин", "US", "840", "TX", "039", "", "", "29.42385", "-95.2441", "America/Chicago"),
("4670866", "Angleton", "", "US", "840", "TX", "039", "", "", "29.16941", "-95.43188", "America/Chicago"),
("4671240", "Arlington", "Арлингтон", "US", "840", "TX", "439", "", "", "32.73569", "-97.10807", "America/Chicago"),
("4671524", "Atascocita", "", "US", "840", "TX", "201", "", "", "29.99883", "-95.1766", "America/Chicago"),
("4671654", "Austin", "Остин", "US", "840", "TX", "453", "", "", "30.26715", "-97.74306", "America/Chicago"),
("4672059", "Balch Springs", "", "US", "840", "TX", "113", "", "", "32.72874", "-96.62277", "America/Chicago"),
("4672731", "Baytown", "", "US", "840", "TX", "201", "", "", "29.7355", "-94.97743", "America/Chicago"),
("4672989", "Beaumont", "Бомонт", "US", "840", "TX", "245", "", "", "30.08605", "-94.10185", "America/Chicago"),
("4673094", "Bedford", "Бедфорд", "US", "840", "TX", "439", "", "", "32.84402", "-97.14307", "America/Chicago"),
("4673353", "Bellaire", "", "US", "840", "TX", "201", "", "", "29.70579", "-95.45883", "America/Chicago"),
("4673425", "Belton", "Белтон", "US", "840", "TX", "027", "", "", "31.05601", "-97.46445", "America/Chicago"),
("4673482", "Benbrook", "", "US", "840", "TX", "439", "", "", "32.67319", "-97.46058", "America/Chicago"),
("4676206", "Brenham", "", "US", "840", "TX", "477", "", "", "30.16688", "-96.39774", "America/Chicago"),
("4676740", "Brownsville", "Браунсвилл", "US", "840", "TX", "061", "", "", "25.90175", "-97.49748", "America/Chicago"),
("4676798", "Brownwood", "", "US", "840", "TX", "049", "", "", "31.70932", "-98.99116", "America/Chicago"),
("4676920", "Brushy Creek", "", "US", "840", "TX", "491", "", "", "30.51353", "-97.73973", "America/Chicago"),
("4677008", "Bryan", "", "US", "840", "TX", "041", "", "", "30.67436", "-96.36996", "America/Chicago"),
("4677551", "Burleson", "Бурлесоне", "US", "840", "TX", "251", "", "", "32.54208", "-97.32085", "America/Chicago"),
("4678901", "Canyon Lake", "", "US", "840", "TX", "091", "", "", "29.87522", "-98.26251", "America/Chicago"),
("4679195", "Carrollton", "Кэрролтон", "US", "840", "TX", "113", "", "", "32.95373", "-96.89028", "America/Chicago"),
("4679803", "Cedar Hill", "", "US", "840", "TX", "113", "", "", "32.58847", "-96.95612", "America/Chicago"),
("4679867", "Cedar Park", "", "US", "840", "TX", "491", "", "", "30.5052", "-97.82029", "America/Chicago"),
("4680388", "Channelview", "", "US", "840", "TX", "201", "", "", "29.77606", "-95.11465", "America/Chicago"),
("4681462", "Cibolo", "", "US", "840", "TX", "187", "", "", "29.56162", "-98.22696", "America/Chicago"),
("4681485", "Cinco Ranch", "", "US", "840", "TX", "157", "", "", "29.73884", "-95.758", "America/Chicago"),
("4681976", "Cleburne", "", "US", "840", "TX", "251", "", "", "32.34764", "-97.38668", "America/Chicago"),
("4682127", "Cloverleaf", "", "US", "840", "TX", "201", "", "", "29.77828", "-95.17188", "America/Chicago"),
("4682464", "College Station", "Колледж-Стейшен", "US", "840", "TX", "041", "", "", "30.62798", "-96.33441", "America/Chicago"),
("4682478", "Colleyville", "", "US", "840", "TX", "439", "", "", "32.88096", "-97.15501", "America/Chicago"),
("4682991", "Conroe", "", "US", "840", "TX", "339", "", "", "30.31188", "-95.45605", "America/Chicago"),
("4683021", "Converse", "", "US", "840", "TX", "029", "", "", "29.51801", "-98.31612", "America/Chicago"),
("4683217", "Coppell", "Коппелл", "US", "840", "TX", "113", "", "", "32.95457", "-97.01501", "America/Chicago"),
("4683244", "Copperas Cove", "", "US", "840", "TX", "099", "", "", "31.12406", "-97.90308", "America/Chicago"),
("4683317", "Corinth", "", "US", "840", "TX", "121", "", "", "33.15401", "-97.06473", "America/Chicago"),
("4683416", "Corpus Christi", "Корпус-Кристи", "US", "840", "TX", "355", "", "", "27.80058", "-97.39638", "America/Chicago"),
("4683462", "Corsicana", "", "US", "840", "TX", "349", "", "", "32.09543", "-96.46887", "America/Chicago"),
("4684724", "Cypress", "", "US", "840", "TX", "201", "", "", "29.96911", "-95.69717", "America/Chicago"),
("4684888", "Dallas", "Даллас", "US", "840", "TX", "113", "", "", "32.78306", "-96.80667", "America/Chicago"),
("4685524", "DeSoto", "Сото", "US", "840", "TX", "113", "", "", "32.58986", "-96.85695", "America/Chicago"),
("4685737", "Deer Park", "", "US", "840", "TX", "201", "", "", "29.70523", "-95.12382", "America/Chicago"),
("4685892", "Denison", "Денисон", "US", "840", "TX", "181", "", "", "33.75566", "-96.53666", "America/Chicago"),
("4685907", "Denton", "Дентон", "US", "840", "TX", "121", "", "", "33.21484", "-97.13307", "America/Chicago"),
("4686163", "Dickinson", "", "US", "840", "TX", "167", "", "", "29.46079", "-95.05132", "America/Chicago"),
("4686593", "Donna", "", "US", "840", "TX", "215", "", "", "26.17035", "-98.05195", "America/Chicago"),
("4687331", "Duncanville", "", "US", "840", "TX", "113", "", "", "32.6518", "-96.90834", "America/Chicago"),
("4688275", "Edinburg", "Эдинбург", "US", "840", "TX", "215", "", "", "26.30174", "-98.16334", "America/Chicago"),
("4689311", "Ennis", "", "US", "840", "TX", "139", "", "", "32.32931", "-96.62527", "America/Chicago"),
("4689550", "Euless", "", "US", "840", "TX", "439", "", "", "32.83707", "-97.08195", "America/Chicago"),
("4690198", "Farmers Branch", "", "US", "840", "TX", "113", "", "", "32.92651", "-96.89612", "America/Chicago"),
("4691585", "Flower Mound", "", "US", "840", "TX", "121", "", "", "33.01457", "-97.09696", "America/Chicago"),
("4691930", "Fort Worth", "Форт-Уэрт", "US", "840", "TX", "439", "", "", "32.72541", "-97.32085", "America/Chicago"),
("4692400", "Fresno", "Фресно", "US", "840", "TX", "157", "", "", "29.53885", "-95.44744", "America/Chicago"),
("4692521", "Friendswood", "", "US", "840", "TX", "167", "", "", "29.5294", "-95.20104", "America/Chicago"),
("4692559", "Frisco", "Фриско", "US", "840", "TX", "085", "", "", "33.15067", "-96.82361", "America/Chicago"),
("4692746", "Gainesville", "", "US", "840", "TX", "097", "", "", "33.62594", "-97.13335", "America/Chicago"),
("4692883", "Galveston", "Галвестон", "US", "840", "TX", "167", "", "", "29.30135", "-94.7977", "America/Chicago"),
("4693003", "Garland", "Гирлянда", "US", "840", "TX", "113", "", "", "32.91262", "-96.63888", "America/Chicago"),
("4693150", "Gatesville", "", "US", "840", "TX", "099", "", "", "31.43516", "-97.74391", "America/Chicago"),
("4693342", "Georgetown", "", "US", "840", "TX", "491", "", "", "30.63269", "-97.67723", "America/Chicago"),
("4694482", "Grand Prairie", "Гранд-Прейри", "US", "840", "TX", "113", "", "", "32.74596", "-96.99778", "America/Chicago"),
("4694568", "Grapevine", "", "US", "840", "TX", "439", "", "", "32.93429", "-97.07807", "America/Chicago"),
("4695066", "Greenville", "Гринвилл", "US", "840", "TX", "231", "", "", "33.13845", "-96.11081", "America/Chicago"),
("4695317", "Groves", "", "US", "840", "TX", "245", "", "", "29.94827", "-93.91712", "America/Chicago"),
("4695912", "Haltom City", "", "US", "840", "TX", "439", "", "", "32.79957", "-97.26918", "America/Chicago"),
("4696202", "Harker Heights", "", "US", "840", "TX", "027", "", "", "31.08351", "-97.65974", "America/Chicago"),
("4696233", "Harlingen", "Харлинген", "US", "840", "TX", "061", "", "", "26.19063", "-97.6961", "America/Chicago"),
("4697645", "Highland Village", "", "US", "840", "TX", "121", "", "", "33.09179", "-97.04668", "America/Chicago"),
("4699066", "Houston", "Хьюстон", "US", "840", "TX", "201", "", "", "29.76328", "-95.36327", "America/Chicago"),
("4699442", "Humble", "", "US", "840", "TX", "201", "", "", "29.99883", "-95.26216", "America/Chicago"),
("4699540", "Huntsville", "Хантсвилл", "US", "840", "TX", "471", "", "", "30.72353", "-95.55078", "America/Chicago"),
("4699575", "Hurst", "Херст", "US", "840", "TX", "439", "", "", "32.82346", "-97.17057", "America/Chicago"),
("4700168", "Irving", "Ирвинг", "US", "840", "TX", "113", "", "", "32.81402", "-96.94889", "America/Chicago"),
("4701458", "Jollyville", "", "US", "840", "TX", "491", "", "", "30.4427", "-97.77501", "America/Chicago"),
("4702828", "Keller", "Келлер", "US", "840", "TX", "439", "", "", "32.93457", "-97.25168", "America/Chicago"),
("4703078", "Kerrville", "", "US", "840", "TX", "265", "", "", "30.04743", "-99.14032", "America/Chicago"),
("4703223", "Killeen", "Киллин", "US", "840", "TX", "027", "", "", "31.11712", "-97.7278", "America/Chicago"),
("4703384", "Kingsville", "", "US", "840", "TX", "273", "", "", "27.51587", "-97.85611", "America/Chicago"),
("4703811", "Kyle", "", "US", "840", "TX", "209", "", "", "29.99835", "-97.87153", "America/Chicago"),
("4704108", "La Porte", "", "US", "840", "TX", "201", "", "", "29.66578", "-95.01937", "America/Chicago"),
("4704628", "Lake Jackson", "", "US", "840", "TX", "039", "", "", "29.03386", "-95.43439", "America/Chicago"),
("4705191", "Lancaster", "Ланкастер", "US", "840", "TX", "113", "", "", "32.59208", "-96.75611", "America/Chicago"),
("4705349", "Laredo", "Ларедо", "US", "840", "TX", "479", "", "", "27.50641", "-99.50754", "America/Chicago"),
("4705692", "League City", "", "US", "840", "TX", "167", "", "", "29.50745", "-95.09493", "America/Chicago"),
("4705708", "Leander", "", "US", "840", "TX", "491", "", "", "30.57881", "-97.85307", "America/Chicago"),
("4706057", "Lewisville", "", "US", "840", "TX", "121", "", "", "33.04623", "-96.99417", "America/Chicago"),
("4706736", "Little Elm", "", "US", "840", "TX", "121", "", "", "33.16262", "-96.93751", "America/Chicago"),
("4707814", "Longview", "", "US", "840", "TX", "183", "", "", "32.5007", "-94.74049", "America/Chicago"),
("4708308", "Lufkin", "", "US", "840", "TX", "005", "", "", "31.33824", "-94.7291", "America/Chicago"),
("4709013", "Mansfield", "Мэнсфилд", "US", "840", "TX", "439", "", "", "32.56319", "-97.14168", "America/Chicago"),
("4709272", "Marshall", "Маршалл", "US", "840", "TX", "203", "", "", "32.54487", "-94.36742", "America/Chicago"),
("4709796", "McAllen", "Мак-Аллен", "US", "840", "TX", "215", "", "", "26.20341", "-98.23001", "America/Chicago"),
("4710178", "McKinney", "Мак-Кинни", "US", "840", "TX", "085", "", "", "33.19762", "-96.61527", "America/Chicago"),
("4710749", "Mercedes", "", "US", "840", "TX", "215", "", "", "26.1498", "-97.91361", "America/Chicago"),
("4710826", "Mesquite", "Мескит", "US", "840", "TX", "113", "", "", "32.7668", "-96.59916", "America/Chicago"),
("4711156", "Midlothian", "", "US", "840", "TX", "139", "", "", "32.48236", "-96.99445", "America/Chicago"),
("4711647", "Mineral Wells", "", "US", "840", "TX", "363", "", "", "32.80846", "-98.11282", "America/Chicago"),
("4711725", "Mission", "Миссия", "US", "840", "TX", "215", "", "", "26.21591", "-98.32529", "America/Chicago"),
("4711729", "Mission Bend", "", "US", "840", "TX", "157", "", "", "29.69384", "-95.66495", "America/Chicago"),
("4711801", "Missouri City", "", "US", "840", "TX", "157", "", "", "29.61857", "-95.53772", "America/Chicago"),
("4712933", "Mount Pleasant", "", "US", "840", "TX", "449", "", "", "33.15679", "-94.96827", "America/Chicago"),
("4713507", "Murphy", "", "US", "840", "TX", "085", "", "", "33.01512", "-96.61305", "America/Chicago"),
("4713735", "Nacogdoches", "", "US", "840", "TX", "347", "", "", "31.60351", "-94.65549", "America/Chicago"),
("4713932", "Nederland", "", "US", "840", "TX", "245", "", "", "29.97438", "-93.9924", "America/Chicago"),
("4714131", "New Braunfels", "", "US", "840", "TX", "091", "", "", "29.703", "-98.12445", "America/Chicago"),
("4714582", "New Territory", "", "US", "840", "TX", "157", "", "", "29.59412", "-95.68078", "America/Chicago"),
("4715292", "North Richland Hills", "", "US", "840", "TX", "439", "", "", "32.8343", "-97.2289", "America/Chicago"),
("4716805", "Orange", "", "US", "840", "TX", "361", "", "", "30.09299", "-93.73655", "America/Chicago"),
("4717232", "Palestine", "Палестин", "US", "840", "TX", "001", "", "", "31.76212", "-95.63079", "America/Chicago"),
("4717560", "Paris", "Париж", "US", "840", "TX", "277", "", "", "33.66094", "-95.55551", "America/Chicago"),
("4717782", "Pasadena", "Пасадена", "US", "840", "TX", "201", "", "", "29.69106", "-95.2091", "America/Chicago"),
("4718097", "Pearland", "", "US", "840", "TX", "039", "", "", "29.56357", "-95.28605", "America/Chicago"),
("4718209", "Pecan Grove", "", "US", "840", "TX", "157", "", "", "29.62607", "-95.73162", "America/Chicago"),
("4718711", "Pflugerville", "", "US", "840", "TX", "453", "", "", "30.43937", "-97.62", "America/Chicago"),
("4718721", "Pharr", "Фарра", "US", "840", "TX", "215", "", "", "26.1948", "-98.18362", "America/Chicago"),
("4719457", "Plano", "Планом", "US", "840", "TX", "085", "", "", "33.01984", "-96.69889", "America/Chicago"),
("4720039", "Port Arthur", "Порт-Артур", "US", "840", "TX", "245", "", "", "29.89883", "-93.92878", "America/Chicago"),
("4720131", "Portland", "Портленд", "US", "840", "TX", "409", "", "", "27.87725", "-97.32388", "America/Chicago"),
("4722625", "Richardson", "Ричардсон", "US", "840", "TX", "113", "", "", "32.94818", "-96.72972", "America/Chicago"),
("4723406", "Rockwall", "", "US", "840", "TX", "397", "", "", "32.93123", "-96.45971", "America/Chicago"),
("4723914", "Rosenberg", "Розенберг", "US", "840", "TX", "157", "", "", "29.55718", "-95.80856", "America/Chicago"),
("4724129", "Round Rock", "Раунд-Рок", "US", "840", "TX", "491", "", "", "30.50826", "-97.6789", "America/Chicago"),
("4724194", "Rowlett", "", "US", "840", "TX", "113", "", "", "32.9029", "-96.56388", "America/Chicago"),
("4724564", "Sachse", "", "US", "840", "TX", "113", "", "", "32.97623", "-96.59527", "America/Chicago"),
("4724642", "Saginaw", "", "US", "840", "TX", "439", "", "", "32.86013", "-97.36391", "America/Chicago"),
("4726206", "San Antonio", "Сан-Антонио", "US", "840", "TX", "029", "", "", "29.42412", "-98.49363", "America/Chicago"),
("4726290", "San Benito", "", "US", "840", "TX", "061", "", "", "26.13258", "-97.6311", "America/Chicago"),
("4726440", "San Juan", "", "US", "840", "TX", "215", "", "", "26.18924", "-98.15529", "America/Chicago"),
("4726491", "San Marcos", "", "US", "840", "TX", "209", "", "", "29.88327", "-97.94139", "America/Chicago"),
("4727326", "Schertz", "", "US", "840", "TX", "187", "", "", "29.55217", "-98.26973", "America/Chicago"),
("4727756", "Seguin", "", "US", "840", "TX", "187", "", "", "29.56884", "-97.96473", "America/Chicago"),
("4728328", "Sherman", "Шерман", "US", "840", "TX", "181", "", "", "33.63566", "-96.60888", "America/Chicago"),
("4733042", "South Houston", "", "US", "840", "TX", "201", "", "", "29.66301", "-95.23549", "America/Chicago"),
("4733313", "Southlake", "", "US", "840", "TX", "439", "", "", "32.94124", "-97.13418", "America/Chicago"),
("4733624", "Spring", "", "US", "840", "TX", "201", "", "", "30.07994", "-95.41716", "America/Chicago"),
("4734005", "Stafford", "", "US", "840", "TX", "157", "", "", "29.61607", "-95.55772", "America/Chicago"),
("4734350", "Stephenville", "", "US", "840", "TX", "143", "", "", "32.2207", "-98.20226", "America/Chicago"),
("4734825", "Sugar Land", "Шугар-Ленд", "US", "840", "TX", "157", "", "", "29.61968", "-95.63495", "America/Chicago"),
("4734909", "Sulphur Springs", "", "US", "840", "TX", "223", "", "", "33.13845", "-95.60107", "America/Chicago"),
("4735702", "Taylor", "Тейлор", "US", "840", "TX", "491", "", "", "30.57076", "-97.40944", "America/Chicago"),
("4735966", "Temple", "", "US", "840", "TX", "027", "", "", "31.09823", "-97.34278", "America/Chicago"),
("4736028", "Terrell", "", "US", "840", "TX", "257", "", "", "32.73596", "-96.27526", "America/Chicago"),
("4736096", "Texarkana", "", "US", "840", "TX", "037", "", "", "33.42512", "-94.04769", "America/Chicago"),
("4736134", "Texas City", "", "US", "840", "TX", "167", "", "", "29.38384", "-94.9027", "America/Chicago"),
("4736388", "The Colony", "Колония", "US", "840", "TX", "121", "", "", "33.08901", "-96.88639", "America/Chicago"),
("4736476", "The Woodlands", "Зе-Вудлендс", "US", "840", "TX", "339", "", "", "30.15799", "-95.48938", "America/Chicago"),
("4738214", "Tyler", "Тайлер", "US", "840", "TX", "423", "", "", "32.35126", "-95.30106", "America/Chicago"),
("4738574", "Universal City", "", "US", "840", "TX", "029", "", "", "29.54801", "-98.29112", "America/Chicago"),
("4738606", "University Park", "", "US", "840", "TX", "113", "", "", "32.85013", "-96.80028", "America/Chicago"),
("4738721", "Uvalde", "", "US", "840", "TX", "463", "", "", "29.20968", "-99.78617", "America/Chicago"),
("4739157", "Victoria", "Виктория", "US", "840", "TX", "469", "", "", "28.80527", "-97.0036", "America/Chicago"),
("4739526", "Waco", "Вако", "US", "840", "TX", "309", "", "", "31.54933", "-97.14667", "America/Chicago"),
("4740214", "Watauga", "", "US", "840", "TX", "439", "", "", "32.85791", "-97.25474", "America/Chicago"),
("4740328", "Waxahachie", "", "US", "840", "TX", "139", "", "", "32.38653", "-96.84833", "America/Chicago"),
("4740364", "Weatherford", "", "US", "840", "TX", "367", "", "", "32.7593", "-97.79725", "America/Chicago"),
("4740629", "Weslaco", "", "US", "840", "TX", "215", "", "", "26.15952", "-97.99084", "America/Chicago"),
("4741616", "White Settlement", "", "US", "840", "TX", "439", "", "", "32.75957", "-97.45835", "America/Chicago"),
("4741752", "Wichita Falls", "Уичито-Фолс", "US", "840", "TX", "485", "", "", "33.91371", "-98.49339", "America/Chicago"),
("4743275", "Wylie", "", "US", "840", "TX", "085", "", "", "33.01512", "-96.53888", "America/Chicago"),
("4744091", "Alexandria", "Александрия", "US", "840", "VA", "510", "", "", "38.80484", "-77.04692", "America/New_York"),
("4744468", "Annandale", "", "US", "840", "VA", "059", "", "", "38.83039", "-77.19637", "America/New_York"),
("4744709", "Arlington", "Арлингтон", "US", "840", "VA", "013", "", "", "38.88101", "-77.10428", "America/New_York"),
("4744870", "Ashburn", "", "US", "840", "VA", "107", "", "", "39.04372", "-77.48749", "America/New_York"),
("4745272", "Baileys Crossroads", "", "US", "840", "VA", "059", "", "", "38.85039", "-77.1297", "America/New_York"),
("4747845", "Blacksburg", "Блэксбург", "US", "840", "VA", "121", "", "", "37.22957", "-80.41394", "America/New_York"),
("4748305", "Bon Air", "", "US", "840", "VA", "041", "", "", "37.52487", "-77.55777", "America/New_York"),
("4748993", "Bristol", "", "US", "840", "VA", "520", "", "", "36.59649", "-82.18847", "America/New_York"),
("4749627", "Buckhall", "", "US", "840", "VA", "153", "", "", "38.73178", "-77.4311", "America/New_York"),
("4749950", "Burke", "Берк", "US", "840", "VA", "059", "", "", "38.79345", "-77.27165", "America/New_York"),
("4751421", "Cave Spring", "", "US", "840", "VA", "161", "", "", "37.22764", "-80.01282", "America/New_York"),
("4751839", "Centreville", "", "US", "840", "VA", "059", "", "", "38.84039", "-77.42888", "America/New_York"),
("4751935", "Chantilly", "", "US", "840", "VA", "059", "", "", "38.89428", "-77.4311", "America/New_York"),
("4752031", "Charlottesville", "Шарлоттсвилль", "US", "840", "VA", "540", "", "", "38.02931", "-78.47668", "America/New_York"),
("4752136", "Cherry Hill", "", "US", "840", "VA", "153", "", "", "38.56984", "-77.26693", "America/New_York"),
("4752186", "Chesapeake", "Чесапик", "US", "840", "VA", "550", "", "", "36.81904", "-76.27494", "America/New_York"),
("4752229", "Chester", "Честер", "US", "840", "VA", "041", "", "", "37.35682", "-77.44165", "America/New_York"),
("4752665", "Christiansburg", "", "US", "840", "VA", "121", "", "", "37.12985", "-80.40894", "America/New_York"),
("4753671", "Colonial Heights", "", "US", "840", "VA", "570", "", "", "37.26804", "-77.40726", "America/New_York"),
("4754966", "Culpeper", "Калпепер", "US", "840", "VA", "047", "", "", "38.47318", "-77.99666", "America/New_York"),
("4755158", "Dale City", "", "US", "840", "VA", "153", "", "", "38.63706", "-77.31109", "America/New_York"),
("4755280", "Danville", "", "US", "840", "VA", "590", "", "", "36.58597", "-79.39502", "America/New_York"),
("4756955", "East Hampton", "", "US", "840", "VA", "650", "", "", "37.03737", "-76.33161", "America/New_York"),
("4758023", "Fairfax", "", "US", "840", "VA", "600", "", "", "38.84622", "-77.30637", "America/New_York"),
("4759968", "Franconia", "Франкония", "US", "840", "VA", "059", "", "", "38.78206", "-77.14637", "America/New_York"),
("4760059", "Fredericksburg", "Фредериксбург", "US", "840", "VA", "630", "", "", "38.30318", "-77.46054", "America/New_York"),
("4761951", "Great Falls", "", "US", "840", "VA", "059", "", "", "38.99817", "-77.28832", "America/New_York"),
("4762894", "Hampton", "Хэмптон", "US", "840", "VA", "650", "", "", "37.02987", "-76.34522", "America/New_York"),
("4763231", "Harrisonburg", "", "US", "840", "VA", "660", "", "", "38.44957", "-78.86892", "America/New_York"),
("4763793", "Herndon", "Херндон", "US", "840", "VA", "059", "", "", "38.96955", "-77.3861", "America/New_York"),
("4764127", "Highland Springs", "", "US", "840", "VA", "087", "", "", "37.54598", "-77.32776", "America/New_York"),
("4764826", "Hopewell", "Хопуэлла", "US", "840", "VA", "670", "", "", "37.30432", "-77.2872", "America/New_York"),
("4765520", "Hybla Valley", "", "US", "840", "VA", "059", "", "", "38.74761", "-77.08303", "America/New_York"),
("4765553", "Idylwood", "", "US", "840", "VA", "059", "", "", "38.89511", "-77.21165", "America/New_York"),
("4766586", "Jefferson", "Джефферсон", "US", "840", "VA", "059", "", "", "38.86456", "-77.18776", "America/New_York"),
("4768351", "Lake Ridge", "", "US", "840", "VA", "153", "", "", "38.68789", "-77.29776", "America/New_York"),
("4768678", "Laurel", "", "US", "840", "VA", "087", "", "", "37.64292", "-77.50887", "America/New_York"),
("4769125", "Leesburg", "", "US", "840", "VA", "107", "", "", "39.11566", "-77.5636", "America/New_York"),
("4769608", "Lincolnia", "", "US", "840", "VA", "059", "", "", "38.81845", "-77.14331", "America/New_York"),
("4769667", "Linton Hall", "", "US", "840", "VA", "153", "", "", "38.75984", "-77.57499", "America/New_York"),
("4770714", "Lorton", "", "US", "840", "VA", "059", "", "", "38.70428", "-77.22776", "America/New_York"),
("4771075", "Lynchburg", "", "US", "840", "VA", "680", "", "", "37.41375", "-79.14225", "America/New_York"),
("4771401", "Manassas", "Манассас", "US", "840", "VA", "683", "", "", "38.75095", "-77.47527", "America/New_York"),
("4772354", "McLean", "Маклин", "US", "840", "VA", "059", "", "", "38.93428", "-77.17748", "America/New_York"),
("4772566", "Mechanicsville", "", "US", "840", "VA", "085", "", "", "37.60876", "-77.37331", "America/New_York"),
("4772735", "Merrifield", "", "US", "840", "VA", "059", "", "", "38.87428", "-77.22693", "America/New_York"),
("4773677", "Montclair", "", "US", "840", "VA", "153", "", "", "38.61095", "-77.33971", "America/New_York"),
("4776024", "Newport News", "Ньюпорт-Ньюс", "US", "840", "VA", "700", "", "", "36.97876", "-76.428", "America/New_York"),
("4776222", "Norfolk", "Норфолк", "US", "840", "VA", "710", "", "", "36.84681", "-76.28522", "America/New_York"),
("4776970", "Oakton", "", "US", "840", "VA", "059", "", "", "38.88095", "-77.30082", "America/New_York"),
("4778626", "Petersburg", "Петербург", "US", "840", "VA", "730", "", "", "37.22793", "-77.40193", "America/New_York"),
("4779999", "Portsmouth", "Портсмут", "US", "840", "VA", "740", "", "", "36.83543", "-76.29827", "America/New_York"),
("4780011", "Portsmouth Heights", "", "US", "840", "VA", "740", "", "", "36.82098", "-76.36883", "America/New_York"),
("4780837", "Radford", "", "US", "840", "VA", "750", "", "", "37.13179", "-80.57645", "America/New_York"),
("4781530", "Reston", "Рестон", "US", "840", "VA", "059", "", "", "38.96872", "-77.3411", "America/New_York"),
("4781708", "Richmond", "Ричмонд", "US", "840", "VA", "760", "", "", "37.55376", "-77.46026", "America/New_York"),
("4782167", "Roanoke", "Роанок", "US", "840", "VA", "770", "", "", "37.27097", "-79.94143", "America/New_York"),
("4782864", "Rose Hill", "", "US", "840", "VA", "059", "", "", "38.78872", "-77.11276", "America/New_York"),
("4784112", "Salem", "Салем", "US", "840", "VA", "775", "", "", "37.29347", "-80.05476", "America/New_York"),
("4785576", "Short Pump", "", "US", "840", "VA", "087", "", "", "37.65042", "-77.61249", "America/New_York"),
("4786667", "South Riding", "", "US", "840", "VA", "107", "", "", "38.92094", "-77.50388", "America/New_York"),
("4786714", "South Suffolk", "", "US", "840", "VA", "800", "", "", "36.71709", "-76.59023", "America/New_York"),
("4787117", "Springfield", "Спрингфилд", "US", "840", "VA", "059", "", "", "38.78928", "-77.1872", "America/New_York"),
("4787440", "Staunton", "Стонтон", "US", "840", "VA", "790", "", "", "38.14958", "-79.0717", "America/New_York"),
("4787534", "Sterling", "Стерлинг", "US", "840", "VA", "107", "", "", "39.00622", "-77.4286", "America/New_York"),
("4788145", "Sudley", "", "US", "840", "VA", "153", "", "", "38.79289", "-77.49749", "America/New_York"),
("4788158", "Suffolk", "Саффолк", "US", "840", "VA", "800", "", "", "36.72821", "-76.58356", "America/New_York"),
("4790207", "Tuckahoe", "", "US", "840", "VA", "087", "", "", "37.59015", "-77.55638", "America/New_York"),
("4790534", "Tysons Corner", "", "US", "840", "VA", "059", "", "", "38.91872", "-77.23109", "America/New_York"),
("4791160", "Vienna", "", "US", "840", "VA", "059", "", "", "38.90122", "-77.26526", "America/New_York"),
("4791259", "Virginia Beach", "Вирджиния-Бич", "US", "840", "VA", "810", "", "", "36.85293", "-75.97798", "America/New_York"),
("4792522", "Waynesboro", "", "US", "840", "VA", "820", "", "", "38.06847", "-78.88947", "America/New_York"),
("4792867", "West Lynchburg", "", "US", "840", "VA", "680", "", "", "37.4032", "-79.17808", "America/New_York"),
("4792901", "West Springfield", "", "US", "840", "VA", "059", "", "", "38.77261", "-77.22109", "America/New_York"),
("4794120", "Winchester", "", "US", "840", "VA", "840", "", "", "39.18566", "-78.16333", "America/New_York"),
("4794350", "Wolf Trap", "", "US", "840", "VA", "059", "", "", "38.93983", "-77.28609", "America/New_York"),
("4794531", "Woodlawn", "", "US", "840", "VA", "059", "", "", "38.71678", "-77.13276", "America/New_York"),
("4798308", "Beckley", "Бекли", "US", "840", "WV", "081", "", "", "37.77817", "-81.18816", "America/New_York"),
("4801859", "Charleston", "Чарлстон", "US", "840", "WV", "039", "", "", "38.34982", "-81.63262", "America/New_York"),
("4802316", "Clarksburg", "Кларксберг", "US", "840", "WV", "033", "", "", "39.28065", "-80.34453", "America/New_York"),
("4805404", "Fairmont", "Фэрмонт", "US", "840", "WV", "049", "", "", "39.48508", "-80.14258", "America/New_York"),
("4809537", "Huntington", "Хантингтон", "US", "840", "WV", "011", "", "", "38.41925", "-82.44515", "America/New_York"),
("4813878", "Martinsburg", "Мартинсберг", "US", "840", "WV", "003", "", "", "39.45621", "-77.96389", "America/New_York"),
("4815352", "Morgantown", "Моргантаун", "US", "840", "WV", "061", "", "", "39.62953", "-79.9559", "America/New_York"),
("4817641", "Parkersburg", "Паркерсберг", "US", "840", "WV", "107", "", "", "39.26674", "-81.56151", "America/New_York"),
("4828193", "Sherwood", "", "US", "840", "AR", "119", "", "", "34.81509", "-92.22432", "America/Chicago"),
("4828382", "Franklin", "Франклин", "US", "840", "IN", "081", "", "", "39.48061", "-86.05499", "America/Indiana/Indianapolis"),
("4828890", "Chillicothe", "", "US", "840", "OH", "141", "", "", "39.33312", "-82.9824", "America/New_York"),
("4829307", "Bay City", "Бей-Сити", "US", "840", "TX", "321", "", "", "28.98276", "-95.9694", "America/Chicago"),
("4829762", "Alabaster", "Алебастр", "US", "840", "AL", "117", "", "", "33.24428", "-86.81638", "America/Chicago"),
("4829791", "Albertville", "", "US", "840", "AL", "095", "", "", "34.26759", "-86.20887", "America/Chicago"),
("4830198", "Anniston", "Аннистон", "US", "840", "AL", "015", "", "", "33.65983", "-85.83163", "America/Chicago"),
("4830668", "Athens", "Атенс", "US", "840", "AL", "083", "", "", "34.80287", "-86.97167", "America/Chicago"),
("4830796", "Auburn", "Оберн", "US", "840", "AL", "081", "", "", "32.60986", "-85.48078", "America/Chicago"),
("4832038", "Glendale Heights", "", "US", "840", "IL", "043", "", "", "41.91031", "-88.07174", "America/Chicago"),
("4832272", "North Andover", "", "US", "840", "MA", "009", "", "", "42.6987", "-71.13506", "America/New_York"),
("4832294", "Revere", "", "US", "840", "MA", "025", "", "", "42.40843", "-71.01199", "America/New_York"),
("4832353", "Danbury", "Данбери", "US", "840", "CT", "001", "", "", "41.39482", "-73.45401", "America/New_York"),
("4832425", "Darien", "", "US", "840", "CT", "001", "", "", "41.07871", "-73.46929", "America/New_York"),
("4832554", "Inkster", "", "US", "840", "MI", "163", "", "", "42.2942", "-83.30993", "America/Detroit"),
("4833320", "Cleveland Heights", "Кливленд-Хайтс", "US", "840", "OH", "035", "", "", "41.52005", "-81.55624", "America/New_York"),
("4833403", "East Hartford", "", "US", "840", "CT", "003", "", "", "41.78232", "-72.61203", "America/New_York"),
("4833425", "East Haven", "", "US", "840", "CT", "009", "", "", "41.27621", "-72.86843", "America/New_York"),
("4833505", "East Norwalk", "", "US", "840", "CT", "001", "", "", "41.10565", "-73.39845", "America/New_York"),
("4834040", "Enfield", "", "US", "840", "CT", "003", "", "", "41.97621", "-72.59176", "America/New_York"),
("4834157", "Fairfield", "Феърфилд", "US", "840", "CT", "001", "", "", "41.14121", "-73.26373", "America/New_York"),
("4834272", "Farmington", "Фармингтон", "US", "840", "CT", "003", "", "", "41.71982", "-72.83204", "America/New_York"),
("4835003", "Glastonbury", "Гластонбери", "US", "840", "CT", "003", "", "", "41.71232", "-72.60815", "America/New_York"),
("4835512", "Guilford", "Гилфорд", "US", "840", "CT", "009", "", "", "41.28899", "-72.68176", "America/New_York"),
("4835654", "Hamden", "", "US", "840", "CT", "009", "", "", "41.39593", "-72.89677", "America/New_York"),
("4835797", "Hartford", "Хартфорд", "US", "840", "CT", "003", "", "", "41.76371", "-72.68509", "America/New_York"),
("4837278", "Killingly Center", "", "US", "840", "CT", "015", "", "", "41.83871", "-71.86924", "America/New_York"),
("4837648", "Ledyard Center", "", "US", "840", "CT", "011", "", "", "41.43982", "-72.01424", "America/New_York"),
("4838116", "Madison", "Мадисон", "US", "840", "CT", "009", "", "", "41.27954", "-72.59843", "America/New_York"),
("4838174", "Manchester", "Манчестер", "US", "840", "CT", "003", "", "", "41.77593", "-72.52148", "America/New_York"),
("4838204", "Mansfield City", "", "US", "840", "CT", "013", "", "", "41.76593", "-72.23369", "America/New_York"),
("4838524", "Meriden", "Мериден", "US", "840", "CT", "009", "", "", "41.53815", "-72.80704", "America/New_York"),
("4838633", "Middletown", "Мидлтаун", "US", "840", "CT", "007", "", "", "41.56232", "-72.65065", "America/New_York"),
("4838652", "Milford", "Милфорд", "US", "840", "CT", "009", "", "", "41.22232", "-73.0565", "America/New_York"),
("4838887", "Montville Center", "", "US", "840", "CT", "011", "", "", "41.47899", "-72.15119", "America/New_York"),
("4839222", "Naugatuck", "", "US", "840", "CT", "009", "", "", "41.48593", "-73.05066", "America/New_York"),
("4839292", "New Britain", "Нью-Бритен", "US", "840", "CT", "003", "", "", "41.66121", "-72.77954", "America/New_York"),
("4839319", "New Canaan", "", "US", "840", "CT", "001", "", "", "41.14676", "-73.49484", "America/New_York"),
("4839366", "New Haven", "Нью-Хейвен", "US", "840", "CT", "009", "", "", "41.30815", "-72.92816", "America/New_York"),
("4839416", "New London", "Нью-Лондон", "US", "840", "CT", "011", "", "", "41.35565", "-72.09952", "America/New_York"),
("4839497", "Newington", "", "US", "840", "CT", "003", "", "", "41.69788", "-72.72371", "America/New_York"),
("4839704", "North Haven", "", "US", "840", "CT", "009", "", "", "41.39093", "-72.85954", "America/New_York"),
("4839745", "North Stamford", "", "US", "840", "CT", "001", "", "", "41.13815", "-73.54346", "America/New_York"),
("4839822", "Norwalk", "Норуолк", "US", "840", "CT", "001", "", "", "41.1176", "-73.4079", "America/New_York"),
("4839843", "Norwich", "Норидж", "US", "840", "CT", "011", "", "", "41.52426", "-72.07591", "America/New_York"),
("4840755", "Plainfield", "", "US", "840", "CT", "015", "", "", "41.67649", "-71.91507", "America/New_York"),
("4840767", "Plainville", "Плейнвилль", "US", "840", "CT", "003", "", "", "41.67454", "-72.85816", "America/New_York"),
("4842818", "Seymour", "", "US", "840", "CT", "009", "", "", "41.39676", "-73.07594", "America/New_York"),
("4842898", "Shelton", "Шелтон", "US", "840", "CT", "001", "", "", "41.31649", "-73.09316", "America/New_York"),
("4843353", "South Windsor", "", "US", "840", "CT", "003", "", "", "41.82371", "-72.6212", "America/New_York"),
("4843362", "Southbury", "", "US", "840", "CT", "009", "", "", "41.48148", "-73.21317", "America/New_York"),
("4843564", "Stamford", "Стэмфорд", "US", "840", "CT", "001", "", "", "41.05343", "-73.53873", "America/New_York"),
("4843786", "Storrs", "Сторрс", "US", "840", "CT", "013", "", "", "41.80843", "-72.24952", "America/New_York"),
("4843811", "Stratford", "Стратфорд", "US", "840", "CT", "001", "", "", "41.18454", "-73.13317", "America/New_York"),
("4844309", "Torrington", "", "US", "840", "CT", "005", "", "", "41.80065", "-73.12122", "America/New_York"),
("4844459", "Trumbull", "Трамбал", "US", "840", "CT", "001", "", "", "41.24287", "-73.20067", "America/New_York"),
("4845056", "Wallingford", "", "US", "840", "CT", "009", "", "", "41.45704", "-72.82316", "America/New_York"),
("4845193", "Waterbury", "Уотербери", "US", "840", "CT", "009", "", "", "41.55815", "-73.0515", "America/New_York"),
("4845411", "West Hartford", "Западный Хартфорд", "US", "840", "CT", "003", "", "", "41.76204", "-72.74204", "America/New_York"),
("4845419", "West Haven", "Уэст-Хейвен", "US", "840", "CT", "009", "", "", "41.27065", "-72.94705", "America/New_York"),
("4845519", "West Torrington", "", "US", "840", "CT", "005", "", "", "41.81843", "-73.14372", "America/New_York"),
("4845585", "Westport", "", "US", "840", "CT", "001", "", "", "41.14149", "-73.3579", "America/New_York"),
("4845612", "Wethersfield", "", "US", "840", "CT", "003", "", "", "41.71427", "-72.65259", "America/New_York"),
("4845823", "Willimantic", "", "US", "840", "CT", "015", "", "", "41.71065", "-72.20813", "America/New_York"),
("4845871", "Wilton", "", "US", "840", "CT", "001", "", "", "41.19537", "-73.4379", "America/New_York"),
("4845898", "Windham", "", "US", "840", "CT", "015", "", "", "41.69982", "-72.15702", "America/New_York"),
("4845920", "Windsor", "", "US", "840", "CT", "003", "", "", "41.8526", "-72.6437", "America/New_York"),
("4845984", "Wolcott", "", "US", "840", "CT", "009", "", "", "41.60232", "-72.98677", "America/New_York"),
("4846834", "Ames", "Эймса", "US", "840", "IA", "169", "", "", "42.03471", "-93.61994", "America/Chicago"),
("4846960", "Ankeny", "", "US", "840", "IA", "153", "", "", "41.72971", "-93.60577", "America/Chicago"),
("4848489", "Bettendorf", "", "US", "840", "IA", "163", "", "", "41.52448", "-90.51569", "America/Chicago"),
("4849826", "Burlington", "Берлингтон", "US", "840", "IA", "057", "", "", "40.80754", "-91.11292", "America/Chicago"),
("4850699", "Cedar Falls", "Сидар-Фолс", "US", "840", "IA", "013", "", "", "42.52776", "-92.44547", "America/Chicago"),
("4850751", "Cedar Rapids", "Сидар-Рапидс", "US", "840", "IA", "113", "", "", "42.00833", "-91.64407", "America/Chicago"),
("4852022", "Clinton", "Клинтон", "US", "840", "IA", "045", "", "", "41.84447", "-90.18874", "America/Chicago"),
("4852065", "Clive", "", "US", "840", "IA", "153", "", "", "41.60304", "-93.72411", "America/Chicago"),
("4852640", "Coralville", "", "US", "840", "IA", "103", "", "", "41.6764", "-91.58045", "America/Chicago"),
("4852832", "Council Bluffs", "Каунсил-Блафс", "US", "840", "IA", "155", "", "", "41.26194", "-95.86083", "America/Chicago"),
("4853423", "Davenport", "Дэвенпорт", "US", "840", "IA", "163", "", "", "41.52364", "-90.57764", "America/Chicago"),
("4853828", "Des Moines", "Де-Мойн", "US", "840", "IA", "153", "", "", "41.60054", "-93.60911", "America/Chicago"),
("4854529", "Dubuque", "Дубьюк", "US", "840", "IA", "061", "", "", "42.50056", "-90.66457", "America/Chicago"),
("4857486", "Fort Dodge", "", "US", "840", "IA", "187", "", "", "42.49747", "-94.16802", "America/Chicago"),
("4862034", "Iowa City", "Айова-Сити", "US", "840", "IA", "103", "", "", "41.66113", "-91.53017", "America/Chicago"),
("4862760", "Johnston", "", "US", "840", "IA", "153", "", "", "41.67304", "-93.69772", "America/Chicago"),
("4866263", "Marion", "Мэрион", "US", "840", "IA", "113", "", "", "42.03417", "-91.59768", "America/Chicago"),
("4866371", "Marshalltown", "Маршалтаун", "US", "840", "IA", "127", "", "", "42.04943", "-92.90798", "America/Chicago"),
("4866445", "Mason City", "Мейсон-Сити", "US", "840", "IA", "033", "", "", "43.15357", "-93.20104", "America/Chicago"),
("4868404", "Muscatine", "", "US", "840", "IA", "139", "", "", "41.42447", "-91.04321", "America/Chicago"),
("4868907", "Newton", "Ньютон", "US", "840", "IA", "099", "", "", "41.69971", "-93.04798", "America/Chicago"),
("4870380", "Ottumwa", "Оттамуа", "US", "840", "IA", "179", "", "", "41.02001", "-92.4113", "America/Chicago"),
("4876523", "Sioux City", "Су-Сити", "US", "840", "IA", "193", "", "", "42.49999", "-96.40031", "America/Chicago"),
("4879890", "Urbandale", "", "US", "840", "IA", "153", "", "", "41.62666", "-93.71217", "America/Chicago"),
("4880889", "Waterloo", "", "US", "840", "IA", "013", "", "", "42.49276", "-92.34296", "America/Chicago"),
("4881346", "West Des Moines", "", "US", "840", "IA", "153", "", "", "41.57199", "-93.74531", "America/Chicago"),
("4882920", "Addison", "", "US", "840", "IL", "043", "", "", "41.9317", "-87.98896", "America/Chicago"),
("4883078", "Algonquin", "", "US", "840", "IL", "111", "", "", "42.16558", "-88.29425", "America/Chicago"),
("4883207", "Alsip", "", "US", "840", "IL", "031", "", "", "41.66892", "-87.73866", "America/Chicago"),
("4883555", "Arlington Heights", "Арлингтон-Хайтс", "US", "840", "IL", "031", "", "", "42.08836", "-87.98063", "America/Chicago"),
("4883817", "Aurora", "Аврора", "US", "840", "IL", "089", "", "", "41.76058", "-88.32007", "America/Chicago"),
("4884141", "Bartlett", "Бартлетт", "US", "840", "IL", "031", "", "", "41.99503", "-88.18563", "America/Chicago"),
("4884192", "Batavia", "Батавия", "US", "840", "IL", "089", "", "", "41.85003", "-88.31257", "America/Chicago"),
("4884434", "Bellwood", "", "US", "840", "IL", "031", "", "", "41.88142", "-87.88312", "America/Chicago"),
("4884453", "Belvidere", "Бельведере", "US", "840", "IL", "007", "", "", "42.26391", "-88.84427", "America/Chicago"),
("4884509", "Bensenville", "", "US", "840", "IL", "043", "", "", "41.95503", "-87.94007", "America/Chicago"),
("4884597", "Berwyn", "Беруин", "US", "840", "IL", "031", "", "", "41.85059", "-87.79367", "America/Chicago"),
("4885156", "Bloomingdale", "", "US", "840", "IL", "043", "", "", "41.95753", "-88.0809", "America/Chicago"),
("4885164", "Bloomington", "Блумингтон", "US", "840", "IL", "113", "", "", "40.4842", "-88.99369", "America/Chicago"),
("4885186", "Blue Island", "", "US", "840", "IL", "031", "", "", "41.65726", "-87.68005", "America/Chicago"),
("4885265", "Bolingbrook", "", "US", "840", "IL", "197", "", "", "41.69864", "-88.0684", "America/Chicago"),
("4885342", "Bourbonnais", "", "US", "840", "IL", "091", "", "", "41.1417", "-87.87504", "America/Chicago"),
("4885418", "Bradley", "", "US", "840", "IL", "091", "", "", "41.14198", "-87.86115", "America/Chicago"),
("4885573", "Bridgeview", "", "US", "840", "IL", "031", "", "", "41.75003", "-87.80422", "America/Chicago"),
("4885689", "Brookfield", "", "US", "840", "IL", "031", "", "", "41.82392", "-87.85173", "America/Chicago"),
("4885955", "Buffalo Grove", "", "US", "840", "IL", "031", "", "", "42.15141", "-87.95979", "America/Chicago"),
("4885983", "Burbank", "Бербанк", "US", "840", "IL", "031", "", "", "41.73392", "-87.7795", "America/Chicago"),
("4886255", "Calumet City", "", "US", "840", "IL", "031", "", "", "41.61559", "-87.52949", "America/Chicago"),
("4886662", "Carol Stream", "", "US", "840", "IL", "043", "", "", "41.91253", "-88.13479", "America/Chicago"),
("4886676", "Carpentersville", "", "US", "840", "IL", "089", "", "", "42.12114", "-88.25786", "America/Chicago"),
("4886738", "Cary", "Кэри", "US", "840", "IL", "111", "", "", "42.21197", "-88.23814", "America/Chicago"),
("4887158", "Champaign", "Шампейн", "US", "840", "IL", "019", "", "", "40.11642", "-88.24338", "America/Chicago"),
("4887398", "Chicago", "Чикаго", "US", "840", "IL", "031", "", "", "41.85003", "-87.65005", "America/Chicago"),
("4887442", "Chicago Heights", "", "US", "840", "IL", "031", "", "", "41.50615", "-87.6356", "America/Chicago"),
("4888015", "Cicero", "Цицерон", "US", "840", "IL", "031", "", "", "41.84559", "-87.75394", "America/Chicago"),
("4888892", "Country Club Hills", "", "US", "840", "IL", "031", "", "", "41.56809", "-87.72033", "America/Chicago"),
("4889107", "Crest Hill", "", "US", "840", "IL", "197", "", "", "41.55475", "-88.09867", "America/Chicago"),
("4889229", "Crystal Lake", "", "US", "840", "IL", "111", "", "", "42.24113", "-88.3162", "America/Chicago"),
("4889426", "Danville", "Данвилл", "US", "840", "IL", "183", "", "", "40.12448", "-87.63002", "America/Chicago"),
("4889447", "Darien", "", "US", "840", "IL", "043", "", "", "41.75198", "-87.97395", "America/Chicago"),
("4889553", "DeKalb", "Де-Калб", "US", "840", "IL", "037", "", "", "41.92947", "-88.75036", "America/Chicago"),
("4889668", "Deerfield", "", "US", "840", "IL", "097", "", "", "42.17114", "-87.84451", "America/Chicago"),
("4889772", "Des Plaines", "Дес-Плейнс", "US", "840", "IL", "031", "", "", "42.03336", "-87.8834", "America/Chicago"),
("4889959", "Dixon", "", "US", "840", "IL", "103", "", "", "41.83892", "-89.47955", "America/Chicago"),
("4890009", "Dolton", "", "US", "840", "IL", "031", "", "", "41.63892", "-87.60727", "America/Chicago"),
("4890119", "Downers Grove", "", "US", "840", "IL", "043", "", "", "41.80892", "-88.01117", "America/Chicago"),
("4890536", "East Moline", "", "US", "840", "IL", "161", "", "", "41.50087", "-90.4443", "America/Chicago"),
("4890549", "East Peoria", "", "US", "840", "IL", "179", "", "", "40.66615", "-89.5801", "America/Chicago"),
("4890864", "Elgin", "Элджин", "US", "840", "IL", "089", "", "", "42.03725", "-88.28119", "America/Chicago"),
("4890925", "Elk Grove Village", "", "US", "840", "IL", "031", "", "", "42.00392", "-87.97035", "America/Chicago"),
("4891010", "Elmhurst", "", "US", "840", "IL", "043", "", "", "41.89947", "-87.94034", "America/Chicago"),
("4891051", "Elmwood Park", "", "US", "840", "IL", "031", "", "", "41.92114", "-87.80923", "America/Chicago"),
("4891382", "Evanston", "", "US", "840", "IL", "031", "", "", "42.04114", "-87.69006", "America/Chicago"),
("4891431", "Evergreen Park", "", "US", "840", "IL", "031", "", "", "41.72059", "-87.70172", "America/Chicago"),
("4893037", "Frankfort", "Франкфурт", "US", "840", "IL", "197", "", "", "41.49587", "-87.84866", "America/Chicago"),
("4893070", "Franklin Park", "", "US", "840", "IL", "031", "", "", "41.93531", "-87.86562", "America/Chicago"),
("4893171", "Freeport", "Фрипорт", "US", "840", "IL", "177", "", "", "42.29669", "-89.62123", "America/Chicago"),
("4893392", "Galesburg", "Гейлсберг", "US", "840", "IL", "095", "", "", "40.94782", "-90.37124", "America/Chicago"),
("4893591", "Geneva", "Женева", "US", "840", "IL", "089", "", "", "41.88753", "-88.30535", "America/Chicago"),
("4893811", "Glen Ellyn", "", "US", "840", "IL", "043", "", "", "41.87753", "-88.06701", "America/Chicago"),
("4893886", "Glenview", "", "US", "840", "IL", "031", "", "", "42.06975", "-87.78784", "America/Chicago"),
("4894061", "Goodings Grove", "", "US", "840", "IL", "197", "", "", "41.6292", "-87.93089", "America/Chicago"),
("4894465", "Grayslake", "", "US", "840", "IL", "097", "", "", "42.34447", "-88.04175", "America/Chicago"),
("4894861", "Gurnee", "", "US", "840", "IL", "097", "", "", "42.3703", "-87.90202", "America/Chicago"),
("4895066", "Hanover Park", "", "US", "840", "IL", "043", "", "", "41.99947", "-88.14507", "America/Chicago"),
("4895298", "Harvey", "Харви", "US", "840", "IL", "031", "", "", "41.61003", "-87.64671", "America/Chicago"),
("4895876", "Highland Park", "Хайленд-Парк", "US", "840", "IL", "097", "", "", "42.18169", "-87.80034", "America/Chicago"),
("4896012", "Hinsdale", "", "US", "840", "IL", "043", "", "", "41.80086", "-87.93701", "America/Chicago"),
("4896075", "Hoffman Estates", "", "US", "840", "IL", "031", "", "", "42.04281", "-88.0798", "America/Chicago"),
("4896336", "Homer Glen", "", "US", "840", "IL", "197", "", "", "41.60003", "-87.93811", "America/Chicago"),
("4896353", "Homewood", "", "US", "840", "IL", "031", "", "", "41.55726", "-87.6656", "America/Chicago"),
("4896691", "Huntley", "", "US", "840", "IL", "111", "", "", "42.16808", "-88.42814", "America/Chicago"),
("4898015", "Joliet", "", "US", "840", "IL", "197", "", "", "41.52503", "-88.08173", "America/Chicago"),
("4898182", "Kankakee", "Канкаки", "US", "840", "IL", "091", "", "", "41.12003", "-87.86115", "America/Chicago"),
("4898846", "La Grange", "", "US", "840", "IL", "031", "", "", "41.80503", "-87.86923", "America/Chicago"),
("4899012", "Lake Forest", "", "US", "840", "IL", "097", "", "", "42.25863", "-87.84062", "America/Chicago"),
("4899170", "Lake Zurich", "", "US", "840", "IL", "097", "", "", "42.19697", "-88.09341", "America/Chicago"),
("4899184", "Lake in the Hills", "", "US", "840", "IL", "111", "", "", "42.18169", "-88.33036", "America/Chicago"),
("4899340", "Lansing", "Лансинг", "US", "840", "IL", "031", "", "", "41.56476", "-87.53893", "America/Chicago"),
("4899581", "Lemont", "", "US", "840", "IL", "031", "", "", "41.67364", "-88.00173", "America/Chicago"),
("4899739", "Libertyville", "", "US", "840", "IL", "097", "", "", "42.28308", "-87.95313", "America/Chicago"),
("4900080", "Lisle", "Лилу", "US", "840", "IL", "043", "", "", "41.80114", "-88.07479", "America/Chicago"),
("4900292", "Lockport", "", "US", "840", "IL", "197", "", "", "41.58948", "-88.05784", "America/Chicago"),
("4900373", "Lombard", "Ломбард", "US", "840", "IL", "043", "", "", "41.88003", "-88.00784", "America/Chicago"),
("4900579", "Loves Park", "", "US", "840", "IL", "201", "", "", "42.32002", "-89.05816", "America/Chicago"),
("4900801", "Machesney Park", "", "US", "840", "IL", "201", "", "", "42.34724", "-89.039", "America/Chicago"),
("4900817", "Macomb", "", "US", "840", "IL", "109", "", "", "40.45921", "-90.6718", "America/Chicago"),
("4901445", "Matteson", "", "US", "840", "IL", "031", "", "", "41.50392", "-87.7131", "America/Chicago"),
("4901514", "Maywood", "Мэйвуд", "US", "840", "IL", "031", "", "", "41.8792", "-87.84312", "America/Chicago"),
("4901663", "McHenry", "", "US", "840", "IL", "111", "", "", "42.33336", "-88.26675", "America/Chicago"),
("4901868", "Melrose Park", "", "US", "840", "IL", "031", "", "", "41.90059", "-87.85673", "America/Chicago"),
("4902475", "Mokena", "", "US", "840", "IL", "197", "", "", "41.52614", "-87.88922", "America/Chicago"),
("4902476", "Moline", "Молин", "US", "840", "IL", "161", "", "", "41.5067", "-90.51513", "America/Chicago"),
("4902559", "Montgomery", "Монтгомери", "US", "840", "IL", "089", "", "", "41.73058", "-88.3459", "America/Chicago"),
("4902754", "Morton", "", "US", "840", "IL", "179", "", "", "40.61282", "-89.45926", "America/Chicago"),
("4902763", "Morton Grove", "", "US", "840", "IL", "031", "", "", "42.04059", "-87.78256", "America/Chicago"),
("4903024", "Mount Prospect", "", "US", "840", "IL", "031", "", "", "42.06642", "-87.93729", "America/Chicago"),
("4903184", "Mundelein", "", "US", "840", "IL", "097", "", "", "42.26308", "-88.00397", "America/Chicago"),
("4903279", "Naperville", "Нэпервилл", "US", "840", "IL", "043", "", "", "41.78586", "-88.14729", "America/Chicago"),
("4903535", "New Lenox", "", "US", "840", "IL", "197", "", "", "41.51198", "-87.96561", "America/Chicago"),
("4903730", "Niles", "", "US", "840", "IL", "031", "", "", "42.01892", "-87.80284", "America/Chicago"),
("4903780", "Normal", "Нормальная", "US", "840", "IL", "113", "", "", "40.5142", "-88.99063", "America/Chicago"),
("4903818", "North Aurora", "", "US", "840", "IL", "089", "", "", "41.80614", "-88.3273", "America/Chicago"),
("4903862", "North Chicago", "", "US", "840", "IL", "097", "", "", "42.32558", "-87.84118", "America/Chicago"),
("4903976", "North Peoria", "", "US", "840", "IL", "143", "", "", "40.71754", "-89.58426", "America/Chicago"),
("4904056", "Northbrook", "", "US", "840", "IL", "031", "", "", "42.12753", "-87.82895", "America/Chicago"),
("4904286", "Oak Forest", "", "US", "840", "IL", "031", "", "", "41.60281", "-87.74394", "America/Chicago"),
("4904365", "Oak Lawn", "", "US", "840", "IL", "031", "", "", "41.71087", "-87.75811", "America/Chicago"),
("4904381", "Oak Park", "Оук-Парк", "US", "840", "IL", "031", "", "", "41.88503", "-87.7845", "America/Chicago"),
("4904937", "Orland Park", "", "US", "840", "IL", "031", "", "", "41.63031", "-87.85394", "America/Chicago"),
("4904996", "Oswego", "", "US", "840", "IL", "093", "", "", "41.68281", "-88.35146", "America/Chicago"),
("4905006", "Ottawa", "Оттава", "US", "840", "IL", "099", "", "", "41.34559", "-88.84258", "America/Chicago"),
("4905211", "Palatine", "Палатин", "US", "840", "IL", "031", "", "", "42.1103", "-88.03424", "America/Chicago"),
("4905263", "Palos Hills", "", "US", "840", "IL", "031", "", "", "41.6967", "-87.817", "America/Chicago"),
("4905337", "Park Forest", "", "US", "840", "IL", "031", "", "", "41.49142", "-87.67449", "America/Chicago"),
("4905367", "Park Ridge", "Парк-Ридж", "US", "840", "IL", "031", "", "", "42.01114", "-87.84062", "America/Chicago"),
("4905599", "Pekin", "Пекин", "US", "840", "IL", "179", "", "", "40.56754", "-89.64066", "America/Chicago"),
("4905687", "Peoria", "Пеория", "US", "840", "IL", "143", "", "", "40.69365", "-89.58899", "America/Chicago"),
("4906125", "Plainfield", "", "US", "840", "IL", "197", "", "", "41.62697", "-88.20395", "America/Chicago"),
("4906882", "Prospect Heights", "", "US", "840", "IL", "031", "", "", "42.0953", "-87.93757", "America/Chicago"),
("4907907", "Rock Island", "Рок-Айленд", "US", "840", "IL", "161", "", "", "41.50948", "-90.57875", "America/Chicago"),
("4907959", "Rockford", "Рокфорд", "US", "840", "IL", "201", "", "", "42.27113", "-89.094", "America/Chicago"),
("4908052", "Rolling Meadows", "", "US", "840", "IL", "031", "", "", "42.08419", "-88.01313", "America/Chicago"),
("4908068", "Romeoville", "", "US", "840", "IL", "197", "", "", "41.64753", "-88.08951", "America/Chicago"),
("4908173", "Roselle", "", "US", "840", "IL", "043", "", "", "41.98475", "-88.07979", "America/Chicago"),
("4908236", "Round Lake", "", "US", "840", "IL", "097", "", "", "42.35336", "-88.09341", "America/Chicago"),
("4908237", "Round Lake Beach", "", "US", "840", "IL", "097", "", "", "42.37169", "-88.09008", "America/Chicago"),
("4908737", "Saint Charles", "Сент-Чарльз", "US", "840", "IL", "089", "", "", "41.91419", "-88.30869", "America/Chicago"),
("4910713", "Schaumburg", "Шаумбург", "US", "840", "IL", "031", "", "", "42.03336", "-88.08341", "America/Chicago"),
("4911418", "Shorewood", "", "US", "840", "IL", "197", "", "", "41.52003", "-88.20173", "America/Chicago"),
("4911600", "Skokie", "Скоки", "US", "840", "IL", "031", "", "", "42.03336", "-87.73339", "America/Chicago"),
("4911893", "South Elgin", "", "US", "840", "IL", "089", "", "", "41.99419", "-88.2923", "America/Chicago"),
("4911934", "South Holland", "", "US", "840", "IL", "031", "", "", "41.60087", "-87.60699", "America/Chicago"),
("4912499", "Sterling", "Стерлинг", "US", "840", "IL", "195", "", "", "41.78864", "-89.69622", "America/Chicago"),
("4912691", "Streamwood", "", "US", "840", "IL", "031", "", "", "42.02558", "-88.17841", "America/Chicago"),
("4913110", "Sycamore", "", "US", "840", "IL", "037", "", "", "41.98892", "-88.68675", "America/Chicago"),
("4913723", "Tinley Park", "", "US", "840", "IL", "031", "", "", "41.57337", "-87.78449", "America/Chicago"),
("4914570", "Urbana", "Урбана", "US", "840", "IL", "019", "", "", "40.11059", "-88.20727", "America/Chicago"),
("4914738", "Vernon Hills", "", "US", "840", "IL", "097", "", "", "42.21809", "-87.96513", "America/Chicago"),
("4914830", "Villa Park", "", "US", "840", "IL", "043", "", "", "41.88975", "-87.98895", "America/Chicago"),
("4915539", "Wasco", "", "US", "840", "IL", "089", "", "", "41.93808", "-88.40452", "America/Chicago"),
("4915545", "Washington", "Вашингтон", "US", "840", "IL", "179", "", "", "40.70365", "-89.40731", "America/Chicago"),
("4915734", "Waukegan", "Уокиган", "US", "840", "IL", "097", "", "", "42.36363", "-87.84479", "America/Chicago"),
("4915963", "West Chicago", "", "US", "840", "IL", "043", "", "", "41.88475", "-88.20396", "America/Chicago"),
("4916140", "Westchester", "Вестчестер", "US", "840", "IL", "031", "", "", "41.85059", "-87.882", "America/Chicago"),
("4916207", "Westmont", "", "US", "840", "IL", "043", "", "", "41.79586", "-87.97562", "America/Chicago"),
("4916288", "Wheaton", "Уитон", "US", "840", "IL", "043", "", "", "41.86614", "-88.10701", "America/Chicago"),
("4916311", "Wheeling", "", "US", "840", "IL", "031", "", "", "42.13919", "-87.92896", "America/Chicago"),
("4916732", "Wilmette", "", "US", "840", "IL", "031", "", "", "42.07225", "-87.72284", "America/Chicago"),
("4917089", "Woodridge", "", "US", "840", "IL", "043", "", "", "41.74697", "-88.05034", "America/Chicago"),
("4917123", "Woodstock", "Вудсток", "US", "840", "IL", "111", "", "", "42.31474", "-88.4487", "America/Chicago"),
("4917298", "Yorkville", "", "US", "840", "IL", "093", "", "", "41.64114", "-88.44729", "America/Chicago"),
("4917358", "Zion", "Сион", "US", "840", "IL", "097", "", "", "42.44613", "-87.83285", "America/Chicago"),
("4917592", "Anderson", "Андерсон", "US", "840", "IN", "095", "", "", "40.10532", "-85.68025", "America/Indiana/Indianapolis"),
("4919381", "Crawfordsville", "", "US", "840", "IN", "107", "", "", "40.04115", "-86.87445", "America/Indiana/Indianapolis"),
("4919451", "Crown Point", "", "US", "840", "IN", "089", "", "", "41.41698", "-87.36531", "America/Chicago"),
("4919820", "Dyer", "", "US", "840", "IN", "089", "", "", "41.4942", "-87.52171", "America/Chicago"),
("4919857", "East Chicago", "", "US", "840", "IN", "089", "", "", "41.6392", "-87.45476", "America/Chicago"),
("4919987", "Elkhart", "Элкхарт", "US", "840", "IN", "039", "", "", "41.68199", "-85.97667", "America/Indiana/Indianapolis"),
("4920423", "Fort Wayne", "Форт-Уэйн", "US", "840", "IN", "003", "", "", "41.1306", "-85.12886", "America/Indiana/Indianapolis"),
("4920473", "Frankfort", "Франкфурт", "US", "840", "IN", "023", "", "", "40.27948", "-86.51084", "America/Indiana/Indianapolis"),
("4920607", "Gary", "Гэри", "US", "840", "IN", "089", "", "", "41.59337", "-87.34643", "America/Chicago"),
("4920808", "Goshen", "Гошен", "US", "840", "IN", "039", "", "", "41.58227", "-85.83444", "America/Indiana/Indianapolis"),
("4920869", "Granger", "", "US", "840", "IN", "141", "", "", "41.74813", "-86.12569", "America/Indiana/Indianapolis"),
("4920986", "Griffith", "", "US", "840", "IN", "089", "", "", "41.52837", "-87.42365", "America/Chicago"),
("4921100", "Hammond", "Хаммонд", "US", "840", "IN", "089", "", "", "41.58337", "-87.50004", "America/Chicago"),
("4921402", "Highland", "", "US", "840", "IN", "089", "", "", "41.55365", "-87.45198", "America/Chicago"),
("4921476", "Hobart", "Хобарт", "US", "840", "IN", "089", "", "", "41.53226", "-87.25504", "America/Chicago"),
("4921725", "Huntington", "Хантингтон", "US", "840", "IN", "069", "", "", "40.8831", "-85.49748", "America/Indiana/Indianapolis"),
("4922388", "Kokomo", "", "US", "840", "IN", "067", "", "", "40.48643", "-86.1336", "America/Indiana/Indianapolis"),
("4922459", "LaPorte", "", "US", "840", "IN", "091", "", "", "41.6106", "-86.72252", "America/Chicago"),
("4922462", "Lafayette", "Лафайет", "US", "840", "IN", "157", "", "", "40.4167", "-86.87529", "America/Indiana/Indianapolis"),
("4922673", "Lebanon", "", "US", "840", "IN", "011", "", "", "40.04837", "-86.46917", "America/Indiana/Indianapolis"),
("4922968", "Logansport", "", "US", "840", "IN", "017", "", "", "40.75448", "-86.35667", "America/Indiana/Indianapolis"),
("4923210", "Marion", "Мэрион", "US", "840", "IN", "053", "", "", "40.55837", "-85.65914", "America/Indiana/Indianapolis"),
("4923482", "Merrillville", "", "US", "840", "IN", "089", "", "", "41.48281", "-87.33281", "America/Chicago"),
("4923531", "Michigan City", "Мичиган-Сити", "US", "840", "IN", "091", "", "", "41.70754", "-86.89503", "America/Chicago"),
("4923670", "Mishawaka", "", "US", "840", "IN", "141", "", "", "41.66199", "-86.15862", "America/Indiana/Indianapolis"),
("4924006", "Muncie", "Манси", "US", "840", "IN", "035", "", "", "40.19338", "-85.38636", "America/Indiana/Indianapolis"),
("4924014", "Munster", "Мюнстер", "US", "840", "IN", "089", "", "", "41.56448", "-87.51254", "America/Chicago"),
("4924198", "Noblesville", "", "US", "840", "IN", "057", "", "", "40.04559", "-86.0086", "America/Indiana/Indianapolis"),
("4925006", "Portage", "", "US", "840", "IN", "127", "", "", "41.57587", "-87.17615", "America/Chicago"),
("4926170", "Schererville", "", "US", "840", "IN", "089", "", "", "41.47892", "-87.45476", "America/Chicago"),
("4926563", "South Bend", "Саут-Бенд", "US", "840", "IN", "141", "", "", "41.68338", "-86.25001", "America/Indiana/Indianapolis"),
("4927537", "Valparaiso", "Вальпараисо", "US", "840", "IN", "127", "", "", "41.47309", "-87.06114", "America/Chicago"),
("4928096", "West Lafayette", "Уэст-Лафайетт", "US", "840", "IN", "157", "", "", "40.42587", "-86.90807", "America/Indiana/Indianapolis"),
("4928118", "Westfield", "", "US", "840", "IN", "057", "", "", "40.04282", "-86.12749", "America/Indiana/Indianapolis"),
("4928662", "Abington", "Абингтон", "US", "840", "MA", "023", "", "", "42.10482", "-70.94532", "America/New_York"),
("4928703", "Acton", "Эктон", "US", "840", "MA", "017", "", "", "42.48509", "-71.43284", "America/New_York"),
("4928788", "Agawam", "", "US", "840", "MA", "013", "", "", "42.06954", "-72.61481", "America/New_York"),
("4929004", "Amesbury", "", "US", "840", "MA", "009", "", "", "42.85842", "-70.93005", "America/New_York"),
("4929023", "Amherst Center", "", "US", "840", "MA", "015", "", "", "42.37537", "-72.51925", "America/New_York"),
("4929180", "Arlington", "Арлингтон", "US", "840", "MA", "017", "", "", "42.41537", "-71.15644", "America/New_York"),
("4929283", "Ashland", "", "US", "840", "MA", "017", "", "", "42.26121", "-71.4634", "America/New_York"),
("4929399", "Attleboro", "", "US", "840", "MA", "005", "", "", "41.94454", "-71.28561", "America/New_York"),
("4929417", "Auburn", "", "US", "840", "MA", "027", "", "", "42.19454", "-71.83563", "America/New_York"),
("4929771", "Barnstable", "", "US", "840", "MA", "001", "", "", "41.70011", "-70.29947", "America/New_York"),
("4930282", "Belmont", "Белмонт", "US", "840", "MA", "017", "", "", "42.39593", "-71.17867", "America/New_York"),
("4930505", "Beverly", "", "US", "840", "MA", "009", "", "", "42.55843", "-70.88005", "America/New_York"),
("4930511", "Beverly Cove", "", "US", "840", "MA", "009", "", "", "42.55343", "-70.85366", "America/New_York"),
("4930577", "Billerica", "", "US", "840", "MA", "017", "", "", "42.55843", "-71.26895", "America/New_York"),
("4930956", "Boston", "Бостон", "US", "840", "MA", "025", "", "", "42.35843", "-71.05977", "America/New_York"),
("4931181", "Braintree", "", "US", "840", "MA", "021", "", "", "42.22232", "-70.99949", "America/New_York"),
("4931429", "Brockton", "Броктон", "US", "840", "MA", "023", "", "", "42.08343", "-71.01838", "America/New_York"),
("4931482", "Brookline", "Бруклин", "US", "840", "MA", "021", "", "", "42.33176", "-71.12116", "America/New_York"),
("4931737", "Burlington", "Берлингтон", "US", "840", "MA", "017", "", "", "42.50482", "-71.19561", "America/New_York"),
("4931972", "Cambridge", "Кеймбридж", "US", "840", "MA", "017", "", "", "42.3751", "-71.10561", "America/New_York"),
("4932214", "Canton", "", "US", "840", "MA", "021", "", "", "42.15843", "-71.14477", "America/New_York"),
("4932869", "Chelmsford", "Челмсфорд", "US", "840", "MA", "017", "", "", "42.59981", "-71.36728", "America/New_York"),
("4932879", "Chelsea", "", "US", "840", "MA", "025", "", "", "42.39176", "-71.03283", "America/New_York"),
("4933002", "Chicopee", "Чикопи", "US", "840", "MA", "013", "", "", "42.14521", "-72.60864", "America/New_York"),
("4933743", "Concord", "Конкорд", "US", "840", "MA", "017", "", "", "42.46037", "-71.34895", "America/New_York"),
("4934500", "Danvers", "Денверс", "US", "840", "MA", "009", "", "", "42.57509", "-70.93005", "America/New_York"),
("4934664", "Dedham", "", "US", "840", "MA", "021", "", "", "42.24177", "-71.16616", "America/New_York"),
("4935038", "Dracut", "", "US", "840", "MA", "017", "", "", "42.67037", "-71.30201", "America/New_York"),
("4935434", "East Longmeadow", "", "US", "840", "MA", "013", "", "", "42.06454", "-72.51259", "America/New_York"),
("4935582", "Easthampton", "Истхэмптон", "US", "840", "MA", "015", "", "", "42.26676", "-72.66898", "America/New_York"),
("4935623", "Easton", "Истон", "US", "840", "MA", "005", "", "", "42.02454", "-71.12866", "America/New_York"),
("4936008", "Everett", "Эверетт", "US", "840", "MA", "017", "", "", "42.40843", "-71.05366", "America/New_York"),
("4936087", "Fairhaven", "", "US", "840", "MA", "005", "", "", "41.6376", "-70.90365", "America/New_York"),
("4936159", "Fall River", "Фолл-Ривер", "US", "840", "MA", "005", "", "", "41.70149", "-71.15505", "America/New_York"),
("4936812", "Fitchburg", "", "US", "840", "MA", "027", "", "", "42.58342", "-71.8023", "America/New_York"),
("4937230", "Framingham", "", "US", "840", "MA", "017", "", "", "42.27926", "-71.41617", "America/New_York"),
("4937232", "Framingham Center", "", "US", "840", "MA", "017", "", "", "42.29732", "-71.43701", "America/New_York"),
("4937276", "Franklin", "Франклин", "US", "840", "MA", "021", "", "", "42.08343", "-71.39672", "America/New_York"),
("4937557", "Gardner", "Гарднер", "US", "840", "MA", "027", "", "", "42.57509", "-71.99813", "America/New_York"),
("4937829", "Gloucester", "Глостер", "US", "840", "MA", "009", "", "", "42.61593", "-70.66199", "America/New_York"),
("4938048", "Grafton", "", "US", "840", "MA", "027", "", "", "42.20704", "-71.68562", "America/New_York"),
("4938378", "Greenfield", "Гринфилд", "US", "840", "MA", "011", "", "", "42.58759", "-72.59953", "America/New_York"),
("4938836", "Hanover", "", "US", "840", "MA", "023", "", "", "42.11316", "-70.81199", "America/New_York"),
("4939085", "Haverhill", "Хаверхилл", "US", "840", "MA", "009", "", "", "42.7762", "-71.07728", "America/New_York"),
("4939647", "Holden", "", "US", "840", "MA", "027", "", "", "42.35176", "-71.86341", "America/New_York"),
("4939783", "Holyoke", "Холиок", "US", "840", "MA", "013", "", "", "42.20426", "-72.6162", "America/New_York"),
("4940764", "Jamaica Plain", "", "US", "840", "MA", "025", "", "", "42.30982", "-71.12033", "America/New_York"),
("4941720", "Lawrence", "Лоуренс", "US", "840", "MA", "009", "", "", "42.70704", "-71.16311", "America/New_York"),
("4941873", "Leominster", "Леоминстере", "US", "840", "MA", "027", "", "", "42.52509", "-71.75979", "America/New_York"),
("4941935", "Lexington", "Лексингтон", "US", "840", "MA", "017", "", "", "42.44732", "-71.2245", "America/New_York"),
("4942508", "Longmeadow", "", "US", "840", "MA", "013", "", "", "42.0501", "-72.58287", "America/New_York"),
("4942618", "Lowell", "Лоуэлл", "US", "840", "MA", "017", "", "", "42.63342", "-71.31617", "America/New_York"),
("4942744", "Ludlow", "", "US", "840", "MA", "013", "", "", "42.16009", "-72.47592", "America/New_York"),
("4942807", "Lynn", "Линн", "US", "840", "MA", "009", "", "", "42.46676", "-70.94949", "America/New_York"),
("4942939", "Malden", "", "US", "840", "MA", "017", "", "", "42.4251", "-71.06616", "America/New_York"),
("4943021", "Mansfield", "Мэнсфилд", "US", "840", "MA", "005", "", "", "42.03343", "-71.21894", "America/New_York"),
("4943097", "Marblehead", "", "US", "840", "MA", "009", "", "", "42.5001", "-70.85783", "America/New_York"),
("4943170", "Marlborough", "Марлборо", "US", "840", "MA", "017", "", "", "42.34624", "-71.55215", "America/New_York"),
("4943629", "Medford", "Медфорд", "US", "840", "MA", "017", "", "", "42.41843", "-71.10616", "America/New_York"),
("4943677", "Melrose", "Мелроуз", "US", "840", "MA", "017", "", "", "42.45843", "-71.06616", "America/New_York"),
("4943828", "Methuen", "", "US", "840", "MA", "009", "", "", "42.7262", "-71.19089", "America/New_York"),
("4943958", "Milford", "Милфорд", "US", "840", "MA", "027", "", "", "42.13982", "-71.51617", "America/New_York"),
("4944193", "Milton", "Мильтон", "US", "840", "MA", "021", "", "", "42.24954", "-71.06616", "America/New_York"),
("4944994", "Natick", "", "US", "840", "MA", "017", "", "", "42.28343", "-71.3495", "America/New_York"),
("4945055", "Needham", "", "US", "840", "MA", "021", "", "", "42.28343", "-71.23283", "America/New_York"),
("4945121", "New Bedford", "Нью-Бедфорд", "US", "840", "MA", "005", "", "", "41.63622", "-70.9342", "America/New_York"),
("4945256", "Newburyport", "", "US", "840", "MA", "009", "", "", "42.81259", "-70.87728", "America/New_York"),
("4945283", "Newton", "Ньютон", "US", "840", "MA", "017", "", "", "42.33704", "-71.20922", "America/New_York"),
("4945588", "North Chicopee", "", "US", "840", "MA", "013", "", "", "42.18343", "-72.59953", "America/New_York"),
("4945819", "Northampton", "Нортхемптон", "US", "840", "MA", "015", "", "", "42.32509", "-72.6412", "America/New_York"),
("4945911", "Norton", "", "US", "840", "MA", "005", "", "", "41.96677", "-71.18699", "America/New_York"),
("4945952", "Norwood", "", "US", "840", "MA", "021", "", "", "42.19454", "-71.1995", "America/New_York"),
("4946620", "Palmer", "", "US", "840", "MA", "013", "", "", "42.15843", "-72.32869", "America/New_York"),
("4946863", "Peabody", "Пибоди", "US", "840", "MA", "009", "", "", "42.52787", "-70.92866", "America/New_York"),
("4947459", "Pittsfield", "", "US", "840", "MA", "003", "", "", "42.45008", "-73.24538", "America/New_York"),
("4948247", "Quincy", "Куинси", "US", "840", "MA", "021", "", "", "42.25288", "-71.00227", "America/New_York"),
("4948403", "Randolph", "Рандольф", "US", "840", "MA", "021", "", "", "42.1626", "-71.04116", "America/New_York"),
("4948462", "Reading", "Рединг", "US", "840", "MA", "017", "", "", "42.52565", "-71.09533", "America/New_York"),
("4948924", "Rockland", "", "US", "840", "MA", "023", "", "", "42.13066", "-70.91616", "America/New_York"),
("4950065", "Salem", "Салем", "US", "840", "MA", "009", "", "", "42.51954", "-70.89672", "America/New_York"),
("4950267", "Saugus", "", "US", "840", "MA", "009", "", "", "42.46482", "-71.01005", "America/New_York"),
("4950898", "Shrewsbury", "Шрусбери", "US", "840", "MA", "027", "", "", "42.29593", "-71.71285", "America/New_York"),
("4951248", "Somerset", "Сомерсет", "US", "840", "MA", "005", "", "", "41.76955", "-71.12866", "America/New_York"),
("4951257", "Somerville", "Сомервилл", "US", "840", "MA", "017", "", "", "42.3876", "-71.0995", "America/New_York"),
("4951305", "South Boston", "", "US", "840", "MA", "025", "", "", "42.33343", "-71.04949", "America/New_York"),
("4951397", "South Hadley", "", "US", "840", "MA", "015", "", "", "42.25842", "-72.57453", "America/New_York"),
("4951473", "South Peabody", "", "US", "840", "MA", "009", "", "", "42.50982", "-70.94949", "America/New_York"),
("4951594", "Southbridge", "", "US", "840", "MA", "027", "", "", "42.0751", "-72.03341", "America/New_York"),
("4951788", "Springfield", "Спрингфилд", "US", "840", "MA", "013", "", "", "42.10148", "-72.58981", "America/New_York"),
("4952121", "Stoneham", "", "US", "840", "MA", "017", "", "", "42.4801", "-71.0995", "America/New_York"),
("4952206", "Stoughton", "", "US", "840", "MA", "021", "", "", "42.1251", "-71.10227", "America/New_York"),
("4952320", "Sudbury", "", "US", "840", "MA", "017", "", "", "42.38343", "-71.41617", "America/New_York"),
("4952487", "Swansea", "", "US", "840", "MA", "005", "", "", "41.74816", "-71.18977", "America/New_York"),
("4952629", "Taunton", "Тонтон", "US", "840", "MA", "005", "", "", "41.9001", "-71.08977", "America/New_York"),
("4952762", "Tewksbury", "", "US", "840", "MA", "017", "", "", "42.61065", "-71.23422", "America/New_York"),
("4954265", "Wakefield", "", "US", "840", "MA", "017", "", "", "42.50648", "-71.07283", "America/New_York"),
("4954380", "Waltham", "Уолтем", "US", "840", "MA", "017", "", "", "42.37649", "-71.23561", "America/New_York"),
("4954611", "Watertown", "", "US", "840", "MA", "017", "", "", "42.37093", "-71.18283", "America/New_York"),
("4954738", "Wellesley", "Уэлсли", "US", "840", "MA", "021", "", "", "42.29649", "-71.29256", "America/New_York"),
("4955089", "West Springfield", "", "US", "840", "MA", "013", "", "", "42.10704", "-72.62037", "America/New_York"),
("4955190", "Westfield", "", "US", "840", "MA", "013", "", "", "42.12509", "-72.74954", "America/New_York"),
("4955219", "Westford", "", "US", "840", "MA", "017", "", "", "42.57926", "-71.43784", "America/New_York"),
("4955336", "Weymouth", "", "US", "840", "MA", "021", "", "", "42.22093", "-70.93977", "America/New_York"),
("4955840", "Wilmington", "Уилмингтон", "US", "840", "MA", "017", "", "", "42.54648", "-71.17367", "America/New_York"),
("4955884", "Winchester", "Уинчестер", "US", "840", "MA", "017", "", "", "42.45232", "-71.137", "America/New_York"),
("4955993", "Winthrop", "", "US", "840", "MA", "025", "", "", "42.3751", "-70.98283", "America/New_York"),
("4956032", "Woburn", "", "US", "840", "MA", "017", "", "", "42.47926", "-71.15228", "America/New_York"),
("4956184", "Worcester", "Вустер", "US", "840", "MA", "027", "", "", "42.26259", "-71.80229", "America/New_York"),
("4956335", "Yarmouth", "", "US", "840", "MA", "001", "", "", "41.70567", "-70.22863", "America/New_York"),
("4956976", "Auburn", "Оберн", "US", "840", "ME", "001", "", "", "44.09785", "-70.23117", "America/New_York"),
("4957003", "Augusta", "Огаста", "US", "840", "ME", "011", "", "", "44.31062", "-69.77949", "America/New_York"),
("4957280", "Bangor", "Бангор", "US", "840", "ME", "019", "", "", "44.80118", "-68.77781", "America/New_York"),
("4958141", "Biddeford", "Биддефорд", "US", "840", "ME", "031", "", "", "43.49258", "-70.45338", "America/New_York"),
("4959473", "Brunswick", "Брауншвейг", "US", "840", "ME", "005", "", "", "43.91452", "-69.96533", "America/New_York"),
("4969398", "Lewiston", "Льюистон", "US", "840", "ME", "001", "", "", "44.10035", "-70.21478", "America/New_York"),
("4975802", "Portland", "Портленд", "US", "840", "ME", "005", "", "", "43.66147", "-70.25533", "America/New_York"),
("4977222", "Saco", "Сако", "US", "840", "ME", "031", "", "", "43.50092", "-70.44283", "America/New_York"),
("4979244", "South Portland", "Саут-Портленд", "US", "840", "ME", "005", "", "", "43.64147", "-70.24088", "America/New_York"),
("4979245", "South Portland Gardens", "", "US", "840", "ME", "005", "", "", "43.63897", "-70.31533", "America/New_York"),
("4982236", "Waterville", "Уотервилл", "US", "840", "ME", "011", "", "", "44.55201", "-69.63171", "America/New_York"),
("4982720", "West Scarborough", "", "US", "840", "ME", "005", "", "", "43.57036", "-70.38783", "America/New_York"),
("4982753", "Westbrook", "Уэстбрук", "US", "840", "ME", "005", "", "", "43.67703", "-70.37116", "America/New_York"),
("4983811", "Adrian", "Адриан", "US", "840", "MI", "091", "", "", "41.89755", "-84.03717", "America/Detroit"),
("4984016", "Allen Park", "", "US", "840", "MI", "163", "", "", "42.25754", "-83.21104", "America/Detroit"),
("4984029", "Allendale", "", "US", "840", "MI", "139", "", "", "42.97225", "-85.95365", "America/Detroit"),
("4984247", "Ann Arbor", "Анн-Арбор", "US", "840", "MI", "161", "", "", "42.27756", "-83.74088", "America/Detroit"),
("4984565", "Auburn Hills", "Оберн-Хиллс", "US", "840", "MI", "125", "", "", "42.68753", "-83.2341", "America/Detroit"),
("4985153", "Battle Creek", "", "US", "840", "MI", "025", "", "", "42.32115", "-85.17971", "America/Detroit"),
("4985180", "Bay City", "Бей-Сити", "US", "840", "MI", "017", "", "", "43.59447", "-83.88886", "America/Detroit"),
("4986172", "Birmingham", "Бирмингем", "US", "840", "MI", "125", "", "", "42.5467", "-83.21132", "America/Detroit"),
("4987482", "Burton", "Бертон", "US", "840", "MI", "049", "", "", "42.99947", "-83.61634", "America/Detroit"),
("4987990", "Canton", "", "US", "840", "MI", "163", "", "", "42.30865", "-83.48216", "America/Detroit"),
("4989133", "Clinton", "", "US", "840", "MI", "099", "", "", "42.58698", "-82.91992", "America/Detroit"),
("4990510", "Dearborn", "Дирборн", "US", "840", "MI", "163", "", "", "42.32226", "-83.17631", "America/Detroit"),
("4990512", "Dearborn Heights", "", "US", "840", "MI", "163", "", "", "42.33698", "-83.27326", "America/Detroit"),
("4990729", "Detroit", "Детройт", "US", "840", "MI", "163", "", "", "42.33143", "-83.04575", "America/Detroit"),
("4991640", "East Lansing", "Ист-Лансинг", "US", "840", "MI", "065", "", "", "42.73698", "-84.48387", "America/Detroit"),
("4991735", "Eastpointe", "", "US", "840", "MI", "099", "", "", "42.46837", "-82.95547", "America/Detroit"),
("4992523", "Farmington Hills", "", "US", "840", "MI", "125", "", "", "42.48531", "-83.37716", "America/Detroit"),
("4992635", "Ferndale", "", "US", "840", "MI", "125", "", "", "42.46059", "-83.13465", "America/Detroit"),
("4992982", "Flint", "Флинт", "US", "840", "MI", "049", "", "", "43.01253", "-83.68746", "America/Detroit"),
("4993125", "Forest Hills", "", "US", "840", "MI", "081", "", "", "42.95947", "-85.48975", "America/Detroit"),
("4993659", "Garden City", "", "US", "840", "MI", "163", "", "", "42.32559", "-83.33104", "America/Detroit"),
("4994358", "Grand Rapids", "Гранд-Рапидс", "US", "840", "MI", "081", "", "", "42.96336", "-85.66809", "America/Detroit"),
("4994391", "Grandville", "", "US", "840", "MI", "081", "", "", "42.90975", "-85.76309", "America/Detroit"),
("4994871", "Grosse Pointe Woods", "", "US", "840", "MI", "163", "", "", "42.44365", "-82.90686", "America/Detroit"),
("4995197", "Hamtramck", "", "US", "840", "MI", "163", "", "", "42.39282", "-83.04964", "America/Detroit"),
("4995514", "Haslett", "", "US", "840", "MI", "065", "", "", "42.74698", "-84.40108", "America/Detroit"),
("4995664", "Hazel Park", "", "US", "840", "MI", "125", "", "", "42.46254", "-83.10409", "America/Detroit"),
("4996248", "Holland", "Голландия", "US", "840", "MI", "139", "", "", "42.78752", "-86.10893", "America/Detroit"),
("4996306", "Holt", "", "US", "840", "MI", "065", "", "", "42.64059", "-84.51525", "America/Detroit"),
("4997384", "Jackson", "Джексон", "US", "840", "MI", "075", "", "", "42.24587", "-84.40135", "America/Detroit"),
("4997500", "Jenison", "", "US", "840", "MI", "139", "", "", "42.90725", "-85.79198", "America/Detroit"),
("4997787", "Kalamazoo", "Каламазу", "US", "840", "MI", "077", "", "", "42.29171", "-85.58723", "America/Detroit"),
("4998018", "Kentwood", "", "US", "840", "MI", "081", "", "", "42.86947", "-85.64475", "America/Detroit"),
("4998830", "Lansing", "Лансинг", "US", "840", "MI", "065", "", "", "42.73254", "-84.55553", "America/Detroit"),
("4999311", "Lincoln Park", "", "US", "840", "MI", "163", "", "", "42.25059", "-83.17854", "America/Detroit"),
("4999837", "Livonia", "Ливония", "US", "840", "MI", "163", "", "", "42.36837", "-83.35271", "America/Detroit"),
("5000500", "Madison Heights", "", "US", "840", "MI", "125", "", "", "42.48587", "-83.1052", "America/Detroit"),
("5000947", "Marquette", "Маркетт", "US", "840", "MI", "103", "", "", "46.54354", "-87.39542", "America/Detroit"),
("5001929", "Midland", "", "US", "840", "MI", "111", "", "", "43.61558", "-84.24721", "America/Detroit"),
("5002344", "Monroe", "Монро", "US", "840", "MI", "115", "", "", "41.91643", "-83.39771", "America/Detroit"),
("5002656", "Mount Clemens", "", "US", "840", "MI", "099", "", "", "42.59726", "-82.87798", "America/Detroit"),
("5002714", "Mount Pleasant", "Маунт-Плезант", "US", "840", "MI", "073", "", "", "43.59781", "-84.76751", "America/Detroit"),
("5003132", "Muskegon", "", "US", "840", "MI", "121", "", "", "43.23418", "-86.24839", "America/Detroit"),
("5004005", "Norton Shores", "", "US", "840", "MI", "121", "", "", "43.1689", "-86.26395", "America/Detroit"),
("5004062", "Novi", "Новый", "US", "840", "MI", "125", "", "", "42.48059", "-83.47549", "America/Detroit"),
("5004188", "Oak Park", "Оук-Парк", "US", "840", "MI", "125", "", "", "42.45948", "-83.18271", "America/Detroit"),
("5004359", "Okemos", "", "US", "840", "MI", "065", "", "", "42.72226", "-84.42747", "America/Detroit"),
("5004792", "Owosso", "", "US", "840", "MI", "155", "", "", "42.9978", "-84.17664", "America/Detroit"),
("5006166", "Pontiac", "Понтиак", "US", "840", "MI", "125", "", "", "42.63892", "-83.29105", "America/Detroit"),
("5006233", "Port Huron", "", "US", "840", "MI", "147", "", "", "42.97086", "-82.42491", "America/Detroit"),
("5006250", "Portage", "", "US", "840", "MI", "077", "", "", "42.20115", "-85.58", "America/Detroit"),
("5006917", "Redford", "Редфорд", "US", "840", "MI", "163", "", "", "42.38337", "-83.2966", "America/Detroit"),
("5007402", "Rochester Hills", "", "US", "840", "MI", "125", "", "", "42.65837", "-83.14993", "America/Detroit"),
("5007531", "Romulus", "Ромул", "US", "840", "MI", "163", "", "", "42.22226", "-83.3966", "America/Detroit"),
("5007655", "Roseville", "Розвелл", "US", "840", "MI", "099", "", "", "42.49726", "-82.93714", "America/Detroit"),
("5007804", "Royal Oak", "", "US", "840", "MI", "125", "", "", "42.48948", "-83.14465", "America/Detroit"),
("5007989", "Saginaw", "", "US", "840", "MI", "145", "", "", "43.41947", "-83.95081", "America/Detroit"),
("5009586", "Shelby", "", "US", "840", "MI", "099", "", "", "42.67087", "-83.03298", "America/Detroit"),
("5010636", "Southfield", "", "US", "840", "MI", "125", "", "", "42.47337", "-83.22187", "America/Detroit"),
("5010646", "Southgate", "", "US", "840", "MI", "163", "", "", "42.21393", "-83.19381", "America/Detroit"),
("5010978", "Saint Clair Shores", "", "US", "840", "MI", "099", "", "", "42.49698", "-82.88881", "America/Detroit"),
("5011148", "Sterling Heights", "", "US", "840", "MI", "099", "", "", "42.58031", "-83.0302", "America/Detroit"),
("5011908", "Taylor", "Тейлор", "US", "840", "MI", "163", "", "", "42.24087", "-83.26965", "America/Detroit"),
("5012521", "Trenton", "Трентон", "US", "840", "MI", "163", "", "", "42.13949", "-83.17826", "America/Detroit"),
("5012639", "Troy", "Троя", "US", "840", "MI", "125", "", "", "42.60559", "-83.14993", "America/Detroit"),
("5013924", "Walker", "", "US", "840", "MI", "081", "", "", "43.00141", "-85.76809", "America/Detroit"),
("5014051", "Warren", "Уоррен", "US", "840", "MI", "099", "", "", "42.47754", "-83.0277", "America/Detroit"),
("5014130", "Waterford", "Уотерфорд", "US", "840", "MI", "125", "", "", "42.70225", "-83.40272", "America/Detroit"),
("5014208", "Waverly", "", "US", "840", "MI", "045", "", "", "42.7392", "-84.62082", "America/Detroit"),
("5014224", "Wayne", "", "US", "840", "MI", "163", "", "", "42.28143", "-83.38632", "America/Detroit"),
("5014681", "Westland", "", "US", "840", "MI", "163", "", "", "42.3242", "-83.40021", "America/Detroit"),
("5015599", "Wyandotte", "", "US", "840", "MI", "163", "", "", "42.21421", "-83.14992", "America/Detroit"),
("5015618", "Wyoming", "", "US", "840", "MI", "081", "", "", "42.91336", "-85.70531", "America/Detroit"),
("5015688", "Ypsilanti", "Ипсиланти", "US", "840", "MI", "161", "", "", "42.24115", "-83.61299", "America/Detroit"),
("5016024", "Albert Lea", "Альберт-Ли", "US", "840", "MN", "047", "", "", "43.64801", "-93.36827", "America/Chicago"),
("5016374", "Andover", "", "US", "840", "MN", "003", "", "", "45.2333", "-93.29134", "America/Chicago"),
("5016450", "Anoka", "Анока", "US", "840", "MN", "003", "", "", "45.19774", "-93.38718", "America/Chicago"),
("5016494", "Apple Valley", "Эпл-Вэлли", "US", "840", "MN", "037", "", "", "44.73191", "-93.21772", "America/Chicago"),
("5016884", "Austin", "Остин", "US", "840", "MN", "099", "", "", "43.66663", "-92.97464", "America/Chicago"),
("5018651", "Blaine", "", "US", "840", "MN", "003", "", "", "45.1608", "-93.23495", "America/Chicago"),
("5018739", "Bloomington", "Блумингтон", "US", "840", "MN", "053", "", "", "44.8408", "-93.29828", "America/Chicago"),
("5019330", "Brooklyn Center", "", "US", "840", "MN", "053", "", "", "45.07608", "-93.33273", "America/Chicago"),
("5019335", "Brooklyn Park", "Бруклин-Парк", "US", "840", "MN", "053", "", "", "45.09413", "-93.35634", "America/Chicago"),
("5019588", "Buffalo", "Буффало", "US", "840", "MN", "171", "", "", "45.17191", "-93.87469", "America/Chicago"),
("5019767", "Burnsville", "Бернсвилл", "US", "840", "MN", "037", "", "", "44.76774", "-93.27772", "America/Chicago"),
("5020859", "Champlin", "", "US", "840", "MN", "053", "", "", "45.18885", "-93.39745", "America/Chicago"),
("5020881", "Chanhassen", "", "US", "840", "MN", "019", "", "", "44.86219", "-93.53079", "America/Chicago"),
("5020938", "Chaska", "Часка", "US", "840", "MN", "019", "", "", "44.78941", "-93.60218", "America/Chicago"),
("5021828", "Columbia Heights", "", "US", "840", "MN", "003", "", "", "45.0408", "-93.263", "America/Chicago"),
("5022025", "Coon Rapids", "Кун-Рапидс", "US", "840", "MN", "003", "", "", "45.11997", "-93.28773", "America/Chicago"),
("5022134", "Cottage Grove", "", "US", "840", "MN", "163", "", "", "44.82774", "-92.94382", "America/Chicago"),
("5023571", "Crystal", "", "US", "840", "MN", "053", "", "", "45.03274", "-93.36023", "America/Chicago"),
("5024719", "Duluth", "Дулут", "US", "840", "MN", "137", "", "", "46.78327", "-92.10658", "America/Chicago"),
("5024825", "Eagan", "Иган", "US", "840", "MN", "037", "", "", "44.80413", "-93.16689", "America/Chicago"),
("5025219", "Eden Prairie", "Иден-Прери", "US", "840", "MN", "053", "", "", "44.85469", "-93.47079", "America/Chicago"),
("5025264", "Edina", "Идайна", "US", "840", "MN", "053", "", "", "44.88969", "-93.34995", "America/Chicago"),
("5025471", "Elk River", "Элк-Ривер", "US", "840", "MN", "141", "", "", "45.30385", "-93.56718", "America/Chicago"),
("5026291", "Faribault", "Фэрибо", "US", "840", "MN", "131", "", "", "44.29496", "-93.26883", "America/Chicago"),
("5026321", "Farmington", "Фармингтон", "US", "840", "MN", "037", "", "", "44.64024", "-93.14355", "America/Chicago"),
("5027117", "Forest Lake", "", "US", "840", "MN", "163", "", "", "45.27886", "-92.98522", "America/Chicago"),
("5027482", "Fridley", "Фридли", "US", "840", "MN", "003", "", "", "45.08608", "-93.26328", "America/Chicago"),
("5028163", "Golden Valley", "", "US", "840", "MN", "053", "", "", "45.00969", "-93.34912", "America/Chicago"),
("5029181", "Ham Lake", "", "US", "840", "MN", "003", "", "", "45.25024", "-93.24995", "America/Chicago"),
("5029500", "Hastings", "Хейстингс", "US", "840", "MN", "037", "", "", "44.7433", "-92.85243", "America/Chicago"),
("5030005", "Hibbing", "Хиббинг", "US", "840", "MN", "137", "", "", "47.42715", "-92.93769", "America/Chicago"),
("5030670", "Hopkins", "", "US", "840", "MN", "053", "", "", "44.92496", "-93.46273", "America/Chicago"),
("5031412", "Inver Grove Heights", "", "US", "840", "MN", "037", "", "", "44.84802", "-93.04272", "America/Chicago"),
("5034059", "Lakeville", "Лейквилл", "US", "840", "MN", "037", "", "", "44.64969", "-93.24272", "America/Chicago"),
("5034767", "Lino Lakes", "", "US", "840", "MN", "003", "", "", "45.16024", "-93.08883", "America/Chicago"),
("5036420", "Mankato", "Манкейто", "US", "840", "MN", "013", "", "", "44.16358", "-93.9994", "America/Chicago"),
("5036493", "Maple Grove", "", "US", "840", "MN", "053", "", "", "45.07246", "-93.45579", "America/Chicago"),
("5036588", "Maplewood", "", "US", "840", "MN", "123", "", "", "44.95302", "-92.99522", "America/Chicago"),
("5037649", "Minneapolis", "Миннеаполис", "US", "840", "MN", "053", "", "", "44.97997", "-93.26384", "America/Chicago"),
("5037784", "Minnetonka", "Миннетонка", "US", "840", "MN", "053", "", "", "44.9133", "-93.50329", "America/Chicago"),
("5037790", "Minnetonka Mills", "", "US", "840", "MN", "053", "", "", "44.94107", "-93.4419", "America/Chicago"),
("5038108", "Moorhead", "Мурхед", "US", "840", "MN", "027", "", "", "46.87385", "-96.76758", "America/Chicago"),
("5039080", "New Brighton", "", "US", "840", "MN", "123", "", "", "45.06552", "-93.20189", "America/Chicago"),
("5039094", "New Hope", "", "US", "840", "MN", "053", "", "", "45.03802", "-93.38662", "America/Chicago"),
("5039675", "Northfield", "Нортфилд", "US", "840", "MN", "131", "", "", "44.4583", "-93.1616", "America/Chicago"),
("5039978", "Oakdale", "", "US", "840", "MN", "163", "", "", "44.96302", "-92.96494", "America/Chicago"),
("5040647", "Owatonna", "", "US", "840", "MN", "147", "", "", "44.08385", "-93.22604", "America/Chicago"),
("5041926", "Plymouth", "", "US", "840", "MN", "053", "", "", "45.01052", "-93.45551", "America/Chicago"),
("5042373", "Prior Lake", "", "US", "840", "MN", "139", "", "", "44.7133", "-93.42273", "America/Chicago"),
("5042561", "Ramsey", "", "US", "840", "MN", "003", "", "", "45.2611", "-93.45", "America/Chicago"),
("5042773", "Red Wing", "Ред-Уинг", "US", "840", "MN", "049", "", "", "44.56247", "-92.5338", "America/Chicago"),
("5043193", "Richfield", "Ричфилд", "US", "840", "MN", "053", "", "", "44.8833", "-93.283", "America/Chicago"),
("5043473", "Rochester", "Рочестер", "US", "840", "MN", "109", "", "", "44.02163", "-92.4699", "America/Chicago"),
("5043779", "Rosemount", "", "US", "840", "MN", "037", "", "", "44.73941", "-93.12577", "America/Chicago"),
("5043799", "Roseville", "Розвелл", "US", "840", "MN", "123", "", "", "45.00608", "-93.15661", "America/Chicago"),
("5044407", "Saint Cloud", "", "US", "840", "MN", "145", "", "", "45.5608", "-94.16249", "America/Chicago"),
("5045021", "Saint Louis Park", "", "US", "840", "MN", "053", "", "", "44.9483", "-93.34801", "America/Chicago"),
("5045258", "Saint Michael", "", "US", "840", "MN", "171", "", "", "45.20996", "-93.66496", "America/Chicago"),
("5045360", "Saint Paul", "Сент-Пол", "US", "840", "MN", "123", "", "", "44.94441", "-93.09327", "America/Chicago"),
("5046001", "Sartell", "", "US", "840", "MN", "145", "", "", "45.62163", "-94.20694", "America/Chicago"),
("5046063", "Savage", "", "US", "840", "MN", "139", "", "", "44.77913", "-93.33634", "America/Chicago"),
("5046997", "Shakopee", "Шейкопе", "US", "840", "MN", "139", "", "", "44.79802", "-93.5269", "America/Chicago"),
("5047234", "Shoreview", "Шорвью", "US", "840", "MN", "123", "", "", "45.07913", "-93.14717", "America/Chicago"),
("5048033", "South Saint Paul", "", "US", "840", "MN", "037", "", "", "44.89274", "-93.03494", "America/Chicago"),
("5048814", "Stillwater", "Стиллуотер", "US", "840", "MN", "163", "", "", "45.05636", "-92.80604", "America/Chicago"),
("5052361", "West Coon Rapids", "", "US", "840", "MN", "053", "", "", "45.15969", "-93.34967", "America/Chicago"),
("5052467", "West Saint Paul", "", "US", "840", "MN", "037", "", "", "44.91608", "-93.10161", "America/Chicago"),
("5052658", "White Bear Lake", "Уайт-Бэр-Лейк", "US", "840", "MN", "123", "", "", "45.08469", "-93.00994", "America/Chicago"),
("5052916", "Willmar", "Уилмар", "US", "840", "MN", "067", "", "", "45.12191", "-95.04334", "America/Chicago"),
("5053156", "Winona", "Вайнона", "US", "840", "MN", "169", "", "", "44.04996", "-91.63932", "America/Chicago"),
("5053358", "Woodbury", "", "US", "840", "MN", "163", "", "", "44.92386", "-92.95938", "America/Chicago"),
("5055787", "Kirksville", "", "US", "840", "MO", "001", "", "", "40.19475", "-92.58325", "America/Chicago"),
("5059163", "Fargo", "Фарго", "US", "840", "ND", "017", "", "", "46.87719", "-96.7898", "America/Chicago"),
("5059429", "Grand Forks", "Гранд-Форкс", "US", "840", "ND", "035", "", "", "47.92526", "-97.03285", "America/Chicago"),
("5059836", "Jamestown", "", "US", "840", "ND", "093", "", "", "46.91054", "-98.70844", "America/Chicago"),
("5062458", "West Fargo", "", "US", "840", "ND", "017", "", "", "46.87497", "-96.90036", "America/Chicago"),
("5063805", "Bellevue", "Белвью", "US", "840", "NE", "153", "", "", "41.13667", "-95.89084", "America/Chicago"),
("5066001", "Columbus", "Колумбус", "US", "840", "NE", "141", "", "", "41.42973", "-97.36838", "America/Chicago"),
("5068725", "Fremont", "Фримонт", "US", "840", "NE", "053", "", "", "41.43333", "-96.49808", "America/Chicago"),
("5069297", "Grand Island", "Гранд-Айленд", "US", "840", "NE", "079", "", "", "40.92501", "-98.34201", "America/Chicago"),
("5069802", "Hastings", "Хейстингс", "US", "840", "NE", "001", "", "", "40.58612", "-98.38839", "America/Chicago"),
("5071348", "Kearney", "Керни", "US", "840", "NE", "019", "", "", "40.69946", "-99.08148", "America/Chicago"),
("5071665", "La Vista", "", "US", "840", "NE", "153", "", "", "41.18389", "-96.03113", "America/Chicago"),
("5072006", "Lincoln", "Линкольн", "US", "840", "NE", "109", "", "", "40.8", "-96.66696", "America/Chicago"),
("5073965", "Norfolk", "Норфолк", "US", "840", "NE", "119", "", "", "42.02834", "-97.417", "America/Chicago"),
("5074472", "Omaha", "Омаха", "US", "840", "NE", "055", "", "", "41.25861", "-95.93779", "America/Chicago"),
("5074792", "Papillion", "", "US", "840", "NE", "153", "", "", "41.15444", "-96.04224", "America/Chicago"),
("5083221", "Bedford", "Бедфорд", "US", "840", "NH", "011", "", "", "42.94647", "-71.5159", "America/New_York"),
("5084868", "Concord", "Конкорд", "US", "840", "NH", "013", "", "", "43.20814", "-71.53757", "America/New_York"),
("5085374", "Derry", "Дерри", "US", "840", "NH", "015", "", "", "42.88064", "-71.32729", "America/New_York"),
("5085382", "Derry Village", "", "US", "840", "NH", "015", "", "", "42.89175", "-71.31201", "America/New_York"),
("5085520", "Dover", "Довер", "US", "840", "NH", "017", "", "", "43.19786", "-70.87367", "America/New_York"),
("5085688", "East Concord", "", "US", "840", "NH", "013", "", "", "43.24202", "-71.53813", "America/New_York"),
("5088262", "Keene", "", "US", "840", "NH", "005", "", "", "42.93369", "-72.27814", "America/New_York"),
("5088438", "Laconia", "", "US", "840", "NH", "001", "", "", "43.52785", "-71.47035", "America/New_York"),
("5089178", "Manchester", "Манчестер", "US", "840", "NH", "011", "", "", "42.99564", "-71.45479", "America/New_York"),
("5089478", "Merrimack", "Мерримак", "US", "840", "NH", "011", "", "", "42.86509", "-71.4934", "America/New_York"),
("5090046", "Nashua", "Нашуа", "US", "840", "NH", "011", "", "", "42.76537", "-71.46757", "America/New_York"),
("5091383", "Portsmouth", "Портсмут", "US", "840", "NH", "015", "", "", "43.07176", "-70.76255", "America/New_York"),
("5091872", "Rochester", "Рочестер", "US", "840", "NH", "017", "", "", "43.30453", "-70.97562", "America/New_York"),
("5092268", "Salem", "Салем", "US", "840", "NH", "015", "", "", "42.78842", "-71.20089", "America/New_York"),
("5095281", "Asbury Park", "", "US", "840", "NJ", "025", "", "", "40.22039", "-74.01208", "America/New_York"),
("5095325", "Avenel", "", "US", "840", "NJ", "023", "", "", "40.58038", "-74.28515", "America/New_York"),
("5095445", "Bayonne", "Бейонн", "US", "840", "NJ", "017", "", "", "40.66871", "-74.11431", "America/New_York"),
("5095549", "Belleville", "", "US", "840", "NJ", "013", "", "", "40.79371", "-74.15014", "America/New_York"),
("5095611", "Bergenfield", "", "US", "840", "NJ", "003", "", "", "40.9276", "-73.99736", "America/New_York"),
("5095779", "Bloomfield", "", "US", "840", "NJ", "013", "", "", "40.80677", "-74.18542", "America/New_York"),
("5096316", "Carteret", "", "US", "840", "NJ", "023", "", "", "40.57733", "-74.2282", "America/New_York"),
("5096686", "Cliffside Park", "", "US", "840", "NJ", "003", "", "", "40.82149", "-73.98764", "America/New_York"),
("5096699", "Clifton", "Клифтон", "US", "840", "NJ", "031", "", "", "40.85843", "-74.16376", "America/New_York"),
("5096798", "Colonia", "", "US", "840", "NJ", "023", "", "", "40.57455", "-74.30209", "America/New_York"),
("5097017", "Cranford", "Крэнфорд", "US", "840", "NJ", "039", "", "", "40.65844", "-74.29959", "America/New_York"),
("5097315", "Dover", "Довер", "US", "840", "NJ", "027", "", "", "40.88399", "-74.5621", "America/New_York"),
("5097357", "Dumont", "", "US", "840", "NJ", "003", "", "", "40.94065", "-73.99681", "America/New_York"),
("5097402", "East Brunswick", "", "US", "840", "NJ", "023", "", "", "40.42788", "-74.41598", "America/New_York"),
("5097441", "East Orange", "", "US", "840", "NJ", "013", "", "", "40.76732", "-74.20487", "America/New_York"),
("5097529", "Edison", "Эдисон", "US", "840", "NJ", "023", "", "", "40.51872", "-74.4121", "America/New_York"),
("5097598", "Elizabeth", "Элизабет", "US", "840", "NJ", "039", "", "", "40.66399", "-74.2107", "America/New_York"),
("5097627", "Elmwood Park", "", "US", "840", "NJ", "003", "", "", "40.90399", "-74.11848", "America/New_York"),
("5097672", "Englewood", "Энглвуд", "US", "840", "NJ", "003", "", "", "40.89288", "-73.97264", "America/New_York"),
("5097751", "Ewing", "", "US", "840", "NJ", "021", "", "", "40.26983", "-74.79988", "America/New_York"),
("5097773", "Fair Lawn", "", "US", "840", "NJ", "003", "", "", "40.94038", "-74.13181", "America/New_York"),
("5098109", "Fords", "", "US", "840", "NJ", "023", "", "", "40.52927", "-74.31598", "America/New_York"),
("5098135", "Fort Lee", "", "US", "840", "NJ", "003", "", "", "40.85093", "-73.97014", "America/New_York"),
("5098343", "Garfield", "", "US", "840", "NJ", "003", "", "", "40.88149", "-74.1132", "America/New_York"),
("5098706", "Hackensack", "Хакенсак", "US", "840", "NJ", "003", "", "", "40.88593", "-74.04347", "America/New_York"),
("5098909", "Hawthorne", "", "US", "840", "NJ", "031", "", "", "40.94926", "-74.15375", "America/New_York"),
("5099093", "Hillside", "", "US", "840", "NJ", "039", "", "", "40.70121", "-74.23015", "America/New_York"),
("5099133", "Hoboken", "Хобокен", "US", "840", "NJ", "017", "", "", "40.74399", "-74.03236", "America/New_York"),
("5099289", "Hopatcong", "", "US", "840", "NJ", "037", "", "", "40.93288", "-74.65933", "America/New_York"),
("5099292", "Hopatcong Hills", "", "US", "840", "NJ", "037", "", "", "40.94399", "-74.67072", "America/New_York"),
("5099724", "Irvington", "", "US", "840", "NJ", "013", "", "", "40.73232", "-74.23487", "America/New_York"),
("5099738", "Iselin", "", "US", "840", "NJ", "023", "", "", "40.57538", "-74.32237", "America/New_York"),
("5099836", "Jersey City", "Джерси-Сити", "US", "840", "NJ", "017", "", "", "40.72816", "-74.07764", "America/New_York"),
("5099967", "Kearny", "Керни", "US", "840", "NJ", "017", "", "", "40.76843", "-74.14542", "America/New_York"),
("5100280", "Lakewood", "Лейквуд", "US", "840", "NJ", "029", "", "", "40.09789", "-74.21764", "America/New_York"),
("5100506", "Linden", "Линден", "US", "840", "NJ", "039", "", "", "40.62205", "-74.24459", "America/New_York"),
("5100572", "Livingston", "Ливингстон", "US", "840", "NJ", "013", "", "", "40.79593", "-74.31487", "America/New_York"),
("5100604", "Lodi", "Лоди", "US", "840", "NJ", "003", "", "", "40.88232", "-74.0832", "America/New_York"),
("5100619", "Long Branch", "", "US", "840", "NJ", "025", "", "", "40.30428", "-73.99236", "America/New_York"),
("5100706", "Lyndhurst", "", "US", "840", "NJ", "003", "", "", "40.81204", "-74.12431", "America/New_York"),
("5100748", "Madison", "Мадисон", "US", "840", "NJ", "027", "", "", "40.75982", "-74.4171", "America/New_York"),
("5100776", "Mahwah", "", "US", "840", "NJ", "003", "", "", "41.08871", "-74.14376", "America/New_York"),
("5100854", "Maplewood", "", "US", "840", "NJ", "013", "", "", "40.73121", "-74.27348", "America/New_York"),
("5100886", "Marlboro", "", "US", "840", "NJ", "025", "", "", "40.31539", "-74.24626", "America/New_York"),
("5101334", "Montclair", "", "US", "840", "NJ", "013", "", "", "40.82593", "-74.20903", "America/New_York"),
("5101427", "Morristown", "", "US", "840", "NJ", "027", "", "", "40.79677", "-74.48154", "America/New_York"),
("5101717", "New Brunswick", "Нью-Брансуик", "US", "840", "NJ", "023", "", "", "40.48622", "-74.45182", "America/New_York"),
("5101766", "New Milford", "Новые Милфорд", "US", "840", "NJ", "003", "", "", "40.93268", "-74.01785", "America/New_York"),
("5101798", "Newark", "Ньюарк", "US", "840", "NJ", "013", "", "", "40.73566", "-74.17237", "America/New_York"),
("5101873", "North Arlington", "", "US", "840", "NJ", "003", "", "", "40.78843", "-74.1332", "America/New_York"),
("5101879", "North Bergen", "", "US", "840", "NJ", "017", "", "", "40.80427", "-74.01208", "America/New_York"),
("5101938", "North Plainfield", "", "US", "840", "NJ", "035", "", "", "40.6301", "-74.42737", "America/New_York"),
("5102076", "Nutley", "", "US", "840", "NJ", "013", "", "", "40.82232", "-74.15987", "America/New_York"),
("5102162", "Old Bridge", "", "US", "840", "NJ", "023", "", "", "40.41483", "-74.36543", "America/New_York"),
("5102213", "Orange", "", "US", "840", "NJ", "013", "", "", "40.77066", "-74.23265", "America/New_York"),
("5102369", "Palisades Park", "", "US", "840", "NJ", "003", "", "", "40.84816", "-73.99764", "America/New_York"),
("5102387", "Paramus", "Парамус", "US", "840", "NJ", "003", "", "", "40.94454", "-74.07542", "America/New_York"),
("5102427", "Parsippany", "Парсиппани", "US", "840", "NJ", "027", "", "", "40.85788", "-74.42599", "America/New_York"),
("5102443", "Passaic", "", "US", "840", "NJ", "031", "", "", "40.85677", "-74.12848", "America/New_York"),
("5102466", "Paterson", "Патерсон", "US", "840", "NJ", "031", "", "", "40.91677", "-74.17181", "America/New_York"),
("5102578", "Perth Amboy", "", "US", "840", "NJ", "023", "", "", "40.50677", "-74.26542", "America/New_York"),
("5102713", "Piscataway", "", "US", "840", "NJ", "023", "", "", "40.49927", "-74.39904", "America/New_York"),
("5102720", "Plainfield", "Плейнфилд", "US", "840", "NJ", "039", "", "", "40.61682", "-74.41727", "America/New_York"),
("5102796", "Point Pleasant", "", "US", "840", "NJ", "029", "", "", "40.08317", "-74.06819", "America/New_York"),
("5103055", "Rahway", "", "US", "840", "NJ", "039", "", "", "40.60816", "-74.27765", "America/New_York"),
("5103269", "Ridgewood", "Риджвуд", "US", "840", "NJ", "003", "", "", "40.97926", "-74.11653", "America/New_York"),
("5103500", "Roselle", "", "US", "840", "NJ", "039", "", "", "40.66427", "-74.2632", "America/New_York"),
("5103580", "Rutherford", "", "US", "840", "NJ", "003", "", "", "40.82649", "-74.10681", "America/New_York"),
("5104404", "Sayreville", "", "US", "840", "NJ", "023", "", "", "40.45927", "-74.36098", "America/New_York"),
("5104405", "Sayreville Junction", "", "US", "840", "NJ", "023", "", "", "40.46538", "-74.33043", "America/New_York"),
("5104473", "Scotch Plains", "", "US", "840", "NJ", "039", "", "", "40.65538", "-74.38987", "America/New_York"),
("5104504", "Secaucus", "", "US", "840", "NJ", "017", "", "", "40.79672", "-74.05532", "America/New_York"),
("5104755", "Somerset", "Сомерсет", "US", "840", "NJ", "035", "", "", "40.4976", "-74.48849", "America/New_York"),
("5104835", "South Old Bridge", "", "US", "840", "NJ", "023", "", "", "40.40816", "-74.35432", "America/New_York"),
("5104836", "South Orange", "", "US", "840", "NJ", "013", "", "", "40.74899", "-74.26126", "America/New_York"),
("5104844", "South Plainfield", "", "US", "840", "NJ", "023", "", "", "40.57927", "-74.41154", "America/New_York"),
("5104853", "South River", "", "US", "840", "NJ", "023", "", "", "40.4465", "-74.38598", "America/New_York"),
("5105127", "Summit", "", "US", "840", "NJ", "039", "", "", "40.74149", "-74.35959", "America/New_York"),
("5105262", "Teaneck", "", "US", "840", "NJ", "003", "", "", "40.8976", "-74.01597", "America/New_York"),
("5105433", "Tinton Falls", "", "US", "840", "NJ", "025", "", "", "40.30428", "-74.10042", "America/New_York"),
("5105496", "Trenton", "Трентон", "US", "840", "NJ", "021", "", "", "40.21705", "-74.74294", "America/New_York"),
("5105608", "Union", "", "US", "840", "NJ", "039", "", "", "40.6976", "-74.2632", "America/New_York"),
("5105634", "Union City", "Юнион-Сити", "US", "840", "NJ", "017", "", "", "40.77955", "-74.02375", "America/New_York"),
("5106160", "Wayne", "", "US", "840", "NJ", "031", "", "", "40.92538", "-74.27654", "America/New_York"),
("5106279", "West Milford", "", "US", "840", "NJ", "031", "", "", "41.13121", "-74.36737", "America/New_York"),
("5106292", "West New York", "", "US", "840", "NJ", "017", "", "", "40.78788", "-74.01431", "America/New_York"),
("5106298", "West Orange", "", "US", "840", "NJ", "013", "", "", "40.79871", "-74.23904", "America/New_York"),
("5106331", "Westfield", "", "US", "840", "NJ", "039", "", "", "40.65899", "-74.34737", "America/New_York"),
("5106453", "Willingboro", "", "US", "840", "NJ", "005", "", "", "40.02789", "-74.86905", "America/New_York"),
("5106529", "Woodbridge", "", "US", "840", "NJ", "023", "", "", "40.5576", "-74.28459", "America/New_York"),
("5106615", "Wyckoff", "", "US", "840", "NJ", "003", "", "", "41.00954", "-74.17292", "America/New_York"),
("5106834", "Albany", "Олбани", "US", "840", "NY", "001", "", "", "42.65258", "-73.75623", "America/New_York"),
("5107129", "Amherst", "Амхерст", "US", "840", "NY", "029", "", "", "42.97839", "-78.79976", "America/New_York"),
("5107152", "Amsterdam", "", "US", "840", "NY", "057", "", "", "42.93869", "-74.18819", "America/New_York"),
("5107505", "Auburn", "Оберн", "US", "840", "NY", "011", "", "", "42.93173", "-76.56605", "America/New_York"),
("5107760", "Baldwin", "Болдуин", "US", "840", "NY", "059", "", "", "40.65649", "-73.6093", "America/New_York"),
("5108093", "Batavia", "Батавия", "US", "840", "NY", "037", "", "", "42.99812", "-78.18752", "America/New_York"),
("5108169", "Bay Shore", "", "US", "840", "NY", "103", "", "", "40.7251", "-73.24539", "America/New_York"),
("5108219", "Beacon", "", "US", "840", "NY", "027", "", "", "41.50482", "-73.96958", "America/New_York"),
("5108707", "Bellmore", "", "US", "840", "NY", "059", "", "", "40.66871", "-73.52707", "America/New_York"),
("5108815", "Bensonhurst", "Бенсонхерст", "US", "840", "NY", "047", "", "", "40.60177", "-73.99403", "America/New_York"),
("5108955", "Bethpage", "", "US", "840", "NY", "059", "", "", "40.74427", "-73.48207", "America/New_York"),
("5109177", "Binghamton", "Бингемтон", "US", "840", "NY", "007", "", "", "42.09869", "-75.91797", "America/New_York"),
("5110077", "Brentwood", "", "US", "840", "NY", "103", "", "", "40.78121", "-73.24623", "America/New_York"),
("5110159", "Brighton", "Брайтон", "US", "840", "NY", "055", "", "", "43.14756", "-77.55055", "America/New_York"),
("5110266", "The Bronx", "Бронкс", "US", "840", "NY", "005", "", "", "40.84985", "-73.86641", "America/New_York"),
("5110302", "Brooklyn", "Бруклин", "US", "840", "NY", "047", "", "", "40.6501", "-73.94958", "America/New_York"),
("5110629", "Buffalo", "Буффало", "US", "840", "NY", "029", "", "", "42.88645", "-78.87837", "America/New_York"),
("5112035", "Centereach", "", "US", "840", "NY", "103", "", "", "40.85843", "-73.09955", "America/New_York"),
("5112078", "Central Islip", "", "US", "840", "NY", "103", "", "", "40.79065", "-73.20178", "America/New_York"),
("5112375", "Cheektowaga", "", "US", "840", "NY", "029", "", "", "42.90339", "-78.75475", "America/New_York"),
("5113142", "Cohoes", "", "US", "840", "NY", "001", "", "", "42.77424", "-73.70012", "America/New_York"),
("5113412", "Commack", "", "US", "840", "NY", "103", "", "", "40.84288", "-73.29289", "America/New_York"),
("5113481", "Coney Island", "Кони-Айленд", "US", "840", "NY", "047", "", "", "40.57788", "-73.99403", "America/New_York"),
("5113683", "Copiague", "", "US", "840", "NY", "103", "", "", "40.68149", "-73.39984", "America/New_York"),
("5113694", "Coram", "", "US", "840", "NY", "103", "", "", "40.86871", "-73.00149", "America/New_York"),
("5113790", "Cortland", "", "US", "840", "NY", "023", "", "", "42.60118", "-76.18048", "America/New_York"),
("5114731", "Deer Park", "", "US", "840", "NY", "103", "", "", "40.76177", "-73.32929", "America/New_York"),
("5114900", "Depew", "", "US", "840", "NY", "029", "", "", "42.90395", "-78.69225", "America/New_York"),
("5115107", "Dix Hills", "", "US", "840", "NY", "103", "", "", "40.80482", "-73.33623", "America/New_York"),
("5115960", "East Meadow", "", "US", "840", "NY", "059", "", "", "40.71399", "-73.55902", "America/New_York"),
("5115962", "East Massapequa", "", "US", "840", "NY", "059", "", "", "40.67343", "-73.43651", "America/New_York"),
("5115985", "East New York", "", "US", "840", "NY", "047", "", "", "40.66677", "-73.88236", "America/New_York"),
("5115989", "East Northport", "", "US", "840", "NY", "103", "", "", "40.87676", "-73.32456", "America/New_York"),
("5116004", "East Patchogue", "", "US", "840", "NY", "103", "", "", "40.76704", "-72.99622", "America/New_York"),
("5116060", "East Setauket", "", "US", "840", "NY", "103", "", "", "40.94149", "-73.10594", "America/New_York"),
("5116119", "Eastchester", "", "US", "840", "NY", "005", "", "", "40.8876", "-73.83291", "America/New_York"),
("5116303", "Eggertsville", "", "US", "840", "NY", "029", "", "", "42.96339", "-78.80392", "America/New_York"),
("5116497", "Elmira", "Эльмира", "US", "840", "NY", "015", "", "", "42.0898", "-76.80773", "America/New_York"),
("5116508", "Elmont", "", "US", "840", "NY", "059", "", "", "40.70094", "-73.71291", "America/New_York"),
("5116937", "Farmingville", "", "US", "840", "NY", "103", "", "", "40.83121", "-73.02955", "America/New_York"),
("5117438", "Floral Park", "", "US", "840", "NY", "059", "", "", "40.72371", "-73.70485", "America/New_York"),
("5117891", "Franklin Square", "", "US", "840", "NY", "059", "", "", "40.70732", "-73.67596", "America/New_York"),
("5117949", "Freeport", "", "US", "840", "NY", "059", "", "", "40.6576", "-73.58318", "America/New_York"),
("5118226", "Garden City", "", "US", "840", "NY", "059", "", "", "40.72677", "-73.6343", "America/New_York"),
("5118626", "Glen Cove", "Глен-Коув", "US", "840", "NY", "059", "", "", "40.86232", "-73.63374", "America/New_York"),
("5118743", "Gloversville", "", "US", "840", "NY", "035", "", "", "43.05285", "-74.34375", "America/New_York"),
("5119347", "Greenburgh", "", "US", "840", "NY", "119", "", "", "41.03288", "-73.84291", "America/New_York"),
("5120095", "Harrison", "Харрисон", "US", "840", "NY", "119", "", "", "40.96899", "-73.71263", "America/New_York"),
("5120228", "Hauppauge", "", "US", "840", "NY", "103", "", "", "40.82565", "-73.20261", "America/New_York"),
("5120478", "Hempstead", "Хемпстед", "US", "840", "NY", "059", "", "", "40.70621", "-73.61874", "America/New_York"),
("5120656", "Hicksville", "Хиксвилла", "US", "840", "NY", "059", "", "", "40.76843", "-73.52513", "America/New_York"),
("5120987", "Holbrook", "Холбрук", "US", "840", "NY", "103", "", "", "40.81232", "-73.07844", "America/New_York"),
("5121163", "Holtsville", "", "US", "840", "NY", "103", "", "", "40.81538", "-73.04511", "America/New_York"),
("5121636", "Huntington", "Хантингтон", "US", "840", "NY", "103", "", "", "40.86815", "-73.42568", "America/New_York"),
("5121650", "Huntington Station", "", "US", "840", "NY", "103", "", "", "40.85343", "-73.41151", "America/New_York"),
("5122331", "Irondequoit", "", "US", "840", "NY", "055", "", "", "43.2134", "-77.57972", "America/New_York"),
("5122413", "Islip", "", "US", "840", "NY", "103", "", "", "40.72982", "-73.21039", "America/New_York"),
("5122432", "Ithaca", "Итак", "US", "840", "NY", "109", "", "", "42.44063", "-76.49661", "America/New_York"),
("5122520", "Jamaica", "", "US", "840", "NY", "081", "", "", "40.69149", "-73.80569", "America/New_York"),
("5122534", "Jamestown", "", "US", "840", "NY", "013", "", "", "42.097", "-79.23533", "America/New_York"),
("5122794", "Johnson City", "Джонсон Сити", "US", "840", "NY", "007", "", "", "42.11563", "-75.95881", "America/New_York"),
("5123247", "Kenmore", "", "US", "840", "NY", "029", "", "", "42.96589", "-78.87004", "America/New_York"),
("5123456", "Kings Park", "", "US", "840", "NY", "103", "", "", "40.88621", "-73.25734", "America/New_York"),
("5123477", "Kingston", "Кингстон", "US", "840", "NY", "111", "", "", "41.92704", "-73.99736", "America/New_York"),
("5123533", "Kiryas Joel", "", "US", "840", "NY", "071", "", "", "41.34204", "-74.16792", "America/New_York"),
("5123718", "Lackawanna", "", "US", "840", "NY", "029", "", "", "42.82561", "-78.82337", "America/New_York"),
("5123840", "Lake Ronkonkoma", "", "US", "840", "NY", "103", "", "", "40.8351", "-73.13122", "America/New_York"),
("5124276", "Levittown", "", "US", "840", "NY", "059", "", "", "40.72593", "-73.51429", "America/New_York"),
("5124497", "Lindenhurst", "", "US", "840", "NY", "103", "", "", "40.68677", "-73.37345", "America/New_York"),
("5125011", "Lockport", "", "US", "840", "NY", "063", "", "", "43.17061", "-78.69031", "America/New_York"),
("5125086", "Long Beach", "Лонг-Бич", "US", "840", "NY", "059", "", "", "40.58844", "-73.65791", "America/New_York"),
("5125125", "Long Island City", "Лонг-Айленд-Сити", "US", "840", "NY", "081", "", "", "40.74482", "-73.94875", "America/New_York"),
("5125523", "Lynbrook", "", "US", "840", "NY", "059", "", "", "40.65483", "-73.6718", "America/New_York"),
("5125738", "Mamaroneck", "", "US", "840", "NY", "119", "", "", "40.94871", "-73.73263", "America/New_York"),
("5125771", "Manhattan", "Манхеттен", "US", "840", "NY", "061", "", "", "40.78343", "-73.96625", "America/New_York"),
("5126183", "Massapequa", "", "US", "840", "NY", "059", "", "", "40.68066", "-73.47429", "America/New_York"),
("5126187", "Massapequa Park", "", "US", "840", "NY", "059", "", "", "40.68038", "-73.45512", "America/New_York"),
("5126208", "Mastic", "", "US", "840", "NY", "103", "", "", "40.80204", "-72.84094", "America/New_York"),
("5126518", "Medford", "Медфорд", "US", "840", "NY", "103", "", "", "40.8176", "-73.00011", "America/New_York"),
("5126555", "Melville", "", "US", "840", "NY", "103", "", "", "40.79343", "-73.41512", "America/New_York"),
("5126630", "Merrick", "Меррик", "US", "840", "NY", "059", "", "", "40.66288", "-73.55152", "America/New_York"),
("5126842", "Middletown", "", "US", "840", "NY", "071", "", "", "41.44593", "-74.42293", "America/New_York"),
("5127134", "Mineola", "", "US", "840", "NY", "059", "", "", "40.74927", "-73.64068", "America/New_York"),
("5127315", "Monsey", "", "US", "840", "NY", "087", "", "", "41.11121", "-74.06848", "America/New_York"),
("5127835", "Mount Vernon", "Маунт-Вернон", "US", "840", "NY", "119", "", "", "40.9126", "-73.83708", "America/New_York"),
("5128266", "Nanuet", "", "US", "840", "NY", "087", "", "", "41.08871", "-74.01347", "America/New_York"),
("5128481", "New City", "", "US", "840", "NY", "087", "", "", "41.1476", "-73.98931", "America/New_York"),
("5128549", "New Rochelle", "Нью-Рошель", "US", "840", "NY", "119", "", "", "40.91149", "-73.78235", "America/New_York"),
("5128581", "New York City", "Нью-Йорк", "US", "840", "NY", "", "", "", "40.71427", "-74.00597", "America/New_York"),
("5128654", "Newburgh", "Ньюберг", "US", "840", "NY", "071", "", "", "41.50343", "-74.01042", "America/New_York"),
("5128723", "Niagara Falls", "Ниагара-Фолс", "US", "840", "NY", "063", "", "", "43.0945", "-79.05671", "America/New_York"),
("5128884", "North Amityville", "", "US", "840", "NY", "103", "", "", "40.6976", "-73.42512", "America/New_York"),
("5128886", "North Babylon", "", "US", "840", "NY", "103", "", "", "40.71649", "-73.32179", "America/New_York"),
("5128898", "North Bay Shore", "", "US", "840", "NY", "103", "", "", "40.73621", "-73.26262", "America/New_York"),
("5128904", "North Bellmore", "", "US", "840", "NY", "059", "", "", "40.69149", "-73.53346", "America/New_York"),
("5129134", "North Massapequa", "", "US", "840", "NY", "059", "", "", "40.70093", "-73.46207", "America/New_York"),
("5129245", "North Tonawanda", "", "US", "840", "NY", "063", "", "", "43.03867", "-78.8642", "America/New_York"),
("5129248", "North Valley Stream", "", "US", "840", "NY", "059", "", "", "40.6851", "-73.7018", "America/New_York"),
("5129603", "Oceanside", "", "US", "840", "NY", "059", "", "", "40.63871", "-73.64013", "America/New_York"),
("5130045", "Ossining", "", "US", "840", "NY", "119", "", "", "41.16287", "-73.86152", "America/New_York"),
("5130081", "Oswego", "Осуиго", "US", "840", "NY", "075", "", "", "43.45535", "-76.5105", "America/New_York"),
("5130780", "Pearl River", "", "US", "840", "NY", "087", "", "", "41.05899", "-74.02181", "America/New_York"),
("5130831", "Peekskill", "", "US", "840", "NY", "119", "", "", "41.29009", "-73.92042", "America/New_York"),
("5131638", "Plainview", "", "US", "840", "NY", "059", "", "", "40.77649", "-73.46735", "America/New_York"),
("5131692", "Plattsburgh", "Платтсбург", "US", "840", "NY", "019", "", "", "44.69949", "-73.45291", "America/New_York"),
("5132002", "Port Chester", "", "US", "840", "NY", "119", "", "", "41.00176", "-73.66568", "America/New_York"),
("5132029", "Port Washington", "", "US", "840", "NY", "059", "", "", "40.82566", "-73.69819", "America/New_York"),
("5132143", "Poughkeepsie", "", "US", "840", "NY", "027", "", "", "41.70037", "-73.92097", "America/New_York"),
("5133273", "Borough of Queens", "", "US", "840", "NY", "081", "", "", "40.68149", "-73.83652", "America/New_York"),
("5134086", "Rochester", "Рочестер", "US", "840", "NY", "055", "", "", "43.15478", "-77.61556", "America/New_York"),
("5134203", "Rockville Centre", "", "US", "840", "NY", "059", "", "", "40.65871", "-73.64124", "America/New_York"),
("5134295", "Rome", "Рим", "US", "840", "NY", "065", "", "", "43.21285", "-75.45573", "America/New_York"),
("5134316", "Ronkonkoma", "", "US", "840", "NY", "103", "", "", "40.81538", "-73.11233", "America/New_York"),
("5134323", "Roosevelt", "", "US", "840", "NY", "059", "", "", "40.67871", "-73.58902", "America/New_York"),
("5134453", "Rotterdam", "", "US", "840", "NY", "093", "", "", "42.78702", "-73.97096", "America/New_York"),
("5134693", "Rye", "", "US", "840", "NY", "119", "", "", "40.98065", "-73.68374", "America/New_York"),
("5136334", "Saratoga Springs", "Саратога-Спрингс", "US", "840", "NY", "091", "", "", "43.08313", "-73.78457", "America/New_York"),
("5136421", "Sayville", "", "US", "840", "NY", "103", "", "", "40.73593", "-73.08206", "America/New_York"),
("5136433", "Scarsdale", "", "US", "840", "NY", "119", "", "", "41.0051", "-73.78458", "America/New_York"),
("5136454", "Schenectady", "Скенектади", "US", "840", "NY", "093", "", "", "42.81424", "-73.93957", "America/New_York"),
("5137507", "Seaford", "", "US", "840", "NY", "059", "", "", "40.66593", "-73.48818", "America/New_York"),
("5137600", "Selden", "Селден", "US", "840", "NY", "103", "", "", "40.86649", "-73.03566", "America/New_York"),
("5138022", "Shirley", "Ширли", "US", "840", "NY", "103", "", "", "40.80149", "-72.8676", "America/New_York"),
("5138539", "Smithtown", "", "US", "840", "NY", "103", "", "", "40.85593", "-73.20067", "America/New_York"),
("5139301", "Spring Valley", "Спринг-Вэлли", "US", "840", "NY", "087", "", "", "41.11315", "-74.04375", "America/New_York"),
("5139568", "Staten Island", "", "US", "840", "NY", "085", "", "", "40.56233", "-74.13986", "America/New_York"),
("5140402", "Syosset", "", "US", "840", "NY", "059", "", "", "40.82621", "-73.50207", "America/New_York"),
("5140405", "Syracuse", "Сиракьюс", "US", "840", "NY", "067", "", "", "43.04812", "-76.14742", "America/New_York"),
("5141175", "Tonawanda", "", "US", "840", "NY", "029", "", "", "43.02033", "-78.88032", "America/New_York"),
("5141502", "Troy", "Троя", "US", "840", "NY", "083", "", "", "42.72841", "-73.69179", "America/New_York"),
("5141927", "Uniondale", "", "US", "840", "NY", "059", "", "", "40.70038", "-73.59291", "America/New_York"),
("5142056", "Utica", "", "US", "840", "NY", "065", "", "", "43.1009", "-75.23266", "America/New_York"),
("5142109", "Valley Stream", "", "US", "840", "NY", "059", "", "", "40.66427", "-73.70846", "America/New_York"),
("5143198", "Wantagh", "", "US", "840", "NY", "059", "", "", "40.68371", "-73.51013", "America/New_York"),
("5143396", "Watertown", "", "US", "840", "NY", "045", "", "", "43.97478", "-75.91076", "America/New_York"),
("5143620", "West Albany", "", "US", "840", "NY", "001", "", "", "42.68313", "-73.77845", "America/New_York"),
("5143630", "West Babylon", "", "US", "840", "NY", "103", "", "", "40.71816", "-73.35429", "America/New_York"),
("5143832", "West Hempstead", "", "US", "840", "NY", "059", "", "", "40.70482", "-73.65013", "America/New_York"),
("5143866", "West Islip", "", "US", "840", "NY", "103", "", "", "40.70621", "-73.30623", "America/New_York"),
("5143992", "West Seneca", "", "US", "840", "NY", "029", "", "", "42.85006", "-78.79975", "America/New_York"),
("5144040", "Westbury", "", "US", "840", "NY", "059", "", "", "40.75566", "-73.58763", "America/New_York"),
("5144336", "White Plains", "Уайт-Плейнс", "US", "840", "NY", "119", "", "", "41.03399", "-73.76291", "America/New_York"),
("5145028", "Woodmere", "", "US", "840", "NY", "059", "", "", "40.63205", "-73.71263", "America/New_York"),
("5145215", "Yonkers", "Йонкерс", "US", "840", "NY", "119", "", "", "40.93121", "-73.89875", "America/New_York"),
("5145476", "Akron", "Акрон", "US", "840", "OH", "153", "", "", "41.08144", "-81.51901", "America/New_York"),
("5145607", "Alliance", "Альянс", "US", "840", "OH", "151", "", "", "40.91534", "-81.10593", "America/New_York"),
("5146055", "Ashland", "Ашленд", "US", "840", "OH", "005", "", "", "40.86867", "-82.31822", "America/New_York"),
("5146089", "Ashtabula", "", "US", "840", "OH", "007", "", "", "41.86505", "-80.78981", "America/New_York"),
("5146233", "Aurora", "Аврора", "US", "840", "OH", "133", "", "", "41.31755", "-81.34539", "America/New_York"),
("5146256", "Austintown", "", "US", "840", "OH", "099", "", "", "41.10172", "-80.76452", "America/New_York"),
("5146277", "Avon", "", "US", "840", "OH", "093", "", "", "41.45171", "-82.03542", "America/New_York"),
("5146282", "Avon Center", "", "US", "840", "OH", "093", "", "", "41.45976", "-82.01959", "America/New_York"),
("5146286", "Avon Lake", "", "US", "840", "OH", "093", "", "", "41.50532", "-82.0282", "America/New_York"),
("5146491", "Barberton", "", "US", "840", "OH", "153", "", "", "41.01283", "-81.60512", "America/New_York"),
("5146675", "Bay Village", "", "US", "840", "OH", "035", "", "", "41.48477", "-81.92208", "America/New_York"),
("5147097", "Berea", "Береа", "US", "840", "OH", "035", "", "", "41.36616", "-81.8543", "America/New_York"),
("5147784", "Boardman", "Бордман", "US", "840", "OH", "099", "", "", "41.02423", "-80.66285", "America/New_York"),
("5147968", "Bowling Green", "Боулинг-Грин", "US", "840", "OH", "173", "", "", "41.37477", "-83.65132", "America/New_York"),
("5148273", "Broadview Heights", "", "US", "840", "OH", "035", "", "", "41.31394", "-81.68513", "America/New_York"),
("5148326", "Brook Park", "", "US", "840", "OH", "035", "", "", "41.39838", "-81.80458", "America/New_York"),
("5148480", "Brunswick", "Брауншвейг", "US", "840", "OH", "103", "", "", "41.23811", "-81.8418", "America/New_York"),
("5149222", "Canton", "", "US", "840", "OH", "151", "", "", "40.79895", "-81.37845", "America/New_York"),
("5150529", "Cleveland", "Кливленд", "US", "840", "OH", "035", "", "", "41.4995", "-81.69541", "America/New_York"),
("5151613", "Cuyahoga Falls", "Каяхога-Фолс", "US", "840", "OH", "153", "", "", "41.13394", "-81.48456", "America/New_York"),
("5151861", "Defiance", "", "US", "840", "OH", "039", "", "", "41.28449", "-84.35578", "America/New_York"),
("5151891", "Delaware", "Делаварский", "US", "840", "OH", "041", "", "", "40.29867", "-83.06796", "America/New_York"),
("5152333", "Dublin", "Дублин", "US", "840", "OH", "049", "", "", "40.09923", "-83.11408", "America/New_York"),
("5152599", "East Cleveland", "", "US", "840", "OH", "035", "", "", "41.53311", "-81.57901", "America/New_York"),
("5152833", "Eastlake", "", "US", "840", "OH", "085", "", "", "41.65394", "-81.45039", "America/New_York"),
("5153207", "Elyria", "Элирия", "US", "840", "OH", "093", "", "", "41.36838", "-82.10765", "America/New_York"),
("5153420", "Euclid", "Евклид", "US", "840", "OH", "035", "", "", "41.5931", "-81.52679", "America/New_York"),
("5153680", "Fairview Park", "", "US", "840", "OH", "035", "", "", "41.44144", "-81.8643", "America/New_York"),
("5153924", "Findlay", "Финдли", "US", "840", "OH", "063", "", "", "41.04422", "-83.64993", "America/New_York"),
("5155207", "Fremont", "Фримонт", "US", "840", "OH", "143", "", "", "41.35033", "-83.12186", "America/New_York"),
("5155393", "Gahanna", "", "US", "840", "OH", "049", "", "", "40.01923", "-82.87934", "America/New_York"),
("5155499", "Garfield Heights", "", "US", "840", "OH", "035", "", "", "41.417", "-81.60596", "America/New_York"),
("5156371", "Green", "", "US", "840", "OH", "153", "", "", "40.94589", "-81.48317", "America/New_York"),
("5157588", "Hilliard", "", "US", "840", "OH", "049", "", "", "40.0334", "-83.15825", "America/New_York"),
("5158164", "Hudson", "Гудзон", "US", "840", "OH", "153", "", "", "41.24006", "-81.44067", "America/New_York"),
("5159537", "Kent", "Кент", "US", "840", "OH", "133", "", "", "41.15367", "-81.35789", "America/New_York"),
("5160315", "Lakewood", "Лейквуд", "US", "840", "OH", "035", "", "", "41.48199", "-81.79819", "America/New_York"),
("5160783", "Lima", "Лима", "US", "840", "OH", "003", "", "", "40.74255", "-84.10523", "America/New_York"),
("5161262", "Lorain", "Лорейн", "US", "840", "OH", "093", "", "", "41.45282", "-82.18237", "America/New_York"),
("5161723", "Mansfield", "Мэнсфилд", "US", "840", "OH", "139", "", "", "40.75839", "-82.51545", "America/New_York"),
("5161803", "Maple Heights", "", "US", "840", "OH", "035", "", "", "41.41533", "-81.56596", "America/New_York"),
("5161902", "Marion", "Мэрион", "US", "840", "OH", "101", "", "", "40.58867", "-83.12852", "America/New_York"),
("5162077", "Marysville", "", "US", "840", "OH", "159", "", "", "40.23645", "-83.36714", "America/New_York"),
("5162097", "Massillon", "", "US", "840", "OH", "151", "", "", "40.79672", "-81.52151", "America/New_York"),
("5162188", "Mayfield Heights", "", "US", "840", "OH", "035", "", "", "41.51922", "-81.4579", "America/New_York"),
("5162512", "Medina", "Медина", "US", "840", "OH", "103", "", "", "41.13839", "-81.86375", "America/New_York"),
("5162645", "Mentor", "Ментор", "US", "840", "OH", "085", "", "", "41.66616", "-81.33955", "America/New_York"),
("5162851", "Middleburg Heights", "", "US", "840", "OH", "035", "", "", "41.36144", "-81.81291", "America/New_York"),
("5163799", "Mount Vernon", "", "US", "840", "OH", "083", "", "", "40.3934", "-82.48572", "America/New_York"),
("5164390", "New Philadelphia", "", "US", "840", "OH", "157", "", "", "40.48979", "-81.44567", "America/New_York"),
("5164466", "Newark", "Ньюарк", "US", "840", "OH", "089", "", "", "40.05812", "-82.40126", "America/New_York"),
("5164582", "Niles", "", "US", "840", "OH", "155", "", "", "41.18284", "-80.76536", "America/New_York"),
("5164706", "North Canton", "", "US", "840", "OH", "151", "", "", "40.87589", "-81.40234", "America/New_York"),
("5164862", "North Olmsted", "", "US", "840", "OH", "035", "", "", "41.4156", "-81.92347", "America/New_York"),
("5164903", "North Ridgeville", "", "US", "840", "OH", "093", "", "", "41.38949", "-82.01903", "America/New_York"),
("5164916", "North Royalton", "", "US", "840", "OH", "035", "", "", "41.31366", "-81.72457", "America/New_York"),
("5165101", "Norwalk", "", "US", "840", "OH", "077", "", "", "41.24255", "-82.61573", "America/New_York"),
("5165734", "Oregon", "Орегон", "US", "840", "OH", "095", "", "", "41.64366", "-83.48688", "America/New_York"),
("5166009", "Painesville", "", "US", "840", "OH", "085", "", "", "41.72449", "-81.24566", "America/New_York"),
("5166177", "Parma", "Парма", "US", "840", "OH", "035", "", "", "41.40477", "-81.72291", "America/New_York"),
("5166184", "Parma Heights", "", "US", "840", "OH", "035", "", "", "41.39005", "-81.75958", "America/New_York"),
("5166516", "Perrysburg", "", "US", "840", "OH", "173", "", "", "41.557", "-83.62716", "America/New_York"),
("5166819", "Piqua", "", "US", "840", "OH", "109", "", "", "40.14477", "-84.24244", "America/New_York"),
("5168491", "Rocky River", "", "US", "840", "OH", "035", "", "", "41.4756", "-81.8393", "America/New_York"),
("5170691", "Sandusky", "", "US", "840", "OH", "043", "", "", "41.44894", "-82.70796", "America/New_York"),
("5171728", "Shaker Heights", "", "US", "840", "OH", "035", "", "", "41.47394", "-81.53707", "America/New_York"),
("5172078", "Sidney", "Сидней", "US", "840", "OH", "149", "", "", "40.28422", "-84.1555", "America/New_York"),
("5172387", "Solon", "Солон", "US", "840", "OH", "035", "", "", "41.38978", "-81.44123", "America/New_York"),
("5172485", "South Euclid", "", "US", "840", "OH", "035", "", "", "41.52311", "-81.51846", "America/New_York"),
("5173048", "Steubenville", "", "US", "840", "OH", "081", "", "", "40.36979", "-80.63396", "America/New_York"),
("5173171", "Stow", "Стоу", "US", "840", "OH", "153", "", "", "41.1595", "-81.44039", "America/New_York"),
("5173210", "Streetsboro", "", "US", "840", "OH", "133", "", "", "41.23922", "-81.34594", "America/New_York"),
("5173237", "Strongsville", "", "US", "840", "OH", "035", "", "", "41.3145", "-81.83569", "America/New_York"),
("5173572", "Sylvania", "", "US", "840", "OH", "095", "", "", "41.71894", "-83.71299", "America/New_York"),
("5173623", "Tallmadge", "", "US", "840", "OH", "153", "", "", "41.10145", "-81.44178", "America/New_York"),
("5173930", "Tiffin", "", "US", "840", "OH", "147", "", "", "41.1145", "-83.17797", "America/New_York"),
("5174035", "Toledo", "Толедо", "US", "840", "OH", "095", "", "", "41.66394", "-83.55521", "America/New_York"),
("5174358", "Troy", "Троя", "US", "840", "OH", "109", "", "", "40.0395", "-84.20328", "America/New_York"),
("5174550", "Twinsburg", "", "US", "840", "OH", "153", "", "", "41.31256", "-81.44011", "America/New_York"),
("5175496", "Wadsworth", "", "US", "840", "OH", "103", "", "", "41.02561", "-81.72985", "America/New_York"),
("5175865", "Warren", "Уоррен", "US", "840", "OH", "155", "", "", "41.23756", "-80.81842", "America/New_York"),
("5176472", "Westerville", "", "US", "840", "OH", "049", "", "", "40.12617", "-82.92907", "America/New_York"),
("5176517", "Westlake", "", "US", "840", "OH", "035", "", "", "41.45532", "-81.91792", "America/New_York"),
("5176937", "Willoughby", "Уиллоуби", "US", "840", "OH", "085", "", "", "41.63977", "-81.4065", "America/New_York"),
("5177358", "Wooster", "Вустер", "US", "840", "OH", "169", "", "", "40.80506", "-81.93514", "America/New_York"),
("5177568", "Youngstown", "Янгстаун", "US", "840", "OH", "099", "", "", "41.09978", "-80.64952", "America/New_York"),
("5178127", "Allentown", "Аллентаун", "US", "840", "PA", "077", "", "", "40.60843", "-75.49018", "America/New_York"),
("5178165", "Allison Park", "", "US", "840", "PA", "003", "", "", "40.55951", "-79.95867", "America/New_York"),
("5178195", "Altoona", "Алтуна", "US", "840", "PA", "013", "", "", "40.51868", "-78.39474", "America/New_York"),
("5178800", "Back Mountain", "", "US", "840", "PA", "079", "", "", "41.33591", "-75.99631", "America/New_York"),
("5178940", "Baldwin", "", "US", "840", "PA", "003", "", "", "40.33813", "-79.97894", "America/New_York"),
("5180199", "Bethel Park", "", "US", "840", "PA", "003", "", "", "40.32757", "-80.0395", "America/New_York"),
("5180225", "Bethlehem", "Вифлеем", "US", "840", "PA", "095", "", "", "40.62593", "-75.37046", "America/New_York"),
("5183234", "Carlisle", "", "US", "840", "PA", "041", "", "", "40.20148", "-77.18887", "America/New_York"),
("5188140", "Easton", "Истон", "US", "840", "PA", "095", "", "", "40.68843", "-75.22073", "America/New_York"),
("5188843", "Erie", "Эри", "US", "840", "PA", "049", "", "", "42.12922", "-80.08506", "America/New_York"),
("5192726", "Harrisburg", "Гаррисберг", "US", "840", "PA", "043", "", "", "40.2737", "-76.88442", "America/New_York"),
("5193011", "Hazleton", "", "US", "840", "PA", "079", "", "", "40.95842", "-75.97465", "America/New_York"),
("5193309", "Hermitage", "", "US", "840", "PA", "085", "", "", "41.23339", "-80.44868", "America/New_York"),
("5195561", "Johnstown", "Джонстаун", "US", "840", "PA", "021", "", "", "40.32674", "-78.92197", "America/New_York"),
("5196220", "King of Prussia", "", "US", "840", "PA", "091", "", "", "40.08927", "-75.39602", "America/New_York"),
("5197079", "Lancaster", "Ланкастер", "US", "840", "PA", "071", "", "", "40.03788", "-76.30551", "America/New_York"),
("5197159", "Lansdale", "", "US", "840", "PA", "091", "", "", "40.2415", "-75.28379", "America/New_York"),
("5197517", "Lebanon", "", "US", "840", "PA", "075", "", "", "40.34093", "-76.41135", "America/New_York"),
("5197796", "Levittown", "", "US", "840", "PA", "017", "", "", "40.15511", "-74.82877", "America/New_York"),
("5198034", "Limerick", "", "US", "840", "PA", "091", "", "", "40.23093", "-75.52212", "America/New_York"),
("5200499", "McKeesport", "", "US", "840", "PA", "003", "", "", "40.34785", "-79.86422", "America/New_York"),
("5201734", "Monroeville", "", "US", "840", "PA", "003", "", "", "40.42118", "-79.7881", "America/New_York"),
("5202215", "Mount Lebanon", "", "US", "840", "PA", "003", "", "", "40.35535", "-80.0495", "America/New_York"),
("5202534", "Mountain Top", "", "US", "840", "PA", "071", "", "", "40.10677", "-75.95272", "America/New_York"),
("5202765", "Murrysville", "", "US", "840", "PA", "129", "", "", "40.4284", "-79.69754", "America/New_York"),
("5203127", "New Castle", "", "US", "840", "PA", "073", "", "", "41.00367", "-80.34701", "America/New_York"),
("5203506", "Norristown", "", "US", "840", "PA", "091", "", "", "40.1215", "-75.3399", "America/New_York"),
("5205377", "Penn Hills", "", "US", "840", "PA", "003", "", "", "40.50118", "-79.83922", "America/New_York"),
("5205849", "Phoenixville", "Финиксвилл", "US", "840", "PA", "029", "", "", "40.13038", "-75.51491", "America/New_York"),
("5206379", "Pittsburgh", "Питтсбург", "US", "840", "PA", "003", "", "", "40.44062", "-79.99589", "America/New_York"),
("5206606", "Plum", "", "US", "840", "PA", "003", "", "", "40.50035", "-79.74949", "America/New_York"),
("5207069", "Pottstown", "", "US", "840", "PA", "091", "", "", "40.24537", "-75.64963", "America/New_York"),
("5207490", "Radnor", "", "US", "840", "PA", "045", "", "", "40.04622", "-75.35991", "America/New_York"),
("5207728", "Reading", "Рединг", "US", "840", "PA", "011", "", "", "40.33565", "-75.92687", "America/New_York"),
("5211303", "Scranton", "Скрантон", "US", "840", "PA", "069", "", "", "41.40897", "-75.66241", "America/New_York"),
("5213681", "State College", "", "US", "840", "PA", "027", "", "", "40.7934", "-77.86", "America/New_York"),
("5216895", "Upper Saint Clair", "", "US", "840", "PA", "003", "", "", "40.3359", "-80.08339", "America/New_York"),
("5218270", "Wayne", "", "US", "840", "PA", "045", "", "", "40.044", "-75.38769", "America/New_York"),
("5218802", "West Mifflin", "", "US", "840", "PA", "003", "", "", "40.3634", "-79.86644", "America/New_York"),
("5219287", "Whitehall Township", "", "US", "840", "PA", "077", "", "", "40.66676", "-75.49991", "America/New_York"),
("5219488", "Wilkes-Barre", "Уилкс-Барре", "US", "840", "PA", "079", "", "", "41.24591", "-75.88131", "America/New_York"),
("5219501", "Wilkinsburg", "", "US", "840", "PA", "003", "", "", "40.44174", "-79.88199", "America/New_York"),
("5219585", "Williamsport", "", "US", "840", "PA", "081", "", "", "41.24119", "-77.00108", "America/New_York"),
("5219619", "Willow Grove", "", "US", "840", "PA", "091", "", "", "40.144", "-75.11573", "America/New_York"),
("5220798", "Barrington", "", "US", "840", "RI", "001", "", "", "41.74066", "-71.30866", "America/New_York"),
("5221077", "Bristol", "", "US", "840", "RI", "001", "", "", "41.67705", "-71.26616", "America/New_York"),
("5221341", "Central Falls", "", "US", "840", "RI", "007", "", "", "41.89066", "-71.39228", "America/New_York"),
("5221637", "Coventry", "Ковентри", "US", "840", "RI", "003", "", "", "41.7001", "-71.68284", "America/New_York"),
("5221659", "Cranston", "Крэнстон", "US", "840", "RI", "007", "5221674", "", "41.77982", "-71.43728", "America/New_York"),
("5221703", "Cumberland", "Камберленд", "US", "840", "RI", "007", "", "", "41.96677", "-71.43284", "America/New_York"),
("5221931", "East Providence", "", "US", "840", "RI", "007", "", "", "41.81371", "-71.37005", "America/New_York"),
("5223358", "Middletown", "", "US", "840", "RI", "005", "", "", "41.54566", "-71.29144", "America/New_York"),
("5223593", "Newport", "Ньюпорт", "US", "840", "RI", "005", "", "", "41.4901", "-71.31283", "America/New_York"),
("5223672", "North Kingstown", "Норт-Кингстаун", "US", "840", "RI", "009", "", "", "41.5501", "-71.46617", "America/New_York"),
("5223681", "North Providence", "", "US", "840", "RI", "007", "5223683", "", "41.8501", "-71.46617", "America/New_York"),
("5223869", "Pawtucket", "Потакет", "US", "840", "RI", "007", "", "", "41.87871", "-71.38256", "America/New_York"),
("5224082", "Portsmouth", "Портсмут", "US", "840", "RI", "005", "", "", "41.60232", "-71.25033", "America/New_York"),
("5224151", "Providence", "Провиденс", "US", "840", "RI", "007", "", "", "41.82399", "-71.41283", "America/New_York"),
("5224949", "Smithfield", "", "US", "840", "RI", "007", "", "", "41.92204", "-71.54951", "America/New_York"),
("5225507", "Warwick", "Уорик", "US", "840", "RI", "003", "", "", "41.7001", "-71.41617", "America/New_York"),
("5225627", "West Warwick", "", "US", "840", "RI", "003", "", "", "41.69689", "-71.52194", "America/New_York"),
("5225631", "Westerly", "", "US", "840", "RI", "009", "", "", "41.3776", "-71.82729", "America/New_York"),
("5225809", "Woonsocket", "Вунсокет", "US", "840", "RI", "007", "", "", "42.00288", "-71.51478", "America/New_York"),
("5225857", "Aberdeen", "Абердин", "US", "840", "SD", "013", "", "", "45.4647", "-98.48648", "America/Chicago"),
("5226534", "Brookings", "Брукингз", "US", "840", "SD", "011", "", "", "44.31136", "-96.79839", "America/Chicago"),
("5229794", "Mitchell", "Митчелл", "US", "840", "SD", "035", "", "", "43.70943", "-98.0298", "America/Chicago"),
("5231851", "Sioux Falls", "Су-Фолс", "US", "840", "SD", "099", "", "", "43.54997", "-96.70033", "America/Chicago"),
("5232741", "Watertown", "Уотертаун", "US", "840", "SD", "029", "", "", "44.89941", "-97.11507", "America/Chicago"),
("5234372", "Burlington", "Берлингтон", "US", "840", "VT", "007", "", "", "44.47588", "-73.21207", "America/New_York"),
("5235024", "Colchester", "", "US", "840", "VT", "007", "", "", "44.54394", "-73.14791", "America/New_York"),
("5240509", "Rutland", "Ратленд", "US", "840", "VT", "021", "", "", "43.61062", "-72.97261", "America/New_York"),
("5241248", "South Burlington", "Саут-Берлингтон", "US", "840", "VT", "007", "", "", "44.46699", "-73.17096", "America/New_York"),
("5244080", "Appleton", "Аплтон", "US", "840", "WI", "087", "", "", "44.26193", "-88.41538", "America/Chicago"),
("5244267", "Ashwaubenon", "", "US", "840", "WI", "009", "", "", "44.48221", "-88.0701", "America/Chicago"),
("5245193", "Beaver Dam", "", "US", "840", "WI", "027", "", "", "43.45777", "-88.83733", "America/Chicago"),
("5245387", "Beloit", "", "US", "840", "WI", "105", "", "", "42.50835", "-89.03178", "America/Chicago"),
("5246835", "Brookfield", "", "US", "840", "WI", "133", "", "", "43.06057", "-88.10648", "America/Chicago"),
("5247415", "Caledonia", "Каледония", "US", "840", "WI", "101", "", "", "42.8078", "-87.92425", "America/Chicago"),
("5249871", "Cudahy", "", "US", "840", "WI", "079", "", "", "42.95974", "-87.86147", "America/Chicago"),
("5250201", "De Pere", "", "US", "840", "WI", "009", "", "", "44.44888", "-88.06038", "America/Chicago"),
("5251436", "Eau Claire", "О-Клэр", "US", "840", "WI", "035", "", "", "44.81135", "-91.49849", "America/Chicago"),
("5253219", "Fitchburg", "", "US", "840", "WI", "025", "", "", "42.96083", "-89.46984", "America/Chicago"),
("5253352", "Fond du Lac", "Фон-дю-Лак", "US", "840", "WI", "039", "", "", "43.775", "-88.43883", "America/Chicago"),
("5253710", "Franklin", "Франклин", "US", "840", "WI", "079", "", "", "42.88863", "-88.03842", "America/Chicago"),
("5254218", "Germantown", "", "US", "840", "WI", "131", "", "", "43.22862", "-88.11037", "America/Chicago"),
("5254962", "Green Bay", "Грин-Бей", "US", "840", "WI", "009", "", "", "44.51916", "-88.01983", "America/Chicago"),
("5255068", "Greenfield", "Гринфилд", "US", "840", "WI", "079", "", "", "42.9614", "-88.01259", "America/Chicago"),
("5257029", "Howard", "", "US", "840", "WI", "009", "", "", "44.5436", "-88.08816", "America/Chicago"),
("5257754", "Janesville", "Джейнсвилл", "US", "840", "WI", "105", "", "", "42.68279", "-89.01872", "America/Chicago"),
("5258296", "Kaukauna", "", "US", "840", "WI", "087", "", "", "44.27804", "-88.27205", "America/Chicago"),
("5258393", "Kenosha", "Кеноша", "US", "840", "WI", "059", "", "", "42.58474", "-87.82119", "America/Chicago"),
("5258957", "La Crosse", "Ла-Кросс", "US", "840", "WI", "063", "", "", "43.80136", "-91.23958", "America/Chicago"),
("5261457", "Madison", "Мадисон", "US", "840", "WI", "025", "", "", "43.07305", "-89.40123", "America/Chicago"),
("5261585", "Manitowoc", "", "US", "840", "WI", "071", "", "", "44.08861", "-87.65758", "America/Chicago"),
("5261969", "Marshfield", "", "US", "840", "WI", "141", "", "", "44.66885", "-90.1718", "America/Chicago"),
("5262596", "Menasha", "", "US", "840", "WI", "139", "", "", "44.20221", "-88.4465", "America/Chicago"),
("5262630", "Menomonee Falls", "", "US", "840", "WI", "133", "", "", "43.1789", "-88.11731", "America/Chicago"),
("5262634", "Menomonie", "", "US", "840", "WI", "033", "", "", "44.87552", "-91.91934", "America/Chicago"),
("5262649", "Mequon", "", "US", "840", "WI", "089", "", "", "43.2364", "-87.98453", "America/Chicago"),
("5262838", "Middleton", "", "US", "840", "WI", "025", "", "", "43.09722", "-89.50429", "America/Chicago"),
("5263045", "Milwaukee", "Милуоки", "US", "840", "WI", "079", "", "", "43.0389", "-87.90647", "America/Chicago"),
("5264049", "Muskego", "", "US", "840", "WI", "133", "", "", "42.90585", "-88.13898", "America/Chicago"),
("5264223", "Neenah", "", "US", "840", "WI", "139", "", "", "44.18582", "-88.46261", "America/Chicago"),
("5264381", "New Berlin", "", "US", "840", "WI", "133", "", "", "42.9764", "-88.10842", "America/Chicago"),
("5264870", "North La Crosse", "", "US", "840", "WI", "063", "", "", "43.84635", "-91.24819", "America/Chicago"),
("5265228", "Oak Creek", "", "US", "840", "WI", "079", "", "", "42.88585", "-87.86314", "America/Chicago"),
("5265499", "Oconomowoc", "", "US", "840", "WI", "133", "", "", "43.11167", "-88.49927", "America/Chicago"),
("5265702", "Onalaska", "", "US", "840", "WI", "063", "", "", "43.88441", "-91.23514", "America/Chicago"),
("5265838", "Oshkosh", "Ошкош", "US", "840", "WI", "139", "", "", "44.02471", "-88.54261", "America/Chicago"),
("5267403", "Pleasant Prairie", "", "US", "840", "WI", "059", "", "", "42.55308", "-87.93341", "America/Chicago"),
("5268249", "Racine", "Расин", "US", "840", "WI", "101", "", "", "42.72613", "-87.78285", "America/Chicago"),
("5272893", "Sheboygan", "Шебойган", "US", "840", "WI", "117", "", "", "43.75083", "-87.71453", "America/Chicago"),
("5273812", "South Milwaukee", "", "US", "840", "WI", "079", "", "", "42.91057", "-87.86064", "America/Chicago"),
("5274644", "Stevens Point", "", "US", "840", "WI", "097", "", "", "44.52358", "-89.57456", "America/Chicago"),
("5275020", "Sun Prairie", "", "US", "840", "WI", "025", "", "", "43.1836", "-89.21373", "America/Chicago"),
("5275191", "Superior", "Сьюпириор", "US", "840", "WI", "031", "", "", "46.72077", "-92.10408", "America/Chicago"),
("5278005", "Watertown", "", "US", "840", "WI", "055", "", "", "43.19472", "-88.72899", "America/Chicago"),
("5278052", "Waukesha", "Уокиша", "US", "840", "WI", "133", "", "", "43.01168", "-88.23148", "America/Chicago"),
("5278120", "Wausau", "", "US", "840", "WI", "073", "", "", "44.95914", "-89.63012", "America/Chicago"),
("5278159", "Wauwatosa", "", "US", "840", "WI", "079", "", "", "43.04946", "-88.00759", "America/Chicago"),
("5278420", "West Allis", "", "US", "840", "WI", "079", "", "", "43.01668", "-88.00703", "America/Chicago"),
("5278422", "West Bend", "", "US", "840", "WI", "131", "", "", "43.42528", "-88.18343", "America/Chicago"),
("5279436", "Wisconsin Rapids", "", "US", "840", "WI", "141", "", "", "44.38358", "-89.81735", "America/Chicago"),
("5280814", "Weirton", "Уиртон", "US", "840", "WV", "029", "", "", "40.41896", "-80.58952", "America/New_York"),
("5280822", "Weirton Heights", "", "US", "840", "WV", "029", "", "", "40.4084", "-80.53924", "America/New_York"),
("5280854", "Wheeling", "Уилинг", "US", "840", "WV", "069", "", "", "40.06396", "-80.72091", "America/New_York"),
("5281551", "Ansonia", "", "US", "840", "CT", "009", "", "", "41.34621", "-73.079", "America/New_York"),
("5282804", "Bridgeport", "Бриджпорт", "US", "840", "CT", "001", "", "", "41.16704", "-73.20483", "America/New_York"),
("5282835", "Bristol", "Бристол", "US", "840", "CT", "003", "", "", "41.67176", "-72.94927", "America/New_York"),
("5283054", "Branford", "", "US", "840", "CT", "009", "", "", "41.27954", "-72.8151", "America/New_York"),
("5283837", "Cheshire", "Чешир", "US", "840", "CT", "009", "", "", "41.49899", "-72.90066", "America/New_York"),
("5284756", "Fillmore", "", "US", "840", "CA", "111", "", "", "34.39916", "-118.91815", "America/Los_Angeles"),
("5287262", "Buckeye", "", "US", "840", "AZ", "013", "", "", "33.37032", "-112.58378", "America/Phoenix"),
("5287565", "Bullhead City", "", "US", "840", "AZ", "015", "", "", "35.14778", "-114.5683", "America/Phoenix"),
("5288636", "Casa Grande", "Каса-Гранде", "US", "840", "AZ", "021", "", "", "32.8795", "-111.75735", "America/Phoenix"),
("5288661", "Casas Adobes", "", "US", "840", "AZ", "019", "", "", "32.32341", "-110.9951", "America/Phoenix"),
("5288786", "Catalina Foothills", "", "US", "840", "AZ", "019", "", "", "32.29785", "-110.9187", "America/Phoenix"),
("5289282", "Chandler", "Чандлер", "US", "840", "AZ", "013", "", "", "33.30616", "-111.84125", "America/Phoenix"),
("5293083", "Douglas", "", "US", "840", "AZ", "003", "", "", "31.34455", "-109.54534", "America/Phoenix"),
("5293183", "Drexel Heights", "", "US", "840", "AZ", "019", "", "", "32.14119", "-111.02843", "America/Phoenix"),
("5293996", "El Mirage", "", "US", "840", "AZ", "013", "", "", "33.61309", "-112.3246", "America/Phoenix"),
("5294167", "Eloy", "", "US", "840", "AZ", "021", "", "", "32.7559", "-111.55484", "America/Phoenix"),
("5294810", "Flagstaff", "Флагстафф", "US", "840", "AZ", "005", "", "", "35.19807", "-111.65127", "America/Phoenix"),
("5294902", "Florence", "Флоренция", "US", "840", "AZ", "021", "", "", "33.03145", "-111.38734", "America/Phoenix"),
("5294937", "Flowing Wells", "", "US", "840", "AZ", "019", "", "", "32.29396", "-111.00982", "America/Phoenix"),
("5295143", "Fortuna Foothills", "", "US", "840", "AZ", "027", "", "", "32.65783", "-114.41189", "America/Phoenix"),
("5295177", "Fountain Hills", "", "US", "840", "AZ", "013", "", "", "33.61171", "-111.71736", "America/Phoenix"),
("5295903", "Gilbert", "Гилберт", "US", "840", "AZ", "013", "", "", "33.35283", "-111.78903", "America/Phoenix"),
("5295985", "Glendale", "Глендейл", "US", "840", "AZ", "013", "", "", "33.53865", "-112.18599", "America/Phoenix"),
("5296266", "Goodyear", "Гудиер", "US", "840", "AZ", "013", "", "", "33.43532", "-112.35821", "America/Phoenix"),
("5296802", "Green Valley", "", "US", "840", "AZ", "019", "", "", "31.85425", "-110.9937", "America/Phoenix"),
("5301067", "Kingman", "Кингмен", "US", "840", "AZ", "015", "", "", "35.18944", "-114.05301", "America/Phoenix"),
("5301388", "Lake Havasu City", "Лейк-Хавасу-Сити", "US", "840", "AZ", "015", "", "", "34.4839", "-114.32245", "America/Phoenix"),
("5303705", "Marana", "", "US", "840", "AZ", "019", "", "", "32.43674", "-111.22538", "America/Phoenix"),
("5303752", "Maricopa", "", "US", "840", "AZ", "021", "", "", "33.05811", "-112.04764", "America/Phoenix"),
("5304391", "Mesa", "Меса", "US", "840", "AZ", "013", "", "", "33.42227", "-111.82264", "America/Phoenix"),
("5306611", "Nogales", "Ногалес", "US", "840", "AZ", "023", "", "", "31.34038", "-110.93425", "America/Phoenix"),
("5307540", "Oro Valley", "", "US", "840", "AZ", "019", "", "", "32.39091", "-110.96649", "America/Phoenix"),
("5308305", "Payson", "", "US", "840", "AZ", "007", "", "", "34.23087", "-111.32514", "America/Phoenix"),
("5308480", "Peoria", "Пеория", "US", "840", "AZ", "013", "", "", "33.5806", "-112.23738", "America/Phoenix"),
("5308655", "Phoenix", "Финикс", "US", "840", "AZ", "013", "", "", "33.44838", "-112.07404", "America/Phoenix"),
("5309842", "Prescott", "Прескотт", "US", "840", "AZ", "025", "", "", "34.54002", "-112.4685", "America/Phoenix"),
("5309858", "Prescott Valley", "", "US", "840", "AZ", "025", "", "", "34.58941", "-112.32525", "America/Phoenix"),
("5310193", "Queen Creek", "", "US", "840", "AZ", "013", "", "", "33.24866", "-111.6343", "America/Phoenix"),
("5311433", "Rio Rico", "", "US", "840", "AZ", "023", "", "", "31.47148", "-110.97648", "America/Phoenix"),
("5312544", "Sahuarita", "", "US", "840", "AZ", "019", "", "", "31.95758", "-110.95565", "America/Phoenix"),
("5312913", "San Luis", "", "US", "840", "AZ", "027", "", "", "32.487", "-114.78218", "America/Phoenix"),
("5313457", "Scottsdale", "Скоттсдейл", "US", "840", "AZ", "013", "", "", "33.50921", "-111.89903", "America/Phoenix"),
("5314328", "Sierra Vista", "Сьерра-Виста", "US", "840", "AZ", "003", "", "", "31.55454", "-110.30369", "America/Phoenix"),
("5316201", "Sun City", "", "US", "840", "AZ", "013", "", "", "33.59754", "-112.27182", "America/Phoenix"),
("5316205", "Sun City West", "", "US", "840", "AZ", "013", "", "", "33.66198", "-112.34127", "America/Phoenix"),
("5316428", "Surprise", "Сюрприз", "US", "840", "AZ", "013", "", "", "33.63059", "-112.33322", "America/Phoenix"),
("5316890", "Tanque Verde", "", "US", "840", "AZ", "019", "", "", "32.25174", "-110.73731", "America/Phoenix"),
("5317058", "Tempe", "Темпе", "US", "840", "AZ", "013", "", "", "33.41477", "-111.90931", "America/Phoenix"),
("5317071", "Tempe Junction", "", "US", "840", "AZ", "013", "", "", "33.41421", "-111.94348", "America/Phoenix"),
("5318313", "Tucson", "Тусон", "US", "840", "AZ", "019", "", "", "32.22174", "-110.92648", "America/Phoenix"),
("5322053", "Yuma", "Юма", "US", "840", "AZ", "027", "", "", "32.72532", "-114.6244", "America/Phoenix"),
("5322400", "Adelanto", "", "US", "840", "CA", "071", "", "", "34.58277", "-117.40922", "America/Los_Angeles"),
("5322551", "Agoura", "", "US", "840", "CA", "037", "", "", "34.14306", "-118.73787", "America/Los_Angeles"),
("5322553", "Agoura Hills", "", "US", "840", "CA", "037", "", "", "34.13639", "-118.77453", "America/Los_Angeles"),
("5322737", "Alameda", "Аламеда", "US", "840", "CA", "001", "", "", "37.76521", "-122.24164", "America/Los_Angeles"),
("5322850", "Albany", "Олбани", "US", "840", "CA", "001", "", "", "37.88687", "-122.29775", "America/Los_Angeles"),
("5323060", "Alhambra", "Альгамбра", "US", "840", "CA", "037", "", "", "34.09529", "-118.12701", "America/Los_Angeles"),
("5323163", "Aliso Viejo", "", "US", "840", "CA", "059", "", "", "33.56504", "-117.72712", "America/Los_Angeles"),
("5323525", "Altadena", "Альтадена", "US", "840", "CA", "037", "", "", "34.18973", "-118.13118", "America/Los_Angeles"),
("5323566", "Alum Rock", "", "US", "840", "CA", "085", "", "", "37.36605", "-121.82718", "America/Los_Angeles"),
("5323694", "American Canyon", "", "US", "840", "CA", "055", "", "", "38.17492", "-122.2608", "America/Los_Angeles"),
("5323810", "Anaheim", "Анахайм", "US", "840", "CA", "059", "", "", "33.83529", "-117.9145", "America/Los_Angeles"),
("5324105", "Antelope", "", "US", "840", "CA", "067", "", "", "38.70824", "-121.32995", "America/Los_Angeles"),
("5324200", "Antioch", "", "US", "840", "CA", "013", "", "", "38.00492", "-121.80579", "America/Los_Angeles"),
("5324363", "Apple Valley", "", "US", "840", "CA", "071", "", "", "34.50083", "-117.18588", "America/Los_Angeles"),
("5324477", "Arcadia", "Аркадия", "US", "840", "CA", "037", "", "", "34.13973", "-118.03534", "America/Los_Angeles"),
("5324802", "Arroyo Grande", "", "US", "840", "CA", "079", "", "", "35.11859", "-120.59073", "America/Los_Angeles"),
("5324862", "Artesia", "Артижа", "US", "840", "CA", "037", "", "", "33.86585", "-118.08312", "America/Los_Angeles"),
("5324903", "Arvin", "", "US", "840", "CA", "029", "", "", "35.20913", "-118.82843", "America/Los_Angeles"),
("5325011", "Ashland", "", "US", "840", "CA", "001", "", "", "37.69465", "-122.11385", "America/Los_Angeles"),
("5325111", "Atascadero", "", "US", "840", "CA", "079", "", "", "35.48942", "-120.67073", "America/Los_Angeles"),
("5325187", "Atwater", "", "US", "840", "CA", "047", "", "", "37.34772", "-120.60908", "America/Los_Angeles"),
("5325327", "Avenal", "", "US", "840", "CA", "031", "", "", "36.00412", "-120.12903", "America/Los_Angeles"),
("5325372", "Avocado Heights", "", "US", "840", "CA", "037", "", "", "34.03612", "-117.99118", "America/Los_Angeles"),
("5325423", "Azusa", "Азуса", "US", "840", "CA", "037", "", "", "34.13362", "-117.90756", "America/Los_Angeles"),
("5325738", "Bakersfield", "Бейкерсфилд", "US", "840", "CA", "029", "", "", "35.37329", "-119.01871", "America/Los_Angeles"),
("5325866", "Baldwin Park", "Болдуин-Парк", "US", "840", "CA", "037", "", "", "34.08529", "-117.9609", "America/Los_Angeles"),
("5326032", "Banning", "", "US", "840", "CA", "065", "", "", "33.92557", "-116.87641", "America/Los_Angeles"),
("5326297", "Barstow", "Барстоу", "US", "840", "CA", "071", "", "", "34.89859", "-117.02282", "America/Los_Angeles"),
("5326305", "Barstow Heights", "", "US", "840", "CA", "071", "", "", "34.86971", "-117.05615", "America/Los_Angeles"),
("5326561", "Bay Point", "", "US", "840", "CA", "013", "", "", "38.02909", "-121.96163", "America/Los_Angeles"),
("5327098", "Beaumont", "", "US", "840", "CA", "065", "", "", "33.92946", "-116.97725", "America/Los_Angeles"),
("5327298", "Bell", "Белла", "US", "840", "CA", "037", "", "", "33.97751", "-118.18702", "America/Los_Angeles"),
("5327319", "Bell Gardens", "", "US", "840", "CA", "037", "", "", "33.96529", "-118.15146", "America/Los_Angeles"),
("5327422", "Bellflower", "Беллфлауэр", "US", "840", "CA", "037", "", "", "33.88168", "-118.11701", "America/Los_Angeles"),
("5327455", "Belmont", "Белмонт", "US", "840", "CA", "081", "", "", "37.52021", "-122.2758", "America/Los_Angeles"),
("5327550", "Benicia", "", "US", "840", "CA", "095", "", "", "38.04936", "-122.15858", "America/Los_Angeles"),
("5327684", "Berkeley", "Беркли", "US", "840", "CA", "001", "", "", "37.87159", "-122.27275", "America/Los_Angeles"),
("5328041", "Beverly Hills", "", "US", "840", "CA", "037", "", "", "34.07362", "-118.40036", "America/Los_Angeles"),
("5329408", "Bloomington", "Блумингтон", "US", "840", "CA", "071", "", "", "34.07029", "-117.39588", "America/Los_Angeles"),
("5329649", "Blythe", "Блайт", "US", "840", "CA", "065", "", "", "33.6103", "-114.59635", "America/Los_Angeles"),
("5330167", "Bostonia", "", "US", "840", "CA", "073", "", "", "32.80755", "-116.93642", "America/Los_Angeles"),
("5330413", "Boyle Heights", "", "US", "840", "CA", "037", "", "", "34.0339", "-118.20535", "America/Los_Angeles"),
("5330567", "Brawley", "", "US", "840", "CA", "025", "", "", "32.97866", "-115.53027", "America/Los_Angeles"),
("5330582", "Brea", "", "US", "840", "CA", "059", "", "", "33.91668", "-117.90006", "America/Los_Angeles"),
("5330642", "Brentwood", "", "US", "840", "CA", "013", "", "", "37.92687", "-121.72577", "America/Los_Angeles"),
("5331575", "Buena Park", "", "US", "840", "CA", "059", "", "", "33.86751", "-117.99812", "America/Los_Angeles"),
("5331835", "Burbank", "Бербанк", "US", "840", "CA", "037", "", "", "34.18084", "-118.30897", "America/Los_Angeles"),
("5331920", "Burlingame", "Берлингем", "US", "840", "CA", "081", "", "", "37.5841", "-122.36608", "America/Los_Angeles"),
("5332593", "Calabasas", "Калабасас", "US", "840", "CA", "037", "", "", "34.15778", "-118.63842", "America/Los_Angeles"),
("5332698", "Calexico", "Калексико", "US", "840", "CA", "025", "", "", "32.67895", "-115.49888", "America/Los_Angeles"),
("5333180", "Camarillo", "", "US", "840", "CA", "111", "", "", "34.21639", "-119.0376", "America/Los_Angeles"),
("5333282", "Cameron Park", "", "US", "840", "CA", "017", "", "", "38.66879", "-120.98716", "America/Los_Angeles"),
("5333689", "Campbell", "Кэмпбелл", "US", "840", "CA", "085", "", "", "37.28717", "-121.94996", "America/Los_Angeles"),
("5333913", "Canoga Park", "", "US", "840", "CA", "037", "", "", "34.20112", "-118.59814", "America/Los_Angeles"),
("5334223", "Carlsbad", "Карлсбад", "US", "840", "CA", "073", "", "", "33.15809", "-117.35059", "America/Los_Angeles"),
("5334336", "Carmichael", "Кармайкл", "US", "840", "CA", "067", "", "", "38.61713", "-121.32828", "America/Los_Angeles"),
("5334519", "Carson", "Карсон", "US", "840", "CA", "037", "", "", "33.83141", "-118.28202", "America/Los_Angeles"),
("5334799", "Castaic", "", "US", "840", "CA", "037", "", "", "34.48888", "-118.62287", "America/Los_Angeles"),
("5334928", "Castro Valley", "", "US", "840", "CA", "001", "", "", "37.6941", "-122.08635", "America/Los_Angeles"),
("5335006", "Cathedral City", "", "US", "840", "CA", "065", "", "", "33.77974", "-116.46529", "America/Los_Angeles"),
("5335650", "Ceres", "Церера", "US", "840", "CA", "099", "", "", "37.59493", "-120.95771", "America/Los_Angeles"),
("5335663", "Cerritos", "Серритос", "US", "840", "CA", "037", "", "", "33.85835", "-118.06479", "America/Los_Angeles"),
("5336054", "Chatsworth", "", "US", "840", "CA", "037", "", "", "34.25723", "-118.6012", "America/Los_Angeles"),
("5336269", "Chico", "Чико", "US", "840", "CA", "007", "", "", "39.72849", "-121.83748", "America/Los_Angeles"),
("5336537", "Chino", "Чино", "US", "840", "CA", "071", "", "", "34.01223", "-117.68894", "America/Los_Angeles"),
("5336545", "Chino Hills", "", "US", "840", "CA", "071", "", "", "33.9938", "-117.75888", "America/Los_Angeles"),
("5336667", "Chowchilla", "", "US", "840", "CA", "039", "", "", "37.123", "-120.26018", "America/Los_Angeles"),
("5336899", "Chula Vista", "Чула-Виста", "US", "840", "CA", "073", "", "", "32.64005", "-117.0842", "America/Los_Angeles"),
("5337561", "Citrus Heights", "", "US", "840", "CA", "067", "", "", "38.70712", "-121.28106", "America/Los_Angeles"),
("5337696", "Claremont", "Клермонт", "US", "840", "CA", "037", "", "", "34.09668", "-117.71978", "America/Los_Angeles"),
("5337908", "Clearlake", "", "US", "840", "CA", "033", "", "", "38.95823", "-122.62637", "America/Los_Angeles"),
("5338122", "Clovis", "Кловис", "US", "840", "CA", "019", "", "", "36.82523", "-119.70292", "America/Los_Angeles"),
("5338166", "Coachella", "", "US", "840", "CA", "065", "", "", "33.6803", "-116.17389", "America/Los_Angeles"),
("5338783", "Colton", "Колтон", "US", "840", "CA", "071", "", "", "34.0739", "-117.31365", "America/Los_Angeles"),
("5339066", "Compton", "Комптон", "US", "840", "CA", "037", "", "", "33.89585", "-118.22007", "America/Los_Angeles"),
("5339111", "Concord", "Конкорд", "US", "840", "CA", "013", "", "", "37.97798", "-122.03107", "America/Los_Angeles"),
("5339539", "Corcoran", "Коркоран", "US", "840", "CA", "031", "", "", "36.09801", "-119.5604", "America/Los_Angeles"),
("5339631", "Corona", "", "US", "840", "CA", "065", "", "", "33.87529", "-117.56644", "America/Los_Angeles"),
("5339663", "Coronado", "Коронадо", "US", "840", "CA", "073", "", "", "32.68589", "-117.18309", "America/Los_Angeles"),
("5339840", "Costa Mesa", "Коста-Меса", "US", "840", "CA", "059", "", "", "33.64113", "-117.91867", "America/Los_Angeles"),
("5340175", "Covina", "Ковина", "US", "840", "CA", "037", "", "", "34.09001", "-117.89034", "America/Los_Angeles"),
("5341051", "Cudahy", "Кадахи", "US", "840", "CA", "037", "", "", "33.96057", "-118.18535", "America/Los_Angeles"),
("5341114", "Culver City", "Калвер-Сити", "US", "840", "CA", "037", "", "", "34.02112", "-118.39647", "America/Los_Angeles"),
("5341145", "Cupertino", "Купертино", "US", "840", "CA", "085", "", "", "37.323", "-122.03218", "America/Los_Angeles"),
("5341256", "Cypress", "", "US", "840", "CA", "059", "", "", "33.81696", "-118.03729", "America/Los_Angeles"),
("5341430", "Daly City", "", "US", "840", "CA", "081", "", "", "37.70577", "-122.46192", "America/Los_Angeles"),
("5341483", "Dana Point", "", "US", "840", "CA", "059", "", "", "33.46697", "-117.69811", "America/Los_Angeles"),
("5341531", "Danville", "", "US", "840", "CA", "013", "", "", "37.82159", "-121.99996", "America/Los_Angeles"),
("5341704", "Davis", "Дейвис", "US", "840", "CA", "113", "", "", "38.54491", "-121.74052", "America/Los_Angeles"),
("5342485", "Delano", "Делано", "US", "840", "CA", "029", "", "", "35.76884", "-119.24705", "America/Los_Angeles"),
("5342710", "Desert Hot Springs", "", "US", "840", "CA", "065", "", "", "33.96112", "-116.50168", "America/Los_Angeles"),
("5342992", "Diamond Bar", "Даймонд-Бар", "US", "840", "CA", "037", "", "", "34.02862", "-117.81034", "America/Los_Angeles"),
("5343171", "Dinuba", "", "US", "840", "CA", "107", "", "", "36.54328", "-119.38707", "America/Los_Angeles"),
("5343303", "Dixon", "", "US", "840", "CA", "095", "", "", "38.44546", "-121.8233", "America/Los_Angeles"),
("5343858", "Downey", "Дауни", "US", "840", "CA", "037", "", "", "33.94001", "-118.13257", "America/Los_Angeles"),
("5344147", "Duarte", "Дуарте", "US", "840", "CA", "037", "", "", "34.13945", "-117.97729", "America/Los_Angeles"),
("5344157", "Dublin", "Дублин", "US", "840", "CA", "001", "", "", "37.70215", "-121.93579", "America/Los_Angeles"),
("5344817", "East Rancho Dominguez", "", "US", "840", "CA", "037", "", "", "33.89807", "-118.19535", "America/Los_Angeles"),
("5344942", "East Hemet", "", "US", "840", "CA", "065", "", "", "33.74002", "-116.93891", "America/Los_Angeles"),
("5344994", "East Los Angeles", "", "US", "840", "CA", "037", "", "", "34.0239", "-118.17202", "America/Los_Angeles"),
("5345032", "East Palo Alto", "", "US", "840", "CA", "081", "", "", "37.46883", "-122.14108", "America/Los_Angeles"),
("5345529", "El Cajon", "", "US", "840", "CA", "073", "", "", "32.79477", "-116.96253", "America/Los_Angeles"),
("5345609", "El Centro", "Эль-Сентро", "US", "840", "CA", "025", "", "", "32.792", "-115.56305", "America/Los_Angeles"),
("5345623", "El Cerrito", "", "US", "840", "CA", "013", "", "", "37.91576", "-122.31164", "America/Los_Angeles"),
("5345679", "El Dorado Hills", "", "US", "840", "CA", "017", "", "", "38.68574", "-121.08217", "America/Los_Angeles"),
("5345743", "El Monte", "Эль-Монте", "US", "840", "CA", "037", "", "", "34.06862", "-118.02757", "America/Los_Angeles"),
("5345860", "El Segundo", "", "US", "840", "CA", "037", "", "", "33.91918", "-118.41647", "America/Los_Angeles"),
("5346111", "Elk Grove", "", "US", "840", "CA", "067", "", "", "38.4088", "-121.37162", "America/Los_Angeles"),
("5346646", "Encinitas", "Энсинитас", "US", "840", "CA", "073", "", "", "33.03699", "-117.29198", "America/Los_Angeles"),
("5346827", "Escondido", "", "US", "840", "CA", "073", "", "", "33.11921", "-117.08642", "America/Los_Angeles"),
("5347287", "Fair Oaks", "", "US", "840", "CA", "067", "", "", "38.64463", "-121.27217", "America/Los_Angeles"),
("5347335", "Fairfield", "", "US", "840", "CA", "095", "", "", "38.24936", "-122.03997", "America/Los_Angeles"),
("5347578", "Fallbrook", "", "US", "840", "CA", "073", "", "", "33.37642", "-117.25115", "America/Los_Angeles"),
("5349613", "Florin", "Флорин", "US", "840", "CA", "067", "", "", "38.49602", "-121.40884", "America/Los_Angeles"),
("5349705", "Folsom", "", "US", "840", "CA", "067", "", "", "38.67796", "-121.17606", "America/Los_Angeles"),
("5349755", "Fontana", "Фонтана", "US", "840", "CA", "071", "", "", "34.09223", "-117.43505", "America/Los_Angeles"),
("5349803", "Foothill Farms", "", "US", "840", "CA", "067", "", "", "38.67877", "-121.35114", "America/Los_Angeles"),
("5350159", "Foster City", "", "US", "840", "CA", "081", "", "", "37.55855", "-122.27108", "America/Los_Angeles"),
("5350207", "Fountain Valley", "", "US", "840", "CA", "059", "", "", "33.70918", "-117.95367", "America/Los_Angeles"),
("5350734", "Fremont", "Фримонт", "US", "840", "CA", "001", "", "", "37.54827", "-121.98857", "America/Los_Angeles"),
("5350937", "Fresno", "Фресно", "US", "840", "CA", "019", "", "", "36.74773", "-119.77237", "America/Los_Angeles"),
("5351247", "Fullerton", "Фуллертон", "US", "840", "CA", "059", "", "", "33.87029", "-117.92534", "America/Los_Angeles"),
("5351428", "Galt", "Галт", "US", "840", "CA", "067", "", "", "38.25464", "-121.29995", "America/Los_Angeles"),
("5351515", "Garden Grove", "", "US", "840", "CA", "059", "", "", "33.77391", "-117.94145", "America/Los_Angeles"),
("5351549", "Gardena", "Гардина", "US", "840", "CA", "037", "", "", "33.88835", "-118.30896", "America/Los_Angeles"),
("5352214", "Gilroy", "", "US", "840", "CA", "085", "", "", "37.00578", "-121.56828", "America/Los_Angeles"),
("5352350", "Glen Avon", "", "US", "840", "CA", "065", "", "", "34.01168", "-117.48477", "America/Los_Angeles"),
("5352423", "Glendale", "Глендейл", "US", "840", "CA", "037", "", "", "34.14251", "-118.25508", "America/Los_Angeles"),
("5352439", "Glendora", "Глендора", "US", "840", "CA", "037", "", "", "34.13612", "-117.86534", "America/Los_Angeles"),
("5352963", "Goleta", "Шхуна", "US", "840", "CA", "083", "", "", "34.43583", "-119.82764", "America/Los_Angeles"),
("5353530", "Granite Bay", "", "US", "840", "CA", "061", "", "", "38.76323", "-121.16384", "America/Los_Angeles"),
("5354172", "Greenfield", "Гринфилд", "US", "840", "CA", "053", "", "", "36.3208", "-121.24381", "America/Los_Angeles"),
("5354819", "Hacienda Heights", "", "US", "840", "CA", "037", "", "", "33.99307", "-117.96868", "America/Los_Angeles"),
("5355180", "Hanford", "Хэнфорд", "US", "840", "CA", "031", "", "", "36.32745", "-119.64568", "America/Los_Angeles"),
("5355828", "Hawthorne", "", "US", "840", "CA", "037", "", "", "33.9164", "-118.35257", "America/Los_Angeles"),
("5355933", "Hayward", "", "US", "840", "CA", "001", "", "", "37.66882", "-122.0808", "America/Los_Angeles"),
("5356277", "Hemet", "", "US", "840", "CA", "065", "", "", "33.74752", "-116.97197", "America/Los_Angeles"),
("5356451", "Hercules", "Геркулес", "US", "840", "CA", "013", "", "", "38.01714", "-122.28858", "America/Los_Angeles"),
("5356521", "Hermosa Beach", "", "US", "840", "CA", "037", "", "", "33.86224", "-118.39952", "America/Los_Angeles"),
("5356576", "Hesperia", "", "US", "840", "CA", "071", "", "", "34.42639", "-117.30088", "America/Los_Angeles"),
("5356868", "Highland", "", "US", "840", "CA", "071", "", "", "34.12834", "-117.20865", "America/Los_Angeles"),
("5357499", "Hollister", "", "US", "840", "CA", "069", "", "", "36.85245", "-121.4016", "America/Los_Angeles"),
("5357527", "Hollywood", "Голливуд", "US", "840", "CA", "037", "", "", "34.09834", "-118.32674", "America/Los_Angeles"),
("5358705", "Huntington Beach", "Хантингтон-Бич", "US", "840", "CA", "059", "", "", "33.6603", "-117.99923", "America/Los_Angeles"),
("5358736", "Huntington Park", "", "US", "840", "CA", "037", "", "", "33.98168", "-118.22507", "America/Los_Angeles"),
("5359054", "Imperial Beach", "", "US", "840", "CA", "073", "", "", "32.58394", "-117.11308", "America/Los_Angeles"),
("5359446", "Indio", "Индио", "US", "840", "CA", "065", "", "", "33.72058", "-116.21556", "America/Los_Angeles"),
("5359488", "Inglewood", "Инглвуд", "US", "840", "CA", "037", "", "", "33.96168", "-118.35313", "America/Los_Angeles"),
("5359777", "Irvine", "Ирвин", "US", "840", "CA", "059", "", "", "33.66946", "-117.82311", "America/Los_Angeles"),
("5359864", "Isla Vista", "", "US", "840", "CA", "083", "", "", "34.41333", "-119.86097", "America/Los_Angeles"),
("5363859", "La Canada Flintridge", "", "US", "840", "CA", "037", "", "", "34.19917", "-118.18785", "America/Los_Angeles"),
("5363922", "La Habra", "", "US", "840", "CA", "059", "", "", "33.93196", "-117.94617", "America/Los_Angeles"),
("5363943", "La Jolla", "Ла-Хойя", "US", "840", "CA", "073", "", "", "32.84727", "-117.2742", "America/Los_Angeles"),
("5363990", "La Mesa", "", "US", "840", "CA", "073", "", "", "32.76783", "-117.02308", "America/Los_Angeles"),
("5364007", "La Mirada", "", "US", "840", "CA", "037", "", "", "33.91724", "-118.01201", "America/Los_Angeles"),
("5364022", "La Palma", "", "US", "840", "CA", "059", "", "", "33.8464", "-118.04673", "America/Los_Angeles"),
("5364059", "La Presa", "", "US", "840", "CA", "073", "", "", "32.70811", "-116.99725", "America/Los_Angeles"),
("5364066", "La Puente", "", "US", "840", "CA", "037", "", "", "34.02001", "-117.94951", "America/Los_Angeles"),
("5364079", "La Quinta", "", "US", "840", "CA", "065", "", "", "33.66336", "-116.31001", "America/Los_Angeles"),
("5364134", "La Verne", "", "US", "840", "CA", "037", "", "", "34.10084", "-117.76784", "America/Los_Angeles"),
("5364199", "Ladera Ranch", "", "US", "840", "CA", "059", "", "", "33.57086", "-117.63561", "America/Los_Angeles"),
("5364226", "Lafayette", "Лафайет", "US", "840", "CA", "013", "", "", "37.88576", "-122.11802", "America/Los_Angeles"),
("5364271", "Laguna", "", "US", "840", "CA", "067", "", "", "38.42102", "-121.42384", "America/Los_Angeles"),
("5364275", "Laguna Beach", "Лагуна-Бич", "US", "840", "CA", "059", "", "", "33.54225", "-117.78311", "America/Los_Angeles"),
("5364306", "Laguna Hills", "", "US", "840", "CA", "059", "", "", "33.5956", "-117.70031", "America/Los_Angeles"),
("5364329", "Laguna Niguel", "", "US", "840", "CA", "059", "", "", "33.52253", "-117.70755", "America/Los_Angeles"),
("5364369", "Laguna Woods", "", "US", "840", "CA", "059", "", "", "33.6103", "-117.72533", "America/Los_Angeles"),
("5364499", "Lake Elsinore", "", "US", "840", "CA", "065", "", "", "33.66808", "-117.32726", "America/Los_Angeles"),
("5364514", "Lake Forest", "", "US", "840", "CA", "059", "", "", "33.64697", "-117.68922", "America/Los_Angeles"),
("5364782", "Lakeside", "", "US", "840", "CA", "073", "", "", "32.85727", "-116.92225", "America/Los_Angeles"),
("5364855", "Lakewood", "Лейквуд", "US", "840", "CA", "037", "", "", "33.85363", "-118.13396", "America/Los_Angeles"),
("5364916", "Lamont", "", "US", "840", "CA", "029", "", "", "35.25968", "-118.91427", "America/Los_Angeles"),
("5364940", "Lancaster", "Ланкастер", "US", "840", "CA", "037", "", "", "34.69804", "-118.13674", "America/Los_Angeles"),
("5365425", "Lathrop", "", "US", "840", "CA", "077", "", "", "37.8227", "-121.27661", "America/Los_Angeles"),
("5365603", "Lawndale", "", "US", "840", "CA", "037", "", "", "33.88724", "-118.35257", "America/Los_Angeles"),
("5365893", "Lemon Grove", "", "US", "840", "CA", "073", "", "", "32.74255", "-117.03142", "America/Los_Angeles"),
("5365918", "Lemoore", "", "US", "840", "CA", "031", "", "", "36.30078", "-119.78291", "America/Los_Angeles"),
("5365937", "Lennox", "Леннокс", "US", "840", "CA", "037", "", "", "33.93807", "-118.35258", "America/Los_Angeles"),
("5366375", "Lincoln", "Линколн", "US", "840", "CA", "061", "", "", "38.89156", "-121.29301", "America/Los_Angeles"),
("5366531", "Linda", "", "US", "840", "CA", "115", "", "", "39.12767", "-121.5508", "America/Los_Angeles"),
("5367314", "Live Oak", "", "US", "840", "CA", "087", "", "", "36.98356", "-121.98052", "America/Los_Angeles"),
("5367440", "Livermore", "Ливермор", "US", "840", "CA", "001", "", "", "37.68187", "-121.76801", "America/Los_Angeles"),
("5367565", "Lodi", "Лоди", "US", "840", "CA", "077", "", "", "38.1302", "-121.27245", "America/Los_Angeles"),
("5367696", "Loma Linda", "Лома-Линда", "US", "840", "CA", "071", "", "", "34.04835", "-117.26115", "America/Los_Angeles"),
("5367767", "Lomita", "", "US", "840", "CA", "037", "", "", "33.79224", "-118.31507", "America/Los_Angeles"),
("5367788", "Lompoc", "", "US", "840", "CA", "083", "", "", "34.63915", "-120.45794", "America/Los_Angeles"),
("5367929", "Long Beach", "Лонг-Бич", "US", "840", "CA", "037", "", "", "33.76696", "-118.18923", "America/Los_Angeles"),
("5368335", "Los Altos", "", "US", "840", "CA", "085", "", "", "37.38522", "-122.11413", "America/Los_Angeles"),
("5368361", "Los Angeles", "Лос-Анджелес", "US", "840", "CA", "037", "", "", "34.05223", "-118.24368", "America/Los_Angeles"),
("5368453", "Los Banos", "Лос-Баньос", "US", "840", "CA", "047", "", "", "37.05828", "-120.84992", "America/Los_Angeles"),
("5368518", "Los Gatos", "", "US", "840", "CA", "085", "", "", "37.22661", "-121.97468", "America/Los_Angeles"),
("5369367", "Lynwood", "Линвуд", "US", "840", "CA", "037", "", "", "33.93029", "-118.21146", "America/Los_Angeles"),
("5369568", "Madera", "Мадера", "US", "840", "CA", "039", "", "", "36.96134", "-120.06072", "America/Los_Angeles"),
("5370082", "Manhattan Beach", "", "US", "840", "CA", "037", "", "", "33.88474", "-118.41091", "America/Los_Angeles"),
("5370164", "Manteca", "", "US", "840", "CA", "077", "", "", "37.79743", "-121.21605", "America/Los_Angeles"),
("5370493", "Marina", "", "US", "840", "CA", "053", "", "", "36.6844", "-121.80217", "America/Los_Angeles"),
("5370868", "Martinez", "Мартинес", "US", "840", "CA", "013", "", "", "38.01937", "-122.13413", "America/Los_Angeles"),
("5371261", "Maywood", "", "US", "840", "CA", "037", "", "", "33.98668", "-118.18535", "America/Los_Angeles"),
("5371858", "Mead Valley", "", "US", "840", "CA", "065", "", "", "33.83335", "-117.29615", "America/Los_Angeles"),
("5372205", "Menifee", "", "US", "840", "CA", "065", "", "", "33.72835", "-117.14642", "America/Los_Angeles"),
("5372223", "Menlo Park", "Менло-Парк", "US", "840", "CA", "081", "", "", "37.45383", "-122.18219", "America/Los_Angeles"),
("5372253", "Merced", "Мерсед", "US", "840", "CA", "047", "", "", "37.30216", "-120.48297", "America/Los_Angeles"),
("5373129", "Millbrae", "", "US", "840", "CA", "081", "", "", "37.59855", "-122.38719", "America/Los_Angeles"),
("5373327", "Milpitas", "", "US", "840", "CA", "085", "", "", "37.42827", "-121.90662", "America/Los_Angeles"),
("5373492", "Mira Loma", "", "US", "840", "CA", "065", "", "", "33.99251", "-117.51644", "America/Los_Angeles"),
("5373763", "Mission Viejo", "Мишн-Вьехо", "US", "840", "CA", "059", "", "", "33.60002", "-117.672", "America/Los_Angeles"),
("5373900", "Modesto", "Модесто", "US", "840", "CA", "099", "", "", "37.6391", "-120.99688", "America/Los_Angeles"),
("5374175", "Monrovia", "Монровия", "US", "840", "CA", "037", "", "", "34.14806", "-117.99895", "America/Los_Angeles"),
("5374232", "Montclair", "", "US", "840", "CA", "071", "", "", "34.07751", "-117.68978", "America/Los_Angeles"),
("5374322", "Montebello", "Монтебелло", "US", "840", "CA", "037", "", "", "34.00946", "-118.10535", "America/Los_Angeles"),
("5374361", "Monterey", "Монтерей", "US", "840", "CA", "053", "", "", "36.60024", "-121.89468", "America/Los_Angeles"),
("5374406", "Monterey Park", "", "US", "840", "CA", "037", "", "", "34.06251", "-118.12285", "America/Los_Angeles"),
("5374648", "Moorpark", "Мурпарк", "US", "840", "CA", "111", "", "", "34.28556", "-118.88204", "America/Los_Angeles"),
("5374671", "Moraga", "", "US", "840", "CA", "013", "", "", "37.83493", "-122.12969", "America/Los_Angeles"),
("5374732", "Moreno Valley", "Морено-Валли", "US", "840", "CA", "065", "", "", "33.93752", "-117.23059", "America/Los_Angeles"),
("5374764", "Morgan Hill", "", "US", "840", "CA", "085", "", "", "37.1305", "-121.65439", "America/Los_Angeles"),
("5375480", "Mountain View", "Маунтин-Вью", "US", "840", "CA", "085", "", "", "37.38605", "-122.08385", "America/Los_Angeles"),
("5375911", "Murrieta", "", "US", "840", "CA", "065", "", "", "33.55391", "-117.21392", "America/Los_Angeles"),
("5376095", "Napa", "Напа", "US", "840", "CA", "055", "", "", "38.29714", "-122.28553", "America/Los_Angeles"),
("5376200", "National City", "", "US", "840", "CA", "073", "", "", "32.67811", "-117.0992", "America/Los_Angeles"),
("5376803", "Newark", "Ньюарк", "US", "840", "CA", "001", "", "", "37.52966", "-122.04024", "America/Los_Angeles"),
("5376890", "Newport Beach", "", "US", "840", "CA", "059", "", "", "33.61891", "-117.92895", "America/Los_Angeles"),
("5377100", "Nipomo", "", "US", "840", "CA", "079", "", "", "35.04275", "-120.476", "America/Los_Angeles"),
("5377199", "Norco", "", "US", "840", "CA", "065", "", "", "33.93113", "-117.54866", "America/Los_Angeles"),
("5377613", "North Glendale", "", "US", "840", "CA", "037", "", "", "34.16056", "-118.26452", "America/Los_Angeles"),
("5377640", "North Highlands", "", "US", "840", "CA", "067", "", "", "38.68574", "-121.37217", "America/Los_Angeles"),
("5377654", "North Hollywood", "", "US", "840", "CA", "037", "", "", "34.17223", "-118.37897", "America/Los_Angeles"),
("5377985", "Northridge", "", "US", "840", "CA", "037", "", "", "34.22834", "-118.53675", "America/Los_Angeles"),
("5377995", "Norwalk", "", "US", "840", "CA", "037", "", "", "33.90224", "-118.08173", "America/Los_Angeles"),
("5378044", "Novato", "Новато", "US", "840", "CA", "041", "", "", "38.10742", "-122.5697", "America/Los_Angeles"),
("5378500", "Oakdale", "", "US", "840", "CA", "099", "", "", "37.76659", "-120.84715", "America/Los_Angeles"),
("5378538", "Oakland", "Окленд", "US", "840", "CA", "001", "", "", "37.80437", "-122.2708", "America/Los_Angeles"),
("5378566", "Oakley", "", "US", "840", "CA", "013", "", "", "37.99742", "-121.71245", "America/Los_Angeles"),
("5378771", "Oceanside", "Оушенсайд", "US", "840", "CA", "073", "", "", "33.19587", "-117.37948", "America/Los_Angeles"),
("5378870", "Oildale", "", "US", "840", "CA", "029", "", "", "35.41968", "-119.01955", "America/Los_Angeles"),
("5379439", "Ontario", "Онтарио", "US", "840", "CA", "071", "", "", "34.06334", "-117.65089", "America/Los_Angeles"),
("5379513", "Orange", "", "US", "840", "CA", "059", "", "", "33.78779", "-117.85311", "America/Los_Angeles"),
("5379566", "Orangevale", "", "US", "840", "CA", "067", "", "", "38.67851", "-121.22578", "America/Los_Angeles"),
("5379609", "Orcutt", "", "US", "840", "CA", "083", "", "", "34.86526", "-120.436", "America/Los_Angeles"),
("5379678", "Orinda", "", "US", "840", "CA", "013", "", "", "37.87715", "-122.17969", "America/Los_Angeles"),
("5379759", "Oroville", "Оровилл", "US", "840", "CA", "007", "", "", "39.51378", "-121.55636", "America/Los_Angeles"),
("5380184", "Oxnard", "Окснард", "US", "840", "CA", "111", "", "", "34.1975", "-119.17705", "America/Los_Angeles"),
("5380202", "Oxnard Shores", "", "US", "840", "CA", "111", "", "", "34.19084", "-119.2415", "America/Los_Angeles"),
("5380420", "Pacifica", "", "US", "840", "CA", "081", "", "", "37.61383", "-122.48692", "America/Los_Angeles"),
("5380437", "Pacific Grove", "", "US", "840", "CA", "053", "", "", "36.61774", "-121.91662", "America/Los_Angeles"),
("5380626", "Palm Desert", "Палм-Дезерт", "US", "840", "CA", "065", "", "", "33.72224", "-116.37446", "America/Los_Angeles"),
("5380668", "Palm Springs", "Палм-Спрингс", "US", "840", "CA", "065", "", "", "33.8303", "-116.54529", "America/Los_Angeles"),
("5380698", "Palmdale", "Палмдейл", "US", "840", "CA", "037", "", "", "34.57943", "-118.11646", "America/Los_Angeles"),
("5380748", "Palo Alto", "Пало Альто", "US", "840", "CA", "085", "", "", "37.44188", "-122.14302", "America/Los_Angeles"),
("5381002", "Paradise", "", "US", "840", "CA", "007", "", "", "39.75961", "-121.62192", "America/Los_Angeles"),
("5381110", "Paramount", "", "US", "840", "CA", "037", "", "", "33.88946", "-118.15979", "America/Los_Angeles"),
("5381396", "Pasadena", "Пасадина", "US", "840", "CA", "037", "", "", "34.14778", "-118.14452", "America/Los_Angeles"),
("5381438", "Paso Robles", "", "US", "840", "CA", "079", "", "", "35.62664", "-120.691", "America/Los_Angeles"),
("5381515", "Patterson", "", "US", "840", "CA", "099", "", "", "37.4716", "-121.12966", "America/Los_Angeles"),
("5382146", "Perris", "", "US", "840", "CA", "065", "", "", "33.78252", "-117.22865", "America/Los_Angeles"),
("5382232", "Petaluma", "Петалума", "US", "840", "CA", "097", "", "", "38.23242", "-122.63665", "America/Los_Angeles"),
("5382496", "Pico Rivera", "", "US", "840", "CA", "037", "", "", "33.98307", "-118.09674", "America/Los_Angeles"),
("5383187", "Pinole", "", "US", "840", "CA", "013", "", "", "38.00437", "-122.29886", "America/Los_Angeles"),
("5383465", "Pittsburg", "", "US", "840", "CA", "013", "", "", "38.02798", "-121.88468", "America/Los_Angeles"),
("5383527", "Placentia", "", "US", "840", "CA", "059", "", "", "33.87224", "-117.87034", "America/Los_Angeles"),
("5383720", "Pleasant Hill", "", "US", "840", "CA", "013", "", "", "37.94798", "-122.0608", "America/Los_Angeles"),
("5383777", "Pleasanton", "Плезантон", "US", "840", "CA", "001", "", "", "37.66243", "-121.87468", "America/Los_Angeles"),
("5384170", "Pomona", "Помона", "US", "840", "CA", "037", "", "", "34.05529", "-117.75228", "America/Los_Angeles"),
("5384339", "Port Hueneme", "", "US", "840", "CA", "111", "", "", "34.14778", "-119.19511", "America/Los_Angeles"),
("5384471", "Porterville", "", "US", "840", "CA", "107", "", "", "36.06523", "-119.01677", "America/Los_Angeles"),
("5384690", "Poway", "", "US", "840", "CA", "073", "", "", "32.96282", "-117.03586", "America/Los_Angeles"),
("5385082", "Prunedale", "", "US", "840", "CA", "053", "", "", "36.77579", "-121.66967", "America/Los_Angeles"),
("5385793", "Ramona", "", "US", "840", "CA", "073", "", "", "33.04171", "-116.86808", "America/Los_Angeles"),
("5385941", "Rancho Cordova", "", "US", "840", "CA", "067", "", "", "38.58907", "-121.30273", "America/Los_Angeles"),
("5385955", "Rancho Cucamonga", "Ранчо-Кукамонга", "US", "840", "CA", "071", "", "", "34.1064", "-117.59311", "America/Los_Angeles"),
("5386015", "Rancho Mirage", "", "US", "840", "CA", "065", "", "", "33.73974", "-116.41279", "America/Los_Angeles"),
("5386035", "Rancho Palos Verdes", "", "US", "840", "CA", "037", "", "", "33.74446", "-118.38702", "America/Los_Angeles"),
("5386053", "Rancho San Diego", "", "US", "840", "CA", "073", "", "", "32.74727", "-116.9353", "America/Los_Angeles"),
("5386082", "Rancho Santa Margarita", "", "US", "840", "CA", "059", "", "", "33.64086", "-117.6031", "America/Los_Angeles"),
("5386754", "Redlands", "", "US", "840", "CA", "071", "", "", "34.05557", "-117.18254", "America/Los_Angeles"),
("5386785", "Redondo Beach", "Редондо-Бич", "US", "840", "CA", "037", "", "", "33.84918", "-118.38841", "America/Los_Angeles"),
("5386834", "Redwood City", "Редвуд Сити", "US", "840", "CA", "081", "", "", "37.48522", "-122.23635", "America/Los_Angeles"),
("5386984", "Reedley", "", "US", "840", "CA", "019", "", "", "36.59634", "-119.4504", "America/Los_Angeles"),
("5387288", "Rialto", "Риальто", "US", "840", "CA", "071", "", "", "34.1064", "-117.37032", "America/Los_Angeles"),
("5387428", "Richmond", "", "US", "840", "CA", "013", "", "", "37.93576", "-122.34775", "America/Los_Angeles"),
("5387494", "Ridgecrest", "", "US", "840", "CA", "029", "", "", "35.62246", "-117.6709", "America/Los_Angeles"),
("5387687", "Rio Linda", "", "US", "840", "CA", "067", "", "", "38.69101", "-121.44857", "America/Los_Angeles"),
("5387844", "Riverbank", "", "US", "840", "CA", "099", "", "", "37.73604", "-120.93549", "America/Los_Angeles"),
("5387877", "Riverside", "Риверсайд", "US", "840", "CA", "065", "", "", "33.95335", "-117.39616", "America/Los_Angeles"),
("5388319", "Rocklin", "", "US", "840", "CA", "061", "", "", "38.79073", "-121.23578", "America/Los_Angeles"),
("5388564", "Rohnert Park", "", "US", "840", "CA", "097", "", "", "38.33964", "-122.7011", "America/Los_Angeles"),
("5388735", "Rosamond", "", "US", "840", "CA", "029", "", "", "34.86414", "-118.16341", "America/Los_Angeles"),
("5388867", "Rosemead", "", "US", "840", "CA", "037", "", "", "34.08057", "-118.07285", "America/Los_Angeles"),
("5388873", "Rosemont", "Роземонт", "US", "840", "CA", "067", "", "", "38.55185", "-121.36467", "America/Los_Angeles"),
("5388881", "Roseville", "Розвелл", "US", "840", "CA", "061", "", "", "38.75212", "-121.28801", "America/Los_Angeles"),
("5389126", "Rowland Heights", "", "US", "840", "CA", "037", "", "", "33.97612", "-117.90534", "America/Los_Angeles"),
("5389213", "Rubidoux", "", "US", "840", "CA", "065", "", "", "33.99613", "-117.4056", "America/Los_Angeles"),
("5389489", "Sacramento", "Сакраменто", "US", "840", "CA", "067", "", "", "38.58157", "-121.4944", "America/Los_Angeles"),
("5391295", "Salinas", "Салинас", "US", "840", "CA", "053", "", "", "36.67774", "-121.6555", "America/Los_Angeles"),
("5391710", "San Bernardino", "Сан-Бернардино", "US", "840", "CA", "071", "", "", "34.10834", "-117.28977", "America/Los_Angeles"),
("5391749", "San Bruno", "", "US", "840", "CA", "081", "", "", "37.63049", "-122.41108", "America/Los_Angeles"),
("5391760", "San Carlos", "", "US", "840", "CA", "081", "", "", "37.50716", "-122.26052", "America/Los_Angeles"),
("5391791", "San Clemente", "", "US", "840", "CA", "059", "", "", "33.42697", "-117.61199", "America/Los_Angeles"),
("5391811", "San Diego", "Сан-Диего", "US", "840", "CA", "073", "", "", "32.71533", "-117.15726", "America/Los_Angeles"),
("5391891", "San Dimas", "", "US", "840", "CA", "037", "", "", "34.10668", "-117.80673", "America/Los_Angeles"),
("5391945", "San Fernando", "Сан-Фернандо", "US", "840", "CA", "037", "", "", "34.28195", "-118.43897", "America/Los_Angeles"),
("5391959", "San Francisco", "Сан-Франциско", "US", "840", "CA", "075", "", "", "37.77493", "-122.41942", "America/Los_Angeles"),
("5392034", "San Gabriel", "Сан-Гейбриел", "US", "840", "CA", "037", "", "", "34.09611", "-118.10583", "America/Los_Angeles"),
("5392090", "San Jacinto", "", "US", "840", "CA", "065", "", "", "33.78391", "-116.95864", "America/Los_Angeles"),
("5392171", "San Jose", "Сан-Хосе", "US", "840", "CA", "085", "", "", "37.33939", "-121.89496", "America/Los_Angeles"),
("5392229", "San Juan Capistrano", "Сан Хуан Капистрано", "US", "840", "CA", "059", "", "", "33.50169", "-117.66255", "America/Los_Angeles"),
("5392263", "San Leandro", "", "US", "840", "CA", "001", "", "", "37.72493", "-122.15608", "America/Los_Angeles"),
("5392281", "San Lorenzo", "", "US", "840", "CA", "001", "", "", "37.68104", "-122.12441", "America/Los_Angeles"),
("5392323", "San Luis Obispo", "Сан Луис Обиспо", "US", "840", "CA", "079", "", "", "35.28275", "-120.65962", "America/Los_Angeles"),
("5392368", "San Marcos", "Сан-Маркос", "US", "840", "CA", "073", "", "", "33.14337", "-117.16614", "America/Los_Angeles"),
("5392423", "San Mateo", "Сан-Матео", "US", "840", "CA", "081", "", "", "37.56299", "-122.32553", "America/Los_Angeles"),
("5392508", "San Pablo", "", "US", "840", "CA", "013", "", "", "37.96215", "-122.34553", "America/Los_Angeles"),
("5392528", "San Pedro", "", "US", "840", "CA", "037", "", "", "33.73585", "-118.29229", "America/Los_Angeles"),
("5392567", "San Rafael", "Сан-Рафел", "US", "840", "CA", "041", "", "", "37.97353", "-122.53109", "America/Los_Angeles"),
("5392593", "San Ramon", "Сан-Рамон", "US", "840", "CA", "013", "", "", "37.77993", "-121.97802", "America/Los_Angeles"),
("5392868", "Sanger", "", "US", "840", "CA", "019", "", "", "36.70801", "-119.55597", "America/Los_Angeles"),
("5392900", "Santa Ana", "Санта-Ана", "US", "840", "CA", "059", "", "", "33.74557", "-117.86783", "America/Los_Angeles"),
("5392952", "Santa Barbara", "Санта-Барбара", "US", "840", "CA", "083", "", "", "34.42083", "-119.69819", "America/Los_Angeles"),
("5393015", "Santa Clara", "Санта-Клара", "US", "840", "CA", "085", "", "", "37.35411", "-121.95524", "America/Los_Angeles"),
("5393049", "Santa Clarita", "Санта-Кларита", "US", "840", "CA", "037", "", "", "34.39166", "-118.54259", "America/Los_Angeles"),
("5393052", "Santa Cruz", "Санта-Крус", "US", "840", "CA", "087", "", "", "36.97412", "-122.0308", "America/Los_Angeles"),
("5393128", "Santa Fe Springs", "", "US", "840", "CA", "037", "", "", "33.94724", "-118.08535", "America/Los_Angeles"),
("5393180", "Santa Maria", "", "US", "840", "CA", "083", "", "", "34.95303", "-120.43572", "America/Los_Angeles"),
("5393212", "Santa Monica", "Санта-Моника", "US", "840", "CA", "037", "", "", "34.01945", "-118.49119", "America/Los_Angeles"),
("5393245", "Santa Paula", "Санта-Паула", "US", "840", "CA", "111", "", "", "34.35417", "-119.05927", "America/Los_Angeles"),
("5393287", "Santa Rosa", "Санта-Роза", "US", "840", "CA", "097", "", "", "38.44047", "-122.71443", "America/Los_Angeles"),
("5393429", "Santee", "Санти", "US", "840", "CA", "073", "", "", "32.83838", "-116.97392", "America/Los_Angeles"),
("5393485", "Saratoga", "", "US", "840", "CA", "085", "", "", "37.26383", "-122.02301", "America/Los_Angeles"),
("5394086", "Seal Beach", "", "US", "840", "CA", "059", "", "", "33.74141", "-118.10479", "America/Los_Angeles"),
("5394136", "Seaside", "Сисайд", "US", "840", "CA", "053", "", "", "36.61107", "-121.85162", "America/Los_Angeles"),
("5394329", "Selma", "Сельма", "US", "840", "CA", "019", "", "", "36.57078", "-119.61208", "America/Los_Angeles"),
("5394842", "Shafter", "", "US", "840", "CA", "029", "", "", "35.50051", "-119.27178", "America/Los_Angeles"),
("5395244", "Sherman Oaks", "", "US", "840", "CA", "037", "", "", "34.15112", "-118.44925", "America/Los_Angeles"),
("5396003", "Simi Valley", "", "US", "840", "CA", "111", "", "", "34.26945", "-118.78148", "America/Los_Angeles"),
("5397018", "Soledad", "Соледад", "US", "840", "CA", "053", "", "", "36.42469", "-121.32632", "America/Los_Angeles"),
("5397376", "South El Monte", "", "US", "840", "CA", "037", "", "", "34.05195", "-118.04673", "America/Los_Angeles"),
("5397603", "South Gate", "", "US", "840", "CA", "037", "", "", "33.95474", "-118.21202", "America/Los_Angeles"),
("5397664", "South Lake Tahoe", "", "US", "840", "CA", "017", "", "", "38.93324", "-119.98435", "America/Los_Angeles"),
("5397717", "South Pasadena", "", "US", "840", "CA", "037", "", "", "34.11612", "-118.15035", "America/Los_Angeles"),
("5397765", "South San Francisco", "", "US", "840", "CA", "081", "", "", "37.65466", "-122.40775", "America/Los_Angeles"),
("5397777", "South San Jose Hills", "", "US", "840", "CA", "037", "", "", "34.01279", "-117.90478", "America/Los_Angeles"),
("5397841", "South Whittier", "", "US", "840", "CA", "037", "", "", "33.96085", "-118.04173", "America/Los_Angeles"),
("5397851", "South Yuba City", "", "US", "840", "CA", "101", "", "", "39.11656", "-121.63913", "America/Los_Angeles"),
("5398277", "Spring Valley", "Спринг-Вэлли", "US", "840", "CA", "073", "", "", "32.74477", "-116.99892", "America/Los_Angeles"),
("5398630", "Stanton", "Стэнтон", "US", "840", "CA", "059", "", "", "33.80252", "-117.99312", "America/Los_Angeles"),
("5399020", "Stockton", "Стоктон", "US", "840", "CA", "077", "", "", "37.9577", "-121.29078", "America/Los_Angeles"),
("5399629", "Suisun", "", "US", "840", "CA", "095", "", "", "38.23825", "-122.04024", "America/Los_Angeles"),
("5399901", "Sun City", "", "US", "840", "CA", "065", "", "", "33.70919", "-117.19726", "America/Los_Angeles"),
("5400075", "Sunnyvale", "Саннивейл", "US", "840", "CA", "085", "", "", "37.36883", "-122.03635", "America/Los_Angeles"),
("5401395", "Temecula", "Темекула", "US", "840", "CA", "065", "", "", "33.49364", "-117.14836", "America/Los_Angeles"),
("5401469", "Temple City", "", "US", "840", "CA", "037", "", "", "34.10723", "-118.05785", "America/Los_Angeles"),
("5402405", "Thousand Oaks", "Таузенд-Оукс", "US", "840", "CA", "111", "", "", "34.17056", "-118.83759", "America/Los_Angeles"),
("5403022", "Torrance", "Торранс", "US", "840", "CA", "037", "", "", "33.83585", "-118.34063", "America/Los_Angeles"),
("5403191", "Tracy", "Трейси", "US", "840", "CA", "077", "", "", "37.73965", "-121.42522", "America/Los_Angeles"),
("5403676", "Truckee", "", "US", "840", "CA", "057", "", "", "39.32796", "-120.18325", "America/Los_Angeles"),
("5403783", "Tulare", "Тулар", "US", "840", "CA", "107", "", "", "36.20773", "-119.34734", "America/Los_Angeles"),
("5404024", "Turlock", "", "US", "840", "CA", "099", "", "", "37.49466", "-120.84659", "America/Los_Angeles"),
("5404119", "Tustin", "", "US", "840", "CA", "059", "", "", "33.74585", "-117.82617", "America/Los_Angeles"),
("5404122", "North Tustin", "", "US", "840", "CA", "059", "", "", "33.76446", "-117.79394", "America/Los_Angeles"),
("5404198", "Twentynine Palms", "Туэнтинайн-Палмс", "US", "840", "CA", "071", "", "", "34.13556", "-116.05417", "America/Los_Angeles"),
("5404476", "Ukiah", "Юкайа", "US", "840", "CA", "045", "", "", "39.15017", "-123.20778", "America/Los_Angeles"),
("5404555", "Union City", "", "US", "840", "CA", "001", "", "", "37.59577", "-122.01913", "America/Los_Angeles"),
("5404794", "Universal City", "Юниверсал-Сити", "US", "840", "CA", "037", "", "", "34.1389", "-118.35341", "America/Los_Angeles"),
("5404915", "Upland", "", "US", "840", "CA", "071", "", "", "34.09751", "-117.64839", "America/Los_Angeles"),
("5405228", "Vacaville", "", "US", "840", "CA", "095", "", "", "38.35658", "-121.98774", "America/Los_Angeles"),
("5405288", "Valencia", "", "US", "840", "CA", "037", "", "", "34.44361", "-118.60953", "America/Los_Angeles"),
("5405326", "Valinda", "", "US", "840", "CA", "037", "", "", "34.04529", "-117.94367", "America/Los_Angeles"),
("5405380", "Vallejo", "Вальехо", "US", "840", "CA", "095", "", "", "38.10409", "-122.25664", "America/Los_Angeles"),
("5405693", "Van Nuys", "", "US", "840", "CA", "037", "", "", "34.18667", "-118.44897", "America/Los_Angeles"),
("5405878", "Ventura", "Вентура", "US", "840", "CA", "111", "", "", "34.27834", "-119.29317", "America/Los_Angeles"),
("5406222", "Victorville", "", "US", "840", "CA", "071", "", "", "34.53611", "-117.29116", "America/Los_Angeles"),
("5406421", "Vincent", "", "US", "840", "CA", "037", "", "", "34.50055", "-118.11646", "America/Los_Angeles"),
("5406567", "Visalia", "Висейлия", "US", "840", "CA", "107", "", "", "36.33023", "-119.29206", "America/Los_Angeles"),
("5406602", "Vista", "", "US", "840", "CA", "073", "", "", "33.20004", "-117.24254", "America/Los_Angeles"),
("5406976", "Walnut", "Уолнат", "US", "840", "CA", "037", "", "", "34.02029", "-117.86534", "America/Los_Angeles"),
("5406990", "Walnut Creek", "Уолнат-Крик", "US", "840", "CA", "013", "", "", "37.90631", "-122.06496", "America/Los_Angeles"),
("5407030", "Walnut Park", "", "US", "840", "CA", "037", "", "", "33.96807", "-118.22507", "America/Los_Angeles"),
("5407529", "Watsonville", "", "US", "840", "CA", "087", "", "", "36.91023", "-121.75689", "America/Los_Angeles"),
("5407908", "West Carson", "", "US", "840", "CA", "037", "", "", "33.82168", "-118.29257", "America/Los_Angeles"),
("5407933", "West Covina", "Западная Ковина", "US", "840", "CA", "037", "", "", "34.06862", "-117.93895", "America/Los_Angeles"),
("5408076", "West Hollywood", "Западный Голливуд", "US", "840", "CA", "037", "", "", "34.09001", "-118.36174", "America/Los_Angeles"),
("5408191", "West Puente Valley", "", "US", "840", "CA", "037", "", "", "34.05168", "-117.9684", "America/Los_Angeles"),
("5408211", "West Sacramento", "", "US", "840", "CA", "113", "", "", "38.58046", "-121.53023", "America/Los_Angeles"),
("5408406", "Westminster", "", "US", "840", "CA", "059", "", "", "33.75918", "-118.00673", "America/Los_Angeles"),
("5408431", "Westmont", "", "US", "840", "CA", "037", "", "", "33.9414", "-118.3023", "America/Los_Angeles"),
("5409059", "Whittier", "", "US", "840", "CA", "037", "", "", "33.97918", "-118.03284", "America/Los_Angeles"),
("5409260", "Wildomar", "", "US", "840", "CA", "065", "", "", "33.59891", "-117.28004", "America/Los_Angeles"),
("5409768", "Willowbrook", "", "US", "840", "CA", "037", "", "", "33.91696", "-118.25507", "America/Los_Angeles"),
("5410004", "Windsor", "Виндзор", "US", "840", "CA", "097", "", "", "38.54713", "-122.81638", "America/Los_Angeles"),
("5410129", "Winter Gardens", "", "US", "840", "CA", "073", "", "", "32.83116", "-116.93336", "America/Los_Angeles"),
("5410430", "Woodland", "", "US", "840", "CA", "113", "", "", "38.67852", "-121.7733", "America/Los_Angeles"),
("5410438", "Woodland Hills", "", "US", "840", "CA", "037", "", "", "34.16834", "-118.60592", "America/Los_Angeles"),
("5410902", "Yorba Linda", "Йорба-Линда", "US", "840", "CA", "059", "", "", "33.88863", "-117.81311", "America/Los_Angeles"),
("5411015", "Yuba City", "Юба-Сити", "US", "840", "CA", "101", "", "", "39.14045", "-121.61691", "America/Los_Angeles"),
("5411046", "Yucaipa", "", "US", "840", "CA", "071", "", "", "34.03362", "-117.04309", "America/Los_Angeles"),
("5411079", "Yucca Valley", "", "US", "840", "CA", "071", "", "", "34.11417", "-116.43224", "America/Los_Angeles"),
("5412199", "Arvada", "Арвада", "US", "840", "CO", "059", "", "", "39.80276", "-105.08748", "America/Denver"),
("5412347", "Aurora", "Аврора", "US", "840", "CO", "001", "", "", "39.72943", "-104.83192", "America/Denver"),
("5414941", "Brighton", "Брайтон", "US", "840", "CO", "001", "", "", "39.98526", "-104.82053", "America/Denver"),
("5415035", "Broomfield", "", "US", "840", "CO", "014", "", "", "39.92054", "-105.08665", "America/Denver"),
("5416005", "Canon City", "", "US", "840", "CO", "043", "", "", "38.44098", "-105.24245", "America/Denver"),
("5416329", "Castle Rock", "", "US", "840", "CO", "035", "", "", "39.37221", "-104.85609", "America/Denver"),
("5416357", "Castlewood", "", "US", "840", "CO", "005", "", "", "39.58471", "-104.90109", "America/Denver"),
("5416541", "Centennial", "Сентенниал", "US", "840", "CO", "005", "", "", "39.57916", "-104.87692", "America/Denver"),
("5417041", "Cimarron Hills", "", "US", "840", "CO", "041", "", "", "38.85861", "-104.69886", "America/Denver"),
("5417258", "Clifton", "Клифтон", "US", "840", "CO", "077", "", "", "39.09193", "-108.44898", "America/Denver"),
("5417598", "Colorado Springs", "Колорадо-Спрингс", "US", "840", "CO", "041", "", "", "38.83388", "-104.82136", "America/Denver"),
("5417657", "Columbine", "Коломбина", "US", "840", "CO", "059", "", "", "39.58777", "-105.06943", "America/Denver"),
("5417737", "Commerce City", "", "US", "840", "CO", "001", "", "", "39.80832", "-104.93387", "America/Denver"),
("5419384", "Denver", "Денвер", "US", "840", "CO", "031", "", "", "39.73915", "-104.9847", "America/Denver"),
("5420241", "Durango", "", "US", "840", "CO", "067", "", "", "37.27528", "-107.88007", "America/Denver"),
("5421250", "Englewood", "", "US", "840", "CO", "005", "", "", "39.64777", "-104.98776", "America/Denver"),
("5422191", "Fountain", "", "US", "840", "CO", "041", "", "", "38.68222", "-104.70081", "America/Denver"),
("5423294", "Golden", "Голден", "US", "840", "CO", "059", "", "", "39.75554", "-105.2211", "America/Denver"),
("5423573", "Grand Junction", "Гранд Джанкшен", "US", "840", "CO", "077", "", "", "39.06387", "-108.55065", "America/Denver"),
("5425043", "Highlands Ranch", "", "US", "840", "CO", "035", "", "", "39.55388", "-104.96943", "America/Denver"),
("5427207", "Ken Caryl", "", "US", "840", "CO", "059", "", "", "39.57726", "-105.11687", "America/Denver"),
("5427771", "Lafayette", "Лафайет", "US", "840", "CO", "013", "", "", "39.9936", "-105.08971", "America/Denver"),
("5427946", "Lakewood", "Лейквуд", "US", "840", "CO", "059", "", "", "39.70471", "-105.08137", "America/Denver"),
("5429032", "Littleton", "Литтлтон", "US", "840", "CO", "005", "", "", "39.61332", "-105.01665", "America/Denver"),
("5429522", "Louisville", "Луисвил", "US", "840", "CO", "013", "", "", "39.97776", "-105.13193", "America/Denver"),
("5431710", "Montrose", "", "US", "840", "CO", "085", "", "", "38.47832", "-107.87617", "America/Denver"),
("5433124", "Northglenn", "", "US", "840", "CO", "001", "", "", "39.88554", "-104.9872", "America/Denver"),
("5434006", "Parker", "Паркер", "US", "840", "CO", "035", "", "", "39.5186", "-104.76136", "America/Denver"),
("5435464", "Pueblo", "Пуэбло", "US", "840", "CO", "101", "", "", "38.25445", "-104.60914", "America/Denver"),
("5435477", "Pueblo West", "", "US", "840", "CO", "101", "", "", "38.35", "-104.72275", "America/Denver"),
("5438567", "Sherrelwood", "", "US", "840", "CO", "001", "", "", "39.83776", "-105.00137", "America/Denver"),
("5439752", "Southglenn", "", "US", "840", "CO", "005", "", "", "39.58721", "-104.95276", "America/Denver"),
("5441492", "Thornton", "Торнтон", "US", "840", "CO", "001", "", "", "39.86804", "-104.97192", "America/Denver"),
("5443910", "Westminster", "Вестминстер", "US", "840", "CO", "001", "", "", "39.83665", "-105.0372", "America/Denver"),
("5443948", "Wheat Ridge", "", "US", "840", "CO", "059", "", "", "39.7661", "-105.07721", "America/Denver"),
("5445298", "Dodge City", "Додж-сити", "US", "840", "KS", "057", "", "", "37.7528", "-100.01708", "America/Chicago"),
("5445439", "Garden City", "", "US", "840", "KS", "055", "", "", "37.97169", "-100.87266", "America/Chicago"),
("5445820", "Liberal", "Либеральная", "US", "840", "KS", "175", "", "", "37.04308", "-100.921", "America/Chicago"),
("5454627", "Alamogordo", "Аламогордо", "US", "840", "NM", "035", "", "", "32.89953", "-105.96026", "America/Denver"),
("5454711", "Albuquerque", "Альбукерке", "US", "840", "NM", "001", "", "", "35.08449", "-106.65114", "America/Denver"),
("5460459", "Carlsbad", "Карлсбад", "US", "840", "NM", "015", "", "", "32.42067", "-104.22884", "America/Denver"),
("5462393", "Clovis", "Кловис", "US", "840", "NM", "009", "", "", "34.4048", "-103.20523", "America/Denver"),
("5467328", "Farmington", "Фармингтон", "US", "840", "NM", "045", "", "", "36.72806", "-108.21869", "America/Denver"),
("5468773", "Gallup", "Гэллап", "US", "840", "NM", "031", "", "", "35.52808", "-108.74258", "America/Denver"),
("5471578", "Hobbs", "Хоббс", "US", "840", "NM", "025", "", "", "32.70261", "-103.13604", "America/Denver"),
("5475352", "Las Cruces", "Лас-Крусес", "US", "840", "NM", "013", "", "", "32.31232", "-106.77834", "America/Denver"),
("5487811", "Rio Rancho", "Рио-Ранчо", "US", "840", "NM", "043", "", "", "35.23338", "-106.66447", "America/Denver"),
("5488441", "Roswell", "Розуэлл", "US", "840", "NM", "005", "", "", "33.39427", "-104.52302", "America/Denver"),
("5490263", "Santa Fe", "Санта-Фе", "US", "840", "NM", "049", "", "", "35.68698", "-105.9378", "America/Denver"),
("5492450", "South Valley", "", "US", "840", "NM", "001", "", "", "35.01005", "-106.67808", "America/Denver"),
("5500539", "Boulder City", "Боулдер", "US", "840", "NV", "003", "", "", "35.97859", "-114.83249", "America/Los_Angeles"),
("5501344", "Carson City", "Карсон-Сити", "US", "840", "NV", "510", "", "", "39.1638", "-119.7674", "America/Los_Angeles"),
("5503766", "Enterprise", "", "US", "840", "NV", "003", "", "", "36.02525", "-115.24194", "America/Los_Angeles"),
("5504003", "Fernley", "", "US", "840", "NV", "019", "", "", "39.60797", "-119.25183", "America/Los_Angeles"),
("5505411", "Henderson", "Хендерсон", "US", "840", "NV", "003", "", "", "36.0397", "-114.98194", "America/Los_Angeles"),
("5506956", "Las Vegas", "Лас-Вегас", "US", "840", "NV", "003", "", "", "36.17497", "-115.13722", "America/Los_Angeles"),
("5508180", "Mesquite", "", "US", "840", "NV", "003", "", "", "36.80553", "-114.06719", "America/Los_Angeles"),
("5509403", "North Las Vegas", "Норт-Лас-Вегас", "US", "840", "NV", "003", "", "", "36.19886", "-115.1175", "America/Los_Angeles"),
("5509851", "Pahrump", "", "US", "840", "NV", "023", "", "", "36.20829", "-115.98391", "America/Los_Angeles"),
("5509952", "Paradise", "Парадайз", "US", "840", "NV", "003", "", "", "36.09719", "-115.14666", "America/Los_Angeles"),
("5511077", "Reno", "Рино", "US", "840", "NV", "031", "", "", "39.52963", "-119.8138", "America/Los_Angeles"),
("5512827", "Spanish Springs", "", "US", "840", "NV", "031", "", "", "39.64908", "-119.70741", "America/Los_Angeles"),
("5512862", "Sparks", "Спаркс", "US", "840", "NV", "031", "", "", "39.53491", "-119.75269", "America/Los_Angeles"),
("5512909", "Spring Valley", "Спринг-Вэлли", "US", "840", "NV", "003", "", "", "36.10803", "-115.245", "America/Los_Angeles"),
("5513307", "Sun Valley", "", "US", "840", "NV", "031", "", "", "39.5963", "-119.77602", "America/Los_Angeles"),
("5513343", "Sunrise Manor", "", "US", "840", "NV", "003", "", "", "36.21108", "-115.07306", "America/Los_Angeles"),
("5515110", "Whitney", "Уитни", "US", "840", "NV", "003", "", "", "36.07081", "-115.08416", "America/Los_Angeles"),
("5515345", "Winchester", "", "US", "840", "NV", "003", "", "", "36.12997", "-115.11889", "America/Los_Angeles"),
("5516233", "Amarillo", "Амарилло", "US", "840", "TX", "375", "", "", "35.222", "-101.8313", "America/Chicago"),
("5517061", "Big Spring", "", "US", "840", "TX", "227", "", "", "32.2504", "-101.47874", "America/Chicago"),
("5520076", "Del Rio", "Дель-Рио", "US", "840", "TX", "465", "", "", "29.36273", "-100.89676", "America/Chicago"),
("5520677", "Eagle Pass", "", "US", "840", "TX", "323", "", "", "28.70914", "-100.49952", "America/Chicago"),
("5520993", "El Paso", "Эль-Пасо", "US", "840", "TX", "141", "", "", "31.75872", "-106.48693", "America/Denver"),
("5523074", "Hereford", "", "US", "840", "TX", "117", "", "", "34.81506", "-102.3977", "America/Chicago"),
("5523369", "Horizon City", "", "US", "840", "TX", "141", "", "", "31.69261", "-106.20748", "America/Denver"),
("5525577", "Lubbock", "Лаббок", "US", "840", "TX", "303", "", "", "33.57786", "-101.85517", "America/Chicago"),
("5526337", "Midland", "Мидленд", "US", "840", "TX", "329", "", "", "31.99735", "-102.07791", "America/Chicago"),
("5527554", "Odessa", "Одесса", "US", "840", "TX", "135", "", "", "31.84568", "-102.36764", "America/Chicago"),
("5527953", "Pampa", "Пампа", "US", "840", "TX", "179", "", "", "35.53616", "-100.95987", "America/Chicago"),
("5528450", "Plainview", "", "US", "840", "TX", "189", "", "", "34.18479", "-101.70684", "America/Chicago"),
("5530022", "San Angelo", "", "US", "840", "TX", "451", "", "", "31.46377", "-100.43704", "America/Chicago"),
("5530932", "Socorro", "Сокорро", "US", "840", "TX", "141", "", "", "31.65456", "-106.30331", "America/Denver"),
("5530937", "Socorro Mission Number 1 Colonia", "", "US", "840", "TX", "141", "", "", "31.63622", "-106.29054", "America/Denver"),
("5533366", "West Odessa", "", "US", "840", "TX", "135", "", "", "31.84235", "-102.49876", "America/Chicago"),
("5536630", "Cedar City", "", "US", "840", "UT", "021", "", "", "37.67748", "-113.06189", "America/Denver"),
("5546220", "Saint George", "", "US", "840", "UT", "053", "", "", "37.10415", "-113.58412", "America/Denver"),
("5549222", "Washington", "Вашингтон", "US", "840", "UT", "053", "", "", "37.13054", "-113.50829", "America/Denver"),
("5550368", "Wasco", "", "US", "840", "CA", "029", "", "", "35.59412", "-119.34095", "America/Los_Angeles"),
("5551498", "Anthem", "", "US", "840", "AZ", "013", "", "", "33.86726", "-112.14682", "America/Phoenix"),
("5551535", "Apache Junction", "", "US", "840", "AZ", "021", "", "", "33.41505", "-111.54958", "America/Phoenix"),
("5552301", "Avondale", "", "US", "840", "AZ", "013", "", "", "33.4356", "-112.3496", "America/Phoenix"),
("5554072", "Juneau", "Джуно", "US", "840", "AK", "110", "", "", "58.30194", "-134.41972", "America/Juneau"),
("5558953", "Arcata", "", "US", "840", "CA", "023", "", "", "40.86652", "-124.08284", "America/Los_Angeles"),
("5559320", "Bayside", "", "US", "840", "CA", "023", "", "", "40.84235", "-124.06367", "America/Los_Angeles"),
("5563397", "Eureka", "Эврика", "US", "840", "CA", "023", "", "", "40.80207", "-124.16367", "America/Los_Angeles"),
("5567770", "McKinleyville", "", "US", "840", "CA", "023", "", "", "40.94652", "-124.10062", "America/Los_Angeles"),
("5570160", "Redding", "", "US", "840", "CA", "089", "", "", "40.58654", "-122.39168", "America/Los_Angeles"),
("5572400", "Susanville", "", "US", "840", "CA", "035", "", "", "40.41628", "-120.65301", "America/Los_Angeles"),
("5574991", "Boulder", "Боулдер", "US", "840", "CO", "013", "", "", "40.01499", "-105.27055", "America/Denver"),
("5576859", "Erie", "Эри", "US", "840", "CO", "013", "", "", "40.05026", "-105.04998", "America/Denver"),
("5576909", "Evans", "", "US", "840", "CO", "123", "", "", "40.37637", "-104.69219", "America/Denver"),
("5577147", "Fort Collins", "Форт-Коллинс", "US", "840", "CO", "069", "", "", "40.58526", "-105.08442", "America/Denver"),
("5577592", "Greeley", "Грили", "US", "840", "CO", "123", "", "", "40.42331", "-104.70913", "America/Denver"),
("5579276", "Longmont", "", "US", "840", "CO", "013", "", "", "40.16721", "-105.10193", "America/Denver"),
("5579368", "Loveland", "", "US", "840", "CO", "069", "", "", "40.39776", "-105.07498", "America/Denver"),
("5583509", "Windsor", "Виндзор", "US", "840", "CO", "123", "", "", "40.47748", "-104.90136", "America/Denver"),
("5586437", "Boise", "Бойсе", "US", "840", "ID", "001", "", "", "43.6135", "-116.20345", "America/Boise"),
("5587698", "Caldwell", "Колдуэлл", "US", "840", "ID", "027", "", "", "43.66294", "-116.68736", "America/Boise"),
("5589173", "Coeur d'Alene", "Кёр-д’Ален", "US", "840", "ID", "055", "", "", "47.67768", "-116.78047", "America/Los_Angeles"),
("5591778", "Eagle", "Игл", "US", "840", "ID", "001", "", "", "43.69544", "-116.35401", "America/Boise"),
("5596475", "Idaho Falls", "Айдахо-Фолс", "US", "840", "ID", "019", "", "", "43.46658", "-112.03414", "America/Boise"),
("5597955", "Kuna", "", "US", "840", "ID", "001", "", "", "43.49183", "-116.42012", "America/Boise"),
("5598538", "Lewiston", "Льюистон", "US", "840", "ID", "069", "", "", "46.41655", "-117.01766", "America/Los_Angeles"),
("5598542", "Lewiston Orchards", "", "US", "840", "ID", "069", "", "", "46.38044", "-116.97543", "America/Los_Angeles"),
("5600685", "Meridian", "Меридиан", "US", "840", "ID", "001", "", "", "43.61211", "-116.39151", "America/Boise"),
("5601538", "Moscow", "Москва", "US", "840", "ID", "057", "", "", "46.73239", "-117.00017", "America/Los_Angeles"),
("5601933", "Nampa", "Нампа", "US", "840", "ID", "027", "", "", "43.54072", "-116.56346", "America/Boise"),
("5604045", "Pocatello", "Покателло", "US", "840", "ID", "005", "", "", "42.8713", "-112.44553", "America/Boise"),
("5604353", "Post Falls", "Пост-Фолс", "US", "840", "ID", "055", "", "", "47.71796", "-116.95159", "America/Los_Angeles"),
("5605242", "Rexburg", "Рексберг", "US", "840", "ID", "065", "", "", "43.82602", "-111.78969", "America/Boise"),
("5610810", "Twin Falls", "Туин-Фолс", "US", "840", "ID", "083", "", "", "42.56297", "-114.46087", "America/Boise"),
("5640350", "Billings", "Биллингс", "US", "840", "MT", "111", "", "", "45.78329", "-108.50069", "America/Denver"),
("5641727", "Bozeman", "Бозмана", "US", "840", "MT", "031", "", "", "45.67965", "-111.03856", "America/Denver"),
("5642934", "Butte", "Бьютт", "US", "840", "MT", "093", "", "", "46.00382", "-112.53474", "America/Denver"),
("5655240", "Great Falls", "Грейт-Фолс", "US", "840", "MT", "013", "", "", "47.50024", "-111.30081", "America/Denver"),
("5656882", "Helena", "Хелена", "US", "840", "MT", "049", "", "", "46.59271", "-112.03611", "America/Denver"),
("5660340", "Kalispell", "Калиспелл", "US", "840", "MT", "029", "", "", "48.19579", "-114.31291", "America/Denver"),
("5666639", "Missoula", "Миссула", "US", "840", "MT", "063", "", "", "46.87215", "-113.994", "America/Denver"),
("5688025", "Bismarck", "Бисмарк", "US", "840", "ND", "015", "", "", "46.80833", "-100.78374", "America/Chicago"),
("5688789", "Dickinson", "", "US", "840", "ND", "089", "", "", "46.87918", "-102.78962", "America/Denver"),
("5690366", "Mandan", "", "US", "840", "ND", "059", "", "", "46.82666", "-100.88958", "America/North_Dakota/New_Salem"),
("5690532", "Minot", "Мина", "US", "840", "ND", "101", "", "", "48.23251", "-101.29627", "America/Chicago"),
("5697939", "North Platte", "Норт-Платт", "US", "840", "NE", "111", "", "", "41.12389", "-100.76542", "America/Chicago"),
("5699404", "Scottsbluff", "Скотсблафф", "US", "840", "NE", "157", "", "", "41.86663", "-103.66717", "America/Denver"),
("5703670", "Elko", "Элко", "US", "840", "NV", "007", "", "", "40.83242", "-115.76312", "America/Los_Angeles"),
("5710756", "Albany", "Олбани", "US", "840", "OR", "043", "", "", "44.63651", "-123.10593", "America/Los_Angeles"),
("5711099", "Aloha", "", "US", "840", "OR", "067", "", "", "45.49428", "-122.86705", "America/Los_Angeles"),
("5711149", "Altamont", "", "US", "840", "OR", "035", "", "", "42.20681", "-121.73722", "America/Los_Angeles"),
("5711789", "Ashland", "", "US", "840", "OR", "029", "", "", "42.19458", "-122.70948", "America/Los_Angeles"),
("5713376", "Beaverton", "Бивертон", "US", "840", "OR", "067", "", "", "45.48706", "-122.80371", "America/Los_Angeles"),
("5713587", "Bend", "Бенд", "US", "840", "OR", "017", "", "", "44.05817", "-121.31531", "America/Los_Angeles"),
("5713759", "Bethany", "", "US", "840", "OR", "067", "", "", "45.55789", "-122.8676", "America/Los_Angeles"),
("5717758", "Canby", "", "US", "840", "OR", "005", "", "", "45.2629", "-122.69259", "America/Los_Angeles"),
("5718601", "Central Point", "", "US", "840", "OR", "029", "", "", "42.37596", "-122.91643", "America/Los_Angeles"),
("5720495", "Coos Bay", "", "US", "840", "OR", "011", "", "", "43.3665", "-124.21789", "America/Los_Angeles"),
("5720727", "Corvallis", "", "US", "840", "OR", "003", "", "", "44.56457", "-123.26204", "America/Los_Angeles"),
("5725846", "Eugene", "Юджин", "US", "840", "OR", "039", "", "", "44.05207", "-123.08675", "America/Los_Angeles"),
("5727190", "Forest Grove", "", "US", "840", "OR", "067", "", "", "45.51984", "-123.11066", "America/Los_Angeles"),
("5727382", "Four Corners", "", "US", "840", "OR", "047", "", "", "44.9279", "-122.98371", "America/Los_Angeles"),
("5729080", "Grants Pass", "Грантс-Пасс", "US", "840", "OR", "033", "", "", "42.43901", "-123.32839", "America/Los_Angeles"),
("5729485", "Gresham", "Грешам", "US", "840", "OR", "051", "", "", "45.49818", "-122.43148", "America/Los_Angeles"),
("5730675", "Hayesville", "", "US", "840", "OR", "047", "", "", "44.98595", "-122.98287", "America/Los_Angeles"),
("5731070", "Hermiston", "", "US", "840", "OR", "059", "", "", "45.84041", "-119.28946", "America/Los_Angeles"),
("5731371", "Hillsboro", "Хиллсборо", "US", "840", "OR", "067", "", "", "45.52289", "-122.98983", "America/Los_Angeles"),
("5734711", "Keizer", "Кейзер", "US", "840", "OR", "047", "", "", "44.99012", "-123.02621", "America/Los_Angeles"),
("5735238", "Klamath Falls", "Кламат Фолс", "US", "840", "OR", "035", "", "", "42.22487", "-121.78167", "America/Los_Angeles"),
("5735724", "Lake Oswego", "", "US", "840", "OR", "005", "", "", "45.42067", "-122.67065", "America/Los_Angeles"),
("5736218", "Lebanon", "", "US", "840", "OR", "043", "", "", "44.53651", "-122.90703", "America/Los_Angeles"),
("5736378", "Lents", "", "US", "840", "OR", "051", "", "", "45.47984", "-122.56731", "America/Los_Angeles"),
("5739936", "McMinnville", "", "US", "840", "OR", "071", "", "", "45.21012", "-123.19872", "America/Los_Angeles"),
("5740099", "Medford", "Медфорд", "US", "840", "OR", "029", "", "", "42.32652", "-122.87559", "America/Los_Angeles"),
("5740900", "Milwaukie", "Милуоки", "US", "840", "OR", "005", "", "", "45.44623", "-122.63926", "America/Los_Angeles"),
("5742726", "Newberg", "Ньюберг", "US", "840", "OR", "071", "", "", "45.30012", "-122.97316", "America/Los_Angeles"),
("5743731", "Oak Grove", "", "US", "840", "OR", "005", "", "", "45.41679", "-122.64009", "America/Los_Angeles"),
("5744253", "Oregon City", "", "US", "840", "OR", "005", "", "", "45.35734", "-122.60676", "America/Los_Angeles"),
("5745380", "Pendleton", "", "US", "840", "OR", "059", "", "", "45.67208", "-118.7886", "America/Los_Angeles"),
("5746545", "Portland", "Портленд", "US", "840", "OR", "051", "", "", "45.52345", "-122.67621", "America/Los_Angeles"),
("5747882", "Redmond", "Редмонд", "US", "840", "OR", "017", "", "", "44.27262", "-121.17392", "America/Los_Angeles"),
("5749352", "Roseburg", "", "US", "840", "OR", "019", "", "", "43.2165", "-123.34174", "America/Los_Angeles"),
("5750162", "Salem", "Сейлем", "US", "840", "OR", "047", "", "", "44.9429", "-123.0351", "America/Los_Angeles"),
("5751632", "Sherwood", "", "US", "840", "OR", "067", "", "", "45.35651", "-122.8401", "America/Los_Angeles"),
("5754005", "Springfield", "Спрингфилд", "US", "840", "OR", "039", "", "", "44.04624", "-123.02203", "America/Los_Angeles"),
("5756758", "Tigard", "", "US", "840", "OR", "067", "", "", "45.43123", "-122.77149", "America/Los_Angeles"),
("5757477", "Troutdale", "", "US", "840", "OR", "051", "", "", "45.53929", "-122.38731", "America/Los_Angeles"),
("5757506", "Tualatin", "", "US", "840", "OR", "067", "", "", "45.38401", "-122.76399", "America/Los_Angeles"),
("5760009", "West Linn", "", "US", "840", "OR", "005", "", "", "45.36568", "-122.61231", "America/Los_Angeles"),
("5761287", "Wilsonville", "", "US", "840", "OR", "005", "", "", "45.29984", "-122.77371", "America/Los_Angeles"),
("5761708", "Woodburn", "Вудберн", "US", "840", "OR", "047", "", "", "45.14373", "-122.85537", "America/Los_Angeles"),
("5768233", "Rapid City", "Рапид-Сити", "US", "840", "SD", "103", "", "", "44.08054", "-103.23101", "America/Denver"),
("5771826", "Bountiful", "", "US", "840", "UT", "011", "", "", "40.88939", "-111.88077", "America/Denver"),
("5771960", "Brigham City", "", "US", "840", "UT", "003", "", "", "41.51021", "-112.0155", "America/Denver"),
("5772654", "Centerville", "", "US", "840", "UT", "011", "", "", "40.918", "-111.87216", "America/Denver"),
("5772959", "Clearfield", "", "US", "840", "UT", "011", "", "", "41.11078", "-112.02605", "America/Denver"),
("5773001", "Clinton", "Клинтон", "US", "840", "UT", "011", "", "", "41.13967", "-112.0505", "America/Denver"),
("5773304", "Cottonwood Heights", "", "US", "840", "UT", "035", "", "", "40.61967", "-111.81021", "America/Denver"),
("5774001", "Draper", "", "US", "840", "UT", "035", "", "", "40.52467", "-111.86382", "America/Denver"),
("5774215", "Eagle Mountain", "", "US", "840", "UT", "049", "", "", "40.31412", "-112.00688", "America/Denver"),
("5774301", "East Millcreek", "", "US", "840", "UT", "035", "", "", "40.69995", "-111.81049", "America/Denver"),
("5774662", "Farmington", "Фармингтон", "US", "840", "UT", "011", "", "", "40.9805", "-111.88744", "America/Denver"),
("5775782", "Herriman", "", "US", "840", "UT", "035", "", "", "40.51411", "-112.03299", "America/Denver"),
("5775863", "Highland", "", "US", "840", "UT", "049", "", "", "40.44995", "-111.77021", "America/Denver"),
("5776008", "Holladay", "", "US", "840", "UT", "035", "", "", "40.66884", "-111.82466", "America/Denver"),
("5776715", "Kaysville", "", "US", "840", "UT", "011", "", "", "41.03522", "-111.93855", "America/Denver"),
("5776727", "Kearns", "Кернс", "US", "840", "UT", "035", "", "", "40.65995", "-111.99633", "America/Denver"),
("5777107", "Layton", "Лейтон", "US", "840", "UT", "011", "", "", "41.06022", "-111.97105", "America/Denver"),
("5777224", "Lehi", "Лехе", "US", "840", "UT", "049", "", "", "40.39162", "-111.85077", "America/Denver"),
("5777544", "Logan", "", "US", "840", "UT", "005", "", "", "41.73549", "-111.83439", "America/Denver"),
("5777793", "Magna", "", "US", "840", "UT", "035", "", "", "40.70911", "-112.10161", "America/Denver"),
("5778244", "Midvale", "", "US", "840", "UT", "035", "", "", "40.61106", "-111.89994", "America/Denver"),
("5778352", "Millcreek", "", "US", "840", "UT", "035", "", "", "40.68689", "-111.87549", "America/Denver"),
("5778755", "Murray", "Мюррей", "US", "840", "UT", "035", "", "", "40.66689", "-111.88799", "America/Denver"),
("5779036", "North Ogden", "", "US", "840", "UT", "057", "", "", "41.30716", "-111.96022", "America/Denver"),
("5779068", "North Salt Lake", "", "US", "840", "UT", "011", "", "", "40.84856", "-111.90688", "America/Denver"),
("5779206", "Ogden", "Огден", "US", "840", "UT", "057", "", "", "41.223", "-111.97383", "America/Denver"),
("5779334", "Orem", "Орем", "US", "840", "UT", "049", "", "", "40.2969", "-111.69465", "America/Denver"),
("5779548", "Payson", "", "US", "840", "UT", "049", "", "", "40.0444", "-111.73215", "America/Denver"),
("5779816", "Pleasant Grove", "", "US", "840", "UT", "049", "", "", "40.36412", "-111.73854", "America/Denver"),
("5780026", "Provo", "Прово", "US", "840", "UT", "049", "", "", "40.23384", "-111.65853", "America/Denver"),
("5780557", "Riverton", "Ривертон", "US", "840", "UT", "035", "", "", "40.52189", "-111.9391", "America/Denver"),
("5780802", "Roy", "Рой", "US", "840", "UT", "057", "", "", "41.16161", "-112.02633", "America/Denver"),
("5780993", "Salt Lake City", "Солт-Лейк-Сити", "US", "840", "UT", "035", "", "", "40.76078", "-111.89105", "America/Denver"),
("5781061", "Sandy City", "", "US", "840", "UT", "035", "", "", "40.57204", "-111.86056", "America/Denver"),
("5781070", "Sandy Hills", "", "US", "840", "UT", "035", "", "", "40.58106", "-111.85077", "America/Denver"),
("5781087", "Saratoga Springs", "Саратога-Спрингс", "US", "840", "UT", "049", "", "", "40.34912", "-111.90466", "America/Denver"),
("5781765", "South Jordan Heights", "", "US", "840", "UT", "035", "", "", "40.56384", "-111.94938", "America/Denver"),
("5781770", "South Jordan", "Саут-Джордан", "US", "840", "UT", "035", "", "", "40.56217", "-111.92966", "America/Denver"),
("5781783", "South Ogden", "", "US", "840", "UT", "057", "", "", "41.19189", "-111.97133", "America/Denver"),
("5781794", "South Salt Lake", "", "US", "840", "UT", "035", "", "", "40.71884", "-111.88827", "America/Denver"),
("5781860", "Spanish Fork", "", "US", "840", "UT", "049", "", "", "40.11496", "-111.65492", "America/Denver"),
("5781993", "Springville", "", "US", "840", "UT", "049", "", "", "40.16523", "-111.61075", "America/Denver"),
("5782391", "Syracuse", "", "US", "840", "UT", "011", "", "", "41.08939", "-112.06467", "America/Denver"),
("5782476", "Taylorsville", "Тейлорсвилл", "US", "840", "UT", "035", "", "", "40.66772", "-111.93883", "America/Denver"),
("5783695", "Tooele", "", "US", "840", "UT", "045", "", "", "40.53078", "-112.29828", "America/Denver"),
("5784549", "West Jordan", "Уэст-Джордан", "US", "840", "UT", "035", "", "", "40.60967", "-111.9391", "America/Denver"),
("5784607", "West Valley City", "Вест-Вэлли-Сити", "US", "840", "UT", "035", "", "", "40.69161", "-112.00105", "America/Denver"),
("5785243", "Aberdeen", "Абердин", "US", "840", "WA", "027", "", "", "46.97537", "-123.81572", "America/Los_Angeles"),
("5785657", "Anacortes", "", "US", "840", "WA", "057", "", "", "48.5126", "-122.61267", "America/Los_Angeles"),
("5785868", "Arlington", "Арлингтон", "US", "840", "WA", "061", "", "", "48.19871", "-122.12514", "America/Los_Angeles"),
("5785965", "Auburn", "", "US", "840", "WA", "033", "", "", "47.30732", "-122.22845", "America/Los_Angeles"),
("5786485", "Battle Ground", "", "US", "840", "WA", "011", "", "", "45.78095", "-122.53343", "America/Los_Angeles"),
("5786882", "Bellevue", "Белвью", "US", "840", "WA", "033", "", "", "47.61038", "-122.20068", "America/Los_Angeles"),
("5786899", "Bellingham", "Беллингхем", "US", "840", "WA", "073", "", "", "48.75955", "-122.48822", "America/Los_Angeles"),
("5787776", "Bonney Lake", "", "US", "840", "WA", "053", "", "", "47.17705", "-122.18651", "America/Los_Angeles"),
("5787829", "Bothell", "", "US", "840", "WA", "033", "", "", "47.76232", "-122.2054", "America/Los_Angeles"),
("5788054", "Bremerton", "Бремертон", "US", "840", "WA", "035", "", "", "47.56732", "-122.63264", "America/Los_Angeles"),
("5788516", "Burien", "", "US", "840", "WA", "033", "", "", "47.47038", "-122.34679", "America/Los_Angeles"),
("5788822", "Camas", "", "US", "840", "WA", "011", "", "", "45.58706", "-122.39954", "America/Los_Angeles"),
("5789683", "Centralia", "", "US", "840", "WA", "041", "", "", "46.71621", "-122.9543", "America/Los_Angeles"),
("5790971", "Cottage Lake", "", "US", "840", "WA", "033", "", "", "47.74427", "-122.07735", "America/Los_Angeles"),
("5791159", "Covington", "", "US", "840", "WA", "033", "", "", "47.35818", "-122.12216", "America/Los_Angeles"),
("5792244", "Des Moines", "Де-Мойн", "US", "840", "WA", "033", "", "", "47.40177", "-122.32429", "America/Los_Angeles"),
("5793427", "Edmonds", "Эдмондс", "US", "840", "WA", "061", "", "", "47.81065", "-122.37736", "America/Los_Angeles"),
("5793639", "Ellensburg", "", "US", "840", "WA", "037", "", "", "46.99651", "-120.54785", "America/Los_Angeles"),
("5793933", "Everett", "Эверетт", "US", "840", "WA", "061", "", "", "47.97898", "-122.20208", "America/Los_Angeles"),
("5794097", "Fairwood", "", "US", "840", "WA", "033", "", "", "47.44843", "-122.15734", "America/Los_Angeles"),
("5794245", "Federal Way", "", "US", "840", "WA", "033", "", "", "47.32232", "-122.31262", "America/Los_Angeles"),
("5794559", "Five Corners", "", "US", "840", "WA", "011", "", "", "45.68456", "-122.5751", "America/Los_Angeles"),
("5795011", "Frederickson", "", "US", "840", "WA", "053", "", "", "47.09621", "-122.35873", "America/Los_Angeles"),
("5795906", "Graham", "", "US", "840", "WA", "053", "", "", "47.05288", "-122.29428", "America/Los_Angeles"),
("5796984", "Hazel Dell", "", "US", "840", "WA", "011", "", "", "45.67151", "-122.66288", "America/Los_Angeles"),
("5798487", "Issaquah", "", "US", "840", "WA", "033", "", "", "47.5301", "-122.03262", "America/Los_Angeles"),
("5799587", "Kenmore", "", "US", "840", "WA", "033", "", "", "47.75732", "-122.24401", "America/Los_Angeles"),
("5799610", "Kennewick", "Кенневик", "US", "840", "WA", "005", "", "", "46.21125", "-119.13723", "America/Los_Angeles"),
("5799625", "Kent", "Кент", "US", "840", "WA", "033", "", "", "47.38093", "-122.23484", "America/Los_Angeles"),
("5799841", "Kirkland", "", "US", "840", "WA", "033", "", "", "47.68149", "-122.20874", "America/Los_Angeles"),
("5800112", "Lacey", "Лейси", "US", "840", "WA", "067", "", "", "47.03426", "-122.82319", "America/Los_Angeles"),
("5800317", "Lake Stevens", "", "US", "840", "WA", "061", "", "", "48.0151", "-122.06374", "America/Los_Angeles"),
("5800420", "Lakewood", "Лейквуд", "US", "840", "WA", "053", "", "", "47.17176", "-122.51846", "America/Los_Angeles"),
("5801617", "Longview", "", "US", "840", "WA", "015", "", "", "46.13817", "-122.93817", "America/Los_Angeles"),
("5802049", "Lynnwood", "Линвуд", "US", "840", "WA", "061", "", "", "47.82093", "-122.31513", "America/Los_Angeles"),
("5802340", "Maple Valley", "", "US", "840", "WA", "033", "", "", "47.39272", "-122.04641", "America/Los_Angeles"),
("5802493", "Martha Lake", "", "US", "840", "WA", "061", "", "", "47.85093", "-122.2393", "America/Los_Angeles"),
("5802570", "Marysville", "", "US", "840", "WA", "061", "", "", "48.05176", "-122.17708", "America/Los_Angeles"),
("5803139", "Mercer Island", "", "US", "840", "WA", "033", "", "", "47.57065", "-122.22207", "America/Los_Angeles"),
("5803457", "Mill Creek", "", "US", "840", "WA", "061", "", "", "47.8601", "-122.2043", "America/Los_Angeles"),
("5803786", "Monroe", "Монро", "US", "840", "WA", "061", "", "", "47.85538", "-121.97096", "America/Los_Angeles"),
("5803990", "Moses Lake", "", "US", "840", "WA", "025", "", "", "47.13014", "-119.27808", "America/Los_Angeles"),
("5804127", "Mount Vernon", "Маунт-Вернон", "US", "840", "WA", "057", "", "", "48.42122", "-122.33405", "America/Los_Angeles"),
("5804191", "Mountlake Terrace", "", "US", "840", "WA", "061", "", "", "47.78815", "-122.30874", "America/Los_Angeles"),
("5804306", "Mukilteo", "", "US", "840", "WA", "061", "", "", "47.94454", "-122.30458", "America/Los_Angeles"),
("5804953", "North Creek", "", "US", "840", "WA", "061", "", "", "47.81954", "-122.17624", "America/Los_Angeles"),
("5805441", "Oak Harbor", "", "US", "840", "WA", "029", "", "", "48.29316", "-122.64322", "America/Los_Angeles"),
("5805687", "Olympia", "Олимпия", "US", "840", "WA", "067", "", "", "47.03787", "-122.9007", "America/Los_Angeles"),
("5805782", "Opportunity", "", "US", "840", "WA", "063", "", "", "47.64995", "-117.23991", "America/Los_Angeles"),
("5805815", "Orchards", "", "US", "840", "WA", "011", "", "", "45.66651", "-122.56093", "America/Los_Angeles"),
("5806253", "Parkland", "", "US", "840", "WA", "053", "", "", "47.15538", "-122.43401", "America/Los_Angeles"),
("5806298", "Pasco", "Паско", "US", "840", "WA", "021", "", "", "46.23958", "-119.10057", "America/Los_Angeles"),
("5807212", "Port Angeles", "", "US", "840", "WA", "009", "", "", "48.11815", "-123.43074", "America/Los_Angeles"),
("5807540", "Pullman", "", "US", "840", "WA", "075", "", "", "46.73127", "-117.17962", "America/Los_Angeles"),
("5807575", "Puyallup", "", "US", "840", "WA", "053", "", "", "47.18538", "-122.2929", "America/Los_Angeles"),
("5808079", "Redmond", "Редмонд", "US", "840", "WA", "033", "", "", "47.67399", "-122.12151", "America/Los_Angeles"),
("5808189", "Renton", "Рентон", "US", "840", "WA", "033", "", "", "47.48288", "-122.21707", "America/Los_Angeles"),
("5808276", "Richland", "Ричленд", "US", "840", "WA", "005", "", "", "46.28569", "-119.28446", "America/Los_Angeles"),
("5809333", "Salmon Creek", "", "US", "840", "WA", "011", "", "", "45.71067", "-122.64899", "America/Los_Angeles"),
("5809402", "Sammamish", "", "US", "840", "WA", "033", "", "", "47.64177", "-122.0804", "America/Los_Angeles"),
("5809805", "SeaTac", "", "US", "840", "WA", "033", "", "", "47.44846", "-122.29217", "America/Los_Angeles"),
("5809844", "Seattle", "Сиэтл", "US", "840", "WA", "033", "", "", "47.60621", "-122.33207", "America/Los_Angeles"),
("5810301", "Shoreline", "", "US", "840", "WA", "033", "", "", "47.75565", "-122.34152", "America/Los_Angeles"),
("5810490", "Silverdale", "", "US", "840", "WA", "035", "", "", "47.64454", "-122.69487", "America/Los_Angeles"),
("5811456", "South Hill", "", "US", "840", "WA", "053", "", "", "47.14121", "-122.27012", "America/Los_Angeles"),
("5811581", "Spanaway", "", "US", "840", "WA", "053", "", "", "47.10399", "-122.43457", "America/Los_Angeles"),
("5811696", "Spokane", "Спокан", "US", "840", "WA", "063", "", "", "47.65966", "-117.42908", "America/Los_Angeles"),
("5811729", "Spokane Valley", "", "US", "840", "WA", "063", "", "", "47.67323", "-117.23937", "America/Los_Angeles"),
("5812604", "Sunnyside", "", "US", "840", "WA", "077", "", "", "46.32374", "-120.00865", "America/Los_Angeles"),
("5812944", "Tacoma", "Такома", "US", "840", "WA", "053", "", "", "47.25288", "-122.44429", "America/Los_Angeles"),
("5814043", "Tukwila", "", "US", "840", "WA", "033", "", "", "47.47399", "-122.26096", "America/Los_Angeles"),
("5814095", "Tumwater", "", "US", "840", "WA", "067", "", "", "47.00732", "-122.90931", "America/Los_Angeles"),
("5814450", "University Place", "", "US", "840", "WA", "053", "", "", "47.23565", "-122.5504", "America/Los_Angeles"),
("5814616", "Vancouver", "Ванкувер", "US", "840", "WA", "011", "", "", "45.63873", "-122.66149", "America/Los_Angeles"),
("5814916", "Walla Walla", "", "US", "840", "WA", "071", "", "", "46.06458", "-118.34302", "America/Los_Angeles"),
("5815342", "Wenatchee", "", "US", "840", "WA", "007", "", "", "47.42346", "-120.31035", "America/Los_Angeles"),
("5815538", "West Lake Sammamish", "", "US", "840", "WA", "033", "", "", "47.5776", "-122.10123", "America/Los_Angeles"),
("5815539", "West Lake Stevens", "", "US", "840", "WA", "061", "", "", "47.99343", "-122.1018", "America/Los_Angeles"),
("5816320", "Bainbridge Island", "Остров Бейнбридж", "US", "840", "WA", "035", "", "", "47.62621", "-122.52124", "America/Los_Angeles"),
("5816605", "Yakima", "Якима", "US", "840", "WA", "077", "", "", "46.60207", "-120.5059", "America/Los_Angeles"),
("5820705", "Casper", "Каспер", "US", "840", "WY", "025", "", "", "42.86663", "-106.31308", "America/Denver"),
("5821086", "Cheyenne", "Шайенн", "US", "840", "WY", "021", "", "", "41.13998", "-104.82025", "America/Denver"),
("5826027", "Gillette", "Джиллетт", "US", "840", "WY", "005", "", "", "44.29109", "-105.50222", "America/Denver"),
("5830062", "Laramie", "Ларами", "US", "840", "WY", "001", "", "", "41.31137", "-105.5911", "America/Denver"),
("5836898", "Rock Springs", "Рок-Спрингс", "US", "840", "WY", "037", "", "", "41.58746", "-109.2029", "America/Denver"),
("5838198", "Sheridan", "Шеридан", "US", "840", "WY", "033", "", "", "44.79719", "-106.95618", "America/Denver"),
("5844096", "American Fork", "", "US", "840", "UT", "049", "", "", "40.3769", "-111.79576", "America/Denver"),
("5847411", "Kahului", "", "US", "840", "HI", "009", "", "", "20.89472", "-156.47", "Pacific/Honolulu"),
("5847486", "Kailua", "", "US", "840", "HI", "003", "", "", "21.40222", "-157.73944", "Pacific/Honolulu"),
("5848189", "Kane'ohe", "", "US", "840", "HI", "003", "", "", "21.40929", "-157.80092", "Pacific/Honolulu"),
("5849297", "Kihei", "", "US", "840", "HI", "009", "", "", "20.75548", "-156.45446", "Pacific/Honolulu"),
("5850554", "Makakilo City", "", "US", "840", "HI", "003", "", "", "21.34694", "-158.08583", "Pacific/Honolulu"),
("5851030", "Mililani Town", "", "US", "840", "HI", "003", "", "", "21.45", "-158.00111", "Pacific/Honolulu"),
("5852275", "Pearl City", "", "US", "840", "HI", "003", "", "", "21.39722", "-157.97333", "Pacific/Honolulu"),
("5853992", "Wahiawa", "", "US", "840", "HI", "003", "", "", "21.50211", "-158.02104", "Pacific/Honolulu"),
("5854496", "Wailuku", "", "US", "840", "HI", "009", "", "", "20.89111", "-156.50472", "Pacific/Honolulu"),
("5854686", "Waipahu", "", "US", "840", "HI", "003", "", "", "21.38667", "-158.00917", "Pacific/Honolulu"),
("5855070", "'Ewa Gentry", "", "US", "840", "HI", "003", "", "", "21.34417", "-158.03083", "Pacific/Honolulu"),
("5855927", "Hilo", "Хило", "US", "840", "HI", "001", "", "", "19.72972", "-155.09", "Pacific/Honolulu"),
("5856195", "Honolulu", "Гонолулу", "US", "840", "HI", "003", "", "", "21.30694", "-157.85833", "Pacific/Honolulu"),
("5861187", "Eagle River", "", "US", "840", "AK", "020", "", "", "61.32139", "-149.56778", "America/Anchorage"),
("5861897", "Fairbanks", "Фэрбанкс", "US", "840", "AK", "090", "", "", "64.83778", "-147.71639", "America/Anchorage"),
("5879400", "Anchorage", "Анкоридж", "US", "840", "AK", "020", "", "", "61.21806", "-149.90028", "America/Anchorage"),
("5879898", "Badger", "", "US", "840", "AK", "090", "", "", "64.8", "-147.53333", "America/Anchorage"),
("6331908", "Milton", "", "US", "840", "GA", "121", "", "", "34.13216", "-84.30067", "America/New_York"),
("6331909", "Johns Creek", "", "US", "840", "GA", "121", "", "", "34.02893", "-84.19858", "America/New_York"),
("6332309", "Cutler Bay", "", "US", "840", "FL", "086", "", "", "25.5783", "-80.3377", "America/New_York"),
("6332439", "Alafaya", "", "US", "840", "FL", "095", "", "", "28.5641", "-81.2114", "America/New_York"),
("6941080", "Fort Bragg", "", "US", "840", "NC", "051", "", "", "35.139", "-79.00603", "America/New_York"),
("7160204", "City of Milford (balance)", "", "US", "840", "CT", "009", "", "", "41.22374", "-73.06164", "America/New_York"),
("7172886", "Butte-Silver Bow (Balance)", "", "US", "840", "MT", "093", "", "", "45.90194", "-112.65708", "America/Denver"),
("7176035", "Silver Firs", "", "US", "840", "WA", "061", "", "", "47.86602", "-122.1551", "America/Los_Angeles"),
("7176039", "Vineyard", "", "US", "840", "CA", "067", "", "", "38.46449", "-121.34692", "America/Los_Angeles"),
("7257422", "Wallingford Center", "", "US", "840", "CT", "009", "", "", "41.44987", "-72.81892", "America/New_York"),
("7257991", "Bel Air North", "", "US", "840", "MD", "025", "", "", "39.55429", "-76.37309", "America/New_York"),
("7257992", "Bel Air South", "", "US", "840", "MD", "025", "", "", "39.50506", "-76.31976", "America/New_York"),
("7258965", "Setauket-East Setauket", "", "US", "840", "NY", "103", "", "", "40.93064", "-73.10178", "America/New_York"),
("7259084", "Tonawanda", "", "US", "840", "NY", "029", "", "", "42.98499", "-78.87798", "America/New_York"),
("7259265", "Fort Leonard Wood", "", "US", "840", "MO", "169", "", "", "37.70573", "-92.15717", "America/Chicago"),
("7259621", "West Bloomfield Township", "", "US", "840", "MI", "125", "", "", "42.56891", "-83.38356", "America/Detroit"),
("7259705", "East Lake-Orient Park", "", "US", "840", "FL", "057", "", "", "27.98269", "-82.37878", "America/New_York"),
("7259780", "Four Corners", "", "US", "840", "FL", "069", "", "", "28.33287", "-81.64738", "America/New_York"),
("7259823", "Greater Northdale", "", "US", "840", "FL", "057", "", "", "28.10545", "-82.52594", "America/New_York"),
("7260019", "Candler-McAfee", "", "US", "840", "GA", "089", "", "", "33.72672", "-84.27246", "America/New_York"),
("7260219", "University", "", "US", "840", "FL", "057", "", "", "28.0692", "-82.43609", "America/New_York"),
("7260233", "Vero Beach South", "", "US", "840", "FL", "061", "", "", "27.61638", "-80.41308", "America/New_York"),
("7260327", "Kendall West", "", "US", "840", "FL", "086", "", "", "25.7065", "-80.4388", "America/New_York"),
("7260548", "Palm River-Clair Mel", "", "US", "840", "FL", "057", "", "", "27.92386", "-82.37939", "America/New_York"),
("7260806", "Arden-Arcade", "", "US", "840", "CA", "067", "", "", "38.6025", "-121.37854", "America/Los_Angeles"),
("7260966", "Bryn Mawr-Skyway", "", "US", "840", "WA", "033", "", "", "47.4943", "-122.24092", "America/Los_Angeles"),
("7261029", "Casa de Oro-Mount Helix", "", "US", "840", "CA", "073", "", "", "32.76397", "-116.96877", "America/Los_Angeles"),
("7261268", "Florence-Graham", "", "US", "840", "CA", "037", "", "", "33.96772", "-118.24438", "America/Los_Angeles"),
("7261291", "Fort Hood", "", "US", "840", "TX", "027", "", "", "31.13489", "-97.77561", "America/Chicago"),
("7261476", "Inglewood-Finn Hill", "", "US", "840", "WA", "033", "", "", "47.72049", "-122.23167", "America/Los_Angeles"),
("7261553", "La Crescenta-Montrose", "", "US", "840", "CA", "037", "", "", "34.23216", "-118.23529", "America/Los_Angeles"),
("7261759", "East Hill-Meridian", "", "US", "840", "WA", "033", "", "", "47.41052", "-122.17369", "America/Los_Angeles"),
("7262349", "Security-Widefield", "", "US", "840", "CO", "041", "", "", "38.74728", "-104.71439", "America/Denver"),
("7262428", "Union Hill-Novelty Hill", "", "US", "840", "WA", "033", "", "", "47.67887", "-122.02833", "America/Los_Angeles"),
("7262518", "West Whittier-Los Nietos", "", "US", "840", "CA", "037", "", "", "33.976", "-118.06909", "America/Los_Angeles"),
("7262622", "Summerlin South", "", "US", "840", "NV", "003", "", "", "36.11708", "-115.33001", "America/Los_Angeles"),
("7262761", "Makakilo", "", "US", "840", "HI", "003", "", "", "21.35237", "-158.08655", "Pacific/Honolulu"),
("7262790", "Schofield Barracks", "", "US", "840", "HI", "003", "", "", "21.4936", "-158.06151", "Pacific/Honolulu"),
("7310164", "San Tan Valley", "", "US", "840", "AZ", "021", "", "", "33.1911", "-111.528", "America/Phoenix"),
("7839240", "Enchanted Hills", "", "US", "840", "NM", "043", "", "", "35.33676", "-106.59296", "America/Denver"),
("8030162", "West Hills", "", "US", "840", "CA", "037", "", "", "34.19731", "-118.64398", "America/Los_Angeles"),
("8097131", "Oak Hill", "", "US", "840", "VA", "059", "", "", "38.9258", "-77.40156", "America/New_York"),
("8299576", "Bridgewater", "", "US", "840", "NJ", "035", "", "", "40.60079", "-74.64815", "America/New_York"),
("8299577", "Warren Township", "", "US", "840", "NJ", "035", "", "", "40.60822", "-74.51803", "America/New_York"),
("8347326", "Fairfield Heights", "", "US", "840", "IN", "063", "", "", "39.82861", "-86.38224", "America/Indiana/Indianapolis"),
("8469295", "Randolph", "", "US", "840", "NJ", "027", "", "", "40.84829", "-74.58148", "America/New_York"),
("8605040", "Hot Springs National Park", "", "US", "840", "AR", "051", "", "", "34.51342", "-93.05429", "America/Chicago"),
("8605041", "Dixiana", "", "US", "840", "AL", "073", "", "", "33.74021", "-86.64938", "America/Chicago"),
("8643098", "Cranberry Township", "", "US", "840", "PA", "019", "", "", "40.68496", "-80.10714", "America/New_York"),
("601294", "Nukus", "Нукус", "UZ", "860", "09", "", "", "", "42.45306", "59.61028", "Asia/Samarkand"),
("601339", "Khujayli", "Ходжейли", "UZ", "860", "09", "", "", "", "42.40043", "59.46005", "Asia/Samarkand"),
("601417", "Oltinko'l", "", "UZ", "860", "09", "", "", "", "43.06874", "58.90372", "Asia/Samarkand"),
("1215694", "Zomin", "Зомин", "UZ", "860", "15", "", "", "", "39.96056", "68.39583", "Asia/Samarkand"),
("1215839", "Urgut", "Ургут", "UZ", "860", "10", "", "", "", "39.40222", "67.24306", "Asia/Samarkand"),
("1215957", "Tirmiz", "Термез", "UZ", "860", "12", "", "", "", "37.22417", "67.27833", "Asia/Samarkand"),
("1216115", "Sho'rchi", "", "UZ", "860", "12", "", "", "", "37.99944", "67.7875", "Asia/Samarkand"),
("1216187", "Shahrisabz", "Шахрисабз", "UZ", "860", "08", "", "", "", "39.05778", "66.83417", "Asia/Samarkand"),
("1216265", "Samarqand", "Самарканд", "UZ", "860", "10", "", "", "", "39.65417", "66.95972", "Asia/Samarkand"),
("1216311", "Qarshi", "Карши", "UZ", "860", "08", "", "", "", "38.86056", "65.78905", "Asia/Samarkand"),
("1216475", "Muborak", "Муборак", "UZ", "860", "08", "", "", "", "39.25528", "65.15278", "Asia/Samarkand"),
("1216787", "Kitob", "Китоб", "UZ", "860", "08", "", "", "", "39.08425", "66.83318", "Asia/Samarkand"),
("1216982", "Kattaqo'rg'on", "", "UZ", "860", "10", "", "", "", "39.89889", "66.25611", "Asia/Samarkand"),
("1217007", "Koson", "Косон", "UZ", "860", "08", "", "", "", "39.0375", "65.585", "Asia/Samarkand"),
("1217084", "Karakul'", "Каракуль", "UZ", "860", "02", "", "", "", "39.53333", "63.83333", "Asia/Samarkand"),
("1217180", "Kogon", "Каган", "UZ", "860", "02", "", "", "", "39.72278", "64.55167", "Asia/Samarkand"),
("1217262", "G'uzor", "", "UZ", "860", "08", "", "", "", "38.62083", "66.24806", "Asia/Samarkand"),
("1217340", "Galaosiyo", "", "UZ", "860", "02", "", "", "", "39.85778", "64.44833", "Asia/Samarkand"),
("1217362", "Juma", "", "UZ", "860", "10", "", "", "", "39.71611", "66.66417", "Asia/Samarkand"),
("1217474", "Denov", "Денов", "UZ", "860", "12", "", "", "", "38.26667", "67.9", "Asia/Samarkand"),
("1217540", "Chiroqchi", "", "UZ", "860", "08", "", "", "", "39.03361", "66.57222", "Asia/Samarkand"),
("1217569", "Chelak", "", "UZ", "860", "10", "", "", "", "39.92028", "66.86111", "Asia/Samarkand"),
("1217658", "Bulung'ur", "", "UZ", "860", "10", "", "", "", "39.76472", "67.27139", "Asia/Samarkand"),
("1217662", "Bukhara", "Бухара", "UZ", "860", "02", "", "", "", "39.77472", "64.42861", "Asia/Samarkand"),
("1217703", "Beshkent", "Бешкент", "UZ", "860", "08", "", "", "", "38.82139", "65.65306", "Asia/Samarkand"),
("1217734", "Boysun", "Бойсун", "UZ", "860", "12", "", "", "", "38.20611", "67.19861", "Asia/Samarkand"),
("1217926", "Oqtosh", "", "UZ", "860", "10", "", "", "", "39.92139", "65.92528", "Asia/Samarkand"),
("1512287", "Zafar", "Зафар", "UZ", "860", "14", "", "", "", "40.98333", "68.9", "Asia/Tashkent"),
("1512320", "Yaypan", "Яйпан", "UZ", "860", "03", "", "", "", "40.37583", "70.81556", "Asia/Tashkent"),
("1512339", "Yangiyul", "Янгиюль", "UZ", "860", "14", "", "", "", "41.11202", "69.0471", "Asia/Tashkent"),
("1512342", "Yangiyer", "Янгиер", "UZ", "860", "16", "", "", "", "40.275", "68.8225", "Asia/Tashkent"),
("1512348", "Yangirabot", "", "UZ", "860", "07", "", "", "", "40.02539", "65.96095", "Asia/Samarkand"),
("1512350", "Yangiqo`rg`on", "", "UZ", "860", "06", "", "", "", "41.18722", "71.73333", "Asia/Tashkent"),
("1512372", "Yangiobod", "Янгиабад", "UZ", "860", "14", "", "", "", "41.11919", "70.09406", "Asia/Tashkent"),
("1512423", "Wobkent", "", "UZ", "860", "02", "", "", "", "40.03028", "64.515", "Asia/Samarkand"),
("1512449", "Uychi", "Уйчи", "UZ", "860", "06", "", "", "", "41.08073", "71.92331", "Asia/Tashkent"),
("1512473", "Urganch", "Ургенч", "UZ", "860", "05", "", "", "", "41.55", "60.63333", "Asia/Samarkand"),
("1512480", "Dashtobod", "", "UZ", "860", "15", "", "", "", "40.12694", "68.49444", "Asia/Tashkent"),
("1512501", "Uchqurghon Shahri", "", "UZ", "860", "06", "", "", "", "41.11371", "72.07915", "Asia/Tashkent"),
("1512524", "Tuytepa", "Тойтепа", "UZ", "860", "14", "", "", "", "41.0321", "69.36253", "Asia/Tashkent"),
("1512549", "Turagurghon", "", "UZ", "860", "06", "", "", "", "40.99984", "71.51162", "Asia/Tashkent"),
("1512568", "Toshloq", "", "UZ", "860", "03", "", "", "", "40.47722", "71.76778", "Asia/Tashkent"),
("1512569", "Tashkent", "Ташкент", "UZ", "860", "13", "", "", "", "41.26465", "69.21627", "Asia/Tashkent"),
("1512658", "Toshbuloq", "", "UZ", "860", "06", "", "", "", "40.92339", "71.57214", "Asia/Tashkent"),
("1512770", "Sirdaryo", "Сырдарьинская", "UZ", "860", "16", "", "", "", "40.84361", "68.66167", "Asia/Tashkent"),
("1512790", "Showot", "", "UZ", "860", "05", "", "", "", "41.65583", "60.3025", "Asia/Samarkand"),
("1512838", "Shofirkon", "", "UZ", "860", "02", "", "", "", "40.12", "64.50139", "Asia/Samarkand"),
("1512934", "Salor", "", "UZ", "860", "14", "", "", "", "41.37222", "69.38167", "Asia/Tashkent"),
("1512978", "Qushkupir", "", "UZ", "860", "05", "", "", "", "41.535", "60.34556", "Asia/Samarkand"),
("1512979", "Qo`qon", "Коканд", "UZ", "860", "03", "", "", "", "40.52861", "70.9425", "Asia/Tashkent"),
("1512986", "Piskent", "", "UZ", "860", "14", "", "", "", "40.89722", "69.35056", "Asia/Tashkent"),
("1513011", "Payshanba", "Пайшанба", "UZ", "860", "10", "", "", "", "40.00778", "66.23694", "Asia/Samarkand"),
("1513017", "Parkent", "", "UZ", "860", "14", "", "", "", "41.29444", "69.67639", "Asia/Tashkent"),
("1513023", "Pop", "Поп", "UZ", "860", "06", "", "", "", "40.87361", "71.10889", "Asia/Tashkent"),
("1513038", "Paxtakor", "", "UZ", "860", "15", "", "", "", "40.31528", "67.95444", "Asia/Samarkand"),
("1513064", "Olmaliq", "Алмалык", "UZ", "860", "14", "", "", "", "40.84472", "69.59833", "Asia/Tashkent"),
("1513072", "Ohangaron", "", "UZ", "860", "14", "", "", "", "40.90639", "69.63833", "Asia/Tashkent"),
("1513087", "Nurota", "Нурота", "UZ", "860", "07", "", "", "", "40.56139", "65.68861", "Asia/Samarkand"),
("1513092", "Novyy Turtkul'", "", "UZ", "860", "09", "", "", "", "41.55", "61.01667", "Asia/Samarkand"),
("1513131", "Navoiy", "Навои", "UZ", "860", "07", "", "", "", "40.08444", "65.37917", "Asia/Samarkand"),
("1513157", "Namangan", "Наманган", "UZ", "860", "06", "", "", "", "40.9983", "71.67257", "Asia/Tashkent"),
("1513243", "Marg`ilon", "Маргилан", "UZ", "860", "03", "", "", "", "40.47111", "71.72472", "Asia/Tashkent"),
("1513245", "Manghit", "", "UZ", "860", "09", "", "", "", "42.11556", "60.05972", "Asia/Samarkand"),
("1513271", "Asaka", "Асака", "UZ", "860", "01", "", "", "", "40.64153", "72.23868", "Asia/Tashkent"),
("1513331", "Quvasoy", "", "UZ", "860", "03", "", "", "", "40.30222", "71.97444", "Asia/Bishkek"),
("1513364", "Qurghontepa", "", "UZ", "860", "01", "", "", "", "40.73192", "72.76177", "Asia/Tashkent"),
("1513555", "Kirgili", "", "UZ", "860", "03", "", "", "", "40.43583", "71.76722", "Asia/Tashkent"),
("1513567", "Qibray", "", "UZ", "860", "14", "", "", "", "41.38972", "69.465", "Asia/Tashkent"),
("1513600", "Khujaobod", "", "UZ", "860", "01", "", "", "", "40.66886", "72.56002", "Asia/Tashkent"),
("1513604", "Khiwa", "Хива", "UZ", "860", "05", "", "", "", "41.37833", "60.36389", "Asia/Samarkand"),
("1513655", "Haqqulobod", "", "UZ", "860", "06", "", "", "", "40.91667", "72.11667", "Asia/Tashkent"),
("1513714", "Kosonsoy", "", "UZ", "860", "06", "", "", "", "41.25611", "71.55083", "Asia/Tashkent"),
("1513886", "Jizzax", "Джизак", "UZ", "860", "15", "", "", "", "40.11583", "67.84222", "Asia/Samarkand"),
("1513900", "Iskandar", "Искандар", "UZ", "860", "14", "", "", "", "41.55389", "69.70083", "Asia/Tashkent"),
("1513957", "Hazorasp", "", "UZ", "860", "05", "", "", "", "41.31944", "61.07417", "Asia/Samarkand"),
("1513962", "Gurlan", "Гурлан", "UZ", "860", "05", "", "", "", "41.84472", "60.39194", "Asia/Samarkand"),
("1513966", "Guliston", "Гулистан", "UZ", "860", "16", "", "", "", "40.48972", "68.78417", "Asia/Tashkent"),
("1513983", "Ghijduwon", "", "UZ", "860", "02", "", "", "", "40.1", "64.68333", "Asia/Samarkand"),
("1513996", "G'azalkent", "Газалкент", "UZ", "860", "14", "", "", "", "41.55806", "69.77083", "Asia/Tashkent"),
("1514011", "Gagarin", "Гагарин", "UZ", "860", "15", "", "", "", "40.66194", "68.17222", "Asia/Tashkent"),
("1514019", "Fergana", "Фергана", "UZ", "860", "03", "", "", "", "40.38421", "71.78432", "Asia/Tashkent"),
("1514125", "Dustlik", "", "UZ", "860", "15", "", "", "", "40.52472", "68.03583", "Asia/Tashkent"),
("1514192", "Chust Shahri", "Чуст", "UZ", "860", "06", "", "", "", "41.00936", "71.2287", "Asia/Tashkent"),
("1514210", "Chirchiq", "Чирчик", "UZ", "860", "14", "", "", "", "41.46889", "69.58222", "Asia/Tashkent"),
("1514215", "Chinoz", "Чиноз", "UZ", "860", "14", "", "", "", "40.93639", "68.76972", "Asia/Tashkent"),
("1514258", "Chortoq", "", "UZ", "860", "06", "", "", "", "41.06656", "71.85527", "Asia/Tashkent"),
("1514330", "Buka", "", "UZ", "860", "14", "", "", "", "40.81083", "69.19861", "Asia/Tashkent"),
("1514382", "Beshariq", "Бешарыкского", "UZ", "860", "03", "", "", "", "40.43583", "70.61028", "Asia/Tashkent"),
("1514387", "Beruniy", "Беруний", "UZ", "860", "09", "", "", "", "41.69111", "60.7525", "Asia/Samarkand"),
("1514396", "Bektemir", "Бектемир", "UZ", "860", "13", "", "", "", "41.20972", "69.33417", "Asia/Tashkent"),
("1514402", "Bekobod", "", "UZ", "860", "14", "", "", "", "40.22083", "69.26972", "Asia/Tashkent"),
("1514581", "Angren", "Ангрен", "UZ", "860", "14", "", "", "", "41.01667", "70.14361", "Asia/Tashkent"),
("1514588", "Andijon", "Андижан", "UZ", "860", "01", "", "", "", "40.78206", "72.34424", "Asia/Tashkent"),
("1514615", "Oltiariq", "", "UZ", "860", "03", "", "", "", "40.39194", "71.47417", "Asia/Tashkent"),
("1526979", "Quva", "Кува", "UZ", "860", "03", "", "", "", "40.52204", "72.07292", "Asia/Tashkent"),
("1538229", "Navoiy Shahri", "", "UZ", "860", "07", "1538229", "", "", "40.09294", "65.3712", "Asia/Samarkand"),
("3577430", "Road Town", "Род-Таун", "VG", "93", "00", "", "", "", "18.42693", "-64.62079", "America/Tortola"),
("8533874", "Tortola", "", "VG", "93", "", "", "", "", "18.43882", "-64.60382", "America/Tortola"),
("1560037", "Yen Vinh", "", "VN", "704", "58", "", "", "", "18.66667", "105.66667", "Asia/Ho_Chi_Minh"),
("1560349", "Yen Bai", "Йенбай", "VN", "704", "70", "", "", "", "21.72288", "104.9113", "Asia/Ho_Chi_Minh"),
("1562414", "Vung Tau", "Вунгтау", "VN", "704", "45", "", "", "", "10.34599", "107.08426", "Asia/Ho_Chi_Minh"),
("1562538", "Vi Thanh", "", "VN", "704", "93", "", "", "", "9.78444", "105.47306", "Asia/Ho_Chi_Minh"),
("1562548", "Vinh Yen", "", "VN", "704", "86", "", "", "", "21.30891", "105.60489", "Asia/Ho_Chi_Minh"),
("1562693", "Vinh Long", "", "VN", "704", "69", "", "", "", "10.25", "105.96667", "Asia/Ho_Chi_Minh"),
("1562798", "Vinh", "Винь", "VN", "704", "58", "", "", "", "18.67336", "105.69232", "Asia/Ho_Chi_Minh"),
("1562820", "Viet Tri", "", "VN", "704", "83", "", "", "", "21.32274", "105.40198", "Asia/Ho_Chi_Minh"),
("1563241", "Thanh Pho Uong Bi", "", "VN", "704", "30", "", "", "", "21.03433", "106.77049", "Asia/Ho_Chi_Minh"),
("1563281", "Tuy Hoa", "Туихоа", "VN", "704", "61", "", "", "", "13.09546", "109.32094", "Asia/Ho_Chi_Minh"),
("1563287", "Thanh Pho Tuyen Quang", "", "VN", "704", "68", "", "", "", "21.82356", "105.21424", "Asia/Ho_Chi_Minh"),
("1563926", "Tra Vinh", "", "VN", "704", "67", "", "", "", "9.93472", "106.34528", "Asia/Ho_Chi_Minh"),
("1565022", "Thu Dau Mot", "", "VN", "704", "75", "", "", "", "10.9804", "106.6519", "Asia/Ho_Chi_Minh"),
("1566083", "Ho Chi Minh City", "Хошимин", "VN", "704", "20", "", "", "", "10.82302", "106.62965", "Asia/Ho_Chi_Minh"),
("1566166", "Thanh Hoa", "", "VN", "704", "34", "", "", "", "19.8", "105.76667", "Asia/Ho_Chi_Minh"),
("1566319", "Thanh Pho Thai Nguyen", "Тай-Нгуен", "VN", "704", "85", "", "", "", "21.59422", "105.84817", "Asia/Ho_Chi_Minh"),
("1566346", "Thanh Pho Thai Binh", "", "VN", "704", "35", "", "", "", "20.45", "106.34002", "Asia/Ho_Chi_Minh"),
("1566559", "Tay Ninh", "", "VN", "704", "33", "", "", "", "11.31004", "106.09828", "Asia/Ho_Chi_Minh"),
("1567069", "Tan An", "Тан", "VN", "704", "24", "", "", "", "10.53589", "106.41366", "Asia/Ho_Chi_Minh"),
("1567148", "Tam Ky", "", "VN", "704", "84", "", "", "", "15.57364", "108.47403", "Asia/Ho_Chi_Minh"),
("1567621", "Son Tay", "Сон-Тай", "VN", "704", "44", "", "", "", "21.14053", "105.50686", "Asia/Ho_Chi_Minh"),
("1567681", "Son La", "Сон-Ла", "VN", "704", "32", "", "", "", "21.3256", "103.91882", "Asia/Ho_Chi_Minh"),
("1567723", "Song Cau", "", "VN", "704", "61", "", "", "", "13.4556", "109.22348", "Asia/Ho_Chi_Minh"),
("1567788", "Soc Trang", "Шокчанг", "VN", "704", "65", "", "", "", "9.60333", "105.98", "Asia/Ho_Chi_Minh"),
("1568043", "Sa Pa", "Шапа", "VN", "704", "90", "", "", "", "22.34023", "103.84415", "Asia/Ho_Chi_Minh"),
("1568212", "Sadek", "", "VN", "704", "09", "", "", "", "10.3", "105.76667", "Asia/Ho_Chi_Minh"),
("1568510", "Rach Gia", "", "VN", "704", "21", "", "", "", "10.01667", "105.08333", "Asia/Ho_Chi_Minh"),
("1568574", "Qui Nhon", "Куинён", "VN", "704", "46", "", "", "", "13.77648", "109.22367", "Asia/Ho_Chi_Minh"),
("1568770", "Quang Ngai", "Куангнгай", "VN", "704", "63", "", "", "", "15.12047", "108.79232", "Asia/Ho_Chi_Minh"),
("1569684", "Pleiku", "Плейку", "VN", "704", "49", "", "", "", "13.98333", "108", "Asia/Ho_Chi_Minh"),
("1570449", "Thanh Pho Phu Ly", "", "VN", "704", "80", "", "", "", "20.54531", "105.91221", "Asia/Ho_Chi_Minh"),
("1570549", "Phu Khuong", "", "VN", "704", "33", "", "", "", "11.28333", "106.13333", "Asia/Ho_Chi_Minh"),
("1571058", "Phan Thiet", "Фантьет", "VN", "704", "47", "", "", "", "10.92889", "108.10208", "Asia/Ho_Chi_Minh"),
("1571067", "Phan Rang-Thap Cham", "", "VN", "704", "60", "", "", "", "11.56432", "108.98858", "Asia/Ho_Chi_Minh"),
("1571968", "Thanh Pho Ninh Binh", "", "VN", "704", "59", "", "", "", "20.25808", "105.97965", "Asia/Ho_Chi_Minh"),
("1572151", "Nha Trang", "Нячанг", "VN", "704", "54", "", "", "", "12.24507", "109.19432", "Asia/Ho_Chi_Minh"),
("1573517", "Thanh Pho Nam Dinh", "Намдинь", "VN", "704", "82", "", "", "", "20.43389", "106.17729", "Asia/Ho_Chi_Minh"),
("1574023", "My Tho", "", "VN", "704", "37", "", "", "", "10.36004", "106.35996", "Asia/Ho_Chi_Minh"),
("1574507", "Mong Cai", "", "VN", "704", "30", "", "", "", "21.52471", "107.9662", "Asia/Ho_Chi_Minh"),
("1575627", "Long Xuyen", "", "VN", "704", "01", "", "", "", "10.38639", "105.43518", "Asia/Ho_Chi_Minh"),
("1576303", "Lao Cai", "Лаокай", "VN", "704", "90", "", "", "", "22.48556", "103.97066", "Asia/Ho_Chi_Minh"),
("1576633", "Thanh Pho Lang Son", "", "VN", "704", "39", "", "", "", "21.85264", "106.76101", "Asia/Ho_Chi_Minh"),
("1577995", "La Gi", "", "VN", "704", "47", "", "", "", "10.65993", "107.77206", "Asia/Ho_Chi_Minh"),
("1578500", "Kon Tum", "", "VN", "704", "55", "", "", "", "14.35452", "108.00759", "Asia/Ho_Chi_Minh"),
("1580142", "Hung Yen", "", "VN", "704", "81", "", "", "", "20.64637", "106.05112", "Asia/Ho_Chi_Minh"),
("1580240", "Hue", "Хюэ", "VN", "704", "66", "", "", "", "16.4619", "107.59546", "Asia/Ho_Chi_Minh"),
("1580410", "Thanh Pho Ha Long", "Халонг", "VN", "704", "30", "", "", "", "20.95045", "107.07336", "Asia/Ho_Chi_Minh"),
("1580541", "Hoi An", "Хой", "VN", "704", "84", "", "", "", "15.87944", "108.335", "Asia/Ho_Chi_Minh"),
("1580830", "Thanh Pho Hoa Binh", "", "VN", "704", "53", "", "", "", "20.81717", "105.33759", "Asia/Ho_Chi_Minh"),
("1581047", "Ha Tinh", "Хатинь", "VN", "704", "52", "", "", "", "18.34282", "105.9057", "Asia/Ho_Chi_Minh"),
("1581052", "Ha Tien", "Хатьен", "VN", "704", "21", "", "", "", "10.38333", "104.48333", "Asia/Ho_Chi_Minh"),
("1581130", "Hanoi", "Ханой", "VN", "704", "44", "", "", "", "21.0245", "105.84117", "Asia/Ho_Chi_Minh"),
("1581298", "Haiphong", "Хайфон", "VN", "704", "13", "", "", "", "20.86481", "106.68345", "Asia/Ho_Chi_Minh"),
("1581326", "Thanh Pho Hai Duong", "Хайзыонг", "VN", "704", "79", "", "", "", "20.94099", "106.33302", "Asia/Ho_Chi_Minh"),
("1581349", "Thanh Pho Ha Giang", "", "VN", "704", "50", "", "", "", "22.82333", "104.98357", "Asia/Ho_Chi_Minh"),
("1581364", "Ha Dong", "", "VN", "704", "44", "", "", "", "20.97136", "105.77876", "Asia/Ho_Chi_Minh"),
("1582436", "Don Luan", "", "VN", "704", "76", "", "", "", "11.53495", "106.88324", "Asia/Ho_Chi_Minh"),
("1582886", "Kwang Binh", "Донгхой", "VN", "704", "62", "", "", "", "17.46885", "106.62226", "Asia/Ho_Chi_Minh"),
("1582926", "Dong Ha", "", "VN", "704", "64", "", "", "", "16.81625", "107.10031", "Asia/Ho_Chi_Minh"),
("1583477", "Dien Bien Phu", "Дьен Бьен Фу", "VN", "704", "92", "", "", "", "21.38602", "103.02301", "Asia/Ho_Chi_Minh"),
("1583992", "Da Nang", "", "VN", "704", "78", "", "", "", "16.06778", "108.22083", "Asia/Ho_Chi_Minh"),
("1584071", "Da Lat", "Далат", "VN", "704", "23", "", "", "", "11.94646", "108.44193", "Asia/Ho_Chi_Minh"),
("1584661", "Cu Chi", "Ку-Чи", "VN", "704", "20", "", "", "", "10.96667", "106.46667", "Asia/Ho_Chi_Minh"),
("1585660", "Cho Dok", "", "VN", "704", "01", "", "", "", "10.7", "105.11667", "Asia/Ho_Chi_Minh"),
("1586052", "Cat Ba", "Кат Ба", "VN", "704", "13", "", "", "", "20.72779", "107.04819", "Asia/Ho_Chi_Minh"),
("1586151", "Cao Lanh", "", "VN", "704", "09", "", "", "", "10.45", "105.63333", "Asia/Ho_Chi_Minh"),
("1586185", "Thanh Pho Cao Bang", "Каобанг", "VN", "704", "05", "", "", "", "22.66568", "106.25786", "Asia/Ho_Chi_Minh"),
("1586203", "Can Tho", "", "VN", "704", "87", "", "", "", "10.03333", "105.78333", "Asia/Ho_Chi_Minh"),
("1586288", "Can Gio", "", "VN", "704", "20", "", "", "", "10.41667", "106.96667", "Asia/Ho_Chi_Minh"),
("1586296", "Can Giuoc", "", "VN", "704", "24", "", "", "", "10.60857", "106.67134", "Asia/Ho_Chi_Minh"),
("1586350", "Cam Ranh", "Камрань", "VN", "704", "54", "", "", "", "11.92144", "109.15913", "Asia/Ho_Chi_Minh"),
("1586357", "Cam Pha Mines", "", "VN", "704", "30", "", "", "", "21.01667", "107.3", "Asia/Ho_Chi_Minh"),
("1586443", "Ca Mau", "Камау", "VN", "704", "77", "", "", "", "9.17694", "105.15", "Asia/Ho_Chi_Minh"),
("1586896", "Buon Ma Thuot", "", "VN", "704", "88", "", "", "", "12.66747", "108.03775", "Asia/Ho_Chi_Minh"),
("1587919", "Bim Son", "", "VN", "704", "34", "", "", "", "20.07806", "105.86028", "Asia/Ho_Chi_Minh"),
("1587923", "Bien Hoa", "", "VN", "704", "43", "", "", "", "10.94469", "106.82432", "Asia/Ho_Chi_Minh"),
("1587976", "Ben Tre", "", "VN", "704", "03", "", "", "", "10.23333", "106.38333", "Asia/Ho_Chi_Minh"),
("1591449", "Bac Ninh", "", "VN", "704", "74", "", "", "", "21.18608", "106.07632", "Asia/Ho_Chi_Minh"),
("1591474", "Thanh pho Bac Lieu", "", "VN", "704", "73", "", "", "", "9.29414", "105.72776", "Asia/Ho_Chi_Minh"),
("1591527", "Bac Giang", "", "VN", "704", "71", "", "", "", "21.27307", "106.1946", "Asia/Ho_Chi_Minh"),
("1591538", "Bac Kan", "", "VN", "704", "72", "", "", "", "22.14701", "105.83481", "Asia/Ho_Chi_Minh"),
("8991407", "GJinh Van", "Динь Ван", "VN", "704", "23", "", "", "", "11.78624", "108.24282", "Asia/Ho_Chi_Minh"),
("69426", "Zinjibar", "", "YE", "887", "01", "1210", "", "", "13.12871", "45.38073", "Asia/Aden"),
("69500", "Zabid", "Забид", "YE", "887", "08", "1824", "", "", "14.1951", "43.31518", "Asia/Aden"),
("69559", "Yarim", "Ярим", "YE", "887", "23", "1102", "", "", "14.29804", "44.37795", "Asia/Aden"),
("70225", "Ta`izz", "Таиз", "YE", "887", "25", "1520", "", "", "13.57952", "44.02091", "Asia/Aden"),
("70979", "Sayyan", "", "YE", "887", "16", "2305", "", "", "15.17177", "44.32442", "Asia/Aden"),
("71137", "Sanaa", "Сана", "YE", "887", "16", "", "", "", "15.35472", "44.20667", "Asia/Aden"),
("71273", "Sahar", "", "YE", "887", "16", "2305", "", "", "15.31586", "44.30858", "Asia/Aden"),
("71334", "Sa'dah", "", "YE", "887", "15", "2215", "", "", "16.94021", "43.76394", "Asia/Aden"),
("72968", "Ma'rib", "Мариб", "YE", "887", "14", "2612", "", "", "15.46253", "45.32581", "Asia/Aden"),
("73560", "Lahij", "Лахыдж", "YE", "887", "24", "2514", "", "", "13.05667", "44.88194", "Asia/Aden"),
("74477", "Ibb", "", "YE", "887", "23", "1118", "", "", "13.96667", "44.18333", "Asia/Aden"),
("75337", "Hajjah", "Хадж", "YE", "887", "22", "1728", "", "", "15.69425", "43.60582", "Asia/Aden"),
("76154", "Dhi as Sufal", "", "YE", "887", "23", "1116", "", "", "13.83446", "44.11469", "Asia/Aden"),
("76184", "Dhamar", "", "YE", "887", "11", "2008", "", "", "14.54274", "44.40514", "Asia/Aden"),
("76991", "Bayt al Faqih", "", "YE", "887", "08", "1817", "", "", "14.51635", "43.32446", "Asia/Aden"),
("77408", "Bajil", "", "YE", "887", "08", "1810", "", "", "15.05835", "43.28506", "Asia/Aden"),
("77726", "Ataq", "", "YE", "887", "05", "2113", "", "", "14.53766", "46.83187", "Asia/Aden"),
("78428", "'Amran", "", "YE", "887", "19", "2915", "", "", "15.6594", "43.94385", "Asia/Aden"),
("78754", "Al Mukalla", "Аль-Мукалла", "YE", "887", "04", "1929", "", "", "14.54248", "49.12424", "Asia/Aden"),
("79415", "Al Hudaydah", "", "YE", "887", "08", "1821", "", "", "14.79781", "42.95452", "Asia/Aden"),
("79455", "Al Hazm", "", "YE", "887", "21", "1605", "", "", "16.16406", "44.77692", "Asia/Aden"),
("79836", "Al Bayda'", "", "YE", "887", "20", "1409", "", "", "13.98523", "45.57272", "Asia/Aden"),
("415189", "Aden", "Аден", "YE", "887", "02", "2407", "", "", "12.77944", "45.03667", "Asia/Aden"),
("936374", "Roodepoort", "", "ZA", "710", "06", "JHB", "JHB", "", "-26.1625", "27.8725", "Africa/Johannesburg"),
("937136", "Zeerust", "", "ZA", "710", "10", "DC38", "NW385", "", "-25.53695", "26.07512", "Africa/Johannesburg"),
("938457", "Wolmaransstad", "", "ZA", "710", "10", "DC40", "NW404", "", "-27.1974", "25.98311", "Africa/Johannesburg"),
("938694", "White River", "", "ZA", "710", "07", "DC32", "MP322", "", "-25.33177", "31.01166", "Africa/Johannesburg"),
("939270", "Witbank", "", "ZA", "710", "07", "DC31", "MP312", "", "-25.87133", "29.23323", "Africa/Johannesburg"),
("940316", "Westonaria", "Вестонария", "ZA", "710", "06", "DC48", "GT483", "", "-26.31906", "27.6486", "Africa/Johannesburg"),
("940424", "Wesselsbron", "", "ZA", "710", "03", "DC18", "FS185", "", "-27.8549", "26.36583", "Africa/Johannesburg"),
("940909", "Welkom", "", "ZA", "710", "03", "DC18", "FS184", "", "-27.97742", "26.73506", "Africa/Johannesburg"),
("941931", "Warrenton", "", "ZA", "710", "08", "DC9", "NC093", "", "-28.11396", "24.84753", "Africa/Johannesburg"),
("941966", "Warmbaths", "", "ZA", "710", "09", "DC36", "LIM366", "", "-24.88333", "28.28333", "Africa/Johannesburg"),
("942470", "Vryheid", "", "ZA", "710", "02", "DC26", "KZN263", "", "-27.76952", "30.79165", "Africa/Johannesburg"),
("942511", "Vryburg", "Фрейбурга", "ZA", "710", "10", "DC39", "NW392", "", "-26.95659", "24.7284", "Africa/Johannesburg"),
("943032", "Volksrust", "", "ZA", "710", "07", "DC30", "MP304", "", "-27.36542", "29.88175", "Africa/Johannesburg"),
("943882", "Virginia", "Вирджиния", "ZA", "710", "03", "DC18", "FS184", "", "-28.10391", "26.86593", "Africa/Johannesburg"),
("943960", "Viljoenskroon", "", "ZA", "710", "03", "DC20", "FS201", "", "-27.20841", "26.94855", "Africa/Johannesburg"),
("944385", "Vereeniging", "Феринихинг", "ZA", "710", "06", "DC42", "GT421", "", "-26.67313", "27.92615", "Africa/Johannesburg"),
("944986", "Vanderbijlpark", "", "ZA", "710", "06", "DC42", "GT421", "", "-26.71171", "27.83795", "Africa/Johannesburg"),
("945945", "Upington", "Апингтон", "ZA", "710", "08", "DC8", "NC083", "", "-28.44776", "21.25612", "Africa/Johannesburg"),
("946058", "Mthatha", "Умтата", "ZA", "710", "05", "DC15", "EC157", "", "-31.58893", "28.78443", "Africa/Johannesburg"),
("946128", "Umkomaas", "", "ZA", "710", "02", "ETH", "ETH", "", "-30.20674", "30.79776", "Africa/Johannesburg"),
("946257", "Ulundi", "Улунди", "ZA", "710", "02", "DC26", "KZN266", "", "-28.33523", "31.41617", "Africa/Johannesburg"),
("946877", "Uitenhage", "", "ZA", "710", "05", "NMA", "NMA", "", "-33.75757", "25.3971", "Africa/Johannesburg"),
("946973", "Tzaneen", "", "ZA", "710", "09", "DC33", "LIM333", "", "-23.83322", "30.16351", "Africa/Johannesburg"),
("949224", "Thohoyandou", "", "ZA", "710", "09", "DC34", "LIM343", "", "-22.94564", "30.48497", "Africa/Johannesburg"),
("949282", "Theunissen", "Тениссен", "ZA", "710", "03", "DC18", "FS181", "", "-28.41098", "26.70107", "Africa/Johannesburg"),
("949703", "Thaba Nchu", "", "ZA", "710", "03", "MAN", "MAN", "", "-29.20932", "26.83898", "Africa/Johannesburg"),
("949880", "Tembisa", "", "ZA", "710", "06", "EKU", "EKU", "", "-25.99636", "28.2268", "Africa/Johannesburg"),
("951650", "Stutterheim", "", "ZA", "710", "05", "DC12", "EC124", "", "-32.57076", "27.42396", "Africa/Johannesburg"),
("952192", "Stilfontein", "", "ZA", "710", "10", "DC40", "NW403", "", "-26.84493", "26.76829", "Africa/Johannesburg"),
("952734", "Stanger", "", "ZA", "710", "02", "DC29", "KZN292", "", "-29.32816", "31.28954", "Africa/Johannesburg"),
("952747", "Standerton", "", "ZA", "710", "07", "DC30", "MP305", "", "-26.93366", "29.24152", "Africa/Johannesburg"),
("952865", "Springs", "", "ZA", "710", "06", "EKU", "EKU", "", "-26.25", "28.4", "Africa/Johannesburg"),
("953781", "Soweto", "Соуэто", "ZA", "710", "06", "JHB", "JHB", "", "-26.26781", "27.85849", "Africa/Johannesburg"),
("954161", "Somerset East", "", "ZA", "710", "05", "DC10", "EC102", "", "-32.72173", "25.58804", "Africa/Johannesburg"),
("955313", "Siyabuswa", "", "ZA", "710", "07", "DC31", "MP316", "", "-25.11319", "29.04454", "Africa/Johannesburg"),
("956507", "Senekal", "", "ZA", "710", "03", "DC19", "FS191", "", "-28.31971", "27.62082", "Africa/Johannesburg"),
("956767", "Secunda", "Секунда", "ZA", "710", "07", "DC30", "MP307", "", "-26.55", "29.16667", "Africa/Johannesburg"),
("956878", "Scottburgh", "", "ZA", "710", "02", "DC21", "KZN212", "", "-30.28666", "30.75316", "Africa/Johannesburg"),
("956907", "Schweizer-Reneke", "", "ZA", "710", "10", "DC39", "NW393", "", "-27.18871", "25.32931", "Africa/Johannesburg"),
("957487", "Sasolburg", "", "ZA", "710", "03", "DC20", "FS204", "", "-26.81358", "27.81695", "Africa/Johannesburg"),
("958724", "Rustenburg", "Рюстенбург", "ZA", "710", "10", "DC37", "NW373", "", "-25.66756", "27.24208", "Africa/Johannesburg"),
("962330", "Richmond", "", "ZA", "710", "02", "DC22", "KZN227", "", "-29.87196", "30.27235", "Africa/Johannesburg"),
("962367", "Richards Bay", "Ричардс-Бей", "ZA", "710", "02", "DC28", "KZN282", "", "-28.78301", "32.03768", "Africa/Johannesburg"),
("962847", "Reitz", "", "ZA", "710", "03", "DC19", "FS193", "", "-27.80138", "28.42726", "Africa/Johannesburg"),
("963230", "Randfontein", "", "ZA", "710", "06", "DC48", "GT482", "", "-26.1844", "27.70203", "Africa/Johannesburg"),
("963516", "Queenstown", "Квинстаун", "ZA", "710", "05", "DC13", "EC134", "", "-31.89756", "26.87533", "Africa/Johannesburg"),
("963525", "Queensdale", "", "ZA", "710", "05", "DC13", "EC134", "", "-31.87101", "26.97862", "Africa/Johannesburg"),
("964137", "Pretoria", "Претория", "ZA", "710", "06", "TSH", "TSH", "", "-25.74486", "28.18783", "Africa/Johannesburg"),
("964315", "Mokopane", "Потгитерсрус", "ZA", "710", "09", "DC36", "LIM367", "", "-24.19436", "29.00974", "Africa/Johannesburg"),
("964349", "Potchefstroom", "Почефструм", "ZA", "710", "10", "DC40", "NW402", "", "-26.71667", "27.1", "Africa/Johannesburg"),
("964406", "Port Shepstone", "", "ZA", "710", "02", "DC21", "KZN216", "", "-30.74137", "30.45499", "Africa/Johannesburg"),
("964420", "Port Elizabeth", "Порт-Элизабет", "ZA", "710", "05", "NMA", "NMA", "", "-33.91799", "25.57007", "Africa/Johannesburg"),
("964432", "Port Alfred", "", "ZA", "710", "05", "DC10", "EC105", "", "-33.59057", "26.89104", "Africa/Johannesburg"),
("964712", "Plettenberg Bay", "", "ZA", "710", "11", "DC4", "WC047", "", "-34.05274", "23.3716", "Africa/Johannesburg"),
("965241", "Piet Retief", "", "ZA", "710", "07", "DC30", "MP303", "", "-27.00706", "30.81323", "Africa/Johannesburg"),
("965289", "Polokwane", "Полокване", "ZA", "710", "09", "DC35", "LIM354", "", "-23.90448", "29.46885", "Africa/Johannesburg"),
("965301", "Pietermaritzburg", "Питермарицбург", "ZA", "710", "02", "DC22", "KZN225", "", "-29.61678", "30.39278", "Africa/Johannesburg"),
("965401", "Phuthaditjhaba", "", "ZA", "710", "03", "DC19", "FS194", "", "-28.52423", "28.81582", "Africa/Johannesburg"),
("965528", "Phalaborwa", "Палаборва", "ZA", "710", "09", "DC33", "LIM334", "", "-23.94299", "31.14107", "Africa/Johannesburg"),
("966166", "Parys", "Парис", "ZA", "710", "03", "DC20", "FS203", "", "-26.9033", "27.45727", "Africa/Johannesburg"),
("966380", "Pampierstad", "", "ZA", "710", "10", "", "", "", "-27.78324", "24.68768", "Africa/Johannesburg"),
("967106", "Oudtshoorn", "", "ZA", "710", "11", "DC4", "WC045", "", "-33.59067", "22.2014", "Africa/Johannesburg"),
("967476", "Orkney", "Оркнейские", "ZA", "710", "10", "DC40", "NW403", "", "-26.98023", "26.67272", "Africa/Johannesburg"),
("968665", "Modimolle", "", "ZA", "710", "09", "DC36", "LIM365", "", "-24.7", "28.4", "Africa/Johannesburg"),
("970341", "Nkowakowa", "", "ZA", "710", "09", "DC33", "LIM333", "", "-23.88782", "30.28708", "Africa/Johannesburg"),
("970566", "Nigel", "Найджел", "ZA", "710", "06", "EKU", "EKU", "", "-26.43138", "28.47713", "Africa/Johannesburg"),
("971421", "Newcastle", "", "ZA", "710", "02", "DC25", "KZN252", "", "-27.75796", "29.9318", "Africa/Johannesburg"),
("971534", "Nelspruit", "Мбомбела", "ZA", "710", "07", "DC32", "MP322", "", "-25.47448", "30.97033", "Africa/Johannesburg"),
("973111", "Mpumalanga", "", "ZA", "710", "02", "ETH", "ETH", "", "-29.81292", "30.63646", "Africa/Johannesburg"),
("973139", "Mpophomeni", "", "ZA", "710", "02", "DC22", "KZN222", "", "-29.56822", "30.18618", "Africa/Johannesburg"),
("973709", "Mossel Bay", "Моссел-Бей", "ZA", "710", "11", "DC4", "WC043", "", "-34.18307", "22.14605", "Africa/Johannesburg"),
("974670", "Mondlo", "", "ZA", "710", "02", "DC26", "KZN263", "", "-27.98299", "30.71769", "Africa/Johannesburg"),
("975436", "Mmabatho", "", "ZA", "710", "10", "DC38", "NW383", "", "-25.85", "25.63333", "Africa/Johannesburg"),
("976358", "Middelburg", "", "ZA", "710", "05", "DC13", "EC131", "", "-31.49285", "25.00633", "Africa/Johannesburg"),
("976361", "Middelburg", "", "ZA", "710", "07", "DC31", "MP313", "", "-25.77507", "29.46482", "Africa/Johannesburg"),
("976885", "Messina", "", "ZA", "710", "09", "DC34", "LIM341", "", "-22.35131", "30.0396", "Africa/Johannesburg"),
("978895", "Margate", "", "ZA", "710", "02", "DC21", "KZN216", "", "-30.8636", "30.37052", "Africa/Johannesburg"),
("980921", "Mabopane", "", "ZA", "710", "06", "TSH", "TSH", "", "-25.49768", "28.10065", "Africa/Johannesburg"),
("981158", "Lydenburg", "", "ZA", "710", "07", "DC32", "MP321", "", "-25.0978", "30.45967", "Africa/Johannesburg"),
("981827", "Louis Trichardt", "", "ZA", "710", "09", "DC34", "LIM344", "", "-23.04385", "29.90319", "Africa/Johannesburg"),
("982899", "Lichtenburg", "Лихтенбурге", "ZA", "710", "10", "DC38", "NW384", "", "-26.152", "26.15968", "Africa/Johannesburg"),
("984087", "Lebowakgomo", "", "ZA", "710", "09", "DC35", "LIM354", "", "-24.2", "29.5", "Africa/Johannesburg"),
("985011", "Lady Frere", "", "ZA", "710", "05", "DC13", "EC136", "", "-31.70312", "27.2329", "Africa/Johannesburg"),
("985015", "Ladybrand", "", "ZA", "710", "03", "DC19", "FS196", "", "-29.19448", "27.45739", "Africa/Johannesburg"),
("986083", "Kutloanong", "", "ZA", "710", "03", "DC18", "FS184", "", "-27.83333", "26.75", "Africa/Johannesburg"),
("986717", "Kruisfontein", "", "ZA", "710", "05", "DC10", "EC108", "", "-34.00333", "24.73142", "Africa/Johannesburg"),
("986822", "Krugersdorp", "Крюгерсдорпа", "ZA", "710", "06", "DC48", "GT481", "", "-26.08577", "27.77515", "Africa/Johannesburg"),
("986846", "Kroonstad", "", "ZA", "710", "03", "DC20", "FS201", "", "-27.65036", "27.23488", "Africa/Johannesburg"),
("987202", "Kriel", "", "ZA", "710", "07", "DC31", "MP312", "", "-26.27391", "29.2253", "Africa/Johannesburg"),
("988290", "Komatipoort", "", "ZA", "710", "07", "DC32", "MP324", "", "-25.4332", "31.95478", "Africa/Johannesburg"),
("988356", "Kokstad", "", "ZA", "710", "02", "DC43", "KZN433", "", "-30.54723", "29.42412", "Africa/Johannesburg"),
("988698", "Knysna", "Найсна", "ZA", "710", "11", "DC4", "WC048", "", "-34.03627", "23.04713", "Africa/Johannesburg"),
("989921", "Klerksdorp", "Клерксдорп", "ZA", "710", "10", "DC40", "NW403", "", "-26.85213", "26.66672", "Africa/Johannesburg"),
("990930", "Kimberley", "Кимберли", "ZA", "710", "08", "DC9", "NC091", "", "-28.73226", "24.76232", "Africa/Johannesburg"),
("993800", "Johannesburg", "Йоханнесбург", "ZA", "710", "06", "JHB", "JHB", "", "-26.20227", "28.04363", "Africa/Johannesburg"),
("995202", "Howick", "", "ZA", "710", "02", "DC22", "KZN222", "", "-29.47795", "30.23057", "Africa/Johannesburg"),
("996918", "Hennenman", "", "ZA", "710", "03", "DC18", "FS184", "", "-27.97654", "27.02423", "Africa/Johannesburg"),
("996930", "Hendrina", "", "ZA", "710", "07", "DC31", "MP313", "", "-26.15881", "29.71528", "Africa/Johannesburg"),
("997140", "Heilbron", "", "ZA", "710", "03", "DC20", "FS203", "", "-27.28115", "27.9709", "Africa/Johannesburg"),
("997151", "Heidelberg", "Гейдельберг", "ZA", "710", "06", "DC42", "GT423", "", "-26.50476", "28.35921", "Africa/Johannesburg"),
("997751", "Harrismith", "", "ZA", "710", "03", "DC19", "FS194", "", "-28.27276", "29.12946", "Africa/Johannesburg"),
("1000501", "Grahamstown", "Грэхэмстаун", "ZA", "710", "05", "DC10", "EC104", "", "-33.30422", "26.53276", "Africa/Johannesburg"),
("1000543", "Graaff-Reinet", "Храфф-Рейнет", "ZA", "710", "05", "DC10", "EC101", "", "-32.25215", "24.53075", "Africa/Johannesburg"),
("1001860", "Giyani", "", "ZA", "710", "09", "DC33", "LIM331", "", "-23.30246", "30.71868", "Africa/Johannesburg"),
("1002145", "George", "Джордж", "ZA", "710", "11", "DC4", "WC044", "", "-33.963", "22.46173", "Africa/Johannesburg"),
("1002851", "Ga-Rankuwa", "", "ZA", "710", "10", "", "", "", "-25.61692", "27.99471", "Africa/Johannesburg"),
("1003953", "Fort Beaufort", "", "ZA", "710", "05", "DC12", "EC127", "", "-32.77477", "26.63376", "Africa/Johannesburg"),
("1004109", "Fochville", "", "ZA", "710", "10", "", "", "", "-26.48862", "27.49387", "Africa/Johannesburg"),
("1005029", "eSikhawini", "", "ZA", "710", "02", "DC28", "KZN282", "", "-28.87097", "31.89961", "Africa/Johannesburg"),
("1005125", "Ermelo", "Эрмело", "ZA", "710", "07", "DC30", "MP302", "", "-26.53333", "29.98333", "Africa/Johannesburg"),
("1005544", "Empangeni", "", "ZA", "710", "02", "DC28", "KZN282", "", "-28.76197", "31.89329", "Africa/Johannesburg"),
("1005646", "eMbalenhle", "", "ZA", "710", "07", "DC30", "MP307", "", "-26.53333", "29.06667", "Africa/Johannesburg"),
("1006984", "East London", "Ист-Лондон", "ZA", "710", "05", "BUF", "BUF", "", "-33.01529", "27.91162", "Africa/Johannesburg"),
("1007311", "Durban", "Дурбан", "ZA", "710", "02", "ETH", "ETH", "", "-29.8579", "31.0292", "Africa/Johannesburg"),
("1007400", "Dundee", "Данди", "ZA", "710", "02", "DC24", "KZN241", "", "-28.16678", "30.23371", "Africa/Johannesburg"),
("1007514", "Duiwelskloof", "", "ZA", "710", "09", "DC33", "LIM332", "", "-23.69339", "30.14002", "Africa/Johannesburg"),
("1008261", "Driefontein", "", "ZA", "710", "07", "DC30", "MP303", "", "-27.0177", "30.44979", "Africa/Johannesburg"),
("1011031", "Delmas", "Дельмас", "ZA", "710", "07", "DC31", "MP311", "", "-26.1466", "28.68322", "Africa/Johannesburg"),
("1011632", "De Aar", "", "ZA", "710", "08", "DC7", "NC073", "", "-30.64966", "24.0123", "Africa/Johannesburg"),
("1012413", "Cullinan", "Куллинан", "ZA", "710", "06", "TSH", "TSH", "", "-25.67088", "28.52364", "Africa/Johannesburg"),
("1012600", "Cradock", "", "ZA", "710", "05", "DC13", "EC131", "", "-32.16422", "25.61918", "Africa/Johannesburg"),
("1013550", "Christiana", "", "ZA", "710", "10", "DC39", "NW396", "", "-27.91402", "25.16111", "Africa/Johannesburg"),
("1014073", "Carletonville", "", "ZA", "710", "06", "DC48", "GT484", "", "-26.36094", "27.39767", "Africa/Johannesburg"),
("1014489", "Butterworth", "Баттерворта", "ZA", "710", "05", "DC12", "EC122", "", "-32.33083", "28.14981", "Africa/Johannesburg"),
("1015504", "Bronkhorstspruit", "", "ZA", "710", "06", "TSH", "TSH", "", "-25.81015", "28.74248", "Africa/Johannesburg"),
("1015621", "Brits", "Британцы", "ZA", "710", "10", "DC37", "NW372", "", "-25.63473", "27.78022", "Africa/Johannesburg"),
("1016181", "Brakpan", "", "ZA", "710", "06", "EKU", "EKU", "", "-26.23656", "28.36938", "Africa/Johannesburg"),
("1016670", "Botshabelo", "", "ZA", "710", "03", "MAN", "MAN", "", "-29.27016", "26.7052", "Africa/Johannesburg"),
("1016698", "Bothaville", "Ботавилль", "ZA", "710", "03", "DC18", "FS185", "", "-27.3887", "26.61701", "Africa/Johannesburg"),
("1017780", "Boksburg", "", "ZA", "710", "06", "EKU", "EKU", "", "-26.21197", "28.25958", "Africa/Johannesburg"),
("1018673", "Bloemhof", "", "ZA", "710", "10", "DC39", "NW396", "", "-27.64686", "25.60697", "Africa/Johannesburg"),
("1018725", "Bloemfontein", "Блумфонтейн", "ZA", "710", "03", "MAN", "MAN", "", "-29.12106", "26.214", "Africa/Johannesburg"),
("1019330", "Bhisho", "Бишо", "ZA", "710", "05", "BUF", "BUF", "", "-32.84721", "27.44218", "Africa/Johannesburg"),
("1019704", "Bethlehem", "Вифлеем", "ZA", "710", "03", "DC19", "FS192", "", "-28.23078", "28.30707", "Africa/Johannesburg"),
("1019760", "Bethal", "", "ZA", "710", "07", "DC30", "MP307", "", "-26.45794", "29.46553", "Africa/Johannesburg"),
("1020098", "Benoni", "Бенони", "ZA", "710", "06", "EKU", "EKU", "", "-26.18848", "28.32078", "Africa/Johannesburg"),
("1020641", "Beaufort West", "", "ZA", "710", "11", "DC5", "WC053", "", "-32.35671", "22.58295", "Africa/Johannesburg"),
("1021086", "Barberton", "", "ZA", "710", "07", "DC32", "MP323", "", "-25.78842", "31.05319", "Africa/Johannesburg"),
("1021360", "Ballitoville", "", "ZA", "710", "02", "DC29", "KZN292", "", "-29.53897", "31.21439", "Africa/Johannesburg"),
("1021396", "Balfour", "Бальфур", "ZA", "710", "07", "DC30", "MP306", "", "-26.66331", "28.59016", "Africa/Johannesburg"),
("1023287", "Allanridge", "", "ZA", "710", "03", "DC18", "FS184", "", "-27.75431", "26.64382", "Africa/Johannesburg"),
("1023309", "Aliwal North", "", "ZA", "710", "05", "DC14", "EC143", "", "-30.69366", "26.71141", "Africa/Johannesburg"),
("1105726", "Ekangala", "", "ZA", "710", "06", "TSH", "TSH", "", "-25.69619", "28.74918", "Africa/Johannesburg"),
("1105776", "Midrand", "Мидранд", "ZA", "710", "06", "JHB", "JHB", "", "-25.98953", "28.12843", "Africa/Johannesburg"),
("1105777", "Centurion", "Центурион", "ZA", "710", "06", "TSH", "TSH", "", "-25.85891", "28.18577", "Africa/Johannesburg"),
("3359041", "Worcester", "Вустер", "ZA", "710", "11", "DC2", "WC025", "", "-33.64651", "19.44852", "Africa/Johannesburg"),
("3361025", "Stellenbosch", "Стелленбос", "ZA", "710", "11", "DC2", "WC024", "", "-33.93462", "18.86676", "Africa/Johannesburg"),
("3361934", "Saldanha", "Салдана", "ZA", "710", "11", "DC1", "WC014", "", "-33.01167", "17.9442", "Africa/Johannesburg"),
("3363613", "Noorder-Paarl", "", "ZA", "710", "11", "DC2", "WC023", "", "-33.70468", "18.96552", "Africa/Johannesburg"),
("3364346", "Malmesbury", "", "ZA", "710", "11", "DC1", "WC015", "", "-33.4608", "18.72714", "Africa/Johannesburg"),
("3364682", "Lansdowne", "", "ZA", "710", "11", "CPT", "CPT", "", "-33.98735", "18.49746", "Africa/Johannesburg"),
("3365083", "Kraaifontein", "", "ZA", "710", "11", "CPT", "CPT", "", "-33.84808", "18.71724", "Africa/Johannesburg"),
("3366880", "Hermanus", "", "ZA", "710", "11", "DC3", "WC032", "", "-34.4187", "19.23446", "Africa/Johannesburg"),
("3367513", "Grabouw", "", "ZA", "710", "11", "DC3", "WC031", "", "-34.15152", "19.01509", "Africa/Johannesburg"),
("3369129", "Ceres", "Церера", "ZA", "710", "11", "DC2", "WC022", "", "-33.36889", "19.31096", "Africa/Johannesburg"),
("3369157", "Cape Town", "Кейптаун", "ZA", "710", "11", "CPT", "CPT", "", "-33.92584", "18.42322", "Africa/Johannesburg"),
("3370352", "Atlantis", "Атлантида", "ZA", "710", "11", "CPT", "CPT", "", "-33.56668", "18.48335", "Africa/Johannesburg"),
("7302802", "Rondebosch", "", "ZA", "710", "11", "CPT", "CPT", "", "-33.96333", "18.47639", "Africa/Johannesburg"),
("8604596", "Retreat", "", "ZA", "710", "11", "CPT", "CPT", "", "-34.05515", "18.47617", "Africa/Johannesburg"),
("8764562", "Diepsloot", "", "ZA", "710", "06", "JHB", "JHB", "", "-25.93312", "28.01213", "Africa/Johannesburg"),
("175499", "Nchelenge", "Нчеленге", "ZM", "894", "04", "", "", "", "-9.34506", "28.73396", "Africa/Lusaka"),
("176146", "Mbala", "Мбала", "ZM", "894", "05", "", "", "", "-8.84024", "31.36587", "Africa/Lusaka"),
("176555", "Kawambwa", "", "ZM", "894", "04", "", "", "", "-9.7915", "29.07913", "Africa/Lusaka"),
("898188", "Siavonga", "", "ZM", "894", "07", "", "", "", "-16.53818", "28.70876", "Africa/Lusaka"),
("898905", "Sesheke", "Шешеке", "ZM", "894", "01", "", "", "", "-17.47593", "24.29684", "Africa/Lusaka"),
("899274", "Samfya", "", "ZM", "894", "04", "", "", "", "-11.36491", "29.55652", "Africa/Lusaka"),
("899825", "Petauke", "", "ZM", "894", "03", "", "", "", "-14.24264", "31.3253", "Africa/Lusaka"),
("901344", "Ndola", "Ндола", "ZM", "894", "08", "", "", "", "-12.95867", "28.63659", "Africa/Lusaka"),
("904422", "Mumbwa", "", "ZM", "894", "02", "", "", "", "-14.98293", "27.0619", "Africa/Lusaka"),
("905395", "Mufulira", "Муфулире", "ZM", "894", "08", "", "", "", "-12.54982", "28.24071", "Africa/Lusaka"),
("905846", "Mpika", "", "ZM", "894", "05", "", "", "", "-11.83431", "31.45287", "Africa/Lusaka"),
("906044", "Monze", "", "ZM", "894", "07", "", "", "", "-16.28333", "27.48333", "Africa/Lusaka"),
("906054", "Mongu", "Монгу", "ZM", "894", "01", "", "", "", "-15.24835", "23.12741", "Africa/Lusaka"),
("907111", "Mazabuka", "Мазабука", "ZM", "894", "07", "", "", "", "-15.85601", "27.748", "Africa/Lusaka"),
("907770", "Mansa", "Манса", "ZM", "894", "04", "", "", "", "-11.19976", "28.89431", "Africa/Lusaka"),
("909137", "Lusaka", "Лусака", "ZM", "894", "09", "", "", "", "-15.40669", "28.28713", "Africa/Lusaka"),
("909863", "Luanshya", "", "ZM", "894", "08", "", "", "", "-13.13667", "28.41661", "Africa/Lusaka"),
("910111", "Livingstone", "Ливингстон", "ZM", "894", "07", "", "", "", "-17.84194", "25.85425", "Africa/Lusaka"),
("911148", "Kitwe", "Китве", "ZM", "894", "08", "", "", "", "-12.80243", "28.21323", "Africa/Lusaka"),
("912764", "Kasama", "Касама", "ZM", "894", "05", "", "", "", "-10.21289", "31.18084", "Africa/Lusaka"),
("913029", "Kapiri Mposhi", "", "ZM", "894", "02", "", "", "", "-13.97147", "28.66985", "Africa/Lusaka"),
("913613", "Kansanshi", "", "ZM", "894", "06", "", "", "", "-12.09514", "26.42727", "Africa/Lusaka"),
("914959", "Kalulushi", "", "ZM", "894", "08", "", "", "", "-12.84151", "28.09479", "Africa/Lusaka"),
("915883", "Kafue", "Кафе", "ZM", "894", "09", "", "", "", "-15.76911", "28.18136", "Africa/Lusaka"),
("916095", "Kabwe", "Кабве", "ZM", "894", "02", "", "", "", "-14.4469", "28.44644", "Africa/Lusaka"),
("917748", "Choma", "", "ZM", "894", "07", "", "", "", "-16.80648", "26.95306", "Africa/Lusaka"),
("918702", "Chipata", "Чипата", "ZM", "894", "03", "", "", "", "-13.63333", "32.65", "Africa/Lusaka"),
("919009", "Chingola", "Чингола", "ZM", "894", "08", "", "", "", "-12.52897", "27.88382", "Africa/Lusaka"),
("919544", "Chililabombwe", "", "ZM", "894", "08", "", "", "", "-12.36475", "27.82286", "Africa/Lusaka"),
("878549", "Zvishavane", "", "ZW", "716", "08", "", "", "", "-20.32674", "30.06648", "Africa/Harare"),
("879431", "Victoria Falls", "", "ZW", "716", "06", "", "", "", "-17.92353", "25.84299", "Africa/Harare"),
("881164", "Shurugwi", "", "ZW", "716", "02", "", "", "", "-19.67016", "30.00589", "Africa/Harare"),
("882100", "Rusape", "", "ZW", "716", "01", "", "", "", "-18.52785", "32.12843", "Africa/Harare"),
("882599", "Redcliff", "Рэдклифф", "ZW", "716", "02", "", "", "", "-19.03333", "29.78333", "Africa/Harare"),
("884141", "Norton", "Нортон", "ZW", "716", "05", "", "", "", "-17.88333", "30.7", "Africa/Harare"),
("884979", "Mutare", "Мутаре", "ZW", "716", "01", "", "", "", "-18.9707", "32.67086", "Africa/Harare"),
("886763", "Masvingo", "", "ZW", "716", "08", "", "", "", "-20.06373", "30.82766", "Africa/Harare"),
("886990", "Marondera", "", "ZW", "716", "04", "", "", "", "-18.18527", "31.55193", "Africa/Harare"),
("888710", "Kwekwe", "", "ZW", "716", "02", "", "", "", "-18.9281", "29.81486", "Africa/Harare"),
("889191", "Karoi", "", "ZW", "716", "05", "", "", "", "-16.80993", "29.69247", "Africa/Harare"),
("889215", "Kariba", "Кариба", "ZW", "716", "05", "", "", "", "-16.51667", "28.8", "Africa/Harare"),
("889453", "Kadoma", "Кадоме", "ZW", "716", "05", "", "", "", "-18.33328", "29.91534", "Africa/Harare"),
("889942", "Hwange", "Хванге", "ZW", "716", "06", "", "", "", "-18.36927", "26.50194", "Africa/Harare"),
("890299", "Harare", "Хараре", "ZW", "716", "10", "", "", "", "-17.82772", "31.05337", "Africa/Harare"),
("890422", "Gweru", "", "ZW", "716", "02", "", "", "", "-19.45", "29.81667", "Africa/Harare"),
("890983", "Gokwe", "", "ZW", "716", "02", "", "", "", "-18.20476", "28.9349", "Africa/Harare"),
("893485", "Chiredzi", "", "ZW", "716", "08", "", "", "", "-21.05", "31.66667", "Africa/Harare"),
("893549", "Chipinge", "", "ZW", "716", "01", "", "", "", "-20.18833", "32.62364", "Africa/Harare"),
("893697", "Chinhoyi", "", "ZW", "716", "05", "", "", "", "-17.36667", "30.2", "Africa/Harare"),
("894239", "Chegutu", "", "ZW", "716", "05", "", "", "", "-18.13021", "30.14074", "Africa/Harare"),
("894701", "Bulawayo", "Булавайо", "ZW", "716", "09", "", "", "", "-20.15", "28.58333", "Africa/Harare"),
("895061", "Bindura", "Биндура", "ZW", "716", "03", "", "", "", "-17.30192", "31.33056", "Africa/Harare"),
("895269", "Beitbridge", "", "ZW", "716", "07", "", "", "", "-22.21667", "30", "Africa/Harare"),
("1085510", "Epworth", "", "ZW", "716", "10", "", "", "", "-17.89", "31.1475", "Africa/Harare"),
("1106542", "Chitungwiza", "", "ZW", "716", "10", "", "", "", "-18.01274", "31.07555", "Africa/Harare");


--//@UNDO

DROP TABLE `all_cities`;

ALTER TABLE `weatherco_cache` DROP `updated_forecast`;
ALTER TABLE `weatherco_cache` DROP `updated_current`;

DROP TABLE `openweathermap_cache`;

ALTER TABLE `users` DROP `openweathermap_city_id`;

--